#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 163
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 59
#define ALIAS_COUNT 0
#define TOKEN_COUNT 36
#define EXTERNAL_TOKEN_COUNT 16
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 4
#define PRODUCTION_ID_COUNT 1

enum ts_symbol_identifiers {
  anon_sym_LT_BANG = 1,
  aux_sym_doctype_token1 = 2,
  anon_sym_GT = 3,
  sym__doctype = 4,
  anon_sym_LT = 5,
  anon_sym_SLASH_GT = 6,
  anon_sym_LT_SLASH = 7,
  anon_sym_EQ = 8,
  sym_attribute_name = 9,
  sym_attribute_value = 10,
  sym_entity = 11,
  anon_sym_SQUOTE = 12,
  aux_sym_quoted_attribute_value_token1 = 13,
  anon_sym_DQUOTE = 14,
  aux_sym_quoted_attribute_value_token2 = 15,
  sym_text = 16,
  anon_sym_DASH_DASH_DASH = 17,
  anon_sym_DASH_DASH_DASH2 = 18,
  anon_sym_LBRACE = 19,
  anon_sym_RBRACE = 20,
  sym__start_tag_name = 21,
  sym__script_start_tag_name = 22,
  sym__style_start_tag_name = 23,
  sym__end_tag_name = 24,
  sym_erroneous_end_tag_name = 25,
  sym__implicit_end_tag = 26,
  sym_raw_text = 27,
  sym_comment = 28,
  sym__html_interpolation_start = 29,
  sym__html_interpolation_end = 30,
  sym_frontmatter_js_block = 31,
  sym_attribute_js_expr = 32,
  sym_attribute_backtick_string = 33,
  sym_permissible_text = 34,
  sym__fragment_tag_delim = 35,
  sym_document = 36,
  sym_doctype = 37,
  sym__node = 38,
  sym_element = 39,
  sym_script_element = 40,
  sym_style_element = 41,
  sym_start_tag = 42,
  sym_script_start_tag = 43,
  sym_style_start_tag = 44,
  sym_self_closing_tag = 45,
  sym_end_tag = 46,
  sym_erroneous_end_tag = 47,
  sym_attribute = 48,
  sym_quoted_attribute_value = 49,
  sym__node_with_permissible_text = 50,
  sym_frontmatter = 51,
  sym_attribute_interpolation = 52,
  sym_html_interpolation = 53,
  sym_self_closing_script_tag = 54,
  sym_self_closing_style_tag = 55,
  aux_sym_document_repeat1 = 56,
  aux_sym_start_tag_repeat1 = 57,
  aux_sym_html_interpolation_repeat1 = 58,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_LT_BANG] = "<!",
  [aux_sym_doctype_token1] = "doctype_token1",
  [anon_sym_GT] = ">",
  [sym__doctype] = "doctype",
  [anon_sym_LT] = "<",
  [anon_sym_SLASH_GT] = "/>",
  [anon_sym_LT_SLASH] = "</",
  [anon_sym_EQ] = "=",
  [sym_attribute_name] = "attribute_name",
  [sym_attribute_value] = "attribute_value",
  [sym_entity] = "entity",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_quoted_attribute_value_token1] = "attribute_value",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_quoted_attribute_value_token2] = "attribute_value",
  [sym_text] = "text",
  [anon_sym_DASH_DASH_DASH] = "---",
  [anon_sym_DASH_DASH_DASH2] = "---",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym__start_tag_name] = "tag_name",
  [sym__script_start_tag_name] = "tag_name",
  [sym__style_start_tag_name] = "tag_name",
  [sym__end_tag_name] = "tag_name",
  [sym_erroneous_end_tag_name] = "erroneous_end_tag_name",
  [sym__implicit_end_tag] = "_implicit_end_tag",
  [sym_raw_text] = "raw_text",
  [sym_comment] = "comment",
  [sym__html_interpolation_start] = "{",
  [sym__html_interpolation_end] = "}",
  [sym_frontmatter_js_block] = "frontmatter_js_block",
  [sym_attribute_js_expr] = "attribute_js_expr",
  [sym_attribute_backtick_string] = "attribute_backtick_string",
  [sym_permissible_text] = "permissible_text",
  [sym__fragment_tag_delim] = ">",
  [sym_document] = "document",
  [sym_doctype] = "doctype",
  [sym__node] = "_node",
  [sym_element] = "element",
  [sym_script_element] = "script_element",
  [sym_style_element] = "style_element",
  [sym_start_tag] = "start_tag",
  [sym_script_start_tag] = "start_tag",
  [sym_style_start_tag] = "start_tag",
  [sym_self_closing_tag] = "self_closing_tag",
  [sym_end_tag] = "end_tag",
  [sym_erroneous_end_tag] = "erroneous_end_tag",
  [sym_attribute] = "attribute",
  [sym_quoted_attribute_value] = "quoted_attribute_value",
  [sym__node_with_permissible_text] = "_node_with_permissible_text",
  [sym_frontmatter] = "frontmatter",
  [sym_attribute_interpolation] = "attribute_interpolation",
  [sym_html_interpolation] = "html_interpolation",
  [sym_self_closing_script_tag] = "self_closing_tag",
  [sym_self_closing_style_tag] = "self_closing_tag",
  [aux_sym_document_repeat1] = "document_repeat1",
  [aux_sym_start_tag_repeat1] = "start_tag_repeat1",
  [aux_sym_html_interpolation_repeat1] = "html_interpolation_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_LT_BANG] = anon_sym_LT_BANG,
  [aux_sym_doctype_token1] = aux_sym_doctype_token1,
  [anon_sym_GT] = anon_sym_GT,
  [sym__doctype] = sym__doctype,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_SLASH_GT] = anon_sym_SLASH_GT,
  [anon_sym_LT_SLASH] = anon_sym_LT_SLASH,
  [anon_sym_EQ] = anon_sym_EQ,
  [sym_attribute_name] = sym_attribute_name,
  [sym_attribute_value] = sym_attribute_value,
  [sym_entity] = sym_entity,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_quoted_attribute_value_token1] = sym_attribute_value,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_quoted_attribute_value_token2] = sym_attribute_value,
  [sym_text] = sym_text,
  [anon_sym_DASH_DASH_DASH] = anon_sym_DASH_DASH_DASH,
  [anon_sym_DASH_DASH_DASH2] = anon_sym_DASH_DASH_DASH,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [sym__start_tag_name] = sym__start_tag_name,
  [sym__script_start_tag_name] = sym__start_tag_name,
  [sym__style_start_tag_name] = sym__start_tag_name,
  [sym__end_tag_name] = sym__start_tag_name,
  [sym_erroneous_end_tag_name] = sym_erroneous_end_tag_name,
  [sym__implicit_end_tag] = sym__implicit_end_tag,
  [sym_raw_text] = sym_raw_text,
  [sym_comment] = sym_comment,
  [sym__html_interpolation_start] = anon_sym_LBRACE,
  [sym__html_interpolation_end] = anon_sym_RBRACE,
  [sym_frontmatter_js_block] = sym_frontmatter_js_block,
  [sym_attribute_js_expr] = sym_attribute_js_expr,
  [sym_attribute_backtick_string] = sym_attribute_backtick_string,
  [sym_permissible_text] = sym_permissible_text,
  [sym__fragment_tag_delim] = anon_sym_GT,
  [sym_document] = sym_document,
  [sym_doctype] = sym_doctype,
  [sym__node] = sym__node,
  [sym_element] = sym_element,
  [sym_script_element] = sym_script_element,
  [sym_style_element] = sym_style_element,
  [sym_start_tag] = sym_start_tag,
  [sym_script_start_tag] = sym_start_tag,
  [sym_style_start_tag] = sym_start_tag,
  [sym_self_closing_tag] = sym_self_closing_tag,
  [sym_end_tag] = sym_end_tag,
  [sym_erroneous_end_tag] = sym_erroneous_end_tag,
  [sym_attribute] = sym_attribute,
  [sym_quoted_attribute_value] = sym_quoted_attribute_value,
  [sym__node_with_permissible_text] = sym__node_with_permissible_text,
  [sym_frontmatter] = sym_frontmatter,
  [sym_attribute_interpolation] = sym_attribute_interpolation,
  [sym_html_interpolation] = sym_html_interpolation,
  [sym_self_closing_script_tag] = sym_self_closing_tag,
  [sym_self_closing_style_tag] = sym_self_closing_tag,
  [aux_sym_document_repeat1] = aux_sym_document_repeat1,
  [aux_sym_start_tag_repeat1] = aux_sym_start_tag_repeat1,
  [aux_sym_html_interpolation_repeat1] = aux_sym_html_interpolation_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LT_BANG] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_doctype_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__doctype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym_entity] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quoted_attribute_value_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quoted_attribute_value_token2] = {
    .visible = true,
    .named = true,
  },
  [sym_text] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH_DASH2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__start_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__script_start_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__style_start_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__end_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym_erroneous_end_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__implicit_end_tag] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_text] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__html_interpolation_start] = {
    .visible = true,
    .named = false,
  },
  [sym__html_interpolation_end] = {
    .visible = true,
    .named = false,
  },
  [sym_frontmatter_js_block] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_js_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_backtick_string] = {
    .visible = true,
    .named = true,
  },
  [sym_permissible_text] = {
    .visible = true,
    .named = true,
  },
  [sym__fragment_tag_delim] = {
    .visible = true,
    .named = false,
  },
  [sym_document] = {
    .visible = true,
    .named = true,
  },
  [sym_doctype] = {
    .visible = true,
    .named = true,
  },
  [sym__node] = {
    .visible = false,
    .named = true,
  },
  [sym_element] = {
    .visible = true,
    .named = true,
  },
  [sym_script_element] = {
    .visible = true,
    .named = true,
  },
  [sym_style_element] = {
    .visible = true,
    .named = true,
  },
  [sym_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_script_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_style_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_self_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_end_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_erroneous_end_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_quoted_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym__node_with_permissible_text] = {
    .visible = false,
    .named = true,
  },
  [sym_frontmatter] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_html_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_self_closing_script_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_self_closing_style_tag] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_document_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_start_tag_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_html_interpolation_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 2,
  [8] = 8,
  [9] = 9,
  [10] = 8,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 13,
  [16] = 16,
  [17] = 13,
  [18] = 16,
  [19] = 16,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 21,
  [25] = 23,
  [26] = 20,
  [27] = 27,
  [28] = 20,
  [29] = 29,
  [30] = 27,
  [31] = 23,
  [32] = 27,
  [33] = 29,
  [34] = 21,
  [35] = 22,
  [36] = 36,
  [37] = 29,
  [38] = 22,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 41,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 60,
  [62] = 62,
  [63] = 55,
  [64] = 64,
  [65] = 51,
  [66] = 66,
  [67] = 49,
  [68] = 48,
  [69] = 59,
  [70] = 58,
  [71] = 57,
  [72] = 56,
  [73] = 52,
  [74] = 74,
  [75] = 75,
  [76] = 50,
  [77] = 40,
  [78] = 43,
  [79] = 42,
  [80] = 46,
  [81] = 75,
  [82] = 74,
  [83] = 66,
  [84] = 84,
  [85] = 64,
  [86] = 53,
  [87] = 74,
  [88] = 66,
  [89] = 40,
  [90] = 56,
  [91] = 57,
  [92] = 58,
  [93] = 59,
  [94] = 60,
  [95] = 55,
  [96] = 64,
  [97] = 49,
  [98] = 48,
  [99] = 43,
  [100] = 42,
  [101] = 41,
  [102] = 46,
  [103] = 75,
  [104] = 104,
  [105] = 52,
  [106] = 50,
  [107] = 51,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 112,
  [115] = 112,
  [116] = 116,
  [117] = 117,
  [118] = 117,
  [119] = 116,
  [120] = 120,
  [121] = 116,
  [122] = 117,
  [123] = 120,
  [124] = 120,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 128,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 132,
  [135] = 131,
  [136] = 131,
  [137] = 128,
  [138] = 138,
  [139] = 139,
  [140] = 132,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 146,
  [150] = 150,
  [151] = 141,
  [152] = 142,
  [153] = 153,
  [154] = 141,
  [155] = 146,
  [156] = 156,
  [157] = 153,
  [158] = 150,
  [159] = 159,
  [160] = 150,
  [161] = 148,
  [162] = 148,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(24);
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '&') ADVANCE(3);
      if (lookahead == '\'') ADVANCE(76);
      if (lookahead == '-') ADVANCE(7);
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(28);
      if (lookahead == '{') ADVANCE(87);
      if (lookahead == '}') ADVANCE(88);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(14);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(76);
      if (lookahead == '{') ADVANCE(87);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1)
      if (lookahead != 0 &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(35);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(79);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(80);
      if (lookahead != 0) ADVANCE(81);
      END_STATE();
    case 3:
      if (lookahead == '#') ADVANCE(17);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(75);
      END_STATE();
    case 4:
      if (lookahead == '\'') ADVANCE(76);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(77);
      if (lookahead != 0) ADVANCE(78);
      END_STATE();
    case 5:
      if (lookahead == '-') ADVANCE(85);
      END_STATE();
    case 6:
      if (lookahead == '-') ADVANCE(86);
      END_STATE();
    case 7:
      if (lookahead == '-') ADVANCE(5);
      END_STATE();
    case 8:
      if (lookahead == '-') ADVANCE(6);
      END_STATE();
    case 9:
      if (lookahead == '-') ADVANCE(8);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9)
      END_STATE();
    case 10:
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(28);
      if (lookahead == '{') ADVANCE(87);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '<') ADVANCE(34);
      END_STATE();
    case 11:
      if (lookahead == '>') ADVANCE(31);
      END_STATE();
    case 12:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(16);
      END_STATE();
    case 13:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(29);
      END_STATE();
    case 14:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(12);
      END_STATE();
    case 15:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(13);
      END_STATE();
    case 16:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(18);
      END_STATE();
    case 17:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(41);
      END_STATE();
    case 18:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(15);
      END_STATE();
    case 19:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(19);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(84);
      END_STATE();
    case 20:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(26);
      if (lookahead != 0 &&
          lookahead != '>') ADVANCE(27);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 22:
      if (eof) ADVANCE(24);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '<') ADVANCE(30);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22)
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(84);
      END_STATE();
    case 23:
      if (eof) ADVANCE(24);
      if (lookahead == '<') ADVANCE(30);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23)
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(84);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_LT_BANG);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(aux_sym_doctype_token1);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(26);
      if (lookahead != 0 &&
          lookahead != '>') ADVANCE(27);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym_doctype_token1);
      if (lookahead != 0 &&
          lookahead != '>') ADVANCE(27);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym__doctype);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(25);
      if (lookahead == '/') ADVANCE(32);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_SLASH_GT);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_SLASH);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_attribute_name);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '/' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(34);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_attribute_value);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_entity);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(38);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(39);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(40);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(37);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(47);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(48);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(51);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(52);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(53);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(57);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(58);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(59);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(60);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(61);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(62);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(63);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(64);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(65);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(66);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(67);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(69);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(70);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(71);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(72);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(73);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_entity);
      if (lookahead == ';') ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(74);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(77);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(81);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_text);
      if (lookahead == '-') ADVANCE(85);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(19);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(84);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_text);
      if (lookahead == '-') ADVANCE(82);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(19);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(84);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_text);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(19);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_DASH);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_DASH2);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 22, .external_lex_state = 2},
  [2] = {.lex_state = 23, .external_lex_state = 3},
  [3] = {.lex_state = 23, .external_lex_state = 3},
  [4] = {.lex_state = 23, .external_lex_state = 3},
  [5] = {.lex_state = 23, .external_lex_state = 3},
  [6] = {.lex_state = 23, .external_lex_state = 3},
  [7] = {.lex_state = 23, .external_lex_state = 3},
  [8] = {.lex_state = 23, .external_lex_state = 2},
  [9] = {.lex_state = 23, .external_lex_state = 2},
  [10] = {.lex_state = 23, .external_lex_state = 3},
  [11] = {.lex_state = 23, .external_lex_state = 2},
  [12] = {.lex_state = 23, .external_lex_state = 2},
  [13] = {.lex_state = 0, .external_lex_state = 4},
  [14] = {.lex_state = 0, .external_lex_state = 4},
  [15] = {.lex_state = 0, .external_lex_state = 4},
  [16] = {.lex_state = 0, .external_lex_state = 4},
  [17] = {.lex_state = 0, .external_lex_state = 4},
  [18] = {.lex_state = 0, .external_lex_state = 4},
  [19] = {.lex_state = 0, .external_lex_state = 4},
  [20] = {.lex_state = 10, .external_lex_state = 5},
  [21] = {.lex_state = 10, .external_lex_state = 5},
  [22] = {.lex_state = 10, .external_lex_state = 5},
  [23] = {.lex_state = 10, .external_lex_state = 5},
  [24] = {.lex_state = 10, .external_lex_state = 5},
  [25] = {.lex_state = 10, .external_lex_state = 5},
  [26] = {.lex_state = 10, .external_lex_state = 5},
  [27] = {.lex_state = 10, .external_lex_state = 5},
  [28] = {.lex_state = 10, .external_lex_state = 5},
  [29] = {.lex_state = 10, .external_lex_state = 5},
  [30] = {.lex_state = 10, .external_lex_state = 5},
  [31] = {.lex_state = 10, .external_lex_state = 5},
  [32] = {.lex_state = 10, .external_lex_state = 5},
  [33] = {.lex_state = 10, .external_lex_state = 5},
  [34] = {.lex_state = 10, .external_lex_state = 5},
  [35] = {.lex_state = 10, .external_lex_state = 5},
  [36] = {.lex_state = 1, .external_lex_state = 6},
  [37] = {.lex_state = 10, .external_lex_state = 5},
  [38] = {.lex_state = 10, .external_lex_state = 5},
  [39] = {.lex_state = 10, .external_lex_state = 5},
  [40] = {.lex_state = 23, .external_lex_state = 2},
  [41] = {.lex_state = 23, .external_lex_state = 3},
  [42] = {.lex_state = 23, .external_lex_state = 2},
  [43] = {.lex_state = 23, .external_lex_state = 2},
  [44] = {.lex_state = 23, .external_lex_state = 2},
  [45] = {.lex_state = 23, .external_lex_state = 3},
  [46] = {.lex_state = 23, .external_lex_state = 2},
  [47] = {.lex_state = 23, .external_lex_state = 2},
  [48] = {.lex_state = 23, .external_lex_state = 3},
  [49] = {.lex_state = 23, .external_lex_state = 3},
  [50] = {.lex_state = 23, .external_lex_state = 2},
  [51] = {.lex_state = 23, .external_lex_state = 3},
  [52] = {.lex_state = 23, .external_lex_state = 2},
  [53] = {.lex_state = 23, .external_lex_state = 2},
  [54] = {.lex_state = 23, .external_lex_state = 2},
  [55] = {.lex_state = 23, .external_lex_state = 3},
  [56] = {.lex_state = 23, .external_lex_state = 2},
  [57] = {.lex_state = 23, .external_lex_state = 2},
  [58] = {.lex_state = 23, .external_lex_state = 2},
  [59] = {.lex_state = 23, .external_lex_state = 2},
  [60] = {.lex_state = 23, .external_lex_state = 2},
  [61] = {.lex_state = 23, .external_lex_state = 3},
  [62] = {.lex_state = 23, .external_lex_state = 3},
  [63] = {.lex_state = 23, .external_lex_state = 2},
  [64] = {.lex_state = 23, .external_lex_state = 2},
  [65] = {.lex_state = 23, .external_lex_state = 2},
  [66] = {.lex_state = 23, .external_lex_state = 2},
  [67] = {.lex_state = 23, .external_lex_state = 2},
  [68] = {.lex_state = 23, .external_lex_state = 2},
  [69] = {.lex_state = 23, .external_lex_state = 3},
  [70] = {.lex_state = 23, .external_lex_state = 3},
  [71] = {.lex_state = 23, .external_lex_state = 3},
  [72] = {.lex_state = 23, .external_lex_state = 3},
  [73] = {.lex_state = 23, .external_lex_state = 3},
  [74] = {.lex_state = 23, .external_lex_state = 2},
  [75] = {.lex_state = 23, .external_lex_state = 2},
  [76] = {.lex_state = 23, .external_lex_state = 3},
  [77] = {.lex_state = 23, .external_lex_state = 3},
  [78] = {.lex_state = 23, .external_lex_state = 3},
  [79] = {.lex_state = 23, .external_lex_state = 3},
  [80] = {.lex_state = 23, .external_lex_state = 3},
  [81] = {.lex_state = 23, .external_lex_state = 3},
  [82] = {.lex_state = 23, .external_lex_state = 3},
  [83] = {.lex_state = 23, .external_lex_state = 3},
  [84] = {.lex_state = 23, .external_lex_state = 3},
  [85] = {.lex_state = 23, .external_lex_state = 3},
  [86] = {.lex_state = 23, .external_lex_state = 3},
  [87] = {.lex_state = 0, .external_lex_state = 4},
  [88] = {.lex_state = 0, .external_lex_state = 4},
  [89] = {.lex_state = 0, .external_lex_state = 4},
  [90] = {.lex_state = 0, .external_lex_state = 4},
  [91] = {.lex_state = 0, .external_lex_state = 4},
  [92] = {.lex_state = 0, .external_lex_state = 4},
  [93] = {.lex_state = 0, .external_lex_state = 4},
  [94] = {.lex_state = 0, .external_lex_state = 4},
  [95] = {.lex_state = 0, .external_lex_state = 4},
  [96] = {.lex_state = 0, .external_lex_state = 4},
  [97] = {.lex_state = 0, .external_lex_state = 4},
  [98] = {.lex_state = 0, .external_lex_state = 4},
  [99] = {.lex_state = 0, .external_lex_state = 4},
  [100] = {.lex_state = 0, .external_lex_state = 4},
  [101] = {.lex_state = 0, .external_lex_state = 4},
  [102] = {.lex_state = 0, .external_lex_state = 4},
  [103] = {.lex_state = 0, .external_lex_state = 4},
  [104] = {.lex_state = 10, .external_lex_state = 5},
  [105] = {.lex_state = 0, .external_lex_state = 4},
  [106] = {.lex_state = 0, .external_lex_state = 4},
  [107] = {.lex_state = 0, .external_lex_state = 4},
  [108] = {.lex_state = 10, .external_lex_state = 5},
  [109] = {.lex_state = 10, .external_lex_state = 5},
  [110] = {.lex_state = 10, .external_lex_state = 5},
  [111] = {.lex_state = 10, .external_lex_state = 5},
  [112] = {.lex_state = 0, .external_lex_state = 7},
  [113] = {.lex_state = 10, .external_lex_state = 5},
  [114] = {.lex_state = 0, .external_lex_state = 7},
  [115] = {.lex_state = 0, .external_lex_state = 7},
  [116] = {.lex_state = 0, .external_lex_state = 8},
  [117] = {.lex_state = 0, .external_lex_state = 8},
  [118] = {.lex_state = 0, .external_lex_state = 8},
  [119] = {.lex_state = 0, .external_lex_state = 8},
  [120] = {.lex_state = 0, .external_lex_state = 9},
  [121] = {.lex_state = 0, .external_lex_state = 8},
  [122] = {.lex_state = 0, .external_lex_state = 8},
  [123] = {.lex_state = 0, .external_lex_state = 9},
  [124] = {.lex_state = 0, .external_lex_state = 9},
  [125] = {.lex_state = 4, .external_lex_state = 10},
  [126] = {.lex_state = 2, .external_lex_state = 10},
  [127] = {.lex_state = 0, .external_lex_state = 8},
  [128] = {.lex_state = 0, .external_lex_state = 10},
  [129] = {.lex_state = 0, .external_lex_state = 8},
  [130] = {.lex_state = 0, .external_lex_state = 10},
  [131] = {.lex_state = 0, .external_lex_state = 11},
  [132] = {.lex_state = 0, .external_lex_state = 10},
  [133] = {.lex_state = 9, .external_lex_state = 12},
  [134] = {.lex_state = 0, .external_lex_state = 10},
  [135] = {.lex_state = 0, .external_lex_state = 11},
  [136] = {.lex_state = 0, .external_lex_state = 11},
  [137] = {.lex_state = 0, .external_lex_state = 10},
  [138] = {.lex_state = 0, .external_lex_state = 8},
  [139] = {.lex_state = 0, .external_lex_state = 8},
  [140] = {.lex_state = 0, .external_lex_state = 10},
  [141] = {.lex_state = 0, .external_lex_state = 10},
  [142] = {.lex_state = 0, .external_lex_state = 10},
  [143] = {.lex_state = 0, .external_lex_state = 10},
  [144] = {.lex_state = 0, .external_lex_state = 10},
  [145] = {.lex_state = 0, .external_lex_state = 10},
  [146] = {.lex_state = 0, .external_lex_state = 10},
  [147] = {.lex_state = 0, .external_lex_state = 10},
  [148] = {.lex_state = 0, .external_lex_state = 10},
  [149] = {.lex_state = 0, .external_lex_state = 10},
  [150] = {.lex_state = 20, .external_lex_state = 10},
  [151] = {.lex_state = 0, .external_lex_state = 10},
  [152] = {.lex_state = 0, .external_lex_state = 10},
  [153] = {.lex_state = 0, .external_lex_state = 13},
  [154] = {.lex_state = 0, .external_lex_state = 10},
  [155] = {.lex_state = 0, .external_lex_state = 10},
  [156] = {.lex_state = 9, .external_lex_state = 10},
  [157] = {.lex_state = 0, .external_lex_state = 13},
  [158] = {.lex_state = 20, .external_lex_state = 10},
  [159] = {.lex_state = 0, .external_lex_state = 14},
  [160] = {.lex_state = 20, .external_lex_state = 10},
  [161] = {.lex_state = 0, .external_lex_state = 10},
  [162] = {.lex_state = 0, .external_lex_state = 10},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LT_BANG] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym__doctype] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_SLASH_GT] = ACTIONS(1),
    [anon_sym_LT_SLASH] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [sym_entity] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DASH_DASH_DASH] = ACTIONS(1),
    [anon_sym_DASH_DASH_DASH2] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym__start_tag_name] = ACTIONS(1),
    [sym__script_start_tag_name] = ACTIONS(1),
    [sym__style_start_tag_name] = ACTIONS(1),
    [sym__end_tag_name] = ACTIONS(1),
    [sym_erroneous_end_tag_name] = ACTIONS(1),
    [sym__implicit_end_tag] = ACTIONS(1),
    [sym_raw_text] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__html_interpolation_start] = ACTIONS(1),
    [sym__html_interpolation_end] = ACTIONS(1),
    [sym_frontmatter_js_block] = ACTIONS(1),
    [sym_attribute_js_expr] = ACTIONS(1),
    [sym_attribute_backtick_string] = ACTIONS(1),
    [sym_permissible_text] = ACTIONS(1),
    [sym__fragment_tag_delim] = ACTIONS(1),
  },
  [1] = {
    [sym_document] = STATE(147),
    [sym_doctype] = STATE(12),
    [sym__node] = STATE(12),
    [sym_element] = STATE(12),
    [sym_script_element] = STATE(12),
    [sym_style_element] = STATE(12),
    [sym_start_tag] = STATE(4),
    [sym_script_start_tag] = STATE(119),
    [sym_style_start_tag] = STATE(118),
    [sym_self_closing_tag] = STATE(64),
    [sym_erroneous_end_tag] = STATE(12),
    [sym_frontmatter] = STATE(11),
    [sym_html_interpolation] = STATE(12),
    [sym_self_closing_script_tag] = STATE(66),
    [sym_self_closing_style_tag] = STATE(74),
    [aux_sym_document_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_LT_BANG] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(9),
    [anon_sym_LT_SLASH] = ACTIONS(11),
    [sym_text] = ACTIONS(13),
    [anon_sym_DASH_DASH_DASH] = ACTIONS(15),
    [sym_comment] = ACTIONS(3),
    [sym__html_interpolation_start] = ACTIONS(17),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LT_BANG,
    ACTIONS(21), 1,
      anon_sym_LT,
    ACTIONS(23), 1,
      anon_sym_LT_SLASH,
    ACTIONS(25), 1,
      sym_text,
    ACTIONS(27), 1,
      sym__implicit_end_tag,
    ACTIONS(29), 1,
      sym__html_interpolation_start,
    STATE(5), 1,
      sym_start_tag,
    STATE(82), 1,
      sym_self_closing_style_tag,
    STATE(83), 1,
      sym_self_closing_script_tag,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(91), 1,
      sym_end_tag,
    STATE(116), 1,
      sym_script_start_tag,
    STATE(117), 1,
      sym_style_start_tag,
    STATE(10), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [53] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LT_BANG,
    ACTIONS(21), 1,
      anon_sym_LT,
    ACTIONS(25), 1,
      sym_text,
    ACTIONS(29), 1,
      sym__html_interpolation_start,
    ACTIONS(31), 1,
      anon_sym_LT_SLASH,
    ACTIONS(33), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_start_tag,
    STATE(71), 1,
      sym_end_tag,
    STATE(82), 1,
      sym_self_closing_style_tag,
    STATE(83), 1,
      sym_self_closing_script_tag,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(116), 1,
      sym_script_start_tag,
    STATE(117), 1,
      sym_style_start_tag,
    STATE(10), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [106] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LT_BANG,
    ACTIONS(21), 1,
      anon_sym_LT,
    ACTIONS(29), 1,
      sym__html_interpolation_start,
    ACTIONS(35), 1,
      anon_sym_LT_SLASH,
    ACTIONS(37), 1,
      sym_text,
    ACTIONS(39), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_start_tag,
    STATE(46), 1,
      sym_end_tag,
    STATE(82), 1,
      sym_self_closing_style_tag,
    STATE(83), 1,
      sym_self_closing_script_tag,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(116), 1,
      sym_script_start_tag,
    STATE(117), 1,
      sym_style_start_tag,
    STATE(7), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [159] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LT_BANG,
    ACTIONS(21), 1,
      anon_sym_LT,
    ACTIONS(29), 1,
      sym__html_interpolation_start,
    ACTIONS(31), 1,
      anon_sym_LT_SLASH,
    ACTIONS(41), 1,
      sym_text,
    ACTIONS(43), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_start_tag,
    STATE(80), 1,
      sym_end_tag,
    STATE(82), 1,
      sym_self_closing_style_tag,
    STATE(83), 1,
      sym_self_closing_script_tag,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(116), 1,
      sym_script_start_tag,
    STATE(117), 1,
      sym_style_start_tag,
    STATE(3), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [212] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LT_BANG,
    ACTIONS(21), 1,
      anon_sym_LT,
    ACTIONS(23), 1,
      anon_sym_LT_SLASH,
    ACTIONS(29), 1,
      sym__html_interpolation_start,
    ACTIONS(45), 1,
      sym_text,
    ACTIONS(47), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_start_tag,
    STATE(82), 1,
      sym_self_closing_style_tag,
    STATE(83), 1,
      sym_self_closing_script_tag,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(102), 1,
      sym_end_tag,
    STATE(116), 1,
      sym_script_start_tag,
    STATE(117), 1,
      sym_style_start_tag,
    STATE(2), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [265] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LT_BANG,
    ACTIONS(21), 1,
      anon_sym_LT,
    ACTIONS(25), 1,
      sym_text,
    ACTIONS(29), 1,
      sym__html_interpolation_start,
    ACTIONS(35), 1,
      anon_sym_LT_SLASH,
    ACTIONS(49), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_start_tag,
    STATE(57), 1,
      sym_end_tag,
    STATE(82), 1,
      sym_self_closing_style_tag,
    STATE(83), 1,
      sym_self_closing_script_tag,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(116), 1,
      sym_script_start_tag,
    STATE(117), 1,
      sym_style_start_tag,
    STATE(10), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [318] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      ts_builtin_sym_end,
    ACTIONS(53), 1,
      anon_sym_LT_BANG,
    ACTIONS(56), 1,
      anon_sym_LT,
    ACTIONS(59), 1,
      anon_sym_LT_SLASH,
    ACTIONS(62), 1,
      sym_text,
    ACTIONS(65), 1,
      sym__html_interpolation_start,
    STATE(4), 1,
      sym_start_tag,
    STATE(64), 1,
      sym_self_closing_tag,
    STATE(66), 1,
      sym_self_closing_script_tag,
    STATE(74), 1,
      sym_self_closing_style_tag,
    STATE(118), 1,
      sym_style_start_tag,
    STATE(119), 1,
      sym_script_start_tag,
    STATE(8), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [368] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LT_BANG,
    ACTIONS(9), 1,
      anon_sym_LT,
    ACTIONS(11), 1,
      anon_sym_LT_SLASH,
    ACTIONS(17), 1,
      sym__html_interpolation_start,
    ACTIONS(68), 1,
      ts_builtin_sym_end,
    ACTIONS(70), 1,
      sym_text,
    STATE(4), 1,
      sym_start_tag,
    STATE(64), 1,
      sym_self_closing_tag,
    STATE(66), 1,
      sym_self_closing_script_tag,
    STATE(74), 1,
      sym_self_closing_style_tag,
    STATE(118), 1,
      sym_style_start_tag,
    STATE(119), 1,
      sym_script_start_tag,
    STATE(8), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [418] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym__implicit_end_tag,
    ACTIONS(72), 1,
      anon_sym_LT_BANG,
    ACTIONS(75), 1,
      anon_sym_LT,
    ACTIONS(78), 1,
      anon_sym_LT_SLASH,
    ACTIONS(81), 1,
      sym_text,
    ACTIONS(84), 1,
      sym__html_interpolation_start,
    STATE(5), 1,
      sym_start_tag,
    STATE(82), 1,
      sym_self_closing_style_tag,
    STATE(83), 1,
      sym_self_closing_script_tag,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(116), 1,
      sym_script_start_tag,
    STATE(117), 1,
      sym_style_start_tag,
    STATE(10), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [468] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LT_BANG,
    ACTIONS(9), 1,
      anon_sym_LT,
    ACTIONS(11), 1,
      anon_sym_LT_SLASH,
    ACTIONS(17), 1,
      sym__html_interpolation_start,
    ACTIONS(87), 1,
      ts_builtin_sym_end,
    ACTIONS(89), 1,
      sym_text,
    STATE(4), 1,
      sym_start_tag,
    STATE(64), 1,
      sym_self_closing_tag,
    STATE(66), 1,
      sym_self_closing_script_tag,
    STATE(74), 1,
      sym_self_closing_style_tag,
    STATE(118), 1,
      sym_style_start_tag,
    STATE(119), 1,
      sym_script_start_tag,
    STATE(9), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [518] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LT_BANG,
    ACTIONS(9), 1,
      anon_sym_LT,
    ACTIONS(11), 1,
      anon_sym_LT_SLASH,
    ACTIONS(17), 1,
      sym__html_interpolation_start,
    ACTIONS(70), 1,
      sym_text,
    ACTIONS(87), 1,
      ts_builtin_sym_end,
    STATE(4), 1,
      sym_start_tag,
    STATE(64), 1,
      sym_self_closing_tag,
    STATE(66), 1,
      sym_self_closing_script_tag,
    STATE(74), 1,
      sym_self_closing_style_tag,
    STATE(118), 1,
      sym_style_start_tag,
    STATE(119), 1,
      sym_script_start_tag,
    STATE(8), 8,
      sym_doctype,
      sym__node,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym_erroneous_end_tag,
      sym_html_interpolation,
      aux_sym_document_repeat1,
  [568] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_LT_BANG,
    ACTIONS(93), 1,
      anon_sym_LT,
    ACTIONS(95), 1,
      sym__html_interpolation_start,
    ACTIONS(97), 1,
      sym__html_interpolation_end,
    ACTIONS(99), 1,
      sym_permissible_text,
    STATE(6), 1,
      sym_start_tag,
    STATE(87), 1,
      sym_self_closing_style_tag,
    STATE(88), 1,
      sym_self_closing_script_tag,
    STATE(96), 1,
      sym_self_closing_tag,
    STATE(121), 1,
      sym_script_start_tag,
    STATE(122), 1,
      sym_style_start_tag,
    STATE(18), 7,
      sym_doctype,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__node_with_permissible_text,
      sym_html_interpolation,
      aux_sym_html_interpolation_repeat1,
  [614] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_LT_BANG,
    ACTIONS(104), 1,
      anon_sym_LT,
    ACTIONS(107), 1,
      sym__html_interpolation_start,
    ACTIONS(110), 1,
      sym__html_interpolation_end,
    ACTIONS(112), 1,
      sym_permissible_text,
    STATE(6), 1,
      sym_start_tag,
    STATE(87), 1,
      sym_self_closing_style_tag,
    STATE(88), 1,
      sym_self_closing_script_tag,
    STATE(96), 1,
      sym_self_closing_tag,
    STATE(121), 1,
      sym_script_start_tag,
    STATE(122), 1,
      sym_style_start_tag,
    STATE(14), 7,
      sym_doctype,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__node_with_permissible_text,
      sym_html_interpolation,
      aux_sym_html_interpolation_repeat1,
  [660] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_LT_BANG,
    ACTIONS(93), 1,
      anon_sym_LT,
    ACTIONS(95), 1,
      sym__html_interpolation_start,
    ACTIONS(115), 1,
      sym__html_interpolation_end,
    ACTIONS(117), 1,
      sym_permissible_text,
    STATE(6), 1,
      sym_start_tag,
    STATE(87), 1,
      sym_self_closing_style_tag,
    STATE(88), 1,
      sym_self_closing_script_tag,
    STATE(96), 1,
      sym_self_closing_tag,
    STATE(121), 1,
      sym_script_start_tag,
    STATE(122), 1,
      sym_style_start_tag,
    STATE(19), 7,
      sym_doctype,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__node_with_permissible_text,
      sym_html_interpolation,
      aux_sym_html_interpolation_repeat1,
  [706] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_LT_BANG,
    ACTIONS(93), 1,
      anon_sym_LT,
    ACTIONS(95), 1,
      sym__html_interpolation_start,
    ACTIONS(119), 1,
      sym__html_interpolation_end,
    ACTIONS(121), 1,
      sym_permissible_text,
    STATE(6), 1,
      sym_start_tag,
    STATE(87), 1,
      sym_self_closing_style_tag,
    STATE(88), 1,
      sym_self_closing_script_tag,
    STATE(96), 1,
      sym_self_closing_tag,
    STATE(121), 1,
      sym_script_start_tag,
    STATE(122), 1,
      sym_style_start_tag,
    STATE(14), 7,
      sym_doctype,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__node_with_permissible_text,
      sym_html_interpolation,
      aux_sym_html_interpolation_repeat1,
  [752] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_LT_BANG,
    ACTIONS(93), 1,
      anon_sym_LT,
    ACTIONS(95), 1,
      sym__html_interpolation_start,
    ACTIONS(123), 1,
      sym__html_interpolation_end,
    ACTIONS(125), 1,
      sym_permissible_text,
    STATE(6), 1,
      sym_start_tag,
    STATE(87), 1,
      sym_self_closing_style_tag,
    STATE(88), 1,
      sym_self_closing_script_tag,
    STATE(96), 1,
      sym_self_closing_tag,
    STATE(121), 1,
      sym_script_start_tag,
    STATE(122), 1,
      sym_style_start_tag,
    STATE(16), 7,
      sym_doctype,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__node_with_permissible_text,
      sym_html_interpolation,
      aux_sym_html_interpolation_repeat1,
  [798] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_LT_BANG,
    ACTIONS(93), 1,
      anon_sym_LT,
    ACTIONS(95), 1,
      sym__html_interpolation_start,
    ACTIONS(121), 1,
      sym_permissible_text,
    ACTIONS(127), 1,
      sym__html_interpolation_end,
    STATE(6), 1,
      sym_start_tag,
    STATE(87), 1,
      sym_self_closing_style_tag,
    STATE(88), 1,
      sym_self_closing_script_tag,
    STATE(96), 1,
      sym_self_closing_tag,
    STATE(121), 1,
      sym_script_start_tag,
    STATE(122), 1,
      sym_style_start_tag,
    STATE(14), 7,
      sym_doctype,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__node_with_permissible_text,
      sym_html_interpolation,
      aux_sym_html_interpolation_repeat1,
  [844] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_LT_BANG,
    ACTIONS(93), 1,
      anon_sym_LT,
    ACTIONS(95), 1,
      sym__html_interpolation_start,
    ACTIONS(121), 1,
      sym_permissible_text,
    ACTIONS(129), 1,
      sym__html_interpolation_end,
    STATE(6), 1,
      sym_start_tag,
    STATE(87), 1,
      sym_self_closing_style_tag,
    STATE(88), 1,
      sym_self_closing_script_tag,
    STATE(96), 1,
      sym_self_closing_tag,
    STATE(121), 1,
      sym_script_start_tag,
    STATE(122), 1,
      sym_style_start_tag,
    STATE(14), 7,
      sym_doctype,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__node_with_permissible_text,
      sym_html_interpolation,
      aux_sym_html_interpolation_repeat1,
  [890] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_GT,
    ACTIONS(133), 1,
      anon_sym_SLASH_GT,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(35), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [913] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(139), 1,
      anon_sym_GT,
    ACTIONS(141), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(32), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [936] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      anon_sym_GT,
    ACTIONS(145), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(147), 1,
      anon_sym_GT,
    ACTIONS(149), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(33), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [982] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(139), 1,
      anon_sym_GT,
    ACTIONS(151), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(30), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1005] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(147), 1,
      anon_sym_GT,
    ACTIONS(153), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(29), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1028] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_GT,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(155), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(22), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1051] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(157), 1,
      anon_sym_GT,
    ACTIONS(159), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1074] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_GT,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(161), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(38), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1097] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(163), 1,
      anon_sym_GT,
    ACTIONS(165), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1120] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(157), 1,
      anon_sym_GT,
    ACTIONS(167), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1143] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(147), 1,
      anon_sym_GT,
    ACTIONS(169), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(37), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(157), 1,
      anon_sym_GT,
    ACTIONS(171), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(163), 1,
      anon_sym_GT,
    ACTIONS(173), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1212] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(139), 1,
      anon_sym_GT,
    ACTIONS(175), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(27), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1235] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      anon_sym_GT,
    ACTIONS(177), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1258] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(179), 1,
      sym_attribute_value,
    ACTIONS(181), 1,
      anon_sym_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_DQUOTE,
    ACTIONS(185), 1,
      sym_attribute_backtick_string,
    STATE(111), 2,
      sym_quoted_attribute_value,
      sym_attribute_interpolation,
  [1281] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(163), 1,
      anon_sym_GT,
    ACTIONS(187), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1304] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 1,
      sym_attribute_name,
    ACTIONS(137), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      anon_sym_GT,
    ACTIONS(189), 1,
      anon_sym_SLASH_GT,
    STATE(113), 1,
      sym_attribute_interpolation,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(193), 1,
      sym_attribute_name,
    ACTIONS(196), 1,
      anon_sym_LBRACE,
    STATE(113), 1,
      sym_attribute_interpolation,
    ACTIONS(191), 2,
      anon_sym_GT,
      anon_sym_SLASH_GT,
    STATE(39), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [1348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LT,
    ACTIONS(199), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(205), 1,
      anon_sym_LT,
    ACTIONS(203), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(207), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_LT,
    ACTIONS(211), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(217), 1,
      anon_sym_LT,
    ACTIONS(215), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_LT,
    ACTIONS(219), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_LT,
    ACTIONS(223), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(205), 1,
      anon_sym_LT,
    ACTIONS(203), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LT,
    ACTIONS(227), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 1,
      anon_sym_LT,
    ACTIONS(231), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 1,
      anon_sym_LT,
    ACTIONS(235), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(241), 1,
      anon_sym_LT,
    ACTIONS(239), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_LT,
    ACTIONS(243), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(249), 1,
      anon_sym_LT,
    ACTIONS(247), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 1,
      anon_sym_LT,
    ACTIONS(251), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(257), 1,
      anon_sym_LT,
    ACTIONS(255), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(261), 1,
      anon_sym_LT,
    ACTIONS(259), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(265), 1,
      anon_sym_LT,
    ACTIONS(263), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_LT,
    ACTIONS(267), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      anon_sym_LT,
    ACTIONS(271), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LT,
    ACTIONS(275), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LT,
    ACTIONS(275), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LT,
    ACTIONS(279), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(257), 1,
      anon_sym_LT,
    ACTIONS(255), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(285), 1,
      anon_sym_LT,
    ACTIONS(283), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(241), 1,
      anon_sym_LT,
    ACTIONS(239), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LT,
    ACTIONS(287), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 1,
      anon_sym_LT,
    ACTIONS(231), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LT,
    ACTIONS(227), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      anon_sym_LT,
    ACTIONS(271), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_LT,
    ACTIONS(267), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(265), 1,
      anon_sym_LT,
    ACTIONS(263), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(261), 1,
      anon_sym_LT,
    ACTIONS(259), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_LT,
    ACTIONS(243), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LT,
    ACTIONS(291), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LT,
    ACTIONS(295), 5,
      sym__html_interpolation_start,
      ts_builtin_sym_end,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 1,
      anon_sym_LT,
    ACTIONS(235), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LT,
    ACTIONS(199), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_LT,
    ACTIONS(211), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(207), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_LT,
    ACTIONS(223), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LT,
    ACTIONS(295), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LT,
    ACTIONS(291), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LT,
    ACTIONS(287), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(301), 1,
      anon_sym_LT,
    ACTIONS(299), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(285), 1,
      anon_sym_LT,
    ACTIONS(283), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [1992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(249), 1,
      anon_sym_LT,
    ACTIONS(247), 5,
      sym__implicit_end_tag,
      sym__html_interpolation_start,
      anon_sym_LT_BANG,
      anon_sym_LT_SLASH,
      sym_text,
  [2006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LT,
    ACTIONS(291), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LT,
    ACTIONS(287), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LT,
    ACTIONS(199), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(261), 1,
      anon_sym_LT,
    ACTIONS(259), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(265), 1,
      anon_sym_LT,
    ACTIONS(263), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_LT,
    ACTIONS(267), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      anon_sym_LT,
    ACTIONS(271), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LT,
    ACTIONS(275), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(257), 1,
      anon_sym_LT,
    ACTIONS(255), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(285), 1,
      anon_sym_LT,
    ACTIONS(283), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 1,
      anon_sym_LT,
    ACTIONS(231), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LT,
    ACTIONS(227), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_LT,
    ACTIONS(211), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(207), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(205), 1,
      anon_sym_LT,
    ACTIONS(203), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_LT,
    ACTIONS(223), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LT,
    ACTIONS(295), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(305), 1,
      anon_sym_EQ,
    ACTIONS(307), 1,
      sym_attribute_name,
    ACTIONS(303), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_LBRACE,
  [2242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_LT,
    ACTIONS(243), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 1,
      anon_sym_LT,
    ACTIONS(235), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(241), 1,
      anon_sym_LT,
    ACTIONS(239), 4,
      sym__html_interpolation_start,
      sym__html_interpolation_end,
      sym_permissible_text,
      anon_sym_LT_BANG,
  [2281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym_attribute_name,
    ACTIONS(309), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_LBRACE,
  [2293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 1,
      sym_attribute_name,
    ACTIONS(313), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_LBRACE,
  [2305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(319), 1,
      sym_attribute_name,
    ACTIONS(317), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_LBRACE,
  [2317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(323), 1,
      sym_attribute_name,
    ACTIONS(321), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_LBRACE,
  [2329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(325), 1,
      sym__start_tag_name,
    ACTIONS(327), 1,
      sym__script_start_tag_name,
    ACTIONS(329), 1,
      sym__style_start_tag_name,
    ACTIONS(331), 1,
      sym__fragment_tag_delim,
  [2345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(307), 1,
      sym_attribute_name,
    ACTIONS(303), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_LBRACE,
  [2357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(331), 1,
      sym__fragment_tag_delim,
    ACTIONS(333), 1,
      sym__start_tag_name,
    ACTIONS(335), 1,
      sym__script_start_tag_name,
    ACTIONS(337), 1,
      sym__style_start_tag_name,
  [2373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(331), 1,
      sym__fragment_tag_delim,
    ACTIONS(339), 1,
      sym__start_tag_name,
    ACTIONS(341), 1,
      sym__script_start_tag_name,
    ACTIONS(343), 1,
      sym__style_start_tag_name,
  [2389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(345), 1,
      anon_sym_LT_SLASH,
    ACTIONS(347), 1,
      sym_raw_text,
    STATE(41), 1,
      sym_end_tag,
  [2402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(345), 1,
      anon_sym_LT_SLASH,
    ACTIONS(349), 1,
      sym_raw_text,
    STATE(79), 1,
      sym_end_tag,
  [2415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(351), 1,
      anon_sym_LT_SLASH,
    ACTIONS(353), 1,
      sym_raw_text,
    STATE(42), 1,
      sym_end_tag,
  [2428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(351), 1,
      anon_sym_LT_SLASH,
    ACTIONS(355), 1,
      sym_raw_text,
    STATE(47), 1,
      sym_end_tag,
  [2441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(357), 1,
      sym__end_tag_name,
    ACTIONS(359), 1,
      sym_erroneous_end_tag_name,
    ACTIONS(361), 1,
      sym__fragment_tag_delim,
  [2454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_LT_SLASH,
    ACTIONS(365), 1,
      sym_raw_text,
    STATE(101), 1,
      sym_end_tag,
  [2467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_LT_SLASH,
    ACTIONS(367), 1,
      sym_raw_text,
    STATE(100), 1,
      sym_end_tag,
  [2480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(359), 1,
      sym_erroneous_end_tag_name,
    ACTIONS(369), 1,
      sym__end_tag_name,
    ACTIONS(371), 1,
      sym__fragment_tag_delim,
  [2493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(359), 1,
      sym_erroneous_end_tag_name,
    ACTIONS(373), 1,
      sym__end_tag_name,
    ACTIONS(375), 1,
      sym__fragment_tag_delim,
  [2506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(377), 1,
      anon_sym_SQUOTE,
    ACTIONS(379), 1,
      aux_sym_quoted_attribute_value_token1,
  [2516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(377), 1,
      anon_sym_DQUOTE,
    ACTIONS(381), 1,
      aux_sym_quoted_attribute_value_token2,
  [2526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(383), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [2534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(351), 1,
      anon_sym_LT_SLASH,
    STATE(58), 1,
      sym_end_tag,
  [2544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(385), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [2552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_LT_SLASH,
    STATE(92), 1,
      sym_end_tag,
  [2562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(373), 1,
      sym__end_tag_name,
    ACTIONS(375), 1,
      sym__fragment_tag_delim,
  [2572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_LT_SLASH,
    STATE(93), 1,
      sym_end_tag,
  [2582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(387), 1,
      anon_sym_DASH_DASH_DASH2,
    ACTIONS(389), 1,
      sym_frontmatter_js_block,
  [2592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(345), 1,
      anon_sym_LT_SLASH,
    STATE(69), 1,
      sym_end_tag,
  [2602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym__end_tag_name,
    ACTIONS(371), 1,
      sym__fragment_tag_delim,
  [2612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(357), 1,
      sym__end_tag_name,
    ACTIONS(361), 1,
      sym__fragment_tag_delim,
  [2622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(345), 1,
      anon_sym_LT_SLASH,
    STATE(70), 1,
      sym_end_tag,
  [2632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(391), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [2640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(393), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [2648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(351), 1,
      anon_sym_LT_SLASH,
    STATE(59), 1,
      sym_end_tag,
  [2658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(395), 1,
      anon_sym_GT,
  [2665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(397), 1,
      anon_sym_GT,
  [2672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_SQUOTE,
  [2679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
  [2686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(401), 1,
      anon_sym_RBRACE,
  [2693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_GT,
  [2700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      ts_builtin_sym_end,
  [2707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(407), 1,
      sym__doctype,
  [2714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(409), 1,
      anon_sym_GT,
  [2721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(411), 1,
      aux_sym_doctype_token1,
  [2728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(413), 1,
      anon_sym_GT,
  [2735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      anon_sym_GT,
  [2742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(417), 1,
      sym_erroneous_end_tag_name,
  [2749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 1,
      anon_sym_GT,
  [2756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(421), 1,
      anon_sym_GT,
  [2763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(423), 1,
      anon_sym_DASH_DASH_DASH2,
  [2770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(359), 1,
      sym_erroneous_end_tag_name,
  [2777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      aux_sym_doctype_token1,
  [2784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_attribute_js_expr,
  [2791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      aux_sym_doctype_token1,
  [2798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(431), 1,
      sym__doctype,
  [2805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(433), 1,
      sym__doctype,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 53,
  [SMALL_STATE(4)] = 106,
  [SMALL_STATE(5)] = 159,
  [SMALL_STATE(6)] = 212,
  [SMALL_STATE(7)] = 265,
  [SMALL_STATE(8)] = 318,
  [SMALL_STATE(9)] = 368,
  [SMALL_STATE(10)] = 418,
  [SMALL_STATE(11)] = 468,
  [SMALL_STATE(12)] = 518,
  [SMALL_STATE(13)] = 568,
  [SMALL_STATE(14)] = 614,
  [SMALL_STATE(15)] = 660,
  [SMALL_STATE(16)] = 706,
  [SMALL_STATE(17)] = 752,
  [SMALL_STATE(18)] = 798,
  [SMALL_STATE(19)] = 844,
  [SMALL_STATE(20)] = 890,
  [SMALL_STATE(21)] = 913,
  [SMALL_STATE(22)] = 936,
  [SMALL_STATE(23)] = 959,
  [SMALL_STATE(24)] = 982,
  [SMALL_STATE(25)] = 1005,
  [SMALL_STATE(26)] = 1028,
  [SMALL_STATE(27)] = 1051,
  [SMALL_STATE(28)] = 1074,
  [SMALL_STATE(29)] = 1097,
  [SMALL_STATE(30)] = 1120,
  [SMALL_STATE(31)] = 1143,
  [SMALL_STATE(32)] = 1166,
  [SMALL_STATE(33)] = 1189,
  [SMALL_STATE(34)] = 1212,
  [SMALL_STATE(35)] = 1235,
  [SMALL_STATE(36)] = 1258,
  [SMALL_STATE(37)] = 1281,
  [SMALL_STATE(38)] = 1304,
  [SMALL_STATE(39)] = 1327,
  [SMALL_STATE(40)] = 1348,
  [SMALL_STATE(41)] = 1362,
  [SMALL_STATE(42)] = 1376,
  [SMALL_STATE(43)] = 1390,
  [SMALL_STATE(44)] = 1404,
  [SMALL_STATE(45)] = 1418,
  [SMALL_STATE(46)] = 1432,
  [SMALL_STATE(47)] = 1446,
  [SMALL_STATE(48)] = 1460,
  [SMALL_STATE(49)] = 1474,
  [SMALL_STATE(50)] = 1488,
  [SMALL_STATE(51)] = 1502,
  [SMALL_STATE(52)] = 1516,
  [SMALL_STATE(53)] = 1530,
  [SMALL_STATE(54)] = 1544,
  [SMALL_STATE(55)] = 1558,
  [SMALL_STATE(56)] = 1572,
  [SMALL_STATE(57)] = 1586,
  [SMALL_STATE(58)] = 1600,
  [SMALL_STATE(59)] = 1614,
  [SMALL_STATE(60)] = 1628,
  [SMALL_STATE(61)] = 1642,
  [SMALL_STATE(62)] = 1656,
  [SMALL_STATE(63)] = 1670,
  [SMALL_STATE(64)] = 1684,
  [SMALL_STATE(65)] = 1698,
  [SMALL_STATE(66)] = 1712,
  [SMALL_STATE(67)] = 1726,
  [SMALL_STATE(68)] = 1740,
  [SMALL_STATE(69)] = 1754,
  [SMALL_STATE(70)] = 1768,
  [SMALL_STATE(71)] = 1782,
  [SMALL_STATE(72)] = 1796,
  [SMALL_STATE(73)] = 1810,
  [SMALL_STATE(74)] = 1824,
  [SMALL_STATE(75)] = 1838,
  [SMALL_STATE(76)] = 1852,
  [SMALL_STATE(77)] = 1866,
  [SMALL_STATE(78)] = 1880,
  [SMALL_STATE(79)] = 1894,
  [SMALL_STATE(80)] = 1908,
  [SMALL_STATE(81)] = 1922,
  [SMALL_STATE(82)] = 1936,
  [SMALL_STATE(83)] = 1950,
  [SMALL_STATE(84)] = 1964,
  [SMALL_STATE(85)] = 1978,
  [SMALL_STATE(86)] = 1992,
  [SMALL_STATE(87)] = 2006,
  [SMALL_STATE(88)] = 2019,
  [SMALL_STATE(89)] = 2032,
  [SMALL_STATE(90)] = 2045,
  [SMALL_STATE(91)] = 2058,
  [SMALL_STATE(92)] = 2071,
  [SMALL_STATE(93)] = 2084,
  [SMALL_STATE(94)] = 2097,
  [SMALL_STATE(95)] = 2110,
  [SMALL_STATE(96)] = 2123,
  [SMALL_STATE(97)] = 2136,
  [SMALL_STATE(98)] = 2149,
  [SMALL_STATE(99)] = 2162,
  [SMALL_STATE(100)] = 2175,
  [SMALL_STATE(101)] = 2188,
  [SMALL_STATE(102)] = 2201,
  [SMALL_STATE(103)] = 2214,
  [SMALL_STATE(104)] = 2227,
  [SMALL_STATE(105)] = 2242,
  [SMALL_STATE(106)] = 2255,
  [SMALL_STATE(107)] = 2268,
  [SMALL_STATE(108)] = 2281,
  [SMALL_STATE(109)] = 2293,
  [SMALL_STATE(110)] = 2305,
  [SMALL_STATE(111)] = 2317,
  [SMALL_STATE(112)] = 2329,
  [SMALL_STATE(113)] = 2345,
  [SMALL_STATE(114)] = 2357,
  [SMALL_STATE(115)] = 2373,
  [SMALL_STATE(116)] = 2389,
  [SMALL_STATE(117)] = 2402,
  [SMALL_STATE(118)] = 2415,
  [SMALL_STATE(119)] = 2428,
  [SMALL_STATE(120)] = 2441,
  [SMALL_STATE(121)] = 2454,
  [SMALL_STATE(122)] = 2467,
  [SMALL_STATE(123)] = 2480,
  [SMALL_STATE(124)] = 2493,
  [SMALL_STATE(125)] = 2506,
  [SMALL_STATE(126)] = 2516,
  [SMALL_STATE(127)] = 2526,
  [SMALL_STATE(128)] = 2534,
  [SMALL_STATE(129)] = 2544,
  [SMALL_STATE(130)] = 2552,
  [SMALL_STATE(131)] = 2562,
  [SMALL_STATE(132)] = 2572,
  [SMALL_STATE(133)] = 2582,
  [SMALL_STATE(134)] = 2592,
  [SMALL_STATE(135)] = 2602,
  [SMALL_STATE(136)] = 2612,
  [SMALL_STATE(137)] = 2622,
  [SMALL_STATE(138)] = 2632,
  [SMALL_STATE(139)] = 2640,
  [SMALL_STATE(140)] = 2648,
  [SMALL_STATE(141)] = 2658,
  [SMALL_STATE(142)] = 2665,
  [SMALL_STATE(143)] = 2672,
  [SMALL_STATE(144)] = 2679,
  [SMALL_STATE(145)] = 2686,
  [SMALL_STATE(146)] = 2693,
  [SMALL_STATE(147)] = 2700,
  [SMALL_STATE(148)] = 2707,
  [SMALL_STATE(149)] = 2714,
  [SMALL_STATE(150)] = 2721,
  [SMALL_STATE(151)] = 2728,
  [SMALL_STATE(152)] = 2735,
  [SMALL_STATE(153)] = 2742,
  [SMALL_STATE(154)] = 2749,
  [SMALL_STATE(155)] = 2756,
  [SMALL_STATE(156)] = 2763,
  [SMALL_STATE(157)] = 2770,
  [SMALL_STATE(158)] = 2777,
  [SMALL_STATE(159)] = 2784,
  [SMALL_STATE(160)] = 2791,
  [SMALL_STATE(161)] = 2798,
  [SMALL_STATE(162)] = 2805,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2),
  [53] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(148),
  [56] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(112),
  [59] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(153),
  [62] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(8),
  [65] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(13),
  [68] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 2),
  [70] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [72] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(162),
  [75] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(115),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(157),
  [81] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(10),
  [84] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(17),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 1),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_html_interpolation_repeat1, 2), SHIFT_REPEAT(161),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_html_interpolation_repeat1, 2), SHIFT_REPEAT(114),
  [107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_html_interpolation_repeat1, 2), SHIFT_REPEAT(15),
  [110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_html_interpolation_repeat1, 2),
  [112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_html_interpolation_repeat1, 2), SHIFT_REPEAT(14),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(104),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(159),
  [199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_tag, 3),
  [201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_tag, 3),
  [203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 2),
  [205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 2),
  [207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 2),
  [209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 2),
  [211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_interpolation, 3),
  [213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_interpolation, 3),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frontmatter, 2),
  [217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_frontmatter, 2),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_tag, 3),
  [221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_tag, 3),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 2),
  [225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 2),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_tag, 3),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_tag, 3),
  [231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_style_tag, 4),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_style_tag, 4),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_script_tag, 3),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_script_tag, 3),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_script_tag, 4),
  [241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_script_tag, 4),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_style_tag, 3),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_style_tag, 3),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_erroneous_end_tag, 3),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_erroneous_end_tag, 3),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frontmatter, 3),
  [253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_frontmatter, 3),
  [255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_tag, 4),
  [257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_tag, 4),
  [259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_tag, 2),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_tag, 2),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 3),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 3),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 3),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 3),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 3),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 3),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_doctype, 4),
  [277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_doctype, 4),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_tag, 4),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_tag, 4),
  [283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 1),
  [285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 1),
  [287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 1),
  [289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 1),
  [291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 1),
  [293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 1),
  [295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_interpolation, 2),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_interpolation, 2),
  [299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_tag, 2),
  [301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_tag, 2),
  [303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 1),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_attribute_value, 3),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_attribute_value, 3),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_attribute_value, 2),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_attribute_value, 2),
  [317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_interpolation, 3),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_interpolation, 3),
  [321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3),
  [323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_start_tag, 3),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_start_tag, 3),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_start_tag, 4),
  [393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_start_tag, 4),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [405] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__start_tag_name = 0,
  ts_external_token__script_start_tag_name = 1,
  ts_external_token__style_start_tag_name = 2,
  ts_external_token__end_tag_name = 3,
  ts_external_token_erroneous_end_tag_name = 4,
  ts_external_token_SLASH_GT = 5,
  ts_external_token__implicit_end_tag = 6,
  ts_external_token_raw_text = 7,
  ts_external_token_comment = 8,
  ts_external_token__html_interpolation_start = 9,
  ts_external_token__html_interpolation_end = 10,
  ts_external_token_frontmatter_js_block = 11,
  ts_external_token_attribute_js_expr = 12,
  ts_external_token_attribute_backtick_string = 13,
  ts_external_token_permissible_text = 14,
  ts_external_token__fragment_tag_delim = 15,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__start_tag_name] = sym__start_tag_name,
  [ts_external_token__script_start_tag_name] = sym__script_start_tag_name,
  [ts_external_token__style_start_tag_name] = sym__style_start_tag_name,
  [ts_external_token__end_tag_name] = sym__end_tag_name,
  [ts_external_token_erroneous_end_tag_name] = sym_erroneous_end_tag_name,
  [ts_external_token_SLASH_GT] = anon_sym_SLASH_GT,
  [ts_external_token__implicit_end_tag] = sym__implicit_end_tag,
  [ts_external_token_raw_text] = sym_raw_text,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token__html_interpolation_start] = sym__html_interpolation_start,
  [ts_external_token__html_interpolation_end] = sym__html_interpolation_end,
  [ts_external_token_frontmatter_js_block] = sym_frontmatter_js_block,
  [ts_external_token_attribute_js_expr] = sym_attribute_js_expr,
  [ts_external_token_attribute_backtick_string] = sym_attribute_backtick_string,
  [ts_external_token_permissible_text] = sym_permissible_text,
  [ts_external_token__fragment_tag_delim] = sym__fragment_tag_delim,
};

static const bool ts_external_scanner_states[15][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__start_tag_name] = true,
    [ts_external_token__script_start_tag_name] = true,
    [ts_external_token__style_start_tag_name] = true,
    [ts_external_token__end_tag_name] = true,
    [ts_external_token_erroneous_end_tag_name] = true,
    [ts_external_token_SLASH_GT] = true,
    [ts_external_token__implicit_end_tag] = true,
    [ts_external_token_raw_text] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__html_interpolation_start] = true,
    [ts_external_token__html_interpolation_end] = true,
    [ts_external_token_frontmatter_js_block] = true,
    [ts_external_token_attribute_js_expr] = true,
    [ts_external_token_attribute_backtick_string] = true,
    [ts_external_token_permissible_text] = true,
    [ts_external_token__fragment_tag_delim] = true,
  },
  [2] = {
    [ts_external_token_comment] = true,
    [ts_external_token__html_interpolation_start] = true,
  },
  [3] = {
    [ts_external_token__implicit_end_tag] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__html_interpolation_start] = true,
  },
  [4] = {
    [ts_external_token_comment] = true,
    [ts_external_token__html_interpolation_start] = true,
    [ts_external_token__html_interpolation_end] = true,
    [ts_external_token_permissible_text] = true,
  },
  [5] = {
    [ts_external_token_SLASH_GT] = true,
    [ts_external_token_comment] = true,
  },
  [6] = {
    [ts_external_token_comment] = true,
    [ts_external_token_attribute_backtick_string] = true,
  },
  [7] = {
    [ts_external_token__start_tag_name] = true,
    [ts_external_token__script_start_tag_name] = true,
    [ts_external_token__style_start_tag_name] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__fragment_tag_delim] = true,
  },
  [8] = {
    [ts_external_token_raw_text] = true,
    [ts_external_token_comment] = true,
  },
  [9] = {
    [ts_external_token__end_tag_name] = true,
    [ts_external_token_erroneous_end_tag_name] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__fragment_tag_delim] = true,
  },
  [10] = {
    [ts_external_token_comment] = true,
  },
  [11] = {
    [ts_external_token__end_tag_name] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__fragment_tag_delim] = true,
  },
  [12] = {
    [ts_external_token_comment] = true,
    [ts_external_token_frontmatter_js_block] = true,
  },
  [13] = {
    [ts_external_token_erroneous_end_tag_name] = true,
    [ts_external_token_comment] = true,
  },
  [14] = {
    [ts_external_token_comment] = true,
    [ts_external_token_attribute_js_expr] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_astro_external_scanner_create(void);
void tree_sitter_astro_external_scanner_destroy(void *);
bool tree_sitter_astro_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_astro_external_scanner_serialize(void *, char *);
void tree_sitter_astro_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_astro(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_astro_external_scanner_create,
      tree_sitter_astro_external_scanner_destroy,
      tree_sitter_astro_external_scanner_scan,
      tree_sitter_astro_external_scanner_serialize,
      tree_sitter_astro_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
