#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 152
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 56
#define ALIAS_COUNT 2
#define TOKEN_COUNT 28
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 5
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 9

enum ts_symbol_identifiers {
  anon_sym_PERCENT_LBRACK = 1,
  aux_sym_intent_def_token1 = 2,
  anon_sym_RBRACK = 3,
  anon_sym_AT_LBRACK = 4,
  aux_sym_slot_def_token1 = 5,
  anon_sym_TILDE_LBRACK = 6,
  anon_sym_import = 7,
  aux_sym_import_token1 = 8,
  aux_sym_comment_token1 = 9,
  anon_sym_QMARK = 10,
  aux_sym_word_token1 = 11,
  anon_sym_POUND = 12,
  anon_sym_STAR_LBRACK = 13,
  anon_sym_PERCENT = 14,
  sym_number = 15,
  anon_sym_LPAREN = 16,
  anon_sym_COMMA = 17,
  anon_sym_RPAREN = 18,
  sym_eq = 19,
  anon_sym_DQUOTE = 20,
  aux_sym_string_token1 = 21,
  anon_sym_SQUOTE = 22,
  aux_sym_string_token2 = 23,
  sym_escape = 24,
  sym__eol = 25,
  sym__indent = 26,
  sym__space = 27,
  sym_source = 28,
  sym__definition = 29,
  sym_intent_def = 30,
  sym_slot_def = 31,
  sym_alias_def = 32,
  sym_import = 33,
  sym_comment = 34,
  sym_intent_body = 35,
  sym_slot_body = 36,
  sym_alias_body = 37,
  sym_slot_ref = 38,
  sym_alias_ref = 39,
  sym_word = 40,
  sym_variation = 41,
  sym_probability = 42,
  sym_arguments = 43,
  sym_argument = 44,
  sym_string = 45,
  aux_sym_source_repeat1 = 46,
  aux_sym_intent_body_repeat1 = 47,
  aux_sym_intent_body_repeat2 = 48,
  aux_sym_slot_body_repeat1 = 49,
  aux_sym_slot_body_repeat2 = 50,
  aux_sym_alias_body_repeat1 = 51,
  aux_sym_word_repeat1 = 52,
  aux_sym_arguments_repeat1 = 53,
  aux_sym_string_repeat1 = 54,
  aux_sym_string_repeat2 = 55,
  alias_sym_intent = 56,
  alias_sym_slot = 57,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_PERCENT_LBRACK] = "%[",
  [aux_sym_intent_def_token1] = "alias",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT_LBRACK] = "@[",
  [aux_sym_slot_def_token1] = "slot_def_token1",
  [anon_sym_TILDE_LBRACK] = "~[",
  [anon_sym_import] = "import",
  [aux_sym_import_token1] = "file",
  [aux_sym_comment_token1] = "comment_token1",
  [anon_sym_QMARK] = "\?",
  [aux_sym_word_token1] = "word_token1",
  [anon_sym_POUND] = "#",
  [anon_sym_STAR_LBRACK] = "*[",
  [anon_sym_PERCENT] = "%",
  [sym_number] = "number",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [sym_eq] = "eq",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape] = "escape",
  [sym__eol] = "_eol",
  [sym__indent] = "_indent",
  [sym__space] = "_space",
  [sym_source] = "source",
  [sym__definition] = "_definition",
  [sym_intent_def] = "intent_def",
  [sym_slot_def] = "slot_def",
  [sym_alias_def] = "alias_def",
  [sym_import] = "import",
  [sym_comment] = "comment",
  [sym_intent_body] = "intent_body",
  [sym_slot_body] = "slot_body",
  [sym_alias_body] = "alias_body",
  [sym_slot_ref] = "slot_ref",
  [sym_alias_ref] = "alias_ref",
  [sym_word] = "word",
  [sym_variation] = "variation",
  [sym_probability] = "probability",
  [sym_arguments] = "arguments",
  [sym_argument] = "argument",
  [sym_string] = "string",
  [aux_sym_source_repeat1] = "source_repeat1",
  [aux_sym_intent_body_repeat1] = "intent_body_repeat1",
  [aux_sym_intent_body_repeat2] = "intent_body_repeat2",
  [aux_sym_slot_body_repeat1] = "slot_body_repeat1",
  [aux_sym_slot_body_repeat2] = "slot_body_repeat2",
  [aux_sym_alias_body_repeat1] = "alias_body_repeat1",
  [aux_sym_word_repeat1] = "word_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [alias_sym_intent] = "intent",
  [alias_sym_slot] = "slot",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_PERCENT_LBRACK] = anon_sym_PERCENT_LBRACK,
  [aux_sym_intent_def_token1] = aux_sym_intent_def_token1,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT_LBRACK] = anon_sym_AT_LBRACK,
  [aux_sym_slot_def_token1] = aux_sym_slot_def_token1,
  [anon_sym_TILDE_LBRACK] = anon_sym_TILDE_LBRACK,
  [anon_sym_import] = anon_sym_import,
  [aux_sym_import_token1] = aux_sym_import_token1,
  [aux_sym_comment_token1] = aux_sym_comment_token1,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [aux_sym_word_token1] = aux_sym_word_token1,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_STAR_LBRACK] = anon_sym_STAR_LBRACK,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [sym_number] = sym_number,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [sym_eq] = sym_eq,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape] = sym_escape,
  [sym__eol] = sym__eol,
  [sym__indent] = sym__indent,
  [sym__space] = sym__space,
  [sym_source] = sym_source,
  [sym__definition] = sym__definition,
  [sym_intent_def] = sym_intent_def,
  [sym_slot_def] = sym_slot_def,
  [sym_alias_def] = sym_alias_def,
  [sym_import] = sym_import,
  [sym_comment] = sym_comment,
  [sym_intent_body] = sym_intent_body,
  [sym_slot_body] = sym_slot_body,
  [sym_alias_body] = sym_alias_body,
  [sym_slot_ref] = sym_slot_ref,
  [sym_alias_ref] = sym_alias_ref,
  [sym_word] = sym_word,
  [sym_variation] = sym_variation,
  [sym_probability] = sym_probability,
  [sym_arguments] = sym_arguments,
  [sym_argument] = sym_argument,
  [sym_string] = sym_string,
  [aux_sym_source_repeat1] = aux_sym_source_repeat1,
  [aux_sym_intent_body_repeat1] = aux_sym_intent_body_repeat1,
  [aux_sym_intent_body_repeat2] = aux_sym_intent_body_repeat2,
  [aux_sym_slot_body_repeat1] = aux_sym_slot_body_repeat1,
  [aux_sym_slot_body_repeat2] = aux_sym_slot_body_repeat2,
  [aux_sym_alias_body_repeat1] = aux_sym_alias_body_repeat1,
  [aux_sym_word_repeat1] = aux_sym_word_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [alias_sym_intent] = alias_sym_intent,
  [alias_sym_slot] = alias_sym_slot,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_PERCENT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intent_def_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_slot_def_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_TILDE_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_import_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_word_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_eq] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape] = {
    .visible = true,
    .named = true,
  },
  [sym__eol] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__space] = {
    .visible = false,
    .named = true,
  },
  [sym_source] = {
    .visible = true,
    .named = true,
  },
  [sym__definition] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_intent_def] = {
    .visible = true,
    .named = true,
  },
  [sym_slot_def] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_def] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_intent_body] = {
    .visible = true,
    .named = true,
  },
  [sym_slot_body] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_body] = {
    .visible = true,
    .named = true,
  },
  [sym_slot_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_variation] = {
    .visible = true,
    .named = true,
  },
  [sym_probability] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_intent_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_intent_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slot_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slot_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alias_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_word_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_intent] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_slot] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_content = 1,
  field_id = 2,
  field_key = 3,
  field_quote = 4,
  field_value = 5,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_content] = "content",
  [field_id] = "id",
  [field_key] = "key",
  [field_quote] = "quote",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 2},
  [5] = {.index = 3, .length = 3},
  [6] = {.index = 6, .length = 2},
  [7] = {.index = 8, .length = 2},
  [8] = {.index = 10, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_id, 1},
  [1] =
    {field_quote, 0},
    {field_quote, 1},
  [3] =
    {field_content, 1},
    {field_quote, 0},
    {field_quote, 2},
  [6] =
    {field_key, 0},
    {field_value, 2},
  [8] =
    {field_key, 0},
    {field_value, 3},
  [10] =
    {field_key, 0},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [1] = alias_sym_intent,
  },
  [3] = {
    [1] = alias_sym_slot,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 41,
  [58] = 58,
  [59] = 59,
  [60] = 42,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 47,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 52,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 81,
  [97] = 97,
  [98] = 98,
  [99] = 75,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 109,
  [113] = 113,
  [114] = 108,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 126,
  [149] = 128,
  [150] = 134,
  [151] = 139,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(30);
      ADVANCE_MAP(
        '\n', 62,
        '\r', 1,
        ' ', 56,
        '"', 55,
        '#', 45,
        '%', 47,
        '\'', 58,
        '(', 51,
        ')', 53,
        ',', 52,
        ':', 54,
        '?', 40,
        ']', 33,
        '\t', 56,
        0x0b, 56,
        '\f', 56,
      );
      if (lookahead != 0) ADVANCE(41);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(62);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '\n', 62,
        '\r', 1,
        ' ', 64,
        '"', 55,
        '#', 45,
        '%', 47,
        '\'', 58,
        '(', 51,
        ')', 53,
        ',', 52,
        ':', 54,
        '?', 40,
        ']', 33,
      );
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(62);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == ' ') ADVANCE(64);
      if (lookahead == '*') ADVANCE(44);
      if (lookahead == '@') ADVANCE(42);
      if (lookahead == '~') ADVANCE(43);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(41);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(62);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == ' ') ADVANCE(64);
      if (lookahead == '@') ADVANCE(42);
      if (lookahead == '~') ADVANCE(43);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(41);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(62);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == ' ') ADVANCE(64);
      if (lookahead == '~') ADVANCE(43);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(41);
      END_STATE();
    case 6:
      if (lookahead == ' ') ADVANCE(63);
      END_STATE();
    case 7:
      if (lookahead == ' ') ADVANCE(64);
      if (lookahead == '*') ADVANCE(44);
      if (lookahead == '~') ADVANCE(43);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(41);
      END_STATE();
    case 8:
      if (lookahead == ' ') ADVANCE(6);
      END_STATE();
    case 9:
      if (lookahead == ' ') ADVANCE(8);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(56);
      END_STATE();
    case 11:
      if (lookahead == '\'') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(59);
      END_STATE();
    case 12:
      if (lookahead == '/') ADVANCE(39);
      END_STATE();
    case 13:
      if (lookahead == '[') ADVANCE(31);
      END_STATE();
    case 14:
      if (lookahead == '[') ADVANCE(34);
      END_STATE();
    case 15:
      if (lookahead == '[') ADVANCE(36);
      END_STATE();
    case 16:
      if (lookahead == 'm') ADVANCE(18);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(19);
      END_STATE();
    case 18:
      if (lookahead == 'p') ADVANCE(17);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(22);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(23);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 26:
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '?' &&
          lookahead != ']') ADVANCE(35);
      END_STATE();
    case 27:
      if (lookahead != 0 &&
          lookahead != '?' &&
          lookahead != ']') ADVANCE(32);
      END_STATE();
    case 28:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(38);
      END_STATE();
    case 29:
      if (eof) ADVANCE(30);
      ADVANCE_MAP(
        '\n', 62,
        '\r', 1,
        ' ', 9,
        '"', 55,
        '#', 39,
        '%', 13,
        '\'', 58,
        '(', 51,
        ')', 53,
        ',', 52,
        '/', 12,
        '0', 48,
        ':', 54,
        '?', 40,
        '@', 14,
        ']', 33,
        'i', 16,
        '~', 15,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(49);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_PERCENT_LBRACK);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(aux_sym_intent_def_token1);
      if (lookahead != 0 &&
          lookahead != '?' &&
          lookahead != ']') ADVANCE(32);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_AT_LBRACK);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(aux_sym_slot_def_token1);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '?' &&
          lookahead != ']') ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_TILDE_LBRACK);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(aux_sym_import_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(38);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(39);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(aux_sym_word_token1);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(aux_sym_word_token1);
      if (lookahead == '[') ADVANCE(34);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(aux_sym_word_token1);
      if (lookahead == '[') ADVANCE(36);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(aux_sym_word_token1);
      if (lookahead == '[') ADVANCE(46);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_STAR_LBRACK);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(21);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(49);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_eq);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_string_token1);
      ADVANCE_MAP(
        'u', 25,
        '"', 61,
        '\'', 61,
        '\\', 61,
        'b', 61,
        'f', 61,
        'n', 61,
        'r', 61,
        't', 61,
        'v', 61,
      );
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym_string_token2);
      ADVANCE_MAP(
        'u', 25,
        '"', 61,
        '\'', 61,
        '\\', 61,
        'b', 61,
        'f', 61,
        'n', 61,
        'r', 61,
        't', 61,
        'v', 61,
      );
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_escape);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym__eol);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym__indent);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym__space);
      if (lookahead == ' ') ADVANCE(64);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 29},
  [2] = {.lex_state = 29},
  [3] = {.lex_state = 29},
  [4] = {.lex_state = 3},
  [5] = {.lex_state = 4},
  [6] = {.lex_state = 29},
  [7] = {.lex_state = 29},
  [8] = {.lex_state = 29},
  [9] = {.lex_state = 4},
  [10] = {.lex_state = 4},
  [11] = {.lex_state = 29},
  [12] = {.lex_state = 4},
  [13] = {.lex_state = 29},
  [14] = {.lex_state = 29},
  [15] = {.lex_state = 4},
  [16] = {.lex_state = 7},
  [17] = {.lex_state = 4},
  [18] = {.lex_state = 5},
  [19] = {.lex_state = 29},
  [20] = {.lex_state = 5},
  [21] = {.lex_state = 29},
  [22] = {.lex_state = 29},
  [23] = {.lex_state = 5},
  [24] = {.lex_state = 29},
  [25] = {.lex_state = 29},
  [26] = {.lex_state = 29},
  [27] = {.lex_state = 29},
  [28] = {.lex_state = 5},
  [29] = {.lex_state = 29},
  [30] = {.lex_state = 29},
  [31] = {.lex_state = 29},
  [32] = {.lex_state = 29},
  [33] = {.lex_state = 29},
  [34] = {.lex_state = 29},
  [35] = {.lex_state = 29},
  [36] = {.lex_state = 29},
  [37] = {.lex_state = 29},
  [38] = {.lex_state = 29},
  [39] = {.lex_state = 29},
  [40] = {.lex_state = 29},
  [41] = {.lex_state = 4},
  [42] = {.lex_state = 4},
  [43] = {.lex_state = 29},
  [44] = {.lex_state = 4},
  [45] = {.lex_state = 2},
  [46] = {.lex_state = 29},
  [47] = {.lex_state = 4},
  [48] = {.lex_state = 29},
  [49] = {.lex_state = 29},
  [50] = {.lex_state = 29},
  [51] = {.lex_state = 29},
  [52] = {.lex_state = 4},
  [53] = {.lex_state = 4},
  [54] = {.lex_state = 4},
  [55] = {.lex_state = 29},
  [56] = {.lex_state = 2},
  [57] = {.lex_state = 5},
  [58] = {.lex_state = 2},
  [59] = {.lex_state = 29},
  [60] = {.lex_state = 5},
  [61] = {.lex_state = 29},
  [62] = {.lex_state = 29},
  [63] = {.lex_state = 2},
  [64] = {.lex_state = 10},
  [65] = {.lex_state = 2},
  [66] = {.lex_state = 2},
  [67] = {.lex_state = 11},
  [68] = {.lex_state = 2},
  [69] = {.lex_state = 2},
  [70] = {.lex_state = 29},
  [71] = {.lex_state = 2},
  [72] = {.lex_state = 2},
  [73] = {.lex_state = 5},
  [74] = {.lex_state = 2},
  [75] = {.lex_state = 4},
  [76] = {.lex_state = 2},
  [77] = {.lex_state = 29},
  [78] = {.lex_state = 2},
  [79] = {.lex_state = 11},
  [80] = {.lex_state = 10},
  [81] = {.lex_state = 4},
  [82] = {.lex_state = 29},
  [83] = {.lex_state = 2},
  [84] = {.lex_state = 2},
  [85] = {.lex_state = 2},
  [86] = {.lex_state = 5},
  [87] = {.lex_state = 2},
  [88] = {.lex_state = 10},
  [89] = {.lex_state = 11},
  [90] = {.lex_state = 2},
  [91] = {.lex_state = 29},
  [92] = {.lex_state = 2},
  [93] = {.lex_state = 29},
  [94] = {.lex_state = 2},
  [95] = {.lex_state = 29},
  [96] = {.lex_state = 5},
  [97] = {.lex_state = 29},
  [98] = {.lex_state = 2},
  [99] = {.lex_state = 5},
  [100] = {.lex_state = 29},
  [101] = {.lex_state = 2},
  [102] = {.lex_state = 2},
  [103] = {.lex_state = 29},
  [104] = {.lex_state = 2},
  [105] = {.lex_state = 29},
  [106] = {.lex_state = 29},
  [107] = {.lex_state = 2},
  [108] = {.lex_state = 2},
  [109] = {.lex_state = 29},
  [110] = {.lex_state = 3},
  [111] = {.lex_state = 29},
  [112] = {.lex_state = 29},
  [113] = {.lex_state = 29},
  [114] = {.lex_state = 2},
  [115] = {.lex_state = 29},
  [116] = {.lex_state = 0},
  [117] = {.lex_state = 0},
  [118] = {.lex_state = 0},
  [119] = {.lex_state = 29},
  [120] = {.lex_state = 0},
  [121] = {.lex_state = 0},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 29},
  [124] = {.lex_state = 29},
  [125] = {.lex_state = 26},
  [126] = {.lex_state = 29},
  [127] = {.lex_state = 0},
  [128] = {.lex_state = 29},
  [129] = {.lex_state = 27},
  [130] = {.lex_state = 26},
  [131] = {.lex_state = 0},
  [132] = {.lex_state = 0},
  [133] = {.lex_state = 3},
  [134] = {.lex_state = 27},
  [135] = {.lex_state = 29},
  [136] = {.lex_state = 29},
  [137] = {.lex_state = 0},
  [138] = {.lex_state = 0},
  [139] = {.lex_state = 29},
  [140] = {.lex_state = 27},
  [141] = {.lex_state = 0},
  [142] = {.lex_state = 29},
  [143] = {.lex_state = 28},
  [144] = {.lex_state = 0},
  [145] = {.lex_state = 29},
  [146] = {.lex_state = 26},
  [147] = {.lex_state = 0},
  [148] = {.lex_state = 29},
  [149] = {.lex_state = 29},
  [150] = {.lex_state = 27},
  [151] = {.lex_state = 29},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [aux_sym_word_token1] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym_eq] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym_string_token1] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [aux_sym_string_token2] = ACTIONS(1),
    [sym__eol] = ACTIONS(1),
    [sym__space] = ACTIONS(1),
  },
  [1] = {
    [sym_source] = STATE(117),
    [sym__definition] = STATE(2),
    [sym_intent_def] = STATE(30),
    [sym_slot_def] = STATE(30),
    [sym_alias_def] = STATE(30),
    [sym_import] = STATE(2),
    [sym_comment] = STATE(2),
    [aux_sym_source_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_PERCENT_LBRACK] = ACTIONS(5),
    [anon_sym_AT_LBRACK] = ACTIONS(7),
    [anon_sym_TILDE_LBRACK] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [aux_sym_comment_token1] = ACTIONS(13),
    [sym__eol] = ACTIONS(15),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 9,
    ACTIONS(5), 1,
      anon_sym_PERCENT_LBRACK,
    ACTIONS(7), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(9), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(11), 1,
      anon_sym_import,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      ts_builtin_sym_end,
    ACTIONS(19), 1,
      sym__eol,
    STATE(30), 3,
      sym_intent_def,
      sym_slot_def,
      sym_alias_def,
    STATE(3), 4,
      sym__definition,
      sym_import,
      sym_comment,
      aux_sym_source_repeat1,
  [33] = 9,
    ACTIONS(21), 1,
      ts_builtin_sym_end,
    ACTIONS(23), 1,
      anon_sym_PERCENT_LBRACK,
    ACTIONS(26), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(29), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(32), 1,
      anon_sym_import,
    ACTIONS(35), 1,
      aux_sym_comment_token1,
    ACTIONS(38), 1,
      sym__eol,
    STATE(30), 3,
      sym_intent_def,
      sym_slot_def,
      sym_alias_def,
    STATE(3), 4,
      sym__definition,
      sym_import,
      sym_comment,
      aux_sym_source_repeat1,
  [66] = 8,
    ACTIONS(41), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(43), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(45), 1,
      aux_sym_word_token1,
    ACTIONS(47), 1,
      anon_sym_STAR_LBRACK,
    ACTIONS(49), 1,
      sym__space,
    STATE(17), 1,
      sym_probability,
    STATE(41), 1,
      aux_sym_word_repeat1,
    STATE(5), 4,
      sym_slot_ref,
      sym_alias_ref,
      sym_word,
      aux_sym_intent_body_repeat1,
  [94] = 7,
    ACTIONS(41), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(43), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(45), 1,
      aux_sym_word_token1,
    ACTIONS(51), 1,
      sym__eol,
    ACTIONS(53), 1,
      sym__space,
    STATE(41), 1,
      aux_sym_word_repeat1,
    STATE(9), 4,
      sym_slot_ref,
      sym_alias_ref,
      sym_word,
      aux_sym_intent_body_repeat1,
  [119] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(57), 1,
      sym__indent,
    STATE(13), 2,
      sym_comment,
      aux_sym_slot_body_repeat2,
    ACTIONS(55), 6,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      sym__eol,
  [138] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(61), 1,
      sym__indent,
    STATE(14), 2,
      sym_comment,
      aux_sym_intent_body_repeat2,
    ACTIONS(59), 6,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      sym__eol,
  [157] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(65), 1,
      sym__indent,
    STATE(11), 2,
      sym_comment,
      aux_sym_alias_body_repeat1,
    ACTIONS(63), 6,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      sym__eol,
  [176] = 7,
    ACTIONS(67), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(70), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(73), 1,
      aux_sym_word_token1,
    ACTIONS(76), 1,
      sym__eol,
    ACTIONS(78), 1,
      sym__space,
    STATE(41), 1,
      aux_sym_word_repeat1,
    STATE(9), 4,
      sym_slot_ref,
      sym_alias_ref,
      sym_word,
      aux_sym_intent_body_repeat1,
  [201] = 7,
    ACTIONS(41), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(43), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(45), 1,
      aux_sym_word_token1,
    ACTIONS(53), 1,
      sym__space,
    ACTIONS(81), 1,
      sym__eol,
    STATE(41), 1,
      aux_sym_word_repeat1,
    STATE(9), 4,
      sym_slot_ref,
      sym_alias_ref,
      sym_word,
      aux_sym_intent_body_repeat1,
  [226] = 4,
    ACTIONS(85), 1,
      aux_sym_comment_token1,
    ACTIONS(88), 1,
      sym__indent,
    STATE(11), 2,
      sym_comment,
      aux_sym_alias_body_repeat1,
    ACTIONS(83), 6,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      sym__eol,
  [245] = 7,
    ACTIONS(41), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(43), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(45), 1,
      aux_sym_word_token1,
    ACTIONS(53), 1,
      sym__space,
    ACTIONS(91), 1,
      sym__eol,
    STATE(41), 1,
      aux_sym_word_repeat1,
    STATE(9), 4,
      sym_slot_ref,
      sym_alias_ref,
      sym_word,
      aux_sym_intent_body_repeat1,
  [270] = 4,
    ACTIONS(95), 1,
      aux_sym_comment_token1,
    ACTIONS(98), 1,
      sym__indent,
    STATE(13), 2,
      sym_comment,
      aux_sym_slot_body_repeat2,
    ACTIONS(93), 6,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      sym__eol,
  [289] = 4,
    ACTIONS(103), 1,
      aux_sym_comment_token1,
    ACTIONS(106), 1,
      sym__indent,
    STATE(14), 2,
      sym_comment,
      aux_sym_intent_body_repeat2,
    ACTIONS(101), 6,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      sym__eol,
  [308] = 6,
    ACTIONS(41), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(43), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(45), 1,
      aux_sym_word_token1,
    ACTIONS(109), 1,
      sym__space,
    STATE(41), 1,
      aux_sym_word_repeat1,
    STATE(12), 4,
      sym_slot_ref,
      sym_alias_ref,
      sym_word,
      aux_sym_intent_body_repeat1,
  [330] = 7,
    ACTIONS(111), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(113), 1,
      aux_sym_word_token1,
    ACTIONS(115), 1,
      anon_sym_STAR_LBRACK,
    ACTIONS(117), 1,
      sym__space,
    STATE(28), 1,
      sym_probability,
    STATE(57), 1,
      aux_sym_word_repeat1,
    STATE(20), 3,
      sym_alias_ref,
      sym_word,
      aux_sym_slot_body_repeat1,
  [354] = 6,
    ACTIONS(41), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(43), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(45), 1,
      aux_sym_word_token1,
    ACTIONS(119), 1,
      sym__space,
    STATE(41), 1,
      aux_sym_word_repeat1,
    STATE(10), 4,
      sym_slot_ref,
      sym_alias_ref,
      sym_word,
      aux_sym_intent_body_repeat1,
  [376] = 6,
    ACTIONS(121), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(124), 1,
      aux_sym_word_token1,
    ACTIONS(127), 1,
      sym__eol,
    ACTIONS(129), 1,
      sym__space,
    STATE(57), 1,
      aux_sym_word_repeat1,
    STATE(18), 3,
      sym_alias_ref,
      sym_word,
      aux_sym_slot_body_repeat1,
  [397] = 1,
    ACTIONS(132), 8,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
      sym__indent,
  [408] = 6,
    ACTIONS(111), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(113), 1,
      aux_sym_word_token1,
    ACTIONS(134), 1,
      sym__eol,
    ACTIONS(136), 1,
      sym__space,
    STATE(57), 1,
      aux_sym_word_repeat1,
    STATE(18), 3,
      sym_alias_ref,
      sym_word,
      aux_sym_slot_body_repeat1,
  [429] = 1,
    ACTIONS(138), 8,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
      sym__indent,
  [440] = 1,
    ACTIONS(140), 8,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
      sym__indent,
  [451] = 6,
    ACTIONS(111), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(113), 1,
      aux_sym_word_token1,
    ACTIONS(136), 1,
      sym__space,
    ACTIONS(142), 1,
      sym__eol,
    STATE(57), 1,
      aux_sym_word_repeat1,
    STATE(18), 3,
      sym_alias_ref,
      sym_word,
      aux_sym_slot_body_repeat1,
  [472] = 1,
    ACTIONS(144), 8,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
      sym__indent,
  [483] = 1,
    ACTIONS(146), 8,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
      sym__indent,
  [494] = 1,
    ACTIONS(148), 8,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
      sym__indent,
  [505] = 1,
    ACTIONS(150), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [515] = 5,
    ACTIONS(111), 1,
      anon_sym_TILDE_LBRACK,
    ACTIONS(113), 1,
      aux_sym_word_token1,
    ACTIONS(152), 1,
      sym__space,
    STATE(57), 1,
      aux_sym_word_repeat1,
    STATE(23), 3,
      sym_alias_ref,
      sym_word,
      aux_sym_slot_body_repeat1,
  [533] = 1,
    ACTIONS(154), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [543] = 1,
    ACTIONS(156), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [553] = 1,
    ACTIONS(158), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [563] = 1,
    ACTIONS(160), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [573] = 1,
    ACTIONS(162), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [583] = 1,
    ACTIONS(164), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [593] = 1,
    ACTIONS(166), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [603] = 1,
    ACTIONS(168), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [613] = 1,
    ACTIONS(170), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [623] = 1,
    ACTIONS(172), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [633] = 1,
    ACTIONS(174), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [643] = 1,
    ACTIONS(176), 7,
      ts_builtin_sym_end,
      anon_sym_PERCENT_LBRACK,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      anon_sym_import,
      aux_sym_comment_token1,
      sym__eol,
  [653] = 3,
    ACTIONS(180), 1,
      aux_sym_word_token1,
    STATE(42), 1,
      aux_sym_word_repeat1,
    ACTIONS(178), 4,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [666] = 3,
    ACTIONS(184), 1,
      aux_sym_word_token1,
    STATE(42), 1,
      aux_sym_word_repeat1,
    ACTIONS(182), 4,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [679] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(61), 1,
      sym__indent,
    STATE(29), 1,
      sym_intent_body,
    STATE(7), 2,
      sym_comment,
      aux_sym_intent_body_repeat2,
  [693] = 2,
    ACTIONS(189), 1,
      aux_sym_word_token1,
    ACTIONS(187), 4,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [703] = 5,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    ACTIONS(195), 1,
      sym__space,
    STATE(92), 1,
      sym_argument,
    STATE(107), 1,
      sym_string,
  [719] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(61), 1,
      sym__indent,
    STATE(36), 1,
      sym_intent_body,
    STATE(7), 2,
      sym_comment,
      aux_sym_intent_body_repeat2,
  [733] = 2,
    ACTIONS(199), 1,
      aux_sym_word_token1,
    ACTIONS(197), 4,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [743] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(61), 1,
      sym__indent,
    STATE(40), 1,
      sym_intent_body,
    STATE(7), 2,
      sym_comment,
      aux_sym_intent_body_repeat2,
  [757] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(65), 1,
      sym__indent,
    STATE(34), 1,
      sym_alias_body,
    STATE(8), 2,
      sym_comment,
      aux_sym_alias_body_repeat1,
  [771] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(57), 1,
      sym__indent,
    STATE(32), 1,
      sym_slot_body,
    STATE(6), 2,
      sym_comment,
      aux_sym_slot_body_repeat2,
  [785] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(57), 1,
      sym__indent,
    STATE(37), 1,
      sym_slot_body,
    STATE(6), 2,
      sym_comment,
      aux_sym_slot_body_repeat2,
  [799] = 2,
    ACTIONS(203), 1,
      aux_sym_word_token1,
    ACTIONS(201), 4,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [809] = 2,
    ACTIONS(207), 1,
      aux_sym_word_token1,
    ACTIONS(205), 4,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [819] = 2,
    ACTIONS(211), 1,
      aux_sym_word_token1,
    ACTIONS(209), 4,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [829] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(65), 1,
      sym__indent,
    STATE(31), 1,
      sym_alias_body,
    STATE(8), 2,
      sym_comment,
      aux_sym_alias_body_repeat1,
  [843] = 5,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    ACTIONS(213), 1,
      sym__space,
    STATE(76), 1,
      sym_argument,
    STATE(107), 1,
      sym_string,
  [859] = 3,
    ACTIONS(215), 1,
      aux_sym_word_token1,
    STATE(60), 1,
      aux_sym_word_repeat1,
    ACTIONS(178), 3,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [871] = 5,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    ACTIONS(217), 1,
      sym__space,
    STATE(94), 1,
      sym_argument,
    STATE(107), 1,
      sym_string,
  [887] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(57), 1,
      sym__indent,
    STATE(38), 1,
      sym_slot_body,
    STATE(6), 2,
      sym_comment,
      aux_sym_slot_body_repeat2,
  [901] = 3,
    ACTIONS(219), 1,
      aux_sym_word_token1,
    STATE(60), 1,
      aux_sym_word_repeat1,
    ACTIONS(182), 3,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [913] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(57), 1,
      sym__indent,
    STATE(35), 1,
      sym_slot_body,
    STATE(6), 2,
      sym_comment,
      aux_sym_slot_body_repeat2,
  [927] = 4,
    ACTIONS(13), 1,
      aux_sym_comment_token1,
    ACTIONS(65), 1,
      sym__indent,
    STATE(27), 1,
      sym_alias_body,
    STATE(8), 2,
      sym_comment,
      aux_sym_alias_body_repeat1,
  [941] = 1,
    ACTIONS(222), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_eq,
      sym__space,
  [948] = 4,
    ACTIONS(224), 1,
      anon_sym_DQUOTE,
    ACTIONS(226), 1,
      aux_sym_string_token1,
    ACTIONS(228), 1,
      sym_escape,
    STATE(88), 1,
      aux_sym_string_repeat1,
  [961] = 4,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(232), 1,
      anon_sym_RPAREN,
    ACTIONS(234), 1,
      sym__space,
    STATE(78), 1,
      aux_sym_arguments_repeat1,
  [974] = 4,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    ACTIONS(236), 1,
      sym__space,
    STATE(98), 1,
      sym_string,
  [987] = 4,
    ACTIONS(224), 1,
      anon_sym_SQUOTE,
    ACTIONS(238), 1,
      aux_sym_string_token2,
    ACTIONS(240), 1,
      sym_escape,
    STATE(89), 1,
      aux_sym_string_repeat2,
  [1000] = 4,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(232), 1,
      anon_sym_RPAREN,
    ACTIONS(234), 1,
      sym__space,
    STATE(69), 1,
      aux_sym_arguments_repeat1,
  [1013] = 4,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(242), 1,
      anon_sym_RPAREN,
    ACTIONS(244), 1,
      sym__space,
    STATE(78), 1,
      aux_sym_arguments_repeat1,
  [1026] = 4,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    STATE(101), 1,
      sym_argument,
    STATE(107), 1,
      sym_string,
  [1039] = 4,
    ACTIONS(246), 1,
      anon_sym_RBRACK,
    ACTIONS(248), 1,
      anon_sym_QMARK,
    ACTIONS(250), 1,
      anon_sym_POUND,
    STATE(111), 1,
      sym_variation,
  [1052] = 4,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    ACTIONS(252), 1,
      sym__space,
    STATE(90), 1,
      sym_string,
  [1065] = 2,
    ACTIONS(199), 1,
      aux_sym_word_token1,
    ACTIONS(197), 3,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [1074] = 4,
    ACTIONS(254), 1,
      anon_sym_LPAREN,
    ACTIONS(256), 1,
      sym__eol,
    ACTIONS(258), 1,
      sym__space,
    STATE(138), 1,
      sym_arguments,
  [1087] = 2,
    ACTIONS(262), 1,
      aux_sym_word_token1,
    ACTIONS(260), 3,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      sym__space,
  [1096] = 4,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(264), 1,
      anon_sym_RPAREN,
    ACTIONS(266), 1,
      sym__space,
    STATE(65), 1,
      aux_sym_arguments_repeat1,
  [1109] = 4,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    STATE(68), 1,
      sym_argument,
    STATE(107), 1,
      sym_string,
  [1122] = 4,
    ACTIONS(268), 1,
      anon_sym_COMMA,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__space,
    STATE(78), 1,
      aux_sym_arguments_repeat1,
  [1135] = 4,
    ACTIONS(276), 1,
      anon_sym_SQUOTE,
    ACTIONS(278), 1,
      aux_sym_string_token2,
    ACTIONS(280), 1,
      sym_escape,
    STATE(67), 1,
      aux_sym_string_repeat2,
  [1148] = 4,
    ACTIONS(276), 1,
      anon_sym_DQUOTE,
    ACTIONS(282), 1,
      aux_sym_string_token1,
    ACTIONS(284), 1,
      sym_escape,
    STATE(64), 1,
      aux_sym_string_repeat1,
  [1161] = 2,
    ACTIONS(288), 1,
      aux_sym_word_token1,
    ACTIONS(286), 3,
      anon_sym_AT_LBRACK,
      anon_sym_TILDE_LBRACK,
      sym__space,
  [1170] = 4,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    STATE(92), 1,
      sym_argument,
    STATE(107), 1,
      sym_string,
  [1183] = 4,
    ACTIONS(254), 1,
      anon_sym_LPAREN,
    ACTIONS(290), 1,
      sym__eol,
    ACTIONS(292), 1,
      sym__space,
    STATE(141), 1,
      sym_arguments,
  [1196] = 4,
    ACTIONS(254), 1,
      anon_sym_LPAREN,
    ACTIONS(294), 1,
      sym__eol,
    ACTIONS(296), 1,
      sym__space,
    STATE(144), 1,
      sym_arguments,
  [1209] = 4,
    ACTIONS(254), 1,
      anon_sym_LPAREN,
    ACTIONS(298), 1,
      sym__eol,
    ACTIONS(300), 1,
      sym__space,
    STATE(127), 1,
      sym_arguments,
  [1222] = 2,
    ACTIONS(203), 1,
      aux_sym_word_token1,
    ACTIONS(201), 3,
      anon_sym_TILDE_LBRACK,
      sym__eol,
      sym__space,
  [1231] = 1,
    ACTIONS(302), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_eq,
      sym__space,
  [1238] = 4,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      aux_sym_string_token1,
    ACTIONS(309), 1,
      sym_escape,
    STATE(88), 1,
      aux_sym_string_repeat1,
  [1251] = 4,
    ACTIONS(312), 1,
      anon_sym_SQUOTE,
    ACTIONS(314), 1,
      aux_sym_string_token2,
    ACTIONS(317), 1,
      sym_escape,
    STATE(89), 1,
      aux_sym_string_repeat2,
  [1264] = 1,
    ACTIONS(320), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__space,
  [1270] = 3,
    ACTIONS(254), 1,
      anon_sym_LPAREN,
    ACTIONS(298), 1,
      sym__eol,
    STATE(127), 1,
      sym_arguments,
  [1280] = 1,
    ACTIONS(322), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__space,
  [1286] = 3,
    ACTIONS(254), 1,
      anon_sym_LPAREN,
    ACTIONS(324), 1,
      sym__eol,
    STATE(131), 1,
      sym_arguments,
  [1296] = 1,
    ACTIONS(271), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__space,
  [1302] = 3,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    STATE(102), 1,
      sym_string,
  [1312] = 2,
    ACTIONS(288), 1,
      aux_sym_word_token1,
    ACTIONS(286), 2,
      anon_sym_TILDE_LBRACK,
      sym__space,
  [1320] = 3,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(193), 1,
      anon_sym_SQUOTE,
    STATE(90), 1,
      sym_string,
  [1330] = 1,
    ACTIONS(326), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__space,
  [1336] = 2,
    ACTIONS(262), 1,
      aux_sym_word_token1,
    ACTIONS(260), 2,
      anon_sym_TILDE_LBRACK,
      sym__space,
  [1344] = 3,
    ACTIONS(254), 1,
      anon_sym_LPAREN,
    ACTIONS(328), 1,
      sym__eol,
    STATE(147), 1,
      sym_arguments,
  [1354] = 1,
    ACTIONS(330), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__space,
  [1360] = 1,
    ACTIONS(332), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__space,
  [1366] = 3,
    ACTIONS(254), 1,
      anon_sym_LPAREN,
    ACTIONS(334), 1,
      sym__eol,
    STATE(122), 1,
      sym_arguments,
  [1376] = 3,
    ACTIONS(250), 1,
      anon_sym_POUND,
    ACTIONS(336), 1,
      anon_sym_RBRACK,
    STATE(145), 1,
      sym_variation,
  [1386] = 1,
    ACTIONS(338), 2,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [1391] = 2,
    ACTIONS(340), 1,
      anon_sym_COMMA,
    ACTIONS(342), 1,
      anon_sym_RPAREN,
  [1398] = 2,
    ACTIONS(344), 1,
      sym_eq,
    ACTIONS(346), 1,
      sym__space,
  [1405] = 2,
    ACTIONS(348), 1,
      anon_sym_RBRACK,
    ACTIONS(350), 1,
      anon_sym_PERCENT,
  [1412] = 2,
    ACTIONS(352), 1,
      anon_sym_RBRACK,
    ACTIONS(354), 1,
      anon_sym_QMARK,
  [1419] = 2,
    ACTIONS(356), 1,
      sym__eol,
    ACTIONS(358), 1,
      sym__space,
  [1426] = 2,
    ACTIONS(360), 1,
      anon_sym_RBRACK,
    ACTIONS(362), 1,
      anon_sym_QMARK,
  [1433] = 2,
    ACTIONS(364), 1,
      anon_sym_RBRACK,
    ACTIONS(366), 1,
      anon_sym_QMARK,
  [1440] = 2,
    ACTIONS(242), 1,
      anon_sym_RPAREN,
    ACTIONS(340), 1,
      anon_sym_COMMA,
  [1447] = 2,
    ACTIONS(368), 1,
      anon_sym_RBRACK,
    ACTIONS(370), 1,
      anon_sym_PERCENT,
  [1454] = 2,
    ACTIONS(232), 1,
      anon_sym_RPAREN,
    ACTIONS(340), 1,
      anon_sym_COMMA,
  [1461] = 1,
    ACTIONS(372), 1,
      sym__eol,
  [1465] = 1,
    ACTIONS(374), 1,
      ts_builtin_sym_end,
  [1469] = 1,
    ACTIONS(376), 1,
      sym__eol,
  [1473] = 1,
    ACTIONS(340), 1,
      anon_sym_COMMA,
  [1477] = 1,
    ACTIONS(378), 1,
      sym__eol,
  [1481] = 1,
    ACTIONS(380), 1,
      sym__eol,
  [1485] = 1,
    ACTIONS(382), 1,
      sym__eol,
  [1489] = 1,
    ACTIONS(360), 1,
      anon_sym_RBRACK,
  [1493] = 1,
    ACTIONS(384), 1,
      sym_eq,
  [1497] = 1,
    ACTIONS(386), 1,
      aux_sym_slot_def_token1,
  [1501] = 1,
    ACTIONS(388), 1,
      anon_sym_RBRACK,
  [1505] = 1,
    ACTIONS(328), 1,
      sym__eol,
  [1509] = 1,
    ACTIONS(390), 1,
      anon_sym_RBRACK,
  [1513] = 1,
    ACTIONS(392), 1,
      aux_sym_intent_def_token1,
  [1517] = 1,
    ACTIONS(394), 1,
      aux_sym_slot_def_token1,
  [1521] = 1,
    ACTIONS(396), 1,
      sym__eol,
  [1525] = 1,
    ACTIONS(398), 1,
      sym__eol,
  [1529] = 1,
    ACTIONS(400), 1,
      sym__space,
  [1533] = 1,
    ACTIONS(402), 1,
      aux_sym_intent_def_token1,
  [1537] = 1,
    ACTIONS(404), 1,
      anon_sym_RBRACK,
  [1541] = 1,
    ACTIONS(406), 1,
      anon_sym_RBRACK,
  [1545] = 1,
    ACTIONS(408), 1,
      sym__eol,
  [1549] = 1,
    ACTIONS(334), 1,
      sym__eol,
  [1553] = 1,
    ACTIONS(410), 1,
      sym_number,
  [1557] = 1,
    ACTIONS(412), 1,
      aux_sym_intent_def_token1,
  [1561] = 1,
    ACTIONS(298), 1,
      sym__eol,
  [1565] = 1,
    ACTIONS(414), 1,
      anon_sym_RBRACK,
  [1569] = 1,
    ACTIONS(416), 1,
      aux_sym_import_token1,
  [1573] = 1,
    ACTIONS(324), 1,
      sym__eol,
  [1577] = 1,
    ACTIONS(418), 1,
      anon_sym_RBRACK,
  [1581] = 1,
    ACTIONS(420), 1,
      aux_sym_slot_def_token1,
  [1585] = 1,
    ACTIONS(422), 1,
      sym__eol,
  [1589] = 1,
    ACTIONS(424), 1,
      anon_sym_RBRACK,
  [1593] = 1,
    ACTIONS(426), 1,
      anon_sym_RBRACK,
  [1597] = 1,
    ACTIONS(428), 1,
      aux_sym_intent_def_token1,
  [1601] = 1,
    ACTIONS(430), 1,
      sym_number,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 33,
  [SMALL_STATE(4)] = 66,
  [SMALL_STATE(5)] = 94,
  [SMALL_STATE(6)] = 119,
  [SMALL_STATE(7)] = 138,
  [SMALL_STATE(8)] = 157,
  [SMALL_STATE(9)] = 176,
  [SMALL_STATE(10)] = 201,
  [SMALL_STATE(11)] = 226,
  [SMALL_STATE(12)] = 245,
  [SMALL_STATE(13)] = 270,
  [SMALL_STATE(14)] = 289,
  [SMALL_STATE(15)] = 308,
  [SMALL_STATE(16)] = 330,
  [SMALL_STATE(17)] = 354,
  [SMALL_STATE(18)] = 376,
  [SMALL_STATE(19)] = 397,
  [SMALL_STATE(20)] = 408,
  [SMALL_STATE(21)] = 429,
  [SMALL_STATE(22)] = 440,
  [SMALL_STATE(23)] = 451,
  [SMALL_STATE(24)] = 472,
  [SMALL_STATE(25)] = 483,
  [SMALL_STATE(26)] = 494,
  [SMALL_STATE(27)] = 505,
  [SMALL_STATE(28)] = 515,
  [SMALL_STATE(29)] = 533,
  [SMALL_STATE(30)] = 543,
  [SMALL_STATE(31)] = 553,
  [SMALL_STATE(32)] = 563,
  [SMALL_STATE(33)] = 573,
  [SMALL_STATE(34)] = 583,
  [SMALL_STATE(35)] = 593,
  [SMALL_STATE(36)] = 603,
  [SMALL_STATE(37)] = 613,
  [SMALL_STATE(38)] = 623,
  [SMALL_STATE(39)] = 633,
  [SMALL_STATE(40)] = 643,
  [SMALL_STATE(41)] = 653,
  [SMALL_STATE(42)] = 666,
  [SMALL_STATE(43)] = 679,
  [SMALL_STATE(44)] = 693,
  [SMALL_STATE(45)] = 703,
  [SMALL_STATE(46)] = 719,
  [SMALL_STATE(47)] = 733,
  [SMALL_STATE(48)] = 743,
  [SMALL_STATE(49)] = 757,
  [SMALL_STATE(50)] = 771,
  [SMALL_STATE(51)] = 785,
  [SMALL_STATE(52)] = 799,
  [SMALL_STATE(53)] = 809,
  [SMALL_STATE(54)] = 819,
  [SMALL_STATE(55)] = 829,
  [SMALL_STATE(56)] = 843,
  [SMALL_STATE(57)] = 859,
  [SMALL_STATE(58)] = 871,
  [SMALL_STATE(59)] = 887,
  [SMALL_STATE(60)] = 901,
  [SMALL_STATE(61)] = 913,
  [SMALL_STATE(62)] = 927,
  [SMALL_STATE(63)] = 941,
  [SMALL_STATE(64)] = 948,
  [SMALL_STATE(65)] = 961,
  [SMALL_STATE(66)] = 974,
  [SMALL_STATE(67)] = 987,
  [SMALL_STATE(68)] = 1000,
  [SMALL_STATE(69)] = 1013,
  [SMALL_STATE(70)] = 1026,
  [SMALL_STATE(71)] = 1039,
  [SMALL_STATE(72)] = 1052,
  [SMALL_STATE(73)] = 1065,
  [SMALL_STATE(74)] = 1074,
  [SMALL_STATE(75)] = 1087,
  [SMALL_STATE(76)] = 1096,
  [SMALL_STATE(77)] = 1109,
  [SMALL_STATE(78)] = 1122,
  [SMALL_STATE(79)] = 1135,
  [SMALL_STATE(80)] = 1148,
  [SMALL_STATE(81)] = 1161,
  [SMALL_STATE(82)] = 1170,
  [SMALL_STATE(83)] = 1183,
  [SMALL_STATE(84)] = 1196,
  [SMALL_STATE(85)] = 1209,
  [SMALL_STATE(86)] = 1222,
  [SMALL_STATE(87)] = 1231,
  [SMALL_STATE(88)] = 1238,
  [SMALL_STATE(89)] = 1251,
  [SMALL_STATE(90)] = 1264,
  [SMALL_STATE(91)] = 1270,
  [SMALL_STATE(92)] = 1280,
  [SMALL_STATE(93)] = 1286,
  [SMALL_STATE(94)] = 1296,
  [SMALL_STATE(95)] = 1302,
  [SMALL_STATE(96)] = 1312,
  [SMALL_STATE(97)] = 1320,
  [SMALL_STATE(98)] = 1330,
  [SMALL_STATE(99)] = 1336,
  [SMALL_STATE(100)] = 1344,
  [SMALL_STATE(101)] = 1354,
  [SMALL_STATE(102)] = 1360,
  [SMALL_STATE(103)] = 1366,
  [SMALL_STATE(104)] = 1376,
  [SMALL_STATE(105)] = 1386,
  [SMALL_STATE(106)] = 1391,
  [SMALL_STATE(107)] = 1398,
  [SMALL_STATE(108)] = 1405,
  [SMALL_STATE(109)] = 1412,
  [SMALL_STATE(110)] = 1419,
  [SMALL_STATE(111)] = 1426,
  [SMALL_STATE(112)] = 1433,
  [SMALL_STATE(113)] = 1440,
  [SMALL_STATE(114)] = 1447,
  [SMALL_STATE(115)] = 1454,
  [SMALL_STATE(116)] = 1461,
  [SMALL_STATE(117)] = 1465,
  [SMALL_STATE(118)] = 1469,
  [SMALL_STATE(119)] = 1473,
  [SMALL_STATE(120)] = 1477,
  [SMALL_STATE(121)] = 1481,
  [SMALL_STATE(122)] = 1485,
  [SMALL_STATE(123)] = 1489,
  [SMALL_STATE(124)] = 1493,
  [SMALL_STATE(125)] = 1497,
  [SMALL_STATE(126)] = 1501,
  [SMALL_STATE(127)] = 1505,
  [SMALL_STATE(128)] = 1509,
  [SMALL_STATE(129)] = 1513,
  [SMALL_STATE(130)] = 1517,
  [SMALL_STATE(131)] = 1521,
  [SMALL_STATE(132)] = 1525,
  [SMALL_STATE(133)] = 1529,
  [SMALL_STATE(134)] = 1533,
  [SMALL_STATE(135)] = 1537,
  [SMALL_STATE(136)] = 1541,
  [SMALL_STATE(137)] = 1545,
  [SMALL_STATE(138)] = 1549,
  [SMALL_STATE(139)] = 1553,
  [SMALL_STATE(140)] = 1557,
  [SMALL_STATE(141)] = 1561,
  [SMALL_STATE(142)] = 1565,
  [SMALL_STATE(143)] = 1569,
  [SMALL_STATE(144)] = 1573,
  [SMALL_STATE(145)] = 1577,
  [SMALL_STATE(146)] = 1581,
  [SMALL_STATE(147)] = 1585,
  [SMALL_STATE(148)] = 1589,
  [SMALL_STATE(149)] = 1593,
  [SMALL_STATE(150)] = 1597,
  [SMALL_STATE(151)] = 1601,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source, 0, 0, 0),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [17] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source, 1, 0, 0),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [21] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 0),
  [23] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 0), SHIFT_REPEAT(140),
  [26] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 0), SHIFT_REPEAT(130),
  [29] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [32] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 0), SHIFT_REPEAT(133),
  [35] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 0), SHIFT_REPEAT(121),
  [38] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 0), SHIFT_REPEAT(3),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot_body, 1, 0, 0),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intent_body, 1, 0, 0),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_body, 1, 0, 0),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [67] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intent_body_repeat1, 2, 0, 0), SHIFT_REPEAT(125),
  [70] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intent_body_repeat1, 2, 0, 0), SHIFT_REPEAT(134),
  [73] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_intent_body_repeat1, 2, 0, 0), SHIFT_REPEAT(41),
  [76] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_intent_body_repeat1, 2, 0, 0),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intent_body_repeat1, 2, 0, 0), SHIFT_REPEAT(9),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alias_body_repeat1, 2, 0, 0),
  [85] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_body_repeat1, 2, 0, 0), SHIFT_REPEAT(121),
  [88] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_body_repeat1, 2, 0, 0), SHIFT_REPEAT(15),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [93] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slot_body_repeat2, 2, 0, 0),
  [95] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slot_body_repeat2, 2, 0, 0), SHIFT_REPEAT(121),
  [98] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slot_body_repeat2, 2, 0, 0), SHIFT_REPEAT(16),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_intent_body_repeat2, 2, 0, 0),
  [103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intent_body_repeat2, 2, 0, 0), SHIFT_REPEAT(121),
  [106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intent_body_repeat2, 2, 0, 0), SHIFT_REPEAT(4),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slot_body_repeat1, 2, 0, 0), SHIFT_REPEAT(150),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_slot_body_repeat1, 2, 0, 0), SHIFT_REPEAT(57),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slot_body_repeat1, 2, 0, 0),
  [129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slot_body_repeat1, 2, 0, 0), SHIFT_REPEAT(18),
  [132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, 0, 0),
  [134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slot_body_repeat2, 4, 0, 0),
  [140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_intent_body_repeat2, 3, 0, 0),
  [142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slot_body_repeat2, 3, 0, 0),
  [146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alias_body_repeat1, 3, 0, 0),
  [148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_intent_body_repeat2, 4, 0, 0),
  [150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_def, 7, 0, 0),
  [152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intent_def, 7, 0, 2),
  [156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__definition, 1, 0, 0),
  [158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_def, 6, 0, 0),
  [160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot_def, 7, 0, 3),
  [162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 0),
  [164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_def, 5, 0, 0),
  [166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot_def, 5, 0, 3),
  [168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intent_def, 5, 0, 2),
  [170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot_def, 6, 0, 3),
  [172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot_def, 8, 0, 3),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, 0, 0),
  [176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intent_def, 6, 0, 2),
  [178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_word, 1, 0, 0),
  [180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_word_repeat1, 2, 0, 0),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_word_repeat1, 2, 0, 0), SHIFT_REPEAT(42),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot_ref, 4, 0, 3),
  [189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slot_ref, 4, 0, 3),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_ref, 4, 0, 0),
  [199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_ref, 4, 0, 0),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_ref, 3, 0, 0),
  [203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_ref, 3, 0, 0),
  [205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot_ref, 3, 0, 3),
  [207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slot_ref, 3, 0, 3),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot_ref, 5, 0, 3),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slot_ref, 5, 0, 3),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_word_repeat1, 2, 0, 0), SHIFT_REPEAT(60),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 4),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_probability, 3, 0, 0),
  [262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_probability, 3, 0, 0),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2, 0, 0),
  [273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(119),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_probability, 4, 0, 0),
  [288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_probability, 4, 0, 0),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 5),
  [304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(89),
  [317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(89),
  [320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 4, 0, 7),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 3, 0, 0),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, 0, 6),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 4, 0, 0),
  [332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 5, 0, 8),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variation, 2, 0, 1),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [374] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5, 0, 0),
  [378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 6, 0, 0),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_chatito(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
