#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 104
#define LARGE_STATE_COUNT 17
#define SYMBOL_COUNT 61
#define ALIAS_COUNT 0
#define TOKEN_COUNT 38
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 1
#define MAX_ALIAS_SEQUENCE_LENGTH 5
#define PRODUCTION_ID_COUNT 2

enum {
  anon_sym_LBRACE = 1,
  anon_sym_RBRACE = 2,
  anon_sym_LF = 3,
  anon_sym_SEMI = 4,
  anon_sym_COMMA = 5,
  anon_sym_COLON = 6,
  sym_leading_key = 7,
  anon_sym_PLUS_EQ = 8,
  anon_sym_EQ = 9,
  anon_sym_DASH_EQ = 10,
  anon_sym_PLUS = 11,
  anon_sym_DASH = 12,
  anon_sym_TILDE = 13,
  anon_sym_DASH_GT = 14,
  anon_sym_AMP = 15,
  anon_sym_PIPE = 16,
  anon_sym_BANG_EQ = 17,
  anon_sym_BANG = 18,
  anon_sym_DOT = 19,
  anon_sym_AT = 20,
  anon_sym_LT = 21,
  anon_sym_GT = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_SQUOTE = 25,
  aux_sym_string_token1 = 26,
  anon_sym_DQUOTE = 27,
  aux_sym_string_token2 = 28,
  anon_sym_LBRACK = 29,
  anon_sym_RBRACK = 30,
  sym_identifier = 31,
  sym_escape_sequence = 32,
  sym_number = 33,
  sym_line_comment = 34,
  sym_block_comment = 35,
  anon_sym_POUND_BANG = 36,
  aux_sym_shebang_token1 = 37,
  sym_source_file = 38,
  sym_block = 39,
  sym_command = 40,
  sym_end_command = 41,
  sym__command_unit = 42,
  sym_arg_spliter = 43,
  sym_operators = 44,
  sym_unit = 45,
  sym_decorate = 46,
  sym__unit = 47,
  sym_generics_class = 48,
  sym_func = 49,
  sym_arg_block = 50,
  sym_string = 51,
  sym_list = 52,
  sym__args = 53,
  sym_shebang = 54,
  aux_sym_source_file_repeat1 = 55,
  aux_sym_command_repeat1 = 56,
  aux_sym_unit_repeat1 = 57,
  aux_sym_string_repeat1 = 58,
  aux_sym_string_repeat2 = 59,
  aux_sym__args_repeat1 = 60,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LF] = "\n",
  [anon_sym_SEMI] = ";",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON] = ":",
  [sym_leading_key] = "leading_key",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_EQ] = "=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG] = "!",
  [anon_sym_DOT] = ".",
  [anon_sym_AT] = "@",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token2] = "string_token2",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_identifier] = "identifier",
  [sym_escape_sequence] = "escape_sequence",
  [sym_number] = "number",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [anon_sym_POUND_BANG] = "#!",
  [aux_sym_shebang_token1] = "shebang_token1",
  [sym_source_file] = "source_file",
  [sym_block] = "block",
  [sym_command] = "command",
  [sym_end_command] = "end_command",
  [sym__command_unit] = "_command_unit",
  [sym_arg_spliter] = "arg_spliter",
  [sym_operators] = "operators",
  [sym_unit] = "unit",
  [sym_decorate] = "decorate",
  [sym__unit] = "_unit",
  [sym_generics_class] = "generics_class",
  [sym_func] = "func",
  [sym_arg_block] = "arg_block",
  [sym_string] = "string",
  [sym_list] = "list",
  [sym__args] = "_args",
  [sym_shebang] = "shebang",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_unit_repeat1] = "unit_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym__args_repeat1] = "_args_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_leading_key] = sym_leading_key,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym_identifier] = sym_identifier,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_number] = sym_number,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [anon_sym_POUND_BANG] = anon_sym_POUND_BANG,
  [aux_sym_shebang_token1] = aux_sym_shebang_token1,
  [sym_source_file] = sym_source_file,
  [sym_block] = sym_block,
  [sym_command] = sym_command,
  [sym_end_command] = sym_end_command,
  [sym__command_unit] = sym__command_unit,
  [sym_arg_spliter] = sym_arg_spliter,
  [sym_operators] = sym_operators,
  [sym_unit] = sym_unit,
  [sym_decorate] = sym_decorate,
  [sym__unit] = sym__unit,
  [sym_generics_class] = sym_generics_class,
  [sym_func] = sym_func,
  [sym_arg_block] = sym_arg_block,
  [sym_string] = sym_string,
  [sym_list] = sym_list,
  [sym__args] = sym__args,
  [sym_shebang] = sym_shebang,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_command_repeat1] = aux_sym_command_repeat1,
  [aux_sym_unit_repeat1] = aux_sym_unit_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym__args_repeat1] = aux_sym__args_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_leading_key] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_BANG] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_shebang_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_end_command] = {
    .visible = true,
    .named = true,
  },
  [sym__command_unit] = {
    .visible = false,
    .named = true,
  },
  [sym_arg_spliter] = {
    .visible = true,
    .named = true,
  },
  [sym_operators] = {
    .visible = true,
    .named = true,
  },
  [sym_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_decorate] = {
    .visible = true,
    .named = true,
  },
  [sym__unit] = {
    .visible = false,
    .named = true,
  },
  [sym_generics_class] = {
    .visible = true,
    .named = true,
  },
  [sym_func] = {
    .visible = true,
    .named = true,
  },
  [sym_arg_block] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__args] = {
    .visible = false,
    .named = true,
  },
  [sym_shebang] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__args_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_generics_type = 1,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_generics_type] = "generics_type",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_generics_type, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 2,
  [5] = 3,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 18,
  [21] = 19,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 17,
  [32] = 30,
  [33] = 33,
  [34] = 28,
  [35] = 35,
  [36] = 23,
  [37] = 33,
  [38] = 38,
  [39] = 35,
  [40] = 29,
  [41] = 38,
  [42] = 42,
  [43] = 43,
  [44] = 25,
  [45] = 24,
  [46] = 46,
  [47] = 46,
  [48] = 48,
  [49] = 49,
  [50] = 27,
  [51] = 48,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 22,
  [57] = 55,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 52,
  [62] = 62,
  [63] = 62,
  [64] = 62,
  [65] = 17,
  [66] = 22,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 69,
  [71] = 68,
  [72] = 72,
  [73] = 24,
  [74] = 25,
  [75] = 75,
  [76] = 76,
  [77] = 72,
  [78] = 78,
  [79] = 27,
  [80] = 80,
  [81] = 76,
  [82] = 49,
  [83] = 83,
  [84] = 54,
  [85] = 43,
  [86] = 53,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 89,
  [97] = 88,
  [98] = 93,
  [99] = 99,
  [100] = 95,
  [101] = 91,
  [102] = 99,
  [103] = 92,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(25);
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == '"') ADVANCE(57);
      if (lookahead == '#') ADVANCE(2);
      if (lookahead == '$') ADVANCE(32);
      if (lookahead == '&') ADVANCE(40);
      if (lookahead == '\'') ADVANCE(50);
      if (lookahead == '(') ADVANCE(48);
      if (lookahead == ')') ADVANCE(49);
      if (lookahead == '+') ADVANCE(36);
      if (lookahead == ',') ADVANCE(30);
      if (lookahead == '-') ADVANCE(37);
      if (lookahead == '.') ADVANCE(44);
      if (lookahead == '/') ADVANCE(5);
      if (lookahead == '0') ADVANCE(71);
      if (lookahead == ':') ADVANCE(31);
      if (lookahead == ';') ADVANCE(29);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '>') ADVANCE(47);
      if (lookahead == '@') ADVANCE(45);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == ']') ADVANCE(65);
      if (lookahead == '{') ADVANCE(26);
      if (lookahead == '|') ADVANCE(41);
      if (lookahead == '}') ADVANCE(27);
      if (lookahead == '~') ADVANCE(38);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(72);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(28);
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == '"') ADVANCE(57);
      if (lookahead == '&') ADVANCE(40);
      if (lookahead == '\'') ADVANCE(50);
      if (lookahead == '(') ADVANCE(48);
      if (lookahead == '+') ADVANCE(36);
      if (lookahead == ',') ADVANCE(30);
      if (lookahead == '-') ADVANCE(37);
      if (lookahead == '.') ADVANCE(44);
      if (lookahead == '/') ADVANCE(5);
      if (lookahead == '0') ADVANCE(71);
      if (lookahead == ':') ADVANCE(31);
      if (lookahead == ';') ADVANCE(29);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '@') ADVANCE(45);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == '{') ADVANCE(26);
      if (lookahead == '|') ADVANCE(41);
      if (lookahead == '}') ADVANCE(27);
      if (lookahead == '~') ADVANCE(38);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(72);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (192 <= lookahead && lookahead <= 214) ||
          (216 <= lookahead && lookahead <= 246) ||
          (248 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65534)) ADVANCE(66);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(83);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(57);
      if (lookahead == '$') ADVANCE(32);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(62);
      if (lookahead != 0 &&
          lookahead != '^') ADVANCE(63);
      END_STATE();
    case 4:
      if (lookahead == '\'') ADVANCE(50);
      if (lookahead == '/') ADVANCE(52);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(55);
      if (lookahead != 0) ADVANCE(56);
      END_STATE();
    case 5:
      if (lookahead == '*') ADVANCE(7);
      if (lookahead == '/') ADVANCE(80);
      END_STATE();
    case 6:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == 'u') ADVANCE(9);
      if (lookahead == 'x') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(69);
      if (lookahead != 0) ADVANCE(67);
      END_STATE();
    case 9:
      if (lookahead == '{') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(21);
      END_STATE();
    case 10:
      if (lookahead == '}') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 12:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(73);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(74);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(72);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(76);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(22);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 23:
      if (eof) ADVANCE(25);
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == '"') ADVANCE(57);
      if (lookahead == '#') ADVANCE(2);
      if (lookahead == '$') ADVANCE(32);
      if (lookahead == '&') ADVANCE(40);
      if (lookahead == '\'') ADVANCE(50);
      if (lookahead == '(') ADVANCE(48);
      if (lookahead == ')') ADVANCE(49);
      if (lookahead == '+') ADVANCE(36);
      if (lookahead == ',') ADVANCE(30);
      if (lookahead == '-') ADVANCE(37);
      if (lookahead == '.') ADVANCE(44);
      if (lookahead == '/') ADVANCE(5);
      if (lookahead == '0') ADVANCE(71);
      if (lookahead == ':') ADVANCE(31);
      if (lookahead == ';') ADVANCE(29);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '>') ADVANCE(47);
      if (lookahead == '@') ADVANCE(45);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == ']') ADVANCE(65);
      if (lookahead == '{') ADVANCE(26);
      if (lookahead == '|') ADVANCE(41);
      if (lookahead == '}') ADVANCE(27);
      if (lookahead == '~') ADVANCE(38);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(72);
      END_STATE();
    case 24:
      if (eof) ADVANCE(25);
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == '"') ADVANCE(57);
      if (lookahead == '#') ADVANCE(2);
      if (lookahead == '&') ADVANCE(40);
      if (lookahead == '\'') ADVANCE(50);
      if (lookahead == '(') ADVANCE(48);
      if (lookahead == ')') ADVANCE(49);
      if (lookahead == '+') ADVANCE(36);
      if (lookahead == ',') ADVANCE(30);
      if (lookahead == '-') ADVANCE(37);
      if (lookahead == '.') ADVANCE(44);
      if (lookahead == '/') ADVANCE(5);
      if (lookahead == '0') ADVANCE(71);
      if (lookahead == ':') ADVANCE(31);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '@') ADVANCE(45);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == ']') ADVANCE(65);
      if (lookahead == '{') ADVANCE(26);
      if (lookahead == '|') ADVANCE(41);
      if (lookahead == '}') ADVANCE(27);
      if (lookahead == '~') ADVANCE(38);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(24)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(72);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (192 <= lookahead && lookahead <= 214) ||
          (216 <= lookahead && lookahead <= 246) ||
          (248 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65534)) ADVANCE(66);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(28);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym_leading_key);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '>') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(42);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(51);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(54);
      if (lookahead == '/') ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(56);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(53);
      if (lookahead == '/') ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(53);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(54);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(55);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(56);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '\n') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(58);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '/') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(63);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(62);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(63);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (192 <= lookahead && lookahead <= 214) ||
          (216 <= lookahead && lookahead <= 246) ||
          (248 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65534)) ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(67);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(68);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(79);
      if (lookahead == '0') ADVANCE(76);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(12);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(11);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(13);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(19);
      if (lookahead == '_') ADVANCE(17);
      if (lookahead == 'n') ADVANCE(70);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(79);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(11);
      if (lookahead == '_') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(12);
      if (lookahead == 'n') ADVANCE(70);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(19);
      if (lookahead == 'n') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(17);
      if (lookahead == 'n') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(11);
      if (lookahead == '_') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_block_comment);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_block_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(88);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_POUND_BANG);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      if (lookahead == '\n') ADVANCE(7);
      if (lookahead == '*') ADVANCE(84);
      if (lookahead == '/') ADVANCE(82);
      if (lookahead != 0) ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      if (lookahead == '\n') ADVANCE(7);
      if (lookahead == '*') ADVANCE(84);
      if (lookahead != 0) ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == '/') ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(88);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      if (lookahead == '/') ADVANCE(86);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(88);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 24},
  [2] = {.lex_state = 24},
  [3] = {.lex_state = 24},
  [4] = {.lex_state = 24},
  [5] = {.lex_state = 24},
  [6] = {.lex_state = 24},
  [7] = {.lex_state = 24},
  [8] = {.lex_state = 24},
  [9] = {.lex_state = 24},
  [10] = {.lex_state = 1},
  [11] = {.lex_state = 1},
  [12] = {.lex_state = 1},
  [13] = {.lex_state = 24},
  [14] = {.lex_state = 24},
  [15] = {.lex_state = 24},
  [16] = {.lex_state = 24},
  [17] = {.lex_state = 1},
  [18] = {.lex_state = 24},
  [19] = {.lex_state = 24},
  [20] = {.lex_state = 24},
  [21] = {.lex_state = 24},
  [22] = {.lex_state = 1},
  [23] = {.lex_state = 1},
  [24] = {.lex_state = 1},
  [25] = {.lex_state = 1},
  [26] = {.lex_state = 24},
  [27] = {.lex_state = 1},
  [28] = {.lex_state = 1},
  [29] = {.lex_state = 24},
  [30] = {.lex_state = 1},
  [31] = {.lex_state = 24},
  [32] = {.lex_state = 24},
  [33] = {.lex_state = 24},
  [34] = {.lex_state = 24},
  [35] = {.lex_state = 1},
  [36] = {.lex_state = 24},
  [37] = {.lex_state = 1},
  [38] = {.lex_state = 24},
  [39] = {.lex_state = 24},
  [40] = {.lex_state = 1},
  [41] = {.lex_state = 1},
  [42] = {.lex_state = 1},
  [43] = {.lex_state = 1},
  [44] = {.lex_state = 24},
  [45] = {.lex_state = 24},
  [46] = {.lex_state = 24},
  [47] = {.lex_state = 1},
  [48] = {.lex_state = 1},
  [49] = {.lex_state = 1},
  [50] = {.lex_state = 24},
  [51] = {.lex_state = 24},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 1},
  [54] = {.lex_state = 1},
  [55] = {.lex_state = 24},
  [56] = {.lex_state = 24},
  [57] = {.lex_state = 1},
  [58] = {.lex_state = 24},
  [59] = {.lex_state = 24},
  [60] = {.lex_state = 24},
  [61] = {.lex_state = 24},
  [62] = {.lex_state = 24},
  [63] = {.lex_state = 24},
  [64] = {.lex_state = 24},
  [65] = {.lex_state = 0},
  [66] = {.lex_state = 0},
  [67] = {.lex_state = 3},
  [68] = {.lex_state = 3},
  [69] = {.lex_state = 3},
  [70] = {.lex_state = 3},
  [71] = {.lex_state = 3},
  [72] = {.lex_state = 4},
  [73] = {.lex_state = 0},
  [74] = {.lex_state = 0},
  [75] = {.lex_state = 3},
  [76] = {.lex_state = 4},
  [77] = {.lex_state = 4},
  [78] = {.lex_state = 3},
  [79] = {.lex_state = 0},
  [80] = {.lex_state = 4},
  [81] = {.lex_state = 4},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 24},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 0},
  [88] = {.lex_state = 0},
  [89] = {.lex_state = 24},
  [90] = {.lex_state = 0},
  [91] = {.lex_state = 0},
  [92] = {.lex_state = 24},
  [93] = {.lex_state = 0},
  [94] = {.lex_state = 87},
  [95] = {.lex_state = 0},
  [96] = {.lex_state = 24},
  [97] = {.lex_state = 0},
  [98] = {.lex_state = 0},
  [99] = {.lex_state = 0},
  [100] = {.lex_state = 0},
  [101] = {.lex_state = 0},
  [102] = {.lex_state = 0},
  [103] = {.lex_state = 24},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [sym_leading_key] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [anon_sym_POUND_BANG] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(90),
    [sym_block] = STATE(42),
    [sym_command] = STATE(8),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [sym_shebang] = STATE(7),
    [aux_sym_source_file_repeat1] = STATE(8),
    [aux_sym_command_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_PLUS_EQ] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(9),
    [anon_sym_DASH_EQ] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(9),
    [anon_sym_DASH_GT] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(9),
    [anon_sym_PIPE] = ACTIONS(9),
    [anon_sym_BANG_EQ] = ACTIONS(9),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_SQUOTE] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [sym_identifier] = ACTIONS(21),
    [sym_number] = ACTIONS(23),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [anon_sym_POUND_BANG] = ACTIONS(25),
  },
  [2] = {
    [sym_block] = STATE(42),
    [sym_command] = STATE(5),
    [sym_end_command] = STATE(102),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_source_file_repeat1] = STATE(5),
    [aux_sym_command_repeat1] = STATE(11),
    [anon_sym_RBRACE] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_PLUS_EQ] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(9),
    [anon_sym_DASH_EQ] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(9),
    [anon_sym_DASH_GT] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(9),
    [anon_sym_PIPE] = ACTIONS(9),
    [anon_sym_BANG_EQ] = ACTIONS(9),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_SQUOTE] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [sym_identifier] = ACTIONS(21),
    [sym_number] = ACTIONS(23),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_block] = STATE(42),
    [sym_command] = STATE(6),
    [sym_end_command] = STATE(101),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_command_repeat1] = STATE(11),
    [anon_sym_RBRACE] = ACTIONS(29),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_PLUS_EQ] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(9),
    [anon_sym_DASH_EQ] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(9),
    [anon_sym_DASH_GT] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(9),
    [anon_sym_PIPE] = ACTIONS(9),
    [anon_sym_BANG_EQ] = ACTIONS(9),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_SQUOTE] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [sym_identifier] = ACTIONS(21),
    [sym_number] = ACTIONS(23),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_block] = STATE(42),
    [sym_command] = STATE(3),
    [sym_end_command] = STATE(99),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_source_file_repeat1] = STATE(3),
    [aux_sym_command_repeat1] = STATE(11),
    [anon_sym_RBRACE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_PLUS_EQ] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(9),
    [anon_sym_DASH_EQ] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(9),
    [anon_sym_DASH_GT] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(9),
    [anon_sym_PIPE] = ACTIONS(9),
    [anon_sym_BANG_EQ] = ACTIONS(9),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_SQUOTE] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [sym_identifier] = ACTIONS(21),
    [sym_number] = ACTIONS(23),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_block] = STATE(42),
    [sym_command] = STATE(6),
    [sym_end_command] = STATE(91),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_command_repeat1] = STATE(11),
    [anon_sym_RBRACE] = ACTIONS(33),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_PLUS_EQ] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(9),
    [anon_sym_DASH_EQ] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(9),
    [anon_sym_DASH_GT] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(9),
    [anon_sym_PIPE] = ACTIONS(9),
    [anon_sym_BANG_EQ] = ACTIONS(9),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_SQUOTE] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [sym_identifier] = ACTIONS(21),
    [sym_number] = ACTIONS(23),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_block] = STATE(42),
    [sym_command] = STATE(6),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_command_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(35),
    [anon_sym_RBRACE] = ACTIONS(35),
    [anon_sym_COMMA] = ACTIONS(37),
    [anon_sym_COLON] = ACTIONS(37),
    [anon_sym_PLUS_EQ] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(40),
    [anon_sym_DASH_EQ] = ACTIONS(40),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(40),
    [anon_sym_DASH_GT] = ACTIONS(40),
    [anon_sym_AMP] = ACTIONS(40),
    [anon_sym_PIPE] = ACTIONS(40),
    [anon_sym_BANG_EQ] = ACTIONS(40),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(46),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(55),
    [sym_identifier] = ACTIONS(58),
    [sym_number] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_block] = STATE(42),
    [sym_command] = STATE(9),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_source_file_repeat1] = STATE(9),
    [aux_sym_command_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(64),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_PLUS_EQ] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(9),
    [anon_sym_DASH_EQ] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(9),
    [anon_sym_DASH_GT] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(9),
    [anon_sym_PIPE] = ACTIONS(9),
    [anon_sym_BANG_EQ] = ACTIONS(9),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_SQUOTE] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [sym_identifier] = ACTIONS(21),
    [sym_number] = ACTIONS(23),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_block] = STATE(42),
    [sym_command] = STATE(6),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_command_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(64),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_PLUS_EQ] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(9),
    [anon_sym_DASH_EQ] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(9),
    [anon_sym_DASH_GT] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(9),
    [anon_sym_PIPE] = ACTIONS(9),
    [anon_sym_BANG_EQ] = ACTIONS(9),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_SQUOTE] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [sym_identifier] = ACTIONS(21),
    [sym_number] = ACTIONS(23),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_block] = STATE(42),
    [sym_command] = STATE(6),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_command_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(66),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_PLUS_EQ] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(9),
    [anon_sym_DASH_EQ] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(9),
    [anon_sym_DASH_GT] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(9),
    [anon_sym_PIPE] = ACTIONS(9),
    [anon_sym_BANG_EQ] = ACTIONS(9),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_SQUOTE] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [sym_identifier] = ACTIONS(21),
    [sym_number] = ACTIONS(23),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_block] = STATE(42),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_command_repeat1] = STATE(10),
    [anon_sym_RBRACE] = ACTIONS(68),
    [anon_sym_LF] = ACTIONS(70),
    [anon_sym_SEMI] = ACTIONS(68),
    [anon_sym_COMMA] = ACTIONS(72),
    [anon_sym_COLON] = ACTIONS(72),
    [anon_sym_PLUS_EQ] = ACTIONS(75),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_DASH_EQ] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_PIPE] = ACTIONS(75),
    [anon_sym_BANG_EQ] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(78),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(84),
    [anon_sym_LBRACK] = ACTIONS(87),
    [sym_identifier] = ACTIONS(90),
    [sym_number] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(96),
    [sym_block_comment] = ACTIONS(96),
  },
  [11] = {
    [sym_block] = STATE(42),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_command_repeat1] = STATE(10),
    [anon_sym_RBRACE] = ACTIONS(98),
    [anon_sym_LF] = ACTIONS(100),
    [anon_sym_SEMI] = ACTIONS(102),
    [anon_sym_COMMA] = ACTIONS(104),
    [anon_sym_COLON] = ACTIONS(104),
    [anon_sym_PLUS_EQ] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_DASH_EQ] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(11),
    [anon_sym_DASH_GT] = ACTIONS(11),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PIPE] = ACTIONS(11),
    [anon_sym_BANG_EQ] = ACTIONS(11),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(106),
    [anon_sym_SQUOTE] = ACTIONS(108),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_LBRACK] = ACTIONS(112),
    [sym_identifier] = ACTIONS(114),
    [sym_number] = ACTIONS(116),
    [sym_line_comment] = ACTIONS(96),
    [sym_block_comment] = ACTIONS(96),
  },
  [12] = {
    [sym_block] = STATE(42),
    [sym__command_unit] = STATE(42),
    [sym_arg_spliter] = STATE(42),
    [sym_operators] = STATE(42),
    [sym_unit] = STATE(42),
    [sym_decorate] = STATE(42),
    [sym__unit] = STATE(25),
    [sym_generics_class] = STATE(22),
    [sym_func] = STATE(25),
    [sym_string] = STATE(42),
    [sym_list] = STATE(42),
    [aux_sym_command_repeat1] = STATE(10),
    [anon_sym_LF] = ACTIONS(100),
    [anon_sym_SEMI] = ACTIONS(102),
    [anon_sym_COMMA] = ACTIONS(104),
    [anon_sym_COLON] = ACTIONS(104),
    [anon_sym_PLUS_EQ] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_DASH_EQ] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(11),
    [anon_sym_DASH] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(11),
    [anon_sym_DASH_GT] = ACTIONS(11),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PIPE] = ACTIONS(11),
    [anon_sym_BANG_EQ] = ACTIONS(11),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(106),
    [anon_sym_SQUOTE] = ACTIONS(108),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_LBRACK] = ACTIONS(112),
    [sym_identifier] = ACTIONS(114),
    [sym_number] = ACTIONS(116),
    [sym_line_comment] = ACTIONS(96),
    [sym_block_comment] = ACTIONS(96),
  },
  [13] = {
    [sym_arg_spliter] = STATE(26),
    [sym_operators] = STATE(13),
    [sym_unit] = STATE(13),
    [sym__unit] = STATE(44),
    [sym_generics_class] = STATE(56),
    [sym_func] = STATE(44),
    [sym_arg_block] = STATE(13),
    [sym_string] = STATE(13),
    [sym_list] = STATE(13),
    [aux_sym__args_repeat1] = STATE(13),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(121),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_DASH_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_DASH] = ACTIONS(124),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE] = ACTIONS(121),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(124),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(130),
    [anon_sym_SQUOTE] = ACTIONS(132),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(138),
    [anon_sym_RBRACK] = ACTIONS(130),
    [sym_identifier] = ACTIONS(141),
    [sym_number] = ACTIONS(144),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_arg_spliter] = STATE(26),
    [sym_operators] = STATE(13),
    [sym_unit] = STATE(13),
    [sym__unit] = STATE(44),
    [sym_generics_class] = STATE(56),
    [sym_func] = STATE(44),
    [sym_arg_block] = STATE(13),
    [sym_string] = STATE(13),
    [sym_list] = STATE(13),
    [aux_sym__args_repeat1] = STATE(13),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_COLON] = ACTIONS(147),
    [anon_sym_PLUS_EQ] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(153),
    [anon_sym_RPAREN] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE] = ACTIONS(159),
    [anon_sym_LBRACK] = ACTIONS(161),
    [anon_sym_RBRACK] = ACTIONS(155),
    [sym_identifier] = ACTIONS(163),
    [sym_number] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_arg_spliter] = STATE(26),
    [sym_operators] = STATE(14),
    [sym_unit] = STATE(14),
    [sym__unit] = STATE(44),
    [sym_generics_class] = STATE(56),
    [sym_func] = STATE(44),
    [sym_arg_block] = STATE(14),
    [sym_string] = STATE(14),
    [sym_list] = STATE(14),
    [aux_sym__args_repeat1] = STATE(14),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_COLON] = ACTIONS(147),
    [anon_sym_PLUS_EQ] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(153),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE] = ACTIONS(159),
    [anon_sym_LBRACK] = ACTIONS(161),
    [anon_sym_RBRACK] = ACTIONS(167),
    [sym_identifier] = ACTIONS(163),
    [sym_number] = ACTIONS(169),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_block] = STATE(87),
    [sym__command_unit] = STATE(87),
    [sym_arg_spliter] = STATE(87),
    [sym_operators] = STATE(87),
    [sym_unit] = STATE(87),
    [sym_decorate] = STATE(87),
    [sym__unit] = STATE(74),
    [sym_generics_class] = STATE(66),
    [sym_func] = STATE(74),
    [sym_string] = STATE(87),
    [sym_list] = STATE(87),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_COLON] = ACTIONS(147),
    [anon_sym_PLUS_EQ] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE] = ACTIONS(159),
    [anon_sym_LBRACK] = ACTIONS(161),
    [sym_identifier] = ACTIONS(173),
    [sym_number] = ACTIONS(175),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 6,
    ACTIONS(179), 1,
      anon_sym_LF,
    ACTIONS(181), 1,
      anon_sym_LT,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_arg_block,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(177), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [42] = 14,
    ACTIONS(153), 1,
      anon_sym_LPAREN,
    ACTIONS(157), 1,
      anon_sym_SQUOTE,
    ACTIONS(159), 1,
      anon_sym_DQUOTE,
    ACTIONS(161), 1,
      anon_sym_LBRACK,
    ACTIONS(163), 1,
      sym_identifier,
    ACTIONS(185), 1,
      anon_sym_RPAREN,
    ACTIONS(187), 1,
      sym_number,
    STATE(56), 1,
      sym_generics_class,
    STATE(97), 1,
      sym__args,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(44), 2,
      sym__unit,
      sym_func,
    ACTIONS(151), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(15), 5,
      sym_operators,
      sym_unit,
      sym_arg_block,
      sym_string,
      sym_list,
    ACTIONS(149), 8,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
  [100] = 14,
    ACTIONS(153), 1,
      anon_sym_LPAREN,
    ACTIONS(157), 1,
      anon_sym_SQUOTE,
    ACTIONS(159), 1,
      anon_sym_DQUOTE,
    ACTIONS(161), 1,
      anon_sym_LBRACK,
    ACTIONS(163), 1,
      sym_identifier,
    ACTIONS(187), 1,
      sym_number,
    ACTIONS(189), 1,
      anon_sym_RBRACK,
    STATE(56), 1,
      sym_generics_class,
    STATE(100), 1,
      sym__args,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(44), 2,
      sym__unit,
      sym_func,
    ACTIONS(151), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(15), 5,
      sym_operators,
      sym_unit,
      sym_arg_block,
      sym_string,
      sym_list,
    ACTIONS(149), 8,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
  [158] = 14,
    ACTIONS(153), 1,
      anon_sym_LPAREN,
    ACTIONS(157), 1,
      anon_sym_SQUOTE,
    ACTIONS(159), 1,
      anon_sym_DQUOTE,
    ACTIONS(161), 1,
      anon_sym_LBRACK,
    ACTIONS(163), 1,
      sym_identifier,
    ACTIONS(187), 1,
      sym_number,
    ACTIONS(191), 1,
      anon_sym_RPAREN,
    STATE(56), 1,
      sym_generics_class,
    STATE(88), 1,
      sym__args,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(44), 2,
      sym__unit,
      sym_func,
    ACTIONS(151), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(15), 5,
      sym_operators,
      sym_unit,
      sym_arg_block,
      sym_string,
      sym_list,
    ACTIONS(149), 8,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
  [216] = 14,
    ACTIONS(153), 1,
      anon_sym_LPAREN,
    ACTIONS(157), 1,
      anon_sym_SQUOTE,
    ACTIONS(159), 1,
      anon_sym_DQUOTE,
    ACTIONS(161), 1,
      anon_sym_LBRACK,
    ACTIONS(163), 1,
      sym_identifier,
    ACTIONS(187), 1,
      sym_number,
    ACTIONS(193), 1,
      anon_sym_RBRACK,
    STATE(56), 1,
      sym_generics_class,
    STATE(95), 1,
      sym__args,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(44), 2,
      sym__unit,
      sym_func,
    ACTIONS(151), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(15), 5,
      sym_operators,
      sym_unit,
      sym_arg_block,
      sym_string,
      sym_list,
    ACTIONS(149), 8,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
  [274] = 5,
    ACTIONS(179), 1,
      anon_sym_LF,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_arg_block,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(177), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [313] = 3,
    ACTIONS(197), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(195), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [347] = 5,
    ACTIONS(201), 1,
      anon_sym_LF,
    ACTIONS(203), 1,
      anon_sym_DOT,
    STATE(24), 1,
      aux_sym_unit_repeat1,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(199), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [385] = 5,
    ACTIONS(208), 1,
      anon_sym_LF,
    ACTIONS(210), 1,
      anon_sym_DOT,
    STATE(27), 1,
      aux_sym_unit_repeat1,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(206), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [423] = 12,
    ACTIONS(153), 1,
      anon_sym_LPAREN,
    ACTIONS(157), 1,
      anon_sym_SQUOTE,
    ACTIONS(159), 1,
      anon_sym_DQUOTE,
    ACTIONS(161), 1,
      anon_sym_LBRACK,
    ACTIONS(163), 1,
      sym_identifier,
    ACTIONS(212), 1,
      sym_number,
    STATE(56), 1,
      sym_generics_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(44), 2,
      sym__unit,
      sym_func,
    ACTIONS(151), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(58), 5,
      sym_operators,
      sym_unit,
      sym_arg_block,
      sym_string,
      sym_list,
    ACTIONS(149), 8,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
  [475] = 5,
    ACTIONS(210), 1,
      anon_sym_DOT,
    ACTIONS(216), 1,
      anon_sym_LF,
    STATE(24), 1,
      aux_sym_unit_repeat1,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(214), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [513] = 3,
    ACTIONS(220), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(218), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [546] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(224), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(222), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [579] = 3,
    ACTIONS(228), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(226), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [612] = 6,
    ACTIONS(230), 1,
      anon_sym_LT,
    ACTIONS(232), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_arg_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(177), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(179), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [651] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(226), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(228), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [684] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(237), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(235), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [717] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(218), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(220), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [750] = 3,
    ACTIONS(201), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(199), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [783] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(195), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(197), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [816] = 3,
    ACTIONS(235), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(237), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [849] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(241), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(239), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [882] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(199), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(201), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [915] = 3,
    ACTIONS(222), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(224), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [948] = 3,
    ACTIONS(239), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(241), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [981] = 4,
    ACTIONS(243), 1,
      anon_sym_LBRACE,
    ACTIONS(247), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(245), 21,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1015] = 3,
    ACTIONS(251), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(249), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1047] = 5,
    ACTIONS(253), 1,
      anon_sym_DOT,
    STATE(50), 1,
      aux_sym_unit_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(206), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(208), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [1083] = 5,
    ACTIONS(255), 1,
      anon_sym_DOT,
    STATE(45), 1,
      aux_sym_unit_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(199), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(201), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [1119] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(260), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(258), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [1151] = 3,
    ACTIONS(258), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(260), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1183] = 3,
    ACTIONS(264), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(262), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1215] = 3,
    ACTIONS(268), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(266), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1247] = 5,
    ACTIONS(253), 1,
      anon_sym_DOT,
    STATE(45), 1,
      aux_sym_unit_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(214), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(216), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [1283] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(262), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(264), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [1315] = 3,
    ACTIONS(272), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(270), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1347] = 3,
    ACTIONS(276), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(274), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1379] = 3,
    ACTIONS(280), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(278), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1411] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(284), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(282), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [1443] = 5,
    ACTIONS(232), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_arg_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(177), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(179), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [1479] = 3,
    ACTIONS(282), 1,
      anon_sym_LF,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(284), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1511] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(286), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(130), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_identifier,
      sym_number,
  [1541] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(290), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(288), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1571] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(294), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(292), 17,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1600] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(270), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(272), 16,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_EQ,
      anon_sym_DASH_EQ,
      anon_sym_TILDE,
      anon_sym_DASH_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      sym_identifier,
      sym_number,
  [1628] = 6,
    ACTIONS(15), 1,
      anon_sym_SQUOTE,
    ACTIONS(17), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      sym_identifier,
    STATE(22), 1,
      sym_generics_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(35), 3,
      sym__unit,
      sym_func,
      sym_string,
  [1650] = 6,
    ACTIONS(157), 1,
      anon_sym_SQUOTE,
    ACTIONS(159), 1,
      anon_sym_DQUOTE,
    ACTIONS(163), 1,
      sym_identifier,
    STATE(56), 1,
      sym_generics_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(39), 3,
      sym__unit,
      sym_func,
      sym_string,
  [1672] = 6,
    ACTIONS(157), 1,
      anon_sym_SQUOTE,
    ACTIONS(159), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      sym_identifier,
    STATE(66), 1,
      sym_generics_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(39), 3,
      sym__unit,
      sym_func,
      sym_string,
  [1694] = 5,
    ACTIONS(153), 1,
      anon_sym_LPAREN,
    ACTIONS(230), 1,
      anon_sym_LT,
    STATE(33), 1,
      sym_arg_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(179), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
  [1713] = 4,
    ACTIONS(153), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_arg_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(179), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
  [1729] = 5,
    ACTIONS(296), 1,
      sym_leading_key,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    STATE(67), 1,
      aux_sym_string_repeat2,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(301), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [1747] = 5,
    ACTIONS(304), 1,
      sym_leading_key,
    ACTIONS(306), 1,
      anon_sym_DQUOTE,
    STATE(67), 1,
      aux_sym_string_repeat2,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(308), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [1765] = 5,
    ACTIONS(304), 1,
      sym_leading_key,
    ACTIONS(310), 1,
      anon_sym_DQUOTE,
    STATE(71), 1,
      aux_sym_string_repeat2,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(312), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [1783] = 5,
    ACTIONS(304), 1,
      sym_leading_key,
    ACTIONS(314), 1,
      anon_sym_DQUOTE,
    STATE(68), 1,
      aux_sym_string_repeat2,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(316), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [1801] = 5,
    ACTIONS(304), 1,
      sym_leading_key,
    ACTIONS(318), 1,
      anon_sym_DQUOTE,
    STATE(67), 1,
      aux_sym_string_repeat2,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(308), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [1819] = 4,
    ACTIONS(310), 1,
      anon_sym_SQUOTE,
    STATE(81), 1,
      aux_sym_string_repeat1,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(320), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [1834] = 4,
    ACTIONS(322), 1,
      anon_sym_DOT,
    STATE(73), 1,
      aux_sym_unit_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(201), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [1849] = 4,
    ACTIONS(325), 1,
      anon_sym_DOT,
    STATE(79), 1,
      aux_sym_unit_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(208), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [1864] = 3,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(327), 2,
      sym_leading_key,
      anon_sym_DQUOTE,
    ACTIONS(329), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [1877] = 4,
    ACTIONS(306), 1,
      anon_sym_SQUOTE,
    STATE(80), 1,
      aux_sym_string_repeat1,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(331), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [1892] = 4,
    ACTIONS(314), 1,
      anon_sym_SQUOTE,
    STATE(76), 1,
      aux_sym_string_repeat1,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(333), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [1907] = 3,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(299), 2,
      sym_leading_key,
      anon_sym_DQUOTE,
    ACTIONS(335), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [1920] = 4,
    ACTIONS(325), 1,
      anon_sym_DOT,
    STATE(73), 1,
      aux_sym_unit_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(216), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [1935] = 4,
    ACTIONS(337), 1,
      anon_sym_SQUOTE,
    STATE(80), 1,
      aux_sym_string_repeat1,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(339), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [1950] = 4,
    ACTIONS(318), 1,
      anon_sym_SQUOTE,
    STATE(80), 1,
      aux_sym_string_repeat1,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(331), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [1965] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(268), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [1974] = 3,
    ACTIONS(342), 1,
      anon_sym_LBRACE,
    ACTIONS(344), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [1985] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(280), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [1994] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(251), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [2003] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(276), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [2012] = 3,
    ACTIONS(346), 1,
      anon_sym_LBRACE,
    ACTIONS(348), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2023] = 2,
    ACTIONS(350), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2031] = 2,
    ACTIONS(352), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2039] = 2,
    ACTIONS(354), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2047] = 2,
    ACTIONS(356), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2055] = 2,
    ACTIONS(358), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2063] = 2,
    ACTIONS(360), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2071] = 2,
    ACTIONS(362), 1,
      aux_sym_shebang_token1,
    ACTIONS(96), 2,
      sym_line_comment,
      sym_block_comment,
  [2079] = 2,
    ACTIONS(364), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2087] = 2,
    ACTIONS(366), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2095] = 2,
    ACTIONS(368), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2103] = 2,
    ACTIONS(370), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2111] = 2,
    ACTIONS(29), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2119] = 2,
    ACTIONS(372), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2127] = 2,
    ACTIONS(374), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2135] = 2,
    ACTIONS(33), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [2143] = 2,
    ACTIONS(376), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(17)] = 0,
  [SMALL_STATE(18)] = 42,
  [SMALL_STATE(19)] = 100,
  [SMALL_STATE(20)] = 158,
  [SMALL_STATE(21)] = 216,
  [SMALL_STATE(22)] = 274,
  [SMALL_STATE(23)] = 313,
  [SMALL_STATE(24)] = 347,
  [SMALL_STATE(25)] = 385,
  [SMALL_STATE(26)] = 423,
  [SMALL_STATE(27)] = 475,
  [SMALL_STATE(28)] = 513,
  [SMALL_STATE(29)] = 546,
  [SMALL_STATE(30)] = 579,
  [SMALL_STATE(31)] = 612,
  [SMALL_STATE(32)] = 651,
  [SMALL_STATE(33)] = 684,
  [SMALL_STATE(34)] = 717,
  [SMALL_STATE(35)] = 750,
  [SMALL_STATE(36)] = 783,
  [SMALL_STATE(37)] = 816,
  [SMALL_STATE(38)] = 849,
  [SMALL_STATE(39)] = 882,
  [SMALL_STATE(40)] = 915,
  [SMALL_STATE(41)] = 948,
  [SMALL_STATE(42)] = 981,
  [SMALL_STATE(43)] = 1015,
  [SMALL_STATE(44)] = 1047,
  [SMALL_STATE(45)] = 1083,
  [SMALL_STATE(46)] = 1119,
  [SMALL_STATE(47)] = 1151,
  [SMALL_STATE(48)] = 1183,
  [SMALL_STATE(49)] = 1215,
  [SMALL_STATE(50)] = 1247,
  [SMALL_STATE(51)] = 1283,
  [SMALL_STATE(52)] = 1315,
  [SMALL_STATE(53)] = 1347,
  [SMALL_STATE(54)] = 1379,
  [SMALL_STATE(55)] = 1411,
  [SMALL_STATE(56)] = 1443,
  [SMALL_STATE(57)] = 1479,
  [SMALL_STATE(58)] = 1511,
  [SMALL_STATE(59)] = 1541,
  [SMALL_STATE(60)] = 1571,
  [SMALL_STATE(61)] = 1600,
  [SMALL_STATE(62)] = 1628,
  [SMALL_STATE(63)] = 1650,
  [SMALL_STATE(64)] = 1672,
  [SMALL_STATE(65)] = 1694,
  [SMALL_STATE(66)] = 1713,
  [SMALL_STATE(67)] = 1729,
  [SMALL_STATE(68)] = 1747,
  [SMALL_STATE(69)] = 1765,
  [SMALL_STATE(70)] = 1783,
  [SMALL_STATE(71)] = 1801,
  [SMALL_STATE(72)] = 1819,
  [SMALL_STATE(73)] = 1834,
  [SMALL_STATE(74)] = 1849,
  [SMALL_STATE(75)] = 1864,
  [SMALL_STATE(76)] = 1877,
  [SMALL_STATE(77)] = 1892,
  [SMALL_STATE(78)] = 1907,
  [SMALL_STATE(79)] = 1920,
  [SMALL_STATE(80)] = 1935,
  [SMALL_STATE(81)] = 1950,
  [SMALL_STATE(82)] = 1965,
  [SMALL_STATE(83)] = 1974,
  [SMALL_STATE(84)] = 1985,
  [SMALL_STATE(85)] = 1994,
  [SMALL_STATE(86)] = 2003,
  [SMALL_STATE(87)] = 2012,
  [SMALL_STATE(88)] = 2023,
  [SMALL_STATE(89)] = 2031,
  [SMALL_STATE(90)] = 2039,
  [SMALL_STATE(91)] = 2047,
  [SMALL_STATE(92)] = 2055,
  [SMALL_STATE(93)] = 2063,
  [SMALL_STATE(94)] = 2071,
  [SMALL_STATE(95)] = 2079,
  [SMALL_STATE(96)] = 2087,
  [SMALL_STATE(97)] = 2095,
  [SMALL_STATE(98)] = 2103,
  [SMALL_STATE(99)] = 2111,
  [SMALL_STATE(100)] = 2119,
  [SMALL_STATE(101)] = 2127,
  [SMALL_STATE(102)] = 2135,
  [SMALL_STATE(103)] = 2143,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [35] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [37] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(52),
  [40] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(48),
  [43] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(48),
  [46] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(96),
  [49] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(72),
  [52] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(69),
  [55] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(19),
  [58] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(17),
  [61] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(42),
  [64] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [66] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2),
  [68] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2),
  [70] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_repeat1, 2),
  [72] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(52),
  [75] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(48),
  [78] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(96),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(72),
  [84] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(69),
  [87] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(19),
  [90] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(17),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(42),
  [96] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [98] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_command, 1),
  [100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__args_repeat1, 2), SHIFT_REPEAT(61),
  [121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__args_repeat1, 2), SHIFT_REPEAT(51),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__args_repeat1, 2), SHIFT_REPEAT(51),
  [127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__args_repeat1, 2), SHIFT_REPEAT(20),
  [130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__args_repeat1, 2),
  [132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__args_repeat1, 2), SHIFT_REPEAT(77),
  [135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__args_repeat1, 2), SHIFT_REPEAT(70),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__args_repeat1, 2), SHIFT_REPEAT(21),
  [141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__args_repeat1, 2), SHIFT_REPEAT(31),
  [144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__args_repeat1, 2), SHIFT_REPEAT(13),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__args, 2),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__args, 1),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unit, 1),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unit, 1),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generics_class, 4, .production_id = 1),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generics_class, 4, .production_id = 1),
  [199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unit_repeat1, 2),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unit_repeat1, 2),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unit_repeat1, 2), SHIFT_REPEAT(62),
  [206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit, 1),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit, 1),
  [210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit, 2),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit, 2),
  [218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg_block, 3),
  [220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg_block, 3),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg_block, 2),
  [224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg_block, 2),
  [226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__unit, 1), SHIFT(20),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func, 2),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func, 2),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 1),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_repeat1, 1),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unit_repeat1, 2), SHIFT_REPEAT(63),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operators, 1),
  [264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operators, 1),
  [266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg_spliter, 1),
  [272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg_spliter, 1),
  [274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 5),
  [276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 5),
  [278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorate, 2),
  [280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorate, 2),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__args_repeat1, 2),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 2),
  [290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 2),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shebang, 2),
  [294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shebang, 2),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(83),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(67),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unit_repeat1, 2), SHIFT_REPEAT(64),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 4),
  [329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 4),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(80),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [354] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_groovy(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
