#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 70
#define LARGE_STATE_COUNT 5
#define SYMBOL_COUNT 34
#define ALIAS_COUNT 2
#define TOKEN_COUNT 17
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 1
#define MAX_ALIAS_SEQUENCE_LENGTH 5
#define PRODUCTION_ID_COUNT 5

enum ts_symbol_identifiers {
  anon_sym_EQ = 1,
  anon_sym_COLON = 2,
  anon_sym_DOT = 3,
  anon_sym_LBRACK = 4,
  anon_sym_RBRACK = 5,
  anon_sym_DOLLAR_LBRACE = 6,
  anon_sym_RBRACE = 7,
  anon_sym_COLON_COLON = 8,
  anon_sym_BSLASH = 9,
  aux_sym_escape_token1 = 10,
  aux_sym_escape_token2 = 11,
  sym_comment = 12,
  sym__space = 13,
  aux_sym__char_token1 = 14,
  sym__eol = 15,
  sym__eof = 16,
  sym_file = 17,
  sym_property = 18,
  sym_key = 19,
  sym__index = 20,
  sym_value = 21,
  sym_substitution = 22,
  sym__default = 23,
  sym__secret = 24,
  aux_sym__content = 25,
  sym__linebreak = 26,
  sym_escape = 27,
  sym__char = 28,
  aux_sym_file_repeat1 = 29,
  aux_sym_key_repeat1 = 30,
  aux_sym__index_repeat1 = 31,
  aux_sym_value_repeat1 = 32,
  aux_sym_substitution_repeat1 = 33,
  alias_sym_index = 34,
  alias_sym_secret = 35,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_EQ] = "=",
  [anon_sym_COLON] = ":",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_RBRACE] = "}",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_escape_token1] = "escape_token1",
  [aux_sym_escape_token2] = "escape_token2",
  [sym_comment] = "comment",
  [sym__space] = "_space",
  [aux_sym__char_token1] = "_char_token1",
  [sym__eol] = "_eol",
  [sym__eof] = "_eof",
  [sym_file] = "file",
  [sym_property] = "property",
  [sym_key] = "key",
  [sym__index] = "_index",
  [sym_value] = "value",
  [sym_substitution] = "substitution",
  [sym__default] = "_default",
  [sym__secret] = "_secret",
  [aux_sym__content] = "_content",
  [sym__linebreak] = "_linebreak",
  [sym_escape] = "escape",
  [sym__char] = "_char",
  [aux_sym_file_repeat1] = "file_repeat1",
  [aux_sym_key_repeat1] = "key_repeat1",
  [aux_sym__index_repeat1] = "_index_repeat1",
  [aux_sym_value_repeat1] = "value_repeat1",
  [aux_sym_substitution_repeat1] = "substitution_repeat1",
  [alias_sym_index] = "index",
  [alias_sym_secret] = "secret",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [aux_sym_escape_token1] = aux_sym_escape_token1,
  [aux_sym_escape_token2] = aux_sym_escape_token2,
  [sym_comment] = sym_comment,
  [sym__space] = sym__space,
  [aux_sym__char_token1] = aux_sym__char_token1,
  [sym__eol] = sym__eol,
  [sym__eof] = sym__eof,
  [sym_file] = sym_file,
  [sym_property] = sym_property,
  [sym_key] = sym_key,
  [sym__index] = sym__index,
  [sym_value] = sym_value,
  [sym_substitution] = sym_substitution,
  [sym__default] = sym__default,
  [sym__secret] = sym__secret,
  [aux_sym__content] = aux_sym__content,
  [sym__linebreak] = sym__linebreak,
  [sym_escape] = sym_escape,
  [sym__char] = sym__char,
  [aux_sym_file_repeat1] = aux_sym_file_repeat1,
  [aux_sym_key_repeat1] = aux_sym_key_repeat1,
  [aux_sym__index_repeat1] = aux_sym__index_repeat1,
  [aux_sym_value_repeat1] = aux_sym_value_repeat1,
  [aux_sym_substitution_repeat1] = aux_sym_substitution_repeat1,
  [alias_sym_index] = alias_sym_index,
  [alias_sym_secret] = alias_sym_secret,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__space] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__char_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__eol] = {
    .visible = false,
    .named = true,
  },
  [sym__eof] = {
    .visible = false,
    .named = true,
  },
  [sym_file] = {
    .visible = true,
    .named = true,
  },
  [sym_property] = {
    .visible = true,
    .named = true,
  },
  [sym_key] = {
    .visible = true,
    .named = true,
  },
  [sym__index] = {
    .visible = false,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym__default] = {
    .visible = false,
    .named = true,
  },
  [sym__secret] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__content] = {
    .visible = false,
    .named = false,
  },
  [sym__linebreak] = {
    .visible = false,
    .named = true,
  },
  [sym_escape] = {
    .visible = true,
    .named = true,
  },
  [sym__char] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_key_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__index_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_substitution_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_index] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_secret] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_default = 1,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_default] = "default",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_default, 1},
  [1] =
    {field_default, 2, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [1] = alias_sym_index,
  },
  [3] = {
    [1] = alias_sym_secret,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym__content, 2,
    aux_sym__content,
    alias_sym_secret,
  aux_sym__index_repeat1, 2,
    aux_sym__index_repeat1,
    alias_sym_index,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 11,
  [18] = 15,
  [19] = 8,
  [20] = 20,
  [21] = 15,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 22,
  [30] = 30,
  [31] = 26,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 25,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 37,
  [42] = 30,
  [43] = 34,
  [44] = 26,
  [45] = 26,
  [46] = 34,
  [47] = 30,
  [48] = 37,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 50,
  [53] = 53,
  [54] = 53,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 64,
  [66] = 63,
  [67] = 64,
  [68] = 63,
  [69] = 69,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(16);
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '\r') ADVANCE(33);
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '[') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(22);
      if (lookahead == '}') ADVANCE(24);
      if (lookahead == '!' ||
          lookahead == '#') ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == ' ') ADVANCE(31);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '\r') ADVANCE(33);
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '[') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == ' ') ADVANCE(31);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '\r') ADVANCE(33);
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == ' ') ADVANCE(31);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '\r') ADVANCE(33);
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == ' ') ADVANCE(31);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '\r') ADVANCE(33);
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '\r') ADVANCE(33);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == '[') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '!' ||
          lookahead == '#') ADVANCE(30);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '\r') ADVANCE(37);
      END_STATE();
    case 7:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '[') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '}') ADVANCE(24);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 8:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == '[') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 9:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '}') ADVANCE(24);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 10:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 11:
      if (lookahead == ']') ADVANCE(22);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(29);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 15:
      if (eof) ADVANCE(16);
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '\r') ADVANCE(33);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == '[') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '!' ||
          lookahead == '#') ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == ' ') ADVANCE(31);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(25);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == 'u') ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(27);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym_escape_token1);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(aux_sym_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(14);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(aux_sym_escape_token2);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(30);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(sym__space);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(aux_sym__char_token1);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(aux_sym__char_token1);
      if (lookahead == '\n') ADVANCE(36);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(aux_sym__char_token1);
      if (lookahead == 'u') ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(27);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(aux_sym__char_token1);
      if (lookahead == '{') ADVANCE(23);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym__eol);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym__eol);
      if (lookahead == '\n') ADVANCE(36);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 15, .external_lex_state = 1},
  [2] = {.lex_state = 7},
  [3] = {.lex_state = 7},
  [4] = {.lex_state = 7},
  [5] = {.lex_state = 15, .external_lex_state = 1},
  [6] = {.lex_state = 15, .external_lex_state = 1},
  [7] = {.lex_state = 2, .external_lex_state = 1},
  [8] = {.lex_state = 1, .external_lex_state = 1},
  [9] = {.lex_state = 7},
  [10] = {.lex_state = 2, .external_lex_state = 1},
  [11] = {.lex_state = 1, .external_lex_state = 1},
  [12] = {.lex_state = 5, .external_lex_state = 1},
  [13] = {.lex_state = 3, .external_lex_state = 1},
  [14] = {.lex_state = 3, .external_lex_state = 1},
  [15] = {.lex_state = 8},
  [16] = {.lex_state = 4, .external_lex_state = 1},
  [17] = {.lex_state = 7},
  [18] = {.lex_state = 8},
  [19] = {.lex_state = 7},
  [20] = {.lex_state = 4, .external_lex_state = 1},
  [21] = {.lex_state = 8},
  [22] = {.lex_state = 1, .external_lex_state = 1},
  [23] = {.lex_state = 4, .external_lex_state = 1},
  [24] = {.lex_state = 4, .external_lex_state = 1},
  [25] = {.lex_state = 1, .external_lex_state = 1},
  [26] = {.lex_state = 1, .external_lex_state = 1},
  [27] = {.lex_state = 15, .external_lex_state = 1},
  [28] = {.lex_state = 15, .external_lex_state = 1},
  [29] = {.lex_state = 7},
  [30] = {.lex_state = 7},
  [31] = {.lex_state = 7},
  [32] = {.lex_state = 9},
  [33] = {.lex_state = 9},
  [34] = {.lex_state = 7},
  [35] = {.lex_state = 9},
  [36] = {.lex_state = 7},
  [37] = {.lex_state = 7},
  [38] = {.lex_state = 10},
  [39] = {.lex_state = 10},
  [40] = {.lex_state = 4, .external_lex_state = 1},
  [41] = {.lex_state = 4, .external_lex_state = 1},
  [42] = {.lex_state = 4, .external_lex_state = 1},
  [43] = {.lex_state = 4, .external_lex_state = 1},
  [44] = {.lex_state = 4, .external_lex_state = 1},
  [45] = {.lex_state = 9},
  [46] = {.lex_state = 9},
  [47] = {.lex_state = 9},
  [48] = {.lex_state = 9},
  [49] = {.lex_state = 9},
  [50] = {.lex_state = 11},
  [51] = {.lex_state = 11},
  [52] = {.lex_state = 11},
  [53] = {.lex_state = 11},
  [54] = {.lex_state = 11},
  [55] = {.lex_state = 6, .external_lex_state = 1},
  [56] = {.lex_state = 6, .external_lex_state = 1},
  [57] = {.lex_state = 6, .external_lex_state = 1},
  [58] = {.lex_state = 6, .external_lex_state = 1},
  [59] = {.lex_state = 6, .external_lex_state = 1},
  [60] = {.lex_state = 11},
  [61] = {.lex_state = 6, .external_lex_state = 1},
  [62] = {.lex_state = 6},
  [63] = {.lex_state = 0},
  [64] = {.lex_state = 0},
  [65] = {.lex_state = 0},
  [66] = {.lex_state = 0},
  [67] = {.lex_state = 0},
  [68] = {.lex_state = 0},
  [69] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [aux_sym_escape_token1] = ACTIONS(1),
    [aux_sym_escape_token2] = ACTIONS(1),
    [sym_comment] = ACTIONS(1),
    [sym__space] = ACTIONS(1),
    [aux_sym__char_token1] = ACTIONS(1),
    [sym__eol] = ACTIONS(1),
    [sym__eof] = ACTIONS(1),
  },
  [1] = {
    [sym_file] = STATE(69),
    [sym_property] = STATE(61),
    [sym_key] = STATE(7),
    [sym__index] = STATE(8),
    [sym_escape] = STATE(8),
    [sym__char] = STATE(8),
    [aux_sym_file_repeat1] = STATE(6),
    [aux_sym_key_repeat1] = STATE(8),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [aux_sym_escape_token1] = ACTIONS(9),
    [aux_sym_escape_token2] = ACTIONS(11),
    [sym_comment] = ACTIONS(13),
    [sym__space] = ACTIONS(15),
    [aux_sym__char_token1] = ACTIONS(17),
    [sym__eol] = ACTIONS(19),
    [sym__eof] = ACTIONS(21),
  },
  [2] = {
    [sym_key] = STATE(9),
    [sym__index] = STATE(19),
    [sym_substitution] = STATE(9),
    [sym__default] = STATE(64),
    [sym__secret] = STATE(63),
    [sym_escape] = STATE(19),
    [sym__char] = STATE(19),
    [aux_sym_key_repeat1] = STATE(19),
    [aux_sym_substitution_repeat1] = STATE(9),
    [anon_sym_COLON] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [aux_sym_escape_token1] = ACTIONS(35),
    [aux_sym_escape_token2] = ACTIONS(37),
    [aux_sym__char_token1] = ACTIONS(39),
  },
  [3] = {
    [sym_key] = STATE(9),
    [sym__index] = STATE(19),
    [sym_substitution] = STATE(9),
    [sym__default] = STATE(65),
    [sym__secret] = STATE(66),
    [sym_escape] = STATE(19),
    [sym__char] = STATE(19),
    [aux_sym_key_repeat1] = STATE(19),
    [aux_sym_substitution_repeat1] = STATE(9),
    [anon_sym_COLON] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [aux_sym_escape_token1] = ACTIONS(35),
    [aux_sym_escape_token2] = ACTIONS(37),
    [aux_sym__char_token1] = ACTIONS(39),
  },
  [4] = {
    [sym_key] = STATE(9),
    [sym__index] = STATE(19),
    [sym_substitution] = STATE(9),
    [sym__default] = STATE(67),
    [sym__secret] = STATE(68),
    [sym_escape] = STATE(19),
    [sym__char] = STATE(19),
    [aux_sym_key_repeat1] = STATE(19),
    [aux_sym_substitution_repeat1] = STATE(9),
    [anon_sym_COLON] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [aux_sym_escape_token1] = ACTIONS(35),
    [aux_sym_escape_token2] = ACTIONS(37),
    [aux_sym__char_token1] = ACTIONS(39),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 14,
    ACTIONS(45), 1,
      ts_builtin_sym_end,
    ACTIONS(47), 1,
      anon_sym_DOT,
    ACTIONS(50), 1,
      anon_sym_LBRACK,
    ACTIONS(53), 1,
      aux_sym_escape_token1,
    ACTIONS(56), 1,
      aux_sym_escape_token2,
    ACTIONS(59), 1,
      sym_comment,
    ACTIONS(62), 1,
      sym__space,
    ACTIONS(65), 1,
      aux_sym__char_token1,
    ACTIONS(68), 1,
      sym__eol,
    ACTIONS(71), 1,
      sym__eof,
    STATE(5), 1,
      aux_sym_file_repeat1,
    STATE(7), 1,
      sym_key,
    STATE(61), 1,
      sym_property,
    STATE(8), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
  [46] = 14,
    ACTIONS(5), 1,
      anon_sym_DOT,
    ACTIONS(7), 1,
      anon_sym_LBRACK,
    ACTIONS(9), 1,
      aux_sym_escape_token1,
    ACTIONS(11), 1,
      aux_sym_escape_token2,
    ACTIONS(13), 1,
      sym_comment,
    ACTIONS(15), 1,
      sym__space,
    ACTIONS(17), 1,
      aux_sym__char_token1,
    ACTIONS(74), 1,
      ts_builtin_sym_end,
    ACTIONS(76), 1,
      sym__eol,
    ACTIONS(78), 1,
      sym__eof,
    STATE(5), 1,
      aux_sym_file_repeat1,
    STATE(7), 1,
      sym_key,
    STATE(61), 1,
      sym_property,
    STATE(8), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
  [92] = 11,
    ACTIONS(82), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(84), 1,
      anon_sym_BSLASH,
    ACTIONS(86), 1,
      aux_sym_escape_token1,
    ACTIONS(88), 1,
      aux_sym_escape_token2,
    ACTIONS(90), 1,
      sym__space,
    ACTIONS(92), 1,
      aux_sym__char_token1,
    ACTIONS(94), 1,
      sym__eol,
    ACTIONS(96), 1,
      sym__eof,
    STATE(56), 1,
      sym_value,
    ACTIONS(80), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(23), 5,
      sym_substitution,
      sym__linebreak,
      sym_escape,
      sym__char,
      aux_sym_value_repeat1,
  [131] = 8,
    ACTIONS(7), 1,
      anon_sym_LBRACK,
    ACTIONS(9), 1,
      aux_sym_escape_token1,
    ACTIONS(11), 1,
      aux_sym_escape_token2,
    ACTIONS(100), 1,
      anon_sym_DOT,
    ACTIONS(104), 1,
      aux_sym__char_token1,
    ACTIONS(102), 2,
      anon_sym_BSLASH,
      sym__eol,
    STATE(11), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
    ACTIONS(98), 5,
      sym__eof,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOLLAR_LBRACE,
      sym__space,
  [164] = 10,
    ACTIONS(106), 1,
      anon_sym_COLON,
    ACTIONS(108), 1,
      anon_sym_DOT,
    ACTIONS(111), 1,
      anon_sym_LBRACK,
    ACTIONS(114), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(119), 1,
      aux_sym_escape_token1,
    ACTIONS(122), 1,
      aux_sym_escape_token2,
    ACTIONS(125), 1,
      aux_sym__char_token1,
    ACTIONS(117), 2,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
    STATE(9), 3,
      sym_key,
      sym_substitution,
      aux_sym_substitution_repeat1,
    STATE(19), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
  [201] = 11,
    ACTIONS(82), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(84), 1,
      anon_sym_BSLASH,
    ACTIONS(86), 1,
      aux_sym_escape_token1,
    ACTIONS(88), 1,
      aux_sym_escape_token2,
    ACTIONS(92), 1,
      aux_sym__char_token1,
    ACTIONS(130), 1,
      sym__space,
    ACTIONS(132), 1,
      sym__eol,
    ACTIONS(134), 1,
      sym__eof,
    STATE(59), 1,
      sym_value,
    ACTIONS(128), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(23), 5,
      sym_substitution,
      sym__linebreak,
      sym_escape,
      sym__char,
      aux_sym_value_repeat1,
  [240] = 8,
    ACTIONS(138), 1,
      anon_sym_DOT,
    ACTIONS(141), 1,
      anon_sym_LBRACK,
    ACTIONS(146), 1,
      aux_sym_escape_token1,
    ACTIONS(149), 1,
      aux_sym_escape_token2,
    ACTIONS(152), 1,
      aux_sym__char_token1,
    ACTIONS(144), 2,
      anon_sym_BSLASH,
      sym__eol,
    STATE(11), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
    ACTIONS(136), 5,
      sym__eof,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOLLAR_LBRACE,
      sym__space,
  [273] = 11,
    ACTIONS(5), 1,
      anon_sym_DOT,
    ACTIONS(7), 1,
      anon_sym_LBRACK,
    ACTIONS(9), 1,
      aux_sym_escape_token1,
    ACTIONS(11), 1,
      aux_sym_escape_token2,
    ACTIONS(17), 1,
      aux_sym__char_token1,
    ACTIONS(155), 1,
      sym_comment,
    ACTIONS(157), 1,
      sym__eol,
    ACTIONS(159), 1,
      sym__eof,
    STATE(7), 1,
      sym_key,
    STATE(55), 1,
      sym_property,
    STATE(8), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
  [310] = 10,
    ACTIONS(82), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(84), 1,
      anon_sym_BSLASH,
    ACTIONS(86), 1,
      aux_sym_escape_token1,
    ACTIONS(88), 1,
      aux_sym_escape_token2,
    ACTIONS(92), 1,
      aux_sym__char_token1,
    ACTIONS(161), 1,
      sym__space,
    ACTIONS(163), 1,
      sym__eol,
    ACTIONS(165), 1,
      sym__eof,
    STATE(57), 1,
      sym_value,
    STATE(23), 5,
      sym_substitution,
      sym__linebreak,
      sym_escape,
      sym__char,
      aux_sym_value_repeat1,
  [345] = 10,
    ACTIONS(82), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(84), 1,
      anon_sym_BSLASH,
    ACTIONS(86), 1,
      aux_sym_escape_token1,
    ACTIONS(88), 1,
      aux_sym_escape_token2,
    ACTIONS(92), 1,
      aux_sym__char_token1,
    ACTIONS(130), 1,
      sym__space,
    ACTIONS(132), 1,
      sym__eol,
    ACTIONS(134), 1,
      sym__eof,
    STATE(59), 1,
      sym_value,
    STATE(23), 5,
      sym_substitution,
      sym__linebreak,
      sym_escape,
      sym__char,
      aux_sym_value_repeat1,
  [380] = 8,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(35), 1,
      aux_sym_escape_token1,
    ACTIONS(37), 1,
      aux_sym_escape_token2,
    ACTIONS(39), 1,
      aux_sym__char_token1,
    STATE(3), 3,
      sym_key,
      sym_substitution,
      aux_sym_substitution_repeat1,
    STATE(19), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
  [410] = 9,
    ACTIONS(82), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(84), 1,
      anon_sym_BSLASH,
    ACTIONS(86), 1,
      aux_sym_escape_token1,
    ACTIONS(88), 1,
      aux_sym_escape_token2,
    ACTIONS(92), 1,
      aux_sym__char_token1,
    ACTIONS(163), 1,
      sym__eol,
    ACTIONS(165), 1,
      sym__eof,
    STATE(57), 1,
      sym_value,
    STATE(23), 5,
      sym_substitution,
      sym__linebreak,
      sym_escape,
      sym__char,
      aux_sym_value_repeat1,
  [442] = 8,
    ACTIONS(144), 1,
      anon_sym_COLON,
    ACTIONS(167), 1,
      anon_sym_DOT,
    ACTIONS(170), 1,
      anon_sym_LBRACK,
    ACTIONS(173), 1,
      aux_sym_escape_token1,
    ACTIONS(176), 1,
      aux_sym_escape_token2,
    ACTIONS(179), 1,
      aux_sym__char_token1,
    ACTIONS(136), 3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
    STATE(17), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
  [472] = 8,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(35), 1,
      aux_sym_escape_token1,
    ACTIONS(37), 1,
      aux_sym_escape_token2,
    ACTIONS(39), 1,
      aux_sym__char_token1,
    STATE(2), 3,
      sym_key,
      sym_substitution,
      aux_sym_substitution_repeat1,
    STATE(19), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
  [502] = 8,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      aux_sym_escape_token1,
    ACTIONS(37), 1,
      aux_sym_escape_token2,
    ACTIONS(102), 1,
      anon_sym_COLON,
    ACTIONS(182), 1,
      anon_sym_DOT,
    ACTIONS(184), 1,
      aux_sym__char_token1,
    ACTIONS(98), 3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
    STATE(17), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
  [532] = 9,
    ACTIONS(82), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(84), 1,
      anon_sym_BSLASH,
    ACTIONS(86), 1,
      aux_sym_escape_token1,
    ACTIONS(88), 1,
      aux_sym_escape_token2,
    ACTIONS(92), 1,
      aux_sym__char_token1,
    ACTIONS(186), 1,
      sym__eol,
    ACTIONS(188), 1,
      sym__eof,
    STATE(58), 1,
      sym_value,
    STATE(23), 5,
      sym_substitution,
      sym__linebreak,
      sym_escape,
      sym__char,
      aux_sym_value_repeat1,
  [564] = 8,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(35), 1,
      aux_sym_escape_token1,
    ACTIONS(37), 1,
      aux_sym_escape_token2,
    ACTIONS(39), 1,
      aux_sym__char_token1,
    STATE(4), 3,
      sym_key,
      sym_substitution,
      aux_sym_substitution_repeat1,
    STATE(19), 4,
      sym__index,
      sym_escape,
      sym__char,
      aux_sym_key_repeat1,
  [594] = 2,
    ACTIONS(192), 4,
      anon_sym_BSLASH,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
    ACTIONS(190), 8,
      sym__eof,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_LBRACE,
      aux_sym_escape_token2,
      sym__space,
  [611] = 8,
    ACTIONS(82), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(84), 1,
      anon_sym_BSLASH,
    ACTIONS(86), 1,
      aux_sym_escape_token1,
    ACTIONS(88), 1,
      aux_sym_escape_token2,
    ACTIONS(194), 1,
      aux_sym__char_token1,
    ACTIONS(196), 1,
      sym__eol,
    ACTIONS(198), 1,
      sym__eof,
    STATE(24), 5,
      sym_substitution,
      sym__linebreak,
      sym_escape,
      sym__char,
      aux_sym_value_repeat1,
  [640] = 8,
    ACTIONS(200), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(203), 1,
      anon_sym_BSLASH,
    ACTIONS(206), 1,
      aux_sym_escape_token1,
    ACTIONS(209), 1,
      aux_sym_escape_token2,
    ACTIONS(212), 1,
      aux_sym__char_token1,
    ACTIONS(215), 1,
      sym__eol,
    ACTIONS(217), 1,
      sym__eof,
    STATE(24), 5,
      sym_substitution,
      sym__linebreak,
      sym_escape,
      sym__char,
      aux_sym_value_repeat1,
  [669] = 2,
    ACTIONS(221), 4,
      anon_sym_BSLASH,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
    ACTIONS(219), 8,
      sym__eof,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_LBRACE,
      aux_sym_escape_token2,
      sym__space,
  [686] = 2,
    ACTIONS(225), 4,
      anon_sym_BSLASH,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
    ACTIONS(223), 8,
      sym__eof,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_LBRACE,
      aux_sym_escape_token2,
      sym__space,
  [703] = 2,
    ACTIONS(229), 3,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
    ACTIONS(227), 7,
      sym__eof,
      ts_builtin_sym_end,
      anon_sym_DOT,
      anon_sym_LBRACK,
      aux_sym_escape_token2,
      sym_comment,
      sym__space,
  [718] = 2,
    ACTIONS(231), 3,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
    ACTIONS(45), 7,
      sym__eof,
      ts_builtin_sym_end,
      anon_sym_DOT,
      anon_sym_LBRACK,
      aux_sym_escape_token2,
      sym_comment,
      sym__space,
  [733] = 2,
    ACTIONS(192), 3,
      anon_sym_COLON,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(190), 6,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      aux_sym_escape_token2,
  [747] = 2,
    ACTIONS(233), 3,
      anon_sym_COLON,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(235), 6,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      aux_sym_escape_token2,
  [761] = 2,
    ACTIONS(225), 3,
      anon_sym_COLON,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(223), 6,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      aux_sym_escape_token2,
  [775] = 7,
    ACTIONS(237), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(239), 1,
      anon_sym_RBRACE,
    ACTIONS(241), 1,
      aux_sym_escape_token1,
    ACTIONS(243), 1,
      aux_sym_escape_token2,
    ACTIONS(245), 1,
      aux_sym__char_token1,
    STATE(35), 1,
      aux_sym__content,
    STATE(49), 3,
      sym_substitution,
      sym_escape,
      sym__char,
  [799] = 7,
    ACTIONS(237), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(241), 1,
      aux_sym_escape_token1,
    ACTIONS(243), 1,
      aux_sym_escape_token2,
    ACTIONS(245), 1,
      aux_sym__char_token1,
    ACTIONS(247), 1,
      anon_sym_RBRACE,
    STATE(35), 1,
      aux_sym__content,
    STATE(49), 3,
      sym_substitution,
      sym_escape,
      sym__char,
  [823] = 2,
    ACTIONS(249), 3,
      anon_sym_COLON,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(251), 6,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      aux_sym_escape_token2,
  [837] = 7,
    ACTIONS(253), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(256), 1,
      anon_sym_RBRACE,
    ACTIONS(258), 1,
      aux_sym_escape_token1,
    ACTIONS(261), 1,
      aux_sym_escape_token2,
    ACTIONS(264), 1,
      aux_sym__char_token1,
    STATE(35), 1,
      aux_sym__content,
    STATE(49), 3,
      sym_substitution,
      sym_escape,
      sym__char,
  [861] = 2,
    ACTIONS(221), 3,
      anon_sym_COLON,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(219), 6,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      aux_sym_escape_token2,
  [875] = 2,
    ACTIONS(267), 3,
      anon_sym_COLON,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(269), 6,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      aux_sym_escape_token2,
  [889] = 6,
    ACTIONS(237), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(241), 1,
      aux_sym_escape_token1,
    ACTIONS(243), 1,
      aux_sym_escape_token2,
    ACTIONS(245), 1,
      aux_sym__char_token1,
    STATE(32), 1,
      aux_sym__content,
    STATE(49), 3,
      sym_substitution,
      sym_escape,
      sym__char,
  [910] = 6,
    ACTIONS(237), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(241), 1,
      aux_sym_escape_token1,
    ACTIONS(243), 1,
      aux_sym_escape_token2,
    ACTIONS(245), 1,
      aux_sym__char_token1,
    STATE(33), 1,
      aux_sym__content,
    STATE(49), 3,
      sym_substitution,
      sym_escape,
      sym__char,
  [931] = 2,
    ACTIONS(271), 3,
      sym__eof,
      anon_sym_DOLLAR_LBRACE,
      aux_sym_escape_token2,
    ACTIONS(273), 4,
      anon_sym_BSLASH,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
  [943] = 2,
    ACTIONS(269), 3,
      sym__eof,
      anon_sym_DOLLAR_LBRACE,
      aux_sym_escape_token2,
    ACTIONS(267), 4,
      anon_sym_BSLASH,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
  [955] = 2,
    ACTIONS(235), 3,
      sym__eof,
      anon_sym_DOLLAR_LBRACE,
      aux_sym_escape_token2,
    ACTIONS(233), 4,
      anon_sym_BSLASH,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
  [967] = 2,
    ACTIONS(251), 3,
      sym__eof,
      anon_sym_DOLLAR_LBRACE,
      aux_sym_escape_token2,
    ACTIONS(249), 4,
      anon_sym_BSLASH,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
  [979] = 2,
    ACTIONS(223), 3,
      sym__eof,
      anon_sym_DOLLAR_LBRACE,
      aux_sym_escape_token2,
    ACTIONS(225), 4,
      anon_sym_BSLASH,
      aux_sym_escape_token1,
      aux_sym__char_token1,
      sym__eol,
  [991] = 2,
    ACTIONS(225), 2,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(223), 3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      aux_sym_escape_token2,
  [1001] = 2,
    ACTIONS(249), 2,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(251), 3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      aux_sym_escape_token2,
  [1011] = 2,
    ACTIONS(233), 2,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(235), 3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      aux_sym_escape_token2,
  [1021] = 2,
    ACTIONS(267), 2,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(269), 3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      aux_sym_escape_token2,
  [1031] = 2,
    ACTIONS(277), 2,
      aux_sym_escape_token1,
      aux_sym__char_token1,
    ACTIONS(275), 3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_RBRACE,
      aux_sym_escape_token2,
  [1041] = 4,
    ACTIONS(279), 1,
      anon_sym_RBRACK,
    ACTIONS(281), 1,
      aux_sym__char_token1,
    STATE(53), 1,
      aux_sym__index_repeat1,
    STATE(60), 1,
      sym__char,
  [1054] = 4,
    ACTIONS(283), 1,
      anon_sym_RBRACK,
    ACTIONS(285), 1,
      aux_sym__char_token1,
    STATE(51), 1,
      aux_sym__index_repeat1,
    STATE(60), 1,
      sym__char,
  [1067] = 4,
    ACTIONS(281), 1,
      aux_sym__char_token1,
    ACTIONS(288), 1,
      anon_sym_RBRACK,
    STATE(54), 1,
      aux_sym__index_repeat1,
    STATE(60), 1,
      sym__char,
  [1080] = 4,
    ACTIONS(281), 1,
      aux_sym__char_token1,
    ACTIONS(290), 1,
      anon_sym_RBRACK,
    STATE(51), 1,
      aux_sym__index_repeat1,
    STATE(60), 1,
      sym__char,
  [1093] = 4,
    ACTIONS(281), 1,
      aux_sym__char_token1,
    ACTIONS(292), 1,
      anon_sym_RBRACK,
    STATE(51), 1,
      aux_sym__index_repeat1,
    STATE(60), 1,
      sym__char,
  [1106] = 1,
    ACTIONS(294), 2,
      sym__eof,
      sym__eol,
  [1111] = 1,
    ACTIONS(134), 2,
      sym__eof,
      sym__eol,
  [1116] = 1,
    ACTIONS(188), 2,
      sym__eof,
      sym__eol,
  [1121] = 1,
    ACTIONS(296), 2,
      sym__eof,
      sym__eol,
  [1126] = 1,
    ACTIONS(165), 2,
      sym__eof,
      sym__eol,
  [1131] = 2,
    ACTIONS(298), 1,
      anon_sym_RBRACK,
    ACTIONS(300), 1,
      aux_sym__char_token1,
  [1138] = 1,
    ACTIONS(159), 2,
      sym__eof,
      sym__eol,
  [1143] = 1,
    ACTIONS(302), 1,
      sym__eol,
  [1147] = 1,
    ACTIONS(304), 1,
      anon_sym_RBRACE,
  [1151] = 1,
    ACTIONS(306), 1,
      anon_sym_RBRACE,
  [1155] = 1,
    ACTIONS(308), 1,
      anon_sym_RBRACE,
  [1159] = 1,
    ACTIONS(310), 1,
      anon_sym_RBRACE,
  [1163] = 1,
    ACTIONS(312), 1,
      anon_sym_RBRACE,
  [1167] = 1,
    ACTIONS(314), 1,
      anon_sym_RBRACE,
  [1171] = 1,
    ACTIONS(316), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(5)] = 0,
  [SMALL_STATE(6)] = 46,
  [SMALL_STATE(7)] = 92,
  [SMALL_STATE(8)] = 131,
  [SMALL_STATE(9)] = 164,
  [SMALL_STATE(10)] = 201,
  [SMALL_STATE(11)] = 240,
  [SMALL_STATE(12)] = 273,
  [SMALL_STATE(13)] = 310,
  [SMALL_STATE(14)] = 345,
  [SMALL_STATE(15)] = 380,
  [SMALL_STATE(16)] = 410,
  [SMALL_STATE(17)] = 442,
  [SMALL_STATE(18)] = 472,
  [SMALL_STATE(19)] = 502,
  [SMALL_STATE(20)] = 532,
  [SMALL_STATE(21)] = 564,
  [SMALL_STATE(22)] = 594,
  [SMALL_STATE(23)] = 611,
  [SMALL_STATE(24)] = 640,
  [SMALL_STATE(25)] = 669,
  [SMALL_STATE(26)] = 686,
  [SMALL_STATE(27)] = 703,
  [SMALL_STATE(28)] = 718,
  [SMALL_STATE(29)] = 733,
  [SMALL_STATE(30)] = 747,
  [SMALL_STATE(31)] = 761,
  [SMALL_STATE(32)] = 775,
  [SMALL_STATE(33)] = 799,
  [SMALL_STATE(34)] = 823,
  [SMALL_STATE(35)] = 837,
  [SMALL_STATE(36)] = 861,
  [SMALL_STATE(37)] = 875,
  [SMALL_STATE(38)] = 889,
  [SMALL_STATE(39)] = 910,
  [SMALL_STATE(40)] = 931,
  [SMALL_STATE(41)] = 943,
  [SMALL_STATE(42)] = 955,
  [SMALL_STATE(43)] = 967,
  [SMALL_STATE(44)] = 979,
  [SMALL_STATE(45)] = 991,
  [SMALL_STATE(46)] = 1001,
  [SMALL_STATE(47)] = 1011,
  [SMALL_STATE(48)] = 1021,
  [SMALL_STATE(49)] = 1031,
  [SMALL_STATE(50)] = 1041,
  [SMALL_STATE(51)] = 1054,
  [SMALL_STATE(52)] = 1067,
  [SMALL_STATE(53)] = 1080,
  [SMALL_STATE(54)] = 1093,
  [SMALL_STATE(55)] = 1106,
  [SMALL_STATE(56)] = 1111,
  [SMALL_STATE(57)] = 1116,
  [SMALL_STATE(58)] = 1121,
  [SMALL_STATE(59)] = 1126,
  [SMALL_STATE(60)] = 1131,
  [SMALL_STATE(61)] = 1138,
  [SMALL_STATE(62)] = 1143,
  [SMALL_STATE(63)] = 1147,
  [SMALL_STATE(64)] = 1151,
  [SMALL_STATE(65)] = 1155,
  [SMALL_STATE(66)] = 1159,
  [SMALL_STATE(67)] = 1163,
  [SMALL_STATE(68)] = 1167,
  [SMALL_STATE(69)] = 1171,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 0),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [45] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2),
  [47] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(8),
  [50] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(52),
  [53] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(26),
  [56] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(26),
  [59] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(61),
  [62] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(12),
  [65] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(8),
  [68] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(5),
  [71] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(5),
  [74] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 1),
  [76] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [78] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [80] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [82] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [84] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [86] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [88] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [90] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [92] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [94] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property, 1),
  [96] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property, 1),
  [98] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key, 1),
  [100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key, 1),
  [104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_substitution_repeat1, 2),
  [108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_substitution_repeat1, 2), SHIFT_REPEAT(19),
  [111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_substitution_repeat1, 2), SHIFT_REPEAT(50),
  [114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_substitution_repeat1, 2), SHIFT_REPEAT(15),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_substitution_repeat1, 2),
  [119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_substitution_repeat1, 2), SHIFT_REPEAT(31),
  [122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_substitution_repeat1, 2), SHIFT_REPEAT(31),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_substitution_repeat1, 2), SHIFT_REPEAT(19),
  [128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property, 2),
  [134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property, 2),
  [136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_key_repeat1, 2),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(11),
  [141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(52),
  [144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_key_repeat1, 2),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(26),
  [149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(26),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(11),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property, 3),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property, 3),
  [167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(17),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(50),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(31),
  [176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(31),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_key_repeat1, 2), SHIFT_REPEAT(17),
  [182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property, 4),
  [188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property, 4),
  [190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index, 3, .production_id = 1),
  [192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__index, 3, .production_id = 1),
  [194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 1),
  [198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1),
  [200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2), SHIFT_REPEAT(18),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2), SHIFT_REPEAT(62),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2), SHIFT_REPEAT(44),
  [209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2), SHIFT_REPEAT(44),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2), SHIFT_REPEAT(24),
  [215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2),
  [217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index, 2),
  [221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__index, 2),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_escape, 1),
  [225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_escape, 1),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 3),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 3),
  [231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution, 4, .production_id = 4),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution, 4, .production_id = 4),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default, 2, .production_id = 2),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__secret, 2, .production_id = 3),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution, 4),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution, 4),
  [253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__content, 2), SHIFT_REPEAT(21),
  [256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__content, 2),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__content, 2), SHIFT_REPEAT(45),
  [261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__content, 2), SHIFT_REPEAT(45),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__content, 2), SHIFT_REPEAT(49),
  [267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution, 3),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution, 3),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__linebreak, 2),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__linebreak, 2),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__content, 1),
  [277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__content, 1),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__index_repeat1, 2),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__index_repeat1, 2), SHIFT_REPEAT(60),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property, 5),
  [298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__index_repeat1, 1),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__index_repeat1, 1),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [316] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__eof = 0,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__eof] = sym__eof,
};

static const bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__eof] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_properties_external_scanner_create(void);
void tree_sitter_properties_external_scanner_destroy(void *);
bool tree_sitter_properties_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_properties_external_scanner_serialize(void *, char *);
void tree_sitter_properties_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_properties(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_properties_external_scanner_create,
      tree_sitter_properties_external_scanner_destroy,
      tree_sitter_properties_external_scanner_scan,
      tree_sitter_properties_external_scanner_serialize,
      tree_sitter_properties_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
