#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1748
#define LARGE_STATE_COUNT 184
#define SYMBOL_COUNT 207
#define ALIAS_COUNT 0
#define TOKEN_COUNT 117
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 33
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 133

enum {
  sym_identifier = 1,
  anon_sym_namespace = 2,
  anon_sym_EQ = 3,
  anon_sym_SEMI = 4,
  anon_sym_package = 5,
  anon_sym_class = 6,
  anon_sym_extends = 7,
  anon_sym_implements = 8,
  anon_sym_COMMA = 9,
  anon_sym_LBRACK = 10,
  anon_sym_LPAREN = 11,
  anon_sym_RPAREN = 12,
  anon_sym_RBRACK = 13,
  anon_sym_dynamic = 14,
  anon_sym_final = 15,
  anon_sym_internal = 16,
  anon_sym_public = 17,
  anon_sym_interface = 18,
  anon_sym_LBRACE = 19,
  anon_sym_RBRACE = 20,
  anon_sym_function = 21,
  anon_sym_get = 22,
  anon_sym_set = 23,
  anon_sym_var = 24,
  anon_sym_const = 25,
  anon_sym_private = 26,
  anon_sym_protected = 27,
  anon_sym_static = 28,
  anon_sym_override = 29,
  anon_sym_DOT_DOT_DOT = 30,
  anon_sym_import = 31,
  anon_sym_if = 32,
  anon_sym_else = 33,
  anon_sym_switch = 34,
  anon_sym_case = 35,
  anon_sym_COLON = 36,
  anon_sym_default = 37,
  anon_sym_for = 38,
  anon_sym_in = 39,
  anon_sym_foreach = 40,
  anon_sym_while = 41,
  anon_sym_do = 42,
  anon_sym_with = 43,
  anon_sym_try = 44,
  anon_sym_catch = 45,
  anon_sym_finally = 46,
  anon_sym_break = 47,
  anon_sym_continue = 48,
  anon_sym_return = 49,
  anon_sym_throw = 50,
  anon_sym_DOT = 51,
  anon_sym_STAR = 52,
  anon_sym_DOT_DOT = 53,
  anon_sym_COLON_COLON = 54,
  anon_sym_LT = 55,
  anon_sym_GT = 56,
  aux_sym_xml_token1 = 57,
  anon_sym_LT_SLASH = 58,
  anon_sym_SLASH_GT = 59,
  anon_sym_STAR_EQ = 60,
  anon_sym_SLASH_EQ = 61,
  anon_sym_PERCENT_EQ = 62,
  anon_sym_PLUS_EQ = 63,
  anon_sym_DASH_EQ = 64,
  anon_sym_LT_LT_EQ = 65,
  anon_sym_GT_GT_EQ = 66,
  anon_sym_GT_GT_GT_EQ = 67,
  anon_sym_AMP_EQ = 68,
  anon_sym_CARET_EQ = 69,
  anon_sym_PIPE_EQ = 70,
  anon_sym_PLUS = 71,
  anon_sym_DASH = 72,
  anon_sym_TILDE = 73,
  anon_sym_BANG = 74,
  anon_sym_delete = 75,
  anon_sym_typeof = 76,
  anon_sym_void = 77,
  anon_sym_SLASH = 78,
  anon_sym_PERCENT = 79,
  anon_sym_LT_LT = 80,
  anon_sym_GT_GT = 81,
  anon_sym_GT_GT_GT = 82,
  anon_sym_LT_EQ = 83,
  anon_sym_GT_EQ = 84,
  anon_sym_instanceof = 85,
  anon_sym_is = 86,
  anon_sym_EQ_EQ = 87,
  anon_sym_BANG_EQ = 88,
  anon_sym_EQ_EQ_EQ = 89,
  anon_sym_BANG_EQ_EQ = 90,
  anon_sym_AMP = 91,
  anon_sym_CARET = 92,
  anon_sym_PIPE = 93,
  anon_sym_AMP_AMP = 94,
  anon_sym_PIPE_PIPE = 95,
  anon_sym_as = 96,
  anon_sym_QMARK = 97,
  anon_sym_PLUS_PLUS = 98,
  anon_sym_DASH_DASH = 99,
  anon_sym_new = 100,
  anon_sym_DOT_LT = 101,
  sym_true = 102,
  sym_false = 103,
  sym_undefined = 104,
  sym_null = 105,
  sym_number = 106,
  anon_sym_DQUOTE = 107,
  anon_sym_SQUOTE = 108,
  sym__unescaped_double_string_fragment = 109,
  sym__unescaped_single_string_fragment = 110,
  sym__escape_sequence = 111,
  anon_sym_SLASH2 = 112,
  sym_regex_pattern = 113,
  sym_regex_flags = 114,
  sym_line_comment = 115,
  sym_block_comment = 116,
  sym_program = 117,
  sym_declaration = 118,
  sym_namespace_declaration = 119,
  sym_package_declaration = 120,
  sym_class_declaration = 121,
  sym_annotation = 122,
  sym_class_attribut = 123,
  sym_interface_declaration = 124,
  sym_interface_attribut = 125,
  sym_method_declaration = 126,
  sym_function_declaration = 127,
  sym_function_parameters = 128,
  sym_variable_declaration = 129,
  sym__variable_declarator = 130,
  sym_constant_declaration = 131,
  sym_property_attribut = 132,
  sym_accessor = 133,
  sym_rest = 134,
  sym_import_statement = 135,
  sym_expression_statement = 136,
  sym_statement_block = 137,
  sym_if_statement = 138,
  sym_else_clause = 139,
  sym_switch_statement = 140,
  sym_switch_body = 141,
  sym_switch_case = 142,
  sym_switch_default = 143,
  sym_for_statement = 144,
  sym_for_in_statement = 145,
  sym_for_each_in_statement = 146,
  sym_while_statement = 147,
  sym_do_statement = 148,
  sym_with_statement = 149,
  sym_try_statement = 150,
  sym_catch_clause = 151,
  sym_finally_clause = 152,
  sym_break_statement = 153,
  sym_continue_statement = 154,
  sym_return_statement = 155,
  sym_throw_statement = 156,
  sym_empty_statement = 157,
  sym_labeled_statement = 158,
  sym_sequence_expression = 159,
  sym_expression = 160,
  sym_primary_expression = 161,
  sym_subscript_expression = 162,
  sym_member_expression = 163,
  sym_descendant_expression = 164,
  sym_namespace_expression = 165,
  sym_parenthesized_expression = 166,
  sym_object = 167,
  sym_pair = 168,
  sym_array = 169,
  sym_vector = 170,
  sym_xml = 171,
  sym_xml_attribute = 172,
  sym_anonymous_function = 173,
  sym_call_expression = 174,
  sym_assignment_expression = 175,
  sym_augmented_assignment_expression = 176,
  sym_unary_expression = 177,
  sym_binary_expression = 178,
  sym_cast_expression = 179,
  sym_ternary_expression = 180,
  sym_update_expression = 181,
  sym_new_expression = 182,
  sym__data_type = 183,
  sym_any_type = 184,
  sym_generic_data_type = 185,
  sym_scoped_data_type = 186,
  sym_type_hint = 187,
  sym_string = 188,
  sym_regex = 189,
  aux_sym_program_repeat1 = 190,
  aux_sym_namespace_declaration_repeat1 = 191,
  aux_sym_namespace_declaration_repeat2 = 192,
  aux_sym_class_declaration_repeat1 = 193,
  aux_sym_class_declaration_repeat2 = 194,
  aux_sym_annotation_repeat1 = 195,
  aux_sym_annotation_repeat2 = 196,
  aux_sym_interface_declaration_repeat1 = 197,
  aux_sym_function_parameters_repeat1 = 198,
  aux_sym_switch_body_repeat1 = 199,
  aux_sym_for_statement_repeat1 = 200,
  aux_sym_try_statement_repeat1 = 201,
  aux_sym_object_repeat1 = 202,
  aux_sym_xml_repeat1 = 203,
  aux_sym_xml_repeat2 = 204,
  aux_sym_string_repeat1 = 205,
  aux_sym_string_repeat2 = 206,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_namespace] = "namespace",
  [anon_sym_EQ] = "=",
  [anon_sym_SEMI] = ";",
  [anon_sym_package] = "package",
  [anon_sym_class] = "class",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_COMMA] = ",",
  [anon_sym_LBRACK] = "[",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_RBRACK] = "]",
  [anon_sym_dynamic] = "dynamic",
  [anon_sym_final] = "final",
  [anon_sym_internal] = "internal",
  [anon_sym_public] = "public",
  [anon_sym_interface] = "interface",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_function] = "function",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_var] = "var",
  [anon_sym_const] = "const",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_static] = "static",
  [anon_sym_override] = "override",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_import] = "import",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_COLON] = ":",
  [anon_sym_default] = "default",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_foreach] = "for each",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_with] = "with",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_DOT] = ".",
  [anon_sym_STAR] = "*",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [aux_sym_xml_token1] = "xml_token1",
  [anon_sym_LT_SLASH] = "</",
  [anon_sym_SLASH_GT] = "/>",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_delete] = "delete",
  [anon_sym_typeof] = "typeof",
  [anon_sym_void] = "void",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_is] = "is",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_as] = "as",
  [anon_sym_QMARK] = "\?",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_new] = "new",
  [anon_sym_DOT_LT] = ".<",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_undefined] = "undefined",
  [sym_null] = "null",
  [sym_number] = "number",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym__unescaped_double_string_fragment] = "_unescaped_double_string_fragment",
  [sym__unescaped_single_string_fragment] = "_unescaped_single_string_fragment",
  [sym__escape_sequence] = "_escape_sequence",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym_program] = "program",
  [sym_declaration] = "declaration",
  [sym_namespace_declaration] = "namespace_declaration",
  [sym_package_declaration] = "package_declaration",
  [sym_class_declaration] = "class_declaration",
  [sym_annotation] = "annotation",
  [sym_class_attribut] = "class_attribut",
  [sym_interface_declaration] = "interface_declaration",
  [sym_interface_attribut] = "interface_attribut",
  [sym_method_declaration] = "method_declaration",
  [sym_function_declaration] = "function_declaration",
  [sym_function_parameters] = "function_parameters",
  [sym_variable_declaration] = "variable_declaration",
  [sym__variable_declarator] = "_variable_declarator",
  [sym_constant_declaration] = "constant_declaration",
  [sym_property_attribut] = "property_attribut",
  [sym_accessor] = "accessor",
  [sym_rest] = "rest",
  [sym_import_statement] = "import_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym_for_each_in_statement] = "for_each_in_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_with_statement] = "with_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_sequence_expression] = "sequence_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_member_expression] = "member_expression",
  [sym_descendant_expression] = "descendant_expression",
  [sym_namespace_expression] = "namespace_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_object] = "object",
  [sym_pair] = "pair",
  [sym_array] = "array",
  [sym_vector] = "vector",
  [sym_xml] = "xml",
  [sym_xml_attribute] = "xml_attribute",
  [sym_anonymous_function] = "anonymous_function",
  [sym_call_expression] = "call_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym_update_expression] = "update_expression",
  [sym_new_expression] = "new_expression",
  [sym__data_type] = "_data_type",
  [sym_any_type] = "any_type",
  [sym_generic_data_type] = "generic_data_type",
  [sym_scoped_data_type] = "scoped_data_type",
  [sym_type_hint] = "type_hint",
  [sym_string] = "string",
  [sym_regex] = "regex",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_namespace_declaration_repeat1] = "namespace_declaration_repeat1",
  [aux_sym_namespace_declaration_repeat2] = "namespace_declaration_repeat2",
  [aux_sym_class_declaration_repeat1] = "class_declaration_repeat1",
  [aux_sym_class_declaration_repeat2] = "class_declaration_repeat2",
  [aux_sym_annotation_repeat1] = "annotation_repeat1",
  [aux_sym_annotation_repeat2] = "annotation_repeat2",
  [aux_sym_interface_declaration_repeat1] = "interface_declaration_repeat1",
  [aux_sym_function_parameters_repeat1] = "function_parameters_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_xml_repeat1] = "xml_repeat1",
  [aux_sym_xml_repeat2] = "xml_repeat2",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_dynamic] = anon_sym_dynamic,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [aux_sym_xml_token1] = aux_sym_xml_token1,
  [anon_sym_LT_SLASH] = anon_sym_LT_SLASH,
  [anon_sym_SLASH_GT] = anon_sym_SLASH_GT,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_DOT_LT] = anon_sym_DOT_LT,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_undefined] = sym_undefined,
  [sym_null] = sym_null,
  [sym_number] = sym_number,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym__unescaped_double_string_fragment] = sym__unescaped_double_string_fragment,
  [sym__unescaped_single_string_fragment] = sym__unescaped_single_string_fragment,
  [sym__escape_sequence] = sym__escape_sequence,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [sym_program] = sym_program,
  [sym_declaration] = sym_declaration,
  [sym_namespace_declaration] = sym_namespace_declaration,
  [sym_package_declaration] = sym_package_declaration,
  [sym_class_declaration] = sym_class_declaration,
  [sym_annotation] = sym_annotation,
  [sym_class_attribut] = sym_class_attribut,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_interface_attribut] = sym_interface_attribut,
  [sym_method_declaration] = sym_method_declaration,
  [sym_function_declaration] = sym_function_declaration,
  [sym_function_parameters] = sym_function_parameters,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym__variable_declarator] = sym__variable_declarator,
  [sym_constant_declaration] = sym_constant_declaration,
  [sym_property_attribut] = sym_property_attribut,
  [sym_accessor] = sym_accessor,
  [sym_rest] = sym_rest,
  [sym_import_statement] = sym_import_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_statement_block] = sym_statement_block,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym_for_each_in_statement] = sym_for_each_in_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_descendant_expression] = sym_descendant_expression,
  [sym_namespace_expression] = sym_namespace_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_object] = sym_object,
  [sym_pair] = sym_pair,
  [sym_array] = sym_array,
  [sym_vector] = sym_vector,
  [sym_xml] = sym_xml,
  [sym_xml_attribute] = sym_xml_attribute,
  [sym_anonymous_function] = sym_anonymous_function,
  [sym_call_expression] = sym_call_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_new_expression] = sym_new_expression,
  [sym__data_type] = sym__data_type,
  [sym_any_type] = sym_any_type,
  [sym_generic_data_type] = sym_generic_data_type,
  [sym_scoped_data_type] = sym_scoped_data_type,
  [sym_type_hint] = sym_type_hint,
  [sym_string] = sym_string,
  [sym_regex] = sym_regex,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_namespace_declaration_repeat1] = aux_sym_namespace_declaration_repeat1,
  [aux_sym_namespace_declaration_repeat2] = aux_sym_namespace_declaration_repeat2,
  [aux_sym_class_declaration_repeat1] = aux_sym_class_declaration_repeat1,
  [aux_sym_class_declaration_repeat2] = aux_sym_class_declaration_repeat2,
  [aux_sym_annotation_repeat1] = aux_sym_annotation_repeat1,
  [aux_sym_annotation_repeat2] = aux_sym_annotation_repeat2,
  [aux_sym_interface_declaration_repeat1] = aux_sym_interface_declaration_repeat1,
  [aux_sym_function_parameters_repeat1] = aux_sym_function_parameters_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_xml_repeat1] = aux_sym_xml_repeat1,
  [aux_sym_xml_repeat2] = aux_sym_xml_repeat2,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dynamic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_xml_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_LT] = {
    .visible = true,
    .named = false,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__unescaped_double_string_fragment] = {
    .visible = false,
    .named = true,
  },
  [sym__unescaped_single_string_fragment] = {
    .visible = false,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_package_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_class_attribut] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_attribut] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_constant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_attribut] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor] = {
    .visible = true,
    .named = true,
  },
  [sym_rest] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_each_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_descendant_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_vector] = {
    .visible = true,
    .named = true,
  },
  [sym_xml] = {
    .visible = true,
    .named = true,
  },
  [sym_xml_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__data_type] = {
    .visible = false,
    .named = true,
  },
  [sym_any_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_data_type] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_data_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_hint] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_xml_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_xml_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alternative = 1,
  field_argument = 2,
  field_body = 3,
  field_condition = 4,
  field_consequence = 5,
  field_default = 6,
  field_finalizer = 7,
  field_flags = 8,
  field_function = 9,
  field_handler = 10,
  field_iffalse = 11,
  field_iftrue = 12,
  field_increment = 13,
  field_index = 14,
  field_initializer = 15,
  field_interfaces = 16,
  field_key = 17,
  field_label = 18,
  field_left = 19,
  field_name = 20,
  field_object = 21,
  field_operator = 22,
  field_parameter = 23,
  field_parameters = 24,
  field_pattern = 25,
  field_property = 26,
  field_return_type = 27,
  field_right = 28,
  field_superclass = 29,
  field_supertype = 30,
  field_type = 31,
  field_type_parameters = 32,
  field_value = 33,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_default] = "default",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_iffalse] = "iffalse",
  [field_iftrue] = "iftrue",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_interfaces] = "interfaces",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_superclass] = "superclass",
  [field_supertype] = "supertype",
  [field_type] = "type",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 3},
  [5] = {.index = 7, .length = 2},
  [6] = {.index = 9, .length = 2},
  [7] = {.index = 11, .length = 2},
  [8] = {.index = 13, .length = 2},
  [9] = {.index = 15, .length = 2},
  [10] = {.index = 17, .length = 2},
  [11] = {.index = 19, .length = 2},
  [12] = {.index = 21, .length = 2},
  [13] = {.index = 23, .length = 2},
  [14] = {.index = 25, .length = 1},
  [15] = {.index = 26, .length = 1},
  [16] = {.index = 27, .length = 2},
  [17] = {.index = 29, .length = 2},
  [18] = {.index = 31, .length = 3},
  [19] = {.index = 34, .length = 1},
  [20] = {.index = 35, .length = 2},
  [21] = {.index = 37, .length = 3},
  [22] = {.index = 40, .length = 2},
  [23] = {.index = 42, .length = 1},
  [24] = {.index = 43, .length = 1},
  [25] = {.index = 44, .length = 2},
  [26] = {.index = 46, .length = 2},
  [27] = {.index = 48, .length = 3},
  [28] = {.index = 51, .length = 3},
  [29] = {.index = 54, .length = 2},
  [30] = {.index = 56, .length = 2},
  [31] = {.index = 58, .length = 1},
  [32] = {.index = 59, .length = 2},
  [33] = {.index = 61, .length = 2},
  [34] = {.index = 63, .length = 1},
  [35] = {.index = 64, .length = 2},
  [36] = {.index = 66, .length = 3},
  [37] = {.index = 69, .length = 4},
  [38] = {.index = 73, .length = 4},
  [39] = {.index = 77, .length = 2},
  [40] = {.index = 79, .length = 2},
  [41] = {.index = 81, .length = 2},
  [42] = {.index = 83, .length = 3},
  [43] = {.index = 86, .length = 4},
  [44] = {.index = 90, .length = 2},
  [45] = {.index = 92, .length = 2},
  [46] = {.index = 94, .length = 3},
  [47] = {.index = 97, .length = 6},
  [48] = {.index = 103, .length = 2},
  [49] = {.index = 105, .length = 2},
  [50] = {.index = 107, .length = 3},
  [51] = {.index = 110, .length = 3},
  [52] = {.index = 113, .length = 2},
  [53] = {.index = 115, .length = 1},
  [54] = {.index = 116, .length = 2},
  [55] = {.index = 118, .length = 5},
  [56] = {.index = 123, .length = 3},
  [57] = {.index = 126, .length = 4},
  [58] = {.index = 130, .length = 1},
  [59] = {.index = 131, .length = 3},
  [60] = {.index = 134, .length = 3},
  [61] = {.index = 137, .length = 3},
  [62] = {.index = 140, .length = 3},
  [63] = {.index = 143, .length = 2},
  [64] = {.index = 145, .length = 1},
  [65] = {.index = 146, .length = 1},
  [66] = {.index = 147, .length = 3},
  [67] = {.index = 150, .length = 2},
  [68] = {.index = 152, .length = 2},
  [69] = {.index = 154, .length = 4},
  [70] = {.index = 158, .length = 4},
  [71] = {.index = 162, .length = 2},
  [72] = {.index = 164, .length = 6},
  [73] = {.index = 170, .length = 4},
  [74] = {.index = 174, .length = 4},
  [75] = {.index = 178, .length = 2},
  [76] = {.index = 180, .length = 5},
  [77] = {.index = 185, .length = 4},
  [78] = {.index = 189, .length = 3},
  [79] = {.index = 192, .length = 3},
  [80] = {.index = 195, .length = 2},
  [81] = {.index = 197, .length = 3},
  [82] = {.index = 200, .length = 7},
  [83] = {.index = 207, .length = 4},
  [84] = {.index = 211, .length = 2},
  [85] = {.index = 213, .length = 3},
  [86] = {.index = 216, .length = 5},
  [87] = {.index = 221, .length = 2},
  [88] = {.index = 223, .length = 3},
  [89] = {.index = 226, .length = 2},
  [90] = {.index = 228, .length = 2},
  [91] = {.index = 230, .length = 4},
  [92] = {.index = 234, .length = 4},
  [93] = {.index = 238, .length = 7},
  [94] = {.index = 245, .length = 5},
  [95] = {.index = 250, .length = 3},
  [96] = {.index = 253, .length = 4},
  [97] = {.index = 257, .length = 3},
  [98] = {.index = 260, .length = 4},
  [99] = {.index = 264, .length = 8},
  [100] = {.index = 272, .length = 11},
  [101] = {.index = 283, .length = 3},
  [102] = {.index = 286, .length = 4},
  [103] = {.index = 290, .length = 4},
  [104] = {.index = 294, .length = 6},
  [105] = {.index = 300, .length = 3},
  [106] = {.index = 303, .length = 3},
  [107] = {.index = 306, .length = 3},
  [108] = {.index = 309, .length = 2},
  [109] = {.index = 311, .length = 3},
  [110] = {.index = 314, .length = 5},
  [111] = {.index = 319, .length = 2},
  [112] = {.index = 321, .length = 2},
  [113] = {.index = 323, .length = 4},
  [114] = {.index = 327, .length = 12},
  [115] = {.index = 339, .length = 5},
  [116] = {.index = 344, .length = 7},
  [117] = {.index = 351, .length = 4},
  [118] = {.index = 355, .length = 4},
  [119] = {.index = 359, .length = 4},
  [120] = {.index = 363, .length = 3},
  [121] = {.index = 366, .length = 3},
  [122] = {.index = 369, .length = 6},
  [123] = {.index = 375, .length = 3},
  [124] = {.index = 378, .length = 2},
  [125] = {.index = 380, .length = 2},
  [126] = {.index = 382, .length = 5},
  [127] = {.index = 387, .length = 4},
  [128] = {.index = 391, .length = 7},
  [129] = {.index = 398, .length = 3},
  [130] = {.index = 401, .length = 2},
  [131] = {.index = 403, .length = 2},
  [132] = {.index = 405, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 1},
  [1] =
    {field_name, 1},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_name, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [7] =
    {field_argument, 0},
    {field_operator, 1},
  [9] =
    {field_body, 2},
    {field_name, 1},
  [11] =
    {field_name, 1},
    {field_type, 2},
  [13] =
    {field_condition, 1},
    {field_consequence, 2},
  [15] =
    {field_body, 2},
    {field_value, 1},
  [17] =
    {field_body, 2},
    {field_condition, 1},
  [19] =
    {field_body, 2},
    {field_object, 1},
  [21] =
    {field_body, 1},
    {field_finalizer, 2},
  [23] =
    {field_body, 1},
    {field_handler, 2},
  [25] =
    {field_label, 1},
  [26] =
    {field_pattern, 1},
  [27] =
    {field_left, 0},
    {field_right, 2},
  [29] =
    {field_body, 2},
    {field_label, 0},
  [31] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [34] =
    {field_function, 0},
  [35] =
    {field_object, 0},
    {field_property, 2},
  [37] =
    {field_name, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [40] =
    {field_key, 0},
    {field_value, 2},
  [42] =
    {field_body, 3},
  [43] =
    {field_type, 1},
  [44] =
    {field_default, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [46] =
    {field_name, 1},
    {field_value, 3},
  [48] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [51] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [54] =
    {field_type, 1},
    {field_value, 3},
  [56] =
    {field_flags, 3},
    {field_pattern, 1},
  [58] =
    {field_type_parameters, 2},
  [59] =
    {field_index, 2},
    {field_object, 0},
  [61] =
    {field_function, 0},
    {field_parameters, 2},
  [63] =
    {field_name, 2},
  [64] =
    {field_body, 3},
    {field_name, 2},
  [66] =
    {field_name, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [69] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 2},
    {field_superclass, 3},
  [73] =
    {field_body, 4},
    {field_interfaces, 2},
    {field_interfaces, 3},
    {field_name, 1},
  [77] =
    {field_body, 3},
    {field_name, 1},
  [79] =
    {field_body, 4},
    {field_return_type, 3},
  [81] =
    {field_default, 1},
    {field_default, 2},
  [83] =
    {field_default, 2, .inherited = true},
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [86] =
    {field_default, 0, .inherited = true},
    {field_default, 1, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [90] =
    {field_body, 4},
    {field_parameters, 2},
  [92] =
    {field_body, 4},
    {field_name, 1},
  [94] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 4},
  [97] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [103] =
    {field_body, 1},
    {field_condition, 3},
  [105] =
    {field_type_parameters, 2},
    {field_type_parameters, 3},
  [107] =
    {field_function, 0},
    {field_parameters, 2},
    {field_parameters, 3},
  [110] =
    {field_condition, 0},
    {field_iffalse, 4},
    {field_iftrue, 2},
  [113] =
    {field_name, 2},
    {field_type, 3},
  [115] =
    {field_name, 3},
  [116] =
    {field_body, 4},
    {field_name, 3},
  [118] =
    {field_body, 5},
    {field_interfaces, 2},
    {field_interfaces, 3},
    {field_interfaces, 4},
    {field_name, 1},
  [123] =
    {field_name, 1},
    {field_supertype, 2},
    {field_supertype, 3},
  [126] =
    {field_default, 1},
    {field_default, 2},
    {field_default, 3, .inherited = true},
    {field_type, 3, .inherited = true},
  [130] =
    {field_type, 2},
  [131] =
    {field_default, 2},
    {field_default, 3},
    {field_type, 1},
  [134] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4},
  [137] =
    {field_body, 5},
    {field_name, 1},
    {field_return_type, 4},
  [140] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
  [143] =
    {field_body, 5},
    {field_name, 2},
  [145] =
    {field_value, 1},
  [146] =
    {field_body, 2},
  [147] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [150] =
    {field_body, 4},
    {field_name, 2},
  [152] =
    {field_name, 2},
    {field_value, 4},
  [154] =
    {field_body, 5},
    {field_name, 2},
    {field_superclass, 3},
    {field_superclass, 4},
  [158] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_interfaces, 4},
    {field_name, 2},
  [162] =
    {field_name, 3},
    {field_type, 4},
  [164] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_interfaces, 5},
    {field_name, 1},
    {field_superclass, 2},
    {field_superclass, 3},
  [170] =
    {field_body, 5},
    {field_name, 1},
    {field_supertype, 2},
    {field_supertype, 3},
  [174] =
    {field_name, 1},
    {field_supertype, 2},
    {field_supertype, 3},
    {field_supertype, 4},
  [178] =
    {field_default, 2},
    {field_default, 3},
  [180] =
    {field_default, 2},
    {field_default, 3},
    {field_default, 4, .inherited = true},
    {field_type, 1},
    {field_type, 4, .inherited = true},
  [185] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
  [189] =
    {field_body, 6},
    {field_name, 2},
    {field_return_type, 5},
  [192] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
  [195] =
    {field_body, 3},
    {field_value, 1},
  [197] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [200] =
    {field_body, 6},
    {field_condition, 4},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_name, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [207] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [211] =
    {field_body, 4},
    {field_parameter, 2},
  [213] =
    {field_name, 2},
    {field_supertype, 3},
    {field_supertype, 4},
  [216] =
    {field_body, 6},
    {field_interfaces, 3},
    {field_interfaces, 4},
    {field_interfaces, 5},
    {field_name, 2},
  [221] =
    {field_body, 6},
    {field_name, 3},
  [223] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 5},
  [226] =
    {field_body, 5},
    {field_name, 3},
  [228] =
    {field_name, 3},
    {field_value, 5},
  [230] =
    {field_body, 6},
    {field_name, 3},
    {field_superclass, 4},
    {field_superclass, 5},
  [234] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_interfaces, 5},
    {field_name, 3},
  [238] =
    {field_body, 7},
    {field_interfaces, 4},
    {field_interfaces, 5},
    {field_interfaces, 6},
    {field_name, 1},
    {field_superclass, 2},
    {field_superclass, 3},
  [245] =
    {field_body, 6},
    {field_name, 1},
    {field_supertype, 2},
    {field_supertype, 3},
    {field_supertype, 4},
  [250] =
    {field_default, 3},
    {field_default, 4},
    {field_type, 2},
  [253] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
  [257] =
    {field_body, 7},
    {field_left, 3},
    {field_right, 5},
  [260] =
    {field_body, 7},
    {field_left, 2},
    {field_left, 3},
    {field_right, 5},
  [264] =
    {field_body, 7},
    {field_condition, 4},
    {field_increment, 5},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_name, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [272] =
    {field_body, 7},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_initializer, 4},
    {field_name, 2, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_type, 3, .inherited = true},
    {field_value, 2, .inherited = true},
    {field_value, 3, .inherited = true},
  [283] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [286] =
    {field_body, 6},
    {field_name, 2},
    {field_supertype, 3},
    {field_supertype, 4},
  [290] =
    {field_name, 2},
    {field_supertype, 3},
    {field_supertype, 4},
    {field_supertype, 5},
  [294] =
    {field_body, 7},
    {field_interfaces, 5},
    {field_interfaces, 6},
    {field_name, 2},
    {field_superclass, 3},
    {field_superclass, 4},
  [300] =
    {field_body, 7},
    {field_name, 3},
    {field_return_type, 6},
  [303] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 5},
  [306] =
    {field_name, 3},
    {field_supertype, 4},
    {field_supertype, 5},
  [309] =
    {field_body, 7},
    {field_name, 4},
  [311] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 6},
  [314] =
    {field_body, 7},
    {field_interfaces, 4},
    {field_interfaces, 5},
    {field_interfaces, 6},
    {field_name, 3},
  [319] =
    {field_name, 1},
    {field_return_type, 4},
  [321] =
    {field_name, 1},
    {field_parameters, 3},
  [323] =
    {field_body, 8},
    {field_left, 3},
    {field_left, 4},
    {field_right, 6},
  [327] =
    {field_body, 8},
    {field_condition, 5},
    {field_increment, 6},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_initializer, 4},
    {field_name, 2, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_type, 3, .inherited = true},
    {field_value, 2, .inherited = true},
    {field_value, 3, .inherited = true},
  [339] =
    {field_body, 7},
    {field_name, 2},
    {field_supertype, 3},
    {field_supertype, 4},
    {field_supertype, 5},
  [344] =
    {field_body, 8},
    {field_interfaces, 5},
    {field_interfaces, 6},
    {field_interfaces, 7},
    {field_name, 2},
    {field_superclass, 3},
    {field_superclass, 4},
  [351] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
  [355] =
    {field_body, 7},
    {field_name, 3},
    {field_supertype, 4},
    {field_supertype, 5},
  [359] =
    {field_name, 3},
    {field_supertype, 4},
    {field_supertype, 5},
    {field_supertype, 6},
  [363] =
    {field_body, 8},
    {field_name, 4},
    {field_return_type, 7},
  [366] =
    {field_body, 8},
    {field_name, 4},
    {field_parameters, 6},
  [369] =
    {field_body, 8},
    {field_interfaces, 6},
    {field_interfaces, 7},
    {field_name, 3},
    {field_superclass, 4},
    {field_superclass, 5},
  [375] =
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
  [378] =
    {field_name, 2},
    {field_return_type, 5},
  [380] =
    {field_name, 2},
    {field_parameters, 4},
  [382] =
    {field_body, 8},
    {field_name, 3},
    {field_supertype, 4},
    {field_supertype, 5},
    {field_supertype, 6},
  [387] =
    {field_body, 9},
    {field_name, 4},
    {field_parameters, 6},
    {field_return_type, 8},
  [391] =
    {field_body, 9},
    {field_interfaces, 6},
    {field_interfaces, 7},
    {field_interfaces, 8},
    {field_name, 3},
    {field_superclass, 4},
    {field_superclass, 5},
  [398] =
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
  [401] =
    {field_name, 3},
    {field_return_type, 6},
  [403] =
    {field_name, 3},
    {field_parameters, 5},
  [405] =
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 7,
  [9] = 7,
  [10] = 7,
  [11] = 11,
  [12] = 12,
  [13] = 12,
  [14] = 14,
  [15] = 12,
  [16] = 14,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 19,
  [22] = 22,
  [23] = 18,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 24,
  [28] = 25,
  [29] = 11,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 33,
  [36] = 34,
  [37] = 26,
  [38] = 22,
  [39] = 20,
  [40] = 30,
  [41] = 31,
  [42] = 14,
  [43] = 32,
  [44] = 12,
  [45] = 4,
  [46] = 46,
  [47] = 14,
  [48] = 32,
  [49] = 49,
  [50] = 34,
  [51] = 14,
  [52] = 17,
  [53] = 12,
  [54] = 33,
  [55] = 18,
  [56] = 19,
  [57] = 49,
  [58] = 11,
  [59] = 26,
  [60] = 31,
  [61] = 22,
  [62] = 30,
  [63] = 20,
  [64] = 14,
  [65] = 24,
  [66] = 14,
  [67] = 25,
  [68] = 17,
  [69] = 12,
  [70] = 12,
  [71] = 49,
  [72] = 72,
  [73] = 72,
  [74] = 74,
  [75] = 75,
  [76] = 72,
  [77] = 74,
  [78] = 75,
  [79] = 74,
  [80] = 75,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 84,
  [89] = 89,
  [90] = 90,
  [91] = 90,
  [92] = 92,
  [93] = 93,
  [94] = 83,
  [95] = 95,
  [96] = 85,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 97,
  [109] = 109,
  [110] = 86,
  [111] = 85,
  [112] = 83,
  [113] = 92,
  [114] = 89,
  [115] = 84,
  [116] = 95,
  [117] = 117,
  [118] = 86,
  [119] = 97,
  [120] = 107,
  [121] = 87,
  [122] = 122,
  [123] = 90,
  [124] = 93,
  [125] = 99,
  [126] = 109,
  [127] = 127,
  [128] = 128,
  [129] = 81,
  [130] = 98,
  [131] = 100,
  [132] = 132,
  [133] = 127,
  [134] = 101,
  [135] = 122,
  [136] = 109,
  [137] = 128,
  [138] = 93,
  [139] = 102,
  [140] = 107,
  [141] = 132,
  [142] = 99,
  [143] = 105,
  [144] = 104,
  [145] = 103,
  [146] = 106,
  [147] = 98,
  [148] = 103,
  [149] = 117,
  [150] = 89,
  [151] = 105,
  [152] = 106,
  [153] = 104,
  [154] = 95,
  [155] = 100,
  [156] = 117,
  [157] = 122,
  [158] = 127,
  [159] = 132,
  [160] = 81,
  [161] = 128,
  [162] = 102,
  [163] = 87,
  [164] = 101,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 170,
  [173] = 167,
  [174] = 169,
  [175] = 168,
  [176] = 165,
  [177] = 166,
  [178] = 171,
  [179] = 166,
  [180] = 169,
  [181] = 170,
  [182] = 167,
  [183] = 171,
  [184] = 184,
  [185] = 184,
  [186] = 184,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 187,
  [192] = 188,
  [193] = 193,
  [194] = 194,
  [195] = 168,
  [196] = 165,
  [197] = 190,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 165,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 168,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 168,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 165,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 198,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 193,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 201,
  [550] = 532,
  [551] = 419,
  [552] = 466,
  [553] = 465,
  [554] = 405,
  [555] = 404,
  [556] = 462,
  [557] = 557,
  [558] = 511,
  [559] = 510,
  [560] = 461,
  [561] = 460,
  [562] = 520,
  [563] = 467,
  [564] = 403,
  [565] = 401,
  [566] = 400,
  [567] = 459,
  [568] = 457,
  [569] = 398,
  [570] = 396,
  [571] = 395,
  [572] = 393,
  [573] = 392,
  [574] = 391,
  [575] = 390,
  [576] = 389,
  [577] = 388,
  [578] = 387,
  [579] = 386,
  [580] = 385,
  [581] = 383,
  [582] = 382,
  [583] = 381,
  [584] = 380,
  [585] = 379,
  [586] = 378,
  [587] = 377,
  [588] = 376,
  [589] = 373,
  [590] = 372,
  [591] = 371,
  [592] = 370,
  [593] = 369,
  [594] = 368,
  [595] = 367,
  [596] = 366,
  [597] = 365,
  [598] = 364,
  [599] = 363,
  [600] = 362,
  [601] = 361,
  [602] = 360,
  [603] = 359,
  [604] = 357,
  [605] = 356,
  [606] = 355,
  [607] = 354,
  [608] = 468,
  [609] = 456,
  [610] = 455,
  [611] = 470,
  [612] = 348,
  [613] = 509,
  [614] = 346,
  [615] = 557,
  [616] = 453,
  [617] = 521,
  [618] = 343,
  [619] = 471,
  [620] = 452,
  [621] = 341,
  [622] = 340,
  [623] = 508,
  [624] = 476,
  [625] = 339,
  [626] = 477,
  [627] = 449,
  [628] = 338,
  [629] = 337,
  [630] = 448,
  [631] = 447,
  [632] = 336,
  [633] = 445,
  [634] = 634,
  [635] = 335,
  [636] = 334,
  [637] = 332,
  [638] = 443,
  [639] = 519,
  [640] = 440,
  [641] = 331,
  [642] = 479,
  [643] = 439,
  [644] = 438,
  [645] = 437,
  [646] = 435,
  [647] = 480,
  [648] = 506,
  [649] = 330,
  [650] = 329,
  [651] = 505,
  [652] = 327,
  [653] = 326,
  [654] = 325,
  [655] = 324,
  [656] = 323,
  [657] = 322,
  [658] = 321,
  [659] = 320,
  [660] = 319,
  [661] = 317,
  [662] = 316,
  [663] = 315,
  [664] = 314,
  [665] = 313,
  [666] = 312,
  [667] = 311,
  [668] = 310,
  [669] = 309,
  [670] = 308,
  [671] = 307,
  [672] = 306,
  [673] = 305,
  [674] = 304,
  [675] = 303,
  [676] = 302,
  [677] = 301,
  [678] = 300,
  [679] = 299,
  [680] = 298,
  [681] = 296,
  [682] = 295,
  [683] = 294,
  [684] = 293,
  [685] = 292,
  [686] = 291,
  [687] = 290,
  [688] = 289,
  [689] = 288,
  [690] = 287,
  [691] = 286,
  [692] = 285,
  [693] = 284,
  [694] = 283,
  [695] = 282,
  [696] = 281,
  [697] = 280,
  [698] = 279,
  [699] = 278,
  [700] = 277,
  [701] = 276,
  [702] = 275,
  [703] = 202,
  [704] = 273,
  [705] = 272,
  [706] = 271,
  [707] = 270,
  [708] = 269,
  [709] = 268,
  [710] = 267,
  [711] = 266,
  [712] = 265,
  [713] = 264,
  [714] = 263,
  [715] = 262,
  [716] = 261,
  [717] = 260,
  [718] = 259,
  [719] = 255,
  [720] = 254,
  [721] = 253,
  [722] = 252,
  [723] = 251,
  [724] = 250,
  [725] = 249,
  [726] = 248,
  [727] = 247,
  [728] = 246,
  [729] = 245,
  [730] = 244,
  [731] = 243,
  [732] = 241,
  [733] = 240,
  [734] = 239,
  [735] = 238,
  [736] = 237,
  [737] = 236,
  [738] = 235,
  [739] = 234,
  [740] = 233,
  [741] = 232,
  [742] = 231,
  [743] = 230,
  [744] = 229,
  [745] = 228,
  [746] = 227,
  [747] = 226,
  [748] = 432,
  [749] = 483,
  [750] = 223,
  [751] = 222,
  [752] = 221,
  [753] = 220,
  [754] = 219,
  [755] = 218,
  [756] = 217,
  [757] = 216,
  [758] = 215,
  [759] = 214,
  [760] = 213,
  [761] = 212,
  [762] = 211,
  [763] = 210,
  [764] = 209,
  [765] = 208,
  [766] = 207,
  [767] = 206,
  [768] = 205,
  [769] = 484,
  [770] = 485,
  [771] = 204,
  [772] = 407,
  [773] = 375,
  [774] = 411,
  [775] = 489,
  [776] = 225,
  [777] = 242,
  [778] = 431,
  [779] = 256,
  [780] = 430,
  [781] = 257,
  [782] = 258,
  [783] = 427,
  [784] = 274,
  [785] = 490,
  [786] = 492,
  [787] = 224,
  [788] = 493,
  [789] = 421,
  [790] = 318,
  [791] = 495,
  [792] = 333,
  [793] = 496,
  [794] = 168,
  [795] = 418,
  [796] = 417,
  [797] = 416,
  [798] = 425,
  [799] = 413,
  [800] = 557,
  [801] = 342,
  [802] = 344,
  [803] = 345,
  [804] = 347,
  [805] = 349,
  [806] = 350,
  [807] = 351,
  [808] = 352,
  [809] = 353,
  [810] = 358,
  [811] = 374,
  [812] = 203,
  [813] = 384,
  [814] = 394,
  [815] = 397,
  [816] = 399,
  [817] = 402,
  [818] = 406,
  [819] = 408,
  [820] = 409,
  [821] = 410,
  [822] = 414,
  [823] = 412,
  [824] = 420,
  [825] = 297,
  [826] = 423,
  [827] = 424,
  [828] = 428,
  [829] = 429,
  [830] = 433,
  [831] = 434,
  [832] = 436,
  [833] = 441,
  [834] = 442,
  [835] = 446,
  [836] = 450,
  [837] = 451,
  [838] = 454,
  [839] = 458,
  [840] = 464,
  [841] = 469,
  [842] = 472,
  [843] = 473,
  [844] = 474,
  [845] = 475,
  [846] = 478,
  [847] = 481,
  [848] = 482,
  [849] = 486,
  [850] = 487,
  [851] = 488,
  [852] = 491,
  [853] = 494,
  [854] = 497,
  [855] = 500,
  [856] = 504,
  [857] = 507,
  [858] = 512,
  [859] = 513,
  [860] = 514,
  [861] = 515,
  [862] = 516,
  [863] = 517,
  [864] = 518,
  [865] = 522,
  [866] = 523,
  [867] = 524,
  [868] = 525,
  [869] = 527,
  [870] = 528,
  [871] = 529,
  [872] = 530,
  [873] = 531,
  [874] = 415,
  [875] = 533,
  [876] = 534,
  [877] = 535,
  [878] = 536,
  [879] = 537,
  [880] = 538,
  [881] = 539,
  [882] = 540,
  [883] = 541,
  [884] = 499,
  [885] = 543,
  [886] = 544,
  [887] = 501,
  [888] = 545,
  [889] = 165,
  [890] = 426,
  [891] = 547,
  [892] = 546,
  [893] = 503,
  [894] = 894,
  [895] = 894,
  [896] = 896,
  [897] = 897,
  [898] = 897,
  [899] = 896,
  [900] = 900,
  [901] = 897,
  [902] = 894,
  [903] = 903,
  [904] = 896,
  [905] = 905,
  [906] = 906,
  [907] = 900,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 911,
  [916] = 914,
  [917] = 909,
  [918] = 918,
  [919] = 911,
  [920] = 912,
  [921] = 913,
  [922] = 913,
  [923] = 909,
  [924] = 918,
  [925] = 912,
  [926] = 910,
  [927] = 918,
  [928] = 914,
  [929] = 910,
  [930] = 930,
  [931] = 931,
  [932] = 930,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 933,
  [938] = 938,
  [939] = 939,
  [940] = 931,
  [941] = 941,
  [942] = 933,
  [943] = 930,
  [944] = 941,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 953,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 954,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 951,
  [972] = 946,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 952,
  [980] = 980,
  [981] = 981,
  [982] = 976,
  [983] = 957,
  [984] = 984,
  [985] = 946,
  [986] = 958,
  [987] = 987,
  [988] = 988,
  [989] = 959,
  [990] = 962,
  [991] = 967,
  [992] = 954,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 970,
  [1001] = 951,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 952,
  [1005] = 993,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 949,
  [1009] = 981,
  [1010] = 961,
  [1011] = 1002,
  [1012] = 953,
  [1013] = 967,
  [1014] = 949,
  [1015] = 948,
  [1016] = 961,
  [1017] = 1017,
  [1018] = 976,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1020,
  [1022] = 1020,
  [1023] = 168,
  [1024] = 463,
  [1025] = 165,
  [1026] = 444,
  [1027] = 199,
  [1028] = 1028,
  [1029] = 900,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 194,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 200,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 167,
  [1081] = 171,
  [1082] = 166,
  [1083] = 169,
  [1084] = 170,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1096,
  [1103] = 1099,
  [1104] = 1104,
  [1105] = 1104,
  [1106] = 1096,
  [1107] = 1100,
  [1108] = 1104,
  [1109] = 1100,
  [1110] = 1101,
  [1111] = 1111,
  [1112] = 1099,
  [1113] = 1101,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1114,
  [1117] = 1117,
  [1118] = 1114,
  [1119] = 1119,
  [1120] = 1119,
  [1121] = 1119,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1125,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1122,
  [1132] = 1132,
  [1133] = 1124,
  [1134] = 1126,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1132,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1136,
  [1142] = 1142,
  [1143] = 1140,
  [1144] = 1123,
  [1145] = 1123,
  [1146] = 1146,
  [1147] = 1137,
  [1148] = 1130,
  [1149] = 1127,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 1140,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 1122,
  [1157] = 1157,
  [1158] = 1135,
  [1159] = 1150,
  [1160] = 1139,
  [1161] = 1157,
  [1162] = 1151,
  [1163] = 1125,
  [1164] = 1150,
  [1165] = 1157,
  [1166] = 1142,
  [1167] = 1129,
  [1168] = 1142,
  [1169] = 1155,
  [1170] = 1135,
  [1171] = 1171,
  [1172] = 505,
  [1173] = 521,
  [1174] = 1174,
  [1175] = 1174,
  [1176] = 1174,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1183,
  [1186] = 1184,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1191,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1202,
  [1204] = 1198,
  [1205] = 1199,
  [1206] = 1206,
  [1207] = 1200,
  [1208] = 1208,
  [1209] = 1194,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1193,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1195,
  [1217] = 1217,
  [1218] = 1211,
  [1219] = 1219,
  [1220] = 1196,
  [1221] = 1208,
  [1222] = 1212,
  [1223] = 1208,
  [1224] = 1206,
  [1225] = 1225,
  [1226] = 1197,
  [1227] = 1201,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1214,
  [1231] = 1229,
  [1232] = 1232,
  [1233] = 1194,
  [1234] = 1232,
  [1235] = 1219,
  [1236] = 1236,
  [1237] = 1215,
  [1238] = 199,
  [1239] = 1217,
  [1240] = 1240,
  [1241] = 1241,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1249,
  [1258] = 1241,
  [1259] = 1255,
  [1260] = 1260,
  [1261] = 1253,
  [1262] = 1251,
  [1263] = 1263,
  [1264] = 1250,
  [1265] = 1265,
  [1266] = 1255,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1250,
  [1271] = 1244,
  [1272] = 1272,
  [1273] = 1242,
  [1274] = 1268,
  [1275] = 1263,
  [1276] = 1253,
  [1277] = 1251,
  [1278] = 1272,
  [1279] = 1272,
  [1280] = 1245,
  [1281] = 199,
  [1282] = 1267,
  [1283] = 1283,
  [1284] = 1269,
  [1285] = 1249,
  [1286] = 1240,
  [1287] = 1287,
  [1288] = 1241,
  [1289] = 1243,
  [1290] = 1240,
  [1291] = 1250,
  [1292] = 1254,
  [1293] = 1263,
  [1294] = 1256,
  [1295] = 1245,
  [1296] = 1242,
  [1297] = 1297,
  [1298] = 1248,
  [1299] = 1269,
  [1300] = 1244,
  [1301] = 1260,
  [1302] = 1265,
  [1303] = 1267,
  [1304] = 1297,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1313,
  [1318] = 1316,
  [1319] = 1316,
  [1320] = 1306,
  [1321] = 1307,
  [1322] = 1309,
  [1323] = 1323,
  [1324] = 1316,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1323,
  [1328] = 1328,
  [1329] = 1311,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1306,
  [1334] = 1306,
  [1335] = 1325,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 463,
  [1340] = 194,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 444,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1338,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 200,
  [1356] = 1356,
  [1357] = 1353,
  [1358] = 1354,
  [1359] = 1359,
  [1360] = 1349,
  [1361] = 1352,
  [1362] = 1348,
  [1363] = 1352,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1359,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1344,
  [1371] = 1342,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1341,
  [1375] = 1375,
  [1376] = 1346,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1343,
  [1380] = 1347,
  [1381] = 1366,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1356,
  [1388] = 1388,
  [1389] = 1342,
  [1390] = 1351,
  [1391] = 1364,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1365,
  [1395] = 1395,
  [1396] = 1395,
  [1397] = 1384,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1369,
  [1404] = 1352,
  [1405] = 1392,
  [1406] = 1388,
  [1407] = 1407,
  [1408] = 1359,
  [1409] = 1359,
  [1410] = 1386,
  [1411] = 1377,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1412,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1068,
  [1421] = 1070,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1428,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1429,
  [1450] = 1436,
  [1451] = 1451,
  [1452] = 201,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1415,
  [1458] = 1419,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1451,
  [1462] = 1426,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1440,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 548,
  [1484] = 1442,
  [1485] = 1485,
  [1486] = 1419,
  [1487] = 1423,
  [1488] = 1426,
  [1489] = 1436,
  [1490] = 1444,
  [1491] = 1471,
  [1492] = 1472,
  [1493] = 1493,
  [1494] = 1471,
  [1495] = 1485,
  [1496] = 1496,
  [1497] = 1423,
  [1498] = 1498,
  [1499] = 1472,
  [1500] = 1418,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1507,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1507,
  [1514] = 1506,
  [1515] = 1512,
  [1516] = 1511,
  [1517] = 1517,
  [1518] = 1510,
  [1519] = 1053,
  [1520] = 1520,
  [1521] = 1509,
  [1522] = 1504,
  [1523] = 1523,
  [1524] = 1502,
  [1525] = 1525,
  [1526] = 1505,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1503,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1501,
  [1539] = 1539,
  [1540] = 1517,
  [1541] = 1504,
  [1542] = 1520,
  [1543] = 1536,
  [1544] = 1544,
  [1545] = 1501,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1548,
  [1549] = 1508,
  [1550] = 1550,
  [1551] = 1523,
  [1552] = 1529,
  [1553] = 1544,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1066,
  [1557] = 1505,
  [1558] = 1525,
  [1559] = 1506,
  [1560] = 1507,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1527,
  [1564] = 1555,
  [1565] = 1537,
  [1566] = 1566,
  [1567] = 1031,
  [1568] = 1554,
  [1569] = 1536,
  [1570] = 1570,
  [1571] = 1536,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1546,
  [1576] = 1576,
  [1577] = 1050,
  [1578] = 1532,
  [1579] = 1579,
  [1580] = 1572,
  [1581] = 1579,
  [1582] = 1582,
  [1583] = 1548,
  [1584] = 1584,
  [1585] = 1531,
  [1586] = 1586,
  [1587] = 1586,
  [1588] = 1528,
  [1589] = 1574,
  [1590] = 1501,
  [1591] = 1045,
  [1592] = 1573,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1599,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1604,
  [1609] = 1606,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1606,
  [1614] = 1614,
  [1615] = 1596,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1602,
  [1620] = 1620,
  [1621] = 1618,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1610,
  [1625] = 1625,
  [1626] = 1610,
  [1627] = 1627,
  [1628] = 1618,
  [1629] = 1629,
  [1630] = 1625,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1611,
  [1634] = 1634,
  [1635] = 1629,
  [1636] = 1631,
  [1637] = 1637,
  [1638] = 1638,
  [1639] = 1638,
  [1640] = 1640,
  [1641] = 1641,
  [1642] = 1642,
  [1643] = 1643,
  [1644] = 1644,
  [1645] = 1645,
  [1646] = 1641,
  [1647] = 1647,
  [1648] = 1601,
  [1649] = 1649,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1653,
  [1654] = 1654,
  [1655] = 1600,
  [1656] = 1617,
  [1657] = 1600,
  [1658] = 1658,
  [1659] = 1659,
  [1660] = 1660,
  [1661] = 1637,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1658,
  [1669] = 1669,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 1600,
  [1673] = 1622,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1659,
  [1677] = 1597,
  [1678] = 1662,
  [1679] = 1623,
  [1680] = 1680,
  [1681] = 1671,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1683,
  [1690] = 1620,
  [1691] = 1627,
  [1692] = 1692,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1671,
  [1697] = 1614,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1666,
  [1701] = 1603,
  [1702] = 1644,
  [1703] = 1595,
  [1704] = 1680,
  [1705] = 1705,
  [1706] = 1650,
  [1707] = 1598,
  [1708] = 1708,
  [1709] = 1680,
  [1710] = 1663,
  [1711] = 1663,
  [1712] = 1634,
  [1713] = 1713,
  [1714] = 1634,
  [1715] = 1664,
  [1716] = 1640,
  [1717] = 1717,
  [1718] = 1713,
  [1719] = 1663,
  [1720] = 1593,
  [1721] = 1687,
  [1722] = 1594,
  [1723] = 1723,
  [1724] = 1644,
  [1725] = 1669,
  [1726] = 1693,
  [1727] = 1616,
  [1728] = 1728,
  [1729] = 1717,
  [1730] = 1645,
  [1731] = 1686,
  [1732] = 1732,
  [1733] = 1670,
  [1734] = 1734,
  [1735] = 1686,
  [1736] = 1665,
  [1737] = 1698,
  [1738] = 1614,
  [1739] = 1603,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1713,
  [1743] = 1728,
  [1744] = 1688,
  [1745] = 1594,
  [1746] = 1669,
  [1747] = 1728,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < 'a'
                  ? (c >= '#' && c <= '_')
                  : (c <= 'z' || c == 167))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1162
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6576
    ? (c < 2974
      ? (c < 2208
        ? (c < 1369
          ? (c < 748
            ? (c < 181
              ? (c < 'a'
                ? (c < '@'
                  ? (c >= '#' && c <= '$')
                  : (c <= 'Z' || c == '_'))
                : (c <= 'z' || (c < 170
                  ? c == 167
                  : c <= 170)))
              : (c <= 181 || (c < 248
                ? (c < 192
                  ? c == 186
                  : (c <= 214 || (c >= 216 && c <= 246)))
                : (c <= 705 || (c < 736
                  ? (c >= 710 && c <= 721)
                  : c <= 740)))))
            : (c <= 748 || (c < 904
              ? (c < 890
                ? (c < 880
                  ? c == 750
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 902
                  ? c == 895
                  : c <= 902)))
              : (c <= 906 || (c < 1015
                ? (c < 910
                  ? c == 908
                  : (c <= 929 || (c >= 931 && c <= 1013)))
                : (c <= 1153 || (c < 1329
                  ? (c >= 1162 && c <= 1327)
                  : c <= 1366)))))))
          : (c <= 1369 || (c < 1869
            ? (c < 1749
              ? (c < 1568
                ? (c < 1488
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 1514 || (c >= 1519 && c <= 1522)))
                : (c <= 1610 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1791
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1810
                  ? c == 1808
                  : c <= 1839)))))
            : (c <= 1957 || (c < 2084
              ? (c < 2042
                ? (c < 1994
                  ? c == 1969
                  : (c <= 2026 || (c >= 2036 && c <= 2037)))
                : (c <= 2042 || (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : c <= 2074)))
              : (c <= 2084 || (c < 2144
                ? (c < 2112
                  ? c == 2088
                  : c <= 2136)
                : (c <= 2154 || (c < 2185
                  ? (c >= 2160 && c <= 2183)
                  : c <= 2190)))))))))
        : (c <= 2249 || (c < 2674
          ? (c < 2524
            ? (c < 2447
              ? (c < 2392
                ? (c < 2365
                  ? (c >= 2308 && c <= 2361)
                  : (c <= 2365 || c == 2384))
                : (c <= 2401 || (c < 2437
                  ? (c >= 2417 && c <= 2432)
                  : c <= 2444)))
              : (c <= 2448 || (c < 2486
                ? (c < 2474
                  ? (c >= 2451 && c <= 2472)
                  : (c <= 2480 || c == 2482))
                : (c <= 2489 || (c < 2510
                  ? c == 2493
                  : c <= 2510)))))
            : (c <= 2525 || (c < 2602
              ? (c < 2565
                ? (c < 2544
                  ? (c >= 2527 && c <= 2529)
                  : (c <= 2545 || c == 2556))
                : (c <= 2570 || (c < 2579
                  ? (c >= 2575 && c <= 2576)
                  : c <= 2600)))
              : (c <= 2608 || (c < 2616
                ? (c < 2613
                  ? (c >= 2610 && c <= 2611)
                  : c <= 2614)
                : (c <= 2617 || (c < 2654
                  ? (c >= 2649 && c <= 2652)
                  : c <= 2654)))))))
          : (c <= 2676 || (c < 2858
            ? (c < 2749
              ? (c < 2730
                ? (c < 2703
                  ? (c >= 2693 && c <= 2701)
                  : (c <= 2705 || (c >= 2707 && c <= 2728)))
                : (c <= 2736 || (c < 2741
                  ? (c >= 2738 && c <= 2739)
                  : c <= 2745)))
              : (c <= 2749 || (c < 2821
                ? (c < 2784
                  ? c == 2768
                  : (c <= 2785 || c == 2809))
                : (c <= 2828 || (c < 2835
                  ? (c >= 2831 && c <= 2832)
                  : c <= 2856)))))
            : (c <= 2864 || (c < 2947
              ? (c < 2908
                ? (c < 2869
                  ? (c >= 2866 && c <= 2867)
                  : (c <= 2873 || c == 2877))
                : (c <= 2909 || (c < 2929
                  ? (c >= 2911 && c <= 2913)
                  : c <= 2929)))
              : (c <= 2947 || (c < 2962
                ? (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : c <= 2960)
                : (c <= 2965 || (c < 2972
                  ? (c >= 2969 && c <= 2970)
                  : c <= 2972)))))))))))
      : (c <= 2975 || (c < 4096
        ? (c < 3406
          ? (c < 3205
            ? (c < 3090
              ? (c < 3024
                ? (c < 2984
                  ? (c >= 2979 && c <= 2980)
                  : (c <= 2986 || (c >= 2990 && c <= 3001)))
                : (c <= 3024 || (c < 3086
                  ? (c >= 3077 && c <= 3084)
                  : c <= 3088)))
              : (c <= 3112 || (c < 3165
                ? (c < 3133
                  ? (c >= 3114 && c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))
                : (c <= 3165 || (c < 3200
                  ? (c >= 3168 && c <= 3169)
                  : c <= 3200)))))
            : (c <= 3212 || (c < 3296
              ? (c < 3253
                ? (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))
                : (c <= 3257 || (c < 3293
                  ? c == 3261
                  : c <= 3294)))
              : (c <= 3297 || (c < 3342
                ? (c < 3332
                  ? (c >= 3313 && c <= 3314)
                  : c <= 3340)
                : (c <= 3344 || (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)))))))
          : (c <= 3406 || (c < 3718
            ? (c < 3517
              ? (c < 3461
                ? (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : (c <= 3425 || (c >= 3450 && c <= 3455)))
                : (c <= 3478 || (c < 3507
                  ? (c >= 3482 && c <= 3505)
                  : c <= 3515)))
              : (c <= 3517 || (c < 3648
                ? (c < 3585
                  ? (c >= 3520 && c <= 3526)
                  : (c <= 3632 || (c >= 3634 && c <= 3635)))
                : (c <= 3654 || (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : c <= 3716)))))
            : (c <= 3722 || (c < 3782
              ? (c < 3762
                ? (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : (c <= 3749 || (c >= 3751 && c <= 3760)))
                : (c <= 3763 || (c < 3776
                  ? c == 3773
                  : c <= 3780)))
              : (c <= 3782 || (c < 3904
                ? (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)
                : (c <= 3911 || (c < 3976
                  ? (c >= 3913 && c <= 3948)
                  : c <= 3980)))))))))
        : (c <= 4138 || (c < 4882
          ? (c < 4682
            ? (c < 4213
              ? (c < 4193
                ? (c < 4176
                  ? c == 4159
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))
                : (c <= 4193 || (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : c <= 4208)))
              : (c <= 4225 || (c < 4301
                ? (c < 4256
                  ? c == 4238
                  : (c <= 4293 || c == 4295))
                : (c <= 4301 || (c < 4348
                  ? (c >= 4304 && c <= 4346)
                  : c <= 4680)))))
            : (c <= 4685 || (c < 4786
              ? (c < 4704
                ? (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : (c <= 4696 || (c >= 4698 && c <= 4701)))
                : (c <= 4744 || (c < 4752
                  ? (c >= 4746 && c <= 4749)
                  : c <= 4784)))
              : (c <= 4789 || (c < 4802
                ? (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)
                : (c <= 4805 || (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : c <= 4880)))))))
          : (c <= 4885 || (c < 5998
            ? (c < 5761
              ? (c < 5112
                ? (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : (c <= 5007 || (c >= 5024 && c <= 5109)))
                : (c <= 5117 || (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : c <= 5759)))
              : (c <= 5786 || (c < 5919
                ? (c < 5873
                  ? (c >= 5792 && c <= 5866)
                  : (c <= 5880 || (c >= 5888 && c <= 5905)))
                : (c <= 5937 || (c < 5984
                  ? (c >= 5952 && c <= 5969)
                  : c <= 5996)))))
            : (c <= 6000 || (c < 6314
              ? (c < 6176
                ? (c < 6103
                  ? (c >= 6016 && c <= 6067)
                  : (c <= 6103 || c == 6108))
                : (c <= 6264 || (c < 6279
                  ? (c >= 6272 && c <= 6276)
                  : c <= 6312)))
              : (c <= 6314 || (c < 6480
                ? (c < 6400
                  ? (c >= 6320 && c <= 6389)
                  : c <= 6430)
                : (c <= 6509 || (c < 6528
                  ? (c >= 6512 && c <= 6516)
                  : c <= 6571)))))))))))))
    : (c <= 6601 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7357
            ? (c < 7086
              ? (c < 6917
                ? (c < 6688
                  ? (c >= 6656 && c <= 6678)
                  : (c <= 6740 || c == 6823))
                : (c <= 6963 || (c < 7043
                  ? (c >= 6981 && c <= 6988)
                  : c <= 7072)))
              : (c <= 7087 || (c < 7258
                ? (c < 7168
                  ? (c >= 7098 && c <= 7141)
                  : (c <= 7203 || (c >= 7245 && c <= 7247)))
                : (c <= 7293 || (c < 7312
                  ? (c >= 7296 && c <= 7304)
                  : c <= 7354)))))
            : (c <= 7359 || (c < 7960
              ? (c < 7418
                ? (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7680
                  ? (c >= 7424 && c <= 7615)
                  : c <= 7957)))
              : (c <= 7965 || (c < 8025
                ? (c < 8008
                  ? (c >= 7968 && c <= 8005)
                  : (c <= 8013 || (c >= 8016 && c <= 8023)))
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < 167
                ? (c < '@'
                  ? (c >= '#' && c <= '$')
                  : (c <= 'Z' || c == '_'))
                : (c <= 167 || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < 167
                ? (c < '_'
                  ? (c >= '#' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 167 || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_5(int32_t c) {
  return (c < 6320
    ? (c < 2974
      ? (c < 2308
        ? (c < 1369
          ? (c < 748
            ? (c < 181
              ? (c < '_'
                ? (c < '0'
                  ? (c >= '#' && c <= '$')
                  : (c <= '9' || (c >= '@' && c <= 'Z')))
                : (c <= '_' || (c < 167
                  ? (c >= 'a' && c <= 'z')
                  : (c <= 167 || c == 170))))
              : (c <= 181 || (c < 248
                ? (c < 192
                  ? c == 186
                  : (c <= 214 || (c >= 216 && c <= 246)))
                : (c <= 705 || (c < 736
                  ? (c >= 710 && c <= 721)
                  : c <= 740)))))
            : (c <= 748 || (c < 904
              ? (c < 890
                ? (c < 880
                  ? c == 750
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 902
                  ? c == 895
                  : c <= 902)))
              : (c <= 906 || (c < 1015
                ? (c < 910
                  ? c == 908
                  : (c <= 929 || (c >= 931 && c <= 1013)))
                : (c <= 1153 || (c < 1329
                  ? (c >= 1162 && c <= 1327)
                  : c <= 1366)))))))
          : (c <= 1369 || (c < 1869
            ? (c < 1649
              ? (c < 1568
                ? (c < 1488
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 1514 || (c >= 1519 && c <= 1522)))
                : (c <= 1610 || (c < 1646
                  ? (c >= 1632 && c <= 1641)
                  : c <= 1647)))
              : (c <= 1747 || (c < 1791
                ? (c < 1765
                  ? c == 1749
                  : (c <= 1766 || (c >= 1774 && c <= 1788)))
                : (c <= 1791 || (c < 1810
                  ? c == 1808
                  : c <= 1839)))))
            : (c <= 1957 || (c < 2084
              ? (c < 2042
                ? (c < 1984
                  ? c == 1969
                  : (c <= 2026 || (c >= 2036 && c <= 2037)))
                : (c <= 2042 || (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : c <= 2074)))
              : (c <= 2084 || (c < 2160
                ? (c < 2112
                  ? c == 2088
                  : (c <= 2136 || (c >= 2144 && c <= 2154)))
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2406
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2415 || (c < 2437
                  ? (c >= 2417 && c <= 2432)
                  : (c <= 2444 || (c >= 2447 && c <= 2448)))))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2534 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2654
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : (c <= 2617 || (c >= 2649 && c <= 2652)))
                : (c <= 2654 || (c < 2674
                  ? (c >= 2662 && c <= 2671)
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2858
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2821
                ? (c < 2790
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2799 || c == 2809))
                : (c <= 2828 || (c < 2835
                  ? (c >= 2831 && c <= 2832)
                  : c <= 2856)))))
            : (c <= 2864 || (c < 2929
              ? (c < 2908
                ? (c < 2869
                  ? (c >= 2866 && c <= 2867)
                  : (c <= 2873 || c == 2877))
                : (c <= 2909 || (c < 2918
                  ? (c >= 2911 && c <= 2913)
                  : c <= 2927)))
              : (c <= 2929 || (c < 2962
                ? (c < 2949
                  ? c == 2947
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))
                : (c <= 2965 || (c < 2972
                  ? (c >= 2969 && c <= 2970)
                  : c <= 2972)))))))))))
      : (c <= 2975 || (c < 3840
        ? (c < 3389
          ? (c < 3200
            ? (c < 3090
              ? (c < 3024
                ? (c < 2984
                  ? (c >= 2979 && c <= 2980)
                  : (c <= 2986 || (c >= 2990 && c <= 3001)))
                : (c <= 3024 || (c < 3077
                  ? (c >= 3046 && c <= 3055)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3165
                ? (c < 3133
                  ? (c >= 3114 && c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))
                : (c <= 3165 || (c < 3174
                  ? (c >= 3168 && c <= 3169)
                  : c <= 3183)))))
            : (c <= 3200 || (c < 3293
              ? (c < 3242
                ? (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))
                : (c <= 3251 || (c < 3261
                  ? (c >= 3253 && c <= 3257)
                  : c <= 3261)))
              : (c <= 3294 || (c < 3332
                ? (c < 3302
                  ? (c >= 3296 && c <= 3297)
                  : (c <= 3311 || (c >= 3313 && c <= 3314)))
                : (c <= 3340 || (c < 3346
                  ? (c >= 3342 && c <= 3344)
                  : c <= 3386)))))))
          : (c <= 3389 || (c < 3648
            ? (c < 3482
              ? (c < 3430
                ? (c < 3412
                  ? c == 3406
                  : (c <= 3414 || (c >= 3423 && c <= 3425)))
                : (c <= 3439 || (c < 3461
                  ? (c >= 3450 && c <= 3455)
                  : c <= 3478)))
              : (c <= 3505 || (c < 3558
                ? (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : (c <= 3517 || (c >= 3520 && c <= 3526)))
                : (c <= 3567 || (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : c <= 3635)))))
            : (c <= 3654 || (c < 3751
              ? (c < 3718
                ? (c < 3713
                  ? (c >= 3664 && c <= 3673)
                  : (c <= 3714 || c == 3716))
                : (c <= 3722 || (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : c <= 3749)))
              : (c <= 3760 || (c < 3782
                ? (c < 3773
                  ? (c >= 3762 && c <= 3763)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))
                : (c <= 3782 || (c < 3804
                  ? (c >= 3792 && c <= 3801)
                  : c <= 3807)))))))))
        : (c <= 3840 || (c < 4800
          ? (c < 4256
            ? (c < 4186
              ? (c < 3976
                ? (c < 3904
                  ? (c >= 3872 && c <= 3881)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4159
                  ? (c >= 4096 && c <= 4138)
                  : (c <= 4169 || (c >= 4176 && c <= 4181)))))
              : (c <= 4189 || (c < 4213
                ? (c < 4197
                  ? c == 4193
                  : (c <= 4198 || (c >= 4206 && c <= 4208)))
                : (c <= 4225 || (c < 4240
                  ? c == 4238
                  : c <= 4249)))))
            : (c <= 4293 || (c < 4696
              ? (c < 4348
                ? (c < 4301
                  ? c == 4295
                  : (c <= 4301 || (c >= 4304 && c <= 4346)))
                : (c <= 4680 || (c < 4688
                  ? (c >= 4682 && c <= 4685)
                  : c <= 4694)))
              : (c <= 4696 || (c < 4752
                ? (c < 4704
                  ? (c >= 4698 && c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4792
                  ? (c >= 4786 && c <= 4789)
                  : c <= 4798)))))))
          : (c <= 4800 || (c < 5888
            ? (c < 5024
              ? (c < 4882
                ? (c < 4808
                  ? (c >= 4802 && c <= 4805)
                  : (c <= 4822 || (c >= 4824 && c <= 4880)))
                : (c <= 4885 || (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : c <= 5007)))
              : (c <= 5109 || (c < 5761
                ? (c < 5121
                  ? (c >= 5112 && c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))
                : (c <= 5786 || (c < 5873
                  ? (c >= 5792 && c <= 5866)
                  : c <= 5880)))))
            : (c <= 5905 || (c < 6108
              ? (c < 5998
                ? (c < 5952
                  ? (c >= 5919 && c <= 5937)
                  : (c <= 5969 || (c >= 5984 && c <= 5996)))
                : (c <= 6000 || (c < 6103
                  ? (c >= 6016 && c <= 6067)
                  : c <= 6103)))
              : (c <= 6108 || (c < 6272
                ? (c < 6160
                  ? (c >= 6112 && c <= 6121)
                  : (c <= 6169 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))))))))))))
    : (c <= 6389 || (c < 43138
      ? (c < 8488
        ? (c < 7960
          ? (c < 7043
            ? (c < 6688
              ? (c < 6528
                ? (c < 6470
                  ? (c >= 6400 && c <= 6430)
                  : (c <= 6509 || (c >= 6512 && c <= 6516)))
                : (c <= 6571 || (c < 6608
                  ? (c >= 6576 && c <= 6601)
                  : (c <= 6617 || (c >= 6656 && c <= 6678)))))
              : (c <= 6740 || (c < 6917
                ? (c < 6800
                  ? (c >= 6784 && c <= 6793)
                  : (c <= 6809 || c == 6823))
                : (c <= 6963 || (c < 6992
                  ? (c >= 6981 && c <= 6988)
                  : c <= 7001)))))
            : (c <= 7072 || (c < 7357
              ? (c < 7245
                ? (c < 7168
                  ? (c >= 7086 && c <= 7141)
                  : (c <= 7203 || (c >= 7232 && c <= 7241)))
                : (c <= 7293 || (c < 7312
                  ? (c >= 7296 && c <= 7304)
                  : c <= 7354)))
              : (c <= 7359 || (c < 7418
                ? (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7680
                  ? (c >= 7424 && c <= 7615)
                  : c <= 7957)))))))
          : (c <= 7965 || (c < 8150
            ? (c < 8031
              ? (c < 8025
                ? (c < 8008
                  ? (c >= 7968 && c <= 8005)
                  : (c <= 8013 || (c >= 8016 && c <= 8023)))
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))
              : (c <= 8061 || (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))))
            : (c <= 8155 || (c < 8450
              ? (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))
              : (c <= 8450 || (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))))))))
        : (c <= 8488 || (c < 12445
          ? (c < 11648
            ? (c < 11499
              ? (c < 8517
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : (c <= 8505 || (c >= 8508 && c <= 8511)))
                : (c <= 8521 || (c < 8579
                  ? c == 8526
                  : (c <= 8580 || (c >= 11264 && c <= 11492)))))
              : (c <= 11502 || (c < 11565
                ? (c < 11520
                  ? (c >= 11506 && c <= 11507)
                  : (c <= 11557 || c == 11559))
                : (c <= 11565 || (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : c <= 11631)))))
            : (c <= 11670 || (c < 11728
              ? (c < 11704
                ? (c < 11688
                  ? (c >= 11680 && c <= 11686)
                  : (c <= 11694 || (c >= 11696 && c <= 11702)))
                : (c <= 11710 || (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : c <= 11726)))
              : (c <= 11734 || (c < 12337
                ? (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : (c <= 11823 || (c >= 12293 && c <= 12294)))
                : (c <= 12341 || (c < 12353
                  ? (c >= 12347 && c <= 12348)
                  : c <= 12438)))))))
          : (c <= 12447 || (c < 42560
            ? (c < 13312
              ? (c < 12593
                ? (c < 12540
                  ? (c >= 12449 && c <= 12538)
                  : (c <= 12543 || (c >= 12549 && c <= 12591)))
                : (c <= 12686 || (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : c <= 12799)))
              : (c <= 13312 || (c < 42192
                ? (c < 19968
                  ? c == 19903
                  : (c <= 19968 || (c >= 40959 && c <= 42124)))
                : (c <= 42237 || (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : c <= 42539)))))
            : (c <= 42606 || (c < 42963
              ? (c < 42786
                ? (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : (c <= 42725 || (c >= 42775 && c <= 42783)))
                : (c <= 42888 || (c < 42960
                  ? (c >= 42891 && c <= 42954)
                  : c <= 42961)))
              : (c <= 42963 || (c < 43015
                ? (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : (c <= 43009 || (c >= 43011 && c <= 43013)))
                : (c <= 43018 || (c < 43072
                  ? (c >= 43020 && c <= 43042)
                  : c <= 43123)))))))))))
      : (c <= 43187 || (c < 65142
        ? (c < 43793
          ? (c < 43600
            ? (c < 43396
              ? (c < 43261
                ? (c < 43250
                  ? (c >= 43216 && c <= 43225)
                  : (c <= 43255 || c == 43259))
                : (c <= 43262 || (c < 43312
                  ? (c >= 43264 && c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))))
              : (c <= 43442 || (c < 43520
                ? (c < 43488
                  ? (c >= 43471 && c <= 43481)
                  : (c <= 43492 || (c >= 43494 && c <= 43518)))
                : (c <= 43560 || (c < 43588
                  ? (c >= 43584 && c <= 43586)
                  : c <= 43595)))))
            : (c <= 43609 || (c < 43712
              ? (c < 43697
                ? (c < 43642
                  ? (c >= 43616 && c <= 43638)
                  : (c <= 43642 || (c >= 43646 && c <= 43695)))
                : (c <= 43697 || (c < 43705
                  ? (c >= 43701 && c <= 43702)
                  : c <= 43709)))
              : (c <= 43712 || (c < 43762
                ? (c < 43739
                  ? c == 43714
                  : (c <= 43741 || (c >= 43744 && c <= 43754)))
                : (c <= 43764 || (c < 43785
                  ? (c >= 43777 && c <= 43782)
                  : c <= 43790)))))))
          : (c <= 43798 || (c < 64275
            ? (c < 44032
              ? (c < 43868
                ? (c < 43816
                  ? (c >= 43808 && c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))
                : (c <= 43881 || (c < 44016
                  ? (c >= 43888 && c <= 44002)
                  : c <= 44025)))
              : (c <= 44032 || (c < 63744
                ? (c < 55216
                  ? c == 55203
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64256
                  ? (c >= 64112 && c <= 64217)
                  : c <= 64262)))))
            : (c <= 64279 || (c < 64323
              ? (c < 64312
                ? (c < 64287
                  ? c == 64285
                  : (c <= 64296 || (c >= 64298 && c <= 64310)))
                : (c <= 64316 || (c < 64320
                  ? c == 64318
                  : c <= 64321)))
              : (c <= 64324 || (c < 64914
                ? (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))
                : (c <= 64967 || (c < 65136
                  ? (c >= 65008 && c <= 65019)
                  : c <= 65140)))))))))
        : (c <= 65276 || (c < 66816
          ? (c < 65664
            ? (c < 65498
              ? (c < 65382
                ? (c < 65313
                  ? (c >= 65296 && c <= 65305)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))
                : (c <= 65470 || (c < 65482
                  ? (c >= 65474 && c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))))
              : (c <= 65500 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : c <= 65629)))))
            : (c <= 65786 || (c < 66432
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66368 || (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)))
              : (c <= 66461 || (c < 66720
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : (c <= 66511 || (c >= 66560 && c <= 66717)))
                : (c <= 66729 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67463
            ? (c < 66979
              ? (c < 66956
                ? (c < 66928
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))
                : (c <= 66962 || (c < 66967
                  ? (c >= 66964 && c <= 66965)
                  : c <= 66977)))
              : (c <= 66993 || (c < 67392
                ? (c < 67003
                  ? (c >= 66995 && c <= 67001)
                  : (c <= 67004 || (c >= 67072 && c <= 67382)))
                : (c <= 67413 || (c < 67456
                  ? (c >= 67424 && c <= 67431)
                  : c <= 67461)))))
            : (c <= 67504 || (c < 67647
              ? (c < 67594
                ? (c < 67584
                  ? (c >= 67506 && c <= 67514)
                  : (c <= 67589 || c == 67592))
                : (c <= 67637 || (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : c <= 67644)))
              : (c <= 67669 || (c < 67828
                ? (c < 67712
                  ? (c >= 67680 && c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_6(int32_t c) {
  return (c < 6400
    ? (c < 2979
      ? (c < 2365
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < '_'
                ? (c < '0'
                  ? (c >= '#' && c <= '$')
                  : (c <= '9' || (c >= '@' && c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? c == 167
                  : (c <= 170 || c == 181))))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1749
              ? (c < 1632
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1641 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1808
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1984 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2185
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : (c <= 2154 || (c >= 2160 && c <= 2183)))
                : (c <= 2190 || (c < 2308
                  ? (c >= 2208 && c <= 2249)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2534
            ? (c < 2474
              ? (c < 2417
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2406 && c <= 2415)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : (c <= 2448 || (c >= 2451 && c <= 2472)))))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2662
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : (c <= 2652 || c == 2654))
                : (c <= 2671 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2866
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2831
                ? (c < 2809
                  ? (c >= 2790 && c <= 2799)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2947
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2929
                  ? (c >= 2918 && c <= 2927)
                  : c <= 2929)))
              : (c <= 2947 || (c < 2969
                ? (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : (c <= 2960 || (c >= 2962 && c <= 2965)))
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 3872
        ? (c < 3406
          ? (c < 3205
            ? (c < 3114
              ? (c < 3046
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3055 || (c < 3086
                  ? (c >= 3077 && c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3200
                  ? (c >= 3174 && c <= 3183)
                  : c <= 3200)))))
            : (c <= 3212 || (c < 3296
              ? (c < 3253
                ? (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))
                : (c <= 3257 || (c < 3293
                  ? c == 3261
                  : c <= 3294)))
              : (c <= 3297 || (c < 3342
                ? (c < 3313
                  ? (c >= 3302 && c <= 3311)
                  : (c <= 3314 || (c >= 3332 && c <= 3340)))
                : (c <= 3344 || (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)))))))
          : (c <= 3406 || (c < 3664
            ? (c < 3507
              ? (c < 3450
                ? (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : (c <= 3425 || (c >= 3430 && c <= 3439)))
                : (c <= 3455 || (c < 3482
                  ? (c >= 3461 && c <= 3478)
                  : c <= 3505)))
              : (c <= 3515 || (c < 3585
                ? (c < 3520
                  ? c == 3517
                  : (c <= 3526 || (c >= 3558 && c <= 3567)))
                : (c <= 3632 || (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : c <= 3654)))))
            : (c <= 3673 || (c < 3762
              ? (c < 3724
                ? (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3751
                  ? c == 3749
                  : c <= 3760)))
              : (c <= 3763 || (c < 3792
                ? (c < 3776
                  ? c == 3773
                  : (c <= 3780 || c == 3782))
                : (c <= 3801 || (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)))))))))
        : (c <= 3881 || (c < 4802
          ? (c < 4295
            ? (c < 4193
              ? (c < 4096
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))
                : (c <= 4138 || (c < 4176
                  ? (c >= 4159 && c <= 4169)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))
              : (c <= 4193 || (c < 4238
                ? (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : (c <= 4208 || (c >= 4213 && c <= 4225)))
                : (c <= 4238 || (c < 4256
                  ? (c >= 4240 && c <= 4249)
                  : c <= 4293)))))
            : (c <= 4295 || (c < 4698
              ? (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))
              : (c <= 4701 || (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))))))
          : (c <= 4805 || (c < 5919
            ? (c < 5112
              ? (c < 4888
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : (c <= 4880 || (c >= 4882 && c <= 4885)))
                : (c <= 4954 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : c <= 5109)))
              : (c <= 5117 || (c < 5792
                ? (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))
                : (c <= 5866 || (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : c <= 5905)))))
            : (c <= 5937 || (c < 6112
              ? (c < 6016
                ? (c < 5984
                  ? (c >= 5952 && c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))
                : (c <= 6067 || (c < 6108
                  ? c == 6103
                  : c <= 6108)))
              : (c <= 6121 || (c < 6279
                ? (c < 6176
                  ? (c >= 6160 && c <= 6169)
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))))))))))))
    : (c <= 6430 || (c < 43216
      ? (c < 8490
        ? (c < 7968
          ? (c < 7086
            ? (c < 6784
              ? (c < 6576
                ? (c < 6512
                  ? (c >= 6470 && c <= 6509)
                  : (c <= 6516 || (c >= 6528 && c <= 6571)))
                : (c <= 6601 || (c < 6656
                  ? (c >= 6608 && c <= 6617)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6793 || (c < 6981
                ? (c < 6823
                  ? (c >= 6800 && c <= 6809)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7043
                  ? (c >= 6992 && c <= 7001)
                  : c <= 7072)))))
            : (c <= 7141 || (c < 7401
              ? (c < 7296
                ? (c < 7232
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7241 || (c >= 7245 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))
              : (c <= 7404 || (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))))))
          : (c <= 8005 || (c < 8160
            ? (c < 8064
              ? (c < 8027
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : (c <= 8023 || c == 8025))
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))
              : (c <= 8116 || (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))))
            : (c <= 8172 || (c < 8455
              ? (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))
              : (c <= 8455 || (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))))))))
        : (c <= 8493 || (c < 12449
          ? (c < 11680
            ? (c < 11506
              ? (c < 8526
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : (c <= 8511 || (c >= 8517 && c <= 8521)))
                : (c <= 8526 || (c < 11264
                  ? (c >= 8579 && c <= 8580)
                  : (c <= 11492 || (c >= 11499 && c <= 11502)))))
              : (c <= 11507 || (c < 11568
                ? (c < 11559
                  ? (c >= 11520 && c <= 11557)
                  : (c <= 11559 || c == 11565))
                : (c <= 11623 || (c < 11648
                  ? c == 11631
                  : c <= 11670)))))
            : (c <= 11686 || (c < 11736
              ? (c < 11712
                ? (c < 11696
                  ? (c >= 11688 && c <= 11694)
                  : (c <= 11702 || (c >= 11704 && c <= 11710)))
                : (c <= 11718 || (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : c <= 11734)))
              : (c <= 11742 || (c < 12347
                ? (c < 12293
                  ? c == 11823
                  : (c <= 12294 || (c >= 12337 && c <= 12341)))
                : (c <= 12348 || (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)))))))
          : (c <= 12538 || (c < 42623
            ? (c < 19903
              ? (c < 12704
                ? (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : (c <= 12591 || (c >= 12593 && c <= 12686)))
                : (c <= 12735 || (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : c <= 13312)))
              : (c <= 19903 || (c < 42240
                ? (c < 40959
                  ? c == 19968
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42560
                  ? (c >= 42512 && c <= 42539)
                  : c <= 42606)))))
            : (c <= 42653 || (c < 42965
              ? (c < 42891
                ? (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42954 || (c < 42963
                  ? (c >= 42960 && c <= 42961)
                  : c <= 42963)))
              : (c <= 42969 || (c < 43020
                ? (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : (c <= 43013 || (c >= 43015 && c <= 43018)))
                : (c <= 43042 || (c < 43138
                  ? (c >= 43072 && c <= 43123)
                  : c <= 43187)))))))))))
      : (c <= 43225 || (c < 65296
        ? (c < 43808
          ? (c < 43616
            ? (c < 43471
              ? (c < 43264
                ? (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : (c <= 43259 || (c >= 43261 && c <= 43262)))
                : (c <= 43301 || (c < 43360
                  ? (c >= 43312 && c <= 43334)
                  : (c <= 43388 || (c >= 43396 && c <= 43442)))))
              : (c <= 43481 || (c < 43584
                ? (c < 43494
                  ? (c >= 43488 && c <= 43492)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43600
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43609)))))
            : (c <= 43638 || (c < 43714
              ? (c < 43701
                ? (c < 43646
                  ? c == 43642
                  : (c <= 43695 || c == 43697))
                : (c <= 43702 || (c < 43712
                  ? (c >= 43705 && c <= 43709)
                  : c <= 43712)))
              : (c <= 43714 || (c < 43777
                ? (c < 43744
                  ? (c >= 43739 && c <= 43741)
                  : (c <= 43754 || (c >= 43762 && c <= 43764)))
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64285
            ? (c < 55203
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 44032
                  ? (c >= 44016 && c <= 44025)
                  : c <= 44032)))
              : (c <= 55203 || (c < 64112
                ? (c < 55243
                  ? (c >= 55216 && c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64275
                  ? (c >= 64256 && c <= 64262)
                  : c <= 64279)))))
            : (c <= 64285 || (c < 64326
              ? (c < 64318
                ? (c < 64298
                  ? (c >= 64287 && c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64323
                  ? (c >= 64320 && c <= 64321)
                  : c <= 64324)))
              : (c <= 64433 || (c < 65008
                ? (c < 64848
                  ? (c >= 64467 && c <= 64829)
                  : (c <= 64911 || (c >= 64914 && c <= 64967)))
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65305 || (c < 66816
          ? (c < 65664
            ? (c < 65498
              ? (c < 65474
                ? (c < 65345
                  ? (c >= 65313 && c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65470)))
                : (c <= 65479 || (c < 65490
                  ? (c >= 65482 && c <= 65487)
                  : c <= 65495)))
              : (c <= 65500 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : c <= 65629)))))
            : (c <= 65786 || (c < 66432
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66368 || (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)))
              : (c <= 66461 || (c < 66720
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : (c <= 66511 || (c >= 66560 && c <= 66717)))
                : (c <= 66729 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67463
            ? (c < 66979
              ? (c < 66956
                ? (c < 66928
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))
                : (c <= 66962 || (c < 66967
                  ? (c >= 66964 && c <= 66965)
                  : c <= 66977)))
              : (c <= 66993 || (c < 67392
                ? (c < 67003
                  ? (c >= 66995 && c <= 67001)
                  : (c <= 67004 || (c >= 67072 && c <= 67382)))
                : (c <= 67413 || (c < 67456
                  ? (c >= 67424 && c <= 67431)
                  : c <= 67461)))))
            : (c <= 67504 || (c < 67647
              ? (c < 67594
                ? (c < 67584
                  ? (c >= 67506 && c <= 67514)
                  : (c <= 67589 || c == 67592))
                : (c <= 67637 || (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : c <= 67644)))
              : (c <= 67669 || (c < 67828
                ? (c < 67712
                  ? (c >= 67680 && c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_7(int32_t c) {
  return (c < 6320
    ? (c < 2974
      ? (c < 2308
        ? (c < 1369
          ? (c < 748
            ? (c < 181
              ? (c < '_'
                ? (c < '0'
                  ? (c >= '#' && c <= '$')
                  : (c <= '9' || (c >= '@' && c <= 'Z')))
                : (c <= '_' || (c < 167
                  ? (c >= 'b' && c <= 'z')
                  : (c <= 167 || c == 170))))
              : (c <= 181 || (c < 248
                ? (c < 192
                  ? c == 186
                  : (c <= 214 || (c >= 216 && c <= 246)))
                : (c <= 705 || (c < 736
                  ? (c >= 710 && c <= 721)
                  : c <= 740)))))
            : (c <= 748 || (c < 904
              ? (c < 890
                ? (c < 880
                  ? c == 750
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 902
                  ? c == 895
                  : c <= 902)))
              : (c <= 906 || (c < 1015
                ? (c < 910
                  ? c == 908
                  : (c <= 929 || (c >= 931 && c <= 1013)))
                : (c <= 1153 || (c < 1329
                  ? (c >= 1162 && c <= 1327)
                  : c <= 1366)))))))
          : (c <= 1369 || (c < 1869
            ? (c < 1649
              ? (c < 1568
                ? (c < 1488
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 1514 || (c >= 1519 && c <= 1522)))
                : (c <= 1610 || (c < 1646
                  ? (c >= 1632 && c <= 1641)
                  : c <= 1647)))
              : (c <= 1747 || (c < 1791
                ? (c < 1765
                  ? c == 1749
                  : (c <= 1766 || (c >= 1774 && c <= 1788)))
                : (c <= 1791 || (c < 1810
                  ? c == 1808
                  : c <= 1839)))))
            : (c <= 1957 || (c < 2084
              ? (c < 2042
                ? (c < 1984
                  ? c == 1969
                  : (c <= 2026 || (c >= 2036 && c <= 2037)))
                : (c <= 2042 || (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : c <= 2074)))
              : (c <= 2084 || (c < 2160
                ? (c < 2112
                  ? c == 2088
                  : (c <= 2136 || (c >= 2144 && c <= 2154)))
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2406
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2415 || (c < 2437
                  ? (c >= 2417 && c <= 2432)
                  : (c <= 2444 || (c >= 2447 && c <= 2448)))))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2534 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2654
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : (c <= 2617 || (c >= 2649 && c <= 2652)))
                : (c <= 2654 || (c < 2674
                  ? (c >= 2662 && c <= 2671)
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2858
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2821
                ? (c < 2790
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2799 || c == 2809))
                : (c <= 2828 || (c < 2835
                  ? (c >= 2831 && c <= 2832)
                  : c <= 2856)))))
            : (c <= 2864 || (c < 2929
              ? (c < 2908
                ? (c < 2869
                  ? (c >= 2866 && c <= 2867)
                  : (c <= 2873 || c == 2877))
                : (c <= 2909 || (c < 2918
                  ? (c >= 2911 && c <= 2913)
                  : c <= 2927)))
              : (c <= 2929 || (c < 2962
                ? (c < 2949
                  ? c == 2947
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))
                : (c <= 2965 || (c < 2972
                  ? (c >= 2969 && c <= 2970)
                  : c <= 2972)))))))))))
      : (c <= 2975 || (c < 3840
        ? (c < 3389
          ? (c < 3200
            ? (c < 3090
              ? (c < 3024
                ? (c < 2984
                  ? (c >= 2979 && c <= 2980)
                  : (c <= 2986 || (c >= 2990 && c <= 3001)))
                : (c <= 3024 || (c < 3077
                  ? (c >= 3046 && c <= 3055)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3165
                ? (c < 3133
                  ? (c >= 3114 && c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))
                : (c <= 3165 || (c < 3174
                  ? (c >= 3168 && c <= 3169)
                  : c <= 3183)))))
            : (c <= 3200 || (c < 3293
              ? (c < 3242
                ? (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))
                : (c <= 3251 || (c < 3261
                  ? (c >= 3253 && c <= 3257)
                  : c <= 3261)))
              : (c <= 3294 || (c < 3332
                ? (c < 3302
                  ? (c >= 3296 && c <= 3297)
                  : (c <= 3311 || (c >= 3313 && c <= 3314)))
                : (c <= 3340 || (c < 3346
                  ? (c >= 3342 && c <= 3344)
                  : c <= 3386)))))))
          : (c <= 3389 || (c < 3648
            ? (c < 3482
              ? (c < 3430
                ? (c < 3412
                  ? c == 3406
                  : (c <= 3414 || (c >= 3423 && c <= 3425)))
                : (c <= 3439 || (c < 3461
                  ? (c >= 3450 && c <= 3455)
                  : c <= 3478)))
              : (c <= 3505 || (c < 3558
                ? (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : (c <= 3517 || (c >= 3520 && c <= 3526)))
                : (c <= 3567 || (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : c <= 3635)))))
            : (c <= 3654 || (c < 3751
              ? (c < 3718
                ? (c < 3713
                  ? (c >= 3664 && c <= 3673)
                  : (c <= 3714 || c == 3716))
                : (c <= 3722 || (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : c <= 3749)))
              : (c <= 3760 || (c < 3782
                ? (c < 3773
                  ? (c >= 3762 && c <= 3763)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))
                : (c <= 3782 || (c < 3804
                  ? (c >= 3792 && c <= 3801)
                  : c <= 3807)))))))))
        : (c <= 3840 || (c < 4800
          ? (c < 4256
            ? (c < 4186
              ? (c < 3976
                ? (c < 3904
                  ? (c >= 3872 && c <= 3881)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4159
                  ? (c >= 4096 && c <= 4138)
                  : (c <= 4169 || (c >= 4176 && c <= 4181)))))
              : (c <= 4189 || (c < 4213
                ? (c < 4197
                  ? c == 4193
                  : (c <= 4198 || (c >= 4206 && c <= 4208)))
                : (c <= 4225 || (c < 4240
                  ? c == 4238
                  : c <= 4249)))))
            : (c <= 4293 || (c < 4696
              ? (c < 4348
                ? (c < 4301
                  ? c == 4295
                  : (c <= 4301 || (c >= 4304 && c <= 4346)))
                : (c <= 4680 || (c < 4688
                  ? (c >= 4682 && c <= 4685)
                  : c <= 4694)))
              : (c <= 4696 || (c < 4752
                ? (c < 4704
                  ? (c >= 4698 && c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4792
                  ? (c >= 4786 && c <= 4789)
                  : c <= 4798)))))))
          : (c <= 4800 || (c < 5888
            ? (c < 5024
              ? (c < 4882
                ? (c < 4808
                  ? (c >= 4802 && c <= 4805)
                  : (c <= 4822 || (c >= 4824 && c <= 4880)))
                : (c <= 4885 || (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : c <= 5007)))
              : (c <= 5109 || (c < 5761
                ? (c < 5121
                  ? (c >= 5112 && c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))
                : (c <= 5786 || (c < 5873
                  ? (c >= 5792 && c <= 5866)
                  : c <= 5880)))))
            : (c <= 5905 || (c < 6108
              ? (c < 5998
                ? (c < 5952
                  ? (c >= 5919 && c <= 5937)
                  : (c <= 5969 || (c >= 5984 && c <= 5996)))
                : (c <= 6000 || (c < 6103
                  ? (c >= 6016 && c <= 6067)
                  : c <= 6103)))
              : (c <= 6108 || (c < 6272
                ? (c < 6160
                  ? (c >= 6112 && c <= 6121)
                  : (c <= 6169 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))))))))))))
    : (c <= 6389 || (c < 43138
      ? (c < 8488
        ? (c < 7960
          ? (c < 7043
            ? (c < 6688
              ? (c < 6528
                ? (c < 6470
                  ? (c >= 6400 && c <= 6430)
                  : (c <= 6509 || (c >= 6512 && c <= 6516)))
                : (c <= 6571 || (c < 6608
                  ? (c >= 6576 && c <= 6601)
                  : (c <= 6617 || (c >= 6656 && c <= 6678)))))
              : (c <= 6740 || (c < 6917
                ? (c < 6800
                  ? (c >= 6784 && c <= 6793)
                  : (c <= 6809 || c == 6823))
                : (c <= 6963 || (c < 6992
                  ? (c >= 6981 && c <= 6988)
                  : c <= 7001)))))
            : (c <= 7072 || (c < 7357
              ? (c < 7245
                ? (c < 7168
                  ? (c >= 7086 && c <= 7141)
                  : (c <= 7203 || (c >= 7232 && c <= 7241)))
                : (c <= 7293 || (c < 7312
                  ? (c >= 7296 && c <= 7304)
                  : c <= 7354)))
              : (c <= 7359 || (c < 7418
                ? (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7680
                  ? (c >= 7424 && c <= 7615)
                  : c <= 7957)))))))
          : (c <= 7965 || (c < 8150
            ? (c < 8031
              ? (c < 8025
                ? (c < 8008
                  ? (c >= 7968 && c <= 8005)
                  : (c <= 8013 || (c >= 8016 && c <= 8023)))
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))
              : (c <= 8061 || (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))))
            : (c <= 8155 || (c < 8450
              ? (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))
              : (c <= 8450 || (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))))))))
        : (c <= 8488 || (c < 12445
          ? (c < 11648
            ? (c < 11499
              ? (c < 8517
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : (c <= 8505 || (c >= 8508 && c <= 8511)))
                : (c <= 8521 || (c < 8579
                  ? c == 8526
                  : (c <= 8580 || (c >= 11264 && c <= 11492)))))
              : (c <= 11502 || (c < 11565
                ? (c < 11520
                  ? (c >= 11506 && c <= 11507)
                  : (c <= 11557 || c == 11559))
                : (c <= 11565 || (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : c <= 11631)))))
            : (c <= 11670 || (c < 11728
              ? (c < 11704
                ? (c < 11688
                  ? (c >= 11680 && c <= 11686)
                  : (c <= 11694 || (c >= 11696 && c <= 11702)))
                : (c <= 11710 || (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : c <= 11726)))
              : (c <= 11734 || (c < 12337
                ? (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : (c <= 11823 || (c >= 12293 && c <= 12294)))
                : (c <= 12341 || (c < 12353
                  ? (c >= 12347 && c <= 12348)
                  : c <= 12438)))))))
          : (c <= 12447 || (c < 42560
            ? (c < 13312
              ? (c < 12593
                ? (c < 12540
                  ? (c >= 12449 && c <= 12538)
                  : (c <= 12543 || (c >= 12549 && c <= 12591)))
                : (c <= 12686 || (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : c <= 12799)))
              : (c <= 13312 || (c < 42192
                ? (c < 19968
                  ? c == 19903
                  : (c <= 19968 || (c >= 40959 && c <= 42124)))
                : (c <= 42237 || (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : c <= 42539)))))
            : (c <= 42606 || (c < 42963
              ? (c < 42786
                ? (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : (c <= 42725 || (c >= 42775 && c <= 42783)))
                : (c <= 42888 || (c < 42960
                  ? (c >= 42891 && c <= 42954)
                  : c <= 42961)))
              : (c <= 42963 || (c < 43015
                ? (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : (c <= 43009 || (c >= 43011 && c <= 43013)))
                : (c <= 43018 || (c < 43072
                  ? (c >= 43020 && c <= 43042)
                  : c <= 43123)))))))))))
      : (c <= 43187 || (c < 65142
        ? (c < 43793
          ? (c < 43600
            ? (c < 43396
              ? (c < 43261
                ? (c < 43250
                  ? (c >= 43216 && c <= 43225)
                  : (c <= 43255 || c == 43259))
                : (c <= 43262 || (c < 43312
                  ? (c >= 43264 && c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))))
              : (c <= 43442 || (c < 43520
                ? (c < 43488
                  ? (c >= 43471 && c <= 43481)
                  : (c <= 43492 || (c >= 43494 && c <= 43518)))
                : (c <= 43560 || (c < 43588
                  ? (c >= 43584 && c <= 43586)
                  : c <= 43595)))))
            : (c <= 43609 || (c < 43712
              ? (c < 43697
                ? (c < 43642
                  ? (c >= 43616 && c <= 43638)
                  : (c <= 43642 || (c >= 43646 && c <= 43695)))
                : (c <= 43697 || (c < 43705
                  ? (c >= 43701 && c <= 43702)
                  : c <= 43709)))
              : (c <= 43712 || (c < 43762
                ? (c < 43739
                  ? c == 43714
                  : (c <= 43741 || (c >= 43744 && c <= 43754)))
                : (c <= 43764 || (c < 43785
                  ? (c >= 43777 && c <= 43782)
                  : c <= 43790)))))))
          : (c <= 43798 || (c < 64275
            ? (c < 44032
              ? (c < 43868
                ? (c < 43816
                  ? (c >= 43808 && c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))
                : (c <= 43881 || (c < 44016
                  ? (c >= 43888 && c <= 44002)
                  : c <= 44025)))
              : (c <= 44032 || (c < 63744
                ? (c < 55216
                  ? c == 55203
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64256
                  ? (c >= 64112 && c <= 64217)
                  : c <= 64262)))))
            : (c <= 64279 || (c < 64323
              ? (c < 64312
                ? (c < 64287
                  ? c == 64285
                  : (c <= 64296 || (c >= 64298 && c <= 64310)))
                : (c <= 64316 || (c < 64320
                  ? c == 64318
                  : c <= 64321)))
              : (c <= 64324 || (c < 64914
                ? (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))
                : (c <= 64967 || (c < 65136
                  ? (c >= 65008 && c <= 65019)
                  : c <= 65140)))))))))
        : (c <= 65276 || (c < 66816
          ? (c < 65664
            ? (c < 65498
              ? (c < 65382
                ? (c < 65313
                  ? (c >= 65296 && c <= 65305)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))
                : (c <= 65470 || (c < 65482
                  ? (c >= 65474 && c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))))
              : (c <= 65500 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : c <= 65629)))))
            : (c <= 65786 || (c < 66432
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66368 || (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)))
              : (c <= 66461 || (c < 66720
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : (c <= 66511 || (c >= 66560 && c <= 66717)))
                : (c <= 66729 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67463
            ? (c < 66979
              ? (c < 66956
                ? (c < 66928
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))
                : (c <= 66962 || (c < 66967
                  ? (c >= 66964 && c <= 66965)
                  : c <= 66977)))
              : (c <= 66993 || (c < 67392
                ? (c < 67003
                  ? (c >= 66995 && c <= 67001)
                  : (c <= 67004 || (c >= 67072 && c <= 67382)))
                : (c <= 67413 || (c < 67456
                  ? (c >= 67424 && c <= 67431)
                  : c <= 67461)))))
            : (c <= 67504 || (c < 67647
              ? (c < 67594
                ? (c < 67584
                  ? (c >= 67506 && c <= 67514)
                  : (c <= 67589 || c == 67592))
                : (c <= 67637 || (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : c <= 67644)))
              : (c <= 67669 || (c < 67828
                ? (c < 67712
                  ? (c >= 67680 && c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(59);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '%') ADVANCE(118);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(155);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(110);
      if (lookahead == '.') ADVANCE(73);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(139);
      if (lookahead == 'I') ADVANCE(181);
      if (lookahead == 'N') ADVANCE(177);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == '\\') ADVANCE(40);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == 'f') ADVANCE(183);
      if (lookahead == '{') ADVANCE(68);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(56)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(187);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(18)
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '[') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(172);
      if (lookahead != 0) ADVANCE(173);
      END_STATE();
    case 2:
      if (lookahead == ' ') ADVANCE(91);
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r') SKIP(2)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\'') ADVANCE(155);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '+') ADVANCE(106);
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '.') ADVANCE(47);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == 'I') ADVANCE(181);
      if (lookahead == 'N') ADVANCE(177);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '{') ADVANCE(68);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(187);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '%') ADVANCE(118);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(109);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '/') ADVANCE(116);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(139);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '{') ADVANCE(68);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(187);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '%') ADVANCE(117);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(106);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(108);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(87);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(139);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead == '{') ADVANCE(68);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(187);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '%') ADVANCE(117);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(106);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(108);
      if (lookahead == '.') ADVANCE(74);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(87);
      if (lookahead == '=') ADVANCE(21);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(139);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(174);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(187);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '%') ADVANCE(117);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(106);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(108);
      if (lookahead == '.') ADVANCE(74);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(87);
      if (lookahead == '=') ADVANCE(21);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(139);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(187);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(160);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 9:
      if (lookahead == '\'') ADVANCE(155);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead == '\\') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(166);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 10:
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '.') ADVANCE(16);
      if (lookahead == '/') ADVANCE(12);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(187);
      END_STATE();
    case 11:
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(188);
      END_STATE();
    case 12:
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(188);
      if (lookahead == '>') ADVANCE(94);
      END_STATE();
    case 13:
      if (lookahead == '*') ADVANCE(13);
      if (lookahead == '/') ADVANCE(189);
      if (lookahead != 0) ADVANCE(14);
      END_STATE();
    case 14:
      if (lookahead == '*') ADVANCE(13);
      if (lookahead != 0) ADVANCE(14);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(70);
      END_STATE();
    case 16:
      if (lookahead == '.') ADVANCE(15);
      END_STATE();
    case 17:
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(18)
      END_STATE();
    case 18:
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(18)
      END_STATE();
    case 19:
      if (lookahead == ':') ADVANCE(82);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 21:
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 22:
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == ']') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(22);
      END_STATE();
    case 23:
      if (lookahead == '_') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 24:
      if (lookahead == '_') ADVANCE(24);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(147);
      END_STATE();
    case 25:
      if (lookahead == '_') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      END_STATE();
    case 26:
      if (lookahead == '_') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 27:
      if (lookahead == '_') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      END_STATE();
    case 28:
      if (lookahead == '_') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 29:
      if (lookahead == '_') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'c') ADVANCE(34);
      END_STATE();
    case 32:
      if (lookahead == 'e') ADVANCE(30);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(36);
      END_STATE();
    case 34:
      if (lookahead == 'h') ADVANCE(72);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(39);
      END_STATE();
    case 36:
      if (lookahead == 'i') ADVANCE(38);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(33);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(41);
      END_STATE();
    case 40:
      if (lookahead == 'u') ADVANCE(42);
      if (lookahead == 'x') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(170);
      if (lookahead != 0) ADVANCE(168);
      END_STATE();
    case 41:
      if (lookahead == 'y') ADVANCE(143);
      END_STATE();
    case 42:
      if (lookahead == '{') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 45:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(147);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(168);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 54:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(22);
      END_STATE();
    case 55:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    case 56:
      if (eof) ADVANCE(59);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '%') ADVANCE(118);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(155);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(110);
      if (lookahead == '.') ADVANCE(73);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(139);
      if (lookahead == 'I') ADVANCE(181);
      if (lookahead == 'N') ADVANCE(177);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == 'f') ADVANCE(183);
      if (lookahead == '{') ADVANCE(68);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(56)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(187);
      END_STATE();
    case 57:
      if (eof) ADVANCE(59);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '%') ADVANCE(117);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(155);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(106);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '.') ADVANCE(76);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(87);
      if (lookahead == '=') ADVANCE(21);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(139);
      if (lookahead == 'I') ADVANCE(181);
      if (lookahead == 'N') ADVANCE(177);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead == 'f') ADVANCE(183);
      if (lookahead == '{') ADVANCE(68);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(57)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(187);
      END_STATE();
    case 58:
      if (eof) ADVANCE(59);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\'') ADVANCE(155);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '+') ADVANCE(106);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '.') ADVANCE(77);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(60);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == 'I') ADVANCE(181);
      if (lookahead == 'N') ADVANCE(177);
      if (lookahead == '[') ADVANCE(64);
      if (lookahead == 'f') ADVANCE(183);
      if (lookahead == '{') ADVANCE(68);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(187);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(82);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '<') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(80);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(80);
      if (lookahead == '<') ADVANCE(142);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '<') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(70);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '/') ADVANCE(93);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '<') ADVANCE(120);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(120);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(119);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(126);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(126);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym_xml_token1);
      if (lookahead == ' ') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym_xml_token1);
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_LT_SLASH);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_SLASH_GT);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(140);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(141);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == 'I') ADVANCE(37);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == 'I') ADVANCE(37);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(188);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(188);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(124);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(130);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(137);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(137);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '|') ADVANCE(138);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(138);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DOT_LT);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == '0') ADVANCE(146);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(45);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(50);
      if (lookahead == '_') ADVANCE(23);
      if (lookahead == 'n') ADVANCE(143);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (lookahead == '_') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(23);
      if (lookahead == 'n') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(24);
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(25);
      if (lookahead == 'n') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(26);
      if (lookahead == 'n') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (lookahead == '_') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_number);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym__unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(156);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym__unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead == '/') ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(161);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym__unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(158);
      if (lookahead == '/') ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(159);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym__unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(159);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym__unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(161);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym__unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(161);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym__unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym__unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(165);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym__unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(164);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(165);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym__unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(165);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym__unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym__unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym__escape_sequence);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(168);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(169);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(188);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(18)
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '[') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(172);
      if (lookahead != 0) ADVANCE(173);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(173);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_regex_flags);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(174);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(187);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == ' ') ADVANCE(32);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N') ADVANCE(153);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(176);
      if (sym_identifier_character_set_7(lookahead)) ADVANCE(187);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(180);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(185);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(182);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(178);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(179);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(184);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(175);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(186);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(153);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(187);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_block_comment);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'n') ADVANCE(9);
      if (lookahead == 'o') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'u') ADVANCE(15);
      if (lookahead == 'v') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 's') ADVANCE(18);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(20);
      if (lookahead == 'l') ADVANCE(21);
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(23);
      if (lookahead == 'o') ADVANCE(24);
      if (lookahead == 'y') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(26);
      if (lookahead == 'x') ADVANCE(27);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'i') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(33);
      if (lookahead == 'm') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 's') ADVANCE(36);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'e') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 10:
      if (lookahead == 'v') ADVANCE(40);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(41);
      if (lookahead == 'r') ADVANCE(42);
      if (lookahead == 'u') ADVANCE(43);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(44);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(45);
      if (lookahead == 't') ADVANCE(46);
      if (lookahead == 'w') ADVANCE(47);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      if (lookahead == 'y') ADVANCE(50);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(52);
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(54);
      if (lookahead == 'i') ADVANCE(55);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 20:
      if (lookahead == 's') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(59);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 23:
      if (lookahead == 'f') ADVANCE(61);
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 25:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(64);
      END_STATE();
    case 27:
      if (lookahead == 't') ADVANCE(65);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(66);
      END_STATE();
    case 29:
      if (lookahead == 'n') ADVANCE(67);
      END_STATE();
    case 30:
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 31:
      if (lookahead == 'n') ADVANCE(69);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 34:
      if (lookahead == 'p') ADVANCE(71);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(72);
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 37:
      if (lookahead == 'm') ADVANCE(74);
      END_STATE();
    case 38:
      if (lookahead == 'w') ADVANCE(75);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(76);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 41:
      if (lookahead == 'c') ADVANCE(78);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(79);
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 43:
      if (lookahead == 'b') ADVANCE(81);
      END_STATE();
    case 44:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(84);
      END_STATE();
    case 47:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 48:
      if (lookahead == 'r') ADVANCE(86);
      END_STATE();
    case 49:
      if (lookahead == 'u') ADVANCE(87);
      if (lookahead == 'y') ADVANCE(88);
      END_STATE();
    case 50:
      if (lookahead == 'p') ADVANCE(89);
      END_STATE();
    case 51:
      if (lookahead == 'd') ADVANCE(90);
      END_STATE();
    case 52:
      if (lookahead == 'r') ADVANCE(91);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(92);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(93);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(94);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(95);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 58:
      if (lookahead == 'c') ADVANCE(97);
      END_STATE();
    case 59:
      if (lookahead == 's') ADVANCE(98);
      END_STATE();
    case 60:
      if (lookahead == 's') ADVANCE(99);
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 61:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(103);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(105);
      END_STATE();
    case 66:
      if (lookahead == 's') ADVANCE(106);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(107);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 69:
      if (lookahead == 'c') ADVANCE(108);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(109);
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(112);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(114);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 78:
      if (lookahead == 'k') ADVANCE(116);
      END_STATE();
    case 79:
      if (lookahead == 'v') ADVANCE(117);
      END_STATE();
    case 80:
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 81:
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(120);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 84:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 86:
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 92:
      if (lookahead == 'd') ADVANCE(127);
      END_STATE();
    case 93:
      if (lookahead == 'l') ADVANCE(128);
      END_STATE();
    case 94:
      if (lookahead == 'h') ADVANCE(129);
      END_STATE();
    case 95:
      if (lookahead == 'k') ADVANCE(130);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 97:
      if (lookahead == 'h') ADVANCE(131);
      END_STATE();
    case 98:
      if (lookahead == 's') ADVANCE(132);
      END_STATE();
    case 99:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(134);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(135);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 103:
      if (lookahead == 'm') ADVANCE(137);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 105:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 106:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(140);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(143);
      END_STATE();
    case 111:
      if (lookahead == 'a') ADVANCE(144);
      END_STATE();
    case 112:
      if (lookahead == 'r') ADVANCE(145);
      END_STATE();
    case 113:
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 115:
      if (lookahead == 'r') ADVANCE(147);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(148);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 119:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 120:
      if (lookahead == 'r') ADVANCE(152);
      END_STATE();
    case 121:
      if (lookahead == 'i') ADVANCE(153);
      END_STATE();
    case 122:
      if (lookahead == 'c') ADVANCE(154);
      END_STATE();
    case 123:
      if (lookahead == 'w') ADVANCE(155);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 125:
      if (lookahead == 'o') ADVANCE(156);
      END_STATE();
    case 126:
      if (lookahead == 'f') ADVANCE(157);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(158);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 134:
      if (lookahead == 'n') ADVANCE(159);
      END_STATE();
    case 135:
      if (lookahead == 'l') ADVANCE(160);
      END_STATE();
    case 136:
      if (lookahead == 'e') ADVANCE(161);
      END_STATE();
    case 137:
      if (lookahead == 'i') ADVANCE(162);
      END_STATE();
    case 138:
      if (lookahead == 'd') ADVANCE(163);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_final);
      if (lookahead == 'l') ADVANCE(164);
      END_STATE();
    case 141:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 142:
      if (lookahead == 'm') ADVANCE(166);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 144:
      if (lookahead == 'n') ADVANCE(168);
      END_STATE();
    case 145:
      if (lookahead == 'f') ADVANCE(169);
      if (lookahead == 'n') ADVANCE(170);
      END_STATE();
    case 146:
      if (lookahead == 'p') ADVANCE(171);
      END_STATE();
    case 147:
      if (lookahead == 'i') ADVANCE(172);
      END_STATE();
    case 148:
      if (lookahead == 'g') ADVANCE(173);
      END_STATE();
    case 149:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 150:
      if (lookahead == 'c') ADVANCE(175);
      END_STATE();
    case 151:
      if (lookahead == 'c') ADVANCE(176);
      END_STATE();
    case 152:
      if (lookahead == 'n') ADVANCE(177);
      END_STATE();
    case 153:
      if (lookahead == 'c') ADVANCE(178);
      END_STATE();
    case 154:
      if (lookahead == 'h') ADVANCE(179);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 156:
      if (lookahead == 'f') ADVANCE(180);
      END_STATE();
    case 157:
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 159:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 160:
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 162:
      if (lookahead == 'c') ADVANCE(184);
      END_STATE();
    case 163:
      if (lookahead == 's') ADVANCE(185);
      END_STATE();
    case 164:
      if (lookahead == 'y') ADVANCE(186);
      END_STATE();
    case 165:
      if (lookahead == 'o') ADVANCE(187);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 168:
      if (lookahead == 'c') ADVANCE(189);
      END_STATE();
    case 169:
      if (lookahead == 'a') ADVANCE(190);
      END_STATE();
    case 170:
      if (lookahead == 'a') ADVANCE(191);
      END_STATE();
    case 171:
      if (lookahead == 'a') ADVANCE(192);
      END_STATE();
    case 172:
      if (lookahead == 'd') ADVANCE(193);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(195);
      END_STATE();
    case 175:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(197);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_dynamic);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 187:
      if (lookahead == 'n') ADVANCE(199);
      END_STATE();
    case 188:
      if (lookahead == 'n') ADVANCE(200);
      END_STATE();
    case 189:
      if (lookahead == 'e') ADVANCE(201);
      END_STATE();
    case 190:
      if (lookahead == 'c') ADVANCE(202);
      END_STATE();
    case 191:
      if (lookahead == 'l') ADVANCE(203);
      END_STATE();
    case 192:
      if (lookahead == 'c') ADVANCE(204);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(206);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(207);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 200:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 201:
      if (lookahead == 'o') ADVANCE(209);
      END_STATE();
    case 202:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(211);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 206:
      if (lookahead == 'd') ADVANCE(212);
      END_STATE();
    case 207:
      if (lookahead == 'd') ADVANCE(213);
      END_STATE();
    case 208:
      if (lookahead == 's') ADVANCE(214);
      END_STATE();
    case 209:
      if (lookahead == 'f') ADVANCE(215);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 58},
  [2] = {.lex_state = 58},
  [3] = {.lex_state = 58},
  [4] = {.lex_state = 58},
  [5] = {.lex_state = 58},
  [6] = {.lex_state = 58},
  [7] = {.lex_state = 58},
  [8] = {.lex_state = 58},
  [9] = {.lex_state = 58},
  [10] = {.lex_state = 58},
  [11] = {.lex_state = 58},
  [12] = {.lex_state = 58},
  [13] = {.lex_state = 58},
  [14] = {.lex_state = 58},
  [15] = {.lex_state = 58},
  [16] = {.lex_state = 58},
  [17] = {.lex_state = 58},
  [18] = {.lex_state = 58},
  [19] = {.lex_state = 58},
  [20] = {.lex_state = 58},
  [21] = {.lex_state = 58},
  [22] = {.lex_state = 58},
  [23] = {.lex_state = 58},
  [24] = {.lex_state = 58},
  [25] = {.lex_state = 58},
  [26] = {.lex_state = 58},
  [27] = {.lex_state = 58},
  [28] = {.lex_state = 58},
  [29] = {.lex_state = 58},
  [30] = {.lex_state = 58},
  [31] = {.lex_state = 58},
  [32] = {.lex_state = 58},
  [33] = {.lex_state = 58},
  [34] = {.lex_state = 58},
  [35] = {.lex_state = 58},
  [36] = {.lex_state = 58},
  [37] = {.lex_state = 58},
  [38] = {.lex_state = 58},
  [39] = {.lex_state = 58},
  [40] = {.lex_state = 58},
  [41] = {.lex_state = 58},
  [42] = {.lex_state = 58},
  [43] = {.lex_state = 58},
  [44] = {.lex_state = 58},
  [45] = {.lex_state = 58},
  [46] = {.lex_state = 58},
  [47] = {.lex_state = 58},
  [48] = {.lex_state = 58},
  [49] = {.lex_state = 58},
  [50] = {.lex_state = 58},
  [51] = {.lex_state = 58},
  [52] = {.lex_state = 58},
  [53] = {.lex_state = 58},
  [54] = {.lex_state = 58},
  [55] = {.lex_state = 58},
  [56] = {.lex_state = 58},
  [57] = {.lex_state = 58},
  [58] = {.lex_state = 58},
  [59] = {.lex_state = 58},
  [60] = {.lex_state = 58},
  [61] = {.lex_state = 58},
  [62] = {.lex_state = 58},
  [63] = {.lex_state = 58},
  [64] = {.lex_state = 58},
  [65] = {.lex_state = 58},
  [66] = {.lex_state = 58},
  [67] = {.lex_state = 58},
  [68] = {.lex_state = 58},
  [69] = {.lex_state = 58},
  [70] = {.lex_state = 58},
  [71] = {.lex_state = 58},
  [72] = {.lex_state = 58},
  [73] = {.lex_state = 58},
  [74] = {.lex_state = 58},
  [75] = {.lex_state = 58},
  [76] = {.lex_state = 58},
  [77] = {.lex_state = 58},
  [78] = {.lex_state = 58},
  [79] = {.lex_state = 58},
  [80] = {.lex_state = 58},
  [81] = {.lex_state = 58},
  [82] = {.lex_state = 58},
  [83] = {.lex_state = 58},
  [84] = {.lex_state = 58},
  [85] = {.lex_state = 58},
  [86] = {.lex_state = 58},
  [87] = {.lex_state = 58},
  [88] = {.lex_state = 58},
  [89] = {.lex_state = 58},
  [90] = {.lex_state = 58},
  [91] = {.lex_state = 58},
  [92] = {.lex_state = 58},
  [93] = {.lex_state = 58},
  [94] = {.lex_state = 58},
  [95] = {.lex_state = 58},
  [96] = {.lex_state = 58},
  [97] = {.lex_state = 58},
  [98] = {.lex_state = 58},
  [99] = {.lex_state = 58},
  [100] = {.lex_state = 58},
  [101] = {.lex_state = 58},
  [102] = {.lex_state = 58},
  [103] = {.lex_state = 58},
  [104] = {.lex_state = 58},
  [105] = {.lex_state = 58},
  [106] = {.lex_state = 58},
  [107] = {.lex_state = 58},
  [108] = {.lex_state = 58},
  [109] = {.lex_state = 58},
  [110] = {.lex_state = 58},
  [111] = {.lex_state = 58},
  [112] = {.lex_state = 58},
  [113] = {.lex_state = 58},
  [114] = {.lex_state = 58},
  [115] = {.lex_state = 58},
  [116] = {.lex_state = 58},
  [117] = {.lex_state = 58},
  [118] = {.lex_state = 58},
  [119] = {.lex_state = 58},
  [120] = {.lex_state = 58},
  [121] = {.lex_state = 58},
  [122] = {.lex_state = 58},
  [123] = {.lex_state = 58},
  [124] = {.lex_state = 58},
  [125] = {.lex_state = 58},
  [126] = {.lex_state = 58},
  [127] = {.lex_state = 58},
  [128] = {.lex_state = 58},
  [129] = {.lex_state = 58},
  [130] = {.lex_state = 58},
  [131] = {.lex_state = 58},
  [132] = {.lex_state = 58},
  [133] = {.lex_state = 58},
  [134] = {.lex_state = 58},
  [135] = {.lex_state = 58},
  [136] = {.lex_state = 58},
  [137] = {.lex_state = 58},
  [138] = {.lex_state = 58},
  [139] = {.lex_state = 58},
  [140] = {.lex_state = 58},
  [141] = {.lex_state = 58},
  [142] = {.lex_state = 58},
  [143] = {.lex_state = 58},
  [144] = {.lex_state = 58},
  [145] = {.lex_state = 58},
  [146] = {.lex_state = 58},
  [147] = {.lex_state = 58},
  [148] = {.lex_state = 58},
  [149] = {.lex_state = 58},
  [150] = {.lex_state = 58},
  [151] = {.lex_state = 58},
  [152] = {.lex_state = 58},
  [153] = {.lex_state = 58},
  [154] = {.lex_state = 58},
  [155] = {.lex_state = 58},
  [156] = {.lex_state = 58},
  [157] = {.lex_state = 58},
  [158] = {.lex_state = 58},
  [159] = {.lex_state = 58},
  [160] = {.lex_state = 58},
  [161] = {.lex_state = 58},
  [162] = {.lex_state = 58},
  [163] = {.lex_state = 58},
  [164] = {.lex_state = 58},
  [165] = {.lex_state = 57},
  [166] = {.lex_state = 57},
  [167] = {.lex_state = 57},
  [168] = {.lex_state = 57},
  [169] = {.lex_state = 57},
  [170] = {.lex_state = 57},
  [171] = {.lex_state = 57},
  [172] = {.lex_state = 57},
  [173] = {.lex_state = 57},
  [174] = {.lex_state = 57},
  [175] = {.lex_state = 57},
  [176] = {.lex_state = 57},
  [177] = {.lex_state = 57},
  [178] = {.lex_state = 57},
  [179] = {.lex_state = 57},
  [180] = {.lex_state = 57},
  [181] = {.lex_state = 57},
  [182] = {.lex_state = 57},
  [183] = {.lex_state = 57},
  [184] = {.lex_state = 4},
  [185] = {.lex_state = 4},
  [186] = {.lex_state = 4},
  [187] = {.lex_state = 58},
  [188] = {.lex_state = 58},
  [189] = {.lex_state = 4},
  [190] = {.lex_state = 58},
  [191] = {.lex_state = 58},
  [192] = {.lex_state = 58},
  [193] = {.lex_state = 58},
  [194] = {.lex_state = 58},
  [195] = {.lex_state = 58},
  [196] = {.lex_state = 58},
  [197] = {.lex_state = 58},
  [198] = {.lex_state = 58},
  [199] = {.lex_state = 58},
  [200] = {.lex_state = 58},
  [201] = {.lex_state = 58},
  [202] = {.lex_state = 58},
  [203] = {.lex_state = 58},
  [204] = {.lex_state = 58},
  [205] = {.lex_state = 58},
  [206] = {.lex_state = 58},
  [207] = {.lex_state = 58},
  [208] = {.lex_state = 58},
  [209] = {.lex_state = 58},
  [210] = {.lex_state = 58},
  [211] = {.lex_state = 58},
  [212] = {.lex_state = 58},
  [213] = {.lex_state = 58},
  [214] = {.lex_state = 58},
  [215] = {.lex_state = 58},
  [216] = {.lex_state = 58},
  [217] = {.lex_state = 58},
  [218] = {.lex_state = 58},
  [219] = {.lex_state = 58},
  [220] = {.lex_state = 58},
  [221] = {.lex_state = 58},
  [222] = {.lex_state = 58},
  [223] = {.lex_state = 58},
  [224] = {.lex_state = 58},
  [225] = {.lex_state = 58},
  [226] = {.lex_state = 58},
  [227] = {.lex_state = 58},
  [228] = {.lex_state = 58},
  [229] = {.lex_state = 58},
  [230] = {.lex_state = 58},
  [231] = {.lex_state = 58},
  [232] = {.lex_state = 58},
  [233] = {.lex_state = 58},
  [234] = {.lex_state = 58},
  [235] = {.lex_state = 58},
  [236] = {.lex_state = 58},
  [237] = {.lex_state = 58},
  [238] = {.lex_state = 58},
  [239] = {.lex_state = 58},
  [240] = {.lex_state = 58},
  [241] = {.lex_state = 58},
  [242] = {.lex_state = 58},
  [243] = {.lex_state = 58},
  [244] = {.lex_state = 58},
  [245] = {.lex_state = 58},
  [246] = {.lex_state = 58},
  [247] = {.lex_state = 58},
  [248] = {.lex_state = 58},
  [249] = {.lex_state = 58},
  [250] = {.lex_state = 58},
  [251] = {.lex_state = 58},
  [252] = {.lex_state = 58},
  [253] = {.lex_state = 58},
  [254] = {.lex_state = 58},
  [255] = {.lex_state = 58},
  [256] = {.lex_state = 58},
  [257] = {.lex_state = 58},
  [258] = {.lex_state = 58},
  [259] = {.lex_state = 58},
  [260] = {.lex_state = 58},
  [261] = {.lex_state = 58},
  [262] = {.lex_state = 58},
  [263] = {.lex_state = 58},
  [264] = {.lex_state = 58},
  [265] = {.lex_state = 58},
  [266] = {.lex_state = 58},
  [267] = {.lex_state = 58},
  [268] = {.lex_state = 58},
  [269] = {.lex_state = 58},
  [270] = {.lex_state = 58},
  [271] = {.lex_state = 58},
  [272] = {.lex_state = 58},
  [273] = {.lex_state = 58},
  [274] = {.lex_state = 58},
  [275] = {.lex_state = 58},
  [276] = {.lex_state = 58},
  [277] = {.lex_state = 58},
  [278] = {.lex_state = 58},
  [279] = {.lex_state = 58},
  [280] = {.lex_state = 58},
  [281] = {.lex_state = 58},
  [282] = {.lex_state = 58},
  [283] = {.lex_state = 58},
  [284] = {.lex_state = 58},
  [285] = {.lex_state = 58},
  [286] = {.lex_state = 58},
  [287] = {.lex_state = 58},
  [288] = {.lex_state = 58},
  [289] = {.lex_state = 58},
  [290] = {.lex_state = 58},
  [291] = {.lex_state = 58},
  [292] = {.lex_state = 58},
  [293] = {.lex_state = 58},
  [294] = {.lex_state = 58},
  [295] = {.lex_state = 58},
  [296] = {.lex_state = 58},
  [297] = {.lex_state = 58},
  [298] = {.lex_state = 58},
  [299] = {.lex_state = 58},
  [300] = {.lex_state = 58},
  [301] = {.lex_state = 58},
  [302] = {.lex_state = 58},
  [303] = {.lex_state = 58},
  [304] = {.lex_state = 58},
  [305] = {.lex_state = 58},
  [306] = {.lex_state = 58},
  [307] = {.lex_state = 58},
  [308] = {.lex_state = 58},
  [309] = {.lex_state = 58},
  [310] = {.lex_state = 58},
  [311] = {.lex_state = 58},
  [312] = {.lex_state = 58},
  [313] = {.lex_state = 58},
  [314] = {.lex_state = 58},
  [315] = {.lex_state = 58},
  [316] = {.lex_state = 58},
  [317] = {.lex_state = 58},
  [318] = {.lex_state = 58},
  [319] = {.lex_state = 58},
  [320] = {.lex_state = 58},
  [321] = {.lex_state = 58},
  [322] = {.lex_state = 58},
  [323] = {.lex_state = 58},
  [324] = {.lex_state = 58},
  [325] = {.lex_state = 58},
  [326] = {.lex_state = 58},
  [327] = {.lex_state = 58},
  [328] = {.lex_state = 58},
  [329] = {.lex_state = 58},
  [330] = {.lex_state = 58},
  [331] = {.lex_state = 58},
  [332] = {.lex_state = 58},
  [333] = {.lex_state = 58},
  [334] = {.lex_state = 58},
  [335] = {.lex_state = 58},
  [336] = {.lex_state = 58},
  [337] = {.lex_state = 58},
  [338] = {.lex_state = 58},
  [339] = {.lex_state = 58},
  [340] = {.lex_state = 58},
  [341] = {.lex_state = 58},
  [342] = {.lex_state = 58},
  [343] = {.lex_state = 58},
  [344] = {.lex_state = 58},
  [345] = {.lex_state = 58},
  [346] = {.lex_state = 58},
  [347] = {.lex_state = 58},
  [348] = {.lex_state = 58},
  [349] = {.lex_state = 58},
  [350] = {.lex_state = 58},
  [351] = {.lex_state = 58},
  [352] = {.lex_state = 58},
  [353] = {.lex_state = 58},
  [354] = {.lex_state = 58},
  [355] = {.lex_state = 58},
  [356] = {.lex_state = 58},
  [357] = {.lex_state = 58},
  [358] = {.lex_state = 58},
  [359] = {.lex_state = 58},
  [360] = {.lex_state = 58},
  [361] = {.lex_state = 58},
  [362] = {.lex_state = 58},
  [363] = {.lex_state = 58},
  [364] = {.lex_state = 58},
  [365] = {.lex_state = 58},
  [366] = {.lex_state = 58},
  [367] = {.lex_state = 58},
  [368] = {.lex_state = 58},
  [369] = {.lex_state = 58},
  [370] = {.lex_state = 58},
  [371] = {.lex_state = 58},
  [372] = {.lex_state = 58},
  [373] = {.lex_state = 58},
  [374] = {.lex_state = 58},
  [375] = {.lex_state = 58},
  [376] = {.lex_state = 58},
  [377] = {.lex_state = 58},
  [378] = {.lex_state = 58},
  [379] = {.lex_state = 58},
  [380] = {.lex_state = 58},
  [381] = {.lex_state = 58},
  [382] = {.lex_state = 58},
  [383] = {.lex_state = 58},
  [384] = {.lex_state = 58},
  [385] = {.lex_state = 58},
  [386] = {.lex_state = 58},
  [387] = {.lex_state = 58},
  [388] = {.lex_state = 58},
  [389] = {.lex_state = 58},
  [390] = {.lex_state = 58},
  [391] = {.lex_state = 58},
  [392] = {.lex_state = 58},
  [393] = {.lex_state = 58},
  [394] = {.lex_state = 58},
  [395] = {.lex_state = 58},
  [396] = {.lex_state = 58},
  [397] = {.lex_state = 58},
  [398] = {.lex_state = 58},
  [399] = {.lex_state = 58},
  [400] = {.lex_state = 58},
  [401] = {.lex_state = 58},
  [402] = {.lex_state = 58},
  [403] = {.lex_state = 58},
  [404] = {.lex_state = 58},
  [405] = {.lex_state = 58},
  [406] = {.lex_state = 58},
  [407] = {.lex_state = 58},
  [408] = {.lex_state = 58},
  [409] = {.lex_state = 58},
  [410] = {.lex_state = 58},
  [411] = {.lex_state = 58},
  [412] = {.lex_state = 58},
  [413] = {.lex_state = 58},
  [414] = {.lex_state = 58},
  [415] = {.lex_state = 58},
  [416] = {.lex_state = 58},
  [417] = {.lex_state = 58},
  [418] = {.lex_state = 58},
  [419] = {.lex_state = 58},
  [420] = {.lex_state = 58},
  [421] = {.lex_state = 58},
  [422] = {.lex_state = 58},
  [423] = {.lex_state = 58},
  [424] = {.lex_state = 58},
  [425] = {.lex_state = 58},
  [426] = {.lex_state = 58},
  [427] = {.lex_state = 58},
  [428] = {.lex_state = 58},
  [429] = {.lex_state = 58},
  [430] = {.lex_state = 58},
  [431] = {.lex_state = 58},
  [432] = {.lex_state = 58},
  [433] = {.lex_state = 58},
  [434] = {.lex_state = 58},
  [435] = {.lex_state = 58},
  [436] = {.lex_state = 58},
  [437] = {.lex_state = 58},
  [438] = {.lex_state = 58},
  [439] = {.lex_state = 58},
  [440] = {.lex_state = 58},
  [441] = {.lex_state = 58},
  [442] = {.lex_state = 58},
  [443] = {.lex_state = 58},
  [444] = {.lex_state = 58},
  [445] = {.lex_state = 58},
  [446] = {.lex_state = 58},
  [447] = {.lex_state = 58},
  [448] = {.lex_state = 58},
  [449] = {.lex_state = 58},
  [450] = {.lex_state = 58},
  [451] = {.lex_state = 58},
  [452] = {.lex_state = 58},
  [453] = {.lex_state = 58},
  [454] = {.lex_state = 58},
  [455] = {.lex_state = 58},
  [456] = {.lex_state = 58},
  [457] = {.lex_state = 58},
  [458] = {.lex_state = 58},
  [459] = {.lex_state = 58},
  [460] = {.lex_state = 58},
  [461] = {.lex_state = 58},
  [462] = {.lex_state = 58},
  [463] = {.lex_state = 58},
  [464] = {.lex_state = 58},
  [465] = {.lex_state = 58},
  [466] = {.lex_state = 58},
  [467] = {.lex_state = 58},
  [468] = {.lex_state = 58},
  [469] = {.lex_state = 58},
  [470] = {.lex_state = 58},
  [471] = {.lex_state = 58},
  [472] = {.lex_state = 58},
  [473] = {.lex_state = 58},
  [474] = {.lex_state = 58},
  [475] = {.lex_state = 58},
  [476] = {.lex_state = 58},
  [477] = {.lex_state = 58},
  [478] = {.lex_state = 58},
  [479] = {.lex_state = 58},
  [480] = {.lex_state = 58},
  [481] = {.lex_state = 58},
  [482] = {.lex_state = 58},
  [483] = {.lex_state = 58},
  [484] = {.lex_state = 58},
  [485] = {.lex_state = 58},
  [486] = {.lex_state = 58},
  [487] = {.lex_state = 58},
  [488] = {.lex_state = 58},
  [489] = {.lex_state = 58},
  [490] = {.lex_state = 58},
  [491] = {.lex_state = 58},
  [492] = {.lex_state = 58},
  [493] = {.lex_state = 58},
  [494] = {.lex_state = 58},
  [495] = {.lex_state = 58},
  [496] = {.lex_state = 58},
  [497] = {.lex_state = 58},
  [498] = {.lex_state = 58},
  [499] = {.lex_state = 58},
  [500] = {.lex_state = 58},
  [501] = {.lex_state = 58},
  [502] = {.lex_state = 58},
  [503] = {.lex_state = 58},
  [504] = {.lex_state = 58},
  [505] = {.lex_state = 58},
  [506] = {.lex_state = 58},
  [507] = {.lex_state = 58},
  [508] = {.lex_state = 58},
  [509] = {.lex_state = 58},
  [510] = {.lex_state = 58},
  [511] = {.lex_state = 58},
  [512] = {.lex_state = 58},
  [513] = {.lex_state = 58},
  [514] = {.lex_state = 58},
  [515] = {.lex_state = 58},
  [516] = {.lex_state = 58},
  [517] = {.lex_state = 58},
  [518] = {.lex_state = 58},
  [519] = {.lex_state = 58},
  [520] = {.lex_state = 58},
  [521] = {.lex_state = 58},
  [522] = {.lex_state = 58},
  [523] = {.lex_state = 58},
  [524] = {.lex_state = 58},
  [525] = {.lex_state = 58},
  [526] = {.lex_state = 58},
  [527] = {.lex_state = 58},
  [528] = {.lex_state = 58},
  [529] = {.lex_state = 58},
  [530] = {.lex_state = 58},
  [531] = {.lex_state = 58},
  [532] = {.lex_state = 58},
  [533] = {.lex_state = 58},
  [534] = {.lex_state = 58},
  [535] = {.lex_state = 58},
  [536] = {.lex_state = 58},
  [537] = {.lex_state = 58},
  [538] = {.lex_state = 58},
  [539] = {.lex_state = 58},
  [540] = {.lex_state = 58},
  [541] = {.lex_state = 58},
  [542] = {.lex_state = 58},
  [543] = {.lex_state = 58},
  [544] = {.lex_state = 58},
  [545] = {.lex_state = 58},
  [546] = {.lex_state = 58},
  [547] = {.lex_state = 58},
  [548] = {.lex_state = 58},
  [549] = {.lex_state = 58},
  [550] = {.lex_state = 58},
  [551] = {.lex_state = 58},
  [552] = {.lex_state = 58},
  [553] = {.lex_state = 58},
  [554] = {.lex_state = 58},
  [555] = {.lex_state = 58},
  [556] = {.lex_state = 58},
  [557] = {.lex_state = 3},
  [558] = {.lex_state = 58},
  [559] = {.lex_state = 58},
  [560] = {.lex_state = 58},
  [561] = {.lex_state = 58},
  [562] = {.lex_state = 58},
  [563] = {.lex_state = 58},
  [564] = {.lex_state = 58},
  [565] = {.lex_state = 58},
  [566] = {.lex_state = 58},
  [567] = {.lex_state = 58},
  [568] = {.lex_state = 58},
  [569] = {.lex_state = 58},
  [570] = {.lex_state = 58},
  [571] = {.lex_state = 58},
  [572] = {.lex_state = 58},
  [573] = {.lex_state = 58},
  [574] = {.lex_state = 58},
  [575] = {.lex_state = 58},
  [576] = {.lex_state = 58},
  [577] = {.lex_state = 58},
  [578] = {.lex_state = 58},
  [579] = {.lex_state = 58},
  [580] = {.lex_state = 58},
  [581] = {.lex_state = 58},
  [582] = {.lex_state = 58},
  [583] = {.lex_state = 58},
  [584] = {.lex_state = 58},
  [585] = {.lex_state = 58},
  [586] = {.lex_state = 58},
  [587] = {.lex_state = 58},
  [588] = {.lex_state = 58},
  [589] = {.lex_state = 58},
  [590] = {.lex_state = 58},
  [591] = {.lex_state = 58},
  [592] = {.lex_state = 58},
  [593] = {.lex_state = 58},
  [594] = {.lex_state = 58},
  [595] = {.lex_state = 58},
  [596] = {.lex_state = 58},
  [597] = {.lex_state = 58},
  [598] = {.lex_state = 58},
  [599] = {.lex_state = 58},
  [600] = {.lex_state = 58},
  [601] = {.lex_state = 58},
  [602] = {.lex_state = 58},
  [603] = {.lex_state = 58},
  [604] = {.lex_state = 58},
  [605] = {.lex_state = 58},
  [606] = {.lex_state = 58},
  [607] = {.lex_state = 58},
  [608] = {.lex_state = 58},
  [609] = {.lex_state = 58},
  [610] = {.lex_state = 58},
  [611] = {.lex_state = 58},
  [612] = {.lex_state = 58},
  [613] = {.lex_state = 58},
  [614] = {.lex_state = 58},
  [615] = {.lex_state = 3},
  [616] = {.lex_state = 58},
  [617] = {.lex_state = 58},
  [618] = {.lex_state = 58},
  [619] = {.lex_state = 58},
  [620] = {.lex_state = 58},
  [621] = {.lex_state = 58},
  [622] = {.lex_state = 58},
  [623] = {.lex_state = 58},
  [624] = {.lex_state = 58},
  [625] = {.lex_state = 58},
  [626] = {.lex_state = 58},
  [627] = {.lex_state = 58},
  [628] = {.lex_state = 58},
  [629] = {.lex_state = 58},
  [630] = {.lex_state = 58},
  [631] = {.lex_state = 58},
  [632] = {.lex_state = 58},
  [633] = {.lex_state = 58},
  [634] = {.lex_state = 58},
  [635] = {.lex_state = 58},
  [636] = {.lex_state = 58},
  [637] = {.lex_state = 58},
  [638] = {.lex_state = 58},
  [639] = {.lex_state = 58},
  [640] = {.lex_state = 58},
  [641] = {.lex_state = 58},
  [642] = {.lex_state = 58},
  [643] = {.lex_state = 58},
  [644] = {.lex_state = 58},
  [645] = {.lex_state = 58},
  [646] = {.lex_state = 58},
  [647] = {.lex_state = 58},
  [648] = {.lex_state = 58},
  [649] = {.lex_state = 58},
  [650] = {.lex_state = 58},
  [651] = {.lex_state = 58},
  [652] = {.lex_state = 58},
  [653] = {.lex_state = 58},
  [654] = {.lex_state = 58},
  [655] = {.lex_state = 58},
  [656] = {.lex_state = 58},
  [657] = {.lex_state = 58},
  [658] = {.lex_state = 58},
  [659] = {.lex_state = 58},
  [660] = {.lex_state = 58},
  [661] = {.lex_state = 58},
  [662] = {.lex_state = 58},
  [663] = {.lex_state = 58},
  [664] = {.lex_state = 58},
  [665] = {.lex_state = 58},
  [666] = {.lex_state = 58},
  [667] = {.lex_state = 58},
  [668] = {.lex_state = 58},
  [669] = {.lex_state = 58},
  [670] = {.lex_state = 58},
  [671] = {.lex_state = 58},
  [672] = {.lex_state = 58},
  [673] = {.lex_state = 58},
  [674] = {.lex_state = 58},
  [675] = {.lex_state = 58},
  [676] = {.lex_state = 58},
  [677] = {.lex_state = 58},
  [678] = {.lex_state = 58},
  [679] = {.lex_state = 58},
  [680] = {.lex_state = 58},
  [681] = {.lex_state = 58},
  [682] = {.lex_state = 58},
  [683] = {.lex_state = 58},
  [684] = {.lex_state = 58},
  [685] = {.lex_state = 58},
  [686] = {.lex_state = 58},
  [687] = {.lex_state = 58},
  [688] = {.lex_state = 58},
  [689] = {.lex_state = 58},
  [690] = {.lex_state = 58},
  [691] = {.lex_state = 58},
  [692] = {.lex_state = 58},
  [693] = {.lex_state = 58},
  [694] = {.lex_state = 58},
  [695] = {.lex_state = 58},
  [696] = {.lex_state = 58},
  [697] = {.lex_state = 58},
  [698] = {.lex_state = 58},
  [699] = {.lex_state = 58},
  [700] = {.lex_state = 58},
  [701] = {.lex_state = 58},
  [702] = {.lex_state = 58},
  [703] = {.lex_state = 58},
  [704] = {.lex_state = 58},
  [705] = {.lex_state = 58},
  [706] = {.lex_state = 58},
  [707] = {.lex_state = 58},
  [708] = {.lex_state = 58},
  [709] = {.lex_state = 58},
  [710] = {.lex_state = 58},
  [711] = {.lex_state = 58},
  [712] = {.lex_state = 58},
  [713] = {.lex_state = 58},
  [714] = {.lex_state = 58},
  [715] = {.lex_state = 58},
  [716] = {.lex_state = 58},
  [717] = {.lex_state = 58},
  [718] = {.lex_state = 58},
  [719] = {.lex_state = 58},
  [720] = {.lex_state = 58},
  [721] = {.lex_state = 58},
  [722] = {.lex_state = 58},
  [723] = {.lex_state = 58},
  [724] = {.lex_state = 58},
  [725] = {.lex_state = 58},
  [726] = {.lex_state = 58},
  [727] = {.lex_state = 58},
  [728] = {.lex_state = 58},
  [729] = {.lex_state = 58},
  [730] = {.lex_state = 58},
  [731] = {.lex_state = 58},
  [732] = {.lex_state = 58},
  [733] = {.lex_state = 58},
  [734] = {.lex_state = 58},
  [735] = {.lex_state = 58},
  [736] = {.lex_state = 58},
  [737] = {.lex_state = 58},
  [738] = {.lex_state = 58},
  [739] = {.lex_state = 58},
  [740] = {.lex_state = 58},
  [741] = {.lex_state = 58},
  [742] = {.lex_state = 58},
  [743] = {.lex_state = 58},
  [744] = {.lex_state = 58},
  [745] = {.lex_state = 58},
  [746] = {.lex_state = 58},
  [747] = {.lex_state = 58},
  [748] = {.lex_state = 58},
  [749] = {.lex_state = 58},
  [750] = {.lex_state = 58},
  [751] = {.lex_state = 58},
  [752] = {.lex_state = 58},
  [753] = {.lex_state = 58},
  [754] = {.lex_state = 58},
  [755] = {.lex_state = 58},
  [756] = {.lex_state = 58},
  [757] = {.lex_state = 58},
  [758] = {.lex_state = 58},
  [759] = {.lex_state = 58},
  [760] = {.lex_state = 58},
  [761] = {.lex_state = 58},
  [762] = {.lex_state = 58},
  [763] = {.lex_state = 58},
  [764] = {.lex_state = 58},
  [765] = {.lex_state = 58},
  [766] = {.lex_state = 58},
  [767] = {.lex_state = 58},
  [768] = {.lex_state = 58},
  [769] = {.lex_state = 58},
  [770] = {.lex_state = 58},
  [771] = {.lex_state = 58},
  [772] = {.lex_state = 58},
  [773] = {.lex_state = 58},
  [774] = {.lex_state = 58},
  [775] = {.lex_state = 58},
  [776] = {.lex_state = 58},
  [777] = {.lex_state = 58},
  [778] = {.lex_state = 58},
  [779] = {.lex_state = 58},
  [780] = {.lex_state = 58},
  [781] = {.lex_state = 58},
  [782] = {.lex_state = 58},
  [783] = {.lex_state = 58},
  [784] = {.lex_state = 58},
  [785] = {.lex_state = 58},
  [786] = {.lex_state = 58},
  [787] = {.lex_state = 58},
  [788] = {.lex_state = 58},
  [789] = {.lex_state = 58},
  [790] = {.lex_state = 58},
  [791] = {.lex_state = 58},
  [792] = {.lex_state = 58},
  [793] = {.lex_state = 58},
  [794] = {.lex_state = 58},
  [795] = {.lex_state = 58},
  [796] = {.lex_state = 58},
  [797] = {.lex_state = 58},
  [798] = {.lex_state = 58},
  [799] = {.lex_state = 58},
  [800] = {.lex_state = 3},
  [801] = {.lex_state = 58},
  [802] = {.lex_state = 58},
  [803] = {.lex_state = 58},
  [804] = {.lex_state = 58},
  [805] = {.lex_state = 58},
  [806] = {.lex_state = 58},
  [807] = {.lex_state = 58},
  [808] = {.lex_state = 58},
  [809] = {.lex_state = 58},
  [810] = {.lex_state = 58},
  [811] = {.lex_state = 58},
  [812] = {.lex_state = 58},
  [813] = {.lex_state = 58},
  [814] = {.lex_state = 58},
  [815] = {.lex_state = 58},
  [816] = {.lex_state = 58},
  [817] = {.lex_state = 58},
  [818] = {.lex_state = 58},
  [819] = {.lex_state = 58},
  [820] = {.lex_state = 58},
  [821] = {.lex_state = 58},
  [822] = {.lex_state = 58},
  [823] = {.lex_state = 58},
  [824] = {.lex_state = 58},
  [825] = {.lex_state = 58},
  [826] = {.lex_state = 58},
  [827] = {.lex_state = 58},
  [828] = {.lex_state = 58},
  [829] = {.lex_state = 58},
  [830] = {.lex_state = 58},
  [831] = {.lex_state = 58},
  [832] = {.lex_state = 58},
  [833] = {.lex_state = 58},
  [834] = {.lex_state = 58},
  [835] = {.lex_state = 58},
  [836] = {.lex_state = 58},
  [837] = {.lex_state = 58},
  [838] = {.lex_state = 58},
  [839] = {.lex_state = 58},
  [840] = {.lex_state = 58},
  [841] = {.lex_state = 58},
  [842] = {.lex_state = 58},
  [843] = {.lex_state = 58},
  [844] = {.lex_state = 58},
  [845] = {.lex_state = 58},
  [846] = {.lex_state = 58},
  [847] = {.lex_state = 58},
  [848] = {.lex_state = 58},
  [849] = {.lex_state = 58},
  [850] = {.lex_state = 58},
  [851] = {.lex_state = 58},
  [852] = {.lex_state = 58},
  [853] = {.lex_state = 58},
  [854] = {.lex_state = 58},
  [855] = {.lex_state = 58},
  [856] = {.lex_state = 58},
  [857] = {.lex_state = 58},
  [858] = {.lex_state = 58},
  [859] = {.lex_state = 58},
  [860] = {.lex_state = 58},
  [861] = {.lex_state = 58},
  [862] = {.lex_state = 58},
  [863] = {.lex_state = 58},
  [864] = {.lex_state = 58},
  [865] = {.lex_state = 58},
  [866] = {.lex_state = 58},
  [867] = {.lex_state = 58},
  [868] = {.lex_state = 58},
  [869] = {.lex_state = 58},
  [870] = {.lex_state = 58},
  [871] = {.lex_state = 58},
  [872] = {.lex_state = 58},
  [873] = {.lex_state = 58},
  [874] = {.lex_state = 58},
  [875] = {.lex_state = 58},
  [876] = {.lex_state = 58},
  [877] = {.lex_state = 58},
  [878] = {.lex_state = 58},
  [879] = {.lex_state = 58},
  [880] = {.lex_state = 58},
  [881] = {.lex_state = 58},
  [882] = {.lex_state = 58},
  [883] = {.lex_state = 58},
  [884] = {.lex_state = 58},
  [885] = {.lex_state = 58},
  [886] = {.lex_state = 58},
  [887] = {.lex_state = 58},
  [888] = {.lex_state = 58},
  [889] = {.lex_state = 58},
  [890] = {.lex_state = 58},
  [891] = {.lex_state = 58},
  [892] = {.lex_state = 58},
  [893] = {.lex_state = 58},
  [894] = {.lex_state = 3},
  [895] = {.lex_state = 3},
  [896] = {.lex_state = 3},
  [897] = {.lex_state = 3},
  [898] = {.lex_state = 3},
  [899] = {.lex_state = 3},
  [900] = {.lex_state = 58},
  [901] = {.lex_state = 3},
  [902] = {.lex_state = 3},
  [903] = {.lex_state = 4},
  [904] = {.lex_state = 3},
  [905] = {.lex_state = 4},
  [906] = {.lex_state = 4},
  [907] = {.lex_state = 4},
  [908] = {.lex_state = 4},
  [909] = {.lex_state = 4},
  [910] = {.lex_state = 4},
  [911] = {.lex_state = 3},
  [912] = {.lex_state = 3},
  [913] = {.lex_state = 3},
  [914] = {.lex_state = 3},
  [915] = {.lex_state = 3},
  [916] = {.lex_state = 3},
  [917] = {.lex_state = 4},
  [918] = {.lex_state = 3},
  [919] = {.lex_state = 3},
  [920] = {.lex_state = 3},
  [921] = {.lex_state = 3},
  [922] = {.lex_state = 3},
  [923] = {.lex_state = 4},
  [924] = {.lex_state = 3},
  [925] = {.lex_state = 3},
  [926] = {.lex_state = 4},
  [927] = {.lex_state = 3},
  [928] = {.lex_state = 3},
  [929] = {.lex_state = 4},
  [930] = {.lex_state = 4},
  [931] = {.lex_state = 3},
  [932] = {.lex_state = 4},
  [933] = {.lex_state = 3},
  [934] = {.lex_state = 3},
  [935] = {.lex_state = 3},
  [936] = {.lex_state = 3},
  [937] = {.lex_state = 3},
  [938] = {.lex_state = 3},
  [939] = {.lex_state = 4},
  [940] = {.lex_state = 3},
  [941] = {.lex_state = 3},
  [942] = {.lex_state = 3},
  [943] = {.lex_state = 4},
  [944] = {.lex_state = 3},
  [945] = {.lex_state = 3},
  [946] = {.lex_state = 3},
  [947] = {.lex_state = 3},
  [948] = {.lex_state = 3},
  [949] = {.lex_state = 3},
  [950] = {.lex_state = 3},
  [951] = {.lex_state = 3},
  [952] = {.lex_state = 3},
  [953] = {.lex_state = 3},
  [954] = {.lex_state = 3},
  [955] = {.lex_state = 3},
  [956] = {.lex_state = 3},
  [957] = {.lex_state = 3},
  [958] = {.lex_state = 3},
  [959] = {.lex_state = 3},
  [960] = {.lex_state = 3},
  [961] = {.lex_state = 3},
  [962] = {.lex_state = 3},
  [963] = {.lex_state = 3},
  [964] = {.lex_state = 3},
  [965] = {.lex_state = 3},
  [966] = {.lex_state = 3},
  [967] = {.lex_state = 3},
  [968] = {.lex_state = 3},
  [969] = {.lex_state = 3},
  [970] = {.lex_state = 3},
  [971] = {.lex_state = 3},
  [972] = {.lex_state = 3},
  [973] = {.lex_state = 3},
  [974] = {.lex_state = 3},
  [975] = {.lex_state = 3},
  [976] = {.lex_state = 3},
  [977] = {.lex_state = 3},
  [978] = {.lex_state = 3},
  [979] = {.lex_state = 3},
  [980] = {.lex_state = 3},
  [981] = {.lex_state = 3},
  [982] = {.lex_state = 3},
  [983] = {.lex_state = 3},
  [984] = {.lex_state = 3},
  [985] = {.lex_state = 3},
  [986] = {.lex_state = 3},
  [987] = {.lex_state = 3},
  [988] = {.lex_state = 3},
  [989] = {.lex_state = 3},
  [990] = {.lex_state = 3},
  [991] = {.lex_state = 3},
  [992] = {.lex_state = 3},
  [993] = {.lex_state = 3},
  [994] = {.lex_state = 3},
  [995] = {.lex_state = 3},
  [996] = {.lex_state = 3},
  [997] = {.lex_state = 3},
  [998] = {.lex_state = 3},
  [999] = {.lex_state = 3},
  [1000] = {.lex_state = 3},
  [1001] = {.lex_state = 3},
  [1002] = {.lex_state = 3},
  [1003] = {.lex_state = 3},
  [1004] = {.lex_state = 3},
  [1005] = {.lex_state = 3},
  [1006] = {.lex_state = 3},
  [1007] = {.lex_state = 3},
  [1008] = {.lex_state = 3},
  [1009] = {.lex_state = 3},
  [1010] = {.lex_state = 3},
  [1011] = {.lex_state = 3},
  [1012] = {.lex_state = 3},
  [1013] = {.lex_state = 3},
  [1014] = {.lex_state = 3},
  [1015] = {.lex_state = 3},
  [1016] = {.lex_state = 3},
  [1017] = {.lex_state = 3},
  [1018] = {.lex_state = 3},
  [1019] = {.lex_state = 3},
  [1020] = {.lex_state = 4},
  [1021] = {.lex_state = 4},
  [1022] = {.lex_state = 4},
  [1023] = {.lex_state = 5},
  [1024] = {.lex_state = 5},
  [1025] = {.lex_state = 5},
  [1026] = {.lex_state = 5},
  [1027] = {.lex_state = 5},
  [1028] = {.lex_state = 6},
  [1029] = {.lex_state = 5},
  [1030] = {.lex_state = 5},
  [1031] = {.lex_state = 5},
  [1032] = {.lex_state = 5},
  [1033] = {.lex_state = 5},
  [1034] = {.lex_state = 5},
  [1035] = {.lex_state = 5},
  [1036] = {.lex_state = 5},
  [1037] = {.lex_state = 5},
  [1038] = {.lex_state = 5},
  [1039] = {.lex_state = 5},
  [1040] = {.lex_state = 5},
  [1041] = {.lex_state = 5},
  [1042] = {.lex_state = 5},
  [1043] = {.lex_state = 5},
  [1044] = {.lex_state = 5},
  [1045] = {.lex_state = 5},
  [1046] = {.lex_state = 5},
  [1047] = {.lex_state = 5},
  [1048] = {.lex_state = 5},
  [1049] = {.lex_state = 5},
  [1050] = {.lex_state = 5},
  [1051] = {.lex_state = 5},
  [1052] = {.lex_state = 5},
  [1053] = {.lex_state = 5},
  [1054] = {.lex_state = 5},
  [1055] = {.lex_state = 5},
  [1056] = {.lex_state = 5},
  [1057] = {.lex_state = 5},
  [1058] = {.lex_state = 5},
  [1059] = {.lex_state = 5},
  [1060] = {.lex_state = 5},
  [1061] = {.lex_state = 5},
  [1062] = {.lex_state = 5},
  [1063] = {.lex_state = 5},
  [1064] = {.lex_state = 5},
  [1065] = {.lex_state = 5},
  [1066] = {.lex_state = 5},
  [1067] = {.lex_state = 5},
  [1068] = {.lex_state = 5},
  [1069] = {.lex_state = 5},
  [1070] = {.lex_state = 5},
  [1071] = {.lex_state = 5},
  [1072] = {.lex_state = 5},
  [1073] = {.lex_state = 5},
  [1074] = {.lex_state = 5},
  [1075] = {.lex_state = 5},
  [1076] = {.lex_state = 5},
  [1077] = {.lex_state = 5},
  [1078] = {.lex_state = 5},
  [1079] = {.lex_state = 5},
  [1080] = {.lex_state = 5},
  [1081] = {.lex_state = 5},
  [1082] = {.lex_state = 5},
  [1083] = {.lex_state = 5},
  [1084] = {.lex_state = 5},
  [1085] = {.lex_state = 5},
  [1086] = {.lex_state = 5},
  [1087] = {.lex_state = 5},
  [1088] = {.lex_state = 5},
  [1089] = {.lex_state = 5},
  [1090] = {.lex_state = 5},
  [1091] = {.lex_state = 5},
  [1092] = {.lex_state = 5},
  [1093] = {.lex_state = 5},
  [1094] = {.lex_state = 5},
  [1095] = {.lex_state = 5},
  [1096] = {.lex_state = 5},
  [1097] = {.lex_state = 5},
  [1098] = {.lex_state = 5},
  [1099] = {.lex_state = 5},
  [1100] = {.lex_state = 5},
  [1101] = {.lex_state = 5},
  [1102] = {.lex_state = 5},
  [1103] = {.lex_state = 5},
  [1104] = {.lex_state = 5},
  [1105] = {.lex_state = 5},
  [1106] = {.lex_state = 5},
  [1107] = {.lex_state = 5},
  [1108] = {.lex_state = 5},
  [1109] = {.lex_state = 5},
  [1110] = {.lex_state = 5},
  [1111] = {.lex_state = 5},
  [1112] = {.lex_state = 5},
  [1113] = {.lex_state = 5},
  [1114] = {.lex_state = 5},
  [1115] = {.lex_state = 5},
  [1116] = {.lex_state = 5},
  [1117] = {.lex_state = 5},
  [1118] = {.lex_state = 5},
  [1119] = {.lex_state = 5},
  [1120] = {.lex_state = 5},
  [1121] = {.lex_state = 5},
  [1122] = {.lex_state = 5},
  [1123] = {.lex_state = 5},
  [1124] = {.lex_state = 5},
  [1125] = {.lex_state = 5},
  [1126] = {.lex_state = 5},
  [1127] = {.lex_state = 5},
  [1128] = {.lex_state = 5},
  [1129] = {.lex_state = 5},
  [1130] = {.lex_state = 5},
  [1131] = {.lex_state = 5},
  [1132] = {.lex_state = 5},
  [1133] = {.lex_state = 5},
  [1134] = {.lex_state = 5},
  [1135] = {.lex_state = 5},
  [1136] = {.lex_state = 5},
  [1137] = {.lex_state = 5},
  [1138] = {.lex_state = 5},
  [1139] = {.lex_state = 5},
  [1140] = {.lex_state = 5},
  [1141] = {.lex_state = 5},
  [1142] = {.lex_state = 5},
  [1143] = {.lex_state = 5},
  [1144] = {.lex_state = 5},
  [1145] = {.lex_state = 5},
  [1146] = {.lex_state = 5},
  [1147] = {.lex_state = 5},
  [1148] = {.lex_state = 5},
  [1149] = {.lex_state = 5},
  [1150] = {.lex_state = 5},
  [1151] = {.lex_state = 5},
  [1152] = {.lex_state = 5},
  [1153] = {.lex_state = 5},
  [1154] = {.lex_state = 5},
  [1155] = {.lex_state = 5},
  [1156] = {.lex_state = 5},
  [1157] = {.lex_state = 5},
  [1158] = {.lex_state = 5},
  [1159] = {.lex_state = 5},
  [1160] = {.lex_state = 5},
  [1161] = {.lex_state = 5},
  [1162] = {.lex_state = 5},
  [1163] = {.lex_state = 5},
  [1164] = {.lex_state = 5},
  [1165] = {.lex_state = 5},
  [1166] = {.lex_state = 5},
  [1167] = {.lex_state = 5},
  [1168] = {.lex_state = 5},
  [1169] = {.lex_state = 5},
  [1170] = {.lex_state = 5},
  [1171] = {.lex_state = 5},
  [1172] = {.lex_state = 3},
  [1173] = {.lex_state = 3},
  [1174] = {.lex_state = 4},
  [1175] = {.lex_state = 4},
  [1176] = {.lex_state = 4},
  [1177] = {.lex_state = 4},
  [1178] = {.lex_state = 4},
  [1179] = {.lex_state = 4},
  [1180] = {.lex_state = 4},
  [1181] = {.lex_state = 4},
  [1182] = {.lex_state = 4},
  [1183] = {.lex_state = 4},
  [1184] = {.lex_state = 4},
  [1185] = {.lex_state = 4},
  [1186] = {.lex_state = 4},
  [1187] = {.lex_state = 4},
  [1188] = {.lex_state = 4},
  [1189] = {.lex_state = 4},
  [1190] = {.lex_state = 4},
  [1191] = {.lex_state = 5},
  [1192] = {.lex_state = 5},
  [1193] = {.lex_state = 4},
  [1194] = {.lex_state = 4},
  [1195] = {.lex_state = 4},
  [1196] = {.lex_state = 4},
  [1197] = {.lex_state = 4},
  [1198] = {.lex_state = 4},
  [1199] = {.lex_state = 4},
  [1200] = {.lex_state = 4},
  [1201] = {.lex_state = 4},
  [1202] = {.lex_state = 4},
  [1203] = {.lex_state = 4},
  [1204] = {.lex_state = 4},
  [1205] = {.lex_state = 4},
  [1206] = {.lex_state = 4},
  [1207] = {.lex_state = 4},
  [1208] = {.lex_state = 4},
  [1209] = {.lex_state = 4},
  [1210] = {.lex_state = 2},
  [1211] = {.lex_state = 4},
  [1212] = {.lex_state = 4},
  [1213] = {.lex_state = 4},
  [1214] = {.lex_state = 4},
  [1215] = {.lex_state = 4},
  [1216] = {.lex_state = 4},
  [1217] = {.lex_state = 4},
  [1218] = {.lex_state = 4},
  [1219] = {.lex_state = 4},
  [1220] = {.lex_state = 4},
  [1221] = {.lex_state = 4},
  [1222] = {.lex_state = 4},
  [1223] = {.lex_state = 4},
  [1224] = {.lex_state = 4},
  [1225] = {.lex_state = 4},
  [1226] = {.lex_state = 4},
  [1227] = {.lex_state = 4},
  [1228] = {.lex_state = 3},
  [1229] = {.lex_state = 4},
  [1230] = {.lex_state = 4},
  [1231] = {.lex_state = 4},
  [1232] = {.lex_state = 4},
  [1233] = {.lex_state = 4},
  [1234] = {.lex_state = 4},
  [1235] = {.lex_state = 4},
  [1236] = {.lex_state = 4},
  [1237] = {.lex_state = 4},
  [1238] = {.lex_state = 58},
  [1239] = {.lex_state = 4},
  [1240] = {.lex_state = 5},
  [1241] = {.lex_state = 5},
  [1242] = {.lex_state = 5},
  [1243] = {.lex_state = 5},
  [1244] = {.lex_state = 5},
  [1245] = {.lex_state = 5},
  [1246] = {.lex_state = 4},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 4},
  [1249] = {.lex_state = 5},
  [1250] = {.lex_state = 5},
  [1251] = {.lex_state = 5},
  [1252] = {.lex_state = 3},
  [1253] = {.lex_state = 5},
  [1254] = {.lex_state = 5},
  [1255] = {.lex_state = 5},
  [1256] = {.lex_state = 5},
  [1257] = {.lex_state = 5},
  [1258] = {.lex_state = 5},
  [1259] = {.lex_state = 5},
  [1260] = {.lex_state = 5},
  [1261] = {.lex_state = 5},
  [1262] = {.lex_state = 5},
  [1263] = {.lex_state = 5},
  [1264] = {.lex_state = 5},
  [1265] = {.lex_state = 5},
  [1266] = {.lex_state = 5},
  [1267] = {.lex_state = 5},
  [1268] = {.lex_state = 4},
  [1269] = {.lex_state = 5},
  [1270] = {.lex_state = 5},
  [1271] = {.lex_state = 5},
  [1272] = {.lex_state = 5},
  [1273] = {.lex_state = 5},
  [1274] = {.lex_state = 4},
  [1275] = {.lex_state = 5},
  [1276] = {.lex_state = 5},
  [1277] = {.lex_state = 5},
  [1278] = {.lex_state = 5},
  [1279] = {.lex_state = 5},
  [1280] = {.lex_state = 5},
  [1281] = {.lex_state = 4},
  [1282] = {.lex_state = 5},
  [1283] = {.lex_state = 5},
  [1284] = {.lex_state = 5},
  [1285] = {.lex_state = 5},
  [1286] = {.lex_state = 5},
  [1287] = {.lex_state = 4},
  [1288] = {.lex_state = 5},
  [1289] = {.lex_state = 5},
  [1290] = {.lex_state = 5},
  [1291] = {.lex_state = 5},
  [1292] = {.lex_state = 5},
  [1293] = {.lex_state = 5},
  [1294] = {.lex_state = 5},
  [1295] = {.lex_state = 5},
  [1296] = {.lex_state = 5},
  [1297] = {.lex_state = 5},
  [1298] = {.lex_state = 4},
  [1299] = {.lex_state = 5},
  [1300] = {.lex_state = 5},
  [1301] = {.lex_state = 5},
  [1302] = {.lex_state = 5},
  [1303] = {.lex_state = 5},
  [1304] = {.lex_state = 5},
  [1305] = {.lex_state = 10},
  [1306] = {.lex_state = 4},
  [1307] = {.lex_state = 2},
  [1308] = {.lex_state = 10},
  [1309] = {.lex_state = 10},
  [1310] = {.lex_state = 10},
  [1311] = {.lex_state = 10},
  [1312] = {.lex_state = 10},
  [1313] = {.lex_state = 10},
  [1314] = {.lex_state = 10},
  [1315] = {.lex_state = 10},
  [1316] = {.lex_state = 10},
  [1317] = {.lex_state = 10},
  [1318] = {.lex_state = 10},
  [1319] = {.lex_state = 10},
  [1320] = {.lex_state = 4},
  [1321] = {.lex_state = 2},
  [1322] = {.lex_state = 10},
  [1323] = {.lex_state = 10},
  [1324] = {.lex_state = 10},
  [1325] = {.lex_state = 10},
  [1326] = {.lex_state = 10},
  [1327] = {.lex_state = 10},
  [1328] = {.lex_state = 4},
  [1329] = {.lex_state = 10},
  [1330] = {.lex_state = 2},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 10},
  [1333] = {.lex_state = 4},
  [1334] = {.lex_state = 4},
  [1335] = {.lex_state = 10},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 4},
  [1338] = {.lex_state = 0},
  [1339] = {.lex_state = 4},
  [1340] = {.lex_state = 4},
  [1341] = {.lex_state = 4},
  [1342] = {.lex_state = 4},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 4},
  [1346] = {.lex_state = 10},
  [1347] = {.lex_state = 8},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 4},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 8},
  [1354] = {.lex_state = 9},
  [1355] = {.lex_state = 4},
  [1356] = {.lex_state = 4},
  [1357] = {.lex_state = 8},
  [1358] = {.lex_state = 9},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 0},
  [1364] = {.lex_state = 4},
  [1365] = {.lex_state = 10},
  [1366] = {.lex_state = 9},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 0},
  [1370] = {.lex_state = 0},
  [1371] = {.lex_state = 4},
  [1372] = {.lex_state = 5},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 4},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 10},
  [1377] = {.lex_state = 0},
  [1378] = {.lex_state = 4},
  [1379] = {.lex_state = 0},
  [1380] = {.lex_state = 8},
  [1381] = {.lex_state = 9},
  [1382] = {.lex_state = 4},
  [1383] = {.lex_state = 4},
  [1384] = {.lex_state = 4},
  [1385] = {.lex_state = 0},
  [1386] = {.lex_state = 0},
  [1387] = {.lex_state = 4},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 4},
  [1390] = {.lex_state = 4},
  [1391] = {.lex_state = 4},
  [1392] = {.lex_state = 0},
  [1393] = {.lex_state = 10},
  [1394] = {.lex_state = 10},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 4},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 0},
  [1400] = {.lex_state = 9},
  [1401] = {.lex_state = 4},
  [1402] = {.lex_state = 8},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 0},
  [1405] = {.lex_state = 0},
  [1406] = {.lex_state = 0},
  [1407] = {.lex_state = 0},
  [1408] = {.lex_state = 0},
  [1409] = {.lex_state = 0},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 0},
  [1412] = {.lex_state = 0},
  [1413] = {.lex_state = 0},
  [1414] = {.lex_state = 0},
  [1415] = {.lex_state = 0},
  [1416] = {.lex_state = 0},
  [1417] = {.lex_state = 0},
  [1418] = {.lex_state = 4},
  [1419] = {.lex_state = 0},
  [1420] = {.lex_state = 10},
  [1421] = {.lex_state = 10},
  [1422] = {.lex_state = 0},
  [1423] = {.lex_state = 58},
  [1424] = {.lex_state = 4},
  [1425] = {.lex_state = 4},
  [1426] = {.lex_state = 4},
  [1427] = {.lex_state = 4},
  [1428] = {.lex_state = 0},
  [1429] = {.lex_state = 0},
  [1430] = {.lex_state = 0},
  [1431] = {.lex_state = 0},
  [1432] = {.lex_state = 4},
  [1433] = {.lex_state = 0},
  [1434] = {.lex_state = 0},
  [1435] = {.lex_state = 0},
  [1436] = {.lex_state = 58},
  [1437] = {.lex_state = 0},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 4},
  [1440] = {.lex_state = 0},
  [1441] = {.lex_state = 0},
  [1442] = {.lex_state = 0},
  [1443] = {.lex_state = 0},
  [1444] = {.lex_state = 4},
  [1445] = {.lex_state = 4},
  [1446] = {.lex_state = 4},
  [1447] = {.lex_state = 10},
  [1448] = {.lex_state = 4},
  [1449] = {.lex_state = 0},
  [1450] = {.lex_state = 58},
  [1451] = {.lex_state = 0},
  [1452] = {.lex_state = 4},
  [1453] = {.lex_state = 4},
  [1454] = {.lex_state = 0},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 0},
  [1457] = {.lex_state = 0},
  [1458] = {.lex_state = 0},
  [1459] = {.lex_state = 0},
  [1460] = {.lex_state = 4},
  [1461] = {.lex_state = 0},
  [1462] = {.lex_state = 4},
  [1463] = {.lex_state = 0},
  [1464] = {.lex_state = 0},
  [1465] = {.lex_state = 0},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 4},
  [1468] = {.lex_state = 4},
  [1469] = {.lex_state = 4},
  [1470] = {.lex_state = 10},
  [1471] = {.lex_state = 0},
  [1472] = {.lex_state = 4},
  [1473] = {.lex_state = 0},
  [1474] = {.lex_state = 0},
  [1475] = {.lex_state = 0},
  [1476] = {.lex_state = 0},
  [1477] = {.lex_state = 0},
  [1478] = {.lex_state = 0},
  [1479] = {.lex_state = 0},
  [1480] = {.lex_state = 0},
  [1481] = {.lex_state = 0},
  [1482] = {.lex_state = 4},
  [1483] = {.lex_state = 0},
  [1484] = {.lex_state = 0},
  [1485] = {.lex_state = 4},
  [1486] = {.lex_state = 0},
  [1487] = {.lex_state = 58},
  [1488] = {.lex_state = 4},
  [1489] = {.lex_state = 58},
  [1490] = {.lex_state = 4},
  [1491] = {.lex_state = 0},
  [1492] = {.lex_state = 4},
  [1493] = {.lex_state = 0},
  [1494] = {.lex_state = 0},
  [1495] = {.lex_state = 4},
  [1496] = {.lex_state = 0},
  [1497] = {.lex_state = 58},
  [1498] = {.lex_state = 0},
  [1499] = {.lex_state = 4},
  [1500] = {.lex_state = 4},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 0},
  [1503] = {.lex_state = 0},
  [1504] = {.lex_state = 4},
  [1505] = {.lex_state = 0},
  [1506] = {.lex_state = 0},
  [1507] = {.lex_state = 0},
  [1508] = {.lex_state = 0},
  [1509] = {.lex_state = 0},
  [1510] = {.lex_state = 4},
  [1511] = {.lex_state = 4},
  [1512] = {.lex_state = 0},
  [1513] = {.lex_state = 0},
  [1514] = {.lex_state = 0},
  [1515] = {.lex_state = 0},
  [1516] = {.lex_state = 4},
  [1517] = {.lex_state = 0},
  [1518] = {.lex_state = 4},
  [1519] = {.lex_state = 10},
  [1520] = {.lex_state = 0},
  [1521] = {.lex_state = 0},
  [1522] = {.lex_state = 4},
  [1523] = {.lex_state = 0},
  [1524] = {.lex_state = 0},
  [1525] = {.lex_state = 0},
  [1526] = {.lex_state = 0},
  [1527] = {.lex_state = 0},
  [1528] = {.lex_state = 4},
  [1529] = {.lex_state = 0},
  [1530] = {.lex_state = 0},
  [1531] = {.lex_state = 0},
  [1532] = {.lex_state = 0},
  [1533] = {.lex_state = 0},
  [1534] = {.lex_state = 0},
  [1535] = {.lex_state = 0},
  [1536] = {.lex_state = 0},
  [1537] = {.lex_state = 4},
  [1538] = {.lex_state = 0},
  [1539] = {.lex_state = 0},
  [1540] = {.lex_state = 0},
  [1541] = {.lex_state = 4},
  [1542] = {.lex_state = 0},
  [1543] = {.lex_state = 0},
  [1544] = {.lex_state = 0},
  [1545] = {.lex_state = 0},
  [1546] = {.lex_state = 0},
  [1547] = {.lex_state = 0},
  [1548] = {.lex_state = 0},
  [1549] = {.lex_state = 0},
  [1550] = {.lex_state = 4},
  [1551] = {.lex_state = 0},
  [1552] = {.lex_state = 0},
  [1553] = {.lex_state = 0},
  [1554] = {.lex_state = 0},
  [1555] = {.lex_state = 0},
  [1556] = {.lex_state = 10},
  [1557] = {.lex_state = 0},
  [1558] = {.lex_state = 0},
  [1559] = {.lex_state = 0},
  [1560] = {.lex_state = 0},
  [1561] = {.lex_state = 0},
  [1562] = {.lex_state = 0},
  [1563] = {.lex_state = 0},
  [1564] = {.lex_state = 0},
  [1565] = {.lex_state = 4},
  [1566] = {.lex_state = 0},
  [1567] = {.lex_state = 10},
  [1568] = {.lex_state = 0},
  [1569] = {.lex_state = 0},
  [1570] = {.lex_state = 0},
  [1571] = {.lex_state = 0},
  [1572] = {.lex_state = 0},
  [1573] = {.lex_state = 0},
  [1574] = {.lex_state = 0},
  [1575] = {.lex_state = 0},
  [1576] = {.lex_state = 0},
  [1577] = {.lex_state = 10},
  [1578] = {.lex_state = 0},
  [1579] = {.lex_state = 4},
  [1580] = {.lex_state = 0},
  [1581] = {.lex_state = 4},
  [1582] = {.lex_state = 4},
  [1583] = {.lex_state = 0},
  [1584] = {.lex_state = 0},
  [1585] = {.lex_state = 0},
  [1586] = {.lex_state = 0},
  [1587] = {.lex_state = 0},
  [1588] = {.lex_state = 4},
  [1589] = {.lex_state = 0},
  [1590] = {.lex_state = 0},
  [1591] = {.lex_state = 10},
  [1592] = {.lex_state = 0},
  [1593] = {.lex_state = 4},
  [1594] = {.lex_state = 0},
  [1595] = {.lex_state = 0},
  [1596] = {.lex_state = 4},
  [1597] = {.lex_state = 4},
  [1598] = {.lex_state = 0},
  [1599] = {.lex_state = 4},
  [1600] = {.lex_state = 0},
  [1601] = {.lex_state = 0},
  [1602] = {.lex_state = 0},
  [1603] = {.lex_state = 4},
  [1604] = {.lex_state = 4},
  [1605] = {.lex_state = 4},
  [1606] = {.lex_state = 0},
  [1607] = {.lex_state = 0},
  [1608] = {.lex_state = 4},
  [1609] = {.lex_state = 0},
  [1610] = {.lex_state = 0},
  [1611] = {.lex_state = 58},
  [1612] = {.lex_state = 0},
  [1613] = {.lex_state = 0},
  [1614] = {.lex_state = 4},
  [1615] = {.lex_state = 4},
  [1616] = {.lex_state = 0},
  [1617] = {.lex_state = 0},
  [1618] = {.lex_state = 0},
  [1619] = {.lex_state = 0},
  [1620] = {.lex_state = 0},
  [1621] = {.lex_state = 0},
  [1622] = {.lex_state = 4},
  [1623] = {.lex_state = 4},
  [1624] = {.lex_state = 0},
  [1625] = {.lex_state = 58},
  [1626] = {.lex_state = 0},
  [1627] = {.lex_state = 4},
  [1628] = {.lex_state = 0},
  [1629] = {.lex_state = 0},
  [1630] = {.lex_state = 58},
  [1631] = {.lex_state = 4},
  [1632] = {.lex_state = 0},
  [1633] = {.lex_state = 58},
  [1634] = {.lex_state = 0},
  [1635] = {.lex_state = 0},
  [1636] = {.lex_state = 4},
  [1637] = {.lex_state = 4},
  [1638] = {.lex_state = 0},
  [1639] = {.lex_state = 0},
  [1640] = {.lex_state = 0},
  [1641] = {.lex_state = 0},
  [1642] = {.lex_state = 0},
  [1643] = {.lex_state = 0},
  [1644] = {.lex_state = 0},
  [1645] = {.lex_state = 0},
  [1646] = {.lex_state = 0},
  [1647] = {.lex_state = 4},
  [1648] = {.lex_state = 0},
  [1649] = {.lex_state = 4},
  [1650] = {.lex_state = 0},
  [1651] = {.lex_state = 0},
  [1652] = {.lex_state = 0},
  [1653] = {.lex_state = 0},
  [1654] = {.lex_state = 0},
  [1655] = {.lex_state = 0},
  [1656] = {.lex_state = 0},
  [1657] = {.lex_state = 0},
  [1658] = {.lex_state = 4},
  [1659] = {.lex_state = 0},
  [1660] = {.lex_state = 0},
  [1661] = {.lex_state = 4},
  [1662] = {.lex_state = 0},
  [1663] = {.lex_state = 0},
  [1664] = {.lex_state = 4},
  [1665] = {.lex_state = 4},
  [1666] = {.lex_state = 4},
  [1667] = {.lex_state = 0},
  [1668] = {.lex_state = 4},
  [1669] = {.lex_state = 4},
  [1670] = {.lex_state = 4},
  [1671] = {.lex_state = 4},
  [1672] = {.lex_state = 0},
  [1673] = {.lex_state = 4},
  [1674] = {.lex_state = 0},
  [1675] = {.lex_state = 4},
  [1676] = {.lex_state = 0},
  [1677] = {.lex_state = 4},
  [1678] = {.lex_state = 0},
  [1679] = {.lex_state = 4},
  [1680] = {.lex_state = 0},
  [1681] = {.lex_state = 4},
  [1682] = {.lex_state = 0},
  [1683] = {.lex_state = 0},
  [1684] = {.lex_state = 4},
  [1685] = {.lex_state = 4},
  [1686] = {.lex_state = 4},
  [1687] = {.lex_state = 4},
  [1688] = {.lex_state = 0},
  [1689] = {.lex_state = 0},
  [1690] = {.lex_state = 0},
  [1691] = {.lex_state = 4},
  [1692] = {.lex_state = 0},
  [1693] = {.lex_state = 0},
  [1694] = {.lex_state = 4},
  [1695] = {.lex_state = 0},
  [1696] = {.lex_state = 4},
  [1697] = {.lex_state = 4},
  [1698] = {.lex_state = 0},
  [1699] = {.lex_state = 0},
  [1700] = {.lex_state = 4},
  [1701] = {.lex_state = 4},
  [1702] = {.lex_state = 0},
  [1703] = {.lex_state = 0},
  [1704] = {.lex_state = 0},
  [1705] = {.lex_state = 4},
  [1706] = {.lex_state = 0},
  [1707] = {.lex_state = 0},
  [1708] = {.lex_state = 4},
  [1709] = {.lex_state = 0},
  [1710] = {.lex_state = 0},
  [1711] = {.lex_state = 0},
  [1712] = {.lex_state = 0},
  [1713] = {.lex_state = 0},
  [1714] = {.lex_state = 0},
  [1715] = {.lex_state = 4},
  [1716] = {.lex_state = 0},
  [1717] = {.lex_state = 58},
  [1718] = {.lex_state = 0},
  [1719] = {.lex_state = 0},
  [1720] = {.lex_state = 4},
  [1721] = {.lex_state = 4},
  [1722] = {.lex_state = 0},
  [1723] = {.lex_state = 17},
  [1724] = {.lex_state = 0},
  [1725] = {.lex_state = 4},
  [1726] = {.lex_state = 0},
  [1727] = {.lex_state = 0},
  [1728] = {.lex_state = 0},
  [1729] = {.lex_state = 58},
  [1730] = {.lex_state = 0},
  [1731] = {.lex_state = 4},
  [1732] = {.lex_state = 0},
  [1733] = {.lex_state = 4},
  [1734] = {.lex_state = 1},
  [1735] = {.lex_state = 4},
  [1736] = {.lex_state = 4},
  [1737] = {.lex_state = 0},
  [1738] = {.lex_state = 4},
  [1739] = {.lex_state = 4},
  [1740] = {.lex_state = 0},
  [1741] = {.lex_state = 0},
  [1742] = {.lex_state = 0},
  [1743] = {.lex_state = 0},
  [1744] = {.lex_state = 0},
  [1745] = {.lex_state = 0},
  [1746] = {.lex_state = 4},
  [1747] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_dynamic] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_SLASH] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_DOT_LT] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym__escape_sequence] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(1682),
    [sym_declaration] = STATE(46),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym_statement_block] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_for_in_statement] = STATE(46),
    [sym_for_each_in_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_throw_statement] = STATE(46),
    [sym_empty_statement] = STATE(46),
    [sym_labeled_statement] = STATE(46),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(46),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_declaration] = STATE(5),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(5),
    [sym_expression_statement] = STATE(5),
    [sym_statement_block] = STATE(5),
    [sym_if_statement] = STATE(5),
    [sym_switch_statement] = STATE(5),
    [sym_for_statement] = STATE(5),
    [sym_for_in_statement] = STATE(5),
    [sym_for_each_in_statement] = STATE(5),
    [sym_while_statement] = STATE(5),
    [sym_do_statement] = STATE(5),
    [sym_with_statement] = STATE(5),
    [sym_try_statement] = STATE(5),
    [sym_break_statement] = STATE(5),
    [sym_continue_statement] = STATE(5),
    [sym_return_statement] = STATE(5),
    [sym_throw_statement] = STATE(5),
    [sym_empty_statement] = STATE(5),
    [sym_labeled_statement] = STATE(5),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(97),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_case] = ACTIONS(109),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(138),
    [anon_sym_SEMI] = ACTIONS(141),
    [anon_sym_package] = ACTIONS(144),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LPAREN] = ACTIONS(153),
    [anon_sym_dynamic] = ACTIONS(156),
    [anon_sym_final] = ACTIONS(159),
    [anon_sym_internal] = ACTIONS(162),
    [anon_sym_public] = ACTIONS(162),
    [anon_sym_interface] = ACTIONS(165),
    [anon_sym_LBRACE] = ACTIONS(168),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_function] = ACTIONS(173),
    [anon_sym_var] = ACTIONS(176),
    [anon_sym_const] = ACTIONS(179),
    [anon_sym_private] = ACTIONS(182),
    [anon_sym_protected] = ACTIONS(182),
    [anon_sym_static] = ACTIONS(182),
    [anon_sym_override] = ACTIONS(182),
    [anon_sym_import] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(188),
    [anon_sym_switch] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(194),
    [anon_sym_default] = ACTIONS(194),
    [anon_sym_for] = ACTIONS(196),
    [anon_sym_foreach] = ACTIONS(199),
    [anon_sym_while] = ACTIONS(202),
    [anon_sym_do] = ACTIONS(205),
    [anon_sym_with] = ACTIONS(208),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_break] = ACTIONS(214),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_return] = ACTIONS(220),
    [anon_sym_throw] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(226),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(232),
    [anon_sym_BANG] = ACTIONS(232),
    [anon_sym_delete] = ACTIONS(229),
    [anon_sym_typeof] = ACTIONS(229),
    [anon_sym_void] = ACTIONS(229),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PLUS_PLUS] = ACTIONS(238),
    [anon_sym_DASH_DASH] = ACTIONS(238),
    [anon_sym_new] = ACTIONS(241),
    [sym_true] = ACTIONS(244),
    [sym_false] = ACTIONS(244),
    [sym_undefined] = ACTIONS(244),
    [sym_null] = ACTIONS(244),
    [sym_number] = ACTIONS(244),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_case] = ACTIONS(255),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_declaration] = STATE(3),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(3),
    [sym_expression_statement] = STATE(3),
    [sym_statement_block] = STATE(3),
    [sym_if_statement] = STATE(3),
    [sym_switch_statement] = STATE(3),
    [sym_for_statement] = STATE(3),
    [sym_for_in_statement] = STATE(3),
    [sym_for_each_in_statement] = STATE(3),
    [sym_while_statement] = STATE(3),
    [sym_do_statement] = STATE(3),
    [sym_with_statement] = STATE(3),
    [sym_try_statement] = STATE(3),
    [sym_break_statement] = STATE(3),
    [sym_continue_statement] = STATE(3),
    [sym_return_statement] = STATE(3),
    [sym_throw_statement] = STATE(3),
    [sym_empty_statement] = STATE(3),
    [sym_labeled_statement] = STATE(3),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(3),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_case] = ACTIONS(259),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_declaration] = STATE(12),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_for_each_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_pair] = STATE(1480),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1086),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_declaration] = STATE(69),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_statement_block] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_for_in_statement] = STATE(69),
    [sym_for_each_in_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_throw_statement] = STATE(69),
    [sym_empty_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_pair] = STATE(1480),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1086),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(69),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_declaration] = STATE(12),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_for_each_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_pair] = STATE(1480),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1086),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_declaration] = STATE(69),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_statement_block] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_for_in_statement] = STATE(69),
    [sym_for_each_in_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_throw_statement] = STATE(69),
    [sym_empty_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_pair] = STATE(1480),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1086),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(69),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_declaration] = STATE(435),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(435),
    [sym_expression_statement] = STATE(435),
    [sym_statement_block] = STATE(435),
    [sym_if_statement] = STATE(435),
    [sym_switch_statement] = STATE(435),
    [sym_for_statement] = STATE(435),
    [sym_for_in_statement] = STATE(435),
    [sym_for_each_in_statement] = STATE(435),
    [sym_while_statement] = STATE(435),
    [sym_do_statement] = STATE(435),
    [sym_with_statement] = STATE(435),
    [sym_try_statement] = STATE(435),
    [sym_break_statement] = STATE(435),
    [sym_continue_statement] = STATE(435),
    [sym_return_statement] = STATE(435),
    [sym_throw_statement] = STATE(435),
    [sym_empty_statement] = STATE(435),
    [sym_labeled_statement] = STATE(435),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_declaration] = STATE(13),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_for_each_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(281),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_declaration] = STATE(69),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_statement_block] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_for_in_statement] = STATE(69),
    [sym_for_each_in_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_throw_statement] = STATE(69),
    [sym_empty_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(69),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_declaration] = STATE(890),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(890),
    [sym_expression_statement] = STATE(890),
    [sym_statement_block] = STATE(890),
    [sym_if_statement] = STATE(890),
    [sym_switch_statement] = STATE(890),
    [sym_for_statement] = STATE(890),
    [sym_for_in_statement] = STATE(890),
    [sym_for_each_in_statement] = STATE(890),
    [sym_while_statement] = STATE(890),
    [sym_do_statement] = STATE(890),
    [sym_with_statement] = STATE(890),
    [sym_try_statement] = STATE(890),
    [sym_break_statement] = STATE(890),
    [sym_continue_statement] = STATE(890),
    [sym_return_statement] = STATE(890),
    [sym_throw_statement] = STATE(890),
    [sym_empty_statement] = STATE(890),
    [sym_labeled_statement] = STATE(890),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_declaration] = STATE(888),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(888),
    [sym_expression_statement] = STATE(888),
    [sym_statement_block] = STATE(888),
    [sym_if_statement] = STATE(888),
    [sym_switch_statement] = STATE(888),
    [sym_for_statement] = STATE(888),
    [sym_for_in_statement] = STATE(888),
    [sym_for_each_in_statement] = STATE(888),
    [sym_while_statement] = STATE(888),
    [sym_do_statement] = STATE(888),
    [sym_with_statement] = STATE(888),
    [sym_try_statement] = STATE(888),
    [sym_break_statement] = STATE(888),
    [sym_continue_statement] = STATE(888),
    [sym_return_statement] = STATE(888),
    [sym_throw_statement] = STATE(888),
    [sym_empty_statement] = STATE(888),
    [sym_labeled_statement] = STATE(888),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(17),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_declaration] = STATE(880),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(880),
    [sym_expression_statement] = STATE(880),
    [sym_statement_block] = STATE(880),
    [sym_if_statement] = STATE(880),
    [sym_switch_statement] = STATE(880),
    [sym_for_statement] = STATE(880),
    [sym_for_in_statement] = STATE(880),
    [sym_for_each_in_statement] = STATE(880),
    [sym_while_statement] = STATE(880),
    [sym_do_statement] = STATE(880),
    [sym_with_statement] = STATE(880),
    [sym_try_statement] = STATE(880),
    [sym_break_statement] = STATE(880),
    [sym_continue_statement] = STATE(880),
    [sym_return_statement] = STATE(880),
    [sym_throw_statement] = STATE(880),
    [sym_empty_statement] = STATE(880),
    [sym_labeled_statement] = STATE(880),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_declaration] = STATE(560),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_for_each_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_extends] = ACTIONS(303),
    [anon_sym_implements] = ACTIONS(305),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_declaration] = STATE(538),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(538),
    [sym_expression_statement] = STATE(538),
    [sym_statement_block] = STATE(538),
    [sym_if_statement] = STATE(538),
    [sym_switch_statement] = STATE(538),
    [sym_for_statement] = STATE(538),
    [sym_for_in_statement] = STATE(538),
    [sym_for_each_in_statement] = STATE(538),
    [sym_while_statement] = STATE(538),
    [sym_do_statement] = STATE(538),
    [sym_with_statement] = STATE(538),
    [sym_try_statement] = STATE(538),
    [sym_break_statement] = STATE(538),
    [sym_continue_statement] = STATE(538),
    [sym_return_statement] = STATE(538),
    [sym_throw_statement] = STATE(538),
    [sym_empty_statement] = STATE(538),
    [sym_labeled_statement] = STATE(538),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_declaration] = STATE(610),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(610),
    [sym_expression_statement] = STATE(610),
    [sym_statement_block] = STATE(610),
    [sym_if_statement] = STATE(610),
    [sym_switch_statement] = STATE(610),
    [sym_for_statement] = STATE(610),
    [sym_for_in_statement] = STATE(610),
    [sym_for_each_in_statement] = STATE(610),
    [sym_while_statement] = STATE(610),
    [sym_do_statement] = STATE(610),
    [sym_with_statement] = STATE(610),
    [sym_try_statement] = STATE(610),
    [sym_break_statement] = STATE(610),
    [sym_continue_statement] = STATE(610),
    [sym_return_statement] = STATE(610),
    [sym_throw_statement] = STATE(610),
    [sym_empty_statement] = STATE(610),
    [sym_labeled_statement] = STATE(610),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(29),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_declaration] = STATE(545),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_statement_block] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_for_in_statement] = STATE(545),
    [sym_for_each_in_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_with_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_empty_statement] = STATE(545),
    [sym_labeled_statement] = STATE(545),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(68),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_declaration] = STATE(333),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(333),
    [sym_expression_statement] = STATE(333),
    [sym_statement_block] = STATE(333),
    [sym_if_statement] = STATE(333),
    [sym_switch_statement] = STATE(333),
    [sym_for_statement] = STATE(333),
    [sym_for_in_statement] = STATE(333),
    [sym_for_each_in_statement] = STATE(333),
    [sym_while_statement] = STATE(333),
    [sym_do_statement] = STATE(333),
    [sym_with_statement] = STATE(333),
    [sym_try_statement] = STATE(333),
    [sym_break_statement] = STATE(333),
    [sym_continue_statement] = STATE(333),
    [sym_return_statement] = STATE(333),
    [sym_throw_statement] = STATE(333),
    [sym_empty_statement] = STATE(333),
    [sym_labeled_statement] = STATE(333),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_declaration] = STATE(256),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(256),
    [sym_expression_statement] = STATE(256),
    [sym_statement_block] = STATE(256),
    [sym_if_statement] = STATE(256),
    [sym_switch_statement] = STATE(256),
    [sym_for_statement] = STATE(256),
    [sym_for_in_statement] = STATE(256),
    [sym_for_each_in_statement] = STATE(256),
    [sym_while_statement] = STATE(256),
    [sym_do_statement] = STATE(256),
    [sym_with_statement] = STATE(256),
    [sym_try_statement] = STATE(256),
    [sym_break_statement] = STATE(256),
    [sym_continue_statement] = STATE(256),
    [sym_return_statement] = STATE(256),
    [sym_throw_statement] = STATE(256),
    [sym_empty_statement] = STATE(256),
    [sym_labeled_statement] = STATE(256),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(21),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_declaration] = STATE(645),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(645),
    [sym_expression_statement] = STATE(645),
    [sym_statement_block] = STATE(645),
    [sym_if_statement] = STATE(645),
    [sym_switch_statement] = STATE(645),
    [sym_for_statement] = STATE(645),
    [sym_for_in_statement] = STATE(645),
    [sym_for_each_in_statement] = STATE(645),
    [sym_while_statement] = STATE(645),
    [sym_do_statement] = STATE(645),
    [sym_with_statement] = STATE(645),
    [sym_try_statement] = STATE(645),
    [sym_break_statement] = STATE(645),
    [sym_continue_statement] = STATE(645),
    [sym_return_statement] = STATE(645),
    [sym_throw_statement] = STATE(645),
    [sym_empty_statement] = STATE(645),
    [sym_labeled_statement] = STATE(645),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_extends] = ACTIONS(307),
    [anon_sym_implements] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_declaration] = STATE(792),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(792),
    [sym_expression_statement] = STATE(792),
    [sym_statement_block] = STATE(792),
    [sym_if_statement] = STATE(792),
    [sym_switch_statement] = STATE(792),
    [sym_for_statement] = STATE(792),
    [sym_for_in_statement] = STATE(792),
    [sym_for_each_in_statement] = STATE(792),
    [sym_while_statement] = STATE(792),
    [sym_do_statement] = STATE(792),
    [sym_with_statement] = STATE(792),
    [sym_try_statement] = STATE(792),
    [sym_break_statement] = STATE(792),
    [sym_continue_statement] = STATE(792),
    [sym_return_statement] = STATE(792),
    [sym_throw_statement] = STATE(792),
    [sym_empty_statement] = STATE(792),
    [sym_labeled_statement] = STATE(792),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_declaration] = STATE(779),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(779),
    [sym_expression_statement] = STATE(779),
    [sym_statement_block] = STATE(779),
    [sym_if_statement] = STATE(779),
    [sym_switch_statement] = STATE(779),
    [sym_for_statement] = STATE(779),
    [sym_for_in_statement] = STATE(779),
    [sym_for_each_in_statement] = STATE(779),
    [sym_while_statement] = STATE(779),
    [sym_do_statement] = STATE(779),
    [sym_with_statement] = STATE(779),
    [sym_try_statement] = STATE(779),
    [sym_break_statement] = STATE(779),
    [sym_continue_statement] = STATE(779),
    [sym_return_statement] = STATE(779),
    [sym_throw_statement] = STATE(779),
    [sym_empty_statement] = STATE(779),
    [sym_labeled_statement] = STATE(779),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(19),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_declaration] = STATE(646),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(646),
    [sym_expression_statement] = STATE(646),
    [sym_statement_block] = STATE(646),
    [sym_if_statement] = STATE(646),
    [sym_switch_statement] = STATE(646),
    [sym_for_statement] = STATE(646),
    [sym_for_in_statement] = STATE(646),
    [sym_for_each_in_statement] = STATE(646),
    [sym_while_statement] = STATE(646),
    [sym_do_statement] = STATE(646),
    [sym_with_statement] = STATE(646),
    [sym_try_statement] = STATE(646),
    [sym_break_statement] = STATE(646),
    [sym_continue_statement] = STATE(646),
    [sym_return_statement] = STATE(646),
    [sym_throw_statement] = STATE(646),
    [sym_empty_statement] = STATE(646),
    [sym_labeled_statement] = STATE(646),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_declaration] = STATE(332),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(332),
    [sym_expression_statement] = STATE(332),
    [sym_statement_block] = STATE(332),
    [sym_if_statement] = STATE(332),
    [sym_switch_statement] = STATE(332),
    [sym_for_statement] = STATE(332),
    [sym_for_in_statement] = STATE(332),
    [sym_for_each_in_statement] = STATE(332),
    [sym_while_statement] = STATE(332),
    [sym_do_statement] = STATE(332),
    [sym_with_statement] = STATE(332),
    [sym_try_statement] = STATE(332),
    [sym_break_statement] = STATE(332),
    [sym_continue_statement] = STATE(332),
    [sym_return_statement] = STATE(332),
    [sym_throw_statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym_labeled_statement] = STATE(332),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_declaration] = STATE(334),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(334),
    [sym_expression_statement] = STATE(334),
    [sym_statement_block] = STATE(334),
    [sym_if_statement] = STATE(334),
    [sym_switch_statement] = STATE(334),
    [sym_for_statement] = STATE(334),
    [sym_for_in_statement] = STATE(334),
    [sym_for_each_in_statement] = STATE(334),
    [sym_while_statement] = STATE(334),
    [sym_do_statement] = STATE(334),
    [sym_with_statement] = STATE(334),
    [sym_try_statement] = STATE(334),
    [sym_break_statement] = STATE(334),
    [sym_continue_statement] = STATE(334),
    [sym_return_statement] = STATE(334),
    [sym_throw_statement] = STATE(334),
    [sym_empty_statement] = STATE(334),
    [sym_labeled_statement] = STATE(334),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(24),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_declaration] = STATE(341),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(341),
    [sym_expression_statement] = STATE(341),
    [sym_statement_block] = STATE(341),
    [sym_if_statement] = STATE(341),
    [sym_switch_statement] = STATE(341),
    [sym_for_statement] = STATE(341),
    [sym_for_in_statement] = STATE(341),
    [sym_for_each_in_statement] = STATE(341),
    [sym_while_statement] = STATE(341),
    [sym_do_statement] = STATE(341),
    [sym_with_statement] = STATE(341),
    [sym_try_statement] = STATE(341),
    [sym_break_statement] = STATE(341),
    [sym_continue_statement] = STATE(341),
    [sym_return_statement] = STATE(341),
    [sym_throw_statement] = STATE(341),
    [sym_empty_statement] = STATE(341),
    [sym_labeled_statement] = STATE(341),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_declaration] = STATE(874),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_statement_block] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_for_in_statement] = STATE(874),
    [sym_for_each_in_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_with_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_empty_statement] = STATE(874),
    [sym_labeled_statement] = STATE(874),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(48),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_declaration] = STATE(407),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(407),
    [sym_expression_statement] = STATE(407),
    [sym_statement_block] = STATE(407),
    [sym_if_statement] = STATE(407),
    [sym_switch_statement] = STATE(407),
    [sym_for_statement] = STATE(407),
    [sym_for_in_statement] = STATE(407),
    [sym_for_each_in_statement] = STATE(407),
    [sym_while_statement] = STATE(407),
    [sym_do_statement] = STATE(407),
    [sym_with_statement] = STATE(407),
    [sym_try_statement] = STATE(407),
    [sym_break_statement] = STATE(407),
    [sym_continue_statement] = STATE(407),
    [sym_return_statement] = STATE(407),
    [sym_throw_statement] = STATE(407),
    [sym_empty_statement] = STATE(407),
    [sym_labeled_statement] = STATE(407),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(30),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_declaration] = STATE(415),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(415),
    [sym_expression_statement] = STATE(415),
    [sym_statement_block] = STATE(415),
    [sym_if_statement] = STATE(415),
    [sym_switch_statement] = STATE(415),
    [sym_for_statement] = STATE(415),
    [sym_for_in_statement] = STATE(415),
    [sym_for_each_in_statement] = STATE(415),
    [sym_while_statement] = STATE(415),
    [sym_do_statement] = STATE(415),
    [sym_with_statement] = STATE(415),
    [sym_try_statement] = STATE(415),
    [sym_break_statement] = STATE(415),
    [sym_continue_statement] = STATE(415),
    [sym_return_statement] = STATE(415),
    [sym_throw_statement] = STATE(415),
    [sym_empty_statement] = STATE(415),
    [sym_labeled_statement] = STATE(415),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(32),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_declaration] = STATE(772),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(772),
    [sym_expression_statement] = STATE(772),
    [sym_statement_block] = STATE(772),
    [sym_if_statement] = STATE(772),
    [sym_switch_statement] = STATE(772),
    [sym_for_statement] = STATE(772),
    [sym_for_in_statement] = STATE(772),
    [sym_for_each_in_statement] = STATE(772),
    [sym_while_statement] = STATE(772),
    [sym_do_statement] = STATE(772),
    [sym_with_statement] = STATE(772),
    [sym_try_statement] = STATE(772),
    [sym_break_statement] = STATE(772),
    [sym_continue_statement] = STATE(772),
    [sym_return_statement] = STATE(772),
    [sym_throw_statement] = STATE(772),
    [sym_empty_statement] = STATE(772),
    [sym_labeled_statement] = STATE(772),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(62),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_declaration] = STATE(437),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(437),
    [sym_expression_statement] = STATE(437),
    [sym_statement_block] = STATE(437),
    [sym_if_statement] = STATE(437),
    [sym_switch_statement] = STATE(437),
    [sym_for_statement] = STATE(437),
    [sym_for_in_statement] = STATE(437),
    [sym_for_each_in_statement] = STATE(437),
    [sym_while_statement] = STATE(437),
    [sym_do_statement] = STATE(437),
    [sym_with_statement] = STATE(437),
    [sym_try_statement] = STATE(437),
    [sym_break_statement] = STATE(437),
    [sym_continue_statement] = STATE(437),
    [sym_return_statement] = STATE(437),
    [sym_throw_statement] = STATE(437),
    [sym_empty_statement] = STATE(437),
    [sym_labeled_statement] = STATE(437),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_extends] = ACTIONS(311),
    [anon_sym_implements] = ACTIONS(313),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_declaration] = STATE(455),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(455),
    [sym_expression_statement] = STATE(455),
    [sym_statement_block] = STATE(455),
    [sym_if_statement] = STATE(455),
    [sym_switch_statement] = STATE(455),
    [sym_for_statement] = STATE(455),
    [sym_for_in_statement] = STATE(455),
    [sym_for_each_in_statement] = STATE(455),
    [sym_while_statement] = STATE(455),
    [sym_do_statement] = STATE(455),
    [sym_with_statement] = STATE(455),
    [sym_try_statement] = STATE(455),
    [sym_break_statement] = STATE(455),
    [sym_continue_statement] = STATE(455),
    [sym_return_statement] = STATE(455),
    [sym_throw_statement] = STATE(455),
    [sym_empty_statement] = STATE(455),
    [sym_labeled_statement] = STATE(455),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(11),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_declaration] = STATE(461),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(461),
    [sym_expression_statement] = STATE(461),
    [sym_statement_block] = STATE(461),
    [sym_if_statement] = STATE(461),
    [sym_switch_statement] = STATE(461),
    [sym_for_statement] = STATE(461),
    [sym_for_in_statement] = STATE(461),
    [sym_for_each_in_statement] = STATE(461),
    [sym_while_statement] = STATE(461),
    [sym_do_statement] = STATE(461),
    [sym_with_statement] = STATE(461),
    [sym_try_statement] = STATE(461),
    [sym_break_statement] = STATE(461),
    [sym_continue_statement] = STATE(461),
    [sym_return_statement] = STATE(461),
    [sym_throw_statement] = STATE(461),
    [sym_empty_statement] = STATE(461),
    [sym_labeled_statement] = STATE(461),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_extends] = ACTIONS(315),
    [anon_sym_implements] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_declaration] = STATE(637),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(637),
    [sym_expression_statement] = STATE(637),
    [sym_statement_block] = STATE(637),
    [sym_if_statement] = STATE(637),
    [sym_switch_statement] = STATE(637),
    [sym_for_statement] = STATE(637),
    [sym_for_in_statement] = STATE(637),
    [sym_for_each_in_statement] = STATE(637),
    [sym_while_statement] = STATE(637),
    [sym_do_statement] = STATE(637),
    [sym_with_statement] = STATE(637),
    [sym_try_statement] = STATE(637),
    [sym_break_statement] = STATE(637),
    [sym_continue_statement] = STATE(637),
    [sym_return_statement] = STATE(637),
    [sym_throw_statement] = STATE(637),
    [sym_empty_statement] = STATE(637),
    [sym_labeled_statement] = STATE(637),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_declaration] = STATE(636),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(636),
    [sym_expression_statement] = STATE(636),
    [sym_statement_block] = STATE(636),
    [sym_if_statement] = STATE(636),
    [sym_switch_statement] = STATE(636),
    [sym_for_statement] = STATE(636),
    [sym_for_in_statement] = STATE(636),
    [sym_for_each_in_statement] = STATE(636),
    [sym_while_statement] = STATE(636),
    [sym_do_statement] = STATE(636),
    [sym_with_statement] = STATE(636),
    [sym_try_statement] = STATE(636),
    [sym_break_statement] = STATE(636),
    [sym_continue_statement] = STATE(636),
    [sym_return_statement] = STATE(636),
    [sym_throw_statement] = STATE(636),
    [sym_empty_statement] = STATE(636),
    [sym_labeled_statement] = STATE(636),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(27),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_declaration] = STATE(44),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_statement_block] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_for_in_statement] = STATE(44),
    [sym_for_each_in_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_throw_statement] = STATE(44),
    [sym_empty_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(44),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(319),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_declaration] = STATE(621),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(621),
    [sym_expression_statement] = STATE(621),
    [sym_statement_block] = STATE(621),
    [sym_if_statement] = STATE(621),
    [sym_switch_statement] = STATE(621),
    [sym_for_statement] = STATE(621),
    [sym_for_in_statement] = STATE(621),
    [sym_for_each_in_statement] = STATE(621),
    [sym_while_statement] = STATE(621),
    [sym_do_statement] = STATE(621),
    [sym_with_statement] = STATE(621),
    [sym_try_statement] = STATE(621),
    [sym_break_statement] = STATE(621),
    [sym_continue_statement] = STATE(621),
    [sym_return_statement] = STATE(621),
    [sym_throw_statement] = STATE(621),
    [sym_empty_statement] = STATE(621),
    [sym_labeled_statement] = STATE(621),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_declaration] = STATE(45),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(45),
    [sym_expression_statement] = STATE(45),
    [sym_statement_block] = STATE(45),
    [sym_if_statement] = STATE(45),
    [sym_switch_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_for_in_statement] = STATE(45),
    [sym_for_each_in_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_do_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_break_statement] = STATE(45),
    [sym_continue_statement] = STATE(45),
    [sym_return_statement] = STATE(45),
    [sym_throw_statement] = STATE(45),
    [sym_empty_statement] = STATE(45),
    [sym_labeled_statement] = STATE(45),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(45),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym_identifier] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(326),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_package] = ACTIONS(332),
    [anon_sym_class] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LPAREN] = ACTIONS(153),
    [anon_sym_dynamic] = ACTIONS(156),
    [anon_sym_final] = ACTIONS(159),
    [anon_sym_internal] = ACTIONS(162),
    [anon_sym_public] = ACTIONS(162),
    [anon_sym_interface] = ACTIONS(338),
    [anon_sym_LBRACE] = ACTIONS(341),
    [anon_sym_function] = ACTIONS(344),
    [anon_sym_var] = ACTIONS(176),
    [anon_sym_const] = ACTIONS(347),
    [anon_sym_private] = ACTIONS(182),
    [anon_sym_protected] = ACTIONS(182),
    [anon_sym_static] = ACTIONS(182),
    [anon_sym_override] = ACTIONS(182),
    [anon_sym_import] = ACTIONS(350),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_switch] = ACTIONS(356),
    [anon_sym_for] = ACTIONS(359),
    [anon_sym_foreach] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(368),
    [anon_sym_with] = ACTIONS(371),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_continue] = ACTIONS(380),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_throw] = ACTIONS(386),
    [anon_sym_LT] = ACTIONS(226),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(232),
    [anon_sym_BANG] = ACTIONS(232),
    [anon_sym_delete] = ACTIONS(229),
    [anon_sym_typeof] = ACTIONS(229),
    [anon_sym_void] = ACTIONS(229),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PLUS_PLUS] = ACTIONS(238),
    [anon_sym_DASH_DASH] = ACTIONS(238),
    [anon_sym_new] = ACTIONS(241),
    [sym_true] = ACTIONS(244),
    [sym_false] = ACTIONS(244),
    [sym_undefined] = ACTIONS(244),
    [sym_null] = ACTIONS(244),
    [sym_number] = ACTIONS(244),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_declaration] = STATE(45),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(45),
    [sym_expression_statement] = STATE(45),
    [sym_statement_block] = STATE(45),
    [sym_if_statement] = STATE(45),
    [sym_switch_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_for_in_statement] = STATE(45),
    [sym_for_each_in_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_do_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_break_statement] = STATE(45),
    [sym_continue_statement] = STATE(45),
    [sym_return_statement] = STATE(45),
    [sym_throw_statement] = STATE(45),
    [sym_empty_statement] = STATE(45),
    [sym_labeled_statement] = STATE(45),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(45),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [ts_builtin_sym_end] = ACTIONS(389),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_declaration] = STATE(53),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_statement_block] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_for_in_statement] = STATE(53),
    [sym_for_each_in_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_with_statement] = STATE(53),
    [sym_try_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_throw_statement] = STATE(53),
    [sym_empty_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(53),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_declaration] = STATE(621),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(621),
    [sym_expression_statement] = STATE(621),
    [sym_statement_block] = STATE(621),
    [sym_if_statement] = STATE(621),
    [sym_switch_statement] = STATE(621),
    [sym_for_statement] = STATE(621),
    [sym_for_in_statement] = STATE(621),
    [sym_for_each_in_statement] = STATE(621),
    [sym_while_statement] = STATE(621),
    [sym_do_statement] = STATE(621),
    [sym_with_statement] = STATE(621),
    [sym_try_statement] = STATE(621),
    [sym_break_statement] = STATE(621),
    [sym_continue_statement] = STATE(621),
    [sym_return_statement] = STATE(621),
    [sym_throw_statement] = STATE(621),
    [sym_empty_statement] = STATE(621),
    [sym_labeled_statement] = STATE(621),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_declaration] = STATE(499),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(499),
    [sym_expression_statement] = STATE(499),
    [sym_statement_block] = STATE(499),
    [sym_if_statement] = STATE(499),
    [sym_switch_statement] = STATE(499),
    [sym_for_statement] = STATE(499),
    [sym_for_in_statement] = STATE(499),
    [sym_for_each_in_statement] = STATE(499),
    [sym_while_statement] = STATE(499),
    [sym_do_statement] = STATE(499),
    [sym_with_statement] = STATE(499),
    [sym_try_statement] = STATE(499),
    [sym_break_statement] = STATE(499),
    [sym_continue_statement] = STATE(499),
    [sym_return_statement] = STATE(499),
    [sym_throw_statement] = STATE(499),
    [sym_empty_statement] = STATE(499),
    [sym_labeled_statement] = STATE(499),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_extends] = ACTIONS(393),
    [anon_sym_implements] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_declaration] = STATE(772),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(772),
    [sym_expression_statement] = STATE(772),
    [sym_statement_block] = STATE(772),
    [sym_if_statement] = STATE(772),
    [sym_switch_statement] = STATE(772),
    [sym_for_statement] = STATE(772),
    [sym_for_in_statement] = STATE(772),
    [sym_for_each_in_statement] = STATE(772),
    [sym_while_statement] = STATE(772),
    [sym_do_statement] = STATE(772),
    [sym_with_statement] = STATE(772),
    [sym_try_statement] = STATE(772),
    [sym_break_statement] = STATE(772),
    [sym_continue_statement] = STATE(772),
    [sym_return_statement] = STATE(772),
    [sym_throw_statement] = STATE(772),
    [sym_empty_statement] = STATE(772),
    [sym_labeled_statement] = STATE(772),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(40),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_declaration] = STATE(12),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_for_each_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_declaration] = STATE(890),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(890),
    [sym_expression_statement] = STATE(890),
    [sym_statement_block] = STATE(890),
    [sym_if_statement] = STATE(890),
    [sym_switch_statement] = STATE(890),
    [sym_for_statement] = STATE(890),
    [sym_for_in_statement] = STATE(890),
    [sym_for_each_in_statement] = STATE(890),
    [sym_while_statement] = STATE(890),
    [sym_do_statement] = STATE(890),
    [sym_with_statement] = STATE(890),
    [sym_try_statement] = STATE(890),
    [sym_break_statement] = STATE(890),
    [sym_continue_statement] = STATE(890),
    [sym_return_statement] = STATE(890),
    [sym_throw_statement] = STATE(890),
    [sym_empty_statement] = STATE(890),
    [sym_labeled_statement] = STATE(890),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_declaration] = STATE(874),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_statement_block] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_for_in_statement] = STATE(874),
    [sym_for_each_in_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_with_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_empty_statement] = STATE(874),
    [sym_labeled_statement] = STATE(874),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(43),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_declaration] = STATE(888),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(888),
    [sym_expression_statement] = STATE(888),
    [sym_statement_block] = STATE(888),
    [sym_if_statement] = STATE(888),
    [sym_switch_statement] = STATE(888),
    [sym_for_statement] = STATE(888),
    [sym_for_in_statement] = STATE(888),
    [sym_for_each_in_statement] = STATE(888),
    [sym_while_statement] = STATE(888),
    [sym_do_statement] = STATE(888),
    [sym_with_statement] = STATE(888),
    [sym_try_statement] = STATE(888),
    [sym_break_statement] = STATE(888),
    [sym_continue_statement] = STATE(888),
    [sym_return_statement] = STATE(888),
    [sym_throw_statement] = STATE(888),
    [sym_empty_statement] = STATE(888),
    [sym_labeled_statement] = STATE(888),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(52),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_declaration] = STATE(880),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(880),
    [sym_expression_statement] = STATE(880),
    [sym_statement_block] = STATE(880),
    [sym_if_statement] = STATE(880),
    [sym_switch_statement] = STATE(880),
    [sym_for_statement] = STATE(880),
    [sym_for_in_statement] = STATE(880),
    [sym_for_each_in_statement] = STATE(880),
    [sym_while_statement] = STATE(880),
    [sym_do_statement] = STATE(880),
    [sym_with_statement] = STATE(880),
    [sym_try_statement] = STATE(880),
    [sym_break_statement] = STATE(880),
    [sym_continue_statement] = STATE(880),
    [sym_return_statement] = STATE(880),
    [sym_throw_statement] = STATE(880),
    [sym_empty_statement] = STATE(880),
    [sym_labeled_statement] = STATE(880),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_declaration] = STATE(884),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(884),
    [sym_expression_statement] = STATE(884),
    [sym_statement_block] = STATE(884),
    [sym_if_statement] = STATE(884),
    [sym_switch_statement] = STATE(884),
    [sym_for_statement] = STATE(884),
    [sym_for_in_statement] = STATE(884),
    [sym_for_each_in_statement] = STATE(884),
    [sym_while_statement] = STATE(884),
    [sym_do_statement] = STATE(884),
    [sym_with_statement] = STATE(884),
    [sym_try_statement] = STATE(884),
    [sym_break_statement] = STATE(884),
    [sym_continue_statement] = STATE(884),
    [sym_return_statement] = STATE(884),
    [sym_throw_statement] = STATE(884),
    [sym_empty_statement] = STATE(884),
    [sym_labeled_statement] = STATE(884),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_extends] = ACTIONS(401),
    [anon_sym_implements] = ACTIONS(403),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_declaration] = STATE(646),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(646),
    [sym_expression_statement] = STATE(646),
    [sym_statement_block] = STATE(646),
    [sym_if_statement] = STATE(646),
    [sym_switch_statement] = STATE(646),
    [sym_for_statement] = STATE(646),
    [sym_for_in_statement] = STATE(646),
    [sym_for_each_in_statement] = STATE(646),
    [sym_while_statement] = STATE(646),
    [sym_do_statement] = STATE(646),
    [sym_with_statement] = STATE(646),
    [sym_try_statement] = STATE(646),
    [sym_break_statement] = STATE(646),
    [sym_continue_statement] = STATE(646),
    [sym_return_statement] = STATE(646),
    [sym_throw_statement] = STATE(646),
    [sym_empty_statement] = STATE(646),
    [sym_labeled_statement] = STATE(646),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_declaration] = STATE(645),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(645),
    [sym_expression_statement] = STATE(645),
    [sym_statement_block] = STATE(645),
    [sym_if_statement] = STATE(645),
    [sym_switch_statement] = STATE(645),
    [sym_for_statement] = STATE(645),
    [sym_for_in_statement] = STATE(645),
    [sym_for_each_in_statement] = STATE(645),
    [sym_while_statement] = STATE(645),
    [sym_do_statement] = STATE(645),
    [sym_with_statement] = STATE(645),
    [sym_try_statement] = STATE(645),
    [sym_break_statement] = STATE(645),
    [sym_continue_statement] = STATE(645),
    [sym_return_statement] = STATE(645),
    [sym_throw_statement] = STATE(645),
    [sym_empty_statement] = STATE(645),
    [sym_labeled_statement] = STATE(645),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_extends] = ACTIONS(405),
    [anon_sym_implements] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_declaration] = STATE(636),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(636),
    [sym_expression_statement] = STATE(636),
    [sym_statement_block] = STATE(636),
    [sym_if_statement] = STATE(636),
    [sym_switch_statement] = STATE(636),
    [sym_for_statement] = STATE(636),
    [sym_for_in_statement] = STATE(636),
    [sym_for_each_in_statement] = STATE(636),
    [sym_while_statement] = STATE(636),
    [sym_do_statement] = STATE(636),
    [sym_with_statement] = STATE(636),
    [sym_try_statement] = STATE(636),
    [sym_break_statement] = STATE(636),
    [sym_continue_statement] = STATE(636),
    [sym_return_statement] = STATE(636),
    [sym_throw_statement] = STATE(636),
    [sym_empty_statement] = STATE(636),
    [sym_labeled_statement] = STATE(636),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(65),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_declaration] = STATE(610),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(610),
    [sym_expression_statement] = STATE(610),
    [sym_statement_block] = STATE(610),
    [sym_if_statement] = STATE(610),
    [sym_switch_statement] = STATE(610),
    [sym_for_statement] = STATE(610),
    [sym_for_in_statement] = STATE(610),
    [sym_for_each_in_statement] = STATE(610),
    [sym_while_statement] = STATE(610),
    [sym_do_statement] = STATE(610),
    [sym_with_statement] = STATE(610),
    [sym_try_statement] = STATE(610),
    [sym_break_statement] = STATE(610),
    [sym_continue_statement] = STATE(610),
    [sym_return_statement] = STATE(610),
    [sym_throw_statement] = STATE(610),
    [sym_empty_statement] = STATE(610),
    [sym_labeled_statement] = STATE(610),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [aux_sym_class_declaration_repeat2] = STATE(58),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_declaration] = STATE(637),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(637),
    [sym_expression_statement] = STATE(637),
    [sym_statement_block] = STATE(637),
    [sym_if_statement] = STATE(637),
    [sym_switch_statement] = STATE(637),
    [sym_for_statement] = STATE(637),
    [sym_for_in_statement] = STATE(637),
    [sym_for_each_in_statement] = STATE(637),
    [sym_while_statement] = STATE(637),
    [sym_do_statement] = STATE(637),
    [sym_with_statement] = STATE(637),
    [sym_try_statement] = STATE(637),
    [sym_break_statement] = STATE(637),
    [sym_continue_statement] = STATE(637),
    [sym_return_statement] = STATE(637),
    [sym_throw_statement] = STATE(637),
    [sym_empty_statement] = STATE(637),
    [sym_labeled_statement] = STATE(637),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_declaration] = STATE(560),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_for_each_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_extends] = ACTIONS(409),
    [anon_sym_implements] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_declaration] = STATE(15),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_for_each_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_declaration] = STATE(792),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(792),
    [sym_expression_statement] = STATE(792),
    [sym_statement_block] = STATE(792),
    [sym_if_statement] = STATE(792),
    [sym_switch_statement] = STATE(792),
    [sym_for_statement] = STATE(792),
    [sym_for_in_statement] = STATE(792),
    [sym_for_each_in_statement] = STATE(792),
    [sym_while_statement] = STATE(792),
    [sym_do_statement] = STATE(792),
    [sym_with_statement] = STATE(792),
    [sym_try_statement] = STATE(792),
    [sym_break_statement] = STATE(792),
    [sym_continue_statement] = STATE(792),
    [sym_return_statement] = STATE(792),
    [sym_throw_statement] = STATE(792),
    [sym_empty_statement] = STATE(792),
    [sym_labeled_statement] = STATE(792),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_declaration] = STATE(70),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym_statement_block] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_switch_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_for_in_statement] = STATE(70),
    [sym_for_each_in_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_throw_statement] = STATE(70),
    [sym_empty_statement] = STATE(70),
    [sym_labeled_statement] = STATE(70),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(70),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_declaration] = STATE(779),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(779),
    [sym_expression_statement] = STATE(779),
    [sym_statement_block] = STATE(779),
    [sym_if_statement] = STATE(779),
    [sym_switch_statement] = STATE(779),
    [sym_for_statement] = STATE(779),
    [sym_for_in_statement] = STATE(779),
    [sym_for_each_in_statement] = STATE(779),
    [sym_while_statement] = STATE(779),
    [sym_do_statement] = STATE(779),
    [sym_with_statement] = STATE(779),
    [sym_try_statement] = STATE(779),
    [sym_break_statement] = STATE(779),
    [sym_continue_statement] = STATE(779),
    [sym_return_statement] = STATE(779),
    [sym_throw_statement] = STATE(779),
    [sym_empty_statement] = STATE(779),
    [sym_labeled_statement] = STATE(779),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [aux_sym_class_declaration_repeat2] = STATE(56),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_declaration] = STATE(426),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(426),
    [sym_expression_statement] = STATE(426),
    [sym_statement_block] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_switch_statement] = STATE(426),
    [sym_for_statement] = STATE(426),
    [sym_for_in_statement] = STATE(426),
    [sym_for_each_in_statement] = STATE(426),
    [sym_while_statement] = STATE(426),
    [sym_do_statement] = STATE(426),
    [sym_with_statement] = STATE(426),
    [sym_try_statement] = STATE(426),
    [sym_break_statement] = STATE(426),
    [sym_continue_statement] = STATE(426),
    [sym_return_statement] = STATE(426),
    [sym_throw_statement] = STATE(426),
    [sym_empty_statement] = STATE(426),
    [sym_labeled_statement] = STATE(426),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [aux_sym_class_declaration_repeat2] = STATE(548),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_declaration] = STATE(4),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_statement_block] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_for_in_statement] = STATE(4),
    [sym_for_each_in_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_with_statement] = STATE(4),
    [sym_try_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_throw_statement] = STATE(4),
    [sym_empty_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_declaration] = STATE(884),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(884),
    [sym_expression_statement] = STATE(884),
    [sym_statement_block] = STATE(884),
    [sym_if_statement] = STATE(884),
    [sym_switch_statement] = STATE(884),
    [sym_for_statement] = STATE(884),
    [sym_for_in_statement] = STATE(884),
    [sym_for_each_in_statement] = STATE(884),
    [sym_while_statement] = STATE(884),
    [sym_do_statement] = STATE(884),
    [sym_with_statement] = STATE(884),
    [sym_try_statement] = STATE(884),
    [sym_break_statement] = STATE(884),
    [sym_continue_statement] = STATE(884),
    [sym_return_statement] = STATE(884),
    [sym_throw_statement] = STATE(884),
    [sym_empty_statement] = STATE(884),
    [sym_labeled_statement] = STATE(884),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_extends] = ACTIONS(421),
    [anon_sym_implements] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_declaration] = STATE(416),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(416),
    [sym_expression_statement] = STATE(416),
    [sym_statement_block] = STATE(416),
    [sym_if_statement] = STATE(416),
    [sym_switch_statement] = STATE(416),
    [sym_for_statement] = STATE(416),
    [sym_for_in_statement] = STATE(416),
    [sym_for_each_in_statement] = STATE(416),
    [sym_while_statement] = STATE(416),
    [sym_do_statement] = STATE(416),
    [sym_with_statement] = STATE(416),
    [sym_try_statement] = STATE(416),
    [sym_break_statement] = STATE(416),
    [sym_continue_statement] = STATE(416),
    [sym_return_statement] = STATE(416),
    [sym_throw_statement] = STATE(416),
    [sym_empty_statement] = STATE(416),
    [sym_labeled_statement] = STATE(416),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_implements] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_declaration] = STATE(797),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(797),
    [sym_expression_statement] = STATE(797),
    [sym_statement_block] = STATE(797),
    [sym_if_statement] = STATE(797),
    [sym_switch_statement] = STATE(797),
    [sym_for_statement] = STATE(797),
    [sym_for_in_statement] = STATE(797),
    [sym_for_each_in_statement] = STATE(797),
    [sym_while_statement] = STATE(797),
    [sym_do_statement] = STATE(797),
    [sym_with_statement] = STATE(797),
    [sym_try_statement] = STATE(797),
    [sym_break_statement] = STATE(797),
    [sym_continue_statement] = STATE(797),
    [sym_return_statement] = STATE(797),
    [sym_throw_statement] = STATE(797),
    [sym_empty_statement] = STATE(797),
    [sym_labeled_statement] = STATE(797),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_implements] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_declaration] = STATE(609),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_statement_block] = STATE(609),
    [sym_if_statement] = STATE(609),
    [sym_switch_statement] = STATE(609),
    [sym_for_statement] = STATE(609),
    [sym_for_in_statement] = STATE(609),
    [sym_for_each_in_statement] = STATE(609),
    [sym_while_statement] = STATE(609),
    [sym_do_statement] = STATE(609),
    [sym_with_statement] = STATE(609),
    [sym_try_statement] = STATE(609),
    [sym_break_statement] = STATE(609),
    [sym_continue_statement] = STATE(609),
    [sym_return_statement] = STATE(609),
    [sym_throw_statement] = STATE(609),
    [sym_empty_statement] = STATE(609),
    [sym_labeled_statement] = STATE(609),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_implements] = ACTIONS(429),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_declaration] = STATE(335),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(335),
    [sym_expression_statement] = STATE(335),
    [sym_statement_block] = STATE(335),
    [sym_if_statement] = STATE(335),
    [sym_switch_statement] = STATE(335),
    [sym_for_statement] = STATE(335),
    [sym_for_in_statement] = STATE(335),
    [sym_for_each_in_statement] = STATE(335),
    [sym_while_statement] = STATE(335),
    [sym_do_statement] = STATE(335),
    [sym_with_statement] = STATE(335),
    [sym_try_statement] = STATE(335),
    [sym_break_statement] = STATE(335),
    [sym_continue_statement] = STATE(335),
    [sym_return_statement] = STATE(335),
    [sym_throw_statement] = STATE(335),
    [sym_empty_statement] = STATE(335),
    [sym_labeled_statement] = STATE(335),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_implements] = ACTIONS(431),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_declaration] = STATE(797),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(797),
    [sym_expression_statement] = STATE(797),
    [sym_statement_block] = STATE(797),
    [sym_if_statement] = STATE(797),
    [sym_switch_statement] = STATE(797),
    [sym_for_statement] = STATE(797),
    [sym_for_in_statement] = STATE(797),
    [sym_for_each_in_statement] = STATE(797),
    [sym_while_statement] = STATE(797),
    [sym_do_statement] = STATE(797),
    [sym_with_statement] = STATE(797),
    [sym_try_statement] = STATE(797),
    [sym_break_statement] = STATE(797),
    [sym_continue_statement] = STATE(797),
    [sym_return_statement] = STATE(797),
    [sym_throw_statement] = STATE(797),
    [sym_empty_statement] = STATE(797),
    [sym_labeled_statement] = STATE(797),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_implements] = ACTIONS(433),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_declaration] = STATE(456),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(456),
    [sym_expression_statement] = STATE(456),
    [sym_statement_block] = STATE(456),
    [sym_if_statement] = STATE(456),
    [sym_switch_statement] = STATE(456),
    [sym_for_statement] = STATE(456),
    [sym_for_in_statement] = STATE(456),
    [sym_for_each_in_statement] = STATE(456),
    [sym_while_statement] = STATE(456),
    [sym_do_statement] = STATE(456),
    [sym_with_statement] = STATE(456),
    [sym_try_statement] = STATE(456),
    [sym_break_statement] = STATE(456),
    [sym_continue_statement] = STATE(456),
    [sym_return_statement] = STATE(456),
    [sym_throw_statement] = STATE(456),
    [sym_empty_statement] = STATE(456),
    [sym_labeled_statement] = STATE(456),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_implements] = ACTIONS(435),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_declaration] = STATE(635),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(635),
    [sym_expression_statement] = STATE(635),
    [sym_statement_block] = STATE(635),
    [sym_if_statement] = STATE(635),
    [sym_switch_statement] = STATE(635),
    [sym_for_statement] = STATE(635),
    [sym_for_in_statement] = STATE(635),
    [sym_for_each_in_statement] = STATE(635),
    [sym_while_statement] = STATE(635),
    [sym_do_statement] = STATE(635),
    [sym_with_statement] = STATE(635),
    [sym_try_statement] = STATE(635),
    [sym_break_statement] = STATE(635),
    [sym_continue_statement] = STATE(635),
    [sym_return_statement] = STATE(635),
    [sym_throw_statement] = STATE(635),
    [sym_empty_statement] = STATE(635),
    [sym_labeled_statement] = STATE(635),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_implements] = ACTIONS(437),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_declaration] = STATE(609),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_statement_block] = STATE(609),
    [sym_if_statement] = STATE(609),
    [sym_switch_statement] = STATE(609),
    [sym_for_statement] = STATE(609),
    [sym_for_in_statement] = STATE(609),
    [sym_for_each_in_statement] = STATE(609),
    [sym_while_statement] = STATE(609),
    [sym_do_statement] = STATE(609),
    [sym_with_statement] = STATE(609),
    [sym_try_statement] = STATE(609),
    [sym_break_statement] = STATE(609),
    [sym_continue_statement] = STATE(609),
    [sym_return_statement] = STATE(609),
    [sym_throw_statement] = STATE(609),
    [sym_empty_statement] = STATE(609),
    [sym_labeled_statement] = STATE(609),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_implements] = ACTIONS(439),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_declaration] = STATE(635),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(635),
    [sym_expression_statement] = STATE(635),
    [sym_statement_block] = STATE(635),
    [sym_if_statement] = STATE(635),
    [sym_switch_statement] = STATE(635),
    [sym_for_statement] = STATE(635),
    [sym_for_in_statement] = STATE(635),
    [sym_for_each_in_statement] = STATE(635),
    [sym_while_statement] = STATE(635),
    [sym_do_statement] = STATE(635),
    [sym_with_statement] = STATE(635),
    [sym_try_statement] = STATE(635),
    [sym_break_statement] = STATE(635),
    [sym_continue_statement] = STATE(635),
    [sym_return_statement] = STATE(635),
    [sym_throw_statement] = STATE(635),
    [sym_empty_statement] = STATE(635),
    [sym_labeled_statement] = STATE(635),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_implements] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_declaration] = STATE(612),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_statement_block] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_for_in_statement] = STATE(612),
    [sym_for_each_in_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_with_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_empty_statement] = STATE(612),
    [sym_labeled_statement] = STATE(612),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_declaration] = STATE(479),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(479),
    [sym_expression_statement] = STATE(479),
    [sym_statement_block] = STATE(479),
    [sym_if_statement] = STATE(479),
    [sym_switch_statement] = STATE(479),
    [sym_for_statement] = STATE(479),
    [sym_for_in_statement] = STATE(479),
    [sym_for_each_in_statement] = STATE(479),
    [sym_while_statement] = STATE(479),
    [sym_do_statement] = STATE(479),
    [sym_with_statement] = STATE(479),
    [sym_try_statement] = STATE(479),
    [sym_break_statement] = STATE(479),
    [sym_continue_statement] = STATE(479),
    [sym_return_statement] = STATE(479),
    [sym_throw_statement] = STATE(479),
    [sym_empty_statement] = STATE(479),
    [sym_labeled_statement] = STATE(479),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1091),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(443),
    [anon_sym_function] = ACTIONS(445),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_declaration] = STATE(464),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(469),
    [sym_expression_statement] = STATE(472),
    [sym_statement_block] = STATE(473),
    [sym_if_statement] = STATE(474),
    [sym_switch_statement] = STATE(475),
    [sym_for_statement] = STATE(478),
    [sym_for_in_statement] = STATE(481),
    [sym_for_each_in_statement] = STATE(482),
    [sym_while_statement] = STATE(486),
    [sym_do_statement] = STATE(487),
    [sym_with_statement] = STATE(488),
    [sym_try_statement] = STATE(491),
    [sym_break_statement] = STATE(494),
    [sym_continue_statement] = STATE(497),
    [sym_return_statement] = STATE(500),
    [sym_throw_statement] = STATE(504),
    [sym_empty_statement] = STATE(507),
    [sym_labeled_statement] = STATE(512),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_declaration] = STATE(536),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(536),
    [sym_expression_statement] = STATE(536),
    [sym_statement_block] = STATE(536),
    [sym_if_statement] = STATE(536),
    [sym_switch_statement] = STATE(536),
    [sym_for_statement] = STATE(536),
    [sym_for_in_statement] = STATE(536),
    [sym_for_each_in_statement] = STATE(536),
    [sym_while_statement] = STATE(536),
    [sym_do_statement] = STATE(536),
    [sym_with_statement] = STATE(536),
    [sym_try_statement] = STATE(536),
    [sym_break_statement] = STATE(536),
    [sym_continue_statement] = STATE(536),
    [sym_return_statement] = STATE(536),
    [sym_throw_statement] = STATE(536),
    [sym_empty_statement] = STATE(536),
    [sym_labeled_statement] = STATE(536),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_declaration] = STATE(410),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(414),
    [sym_expression_statement] = STATE(419),
    [sym_statement_block] = STATE(420),
    [sym_if_statement] = STATE(297),
    [sym_switch_statement] = STATE(423),
    [sym_for_statement] = STATE(424),
    [sym_for_in_statement] = STATE(428),
    [sym_for_each_in_statement] = STATE(429),
    [sym_while_statement] = STATE(433),
    [sym_do_statement] = STATE(434),
    [sym_with_statement] = STATE(436),
    [sym_try_statement] = STATE(441),
    [sym_break_statement] = STATE(442),
    [sym_continue_statement] = STATE(446),
    [sym_return_statement] = STATE(450),
    [sym_throw_statement] = STATE(451),
    [sym_empty_statement] = STATE(454),
    [sym_labeled_statement] = STATE(458),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_declaration] = STATE(344),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(345),
    [sym_expression_statement] = STATE(347),
    [sym_statement_block] = STATE(349),
    [sym_if_statement] = STATE(350),
    [sym_switch_statement] = STATE(351),
    [sym_for_statement] = STATE(352),
    [sym_for_in_statement] = STATE(353),
    [sym_for_each_in_statement] = STATE(358),
    [sym_while_statement] = STATE(374),
    [sym_do_statement] = STATE(203),
    [sym_with_statement] = STATE(384),
    [sym_try_statement] = STATE(394),
    [sym_break_statement] = STATE(397),
    [sym_continue_statement] = STATE(399),
    [sym_return_statement] = STATE(402),
    [sym_throw_statement] = STATE(406),
    [sym_empty_statement] = STATE(408),
    [sym_labeled_statement] = STATE(409),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_declaration] = STATE(549),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(549),
    [sym_expression_statement] = STATE(549),
    [sym_statement_block] = STATE(549),
    [sym_if_statement] = STATE(549),
    [sym_switch_statement] = STATE(549),
    [sym_for_statement] = STATE(549),
    [sym_for_in_statement] = STATE(549),
    [sym_for_each_in_statement] = STATE(549),
    [sym_while_statement] = STATE(549),
    [sym_do_statement] = STATE(549),
    [sym_with_statement] = STATE(549),
    [sym_try_statement] = STATE(549),
    [sym_break_statement] = STATE(549),
    [sym_continue_statement] = STATE(549),
    [sym_return_statement] = STATE(549),
    [sym_throw_statement] = STATE(549),
    [sym_empty_statement] = STATE(549),
    [sym_labeled_statement] = STATE(549),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_declaration] = STATE(878),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(878),
    [sym_expression_statement] = STATE(878),
    [sym_statement_block] = STATE(878),
    [sym_if_statement] = STATE(878),
    [sym_switch_statement] = STATE(878),
    [sym_for_statement] = STATE(878),
    [sym_for_in_statement] = STATE(878),
    [sym_for_each_in_statement] = STATE(878),
    [sym_while_statement] = STATE(878),
    [sym_do_statement] = STATE(878),
    [sym_with_statement] = STATE(878),
    [sym_try_statement] = STATE(878),
    [sym_break_statement] = STATE(878),
    [sym_continue_statement] = STATE(878),
    [sym_return_statement] = STATE(878),
    [sym_throw_statement] = STATE(878),
    [sym_empty_statement] = STATE(878),
    [sym_labeled_statement] = STATE(878),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_declaration] = STATE(859),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(860),
    [sym_expression_statement] = STATE(861),
    [sym_statement_block] = STATE(862),
    [sym_if_statement] = STATE(863),
    [sym_switch_statement] = STATE(864),
    [sym_for_statement] = STATE(865),
    [sym_for_in_statement] = STATE(866),
    [sym_for_each_in_statement] = STATE(867),
    [sym_while_statement] = STATE(868),
    [sym_do_statement] = STATE(869),
    [sym_with_statement] = STATE(870),
    [sym_try_statement] = STATE(871),
    [sym_break_statement] = STATE(872),
    [sym_continue_statement] = STATE(873),
    [sym_return_statement] = STATE(550),
    [sym_throw_statement] = STATE(875),
    [sym_empty_statement] = STATE(876),
    [sym_labeled_statement] = STATE(877),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_declaration] = STATE(786),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(786),
    [sym_expression_statement] = STATE(786),
    [sym_statement_block] = STATE(786),
    [sym_if_statement] = STATE(786),
    [sym_switch_statement] = STATE(786),
    [sym_for_statement] = STATE(786),
    [sym_for_in_statement] = STATE(786),
    [sym_for_each_in_statement] = STATE(786),
    [sym_while_statement] = STATE(786),
    [sym_do_statement] = STATE(786),
    [sym_with_statement] = STATE(786),
    [sym_try_statement] = STATE(786),
    [sym_break_statement] = STATE(786),
    [sym_continue_statement] = STATE(786),
    [sym_return_statement] = STATE(786),
    [sym_throw_statement] = STATE(786),
    [sym_empty_statement] = STATE(786),
    [sym_labeled_statement] = STATE(786),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_declaration] = STATE(786),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(786),
    [sym_expression_statement] = STATE(786),
    [sym_statement_block] = STATE(786),
    [sym_if_statement] = STATE(786),
    [sym_switch_statement] = STATE(786),
    [sym_for_statement] = STATE(786),
    [sym_for_in_statement] = STATE(786),
    [sym_for_each_in_statement] = STATE(786),
    [sym_while_statement] = STATE(786),
    [sym_do_statement] = STATE(786),
    [sym_with_statement] = STATE(786),
    [sym_try_statement] = STATE(786),
    [sym_break_statement] = STATE(786),
    [sym_continue_statement] = STATE(786),
    [sym_return_statement] = STATE(786),
    [sym_throw_statement] = STATE(786),
    [sym_empty_statement] = STATE(786),
    [sym_labeled_statement] = STATE(786),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_declaration] = STATE(1736),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(1736),
    [sym_expression_statement] = STATE(1736),
    [sym_statement_block] = STATE(1736),
    [sym_if_statement] = STATE(1736),
    [sym_switch_statement] = STATE(1736),
    [sym_for_statement] = STATE(1736),
    [sym_for_in_statement] = STATE(1736),
    [sym_for_each_in_statement] = STATE(1736),
    [sym_while_statement] = STATE(1736),
    [sym_do_statement] = STATE(1736),
    [sym_with_statement] = STATE(1736),
    [sym_try_statement] = STATE(1736),
    [sym_break_statement] = STATE(1736),
    [sym_continue_statement] = STATE(1736),
    [sym_return_statement] = STATE(1736),
    [sym_throw_statement] = STATE(1736),
    [sym_empty_statement] = STATE(1736),
    [sym_labeled_statement] = STATE(1736),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_declaration] = STATE(785),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(785),
    [sym_expression_statement] = STATE(785),
    [sym_statement_block] = STATE(785),
    [sym_if_statement] = STATE(785),
    [sym_switch_statement] = STATE(785),
    [sym_for_statement] = STATE(785),
    [sym_for_in_statement] = STATE(785),
    [sym_for_each_in_statement] = STATE(785),
    [sym_while_statement] = STATE(785),
    [sym_do_statement] = STATE(785),
    [sym_with_statement] = STATE(785),
    [sym_try_statement] = STATE(785),
    [sym_break_statement] = STATE(785),
    [sym_continue_statement] = STATE(785),
    [sym_return_statement] = STATE(785),
    [sym_throw_statement] = STATE(785),
    [sym_empty_statement] = STATE(785),
    [sym_labeled_statement] = STATE(785),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_declaration] = STATE(840),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(841),
    [sym_expression_statement] = STATE(842),
    [sym_statement_block] = STATE(843),
    [sym_if_statement] = STATE(844),
    [sym_switch_statement] = STATE(845),
    [sym_for_statement] = STATE(846),
    [sym_for_in_statement] = STATE(847),
    [sym_for_each_in_statement] = STATE(848),
    [sym_while_statement] = STATE(849),
    [sym_do_statement] = STATE(850),
    [sym_with_statement] = STATE(851),
    [sym_try_statement] = STATE(852),
    [sym_break_statement] = STATE(853),
    [sym_continue_statement] = STATE(854),
    [sym_return_statement] = STATE(855),
    [sym_throw_statement] = STATE(856),
    [sym_empty_statement] = STATE(857),
    [sym_labeled_statement] = STATE(858),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_declaration] = STATE(630),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(630),
    [sym_expression_statement] = STATE(630),
    [sym_statement_block] = STATE(630),
    [sym_if_statement] = STATE(630),
    [sym_switch_statement] = STATE(630),
    [sym_for_statement] = STATE(630),
    [sym_for_in_statement] = STATE(630),
    [sym_for_each_in_statement] = STATE(630),
    [sym_while_statement] = STATE(630),
    [sym_do_statement] = STATE(630),
    [sym_with_statement] = STATE(630),
    [sym_try_statement] = STATE(630),
    [sym_break_statement] = STATE(630),
    [sym_continue_statement] = STATE(630),
    [sym_return_statement] = STATE(630),
    [sym_throw_statement] = STATE(630),
    [sym_empty_statement] = STATE(630),
    [sym_labeled_statement] = STATE(630),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_declaration] = STATE(821),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(822),
    [sym_expression_statement] = STATE(551),
    [sym_statement_block] = STATE(824),
    [sym_if_statement] = STATE(825),
    [sym_switch_statement] = STATE(826),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(828),
    [sym_for_each_in_statement] = STATE(829),
    [sym_while_statement] = STATE(830),
    [sym_do_statement] = STATE(831),
    [sym_with_statement] = STATE(832),
    [sym_try_statement] = STATE(833),
    [sym_break_statement] = STATE(834),
    [sym_continue_statement] = STATE(835),
    [sym_return_statement] = STATE(836),
    [sym_throw_statement] = STATE(837),
    [sym_empty_statement] = STATE(838),
    [sym_labeled_statement] = STATE(839),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_declaration] = STATE(342),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(342),
    [sym_expression_statement] = STATE(342),
    [sym_statement_block] = STATE(342),
    [sym_if_statement] = STATE(342),
    [sym_switch_statement] = STATE(342),
    [sym_for_statement] = STATE(342),
    [sym_for_in_statement] = STATE(342),
    [sym_for_each_in_statement] = STATE(342),
    [sym_while_statement] = STATE(342),
    [sym_do_statement] = STATE(342),
    [sym_with_statement] = STATE(342),
    [sym_try_statement] = STATE(342),
    [sym_break_statement] = STATE(342),
    [sym_continue_statement] = STATE(342),
    [sym_return_statement] = STATE(342),
    [sym_throw_statement] = STATE(342),
    [sym_empty_statement] = STATE(342),
    [sym_labeled_statement] = STATE(342),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_declaration] = STATE(750),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(751),
    [sym_expression_statement] = STATE(752),
    [sym_statement_block] = STATE(753),
    [sym_if_statement] = STATE(754),
    [sym_switch_statement] = STATE(755),
    [sym_for_statement] = STATE(756),
    [sym_for_in_statement] = STATE(757),
    [sym_for_each_in_statement] = STATE(758),
    [sym_while_statement] = STATE(759),
    [sym_do_statement] = STATE(760),
    [sym_with_statement] = STATE(761),
    [sym_try_statement] = STATE(762),
    [sym_break_statement] = STATE(763),
    [sym_continue_statement] = STATE(764),
    [sym_return_statement] = STATE(765),
    [sym_throw_statement] = STATE(766),
    [sym_empty_statement] = STATE(767),
    [sym_labeled_statement] = STATE(768),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_declaration] = STATE(771),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(771),
    [sym_expression_statement] = STATE(771),
    [sym_statement_block] = STATE(771),
    [sym_if_statement] = STATE(771),
    [sym_switch_statement] = STATE(771),
    [sym_for_statement] = STATE(771),
    [sym_for_in_statement] = STATE(771),
    [sym_for_each_in_statement] = STATE(771),
    [sym_while_statement] = STATE(771),
    [sym_do_statement] = STATE(771),
    [sym_with_statement] = STATE(771),
    [sym_try_statement] = STATE(771),
    [sym_break_statement] = STATE(771),
    [sym_continue_statement] = STATE(771),
    [sym_return_statement] = STATE(771),
    [sym_throw_statement] = STATE(771),
    [sym_empty_statement] = STATE(771),
    [sym_labeled_statement] = STATE(771),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_declaration] = STATE(729),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(730),
    [sym_expression_statement] = STATE(731),
    [sym_statement_block] = STATE(732),
    [sym_if_statement] = STATE(733),
    [sym_switch_statement] = STATE(734),
    [sym_for_statement] = STATE(735),
    [sym_for_in_statement] = STATE(736),
    [sym_for_each_in_statement] = STATE(737),
    [sym_while_statement] = STATE(738),
    [sym_do_statement] = STATE(739),
    [sym_with_statement] = STATE(740),
    [sym_try_statement] = STATE(741),
    [sym_break_statement] = STATE(742),
    [sym_continue_statement] = STATE(743),
    [sym_return_statement] = STATE(744),
    [sym_throw_statement] = STATE(745),
    [sym_empty_statement] = STATE(746),
    [sym_labeled_statement] = STATE(747),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_declaration] = STATE(710),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(711),
    [sym_expression_statement] = STATE(712),
    [sym_statement_block] = STATE(713),
    [sym_if_statement] = STATE(714),
    [sym_switch_statement] = STATE(715),
    [sym_for_statement] = STATE(716),
    [sym_for_in_statement] = STATE(717),
    [sym_for_each_in_statement] = STATE(718),
    [sym_while_statement] = STATE(719),
    [sym_do_statement] = STATE(720),
    [sym_with_statement] = STATE(721),
    [sym_try_statement] = STATE(722),
    [sym_break_statement] = STATE(723),
    [sym_continue_statement] = STATE(724),
    [sym_return_statement] = STATE(725),
    [sym_throw_statement] = STATE(726),
    [sym_empty_statement] = STATE(727),
    [sym_labeled_statement] = STATE(728),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_declaration] = STATE(691),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(692),
    [sym_expression_statement] = STATE(693),
    [sym_statement_block] = STATE(694),
    [sym_if_statement] = STATE(695),
    [sym_switch_statement] = STATE(696),
    [sym_for_statement] = STATE(697),
    [sym_for_in_statement] = STATE(698),
    [sym_for_each_in_statement] = STATE(699),
    [sym_while_statement] = STATE(700),
    [sym_do_statement] = STATE(701),
    [sym_with_statement] = STATE(702),
    [sym_try_statement] = STATE(703),
    [sym_break_statement] = STATE(704),
    [sym_continue_statement] = STATE(705),
    [sym_return_statement] = STATE(706),
    [sym_throw_statement] = STATE(707),
    [sym_empty_statement] = STATE(708),
    [sym_labeled_statement] = STATE(709),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_declaration] = STATE(652),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(652),
    [sym_expression_statement] = STATE(652),
    [sym_statement_block] = STATE(652),
    [sym_if_statement] = STATE(652),
    [sym_switch_statement] = STATE(652),
    [sym_for_statement] = STATE(652),
    [sym_for_in_statement] = STATE(652),
    [sym_for_each_in_statement] = STATE(652),
    [sym_while_statement] = STATE(652),
    [sym_do_statement] = STATE(652),
    [sym_with_statement] = STATE(652),
    [sym_try_statement] = STATE(652),
    [sym_break_statement] = STATE(652),
    [sym_continue_statement] = STATE(652),
    [sym_return_statement] = STATE(652),
    [sym_throw_statement] = STATE(652),
    [sym_empty_statement] = STATE(652),
    [sym_labeled_statement] = STATE(652),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_declaration] = STATE(672),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(673),
    [sym_expression_statement] = STATE(674),
    [sym_statement_block] = STATE(675),
    [sym_if_statement] = STATE(676),
    [sym_switch_statement] = STATE(677),
    [sym_for_statement] = STATE(678),
    [sym_for_in_statement] = STATE(679),
    [sym_for_each_in_statement] = STATE(680),
    [sym_while_statement] = STATE(681),
    [sym_do_statement] = STATE(682),
    [sym_with_statement] = STATE(683),
    [sym_try_statement] = STATE(684),
    [sym_break_statement] = STATE(685),
    [sym_continue_statement] = STATE(686),
    [sym_return_statement] = STATE(687),
    [sym_throw_statement] = STATE(688),
    [sym_empty_statement] = STATE(689),
    [sym_labeled_statement] = STATE(690),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_declaration] = STATE(650),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(650),
    [sym_expression_statement] = STATE(650),
    [sym_statement_block] = STATE(650),
    [sym_if_statement] = STATE(650),
    [sym_switch_statement] = STATE(650),
    [sym_for_statement] = STATE(650),
    [sym_for_in_statement] = STATE(650),
    [sym_for_each_in_statement] = STATE(650),
    [sym_while_statement] = STATE(650),
    [sym_do_statement] = STATE(650),
    [sym_with_statement] = STATE(650),
    [sym_try_statement] = STATE(650),
    [sym_break_statement] = STATE(650),
    [sym_continue_statement] = STATE(650),
    [sym_return_statement] = STATE(650),
    [sym_throw_statement] = STATE(650),
    [sym_empty_statement] = STATE(650),
    [sym_labeled_statement] = STATE(650),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_declaration] = STATE(653),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(654),
    [sym_expression_statement] = STATE(655),
    [sym_statement_block] = STATE(656),
    [sym_if_statement] = STATE(657),
    [sym_switch_statement] = STATE(658),
    [sym_for_statement] = STATE(659),
    [sym_for_in_statement] = STATE(660),
    [sym_for_each_in_statement] = STATE(661),
    [sym_while_statement] = STATE(662),
    [sym_do_statement] = STATE(663),
    [sym_with_statement] = STATE(664),
    [sym_try_statement] = STATE(665),
    [sym_break_statement] = STATE(666),
    [sym_continue_statement] = STATE(667),
    [sym_return_statement] = STATE(668),
    [sym_throw_statement] = STATE(669),
    [sym_empty_statement] = STATE(670),
    [sym_labeled_statement] = STATE(671),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_declaration] = STATE(773),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(773),
    [sym_expression_statement] = STATE(773),
    [sym_statement_block] = STATE(773),
    [sym_if_statement] = STATE(773),
    [sym_switch_statement] = STATE(773),
    [sym_for_statement] = STATE(773),
    [sym_for_in_statement] = STATE(773),
    [sym_for_each_in_statement] = STATE(773),
    [sym_while_statement] = STATE(773),
    [sym_do_statement] = STATE(773),
    [sym_with_statement] = STATE(773),
    [sym_try_statement] = STATE(773),
    [sym_break_statement] = STATE(773),
    [sym_continue_statement] = STATE(773),
    [sym_return_statement] = STATE(773),
    [sym_throw_statement] = STATE(773),
    [sym_empty_statement] = STATE(773),
    [sym_labeled_statement] = STATE(773),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_declaration] = STATE(801),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(801),
    [sym_expression_statement] = STATE(801),
    [sym_statement_block] = STATE(801),
    [sym_if_statement] = STATE(801),
    [sym_switch_statement] = STATE(801),
    [sym_for_statement] = STATE(801),
    [sym_for_in_statement] = STATE(801),
    [sym_for_each_in_statement] = STATE(801),
    [sym_while_statement] = STATE(801),
    [sym_do_statement] = STATE(801),
    [sym_with_statement] = STATE(801),
    [sym_try_statement] = STATE(801),
    [sym_break_statement] = STATE(801),
    [sym_continue_statement] = STATE(801),
    [sym_return_statement] = STATE(801),
    [sym_throw_statement] = STATE(801),
    [sym_empty_statement] = STATE(801),
    [sym_labeled_statement] = STATE(801),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_declaration] = STATE(642),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(642),
    [sym_expression_statement] = STATE(642),
    [sym_statement_block] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_switch_statement] = STATE(642),
    [sym_for_statement] = STATE(642),
    [sym_for_in_statement] = STATE(642),
    [sym_for_each_in_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_do_statement] = STATE(642),
    [sym_with_statement] = STATE(642),
    [sym_try_statement] = STATE(642),
    [sym_break_statement] = STATE(642),
    [sym_continue_statement] = STATE(642),
    [sym_return_statement] = STATE(642),
    [sym_throw_statement] = STATE(642),
    [sym_empty_statement] = STATE(642),
    [sym_labeled_statement] = STATE(642),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_declaration] = STATE(802),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(803),
    [sym_expression_statement] = STATE(804),
    [sym_statement_block] = STATE(805),
    [sym_if_statement] = STATE(806),
    [sym_switch_statement] = STATE(807),
    [sym_for_statement] = STATE(808),
    [sym_for_in_statement] = STATE(809),
    [sym_for_each_in_statement] = STATE(810),
    [sym_while_statement] = STATE(811),
    [sym_do_statement] = STATE(812),
    [sym_with_statement] = STATE(813),
    [sym_try_statement] = STATE(814),
    [sym_break_statement] = STATE(815),
    [sym_continue_statement] = STATE(816),
    [sym_return_statement] = STATE(817),
    [sym_throw_statement] = STATE(818),
    [sym_empty_statement] = STATE(819),
    [sym_labeled_statement] = STATE(820),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_declaration] = STATE(821),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(822),
    [sym_expression_statement] = STATE(551),
    [sym_statement_block] = STATE(824),
    [sym_if_statement] = STATE(825),
    [sym_switch_statement] = STATE(826),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(828),
    [sym_for_each_in_statement] = STATE(829),
    [sym_while_statement] = STATE(830),
    [sym_do_statement] = STATE(831),
    [sym_with_statement] = STATE(832),
    [sym_try_statement] = STATE(833),
    [sym_break_statement] = STATE(834),
    [sym_continue_statement] = STATE(835),
    [sym_return_statement] = STATE(836),
    [sym_throw_statement] = STATE(837),
    [sym_empty_statement] = STATE(838),
    [sym_labeled_statement] = STATE(839),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_declaration] = STATE(840),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(841),
    [sym_expression_statement] = STATE(842),
    [sym_statement_block] = STATE(843),
    [sym_if_statement] = STATE(844),
    [sym_switch_statement] = STATE(845),
    [sym_for_statement] = STATE(846),
    [sym_for_in_statement] = STATE(847),
    [sym_for_each_in_statement] = STATE(848),
    [sym_while_statement] = STATE(849),
    [sym_do_statement] = STATE(850),
    [sym_with_statement] = STATE(851),
    [sym_try_statement] = STATE(852),
    [sym_break_statement] = STATE(853),
    [sym_continue_statement] = STATE(854),
    [sym_return_statement] = STATE(855),
    [sym_throw_statement] = STATE(856),
    [sym_empty_statement] = STATE(857),
    [sym_labeled_statement] = STATE(858),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_declaration] = STATE(1665),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(1665),
    [sym_expression_statement] = STATE(1665),
    [sym_statement_block] = STATE(1665),
    [sym_if_statement] = STATE(1665),
    [sym_switch_statement] = STATE(1665),
    [sym_for_statement] = STATE(1665),
    [sym_for_in_statement] = STATE(1665),
    [sym_for_each_in_statement] = STATE(1665),
    [sym_while_statement] = STATE(1665),
    [sym_do_statement] = STATE(1665),
    [sym_with_statement] = STATE(1665),
    [sym_try_statement] = STATE(1665),
    [sym_break_statement] = STATE(1665),
    [sym_continue_statement] = STATE(1665),
    [sym_return_statement] = STATE(1665),
    [sym_throw_statement] = STATE(1665),
    [sym_empty_statement] = STATE(1665),
    [sym_labeled_statement] = STATE(1665),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_declaration] = STATE(859),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(860),
    [sym_expression_statement] = STATE(861),
    [sym_statement_block] = STATE(862),
    [sym_if_statement] = STATE(863),
    [sym_switch_statement] = STATE(864),
    [sym_for_statement] = STATE(865),
    [sym_for_in_statement] = STATE(866),
    [sym_for_each_in_statement] = STATE(867),
    [sym_while_statement] = STATE(868),
    [sym_do_statement] = STATE(869),
    [sym_with_statement] = STATE(870),
    [sym_try_statement] = STATE(871),
    [sym_break_statement] = STATE(872),
    [sym_continue_statement] = STATE(873),
    [sym_return_statement] = STATE(550),
    [sym_throw_statement] = STATE(875),
    [sym_empty_statement] = STATE(876),
    [sym_labeled_statement] = STATE(877),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_declaration] = STATE(878),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(878),
    [sym_expression_statement] = STATE(878),
    [sym_statement_block] = STATE(878),
    [sym_if_statement] = STATE(878),
    [sym_switch_statement] = STATE(878),
    [sym_for_statement] = STATE(878),
    [sym_for_in_statement] = STATE(878),
    [sym_for_each_in_statement] = STATE(878),
    [sym_while_statement] = STATE(878),
    [sym_do_statement] = STATE(878),
    [sym_with_statement] = STATE(878),
    [sym_try_statement] = STATE(878),
    [sym_break_statement] = STATE(878),
    [sym_continue_statement] = STATE(878),
    [sym_return_statement] = STATE(878),
    [sym_throw_statement] = STATE(878),
    [sym_empty_statement] = STATE(878),
    [sym_labeled_statement] = STATE(878),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_declaration] = STATE(630),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(630),
    [sym_expression_statement] = STATE(630),
    [sym_statement_block] = STATE(630),
    [sym_if_statement] = STATE(630),
    [sym_switch_statement] = STATE(630),
    [sym_for_statement] = STATE(630),
    [sym_for_in_statement] = STATE(630),
    [sym_for_each_in_statement] = STATE(630),
    [sym_while_statement] = STATE(630),
    [sym_do_statement] = STATE(630),
    [sym_with_statement] = STATE(630),
    [sym_try_statement] = STATE(630),
    [sym_break_statement] = STATE(630),
    [sym_continue_statement] = STATE(630),
    [sym_return_statement] = STATE(630),
    [sym_throw_statement] = STATE(630),
    [sym_empty_statement] = STATE(630),
    [sym_labeled_statement] = STATE(630),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_declaration] = STATE(789),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(789),
    [sym_expression_statement] = STATE(789),
    [sym_statement_block] = STATE(789),
    [sym_if_statement] = STATE(789),
    [sym_switch_statement] = STATE(789),
    [sym_for_statement] = STATE(789),
    [sym_for_in_statement] = STATE(789),
    [sym_for_each_in_statement] = STATE(789),
    [sym_while_statement] = STATE(789),
    [sym_do_statement] = STATE(789),
    [sym_with_statement] = STATE(789),
    [sym_try_statement] = STATE(789),
    [sym_break_statement] = STATE(789),
    [sym_continue_statement] = STATE(789),
    [sym_return_statement] = STATE(789),
    [sym_throw_statement] = STATE(789),
    [sym_empty_statement] = STATE(789),
    [sym_labeled_statement] = STATE(789),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_declaration] = STATE(802),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(803),
    [sym_expression_statement] = STATE(804),
    [sym_statement_block] = STATE(805),
    [sym_if_statement] = STATE(806),
    [sym_switch_statement] = STATE(807),
    [sym_for_statement] = STATE(808),
    [sym_for_in_statement] = STATE(809),
    [sym_for_each_in_statement] = STATE(810),
    [sym_while_statement] = STATE(811),
    [sym_do_statement] = STATE(812),
    [sym_with_statement] = STATE(813),
    [sym_try_statement] = STATE(814),
    [sym_break_statement] = STATE(815),
    [sym_continue_statement] = STATE(816),
    [sym_return_statement] = STATE(817),
    [sym_throw_statement] = STATE(818),
    [sym_empty_statement] = STATE(819),
    [sym_labeled_statement] = STATE(820),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_declaration] = STATE(801),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(801),
    [sym_expression_statement] = STATE(801),
    [sym_statement_block] = STATE(801),
    [sym_if_statement] = STATE(801),
    [sym_switch_statement] = STATE(801),
    [sym_for_statement] = STATE(801),
    [sym_for_in_statement] = STATE(801),
    [sym_for_each_in_statement] = STATE(801),
    [sym_while_statement] = STATE(801),
    [sym_do_statement] = STATE(801),
    [sym_with_statement] = STATE(801),
    [sym_try_statement] = STATE(801),
    [sym_break_statement] = STATE(801),
    [sym_continue_statement] = STATE(801),
    [sym_return_statement] = STATE(801),
    [sym_throw_statement] = STATE(801),
    [sym_empty_statement] = STATE(801),
    [sym_labeled_statement] = STATE(801),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_declaration] = STATE(375),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(375),
    [sym_expression_statement] = STATE(375),
    [sym_statement_block] = STATE(375),
    [sym_if_statement] = STATE(375),
    [sym_switch_statement] = STATE(375),
    [sym_for_statement] = STATE(375),
    [sym_for_in_statement] = STATE(375),
    [sym_for_each_in_statement] = STATE(375),
    [sym_while_statement] = STATE(375),
    [sym_do_statement] = STATE(375),
    [sym_with_statement] = STATE(375),
    [sym_try_statement] = STATE(375),
    [sym_break_statement] = STATE(375),
    [sym_continue_statement] = STATE(375),
    [sym_return_statement] = STATE(375),
    [sym_throw_statement] = STATE(375),
    [sym_empty_statement] = STATE(375),
    [sym_labeled_statement] = STATE(375),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_declaration] = STATE(201),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(201),
    [sym_expression_statement] = STATE(201),
    [sym_statement_block] = STATE(201),
    [sym_if_statement] = STATE(201),
    [sym_switch_statement] = STATE(201),
    [sym_for_statement] = STATE(201),
    [sym_for_in_statement] = STATE(201),
    [sym_for_each_in_statement] = STATE(201),
    [sym_while_statement] = STATE(201),
    [sym_do_statement] = STATE(201),
    [sym_with_statement] = STATE(201),
    [sym_try_statement] = STATE(201),
    [sym_break_statement] = STATE(201),
    [sym_continue_statement] = STATE(201),
    [sym_return_statement] = STATE(201),
    [sym_throw_statement] = STATE(201),
    [sym_empty_statement] = STATE(201),
    [sym_labeled_statement] = STATE(201),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_declaration] = STATE(569),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_statement_block] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_for_in_statement] = STATE(569),
    [sym_for_each_in_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_with_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_empty_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_declaration] = STATE(492),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(492),
    [sym_expression_statement] = STATE(492),
    [sym_statement_block] = STATE(492),
    [sym_if_statement] = STATE(492),
    [sym_switch_statement] = STATE(492),
    [sym_for_statement] = STATE(492),
    [sym_for_in_statement] = STATE(492),
    [sym_for_each_in_statement] = STATE(492),
    [sym_while_statement] = STATE(492),
    [sym_do_statement] = STATE(492),
    [sym_with_statement] = STATE(492),
    [sym_try_statement] = STATE(492),
    [sym_break_statement] = STATE(492),
    [sym_continue_statement] = STATE(492),
    [sym_return_statement] = STATE(492),
    [sym_throw_statement] = STATE(492),
    [sym_empty_statement] = STATE(492),
    [sym_labeled_statement] = STATE(492),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_declaration] = STATE(490),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(490),
    [sym_expression_statement] = STATE(490),
    [sym_statement_block] = STATE(490),
    [sym_if_statement] = STATE(490),
    [sym_switch_statement] = STATE(490),
    [sym_for_statement] = STATE(490),
    [sym_for_in_statement] = STATE(490),
    [sym_for_each_in_statement] = STATE(490),
    [sym_while_statement] = STATE(490),
    [sym_do_statement] = STATE(490),
    [sym_with_statement] = STATE(490),
    [sym_try_statement] = STATE(490),
    [sym_break_statement] = STATE(490),
    [sym_continue_statement] = STATE(490),
    [sym_return_statement] = STATE(490),
    [sym_throw_statement] = STATE(490),
    [sym_empty_statement] = STATE(490),
    [sym_labeled_statement] = STATE(490),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_declaration] = STATE(204),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_statement_block] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_for_in_statement] = STATE(204),
    [sym_for_each_in_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_with_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_empty_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_declaration] = STATE(479),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(479),
    [sym_expression_statement] = STATE(479),
    [sym_statement_block] = STATE(479),
    [sym_if_statement] = STATE(479),
    [sym_switch_statement] = STATE(479),
    [sym_for_statement] = STATE(479),
    [sym_for_in_statement] = STATE(479),
    [sym_for_each_in_statement] = STATE(479),
    [sym_while_statement] = STATE(479),
    [sym_do_statement] = STATE(479),
    [sym_with_statement] = STATE(479),
    [sym_try_statement] = STATE(479),
    [sym_break_statement] = STATE(479),
    [sym_continue_statement] = STATE(479),
    [sym_return_statement] = STATE(479),
    [sym_throw_statement] = STATE(479),
    [sym_empty_statement] = STATE(479),
    [sym_labeled_statement] = STATE(479),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_declaration] = STATE(570),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(571),
    [sym_expression_statement] = STATE(572),
    [sym_statement_block] = STATE(573),
    [sym_if_statement] = STATE(574),
    [sym_switch_statement] = STATE(575),
    [sym_for_statement] = STATE(576),
    [sym_for_in_statement] = STATE(577),
    [sym_for_each_in_statement] = STATE(578),
    [sym_while_statement] = STATE(579),
    [sym_do_statement] = STATE(580),
    [sym_with_statement] = STATE(581),
    [sym_try_statement] = STATE(582),
    [sym_break_statement] = STATE(583),
    [sym_continue_statement] = STATE(584),
    [sym_return_statement] = STATE(585),
    [sym_throw_statement] = STATE(586),
    [sym_empty_statement] = STATE(587),
    [sym_labeled_statement] = STATE(588),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_declaration] = STATE(614),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(614),
    [sym_expression_statement] = STATE(614),
    [sym_statement_block] = STATE(614),
    [sym_if_statement] = STATE(614),
    [sym_switch_statement] = STATE(614),
    [sym_for_statement] = STATE(614),
    [sym_for_in_statement] = STATE(614),
    [sym_for_each_in_statement] = STATE(614),
    [sym_while_statement] = STATE(614),
    [sym_do_statement] = STATE(614),
    [sym_with_statement] = STATE(614),
    [sym_try_statement] = STATE(614),
    [sym_break_statement] = STATE(614),
    [sym_continue_statement] = STATE(614),
    [sym_return_statement] = STATE(614),
    [sym_throw_statement] = STATE(614),
    [sym_empty_statement] = STATE(614),
    [sym_labeled_statement] = STATE(614),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_declaration] = STATE(612),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_statement_block] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_for_in_statement] = STATE(612),
    [sym_for_each_in_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_with_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_empty_statement] = STATE(612),
    [sym_labeled_statement] = STATE(612),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_declaration] = STATE(223),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(222),
    [sym_expression_statement] = STATE(221),
    [sym_statement_block] = STATE(220),
    [sym_if_statement] = STATE(219),
    [sym_switch_statement] = STATE(218),
    [sym_for_statement] = STATE(217),
    [sym_for_in_statement] = STATE(216),
    [sym_for_each_in_statement] = STATE(215),
    [sym_while_statement] = STATE(214),
    [sym_do_statement] = STATE(213),
    [sym_with_statement] = STATE(212),
    [sym_try_statement] = STATE(211),
    [sym_break_statement] = STATE(210),
    [sym_continue_statement] = STATE(209),
    [sym_return_statement] = STATE(208),
    [sym_throw_statement] = STATE(207),
    [sym_empty_statement] = STATE(206),
    [sym_labeled_statement] = STATE(205),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_declaration] = STATE(245),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(244),
    [sym_expression_statement] = STATE(243),
    [sym_statement_block] = STATE(241),
    [sym_if_statement] = STATE(240),
    [sym_switch_statement] = STATE(239),
    [sym_for_statement] = STATE(238),
    [sym_for_in_statement] = STATE(237),
    [sym_for_each_in_statement] = STATE(236),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(234),
    [sym_with_statement] = STATE(233),
    [sym_try_statement] = STATE(232),
    [sym_break_statement] = STATE(231),
    [sym_continue_statement] = STATE(230),
    [sym_return_statement] = STATE(229),
    [sym_throw_statement] = STATE(228),
    [sym_empty_statement] = STATE(227),
    [sym_labeled_statement] = STATE(226),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_declaration] = STATE(589),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(590),
    [sym_expression_statement] = STATE(591),
    [sym_statement_block] = STATE(592),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(594),
    [sym_for_statement] = STATE(595),
    [sym_for_in_statement] = STATE(596),
    [sym_for_each_in_statement] = STATE(597),
    [sym_while_statement] = STATE(598),
    [sym_do_statement] = STATE(599),
    [sym_with_statement] = STATE(600),
    [sym_try_statement] = STATE(601),
    [sym_break_statement] = STATE(602),
    [sym_continue_statement] = STATE(603),
    [sym_return_statement] = STATE(604),
    [sym_throw_statement] = STATE(605),
    [sym_empty_statement] = STATE(606),
    [sym_labeled_statement] = STATE(607),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_declaration] = STATE(570),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(571),
    [sym_expression_statement] = STATE(572),
    [sym_statement_block] = STATE(573),
    [sym_if_statement] = STATE(574),
    [sym_switch_statement] = STATE(575),
    [sym_for_statement] = STATE(576),
    [sym_for_in_statement] = STATE(577),
    [sym_for_each_in_statement] = STATE(578),
    [sym_while_statement] = STATE(579),
    [sym_do_statement] = STATE(580),
    [sym_with_statement] = STATE(581),
    [sym_try_statement] = STATE(582),
    [sym_break_statement] = STATE(583),
    [sym_continue_statement] = STATE(584),
    [sym_return_statement] = STATE(585),
    [sym_throw_statement] = STATE(586),
    [sym_empty_statement] = STATE(587),
    [sym_labeled_statement] = STATE(588),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_declaration] = STATE(267),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(266),
    [sym_expression_statement] = STATE(265),
    [sym_statement_block] = STATE(264),
    [sym_if_statement] = STATE(263),
    [sym_switch_statement] = STATE(262),
    [sym_for_statement] = STATE(261),
    [sym_for_in_statement] = STATE(260),
    [sym_for_each_in_statement] = STATE(259),
    [sym_while_statement] = STATE(255),
    [sym_do_statement] = STATE(254),
    [sym_with_statement] = STATE(253),
    [sym_try_statement] = STATE(252),
    [sym_break_statement] = STATE(251),
    [sym_continue_statement] = STATE(250),
    [sym_return_statement] = STATE(249),
    [sym_throw_statement] = STATE(248),
    [sym_empty_statement] = STATE(247),
    [sym_labeled_statement] = STATE(246),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_declaration] = STATE(569),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_statement_block] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_for_in_statement] = STATE(569),
    [sym_for_each_in_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_with_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_empty_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_declaration] = STATE(642),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(642),
    [sym_expression_statement] = STATE(642),
    [sym_statement_block] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_switch_statement] = STATE(642),
    [sym_for_statement] = STATE(642),
    [sym_for_in_statement] = STATE(642),
    [sym_for_each_in_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_do_statement] = STATE(642),
    [sym_with_statement] = STATE(642),
    [sym_try_statement] = STATE(642),
    [sym_break_statement] = STATE(642),
    [sym_continue_statement] = STATE(642),
    [sym_return_statement] = STATE(642),
    [sym_throw_statement] = STATE(642),
    [sym_empty_statement] = STATE(642),
    [sym_labeled_statement] = STATE(642),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_declaration] = STATE(614),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(614),
    [sym_expression_statement] = STATE(614),
    [sym_statement_block] = STATE(614),
    [sym_if_statement] = STATE(614),
    [sym_switch_statement] = STATE(614),
    [sym_for_statement] = STATE(614),
    [sym_for_in_statement] = STATE(614),
    [sym_for_each_in_statement] = STATE(614),
    [sym_while_statement] = STATE(614),
    [sym_do_statement] = STATE(614),
    [sym_with_statement] = STATE(614),
    [sym_try_statement] = STATE(614),
    [sym_break_statement] = STATE(614),
    [sym_continue_statement] = STATE(614),
    [sym_return_statement] = STATE(614),
    [sym_throw_statement] = STATE(614),
    [sym_empty_statement] = STATE(614),
    [sym_labeled_statement] = STATE(614),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_declaration] = STATE(785),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(785),
    [sym_expression_statement] = STATE(785),
    [sym_statement_block] = STATE(785),
    [sym_if_statement] = STATE(785),
    [sym_switch_statement] = STATE(785),
    [sym_for_statement] = STATE(785),
    [sym_for_in_statement] = STATE(785),
    [sym_for_each_in_statement] = STATE(785),
    [sym_while_statement] = STATE(785),
    [sym_do_statement] = STATE(785),
    [sym_with_statement] = STATE(785),
    [sym_try_statement] = STATE(785),
    [sym_break_statement] = STATE(785),
    [sym_continue_statement] = STATE(785),
    [sym_return_statement] = STATE(785),
    [sym_throw_statement] = STATE(785),
    [sym_empty_statement] = STATE(785),
    [sym_labeled_statement] = STATE(785),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_declaration] = STATE(286),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(285),
    [sym_expression_statement] = STATE(284),
    [sym_statement_block] = STATE(283),
    [sym_if_statement] = STATE(282),
    [sym_switch_statement] = STATE(281),
    [sym_for_statement] = STATE(280),
    [sym_for_in_statement] = STATE(279),
    [sym_for_each_in_statement] = STATE(278),
    [sym_while_statement] = STATE(277),
    [sym_do_statement] = STATE(276),
    [sym_with_statement] = STATE(275),
    [sym_try_statement] = STATE(202),
    [sym_break_statement] = STATE(273),
    [sym_continue_statement] = STATE(272),
    [sym_return_statement] = STATE(271),
    [sym_throw_statement] = STATE(270),
    [sym_empty_statement] = STATE(269),
    [sym_labeled_statement] = STATE(268),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_declaration] = STATE(773),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(773),
    [sym_expression_statement] = STATE(773),
    [sym_statement_block] = STATE(773),
    [sym_if_statement] = STATE(773),
    [sym_switch_statement] = STATE(773),
    [sym_for_statement] = STATE(773),
    [sym_for_in_statement] = STATE(773),
    [sym_for_each_in_statement] = STATE(773),
    [sym_while_statement] = STATE(773),
    [sym_do_statement] = STATE(773),
    [sym_with_statement] = STATE(773),
    [sym_try_statement] = STATE(773),
    [sym_break_statement] = STATE(773),
    [sym_continue_statement] = STATE(773),
    [sym_return_statement] = STATE(773),
    [sym_throw_statement] = STATE(773),
    [sym_empty_statement] = STATE(773),
    [sym_labeled_statement] = STATE(773),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_declaration] = STATE(589),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(590),
    [sym_expression_statement] = STATE(591),
    [sym_statement_block] = STATE(592),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(594),
    [sym_for_statement] = STATE(595),
    [sym_for_in_statement] = STATE(596),
    [sym_for_each_in_statement] = STATE(597),
    [sym_while_statement] = STATE(598),
    [sym_do_statement] = STATE(599),
    [sym_with_statement] = STATE(600),
    [sym_try_statement] = STATE(601),
    [sym_break_statement] = STATE(602),
    [sym_continue_statement] = STATE(603),
    [sym_return_statement] = STATE(604),
    [sym_throw_statement] = STATE(605),
    [sym_empty_statement] = STATE(606),
    [sym_labeled_statement] = STATE(607),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_declaration] = STATE(771),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(771),
    [sym_expression_statement] = STATE(771),
    [sym_statement_block] = STATE(771),
    [sym_if_statement] = STATE(771),
    [sym_switch_statement] = STATE(771),
    [sym_for_statement] = STATE(771),
    [sym_for_in_statement] = STATE(771),
    [sym_for_each_in_statement] = STATE(771),
    [sym_while_statement] = STATE(771),
    [sym_do_statement] = STATE(771),
    [sym_with_statement] = STATE(771),
    [sym_try_statement] = STATE(771),
    [sym_break_statement] = STATE(771),
    [sym_continue_statement] = STATE(771),
    [sym_return_statement] = STATE(771),
    [sym_throw_statement] = STATE(771),
    [sym_empty_statement] = STATE(771),
    [sym_labeled_statement] = STATE(771),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_declaration] = STATE(650),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(650),
    [sym_expression_statement] = STATE(650),
    [sym_statement_block] = STATE(650),
    [sym_if_statement] = STATE(650),
    [sym_switch_statement] = STATE(650),
    [sym_for_statement] = STATE(650),
    [sym_for_in_statement] = STATE(650),
    [sym_for_each_in_statement] = STATE(650),
    [sym_while_statement] = STATE(650),
    [sym_do_statement] = STATE(650),
    [sym_with_statement] = STATE(650),
    [sym_try_statement] = STATE(650),
    [sym_break_statement] = STATE(650),
    [sym_continue_statement] = STATE(650),
    [sym_return_statement] = STATE(650),
    [sym_throw_statement] = STATE(650),
    [sym_empty_statement] = STATE(650),
    [sym_labeled_statement] = STATE(650),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_declaration] = STATE(306),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(305),
    [sym_expression_statement] = STATE(304),
    [sym_statement_block] = STATE(303),
    [sym_if_statement] = STATE(302),
    [sym_switch_statement] = STATE(301),
    [sym_for_statement] = STATE(300),
    [sym_for_in_statement] = STATE(299),
    [sym_for_each_in_statement] = STATE(298),
    [sym_while_statement] = STATE(296),
    [sym_do_statement] = STATE(295),
    [sym_with_statement] = STATE(294),
    [sym_try_statement] = STATE(293),
    [sym_break_statement] = STATE(292),
    [sym_continue_statement] = STATE(291),
    [sym_return_statement] = STATE(290),
    [sym_throw_statement] = STATE(289),
    [sym_empty_statement] = STATE(288),
    [sym_labeled_statement] = STATE(287),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_declaration] = STATE(652),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(652),
    [sym_expression_statement] = STATE(652),
    [sym_statement_block] = STATE(652),
    [sym_if_statement] = STATE(652),
    [sym_switch_statement] = STATE(652),
    [sym_for_statement] = STATE(652),
    [sym_for_in_statement] = STATE(652),
    [sym_for_each_in_statement] = STATE(652),
    [sym_while_statement] = STATE(652),
    [sym_do_statement] = STATE(652),
    [sym_with_statement] = STATE(652),
    [sym_try_statement] = STATE(652),
    [sym_break_statement] = STATE(652),
    [sym_continue_statement] = STATE(652),
    [sym_return_statement] = STATE(652),
    [sym_throw_statement] = STATE(652),
    [sym_empty_statement] = STATE(652),
    [sym_labeled_statement] = STATE(652),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_declaration] = STATE(326),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(325),
    [sym_expression_statement] = STATE(324),
    [sym_statement_block] = STATE(323),
    [sym_if_statement] = STATE(322),
    [sym_switch_statement] = STATE(321),
    [sym_for_statement] = STATE(320),
    [sym_for_in_statement] = STATE(319),
    [sym_for_each_in_statement] = STATE(317),
    [sym_while_statement] = STATE(316),
    [sym_do_statement] = STATE(315),
    [sym_with_statement] = STATE(314),
    [sym_try_statement] = STATE(313),
    [sym_break_statement] = STATE(312),
    [sym_continue_statement] = STATE(311),
    [sym_return_statement] = STATE(310),
    [sym_throw_statement] = STATE(309),
    [sym_empty_statement] = STATE(308),
    [sym_labeled_statement] = STATE(307),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_declaration] = STATE(750),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(751),
    [sym_expression_statement] = STATE(752),
    [sym_statement_block] = STATE(753),
    [sym_if_statement] = STATE(754),
    [sym_switch_statement] = STATE(755),
    [sym_for_statement] = STATE(756),
    [sym_for_in_statement] = STATE(757),
    [sym_for_each_in_statement] = STATE(758),
    [sym_while_statement] = STATE(759),
    [sym_do_statement] = STATE(760),
    [sym_with_statement] = STATE(761),
    [sym_try_statement] = STATE(762),
    [sym_break_statement] = STATE(763),
    [sym_continue_statement] = STATE(764),
    [sym_return_statement] = STATE(765),
    [sym_throw_statement] = STATE(766),
    [sym_empty_statement] = STATE(767),
    [sym_labeled_statement] = STATE(768),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_declaration] = STATE(327),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(327),
    [sym_expression_statement] = STATE(327),
    [sym_statement_block] = STATE(327),
    [sym_if_statement] = STATE(327),
    [sym_switch_statement] = STATE(327),
    [sym_for_statement] = STATE(327),
    [sym_for_in_statement] = STATE(327),
    [sym_for_each_in_statement] = STATE(327),
    [sym_while_statement] = STATE(327),
    [sym_do_statement] = STATE(327),
    [sym_with_statement] = STATE(327),
    [sym_try_statement] = STATE(327),
    [sym_break_statement] = STATE(327),
    [sym_continue_statement] = STATE(327),
    [sym_return_statement] = STATE(327),
    [sym_throw_statement] = STATE(327),
    [sym_empty_statement] = STATE(327),
    [sym_labeled_statement] = STATE(327),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_declaration] = STATE(421),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(421),
    [sym_expression_statement] = STATE(421),
    [sym_statement_block] = STATE(421),
    [sym_if_statement] = STATE(421),
    [sym_switch_statement] = STATE(421),
    [sym_for_statement] = STATE(421),
    [sym_for_in_statement] = STATE(421),
    [sym_for_each_in_statement] = STATE(421),
    [sym_while_statement] = STATE(421),
    [sym_do_statement] = STATE(421),
    [sym_with_statement] = STATE(421),
    [sym_try_statement] = STATE(421),
    [sym_break_statement] = STATE(421),
    [sym_continue_statement] = STATE(421),
    [sym_return_statement] = STATE(421),
    [sym_throw_statement] = STATE(421),
    [sym_empty_statement] = STATE(421),
    [sym_labeled_statement] = STATE(421),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_declaration] = STATE(513),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(514),
    [sym_expression_statement] = STATE(515),
    [sym_statement_block] = STATE(516),
    [sym_if_statement] = STATE(517),
    [sym_switch_statement] = STATE(518),
    [sym_for_statement] = STATE(522),
    [sym_for_in_statement] = STATE(523),
    [sym_for_each_in_statement] = STATE(524),
    [sym_while_statement] = STATE(525),
    [sym_do_statement] = STATE(527),
    [sym_with_statement] = STATE(528),
    [sym_try_statement] = STATE(529),
    [sym_break_statement] = STATE(530),
    [sym_continue_statement] = STATE(531),
    [sym_return_statement] = STATE(532),
    [sym_throw_statement] = STATE(533),
    [sym_empty_statement] = STATE(534),
    [sym_labeled_statement] = STATE(535),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_declaration] = STATE(329),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(329),
    [sym_expression_statement] = STATE(329),
    [sym_statement_block] = STATE(329),
    [sym_if_statement] = STATE(329),
    [sym_switch_statement] = STATE(329),
    [sym_for_statement] = STATE(329),
    [sym_for_in_statement] = STATE(329),
    [sym_for_each_in_statement] = STATE(329),
    [sym_while_statement] = STATE(329),
    [sym_do_statement] = STATE(329),
    [sym_with_statement] = STATE(329),
    [sym_try_statement] = STATE(329),
    [sym_break_statement] = STATE(329),
    [sym_continue_statement] = STATE(329),
    [sym_return_statement] = STATE(329),
    [sym_throw_statement] = STATE(329),
    [sym_empty_statement] = STATE(329),
    [sym_labeled_statement] = STATE(329),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [152] = {
    [sym_declaration] = STATE(653),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(654),
    [sym_expression_statement] = STATE(655),
    [sym_statement_block] = STATE(656),
    [sym_if_statement] = STATE(657),
    [sym_switch_statement] = STATE(658),
    [sym_for_statement] = STATE(659),
    [sym_for_in_statement] = STATE(660),
    [sym_for_each_in_statement] = STATE(661),
    [sym_while_statement] = STATE(662),
    [sym_do_statement] = STATE(663),
    [sym_with_statement] = STATE(664),
    [sym_try_statement] = STATE(665),
    [sym_break_statement] = STATE(666),
    [sym_continue_statement] = STATE(667),
    [sym_return_statement] = STATE(668),
    [sym_throw_statement] = STATE(669),
    [sym_empty_statement] = STATE(670),
    [sym_labeled_statement] = STATE(671),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_declaration] = STATE(672),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(673),
    [sym_expression_statement] = STATE(674),
    [sym_statement_block] = STATE(675),
    [sym_if_statement] = STATE(676),
    [sym_switch_statement] = STATE(677),
    [sym_for_statement] = STATE(678),
    [sym_for_in_statement] = STATE(679),
    [sym_for_each_in_statement] = STATE(680),
    [sym_while_statement] = STATE(681),
    [sym_do_statement] = STATE(682),
    [sym_with_statement] = STATE(683),
    [sym_try_statement] = STATE(684),
    [sym_break_statement] = STATE(685),
    [sym_continue_statement] = STATE(686),
    [sym_return_statement] = STATE(687),
    [sym_throw_statement] = STATE(688),
    [sym_empty_statement] = STATE(689),
    [sym_labeled_statement] = STATE(690),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [154] = {
    [sym_declaration] = STATE(448),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(448),
    [sym_expression_statement] = STATE(448),
    [sym_statement_block] = STATE(448),
    [sym_if_statement] = STATE(448),
    [sym_switch_statement] = STATE(448),
    [sym_for_statement] = STATE(448),
    [sym_for_in_statement] = STATE(448),
    [sym_for_each_in_statement] = STATE(448),
    [sym_while_statement] = STATE(448),
    [sym_do_statement] = STATE(448),
    [sym_with_statement] = STATE(448),
    [sym_try_statement] = STATE(448),
    [sym_break_statement] = STATE(448),
    [sym_continue_statement] = STATE(448),
    [sym_return_statement] = STATE(448),
    [sym_throw_statement] = STATE(448),
    [sym_empty_statement] = STATE(448),
    [sym_labeled_statement] = STATE(448),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_declaration] = STATE(729),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(730),
    [sym_expression_statement] = STATE(731),
    [sym_statement_block] = STATE(732),
    [sym_if_statement] = STATE(733),
    [sym_switch_statement] = STATE(734),
    [sym_for_statement] = STATE(735),
    [sym_for_in_statement] = STATE(736),
    [sym_for_each_in_statement] = STATE(737),
    [sym_while_statement] = STATE(738),
    [sym_do_statement] = STATE(739),
    [sym_with_statement] = STATE(740),
    [sym_try_statement] = STATE(741),
    [sym_break_statement] = STATE(742),
    [sym_continue_statement] = STATE(743),
    [sym_return_statement] = STATE(744),
    [sym_throw_statement] = STATE(745),
    [sym_empty_statement] = STATE(746),
    [sym_labeled_statement] = STATE(747),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_declaration] = STATE(789),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1174),
    [sym_class_attribut] = STATE(1194),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(789),
    [sym_expression_statement] = STATE(789),
    [sym_statement_block] = STATE(789),
    [sym_if_statement] = STATE(789),
    [sym_switch_statement] = STATE(789),
    [sym_for_statement] = STATE(789),
    [sym_for_in_statement] = STATE(789),
    [sym_for_each_in_statement] = STATE(789),
    [sym_while_statement] = STATE(789),
    [sym_do_statement] = STATE(789),
    [sym_with_statement] = STATE(789),
    [sym_try_statement] = STATE(789),
    [sym_break_statement] = STATE(789),
    [sym_continue_statement] = STATE(789),
    [sym_return_statement] = STATE(789),
    [sym_throw_statement] = STATE(789),
    [sym_empty_statement] = STATE(789),
    [sym_labeled_statement] = STATE(789),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1174),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_foreach] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_declaration] = STATE(398),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(398),
    [sym_expression_statement] = STATE(398),
    [sym_statement_block] = STATE(398),
    [sym_if_statement] = STATE(398),
    [sym_switch_statement] = STATE(398),
    [sym_for_statement] = STATE(398),
    [sym_for_in_statement] = STATE(398),
    [sym_for_each_in_statement] = STATE(398),
    [sym_while_statement] = STATE(398),
    [sym_do_statement] = STATE(398),
    [sym_with_statement] = STATE(398),
    [sym_try_statement] = STATE(398),
    [sym_break_statement] = STATE(398),
    [sym_continue_statement] = STATE(398),
    [sym_return_statement] = STATE(398),
    [sym_throw_statement] = STATE(398),
    [sym_empty_statement] = STATE(398),
    [sym_labeled_statement] = STATE(398),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [158] = {
    [sym_declaration] = STATE(396),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(395),
    [sym_expression_statement] = STATE(393),
    [sym_statement_block] = STATE(392),
    [sym_if_statement] = STATE(391),
    [sym_switch_statement] = STATE(390),
    [sym_for_statement] = STATE(389),
    [sym_for_in_statement] = STATE(388),
    [sym_for_each_in_statement] = STATE(387),
    [sym_while_statement] = STATE(386),
    [sym_do_statement] = STATE(385),
    [sym_with_statement] = STATE(383),
    [sym_try_statement] = STATE(382),
    [sym_break_statement] = STATE(381),
    [sym_continue_statement] = STATE(380),
    [sym_return_statement] = STATE(379),
    [sym_throw_statement] = STATE(378),
    [sym_empty_statement] = STATE(377),
    [sym_labeled_statement] = STATE(376),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_declaration] = STATE(373),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(372),
    [sym_expression_statement] = STATE(371),
    [sym_statement_block] = STATE(370),
    [sym_if_statement] = STATE(369),
    [sym_switch_statement] = STATE(368),
    [sym_for_statement] = STATE(367),
    [sym_for_in_statement] = STATE(366),
    [sym_for_each_in_statement] = STATE(365),
    [sym_while_statement] = STATE(364),
    [sym_do_statement] = STATE(363),
    [sym_with_statement] = STATE(362),
    [sym_try_statement] = STATE(361),
    [sym_break_statement] = STATE(360),
    [sym_continue_statement] = STATE(359),
    [sym_return_statement] = STATE(357),
    [sym_throw_statement] = STATE(356),
    [sym_empty_statement] = STATE(355),
    [sym_labeled_statement] = STATE(354),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_declaration] = STATE(348),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(348),
    [sym_expression_statement] = STATE(348),
    [sym_statement_block] = STATE(348),
    [sym_if_statement] = STATE(348),
    [sym_switch_statement] = STATE(348),
    [sym_for_statement] = STATE(348),
    [sym_for_in_statement] = STATE(348),
    [sym_for_each_in_statement] = STATE(348),
    [sym_while_statement] = STATE(348),
    [sym_do_statement] = STATE(348),
    [sym_with_statement] = STATE(348),
    [sym_try_statement] = STATE(348),
    [sym_break_statement] = STATE(348),
    [sym_continue_statement] = STATE(348),
    [sym_return_statement] = STATE(348),
    [sym_throw_statement] = STATE(348),
    [sym_empty_statement] = STATE(348),
    [sym_labeled_statement] = STATE(348),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_declaration] = STATE(346),
    [sym_namespace_declaration] = STATE(520),
    [sym_package_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_annotation] = STATE(1175),
    [sym_class_attribut] = STATE(1233),
    [sym_interface_declaration] = STATE(520),
    [sym_interface_attribut] = STATE(1715),
    [sym_function_declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym__variable_declarator] = STATE(1716),
    [sym_constant_declaration] = STATE(520),
    [sym_property_attribut] = STATE(1185),
    [sym_import_statement] = STATE(346),
    [sym_expression_statement] = STATE(346),
    [sym_statement_block] = STATE(346),
    [sym_if_statement] = STATE(346),
    [sym_switch_statement] = STATE(346),
    [sym_for_statement] = STATE(346),
    [sym_for_in_statement] = STATE(346),
    [sym_for_each_in_statement] = STATE(346),
    [sym_while_statement] = STATE(346),
    [sym_do_statement] = STATE(346),
    [sym_with_statement] = STATE(346),
    [sym_try_statement] = STATE(346),
    [sym_break_statement] = STATE(346),
    [sym_continue_statement] = STATE(346),
    [sym_return_statement] = STATE(346),
    [sym_throw_statement] = STATE(346),
    [sym_empty_statement] = STATE(346),
    [sym_labeled_statement] = STATE(346),
    [sym_sequence_expression] = STATE(1712),
    [sym_expression] = STATE(1114),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1175),
    [aux_sym_namespace_declaration_repeat2] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_namespace] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_class] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_function] = ACTIONS(99),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_do] = ACTIONS(117),
    [anon_sym_with] = ACTIONS(119),
    [anon_sym_try] = ACTIONS(121),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_throw] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_declaration] = STATE(691),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(692),
    [sym_expression_statement] = STATE(693),
    [sym_statement_block] = STATE(694),
    [sym_if_statement] = STATE(695),
    [sym_switch_statement] = STATE(696),
    [sym_for_statement] = STATE(697),
    [sym_for_in_statement] = STATE(698),
    [sym_for_each_in_statement] = STATE(699),
    [sym_while_statement] = STATE(700),
    [sym_do_statement] = STATE(701),
    [sym_with_statement] = STATE(702),
    [sym_try_statement] = STATE(703),
    [sym_break_statement] = STATE(704),
    [sym_continue_statement] = STATE(705),
    [sym_return_statement] = STATE(706),
    [sym_throw_statement] = STATE(707),
    [sym_empty_statement] = STATE(708),
    [sym_labeled_statement] = STATE(709),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_declaration] = STATE(1452),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(1452),
    [sym_expression_statement] = STATE(1452),
    [sym_statement_block] = STATE(1452),
    [sym_if_statement] = STATE(1452),
    [sym_switch_statement] = STATE(1452),
    [sym_for_statement] = STATE(1452),
    [sym_for_in_statement] = STATE(1452),
    [sym_for_each_in_statement] = STATE(1452),
    [sym_while_statement] = STATE(1452),
    [sym_do_statement] = STATE(1452),
    [sym_with_statement] = STATE(1452),
    [sym_try_statement] = STATE(1452),
    [sym_break_statement] = STATE(1452),
    [sym_continue_statement] = STATE(1452),
    [sym_return_statement] = STATE(1452),
    [sym_throw_statement] = STATE(1452),
    [sym_empty_statement] = STATE(1452),
    [sym_labeled_statement] = STATE(1452),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_declaration] = STATE(710),
    [sym_namespace_declaration] = STATE(562),
    [sym_package_declaration] = STATE(562),
    [sym_class_declaration] = STATE(562),
    [sym_annotation] = STATE(1176),
    [sym_class_attribut] = STATE(1209),
    [sym_interface_declaration] = STATE(562),
    [sym_interface_attribut] = STATE(1664),
    [sym_function_declaration] = STATE(562),
    [sym_variable_declaration] = STATE(562),
    [sym__variable_declarator] = STATE(1640),
    [sym_constant_declaration] = STATE(562),
    [sym_property_attribut] = STATE(1183),
    [sym_import_statement] = STATE(711),
    [sym_expression_statement] = STATE(712),
    [sym_statement_block] = STATE(713),
    [sym_if_statement] = STATE(714),
    [sym_switch_statement] = STATE(715),
    [sym_for_statement] = STATE(716),
    [sym_for_in_statement] = STATE(717),
    [sym_for_each_in_statement] = STATE(718),
    [sym_while_statement] = STATE(719),
    [sym_do_statement] = STATE(720),
    [sym_with_statement] = STATE(721),
    [sym_try_statement] = STATE(722),
    [sym_break_statement] = STATE(723),
    [sym_continue_statement] = STATE(724),
    [sym_return_statement] = STATE(725),
    [sym_throw_statement] = STATE(726),
    [sym_empty_statement] = STATE(727),
    [sym_labeled_statement] = STATE(728),
    [sym_sequence_expression] = STATE(1634),
    [sym_expression] = STATE(1116),
    [sym_primary_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(908),
    [sym_member_expression] = STATE(908),
    [sym_descendant_expression] = STATE(1030),
    [sym_namespace_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_object] = STATE(1030),
    [sym_array] = STATE(1030),
    [sym_vector] = STATE(1030),
    [sym_xml] = STATE(1030),
    [sym_anonymous_function] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_cast_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_generic_data_type] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [aux_sym_namespace_declaration_repeat1] = STATE(1176),
    [aux_sym_namespace_declaration_repeat2] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_package] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_dynamic] = ACTIONS(21),
    [anon_sym_final] = ACTIONS(23),
    [anon_sym_internal] = ACTIONS(25),
    [anon_sym_public] = ACTIONS(25),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(37),
    [anon_sym_protected] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_override] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(301),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_throw] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_delete] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(67),
    [anon_sym_void] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_undefined] = ACTIONS(77),
    [sym_null] = ACTIONS(77),
    [sym_number] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_identifier] = ACTIONS(447),
    [anon_sym_namespace] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_package] = ACTIONS(447),
    [anon_sym_class] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_LBRACK] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(449),
    [anon_sym_dynamic] = ACTIONS(447),
    [anon_sym_final] = ACTIONS(447),
    [anon_sym_internal] = ACTIONS(447),
    [anon_sym_public] = ACTIONS(447),
    [anon_sym_interface] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(449),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(447),
    [anon_sym_var] = ACTIONS(447),
    [anon_sym_const] = ACTIONS(447),
    [anon_sym_private] = ACTIONS(447),
    [anon_sym_protected] = ACTIONS(447),
    [anon_sym_static] = ACTIONS(447),
    [anon_sym_override] = ACTIONS(447),
    [anon_sym_import] = ACTIONS(447),
    [anon_sym_if] = ACTIONS(447),
    [anon_sym_else] = ACTIONS(447),
    [anon_sym_switch] = ACTIONS(447),
    [anon_sym_case] = ACTIONS(447),
    [anon_sym_default] = ACTIONS(447),
    [anon_sym_for] = ACTIONS(447),
    [anon_sym_in] = ACTIONS(447),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(447),
    [anon_sym_do] = ACTIONS(447),
    [anon_sym_with] = ACTIONS(447),
    [anon_sym_try] = ACTIONS(447),
    [anon_sym_break] = ACTIONS(447),
    [anon_sym_continue] = ACTIONS(447),
    [anon_sym_return] = ACTIONS(447),
    [anon_sym_throw] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_COLON_COLON] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_GT] = ACTIONS(447),
    [anon_sym_PLUS] = ACTIONS(447),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_delete] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(447),
    [anon_sym_void] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(447),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(447),
    [anon_sym_GT_GT_GT] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_instanceof] = ACTIONS(447),
    [anon_sym_is] = ACTIONS(447),
    [anon_sym_EQ_EQ] = ACTIONS(447),
    [anon_sym_BANG_EQ] = ACTIONS(447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(447),
    [anon_sym_CARET] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(447),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_as] = ACTIONS(447),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_new] = ACTIONS(447),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_undefined] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_number] = ACTIONS(447),
    [anon_sym_DQUOTE] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_identifier] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_package] = ACTIONS(451),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_dynamic] = ACTIONS(451),
    [anon_sym_final] = ACTIONS(451),
    [anon_sym_internal] = ACTIONS(451),
    [anon_sym_public] = ACTIONS(451),
    [anon_sym_interface] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_var] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(451),
    [anon_sym_private] = ACTIONS(451),
    [anon_sym_protected] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(451),
    [anon_sym_override] = ACTIONS(451),
    [anon_sym_import] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_else] = ACTIONS(451),
    [anon_sym_switch] = ACTIONS(451),
    [anon_sym_case] = ACTIONS(451),
    [anon_sym_default] = ACTIONS(451),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_in] = ACTIONS(457),
    [anon_sym_foreach] = ACTIONS(455),
    [anon_sym_while] = ACTIONS(451),
    [anon_sym_do] = ACTIONS(451),
    [anon_sym_with] = ACTIONS(451),
    [anon_sym_try] = ACTIONS(451),
    [anon_sym_break] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(451),
    [anon_sym_return] = ACTIONS(451),
    [anon_sym_throw] = ACTIONS(451),
    [anon_sym_DOT] = ACTIONS(457),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_DOT_DOT] = ACTIONS(453),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(457),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(451),
    [anon_sym_delete] = ACTIONS(451),
    [anon_sym_typeof] = ACTIONS(451),
    [anon_sym_void] = ACTIONS(451),
    [anon_sym_SLASH] = ACTIONS(457),
    [anon_sym_PERCENT] = ACTIONS(453),
    [anon_sym_LT_LT] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_GT_GT_GT] = ACTIONS(453),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(457),
    [anon_sym_is] = ACTIONS(457),
    [anon_sym_EQ_EQ] = ACTIONS(457),
    [anon_sym_BANG_EQ] = ACTIONS(457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_CARET] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_as] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_new] = ACTIONS(451),
    [sym_true] = ACTIONS(451),
    [sym_false] = ACTIONS(451),
    [sym_undefined] = ACTIONS(451),
    [sym_null] = ACTIONS(451),
    [sym_number] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_identifier] = ACTIONS(459),
    [anon_sym_namespace] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_package] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(459),
    [anon_sym_COMMA] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_dynamic] = ACTIONS(459),
    [anon_sym_final] = ACTIONS(459),
    [anon_sym_internal] = ACTIONS(459),
    [anon_sym_public] = ACTIONS(459),
    [anon_sym_interface] = ACTIONS(459),
    [anon_sym_LBRACE] = ACTIONS(463),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(459),
    [anon_sym_var] = ACTIONS(459),
    [anon_sym_const] = ACTIONS(459),
    [anon_sym_private] = ACTIONS(459),
    [anon_sym_protected] = ACTIONS(459),
    [anon_sym_static] = ACTIONS(459),
    [anon_sym_override] = ACTIONS(459),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(459),
    [anon_sym_switch] = ACTIONS(459),
    [anon_sym_case] = ACTIONS(459),
    [anon_sym_default] = ACTIONS(459),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(465),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_do] = ACTIONS(459),
    [anon_sym_with] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(459),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_continue] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(459),
    [anon_sym_throw] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_DOT_DOT] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(465),
    [anon_sym_DASH] = ACTIONS(465),
    [anon_sym_TILDE] = ACTIONS(463),
    [anon_sym_BANG] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(465),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_GT_GT_GT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_instanceof] = ACTIONS(465),
    [anon_sym_is] = ACTIONS(465),
    [anon_sym_EQ_EQ] = ACTIONS(465),
    [anon_sym_BANG_EQ] = ACTIONS(465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_CARET] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_as] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_PLUS_PLUS] = ACTIONS(461),
    [anon_sym_DASH_DASH] = ACTIONS(461),
    [anon_sym_new] = ACTIONS(459),
    [sym_true] = ACTIONS(459),
    [sym_false] = ACTIONS(459),
    [sym_undefined] = ACTIONS(459),
    [sym_null] = ACTIONS(459),
    [sym_number] = ACTIONS(459),
    [anon_sym_DQUOTE] = ACTIONS(463),
    [anon_sym_SQUOTE] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [168] = {
    [sym_identifier] = ACTIONS(467),
    [anon_sym_namespace] = ACTIONS(467),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_package] = ACTIONS(467),
    [anon_sym_class] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_dynamic] = ACTIONS(467),
    [anon_sym_final] = ACTIONS(467),
    [anon_sym_internal] = ACTIONS(467),
    [anon_sym_public] = ACTIONS(467),
    [anon_sym_interface] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_function] = ACTIONS(467),
    [anon_sym_var] = ACTIONS(467),
    [anon_sym_const] = ACTIONS(467),
    [anon_sym_private] = ACTIONS(467),
    [anon_sym_protected] = ACTIONS(467),
    [anon_sym_static] = ACTIONS(467),
    [anon_sym_override] = ACTIONS(467),
    [anon_sym_import] = ACTIONS(467),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_else] = ACTIONS(467),
    [anon_sym_switch] = ACTIONS(467),
    [anon_sym_case] = ACTIONS(467),
    [anon_sym_default] = ACTIONS(467),
    [anon_sym_for] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_foreach] = ACTIONS(469),
    [anon_sym_while] = ACTIONS(467),
    [anon_sym_do] = ACTIONS(467),
    [anon_sym_with] = ACTIONS(467),
    [anon_sym_try] = ACTIONS(467),
    [anon_sym_break] = ACTIONS(467),
    [anon_sym_continue] = ACTIONS(467),
    [anon_sym_return] = ACTIONS(467),
    [anon_sym_throw] = ACTIONS(467),
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_DOT_DOT] = ACTIONS(469),
    [anon_sym_COLON_COLON] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_delete] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(467),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_GT_GT_GT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_instanceof] = ACTIONS(467),
    [anon_sym_is] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(469),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_as] = ACTIONS(467),
    [anon_sym_QMARK] = ACTIONS(469),
    [anon_sym_PLUS_PLUS] = ACTIONS(469),
    [anon_sym_DASH_DASH] = ACTIONS(469),
    [anon_sym_new] = ACTIONS(467),
    [sym_true] = ACTIONS(467),
    [sym_false] = ACTIONS(467),
    [sym_undefined] = ACTIONS(467),
    [sym_null] = ACTIONS(467),
    [sym_number] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_SQUOTE] = ACTIONS(469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_identifier] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_package] = ACTIONS(471),
    [anon_sym_class] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(473),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_dynamic] = ACTIONS(471),
    [anon_sym_final] = ACTIONS(471),
    [anon_sym_internal] = ACTIONS(471),
    [anon_sym_public] = ACTIONS(471),
    [anon_sym_interface] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(475),
    [anon_sym_RBRACE] = ACTIONS(475),
    [anon_sym_function] = ACTIONS(471),
    [anon_sym_var] = ACTIONS(471),
    [anon_sym_const] = ACTIONS(471),
    [anon_sym_private] = ACTIONS(471),
    [anon_sym_protected] = ACTIONS(471),
    [anon_sym_static] = ACTIONS(471),
    [anon_sym_override] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_else] = ACTIONS(471),
    [anon_sym_switch] = ACTIONS(471),
    [anon_sym_case] = ACTIONS(471),
    [anon_sym_default] = ACTIONS(471),
    [anon_sym_for] = ACTIONS(471),
    [anon_sym_in] = ACTIONS(477),
    [anon_sym_foreach] = ACTIONS(475),
    [anon_sym_while] = ACTIONS(471),
    [anon_sym_do] = ACTIONS(471),
    [anon_sym_with] = ACTIONS(471),
    [anon_sym_try] = ACTIONS(471),
    [anon_sym_break] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_throw] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_DOT_DOT] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(475),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(473),
    [anon_sym_LT_LT] = ACTIONS(473),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_GT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(473),
    [anon_sym_instanceof] = ACTIONS(477),
    [anon_sym_is] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(473),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(473),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_new] = ACTIONS(471),
    [sym_true] = ACTIONS(471),
    [sym_false] = ACTIONS(471),
    [sym_undefined] = ACTIONS(471),
    [sym_null] = ACTIONS(471),
    [sym_number] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(475),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_identifier] = ACTIONS(447),
    [anon_sym_namespace] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_package] = ACTIONS(447),
    [anon_sym_class] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_dynamic] = ACTIONS(447),
    [anon_sym_final] = ACTIONS(447),
    [anon_sym_internal] = ACTIONS(447),
    [anon_sym_public] = ACTIONS(447),
    [anon_sym_interface] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(449),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(447),
    [anon_sym_var] = ACTIONS(447),
    [anon_sym_const] = ACTIONS(447),
    [anon_sym_private] = ACTIONS(447),
    [anon_sym_protected] = ACTIONS(447),
    [anon_sym_static] = ACTIONS(447),
    [anon_sym_override] = ACTIONS(447),
    [anon_sym_import] = ACTIONS(447),
    [anon_sym_if] = ACTIONS(447),
    [anon_sym_else] = ACTIONS(447),
    [anon_sym_switch] = ACTIONS(447),
    [anon_sym_case] = ACTIONS(447),
    [anon_sym_default] = ACTIONS(447),
    [anon_sym_for] = ACTIONS(447),
    [anon_sym_in] = ACTIONS(481),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(447),
    [anon_sym_do] = ACTIONS(447),
    [anon_sym_with] = ACTIONS(447),
    [anon_sym_try] = ACTIONS(447),
    [anon_sym_break] = ACTIONS(447),
    [anon_sym_continue] = ACTIONS(447),
    [anon_sym_return] = ACTIONS(447),
    [anon_sym_throw] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_DOT_DOT] = ACTIONS(479),
    [anon_sym_COLON_COLON] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_DASH] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(449),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_delete] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(447),
    [anon_sym_void] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(479),
    [anon_sym_LT_LT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_GT_GT_GT] = ACTIONS(479),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(481),
    [anon_sym_is] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(481),
    [anon_sym_BANG_EQ] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(479),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_as] = ACTIONS(481),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_new] = ACTIONS(447),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_undefined] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_number] = ACTIONS(447),
    [anon_sym_DQUOTE] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_identifier] = ACTIONS(483),
    [anon_sym_namespace] = ACTIONS(483),
    [anon_sym_SEMI] = ACTIONS(485),
    [anon_sym_package] = ACTIONS(483),
    [anon_sym_class] = ACTIONS(483),
    [anon_sym_COMMA] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_dynamic] = ACTIONS(483),
    [anon_sym_final] = ACTIONS(483),
    [anon_sym_internal] = ACTIONS(483),
    [anon_sym_public] = ACTIONS(483),
    [anon_sym_interface] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(487),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_function] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(483),
    [anon_sym_private] = ACTIONS(483),
    [anon_sym_protected] = ACTIONS(483),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_override] = ACTIONS(483),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(483),
    [anon_sym_else] = ACTIONS(483),
    [anon_sym_switch] = ACTIONS(483),
    [anon_sym_case] = ACTIONS(483),
    [anon_sym_default] = ACTIONS(483),
    [anon_sym_for] = ACTIONS(483),
    [anon_sym_in] = ACTIONS(489),
    [anon_sym_foreach] = ACTIONS(487),
    [anon_sym_while] = ACTIONS(483),
    [anon_sym_do] = ACTIONS(483),
    [anon_sym_with] = ACTIONS(483),
    [anon_sym_try] = ACTIONS(483),
    [anon_sym_break] = ACTIONS(483),
    [anon_sym_continue] = ACTIONS(483),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_throw] = ACTIONS(483),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(485),
    [anon_sym_COLON_COLON] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(489),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_delete] = ACTIONS(483),
    [anon_sym_typeof] = ACTIONS(483),
    [anon_sym_void] = ACTIONS(483),
    [anon_sym_SLASH] = ACTIONS(489),
    [anon_sym_PERCENT] = ACTIONS(485),
    [anon_sym_LT_LT] = ACTIONS(485),
    [anon_sym_GT_GT] = ACTIONS(489),
    [anon_sym_GT_GT_GT] = ACTIONS(485),
    [anon_sym_LT_EQ] = ACTIONS(485),
    [anon_sym_GT_EQ] = ACTIONS(485),
    [anon_sym_instanceof] = ACTIONS(489),
    [anon_sym_is] = ACTIONS(489),
    [anon_sym_EQ_EQ] = ACTIONS(489),
    [anon_sym_BANG_EQ] = ACTIONS(489),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(485),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(485),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_CARET] = ACTIONS(485),
    [anon_sym_PIPE] = ACTIONS(489),
    [anon_sym_AMP_AMP] = ACTIONS(485),
    [anon_sym_PIPE_PIPE] = ACTIONS(485),
    [anon_sym_as] = ACTIONS(489),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_PLUS_PLUS] = ACTIONS(485),
    [anon_sym_DASH_DASH] = ACTIONS(485),
    [anon_sym_new] = ACTIONS(483),
    [sym_true] = ACTIONS(483),
    [sym_false] = ACTIONS(483),
    [sym_undefined] = ACTIONS(483),
    [sym_null] = ACTIONS(483),
    [sym_number] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(487),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [172] = {
    [ts_builtin_sym_end] = ACTIONS(449),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_namespace] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_package] = ACTIONS(447),
    [anon_sym_class] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_dynamic] = ACTIONS(447),
    [anon_sym_final] = ACTIONS(447),
    [anon_sym_internal] = ACTIONS(447),
    [anon_sym_public] = ACTIONS(447),
    [anon_sym_interface] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(447),
    [anon_sym_var] = ACTIONS(447),
    [anon_sym_const] = ACTIONS(447),
    [anon_sym_private] = ACTIONS(447),
    [anon_sym_protected] = ACTIONS(447),
    [anon_sym_static] = ACTIONS(447),
    [anon_sym_override] = ACTIONS(447),
    [anon_sym_import] = ACTIONS(447),
    [anon_sym_if] = ACTIONS(447),
    [anon_sym_else] = ACTIONS(447),
    [anon_sym_switch] = ACTIONS(447),
    [anon_sym_for] = ACTIONS(447),
    [anon_sym_in] = ACTIONS(481),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(447),
    [anon_sym_do] = ACTIONS(447),
    [anon_sym_with] = ACTIONS(447),
    [anon_sym_try] = ACTIONS(447),
    [anon_sym_break] = ACTIONS(447),
    [anon_sym_continue] = ACTIONS(447),
    [anon_sym_return] = ACTIONS(447),
    [anon_sym_throw] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_DOT_DOT] = ACTIONS(479),
    [anon_sym_COLON_COLON] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_DASH] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(449),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_delete] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(447),
    [anon_sym_void] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(479),
    [anon_sym_LT_LT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_GT_GT_GT] = ACTIONS(479),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(481),
    [anon_sym_is] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(481),
    [anon_sym_BANG_EQ] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(479),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_as] = ACTIONS(481),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_new] = ACTIONS(447),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_undefined] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_number] = ACTIONS(447),
    [anon_sym_DQUOTE] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(463),
    [sym_identifier] = ACTIONS(459),
    [anon_sym_namespace] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_package] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(459),
    [anon_sym_COMMA] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_dynamic] = ACTIONS(459),
    [anon_sym_final] = ACTIONS(459),
    [anon_sym_internal] = ACTIONS(459),
    [anon_sym_public] = ACTIONS(459),
    [anon_sym_interface] = ACTIONS(459),
    [anon_sym_LBRACE] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(459),
    [anon_sym_var] = ACTIONS(459),
    [anon_sym_const] = ACTIONS(459),
    [anon_sym_private] = ACTIONS(459),
    [anon_sym_protected] = ACTIONS(459),
    [anon_sym_static] = ACTIONS(459),
    [anon_sym_override] = ACTIONS(459),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(459),
    [anon_sym_switch] = ACTIONS(459),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(465),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_do] = ACTIONS(459),
    [anon_sym_with] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(459),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_continue] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(459),
    [anon_sym_throw] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_DOT_DOT] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(465),
    [anon_sym_DASH] = ACTIONS(465),
    [anon_sym_TILDE] = ACTIONS(463),
    [anon_sym_BANG] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(465),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_GT_GT_GT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_instanceof] = ACTIONS(465),
    [anon_sym_is] = ACTIONS(465),
    [anon_sym_EQ_EQ] = ACTIONS(465),
    [anon_sym_BANG_EQ] = ACTIONS(465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_CARET] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_as] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_PLUS_PLUS] = ACTIONS(461),
    [anon_sym_DASH_DASH] = ACTIONS(461),
    [anon_sym_new] = ACTIONS(459),
    [sym_true] = ACTIONS(459),
    [sym_false] = ACTIONS(459),
    [sym_undefined] = ACTIONS(459),
    [sym_null] = ACTIONS(459),
    [sym_number] = ACTIONS(459),
    [anon_sym_DQUOTE] = ACTIONS(463),
    [anon_sym_SQUOTE] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(475),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_package] = ACTIONS(471),
    [anon_sym_class] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(473),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_dynamic] = ACTIONS(471),
    [anon_sym_final] = ACTIONS(471),
    [anon_sym_internal] = ACTIONS(471),
    [anon_sym_public] = ACTIONS(471),
    [anon_sym_interface] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(475),
    [anon_sym_function] = ACTIONS(471),
    [anon_sym_var] = ACTIONS(471),
    [anon_sym_const] = ACTIONS(471),
    [anon_sym_private] = ACTIONS(471),
    [anon_sym_protected] = ACTIONS(471),
    [anon_sym_static] = ACTIONS(471),
    [anon_sym_override] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_else] = ACTIONS(471),
    [anon_sym_switch] = ACTIONS(471),
    [anon_sym_for] = ACTIONS(471),
    [anon_sym_in] = ACTIONS(477),
    [anon_sym_foreach] = ACTIONS(475),
    [anon_sym_while] = ACTIONS(471),
    [anon_sym_do] = ACTIONS(471),
    [anon_sym_with] = ACTIONS(471),
    [anon_sym_try] = ACTIONS(471),
    [anon_sym_break] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_throw] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_DOT_DOT] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(475),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(473),
    [anon_sym_LT_LT] = ACTIONS(473),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_GT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(473),
    [anon_sym_instanceof] = ACTIONS(477),
    [anon_sym_is] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(473),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(473),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_new] = ACTIONS(471),
    [sym_true] = ACTIONS(471),
    [sym_false] = ACTIONS(471),
    [sym_undefined] = ACTIONS(471),
    [sym_null] = ACTIONS(471),
    [sym_number] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(475),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(469),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_namespace] = ACTIONS(467),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_package] = ACTIONS(467),
    [anon_sym_class] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_dynamic] = ACTIONS(467),
    [anon_sym_final] = ACTIONS(467),
    [anon_sym_internal] = ACTIONS(467),
    [anon_sym_public] = ACTIONS(467),
    [anon_sym_interface] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_function] = ACTIONS(467),
    [anon_sym_var] = ACTIONS(467),
    [anon_sym_const] = ACTIONS(467),
    [anon_sym_private] = ACTIONS(467),
    [anon_sym_protected] = ACTIONS(467),
    [anon_sym_static] = ACTIONS(467),
    [anon_sym_override] = ACTIONS(467),
    [anon_sym_import] = ACTIONS(467),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_else] = ACTIONS(467),
    [anon_sym_switch] = ACTIONS(467),
    [anon_sym_for] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_foreach] = ACTIONS(469),
    [anon_sym_while] = ACTIONS(467),
    [anon_sym_do] = ACTIONS(467),
    [anon_sym_with] = ACTIONS(467),
    [anon_sym_try] = ACTIONS(467),
    [anon_sym_break] = ACTIONS(467),
    [anon_sym_continue] = ACTIONS(467),
    [anon_sym_return] = ACTIONS(467),
    [anon_sym_throw] = ACTIONS(467),
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_DOT_DOT] = ACTIONS(469),
    [anon_sym_COLON_COLON] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_delete] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(467),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_GT_GT_GT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_instanceof] = ACTIONS(467),
    [anon_sym_is] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(469),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_as] = ACTIONS(467),
    [anon_sym_QMARK] = ACTIONS(469),
    [anon_sym_PLUS_PLUS] = ACTIONS(469),
    [anon_sym_DASH_DASH] = ACTIONS(469),
    [anon_sym_new] = ACTIONS(467),
    [sym_true] = ACTIONS(467),
    [sym_false] = ACTIONS(467),
    [sym_undefined] = ACTIONS(467),
    [sym_null] = ACTIONS(467),
    [sym_number] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_SQUOTE] = ACTIONS(469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(449),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_namespace] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_package] = ACTIONS(447),
    [anon_sym_class] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_LBRACK] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(449),
    [anon_sym_dynamic] = ACTIONS(447),
    [anon_sym_final] = ACTIONS(447),
    [anon_sym_internal] = ACTIONS(447),
    [anon_sym_public] = ACTIONS(447),
    [anon_sym_interface] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(447),
    [anon_sym_var] = ACTIONS(447),
    [anon_sym_const] = ACTIONS(447),
    [anon_sym_private] = ACTIONS(447),
    [anon_sym_protected] = ACTIONS(447),
    [anon_sym_static] = ACTIONS(447),
    [anon_sym_override] = ACTIONS(447),
    [anon_sym_import] = ACTIONS(447),
    [anon_sym_if] = ACTIONS(447),
    [anon_sym_else] = ACTIONS(447),
    [anon_sym_switch] = ACTIONS(447),
    [anon_sym_for] = ACTIONS(447),
    [anon_sym_in] = ACTIONS(447),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(447),
    [anon_sym_do] = ACTIONS(447),
    [anon_sym_with] = ACTIONS(447),
    [anon_sym_try] = ACTIONS(447),
    [anon_sym_break] = ACTIONS(447),
    [anon_sym_continue] = ACTIONS(447),
    [anon_sym_return] = ACTIONS(447),
    [anon_sym_throw] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_COLON_COLON] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_GT] = ACTIONS(447),
    [anon_sym_PLUS] = ACTIONS(447),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_delete] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(447),
    [anon_sym_void] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(447),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(447),
    [anon_sym_GT_GT_GT] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_instanceof] = ACTIONS(447),
    [anon_sym_is] = ACTIONS(447),
    [anon_sym_EQ_EQ] = ACTIONS(447),
    [anon_sym_BANG_EQ] = ACTIONS(447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(447),
    [anon_sym_CARET] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(447),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_as] = ACTIONS(447),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_new] = ACTIONS(447),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_undefined] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_number] = ACTIONS(447),
    [anon_sym_DQUOTE] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(455),
    [sym_identifier] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_package] = ACTIONS(451),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_dynamic] = ACTIONS(451),
    [anon_sym_final] = ACTIONS(451),
    [anon_sym_internal] = ACTIONS(451),
    [anon_sym_public] = ACTIONS(451),
    [anon_sym_interface] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_var] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(451),
    [anon_sym_private] = ACTIONS(451),
    [anon_sym_protected] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(451),
    [anon_sym_override] = ACTIONS(451),
    [anon_sym_import] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_else] = ACTIONS(451),
    [anon_sym_switch] = ACTIONS(451),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_in] = ACTIONS(457),
    [anon_sym_foreach] = ACTIONS(455),
    [anon_sym_while] = ACTIONS(451),
    [anon_sym_do] = ACTIONS(451),
    [anon_sym_with] = ACTIONS(451),
    [anon_sym_try] = ACTIONS(451),
    [anon_sym_break] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(451),
    [anon_sym_return] = ACTIONS(451),
    [anon_sym_throw] = ACTIONS(451),
    [anon_sym_DOT] = ACTIONS(457),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_DOT_DOT] = ACTIONS(453),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(457),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(451),
    [anon_sym_delete] = ACTIONS(451),
    [anon_sym_typeof] = ACTIONS(451),
    [anon_sym_void] = ACTIONS(451),
    [anon_sym_SLASH] = ACTIONS(457),
    [anon_sym_PERCENT] = ACTIONS(453),
    [anon_sym_LT_LT] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_GT_GT_GT] = ACTIONS(453),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(457),
    [anon_sym_is] = ACTIONS(457),
    [anon_sym_EQ_EQ] = ACTIONS(457),
    [anon_sym_BANG_EQ] = ACTIONS(457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_CARET] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_as] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_new] = ACTIONS(451),
    [sym_true] = ACTIONS(451),
    [sym_false] = ACTIONS(451),
    [sym_undefined] = ACTIONS(451),
    [sym_null] = ACTIONS(451),
    [sym_number] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [178] = {
    [ts_builtin_sym_end] = ACTIONS(487),
    [sym_identifier] = ACTIONS(483),
    [anon_sym_namespace] = ACTIONS(483),
    [anon_sym_SEMI] = ACTIONS(485),
    [anon_sym_package] = ACTIONS(483),
    [anon_sym_class] = ACTIONS(483),
    [anon_sym_COMMA] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_dynamic] = ACTIONS(483),
    [anon_sym_final] = ACTIONS(483),
    [anon_sym_internal] = ACTIONS(483),
    [anon_sym_public] = ACTIONS(483),
    [anon_sym_interface] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(487),
    [anon_sym_function] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(483),
    [anon_sym_private] = ACTIONS(483),
    [anon_sym_protected] = ACTIONS(483),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_override] = ACTIONS(483),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(483),
    [anon_sym_else] = ACTIONS(483),
    [anon_sym_switch] = ACTIONS(483),
    [anon_sym_for] = ACTIONS(483),
    [anon_sym_in] = ACTIONS(489),
    [anon_sym_foreach] = ACTIONS(487),
    [anon_sym_while] = ACTIONS(483),
    [anon_sym_do] = ACTIONS(483),
    [anon_sym_with] = ACTIONS(483),
    [anon_sym_try] = ACTIONS(483),
    [anon_sym_break] = ACTIONS(483),
    [anon_sym_continue] = ACTIONS(483),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_throw] = ACTIONS(483),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(485),
    [anon_sym_COLON_COLON] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(489),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_delete] = ACTIONS(483),
    [anon_sym_typeof] = ACTIONS(483),
    [anon_sym_void] = ACTIONS(483),
    [anon_sym_SLASH] = ACTIONS(489),
    [anon_sym_PERCENT] = ACTIONS(485),
    [anon_sym_LT_LT] = ACTIONS(485),
    [anon_sym_GT_GT] = ACTIONS(489),
    [anon_sym_GT_GT_GT] = ACTIONS(485),
    [anon_sym_LT_EQ] = ACTIONS(485),
    [anon_sym_GT_EQ] = ACTIONS(485),
    [anon_sym_instanceof] = ACTIONS(489),
    [anon_sym_is] = ACTIONS(489),
    [anon_sym_EQ_EQ] = ACTIONS(489),
    [anon_sym_BANG_EQ] = ACTIONS(489),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(485),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(485),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_CARET] = ACTIONS(485),
    [anon_sym_PIPE] = ACTIONS(489),
    [anon_sym_AMP_AMP] = ACTIONS(485),
    [anon_sym_PIPE_PIPE] = ACTIONS(485),
    [anon_sym_as] = ACTIONS(489),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_PLUS_PLUS] = ACTIONS(485),
    [anon_sym_DASH_DASH] = ACTIONS(485),
    [anon_sym_new] = ACTIONS(483),
    [sym_true] = ACTIONS(483),
    [sym_false] = ACTIONS(483),
    [sym_undefined] = ACTIONS(483),
    [sym_null] = ACTIONS(483),
    [sym_number] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(487),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_identifier] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_package] = ACTIONS(451),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_dynamic] = ACTIONS(451),
    [anon_sym_final] = ACTIONS(451),
    [anon_sym_internal] = ACTIONS(451),
    [anon_sym_public] = ACTIONS(451),
    [anon_sym_interface] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_var] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(451),
    [anon_sym_private] = ACTIONS(451),
    [anon_sym_protected] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(451),
    [anon_sym_override] = ACTIONS(451),
    [anon_sym_import] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_switch] = ACTIONS(451),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_in] = ACTIONS(457),
    [anon_sym_foreach] = ACTIONS(455),
    [anon_sym_while] = ACTIONS(451),
    [anon_sym_do] = ACTIONS(451),
    [anon_sym_with] = ACTIONS(451),
    [anon_sym_try] = ACTIONS(451),
    [anon_sym_break] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(451),
    [anon_sym_return] = ACTIONS(451),
    [anon_sym_throw] = ACTIONS(451),
    [anon_sym_DOT] = ACTIONS(457),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_DOT_DOT] = ACTIONS(453),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(457),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(451),
    [anon_sym_delete] = ACTIONS(451),
    [anon_sym_typeof] = ACTIONS(451),
    [anon_sym_void] = ACTIONS(451),
    [anon_sym_SLASH] = ACTIONS(457),
    [anon_sym_PERCENT] = ACTIONS(453),
    [anon_sym_LT_LT] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_GT_GT_GT] = ACTIONS(453),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(457),
    [anon_sym_is] = ACTIONS(457),
    [anon_sym_EQ_EQ] = ACTIONS(457),
    [anon_sym_BANG_EQ] = ACTIONS(457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_CARET] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_as] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_new] = ACTIONS(451),
    [sym_true] = ACTIONS(451),
    [sym_false] = ACTIONS(451),
    [sym_undefined] = ACTIONS(451),
    [sym_null] = ACTIONS(451),
    [sym_number] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_identifier] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_package] = ACTIONS(471),
    [anon_sym_class] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(473),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_dynamic] = ACTIONS(471),
    [anon_sym_final] = ACTIONS(471),
    [anon_sym_internal] = ACTIONS(471),
    [anon_sym_public] = ACTIONS(471),
    [anon_sym_interface] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(475),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_function] = ACTIONS(471),
    [anon_sym_var] = ACTIONS(471),
    [anon_sym_const] = ACTIONS(471),
    [anon_sym_private] = ACTIONS(471),
    [anon_sym_protected] = ACTIONS(471),
    [anon_sym_static] = ACTIONS(471),
    [anon_sym_override] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_switch] = ACTIONS(471),
    [anon_sym_for] = ACTIONS(471),
    [anon_sym_in] = ACTIONS(477),
    [anon_sym_foreach] = ACTIONS(475),
    [anon_sym_while] = ACTIONS(471),
    [anon_sym_do] = ACTIONS(471),
    [anon_sym_with] = ACTIONS(471),
    [anon_sym_try] = ACTIONS(471),
    [anon_sym_break] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_throw] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_DOT_DOT] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(475),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(473),
    [anon_sym_LT_LT] = ACTIONS(473),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_GT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(473),
    [anon_sym_instanceof] = ACTIONS(477),
    [anon_sym_is] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(473),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(473),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_new] = ACTIONS(471),
    [sym_true] = ACTIONS(471),
    [sym_false] = ACTIONS(471),
    [sym_undefined] = ACTIONS(471),
    [sym_null] = ACTIONS(471),
    [sym_number] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(475),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_identifier] = ACTIONS(447),
    [anon_sym_namespace] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_package] = ACTIONS(447),
    [anon_sym_class] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_dynamic] = ACTIONS(447),
    [anon_sym_final] = ACTIONS(447),
    [anon_sym_internal] = ACTIONS(447),
    [anon_sym_public] = ACTIONS(447),
    [anon_sym_interface] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(449),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_function] = ACTIONS(447),
    [anon_sym_var] = ACTIONS(447),
    [anon_sym_const] = ACTIONS(447),
    [anon_sym_private] = ACTIONS(447),
    [anon_sym_protected] = ACTIONS(447),
    [anon_sym_static] = ACTIONS(447),
    [anon_sym_override] = ACTIONS(447),
    [anon_sym_import] = ACTIONS(447),
    [anon_sym_if] = ACTIONS(447),
    [anon_sym_switch] = ACTIONS(447),
    [anon_sym_for] = ACTIONS(447),
    [anon_sym_in] = ACTIONS(481),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(447),
    [anon_sym_do] = ACTIONS(447),
    [anon_sym_with] = ACTIONS(447),
    [anon_sym_try] = ACTIONS(447),
    [anon_sym_break] = ACTIONS(447),
    [anon_sym_continue] = ACTIONS(447),
    [anon_sym_return] = ACTIONS(447),
    [anon_sym_throw] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_DOT_DOT] = ACTIONS(479),
    [anon_sym_COLON_COLON] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_DASH] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(449),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_delete] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(447),
    [anon_sym_void] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(479),
    [anon_sym_LT_LT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_GT_GT_GT] = ACTIONS(479),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(481),
    [anon_sym_is] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(481),
    [anon_sym_BANG_EQ] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(479),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_as] = ACTIONS(481),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_new] = ACTIONS(447),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_undefined] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_number] = ACTIONS(447),
    [anon_sym_DQUOTE] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_identifier] = ACTIONS(459),
    [anon_sym_namespace] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_package] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(459),
    [anon_sym_COMMA] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_dynamic] = ACTIONS(459),
    [anon_sym_final] = ACTIONS(459),
    [anon_sym_internal] = ACTIONS(459),
    [anon_sym_public] = ACTIONS(459),
    [anon_sym_interface] = ACTIONS(459),
    [anon_sym_LBRACE] = ACTIONS(463),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_function] = ACTIONS(459),
    [anon_sym_var] = ACTIONS(459),
    [anon_sym_const] = ACTIONS(459),
    [anon_sym_private] = ACTIONS(459),
    [anon_sym_protected] = ACTIONS(459),
    [anon_sym_static] = ACTIONS(459),
    [anon_sym_override] = ACTIONS(459),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_switch] = ACTIONS(459),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(465),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_do] = ACTIONS(459),
    [anon_sym_with] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(459),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_continue] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(459),
    [anon_sym_throw] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_DOT_DOT] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(465),
    [anon_sym_DASH] = ACTIONS(465),
    [anon_sym_TILDE] = ACTIONS(463),
    [anon_sym_BANG] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(465),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_GT_GT_GT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_instanceof] = ACTIONS(465),
    [anon_sym_is] = ACTIONS(465),
    [anon_sym_EQ_EQ] = ACTIONS(465),
    [anon_sym_BANG_EQ] = ACTIONS(465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_CARET] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_as] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_PLUS_PLUS] = ACTIONS(461),
    [anon_sym_DASH_DASH] = ACTIONS(461),
    [anon_sym_new] = ACTIONS(459),
    [sym_true] = ACTIONS(459),
    [sym_false] = ACTIONS(459),
    [sym_undefined] = ACTIONS(459),
    [sym_null] = ACTIONS(459),
    [sym_number] = ACTIONS(459),
    [anon_sym_DQUOTE] = ACTIONS(463),
    [anon_sym_SQUOTE] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_identifier] = ACTIONS(483),
    [anon_sym_namespace] = ACTIONS(483),
    [anon_sym_SEMI] = ACTIONS(485),
    [anon_sym_package] = ACTIONS(483),
    [anon_sym_class] = ACTIONS(483),
    [anon_sym_COMMA] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_dynamic] = ACTIONS(483),
    [anon_sym_final] = ACTIONS(483),
    [anon_sym_internal] = ACTIONS(483),
    [anon_sym_public] = ACTIONS(483),
    [anon_sym_interface] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(487),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_function] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(483),
    [anon_sym_private] = ACTIONS(483),
    [anon_sym_protected] = ACTIONS(483),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_override] = ACTIONS(483),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(483),
    [anon_sym_switch] = ACTIONS(483),
    [anon_sym_for] = ACTIONS(483),
    [anon_sym_in] = ACTIONS(489),
    [anon_sym_foreach] = ACTIONS(487),
    [anon_sym_while] = ACTIONS(483),
    [anon_sym_do] = ACTIONS(483),
    [anon_sym_with] = ACTIONS(483),
    [anon_sym_try] = ACTIONS(483),
    [anon_sym_break] = ACTIONS(483),
    [anon_sym_continue] = ACTIONS(483),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_throw] = ACTIONS(483),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(485),
    [anon_sym_COLON_COLON] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(489),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_delete] = ACTIONS(483),
    [anon_sym_typeof] = ACTIONS(483),
    [anon_sym_void] = ACTIONS(483),
    [anon_sym_SLASH] = ACTIONS(489),
    [anon_sym_PERCENT] = ACTIONS(485),
    [anon_sym_LT_LT] = ACTIONS(485),
    [anon_sym_GT_GT] = ACTIONS(489),
    [anon_sym_GT_GT_GT] = ACTIONS(485),
    [anon_sym_LT_EQ] = ACTIONS(485),
    [anon_sym_GT_EQ] = ACTIONS(485),
    [anon_sym_instanceof] = ACTIONS(489),
    [anon_sym_is] = ACTIONS(489),
    [anon_sym_EQ_EQ] = ACTIONS(489),
    [anon_sym_BANG_EQ] = ACTIONS(489),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(485),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(485),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_CARET] = ACTIONS(485),
    [anon_sym_PIPE] = ACTIONS(489),
    [anon_sym_AMP_AMP] = ACTIONS(485),
    [anon_sym_PIPE_PIPE] = ACTIONS(485),
    [anon_sym_as] = ACTIONS(489),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_PLUS_PLUS] = ACTIONS(485),
    [anon_sym_DASH_DASH] = ACTIONS(485),
    [anon_sym_new] = ACTIONS(483),
    [sym_true] = ACTIONS(483),
    [sym_false] = ACTIONS(483),
    [sym_undefined] = ACTIONS(483),
    [sym_null] = ACTIONS(483),
    [sym_number] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(487),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(497), 1,
      anon_sym_COLON,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(491), 12,
      anon_sym_namespace,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
    ACTIONS(495), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 20,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_as,
  [81] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(505), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(491), 12,
      anon_sym_namespace,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
    ACTIONS(495), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 20,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_as,
  [161] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(507), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(491), 12,
      anon_sym_namespace,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
    ACTIONS(495), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 20,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_as,
  [241] = 7,
    ACTIONS(513), 1,
      anon_sym_catch,
    ACTIONS(515), 1,
      anon_sym_finally,
    STATE(489), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(188), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(511), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(509), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [319] = 7,
    ACTIONS(513), 1,
      anon_sym_catch,
    ACTIONS(515), 1,
      anon_sym_finally,
    STATE(465), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(190), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(519), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(517), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [397] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(521), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(491), 12,
      anon_sym_namespace,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
    ACTIONS(495), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 20,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_as,
  [477] = 5,
    ACTIONS(527), 1,
      anon_sym_catch,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(190), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(525), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(523), 44,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [550] = 7,
    ACTIONS(530), 1,
      anon_sym_catch,
    ACTIONS(532), 1,
      anon_sym_finally,
    STATE(775), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(192), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(511), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(509), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [626] = 7,
    ACTIONS(530), 1,
      anon_sym_catch,
    ACTIONS(532), 1,
      anon_sym_finally,
    STATE(553), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(197), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(519), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(517), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [702] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(536), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(534), 45,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [769] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(540), 16,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(538), 42,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [836] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(469), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(467), 45,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [903] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(449), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(447), 45,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [970] = 5,
    ACTIONS(542), 1,
      anon_sym_catch,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(197), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(525), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(523), 42,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1041] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(547), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(545), 45,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1108] = 5,
    ACTIONS(553), 1,
      anon_sym_DOT,
    ACTIONS(555), 1,
      anon_sym_DOT_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(551), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(549), 42,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1179] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(559), 16,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(557), 42,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1246] = 5,
    ACTIONS(565), 1,
      anon_sym_else,
    STATE(468), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(563), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(561), 42,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1316] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1381] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1446] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(577), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(575), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1511] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1576] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1641] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1706] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1771] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1836] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1901] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [1966] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2031] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2096] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2161] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2226] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2291] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2356] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2421] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2486] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2551] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2616] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2681] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2746] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(585), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(583), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2811] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(589), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(587), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2876] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [2941] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3006] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3071] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3136] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3201] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3266] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3331] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3396] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3461] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3526] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3591] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3656] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3721] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3786] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3851] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3916] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(593), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(591), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [3981] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4046] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4111] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4176] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4241] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4306] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4371] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4436] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4501] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4566] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4631] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4696] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4761] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4826] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(597), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(595), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4891] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(601), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(599), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [4956] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(605), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(603), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5021] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5086] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5151] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5216] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5281] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5346] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5411] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5476] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5541] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5606] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5671] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5736] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5801] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5866] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5931] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [5996] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(609), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(607), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6061] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6126] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6191] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6256] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6321] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6386] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6451] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6516] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6581] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6646] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6711] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6776] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6841] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6906] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [6971] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7036] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7101] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7166] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7231] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7296] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7361] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7426] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7491] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7556] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7621] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7686] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7751] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7816] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7881] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [7946] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8011] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8076] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8141] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8206] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8271] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8336] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8401] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8466] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8531] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8596] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8661] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8726] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8791] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8856] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(611), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8921] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [8986] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9051] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9116] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9181] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9246] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9311] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9376] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9441] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(617), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(615), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9506] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(449), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(447), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9571] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(621), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(619), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9636] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(625), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(623), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9701] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(629), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(627), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9766] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(633), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(631), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9831] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(637), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(635), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9896] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(641), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(639), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [9961] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(645), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(643), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10026] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(649), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(647), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10091] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(653), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(651), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10156] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(657), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(655), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10221] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(661), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(659), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10286] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(665), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(663), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10351] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(669), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(667), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10416] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(673), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(671), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10481] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(677), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(675), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10546] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10611] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10676] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(681), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(679), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10741] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10806] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(685), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(683), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10871] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [10936] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11001] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11066] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11131] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11196] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11261] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11326] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11391] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11456] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11521] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11586] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11651] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11716] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11781] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11846] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11911] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [11976] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12041] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12106] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12171] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12236] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12301] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12366] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12431] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12496] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12561] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(693), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(691), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12626] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12691] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12756] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12821] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12886] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [12951] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13016] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13081] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13146] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13211] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13276] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13341] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13406] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13471] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13536] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13601] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13666] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13731] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13796] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13861] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13926] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [13991] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14056] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(697), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(695), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14121] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14186] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(701), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(699), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14251] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(705), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(703), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14316] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14381] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(463), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(459), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14446] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(709), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(707), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14511] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(713), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(711), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14576] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14641] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(717), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(715), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14706] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14771] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14836] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14901] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(721), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(719), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [14966] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(725), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(723), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15031] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(729), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(727), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15096] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15161] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(733), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(731), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15226] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(737), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(735), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15291] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(741), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(739), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15356] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(745), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(743), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15421] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15486] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15551] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(749), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(747), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15616] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(469), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(467), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15681] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15746] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15811] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(753), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(751), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15876] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(757), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(755), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [15941] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(761), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(759), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16006] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16071] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16136] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(487), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(483), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16201] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(455), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(451), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16266] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(765), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(763), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16331] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16396] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16461] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(769), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(767), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16526] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16591] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(773), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(771), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16656] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(777), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(775), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16721] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(781), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(779), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16786] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(785), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(783), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16851] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16916] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [16981] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(789), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(787), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17046] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(793), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(791), 42,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17111] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(797), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(795), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17176] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17241] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(801), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(799), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17306] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(805), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(803), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17371] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(809), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(807), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17436] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17501] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17566] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(475), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(471), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17631] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(813), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(811), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17696] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17761] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(817), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(815), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17826] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(821), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(819), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17891] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(825), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(823), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [17956] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18021] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(829), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(827), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18086] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(833), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(831), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18151] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(837), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(835), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18216] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(841), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(839), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18281] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(845), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(843), 42,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18346] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18411] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(849), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(847), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18476] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(853), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(851), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18541] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(857), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(855), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18606] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(861), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(859), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18671] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18736] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(865), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(863), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18801] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(869), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(867), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18866] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18931] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [18996] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19061] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19126] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(873), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(871), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19191] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(873), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(871), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19256] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19321] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(877), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(875), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19386] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(881), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(879), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19451] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19516] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19581] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(885), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(883), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19646] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(889), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(887), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19711] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(893), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(891), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19776] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19841] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19906] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [19971] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(897), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(895), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20036] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(901), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(899), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20101] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20166] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(905), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(903), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20231] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(909), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(907), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20296] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20361] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(913), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(911), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20426] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(917), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(915), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20491] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20556] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(469), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(467), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20621] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(921), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(919), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20686] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20751] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(925), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(923), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20816] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(449), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(447), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20881] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(929), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(927), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [20946] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21011] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(933), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(931), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21076] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(937), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(935), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21141] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21206] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(941), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(939), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21271] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(945), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(943), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21336] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(949), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(947), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21401] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(953), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(951), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21466] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21531] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21596] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21661] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21726] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21791] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21856] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21921] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(957), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(955), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [21986] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(961), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(959), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22051] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(965), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(963), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22116] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22181] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22246] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22311] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22376] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(547), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(545), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22441] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22506] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22571] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22636] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22701] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22766] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22831] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22896] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [22961] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23026] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(969), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(967), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23091] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(973), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(971), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23156] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(977), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(975), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23221] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(981), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(979), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23286] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(985), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(983), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23351] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(989), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(987), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23416] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(536), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(534), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23481] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(993), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(991), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23546] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(997), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(995), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23611] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1001), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(999), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23676] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1005), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1003), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23741] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1009), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1007), 43,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23806] = 5,
    ACTIONS(1015), 1,
      anon_sym_COMMA,
    STATE(548), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1013), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1011), 40,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23874] = 5,
    ACTIONS(1018), 1,
      anon_sym_else,
    STATE(608), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(563), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(561), 40,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [23942] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24005] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24068] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(853), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(851), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24131] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(849), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(847), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24194] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(713), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(711), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24257] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(709), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(707), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24320] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(841), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(839), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24383] = 25,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1020), 1,
      sym_identifier,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1030), 1,
      anon_sym_var,
    STATE(908), 1,
      sym_member_expression,
    STATE(943), 1,
      sym_subscript_expression,
    STATE(1118), 1,
      sym_expression,
    STATE(1419), 1,
      sym__variable_declarator,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(895), 2,
      sym_expression_statement,
      sym_empty_statement,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [24490] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(953), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(951), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24553] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(949), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(947), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24616] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(837), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(835), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24679] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(833), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(831), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24742] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(961), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(959), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24805] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(857), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(855), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24868] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(463), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(459), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24931] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(705), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(703), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [24994] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(701), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(699), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25057] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(829), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(827), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25120] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(825), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(823), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25183] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(697), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(695), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25246] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25309] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25372] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25435] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25498] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25561] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25624] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25687] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25750] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25813] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25876] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [25939] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26002] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26065] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26128] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26191] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26254] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26317] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26380] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26443] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26506] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26569] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26632] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26695] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26758] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26821] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26884] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [26947] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27010] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27073] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27136] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27199] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27262] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27325] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27388] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27451] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27514] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27577] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(687), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27640] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(861), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(859), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27703] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(821), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(819), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27766] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(817), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(815), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27829] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(865), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(863), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27892] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(685), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(683), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [27955] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(945), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(943), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28018] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(681), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(679), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28081] = 25,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1032), 1,
      sym_identifier,
    ACTIONS(1034), 1,
      anon_sym_var,
    STATE(908), 1,
      sym_member_expression,
    STATE(932), 1,
      sym_subscript_expression,
    STATE(1118), 1,
      sym_expression,
    STATE(1486), 1,
      sym__variable_declarator,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(902), 2,
      sym_expression_statement,
      sym_empty_statement,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [28188] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(813), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(811), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28251] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(965), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(963), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28314] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(677), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(675), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28377] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(869), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(867), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28440] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(475), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(471), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28503] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(669), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(667), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28566] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(665), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(663), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28629] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(941), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(939), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28692] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(873), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(871), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28755] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(661), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(659), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28818] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(873), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(871), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28881] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(809), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(807), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [28944] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(657), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(655), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29007] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(653), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(651), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29070] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(805), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(803), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29133] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(801), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(799), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29196] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(649), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(647), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29259] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(797), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(795), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29322] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1013), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1011), 40,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29385] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(645), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(643), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29448] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(641), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(639), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29511] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(633), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(631), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29574] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(789), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(787), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29637] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(957), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(955), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29700] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(785), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(783), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29763] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(629), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(627), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29826] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(877), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(875), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29889] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(781), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(779), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [29952] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(777), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(775), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30015] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(773), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(771), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30078] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(769), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(767), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30141] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(881), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(879), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30204] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(937), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(935), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30267] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(625), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(623), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30330] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(621), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(619), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30393] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(933), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(931), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30456] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(617), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(615), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30519] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30582] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30645] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30708] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30771] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30834] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30897] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [30960] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31023] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31086] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31149] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31212] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31275] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31338] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31401] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31464] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31527] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31590] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31653] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31716] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31779] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31842] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31905] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [31968] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32031] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32094] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32157] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32220] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32283] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32346] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32409] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32472] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32535] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32598] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32661] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32724] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32787] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32850] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32913] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [32976] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33039] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33102] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33165] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33228] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33291] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33354] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33417] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33480] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33543] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33606] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33669] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33732] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33795] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33858] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33921] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [33984] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34047] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34110] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34173] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34236] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34299] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34362] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34425] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34488] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34551] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34614] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34677] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34740] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34803] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34866] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34929] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [34992] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35055] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35118] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35181] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35244] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(567), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35307] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35370] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35433] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35496] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35559] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35622] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35685] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35748] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35811] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35874] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [35937] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36000] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36063] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36126] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36189] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36252] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36315] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36378] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36441] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36504] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(765), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(763), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36567] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(885), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(883), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36630] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36693] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36756] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36819] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36882] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [36945] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37008] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37071] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37134] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37197] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37260] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37323] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37386] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37449] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37512] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37575] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37638] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37701] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37764] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(579), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37827] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(889), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(887), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37890] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(893), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(891), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [37953] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(577), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(575), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38016] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(717), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(715), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38079] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(693), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(691), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38142] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(721), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(719), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38205] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(897), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(895), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38268] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(589), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(587), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38331] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(593), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(591), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38394] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(455), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(451), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38457] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(597), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(595), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38520] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(487), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(483), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38583] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(601), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(599), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38646] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(605), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(603), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38709] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(761), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(759), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38772] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(609), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(607), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38835] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(901), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(899), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38898] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(905), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(903), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [38961] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(585), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(583), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39024] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(909), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(907), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39087] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(749), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(747), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39150] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(611), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39213] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(913), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(911), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39276] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(637), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(635), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39339] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(917), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(915), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39402] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(469), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(467), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39465] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(745), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(743), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39528] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(741), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(739), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39591] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(737), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(735), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39654] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(753), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(751), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39717] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(729), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(727), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39780] = 25,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1036), 1,
      sym_identifier,
    ACTIONS(1038), 1,
      anon_sym_var,
    STATE(908), 1,
      sym_member_expression,
    STATE(930), 1,
      sym_subscript_expression,
    STATE(1118), 1,
      sym_expression,
    STATE(1458), 1,
      sym__variable_declarator,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(894), 2,
      sym_expression_statement,
      sym_empty_statement,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [39887] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(673), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(671), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [39950] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40013] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40076] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40139] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40202] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40265] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40328] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40391] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40454] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40517] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40580] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40643] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40706] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40769] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40832] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40895] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [40958] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41021] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41084] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41147] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41210] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41273] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(725), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(723), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41336] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41399] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41462] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41525] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41588] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41651] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41714] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41777] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41840] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41903] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [41966] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42029] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42092] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42155] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42218] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42281] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42344] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42407] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42470] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42533] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42596] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42659] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42722] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42785] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42848] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42911] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [42974] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43037] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43100] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43163] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43226] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43289] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43352] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43415] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43478] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43541] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43604] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43667] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43730] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43793] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43856] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43919] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [43982] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44045] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44108] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44171] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44234] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44297] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44360] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44423] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44486] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(733), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(731), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44549] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44612] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44675] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(571), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44738] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(969), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(967), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44801] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(973), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(971), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44864] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(977), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(975), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44927] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(981), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(979), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [44990] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(985), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(983), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45053] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(989), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(987), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45116] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(921), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(919), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45179] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(993), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(991), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45242] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(997), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(995), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45305] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(925), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(923), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45368] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1001), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(999), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45431] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(449), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(447), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45494] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(757), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(755), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45557] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1009), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1007), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45620] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1005), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1003), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45683] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(929), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(927), 41,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [45746] = 22,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1118), 1,
      sym_expression,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    STATE(927), 2,
      sym_expression_statement,
      sym_empty_statement,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [45845] = 22,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1118), 1,
      sym_expression,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    STATE(918), 2,
      sym_expression_statement,
      sym_empty_statement,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [45944] = 23,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(912), 1,
      sym_empty_statement,
    STATE(913), 1,
      sym_expression_statement,
    STATE(1118), 1,
      sym_expression,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [46045] = 23,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(911), 1,
      sym_expression_statement,
    STATE(914), 1,
      sym_empty_statement,
    STATE(1118), 1,
      sym_expression,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [46146] = 23,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(915), 1,
      sym_expression_statement,
    STATE(916), 1,
      sym_empty_statement,
    STATE(1118), 1,
      sym_expression,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [46247] = 23,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(920), 1,
      sym_empty_statement,
    STATE(922), 1,
      sym_expression_statement,
    STATE(1118), 1,
      sym_expression,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [46348] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1044), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_foreach,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1042), 40,
      anon_sym_namespace,
      anon_sym_package,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      anon_sym_import,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_with,
      anon_sym_try,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [46409] = 23,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(919), 1,
      sym_expression_statement,
    STATE(928), 1,
      sym_empty_statement,
    STATE(1118), 1,
      sym_expression,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [46510] = 22,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1118), 1,
      sym_expression,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    STATE(924), 2,
      sym_expression_statement,
      sym_empty_statement,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [46609] = 6,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(499), 18,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(495), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [46676] = 23,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1022), 1,
      anon_sym_SEMI,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(921), 1,
      sym_expression_statement,
    STATE(925), 1,
      sym_empty_statement,
    STATE(1118), 1,
      sym_expression,
    STATE(1714), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [46777] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1048), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [46837] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1050), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1052), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [46897] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1042), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1044), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [46957] = 5,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(499), 18,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(495), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [47021] = 9,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1056), 1,
      anon_sym_in,
    STATE(1681), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(495), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [47092] = 10,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1059), 1,
      anon_sym_EQ,
    ACTIONS(1063), 1,
      anon_sym_in,
    STATE(1371), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1061), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(495), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
  [47165] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_RPAREN,
    STATE(1108), 1,
      sym_expression,
    STATE(1626), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [47260] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1068), 1,
      anon_sym_RPAREN,
    STATE(1106), 1,
      sym_expression,
    STATE(1745), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [47355] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1070), 1,
      anon_sym_RPAREN,
    STATE(1110), 1,
      sym_expression,
    STATE(1702), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [47450] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1072), 1,
      anon_sym_RPAREN,
    STATE(1109), 1,
      sym_expression,
    STATE(1628), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [47545] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
    STATE(1105), 1,
      sym_expression,
    STATE(1624), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [47640] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1076), 1,
      anon_sym_RPAREN,
    STATE(1100), 1,
      sym_expression,
    STATE(1618), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [47735] = 9,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1078), 1,
      anon_sym_in,
    STATE(1696), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(495), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [47806] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1081), 1,
      anon_sym_RPAREN,
    STATE(1103), 1,
      sym_expression,
    STATE(1606), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [47901] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1083), 1,
      anon_sym_RPAREN,
    STATE(1104), 1,
      sym_expression,
    STATE(1610), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [47996] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1085), 1,
      anon_sym_RPAREN,
    STATE(1096), 1,
      sym_expression,
    STATE(1594), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [48091] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1087), 1,
      anon_sym_RPAREN,
    STATE(1101), 1,
      sym_expression,
    STATE(1724), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [48186] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1089), 1,
      anon_sym_RPAREN,
    STATE(1113), 1,
      sym_expression,
    STATE(1644), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [48281] = 9,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1091), 1,
      anon_sym_in,
    STATE(1671), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(495), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [48352] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1094), 1,
      anon_sym_RPAREN,
    STATE(1112), 1,
      sym_expression,
    STATE(1609), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [48447] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1096), 1,
      anon_sym_RPAREN,
    STATE(1102), 1,
      sym_expression,
    STATE(1722), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [48542] = 10,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1059), 1,
      anon_sym_EQ,
    ACTIONS(1098), 1,
      anon_sym_in,
    STATE(1389), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1061), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(495), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
  [48615] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1101), 1,
      anon_sym_RPAREN,
    STATE(1099), 1,
      sym_expression,
    STATE(1613), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [48710] = 21,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      sym_expression,
    STATE(1621), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [48805] = 10,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1059), 1,
      anon_sym_EQ,
    ACTIONS(1105), 1,
      anon_sym_in,
    STATE(1342), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1061), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(495), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
  [48878] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1056), 1,
      anon_sym_in,
    STATE(1681), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(495), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [48946] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1108), 1,
      anon_sym_SEMI,
    STATE(1130), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [49038] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1091), 1,
      anon_sym_in,
    STATE(1671), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(495), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [49106] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1119), 1,
      sym_expression,
    STATE(1704), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [49198] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1110), 1,
      anon_sym_RBRACK,
    STATE(1092), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [49290] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1110), 1,
      anon_sym_RBRACK,
    ACTIONS(1112), 1,
      sym_identifier,
    STATE(1092), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [49382] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1114), 1,
      anon_sym_RPAREN,
    STATE(1089), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [49474] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1121), 1,
      sym_expression,
    STATE(1680), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [49566] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1088), 1,
      sym_expression,
    STATE(1530), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [49658] = 10,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(1116), 1,
      anon_sym_COMMA,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    ACTIONS(1122), 1,
      anon_sym_RBRACK,
    STATE(1435), 1,
      aux_sym_annotation_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(495), 15,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 17,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
  [49730] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_SEMI,
    STATE(1148), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [49822] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1127), 1,
      anon_sym_SEMI,
    STATE(1167), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [49914] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1120), 1,
      sym_expression,
    STATE(1709), 1,
      sym_sequence_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50006] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1078), 1,
      anon_sym_in,
    STATE(1696), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(495), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [50074] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1129), 1,
      anon_sym_SEMI,
    STATE(1129), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50166] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1046), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50255] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1159), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50344] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1117), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50433] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1127), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50522] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1170), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50611] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1039), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50700] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1168), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50789] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1125), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50878] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1131), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [50967] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      sym_identifier,
    STATE(908), 1,
      sym_member_expression,
    STATE(1022), 1,
      sym_subscript_expression,
    STATE(1171), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51058] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1156), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51147] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1037), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51236] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1133), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51325] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1134), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51414] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1136), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51503] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1133), 1,
      sym_identifier,
    STATE(908), 1,
      sym_member_expression,
    STATE(1021), 1,
      sym_subscript_expression,
    STATE(1171), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51594] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1140), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51683] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1147), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51772] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1152), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51861] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1154), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [51950] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1034), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52039] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1098), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52128] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1144), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52217] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1032), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52306] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1061), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52395] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1138), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52484] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1142), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52573] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1164), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52662] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1067), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52751] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1072), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52840] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1047), 1,
      sym_primary_expression,
    STATE(1171), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 8,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [52931] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1165), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53020] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1062), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53109] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1069), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53198] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1128), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53287] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1042), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53376] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1155), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53465] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1157), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53554] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1124), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53643] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53732] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1150), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53821] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1126), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53910] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1146), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [53999] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1040), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54088] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1141), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54177] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1137), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54266] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54355] = 20,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1135), 1,
      sym_identifier,
    STATE(908), 1,
      sym_member_expression,
    STATE(1020), 1,
      sym_subscript_expression,
    STATE(1171), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54446] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1151), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54535] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1085), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54624] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1097), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54713] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1090), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54802] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1038), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54891] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1094), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [54980] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1087), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55069] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1132), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55158] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1166), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55247] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1160), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55336] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1111), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55425] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1163), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55514] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1162), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55603] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1077), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55692] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1093), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55781] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1135), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55870] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1169), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [55959] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1153), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56048] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1139), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56137] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1122), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56226] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1123), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56315] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1158), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56404] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1149), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56493] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1143), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56582] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1095), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56671] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1161), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56760] = 19,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LT,
    ACTIONS(71), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_new,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1024), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_function,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(1079), 1,
      sym_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(69), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(908), 2,
      sym_subscript_expression,
      sym_member_expression,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
    ACTIONS(77), 5,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
    STATE(1058), 9,
      sym_primary_expression,
      sym_assignment_expression,
      sym_augmented_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_cast_expression,
      sym_ternary_expression,
      sym_update_expression,
      sym_new_expression,
    STATE(1030), 12,
      sym_descendant_expression,
      sym_namespace_expression,
      sym_parenthesized_expression,
      sym_object,
      sym_array,
      sym_vector,
      sym_xml,
      sym_anonymous_function,
      sym_call_expression,
      sym_generic_data_type,
      sym_string,
      sym_regex,
  [56849] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1063), 1,
      anon_sym_in,
    STATE(1697), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(495), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
  [56915] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1105), 1,
      anon_sym_in,
    STATE(1738), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(495), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
  [56981] = 8,
    ACTIONS(493), 1,
      anon_sym_EQ,
    ACTIONS(1054), 1,
      anon_sym_COLON,
    ACTIONS(1098), 1,
      anon_sym_in,
    STATE(1614), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(495), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(499), 16,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
  [57047] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(467), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(469), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57097] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(843), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(845), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57147] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(447), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(449), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57197] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(791), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(793), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57247] = 5,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(1137), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(549), 12,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(551), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57300] = 4,
    ACTIONS(1143), 1,
      sym_regex_flags,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1141), 16,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_as,
    ACTIONS(1139), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57351] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1042), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1044), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57400] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(499), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(495), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57448] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1147), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1145), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57496] = 22,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_COLON,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
    ACTIONS(1149), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [57582] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1193), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1191), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57630] = 23,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_COLON,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
    ACTIONS(1149), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [57718] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1199), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1197), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57766] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1203), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1201), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57814] = 9,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1207), 12,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1205), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
  [57874] = 9,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1211), 12,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1209), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
  [57934] = 9,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1155), 12,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1149), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
  [57994] = 17,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
    ACTIONS(1155), 5,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1149), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [58070] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1215), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1213), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58118] = 19,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1155), 3,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
    ACTIONS(1149), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [58198] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1219), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1217), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58246] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1223), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58294] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1227), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1225), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58342] = 14,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1155), 8,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1149), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
  [58412] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1231), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1229), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58460] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(538), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(540), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58508] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1235), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1233), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58556] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1239), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1237), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58604] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1243), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1241), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58652] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1247), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1245), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58700] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1251), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1249), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58748] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1255), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1253), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58796] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(557), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(559), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58844] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1259), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1257), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58892] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(465), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(461), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58940] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1263), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1261), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [58988] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1267), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1265), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59036] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1271), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1269), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59084] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1275), 1,
      anon_sym_COLON,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
    ACTIONS(1273), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [59176] = 20,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1155), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
    ACTIONS(1149), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [59258] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1283), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1281), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59306] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1287), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1285), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59354] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(481), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(479), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59402] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1291), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1289), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59450] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1295), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
    ACTIONS(1293), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [59542] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1299), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1297), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59590] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1303), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
    ACTIONS(1301), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [59682] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1307), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1305), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59730] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1311), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1309), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59778] = 21,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1155), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
    ACTIONS(1149), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [59862] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1315), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1313), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59910] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(457), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(453), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59958] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(489), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(485), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60006] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(477), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(473), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60054] = 12,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1155), 9,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1149), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
  [60120] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1319), 13,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1317), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60168] = 11,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1155), 11,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1149), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
  [60232] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(463), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(465), 12,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(461), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60280] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(487), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(489), 12,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(485), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60328] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(455), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(457), 12,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(453), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60376] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(475), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(477), 12,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(473), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60424] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(449), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(481), 12,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(479), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60472] = 26,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(1323), 1,
      anon_sym_RPAREN,
    STATE(1463), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [60563] = 4,
    ACTIONS(1325), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(499), 12,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(495), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60610] = 26,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(1329), 1,
      anon_sym_RPAREN,
    STATE(1493), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [60701] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1331), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [60790] = 26,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(1335), 1,
      anon_sym_RPAREN,
    STATE(1498), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [60881] = 26,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(1337), 1,
      anon_sym_RPAREN,
    STATE(1431), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [60972] = 26,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1339), 1,
      anon_sym_SEMI,
    ACTIONS(1341), 1,
      anon_sym_COMMA,
    ACTIONS(1344), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61063] = 26,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(1346), 1,
      anon_sym_RBRACK,
    STATE(1434), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61154] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1348), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61241] = 26,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(1350), 1,
      anon_sym_RPAREN,
    STATE(1478), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61332] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1352), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61418] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1354), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61506] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1356), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61592] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1358), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61678] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1360), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61766] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1362), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61854] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1364), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [61942] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1366), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62030] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1368), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62118] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1370), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62206] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1372), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62294] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1374), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62382] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1376), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62470] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1378), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62558] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1380), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62646] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1382), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62734] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1344), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62820] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62908] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1386), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [62996] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1339), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63084] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1388), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63170] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1390), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63258] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1352), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63344] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1392), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63432] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1394), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63520] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1396), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63608] = 25,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63696] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1400), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63781] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1402), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63866] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1404), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [63951] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1406), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64036] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1408), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64121] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1410), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64206] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1412), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64291] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1414), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64376] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1416), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64461] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1418), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64546] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1420), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64631] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1422), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64716] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1424), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64801] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1426), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64886] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [64971] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1430), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65056] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1432), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65141] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1434), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65226] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1436), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65311] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1438), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65396] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65481] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1442), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65566] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65651] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1446), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65736] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1448), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65821] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1450), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65906] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [65991] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1454), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66076] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1456), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66161] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1458), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66246] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1460), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66331] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1462), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66416] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1464), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66501] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1466), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66586] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66671] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66756] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1472), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66841] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1474), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [66926] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1476), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67011] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1478), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67096] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1480), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67181] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1482), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67266] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1484), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67351] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1486), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67436] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1488), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67521] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1490), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67606] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1492), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67691] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1494), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67776] = 24,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(1496), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67861] = 23,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1169), 1,
      anon_sym_SLASH,
    ACTIONS(1173), 1,
      anon_sym_GT_GT,
    ACTIONS(1181), 1,
      anon_sym_AMP,
    ACTIONS(1183), 1,
      anon_sym_CARET,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_as,
    ACTIONS(1195), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1189), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1157), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_is,
  [67943] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(933), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(931), 14,
      anon_sym_function,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [67978] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(965), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(963), 14,
      anon_sym_function,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_delete,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_SLASH,
      anon_sym_new,
      sym_true,
      sym_false,
      sym_undefined,
      sym_null,
      sym_number,
      sym_identifier,
  [68013] = 17,
    ACTIONS(21), 1,
      anon_sym_dynamic,
    ACTIONS(23), 1,
      anon_sym_final,
    ACTIONS(33), 1,
      anon_sym_var,
    ACTIONS(1498), 1,
      anon_sym_namespace,
    ACTIONS(1500), 1,
      anon_sym_class,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1504), 1,
      anon_sym_interface,
    ACTIONS(1506), 1,
      anon_sym_function,
    ACTIONS(1508), 1,
      anon_sym_const,
    STATE(1593), 1,
      sym_interface_attribut,
    STATE(1662), 1,
      sym__variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(25), 2,
      anon_sym_internal,
      anon_sym_public,
    STATE(1177), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
    STATE(1186), 2,
      sym_property_attribut,
      aux_sym_namespace_declaration_repeat2,
    STATE(1223), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(37), 5,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68074] = 17,
    ACTIONS(21), 1,
      anon_sym_dynamic,
    ACTIONS(23), 1,
      anon_sym_final,
    ACTIONS(33), 1,
      anon_sym_var,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1510), 1,
      anon_sym_namespace,
    ACTIONS(1512), 1,
      anon_sym_class,
    ACTIONS(1514), 1,
      anon_sym_interface,
    ACTIONS(1516), 1,
      anon_sym_function,
    ACTIONS(1518), 1,
      anon_sym_const,
    STATE(1678), 1,
      sym__variable_declarator,
    STATE(1720), 1,
      sym_interface_attribut,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(25), 2,
      anon_sym_internal,
      anon_sym_public,
    STATE(1177), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
    STATE(1184), 2,
      sym_property_attribut,
      aux_sym_namespace_declaration_repeat2,
    STATE(1221), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(37), 5,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68135] = 17,
    ACTIONS(21), 1,
      anon_sym_dynamic,
    ACTIONS(23), 1,
      anon_sym_final,
    ACTIONS(33), 1,
      anon_sym_var,
    ACTIONS(1498), 1,
      anon_sym_namespace,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1504), 1,
      anon_sym_interface,
    ACTIONS(1506), 1,
      anon_sym_function,
    ACTIONS(1508), 1,
      anon_sym_const,
    ACTIONS(1520), 1,
      anon_sym_class,
    STATE(1593), 1,
      sym_interface_attribut,
    STATE(1662), 1,
      sym__variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(25), 2,
      anon_sym_internal,
      anon_sym_public,
    STATE(1177), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
    STATE(1186), 2,
      sym_property_attribut,
      aux_sym_namespace_declaration_repeat2,
    STATE(1208), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(37), 5,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68196] = 4,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1177), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
    ACTIONS(1522), 15,
      anon_sym_namespace,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68225] = 3,
    ACTIONS(1529), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1527), 15,
      anon_sym_namespace,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68250] = 3,
    ACTIONS(1533), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1531), 15,
      anon_sym_namespace,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68275] = 3,
    ACTIONS(1537), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1535), 15,
      anon_sym_namespace,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68300] = 3,
    ACTIONS(1541), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1539), 15,
      anon_sym_namespace,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68325] = 3,
    ACTIONS(1545), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1543), 15,
      anon_sym_namespace,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_interface,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68350] = 8,
    ACTIONS(33), 1,
      anon_sym_var,
    ACTIONS(1498), 1,
      anon_sym_namespace,
    ACTIONS(1506), 1,
      anon_sym_function,
    ACTIONS(1508), 1,
      anon_sym_const,
    STATE(1659), 1,
      sym__variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1189), 2,
      sym_property_attribut,
      aux_sym_namespace_declaration_repeat2,
    ACTIONS(37), 8,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68384] = 8,
    ACTIONS(33), 1,
      anon_sym_var,
    ACTIONS(1547), 1,
      anon_sym_namespace,
    ACTIONS(1549), 1,
      anon_sym_function,
    ACTIONS(1551), 1,
      anon_sym_const,
    STATE(1656), 1,
      sym__variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1189), 2,
      sym_property_attribut,
      aux_sym_namespace_declaration_repeat2,
    ACTIONS(37), 8,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68418] = 8,
    ACTIONS(33), 1,
      anon_sym_var,
    ACTIONS(1510), 1,
      anon_sym_namespace,
    ACTIONS(1516), 1,
      anon_sym_function,
    ACTIONS(1518), 1,
      anon_sym_const,
    STATE(1676), 1,
      sym__variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1189), 2,
      sym_property_attribut,
      aux_sym_namespace_declaration_repeat2,
    ACTIONS(37), 8,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68452] = 8,
    ACTIONS(33), 1,
      anon_sym_var,
    ACTIONS(1553), 1,
      anon_sym_namespace,
    ACTIONS(1555), 1,
      anon_sym_function,
    ACTIONS(1557), 1,
      anon_sym_const,
    STATE(1617), 1,
      sym__variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1189), 2,
      sym_property_attribut,
      aux_sym_namespace_declaration_repeat2,
    ACTIONS(37), 8,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68486] = 5,
    ACTIONS(1564), 1,
      anon_sym_interface,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1559), 2,
      anon_sym_class,
      anon_sym_dynamic,
    ACTIONS(1561), 3,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
    ACTIONS(491), 9,
      anon_sym_namespace,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68514] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1559), 2,
      anon_sym_class,
      anon_sym_dynamic,
    ACTIONS(1561), 3,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
    ACTIONS(491), 9,
      anon_sym_namespace,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68539] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1189), 2,
      sym_property_attribut,
      aux_sym_namespace_declaration_repeat2,
    ACTIONS(1569), 4,
      anon_sym_namespace,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
    ACTIONS(1566), 8,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68564] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(491), 12,
      anon_sym_namespace,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
      anon_sym_function,
      anon_sym_var,
      anon_sym_const,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_static,
      anon_sym_override,
      sym_identifier,
  [68583] = 6,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    STATE(639), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1578), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [68606] = 6,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(519), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1532), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [68629] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1579), 1,
      anon_sym_RBRACE,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68651] = 4,
    ACTIONS(1583), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1225), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(1585), 4,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
  [68669] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1587), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68691] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1589), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1204), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68713] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1591), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1205), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68735] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1593), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68757] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1595), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68779] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1597), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1201), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68801] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1599), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68823] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1601), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68845] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68867] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1605), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68889] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1607), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68911] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1609), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1235), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68933] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1611), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1227), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [68955] = 4,
    ACTIONS(1613), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1225), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(1585), 4,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
  [68973] = 4,
    ACTIONS(1615), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1225), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(1585), 4,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
  [68991] = 7,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1621), 1,
      aux_sym_xml_token1,
    ACTIONS(1623), 1,
      anon_sym_LT_SLASH,
    STATE(1049), 1,
      sym_array,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1346), 2,
      sym_xml,
      aux_sym_xml_repeat2,
  [69015] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1193), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69037] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1629), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1230), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69059] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1631), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69081] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1633), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69103] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1635), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1202), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69125] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1637), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69147] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1639), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1232), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69169] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1641), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1213), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69191] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1643), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69213] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1645), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1198), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69235] = 4,
    ACTIONS(1647), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1225), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(1585), 4,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
  [69253] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1649), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69275] = 4,
    ACTIONS(1651), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1225), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(1585), 4,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
  [69293] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1653), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1219), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69315] = 4,
    ACTIONS(1655), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1225), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(1657), 4,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
  [69333] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1199), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69355] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1662), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69377] = 7,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    STATE(1480), 1,
      sym_pair,
    STATE(1653), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1664), 2,
      sym_number,
      sym_identifier,
  [69401] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1668), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1216), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69423] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1670), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69445] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1672), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1195), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69467] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1674), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69489] = 4,
    ACTIONS(1676), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1225), 2,
      sym_class_attribut,
      aux_sym_class_declaration_repeat1,
    ACTIONS(1585), 4,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
  [69507] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1678), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69529] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1680), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69551] = 6,
    ACTIONS(1682), 1,
      anon_sym_LBRACK,
    ACTIONS(1685), 1,
      anon_sym_RBRACE,
    ACTIONS(1687), 1,
      anon_sym_function,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1236), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69573] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1690), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1203), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69595] = 4,
    ACTIONS(503), 1,
      anon_sym_DOT_LT,
    ACTIONS(1692), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(551), 5,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [69613] = 6,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_function,
    ACTIONS(1694), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1234), 2,
      sym_method_declaration,
      aux_sym_interface_declaration_repeat1,
    STATE(1337), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [69635] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(34), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69652] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(26), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69669] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(35), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69686] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1287), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69703] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(72), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69720] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(75), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69737] = 5,
    ACTIONS(1698), 1,
      anon_sym_RBRACE,
    ACTIONS(1700), 1,
      anon_sym_case,
    ACTIONS(1703), 1,
      anon_sym_default,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1246), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [69756] = 7,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(1706), 1,
      anon_sym_EQ,
    ACTIONS(1708), 1,
      anon_sym_RPAREN,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(1375), 1,
      sym_type_hint,
    STATE(1473), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [69779] = 5,
    ACTIONS(1712), 1,
      anon_sym_RBRACE,
    ACTIONS(1714), 1,
      anon_sym_case,
    ACTIONS(1716), 1,
      anon_sym_default,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1246), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [69798] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(57), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69815] = 4,
    ACTIONS(1718), 1,
      sym_identifier,
    ACTIONS(1720), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1048), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69832] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(79), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69849] = 6,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    STATE(1570), 1,
      sym_pair,
    STATE(1653), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1664), 2,
      sym_number,
      sym_identifier,
  [69870] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(61), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69887] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1461), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69904] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(67), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69921] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1698), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69938] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(71), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69955] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(37), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69972] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(28), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [69989] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(634), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70006] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(22), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70023] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(74), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70040] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(31), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70057] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(194), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70074] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1441), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70091] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(25), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70108] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(23), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70125] = 5,
    ACTIONS(1714), 1,
      anon_sym_case,
    ACTIONS(1716), 1,
      anon_sym_default,
    ACTIONS(1722), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1298), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [70144] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1450), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70161] = 4,
    ACTIONS(1724), 1,
      sym_identifier,
    ACTIONS(1726), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1340), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70178] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(76), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70195] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(63), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70212] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(33), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70229] = 5,
    ACTIONS(1714), 1,
      anon_sym_case,
    ACTIONS(1716), 1,
      anon_sym_default,
    ACTIONS(1728), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1248), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [70248] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(41), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70265] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(38), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70282] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(77), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70299] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(39), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70316] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(20), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70333] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(78), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70350] = 4,
    ACTIONS(1730), 1,
      anon_sym_DOT,
    ACTIONS(1732), 1,
      anon_sym_DOT_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(551), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_in,
  [70367] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(18), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70384] = 4,
    ACTIONS(1718), 1,
      sym_identifier,
    ACTIONS(1720), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1035), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70401] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1489), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70418] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(49), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70435] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(36), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70452] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1734), 6,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
  [70465] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(59), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70482] = 4,
    ACTIONS(1724), 1,
      sym_identifier,
    ACTIONS(1726), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1287), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70499] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(50), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70516] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(194), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70533] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1451), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70550] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(60), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70567] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1737), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70584] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(80), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70601] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(54), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70618] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1457), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70635] = 5,
    ACTIONS(1714), 1,
      anon_sym_case,
    ACTIONS(1716), 1,
      anon_sym_default,
    ACTIONS(1736), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1246), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [70654] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1436), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70671] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(73), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70688] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(634), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70705] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1428), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70722] = 4,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(55), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70739] = 4,
    ACTIONS(1571), 1,
      sym_identifier,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1415), 4,
      sym__data_type,
      sym_any_type,
      sym_generic_data_type,
      sym_scoped_data_type,
  [70756] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1740), 1,
      anon_sym_RPAREN,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1414), 1,
      sym_rest,
    STATE(1741), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [70776] = 5,
    ACTIONS(1744), 1,
      sym_identifier,
    ACTIONS(1746), 1,
      anon_sym_LPAREN,
    STATE(1495), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1748), 2,
      anon_sym_get,
      anon_sym_set,
  [70794] = 5,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1750), 1,
      aux_sym_xml_token1,
    ACTIONS(1752), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1365), 2,
      sym_xml,
      aux_sym_xml_repeat2,
  [70812] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1754), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1642), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [70832] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1602), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [70852] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1758), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1660), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [70872] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1760), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1706), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [70892] = 5,
    ACTIONS(1762), 1,
      sym_identifier,
    ACTIONS(1764), 1,
      anon_sym_GT,
    ACTIONS(1766), 1,
      anon_sym_SLASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 2,
      sym_xml_attribute,
      aux_sym_xml_repeat1,
  [70910] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1768), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1638), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [70930] = 5,
    ACTIONS(1762), 1,
      sym_identifier,
    ACTIONS(1770), 1,
      anon_sym_GT,
    ACTIONS(1772), 1,
      anon_sym_SLASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1323), 2,
      sym_xml_attribute,
      aux_sym_xml_repeat1,
  [70948] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1774), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1667), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [70968] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1776), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1672), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [70988] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1778), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1639), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71008] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1780), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1657), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71028] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1782), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1655), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71048] = 5,
    ACTIONS(1746), 1,
      anon_sym_LPAREN,
    ACTIONS(1784), 1,
      sym_identifier,
    STATE(1485), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1786), 2,
      anon_sym_get,
      anon_sym_set,
  [71066] = 5,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1788), 1,
      aux_sym_xml_token1,
    ACTIONS(1790), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1394), 2,
      sym_xml,
      aux_sym_xml_repeat2,
  [71084] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1792), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1619), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71104] = 5,
    ACTIONS(1762), 1,
      sym_identifier,
    ACTIONS(1794), 1,
      anon_sym_GT,
    ACTIONS(1796), 1,
      anon_sym_SLASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1326), 2,
      sym_xml_attribute,
      aux_sym_xml_repeat1,
  [71122] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1798), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1600), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71142] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1800), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1601), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71162] = 4,
    ACTIONS(1802), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1805), 2,
      anon_sym_GT,
      anon_sym_SLASH_GT,
    STATE(1326), 2,
      sym_xml_attribute,
      aux_sym_xml_repeat1,
  [71178] = 5,
    ACTIONS(1762), 1,
      sym_identifier,
    ACTIONS(1807), 1,
      anon_sym_GT,
    ACTIONS(1809), 1,
      anon_sym_SLASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1326), 2,
      sym_xml_attribute,
      aux_sym_xml_repeat1,
  [71196] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1811), 5,
      anon_sym_class,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_internal,
      anon_sym_public,
  [71208] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1813), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1650), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71228] = 5,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1815), 1,
      aux_sym_xml_token1,
    ACTIONS(1817), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1376), 2,
      sym_xml,
      aux_sym_xml_repeat2,
  [71246] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    STATE(1430), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1821), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71264] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1823), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1692), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71284] = 5,
    ACTIONS(1746), 1,
      anon_sym_LPAREN,
    ACTIONS(1825), 1,
      sym_identifier,
    STATE(1495), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1748), 2,
      anon_sym_get,
      anon_sym_set,
  [71302] = 5,
    ACTIONS(1746), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      sym_identifier,
    STATE(1485), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1786), 2,
      anon_sym_get,
      anon_sym_set,
  [71320] = 6,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1829), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_rest,
    STATE(1648), 1,
      sym_function_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71340] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1831), 1,
      anon_sym_EQ,
    STATE(1417), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1061), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [71358] = 4,
    ACTIONS(1502), 1,
      anon_sym_LBRACK,
    ACTIONS(1833), 1,
      anon_sym_function,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1177), 2,
      sym_annotation,
      aux_sym_namespace_declaration_repeat1,
  [71373] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1835), 1,
      anon_sym_EQ,
    ACTIONS(1837), 1,
      anon_sym_SEMI,
    STATE(1586), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71390] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(845), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_in,
  [71401] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(540), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_in,
  [71412] = 3,
    ACTIONS(1841), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1839), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [71425] = 4,
    ACTIONS(1843), 1,
      anon_sym_EQ,
    ACTIONS(1847), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1845), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [71440] = 5,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(544), 1,
      sym_statement_block,
    STATE(1524), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71457] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1849), 1,
      anon_sym_EQ,
    ACTIONS(1851), 1,
      anon_sym_SEMI,
    STATE(1553), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71474] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(793), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_in,
  [71485] = 4,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1853), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1393), 2,
      sym_xml,
      aux_sym_xml_repeat2,
  [71500] = 4,
    ACTIONS(1855), 1,
      anon_sym_DQUOTE,
    STATE(1402), 1,
      aux_sym_string_repeat1,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1857), 2,
      sym__unescaped_double_string_fragment,
      sym__escape_sequence,
  [71515] = 5,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(224), 1,
      sym_statement_block,
    STATE(1520), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71532] = 5,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(258), 1,
      sym_statement_block,
    STATE(1517), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71549] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1859), 1,
      anon_sym_EQ,
    ACTIONS(1861), 1,
      anon_sym_SEMI,
    STATE(1587), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71566] = 4,
    ACTIONS(1863), 1,
      sym_identifier,
    STATE(1500), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1865), 2,
      anon_sym_get,
      anon_sym_set,
  [71581] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1083), 1,
      sym_statement_block,
    STATE(1536), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71598] = 4,
    ACTIONS(1869), 1,
      anon_sym_DQUOTE,
    STATE(1347), 1,
      aux_sym_string_repeat1,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1871), 2,
      sym__unescaped_double_string_fragment,
      sym__escape_sequence,
  [71613] = 4,
    ACTIONS(1869), 1,
      anon_sym_SQUOTE,
    STATE(1366), 1,
      aux_sym_string_repeat2,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1873), 2,
      sym__unescaped_single_string_fragment,
      sym__escape_sequence,
  [71628] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(559), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_in,
  [71639] = 4,
    ACTIONS(1875), 1,
      sym_identifier,
    STATE(1490), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1877), 2,
      anon_sym_get,
      anon_sym_set,
  [71654] = 4,
    ACTIONS(1879), 1,
      anon_sym_DQUOTE,
    STATE(1380), 1,
      aux_sym_string_repeat1,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1881), 2,
      sym__unescaped_double_string_fragment,
      sym__escape_sequence,
  [71669] = 4,
    ACTIONS(1879), 1,
      anon_sym_SQUOTE,
    STATE(1381), 1,
      aux_sym_string_repeat2,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1883), 2,
      sym__unescaped_single_string_fragment,
      sym__escape_sequence,
  [71684] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1081), 1,
      sym_statement_block,
    STATE(1538), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71701] = 5,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(782), 1,
      sym_statement_block,
    STATE(1540), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71718] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1885), 1,
      anon_sym_LBRACE,
    STATE(180), 1,
      sym_statement_block,
    STATE(1543), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71735] = 5,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(787), 1,
      sym_statement_block,
    STATE(1542), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71752] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1887), 1,
      anon_sym_LBRACE,
    STATE(174), 1,
      sym_statement_block,
    STATE(1571), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71769] = 3,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1839), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [71782] = 4,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1891), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1393), 2,
      sym_xml,
      aux_sym_xml_repeat2,
  [71797] = 4,
    ACTIONS(1855), 1,
      anon_sym_SQUOTE,
    STATE(1400), 1,
      aux_sym_string_repeat2,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1893), 2,
      sym__unescaped_single_string_fragment,
      sym__escape_sequence,
  [71812] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1885), 1,
      anon_sym_LBRACE,
    STATE(183), 1,
      sym_statement_block,
    STATE(1545), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71829] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1076), 1,
      sym_statement_block,
    STATE(1584), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71846] = 5,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(620), 1,
      sym_statement_block,
    STATE(1568), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71863] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1895), 1,
      anon_sym_EQ,
    ACTIONS(1897), 1,
      anon_sym_SEMI,
    STATE(1544), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71880] = 4,
    ACTIONS(1843), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1845), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [71895] = 4,
    ACTIONS(1903), 1,
      anon_sym_LPAREN,
    STATE(906), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1901), 2,
      anon_sym_STAR,
      sym_identifier,
  [71910] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1044), 1,
      sym_statement_block,
    STATE(1566), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71927] = 3,
    ACTIONS(1905), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1839), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [71940] = 5,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(1907), 1,
      anon_sym_EQ,
    ACTIONS(1909), 1,
      anon_sym_RPAREN,
    STATE(1466), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71957] = 4,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1911), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1393), 2,
      sym_xml,
      aux_sym_xml_repeat2,
  [71972] = 5,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(340), 1,
      sym_statement_block,
    STATE(1563), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [71989] = 3,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1839), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [72002] = 5,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(886), 1,
      sym_statement_block,
    STATE(1502), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72019] = 4,
    ACTIONS(1915), 1,
      anon_sym_DQUOTE,
    STATE(1402), 1,
      aux_sym_string_repeat1,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1857), 2,
      sym__unescaped_double_string_fragment,
      sym__escape_sequence,
  [72034] = 4,
    ACTIONS(1915), 1,
      anon_sym_SQUOTE,
    STATE(1400), 1,
      aux_sym_string_repeat2,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1893), 2,
      sym__unescaped_single_string_fragment,
      sym__escape_sequence,
  [72049] = 4,
    ACTIONS(1917), 1,
      sym_identifier,
    STATE(1432), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1919), 2,
      anon_sym_get,
      anon_sym_set,
  [72064] = 4,
    ACTIONS(1921), 1,
      sym_identifier,
    STATE(1468), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1923), 2,
      anon_sym_get,
      anon_sym_set,
  [72079] = 3,
    ACTIONS(1925), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1839), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [72092] = 4,
    ACTIONS(1927), 1,
      anon_sym_COMMA,
    STATE(1385), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1348), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [72107] = 5,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(780), 1,
      sym_statement_block,
    STATE(1574), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72124] = 4,
    ACTIONS(1930), 1,
      sym_identifier,
    STATE(1444), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1932), 2,
      anon_sym_get,
      anon_sym_set,
  [72139] = 5,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(783), 1,
      sym_statement_block,
    STATE(1573), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72156] = 4,
    ACTIONS(1843), 1,
      anon_sym_EQ,
    ACTIONS(1934), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1845), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [72171] = 4,
    ACTIONS(1936), 1,
      sym_identifier,
    STATE(1418), 1,
      sym_accessor,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1938), 2,
      anon_sym_get,
      anon_sym_set,
  [72186] = 3,
    ACTIONS(1940), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1839), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [72199] = 5,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(400), 1,
      sym_statement_block,
    STATE(1549), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72216] = 4,
    ACTIONS(1942), 1,
      anon_sym_LT,
    ACTIONS(1945), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1393), 2,
      sym_xml,
      aux_sym_xml_repeat2,
  [72231] = 4,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1947), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1393), 2,
      sym_xml,
      aux_sym_xml_repeat2,
  [72246] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1949), 1,
      anon_sym_EQ,
    ACTIONS(1951), 1,
      anon_sym_SEMI,
    STATE(1523), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72263] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1953), 1,
      anon_sym_EQ,
    ACTIONS(1955), 1,
      anon_sym_SEMI,
    STATE(1551), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72280] = 3,
    ACTIONS(1957), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1839), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [72293] = 5,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(1961), 1,
      anon_sym_LPAREN,
    ACTIONS(1963), 1,
      anon_sym_RBRACK,
    STATE(1435), 1,
      aux_sym_annotation_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72310] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1075), 1,
      sym_statement_block,
    STATE(1547), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72327] = 4,
    ACTIONS(1965), 1,
      anon_sym_SQUOTE,
    STATE(1400), 1,
      aux_sym_string_repeat2,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1967), 2,
      sym__unescaped_single_string_fragment,
      sym__escape_sequence,
  [72342] = 3,
    ACTIONS(1970), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1839), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [72355] = 4,
    ACTIONS(1972), 1,
      anon_sym_DQUOTE,
    STATE(1402), 1,
      aux_sym_string_repeat1,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1974), 2,
      sym__unescaped_double_string_fragment,
      sym__escape_sequence,
  [72370] = 5,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_statement_block,
    STATE(1554), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72387] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1885), 1,
      anon_sym_LBRACE,
    STATE(169), 1,
      sym_statement_block,
    STATE(1569), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72404] = 5,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(566), 1,
      sym_statement_block,
    STATE(1508), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72421] = 5,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(427), 1,
      sym_statement_block,
    STATE(1592), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72438] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1054), 1,
      sym_statement_block,
    STATE(1561), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72455] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1885), 1,
      anon_sym_LBRACE,
    STATE(171), 1,
      sym_statement_block,
    STATE(1590), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72472] = 5,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1887), 1,
      anon_sym_LBRACE,
    STATE(178), 1,
      sym_statement_block,
    STATE(1501), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72489] = 5,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(430), 1,
      sym_statement_block,
    STATE(1589), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72506] = 5,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    STATE(622), 1,
      sym_statement_block,
    STATE(1527), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72523] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(1979), 1,
      anon_sym_LBRACE,
    STATE(1483), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72537] = 3,
    ACTIONS(1983), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1981), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [72549] = 4,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(1708), 1,
      anon_sym_RPAREN,
    STATE(1475), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72563] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(1985), 1,
      anon_sym_LBRACE,
    STATE(1442), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72577] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(1987), 1,
      anon_sym_LBRACE,
    STATE(1483), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72591] = 3,
    ACTIONS(1843), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1845), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [72603] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1989), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [72613] = 4,
    ACTIONS(1991), 1,
      anon_sym_SEMI,
    ACTIONS(1993), 1,
      anon_sym_COMMA,
    STATE(1491), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72627] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1297), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_identifier,
  [72637] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1305), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_identifier,
  [72647] = 4,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(1995), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72661] = 4,
    ACTIONS(273), 1,
      anon_sym_COMMA,
    ACTIONS(1997), 1,
      anon_sym_GT,
    STATE(548), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72675] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1999), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [72685] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2001), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [72695] = 4,
    ACTIONS(2003), 1,
      anon_sym_COLON,
    ACTIONS(2005), 1,
      anon_sym_in,
    STATE(1731), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72709] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2007), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [72719] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(2009), 1,
      anon_sym_LBRACE,
    STATE(1416), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72733] = 4,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(2011), 1,
      anon_sym_RPAREN,
    STATE(1635), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72747] = 3,
    ACTIONS(2013), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2015), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72759] = 4,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(2017), 1,
      anon_sym_RPAREN,
    STATE(1464), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72773] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2019), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [72783] = 4,
    ACTIONS(2021), 1,
      anon_sym_COMMA,
    ACTIONS(2023), 1,
      anon_sym_RBRACE,
    STATE(1465), 1,
      aux_sym_object_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72797] = 4,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(2025), 1,
      anon_sym_RBRACK,
    STATE(1385), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72811] = 4,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(2027), 1,
      anon_sym_RBRACK,
    STATE(1459), 1,
      aux_sym_annotation_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72825] = 4,
    ACTIONS(273), 1,
      anon_sym_COMMA,
    ACTIONS(2029), 1,
      anon_sym_GT,
    STATE(1497), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72839] = 4,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(2031), 1,
      anon_sym_RBRACK,
    STATE(1474), 1,
      aux_sym_annotation_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72853] = 4,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(2031), 1,
      anon_sym_RBRACK,
    STATE(1459), 1,
      aux_sym_annotation_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72867] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2033), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [72877] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(2035), 1,
      anon_sym_LBRACE,
    STATE(1483), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72891] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(2037), 1,
      anon_sym_LBRACE,
    STATE(1412), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72905] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(2039), 1,
      anon_sym_LBRACE,
    STATE(1483), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72919] = 4,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(2041), 1,
      anon_sym_SEMI,
    STATE(1643), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72933] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1936), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [72943] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2043), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [72953] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2045), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [72963] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2047), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_identifier,
  [72973] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2049), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [72983] = 4,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(2051), 1,
      anon_sym_RPAREN,
    STATE(1629), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [72997] = 4,
    ACTIONS(273), 1,
      anon_sym_COMMA,
    ACTIONS(2053), 1,
      anon_sym_GT,
    STATE(1423), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73011] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(2055), 1,
      anon_sym_LBRACE,
    STATE(1440), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73025] = 4,
    ACTIONS(563), 1,
      anon_sym_while,
    ACTIONS(2057), 1,
      anon_sym_else,
    STATE(608), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73039] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2059), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [73049] = 4,
    ACTIONS(2061), 1,
      anon_sym_SEMI,
    ACTIONS(2063), 1,
      anon_sym_COMMA,
    STATE(1454), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73063] = 4,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(2066), 1,
      anon_sym_SEMI,
    STATE(1652), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73077] = 4,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(2068), 1,
      anon_sym_SEMI,
    STATE(1654), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73091] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(2070), 1,
      anon_sym_LBRACE,
    STATE(1484), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73105] = 4,
    ACTIONS(1993), 1,
      anon_sym_COMMA,
    ACTIONS(2072), 1,
      anon_sym_SEMI,
    STATE(1471), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73119] = 4,
    ACTIONS(1981), 1,
      anon_sym_RBRACK,
    ACTIONS(2074), 1,
      anon_sym_COMMA,
    STATE(1459), 1,
      aux_sym_annotation_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73133] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2077), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [73143] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(2079), 1,
      anon_sym_LBRACE,
    STATE(1477), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73157] = 4,
    ACTIONS(2003), 1,
      anon_sym_COLON,
    ACTIONS(2081), 1,
      anon_sym_in,
    STATE(1686), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73171] = 4,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(2083), 1,
      anon_sym_RPAREN,
    STATE(1385), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73185] = 4,
    ACTIONS(2085), 1,
      anon_sym_COMMA,
    ACTIONS(2088), 1,
      anon_sym_RPAREN,
    STATE(1464), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73199] = 4,
    ACTIONS(2090), 1,
      anon_sym_COMMA,
    ACTIONS(2093), 1,
      anon_sym_RBRACE,
    STATE(1465), 1,
      aux_sym_object_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73213] = 4,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(2095), 1,
      anon_sym_RPAREN,
    STATE(1464), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73227] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2097), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [73237] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1917), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [73247] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2099), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [73257] = 4,
    ACTIONS(1742), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2101), 1,
      sym_identifier,
    STATE(1562), 1,
      sym_rest,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73271] = 4,
    ACTIONS(1993), 1,
      anon_sym_COMMA,
    ACTIONS(2103), 1,
      anon_sym_SEMI,
    STATE(1454), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73285] = 4,
    ACTIONS(2003), 1,
      anon_sym_COLON,
    ACTIONS(2105), 1,
      anon_sym_in,
    STATE(1701), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73299] = 4,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(2107), 1,
      anon_sym_RPAREN,
    STATE(1464), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73313] = 4,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(2109), 1,
      anon_sym_RBRACK,
    STATE(1459), 1,
      aux_sym_annotation_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73327] = 4,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(2107), 1,
      anon_sym_RPAREN,
    STATE(1464), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73341] = 4,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(2111), 1,
      anon_sym_SEMI,
    STATE(1732), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73355] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(2113), 1,
      anon_sym_LBRACE,
    STATE(1483), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73369] = 4,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(2115), 1,
      anon_sym_RPAREN,
    STATE(1385), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73383] = 4,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(2117), 1,
      anon_sym_RBRACK,
    STATE(1438), 1,
      aux_sym_annotation_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73397] = 4,
    ACTIONS(2021), 1,
      anon_sym_COMMA,
    ACTIONS(2119), 1,
      anon_sym_RBRACE,
    STATE(1433), 1,
      aux_sym_object_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73411] = 4,
    ACTIONS(1710), 1,
      anon_sym_COLON,
    ACTIONS(2121), 1,
      anon_sym_SEMI,
    STATE(1674), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73425] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2123), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_function,
  [73435] = 4,
    ACTIONS(1013), 1,
      anon_sym_LBRACE,
    ACTIONS(2125), 1,
      anon_sym_COMMA,
    STATE(1483), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73449] = 4,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(2128), 1,
      anon_sym_LBRACE,
    STATE(1483), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73463] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1875), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [73473] = 4,
    ACTIONS(1993), 1,
      anon_sym_COMMA,
    ACTIONS(2130), 1,
      anon_sym_SEMI,
    STATE(1494), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73487] = 4,
    ACTIONS(273), 1,
      anon_sym_COMMA,
    ACTIONS(2132), 1,
      anon_sym_GT,
    STATE(548), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73501] = 4,
    ACTIONS(2003), 1,
      anon_sym_COLON,
    ACTIONS(2134), 1,
      anon_sym_in,
    STATE(1735), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73515] = 4,
    ACTIONS(273), 1,
      anon_sym_COMMA,
    ACTIONS(2136), 1,
      anon_sym_GT,
    STATE(1487), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73529] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1863), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [73539] = 4,
    ACTIONS(1993), 1,
      anon_sym_COMMA,
    ACTIONS(2138), 1,
      anon_sym_SEMI,
    STATE(1454), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73553] = 4,
    ACTIONS(2003), 1,
      anon_sym_COLON,
    ACTIONS(2140), 1,
      anon_sym_in,
    STATE(1603), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73567] = 4,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(2142), 1,
      anon_sym_RPAREN,
    STATE(1464), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73581] = 4,
    ACTIONS(1993), 1,
      anon_sym_COMMA,
    ACTIONS(2144), 1,
      anon_sym_SEMI,
    STATE(1454), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73595] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1930), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [73605] = 4,
    ACTIONS(2146), 1,
      anon_sym_DQUOTE,
    ACTIONS(2148), 1,
      anon_sym_SQUOTE,
    STATE(1447), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73619] = 4,
    ACTIONS(273), 1,
      anon_sym_COMMA,
    ACTIONS(2150), 1,
      anon_sym_GT,
    STATE(548), 1,
      aux_sym_class_declaration_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73633] = 4,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(2152), 1,
      anon_sym_RPAREN,
    STATE(1385), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73647] = 4,
    ACTIONS(2003), 1,
      anon_sym_COLON,
    ACTIONS(2154), 1,
      anon_sym_in,
    STATE(1739), 1,
      sym_type_hint,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73661] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2156), 3,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [73671] = 3,
    ACTIONS(1887), 1,
      anon_sym_LBRACE,
    STATE(173), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73682] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(891), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73693] = 3,
    ACTIONS(2158), 1,
      anon_sym_LBRACE,
    STATE(788), 1,
      sym_switch_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73704] = 3,
    ACTIONS(2160), 1,
      sym_identifier,
    ACTIONS(2162), 1,
      anon_sym_var,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73715] = 3,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(121), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73726] = 3,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(123), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73737] = 3,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(124), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73748] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(649), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73759] = 3,
    ACTIONS(2166), 1,
      anon_sym_LBRACE,
    STATE(198), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73770] = 3,
    ACTIONS(2168), 1,
      sym_identifier,
    ACTIONS(2170), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73781] = 3,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2174), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73792] = 3,
    ACTIONS(2176), 1,
      anon_sym_LBRACE,
    STATE(191), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73803] = 3,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(93), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73814] = 3,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(91), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73825] = 3,
    ACTIONS(2166), 1,
      anon_sym_LBRACE,
    STATE(187), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73836] = 3,
    ACTIONS(2178), 1,
      sym_identifier,
    ACTIONS(2180), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73847] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(539), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73858] = 3,
    ACTIONS(2182), 1,
      sym_identifier,
    ACTIONS(2184), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73869] = 3,
    ACTIONS(1249), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1251), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73880] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(543), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73891] = 3,
    ACTIONS(2176), 1,
      anon_sym_LBRACE,
    STATE(526), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73902] = 3,
    ACTIONS(2186), 1,
      sym_identifier,
    ACTIONS(2188), 1,
      anon_sym_var,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73913] = 3,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2192), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73924] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(547), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73935] = 3,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    STATE(1503), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73946] = 3,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73957] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(781), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73968] = 3,
    ACTIONS(2194), 1,
      anon_sym_extends,
    ACTIONS(2196), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73979] = 3,
    ACTIONS(2198), 1,
      anon_sym_EQ,
    ACTIONS(2200), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [73990] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1331), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [73999] = 3,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2204), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74010] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(501), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74021] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2206), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [74030] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2208), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [74039] = 3,
    ACTIONS(2210), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      sym_switch_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74050] = 3,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1082), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74061] = 3,
    ACTIONS(2212), 1,
      anon_sym_extends,
    ACTIONS(2214), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74072] = 3,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1080), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74083] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2216), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [74092] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(881), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74103] = 3,
    ACTIONS(2218), 1,
      sym_identifier,
    ACTIONS(2220), 1,
      anon_sym_var,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74114] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(885), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74125] = 3,
    ACTIONS(1885), 1,
      anon_sym_LBRACE,
    STATE(179), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74136] = 3,
    ACTIONS(2222), 1,
      anon_sym_EQ,
    ACTIONS(2224), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74147] = 3,
    ACTIONS(1885), 1,
      anon_sym_LBRACE,
    STATE(182), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74158] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(466), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74169] = 3,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1057), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74180] = 3,
    ACTIONS(2226), 1,
      anon_sym_EQ,
    ACTIONS(2228), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74191] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(330), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74202] = 3,
    ACTIONS(1746), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74213] = 3,
    ACTIONS(2232), 1,
      anon_sym_EQ,
    ACTIONS(2234), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74224] = 3,
    ACTIONS(2236), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74235] = 3,
    ACTIONS(2240), 1,
      anon_sym_EQ,
    ACTIONS(2242), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74246] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(431), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74257] = 3,
    ACTIONS(2176), 1,
      anon_sym_LBRACE,
    STATE(542), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74268] = 3,
    ACTIONS(1289), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1291), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74279] = 3,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(163), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74290] = 3,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    STATE(1535), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74301] = 3,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(90), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74312] = 3,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(138), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74323] = 3,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1051), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74334] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1821), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [74343] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(257), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74354] = 3,
    ACTIONS(2166), 1,
      anon_sym_LBRACE,
    STATE(193), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74365] = 3,
    ACTIONS(2244), 1,
      anon_sym_extends,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74376] = 3,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1063), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74387] = 3,
    ACTIONS(1145), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1147), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74398] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(778), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74409] = 3,
    ACTIONS(1885), 1,
      anon_sym_LBRACE,
    STATE(166), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74420] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2093), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [74429] = 3,
    ACTIONS(1887), 1,
      anon_sym_LBRACE,
    STATE(177), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74440] = 3,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    STATE(1730), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74451] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(565), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74462] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(564), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74473] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(552), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74484] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2248), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [74493] = 3,
    ACTIONS(1237), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1239), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74504] = 3,
    ACTIONS(1573), 1,
      anon_sym_LBRACE,
    STATE(887), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74515] = 3,
    ACTIONS(2250), 1,
      anon_sym_extends,
    ACTIONS(2252), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74526] = 3,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    STATE(1645), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74537] = 3,
    ACTIONS(2254), 1,
      anon_sym_extends,
    ACTIONS(2256), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74548] = 3,
    ACTIONS(2258), 1,
      anon_sym_var,
    STATE(1576), 1,
      sym__variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74559] = 3,
    ACTIONS(2260), 1,
      anon_sym_EQ,
    ACTIONS(2262), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74570] = 3,
    ACTIONS(1867), 1,
      anon_sym_LBRACE,
    STATE(1074), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74581] = 3,
    ACTIONS(2264), 1,
      anon_sym_EQ,
    ACTIONS(2266), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74592] = 3,
    ACTIONS(2268), 1,
      anon_sym_EQ,
    ACTIONS(2270), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74603] = 3,
    ACTIONS(2272), 1,
      anon_sym_EQ,
    ACTIONS(2274), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74614] = 3,
    ACTIONS(2276), 1,
      anon_sym_extends,
    ACTIONS(2278), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74625] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(403), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74636] = 3,
    ACTIONS(1885), 1,
      anon_sym_LBRACE,
    STATE(167), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74647] = 3,
    ACTIONS(1225), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1227), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74658] = 3,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
    STATE(401), 1,
      sym_statement_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74669] = 2,
    ACTIONS(2280), 1,
      anon_sym_interface,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74677] = 2,
    ACTIONS(2282), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74685] = 2,
    ACTIONS(1947), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74693] = 2,
    ACTIONS(2284), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74701] = 2,
    ACTIONS(2286), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74709] = 2,
    ACTIONS(2288), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74717] = 2,
    ACTIONS(2290), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74725] = 2,
    ACTIONS(2292), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74733] = 2,
    ACTIONS(2294), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74741] = 2,
    ACTIONS(2296), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74749] = 2,
    ACTIONS(2298), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74757] = 2,
    ACTIONS(2300), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74765] = 2,
    ACTIONS(2302), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74773] = 2,
    ACTIONS(1368), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74781] = 2,
    ACTIONS(1970), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74789] = 2,
    ACTIONS(2304), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74797] = 2,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74805] = 2,
    ACTIONS(2306), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74813] = 2,
    ACTIONS(2308), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74821] = 2,
    ACTIONS(2310), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74829] = 2,
    ACTIONS(1360), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74837] = 2,
    ACTIONS(1934), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74845] = 2,
    ACTIONS(2312), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74853] = 2,
    ACTIONS(2314), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74861] = 2,
    ACTIONS(2316), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74869] = 2,
    ACTIONS(2318), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74877] = 2,
    ACTIONS(2320), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74885] = 2,
    ACTIONS(2322), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74893] = 2,
    ACTIONS(2324), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74901] = 2,
    ACTIONS(2326), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74909] = 2,
    ACTIONS(2328), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74917] = 2,
    ACTIONS(2330), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74925] = 2,
    ACTIONS(2332), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74933] = 2,
    ACTIONS(2334), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74941] = 2,
    ACTIONS(2336), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74949] = 2,
    ACTIONS(2338), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74957] = 2,
    ACTIONS(2340), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74965] = 2,
    ACTIONS(2342), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74973] = 2,
    ACTIONS(2344), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74981] = 2,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74989] = 2,
    ACTIONS(2346), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [74997] = 2,
    ACTIONS(1390), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75005] = 2,
    ACTIONS(2348), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75013] = 2,
    ACTIONS(2350), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75021] = 2,
    ACTIONS(2352), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75029] = 2,
    ACTIONS(2354), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75037] = 2,
    ACTIONS(2356), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75045] = 2,
    ACTIONS(2358), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75053] = 2,
    ACTIONS(1957), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75061] = 2,
    ACTIONS(2360), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75069] = 2,
    ACTIONS(2362), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75077] = 2,
    ACTIONS(2364), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75085] = 2,
    ACTIONS(2366), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75093] = 2,
    ACTIONS(1925), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75101] = 2,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75109] = 2,
    ACTIONS(2370), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75117] = 2,
    ACTIONS(2372), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75125] = 2,
    ACTIONS(2374), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75133] = 2,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75141] = 2,
    ACTIONS(2378), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75149] = 2,
    ACTIONS(2380), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75157] = 2,
    ACTIONS(2382), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75165] = 2,
    ACTIONS(2384), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75173] = 2,
    ACTIONS(2386), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75181] = 2,
    ACTIONS(2388), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75189] = 2,
    ACTIONS(2390), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75197] = 2,
    ACTIONS(2392), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75205] = 2,
    ACTIONS(2394), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75213] = 2,
    ACTIONS(2396), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75221] = 2,
    ACTIONS(2398), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75229] = 2,
    ACTIONS(2400), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75237] = 2,
    ACTIONS(2402), 1,
      anon_sym_interface,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75245] = 2,
    ACTIONS(2404), 1,
      anon_sym_while,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75253] = 2,
    ACTIONS(2406), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75261] = 2,
    ACTIONS(2408), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75269] = 2,
    ACTIONS(2410), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75277] = 2,
    ACTIONS(2412), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75285] = 2,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75293] = 2,
    ACTIONS(2416), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75301] = 2,
    ACTIONS(2418), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75309] = 2,
    ACTIONS(2420), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75317] = 2,
    ACTIONS(2422), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75325] = 2,
    ACTIONS(2424), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75333] = 2,
    ACTIONS(2426), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75341] = 2,
    ACTIONS(2428), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75349] = 2,
    ACTIONS(2430), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75357] = 2,
    ACTIONS(2432), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75365] = 2,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75373] = 2,
    ACTIONS(2434), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75381] = 2,
    ACTIONS(2436), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75389] = 2,
    ACTIONS(2438), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75397] = 2,
    ACTIONS(2440), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75405] = 2,
    ACTIONS(2442), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75413] = 2,
    ACTIONS(2444), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75421] = 2,
    ACTIONS(2446), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75429] = 2,
    ACTIONS(1911), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75437] = 2,
    ACTIONS(2448), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75445] = 2,
    ACTIONS(2450), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75453] = 2,
    ACTIONS(2452), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75461] = 2,
    ACTIONS(2454), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75469] = 2,
    ACTIONS(1905), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75477] = 2,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75485] = 2,
    ACTIONS(2458), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75493] = 2,
    ACTIONS(2460), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75501] = 2,
    ACTIONS(1899), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75509] = 2,
    ACTIONS(2462), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75517] = 2,
    ACTIONS(2464), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75525] = 2,
    ACTIONS(2466), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75533] = 2,
    ACTIONS(2468), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75541] = 2,
    ACTIONS(2470), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75549] = 2,
    ACTIONS(1891), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75557] = 2,
    ACTIONS(1394), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75565] = 2,
    ACTIONS(2472), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75573] = 2,
    ACTIONS(2474), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75581] = 2,
    ACTIONS(2476), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75589] = 2,
    ACTIONS(2478), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75597] = 2,
    ACTIONS(1396), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75605] = 2,
    ACTIONS(2480), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75613] = 2,
    ACTIONS(2482), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75621] = 2,
    ACTIONS(1339), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75629] = 2,
    ACTIONS(2484), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75637] = 2,
    ACTIONS(1392), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75645] = 2,
    ACTIONS(2486), 1,
      anon_sym_interface,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75653] = 2,
    ACTIONS(2488), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75661] = 2,
    ACTIONS(2490), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75669] = 2,
    ACTIONS(2492), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75677] = 2,
    ACTIONS(2494), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75685] = 2,
    ACTIONS(2496), 1,
      anon_sym_interface,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75693] = 2,
    ACTIONS(2498), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75701] = 2,
    ACTIONS(2500), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75709] = 2,
    ACTIONS(2502), 1,
      anon_sym_SLASH2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75717] = 2,
    ACTIONS(2504), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75725] = 2,
    ACTIONS(2506), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75733] = 2,
    ACTIONS(1841), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75741] = 2,
    ACTIONS(2508), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75749] = 2,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75757] = 2,
    ACTIONS(2512), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75765] = 2,
    ACTIONS(2514), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75773] = 2,
    ACTIONS(2516), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75781] = 2,
    ACTIONS(2518), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75789] = 2,
    ACTIONS(2520), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75797] = 2,
    ACTIONS(2522), 1,
      sym_regex_pattern,
    ACTIONS(1625), 2,
      sym_line_comment,
      sym_block_comment,
  [75805] = 2,
    ACTIONS(2524), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75813] = 2,
    ACTIONS(2526), 1,
      anon_sym_while,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75821] = 2,
    ACTIONS(2528), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75829] = 2,
    ACTIONS(1847), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75837] = 2,
    ACTIONS(2530), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75845] = 2,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75853] = 2,
    ACTIONS(2534), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75861] = 2,
    ACTIONS(2536), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75869] = 2,
    ACTIONS(2538), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75877] = 2,
    ACTIONS(1853), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75885] = 2,
    ACTIONS(2540), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75893] = 2,
    ACTIONS(2542), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [75901] = 2,
    ACTIONS(2544), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(184)] = 0,
  [SMALL_STATE(185)] = 81,
  [SMALL_STATE(186)] = 161,
  [SMALL_STATE(187)] = 241,
  [SMALL_STATE(188)] = 319,
  [SMALL_STATE(189)] = 397,
  [SMALL_STATE(190)] = 477,
  [SMALL_STATE(191)] = 550,
  [SMALL_STATE(192)] = 626,
  [SMALL_STATE(193)] = 702,
  [SMALL_STATE(194)] = 769,
  [SMALL_STATE(195)] = 836,
  [SMALL_STATE(196)] = 903,
  [SMALL_STATE(197)] = 970,
  [SMALL_STATE(198)] = 1041,
  [SMALL_STATE(199)] = 1108,
  [SMALL_STATE(200)] = 1179,
  [SMALL_STATE(201)] = 1246,
  [SMALL_STATE(202)] = 1316,
  [SMALL_STATE(203)] = 1381,
  [SMALL_STATE(204)] = 1446,
  [SMALL_STATE(205)] = 1511,
  [SMALL_STATE(206)] = 1576,
  [SMALL_STATE(207)] = 1641,
  [SMALL_STATE(208)] = 1706,
  [SMALL_STATE(209)] = 1771,
  [SMALL_STATE(210)] = 1836,
  [SMALL_STATE(211)] = 1901,
  [SMALL_STATE(212)] = 1966,
  [SMALL_STATE(213)] = 2031,
  [SMALL_STATE(214)] = 2096,
  [SMALL_STATE(215)] = 2161,
  [SMALL_STATE(216)] = 2226,
  [SMALL_STATE(217)] = 2291,
  [SMALL_STATE(218)] = 2356,
  [SMALL_STATE(219)] = 2421,
  [SMALL_STATE(220)] = 2486,
  [SMALL_STATE(221)] = 2551,
  [SMALL_STATE(222)] = 2616,
  [SMALL_STATE(223)] = 2681,
  [SMALL_STATE(224)] = 2746,
  [SMALL_STATE(225)] = 2811,
  [SMALL_STATE(226)] = 2876,
  [SMALL_STATE(227)] = 2941,
  [SMALL_STATE(228)] = 3006,
  [SMALL_STATE(229)] = 3071,
  [SMALL_STATE(230)] = 3136,
  [SMALL_STATE(231)] = 3201,
  [SMALL_STATE(232)] = 3266,
  [SMALL_STATE(233)] = 3331,
  [SMALL_STATE(234)] = 3396,
  [SMALL_STATE(235)] = 3461,
  [SMALL_STATE(236)] = 3526,
  [SMALL_STATE(237)] = 3591,
  [SMALL_STATE(238)] = 3656,
  [SMALL_STATE(239)] = 3721,
  [SMALL_STATE(240)] = 3786,
  [SMALL_STATE(241)] = 3851,
  [SMALL_STATE(242)] = 3916,
  [SMALL_STATE(243)] = 3981,
  [SMALL_STATE(244)] = 4046,
  [SMALL_STATE(245)] = 4111,
  [SMALL_STATE(246)] = 4176,
  [SMALL_STATE(247)] = 4241,
  [SMALL_STATE(248)] = 4306,
  [SMALL_STATE(249)] = 4371,
  [SMALL_STATE(250)] = 4436,
  [SMALL_STATE(251)] = 4501,
  [SMALL_STATE(252)] = 4566,
  [SMALL_STATE(253)] = 4631,
  [SMALL_STATE(254)] = 4696,
  [SMALL_STATE(255)] = 4761,
  [SMALL_STATE(256)] = 4826,
  [SMALL_STATE(257)] = 4891,
  [SMALL_STATE(258)] = 4956,
  [SMALL_STATE(259)] = 5021,
  [SMALL_STATE(260)] = 5086,
  [SMALL_STATE(261)] = 5151,
  [SMALL_STATE(262)] = 5216,
  [SMALL_STATE(263)] = 5281,
  [SMALL_STATE(264)] = 5346,
  [SMALL_STATE(265)] = 5411,
  [SMALL_STATE(266)] = 5476,
  [SMALL_STATE(267)] = 5541,
  [SMALL_STATE(268)] = 5606,
  [SMALL_STATE(269)] = 5671,
  [SMALL_STATE(270)] = 5736,
  [SMALL_STATE(271)] = 5801,
  [SMALL_STATE(272)] = 5866,
  [SMALL_STATE(273)] = 5931,
  [SMALL_STATE(274)] = 5996,
  [SMALL_STATE(275)] = 6061,
  [SMALL_STATE(276)] = 6126,
  [SMALL_STATE(277)] = 6191,
  [SMALL_STATE(278)] = 6256,
  [SMALL_STATE(279)] = 6321,
  [SMALL_STATE(280)] = 6386,
  [SMALL_STATE(281)] = 6451,
  [SMALL_STATE(282)] = 6516,
  [SMALL_STATE(283)] = 6581,
  [SMALL_STATE(284)] = 6646,
  [SMALL_STATE(285)] = 6711,
  [SMALL_STATE(286)] = 6776,
  [SMALL_STATE(287)] = 6841,
  [SMALL_STATE(288)] = 6906,
  [SMALL_STATE(289)] = 6971,
  [SMALL_STATE(290)] = 7036,
  [SMALL_STATE(291)] = 7101,
  [SMALL_STATE(292)] = 7166,
  [SMALL_STATE(293)] = 7231,
  [SMALL_STATE(294)] = 7296,
  [SMALL_STATE(295)] = 7361,
  [SMALL_STATE(296)] = 7426,
  [SMALL_STATE(297)] = 7491,
  [SMALL_STATE(298)] = 7556,
  [SMALL_STATE(299)] = 7621,
  [SMALL_STATE(300)] = 7686,
  [SMALL_STATE(301)] = 7751,
  [SMALL_STATE(302)] = 7816,
  [SMALL_STATE(303)] = 7881,
  [SMALL_STATE(304)] = 7946,
  [SMALL_STATE(305)] = 8011,
  [SMALL_STATE(306)] = 8076,
  [SMALL_STATE(307)] = 8141,
  [SMALL_STATE(308)] = 8206,
  [SMALL_STATE(309)] = 8271,
  [SMALL_STATE(310)] = 8336,
  [SMALL_STATE(311)] = 8401,
  [SMALL_STATE(312)] = 8466,
  [SMALL_STATE(313)] = 8531,
  [SMALL_STATE(314)] = 8596,
  [SMALL_STATE(315)] = 8661,
  [SMALL_STATE(316)] = 8726,
  [SMALL_STATE(317)] = 8791,
  [SMALL_STATE(318)] = 8856,
  [SMALL_STATE(319)] = 8921,
  [SMALL_STATE(320)] = 8986,
  [SMALL_STATE(321)] = 9051,
  [SMALL_STATE(322)] = 9116,
  [SMALL_STATE(323)] = 9181,
  [SMALL_STATE(324)] = 9246,
  [SMALL_STATE(325)] = 9311,
  [SMALL_STATE(326)] = 9376,
  [SMALL_STATE(327)] = 9441,
  [SMALL_STATE(328)] = 9506,
  [SMALL_STATE(329)] = 9571,
  [SMALL_STATE(330)] = 9636,
  [SMALL_STATE(331)] = 9701,
  [SMALL_STATE(332)] = 9766,
  [SMALL_STATE(333)] = 9831,
  [SMALL_STATE(334)] = 9896,
  [SMALL_STATE(335)] = 9961,
  [SMALL_STATE(336)] = 10026,
  [SMALL_STATE(337)] = 10091,
  [SMALL_STATE(338)] = 10156,
  [SMALL_STATE(339)] = 10221,
  [SMALL_STATE(340)] = 10286,
  [SMALL_STATE(341)] = 10351,
  [SMALL_STATE(342)] = 10416,
  [SMALL_STATE(343)] = 10481,
  [SMALL_STATE(344)] = 10546,
  [SMALL_STATE(345)] = 10611,
  [SMALL_STATE(346)] = 10676,
  [SMALL_STATE(347)] = 10741,
  [SMALL_STATE(348)] = 10806,
  [SMALL_STATE(349)] = 10871,
  [SMALL_STATE(350)] = 10936,
  [SMALL_STATE(351)] = 11001,
  [SMALL_STATE(352)] = 11066,
  [SMALL_STATE(353)] = 11131,
  [SMALL_STATE(354)] = 11196,
  [SMALL_STATE(355)] = 11261,
  [SMALL_STATE(356)] = 11326,
  [SMALL_STATE(357)] = 11391,
  [SMALL_STATE(358)] = 11456,
  [SMALL_STATE(359)] = 11521,
  [SMALL_STATE(360)] = 11586,
  [SMALL_STATE(361)] = 11651,
  [SMALL_STATE(362)] = 11716,
  [SMALL_STATE(363)] = 11781,
  [SMALL_STATE(364)] = 11846,
  [SMALL_STATE(365)] = 11911,
  [SMALL_STATE(366)] = 11976,
  [SMALL_STATE(367)] = 12041,
  [SMALL_STATE(368)] = 12106,
  [SMALL_STATE(369)] = 12171,
  [SMALL_STATE(370)] = 12236,
  [SMALL_STATE(371)] = 12301,
  [SMALL_STATE(372)] = 12366,
  [SMALL_STATE(373)] = 12431,
  [SMALL_STATE(374)] = 12496,
  [SMALL_STATE(375)] = 12561,
  [SMALL_STATE(376)] = 12626,
  [SMALL_STATE(377)] = 12691,
  [SMALL_STATE(378)] = 12756,
  [SMALL_STATE(379)] = 12821,
  [SMALL_STATE(380)] = 12886,
  [SMALL_STATE(381)] = 12951,
  [SMALL_STATE(382)] = 13016,
  [SMALL_STATE(383)] = 13081,
  [SMALL_STATE(384)] = 13146,
  [SMALL_STATE(385)] = 13211,
  [SMALL_STATE(386)] = 13276,
  [SMALL_STATE(387)] = 13341,
  [SMALL_STATE(388)] = 13406,
  [SMALL_STATE(389)] = 13471,
  [SMALL_STATE(390)] = 13536,
  [SMALL_STATE(391)] = 13601,
  [SMALL_STATE(392)] = 13666,
  [SMALL_STATE(393)] = 13731,
  [SMALL_STATE(394)] = 13796,
  [SMALL_STATE(395)] = 13861,
  [SMALL_STATE(396)] = 13926,
  [SMALL_STATE(397)] = 13991,
  [SMALL_STATE(398)] = 14056,
  [SMALL_STATE(399)] = 14121,
  [SMALL_STATE(400)] = 14186,
  [SMALL_STATE(401)] = 14251,
  [SMALL_STATE(402)] = 14316,
  [SMALL_STATE(403)] = 14381,
  [SMALL_STATE(404)] = 14446,
  [SMALL_STATE(405)] = 14511,
  [SMALL_STATE(406)] = 14576,
  [SMALL_STATE(407)] = 14641,
  [SMALL_STATE(408)] = 14706,
  [SMALL_STATE(409)] = 14771,
  [SMALL_STATE(410)] = 14836,
  [SMALL_STATE(411)] = 14901,
  [SMALL_STATE(412)] = 14966,
  [SMALL_STATE(413)] = 15031,
  [SMALL_STATE(414)] = 15096,
  [SMALL_STATE(415)] = 15161,
  [SMALL_STATE(416)] = 15226,
  [SMALL_STATE(417)] = 15291,
  [SMALL_STATE(418)] = 15356,
  [SMALL_STATE(419)] = 15421,
  [SMALL_STATE(420)] = 15486,
  [SMALL_STATE(421)] = 15551,
  [SMALL_STATE(422)] = 15616,
  [SMALL_STATE(423)] = 15681,
  [SMALL_STATE(424)] = 15746,
  [SMALL_STATE(425)] = 15811,
  [SMALL_STATE(426)] = 15876,
  [SMALL_STATE(427)] = 15941,
  [SMALL_STATE(428)] = 16006,
  [SMALL_STATE(429)] = 16071,
  [SMALL_STATE(430)] = 16136,
  [SMALL_STATE(431)] = 16201,
  [SMALL_STATE(432)] = 16266,
  [SMALL_STATE(433)] = 16331,
  [SMALL_STATE(434)] = 16396,
  [SMALL_STATE(435)] = 16461,
  [SMALL_STATE(436)] = 16526,
  [SMALL_STATE(437)] = 16591,
  [SMALL_STATE(438)] = 16656,
  [SMALL_STATE(439)] = 16721,
  [SMALL_STATE(440)] = 16786,
  [SMALL_STATE(441)] = 16851,
  [SMALL_STATE(442)] = 16916,
  [SMALL_STATE(443)] = 16981,
  [SMALL_STATE(444)] = 17046,
  [SMALL_STATE(445)] = 17111,
  [SMALL_STATE(446)] = 17176,
  [SMALL_STATE(447)] = 17241,
  [SMALL_STATE(448)] = 17306,
  [SMALL_STATE(449)] = 17371,
  [SMALL_STATE(450)] = 17436,
  [SMALL_STATE(451)] = 17501,
  [SMALL_STATE(452)] = 17566,
  [SMALL_STATE(453)] = 17631,
  [SMALL_STATE(454)] = 17696,
  [SMALL_STATE(455)] = 17761,
  [SMALL_STATE(456)] = 17826,
  [SMALL_STATE(457)] = 17891,
  [SMALL_STATE(458)] = 17956,
  [SMALL_STATE(459)] = 18021,
  [SMALL_STATE(460)] = 18086,
  [SMALL_STATE(461)] = 18151,
  [SMALL_STATE(462)] = 18216,
  [SMALL_STATE(463)] = 18281,
  [SMALL_STATE(464)] = 18346,
  [SMALL_STATE(465)] = 18411,
  [SMALL_STATE(466)] = 18476,
  [SMALL_STATE(467)] = 18541,
  [SMALL_STATE(468)] = 18606,
  [SMALL_STATE(469)] = 18671,
  [SMALL_STATE(470)] = 18736,
  [SMALL_STATE(471)] = 18801,
  [SMALL_STATE(472)] = 18866,
  [SMALL_STATE(473)] = 18931,
  [SMALL_STATE(474)] = 18996,
  [SMALL_STATE(475)] = 19061,
  [SMALL_STATE(476)] = 19126,
  [SMALL_STATE(477)] = 19191,
  [SMALL_STATE(478)] = 19256,
  [SMALL_STATE(479)] = 19321,
  [SMALL_STATE(480)] = 19386,
  [SMALL_STATE(481)] = 19451,
  [SMALL_STATE(482)] = 19516,
  [SMALL_STATE(483)] = 19581,
  [SMALL_STATE(484)] = 19646,
  [SMALL_STATE(485)] = 19711,
  [SMALL_STATE(486)] = 19776,
  [SMALL_STATE(487)] = 19841,
  [SMALL_STATE(488)] = 19906,
  [SMALL_STATE(489)] = 19971,
  [SMALL_STATE(490)] = 20036,
  [SMALL_STATE(491)] = 20101,
  [SMALL_STATE(492)] = 20166,
  [SMALL_STATE(493)] = 20231,
  [SMALL_STATE(494)] = 20296,
  [SMALL_STATE(495)] = 20361,
  [SMALL_STATE(496)] = 20426,
  [SMALL_STATE(497)] = 20491,
  [SMALL_STATE(498)] = 20556,
  [SMALL_STATE(499)] = 20621,
  [SMALL_STATE(500)] = 20686,
  [SMALL_STATE(501)] = 20751,
  [SMALL_STATE(502)] = 20816,
  [SMALL_STATE(503)] = 20881,
  [SMALL_STATE(504)] = 20946,
  [SMALL_STATE(505)] = 21011,
  [SMALL_STATE(506)] = 21076,
  [SMALL_STATE(507)] = 21141,
  [SMALL_STATE(508)] = 21206,
  [SMALL_STATE(509)] = 21271,
  [SMALL_STATE(510)] = 21336,
  [SMALL_STATE(511)] = 21401,
  [SMALL_STATE(512)] = 21466,
  [SMALL_STATE(513)] = 21531,
  [SMALL_STATE(514)] = 21596,
  [SMALL_STATE(515)] = 21661,
  [SMALL_STATE(516)] = 21726,
  [SMALL_STATE(517)] = 21791,
  [SMALL_STATE(518)] = 21856,
  [SMALL_STATE(519)] = 21921,
  [SMALL_STATE(520)] = 21986,
  [SMALL_STATE(521)] = 22051,
  [SMALL_STATE(522)] = 22116,
  [SMALL_STATE(523)] = 22181,
  [SMALL_STATE(524)] = 22246,
  [SMALL_STATE(525)] = 22311,
  [SMALL_STATE(526)] = 22376,
  [SMALL_STATE(527)] = 22441,
  [SMALL_STATE(528)] = 22506,
  [SMALL_STATE(529)] = 22571,
  [SMALL_STATE(530)] = 22636,
  [SMALL_STATE(531)] = 22701,
  [SMALL_STATE(532)] = 22766,
  [SMALL_STATE(533)] = 22831,
  [SMALL_STATE(534)] = 22896,
  [SMALL_STATE(535)] = 22961,
  [SMALL_STATE(536)] = 23026,
  [SMALL_STATE(537)] = 23091,
  [SMALL_STATE(538)] = 23156,
  [SMALL_STATE(539)] = 23221,
  [SMALL_STATE(540)] = 23286,
  [SMALL_STATE(541)] = 23351,
  [SMALL_STATE(542)] = 23416,
  [SMALL_STATE(543)] = 23481,
  [SMALL_STATE(544)] = 23546,
  [SMALL_STATE(545)] = 23611,
  [SMALL_STATE(546)] = 23676,
  [SMALL_STATE(547)] = 23741,
  [SMALL_STATE(548)] = 23806,
  [SMALL_STATE(549)] = 23874,
  [SMALL_STATE(550)] = 23942,
  [SMALL_STATE(551)] = 24005,
  [SMALL_STATE(552)] = 24068,
  [SMALL_STATE(553)] = 24131,
  [SMALL_STATE(554)] = 24194,
  [SMALL_STATE(555)] = 24257,
  [SMALL_STATE(556)] = 24320,
  [SMALL_STATE(557)] = 24383,
  [SMALL_STATE(558)] = 24490,
  [SMALL_STATE(559)] = 24553,
  [SMALL_STATE(560)] = 24616,
  [SMALL_STATE(561)] = 24679,
  [SMALL_STATE(562)] = 24742,
  [SMALL_STATE(563)] = 24805,
  [SMALL_STATE(564)] = 24868,
  [SMALL_STATE(565)] = 24931,
  [SMALL_STATE(566)] = 24994,
  [SMALL_STATE(567)] = 25057,
  [SMALL_STATE(568)] = 25120,
  [SMALL_STATE(569)] = 25183,
  [SMALL_STATE(570)] = 25246,
  [SMALL_STATE(571)] = 25309,
  [SMALL_STATE(572)] = 25372,
  [SMALL_STATE(573)] = 25435,
  [SMALL_STATE(574)] = 25498,
  [SMALL_STATE(575)] = 25561,
  [SMALL_STATE(576)] = 25624,
  [SMALL_STATE(577)] = 25687,
  [SMALL_STATE(578)] = 25750,
  [SMALL_STATE(579)] = 25813,
  [SMALL_STATE(580)] = 25876,
  [SMALL_STATE(581)] = 25939,
  [SMALL_STATE(582)] = 26002,
  [SMALL_STATE(583)] = 26065,
  [SMALL_STATE(584)] = 26128,
  [SMALL_STATE(585)] = 26191,
  [SMALL_STATE(586)] = 26254,
  [SMALL_STATE(587)] = 26317,
  [SMALL_STATE(588)] = 26380,
  [SMALL_STATE(589)] = 26443,
  [SMALL_STATE(590)] = 26506,
  [SMALL_STATE(591)] = 26569,
  [SMALL_STATE(592)] = 26632,
  [SMALL_STATE(593)] = 26695,
  [SMALL_STATE(594)] = 26758,
  [SMALL_STATE(595)] = 26821,
  [SMALL_STATE(596)] = 26884,
  [SMALL_STATE(597)] = 26947,
  [SMALL_STATE(598)] = 27010,
  [SMALL_STATE(599)] = 27073,
  [SMALL_STATE(600)] = 27136,
  [SMALL_STATE(601)] = 27199,
  [SMALL_STATE(602)] = 27262,
  [SMALL_STATE(603)] = 27325,
  [SMALL_STATE(604)] = 27388,
  [SMALL_STATE(605)] = 27451,
  [SMALL_STATE(606)] = 27514,
  [SMALL_STATE(607)] = 27577,
  [SMALL_STATE(608)] = 27640,
  [SMALL_STATE(609)] = 27703,
  [SMALL_STATE(610)] = 27766,
  [SMALL_STATE(611)] = 27829,
  [SMALL_STATE(612)] = 27892,
  [SMALL_STATE(613)] = 27955,
  [SMALL_STATE(614)] = 28018,
  [SMALL_STATE(615)] = 28081,
  [SMALL_STATE(616)] = 28188,
  [SMALL_STATE(617)] = 28251,
  [SMALL_STATE(618)] = 28314,
  [SMALL_STATE(619)] = 28377,
  [SMALL_STATE(620)] = 28440,
  [SMALL_STATE(621)] = 28503,
  [SMALL_STATE(622)] = 28566,
  [SMALL_STATE(623)] = 28629,
  [SMALL_STATE(624)] = 28692,
  [SMALL_STATE(625)] = 28755,
  [SMALL_STATE(626)] = 28818,
  [SMALL_STATE(627)] = 28881,
  [SMALL_STATE(628)] = 28944,
  [SMALL_STATE(629)] = 29007,
  [SMALL_STATE(630)] = 29070,
  [SMALL_STATE(631)] = 29133,
  [SMALL_STATE(632)] = 29196,
  [SMALL_STATE(633)] = 29259,
  [SMALL_STATE(634)] = 29322,
  [SMALL_STATE(635)] = 29385,
  [SMALL_STATE(636)] = 29448,
  [SMALL_STATE(637)] = 29511,
  [SMALL_STATE(638)] = 29574,
  [SMALL_STATE(639)] = 29637,
  [SMALL_STATE(640)] = 29700,
  [SMALL_STATE(641)] = 29763,
  [SMALL_STATE(642)] = 29826,
  [SMALL_STATE(643)] = 29889,
  [SMALL_STATE(644)] = 29952,
  [SMALL_STATE(645)] = 30015,
  [SMALL_STATE(646)] = 30078,
  [SMALL_STATE(647)] = 30141,
  [SMALL_STATE(648)] = 30204,
  [SMALL_STATE(649)] = 30267,
  [SMALL_STATE(650)] = 30330,
  [SMALL_STATE(651)] = 30393,
  [SMALL_STATE(652)] = 30456,
  [SMALL_STATE(653)] = 30519,
  [SMALL_STATE(654)] = 30582,
  [SMALL_STATE(655)] = 30645,
  [SMALL_STATE(656)] = 30708,
  [SMALL_STATE(657)] = 30771,
  [SMALL_STATE(658)] = 30834,
  [SMALL_STATE(659)] = 30897,
  [SMALL_STATE(660)] = 30960,
  [SMALL_STATE(661)] = 31023,
  [SMALL_STATE(662)] = 31086,
  [SMALL_STATE(663)] = 31149,
  [SMALL_STATE(664)] = 31212,
  [SMALL_STATE(665)] = 31275,
  [SMALL_STATE(666)] = 31338,
  [SMALL_STATE(667)] = 31401,
  [SMALL_STATE(668)] = 31464,
  [SMALL_STATE(669)] = 31527,
  [SMALL_STATE(670)] = 31590,
  [SMALL_STATE(671)] = 31653,
  [SMALL_STATE(672)] = 31716,
  [SMALL_STATE(673)] = 31779,
  [SMALL_STATE(674)] = 31842,
  [SMALL_STATE(675)] = 31905,
  [SMALL_STATE(676)] = 31968,
  [SMALL_STATE(677)] = 32031,
  [SMALL_STATE(678)] = 32094,
  [SMALL_STATE(679)] = 32157,
  [SMALL_STATE(680)] = 32220,
  [SMALL_STATE(681)] = 32283,
  [SMALL_STATE(682)] = 32346,
  [SMALL_STATE(683)] = 32409,
  [SMALL_STATE(684)] = 32472,
  [SMALL_STATE(685)] = 32535,
  [SMALL_STATE(686)] = 32598,
  [SMALL_STATE(687)] = 32661,
  [SMALL_STATE(688)] = 32724,
  [SMALL_STATE(689)] = 32787,
  [SMALL_STATE(690)] = 32850,
  [SMALL_STATE(691)] = 32913,
  [SMALL_STATE(692)] = 32976,
  [SMALL_STATE(693)] = 33039,
  [SMALL_STATE(694)] = 33102,
  [SMALL_STATE(695)] = 33165,
  [SMALL_STATE(696)] = 33228,
  [SMALL_STATE(697)] = 33291,
  [SMALL_STATE(698)] = 33354,
  [SMALL_STATE(699)] = 33417,
  [SMALL_STATE(700)] = 33480,
  [SMALL_STATE(701)] = 33543,
  [SMALL_STATE(702)] = 33606,
  [SMALL_STATE(703)] = 33669,
  [SMALL_STATE(704)] = 33732,
  [SMALL_STATE(705)] = 33795,
  [SMALL_STATE(706)] = 33858,
  [SMALL_STATE(707)] = 33921,
  [SMALL_STATE(708)] = 33984,
  [SMALL_STATE(709)] = 34047,
  [SMALL_STATE(710)] = 34110,
  [SMALL_STATE(711)] = 34173,
  [SMALL_STATE(712)] = 34236,
  [SMALL_STATE(713)] = 34299,
  [SMALL_STATE(714)] = 34362,
  [SMALL_STATE(715)] = 34425,
  [SMALL_STATE(716)] = 34488,
  [SMALL_STATE(717)] = 34551,
  [SMALL_STATE(718)] = 34614,
  [SMALL_STATE(719)] = 34677,
  [SMALL_STATE(720)] = 34740,
  [SMALL_STATE(721)] = 34803,
  [SMALL_STATE(722)] = 34866,
  [SMALL_STATE(723)] = 34929,
  [SMALL_STATE(724)] = 34992,
  [SMALL_STATE(725)] = 35055,
  [SMALL_STATE(726)] = 35118,
  [SMALL_STATE(727)] = 35181,
  [SMALL_STATE(728)] = 35244,
  [SMALL_STATE(729)] = 35307,
  [SMALL_STATE(730)] = 35370,
  [SMALL_STATE(731)] = 35433,
  [SMALL_STATE(732)] = 35496,
  [SMALL_STATE(733)] = 35559,
  [SMALL_STATE(734)] = 35622,
  [SMALL_STATE(735)] = 35685,
  [SMALL_STATE(736)] = 35748,
  [SMALL_STATE(737)] = 35811,
  [SMALL_STATE(738)] = 35874,
  [SMALL_STATE(739)] = 35937,
  [SMALL_STATE(740)] = 36000,
  [SMALL_STATE(741)] = 36063,
  [SMALL_STATE(742)] = 36126,
  [SMALL_STATE(743)] = 36189,
  [SMALL_STATE(744)] = 36252,
  [SMALL_STATE(745)] = 36315,
  [SMALL_STATE(746)] = 36378,
  [SMALL_STATE(747)] = 36441,
  [SMALL_STATE(748)] = 36504,
  [SMALL_STATE(749)] = 36567,
  [SMALL_STATE(750)] = 36630,
  [SMALL_STATE(751)] = 36693,
  [SMALL_STATE(752)] = 36756,
  [SMALL_STATE(753)] = 36819,
  [SMALL_STATE(754)] = 36882,
  [SMALL_STATE(755)] = 36945,
  [SMALL_STATE(756)] = 37008,
  [SMALL_STATE(757)] = 37071,
  [SMALL_STATE(758)] = 37134,
  [SMALL_STATE(759)] = 37197,
  [SMALL_STATE(760)] = 37260,
  [SMALL_STATE(761)] = 37323,
  [SMALL_STATE(762)] = 37386,
  [SMALL_STATE(763)] = 37449,
  [SMALL_STATE(764)] = 37512,
  [SMALL_STATE(765)] = 37575,
  [SMALL_STATE(766)] = 37638,
  [SMALL_STATE(767)] = 37701,
  [SMALL_STATE(768)] = 37764,
  [SMALL_STATE(769)] = 37827,
  [SMALL_STATE(770)] = 37890,
  [SMALL_STATE(771)] = 37953,
  [SMALL_STATE(772)] = 38016,
  [SMALL_STATE(773)] = 38079,
  [SMALL_STATE(774)] = 38142,
  [SMALL_STATE(775)] = 38205,
  [SMALL_STATE(776)] = 38268,
  [SMALL_STATE(777)] = 38331,
  [SMALL_STATE(778)] = 38394,
  [SMALL_STATE(779)] = 38457,
  [SMALL_STATE(780)] = 38520,
  [SMALL_STATE(781)] = 38583,
  [SMALL_STATE(782)] = 38646,
  [SMALL_STATE(783)] = 38709,
  [SMALL_STATE(784)] = 38772,
  [SMALL_STATE(785)] = 38835,
  [SMALL_STATE(786)] = 38898,
  [SMALL_STATE(787)] = 38961,
  [SMALL_STATE(788)] = 39024,
  [SMALL_STATE(789)] = 39087,
  [SMALL_STATE(790)] = 39150,
  [SMALL_STATE(791)] = 39213,
  [SMALL_STATE(792)] = 39276,
  [SMALL_STATE(793)] = 39339,
  [SMALL_STATE(794)] = 39402,
  [SMALL_STATE(795)] = 39465,
  [SMALL_STATE(796)] = 39528,
  [SMALL_STATE(797)] = 39591,
  [SMALL_STATE(798)] = 39654,
  [SMALL_STATE(799)] = 39717,
  [SMALL_STATE(800)] = 39780,
  [SMALL_STATE(801)] = 39887,
  [SMALL_STATE(802)] = 39950,
  [SMALL_STATE(803)] = 40013,
  [SMALL_STATE(804)] = 40076,
  [SMALL_STATE(805)] = 40139,
  [SMALL_STATE(806)] = 40202,
  [SMALL_STATE(807)] = 40265,
  [SMALL_STATE(808)] = 40328,
  [SMALL_STATE(809)] = 40391,
  [SMALL_STATE(810)] = 40454,
  [SMALL_STATE(811)] = 40517,
  [SMALL_STATE(812)] = 40580,
  [SMALL_STATE(813)] = 40643,
  [SMALL_STATE(814)] = 40706,
  [SMALL_STATE(815)] = 40769,
  [SMALL_STATE(816)] = 40832,
  [SMALL_STATE(817)] = 40895,
  [SMALL_STATE(818)] = 40958,
  [SMALL_STATE(819)] = 41021,
  [SMALL_STATE(820)] = 41084,
  [SMALL_STATE(821)] = 41147,
  [SMALL_STATE(822)] = 41210,
  [SMALL_STATE(823)] = 41273,
  [SMALL_STATE(824)] = 41336,
  [SMALL_STATE(825)] = 41399,
  [SMALL_STATE(826)] = 41462,
  [SMALL_STATE(827)] = 41525,
  [SMALL_STATE(828)] = 41588,
  [SMALL_STATE(829)] = 41651,
  [SMALL_STATE(830)] = 41714,
  [SMALL_STATE(831)] = 41777,
  [SMALL_STATE(832)] = 41840,
  [SMALL_STATE(833)] = 41903,
  [SMALL_STATE(834)] = 41966,
  [SMALL_STATE(835)] = 42029,
  [SMALL_STATE(836)] = 42092,
  [SMALL_STATE(837)] = 42155,
  [SMALL_STATE(838)] = 42218,
  [SMALL_STATE(839)] = 42281,
  [SMALL_STATE(840)] = 42344,
  [SMALL_STATE(841)] = 42407,
  [SMALL_STATE(842)] = 42470,
  [SMALL_STATE(843)] = 42533,
  [SMALL_STATE(844)] = 42596,
  [SMALL_STATE(845)] = 42659,
  [SMALL_STATE(846)] = 42722,
  [SMALL_STATE(847)] = 42785,
  [SMALL_STATE(848)] = 42848,
  [SMALL_STATE(849)] = 42911,
  [SMALL_STATE(850)] = 42974,
  [SMALL_STATE(851)] = 43037,
  [SMALL_STATE(852)] = 43100,
  [SMALL_STATE(853)] = 43163,
  [SMALL_STATE(854)] = 43226,
  [SMALL_STATE(855)] = 43289,
  [SMALL_STATE(856)] = 43352,
  [SMALL_STATE(857)] = 43415,
  [SMALL_STATE(858)] = 43478,
  [SMALL_STATE(859)] = 43541,
  [SMALL_STATE(860)] = 43604,
  [SMALL_STATE(861)] = 43667,
  [SMALL_STATE(862)] = 43730,
  [SMALL_STATE(863)] = 43793,
  [SMALL_STATE(864)] = 43856,
  [SMALL_STATE(865)] = 43919,
  [SMALL_STATE(866)] = 43982,
  [SMALL_STATE(867)] = 44045,
  [SMALL_STATE(868)] = 44108,
  [SMALL_STATE(869)] = 44171,
  [SMALL_STATE(870)] = 44234,
  [SMALL_STATE(871)] = 44297,
  [SMALL_STATE(872)] = 44360,
  [SMALL_STATE(873)] = 44423,
  [SMALL_STATE(874)] = 44486,
  [SMALL_STATE(875)] = 44549,
  [SMALL_STATE(876)] = 44612,
  [SMALL_STATE(877)] = 44675,
  [SMALL_STATE(878)] = 44738,
  [SMALL_STATE(879)] = 44801,
  [SMALL_STATE(880)] = 44864,
  [SMALL_STATE(881)] = 44927,
  [SMALL_STATE(882)] = 44990,
  [SMALL_STATE(883)] = 45053,
  [SMALL_STATE(884)] = 45116,
  [SMALL_STATE(885)] = 45179,
  [SMALL_STATE(886)] = 45242,
  [SMALL_STATE(887)] = 45305,
  [SMALL_STATE(888)] = 45368,
  [SMALL_STATE(889)] = 45431,
  [SMALL_STATE(890)] = 45494,
  [SMALL_STATE(891)] = 45557,
  [SMALL_STATE(892)] = 45620,
  [SMALL_STATE(893)] = 45683,
  [SMALL_STATE(894)] = 45746,
  [SMALL_STATE(895)] = 45845,
  [SMALL_STATE(896)] = 45944,
  [SMALL_STATE(897)] = 46045,
  [SMALL_STATE(898)] = 46146,
  [SMALL_STATE(899)] = 46247,
  [SMALL_STATE(900)] = 46348,
  [SMALL_STATE(901)] = 46409,
  [SMALL_STATE(902)] = 46510,
  [SMALL_STATE(903)] = 46609,
  [SMALL_STATE(904)] = 46676,
  [SMALL_STATE(905)] = 46777,
  [SMALL_STATE(906)] = 46837,
  [SMALL_STATE(907)] = 46897,
  [SMALL_STATE(908)] = 46957,
  [SMALL_STATE(909)] = 47021,
  [SMALL_STATE(910)] = 47092,
  [SMALL_STATE(911)] = 47165,
  [SMALL_STATE(912)] = 47260,
  [SMALL_STATE(913)] = 47355,
  [SMALL_STATE(914)] = 47450,
  [SMALL_STATE(915)] = 47545,
  [SMALL_STATE(916)] = 47640,
  [SMALL_STATE(917)] = 47735,
  [SMALL_STATE(918)] = 47806,
  [SMALL_STATE(919)] = 47901,
  [SMALL_STATE(920)] = 47996,
  [SMALL_STATE(921)] = 48091,
  [SMALL_STATE(922)] = 48186,
  [SMALL_STATE(923)] = 48281,
  [SMALL_STATE(924)] = 48352,
  [SMALL_STATE(925)] = 48447,
  [SMALL_STATE(926)] = 48542,
  [SMALL_STATE(927)] = 48615,
  [SMALL_STATE(928)] = 48710,
  [SMALL_STATE(929)] = 48805,
  [SMALL_STATE(930)] = 48878,
  [SMALL_STATE(931)] = 48946,
  [SMALL_STATE(932)] = 49038,
  [SMALL_STATE(933)] = 49106,
  [SMALL_STATE(934)] = 49198,
  [SMALL_STATE(935)] = 49290,
  [SMALL_STATE(936)] = 49382,
  [SMALL_STATE(937)] = 49474,
  [SMALL_STATE(938)] = 49566,
  [SMALL_STATE(939)] = 49658,
  [SMALL_STATE(940)] = 49730,
  [SMALL_STATE(941)] = 49822,
  [SMALL_STATE(942)] = 49914,
  [SMALL_STATE(943)] = 50006,
  [SMALL_STATE(944)] = 50074,
  [SMALL_STATE(945)] = 50166,
  [SMALL_STATE(946)] = 50255,
  [SMALL_STATE(947)] = 50344,
  [SMALL_STATE(948)] = 50433,
  [SMALL_STATE(949)] = 50522,
  [SMALL_STATE(950)] = 50611,
  [SMALL_STATE(951)] = 50700,
  [SMALL_STATE(952)] = 50789,
  [SMALL_STATE(953)] = 50878,
  [SMALL_STATE(954)] = 50967,
  [SMALL_STATE(955)] = 51058,
  [SMALL_STATE(956)] = 51147,
  [SMALL_STATE(957)] = 51236,
  [SMALL_STATE(958)] = 51325,
  [SMALL_STATE(959)] = 51414,
  [SMALL_STATE(960)] = 51503,
  [SMALL_STATE(961)] = 51594,
  [SMALL_STATE(962)] = 51683,
  [SMALL_STATE(963)] = 51772,
  [SMALL_STATE(964)] = 51861,
  [SMALL_STATE(965)] = 51950,
  [SMALL_STATE(966)] = 52039,
  [SMALL_STATE(967)] = 52128,
  [SMALL_STATE(968)] = 52217,
  [SMALL_STATE(969)] = 52306,
  [SMALL_STATE(970)] = 52395,
  [SMALL_STATE(971)] = 52484,
  [SMALL_STATE(972)] = 52573,
  [SMALL_STATE(973)] = 52662,
  [SMALL_STATE(974)] = 52751,
  [SMALL_STATE(975)] = 52840,
  [SMALL_STATE(976)] = 52931,
  [SMALL_STATE(977)] = 53020,
  [SMALL_STATE(978)] = 53109,
  [SMALL_STATE(979)] = 53198,
  [SMALL_STATE(980)] = 53287,
  [SMALL_STATE(981)] = 53376,
  [SMALL_STATE(982)] = 53465,
  [SMALL_STATE(983)] = 53554,
  [SMALL_STATE(984)] = 53643,
  [SMALL_STATE(985)] = 53732,
  [SMALL_STATE(986)] = 53821,
  [SMALL_STATE(987)] = 53910,
  [SMALL_STATE(988)] = 53999,
  [SMALL_STATE(989)] = 54088,
  [SMALL_STATE(990)] = 54177,
  [SMALL_STATE(991)] = 54266,
  [SMALL_STATE(992)] = 54355,
  [SMALL_STATE(993)] = 54446,
  [SMALL_STATE(994)] = 54535,
  [SMALL_STATE(995)] = 54624,
  [SMALL_STATE(996)] = 54713,
  [SMALL_STATE(997)] = 54802,
  [SMALL_STATE(998)] = 54891,
  [SMALL_STATE(999)] = 54980,
  [SMALL_STATE(1000)] = 55069,
  [SMALL_STATE(1001)] = 55158,
  [SMALL_STATE(1002)] = 55247,
  [SMALL_STATE(1003)] = 55336,
  [SMALL_STATE(1004)] = 55425,
  [SMALL_STATE(1005)] = 55514,
  [SMALL_STATE(1006)] = 55603,
  [SMALL_STATE(1007)] = 55692,
  [SMALL_STATE(1008)] = 55781,
  [SMALL_STATE(1009)] = 55870,
  [SMALL_STATE(1010)] = 55959,
  [SMALL_STATE(1011)] = 56048,
  [SMALL_STATE(1012)] = 56137,
  [SMALL_STATE(1013)] = 56226,
  [SMALL_STATE(1014)] = 56315,
  [SMALL_STATE(1015)] = 56404,
  [SMALL_STATE(1016)] = 56493,
  [SMALL_STATE(1017)] = 56582,
  [SMALL_STATE(1018)] = 56671,
  [SMALL_STATE(1019)] = 56760,
  [SMALL_STATE(1020)] = 56849,
  [SMALL_STATE(1021)] = 56915,
  [SMALL_STATE(1022)] = 56981,
  [SMALL_STATE(1023)] = 57047,
  [SMALL_STATE(1024)] = 57097,
  [SMALL_STATE(1025)] = 57147,
  [SMALL_STATE(1026)] = 57197,
  [SMALL_STATE(1027)] = 57247,
  [SMALL_STATE(1028)] = 57300,
  [SMALL_STATE(1029)] = 57351,
  [SMALL_STATE(1030)] = 57400,
  [SMALL_STATE(1031)] = 57448,
  [SMALL_STATE(1032)] = 57496,
  [SMALL_STATE(1033)] = 57582,
  [SMALL_STATE(1034)] = 57630,
  [SMALL_STATE(1035)] = 57718,
  [SMALL_STATE(1036)] = 57766,
  [SMALL_STATE(1037)] = 57814,
  [SMALL_STATE(1038)] = 57874,
  [SMALL_STATE(1039)] = 57934,
  [SMALL_STATE(1040)] = 57994,
  [SMALL_STATE(1041)] = 58070,
  [SMALL_STATE(1042)] = 58118,
  [SMALL_STATE(1043)] = 58198,
  [SMALL_STATE(1044)] = 58246,
  [SMALL_STATE(1045)] = 58294,
  [SMALL_STATE(1046)] = 58342,
  [SMALL_STATE(1047)] = 58412,
  [SMALL_STATE(1048)] = 58460,
  [SMALL_STATE(1049)] = 58508,
  [SMALL_STATE(1050)] = 58556,
  [SMALL_STATE(1051)] = 58604,
  [SMALL_STATE(1052)] = 58652,
  [SMALL_STATE(1053)] = 58700,
  [SMALL_STATE(1054)] = 58748,
  [SMALL_STATE(1055)] = 58796,
  [SMALL_STATE(1056)] = 58844,
  [SMALL_STATE(1057)] = 58892,
  [SMALL_STATE(1058)] = 58940,
  [SMALL_STATE(1059)] = 58988,
  [SMALL_STATE(1060)] = 59036,
  [SMALL_STATE(1061)] = 59084,
  [SMALL_STATE(1062)] = 59176,
  [SMALL_STATE(1063)] = 59258,
  [SMALL_STATE(1064)] = 59306,
  [SMALL_STATE(1065)] = 59354,
  [SMALL_STATE(1066)] = 59402,
  [SMALL_STATE(1067)] = 59450,
  [SMALL_STATE(1068)] = 59542,
  [SMALL_STATE(1069)] = 59590,
  [SMALL_STATE(1070)] = 59682,
  [SMALL_STATE(1071)] = 59730,
  [SMALL_STATE(1072)] = 59778,
  [SMALL_STATE(1073)] = 59862,
  [SMALL_STATE(1074)] = 59910,
  [SMALL_STATE(1075)] = 59958,
  [SMALL_STATE(1076)] = 60006,
  [SMALL_STATE(1077)] = 60054,
  [SMALL_STATE(1078)] = 60120,
  [SMALL_STATE(1079)] = 60168,
  [SMALL_STATE(1080)] = 60232,
  [SMALL_STATE(1081)] = 60280,
  [SMALL_STATE(1082)] = 60328,
  [SMALL_STATE(1083)] = 60376,
  [SMALL_STATE(1084)] = 60424,
  [SMALL_STATE(1085)] = 60472,
  [SMALL_STATE(1086)] = 60563,
  [SMALL_STATE(1087)] = 60610,
  [SMALL_STATE(1088)] = 60701,
  [SMALL_STATE(1089)] = 60790,
  [SMALL_STATE(1090)] = 60881,
  [SMALL_STATE(1091)] = 60972,
  [SMALL_STATE(1092)] = 61063,
  [SMALL_STATE(1093)] = 61154,
  [SMALL_STATE(1094)] = 61241,
  [SMALL_STATE(1095)] = 61332,
  [SMALL_STATE(1096)] = 61418,
  [SMALL_STATE(1097)] = 61506,
  [SMALL_STATE(1098)] = 61592,
  [SMALL_STATE(1099)] = 61678,
  [SMALL_STATE(1100)] = 61766,
  [SMALL_STATE(1101)] = 61854,
  [SMALL_STATE(1102)] = 61942,
  [SMALL_STATE(1103)] = 62030,
  [SMALL_STATE(1104)] = 62118,
  [SMALL_STATE(1105)] = 62206,
  [SMALL_STATE(1106)] = 62294,
  [SMALL_STATE(1107)] = 62382,
  [SMALL_STATE(1108)] = 62470,
  [SMALL_STATE(1109)] = 62558,
  [SMALL_STATE(1110)] = 62646,
  [SMALL_STATE(1111)] = 62734,
  [SMALL_STATE(1112)] = 62820,
  [SMALL_STATE(1113)] = 62908,
  [SMALL_STATE(1114)] = 62996,
  [SMALL_STATE(1115)] = 63084,
  [SMALL_STATE(1116)] = 63170,
  [SMALL_STATE(1117)] = 63258,
  [SMALL_STATE(1118)] = 63344,
  [SMALL_STATE(1119)] = 63432,
  [SMALL_STATE(1120)] = 63520,
  [SMALL_STATE(1121)] = 63608,
  [SMALL_STATE(1122)] = 63696,
  [SMALL_STATE(1123)] = 63781,
  [SMALL_STATE(1124)] = 63866,
  [SMALL_STATE(1125)] = 63951,
  [SMALL_STATE(1126)] = 64036,
  [SMALL_STATE(1127)] = 64121,
  [SMALL_STATE(1128)] = 64206,
  [SMALL_STATE(1129)] = 64291,
  [SMALL_STATE(1130)] = 64376,
  [SMALL_STATE(1131)] = 64461,
  [SMALL_STATE(1132)] = 64546,
  [SMALL_STATE(1133)] = 64631,
  [SMALL_STATE(1134)] = 64716,
  [SMALL_STATE(1135)] = 64801,
  [SMALL_STATE(1136)] = 64886,
  [SMALL_STATE(1137)] = 64971,
  [SMALL_STATE(1138)] = 65056,
  [SMALL_STATE(1139)] = 65141,
  [SMALL_STATE(1140)] = 65226,
  [SMALL_STATE(1141)] = 65311,
  [SMALL_STATE(1142)] = 65396,
  [SMALL_STATE(1143)] = 65481,
  [SMALL_STATE(1144)] = 65566,
  [SMALL_STATE(1145)] = 65651,
  [SMALL_STATE(1146)] = 65736,
  [SMALL_STATE(1147)] = 65821,
  [SMALL_STATE(1148)] = 65906,
  [SMALL_STATE(1149)] = 65991,
  [SMALL_STATE(1150)] = 66076,
  [SMALL_STATE(1151)] = 66161,
  [SMALL_STATE(1152)] = 66246,
  [SMALL_STATE(1153)] = 66331,
  [SMALL_STATE(1154)] = 66416,
  [SMALL_STATE(1155)] = 66501,
  [SMALL_STATE(1156)] = 66586,
  [SMALL_STATE(1157)] = 66671,
  [SMALL_STATE(1158)] = 66756,
  [SMALL_STATE(1159)] = 66841,
  [SMALL_STATE(1160)] = 66926,
  [SMALL_STATE(1161)] = 67011,
  [SMALL_STATE(1162)] = 67096,
  [SMALL_STATE(1163)] = 67181,
  [SMALL_STATE(1164)] = 67266,
  [SMALL_STATE(1165)] = 67351,
  [SMALL_STATE(1166)] = 67436,
  [SMALL_STATE(1167)] = 67521,
  [SMALL_STATE(1168)] = 67606,
  [SMALL_STATE(1169)] = 67691,
  [SMALL_STATE(1170)] = 67776,
  [SMALL_STATE(1171)] = 67861,
  [SMALL_STATE(1172)] = 67943,
  [SMALL_STATE(1173)] = 67978,
  [SMALL_STATE(1174)] = 68013,
  [SMALL_STATE(1175)] = 68074,
  [SMALL_STATE(1176)] = 68135,
  [SMALL_STATE(1177)] = 68196,
  [SMALL_STATE(1178)] = 68225,
  [SMALL_STATE(1179)] = 68250,
  [SMALL_STATE(1180)] = 68275,
  [SMALL_STATE(1181)] = 68300,
  [SMALL_STATE(1182)] = 68325,
  [SMALL_STATE(1183)] = 68350,
  [SMALL_STATE(1184)] = 68384,
  [SMALL_STATE(1185)] = 68418,
  [SMALL_STATE(1186)] = 68452,
  [SMALL_STATE(1187)] = 68486,
  [SMALL_STATE(1188)] = 68514,
  [SMALL_STATE(1189)] = 68539,
  [SMALL_STATE(1190)] = 68564,
  [SMALL_STATE(1191)] = 68583,
  [SMALL_STATE(1192)] = 68606,
  [SMALL_STATE(1193)] = 68629,
  [SMALL_STATE(1194)] = 68651,
  [SMALL_STATE(1195)] = 68669,
  [SMALL_STATE(1196)] = 68691,
  [SMALL_STATE(1197)] = 68713,
  [SMALL_STATE(1198)] = 68735,
  [SMALL_STATE(1199)] = 68757,
  [SMALL_STATE(1200)] = 68779,
  [SMALL_STATE(1201)] = 68801,
  [SMALL_STATE(1202)] = 68823,
  [SMALL_STATE(1203)] = 68845,
  [SMALL_STATE(1204)] = 68867,
  [SMALL_STATE(1205)] = 68889,
  [SMALL_STATE(1206)] = 68911,
  [SMALL_STATE(1207)] = 68933,
  [SMALL_STATE(1208)] = 68955,
  [SMALL_STATE(1209)] = 68973,
  [SMALL_STATE(1210)] = 68991,
  [SMALL_STATE(1211)] = 69015,
  [SMALL_STATE(1212)] = 69037,
  [SMALL_STATE(1213)] = 69059,
  [SMALL_STATE(1214)] = 69081,
  [SMALL_STATE(1215)] = 69103,
  [SMALL_STATE(1216)] = 69125,
  [SMALL_STATE(1217)] = 69147,
  [SMALL_STATE(1218)] = 69169,
  [SMALL_STATE(1219)] = 69191,
  [SMALL_STATE(1220)] = 69213,
  [SMALL_STATE(1221)] = 69235,
  [SMALL_STATE(1222)] = 69253,
  [SMALL_STATE(1223)] = 69275,
  [SMALL_STATE(1224)] = 69293,
  [SMALL_STATE(1225)] = 69315,
  [SMALL_STATE(1226)] = 69333,
  [SMALL_STATE(1227)] = 69355,
  [SMALL_STATE(1228)] = 69377,
  [SMALL_STATE(1229)] = 69401,
  [SMALL_STATE(1230)] = 69423,
  [SMALL_STATE(1231)] = 69445,
  [SMALL_STATE(1232)] = 69467,
  [SMALL_STATE(1233)] = 69489,
  [SMALL_STATE(1234)] = 69507,
  [SMALL_STATE(1235)] = 69529,
  [SMALL_STATE(1236)] = 69551,
  [SMALL_STATE(1237)] = 69573,
  [SMALL_STATE(1238)] = 69595,
  [SMALL_STATE(1239)] = 69613,
  [SMALL_STATE(1240)] = 69635,
  [SMALL_STATE(1241)] = 69652,
  [SMALL_STATE(1242)] = 69669,
  [SMALL_STATE(1243)] = 69686,
  [SMALL_STATE(1244)] = 69703,
  [SMALL_STATE(1245)] = 69720,
  [SMALL_STATE(1246)] = 69737,
  [SMALL_STATE(1247)] = 69756,
  [SMALL_STATE(1248)] = 69779,
  [SMALL_STATE(1249)] = 69798,
  [SMALL_STATE(1250)] = 69815,
  [SMALL_STATE(1251)] = 69832,
  [SMALL_STATE(1252)] = 69849,
  [SMALL_STATE(1253)] = 69870,
  [SMALL_STATE(1254)] = 69887,
  [SMALL_STATE(1255)] = 69904,
  [SMALL_STATE(1256)] = 69921,
  [SMALL_STATE(1257)] = 69938,
  [SMALL_STATE(1258)] = 69955,
  [SMALL_STATE(1259)] = 69972,
  [SMALL_STATE(1260)] = 69989,
  [SMALL_STATE(1261)] = 70006,
  [SMALL_STATE(1262)] = 70023,
  [SMALL_STATE(1263)] = 70040,
  [SMALL_STATE(1264)] = 70057,
  [SMALL_STATE(1265)] = 70074,
  [SMALL_STATE(1266)] = 70091,
  [SMALL_STATE(1267)] = 70108,
  [SMALL_STATE(1268)] = 70125,
  [SMALL_STATE(1269)] = 70144,
  [SMALL_STATE(1270)] = 70161,
  [SMALL_STATE(1271)] = 70178,
  [SMALL_STATE(1272)] = 70195,
  [SMALL_STATE(1273)] = 70212,
  [SMALL_STATE(1274)] = 70229,
  [SMALL_STATE(1275)] = 70248,
  [SMALL_STATE(1276)] = 70265,
  [SMALL_STATE(1277)] = 70282,
  [SMALL_STATE(1278)] = 70299,
  [SMALL_STATE(1279)] = 70316,
  [SMALL_STATE(1280)] = 70333,
  [SMALL_STATE(1281)] = 70350,
  [SMALL_STATE(1282)] = 70367,
  [SMALL_STATE(1283)] = 70384,
  [SMALL_STATE(1284)] = 70401,
  [SMALL_STATE(1285)] = 70418,
  [SMALL_STATE(1286)] = 70435,
  [SMALL_STATE(1287)] = 70452,
  [SMALL_STATE(1288)] = 70465,
  [SMALL_STATE(1289)] = 70482,
  [SMALL_STATE(1290)] = 70499,
  [SMALL_STATE(1291)] = 70516,
  [SMALL_STATE(1292)] = 70533,
  [SMALL_STATE(1293)] = 70550,
  [SMALL_STATE(1294)] = 70567,
  [SMALL_STATE(1295)] = 70584,
  [SMALL_STATE(1296)] = 70601,
  [SMALL_STATE(1297)] = 70618,
  [SMALL_STATE(1298)] = 70635,
  [SMALL_STATE(1299)] = 70654,
  [SMALL_STATE(1300)] = 70671,
  [SMALL_STATE(1301)] = 70688,
  [SMALL_STATE(1302)] = 70705,
  [SMALL_STATE(1303)] = 70722,
  [SMALL_STATE(1304)] = 70739,
  [SMALL_STATE(1305)] = 70756,
  [SMALL_STATE(1306)] = 70776,
  [SMALL_STATE(1307)] = 70794,
  [SMALL_STATE(1308)] = 70812,
  [SMALL_STATE(1309)] = 70832,
  [SMALL_STATE(1310)] = 70852,
  [SMALL_STATE(1311)] = 70872,
  [SMALL_STATE(1312)] = 70892,
  [SMALL_STATE(1313)] = 70910,
  [SMALL_STATE(1314)] = 70930,
  [SMALL_STATE(1315)] = 70948,
  [SMALL_STATE(1316)] = 70968,
  [SMALL_STATE(1317)] = 70988,
  [SMALL_STATE(1318)] = 71008,
  [SMALL_STATE(1319)] = 71028,
  [SMALL_STATE(1320)] = 71048,
  [SMALL_STATE(1321)] = 71066,
  [SMALL_STATE(1322)] = 71084,
  [SMALL_STATE(1323)] = 71104,
  [SMALL_STATE(1324)] = 71122,
  [SMALL_STATE(1325)] = 71142,
  [SMALL_STATE(1326)] = 71162,
  [SMALL_STATE(1327)] = 71178,
  [SMALL_STATE(1328)] = 71196,
  [SMALL_STATE(1329)] = 71208,
  [SMALL_STATE(1330)] = 71228,
  [SMALL_STATE(1331)] = 71246,
  [SMALL_STATE(1332)] = 71264,
  [SMALL_STATE(1333)] = 71284,
  [SMALL_STATE(1334)] = 71302,
  [SMALL_STATE(1335)] = 71320,
  [SMALL_STATE(1336)] = 71340,
  [SMALL_STATE(1337)] = 71358,
  [SMALL_STATE(1338)] = 71373,
  [SMALL_STATE(1339)] = 71390,
  [SMALL_STATE(1340)] = 71401,
  [SMALL_STATE(1341)] = 71412,
  [SMALL_STATE(1342)] = 71425,
  [SMALL_STATE(1343)] = 71440,
  [SMALL_STATE(1344)] = 71457,
  [SMALL_STATE(1345)] = 71474,
  [SMALL_STATE(1346)] = 71485,
  [SMALL_STATE(1347)] = 71500,
  [SMALL_STATE(1348)] = 71515,
  [SMALL_STATE(1349)] = 71532,
  [SMALL_STATE(1350)] = 71549,
  [SMALL_STATE(1351)] = 71566,
  [SMALL_STATE(1352)] = 71581,
  [SMALL_STATE(1353)] = 71598,
  [SMALL_STATE(1354)] = 71613,
  [SMALL_STATE(1355)] = 71628,
  [SMALL_STATE(1356)] = 71639,
  [SMALL_STATE(1357)] = 71654,
  [SMALL_STATE(1358)] = 71669,
  [SMALL_STATE(1359)] = 71684,
  [SMALL_STATE(1360)] = 71701,
  [SMALL_STATE(1361)] = 71718,
  [SMALL_STATE(1362)] = 71735,
  [SMALL_STATE(1363)] = 71752,
  [SMALL_STATE(1364)] = 71769,
  [SMALL_STATE(1365)] = 71782,
  [SMALL_STATE(1366)] = 71797,
  [SMALL_STATE(1367)] = 71812,
  [SMALL_STATE(1368)] = 71829,
  [SMALL_STATE(1369)] = 71846,
  [SMALL_STATE(1370)] = 71863,
  [SMALL_STATE(1371)] = 71880,
  [SMALL_STATE(1372)] = 71895,
  [SMALL_STATE(1373)] = 71910,
  [SMALL_STATE(1374)] = 71927,
  [SMALL_STATE(1375)] = 71940,
  [SMALL_STATE(1376)] = 71957,
  [SMALL_STATE(1377)] = 71972,
  [SMALL_STATE(1378)] = 71989,
  [SMALL_STATE(1379)] = 72002,
  [SMALL_STATE(1380)] = 72019,
  [SMALL_STATE(1381)] = 72034,
  [SMALL_STATE(1382)] = 72049,
  [SMALL_STATE(1383)] = 72064,
  [SMALL_STATE(1384)] = 72079,
  [SMALL_STATE(1385)] = 72092,
  [SMALL_STATE(1386)] = 72107,
  [SMALL_STATE(1387)] = 72124,
  [SMALL_STATE(1388)] = 72139,
  [SMALL_STATE(1389)] = 72156,
  [SMALL_STATE(1390)] = 72171,
  [SMALL_STATE(1391)] = 72186,
  [SMALL_STATE(1392)] = 72199,
  [SMALL_STATE(1393)] = 72216,
  [SMALL_STATE(1394)] = 72231,
  [SMALL_STATE(1395)] = 72246,
  [SMALL_STATE(1396)] = 72263,
  [SMALL_STATE(1397)] = 72280,
  [SMALL_STATE(1398)] = 72293,
  [SMALL_STATE(1399)] = 72310,
  [SMALL_STATE(1400)] = 72327,
  [SMALL_STATE(1401)] = 72342,
  [SMALL_STATE(1402)] = 72355,
  [SMALL_STATE(1403)] = 72370,
  [SMALL_STATE(1404)] = 72387,
  [SMALL_STATE(1405)] = 72404,
  [SMALL_STATE(1406)] = 72421,
  [SMALL_STATE(1407)] = 72438,
  [SMALL_STATE(1408)] = 72455,
  [SMALL_STATE(1409)] = 72472,
  [SMALL_STATE(1410)] = 72489,
  [SMALL_STATE(1411)] = 72506,
  [SMALL_STATE(1412)] = 72523,
  [SMALL_STATE(1413)] = 72537,
  [SMALL_STATE(1414)] = 72549,
  [SMALL_STATE(1415)] = 72563,
  [SMALL_STATE(1416)] = 72577,
  [SMALL_STATE(1417)] = 72591,
  [SMALL_STATE(1418)] = 72603,
  [SMALL_STATE(1419)] = 72613,
  [SMALL_STATE(1420)] = 72627,
  [SMALL_STATE(1421)] = 72637,
  [SMALL_STATE(1422)] = 72647,
  [SMALL_STATE(1423)] = 72661,
  [SMALL_STATE(1424)] = 72675,
  [SMALL_STATE(1425)] = 72685,
  [SMALL_STATE(1426)] = 72695,
  [SMALL_STATE(1427)] = 72709,
  [SMALL_STATE(1428)] = 72719,
  [SMALL_STATE(1429)] = 72733,
  [SMALL_STATE(1430)] = 72747,
  [SMALL_STATE(1431)] = 72759,
  [SMALL_STATE(1432)] = 72773,
  [SMALL_STATE(1433)] = 72783,
  [SMALL_STATE(1434)] = 72797,
  [SMALL_STATE(1435)] = 72811,
  [SMALL_STATE(1436)] = 72825,
  [SMALL_STATE(1437)] = 72839,
  [SMALL_STATE(1438)] = 72853,
  [SMALL_STATE(1439)] = 72867,
  [SMALL_STATE(1440)] = 72877,
  [SMALL_STATE(1441)] = 72891,
  [SMALL_STATE(1442)] = 72905,
  [SMALL_STATE(1443)] = 72919,
  [SMALL_STATE(1444)] = 72933,
  [SMALL_STATE(1445)] = 72943,
  [SMALL_STATE(1446)] = 72953,
  [SMALL_STATE(1447)] = 72963,
  [SMALL_STATE(1448)] = 72973,
  [SMALL_STATE(1449)] = 72983,
  [SMALL_STATE(1450)] = 72997,
  [SMALL_STATE(1451)] = 73011,
  [SMALL_STATE(1452)] = 73025,
  [SMALL_STATE(1453)] = 73039,
  [SMALL_STATE(1454)] = 73049,
  [SMALL_STATE(1455)] = 73063,
  [SMALL_STATE(1456)] = 73077,
  [SMALL_STATE(1457)] = 73091,
  [SMALL_STATE(1458)] = 73105,
  [SMALL_STATE(1459)] = 73119,
  [SMALL_STATE(1460)] = 73133,
  [SMALL_STATE(1461)] = 73143,
  [SMALL_STATE(1462)] = 73157,
  [SMALL_STATE(1463)] = 73171,
  [SMALL_STATE(1464)] = 73185,
  [SMALL_STATE(1465)] = 73199,
  [SMALL_STATE(1466)] = 73213,
  [SMALL_STATE(1467)] = 73227,
  [SMALL_STATE(1468)] = 73237,
  [SMALL_STATE(1469)] = 73247,
  [SMALL_STATE(1470)] = 73257,
  [SMALL_STATE(1471)] = 73271,
  [SMALL_STATE(1472)] = 73285,
  [SMALL_STATE(1473)] = 73299,
  [SMALL_STATE(1474)] = 73313,
  [SMALL_STATE(1475)] = 73327,
  [SMALL_STATE(1476)] = 73341,
  [SMALL_STATE(1477)] = 73355,
  [SMALL_STATE(1478)] = 73369,
  [SMALL_STATE(1479)] = 73383,
  [SMALL_STATE(1480)] = 73397,
  [SMALL_STATE(1481)] = 73411,
  [SMALL_STATE(1482)] = 73425,
  [SMALL_STATE(1483)] = 73435,
  [SMALL_STATE(1484)] = 73449,
  [SMALL_STATE(1485)] = 73463,
  [SMALL_STATE(1486)] = 73473,
  [SMALL_STATE(1487)] = 73487,
  [SMALL_STATE(1488)] = 73501,
  [SMALL_STATE(1489)] = 73515,
  [SMALL_STATE(1490)] = 73529,
  [SMALL_STATE(1491)] = 73539,
  [SMALL_STATE(1492)] = 73553,
  [SMALL_STATE(1493)] = 73567,
  [SMALL_STATE(1494)] = 73581,
  [SMALL_STATE(1495)] = 73595,
  [SMALL_STATE(1496)] = 73605,
  [SMALL_STATE(1497)] = 73619,
  [SMALL_STATE(1498)] = 73633,
  [SMALL_STATE(1499)] = 73647,
  [SMALL_STATE(1500)] = 73661,
  [SMALL_STATE(1501)] = 73671,
  [SMALL_STATE(1502)] = 73682,
  [SMALL_STATE(1503)] = 73693,
  [SMALL_STATE(1504)] = 73704,
  [SMALL_STATE(1505)] = 73715,
  [SMALL_STATE(1506)] = 73726,
  [SMALL_STATE(1507)] = 73737,
  [SMALL_STATE(1508)] = 73748,
  [SMALL_STATE(1509)] = 73759,
  [SMALL_STATE(1510)] = 73770,
  [SMALL_STATE(1511)] = 73781,
  [SMALL_STATE(1512)] = 73792,
  [SMALL_STATE(1513)] = 73803,
  [SMALL_STATE(1514)] = 73814,
  [SMALL_STATE(1515)] = 73825,
  [SMALL_STATE(1516)] = 73836,
  [SMALL_STATE(1517)] = 73847,
  [SMALL_STATE(1518)] = 73858,
  [SMALL_STATE(1519)] = 73869,
  [SMALL_STATE(1520)] = 73880,
  [SMALL_STATE(1521)] = 73891,
  [SMALL_STATE(1522)] = 73902,
  [SMALL_STATE(1523)] = 73913,
  [SMALL_STATE(1524)] = 73924,
  [SMALL_STATE(1525)] = 73935,
  [SMALL_STATE(1526)] = 73946,
  [SMALL_STATE(1527)] = 73957,
  [SMALL_STATE(1528)] = 73968,
  [SMALL_STATE(1529)] = 73979,
  [SMALL_STATE(1530)] = 73990,
  [SMALL_STATE(1531)] = 73999,
  [SMALL_STATE(1532)] = 74010,
  [SMALL_STATE(1533)] = 74021,
  [SMALL_STATE(1534)] = 74030,
  [SMALL_STATE(1535)] = 74039,
  [SMALL_STATE(1536)] = 74050,
  [SMALL_STATE(1537)] = 74061,
  [SMALL_STATE(1538)] = 74072,
  [SMALL_STATE(1539)] = 74083,
  [SMALL_STATE(1540)] = 74092,
  [SMALL_STATE(1541)] = 74103,
  [SMALL_STATE(1542)] = 74114,
  [SMALL_STATE(1543)] = 74125,
  [SMALL_STATE(1544)] = 74136,
  [SMALL_STATE(1545)] = 74147,
  [SMALL_STATE(1546)] = 74158,
  [SMALL_STATE(1547)] = 74169,
  [SMALL_STATE(1548)] = 74180,
  [SMALL_STATE(1549)] = 74191,
  [SMALL_STATE(1550)] = 74202,
  [SMALL_STATE(1551)] = 74213,
  [SMALL_STATE(1552)] = 74224,
  [SMALL_STATE(1553)] = 74235,
  [SMALL_STATE(1554)] = 74246,
  [SMALL_STATE(1555)] = 74257,
  [SMALL_STATE(1556)] = 74268,
  [SMALL_STATE(1557)] = 74279,
  [SMALL_STATE(1558)] = 74290,
  [SMALL_STATE(1559)] = 74301,
  [SMALL_STATE(1560)] = 74312,
  [SMALL_STATE(1561)] = 74323,
  [SMALL_STATE(1562)] = 74334,
  [SMALL_STATE(1563)] = 74343,
  [SMALL_STATE(1564)] = 74354,
  [SMALL_STATE(1565)] = 74365,
  [SMALL_STATE(1566)] = 74376,
  [SMALL_STATE(1567)] = 74387,
  [SMALL_STATE(1568)] = 74398,
  [SMALL_STATE(1569)] = 74409,
  [SMALL_STATE(1570)] = 74420,
  [SMALL_STATE(1571)] = 74429,
  [SMALL_STATE(1572)] = 74440,
  [SMALL_STATE(1573)] = 74451,
  [SMALL_STATE(1574)] = 74462,
  [SMALL_STATE(1575)] = 74473,
  [SMALL_STATE(1576)] = 74484,
  [SMALL_STATE(1577)] = 74493,
  [SMALL_STATE(1578)] = 74504,
  [SMALL_STATE(1579)] = 74515,
  [SMALL_STATE(1580)] = 74526,
  [SMALL_STATE(1581)] = 74537,
  [SMALL_STATE(1582)] = 74548,
  [SMALL_STATE(1583)] = 74559,
  [SMALL_STATE(1584)] = 74570,
  [SMALL_STATE(1585)] = 74581,
  [SMALL_STATE(1586)] = 74592,
  [SMALL_STATE(1587)] = 74603,
  [SMALL_STATE(1588)] = 74614,
  [SMALL_STATE(1589)] = 74625,
  [SMALL_STATE(1590)] = 74636,
  [SMALL_STATE(1591)] = 74647,
  [SMALL_STATE(1592)] = 74658,
  [SMALL_STATE(1593)] = 74669,
  [SMALL_STATE(1594)] = 74677,
  [SMALL_STATE(1595)] = 74685,
  [SMALL_STATE(1596)] = 74693,
  [SMALL_STATE(1597)] = 74701,
  [SMALL_STATE(1598)] = 74709,
  [SMALL_STATE(1599)] = 74717,
  [SMALL_STATE(1600)] = 74725,
  [SMALL_STATE(1601)] = 74733,
  [SMALL_STATE(1602)] = 74741,
  [SMALL_STATE(1603)] = 74749,
  [SMALL_STATE(1604)] = 74757,
  [SMALL_STATE(1605)] = 74765,
  [SMALL_STATE(1606)] = 74773,
  [SMALL_STATE(1607)] = 74781,
  [SMALL_STATE(1608)] = 74789,
  [SMALL_STATE(1609)] = 74797,
  [SMALL_STATE(1610)] = 74805,
  [SMALL_STATE(1611)] = 74813,
  [SMALL_STATE(1612)] = 74821,
  [SMALL_STATE(1613)] = 74829,
  [SMALL_STATE(1614)] = 74837,
  [SMALL_STATE(1615)] = 74845,
  [SMALL_STATE(1616)] = 74853,
  [SMALL_STATE(1617)] = 74861,
  [SMALL_STATE(1618)] = 74869,
  [SMALL_STATE(1619)] = 74877,
  [SMALL_STATE(1620)] = 74885,
  [SMALL_STATE(1621)] = 74893,
  [SMALL_STATE(1622)] = 74901,
  [SMALL_STATE(1623)] = 74909,
  [SMALL_STATE(1624)] = 74917,
  [SMALL_STATE(1625)] = 74925,
  [SMALL_STATE(1626)] = 74933,
  [SMALL_STATE(1627)] = 74941,
  [SMALL_STATE(1628)] = 74949,
  [SMALL_STATE(1629)] = 74957,
  [SMALL_STATE(1630)] = 74965,
  [SMALL_STATE(1631)] = 74973,
  [SMALL_STATE(1632)] = 74981,
  [SMALL_STATE(1633)] = 74989,
  [SMALL_STATE(1634)] = 74997,
  [SMALL_STATE(1635)] = 75005,
  [SMALL_STATE(1636)] = 75013,
  [SMALL_STATE(1637)] = 75021,
  [SMALL_STATE(1638)] = 75029,
  [SMALL_STATE(1639)] = 75037,
  [SMALL_STATE(1640)] = 75045,
  [SMALL_STATE(1641)] = 75053,
  [SMALL_STATE(1642)] = 75061,
  [SMALL_STATE(1643)] = 75069,
  [SMALL_STATE(1644)] = 75077,
  [SMALL_STATE(1645)] = 75085,
  [SMALL_STATE(1646)] = 75093,
  [SMALL_STATE(1647)] = 75101,
  [SMALL_STATE(1648)] = 75109,
  [SMALL_STATE(1649)] = 75117,
  [SMALL_STATE(1650)] = 75125,
  [SMALL_STATE(1651)] = 75133,
  [SMALL_STATE(1652)] = 75141,
  [SMALL_STATE(1653)] = 75149,
  [SMALL_STATE(1654)] = 75157,
  [SMALL_STATE(1655)] = 75165,
  [SMALL_STATE(1656)] = 75173,
  [SMALL_STATE(1657)] = 75181,
  [SMALL_STATE(1658)] = 75189,
  [SMALL_STATE(1659)] = 75197,
  [SMALL_STATE(1660)] = 75205,
  [SMALL_STATE(1661)] = 75213,
  [SMALL_STATE(1662)] = 75221,
  [SMALL_STATE(1663)] = 75229,
  [SMALL_STATE(1664)] = 75237,
  [SMALL_STATE(1665)] = 75245,
  [SMALL_STATE(1666)] = 75253,
  [SMALL_STATE(1667)] = 75261,
  [SMALL_STATE(1668)] = 75269,
  [SMALL_STATE(1669)] = 75277,
  [SMALL_STATE(1670)] = 75285,
  [SMALL_STATE(1671)] = 75293,
  [SMALL_STATE(1672)] = 75301,
  [SMALL_STATE(1673)] = 75309,
  [SMALL_STATE(1674)] = 75317,
  [SMALL_STATE(1675)] = 75325,
  [SMALL_STATE(1676)] = 75333,
  [SMALL_STATE(1677)] = 75341,
  [SMALL_STATE(1678)] = 75349,
  [SMALL_STATE(1679)] = 75357,
  [SMALL_STATE(1680)] = 75365,
  [SMALL_STATE(1681)] = 75373,
  [SMALL_STATE(1682)] = 75381,
  [SMALL_STATE(1683)] = 75389,
  [SMALL_STATE(1684)] = 75397,
  [SMALL_STATE(1685)] = 75405,
  [SMALL_STATE(1686)] = 75413,
  [SMALL_STATE(1687)] = 75421,
  [SMALL_STATE(1688)] = 75429,
  [SMALL_STATE(1689)] = 75437,
  [SMALL_STATE(1690)] = 75445,
  [SMALL_STATE(1691)] = 75453,
  [SMALL_STATE(1692)] = 75461,
  [SMALL_STATE(1693)] = 75469,
  [SMALL_STATE(1694)] = 75477,
  [SMALL_STATE(1695)] = 75485,
  [SMALL_STATE(1696)] = 75493,
  [SMALL_STATE(1697)] = 75501,
  [SMALL_STATE(1698)] = 75509,
  [SMALL_STATE(1699)] = 75517,
  [SMALL_STATE(1700)] = 75525,
  [SMALL_STATE(1701)] = 75533,
  [SMALL_STATE(1702)] = 75541,
  [SMALL_STATE(1703)] = 75549,
  [SMALL_STATE(1704)] = 75557,
  [SMALL_STATE(1705)] = 75565,
  [SMALL_STATE(1706)] = 75573,
  [SMALL_STATE(1707)] = 75581,
  [SMALL_STATE(1708)] = 75589,
  [SMALL_STATE(1709)] = 75597,
  [SMALL_STATE(1710)] = 75605,
  [SMALL_STATE(1711)] = 75613,
  [SMALL_STATE(1712)] = 75621,
  [SMALL_STATE(1713)] = 75629,
  [SMALL_STATE(1714)] = 75637,
  [SMALL_STATE(1715)] = 75645,
  [SMALL_STATE(1716)] = 75653,
  [SMALL_STATE(1717)] = 75661,
  [SMALL_STATE(1718)] = 75669,
  [SMALL_STATE(1719)] = 75677,
  [SMALL_STATE(1720)] = 75685,
  [SMALL_STATE(1721)] = 75693,
  [SMALL_STATE(1722)] = 75701,
  [SMALL_STATE(1723)] = 75709,
  [SMALL_STATE(1724)] = 75717,
  [SMALL_STATE(1725)] = 75725,
  [SMALL_STATE(1726)] = 75733,
  [SMALL_STATE(1727)] = 75741,
  [SMALL_STATE(1728)] = 75749,
  [SMALL_STATE(1729)] = 75757,
  [SMALL_STATE(1730)] = 75765,
  [SMALL_STATE(1731)] = 75773,
  [SMALL_STATE(1732)] = 75781,
  [SMALL_STATE(1733)] = 75789,
  [SMALL_STATE(1734)] = 75797,
  [SMALL_STATE(1735)] = 75805,
  [SMALL_STATE(1736)] = 75813,
  [SMALL_STATE(1737)] = 75821,
  [SMALL_STATE(1738)] = 75829,
  [SMALL_STATE(1739)] = 75837,
  [SMALL_STATE(1740)] = 75845,
  [SMALL_STATE(1741)] = 75853,
  [SMALL_STATE(1742)] = 75861,
  [SMALL_STATE(1743)] = 75869,
  [SMALL_STATE(1744)] = 75877,
  [SMALL_STATE(1745)] = 75885,
  [SMALL_STATE(1746)] = 75893,
  [SMALL_STATE(1747)] = 75901,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [97] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 80),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 80),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(184),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1637),
  [141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(521),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1192),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1285),
  [150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(935),
  [153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(937),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1328),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1188),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1187),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1658),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1320),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1685),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1627),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1190),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1256),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1505),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1558),
  [194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1713),
  [199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1743),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1506),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(113),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1507),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1515),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1516),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1518),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(944),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(931),
  [226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1705),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(956),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(956),
  [235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1734),
  [238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(997),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(975),
  [244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1030),
  [247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1353),
  [250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1354),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, .production_id = 65),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, .production_id = 65),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 64),
  [259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 64),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(186),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1661),
  [329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(617),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1191),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1249),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1668),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1306),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1691),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1294),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1526),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1525),
  [359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1718),
  [362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1728),
  [365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1514),
  [368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(92),
  [371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1513),
  [374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1512),
  [377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1511),
  [380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1510),
  [383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(941),
  [386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(940),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 61),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 6, .production_id = 61),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 61),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 6, .production_id = 61),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, .production_id = 77),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 7, .production_id = 77),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, .production_id = 77),
  [465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 7, .production_id = 77),
  [467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 45),
  [473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 5, .production_id = 45),
  [475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 45),
  [477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 5, .production_id = 45),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 62),
  [485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 6, .production_id = 62),
  [487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 62),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 6, .production_id = 62),
  [491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_attribut, 1),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 1),
  [511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 1),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 13),
  [519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 13),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1727),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 84),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 84),
  [538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_data_type, 3),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_data_type, 3),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1616),
  [545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 101),
  [547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 101),
  [549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__data_type, 1),
  [551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data_type, 1),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_any_type, 1),
  [559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_any_type, 1),
  [561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 8),
  [563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 8),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 99),
  [569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 99),
  [571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 114),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 114),
  [575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_each_in_statement, 8, .production_id = 97),
  [577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_each_in_statement, 8, .production_id = 97),
  [579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 100),
  [581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 100),
  [583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, .production_id = 108),
  [585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, .production_id = 108),
  [587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, .production_id = 102),
  [589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, .production_id = 102),
  [591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, .production_id = 103),
  [593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, .production_id = 103),
  [595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 104),
  [597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 104),
  [599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, .production_id = 105),
  [601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, .production_id = 105),
  [603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, .production_id = 106),
  [605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, .production_id = 106),
  [607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, .production_id = 107),
  [609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, .production_id = 107),
  [611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 8, .production_id = 109),
  [613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 8, .production_id = 109),
  [615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 8, .production_id = 98),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 8, .production_id = 98),
  [619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 8, .production_id = 97),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 8, .production_id = 97),
  [623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, .production_id = 96),
  [625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, .production_id = 96),
  [627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, .production_id = 94),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, .production_id = 94),
  [631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 93),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 93),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 110),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 110),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 92),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 92),
  [643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 91),
  [645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 91),
  [647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 7, .production_id = 90),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 7, .production_id = 90),
  [651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 7, .production_id = 90),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 7, .production_id = 90),
  [655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 89),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 89),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 7, .production_id = 88),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 7, .production_id = 88),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, .production_id = 87),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, .production_id = 87),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 86),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 86),
  [671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 9, .production_id = 113),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 9, .production_id = 113),
  [675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 85),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 85),
  [679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_each_in_statement, 7, .production_id = 81),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_each_in_statement, 7, .production_id = 81),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 83),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 83),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 82),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 82),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_each_in_statement, 8, .production_id = 98),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_each_in_statement, 8, .production_id = 98),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 7, .production_id = 81),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 7, .production_id = 81),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, .production_id = 79),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, .production_id = 79),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, .production_id = 78),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, .production_id = 78),
  [707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 74),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 74),
  [711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 73),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 73),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 72),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 72),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 6, .production_id = 71),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 6, .production_id = 71),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 53),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 53),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 6, .production_id = 68),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 6, .production_id = 68),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 70),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 70),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 69),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 69),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 6, .production_id = 68),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 6, .production_id = 68),
  [743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 67),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 67),
  [747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 66),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 66),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 6, .production_id = 46),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 6, .production_id = 46),
  [755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 10, .production_id = 128),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 10, .production_id = 128),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 63),
  [761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 63),
  [763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 56),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 56),
  [767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 55),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 55),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 54),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 54),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 5, .production_id = 53),
  [777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 5, .production_id = 53),
  [779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 5, .production_id = 53),
  [781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 5, .production_id = 53),
  [783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 5, .production_id = 52),
  [785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 5, .production_id = 52),
  [787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 34),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 34),
  [791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_data_type, 5, .production_id = 49),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_data_type, 5, .production_id = 49),
  [795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 48),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 48),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 5, .production_id = 26),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 5, .production_id = 26),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 39),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 39),
  [815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 38),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 38),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 37),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 37),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 5, .production_id = 26),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 5, .production_id = 26),
  [827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, .production_id = 36),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, .production_id = 36),
  [831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 4, .production_id = 34),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 4, .production_id = 34),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 35),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 35),
  [839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 4, .production_id = 34),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 4, .production_id = 34),
  [843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_data_type, 4, .production_id = 31),
  [845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_data_type, 4, .production_id = 31),
  [847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 28),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 28),
  [851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 1),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 1),
  [855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 27),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 27),
  [863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 4, .production_id = 7),
  [865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 4, .production_id = 7),
  [867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 2),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 2),
  [871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3, .production_id = 21),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, .production_id = 21),
  [875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 17),
  [877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 17),
  [879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 14),
  [889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 14),
  [891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 14),
  [893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 14),
  [895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 12),
  [897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 12),
  [899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 11),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 11),
  [903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 10),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 10),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 9),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 9),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 3, .production_id = 2),
  [917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 3, .production_id = 2),
  [919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 6),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 6),
  [923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 3, .production_id = 6),
  [925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 3, .production_id = 6),
  [927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 3, .production_id = 2),
  [929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 3, .production_id = 2),
  [931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, .production_id = 4),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, .production_id = 4),
  [939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 2, .production_id = 1),
  [957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 2, .production_id = 1),
  [959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_each_in_statement, 9, .production_id = 113),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_each_in_statement, 9, .production_id = 113),
  [971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 9, .production_id = 115),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 9, .production_id = 115),
  [975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, .production_id = 116),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, .production_id = 116),
  [979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 9, .production_id = 117),
  [981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 9, .production_id = 117),
  [983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 9, .production_id = 118),
  [985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 9, .production_id = 118),
  [987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 9, .production_id = 119),
  [989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 9, .production_id = 119),
  [991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 9, .production_id = 120),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 9, .production_id = 120),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 9, .production_id = 121),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 9, .production_id = 121),
  [999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, .production_id = 122),
  [1001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, .production_id = 122),
  [1003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 10, .production_id = 126),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 10, .production_id = 126),
  [1007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 10, .production_id = 127),
  [1009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 10, .production_id = 127),
  [1011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 2),
  [1013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 2),
  [1015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(1260),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [1020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [1032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [1042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 32),
  [1048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 32),
  [1050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 20),
  [1052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 20),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [1056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1004),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator, 2, .production_id = 2),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(976),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(979),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(952),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1018),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(982),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [1116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(1649),
  [1119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(998),
  [1122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(1181),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 15),
  [1141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 15),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_xml, 3),
  [1147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_xml, 3),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_expression, 3, .production_id = 20),
  [1193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_expression, 3, .production_id = 20),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 3),
  [1199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 3),
  [1201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_descendant_expression, 3, .production_id = 20),
  [1203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_descendant_expression, 3, .production_id = 20),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 3),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 3),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 3),
  [1211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 3),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [1215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [1217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [1219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [1221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 5, .production_id = 44),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 5, .production_id = 44),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_xml, 6),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_xml, 6),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector, 4, .production_id = 29),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector, 4, .production_id = 29),
  [1237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_xml, 4),
  [1239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_xml, 4),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 5, .production_id = 40),
  [1243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 5, .production_id = 40),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [1247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_xml, 7),
  [1251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_xml, 7),
  [1253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 4, .production_id = 23),
  [1255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 4, .production_id = 23),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 30),
  [1259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 30),
  [1261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 19),
  [1267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 19),
  [1269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 5, .production_id = 50),
  [1271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 5, .production_id = 50),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 51),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 51),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 6, .production_id = 60),
  [1283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 6, .production_id = 60),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 33),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 33),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_xml, 8),
  [1291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_xml, 8),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 18),
  [1295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 18),
  [1297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 16),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 16),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [1311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [1313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [1319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [1329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 4, .production_id = 59),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 16),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 3, .production_id = 41),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 22), SHIFT(938),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 22),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator, 4, .production_id = 26),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator, 5, .production_id = 46),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 4, .production_id = 75),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 5, .production_id = 95),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [1506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [1508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [1522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_namespace_declaration_repeat1, 2),
  [1524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(1675),
  [1527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 6),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 6),
  [1531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 4),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 4),
  [1535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 7),
  [1537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 7),
  [1539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3),
  [1541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3),
  [1543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 8),
  [1545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 8),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [1553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [1559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_attribut, 1),
  [1561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class_attribut, 1), REDUCE(sym_property_attribut, 1),
  [1564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_attribut, 1),
  [1566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_namespace_declaration_repeat2, 2), SHIFT_REPEAT(1190),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_namespace_declaration_repeat2, 2),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2),
  [1657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2), SHIFT_REPEAT(1328),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_declaration_repeat1, 2), SHIFT_REPEAT(1675),
  [1685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_declaration_repeat1, 2),
  [1687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_declaration_repeat1, 2), SHIFT_REPEAT(1383),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [1700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(987),
  [1703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(1695),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [1708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 1),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_hint, 2, .production_id = 24),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [1802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_xml_repeat1, 2), SHIFT_REPEAT(1612),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_xml_repeat1, 2),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [1811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_attribut, 1),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 2),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor, 1),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [1845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator, 3, .production_id = 7),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [1849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 2, .production_id = 24),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [1927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2), SHIFT_REPEAT(1007),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [1942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_xml_repeat2, 2), SHIFT_REPEAT(1708),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_xml_repeat2, 2),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [1967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(1400),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [1972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [1974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1402),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat2, 2),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 9, .production_id = 132),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, .production_id = 131),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, .production_id = 130),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 3, .production_id = 58),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 4, .production_id = 57),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, .production_id = 129),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [2043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 53),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 125),
  [2047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_xml_attribute, 3),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 124),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 123),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 47),
  [2063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 47), SHIFT_REPEAT(1582),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_repeat2, 2), SHIFT_REPEAT(1649),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 34),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [2085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 2, .production_id = 43), SHIFT_REPEAT(1470),
  [2088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 2, .production_id = 43),
  [2090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1252),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [2095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 3, .production_id = 42),
  [2097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 112),
  [2099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 111),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 2, .production_id = 25),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [2123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 2),
  [2125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(1301),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 5, .production_id = 76),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest, 2),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat2, 6),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [2216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat2, 5),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 21),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2436] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [2522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_actionscript(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
