#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2582
#define LARGE_STATE_COUNT 128
#define SYMBOL_COUNT 316
#define ALIAS_COUNT 5
#define TOKEN_COUNT 149
#define EXTERNAL_TOKEN_COUNT 13
#define FIELD_COUNT 27
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 102

enum ts_symbol_identifiers {
  aux_sym_recipe_token1 = 1,
  anon_sym_NULL = 2,
  anon_sym_EQ = 3,
  anon_sym_QMARK_EQ = 4,
  anon_sym_QMARK_QMARK_EQ = 5,
  anon_sym_COLON_EQ = 6,
  anon_sym_PLUS_EQ = 7,
  anon_sym_EQ_PLUS = 8,
  anon_sym_DOT_EQ = 9,
  anon_sym_EQ_DOT = 10,
  anon_sym_LBRACK = 11,
  anon_sym_noexec = 12,
  aux_sym_variable_flag_token1 = 13,
  anon_sym_RBRACK = 14,
  anon_sym_COLON = 15,
  anon_sym_append = 16,
  anon_sym_prepend = 17,
  anon_sym_remove = 18,
  anon_sym_unset = 19,
  anon_sym_inherit = 20,
  sym_inherit_path = 21,
  anon_sym_INHERIT = 22,
  anon_sym_DQUOTE = 23,
  anon_sym_include = 24,
  aux_sym_include_directive_token1 = 25,
  anon_sym_require = 26,
  anon_sym_export = 27,
  anon_sym_OVERRIDES = 28,
  anon_sym_EXPORT_FUNCTIONS = 29,
  anon_sym_addtask = 30,
  anon_sym_after = 31,
  anon_sym_before = 32,
  anon_sym_deltask = 33,
  anon_sym_addhandler = 34,
  anon_sym_fakeroot = 35,
  anon_sym_python = 36,
  anon_sym_LPAREN = 37,
  anon_sym_RPAREN = 38,
  anon_sym_LBRACE = 39,
  anon_sym_RBRACE = 40,
  aux_sym_string_token1 = 41,
  aux_sym_string_token2 = 42,
  anon_sym_DOLLARBB_ENV_PASSTHROUGH = 43,
  anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS = 44,
  anon_sym_DOLLAR = 45,
  anon_sym_SQUOTE = 46,
  aux_sym_string_token3 = 47,
  aux_sym_string_token4 = 48,
  anon_sym_DOLLAR_LBRACE_AT = 49,
  anon_sym_DOLLAR_LBRACE = 50,
  anon_sym_def = 51,
  anon_sym_DASH_GT = 52,
  anon_sym_SEMI = 53,
  anon_sym_import = 54,
  anon_sym_DOT = 55,
  anon_sym_from = 56,
  anon_sym___future__ = 57,
  anon_sym_COMMA = 58,
  anon_sym_as = 59,
  anon_sym_STAR = 60,
  anon_sym_print = 61,
  anon_sym_GT_GT = 62,
  anon_sym_assert = 63,
  anon_sym_return = 64,
  anon_sym_del = 65,
  anon_sym_raise = 66,
  anon_sym_pass = 67,
  anon_sym_break = 68,
  anon_sym_continue = 69,
  anon_sym_global = 70,
  anon_sym_nonlocal = 71,
  anon_sym_exec = 72,
  anon_sym_in = 73,
  anon_sym_if = 74,
  anon_sym_elif = 75,
  anon_sym_else = 76,
  anon_sym_async = 77,
  anon_sym_for = 78,
  anon_sym_while = 79,
  anon_sym_try = 80,
  anon_sym_except = 81,
  anon_sym_except_STAR = 82,
  anon_sym_finally = 83,
  anon_sym_with = 84,
  anon_sym_not = 85,
  anon_sym_and = 86,
  anon_sym_or = 87,
  anon_sym_PLUS = 88,
  anon_sym_DASH = 89,
  anon_sym_AT = 90,
  anon_sym_SLASH = 91,
  anon_sym_PERCENT = 92,
  anon_sym_SLASH_SLASH = 93,
  anon_sym_STAR_STAR = 94,
  anon_sym_PIPE = 95,
  anon_sym_AMP = 96,
  anon_sym_CARET = 97,
  anon_sym_LT_LT = 98,
  anon_sym_TILDE = 99,
  anon_sym_LT = 100,
  anon_sym_LT_EQ = 101,
  anon_sym_EQ_EQ = 102,
  anon_sym_BANG_EQ = 103,
  anon_sym_GT_EQ = 104,
  anon_sym_GT = 105,
  anon_sym_LT_GT = 106,
  anon_sym_is = 107,
  anon_sym_lambda = 108,
  anon_sym_DASH_EQ = 109,
  anon_sym_STAR_EQ = 110,
  anon_sym_SLASH_EQ = 111,
  anon_sym_AT_EQ = 112,
  anon_sym_SLASH_SLASH_EQ = 113,
  anon_sym_PERCENT_EQ = 114,
  anon_sym_STAR_STAR_EQ = 115,
  anon_sym_GT_GT_EQ = 116,
  anon_sym_LT_LT_EQ = 117,
  anon_sym_AMP_EQ = 118,
  anon_sym_CARET_EQ = 119,
  anon_sym_PIPE_EQ = 120,
  anon_sym_yield = 121,
  sym_ellipsis = 122,
  sym_escape_sequence = 123,
  sym__not_escape_sequence = 124,
  aux_sym_format_specifier_token1 = 125,
  sym_type_conversion = 126,
  anon_sym_await = 127,
  anon_sym_match = 128,
  anon_sym_type = 129,
  sym_integer = 130,
  sym_float = 131,
  sym_true = 132,
  sym_false = 133,
  sym_none = 134,
  sym_python_identifier = 135,
  sym_line_continuation = 136,
  sym_identifier = 137,
  aux_sym__dotted_identifier_token1 = 138,
  sym_comment = 139,
  sym__concat = 140,
  sym__newline = 141,
  sym__indent = 142,
  sym__dedent = 143,
  sym_string_start = 144,
  sym__string_content = 145,
  sym_escape_interpolation = 146,
  sym_string_end = 147,
  sym_shell_content = 148,
  sym_recipe = 149,
  sym_variable_assignment = 150,
  sym_variable_flag = 151,
  sym_override = 152,
  sym_unset_statement = 153,
  sym_inherit_directive = 154,
  sym_include_directive = 155,
  sym_require_directive = 156,
  sym_export_statement = 157,
  sym_overrides_statement = 158,
  sym_export_functions_statement = 159,
  sym_addtask_statement = 160,
  sym_deltask_statement = 161,
  sym_addhandler_statement = 162,
  sym_anonymous_python_function = 163,
  sym_function_definition = 164,
  sym_literal = 165,
  sym_string = 166,
  sym_inline_python = 167,
  sym_variable_expansion = 168,
  sym_python_function_definition = 169,
  sym__statement = 170,
  sym__simple_statements = 171,
  sym_import_statement = 172,
  sym_import_prefix = 173,
  sym_relative_import = 174,
  sym_future_import_statement = 175,
  sym_import_from_statement = 176,
  sym__import_list = 177,
  sym_aliased_import = 178,
  sym_wildcard_import = 179,
  sym_print_statement = 180,
  sym_chevron = 181,
  sym_assert_statement = 182,
  sym_expression_statement = 183,
  sym_named_expression = 184,
  sym__named_expression_lhs = 185,
  sym_return_statement = 186,
  sym_delete_statement = 187,
  sym_raise_statement = 188,
  sym_pass_statement = 189,
  sym_break_statement = 190,
  sym_continue_statement = 191,
  sym_global_statement = 192,
  sym_nonlocal_statement = 193,
  sym_exec_statement = 194,
  sym_type_parameter = 195,
  sym_parenthesized_list_splat = 196,
  sym_argument_list = 197,
  sym_if_statement = 198,
  sym_elif_clause = 199,
  sym_else_clause = 200,
  sym_for_statement = 201,
  sym_while_statement = 202,
  sym_try_statement = 203,
  sym_except_clause = 204,
  sym_except_group_clause = 205,
  sym_finally_clause = 206,
  sym_with_statement = 207,
  sym_with_clause = 208,
  sym_with_item = 209,
  sym_dotted_name = 210,
  sym_not_operator = 211,
  sym_boolean_operator = 212,
  sym_binary_operator = 213,
  sym_unary_operator = 214,
  sym_comparison_operator = 215,
  sym_lambda = 216,
  sym_lambda_within_for_in_clause = 217,
  sym_assignment = 218,
  sym_augmented_assignment = 219,
  sym_pattern_list = 220,
  sym__right_hand_side = 221,
  sym_yield = 222,
  sym_attribute = 223,
  sym_subscript = 224,
  sym_slice = 225,
  sym_call = 226,
  sym_generator_expression = 227,
  sym__comprehension_clauses = 228,
  sym_parenthesized_expression = 229,
  sym__collection_elements = 230,
  sym_for_in_clause = 231,
  sym_if_clause = 232,
  sym_block = 233,
  sym_expression_list = 234,
  sym_parameters = 235,
  sym_lambda_parameters = 236,
  sym_list_splat = 237,
  sym_dictionary_splat = 238,
  sym__parameters = 239,
  sym__patterns = 240,
  sym_parameter = 241,
  sym_pattern = 242,
  sym_tuple_pattern = 243,
  sym_list_pattern = 244,
  sym_default_parameter = 245,
  sym_typed_default_parameter = 246,
  sym_list_splat_pattern = 247,
  sym_dictionary_splat_pattern = 248,
  sym_as_pattern = 249,
  sym__expression_within_for_in_clause = 250,
  sym_expression = 251,
  sym_primary_expression = 252,
  sym_typed_parameter = 253,
  sym_type = 254,
  sym_splat_type = 255,
  sym_generic_type = 256,
  sym_union_type = 257,
  sym_constrained_type = 258,
  sym_member_type = 259,
  sym_keyword_argument = 260,
  sym_list = 261,
  sym_set = 262,
  sym_tuple = 263,
  sym_dictionary = 264,
  sym_pair = 265,
  sym_list_comprehension = 266,
  sym_dictionary_comprehension = 267,
  sym_set_comprehension = 268,
  sym_conditional_expression = 269,
  sym_concatenated_string = 270,
  sym_python_string = 271,
  sym_string_content = 272,
  sym_interpolation = 273,
  sym__f_expression = 274,
  sym_format_specifier = 275,
  sym_await = 276,
  sym_positional_separator = 277,
  sym_keyword_separator = 278,
  sym_concatenation = 279,
  aux_sym_recipe_repeat1 = 280,
  aux_sym_override_repeat1 = 281,
  aux_sym_inherit_directive_repeat1 = 282,
  aux_sym_include_directive_repeat1 = 283,
  aux_sym_overrides_statement_repeat1 = 284,
  aux_sym_export_functions_statement_repeat1 = 285,
  aux_sym_function_definition_repeat1 = 286,
  aux_sym_string_repeat1 = 287,
  aux_sym_string_repeat2 = 288,
  aux_sym__simple_statements_repeat1 = 289,
  aux_sym_import_prefix_repeat1 = 290,
  aux_sym__import_list_repeat1 = 291,
  aux_sym_print_statement_repeat1 = 292,
  aux_sym_assert_statement_repeat1 = 293,
  aux_sym_global_statement_repeat1 = 294,
  aux_sym_type_parameter_repeat1 = 295,
  aux_sym_argument_list_repeat1 = 296,
  aux_sym_if_statement_repeat1 = 297,
  aux_sym_try_statement_repeat1 = 298,
  aux_sym_try_statement_repeat2 = 299,
  aux_sym_with_clause_repeat1 = 300,
  aux_sym_dotted_name_repeat1 = 301,
  aux_sym_comparison_operator_repeat1 = 302,
  aux_sym_pattern_list_repeat1 = 303,
  aux_sym_subscript_repeat1 = 304,
  aux_sym__comprehension_clauses_repeat1 = 305,
  aux_sym__collection_elements_repeat1 = 306,
  aux_sym_for_in_clause_repeat1 = 307,
  aux_sym_block_repeat1 = 308,
  aux_sym__parameters_repeat1 = 309,
  aux_sym_dictionary_repeat1 = 310,
  aux_sym_concatenated_string_repeat1 = 311,
  aux_sym_python_string_repeat1 = 312,
  aux_sym_string_content_repeat1 = 313,
  aux_sym_format_specifier_repeat1 = 314,
  aux_sym_concatenation_repeat1 = 315,
  alias_sym_as_pattern_target = 316,
  alias_sym_format_expression = 317,
  alias_sym_include_path = 318,
  anon_alias_sym_isnot = 319,
  anon_alias_sym_notin = 320,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [aux_sym_recipe_token1] = "recipe_token1",
  [anon_sym_NULL] = "\0",
  [anon_sym_EQ] = "=",
  [anon_sym_QMARK_EQ] = "\?=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_EQ_PLUS] = "=+",
  [anon_sym_DOT_EQ] = ".=",
  [anon_sym_EQ_DOT] = "=.",
  [anon_sym_LBRACK] = "[",
  [anon_sym_noexec] = "noexec",
  [aux_sym_variable_flag_token1] = "flag",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON] = ":",
  [anon_sym_append] = "append",
  [anon_sym_prepend] = "prepend",
  [anon_sym_remove] = "remove",
  [anon_sym_unset] = "unset",
  [anon_sym_inherit] = "inherit",
  [sym_inherit_path] = "inherit_path",
  [anon_sym_INHERIT] = "INHERIT",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_include] = "include",
  [aux_sym_include_directive_token1] = "include_directive_token1",
  [anon_sym_require] = "require",
  [anon_sym_export] = "export",
  [anon_sym_OVERRIDES] = "OVERRIDES",
  [anon_sym_EXPORT_FUNCTIONS] = "EXPORT_FUNCTIONS",
  [anon_sym_addtask] = "addtask",
  [anon_sym_after] = "after",
  [anon_sym_before] = "before",
  [anon_sym_deltask] = "deltask",
  [anon_sym_addhandler] = "addhandler",
  [anon_sym_fakeroot] = "fakeroot",
  [anon_sym_python] = "python",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [aux_sym_string_token1] = "string_content",
  [aux_sym_string_token2] = "string_token2",
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH] = "$BB_ENV_PASSTHROUGH",
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS] = "$BB_ENV_PASSTHROUGH_ADDITIONS",
  [anon_sym_DOLLAR] = "string_content",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token3] = "string_content",
  [aux_sym_string_token4] = "string_token4",
  [anon_sym_DOLLAR_LBRACE_AT] = "${@",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_SEMI] = ";",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_in] = "in",
  [anon_sym_if] = "if",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_except_STAR] = "except*",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_AT] = "@",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [sym_ellipsis] = "ellipsis",
  [sym_escape_sequence] = "escape_sequence",
  [sym__not_escape_sequence] = "_not_escape_sequence",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [anon_sym_await] = "await",
  [anon_sym_match] = "python_identifier",
  [anon_sym_type] = "python_identifier",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [sym_python_identifier] = "python_identifier",
  [sym_line_continuation] = "line_continuation",
  [sym_identifier] = "identifier",
  [aux_sym__dotted_identifier_token1] = "identifier",
  [sym_comment] = "comment",
  [sym__concat] = "_concat",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym_string_start] = "string_start",
  [sym__string_content] = "_string_content",
  [sym_escape_interpolation] = "escape_interpolation",
  [sym_string_end] = "string_end",
  [sym_shell_content] = "shell_content",
  [sym_recipe] = "recipe",
  [sym_variable_assignment] = "variable_assignment",
  [sym_variable_flag] = "variable_flag",
  [sym_override] = "override",
  [sym_unset_statement] = "unset_statement",
  [sym_inherit_directive] = "inherit_directive",
  [sym_include_directive] = "include_directive",
  [sym_require_directive] = "require_directive",
  [sym_export_statement] = "export_statement",
  [sym_overrides_statement] = "overrides_statement",
  [sym_export_functions_statement] = "export_functions_statement",
  [sym_addtask_statement] = "addtask_statement",
  [sym_deltask_statement] = "deltask_statement",
  [sym_addhandler_statement] = "addhandler_statement",
  [sym_anonymous_python_function] = "anonymous_python_function",
  [sym_function_definition] = "function_definition",
  [sym_literal] = "literal",
  [sym_string] = "string",
  [sym_inline_python] = "inline_python",
  [sym_variable_expansion] = "variable_expansion",
  [sym_python_function_definition] = "python_function_definition",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym__named_expression_lhs] = "_named_expression_lhs",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_type_parameter] = "type_parameter",
  [sym_parenthesized_list_splat] = "parenthesized_list_splat",
  [sym_argument_list] = "argument_list",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_except_group_clause] = "except_group_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_clause] = "with_clause",
  [sym_with_item] = "with_item",
  [sym_dotted_name] = "dotted_name",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym_pattern_list] = "pattern_list",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_generator_expression] = "generator_expression",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__collection_elements] = "_collection_elements",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_block] = "block",
  [sym_expression_list] = "expression_list",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym__parameters] = "_parameters",
  [sym__patterns] = "_patterns",
  [sym_parameter] = "parameter",
  [sym_pattern] = "pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat_pattern] = "list_splat_pattern",
  [sym_dictionary_splat_pattern] = "dictionary_splat_pattern",
  [sym_as_pattern] = "as_pattern",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_splat_type] = "splat_type",
  [sym_generic_type] = "generic_type",
  [sym_union_type] = "union_type",
  [sym_constrained_type] = "constrained_type",
  [sym_member_type] = "member_type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym_set] = "set",
  [sym_tuple] = "tuple",
  [sym_dictionary] = "dictionary",
  [sym_pair] = "pair",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_set_comprehension] = "set_comprehension",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_python_string] = "python_string",
  [sym_string_content] = "string_content",
  [sym_interpolation] = "interpolation",
  [sym__f_expression] = "_f_expression",
  [sym_format_specifier] = "format_specifier",
  [sym_await] = "await",
  [sym_positional_separator] = "positional_separator",
  [sym_keyword_separator] = "keyword_separator",
  [sym_concatenation] = "concatenation",
  [aux_sym_recipe_repeat1] = "recipe_repeat1",
  [aux_sym_override_repeat1] = "override_repeat1",
  [aux_sym_inherit_directive_repeat1] = "inherit_directive_repeat1",
  [aux_sym_include_directive_repeat1] = "include_directive_repeat1",
  [aux_sym_overrides_statement_repeat1] = "overrides_statement_repeat1",
  [aux_sym_export_functions_statement_repeat1] = "export_functions_statement_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_type_parameter_repeat1] = "type_parameter_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_try_statement_repeat2] = "try_statement_repeat2",
  [aux_sym_with_clause_repeat1] = "with_clause_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_pattern_list_repeat1] = "pattern_list_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym__collection_elements_repeat1] = "_collection_elements_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_python_string_repeat1] = "python_string_repeat1",
  [aux_sym_string_content_repeat1] = "string_content_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [alias_sym_as_pattern_target] = "as_pattern_target",
  [alias_sym_format_expression] = "format_expression",
  [alias_sym_include_path] = "include_path",
  [anon_alias_sym_isnot] = "is not",
  [anon_alias_sym_notin] = "not in",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [aux_sym_recipe_token1] = aux_sym_recipe_token1,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_QMARK_EQ] = anon_sym_QMARK_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_EQ_PLUS] = anon_sym_EQ_PLUS,
  [anon_sym_DOT_EQ] = anon_sym_DOT_EQ,
  [anon_sym_EQ_DOT] = anon_sym_EQ_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_noexec] = anon_sym_noexec,
  [aux_sym_variable_flag_token1] = aux_sym_variable_flag_token1,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_append] = anon_sym_append,
  [anon_sym_prepend] = anon_sym_prepend,
  [anon_sym_remove] = anon_sym_remove,
  [anon_sym_unset] = anon_sym_unset,
  [anon_sym_inherit] = anon_sym_inherit,
  [sym_inherit_path] = sym_inherit_path,
  [anon_sym_INHERIT] = anon_sym_INHERIT,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_include] = anon_sym_include,
  [aux_sym_include_directive_token1] = aux_sym_include_directive_token1,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_OVERRIDES] = anon_sym_OVERRIDES,
  [anon_sym_EXPORT_FUNCTIONS] = anon_sym_EXPORT_FUNCTIONS,
  [anon_sym_addtask] = anon_sym_addtask,
  [anon_sym_after] = anon_sym_after,
  [anon_sym_before] = anon_sym_before,
  [anon_sym_deltask] = anon_sym_deltask,
  [anon_sym_addhandler] = anon_sym_addhandler,
  [anon_sym_fakeroot] = anon_sym_fakeroot,
  [anon_sym_python] = anon_sym_python,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [aux_sym_string_token1] = sym_string_content,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH] = anon_sym_DOLLARBB_ENV_PASSTHROUGH,
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS] = anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
  [anon_sym_DOLLAR] = sym_string_content,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token3] = sym_string_content,
  [aux_sym_string_token4] = aux_sym_string_token4,
  [anon_sym_DOLLAR_LBRACE_AT] = anon_sym_DOLLAR_LBRACE_AT,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_from] = anon_sym_from,
  [anon_sym___future__] = anon_sym___future__,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_del] = anon_sym_del,
  [anon_sym_raise] = anon_sym_raise,
  [anon_sym_pass] = anon_sym_pass,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_nonlocal] = anon_sym_nonlocal,
  [anon_sym_exec] = anon_sym_exec,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_except] = anon_sym_except,
  [anon_sym_except_STAR] = anon_sym_except_STAR,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_lambda] = anon_sym_lambda,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AT_EQ] = anon_sym_AT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_yield] = anon_sym_yield,
  [sym_ellipsis] = sym_ellipsis,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__not_escape_sequence] = sym__not_escape_sequence,
  [aux_sym_format_specifier_token1] = aux_sym_format_specifier_token1,
  [sym_type_conversion] = sym_type_conversion,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_match] = sym_python_identifier,
  [anon_sym_type] = sym_python_identifier,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_none] = sym_none,
  [sym_python_identifier] = sym_python_identifier,
  [sym_line_continuation] = sym_line_continuation,
  [sym_identifier] = sym_identifier,
  [aux_sym__dotted_identifier_token1] = sym_identifier,
  [sym_comment] = sym_comment,
  [sym__concat] = sym__concat,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym_string_start] = sym_string_start,
  [sym__string_content] = sym__string_content,
  [sym_escape_interpolation] = sym_escape_interpolation,
  [sym_string_end] = sym_string_end,
  [sym_shell_content] = sym_shell_content,
  [sym_recipe] = sym_recipe,
  [sym_variable_assignment] = sym_variable_assignment,
  [sym_variable_flag] = sym_variable_flag,
  [sym_override] = sym_override,
  [sym_unset_statement] = sym_unset_statement,
  [sym_inherit_directive] = sym_inherit_directive,
  [sym_include_directive] = sym_include_directive,
  [sym_require_directive] = sym_require_directive,
  [sym_export_statement] = sym_export_statement,
  [sym_overrides_statement] = sym_overrides_statement,
  [sym_export_functions_statement] = sym_export_functions_statement,
  [sym_addtask_statement] = sym_addtask_statement,
  [sym_deltask_statement] = sym_deltask_statement,
  [sym_addhandler_statement] = sym_addhandler_statement,
  [sym_anonymous_python_function] = sym_anonymous_python_function,
  [sym_function_definition] = sym_function_definition,
  [sym_literal] = sym_literal,
  [sym_string] = sym_string,
  [sym_inline_python] = sym_inline_python,
  [sym_variable_expansion] = sym_variable_expansion,
  [sym_python_function_definition] = sym_python_function_definition,
  [sym__statement] = sym__statement,
  [sym__simple_statements] = sym__simple_statements,
  [sym_import_statement] = sym_import_statement,
  [sym_import_prefix] = sym_import_prefix,
  [sym_relative_import] = sym_relative_import,
  [sym_future_import_statement] = sym_future_import_statement,
  [sym_import_from_statement] = sym_import_from_statement,
  [sym__import_list] = sym__import_list,
  [sym_aliased_import] = sym_aliased_import,
  [sym_wildcard_import] = sym_wildcard_import,
  [sym_print_statement] = sym_print_statement,
  [sym_chevron] = sym_chevron,
  [sym_assert_statement] = sym_assert_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_named_expression] = sym_named_expression,
  [sym__named_expression_lhs] = sym__named_expression_lhs,
  [sym_return_statement] = sym_return_statement,
  [sym_delete_statement] = sym_delete_statement,
  [sym_raise_statement] = sym_raise_statement,
  [sym_pass_statement] = sym_pass_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_global_statement] = sym_global_statement,
  [sym_nonlocal_statement] = sym_nonlocal_statement,
  [sym_exec_statement] = sym_exec_statement,
  [sym_type_parameter] = sym_type_parameter,
  [sym_parenthesized_list_splat] = sym_parenthesized_list_splat,
  [sym_argument_list] = sym_argument_list,
  [sym_if_statement] = sym_if_statement,
  [sym_elif_clause] = sym_elif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_except_clause] = sym_except_clause,
  [sym_except_group_clause] = sym_except_group_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_with_statement] = sym_with_statement,
  [sym_with_clause] = sym_with_clause,
  [sym_with_item] = sym_with_item,
  [sym_dotted_name] = sym_dotted_name,
  [sym_not_operator] = sym_not_operator,
  [sym_boolean_operator] = sym_boolean_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_lambda] = sym_lambda,
  [sym_lambda_within_for_in_clause] = sym_lambda,
  [sym_assignment] = sym_assignment,
  [sym_augmented_assignment] = sym_augmented_assignment,
  [sym_pattern_list] = sym_pattern_list,
  [sym__right_hand_side] = sym__right_hand_side,
  [sym_yield] = sym_yield,
  [sym_attribute] = sym_attribute,
  [sym_subscript] = sym_subscript,
  [sym_slice] = sym_slice,
  [sym_call] = sym_call,
  [sym_generator_expression] = sym_generator_expression,
  [sym__comprehension_clauses] = sym__comprehension_clauses,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__collection_elements] = sym__collection_elements,
  [sym_for_in_clause] = sym_for_in_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_block] = sym_block,
  [sym_expression_list] = sym_expression_list,
  [sym_parameters] = sym_parameters,
  [sym_lambda_parameters] = sym_lambda_parameters,
  [sym_list_splat] = sym_list_splat,
  [sym_dictionary_splat] = sym_dictionary_splat,
  [sym__parameters] = sym__parameters,
  [sym__patterns] = sym__patterns,
  [sym_parameter] = sym_parameter,
  [sym_pattern] = sym_pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_default_parameter] = sym_default_parameter,
  [sym_typed_default_parameter] = sym_typed_default_parameter,
  [sym_list_splat_pattern] = sym_list_splat_pattern,
  [sym_dictionary_splat_pattern] = sym_dictionary_splat_pattern,
  [sym_as_pattern] = sym_as_pattern,
  [sym__expression_within_for_in_clause] = sym__expression_within_for_in_clause,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_type] = sym_type,
  [sym_splat_type] = sym_splat_type,
  [sym_generic_type] = sym_generic_type,
  [sym_union_type] = sym_union_type,
  [sym_constrained_type] = sym_constrained_type,
  [sym_member_type] = sym_member_type,
  [sym_keyword_argument] = sym_keyword_argument,
  [sym_list] = sym_list,
  [sym_set] = sym_set,
  [sym_tuple] = sym_tuple,
  [sym_dictionary] = sym_dictionary,
  [sym_pair] = sym_pair,
  [sym_list_comprehension] = sym_list_comprehension,
  [sym_dictionary_comprehension] = sym_dictionary_comprehension,
  [sym_set_comprehension] = sym_set_comprehension,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_python_string] = sym_python_string,
  [sym_string_content] = sym_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym__f_expression] = sym__f_expression,
  [sym_format_specifier] = sym_format_specifier,
  [sym_await] = sym_await,
  [sym_positional_separator] = sym_positional_separator,
  [sym_keyword_separator] = sym_keyword_separator,
  [sym_concatenation] = sym_concatenation,
  [aux_sym_recipe_repeat1] = aux_sym_recipe_repeat1,
  [aux_sym_override_repeat1] = aux_sym_override_repeat1,
  [aux_sym_inherit_directive_repeat1] = aux_sym_inherit_directive_repeat1,
  [aux_sym_include_directive_repeat1] = aux_sym_include_directive_repeat1,
  [aux_sym_overrides_statement_repeat1] = aux_sym_overrides_statement_repeat1,
  [aux_sym_export_functions_statement_repeat1] = aux_sym_export_functions_statement_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym__simple_statements_repeat1] = aux_sym__simple_statements_repeat1,
  [aux_sym_import_prefix_repeat1] = aux_sym_import_prefix_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_print_statement_repeat1] = aux_sym_print_statement_repeat1,
  [aux_sym_assert_statement_repeat1] = aux_sym_assert_statement_repeat1,
  [aux_sym_global_statement_repeat1] = aux_sym_global_statement_repeat1,
  [aux_sym_type_parameter_repeat1] = aux_sym_type_parameter_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_try_statement_repeat2] = aux_sym_try_statement_repeat2,
  [aux_sym_with_clause_repeat1] = aux_sym_with_clause_repeat1,
  [aux_sym_dotted_name_repeat1] = aux_sym_dotted_name_repeat1,
  [aux_sym_comparison_operator_repeat1] = aux_sym_comparison_operator_repeat1,
  [aux_sym_pattern_list_repeat1] = aux_sym_pattern_list_repeat1,
  [aux_sym_subscript_repeat1] = aux_sym_subscript_repeat1,
  [aux_sym__comprehension_clauses_repeat1] = aux_sym__comprehension_clauses_repeat1,
  [aux_sym__collection_elements_repeat1] = aux_sym__collection_elements_repeat1,
  [aux_sym_for_in_clause_repeat1] = aux_sym_for_in_clause_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym__parameters_repeat1] = aux_sym__parameters_repeat1,
  [aux_sym_dictionary_repeat1] = aux_sym_dictionary_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_python_string_repeat1] = aux_sym_python_string_repeat1,
  [aux_sym_string_content_repeat1] = aux_sym_string_content_repeat1,
  [aux_sym_format_specifier_repeat1] = aux_sym_format_specifier_repeat1,
  [aux_sym_concatenation_repeat1] = aux_sym_concatenation_repeat1,
  [alias_sym_as_pattern_target] = alias_sym_as_pattern_target,
  [alias_sym_format_expression] = alias_sym_format_expression,
  [alias_sym_include_path] = alias_sym_include_path,
  [anon_alias_sym_isnot] = anon_alias_sym_isnot,
  [anon_alias_sym_notin] = anon_alias_sym_notin,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_recipe_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexec] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_variable_flag_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_append] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prepend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_remove] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inherit] = {
    .visible = true,
    .named = false,
  },
  [sym_inherit_path] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_INHERIT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_directive_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_OVERRIDES] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EXPORT_FUNCTIONS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addtask] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_after] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_before] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_deltask] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addhandler] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fakeroot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_python] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token3] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_token4] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__not_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_python_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_line_continuation] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__dotted_identifier_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym_string_start] = {
    .visible = true,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string_end] = {
    .visible = true,
    .named = true,
  },
  [sym_shell_content] = {
    .visible = true,
    .named = true,
  },
  [sym_recipe] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_flag] = {
    .visible = true,
    .named = true,
  },
  [sym_override] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_inherit_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_include_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_require_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_overrides_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_functions_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_addtask_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_deltask_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_addhandler_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_python_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_python] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_python_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__named_expression_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_except_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_list] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__collection_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__patterns] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type] = {
    .visible = true,
    .named = true,
  },
  [sym_member_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_python_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__f_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_recipe_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_override_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inherit_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_include_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_overrides_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_functions_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__collection_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_python_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_as_pattern_target] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_include_path] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_isnot] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_notin] = {
    .visible = true,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_cause = 7,
  field_code = 8,
  field_condition = 9,
  field_consequence = 10,
  field_expression = 11,
  field_format_specifier = 12,
  field_function = 13,
  field_key = 14,
  field_left = 15,
  field_module_name = 16,
  field_name = 17,
  field_object = 18,
  field_operator = 19,
  field_operators = 20,
  field_parameters = 21,
  field_return_type = 22,
  field_right = 23,
  field_subscript = 24,
  field_type = 25,
  field_type_conversion = 26,
  field_value = 27,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_cause] = "cause",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_expression] = "expression",
  [field_format_specifier] = "format_specifier",
  [field_function] = "function",
  [field_key] = "key",
  [field_left] = "left",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_operators] = "operators",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_type] = "type",
  [field_type_conversion] = "type_conversion",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [4] = {.index = 0, .length = 1},
  [6] = {.index = 1, .length = 1},
  [7] = {.index = 2, .length = 2},
  [8] = {.index = 4, .length = 2},
  [9] = {.index = 6, .length = 1},
  [10] = {.index = 7, .length = 1},
  [11] = {.index = 8, .length = 1},
  [12] = {.index = 9, .length = 2},
  [13] = {.index = 11, .length = 1},
  [14] = {.index = 12, .length = 3},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 17, .length = 1},
  [17] = {.index = 18, .length = 2},
  [18] = {.index = 20, .length = 3},
  [19] = {.index = 23, .length = 1},
  [21] = {.index = 24, .length = 1},
  [22] = {.index = 25, .length = 2},
  [23] = {.index = 27, .length = 1},
  [24] = {.index = 28, .length = 2},
  [25] = {.index = 30, .length = 2},
  [26] = {.index = 32, .length = 2},
  [27] = {.index = 32, .length = 2},
  [29] = {.index = 34, .length = 1},
  [30] = {.index = 35, .length = 1},
  [31] = {.index = 36, .length = 1},
  [32] = {.index = 37, .length = 4},
  [34] = {.index = 41, .length = 2},
  [35] = {.index = 43, .length = 2},
  [36] = {.index = 45, .length = 1},
  [37] = {.index = 46, .length = 3},
  [38] = {.index = 49, .length = 2},
  [39] = {.index = 9, .length = 2},
  [41] = {.index = 51, .length = 1},
  [42] = {.index = 52, .length = 2},
  [43] = {.index = 54, .length = 1},
  [44] = {.index = 55, .length = 2},
  [45] = {.index = 57, .length = 1},
  [46] = {.index = 58, .length = 2},
  [47] = {.index = 60, .length = 2},
  [48] = {.index = 62, .length = 4},
  [49] = {.index = 66, .length = 2},
  [50] = {.index = 68, .length = 2},
  [51] = {.index = 70, .length = 3},
  [52] = {.index = 73, .length = 2},
  [53] = {.index = 75, .length = 3},
  [55] = {.index = 78, .length = 1},
  [56] = {.index = 79, .length = 2},
  [57] = {.index = 81, .length = 2},
  [58] = {.index = 83, .length = 1},
  [59] = {.index = 84, .length = 2},
  [60] = {.index = 86, .length = 1},
  [61] = {.index = 87, .length = 2},
  [62] = {.index = 89, .length = 1},
  [63] = {.index = 90, .length = 5},
  [64] = {.index = 95, .length = 3},
  [65] = {.index = 98, .length = 2},
  [66] = {.index = 100, .length = 3},
  [68] = {.index = 103, .length = 2},
  [69] = {.index = 105, .length = 2},
  [70] = {.index = 8, .length = 1},
  [71] = {.index = 107, .length = 1},
  [72] = {.index = 108, .length = 3},
  [73] = {.index = 111, .length = 3},
  [74] = {.index = 114, .length = 1},
  [75] = {.index = 115, .length = 3},
  [76] = {.index = 118, .length = 3},
  [77] = {.index = 121, .length = 3},
  [78] = {.index = 124, .length = 1},
  [79] = {.index = 125, .length = 3},
  [80] = {.index = 128, .length = 3},
  [81] = {.index = 131, .length = 2},
  [82] = {.index = 133, .length = 2},
  [83] = {.index = 135, .length = 1},
  [84] = {.index = 136, .length = 2},
  [85] = {.index = 138, .length = 4},
  [86] = {.index = 142, .length = 2},
  [87] = {.index = 144, .length = 4},
  [88] = {.index = 148, .length = 4},
  [89] = {.index = 152, .length = 2},
  [90] = {.index = 154, .length = 3},
  [91] = {.index = 157, .length = 4},
  [93] = {.index = 161, .length = 5},
  [94] = {.index = 166, .length = 3},
  [95] = {.index = 169, .length = 4},
  [96] = {.index = 173, .length = 4},
  [98] = {.index = 177, .length = 4},
  [99] = {.index = 181, .length = 4},
  [100] = {.index = 185, .length = 5},
  [101] = {.index = 190, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_operator, 1},
  [1] =
    {field_argument, 1},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_arguments, 1},
    {field_function, 0},
  [6] =
    {field_operators, 1, .inherited = true},
  [7] =
    {field_operator, 2},
  [8] =
    {field_body, 2},
  [9] =
    {field_name, 0},
    {field_value, 2},
  [11] =
    {field_alias, 2},
  [12] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [15] =
    {field_attribute, 2},
    {field_object, 0},
  [17] =
    {field_operators, 0},
  [18] =
    {field_operators, 0, .inherited = true},
    {field_operators, 1, .inherited = true},
  [20] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [23] =
    {field_expression, 1},
  [24] =
    {field_body, 1},
  [25] =
    {field_key, 0},
    {field_value, 2},
  [27] =
    {field_type, 2},
  [28] =
    {field_body, 3},
    {field_parameters, 1},
  [30] =
    {field_subscript, 2},
    {field_value, 0},
  [32] =
    {field_operators, 0},
    {field_operators, 1},
  [34] =
    {field_name, 1, .inherited = true},
  [35] =
    {field_name, 0},
  [36] =
    {field_code, 1},
  [37] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [41] =
    {field_expression, 1},
    {field_type_conversion, 2},
  [43] =
    {field_expression, 1},
    {field_format_specifier, 2},
  [45] =
    {field_subscript, 1},
  [46] =
    {field_subscript, 2},
    {field_subscript, 3, .inherited = true},
    {field_value, 0},
  [49] =
    {field_subscript, 0, .inherited = true},
    {field_subscript, 1, .inherited = true},
  [51] =
    {field_value, 0},
  [52] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [54] =
    {field_argument, 2, .inherited = true},
  [55] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [57] =
    {field_cause, 2},
  [58] =
    {field_left, 0},
    {field_right, 2},
  [60] =
    {field_left, 0},
    {field_type, 2},
  [62] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [66] =
    {field_expression, 1},
    {field_type_conversion, 3},
  [68] =
    {field_expression, 1},
    {field_format_specifier, 3},
  [70] =
    {field_expression, 1},
    {field_format_specifier, 3},
    {field_type_conversion, 2},
  [73] =
    {field_left, 1},
    {field_right, 3},
  [75] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [78] =
    {field_name, 1},
  [79] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [81] =
    {field_alias, 2},
    {field_name, 0},
  [83] =
    {field_name, 3, .inherited = true},
  [84] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [86] =
    {field_module_name, 1},
  [87] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [89] =
    {field_cause, 3},
  [90] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [95] =
    {field_expression, 1},
    {field_format_specifier, 4},
    {field_type_conversion, 3},
  [98] =
    {field_left, 2},
    {field_right, 4},
  [100] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [103] =
    {field_condition, 1},
    {field_consequence, 3},
  [105] =
    {field_body, 3},
    {field_condition, 1},
  [107] =
    {field_body, 3},
  [108] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [111] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [114] =
    {field_alternative, 0},
  [115] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [118] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [121] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [124] =
    {field_body, 4},
  [125] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [128] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [131] =
    {field_body, 2},
    {field_body, 3},
  [133] =
    {field_body, 3},
    {field_body, 4},
  [135] =
    {field_name, 4, .inherited = true},
  [136] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [138] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [142] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [144] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [148] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [152] =
    {field_body, 4},
    {field_body, 5},
  [154] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [157] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [161] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [166] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [169] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [173] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [177] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [181] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [185] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [190] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [1] = alias_sym_include_path,
  },
  [2] = {
    [0] = sym_python_identifier,
  },
  [3] = {
    [0] = sym_list_splat,
  },
  [5] = {
    [1] = sym_python_identifier,
  },
  [13] = {
    [2] = alias_sym_as_pattern_target,
  },
  [18] = {
    [4] = sym_block,
  },
  [20] = {
    [1] = sym_parenthesized_expression,
  },
  [26] = {
    [0] = anon_alias_sym_notin,
    [1] = anon_alias_sym_notin,
  },
  [27] = {
    [0] = anon_alias_sym_isnot,
    [1] = anon_alias_sym_isnot,
  },
  [28] = {
    [4] = sym_block,
  },
  [33] = {
    [0] = alias_sym_format_expression,
  },
  [39] = {
    [0] = sym_python_identifier,
  },
  [40] = {
    [5] = sym_block,
  },
  [48] = {
    [6] = sym_block,
  },
  [54] = {
    [6] = sym_block,
  },
  [67] = {
    [7] = sym_block,
  },
  [68] = {
    [3] = sym_block,
  },
  [69] = {
    [3] = sym_block,
  },
  [70] = {
    [2] = sym_block,
  },
  [71] = {
    [3] = sym_block,
  },
  [75] = {
    [3] = sym_block,
  },
  [76] = {
    [3] = sym_block,
  },
  [78] = {
    [4] = sym_block,
  },
  [79] = {
    [3] = sym_block,
  },
  [85] = {
    [3] = sym_block,
  },
  [90] = {
    [5] = sym_block,
  },
  [92] = {
    [2] = sym_block,
  },
  [94] = {
    [6] = sym_block,
  },
  [95] = {
    [5] = sym_block,
  },
  [97] = {
    [3] = sym_block,
  },
  [98] = {
    [6] = sym_block,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__simple_statements, 2,
    sym__simple_statements,
    sym_block,
  sym_parenthesized_list_splat, 2,
    sym_parenthesized_list_splat,
    sym_parenthesized_expression,
  sym_list_splat_pattern, 2,
    sym_list_splat_pattern,
    sym_list_splat,
  sym_expression, 2,
    sym_expression,
    alias_sym_as_pattern_target,
  sym_interpolation, 2,
    sym_interpolation,
    alias_sym_format_expression,
  aux_sym_include_directive_repeat1, 2,
    aux_sym_include_directive_repeat1,
    alias_sym_include_path,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 9,
  [18] = 18,
  [19] = 19,
  [20] = 8,
  [21] = 21,
  [22] = 22,
  [23] = 18,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 26,
  [28] = 26,
  [29] = 26,
  [30] = 26,
  [31] = 26,
  [32] = 26,
  [33] = 33,
  [34] = 26,
  [35] = 26,
  [36] = 36,
  [37] = 37,
  [38] = 36,
  [39] = 37,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 46,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 55,
  [60] = 60,
  [61] = 61,
  [62] = 61,
  [63] = 61,
  [64] = 61,
  [65] = 65,
  [66] = 61,
  [67] = 65,
  [68] = 61,
  [69] = 65,
  [70] = 65,
  [71] = 61,
  [72] = 61,
  [73] = 65,
  [74] = 65,
  [75] = 61,
  [76] = 65,
  [77] = 65,
  [78] = 65,
  [79] = 79,
  [80] = 80,
  [81] = 80,
  [82] = 82,
  [83] = 83,
  [84] = 83,
  [85] = 80,
  [86] = 83,
  [87] = 87,
  [88] = 82,
  [89] = 82,
  [90] = 83,
  [91] = 91,
  [92] = 92,
  [93] = 91,
  [94] = 83,
  [95] = 82,
  [96] = 83,
  [97] = 92,
  [98] = 98,
  [99] = 87,
  [100] = 83,
  [101] = 80,
  [102] = 83,
  [103] = 82,
  [104] = 80,
  [105] = 87,
  [106] = 91,
  [107] = 83,
  [108] = 91,
  [109] = 91,
  [110] = 82,
  [111] = 82,
  [112] = 82,
  [113] = 82,
  [114] = 87,
  [115] = 91,
  [116] = 82,
  [117] = 91,
  [118] = 87,
  [119] = 91,
  [120] = 82,
  [121] = 91,
  [122] = 87,
  [123] = 98,
  [124] = 82,
  [125] = 83,
  [126] = 91,
  [127] = 82,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 128,
  [132] = 132,
  [133] = 132,
  [134] = 128,
  [135] = 129,
  [136] = 128,
  [137] = 129,
  [138] = 138,
  [139] = 128,
  [140] = 132,
  [141] = 141,
  [142] = 129,
  [143] = 132,
  [144] = 129,
  [145] = 129,
  [146] = 128,
  [147] = 132,
  [148] = 132,
  [149] = 129,
  [150] = 128,
  [151] = 129,
  [152] = 152,
  [153] = 152,
  [154] = 128,
  [155] = 129,
  [156] = 132,
  [157] = 128,
  [158] = 129,
  [159] = 132,
  [160] = 129,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 163,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 165,
  [170] = 170,
  [171] = 166,
  [172] = 161,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 166,
  [177] = 166,
  [178] = 174,
  [179] = 166,
  [180] = 174,
  [181] = 181,
  [182] = 182,
  [183] = 167,
  [184] = 166,
  [185] = 166,
  [186] = 174,
  [187] = 167,
  [188] = 167,
  [189] = 165,
  [190] = 165,
  [191] = 191,
  [192] = 168,
  [193] = 166,
  [194] = 162,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 195,
  [199] = 199,
  [200] = 196,
  [201] = 201,
  [202] = 202,
  [203] = 196,
  [204] = 202,
  [205] = 196,
  [206] = 195,
  [207] = 197,
  [208] = 208,
  [209] = 208,
  [210] = 196,
  [211] = 201,
  [212] = 196,
  [213] = 202,
  [214] = 202,
  [215] = 197,
  [216] = 195,
  [217] = 199,
  [218] = 199,
  [219] = 201,
  [220] = 202,
  [221] = 199,
  [222] = 201,
  [223] = 208,
  [224] = 195,
  [225] = 197,
  [226] = 196,
  [227] = 202,
  [228] = 202,
  [229] = 208,
  [230] = 201,
  [231] = 199,
  [232] = 197,
  [233] = 195,
  [234] = 202,
  [235] = 196,
  [236] = 201,
  [237] = 195,
  [238] = 197,
  [239] = 201,
  [240] = 208,
  [241] = 199,
  [242] = 201,
  [243] = 197,
  [244] = 195,
  [245] = 197,
  [246] = 208,
  [247] = 199,
  [248] = 199,
  [249] = 98,
  [250] = 250,
  [251] = 251,
  [252] = 250,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 257,
  [259] = 257,
  [260] = 256,
  [261] = 255,
  [262] = 262,
  [263] = 256,
  [264] = 264,
  [265] = 250,
  [266] = 82,
  [267] = 255,
  [268] = 254,
  [269] = 254,
  [270] = 253,
  [271] = 253,
  [272] = 272,
  [273] = 272,
  [274] = 272,
  [275] = 275,
  [276] = 276,
  [277] = 272,
  [278] = 272,
  [279] = 275,
  [280] = 275,
  [281] = 275,
  [282] = 275,
  [283] = 276,
  [284] = 272,
  [285] = 272,
  [286] = 275,
  [287] = 170,
  [288] = 170,
  [289] = 272,
  [290] = 275,
  [291] = 291,
  [292] = 170,
  [293] = 276,
  [294] = 275,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 82,
  [299] = 297,
  [300] = 297,
  [301] = 296,
  [302] = 302,
  [303] = 303,
  [304] = 296,
  [305] = 295,
  [306] = 296,
  [307] = 295,
  [308] = 296,
  [309] = 297,
  [310] = 310,
  [311] = 264,
  [312] = 297,
  [313] = 297,
  [314] = 297,
  [315] = 262,
  [316] = 295,
  [317] = 295,
  [318] = 296,
  [319] = 295,
  [320] = 320,
  [321] = 296,
  [322] = 295,
  [323] = 297,
  [324] = 297,
  [325] = 295,
  [326] = 296,
  [327] = 295,
  [328] = 296,
  [329] = 295,
  [330] = 297,
  [331] = 296,
  [332] = 332,
  [333] = 262,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 337,
  [344] = 334,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 340,
  [350] = 264,
  [351] = 334,
  [352] = 98,
  [353] = 82,
  [354] = 354,
  [355] = 345,
  [356] = 98,
  [357] = 82,
  [358] = 358,
  [359] = 320,
  [360] = 98,
  [361] = 334,
  [362] = 334,
  [363] = 262,
  [364] = 340,
  [365] = 334,
  [366] = 366,
  [367] = 262,
  [368] = 358,
  [369] = 82,
  [370] = 334,
  [371] = 347,
  [372] = 334,
  [373] = 373,
  [374] = 337,
  [375] = 358,
  [376] = 376,
  [377] = 82,
  [378] = 378,
  [379] = 347,
  [380] = 380,
  [381] = 264,
  [382] = 334,
  [383] = 383,
  [384] = 384,
  [385] = 345,
  [386] = 264,
  [387] = 334,
  [388] = 388,
  [389] = 264,
  [390] = 390,
  [391] = 391,
  [392] = 262,
  [393] = 393,
  [394] = 394,
  [395] = 391,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 398,
  [405] = 396,
  [406] = 406,
  [407] = 407,
  [408] = 397,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 401,
  [421] = 409,
  [422] = 411,
  [423] = 411,
  [424] = 397,
  [425] = 425,
  [426] = 416,
  [427] = 427,
  [428] = 402,
  [429] = 429,
  [430] = 412,
  [431] = 431,
  [432] = 412,
  [433] = 407,
  [434] = 411,
  [435] = 416,
  [436] = 400,
  [437] = 437,
  [438] = 409,
  [439] = 399,
  [440] = 401,
  [441] = 397,
  [442] = 398,
  [443] = 398,
  [444] = 409,
  [445] = 397,
  [446] = 402,
  [447] = 412,
  [448] = 409,
  [449] = 399,
  [450] = 396,
  [451] = 396,
  [452] = 402,
  [453] = 409,
  [454] = 454,
  [455] = 407,
  [456] = 456,
  [457] = 402,
  [458] = 409,
  [459] = 399,
  [460] = 437,
  [461] = 398,
  [462] = 401,
  [463] = 397,
  [464] = 412,
  [465] = 411,
  [466] = 400,
  [467] = 467,
  [468] = 411,
  [469] = 396,
  [470] = 411,
  [471] = 400,
  [472] = 402,
  [473] = 399,
  [474] = 474,
  [475] = 398,
  [476] = 467,
  [477] = 477,
  [478] = 396,
  [479] = 402,
  [480] = 409,
  [481] = 396,
  [482] = 401,
  [483] = 397,
  [484] = 437,
  [485] = 416,
  [486] = 399,
  [487] = 398,
  [488] = 411,
  [489] = 418,
  [490] = 454,
  [491] = 397,
  [492] = 454,
  [493] = 412,
  [494] = 397,
  [495] = 474,
  [496] = 412,
  [497] = 398,
  [498] = 399,
  [499] = 402,
  [500] = 416,
  [501] = 416,
  [502] = 400,
  [503] = 91,
  [504] = 411,
  [505] = 82,
  [506] = 399,
  [507] = 409,
  [508] = 508,
  [509] = 402,
  [510] = 412,
  [511] = 399,
  [512] = 400,
  [513] = 398,
  [514] = 407,
  [515] = 400,
  [516] = 454,
  [517] = 400,
  [518] = 518,
  [519] = 411,
  [520] = 396,
  [521] = 456,
  [522] = 400,
  [523] = 412,
  [524] = 397,
  [525] = 398,
  [526] = 399,
  [527] = 409,
  [528] = 402,
  [529] = 412,
  [530] = 530,
  [531] = 396,
  [532] = 508,
  [533] = 401,
  [534] = 400,
  [535] = 396,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 542,
  [545] = 545,
  [546] = 543,
  [547] = 161,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 162,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 550,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 564,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 568,
  [571] = 569,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 578,
  [583] = 579,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 580,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 585,
  [593] = 589,
  [594] = 577,
  [595] = 595,
  [596] = 596,
  [597] = 579,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 589,
  [602] = 602,
  [603] = 578,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 161,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 612,
  [615] = 610,
  [616] = 616,
  [617] = 612,
  [618] = 577,
  [619] = 162,
  [620] = 620,
  [621] = 621,
  [622] = 610,
  [623] = 611,
  [624] = 624,
  [625] = 580,
  [626] = 616,
  [627] = 578,
  [628] = 628,
  [629] = 628,
  [630] = 580,
  [631] = 628,
  [632] = 632,
  [633] = 579,
  [634] = 589,
  [635] = 635,
  [636] = 578,
  [637] = 577,
  [638] = 628,
  [639] = 589,
  [640] = 579,
  [641] = 628,
  [642] = 580,
  [643] = 577,
  [644] = 628,
  [645] = 645,
  [646] = 589,
  [647] = 647,
  [648] = 632,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 578,
  [657] = 657,
  [658] = 577,
  [659] = 659,
  [660] = 660,
  [661] = 635,
  [662] = 662,
  [663] = 663,
  [664] = 579,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 659,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 580,
  [680] = 680,
  [681] = 680,
  [682] = 680,
  [683] = 680,
  [684] = 680,
  [685] = 680,
  [686] = 680,
  [687] = 680,
  [688] = 680,
  [689] = 680,
  [690] = 690,
  [691] = 691,
  [692] = 691,
  [693] = 693,
  [694] = 694,
  [695] = 693,
  [696] = 696,
  [697] = 697,
  [698] = 693,
  [699] = 694,
  [700] = 693,
  [701] = 694,
  [702] = 696,
  [703] = 703,
  [704] = 693,
  [705] = 693,
  [706] = 696,
  [707] = 693,
  [708] = 693,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 691,
  [714] = 712,
  [715] = 703,
  [716] = 710,
  [717] = 717,
  [718] = 711,
  [719] = 703,
  [720] = 720,
  [721] = 720,
  [722] = 717,
  [723] = 693,
  [724] = 691,
  [725] = 712,
  [726] = 691,
  [727] = 709,
  [728] = 712,
  [729] = 694,
  [730] = 691,
  [731] = 710,
  [732] = 709,
  [733] = 693,
  [734] = 717,
  [735] = 690,
  [736] = 697,
  [737] = 737,
  [738] = 711,
  [739] = 711,
  [740] = 696,
  [741] = 717,
  [742] = 693,
  [743] = 717,
  [744] = 693,
  [745] = 737,
  [746] = 711,
  [747] = 703,
  [748] = 720,
  [749] = 717,
  [750] = 703,
  [751] = 720,
  [752] = 691,
  [753] = 720,
  [754] = 690,
  [755] = 693,
  [756] = 703,
  [757] = 712,
  [758] = 697,
  [759] = 710,
  [760] = 709,
  [761] = 690,
  [762] = 710,
  [763] = 709,
  [764] = 712,
  [765] = 694,
  [766] = 690,
  [767] = 717,
  [768] = 693,
  [769] = 710,
  [770] = 697,
  [771] = 696,
  [772] = 711,
  [773] = 717,
  [774] = 693,
  [775] = 697,
  [776] = 690,
  [777] = 690,
  [778] = 694,
  [779] = 709,
  [780] = 690,
  [781] = 717,
  [782] = 709,
  [783] = 709,
  [784] = 710,
  [785] = 711,
  [786] = 703,
  [787] = 691,
  [788] = 710,
  [789] = 696,
  [790] = 712,
  [791] = 712,
  [792] = 691,
  [793] = 720,
  [794] = 693,
  [795] = 694,
  [796] = 694,
  [797] = 703,
  [798] = 720,
  [799] = 690,
  [800] = 709,
  [801] = 712,
  [802] = 710,
  [803] = 717,
  [804] = 711,
  [805] = 703,
  [806] = 696,
  [807] = 717,
  [808] = 696,
  [809] = 693,
  [810] = 711,
  [811] = 710,
  [812] = 720,
  [813] = 709,
  [814] = 690,
  [815] = 696,
  [816] = 711,
  [817] = 703,
  [818] = 691,
  [819] = 712,
  [820] = 694,
  [821] = 720,
  [822] = 693,
  [823] = 696,
  [824] = 694,
  [825] = 711,
  [826] = 703,
  [827] = 720,
  [828] = 691,
  [829] = 712,
  [830] = 710,
  [831] = 709,
  [832] = 690,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 833,
  [837] = 833,
  [838] = 834,
  [839] = 839,
  [840] = 839,
  [841] = 834,
  [842] = 835,
  [843] = 835,
  [844] = 839,
  [845] = 845,
  [846] = 839,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 834,
  [851] = 834,
  [852] = 852,
  [853] = 833,
  [854] = 845,
  [855] = 855,
  [856] = 856,
  [857] = 834,
  [858] = 839,
  [859] = 852,
  [860] = 849,
  [861] = 861,
  [862] = 862,
  [863] = 833,
  [864] = 835,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 834,
  [869] = 869,
  [870] = 835,
  [871] = 861,
  [872] = 861,
  [873] = 852,
  [874] = 839,
  [875] = 849,
  [876] = 855,
  [877] = 839,
  [878] = 847,
  [879] = 855,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 839,
  [884] = 833,
  [885] = 835,
  [886] = 867,
  [887] = 887,
  [888] = 865,
  [889] = 880,
  [890] = 847,
  [891] = 880,
  [892] = 833,
  [893] = 881,
  [894] = 882,
  [895] = 845,
  [896] = 869,
  [897] = 867,
  [898] = 881,
  [899] = 835,
  [900] = 865,
  [901] = 882,
  [902] = 869,
  [903] = 887,
  [904] = 904,
  [905] = 882,
  [906] = 551,
  [907] = 552,
  [908] = 548,
  [909] = 845,
  [910] = 869,
  [911] = 567,
  [912] = 855,
  [913] = 847,
  [914] = 861,
  [915] = 867,
  [916] = 852,
  [917] = 862,
  [918] = 881,
  [919] = 882,
  [920] = 880,
  [921] = 881,
  [922] = 839,
  [923] = 856,
  [924] = 924,
  [925] = 845,
  [926] = 549,
  [927] = 557,
  [928] = 865,
  [929] = 849,
  [930] = 880,
  [931] = 565,
  [932] = 833,
  [933] = 933,
  [934] = 934,
  [935] = 855,
  [936] = 869,
  [937] = 861,
  [938] = 938,
  [939] = 939,
  [940] = 847,
  [941] = 848,
  [942] = 867,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 865,
  [948] = 865,
  [949] = 867,
  [950] = 835,
  [951] = 847,
  [952] = 887,
  [953] = 849,
  [954] = 954,
  [955] = 852,
  [956] = 861,
  [957] = 855,
  [958] = 849,
  [959] = 847,
  [960] = 880,
  [961] = 961,
  [962] = 881,
  [963] = 882,
  [964] = 849,
  [965] = 845,
  [966] = 869,
  [967] = 848,
  [968] = 904,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 866,
  [973] = 973,
  [974] = 545,
  [975] = 975,
  [976] = 558,
  [977] = 852,
  [978] = 856,
  [979] = 542,
  [980] = 980,
  [981] = 981,
  [982] = 866,
  [983] = 543,
  [984] = 852,
  [985] = 985,
  [986] = 986,
  [987] = 553,
  [988] = 865,
  [989] = 989,
  [990] = 839,
  [991] = 563,
  [992] = 862,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 861,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 855,
  [1003] = 834,
  [1004] = 880,
  [1005] = 881,
  [1006] = 882,
  [1007] = 1007,
  [1008] = 845,
  [1009] = 869,
  [1010] = 867,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 882,
  [1014] = 847,
  [1015] = 862,
  [1016] = 887,
  [1017] = 856,
  [1018] = 848,
  [1019] = 869,
  [1020] = 845,
  [1021] = 882,
  [1022] = 881,
  [1023] = 880,
  [1024] = 855,
  [1025] = 861,
  [1026] = 971,
  [1027] = 986,
  [1028] = 989,
  [1029] = 852,
  [1030] = 849,
  [1031] = 839,
  [1032] = 887,
  [1033] = 856,
  [1034] = 839,
  [1035] = 848,
  [1036] = 995,
  [1037] = 954,
  [1038] = 1011,
  [1039] = 867,
  [1040] = 865,
  [1041] = 558,
  [1042] = 848,
  [1043] = 553,
  [1044] = 563,
  [1045] = 558,
  [1046] = 856,
  [1047] = 887,
  [1048] = 973,
  [1049] = 553,
  [1050] = 944,
  [1051] = 847,
  [1052] = 866,
  [1053] = 550,
  [1054] = 564,
  [1055] = 862,
  [1056] = 938,
  [1057] = 939,
  [1058] = 943,
  [1059] = 945,
  [1060] = 946,
  [1061] = 961,
  [1062] = 975,
  [1063] = 1012,
  [1064] = 862,
  [1065] = 839,
  [1066] = 866,
  [1067] = 969,
  [1068] = 970,
  [1069] = 557,
  [1070] = 549,
  [1071] = 980,
  [1072] = 981,
  [1073] = 551,
  [1074] = 552,
  [1075] = 548,
  [1076] = 985,
  [1077] = 1007,
  [1078] = 565,
  [1079] = 904,
  [1080] = 993,
  [1081] = 994,
  [1082] = 567,
  [1083] = 997,
  [1084] = 998,
  [1085] = 999,
  [1086] = 1000,
  [1087] = 1001,
  [1088] = 904,
  [1089] = 543,
  [1090] = 569,
  [1091] = 542,
  [1092] = 545,
  [1093] = 568,
  [1094] = 1001,
  [1095] = 1000,
  [1096] = 866,
  [1097] = 565,
  [1098] = 1007,
  [1099] = 999,
  [1100] = 998,
  [1101] = 943,
  [1102] = 939,
  [1103] = 997,
  [1104] = 938,
  [1105] = 866,
  [1106] = 1012,
  [1107] = 975,
  [1108] = 961,
  [1109] = 946,
  [1110] = 945,
  [1111] = 545,
  [1112] = 542,
  [1113] = 543,
  [1114] = 944,
  [1115] = 567,
  [1116] = 994,
  [1117] = 993,
  [1118] = 852,
  [1119] = 849,
  [1120] = 861,
  [1121] = 985,
  [1122] = 565,
  [1123] = 855,
  [1124] = 880,
  [1125] = 881,
  [1126] = 973,
  [1127] = 563,
  [1128] = 548,
  [1129] = 1011,
  [1130] = 954,
  [1131] = 995,
  [1132] = 845,
  [1133] = 551,
  [1134] = 981,
  [1135] = 862,
  [1136] = 989,
  [1137] = 869,
  [1138] = 986,
  [1139] = 980,
  [1140] = 971,
  [1141] = 552,
  [1142] = 865,
  [1143] = 887,
  [1144] = 856,
  [1145] = 567,
  [1146] = 848,
  [1147] = 563,
  [1148] = 867,
  [1149] = 548,
  [1150] = 552,
  [1151] = 551,
  [1152] = 969,
  [1153] = 970,
  [1154] = 557,
  [1155] = 549,
  [1156] = 549,
  [1157] = 557,
  [1158] = 550,
  [1159] = 961,
  [1160] = 563,
  [1161] = 994,
  [1162] = 993,
  [1163] = 989,
  [1164] = 563,
  [1165] = 561,
  [1166] = 558,
  [1167] = 564,
  [1168] = 561,
  [1169] = 569,
  [1170] = 568,
  [1171] = 1007,
  [1172] = 989,
  [1173] = 973,
  [1174] = 569,
  [1175] = 944,
  [1176] = 568,
  [1177] = 986,
  [1178] = 986,
  [1179] = 1001,
  [1180] = 553,
  [1181] = 558,
  [1182] = 985,
  [1183] = 1011,
  [1184] = 954,
  [1185] = 1000,
  [1186] = 999,
  [1187] = 1001,
  [1188] = 981,
  [1189] = 980,
  [1190] = 995,
  [1191] = 1012,
  [1192] = 839,
  [1193] = 989,
  [1194] = 986,
  [1195] = 1000,
  [1196] = 999,
  [1197] = 998,
  [1198] = 997,
  [1199] = 975,
  [1200] = 970,
  [1201] = 969,
  [1202] = 961,
  [1203] = 969,
  [1204] = 946,
  [1205] = 970,
  [1206] = 557,
  [1207] = 945,
  [1208] = 549,
  [1209] = 998,
  [1210] = 1210,
  [1211] = 993,
  [1212] = 980,
  [1213] = 981,
  [1214] = 551,
  [1215] = 553,
  [1216] = 552,
  [1217] = 564,
  [1218] = 548,
  [1219] = 985,
  [1220] = 997,
  [1221] = 550,
  [1222] = 971,
  [1223] = 971,
  [1224] = 985,
  [1225] = 994,
  [1226] = 944,
  [1227] = 557,
  [1228] = 549,
  [1229] = 994,
  [1230] = 995,
  [1231] = 995,
  [1232] = 993,
  [1233] = 551,
  [1234] = 567,
  [1235] = 552,
  [1236] = 954,
  [1237] = 1011,
  [1238] = 980,
  [1239] = 558,
  [1240] = 954,
  [1241] = 553,
  [1242] = 1011,
  [1243] = 563,
  [1244] = 548,
  [1245] = 973,
  [1246] = 1007,
  [1247] = 985,
  [1248] = 997,
  [1249] = 993,
  [1250] = 981,
  [1251] = 980,
  [1252] = 973,
  [1253] = 567,
  [1254] = 563,
  [1255] = 563,
  [1256] = 1011,
  [1257] = 954,
  [1258] = 995,
  [1259] = 973,
  [1260] = 989,
  [1261] = 944,
  [1262] = 986,
  [1263] = 887,
  [1264] = 856,
  [1265] = 970,
  [1266] = 971,
  [1267] = 969,
  [1268] = 548,
  [1269] = 550,
  [1270] = 994,
  [1271] = 564,
  [1272] = 549,
  [1273] = 848,
  [1274] = 998,
  [1275] = 945,
  [1276] = 946,
  [1277] = 567,
  [1278] = 961,
  [1279] = 1012,
  [1280] = 975,
  [1281] = 961,
  [1282] = 946,
  [1283] = 971,
  [1284] = 997,
  [1285] = 999,
  [1286] = 945,
  [1287] = 1000,
  [1288] = 565,
  [1289] = 998,
  [1290] = 945,
  [1291] = 999,
  [1292] = 1000,
  [1293] = 563,
  [1294] = 946,
  [1295] = 1001,
  [1296] = 975,
  [1297] = 981,
  [1298] = 975,
  [1299] = 1299,
  [1300] = 1012,
  [1301] = 1301,
  [1302] = 1012,
  [1303] = 551,
  [1304] = 552,
  [1305] = 862,
  [1306] = 1007,
  [1307] = 565,
  [1308] = 1001,
  [1309] = 565,
  [1310] = 569,
  [1311] = 568,
  [1312] = 933,
  [1313] = 924,
  [1314] = 558,
  [1315] = 1315,
  [1316] = 553,
  [1317] = 969,
  [1318] = 970,
  [1319] = 944,
  [1320] = 934,
  [1321] = 866,
  [1322] = 1007,
  [1323] = 557,
  [1324] = 558,
  [1325] = 855,
  [1326] = 565,
  [1327] = 563,
  [1328] = 869,
  [1329] = 845,
  [1330] = 849,
  [1331] = 561,
  [1332] = 943,
  [1333] = 973,
  [1334] = 938,
  [1335] = 939,
  [1336] = 847,
  [1337] = 939,
  [1338] = 1011,
  [1339] = 954,
  [1340] = 943,
  [1341] = 852,
  [1342] = 945,
  [1343] = 995,
  [1344] = 946,
  [1345] = 938,
  [1346] = 882,
  [1347] = 989,
  [1348] = 986,
  [1349] = 969,
  [1350] = 961,
  [1351] = 975,
  [1352] = 567,
  [1353] = 1012,
  [1354] = 970,
  [1355] = 1007,
  [1356] = 980,
  [1357] = 981,
  [1358] = 867,
  [1359] = 861,
  [1360] = 943,
  [1361] = 939,
  [1362] = 549,
  [1363] = 938,
  [1364] = 865,
  [1365] = 880,
  [1366] = 985,
  [1367] = 881,
  [1368] = 548,
  [1369] = 552,
  [1370] = 551,
  [1371] = 993,
  [1372] = 1001,
  [1373] = 557,
  [1374] = 561,
  [1375] = 994,
  [1376] = 1000,
  [1377] = 999,
  [1378] = 997,
  [1379] = 971,
  [1380] = 944,
  [1381] = 553,
  [1382] = 998,
  [1383] = 563,
  [1384] = 564,
  [1385] = 557,
  [1386] = 553,
  [1387] = 565,
  [1388] = 563,
  [1389] = 563,
  [1390] = 563,
  [1391] = 549,
  [1392] = 558,
  [1393] = 548,
  [1394] = 550,
  [1395] = 569,
  [1396] = 568,
  [1397] = 1301,
  [1398] = 1299,
  [1399] = 552,
  [1400] = 567,
  [1401] = 551,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1299,
  [1405] = 1403,
  [1406] = 564,
  [1407] = 550,
  [1408] = 1301,
  [1409] = 1402,
  [1410] = 568,
  [1411] = 569,
  [1412] = 1402,
  [1413] = 1402,
  [1414] = 1403,
  [1415] = 1403,
  [1416] = 1402,
  [1417] = 1403,
  [1418] = 1402,
  [1419] = 1403,
  [1420] = 558,
  [1421] = 1402,
  [1422] = 1422,
  [1423] = 1403,
  [1424] = 1424,
  [1425] = 1403,
  [1426] = 563,
  [1427] = 1403,
  [1428] = 1402,
  [1429] = 1429,
  [1430] = 553,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1402,
  [1434] = 558,
  [1435] = 564,
  [1436] = 880,
  [1437] = 881,
  [1438] = 882,
  [1439] = 845,
  [1440] = 869,
  [1441] = 1441,
  [1442] = 861,
  [1443] = 1441,
  [1444] = 1441,
  [1445] = 568,
  [1446] = 1441,
  [1447] = 569,
  [1448] = 1299,
  [1449] = 1449,
  [1450] = 1301,
  [1451] = 1441,
  [1452] = 1441,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 564,
  [1456] = 550,
  [1457] = 568,
  [1458] = 569,
  [1459] = 1441,
  [1460] = 550,
  [1461] = 1301,
  [1462] = 1299,
  [1463] = 855,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 550,
  [1467] = 1441,
  [1468] = 1441,
  [1469] = 563,
  [1470] = 1422,
  [1471] = 564,
  [1472] = 569,
  [1473] = 1441,
  [1474] = 568,
  [1475] = 852,
  [1476] = 849,
  [1477] = 1431,
  [1478] = 1424,
  [1479] = 553,
  [1480] = 1299,
  [1481] = 1301,
  [1482] = 1464,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1484,
  [1486] = 1486,
  [1487] = 1453,
  [1488] = 1488,
  [1489] = 1432,
  [1490] = 1484,
  [1491] = 1454,
  [1492] = 1484,
  [1493] = 1484,
  [1494] = 1494,
  [1495] = 1494,
  [1496] = 1484,
  [1497] = 1488,
  [1498] = 1498,
  [1499] = 1484,
  [1500] = 1429,
  [1501] = 1484,
  [1502] = 1484,
  [1503] = 1488,
  [1504] = 1465,
  [1505] = 1484,
  [1506] = 1403,
  [1507] = 1507,
  [1508] = 1402,
  [1509] = 1509,
  [1510] = 1509,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1513,
  [1516] = 1516,
  [1517] = 1516,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1527,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1527,
  [1532] = 1527,
  [1533] = 1527,
  [1534] = 1527,
  [1535] = 1527,
  [1536] = 1536,
  [1537] = 1527,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1544,
  [1548] = 1538,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1551,
  [1552] = 1544,
  [1553] = 1545,
  [1554] = 1538,
  [1555] = 1555,
  [1556] = 1538,
  [1557] = 1544,
  [1558] = 1558,
  [1559] = 1544,
  [1560] = 1538,
  [1561] = 1561,
  [1562] = 1544,
  [1563] = 1563,
  [1564] = 1538,
  [1565] = 1538,
  [1566] = 1566,
  [1567] = 1544,
  [1568] = 1545,
  [1569] = 1544,
  [1570] = 1570,
  [1571] = 1545,
  [1572] = 1538,
  [1573] = 1545,
  [1574] = 1574,
  [1575] = 1545,
  [1576] = 1545,
  [1577] = 1545,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1551,
  [1582] = 1582,
  [1583] = 1582,
  [1584] = 1582,
  [1585] = 1585,
  [1586] = 1578,
  [1587] = 1558,
  [1588] = 1582,
  [1589] = 1582,
  [1590] = 1590,
  [1591] = 1582,
  [1592] = 1585,
  [1593] = 1526,
  [1594] = 1594,
  [1595] = 1585,
  [1596] = 1585,
  [1597] = 1582,
  [1598] = 1598,
  [1599] = 1585,
  [1600] = 1585,
  [1601] = 1529,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1582,
  [1605] = 1585,
  [1606] = 1574,
  [1607] = 1530,
  [1608] = 1546,
  [1609] = 1585,
  [1610] = 1543,
  [1611] = 1529,
  [1612] = 1582,
  [1613] = 1526,
  [1614] = 1561,
  [1615] = 1530,
  [1616] = 1585,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1546,
  [1620] = 1530,
  [1621] = 1543,
  [1622] = 1561,
  [1623] = 1546,
  [1624] = 1529,
  [1625] = 1551,
  [1626] = 1561,
  [1627] = 1558,
  [1628] = 1558,
  [1629] = 1629,
  [1630] = 1574,
  [1631] = 1530,
  [1632] = 1546,
  [1633] = 1543,
  [1634] = 1561,
  [1635] = 1526,
  [1636] = 1636,
  [1637] = 1529,
  [1638] = 1530,
  [1639] = 1561,
  [1640] = 1543,
  [1641] = 1574,
  [1642] = 1546,
  [1643] = 1574,
  [1644] = 1558,
  [1645] = 1645,
  [1646] = 1551,
  [1647] = 1647,
  [1648] = 1551,
  [1649] = 1558,
  [1650] = 1551,
  [1651] = 1543,
  [1652] = 1526,
  [1653] = 1526,
  [1654] = 1578,
  [1655] = 1529,
  [1656] = 1578,
  [1657] = 1574,
  [1658] = 1658,
  [1659] = 1659,
  [1660] = 1561,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1543,
  [1664] = 1546,
  [1665] = 1665,
  [1666] = 1658,
  [1667] = 1574,
  [1668] = 1558,
  [1669] = 1551,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1603,
  [1674] = 1674,
  [1675] = 1658,
  [1676] = 1525,
  [1677] = 1523,
  [1678] = 1658,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1658,
  [1682] = 1671,
  [1683] = 1680,
  [1684] = 1679,
  [1685] = 1529,
  [1686] = 1526,
  [1687] = 1679,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1658,
  [1691] = 1561,
  [1692] = 1692,
  [1693] = 1543,
  [1694] = 1546,
  [1695] = 1530,
  [1696] = 1574,
  [1697] = 1697,
  [1698] = 1647,
  [1699] = 1551,
  [1700] = 1700,
  [1701] = 1701,
  [1702] = 1662,
  [1703] = 1661,
  [1704] = 1658,
  [1705] = 1705,
  [1706] = 1706,
  [1707] = 1672,
  [1708] = 1708,
  [1709] = 1558,
  [1710] = 1710,
  [1711] = 1711,
  [1712] = 1708,
  [1713] = 1713,
  [1714] = 1714,
  [1715] = 1523,
  [1716] = 1558,
  [1717] = 1658,
  [1718] = 1718,
  [1719] = 1713,
  [1720] = 1574,
  [1721] = 1530,
  [1722] = 1546,
  [1723] = 1543,
  [1724] = 1561,
  [1725] = 1711,
  [1726] = 1658,
  [1727] = 1551,
  [1728] = 1525,
  [1729] = 1692,
  [1730] = 1692,
  [1731] = 1658,
  [1732] = 1526,
  [1733] = 1659,
  [1734] = 1734,
  [1735] = 1735,
  [1736] = 1529,
  [1737] = 1680,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1525,
  [1741] = 1511,
  [1742] = 1742,
  [1743] = 1523,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1738,
  [1747] = 1603,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1744,
  [1754] = 1738,
  [1755] = 1742,
  [1756] = 1756,
  [1757] = 1738,
  [1758] = 1751,
  [1759] = 1759,
  [1760] = 1688,
  [1761] = 1738,
  [1762] = 1751,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1738,
  [1766] = 1766,
  [1767] = 1748,
  [1768] = 1748,
  [1769] = 1744,
  [1770] = 1742,
  [1771] = 1771,
  [1772] = 1738,
  [1773] = 1738,
  [1774] = 1603,
  [1775] = 1647,
  [1776] = 1776,
  [1777] = 1647,
  [1778] = 1778,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1776,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1647,
  [1790] = 1780,
  [1791] = 1787,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1636,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1429,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1799,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1734,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1810,
  [1818] = 1795,
  [1819] = 1636,
  [1820] = 1794,
  [1821] = 1821,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 1806,
  [1825] = 1778,
  [1826] = 1826,
  [1827] = 1647,
  [1828] = 1811,
  [1829] = 1829,
  [1830] = 1518,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1783,
  [1835] = 1782,
  [1836] = 1781,
  [1837] = 1807,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1778,
  [1841] = 1779,
  [1842] = 1808,
  [1843] = 1816,
  [1844] = 1810,
  [1845] = 1636,
  [1846] = 1787,
  [1847] = 1847,
  [1848] = 1800,
  [1849] = 1849,
  [1850] = 1839,
  [1851] = 1833,
  [1852] = 1432,
  [1853] = 1807,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1780,
  [1857] = 1780,
  [1858] = 1808,
  [1859] = 1839,
  [1860] = 1860,
  [1861] = 1512,
  [1862] = 1862,
  [1863] = 1816,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 1688,
  [1867] = 1867,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1870,
  [1871] = 1871,
  [1872] = 1525,
  [1873] = 1873,
  [1874] = 1524,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1869,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1465,
  [1883] = 1812,
  [1884] = 1878,
  [1885] = 1794,
  [1886] = 1800,
  [1887] = 1795,
  [1888] = 1876,
  [1889] = 1876,
  [1890] = 1878,
  [1891] = 1891,
  [1892] = 1833,
  [1893] = 1800,
  [1894] = 1894,
  [1895] = 1895,
  [1896] = 1895,
  [1897] = 1880,
  [1898] = 1793,
  [1899] = 1869,
  [1900] = 1895,
  [1901] = 1895,
  [1902] = 1523,
  [1903] = 1551,
  [1904] = 1688,
  [1905] = 1805,
  [1906] = 1781,
  [1907] = 1454,
  [1908] = 1799,
  [1909] = 1909,
  [1910] = 1910,
  [1911] = 1911,
  [1912] = 1912,
  [1913] = 1895,
  [1914] = 1880,
  [1915] = 1915,
  [1916] = 1792,
  [1917] = 1917,
  [1918] = 1918,
  [1919] = 1895,
  [1920] = 1895,
  [1921] = 1781,
  [1922] = 1880,
  [1923] = 1558,
  [1924] = 1924,
  [1925] = 1799,
  [1926] = 1833,
  [1927] = 1782,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1803,
  [1932] = 1854,
  [1933] = 1933,
  [1934] = 1783,
  [1935] = 1453,
  [1936] = 1561,
  [1937] = 1937,
  [1938] = 1795,
  [1939] = 1794,
  [1940] = 1940,
  [1941] = 1782,
  [1942] = 1464,
  [1943] = 1895,
  [1944] = 1543,
  [1945] = 1546,
  [1946] = 1917,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 1870,
  [1950] = 1783,
  [1951] = 1951,
  [1952] = 1574,
  [1953] = 1953,
  [1954] = 1895,
  [1955] = 1895,
  [1956] = 1956,
  [1957] = 1957,
  [1958] = 1958,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1854,
  [1963] = 1963,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 1966,
  [1967] = 1940,
  [1968] = 1968,
  [1969] = 1969,
  [1970] = 1970,
  [1971] = 1971,
  [1972] = 1972,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1975,
  [1976] = 1970,
  [1977] = 1928,
  [1978] = 1948,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1982,
  [1983] = 1803,
  [1984] = 1984,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 1960,
  [1988] = 1536,
  [1989] = 1989,
  [1990] = 1990,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1930,
  [1994] = 1525,
  [1995] = 1937,
  [1996] = 1996,
  [1997] = 1997,
  [1998] = 1867,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 1523,
  [2002] = 1520,
  [2003] = 1870,
  [2004] = 1519,
  [2005] = 2005,
  [2006] = 2006,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 1854,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 1803,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 580,
  [2019] = 2019,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 1429,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 578,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 2030,
  [2031] = 2017,
  [2032] = 2032,
  [2033] = 1432,
  [2034] = 2034,
  [2035] = 2029,
  [2036] = 2007,
  [2037] = 1432,
  [2038] = 2038,
  [2039] = 2020,
  [2040] = 2040,
  [2041] = 2023,
  [2042] = 2038,
  [2043] = 2024,
  [2044] = 2025,
  [2045] = 2045,
  [2046] = 2005,
  [2047] = 2047,
  [2048] = 2028,
  [2049] = 2049,
  [2050] = 589,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2029,
  [2054] = 2054,
  [2055] = 2007,
  [2056] = 2016,
  [2057] = 2010,
  [2058] = 2054,
  [2059] = 2038,
  [2060] = 2040,
  [2061] = 2012,
  [2062] = 2040,
  [2063] = 579,
  [2064] = 2064,
  [2065] = 2038,
  [2066] = 2014,
  [2067] = 2067,
  [2068] = 2025,
  [2069] = 1854,
  [2070] = 2007,
  [2071] = 2029,
  [2072] = 577,
  [2073] = 2005,
  [2074] = 2024,
  [2075] = 2075,
  [2076] = 2010,
  [2077] = 2077,
  [2078] = 2012,
  [2079] = 2012,
  [2080] = 2040,
  [2081] = 2010,
  [2082] = 2023,
  [2083] = 2010,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 2024,
  [2088] = 2005,
  [2089] = 2089,
  [2090] = 2012,
  [2091] = 2052,
  [2092] = 2051,
  [2093] = 2020,
  [2094] = 2000,
  [2095] = 1803,
  [2096] = 2096,
  [2097] = 2025,
  [2098] = 2040,
  [2099] = 1525,
  [2100] = 2100,
  [2101] = 2077,
  [2102] = 2040,
  [2103] = 2075,
  [2104] = 2104,
  [2105] = 2038,
  [2106] = 2007,
  [2107] = 2107,
  [2108] = 2029,
  [2109] = 2030,
  [2110] = 2110,
  [2111] = 2017,
  [2112] = 2112,
  [2113] = 2107,
  [2114] = 2006,
  [2115] = 2005,
  [2116] = 2024,
  [2117] = 2085,
  [2118] = 2023,
  [2119] = 2119,
  [2120] = 2020,
  [2121] = 1523,
  [2122] = 2017,
  [2123] = 2017,
  [2124] = 2016,
  [2125] = 2028,
  [2126] = 862,
  [2127] = 2049,
  [2128] = 2017,
  [2129] = 1522,
  [2130] = 2024,
  [2131] = 1540,
  [2132] = 2132,
  [2133] = 2077,
  [2134] = 2005,
  [2135] = 2015,
  [2136] = 2014,
  [2137] = 2020,
  [2138] = 2104,
  [2139] = 2110,
  [2140] = 2023,
  [2141] = 2141,
  [2142] = 2024,
  [2143] = 2143,
  [2144] = 2029,
  [2145] = 1566,
  [2146] = 2005,
  [2147] = 1563,
  [2148] = 2148,
  [2149] = 1971,
  [2150] = 2150,
  [2151] = 2017,
  [2152] = 2040,
  [2153] = 2153,
  [2154] = 2096,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2150,
  [2158] = 2029,
  [2159] = 2159,
  [2160] = 1541,
  [2161] = 2012,
  [2162] = 1980,
  [2163] = 1542,
  [2164] = 2007,
  [2165] = 2038,
  [2166] = 2010,
  [2167] = 1803,
  [2168] = 1821,
  [2169] = 2156,
  [2170] = 2040,
  [2171] = 2017,
  [2172] = 1812,
  [2173] = 2155,
  [2174] = 2025,
  [2175] = 2025,
  [2176] = 1823,
  [2177] = 2025,
  [2178] = 2020,
  [2179] = 2085,
  [2180] = 2023,
  [2181] = 1453,
  [2182] = 2040,
  [2183] = 866,
  [2184] = 1822,
  [2185] = 2038,
  [2186] = 2007,
  [2187] = 2187,
  [2188] = 2029,
  [2189] = 1815,
  [2190] = 2024,
  [2191] = 2005,
  [2192] = 1792,
  [2193] = 2020,
  [2194] = 2005,
  [2195] = 2024,
  [2196] = 2196,
  [2197] = 2023,
  [2198] = 2052,
  [2199] = 2020,
  [2200] = 1973,
  [2201] = 2012,
  [2202] = 2017,
  [2203] = 2051,
  [2204] = 2010,
  [2205] = 2187,
  [2206] = 2029,
  [2207] = 1968,
  [2208] = 2007,
  [2209] = 1969,
  [2210] = 2010,
  [2211] = 1432,
  [2212] = 2014,
  [2213] = 1801,
  [2214] = 2096,
  [2215] = 2038,
  [2216] = 1854,
  [2217] = 1793,
  [2218] = 2040,
  [2219] = 1855,
  [2220] = 2220,
  [2221] = 2012,
  [2222] = 2025,
  [2223] = 1865,
  [2224] = 2023,
  [2225] = 2024,
  [2226] = 1864,
  [2227] = 2005,
  [2228] = 672,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 1947,
  [2232] = 579,
  [2233] = 2233,
  [2234] = 1929,
  [2235] = 1465,
  [2236] = 2236,
  [2237] = 1464,
  [2238] = 1580,
  [2239] = 2239,
  [2240] = 589,
  [2241] = 2241,
  [2242] = 578,
  [2243] = 577,
  [2244] = 2241,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 1930,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2027,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 1617,
  [2258] = 2233,
  [2259] = 1947,
  [2260] = 677,
  [2261] = 1454,
  [2262] = 2233,
  [2263] = 1590,
  [2264] = 2034,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2256,
  [2268] = 580,
  [2269] = 2141,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2245,
  [2275] = 2275,
  [2276] = 2250,
  [2277] = 2251,
  [2278] = 2233,
  [2279] = 2279,
  [2280] = 2265,
  [2281] = 2281,
  [2282] = 2273,
  [2283] = 1590,
  [2284] = 1454,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2251,
  [2288] = 2250,
  [2289] = 2245,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2233,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2294,
  [2297] = 2297,
  [2298] = 1953,
  [2299] = 1910,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 1464,
  [2305] = 2305,
  [2306] = 663,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2302,
  [2310] = 1453,
  [2311] = 2233,
  [2312] = 1947,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 1465,
  [2320] = 2320,
  [2321] = 2279,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2300,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2233,
  [2333] = 2333,
  [2334] = 649,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 1912,
  [2340] = 2300,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2344,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2367,
  [2369] = 2344,
  [2370] = 2363,
  [2371] = 2360,
  [2372] = 2359,
  [2373] = 2367,
  [2374] = 2374,
  [2375] = 2356,
  [2376] = 2355,
  [2377] = 2353,
  [2378] = 2350,
  [2379] = 2349,
  [2380] = 2347,
  [2381] = 2345,
  [2382] = 2365,
  [2383] = 2361,
  [2384] = 2384,
  [2385] = 2348,
  [2386] = 2386,
  [2387] = 2349,
  [2388] = 2388,
  [2389] = 2367,
  [2390] = 2388,
  [2391] = 2344,
  [2392] = 2363,
  [2393] = 2344,
  [2394] = 2363,
  [2395] = 2360,
  [2396] = 2361,
  [2397] = 2360,
  [2398] = 2345,
  [2399] = 2359,
  [2400] = 2347,
  [2401] = 2359,
  [2402] = 2349,
  [2403] = 2350,
  [2404] = 2356,
  [2405] = 2355,
  [2406] = 2353,
  [2407] = 2407,
  [2408] = 2355,
  [2409] = 2356,
  [2410] = 2353,
  [2411] = 2350,
  [2412] = 2359,
  [2413] = 2360,
  [2414] = 2349,
  [2415] = 2347,
  [2416] = 2363,
  [2417] = 2344,
  [2418] = 2345,
  [2419] = 2361,
  [2420] = 2348,
  [2421] = 2367,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 577,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2365,
  [2430] = 2366,
  [2431] = 2367,
  [2432] = 2388,
  [2433] = 2344,
  [2434] = 2363,
  [2435] = 2360,
  [2436] = 2359,
  [2437] = 2356,
  [2438] = 2355,
  [2439] = 2353,
  [2440] = 2440,
  [2441] = 2350,
  [2442] = 2442,
  [2443] = 2443,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 2361,
  [2447] = 2447,
  [2448] = 2353,
  [2449] = 2355,
  [2450] = 2356,
  [2451] = 2451,
  [2452] = 2347,
  [2453] = 2345,
  [2454] = 2361,
  [2455] = 589,
  [2456] = 2348,
  [2457] = 2427,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2356,
  [2461] = 2355,
  [2462] = 2462,
  [2463] = 2463,
  [2464] = 2464,
  [2465] = 2427,
  [2466] = 2365,
  [2467] = 2366,
  [2468] = 2468,
  [2469] = 2361,
  [2470] = 2353,
  [2471] = 2355,
  [2472] = 2356,
  [2473] = 2353,
  [2474] = 2367,
  [2475] = 2388,
  [2476] = 2363,
  [2477] = 2360,
  [2478] = 2359,
  [2479] = 2356,
  [2480] = 2480,
  [2481] = 2355,
  [2482] = 2353,
  [2483] = 2350,
  [2484] = 2350,
  [2485] = 2349,
  [2486] = 2347,
  [2487] = 2349,
  [2488] = 2345,
  [2489] = 2347,
  [2490] = 2345,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2494,
  [2496] = 2492,
  [2497] = 2361,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2443,
  [2504] = 2352,
  [2505] = 2348,
  [2506] = 2386,
  [2507] = 579,
  [2508] = 2508,
  [2509] = 2451,
  [2510] = 2462,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 578,
  [2518] = 2518,
  [2519] = 2518,
  [2520] = 2520,
  [2521] = 2511,
  [2522] = 2462,
  [2523] = 2523,
  [2524] = 2524,
  [2525] = 2361,
  [2526] = 2526,
  [2527] = 2463,
  [2528] = 2386,
  [2529] = 2459,
  [2530] = 2427,
  [2531] = 2451,
  [2532] = 2532,
  [2533] = 2384,
  [2534] = 2512,
  [2535] = 2535,
  [2536] = 2365,
  [2537] = 2366,
  [2538] = 2367,
  [2539] = 2388,
  [2540] = 2344,
  [2541] = 2348,
  [2542] = 2363,
  [2543] = 2543,
  [2544] = 2360,
  [2545] = 2359,
  [2546] = 2356,
  [2547] = 2355,
  [2548] = 2548,
  [2549] = 2353,
  [2550] = 2550,
  [2551] = 2350,
  [2552] = 2349,
  [2553] = 580,
  [2554] = 2347,
  [2555] = 2345,
  [2556] = 2494,
  [2557] = 2361,
  [2558] = 2558,
  [2559] = 2512,
  [2560] = 2560,
  [2561] = 2348,
  [2562] = 2562,
  [2563] = 2563,
  [2564] = 2564,
  [2565] = 2565,
  [2566] = 2566,
  [2567] = 2567,
  [2568] = 2568,
  [2569] = 2535,
  [2570] = 2508,
  [2571] = 2442,
  [2572] = 2572,
  [2573] = 2573,
  [2574] = 2513,
  [2575] = 2575,
  [2576] = 2576,
  [2577] = 2560,
  [2578] = 2578,
  [2579] = 2502,
  [2580] = 2407,
  [2581] = 2407,
};

static TSCharacterRange sym_python_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d},
  {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339},
  {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5},
  {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a},
  {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f},
  {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32},
  {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40},
  {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89},
  {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e},
  {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77},
  {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7},
  {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167},
  {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f},
  {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a},
  {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5},
  {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788},
  {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad},
  {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b},
  {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39},
  {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54},
  {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a},
  {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9},
  {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
};

static TSCharacterRange sym_python_identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf2}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xecd},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115},
  {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e},
  {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f},
  {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6},
  {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a},
  {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf},
  {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c}, {0xa840, 0xa873},
  {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c}, {0xa980, 0xa9c0},
  {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2}, {0xaadb, 0xaadd},
  {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a},
  {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d},
  {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41},
  {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f},
  {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff66, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f},
  {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9},
  {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595},
  {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785},
  {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855},
  {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf},
  {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075}, {0x1107f, 0x110ba},
  {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173}, {0x11176, 0x11176},
  {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x1123e}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303}, {0x11305, 0x1130c},
  {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348}, {0x1134b, 0x1134d},
  {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459}, {0x1145e, 0x11461},
  {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640}, {0x11644, 0x11644},
  {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746}, {0x11800, 0x1183a},
  {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938}, {0x1193b, 0x11943},
  {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47}, {0x11a50, 0x11a99},
  {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7},
  {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47}, {0x11d50, 0x11d59},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6}, {0x11fb0, 0x11fb0},
  {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59},
  {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4},
  {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122},
  {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e},
  {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244},
  {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb},
  {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544},
  {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734},
  {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36},
  {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1e000, 0x1e006}, {0x1e008, 0x1e018},
  {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae},
  {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b},
  {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37},
  {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52},
  {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64},
  {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3},
  {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(195);
      ADVANCE_MAP(
        0, 202,
        '!', 251,
        '"', 247,
        '#', 969,
        '$', 492,
        '%', 598,
        '&', 606,
        '\'', 493,
        '(', 478,
        ')', 479,
        '*', 526,
        '+', 587,
        ',', 519,
        '-', 588,
        '.', 513,
        '/', 595,
        '0', 658,
        ':', 229,
        ';', 508,
        '<', 612,
        '=', 206,
        '>', 618,
        '?', 252,
        '@', 593,
        'E', 281,
        'F', 293,
        'I', 264,
        'N', 394,
        'O', 280,
        'T', 409,
        '[', 215,
        '\\', 642,
        ']', 227,
        '^', 608,
        '_', 282,
        'a', 311,
        'b', 332,
        'c', 396,
        'd', 319,
        'e', 365,
        'f', 289,
        'g', 369,
        'i', 345,
        'l', 290,
        'm', 295,
        'n', 391,
        'o', 410,
        'p', 291,
        'r', 294,
        't', 411,
        'u', 381,
        'w', 352,
        'y', 355,
        '{', 480,
        '|', 604,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(659);
      if (lookahead != 0) ADVANCE(454);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        0, 202,
        '\n', 196,
        '\r', 1,
        '#', 970,
        '$', 174,
        '+', 83,
        '.', 84,
        ':', 229,
        '=', 205,
        '?', 87,
        '[', 215,
        '\\', 15,
        'a', 943,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(1);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 2:
      if ((!eof && lookahead == 00)) ADVANCE(202);
      if (lookahead == '\n') ADVANCE(198);
      if (lookahead == '\r') ADVANCE(2);
      if (lookahead == '#') ADVANCE(969);
      if (lookahead == '$') ADVANCE(174);
      if (lookahead == '\\') ADVANCE(249);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(2);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 3:
      if ((!eof && lookahead == 00)) ADVANCE(202);
      if (lookahead == '\n') ADVANCE(199);
      if (lookahead == '\r') ADVANCE(3);
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == 'b') ADVANCE(941);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(3);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 4:
      if ((!eof && lookahead == 00)) ADVANCE(202);
      if (lookahead == '\n') ADVANCE(200);
      if (lookahead == '\r') ADVANCE(4);
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '\\') ADVANCE(15);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(4);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 5:
      if ((!eof && lookahead == 00)) ADVANCE(202);
      if (lookahead == '\n') ADVANCE(201);
      if (lookahead == '\r') ADVANCE(5);
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == 'a') ADVANCE(139);
      if (lookahead == 'b') ADVANCE(135);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(5);
      END_STATE();
    case 6:
      if ((!eof && lookahead == 00)) ADVANCE(838);
      if (lookahead == '\n') ADVANCE(498);
      if (lookahead == '\r') ADVANCE(11);
      END_STATE();
    case 7:
      if ((!eof && lookahead == 00)) ADVANCE(203);
      if (lookahead == '\n') ADVANCE(197);
      if (lookahead == '\r') ADVANCE(7);
      if (lookahead == ' ') SKIP(7);
      if (lookahead == '#') ADVANCE(968);
      if (lookahead == '$') ADVANCE(173);
      if (lookahead == '\\') ADVANCE(9);
      if (('\t' <= lookahead && lookahead <= '\f')) ADVANCE(8);
      if (lookahead != 0) ADVANCE(191);
      END_STATE();
    case 8:
      if ((!eof && lookahead == 00)) ADVANCE(203);
      if (lookahead == '\n') ADVANCE(197);
      if (lookahead == '\r') ADVANCE(7);
      if (lookahead == ' ') SKIP(7);
      if (lookahead == '#') ADVANCE(243);
      if (lookahead == '$') ADVANCE(242);
      if (lookahead == '\\') ADVANCE(240);
      if (('\t' <= lookahead && lookahead <= '\f')) ADVANCE(239);
      if (lookahead != 0) ADVANCE(244);
      END_STATE();
    case 9:
      if ((!eof && lookahead == 00)) ADVANCE(244);
      if (lookahead == '\n') ADVANCE(838);
      if (lookahead == '\r') ADVANCE(10);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 10:
      if (lookahead == '\n') ADVANCE(838);
      END_STATE();
    case 11:
      if (lookahead == '\n') ADVANCE(498);
      END_STATE();
    case 12:
      if (lookahead == '\n') ADVANCE(498);
      if (lookahead == '\r') ADVANCE(11);
      END_STATE();
    case 13:
      if (lookahead == '\n') ADVANCE(641);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(14);
      if (lookahead == '#') ADVANCE(646);
      if (lookahead == '\\') ADVANCE(644);
      if (lookahead == '{') ADVANCE(480);
      if (lookahead == '}') ADVANCE(481);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(645);
      if (lookahead != 0) ADVANCE(646);
      END_STATE();
    case 15:
      if (lookahead == '\r') ADVANCE(10);
      if ((!eof && lookahead == 00) ||
          lookahead == '\n') ADVANCE(838);
      END_STATE();
    case 16:
      if (lookahead == '\r') ADVANCE(485);
      if (lookahead == '"') ADVANCE(247);
      if (lookahead == '#') ADVANCE(482);
      if (lookahead == '$') ADVANCE(492);
      if (lookahead == '\\') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(485);
      if (lookahead != 0) ADVANCE(486);
      END_STATE();
    case 17:
      if (lookahead == '\r') ADVANCE(495);
      if (lookahead == '"') ADVANCE(497);
      if (lookahead == '#') ADVANCE(494);
      if (lookahead == '$') ADVANCE(103);
      if (lookahead == '\'') ADVANCE(493);
      if (lookahead == '\\') ADVANCE(6);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(495);
      if (lookahead != 0) ADVANCE(498);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '!', 190,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        ')', 479,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 514,
        '/', 596,
        '0', 655,
        ':', 228,
        '<', 77,
        '=', 204,
        '>', 97,
        '@', 592,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 607,
        'a', 792,
        'e', 811,
        'm', 684,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 603,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '!', 190,
        '#', 970,
        '(', 478,
        ')', 479,
        '*', 525,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 74,
        '0', 655,
        ':', 228,
        ';', 508,
        '=', 204,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        ']', 227,
        'a', 792,
        'e', 811,
        'f', 785,
        'l', 683,
        'm', 684,
        'n', 773,
        'p', 784,
        't', 814,
        '{', 480,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '!', 190,
        '#', 970,
        '(', 478,
        ')', 479,
        '*', 525,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 74,
        '0', 655,
        ':', 228,
        ';', 508,
        '=', 204,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        ']', 227,
        'a', 792,
        'e', 811,
        'l', 683,
        'm', 684,
        'n', 773,
        'p', 784,
        't', 814,
        '{', 480,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(20);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '!', 190,
        '#', 970,
        '(', 478,
        ')', 479,
        '*', 525,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 74,
        '0', 655,
        ':', 228,
        '=', 204,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        ']', 227,
        'a', 792,
        'e', 811,
        'm', 684,
        'p', 784,
        't', 814,
        '{', 480,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '!', 80,
        '#', 970,
        '%', 598,
        '&', 606,
        '(', 478,
        ')', 479,
        '*', 526,
        '+', 587,
        ',', 519,
        '-', 589,
        '.', 512,
        '/', 595,
        ':', 228,
        ';', 508,
        '<', 612,
        '=', 207,
        '>', 618,
        '@', 593,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 608,
        'a', 149,
        'e', 144,
        'f', 163,
        'i', 138,
        'n', 153,
        'o', 160,
        '|', 604,
        '}', 481,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '!', 80,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        ')', 479,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 588,
        '.', 512,
        '/', 596,
        ':', 229,
        ';', 508,
        '<', 613,
        '=', 207,
        '>', 619,
        '@', 592,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 607,
        'a', 149,
        'e', 144,
        'f', 163,
        'i', 138,
        'n', 153,
        'o', 160,
        '|', 603,
        '}', 481,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '!', 80,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        ')', 479,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 588,
        '.', 512,
        '/', 596,
        ':', 228,
        ';', 508,
        '<', 613,
        '=', 207,
        '>', 619,
        '@', 592,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 607,
        'a', 149,
        'e', 144,
        'f', 163,
        'i', 138,
        'n', 153,
        'o', 160,
        '|', 603,
        '}', 481,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(24);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '!', 80,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        ')', 479,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 514,
        '/', 596,
        '0', 655,
        ':', 229,
        ';', 508,
        '<', 613,
        '=', 207,
        '>', 619,
        '@', 592,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 607,
        'a', 758,
        'e', 811,
        'i', 722,
        'm', 684,
        'n', 773,
        'o', 782,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 603,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(25);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '!', 80,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        ')', 479,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 514,
        '/', 596,
        '0', 655,
        ':', 228,
        ';', 508,
        '<', 613,
        '=', 207,
        '>', 619,
        '@', 592,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 607,
        'a', 758,
        'e', 811,
        'i', 722,
        'm', 684,
        'n', 773,
        'o', 782,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 603,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 598,
        '&', 606,
        '(', 478,
        ')', 479,
        '*', 526,
        '+', 587,
        ',', 519,
        '-', 589,
        '.', 512,
        '/', 595,
        ':', 229,
        ';', 508,
        '<', 612,
        '=', 207,
        '>', 618,
        '@', 593,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 608,
        'a', 149,
        'e', 145,
        'f', 142,
        'i', 137,
        'n', 153,
        'o', 160,
        'w', 143,
        '|', 604,
        '}', 481,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 598,
        '&', 606,
        '(', 478,
        '*', 526,
        '+', 587,
        ',', 519,
        '-', 590,
        '.', 514,
        '/', 595,
        '0', 655,
        ':', 229,
        ';', 508,
        '<', 612,
        '=', 207,
        '>', 618,
        '@', 593,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        '^', 608,
        'a', 758,
        'e', 811,
        'i', 722,
        'l', 683,
        'm', 684,
        'n', 773,
        'o', 782,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 604,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 598,
        '&', 606,
        '(', 478,
        '*', 526,
        '+', 587,
        ',', 519,
        '-', 590,
        '.', 514,
        '/', 595,
        '0', 655,
        ':', 229,
        ';', 508,
        '<', 612,
        '=', 207,
        '>', 618,
        '@', 593,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        '^', 608,
        'a', 758,
        'e', 811,
        'i', 722,
        'm', 684,
        'n', 773,
        'o', 782,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 604,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(29);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 598,
        '&', 606,
        '(', 478,
        '*', 526,
        '+', 587,
        ',', 519,
        '-', 590,
        '.', 514,
        '/', 595,
        '0', 655,
        ':', 228,
        ';', 508,
        '<', 612,
        '=', 207,
        '>', 618,
        '@', 593,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        '^', 608,
        'a', 758,
        'e', 811,
        'i', 722,
        'm', 684,
        'n', 773,
        'o', 782,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 604,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 598,
        '&', 606,
        '(', 478,
        '*', 526,
        '+', 587,
        ',', 519,
        '-', 589,
        '.', 512,
        '/', 595,
        ':', 229,
        ';', 508,
        '<', 612,
        '=', 207,
        '>', 618,
        '@', 593,
        '[', 215,
        '\\', 15,
        '^', 608,
        'a', 825,
        'i', 822,
        'n', 826,
        'o', 829,
        '|', 604,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(31);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        ')', 479,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 588,
        '.', 512,
        '/', 596,
        ':', 229,
        '<', 613,
        '=', 207,
        '>', 619,
        '@', 592,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 607,
        'a', 150,
        'f', 155,
        'i', 138,
        'n', 153,
        'o', 160,
        '|', 603,
        '}', 481,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(32);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        ')', 479,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 588,
        '.', 512,
        '/', 596,
        ':', 228,
        '<', 613,
        '=', 86,
        '>', 619,
        '@', 592,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 607,
        'a', 150,
        'f', 155,
        'i', 138,
        'n', 153,
        'o', 160,
        '|', 603,
        '}', 481,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33);
      END_STATE();
    case 34:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        ')', 479,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 514,
        '/', 596,
        '0', 655,
        ':', 229,
        '<', 613,
        '=', 207,
        '>', 619,
        '@', 592,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        ']', 227,
        '^', 607,
        'a', 758,
        'e', 811,
        'f', 771,
        'i', 722,
        'm', 684,
        'n', 773,
        'o', 782,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 603,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 35:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 514,
        '/', 596,
        '0', 655,
        ':', 228,
        '<', 613,
        '=', 86,
        '>', 619,
        '@', 592,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        '^', 607,
        'a', 758,
        'e', 811,
        'f', 771,
        'i', 722,
        'm', 684,
        'n', 773,
        'o', 782,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 603,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 36:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 514,
        '/', 596,
        '0', 655,
        ':', 85,
        ';', 508,
        '<', 613,
        '=', 86,
        '>', 619,
        '@', 592,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        '^', 607,
        'a', 758,
        'e', 811,
        'f', 785,
        'i', 722,
        'm', 684,
        'n', 773,
        'o', 782,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 603,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        '!', 79,
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        '*', 527,
        '+', 586,
        '-', 591,
        '.', 514,
        '/', 596,
        '0', 655,
        ':', 85,
        '<', 613,
        '=', 86,
        '>', 619,
        '@', 592,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        '^', 607,
        'a', 758,
        'e', 750,
        'i', 722,
        'm', 684,
        'n', 773,
        'o', 782,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 603,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(37);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 38:
      if (lookahead == '"') ADVANCE(489);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(38);
      END_STATE();
    case 39:
      if (lookahead == '"') ADVANCE(246);
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '\'') ADVANCE(493);
      if (lookahead == '(') ADVANCE(478);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == '}') ADVANCE(481);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 40:
      if (lookahead == '#') ADVANCE(969);
      if (lookahead == '$') ADVANCE(174);
      if (lookahead == '\\') ADVANCE(249);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(40);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        '#', 970,
        '$', 174,
        '(', 478,
        '*', 525,
        '+', 587,
        '-', 591,
        '.', 73,
        '0', 655,
        ':', 229,
        '=', 205,
        '?', 87,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 789,
        'b', 783,
        'c', 768,
        'd', 705,
        'e', 811,
        'f', 770,
        'g', 744,
        'i', 721,
        'l', 683,
        'm', 684,
        'n', 766,
        'p', 685,
        'r', 689,
        't', 780,
        'w', 728,
        'y', 731,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 42:
      ADVANCE_MAP(
        '#', 970,
        '$', 174,
        '(', 478,
        '+', 83,
        '.', 964,
        ':', 229,
        '=', 205,
        '?', 87,
        '[', 215,
        '\\', 15,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(42);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 43:
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '$') ADVANCE(174);
      if (lookahead == '(') ADVANCE(478);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == '\\') ADVANCE(15);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 44:
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '$') ADVANCE(174);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == 'a') ADVANCE(910);
      if (lookahead == 'p') ADVANCE(919);
      if (lookahead == 'r') ADVANCE(878);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 45:
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '$') ADVANCE(176);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == 'f') ADVANCE(938);
      if (lookahead == '}') ADVANCE(481);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '#', 970,
        '%', 598,
        '&', 606,
        '(', 478,
        '*', 526,
        '+', 587,
        ',', 519,
        '-', 590,
        '.', 514,
        '/', 595,
        '0', 655,
        ':', 228,
        ';', 508,
        '<', 76,
        '=', 204,
        '>', 96,
        '@', 593,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        '^', 608,
        'a', 792,
        'e', 811,
        'm', 684,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 604,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '#', 970,
        '%', 597,
        '&', 605,
        '(', 478,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 514,
        '/', 596,
        '0', 655,
        '<', 77,
        '>', 97,
        '@', 592,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        '^', 607,
        'a', 792,
        'e', 811,
        'i', 756,
        'm', 684,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 603,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '#', 970,
        '%', 81,
        '&', 82,
        '(', 478,
        '*', 528,
        '+', 587,
        '-', 590,
        '.', 74,
        '/', 75,
        '0', 655,
        ':', 228,
        ';', 508,
        '<', 78,
        '=', 204,
        '>', 99,
        '@', 88,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        '^', 89,
        'a', 792,
        'e', 811,
        'm', 684,
        'p', 784,
        't', 814,
        '{', 480,
        '|', 90,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        ')', 479,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        ']', 227,
        'a', 792,
        'e', 811,
        'f', 771,
        'i', 723,
        'l', 683,
        'm', 684,
        'n', 773,
        'p', 784,
        't', 814,
        '{', 480,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        ')', 479,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        ']', 227,
        'a', 792,
        'e', 811,
        'l', 683,
        'm', 684,
        'n', 773,
        'p', 784,
        't', 814,
        'y', 731,
        '{', 480,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        ')', 479,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 792,
        'e', 811,
        'l', 683,
        'm', 684,
        'n', 773,
        'p', 784,
        't', 814,
        '{', 480,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        ')', 479,
        '*', 527,
        '-', 98,
        '/', 594,
        ':', 228,
        ';', 508,
        '\\', 15,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 789,
        'b', 783,
        'c', 768,
        'd', 705,
        'e', 811,
        'f', 734,
        'g', 744,
        'i', 721,
        'l', 683,
        'm', 684,
        'n', 766,
        'p', 685,
        'r', 689,
        't', 780,
        'w', 728,
        'y', 731,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 54:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 789,
        'b', 783,
        'c', 768,
        'd', 705,
        'e', 750,
        'f', 770,
        'g', 744,
        'i', 721,
        'l', 683,
        'm', 684,
        'n', 766,
        'p', 685,
        'r', 689,
        't', 780,
        'w', 728,
        'y', 731,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 789,
        'b', 783,
        'c', 768,
        'd', 705,
        'e', 749,
        'f', 734,
        'g', 744,
        'i', 721,
        'l', 683,
        'm', 684,
        'n', 766,
        'p', 685,
        'r', 689,
        't', 780,
        'w', 728,
        'y', 731,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 789,
        'b', 783,
        'c', 768,
        'd', 705,
        'e', 741,
        'f', 770,
        'g', 744,
        'i', 721,
        'l', 683,
        'm', 684,
        'n', 766,
        'p', 685,
        'r', 689,
        't', 780,
        'w', 728,
        'y', 731,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 789,
        'b', 783,
        'c', 768,
        'd', 705,
        'e', 751,
        'f', 734,
        'g', 744,
        'i', 721,
        'l', 683,
        'm', 684,
        'n', 766,
        'p', 685,
        'r', 689,
        't', 780,
        'w', 728,
        'y', 731,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 58:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 789,
        'b', 783,
        'c', 768,
        'd', 719,
        'e', 811,
        'f', 785,
        'g', 744,
        'i', 752,
        'l', 683,
        'm', 684,
        'n', 766,
        'p', 685,
        'r', 689,
        't', 814,
        'y', 731,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 59:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 792,
        'e', 811,
        'i', 756,
        'm', 684,
        'p', 784,
        't', 814,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 60:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 525,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 792,
        'e', 811,
        'm', 684,
        'n', 773,
        'p', 784,
        't', 814,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(60);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 61:
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '(') ADVANCE(478);
      if (lookahead == '*') ADVANCE(525);
      if (lookahead == '\\') ADVANCE(15);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 62:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 527,
        '+', 586,
        ',', 519,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 792,
        'e', 811,
        'l', 683,
        'm', 684,
        'n', 773,
        'p', 784,
        't', 814,
        'y', 731,
        '{', 480,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(62);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        '#', 970,
        '(', 478,
        '*', 527,
        '+', 586,
        '-', 591,
        '.', 74,
        '0', 655,
        'F', 688,
        'N', 765,
        'T', 779,
        '[', 215,
        '\\', 15,
        'a', 789,
        'b', 783,
        'c', 768,
        'd', 719,
        'e', 811,
        'f', 785,
        'g', 744,
        'i', 752,
        'l', 683,
        'm', 684,
        'n', 766,
        'p', 685,
        'r', 689,
        't', 814,
        'y', 731,
        '{', 480,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(63);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 64:
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == '_') ADVANCE(817);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(64);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 65:
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == 'i') ADVANCE(824);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(65);
      if (set_contains(sym_python_identifier_character_set_1, 656, lookahead)) ADVANCE(837);
      END_STATE();
    case 66:
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(958);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 67:
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == '{') ADVANCE(480);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67);
      END_STATE();
    case 68:
      if (lookahead == '#') ADVANCE(970);
      if (lookahead == '\\') ADVANCE(643);
      if (lookahead == '{') ADVANCE(480);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67);
      END_STATE();
    case 69:
      if (lookahead == '#') ADVANCE(968);
      if (lookahead == '$') ADVANCE(173);
      if (lookahead == '\\') ADVANCE(9);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f') ADVANCE(70);
      if (('\n' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (lookahead != 0) ADVANCE(191);
      END_STATE();
    case 70:
      if (lookahead == '#') ADVANCE(243);
      if (lookahead == '$') ADVANCE(242);
      if (lookahead == '\\') ADVANCE(240);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f') ADVANCE(241);
      if (('\n' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (lookahead != 0) ADVANCE(244);
      END_STATE();
    case 71:
      if (lookahead == '#') ADVANCE(225);
      if (lookahead == '\\') ADVANCE(218);
      if (lookahead == 'n') ADVANCE(223);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f') ADVANCE(219);
      if (('\n' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 72:
      if (lookahead == '.') ADVANCE(640);
      END_STATE();
    case 73:
      if (lookahead == '.') ADVANCE(72);
      if (lookahead == '=') ADVANCE(213);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(669);
      END_STATE();
    case 74:
      if (lookahead == '.') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(669);
      END_STATE();
    case 75:
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '=') ADVANCE(628);
      END_STATE();
    case 76:
      if (lookahead == '<') ADVANCE(610);
      END_STATE();
    case 77:
      if (lookahead == '<') ADVANCE(609);
      END_STATE();
    case 78:
      if (lookahead == '<') ADVANCE(93);
      END_STATE();
    case 79:
      if (lookahead == '=') ADVANCE(616);
      END_STATE();
    case 80:
      if (lookahead == '=') ADVANCE(616);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(647);
      END_STATE();
    case 81:
      if (lookahead == '=') ADVANCE(631);
      END_STATE();
    case 82:
      if (lookahead == '=') ADVANCE(635);
      END_STATE();
    case 83:
      if (lookahead == '=') ADVANCE(211);
      END_STATE();
    case 84:
      if (lookahead == '=') ADVANCE(213);
      END_STATE();
    case 85:
      if (lookahead == '=') ADVANCE(210);
      END_STATE();
    case 86:
      if (lookahead == '=') ADVANCE(615);
      END_STATE();
    case 87:
      if (lookahead == '=') ADVANCE(208);
      if (lookahead == '?') ADVANCE(95);
      END_STATE();
    case 88:
      if (lookahead == '=') ADVANCE(629);
      END_STATE();
    case 89:
      if (lookahead == '=') ADVANCE(636);
      END_STATE();
    case 90:
      if (lookahead == '=') ADVANCE(637);
      END_STATE();
    case 91:
      if (lookahead == '=') ADVANCE(632);
      END_STATE();
    case 92:
      if (lookahead == '=') ADVANCE(630);
      END_STATE();
    case 93:
      if (lookahead == '=') ADVANCE(634);
      END_STATE();
    case 94:
      if (lookahead == '=') ADVANCE(633);
      END_STATE();
    case 95:
      if (lookahead == '=') ADVANCE(209);
      END_STATE();
    case 96:
      if (lookahead == '>') ADVANCE(532);
      END_STATE();
    case 97:
      if (lookahead == '>') ADVANCE(531);
      END_STATE();
    case 98:
      if (lookahead == '>') ADVANCE(507);
      END_STATE();
    case 99:
      if (lookahead == '>') ADVANCE(94);
      END_STATE();
    case 100:
      if (lookahead == '@') ADVANCE(499);
      END_STATE();
    case 101:
      if (lookahead == 'A') ADVANCE(121);
      END_STATE();
    case 102:
      if (lookahead == 'A') ADVANCE(106);
      END_STATE();
    case 103:
      if (lookahead == 'B') ADVANCE(104);
      if (lookahead == '{') ADVANCE(502);
      END_STATE();
    case 104:
      if (lookahead == 'B') ADVANCE(126);
      END_STATE();
    case 105:
      if (lookahead == 'D') ADVANCE(111);
      END_STATE();
    case 106:
      if (lookahead == 'D') ADVANCE(105);
      END_STATE();
    case 107:
      if (lookahead == 'E') ADVANCE(113);
      END_STATE();
    case 108:
      if (lookahead == 'G') ADVANCE(110);
      END_STATE();
    case 109:
      if (lookahead == 'H') ADVANCE(118);
      END_STATE();
    case 110:
      if (lookahead == 'H') ADVANCE(490);
      END_STATE();
    case 111:
      if (lookahead == 'I') ADVANCE(123);
      END_STATE();
    case 112:
      if (lookahead == 'I') ADVANCE(116);
      END_STATE();
    case 113:
      if (lookahead == 'N') ADVANCE(125);
      END_STATE();
    case 114:
      if (lookahead == 'N') ADVANCE(120);
      END_STATE();
    case 115:
      if (lookahead == 'O') ADVANCE(124);
      END_STATE();
    case 116:
      if (lookahead == 'O') ADVANCE(114);
      END_STATE();
    case 117:
      if (lookahead == 'P') ADVANCE(101);
      END_STATE();
    case 118:
      if (lookahead == 'R') ADVANCE(115);
      END_STATE();
    case 119:
      if (lookahead == 'S') ADVANCE(122);
      END_STATE();
    case 120:
      if (lookahead == 'S') ADVANCE(491);
      END_STATE();
    case 121:
      if (lookahead == 'S') ADVANCE(119);
      END_STATE();
    case 122:
      if (lookahead == 'T') ADVANCE(109);
      END_STATE();
    case 123:
      if (lookahead == 'T') ADVANCE(112);
      END_STATE();
    case 124:
      if (lookahead == 'U') ADVANCE(108);
      END_STATE();
    case 125:
      if (lookahead == 'V') ADVANCE(127);
      END_STATE();
    case 126:
      if (lookahead == '_') ADVANCE(107);
      END_STATE();
    case 127:
      if (lookahead == '_') ADVANCE(117);
      END_STATE();
    case 128:
      if (lookahead == 'a') ADVANCE(147);
      END_STATE();
    case 129:
      if (lookahead == 'c') ADVANCE(562);
      END_STATE();
    case 130:
      if (lookahead == 'c') ADVANCE(134);
      END_STATE();
    case 131:
      if (lookahead == 'd') ADVANCE(580);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(560);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(467);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 135:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 136:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 137:
      if (lookahead == 'f') ADVANCE(555);
      if (lookahead == 'm') ADVANCE(158);
      if (lookahead == 'n') ADVANCE(552);
      if (lookahead == 's') ADVANCE(621);
      END_STATE();
    case 138:
      if (lookahead == 'f') ADVANCE(555);
      if (lookahead == 'n') ADVANCE(552);
      if (lookahead == 's') ADVANCE(621);
      END_STATE();
    case 139:
      if (lookahead == 'f') ADVANCE(171);
      END_STATE();
    case 140:
      if (lookahead == 'f') ADVANCE(157);
      END_STATE();
    case 141:
      if (lookahead == 'h') ADVANCE(575);
      END_STATE();
    case 142:
      if (lookahead == 'i') ADVANCE(151);
      if (lookahead == 'o') ADVANCE(161);
      if (lookahead == 'r') ADVANCE(154);
      END_STATE();
    case 143:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 144:
      if (lookahead == 'l') ADVANCE(166);
      END_STATE();
    case 145:
      if (lookahead == 'l') ADVANCE(166);
      if (lookahead == 'x') ADVANCE(130);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(172);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(146);
      END_STATE();
    case 148:
      if (lookahead == 'm') ADVANCE(515);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(131);
      if (lookahead == 's') ADVANCE(520);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(131);
      if (lookahead == 's') ADVANCE(522);
      END_STATE();
    case 151:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 152:
      if (lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 153:
      if (lookahead == 'o') ADVANCE(167);
      END_STATE();
    case 154:
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 155:
      if (lookahead == 'o') ADVANCE(161);
      END_STATE();
    case 156:
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 157:
      if (lookahead == 'o') ADVANCE(165);
      END_STATE();
    case 158:
      if (lookahead == 'p') ADVANCE(156);
      END_STATE();
    case 159:
      if (lookahead == 'p') ADVANCE(168);
      END_STATE();
    case 160:
      if (lookahead == 'r') ADVANCE(583);
      END_STATE();
    case 161:
      if (lookahead == 'r') ADVANCE(564);
      END_STATE();
    case 162:
      if (lookahead == 'r') ADVANCE(465);
      END_STATE();
    case 163:
      if (lookahead == 'r') ADVANCE(154);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(169);
      END_STATE();
    case 165:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 166:
      if (lookahead == 's') ADVANCE(132);
      END_STATE();
    case 167:
      if (lookahead == 't') ADVANCE(577);
      END_STATE();
    case 168:
      if (lookahead == 't') ADVANCE(570);
      END_STATE();
    case 169:
      if (lookahead == 't') ADVANCE(509);
      END_STATE();
    case 170:
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 172:
      if (lookahead == 'y') ADVANCE(573);
      END_STATE();
    case 173:
      if (lookahead == '{') ADVANCE(502);
      END_STATE();
    case 174:
      if (lookahead == '{') ADVANCE(501);
      END_STATE();
    case 175:
      if (lookahead == '{') ADVANCE(192);
      END_STATE();
    case 176:
      if (lookahead == '{') ADVANCE(100);
      END_STATE();
    case 177:
      if (lookahead == '}') ADVANCE(641);
      if (lookahead != 0) ADVANCE(177);
      END_STATE();
    case 178:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(179);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(671);
      END_STATE();
    case 179:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(671);
      END_STATE();
    case 180:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(641);
      END_STATE();
    case 181:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(180);
      END_STATE();
    case 182:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(641);
      END_STATE();
    case 183:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      END_STATE();
    case 184:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(183);
      END_STATE();
    case 185:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(184);
      END_STATE();
    case 186:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(185);
      END_STATE();
    case 187:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(186);
      END_STATE();
    case 188:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(187);
      END_STATE();
    case 189:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(188);
      END_STATE();
    case 190:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(647);
      END_STATE();
    case 191:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 192:
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(177);
      END_STATE();
    case 193:
      if (eof) ADVANCE(195);
      ADVANCE_MAP(
        0, 202,
        '!', 251,
        '"', 247,
        '#', 969,
        '$', 492,
        '%', 598,
        '&', 606,
        '\'', 493,
        '(', 478,
        ')', 479,
        '*', 526,
        '+', 587,
        ',', 519,
        '-', 588,
        '.', 513,
        '/', 595,
        '0', 658,
        ':', 229,
        ';', 508,
        '<', 612,
        '=', 206,
        '>', 618,
        '?', 252,
        '@', 593,
        'E', 281,
        'F', 293,
        'I', 264,
        'N', 394,
        'O', 280,
        'T', 409,
        '[', 215,
        '\\', 249,
        ']', 227,
        '^', 608,
        '_', 282,
        'a', 311,
        'b', 332,
        'c', 396,
        'd', 319,
        'e', 365,
        'f', 289,
        'g', 369,
        'i', 345,
        'l', 290,
        'm', 295,
        'n', 391,
        'o', 410,
        'p', 291,
        'r', 294,
        't', 411,
        'u', 381,
        'w', 352,
        'y', 355,
        '{', 480,
        '|', 604,
        '}', 481,
        '~', 611,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(659);
      if (lookahead != 0) ADVANCE(454);
      END_STATE();
    case 194:
      if (eof) ADVANCE(195);
      ADVANCE_MAP(
        '!', 190,
        '"', 246,
        '#', 970,
        '$', 174,
        '(', 478,
        ')', 479,
        ',', 519,
        '.', 965,
        ':', 228,
        ';', 508,
        '=', 204,
        'E', 861,
        'O', 860,
        '[', 215,
        '\\', 15,
        ']', 227,
        'a', 871,
        'd', 874,
        'e', 932,
        'f', 863,
        'i', 898,
        'p', 933,
        'r', 875,
        'u', 899,
        '}', 481,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(196);
      if (lookahead == '\r') ADVANCE(1);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(197);
      if (lookahead == '\r') ADVANCE(7);
      if (('\t' <= lookahead && lookahead <= '\f')) ADVANCE(8);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(198);
      if (lookahead == '\r') ADVANCE(2);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(199);
      if (lookahead == '\r') ADVANCE(3);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(200);
      if (lookahead == '\r') ADVANCE(4);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(201);
      if (lookahead == '\r') ADVANCE(5);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_NULL);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '+') ADVANCE(212);
      if (lookahead == '.') ADVANCE(214);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '+') ADVANCE(212);
      if (lookahead == '.') ADVANCE(214);
      if (lookahead == '=') ADVANCE(615);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(615);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_QMARK_EQ);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_EQ_PLUS);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_EQ_DOT);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_noexec);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_noexec);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if ((!eof && lookahead == 00)) ADVANCE(226);
      if (lookahead == '\n') ADVANCE(838);
      if (lookahead == '\r') ADVANCE(10);
      if (lookahead != 0 &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == '#') ADVANCE(225);
      if (lookahead == '\\') ADVANCE(218);
      if (lookahead == 'n') ADVANCE(223);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f') ADVANCE(219);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '\\' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'c') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'e') ADVANCE(224);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'e') ADVANCE(220);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'o') ADVANCE(221);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'x') ADVANCE(222);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == ']') ADVANCE(970);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(225);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(226);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(210);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_append);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_append);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_prepend);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_prepend);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_remove);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_remove);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_unset);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_inherit);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_inherit_path);
      ADVANCE_MAP(
        0, 203,
        '\n', 197,
        '\r', 7,
        '#', 243,
        '$', 242,
        '\\', 240,
        '\t', 239,
        0x0b, 239,
        '\f', 239,
      );
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_inherit_path);
      if ((!eof && lookahead == 00)) ADVANCE(244);
      if (lookahead == '\n') ADVANCE(838);
      if (lookahead == '\r') ADVANCE(10);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_inherit_path);
      if (lookahead == '#') ADVANCE(243);
      if (lookahead == '$') ADVANCE(242);
      if (lookahead == '\\') ADVANCE(240);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f') ADVANCE(241);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_inherit_path);
      if (lookahead == '{') ADVANCE(503);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_inherit_path);
      if (lookahead == '\r' ||
          lookahead == ' ') ADVANCE(970);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(243);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_inherit_path);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_INHERIT);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(38);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_include);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if ((!eof && lookahead == 00)) ADVANCE(838);
      if (lookahead == '\n') ADVANCE(838);
      if (lookahead == '\r') ADVANCE(10);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '.') ADVANCE(640);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '=') ADVANCE(616);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(647);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '=') ADVANCE(208);
      if (lookahead == '?') ADVANCE(253);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '=') ADVANCE(209);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'C') ADVANCE(278);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'D') ADVANCE(257);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'E') ADVANCE(273);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'E') ADVANCE(274);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'E') ADVANCE(271);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'F') ADVANCE(279);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'H') ADVANCE(258);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'I') ADVANCE(255);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'I') ADVANCE(268);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'I') ADVANCE(276);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'N') ADVANCE(260);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'N') ADVANCE(254);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'N') ADVANCE(275);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'O') ADVANCE(270);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'O') ADVANCE(266);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'P') ADVANCE(267);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'R') ADVANCE(277);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'R') ADVANCE(263);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'R') ADVANCE(261);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'R') ADVANCE(272);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'S') ADVANCE(459);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'S') ADVANCE(461);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'T') ADVANCE(245);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'T') ADVANCE(286);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'T') ADVANCE(262);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'U') ADVANCE(265);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'V') ADVANCE(256);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'X') ADVANCE(269);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '_') ADVANCE(348);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '_') ADVANCE(451);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(660);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '_') ADVANCE(452);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(661);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '_') ADVANCE(453);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(662);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '_') ADVANCE(259);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '_') ADVANCE(287);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(364);
      if (lookahead == 'i') ADVANCE(389);
      if (lookahead == 'o') ADVANCE(412);
      if (lookahead == 'r') ADVANCE(395);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(377);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(424);
      if (lookahead == 'r') ADVANCE(344);
      if (lookahead == 'y') ADVANCE(428);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(624);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(375);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(361);
      if (lookahead == 'e') ADVANCE(378);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(436);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(362);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(358);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(371);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(366);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(386);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'a') ADVANCE(367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'b') ADVANCE(317);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'b') ADVANCE(300);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'c') ADVANCE(550);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'c') ADVANCE(562);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'c') ADVANCE(216);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'c') ADVANCE(351);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'c') ADVANCE(334);
      if (lookahead == 'e') ADVANCE(305);
      if (lookahead == 'p') ADVANCE(399);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'c') ADVANCE(302);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'd') ADVANCE(312);
      if (lookahead == 'f') ADVANCE(439);
      if (lookahead == 'n') ADVANCE(313);
      if (lookahead == 'p') ADVANCE(404);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'w') ADVANCE(297);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'd') ADVANCE(353);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'd') ADVANCE(580);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'd') ADVANCE(638);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'd') ADVANCE(230);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'd') ADVANCE(232);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'd') ADVANCE(292);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'd') ADVANCE(374);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(346);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(448);
      if (lookahead == 'n') ADVANCE(372);
      if (lookahead == 't') ADVANCE(577);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(680);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(676);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(560);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(652);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(678);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(538);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(566);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(467);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(234);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(455);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(544);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(349);
      if (lookahead == 'r') ADVANCE(338);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(288);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(405);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(413);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(370);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(307);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(296);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(384);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(415);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(414);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(387);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(431);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'e') ADVANCE(407);
      if (lookahead == 'i') ADVANCE(388);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'f') ADVANCE(555);
      if (lookahead == 'm') ADVANCE(408);
      if (lookahead == 'n') ADVANCE(552);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'f') ADVANCE(504);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'f') ADVANCE(558);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'f') ADVANCE(443);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'f') ADVANCE(397);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'h') ADVANCE(575);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'h') ADVANCE(650);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'h') ADVANCE(356);
      if (lookahead == 'i') ADVANCE(437);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'h') ADVANCE(301);
      if (lookahead == 't') ADVANCE(298);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'h') ADVANCE(401);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'i') ADVANCE(336);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'i') ADVANCE(373);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'i') ADVANCE(347);
      if (lookahead == 's') ADVANCE(323);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'i') ADVANCE(429);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'i') ADVANCE(390);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'i') ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'i') ADVANCE(427);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'k') ADVANCE(542);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'k') ADVANCE(463);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'k') ADVANCE(340);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(357);
      if (lookahead == 'x') ADVANCE(309);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(546);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(548);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(450);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(392);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(314);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(368);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(398);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(327);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(341);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'l') ADVANCE(426);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'm') ADVANCE(515);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'm') ADVANCE(303);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'm') ADVANCE(393);
      if (lookahead == 'q') ADVANCE(442);
      if (lookahead == 't') ADVANCE(444);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(475);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(534);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(425);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(306);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(321);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(315);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(438);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(318);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(316);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(430);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(299);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'n') ADVANCE(445);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(320);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(304);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(447);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(383);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(376);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(385);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(419);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(310);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(417);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(402);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(379);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(435);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'o') ADVANCE(418);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'p') ADVANCE(339);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'p') ADVANCE(432);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'p') ADVANCE(342);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'p') ADVANCE(403);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(441);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(583);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(449);
      if (lookahead == 'y') ADVANCE(406);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(564);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(465);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(470);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(400);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(380);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(433);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(434);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(328);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(330);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'r') ADVANCE(333);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 's') ADVANCE(540);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 's') ADVANCE(363);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 's') ADVANCE(422);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 's') ADVANCE(343);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 's') ADVANCE(325);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 's') ADVANCE(326);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(354);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(648);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(529);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(236);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(570);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(457);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(509);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(472);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(308);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(350);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(359);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(335);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 't') ADVANCE(446);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'u') ADVANCE(322);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'u') ADVANCE(360);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'u') ADVANCE(440);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'u') ADVANCE(416);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'u') ADVANCE(331);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'u') ADVANCE(421);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'v') ADVANCE(329);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'x') ADVANCE(337);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'y') ADVANCE(568);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == 'y') ADVANCE(573);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(660);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(661);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(662);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(454);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_require);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_export);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_OVERRIDES);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_OVERRIDES);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_EXPORT_FUNCTIONS);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_EXPORT_FUNCTIONS);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_addtask);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_addtask);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_after);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_after);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_before);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_before);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_deltask);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_addhandler);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_addhandler);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_fakeroot);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_fakeroot);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_fakeroot);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_python);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_python);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_python);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(486);
      if (lookahead == '\r') ADVANCE(482);
      if (lookahead == '\\') ADVANCE(483);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$') ADVANCE(482);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(486);
      if (lookahead == '\r') ADVANCE(482);
      if (lookahead == '\\') ADVANCE(483);
      if (lookahead != 0) ADVANCE(482);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(486);
      if (lookahead == '\r') ADVANCE(486);
      if (lookahead == '\\') ADVANCE(487);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$') ADVANCE(486);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\r') ADVANCE(485);
      if (lookahead == '#') ADVANCE(482);
      if (lookahead == '\\') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(485);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead)) ADVANCE(486);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\r') ADVANCE(486);
      if (lookahead == '\\') ADVANCE(487);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$') ADVANCE(486);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\r') ADVANCE(486);
      if (lookahead == '\\') ADVANCE(487);
      if (lookahead != 0) ADVANCE(486);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\r') ADVANCE(484);
      if (lookahead == '\\') ADVANCE(487);
      if ((!eof && lookahead == 00) ||
          lookahead == '\n') ADVANCE(486);
      if (lookahead != 0) ADVANCE(486);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_DOLLARBB_ENV_PASSTHROUGH);
      if (lookahead == '_') ADVANCE(102);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == 'B') ADVANCE(104);
      if (lookahead == '{') ADVANCE(502);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead == '\n') ADVANCE(498);
      if (lookahead == '\r') ADVANCE(494);
      if (lookahead == '\\') ADVANCE(966);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(494);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead == '\r') ADVANCE(495);
      if (lookahead == '"') ADVANCE(497);
      if (lookahead == '#') ADVANCE(494);
      if (lookahead == '\\') ADVANCE(6);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(495);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\'') ADVANCE(498);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead == '\r') ADVANCE(498);
      if (lookahead == '"') ADVANCE(498);
      if (lookahead == '\\') ADVANCE(12);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(498);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(496);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead == '\r') ADVANCE(498);
      if (lookahead == '\\') ADVANCE(12);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == '"') ADVANCE(498);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(496);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead == '\r') ADVANCE(498);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(498);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE_AT);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE_AT);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      if (lookahead == '@') ADVANCE(499);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      if (lookahead == '@') ADVANCE(500);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(244);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_import);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_import);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(250);
      if (lookahead == '=') ADVANCE(213);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(669);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_from);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym___future__);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'y') ADVANCE(757);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(152);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(382);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_as);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(602);
      if (lookahead == '=') ADVANCE(627);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(601);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(91);
      if (lookahead == '=') ADVANCE(627);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_print);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(633);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_assert);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_return);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_del);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_raise);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_pass);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_break);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_continue);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_global);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_exec);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_in);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(anon_sym_if);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_try);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_except);
      if (lookahead == '*') ADVANCE(572);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_except);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_except_STAR);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_finally);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_with);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym_not);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(anon_sym_and);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_or);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(211);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(626);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(626);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(629);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(600);
      if (lookahead == '=') ADVANCE(628);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(599);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(631);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(630);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(632);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(637);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(635);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(636);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(634);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(610);
      if (lookahead == '=') ADVANCE(614);
      if (lookahead == '>') ADVANCE(620);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(609);
      if (lookahead == '=') ADVANCE(614);
      if (lookahead == '>') ADVANCE(620);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(617);
      if (lookahead == '>') ADVANCE(532);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(617);
      if (lookahead == '>') ADVANCE(531);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(anon_sym_is);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(anon_sym_is);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(anon_sym_lambda);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(anon_sym_yield);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym__not_escape_sequence);
      if ((!eof && lookahead == 00)) ADVANCE(838);
      if (lookahead == '\n') ADVANCE(838);
      if (lookahead == '\r') ADVANCE(10);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym__not_escape_sequence);
      ADVANCE_MAP(
        0, 838,
        '\n', 641,
        '\r', 13,
        'N', 175,
        'U', 189,
        'u', 185,
        'x', 183,
        '"', 641,
        '\'', 641,
        '\\', 641,
        'a', 641,
        'b', 641,
        'f', 641,
        'n', 641,
        'r', 641,
        't', 641,
        'v', 641,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(181);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if ((!eof && lookahead == 00)) ADVANCE(646);
      if (lookahead == '\r') ADVANCE(646);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(646);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '#') ADVANCE(646);
      if (lookahead == '\\') ADVANCE(644);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(645);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(646);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(646);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(anon_sym_await);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(anon_sym_match);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '.', 672,
        '_', 657,
        'B', 935,
        'b', 935,
        'E', 839,
        'e', 839,
        'O', 936,
        'o', 936,
        'X', 937,
        'x', 937,
        'J', 667,
        'L', 667,
        'j', 667,
        'l', 667,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '.', 672,
        '_', 657,
        'E', 839,
        'e', 839,
        'J', 667,
        'L', 667,
        'j', 667,
        'l', 667,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(672);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(839);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(667);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(656);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '_', 666,
        'B', 283,
        'b', 283,
        'O', 284,
        'o', 284,
        'X', 285,
        'x', 285,
        'J', 654,
        'L', 654,
        'j', 654,
        'l', 654,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(659);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(666);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(654);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(659);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(451);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(654);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(660);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(452);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(654);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(661);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(453);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(654);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(662);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(959);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(667);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(663);
      if (lookahead == '-' ||
          ('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(960);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(667);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(664);
      if (lookahead == '-' ||
          lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(962);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(667);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(665);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(654);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(659);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(672);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(178);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(668);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(669);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(674);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(675);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(670);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(673);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(668);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(671);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(178);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(668);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(669);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(668);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(671);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(675);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(670);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(sym_none);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '*') ADVANCE(572);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(754);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(806);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(791);
      if (lookahead == 'r') ADVANCE(735);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(737);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(625);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(742);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'e') ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(739);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(733);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(740);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'a') ADVANCE(747);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'b') ADVANCE(704);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'b') ADVANCE(690);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'c') ADVANCE(551);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'c') ADVANCE(563);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'c') ADVANCE(727);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'c') ADVANCE(715);
      if (lookahead == 'e') ADVANCE(696);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'c') ADVANCE(720);
      if (lookahead == 'e') ADVANCE(696);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'c') ADVANCE(692);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'd') ADVANCE(639);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'd') ADVANCE(581);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'd') ADVANCE(687);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(724);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(696);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(681);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(677);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(653);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(679);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(539);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(567);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(545);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(561);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(777);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(787);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(743);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(686);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(738);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'e') ADVANCE(778);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'f') ADVANCE(556);
      if (lookahead == 'm') ADVANCE(775);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'f') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(553);
      if (lookahead == 's') ADVANCE(622);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'f') ADVANCE(556);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'f') ADVANCE(505);
      if (lookahead == 'l') ADVANCE(537);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'f') ADVANCE(559);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'h') ADVANCE(576);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'h') ADVANCE(651);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'h') ADVANCE(730);
      if (lookahead == 'i') ADVANCE(798);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'i') ADVANCE(725);
      if (lookahead == 's') ADVANCE(714);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'i') ADVANCE(748);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'i') ADVANCE(717);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'i') ADVANCE(763);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'i') ADVANCE(799);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'i') ADVANCE(764);
      if (lookahead == 'o') ADVANCE(781);
      if (lookahead == 'r') ADVANCE(769);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'i') ADVANCE(761);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'i') ADVANCE(795);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'k') ADVANCE(543);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(537);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(547);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(549);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(729);
      if (lookahead == 'x') ADVANCE(706);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(794);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(767);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(813);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(772);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(745);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(712);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(796);
      if (lookahead == 'x') ADVANCE(699);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(796);
      if (lookahead == 'x') ADVANCE(706);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'l') ADVANCE(796);
      if (lookahead == 'x') ADVANCE(700);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'm') ADVANCE(775);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'm') ADVANCE(516);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'm') ADVANCE(694);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(535);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(553);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(697);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(703);
      if (lookahead == 's') ADVANCE(521);
      if (lookahead == 'w') ADVANCE(691);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(807);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(707);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(800);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(746);
      if (lookahead == 't') ADVANCE(578);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(810);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(693);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(760);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(762);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(695);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 768:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(759);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(753);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(781);
      if (lookahead == 'r') ADVANCE(769);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(781);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(701);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'o') ADVANCE(788);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'p') ADVANCE(774);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'p') ADVANCE(709);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'p') ADVANCE(803);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'p') ADVANCE(804);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(809);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(812);
      if (lookahead == 'y') ADVANCE(776);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(565);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(584);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(718);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 784:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(735);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(769);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 786:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(755);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(801);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'r') ADVANCE(802);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 's') ADVANCE(793);
      if (lookahead == 'w') ADVANCE(691);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 's') ADVANCE(541);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 's') ADVANCE(790);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 's') ADVANCE(815);
      if (lookahead == 'w') ADVANCE(691);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 's') ADVANCE(716);
      if (lookahead == 'y') ADVANCE(757);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 's') ADVANCE(710);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 's') ADVANCE(711);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 's') ADVANCE(714);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(578);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 798:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(726);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 799:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(649);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(530);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(533);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(510);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(682);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(571);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(808);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 806:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(698);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 't') ADVANCE(732);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 808:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'u') ADVANCE(786);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'u') ADVANCE(708);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 810:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'u') ADVANCE(713);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 811:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'x') ADVANCE(706);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 812:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'y') ADVANCE(569);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'y') ADVANCE(574);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 814:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'y') ADVANCE(776);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 815:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (lookahead == 'y') ADVANCE(757);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(816);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 817:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '_') ADVANCE(823);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 818:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '_') ADVANCE(518);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 819:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '_') ADVANCE(818);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 820:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'd') ADVANCE(582);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 821:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'e') ADVANCE(819);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'f') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(554);
      if (lookahead == 's') ADVANCE(623);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 823:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'f') ADVANCE(836);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 824:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'm') ADVANCE(828);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'n') ADVANCE(820);
      if (lookahead == 's') ADVANCE(524);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'o') ADVANCE(832);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 827:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'o') ADVANCE(831);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 828:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'p') ADVANCE(827);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 829:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'r') ADVANCE(585);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 830:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'r') ADVANCE(821);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 831:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'r') ADVANCE(833);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 't') ADVANCE(579);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 833:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 't') ADVANCE(511);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 834:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 't') ADVANCE(835);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 835:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'u') ADVANCE(830);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 836:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'u') ADVANCE(834);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 837:
      ACCEPT_TOKEN(sym_python_identifier);
      if (set_contains(sym_python_identifier_character_set_2, 763, lookahead)) ADVANCE(837);
      END_STATE();
    case 838:
      ACCEPT_TOKEN(sym_line_continuation);
      END_STATE();
    case 839:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '+') ADVANCE(179);
      if (lookahead == '-') ADVANCE(961);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(670);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 840:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'C') ADVANCE(858);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 841:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'D') ADVANCE(843);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 842:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'E') ADVANCE(854);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 843:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'E') ADVANCE(855);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 844:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'F') ADVANCE(859);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 845:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'I') ADVANCE(841);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 846:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'I') ADVANCE(850);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 847:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'N') ADVANCE(840);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 848:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'N') ADVANCE(856);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 849:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'O') ADVANCE(852);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 850:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'O') ADVANCE(848);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 851:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'P') ADVANCE(849);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 852:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'R') ADVANCE(857);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 853:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'R') ADVANCE(845);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 854:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'R') ADVANCE(853);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 855:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'S') ADVANCE(460);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 856:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'S') ADVANCE(462);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 857:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'T') ADVANCE(862);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 858:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'T') ADVANCE(846);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 859:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'U') ADVANCE(847);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 860:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'V') ADVANCE(842);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 861:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'X') ADVANCE(851);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 862:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '_') ADVANCE(844);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 863:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'a') ADVANCE(894);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 864:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'a') ADVANCE(920);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 865:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'a') ADVANCE(901);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 866:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'a') ADVANCE(921);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 867:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'c') ADVANCE(895);
      if (lookahead == 'h') ADVANCE(882);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 868:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'd') ADVANCE(888);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 869:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'd') ADVANCE(231);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 870:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'd') ADVANCE(233);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 871:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'd') ADVANCE(868);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 872:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'd') ADVANCE(896);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 873:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'd') ADVANCE(876);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 874:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(887);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 875:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(913);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 876:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(248);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 877:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(456);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 878:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(897);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 879:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(235);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 880:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(916);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 881:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(924);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 882:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(915);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 883:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(914);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 884:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(902);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 885:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(903);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 886:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 887:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'f') ADVANCE(506);
      if (lookahead == 'l') ADVANCE(928);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 888:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'h') ADVANCE(865);
      if (lookahead == 't') ADVANCE(864);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 889:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'h') ADVANCE(906);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 890:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'i') ADVANCE(918);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 891:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'i') ADVANCE(926);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 892:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'k') ADVANCE(464);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 893:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'k') ADVANCE(469);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 894:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'k') ADVANCE(880);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 895:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'l') ADVANCE(930);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 896:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'l') ADVANCE(883);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 897:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'm') ADVANCE(905);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 898:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'n') ADVANCE(867);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 899:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'n') ADVANCE(922);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 900:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'n') ADVANCE(476);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 901:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'n') ADVANCE(872);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 902:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'n') ADVANCE(869);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 903:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'n') ADVANCE(870);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 904:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'o') ADVANCE(917);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 905:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'o') ADVANCE(931);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 906:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'o') ADVANCE(900);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 907:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'o') ADVANCE(908);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'o') ADVANCE(927);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 909:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'p') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 910:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'p') ADVANCE(911);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 911:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'p') ADVANCE(884);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 912:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'p') ADVANCE(885);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 913:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'q') ADVANCE(929);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 914:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'r') ADVANCE(471);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 915:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'r') ADVANCE(891);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 916:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'r') ADVANCE(907);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 917:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'r') ADVANCE(925);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 918:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'r') ADVANCE(877);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 919:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'r') ADVANCE(886);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 920:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 's') ADVANCE(892);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 921:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 's') ADVANCE(893);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 922:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 's') ADVANCE(881);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 923:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 't') ADVANCE(889);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 924:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 't') ADVANCE(237);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 925:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 't') ADVANCE(458);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 926:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 't') ADVANCE(238);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 927:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 't') ADVANCE(473);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 928:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 't') ADVANCE(866);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 929:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'u') ADVANCE(890);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 930:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'u') ADVANCE(873);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 931:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'v') ADVANCE(879);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 932:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'x') ADVANCE(909);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 933:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == 'y') ADVANCE(923);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 934:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(965);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(934);
      END_STATE();
    case 935:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(959);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(663);
      if (lookahead == '-' ||
          ('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 936:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(960);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(664);
      if (lookahead == '-' ||
          lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 937:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(962);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(665);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 938:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(946);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 939:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(952);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 940:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(468);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 941:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(944);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 942:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(953);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 943:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(955);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 944:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(951);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 945:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(948);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 946:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'k') ADVANCE(942);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 947:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(477);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 948:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(947);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 949:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(956);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 950:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(949);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 951:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(954);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 952:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(466);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 953:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(950);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 954:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(940);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 955:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(939);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 956:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(474);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 957:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(945);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 958:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(957);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 959:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(663);
      if (lookahead == '-' ||
          ('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 960:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(664);
      if (lookahead == '-' ||
          lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 961:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(670);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 962:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(665);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 963:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(963);
      END_STATE();
    case 964:
      ACCEPT_TOKEN(aux_sym__dotted_identifier_token1);
      if (lookahead == '=') ADVANCE(213);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(965);
      END_STATE();
    case 965:
      ACCEPT_TOKEN(aux_sym__dotted_identifier_token1);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(965);
      END_STATE();
    case 966:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(498);
      if (lookahead == '\r') ADVANCE(967);
      if (lookahead != 0) ADVANCE(970);
      END_STATE();
    case 967:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(498);
      if (lookahead != 0) ADVANCE(970);
      END_STATE();
    case 968:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r' ||
          lookahead == ' ') ADVANCE(970);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(243);
      END_STATE();
    case 969:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(970);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(969);
      END_STATE();
    case 970:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(970);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 194, .external_lex_state = 2},
  [2] = {.lex_state = 41, .external_lex_state = 3},
  [3] = {.lex_state = 41, .external_lex_state = 3},
  [4] = {.lex_state = 41, .external_lex_state = 3},
  [5] = {.lex_state = 41, .external_lex_state = 3},
  [6] = {.lex_state = 41, .external_lex_state = 3},
  [7] = {.lex_state = 41, .external_lex_state = 3},
  [8] = {.lex_state = 41, .external_lex_state = 3},
  [9] = {.lex_state = 41, .external_lex_state = 3},
  [10] = {.lex_state = 41, .external_lex_state = 3},
  [11] = {.lex_state = 41, .external_lex_state = 3},
  [12] = {.lex_state = 41, .external_lex_state = 3},
  [13] = {.lex_state = 41, .external_lex_state = 3},
  [14] = {.lex_state = 41, .external_lex_state = 3},
  [15] = {.lex_state = 41, .external_lex_state = 3},
  [16] = {.lex_state = 41, .external_lex_state = 3},
  [17] = {.lex_state = 41, .external_lex_state = 3},
  [18] = {.lex_state = 41, .external_lex_state = 3},
  [19] = {.lex_state = 41, .external_lex_state = 3},
  [20] = {.lex_state = 41, .external_lex_state = 3},
  [21] = {.lex_state = 41, .external_lex_state = 3},
  [22] = {.lex_state = 41, .external_lex_state = 3},
  [23] = {.lex_state = 41, .external_lex_state = 3},
  [24] = {.lex_state = 41, .external_lex_state = 3},
  [25] = {.lex_state = 41, .external_lex_state = 3},
  [26] = {.lex_state = 41, .external_lex_state = 3},
  [27] = {.lex_state = 41, .external_lex_state = 3},
  [28] = {.lex_state = 41, .external_lex_state = 3},
  [29] = {.lex_state = 41, .external_lex_state = 3},
  [30] = {.lex_state = 41, .external_lex_state = 3},
  [31] = {.lex_state = 41, .external_lex_state = 3},
  [32] = {.lex_state = 41, .external_lex_state = 3},
  [33] = {.lex_state = 41, .external_lex_state = 3},
  [34] = {.lex_state = 41, .external_lex_state = 3},
  [35] = {.lex_state = 41, .external_lex_state = 3},
  [36] = {.lex_state = 63, .external_lex_state = 4},
  [37] = {.lex_state = 28, .external_lex_state = 5},
  [38] = {.lex_state = 63, .external_lex_state = 4},
  [39] = {.lex_state = 28, .external_lex_state = 5},
  [40] = {.lex_state = 58, .external_lex_state = 4},
  [41] = {.lex_state = 58, .external_lex_state = 4},
  [42] = {.lex_state = 58, .external_lex_state = 4},
  [43] = {.lex_state = 58, .external_lex_state = 4},
  [44] = {.lex_state = 58, .external_lex_state = 4},
  [45] = {.lex_state = 58, .external_lex_state = 4},
  [46] = {.lex_state = 58, .external_lex_state = 4},
  [47] = {.lex_state = 58, .external_lex_state = 4},
  [48] = {.lex_state = 58, .external_lex_state = 4},
  [49] = {.lex_state = 58, .external_lex_state = 4},
  [50] = {.lex_state = 58, .external_lex_state = 4},
  [51] = {.lex_state = 58, .external_lex_state = 4},
  [52] = {.lex_state = 58, .external_lex_state = 4},
  [53] = {.lex_state = 58, .external_lex_state = 4},
  [54] = {.lex_state = 58, .external_lex_state = 4},
  [55] = {.lex_state = 58, .external_lex_state = 4},
  [56] = {.lex_state = 58, .external_lex_state = 4},
  [57] = {.lex_state = 58, .external_lex_state = 4},
  [58] = {.lex_state = 58, .external_lex_state = 4},
  [59] = {.lex_state = 58, .external_lex_state = 4},
  [60] = {.lex_state = 58, .external_lex_state = 4},
  [61] = {.lex_state = 58, .external_lex_state = 5},
  [62] = {.lex_state = 58, .external_lex_state = 5},
  [63] = {.lex_state = 58, .external_lex_state = 5},
  [64] = {.lex_state = 58, .external_lex_state = 5},
  [65] = {.lex_state = 58, .external_lex_state = 5},
  [66] = {.lex_state = 58, .external_lex_state = 5},
  [67] = {.lex_state = 58, .external_lex_state = 5},
  [68] = {.lex_state = 58, .external_lex_state = 5},
  [69] = {.lex_state = 58, .external_lex_state = 5},
  [70] = {.lex_state = 58, .external_lex_state = 5},
  [71] = {.lex_state = 58, .external_lex_state = 5},
  [72] = {.lex_state = 58, .external_lex_state = 5},
  [73] = {.lex_state = 58, .external_lex_state = 5},
  [74] = {.lex_state = 58, .external_lex_state = 5},
  [75] = {.lex_state = 58, .external_lex_state = 5},
  [76] = {.lex_state = 58, .external_lex_state = 5},
  [77] = {.lex_state = 58, .external_lex_state = 5},
  [78] = {.lex_state = 58, .external_lex_state = 5},
  [79] = {.lex_state = 58, .external_lex_state = 6},
  [80] = {.lex_state = 29, .external_lex_state = 5},
  [81] = {.lex_state = 29, .external_lex_state = 5},
  [82] = {.lex_state = 30, .external_lex_state = 5},
  [83] = {.lex_state = 25, .external_lex_state = 5},
  [84] = {.lex_state = 25, .external_lex_state = 7},
  [85] = {.lex_state = 25, .external_lex_state = 7},
  [86] = {.lex_state = 36, .external_lex_state = 5},
  [87] = {.lex_state = 34, .external_lex_state = 7},
  [88] = {.lex_state = 26, .external_lex_state = 5},
  [89] = {.lex_state = 26, .external_lex_state = 7},
  [90] = {.lex_state = 34, .external_lex_state = 7},
  [91] = {.lex_state = 26, .external_lex_state = 7},
  [92] = {.lex_state = 34, .external_lex_state = 8},
  [93] = {.lex_state = 26, .external_lex_state = 5},
  [94] = {.lex_state = 25, .external_lex_state = 8},
  [95] = {.lex_state = 26, .external_lex_state = 8},
  [96] = {.lex_state = 34, .external_lex_state = 9},
  [97] = {.lex_state = 25, .external_lex_state = 8},
  [98] = {.lex_state = 46, .external_lex_state = 5},
  [99] = {.lex_state = 34, .external_lex_state = 9},
  [100] = {.lex_state = 25, .external_lex_state = 6},
  [101] = {.lex_state = 34, .external_lex_state = 8},
  [102] = {.lex_state = 34, .external_lex_state = 8},
  [103] = {.lex_state = 35, .external_lex_state = 7},
  [104] = {.lex_state = 34, .external_lex_state = 9},
  [105] = {.lex_state = 34, .external_lex_state = 8},
  [106] = {.lex_state = 35, .external_lex_state = 7},
  [107] = {.lex_state = 25, .external_lex_state = 9},
  [108] = {.lex_state = 36, .external_lex_state = 5},
  [109] = {.lex_state = 26, .external_lex_state = 8},
  [110] = {.lex_state = 36, .external_lex_state = 5},
  [111] = {.lex_state = 46, .external_lex_state = 5},
  [112] = {.lex_state = 34, .external_lex_state = 8},
  [113] = {.lex_state = 26, .external_lex_state = 6},
  [114] = {.lex_state = 25, .external_lex_state = 8},
  [115] = {.lex_state = 26, .external_lex_state = 9},
  [116] = {.lex_state = 34, .external_lex_state = 9},
  [117] = {.lex_state = 26, .external_lex_state = 6},
  [118] = {.lex_state = 25, .external_lex_state = 9},
  [119] = {.lex_state = 34, .external_lex_state = 8},
  [120] = {.lex_state = 26, .external_lex_state = 9},
  [121] = {.lex_state = 34, .external_lex_state = 9},
  [122] = {.lex_state = 25, .external_lex_state = 7},
  [123] = {.lex_state = 46, .external_lex_state = 6},
  [124] = {.lex_state = 46, .external_lex_state = 6},
  [125] = {.lex_state = 37, .external_lex_state = 6},
  [126] = {.lex_state = 37, .external_lex_state = 6},
  [127] = {.lex_state = 37, .external_lex_state = 6},
  [128] = {.lex_state = 50, .external_lex_state = 8},
  [129] = {.lex_state = 50, .external_lex_state = 9},
  [130] = {.lex_state = 50, .external_lex_state = 6},
  [131] = {.lex_state = 50, .external_lex_state = 8},
  [132] = {.lex_state = 62, .external_lex_state = 7},
  [133] = {.lex_state = 62, .external_lex_state = 7},
  [134] = {.lex_state = 50, .external_lex_state = 8},
  [135] = {.lex_state = 50, .external_lex_state = 9},
  [136] = {.lex_state = 50, .external_lex_state = 8},
  [137] = {.lex_state = 50, .external_lex_state = 9},
  [138] = {.lex_state = 50, .external_lex_state = 6},
  [139] = {.lex_state = 50, .external_lex_state = 8},
  [140] = {.lex_state = 62, .external_lex_state = 7},
  [141] = {.lex_state = 50, .external_lex_state = 6},
  [142] = {.lex_state = 50, .external_lex_state = 9},
  [143] = {.lex_state = 62, .external_lex_state = 7},
  [144] = {.lex_state = 50, .external_lex_state = 9},
  [145] = {.lex_state = 50, .external_lex_state = 9},
  [146] = {.lex_state = 50, .external_lex_state = 8},
  [147] = {.lex_state = 62, .external_lex_state = 7},
  [148] = {.lex_state = 62, .external_lex_state = 7},
  [149] = {.lex_state = 50, .external_lex_state = 9},
  [150] = {.lex_state = 50, .external_lex_state = 8},
  [151] = {.lex_state = 50, .external_lex_state = 9},
  [152] = {.lex_state = 50, .external_lex_state = 8},
  [153] = {.lex_state = 50, .external_lex_state = 8},
  [154] = {.lex_state = 50, .external_lex_state = 8},
  [155] = {.lex_state = 50, .external_lex_state = 9},
  [156] = {.lex_state = 62, .external_lex_state = 7},
  [157] = {.lex_state = 50, .external_lex_state = 8},
  [158] = {.lex_state = 50, .external_lex_state = 9},
  [159] = {.lex_state = 62, .external_lex_state = 7},
  [160] = {.lex_state = 50, .external_lex_state = 9},
  [161] = {.lex_state = 48, .external_lex_state = 5},
  [162] = {.lex_state = 48, .external_lex_state = 5},
  [163] = {.lex_state = 50, .external_lex_state = 6},
  [164] = {.lex_state = 50, .external_lex_state = 6},
  [165] = {.lex_state = 51, .external_lex_state = 6},
  [166] = {.lex_state = 51, .external_lex_state = 8},
  [167] = {.lex_state = 51, .external_lex_state = 6},
  [168] = {.lex_state = 51, .external_lex_state = 6},
  [169] = {.lex_state = 51, .external_lex_state = 6},
  [170] = {.lex_state = 19, .external_lex_state = 7},
  [171] = {.lex_state = 51, .external_lex_state = 8},
  [172] = {.lex_state = 48, .external_lex_state = 6},
  [173] = {.lex_state = 51, .external_lex_state = 6},
  [174] = {.lex_state = 51, .external_lex_state = 6},
  [175] = {.lex_state = 51, .external_lex_state = 6},
  [176] = {.lex_state = 51, .external_lex_state = 8},
  [177] = {.lex_state = 51, .external_lex_state = 8},
  [178] = {.lex_state = 51, .external_lex_state = 6},
  [179] = {.lex_state = 51, .external_lex_state = 8},
  [180] = {.lex_state = 51, .external_lex_state = 6},
  [181] = {.lex_state = 51, .external_lex_state = 6},
  [182] = {.lex_state = 51, .external_lex_state = 6},
  [183] = {.lex_state = 51, .external_lex_state = 6},
  [184] = {.lex_state = 51, .external_lex_state = 8},
  [185] = {.lex_state = 51, .external_lex_state = 8},
  [186] = {.lex_state = 51, .external_lex_state = 6},
  [187] = {.lex_state = 51, .external_lex_state = 6},
  [188] = {.lex_state = 51, .external_lex_state = 6},
  [189] = {.lex_state = 51, .external_lex_state = 6},
  [190] = {.lex_state = 51, .external_lex_state = 6},
  [191] = {.lex_state = 50, .external_lex_state = 8},
  [192] = {.lex_state = 51, .external_lex_state = 6},
  [193] = {.lex_state = 51, .external_lex_state = 8},
  [194] = {.lex_state = 48, .external_lex_state = 6},
  [195] = {.lex_state = 51, .external_lex_state = 8},
  [196] = {.lex_state = 51, .external_lex_state = 8},
  [197] = {.lex_state = 51, .external_lex_state = 8},
  [198] = {.lex_state = 51, .external_lex_state = 8},
  [199] = {.lex_state = 50, .external_lex_state = 9},
  [200] = {.lex_state = 51, .external_lex_state = 8},
  [201] = {.lex_state = 50, .external_lex_state = 8},
  [202] = {.lex_state = 51, .external_lex_state = 8},
  [203] = {.lex_state = 51, .external_lex_state = 8},
  [204] = {.lex_state = 51, .external_lex_state = 8},
  [205] = {.lex_state = 51, .external_lex_state = 8},
  [206] = {.lex_state = 51, .external_lex_state = 8},
  [207] = {.lex_state = 51, .external_lex_state = 8},
  [208] = {.lex_state = 50, .external_lex_state = 8},
  [209] = {.lex_state = 50, .external_lex_state = 8},
  [210] = {.lex_state = 51, .external_lex_state = 8},
  [211] = {.lex_state = 50, .external_lex_state = 8},
  [212] = {.lex_state = 51, .external_lex_state = 8},
  [213] = {.lex_state = 51, .external_lex_state = 8},
  [214] = {.lex_state = 51, .external_lex_state = 8},
  [215] = {.lex_state = 51, .external_lex_state = 8},
  [216] = {.lex_state = 51, .external_lex_state = 8},
  [217] = {.lex_state = 50, .external_lex_state = 9},
  [218] = {.lex_state = 50, .external_lex_state = 9},
  [219] = {.lex_state = 50, .external_lex_state = 8},
  [220] = {.lex_state = 51, .external_lex_state = 8},
  [221] = {.lex_state = 50, .external_lex_state = 9},
  [222] = {.lex_state = 50, .external_lex_state = 8},
  [223] = {.lex_state = 50, .external_lex_state = 8},
  [224] = {.lex_state = 51, .external_lex_state = 8},
  [225] = {.lex_state = 51, .external_lex_state = 8},
  [226] = {.lex_state = 51, .external_lex_state = 8},
  [227] = {.lex_state = 51, .external_lex_state = 8},
  [228] = {.lex_state = 51, .external_lex_state = 8},
  [229] = {.lex_state = 50, .external_lex_state = 8},
  [230] = {.lex_state = 50, .external_lex_state = 8},
  [231] = {.lex_state = 50, .external_lex_state = 9},
  [232] = {.lex_state = 51, .external_lex_state = 8},
  [233] = {.lex_state = 51, .external_lex_state = 8},
  [234] = {.lex_state = 51, .external_lex_state = 8},
  [235] = {.lex_state = 51, .external_lex_state = 8},
  [236] = {.lex_state = 50, .external_lex_state = 8},
  [237] = {.lex_state = 51, .external_lex_state = 8},
  [238] = {.lex_state = 51, .external_lex_state = 8},
  [239] = {.lex_state = 50, .external_lex_state = 8},
  [240] = {.lex_state = 50, .external_lex_state = 8},
  [241] = {.lex_state = 50, .external_lex_state = 9},
  [242] = {.lex_state = 50, .external_lex_state = 8},
  [243] = {.lex_state = 51, .external_lex_state = 8},
  [244] = {.lex_state = 51, .external_lex_state = 8},
  [245] = {.lex_state = 51, .external_lex_state = 8},
  [246] = {.lex_state = 50, .external_lex_state = 8},
  [247] = {.lex_state = 50, .external_lex_state = 9},
  [248] = {.lex_state = 50, .external_lex_state = 9},
  [249] = {.lex_state = 18, .external_lex_state = 7},
  [250] = {.lex_state = 49, .external_lex_state = 8},
  [251] = {.lex_state = 51, .external_lex_state = 6},
  [252] = {.lex_state = 49, .external_lex_state = 7},
  [253] = {.lex_state = 49, .external_lex_state = 8},
  [254] = {.lex_state = 49, .external_lex_state = 8},
  [255] = {.lex_state = 49, .external_lex_state = 8},
  [256] = {.lex_state = 50, .external_lex_state = 8},
  [257] = {.lex_state = 50, .external_lex_state = 9},
  [258] = {.lex_state = 50, .external_lex_state = 8},
  [259] = {.lex_state = 50, .external_lex_state = 7},
  [260] = {.lex_state = 50, .external_lex_state = 9},
  [261] = {.lex_state = 49, .external_lex_state = 7},
  [262] = {.lex_state = 20, .external_lex_state = 7},
  [263] = {.lex_state = 50, .external_lex_state = 7},
  [264] = {.lex_state = 20, .external_lex_state = 7},
  [265] = {.lex_state = 49, .external_lex_state = 9},
  [266] = {.lex_state = 18, .external_lex_state = 7},
  [267] = {.lex_state = 49, .external_lex_state = 9},
  [268] = {.lex_state = 49, .external_lex_state = 9},
  [269] = {.lex_state = 49, .external_lex_state = 7},
  [270] = {.lex_state = 49, .external_lex_state = 7},
  [271] = {.lex_state = 49, .external_lex_state = 9},
  [272] = {.lex_state = 51, .external_lex_state = 7},
  [273] = {.lex_state = 51, .external_lex_state = 7},
  [274] = {.lex_state = 51, .external_lex_state = 7},
  [275] = {.lex_state = 51, .external_lex_state = 7},
  [276] = {.lex_state = 50, .external_lex_state = 6},
  [277] = {.lex_state = 51, .external_lex_state = 7},
  [278] = {.lex_state = 51, .external_lex_state = 7},
  [279] = {.lex_state = 51, .external_lex_state = 7},
  [280] = {.lex_state = 51, .external_lex_state = 7},
  [281] = {.lex_state = 51, .external_lex_state = 7},
  [282] = {.lex_state = 51, .external_lex_state = 7},
  [283] = {.lex_state = 50, .external_lex_state = 6},
  [284] = {.lex_state = 51, .external_lex_state = 7},
  [285] = {.lex_state = 51, .external_lex_state = 7},
  [286] = {.lex_state = 51, .external_lex_state = 7},
  [287] = {.lex_state = 19, .external_lex_state = 5},
  [288] = {.lex_state = 19, .external_lex_state = 8},
  [289] = {.lex_state = 51, .external_lex_state = 7},
  [290] = {.lex_state = 51, .external_lex_state = 7},
  [291] = {.lex_state = 19, .external_lex_state = 5},
  [292] = {.lex_state = 19, .external_lex_state = 9},
  [293] = {.lex_state = 50, .external_lex_state = 6},
  [294] = {.lex_state = 51, .external_lex_state = 7},
  [295] = {.lex_state = 20, .external_lex_state = 9},
  [296] = {.lex_state = 20, .external_lex_state = 9},
  [297] = {.lex_state = 20, .external_lex_state = 9},
  [298] = {.lex_state = 18, .external_lex_state = 8},
  [299] = {.lex_state = 20, .external_lex_state = 9},
  [300] = {.lex_state = 20, .external_lex_state = 9},
  [301] = {.lex_state = 20, .external_lex_state = 9},
  [302] = {.lex_state = 51, .external_lex_state = 6},
  [303] = {.lex_state = 20, .external_lex_state = 5},
  [304] = {.lex_state = 20, .external_lex_state = 9},
  [305] = {.lex_state = 20, .external_lex_state = 9},
  [306] = {.lex_state = 20, .external_lex_state = 9},
  [307] = {.lex_state = 20, .external_lex_state = 9},
  [308] = {.lex_state = 20, .external_lex_state = 9},
  [309] = {.lex_state = 20, .external_lex_state = 9},
  [310] = {.lex_state = 20, .external_lex_state = 9},
  [311] = {.lex_state = 19, .external_lex_state = 5},
  [312] = {.lex_state = 20, .external_lex_state = 9},
  [313] = {.lex_state = 20, .external_lex_state = 9},
  [314] = {.lex_state = 20, .external_lex_state = 9},
  [315] = {.lex_state = 19, .external_lex_state = 5},
  [316] = {.lex_state = 20, .external_lex_state = 9},
  [317] = {.lex_state = 20, .external_lex_state = 9},
  [318] = {.lex_state = 20, .external_lex_state = 9},
  [319] = {.lex_state = 20, .external_lex_state = 9},
  [320] = {.lex_state = 18, .external_lex_state = 8},
  [321] = {.lex_state = 20, .external_lex_state = 9},
  [322] = {.lex_state = 20, .external_lex_state = 9},
  [323] = {.lex_state = 20, .external_lex_state = 9},
  [324] = {.lex_state = 20, .external_lex_state = 9},
  [325] = {.lex_state = 20, .external_lex_state = 9},
  [326] = {.lex_state = 20, .external_lex_state = 9},
  [327] = {.lex_state = 20, .external_lex_state = 9},
  [328] = {.lex_state = 20, .external_lex_state = 9},
  [329] = {.lex_state = 20, .external_lex_state = 9},
  [330] = {.lex_state = 20, .external_lex_state = 9},
  [331] = {.lex_state = 20, .external_lex_state = 9},
  [332] = {.lex_state = 20, .external_lex_state = 9},
  [333] = {.lex_state = 20, .external_lex_state = 5},
  [334] = {.lex_state = 20, .external_lex_state = 6},
  [335] = {.lex_state = 20, .external_lex_state = 6},
  [336] = {.lex_state = 20, .external_lex_state = 5},
  [337] = {.lex_state = 20, .external_lex_state = 6},
  [338] = {.lex_state = 20, .external_lex_state = 9},
  [339] = {.lex_state = 20, .external_lex_state = 5},
  [340] = {.lex_state = 20, .external_lex_state = 6},
  [341] = {.lex_state = 20, .external_lex_state = 5},
  [342] = {.lex_state = 20, .external_lex_state = 6},
  [343] = {.lex_state = 20, .external_lex_state = 6},
  [344] = {.lex_state = 20, .external_lex_state = 6},
  [345] = {.lex_state = 20, .external_lex_state = 6},
  [346] = {.lex_state = 20, .external_lex_state = 5},
  [347] = {.lex_state = 20, .external_lex_state = 6},
  [348] = {.lex_state = 20, .external_lex_state = 8},
  [349] = {.lex_state = 20, .external_lex_state = 6},
  [350] = {.lex_state = 20, .external_lex_state = 5},
  [351] = {.lex_state = 20, .external_lex_state = 6},
  [352] = {.lex_state = 18, .external_lex_state = 9},
  [353] = {.lex_state = 18, .external_lex_state = 8},
  [354] = {.lex_state = 20, .external_lex_state = 6},
  [355] = {.lex_state = 20, .external_lex_state = 6},
  [356] = {.lex_state = 18, .external_lex_state = 8},
  [357] = {.lex_state = 18, .external_lex_state = 9},
  [358] = {.lex_state = 20, .external_lex_state = 6},
  [359] = {.lex_state = 18, .external_lex_state = 6},
  [360] = {.lex_state = 47, .external_lex_state = 6},
  [361] = {.lex_state = 20, .external_lex_state = 6},
  [362] = {.lex_state = 20, .external_lex_state = 6},
  [363] = {.lex_state = 20, .external_lex_state = 8},
  [364] = {.lex_state = 20, .external_lex_state = 6},
  [365] = {.lex_state = 20, .external_lex_state = 6},
  [366] = {.lex_state = 20, .external_lex_state = 9},
  [367] = {.lex_state = 20, .external_lex_state = 9},
  [368] = {.lex_state = 20, .external_lex_state = 6},
  [369] = {.lex_state = 18, .external_lex_state = 6},
  [370] = {.lex_state = 20, .external_lex_state = 6},
  [371] = {.lex_state = 20, .external_lex_state = 6},
  [372] = {.lex_state = 20, .external_lex_state = 6},
  [373] = {.lex_state = 20, .external_lex_state = 9},
  [374] = {.lex_state = 20, .external_lex_state = 6},
  [375] = {.lex_state = 20, .external_lex_state = 6},
  [376] = {.lex_state = 20, .external_lex_state = 5},
  [377] = {.lex_state = 47, .external_lex_state = 6},
  [378] = {.lex_state = 20, .external_lex_state = 5},
  [379] = {.lex_state = 20, .external_lex_state = 6},
  [380] = {.lex_state = 20, .external_lex_state = 6},
  [381] = {.lex_state = 20, .external_lex_state = 9},
  [382] = {.lex_state = 20, .external_lex_state = 6},
  [383] = {.lex_state = 20, .external_lex_state = 6},
  [384] = {.lex_state = 20, .external_lex_state = 8},
  [385] = {.lex_state = 20, .external_lex_state = 6},
  [386] = {.lex_state = 20, .external_lex_state = 8},
  [387] = {.lex_state = 20, .external_lex_state = 6},
  [388] = {.lex_state = 20, .external_lex_state = 6},
  [389] = {.lex_state = 20, .external_lex_state = 6},
  [390] = {.lex_state = 20, .external_lex_state = 6},
  [391] = {.lex_state = 20, .external_lex_state = 6},
  [392] = {.lex_state = 20, .external_lex_state = 6},
  [393] = {.lex_state = 20, .external_lex_state = 6},
  [394] = {.lex_state = 20, .external_lex_state = 6},
  [395] = {.lex_state = 20, .external_lex_state = 6},
  [396] = {.lex_state = 20, .external_lex_state = 6},
  [397] = {.lex_state = 20, .external_lex_state = 6},
  [398] = {.lex_state = 20, .external_lex_state = 6},
  [399] = {.lex_state = 20, .external_lex_state = 6},
  [400] = {.lex_state = 20, .external_lex_state = 6},
  [401] = {.lex_state = 20, .external_lex_state = 6},
  [402] = {.lex_state = 20, .external_lex_state = 6},
  [403] = {.lex_state = 20, .external_lex_state = 6},
  [404] = {.lex_state = 20, .external_lex_state = 6},
  [405] = {.lex_state = 20, .external_lex_state = 6},
  [406] = {.lex_state = 20, .external_lex_state = 6},
  [407] = {.lex_state = 20, .external_lex_state = 6},
  [408] = {.lex_state = 20, .external_lex_state = 6},
  [409] = {.lex_state = 20, .external_lex_state = 6},
  [410] = {.lex_state = 20, .external_lex_state = 6},
  [411] = {.lex_state = 20, .external_lex_state = 6},
  [412] = {.lex_state = 20, .external_lex_state = 6},
  [413] = {.lex_state = 20, .external_lex_state = 6},
  [414] = {.lex_state = 20, .external_lex_state = 6},
  [415] = {.lex_state = 20, .external_lex_state = 6},
  [416] = {.lex_state = 20, .external_lex_state = 6},
  [417] = {.lex_state = 20, .external_lex_state = 6},
  [418] = {.lex_state = 20, .external_lex_state = 6},
  [419] = {.lex_state = 20, .external_lex_state = 6},
  [420] = {.lex_state = 20, .external_lex_state = 6},
  [421] = {.lex_state = 20, .external_lex_state = 6},
  [422] = {.lex_state = 20, .external_lex_state = 6},
  [423] = {.lex_state = 20, .external_lex_state = 6},
  [424] = {.lex_state = 20, .external_lex_state = 6},
  [425] = {.lex_state = 20, .external_lex_state = 6},
  [426] = {.lex_state = 20, .external_lex_state = 6},
  [427] = {.lex_state = 20, .external_lex_state = 6},
  [428] = {.lex_state = 20, .external_lex_state = 6},
  [429] = {.lex_state = 20, .external_lex_state = 6},
  [430] = {.lex_state = 20, .external_lex_state = 6},
  [431] = {.lex_state = 20, .external_lex_state = 6},
  [432] = {.lex_state = 20, .external_lex_state = 6},
  [433] = {.lex_state = 20, .external_lex_state = 6},
  [434] = {.lex_state = 20, .external_lex_state = 6},
  [435] = {.lex_state = 20, .external_lex_state = 6},
  [436] = {.lex_state = 20, .external_lex_state = 6},
  [437] = {.lex_state = 20, .external_lex_state = 6},
  [438] = {.lex_state = 20, .external_lex_state = 6},
  [439] = {.lex_state = 20, .external_lex_state = 6},
  [440] = {.lex_state = 20, .external_lex_state = 6},
  [441] = {.lex_state = 20, .external_lex_state = 6},
  [442] = {.lex_state = 20, .external_lex_state = 6},
  [443] = {.lex_state = 20, .external_lex_state = 6},
  [444] = {.lex_state = 20, .external_lex_state = 6},
  [445] = {.lex_state = 20, .external_lex_state = 6},
  [446] = {.lex_state = 20, .external_lex_state = 6},
  [447] = {.lex_state = 20, .external_lex_state = 6},
  [448] = {.lex_state = 20, .external_lex_state = 6},
  [449] = {.lex_state = 20, .external_lex_state = 6},
  [450] = {.lex_state = 20, .external_lex_state = 6},
  [451] = {.lex_state = 20, .external_lex_state = 6},
  [452] = {.lex_state = 20, .external_lex_state = 6},
  [453] = {.lex_state = 20, .external_lex_state = 6},
  [454] = {.lex_state = 20, .external_lex_state = 6},
  [455] = {.lex_state = 20, .external_lex_state = 6},
  [456] = {.lex_state = 20, .external_lex_state = 6},
  [457] = {.lex_state = 20, .external_lex_state = 6},
  [458] = {.lex_state = 20, .external_lex_state = 6},
  [459] = {.lex_state = 20, .external_lex_state = 6},
  [460] = {.lex_state = 20, .external_lex_state = 6},
  [461] = {.lex_state = 20, .external_lex_state = 6},
  [462] = {.lex_state = 20, .external_lex_state = 6},
  [463] = {.lex_state = 20, .external_lex_state = 6},
  [464] = {.lex_state = 20, .external_lex_state = 6},
  [465] = {.lex_state = 20, .external_lex_state = 6},
  [466] = {.lex_state = 20, .external_lex_state = 6},
  [467] = {.lex_state = 20, .external_lex_state = 6},
  [468] = {.lex_state = 20, .external_lex_state = 6},
  [469] = {.lex_state = 20, .external_lex_state = 6},
  [470] = {.lex_state = 20, .external_lex_state = 6},
  [471] = {.lex_state = 20, .external_lex_state = 6},
  [472] = {.lex_state = 20, .external_lex_state = 6},
  [473] = {.lex_state = 20, .external_lex_state = 6},
  [474] = {.lex_state = 31, .external_lex_state = 5},
  [475] = {.lex_state = 20, .external_lex_state = 6},
  [476] = {.lex_state = 20, .external_lex_state = 6},
  [477] = {.lex_state = 20, .external_lex_state = 6},
  [478] = {.lex_state = 20, .external_lex_state = 6},
  [479] = {.lex_state = 20, .external_lex_state = 6},
  [480] = {.lex_state = 20, .external_lex_state = 6},
  [481] = {.lex_state = 20, .external_lex_state = 6},
  [482] = {.lex_state = 20, .external_lex_state = 6},
  [483] = {.lex_state = 20, .external_lex_state = 6},
  [484] = {.lex_state = 20, .external_lex_state = 6},
  [485] = {.lex_state = 20, .external_lex_state = 6},
  [486] = {.lex_state = 20, .external_lex_state = 6},
  [487] = {.lex_state = 20, .external_lex_state = 6},
  [488] = {.lex_state = 20, .external_lex_state = 6},
  [489] = {.lex_state = 20, .external_lex_state = 6},
  [490] = {.lex_state = 20, .external_lex_state = 6},
  [491] = {.lex_state = 20, .external_lex_state = 6},
  [492] = {.lex_state = 20, .external_lex_state = 6},
  [493] = {.lex_state = 20, .external_lex_state = 6},
  [494] = {.lex_state = 20, .external_lex_state = 6},
  [495] = {.lex_state = 31, .external_lex_state = 5},
  [496] = {.lex_state = 20, .external_lex_state = 6},
  [497] = {.lex_state = 20, .external_lex_state = 6},
  [498] = {.lex_state = 20, .external_lex_state = 6},
  [499] = {.lex_state = 20, .external_lex_state = 6},
  [500] = {.lex_state = 20, .external_lex_state = 6},
  [501] = {.lex_state = 20, .external_lex_state = 6},
  [502] = {.lex_state = 20, .external_lex_state = 6},
  [503] = {.lex_state = 18, .external_lex_state = 6},
  [504] = {.lex_state = 20, .external_lex_state = 6},
  [505] = {.lex_state = 18, .external_lex_state = 6},
  [506] = {.lex_state = 20, .external_lex_state = 6},
  [507] = {.lex_state = 20, .external_lex_state = 6},
  [508] = {.lex_state = 20, .external_lex_state = 6},
  [509] = {.lex_state = 20, .external_lex_state = 6},
  [510] = {.lex_state = 20, .external_lex_state = 6},
  [511] = {.lex_state = 20, .external_lex_state = 6},
  [512] = {.lex_state = 20, .external_lex_state = 6},
  [513] = {.lex_state = 20, .external_lex_state = 6},
  [514] = {.lex_state = 20, .external_lex_state = 6},
  [515] = {.lex_state = 20, .external_lex_state = 6},
  [516] = {.lex_state = 20, .external_lex_state = 6},
  [517] = {.lex_state = 20, .external_lex_state = 6},
  [518] = {.lex_state = 20, .external_lex_state = 6},
  [519] = {.lex_state = 20, .external_lex_state = 6},
  [520] = {.lex_state = 20, .external_lex_state = 6},
  [521] = {.lex_state = 20, .external_lex_state = 6},
  [522] = {.lex_state = 20, .external_lex_state = 6},
  [523] = {.lex_state = 20, .external_lex_state = 6},
  [524] = {.lex_state = 20, .external_lex_state = 6},
  [525] = {.lex_state = 20, .external_lex_state = 6},
  [526] = {.lex_state = 20, .external_lex_state = 6},
  [527] = {.lex_state = 20, .external_lex_state = 6},
  [528] = {.lex_state = 20, .external_lex_state = 6},
  [529] = {.lex_state = 20, .external_lex_state = 6},
  [530] = {.lex_state = 20, .external_lex_state = 6},
  [531] = {.lex_state = 20, .external_lex_state = 6},
  [532] = {.lex_state = 20, .external_lex_state = 6},
  [533] = {.lex_state = 20, .external_lex_state = 6},
  [534] = {.lex_state = 20, .external_lex_state = 6},
  [535] = {.lex_state = 20, .external_lex_state = 6},
  [536] = {.lex_state = 27, .external_lex_state = 10},
  [537] = {.lex_state = 55, .external_lex_state = 3},
  [538] = {.lex_state = 57, .external_lex_state = 3},
  [539] = {.lex_state = 55, .external_lex_state = 3},
  [540] = {.lex_state = 57, .external_lex_state = 3},
  [541] = {.lex_state = 27, .external_lex_state = 10},
  [542] = {.lex_state = 27, .external_lex_state = 10},
  [543] = {.lex_state = 27, .external_lex_state = 10},
  [544] = {.lex_state = 27, .external_lex_state = 10},
  [545] = {.lex_state = 27, .external_lex_state = 10},
  [546] = {.lex_state = 27, .external_lex_state = 10},
  [547] = {.lex_state = 21, .external_lex_state = 7},
  [548] = {.lex_state = 22, .external_lex_state = 10},
  [549] = {.lex_state = 22, .external_lex_state = 10},
  [550] = {.lex_state = 22, .external_lex_state = 10},
  [551] = {.lex_state = 22, .external_lex_state = 10},
  [552] = {.lex_state = 22, .external_lex_state = 10},
  [553] = {.lex_state = 22, .external_lex_state = 10},
  [554] = {.lex_state = 21, .external_lex_state = 7},
  [555] = {.lex_state = 56, .external_lex_state = 3},
  [556] = {.lex_state = 56, .external_lex_state = 3},
  [557] = {.lex_state = 22, .external_lex_state = 10},
  [558] = {.lex_state = 22, .external_lex_state = 10},
  [559] = {.lex_state = 55, .external_lex_state = 3},
  [560] = {.lex_state = 57, .external_lex_state = 3},
  [561] = {.lex_state = 22, .external_lex_state = 10},
  [562] = {.lex_state = 22, .external_lex_state = 10},
  [563] = {.lex_state = 22, .external_lex_state = 10},
  [564] = {.lex_state = 22, .external_lex_state = 10},
  [565] = {.lex_state = 22, .external_lex_state = 10},
  [566] = {.lex_state = 22, .external_lex_state = 10},
  [567] = {.lex_state = 22, .external_lex_state = 10},
  [568] = {.lex_state = 22, .external_lex_state = 10},
  [569] = {.lex_state = 22, .external_lex_state = 10},
  [570] = {.lex_state = 22, .external_lex_state = 10},
  [571] = {.lex_state = 22, .external_lex_state = 10},
  [572] = {.lex_state = 56, .external_lex_state = 3},
  [573] = {.lex_state = 56, .external_lex_state = 3},
  [574] = {.lex_state = 56, .external_lex_state = 3},
  [575] = {.lex_state = 57, .external_lex_state = 3},
  [576] = {.lex_state = 55, .external_lex_state = 3},
  [577] = {.lex_state = 57, .external_lex_state = 3},
  [578] = {.lex_state = 55, .external_lex_state = 3},
  [579] = {.lex_state = 55, .external_lex_state = 3},
  [580] = {.lex_state = 55, .external_lex_state = 3},
  [581] = {.lex_state = 57, .external_lex_state = 3},
  [582] = {.lex_state = 57, .external_lex_state = 3},
  [583] = {.lex_state = 57, .external_lex_state = 3},
  [584] = {.lex_state = 55, .external_lex_state = 3},
  [585] = {.lex_state = 21, .external_lex_state = 8},
  [586] = {.lex_state = 57, .external_lex_state = 3},
  [587] = {.lex_state = 57, .external_lex_state = 3},
  [588] = {.lex_state = 57, .external_lex_state = 3},
  [589] = {.lex_state = 57, .external_lex_state = 3},
  [590] = {.lex_state = 55, .external_lex_state = 3},
  [591] = {.lex_state = 57, .external_lex_state = 3},
  [592] = {.lex_state = 21, .external_lex_state = 8},
  [593] = {.lex_state = 55, .external_lex_state = 3},
  [594] = {.lex_state = 55, .external_lex_state = 3},
  [595] = {.lex_state = 55, .external_lex_state = 3},
  [596] = {.lex_state = 57, .external_lex_state = 3},
  [597] = {.lex_state = 56, .external_lex_state = 3},
  [598] = {.lex_state = 54, .external_lex_state = 3},
  [599] = {.lex_state = 54, .external_lex_state = 3},
  [600] = {.lex_state = 56, .external_lex_state = 3},
  [601] = {.lex_state = 56, .external_lex_state = 3},
  [602] = {.lex_state = 54, .external_lex_state = 3},
  [603] = {.lex_state = 56, .external_lex_state = 3},
  [604] = {.lex_state = 21, .external_lex_state = 6},
  [605] = {.lex_state = 56, .external_lex_state = 3},
  [606] = {.lex_state = 56, .external_lex_state = 3},
  [607] = {.lex_state = 59, .external_lex_state = 6},
  [608] = {.lex_state = 53, .external_lex_state = 3},
  [609] = {.lex_state = 21, .external_lex_state = 6},
  [610] = {.lex_state = 21, .external_lex_state = 6},
  [611] = {.lex_state = 21, .external_lex_state = 9},
  [612] = {.lex_state = 21, .external_lex_state = 6},
  [613] = {.lex_state = 54, .external_lex_state = 3},
  [614] = {.lex_state = 21, .external_lex_state = 6},
  [615] = {.lex_state = 21, .external_lex_state = 6},
  [616] = {.lex_state = 21, .external_lex_state = 8},
  [617] = {.lex_state = 21, .external_lex_state = 6},
  [618] = {.lex_state = 56, .external_lex_state = 3},
  [619] = {.lex_state = 59, .external_lex_state = 6},
  [620] = {.lex_state = 54, .external_lex_state = 3},
  [621] = {.lex_state = 54, .external_lex_state = 3},
  [622] = {.lex_state = 21, .external_lex_state = 6},
  [623] = {.lex_state = 21, .external_lex_state = 8},
  [624] = {.lex_state = 53, .external_lex_state = 3},
  [625] = {.lex_state = 56, .external_lex_state = 3},
  [626] = {.lex_state = 21, .external_lex_state = 9},
  [627] = {.lex_state = 54, .external_lex_state = 3},
  [628] = {.lex_state = 21, .external_lex_state = 6},
  [629] = {.lex_state = 21, .external_lex_state = 6},
  [630] = {.lex_state = 53, .external_lex_state = 3},
  [631] = {.lex_state = 21, .external_lex_state = 6},
  [632] = {.lex_state = 53, .external_lex_state = 3},
  [633] = {.lex_state = 53, .external_lex_state = 3},
  [634] = {.lex_state = 53, .external_lex_state = 3},
  [635] = {.lex_state = 53, .external_lex_state = 3},
  [636] = {.lex_state = 53, .external_lex_state = 3},
  [637] = {.lex_state = 53, .external_lex_state = 3},
  [638] = {.lex_state = 21, .external_lex_state = 6},
  [639] = {.lex_state = 54, .external_lex_state = 3},
  [640] = {.lex_state = 54, .external_lex_state = 3},
  [641] = {.lex_state = 21, .external_lex_state = 6},
  [642] = {.lex_state = 54, .external_lex_state = 3},
  [643] = {.lex_state = 54, .external_lex_state = 3},
  [644] = {.lex_state = 21, .external_lex_state = 6},
  [645] = {.lex_state = 41, .external_lex_state = 3},
  [646] = {.lex_state = 41, .external_lex_state = 3},
  [647] = {.lex_state = 41, .external_lex_state = 3},
  [648] = {.lex_state = 41, .external_lex_state = 3},
  [649] = {.lex_state = 41, .external_lex_state = 3},
  [650] = {.lex_state = 41, .external_lex_state = 3},
  [651] = {.lex_state = 41, .external_lex_state = 3},
  [652] = {.lex_state = 41, .external_lex_state = 3},
  [653] = {.lex_state = 41, .external_lex_state = 3},
  [654] = {.lex_state = 41, .external_lex_state = 3},
  [655] = {.lex_state = 41, .external_lex_state = 3},
  [656] = {.lex_state = 41, .external_lex_state = 3},
  [657] = {.lex_state = 41, .external_lex_state = 3},
  [658] = {.lex_state = 41, .external_lex_state = 3},
  [659] = {.lex_state = 21, .external_lex_state = 6},
  [660] = {.lex_state = 41, .external_lex_state = 3},
  [661] = {.lex_state = 41, .external_lex_state = 3},
  [662] = {.lex_state = 41, .external_lex_state = 3},
  [663] = {.lex_state = 41, .external_lex_state = 3},
  [664] = {.lex_state = 41, .external_lex_state = 3},
  [665] = {.lex_state = 41, .external_lex_state = 3},
  [666] = {.lex_state = 41, .external_lex_state = 3},
  [667] = {.lex_state = 41, .external_lex_state = 3},
  [668] = {.lex_state = 21, .external_lex_state = 8},
  [669] = {.lex_state = 41, .external_lex_state = 3},
  [670] = {.lex_state = 41, .external_lex_state = 3},
  [671] = {.lex_state = 41, .external_lex_state = 3},
  [672] = {.lex_state = 41, .external_lex_state = 3},
  [673] = {.lex_state = 41, .external_lex_state = 3},
  [674] = {.lex_state = 41, .external_lex_state = 3},
  [675] = {.lex_state = 41, .external_lex_state = 3},
  [676] = {.lex_state = 41, .external_lex_state = 3},
  [677] = {.lex_state = 41, .external_lex_state = 3},
  [678] = {.lex_state = 41, .external_lex_state = 3},
  [679] = {.lex_state = 41, .external_lex_state = 3},
  [680] = {.lex_state = 60, .external_lex_state = 6},
  [681] = {.lex_state = 60, .external_lex_state = 6},
  [682] = {.lex_state = 60, .external_lex_state = 6},
  [683] = {.lex_state = 60, .external_lex_state = 6},
  [684] = {.lex_state = 60, .external_lex_state = 6},
  [685] = {.lex_state = 60, .external_lex_state = 6},
  [686] = {.lex_state = 60, .external_lex_state = 6},
  [687] = {.lex_state = 60, .external_lex_state = 6},
  [688] = {.lex_state = 60, .external_lex_state = 6},
  [689] = {.lex_state = 60, .external_lex_state = 6},
  [690] = {.lex_state = 21, .external_lex_state = 6},
  [691] = {.lex_state = 21, .external_lex_state = 6},
  [692] = {.lex_state = 21, .external_lex_state = 6},
  [693] = {.lex_state = 21, .external_lex_state = 6},
  [694] = {.lex_state = 21, .external_lex_state = 6},
  [695] = {.lex_state = 21, .external_lex_state = 6},
  [696] = {.lex_state = 21, .external_lex_state = 6},
  [697] = {.lex_state = 21, .external_lex_state = 6},
  [698] = {.lex_state = 21, .external_lex_state = 6},
  [699] = {.lex_state = 21, .external_lex_state = 6},
  [700] = {.lex_state = 21, .external_lex_state = 6},
  [701] = {.lex_state = 21, .external_lex_state = 6},
  [702] = {.lex_state = 21, .external_lex_state = 6},
  [703] = {.lex_state = 21, .external_lex_state = 6},
  [704] = {.lex_state = 21, .external_lex_state = 6},
  [705] = {.lex_state = 21, .external_lex_state = 6},
  [706] = {.lex_state = 21, .external_lex_state = 6},
  [707] = {.lex_state = 21, .external_lex_state = 6},
  [708] = {.lex_state = 21, .external_lex_state = 6},
  [709] = {.lex_state = 21, .external_lex_state = 6},
  [710] = {.lex_state = 21, .external_lex_state = 6},
  [711] = {.lex_state = 21, .external_lex_state = 6},
  [712] = {.lex_state = 21, .external_lex_state = 6},
  [713] = {.lex_state = 21, .external_lex_state = 6},
  [714] = {.lex_state = 21, .external_lex_state = 6},
  [715] = {.lex_state = 21, .external_lex_state = 6},
  [716] = {.lex_state = 21, .external_lex_state = 6},
  [717] = {.lex_state = 21, .external_lex_state = 6},
  [718] = {.lex_state = 21, .external_lex_state = 6},
  [719] = {.lex_state = 21, .external_lex_state = 6},
  [720] = {.lex_state = 21, .external_lex_state = 6},
  [721] = {.lex_state = 21, .external_lex_state = 6},
  [722] = {.lex_state = 21, .external_lex_state = 6},
  [723] = {.lex_state = 21, .external_lex_state = 6},
  [724] = {.lex_state = 21, .external_lex_state = 6},
  [725] = {.lex_state = 21, .external_lex_state = 6},
  [726] = {.lex_state = 21, .external_lex_state = 6},
  [727] = {.lex_state = 21, .external_lex_state = 6},
  [728] = {.lex_state = 21, .external_lex_state = 6},
  [729] = {.lex_state = 21, .external_lex_state = 6},
  [730] = {.lex_state = 21, .external_lex_state = 6},
  [731] = {.lex_state = 21, .external_lex_state = 6},
  [732] = {.lex_state = 21, .external_lex_state = 6},
  [733] = {.lex_state = 21, .external_lex_state = 6},
  [734] = {.lex_state = 21, .external_lex_state = 6},
  [735] = {.lex_state = 21, .external_lex_state = 6},
  [736] = {.lex_state = 21, .external_lex_state = 6},
  [737] = {.lex_state = 21, .external_lex_state = 6},
  [738] = {.lex_state = 21, .external_lex_state = 6},
  [739] = {.lex_state = 21, .external_lex_state = 6},
  [740] = {.lex_state = 21, .external_lex_state = 6},
  [741] = {.lex_state = 21, .external_lex_state = 6},
  [742] = {.lex_state = 21, .external_lex_state = 6},
  [743] = {.lex_state = 21, .external_lex_state = 6},
  [744] = {.lex_state = 21, .external_lex_state = 6},
  [745] = {.lex_state = 21, .external_lex_state = 6},
  [746] = {.lex_state = 21, .external_lex_state = 6},
  [747] = {.lex_state = 21, .external_lex_state = 6},
  [748] = {.lex_state = 21, .external_lex_state = 6},
  [749] = {.lex_state = 21, .external_lex_state = 6},
  [750] = {.lex_state = 21, .external_lex_state = 6},
  [751] = {.lex_state = 21, .external_lex_state = 6},
  [752] = {.lex_state = 21, .external_lex_state = 6},
  [753] = {.lex_state = 21, .external_lex_state = 6},
  [754] = {.lex_state = 21, .external_lex_state = 6},
  [755] = {.lex_state = 21, .external_lex_state = 6},
  [756] = {.lex_state = 21, .external_lex_state = 6},
  [757] = {.lex_state = 21, .external_lex_state = 6},
  [758] = {.lex_state = 21, .external_lex_state = 6},
  [759] = {.lex_state = 21, .external_lex_state = 6},
  [760] = {.lex_state = 21, .external_lex_state = 6},
  [761] = {.lex_state = 21, .external_lex_state = 6},
  [762] = {.lex_state = 21, .external_lex_state = 6},
  [763] = {.lex_state = 21, .external_lex_state = 6},
  [764] = {.lex_state = 21, .external_lex_state = 6},
  [765] = {.lex_state = 21, .external_lex_state = 6},
  [766] = {.lex_state = 21, .external_lex_state = 6},
  [767] = {.lex_state = 21, .external_lex_state = 6},
  [768] = {.lex_state = 21, .external_lex_state = 6},
  [769] = {.lex_state = 21, .external_lex_state = 6},
  [770] = {.lex_state = 21, .external_lex_state = 6},
  [771] = {.lex_state = 21, .external_lex_state = 6},
  [772] = {.lex_state = 21, .external_lex_state = 6},
  [773] = {.lex_state = 21, .external_lex_state = 6},
  [774] = {.lex_state = 21, .external_lex_state = 6},
  [775] = {.lex_state = 21, .external_lex_state = 6},
  [776] = {.lex_state = 21, .external_lex_state = 6},
  [777] = {.lex_state = 21, .external_lex_state = 6},
  [778] = {.lex_state = 21, .external_lex_state = 6},
  [779] = {.lex_state = 21, .external_lex_state = 6},
  [780] = {.lex_state = 21, .external_lex_state = 6},
  [781] = {.lex_state = 21, .external_lex_state = 6},
  [782] = {.lex_state = 21, .external_lex_state = 6},
  [783] = {.lex_state = 21, .external_lex_state = 6},
  [784] = {.lex_state = 21, .external_lex_state = 6},
  [785] = {.lex_state = 21, .external_lex_state = 6},
  [786] = {.lex_state = 21, .external_lex_state = 6},
  [787] = {.lex_state = 21, .external_lex_state = 6},
  [788] = {.lex_state = 21, .external_lex_state = 6},
  [789] = {.lex_state = 21, .external_lex_state = 6},
  [790] = {.lex_state = 21, .external_lex_state = 6},
  [791] = {.lex_state = 21, .external_lex_state = 6},
  [792] = {.lex_state = 21, .external_lex_state = 6},
  [793] = {.lex_state = 21, .external_lex_state = 6},
  [794] = {.lex_state = 21, .external_lex_state = 6},
  [795] = {.lex_state = 21, .external_lex_state = 6},
  [796] = {.lex_state = 21, .external_lex_state = 6},
  [797] = {.lex_state = 21, .external_lex_state = 6},
  [798] = {.lex_state = 21, .external_lex_state = 6},
  [799] = {.lex_state = 21, .external_lex_state = 6},
  [800] = {.lex_state = 21, .external_lex_state = 6},
  [801] = {.lex_state = 21, .external_lex_state = 6},
  [802] = {.lex_state = 21, .external_lex_state = 6},
  [803] = {.lex_state = 21, .external_lex_state = 6},
  [804] = {.lex_state = 21, .external_lex_state = 6},
  [805] = {.lex_state = 21, .external_lex_state = 6},
  [806] = {.lex_state = 21, .external_lex_state = 6},
  [807] = {.lex_state = 21, .external_lex_state = 6},
  [808] = {.lex_state = 21, .external_lex_state = 6},
  [809] = {.lex_state = 21, .external_lex_state = 6},
  [810] = {.lex_state = 21, .external_lex_state = 6},
  [811] = {.lex_state = 21, .external_lex_state = 6},
  [812] = {.lex_state = 21, .external_lex_state = 6},
  [813] = {.lex_state = 21, .external_lex_state = 6},
  [814] = {.lex_state = 21, .external_lex_state = 6},
  [815] = {.lex_state = 21, .external_lex_state = 6},
  [816] = {.lex_state = 21, .external_lex_state = 6},
  [817] = {.lex_state = 21, .external_lex_state = 6},
  [818] = {.lex_state = 21, .external_lex_state = 6},
  [819] = {.lex_state = 21, .external_lex_state = 6},
  [820] = {.lex_state = 21, .external_lex_state = 6},
  [821] = {.lex_state = 21, .external_lex_state = 6},
  [822] = {.lex_state = 21, .external_lex_state = 6},
  [823] = {.lex_state = 21, .external_lex_state = 6},
  [824] = {.lex_state = 21, .external_lex_state = 6},
  [825] = {.lex_state = 21, .external_lex_state = 6},
  [826] = {.lex_state = 21, .external_lex_state = 6},
  [827] = {.lex_state = 21, .external_lex_state = 6},
  [828] = {.lex_state = 21, .external_lex_state = 6},
  [829] = {.lex_state = 21, .external_lex_state = 6},
  [830] = {.lex_state = 21, .external_lex_state = 6},
  [831] = {.lex_state = 21, .external_lex_state = 6},
  [832] = {.lex_state = 21, .external_lex_state = 6},
  [833] = {.lex_state = 24, .external_lex_state = 5},
  [834] = {.lex_state = 24, .external_lex_state = 5},
  [835] = {.lex_state = 24, .external_lex_state = 5},
  [836] = {.lex_state = 33, .external_lex_state = 7},
  [837] = {.lex_state = 24, .external_lex_state = 7},
  [838] = {.lex_state = 33, .external_lex_state = 7},
  [839] = {.lex_state = 33, .external_lex_state = 11},
  [840] = {.lex_state = 24, .external_lex_state = 10},
  [841] = {.lex_state = 24, .external_lex_state = 7},
  [842] = {.lex_state = 33, .external_lex_state = 7},
  [843] = {.lex_state = 24, .external_lex_state = 7},
  [844] = {.lex_state = 24, .external_lex_state = 11},
  [845] = {.lex_state = 24, .external_lex_state = 10},
  [846] = {.lex_state = 24, .external_lex_state = 10},
  [847] = {.lex_state = 33, .external_lex_state = 11},
  [848] = {.lex_state = 23, .external_lex_state = 10},
  [849] = {.lex_state = 33, .external_lex_state = 11},
  [850] = {.lex_state = 24, .external_lex_state = 8},
  [851] = {.lex_state = 33, .external_lex_state = 8},
  [852] = {.lex_state = 33, .external_lex_state = 11},
  [853] = {.lex_state = 33, .external_lex_state = 8},
  [854] = {.lex_state = 33, .external_lex_state = 11},
  [855] = {.lex_state = 33, .external_lex_state = 11},
  [856] = {.lex_state = 23, .external_lex_state = 10},
  [857] = {.lex_state = 33, .external_lex_state = 9},
  [858] = {.lex_state = 33, .external_lex_state = 12},
  [859] = {.lex_state = 24, .external_lex_state = 10},
  [860] = {.lex_state = 24, .external_lex_state = 10},
  [861] = {.lex_state = 33, .external_lex_state = 11},
  [862] = {.lex_state = 24, .external_lex_state = 5},
  [863] = {.lex_state = 24, .external_lex_state = 8},
  [864] = {.lex_state = 24, .external_lex_state = 6},
  [865] = {.lex_state = 33, .external_lex_state = 11},
  [866] = {.lex_state = 24, .external_lex_state = 5},
  [867] = {.lex_state = 33, .external_lex_state = 11},
  [868] = {.lex_state = 24, .external_lex_state = 6},
  [869] = {.lex_state = 33, .external_lex_state = 11},
  [870] = {.lex_state = 33, .external_lex_state = 8},
  [871] = {.lex_state = 24, .external_lex_state = 10},
  [872] = {.lex_state = 24, .external_lex_state = 11},
  [873] = {.lex_state = 24, .external_lex_state = 11},
  [874] = {.lex_state = 33, .external_lex_state = 13},
  [875] = {.lex_state = 24, .external_lex_state = 11},
  [876] = {.lex_state = 24, .external_lex_state = 11},
  [877] = {.lex_state = 24, .external_lex_state = 10},
  [878] = {.lex_state = 24, .external_lex_state = 11},
  [879] = {.lex_state = 24, .external_lex_state = 10},
  [880] = {.lex_state = 24, .external_lex_state = 10},
  [881] = {.lex_state = 24, .external_lex_state = 10},
  [882] = {.lex_state = 24, .external_lex_state = 10},
  [883] = {.lex_state = 24, .external_lex_state = 13},
  [884] = {.lex_state = 24, .external_lex_state = 6},
  [885] = {.lex_state = 24, .external_lex_state = 8},
  [886] = {.lex_state = 24, .external_lex_state = 10},
  [887] = {.lex_state = 23, .external_lex_state = 10},
  [888] = {.lex_state = 24, .external_lex_state = 10},
  [889] = {.lex_state = 33, .external_lex_state = 11},
  [890] = {.lex_state = 24, .external_lex_state = 10},
  [891] = {.lex_state = 24, .external_lex_state = 11},
  [892] = {.lex_state = 33, .external_lex_state = 9},
  [893] = {.lex_state = 24, .external_lex_state = 11},
  [894] = {.lex_state = 24, .external_lex_state = 11},
  [895] = {.lex_state = 24, .external_lex_state = 11},
  [896] = {.lex_state = 24, .external_lex_state = 11},
  [897] = {.lex_state = 24, .external_lex_state = 11},
  [898] = {.lex_state = 33, .external_lex_state = 11},
  [899] = {.lex_state = 33, .external_lex_state = 9},
  [900] = {.lex_state = 24, .external_lex_state = 11},
  [901] = {.lex_state = 33, .external_lex_state = 11},
  [902] = {.lex_state = 24, .external_lex_state = 10},
  [903] = {.lex_state = 23, .external_lex_state = 11},
  [904] = {.lex_state = 23, .external_lex_state = 13},
  [905] = {.lex_state = 33, .external_lex_state = 12},
  [906] = {.lex_state = 24, .external_lex_state = 10},
  [907] = {.lex_state = 24, .external_lex_state = 10},
  [908] = {.lex_state = 24, .external_lex_state = 10},
  [909] = {.lex_state = 33, .external_lex_state = 12},
  [910] = {.lex_state = 33, .external_lex_state = 12},
  [911] = {.lex_state = 24, .external_lex_state = 10},
  [912] = {.lex_state = 33, .external_lex_state = 12},
  [913] = {.lex_state = 33, .external_lex_state = 12},
  [914] = {.lex_state = 33, .external_lex_state = 12},
  [915] = {.lex_state = 24, .external_lex_state = 13},
  [916] = {.lex_state = 33, .external_lex_state = 13},
  [917] = {.lex_state = 33, .external_lex_state = 7},
  [918] = {.lex_state = 24, .external_lex_state = 13},
  [919] = {.lex_state = 24, .external_lex_state = 13},
  [920] = {.lex_state = 33, .external_lex_state = 12},
  [921] = {.lex_state = 33, .external_lex_state = 12},
  [922] = {.lex_state = 24, .external_lex_state = 2},
  [923] = {.lex_state = 32, .external_lex_state = 11},
  [924] = {.lex_state = 32, .external_lex_state = 13},
  [925] = {.lex_state = 24, .external_lex_state = 13},
  [926] = {.lex_state = 24, .external_lex_state = 10},
  [927] = {.lex_state = 24, .external_lex_state = 10},
  [928] = {.lex_state = 24, .external_lex_state = 13},
  [929] = {.lex_state = 33, .external_lex_state = 13},
  [930] = {.lex_state = 24, .external_lex_state = 13},
  [931] = {.lex_state = 24, .external_lex_state = 10},
  [932] = {.lex_state = 24, .external_lex_state = 9},
  [933] = {.lex_state = 32, .external_lex_state = 13},
  [934] = {.lex_state = 32, .external_lex_state = 13},
  [935] = {.lex_state = 24, .external_lex_state = 13},
  [936] = {.lex_state = 24, .external_lex_state = 13},
  [937] = {.lex_state = 24, .external_lex_state = 13},
  [938] = {.lex_state = 32, .external_lex_state = 11},
  [939] = {.lex_state = 32, .external_lex_state = 11},
  [940] = {.lex_state = 24, .external_lex_state = 13},
  [941] = {.lex_state = 32, .external_lex_state = 11},
  [942] = {.lex_state = 24, .external_lex_state = 10},
  [943] = {.lex_state = 32, .external_lex_state = 11},
  [944] = {.lex_state = 24, .external_lex_state = 10},
  [945] = {.lex_state = 24, .external_lex_state = 10},
  [946] = {.lex_state = 24, .external_lex_state = 10},
  [947] = {.lex_state = 24, .external_lex_state = 10},
  [948] = {.lex_state = 33, .external_lex_state = 12},
  [949] = {.lex_state = 33, .external_lex_state = 12},
  [950] = {.lex_state = 24, .external_lex_state = 9},
  [951] = {.lex_state = 24, .external_lex_state = 10},
  [952] = {.lex_state = 32, .external_lex_state = 11},
  [953] = {.lex_state = 24, .external_lex_state = 10},
  [954] = {.lex_state = 24, .external_lex_state = 10},
  [955] = {.lex_state = 33, .external_lex_state = 12},
  [956] = {.lex_state = 33, .external_lex_state = 13},
  [957] = {.lex_state = 33, .external_lex_state = 13},
  [958] = {.lex_state = 33, .external_lex_state = 12},
  [959] = {.lex_state = 33, .external_lex_state = 13},
  [960] = {.lex_state = 33, .external_lex_state = 13},
  [961] = {.lex_state = 24, .external_lex_state = 10},
  [962] = {.lex_state = 33, .external_lex_state = 13},
  [963] = {.lex_state = 33, .external_lex_state = 13},
  [964] = {.lex_state = 24, .external_lex_state = 13},
  [965] = {.lex_state = 33, .external_lex_state = 13},
  [966] = {.lex_state = 33, .external_lex_state = 13},
  [967] = {.lex_state = 23, .external_lex_state = 11},
  [968] = {.lex_state = 23, .external_lex_state = 10},
  [969] = {.lex_state = 24, .external_lex_state = 10},
  [970] = {.lex_state = 24, .external_lex_state = 10},
  [971] = {.lex_state = 24, .external_lex_state = 10},
  [972] = {.lex_state = 24, .external_lex_state = 7},
  [973] = {.lex_state = 24, .external_lex_state = 10},
  [974] = {.lex_state = 23, .external_lex_state = 11},
  [975] = {.lex_state = 24, .external_lex_state = 10},
  [976] = {.lex_state = 24, .external_lex_state = 10},
  [977] = {.lex_state = 24, .external_lex_state = 13},
  [978] = {.lex_state = 23, .external_lex_state = 11},
  [979] = {.lex_state = 23, .external_lex_state = 11},
  [980] = {.lex_state = 24, .external_lex_state = 10},
  [981] = {.lex_state = 24, .external_lex_state = 10},
  [982] = {.lex_state = 33, .external_lex_state = 7},
  [983] = {.lex_state = 23, .external_lex_state = 11},
  [984] = {.lex_state = 24, .external_lex_state = 10},
  [985] = {.lex_state = 24, .external_lex_state = 10},
  [986] = {.lex_state = 24, .external_lex_state = 10},
  [987] = {.lex_state = 24, .external_lex_state = 10},
  [988] = {.lex_state = 33, .external_lex_state = 13},
  [989] = {.lex_state = 24, .external_lex_state = 10},
  [990] = {.lex_state = 24, .external_lex_state = 12},
  [991] = {.lex_state = 24, .external_lex_state = 10},
  [992] = {.lex_state = 24, .external_lex_state = 7},
  [993] = {.lex_state = 24, .external_lex_state = 10},
  [994] = {.lex_state = 24, .external_lex_state = 10},
  [995] = {.lex_state = 24, .external_lex_state = 10},
  [996] = {.lex_state = 24, .external_lex_state = 10},
  [997] = {.lex_state = 24, .external_lex_state = 10},
  [998] = {.lex_state = 24, .external_lex_state = 10},
  [999] = {.lex_state = 24, .external_lex_state = 10},
  [1000] = {.lex_state = 24, .external_lex_state = 10},
  [1001] = {.lex_state = 24, .external_lex_state = 10},
  [1002] = {.lex_state = 24, .external_lex_state = 10},
  [1003] = {.lex_state = 24, .external_lex_state = 9},
  [1004] = {.lex_state = 24, .external_lex_state = 10},
  [1005] = {.lex_state = 24, .external_lex_state = 10},
  [1006] = {.lex_state = 24, .external_lex_state = 10},
  [1007] = {.lex_state = 24, .external_lex_state = 10},
  [1008] = {.lex_state = 24, .external_lex_state = 10},
  [1009] = {.lex_state = 24, .external_lex_state = 10},
  [1010] = {.lex_state = 33, .external_lex_state = 13},
  [1011] = {.lex_state = 24, .external_lex_state = 10},
  [1012] = {.lex_state = 24, .external_lex_state = 10},
  [1013] = {.lex_state = 24, .external_lex_state = 2},
  [1014] = {.lex_state = 24, .external_lex_state = 2},
  [1015] = {.lex_state = 24, .external_lex_state = 8},
  [1016] = {.lex_state = 23, .external_lex_state = 2},
  [1017] = {.lex_state = 23, .external_lex_state = 2},
  [1018] = {.lex_state = 23, .external_lex_state = 2},
  [1019] = {.lex_state = 24, .external_lex_state = 12},
  [1020] = {.lex_state = 24, .external_lex_state = 12},
  [1021] = {.lex_state = 24, .external_lex_state = 12},
  [1022] = {.lex_state = 24, .external_lex_state = 12},
  [1023] = {.lex_state = 24, .external_lex_state = 12},
  [1024] = {.lex_state = 24, .external_lex_state = 12},
  [1025] = {.lex_state = 24, .external_lex_state = 12},
  [1026] = {.lex_state = 24, .external_lex_state = 11},
  [1027] = {.lex_state = 24, .external_lex_state = 11},
  [1028] = {.lex_state = 24, .external_lex_state = 11},
  [1029] = {.lex_state = 24, .external_lex_state = 12},
  [1030] = {.lex_state = 24, .external_lex_state = 12},
  [1031] = {.lex_state = 24, .external_lex_state = 13},
  [1032] = {.lex_state = 23, .external_lex_state = 13},
  [1033] = {.lex_state = 23, .external_lex_state = 13},
  [1034] = {.lex_state = 24, .external_lex_state = 11},
  [1035] = {.lex_state = 23, .external_lex_state = 13},
  [1036] = {.lex_state = 24, .external_lex_state = 11},
  [1037] = {.lex_state = 24, .external_lex_state = 11},
  [1038] = {.lex_state = 24, .external_lex_state = 11},
  [1039] = {.lex_state = 24, .external_lex_state = 12},
  [1040] = {.lex_state = 24, .external_lex_state = 12},
  [1041] = {.lex_state = 24, .external_lex_state = 11},
  [1042] = {.lex_state = 32, .external_lex_state = 13},
  [1043] = {.lex_state = 24, .external_lex_state = 11},
  [1044] = {.lex_state = 24, .external_lex_state = 11},
  [1045] = {.lex_state = 33, .external_lex_state = 11},
  [1046] = {.lex_state = 32, .external_lex_state = 13},
  [1047] = {.lex_state = 32, .external_lex_state = 13},
  [1048] = {.lex_state = 24, .external_lex_state = 11},
  [1049] = {.lex_state = 33, .external_lex_state = 11},
  [1050] = {.lex_state = 24, .external_lex_state = 11},
  [1051] = {.lex_state = 24, .external_lex_state = 12},
  [1052] = {.lex_state = 24, .external_lex_state = 6},
  [1053] = {.lex_state = 24, .external_lex_state = 11},
  [1054] = {.lex_state = 24, .external_lex_state = 11},
  [1055] = {.lex_state = 33, .external_lex_state = 8},
  [1056] = {.lex_state = 32, .external_lex_state = 12},
  [1057] = {.lex_state = 32, .external_lex_state = 12},
  [1058] = {.lex_state = 32, .external_lex_state = 12},
  [1059] = {.lex_state = 24, .external_lex_state = 11},
  [1060] = {.lex_state = 24, .external_lex_state = 11},
  [1061] = {.lex_state = 24, .external_lex_state = 11},
  [1062] = {.lex_state = 24, .external_lex_state = 11},
  [1063] = {.lex_state = 24, .external_lex_state = 11},
  [1064] = {.lex_state = 24, .external_lex_state = 6},
  [1065] = {.lex_state = 24, .external_lex_state = 12},
  [1066] = {.lex_state = 24, .external_lex_state = 8},
  [1067] = {.lex_state = 33, .external_lex_state = 11},
  [1068] = {.lex_state = 33, .external_lex_state = 11},
  [1069] = {.lex_state = 33, .external_lex_state = 11},
  [1070] = {.lex_state = 33, .external_lex_state = 11},
  [1071] = {.lex_state = 33, .external_lex_state = 11},
  [1072] = {.lex_state = 33, .external_lex_state = 11},
  [1073] = {.lex_state = 33, .external_lex_state = 11},
  [1074] = {.lex_state = 33, .external_lex_state = 11},
  [1075] = {.lex_state = 33, .external_lex_state = 11},
  [1076] = {.lex_state = 33, .external_lex_state = 11},
  [1077] = {.lex_state = 24, .external_lex_state = 11},
  [1078] = {.lex_state = 24, .external_lex_state = 11},
  [1079] = {.lex_state = 23, .external_lex_state = 2},
  [1080] = {.lex_state = 33, .external_lex_state = 11},
  [1081] = {.lex_state = 33, .external_lex_state = 11},
  [1082] = {.lex_state = 33, .external_lex_state = 11},
  [1083] = {.lex_state = 33, .external_lex_state = 11},
  [1084] = {.lex_state = 33, .external_lex_state = 11},
  [1085] = {.lex_state = 33, .external_lex_state = 11},
  [1086] = {.lex_state = 33, .external_lex_state = 11},
  [1087] = {.lex_state = 33, .external_lex_state = 11},
  [1088] = {.lex_state = 23, .external_lex_state = 12},
  [1089] = {.lex_state = 32, .external_lex_state = 12},
  [1090] = {.lex_state = 24, .external_lex_state = 11},
  [1091] = {.lex_state = 32, .external_lex_state = 12},
  [1092] = {.lex_state = 32, .external_lex_state = 12},
  [1093] = {.lex_state = 24, .external_lex_state = 11},
  [1094] = {.lex_state = 24, .external_lex_state = 11},
  [1095] = {.lex_state = 24, .external_lex_state = 11},
  [1096] = {.lex_state = 33, .external_lex_state = 8},
  [1097] = {.lex_state = 33, .external_lex_state = 11},
  [1098] = {.lex_state = 33, .external_lex_state = 11},
  [1099] = {.lex_state = 24, .external_lex_state = 11},
  [1100] = {.lex_state = 24, .external_lex_state = 11},
  [1101] = {.lex_state = 32, .external_lex_state = 13},
  [1102] = {.lex_state = 32, .external_lex_state = 13},
  [1103] = {.lex_state = 24, .external_lex_state = 11},
  [1104] = {.lex_state = 32, .external_lex_state = 13},
  [1105] = {.lex_state = 33, .external_lex_state = 9},
  [1106] = {.lex_state = 33, .external_lex_state = 11},
  [1107] = {.lex_state = 33, .external_lex_state = 11},
  [1108] = {.lex_state = 33, .external_lex_state = 11},
  [1109] = {.lex_state = 33, .external_lex_state = 11},
  [1110] = {.lex_state = 33, .external_lex_state = 11},
  [1111] = {.lex_state = 32, .external_lex_state = 13},
  [1112] = {.lex_state = 32, .external_lex_state = 13},
  [1113] = {.lex_state = 32, .external_lex_state = 13},
  [1114] = {.lex_state = 33, .external_lex_state = 11},
  [1115] = {.lex_state = 24, .external_lex_state = 11},
  [1116] = {.lex_state = 24, .external_lex_state = 11},
  [1117] = {.lex_state = 24, .external_lex_state = 11},
  [1118] = {.lex_state = 24, .external_lex_state = 2},
  [1119] = {.lex_state = 24, .external_lex_state = 2},
  [1120] = {.lex_state = 24, .external_lex_state = 2},
  [1121] = {.lex_state = 24, .external_lex_state = 11},
  [1122] = {.lex_state = 33, .external_lex_state = 13},
  [1123] = {.lex_state = 24, .external_lex_state = 2},
  [1124] = {.lex_state = 24, .external_lex_state = 2},
  [1125] = {.lex_state = 24, .external_lex_state = 2},
  [1126] = {.lex_state = 33, .external_lex_state = 11},
  [1127] = {.lex_state = 33, .external_lex_state = 11},
  [1128] = {.lex_state = 24, .external_lex_state = 11},
  [1129] = {.lex_state = 33, .external_lex_state = 11},
  [1130] = {.lex_state = 33, .external_lex_state = 11},
  [1131] = {.lex_state = 33, .external_lex_state = 11},
  [1132] = {.lex_state = 24, .external_lex_state = 2},
  [1133] = {.lex_state = 24, .external_lex_state = 11},
  [1134] = {.lex_state = 24, .external_lex_state = 11},
  [1135] = {.lex_state = 33, .external_lex_state = 9},
  [1136] = {.lex_state = 33, .external_lex_state = 11},
  [1137] = {.lex_state = 24, .external_lex_state = 2},
  [1138] = {.lex_state = 33, .external_lex_state = 11},
  [1139] = {.lex_state = 24, .external_lex_state = 11},
  [1140] = {.lex_state = 33, .external_lex_state = 11},
  [1141] = {.lex_state = 24, .external_lex_state = 11},
  [1142] = {.lex_state = 24, .external_lex_state = 2},
  [1143] = {.lex_state = 32, .external_lex_state = 12},
  [1144] = {.lex_state = 32, .external_lex_state = 12},
  [1145] = {.lex_state = 33, .external_lex_state = 13},
  [1146] = {.lex_state = 32, .external_lex_state = 12},
  [1147] = {.lex_state = 33, .external_lex_state = 11},
  [1148] = {.lex_state = 24, .external_lex_state = 2},
  [1149] = {.lex_state = 33, .external_lex_state = 13},
  [1150] = {.lex_state = 33, .external_lex_state = 13},
  [1151] = {.lex_state = 33, .external_lex_state = 13},
  [1152] = {.lex_state = 24, .external_lex_state = 11},
  [1153] = {.lex_state = 24, .external_lex_state = 11},
  [1154] = {.lex_state = 24, .external_lex_state = 11},
  [1155] = {.lex_state = 24, .external_lex_state = 11},
  [1156] = {.lex_state = 33, .external_lex_state = 13},
  [1157] = {.lex_state = 33, .external_lex_state = 13},
  [1158] = {.lex_state = 22, .external_lex_state = 10},
  [1159] = {.lex_state = 33, .external_lex_state = 12},
  [1160] = {.lex_state = 33, .external_lex_state = 12},
  [1161] = {.lex_state = 33, .external_lex_state = 13},
  [1162] = {.lex_state = 33, .external_lex_state = 13},
  [1163] = {.lex_state = 33, .external_lex_state = 12},
  [1164] = {.lex_state = 33, .external_lex_state = 13},
  [1165] = {.lex_state = 24, .external_lex_state = 13},
  [1166] = {.lex_state = 33, .external_lex_state = 13},
  [1167] = {.lex_state = 22, .external_lex_state = 10},
  [1168] = {.lex_state = 24, .external_lex_state = 10},
  [1169] = {.lex_state = 22, .external_lex_state = 10},
  [1170] = {.lex_state = 22, .external_lex_state = 10},
  [1171] = {.lex_state = 24, .external_lex_state = 2},
  [1172] = {.lex_state = 33, .external_lex_state = 13},
  [1173] = {.lex_state = 24, .external_lex_state = 13},
  [1174] = {.lex_state = 33, .external_lex_state = 13},
  [1175] = {.lex_state = 24, .external_lex_state = 13},
  [1176] = {.lex_state = 33, .external_lex_state = 13},
  [1177] = {.lex_state = 33, .external_lex_state = 13},
  [1178] = {.lex_state = 33, .external_lex_state = 12},
  [1179] = {.lex_state = 24, .external_lex_state = 2},
  [1180] = {.lex_state = 24, .external_lex_state = 13},
  [1181] = {.lex_state = 24, .external_lex_state = 13},
  [1182] = {.lex_state = 33, .external_lex_state = 13},
  [1183] = {.lex_state = 24, .external_lex_state = 13},
  [1184] = {.lex_state = 24, .external_lex_state = 13},
  [1185] = {.lex_state = 24, .external_lex_state = 2},
  [1186] = {.lex_state = 24, .external_lex_state = 2},
  [1187] = {.lex_state = 33, .external_lex_state = 13},
  [1188] = {.lex_state = 33, .external_lex_state = 13},
  [1189] = {.lex_state = 33, .external_lex_state = 13},
  [1190] = {.lex_state = 24, .external_lex_state = 13},
  [1191] = {.lex_state = 24, .external_lex_state = 2},
  [1192] = {.lex_state = 24, .external_lex_state = 2},
  [1193] = {.lex_state = 24, .external_lex_state = 13},
  [1194] = {.lex_state = 24, .external_lex_state = 13},
  [1195] = {.lex_state = 33, .external_lex_state = 13},
  [1196] = {.lex_state = 33, .external_lex_state = 13},
  [1197] = {.lex_state = 33, .external_lex_state = 13},
  [1198] = {.lex_state = 33, .external_lex_state = 13},
  [1199] = {.lex_state = 24, .external_lex_state = 2},
  [1200] = {.lex_state = 33, .external_lex_state = 13},
  [1201] = {.lex_state = 33, .external_lex_state = 13},
  [1202] = {.lex_state = 24, .external_lex_state = 2},
  [1203] = {.lex_state = 24, .external_lex_state = 13},
  [1204] = {.lex_state = 24, .external_lex_state = 2},
  [1205] = {.lex_state = 24, .external_lex_state = 13},
  [1206] = {.lex_state = 24, .external_lex_state = 2},
  [1207] = {.lex_state = 24, .external_lex_state = 2},
  [1208] = {.lex_state = 24, .external_lex_state = 2},
  [1209] = {.lex_state = 24, .external_lex_state = 2},
  [1210] = {.lex_state = 194, .external_lex_state = 2},
  [1211] = {.lex_state = 33, .external_lex_state = 12},
  [1212] = {.lex_state = 24, .external_lex_state = 13},
  [1213] = {.lex_state = 24, .external_lex_state = 13},
  [1214] = {.lex_state = 24, .external_lex_state = 2},
  [1215] = {.lex_state = 33, .external_lex_state = 13},
  [1216] = {.lex_state = 24, .external_lex_state = 2},
  [1217] = {.lex_state = 33, .external_lex_state = 13},
  [1218] = {.lex_state = 24, .external_lex_state = 2},
  [1219] = {.lex_state = 24, .external_lex_state = 13},
  [1220] = {.lex_state = 24, .external_lex_state = 2},
  [1221] = {.lex_state = 33, .external_lex_state = 13},
  [1222] = {.lex_state = 24, .external_lex_state = 13},
  [1223] = {.lex_state = 33, .external_lex_state = 13},
  [1224] = {.lex_state = 33, .external_lex_state = 12},
  [1225] = {.lex_state = 33, .external_lex_state = 12},
  [1226] = {.lex_state = 24, .external_lex_state = 2},
  [1227] = {.lex_state = 24, .external_lex_state = 13},
  [1228] = {.lex_state = 24, .external_lex_state = 13},
  [1229] = {.lex_state = 24, .external_lex_state = 2},
  [1230] = {.lex_state = 33, .external_lex_state = 13},
  [1231] = {.lex_state = 33, .external_lex_state = 12},
  [1232] = {.lex_state = 24, .external_lex_state = 2},
  [1233] = {.lex_state = 24, .external_lex_state = 13},
  [1234] = {.lex_state = 33, .external_lex_state = 12},
  [1235] = {.lex_state = 24, .external_lex_state = 13},
  [1236] = {.lex_state = 33, .external_lex_state = 12},
  [1237] = {.lex_state = 33, .external_lex_state = 12},
  [1238] = {.lex_state = 33, .external_lex_state = 12},
  [1239] = {.lex_state = 24, .external_lex_state = 2},
  [1240] = {.lex_state = 33, .external_lex_state = 13},
  [1241] = {.lex_state = 24, .external_lex_state = 2},
  [1242] = {.lex_state = 33, .external_lex_state = 13},
  [1243] = {.lex_state = 33, .external_lex_state = 12},
  [1244] = {.lex_state = 24, .external_lex_state = 13},
  [1245] = {.lex_state = 33, .external_lex_state = 12},
  [1246] = {.lex_state = 33, .external_lex_state = 13},
  [1247] = {.lex_state = 24, .external_lex_state = 2},
  [1248] = {.lex_state = 33, .external_lex_state = 12},
  [1249] = {.lex_state = 24, .external_lex_state = 13},
  [1250] = {.lex_state = 24, .external_lex_state = 2},
  [1251] = {.lex_state = 24, .external_lex_state = 2},
  [1252] = {.lex_state = 24, .external_lex_state = 2},
  [1253] = {.lex_state = 24, .external_lex_state = 13},
  [1254] = {.lex_state = 33, .external_lex_state = 13},
  [1255] = {.lex_state = 24, .external_lex_state = 2},
  [1256] = {.lex_state = 24, .external_lex_state = 2},
  [1257] = {.lex_state = 24, .external_lex_state = 2},
  [1258] = {.lex_state = 24, .external_lex_state = 2},
  [1259] = {.lex_state = 33, .external_lex_state = 13},
  [1260] = {.lex_state = 24, .external_lex_state = 2},
  [1261] = {.lex_state = 33, .external_lex_state = 12},
  [1262] = {.lex_state = 24, .external_lex_state = 2},
  [1263] = {.lex_state = 23, .external_lex_state = 12},
  [1264] = {.lex_state = 23, .external_lex_state = 12},
  [1265] = {.lex_state = 24, .external_lex_state = 2},
  [1266] = {.lex_state = 24, .external_lex_state = 2},
  [1267] = {.lex_state = 24, .external_lex_state = 2},
  [1268] = {.lex_state = 33, .external_lex_state = 12},
  [1269] = {.lex_state = 33, .external_lex_state = 12},
  [1270] = {.lex_state = 24, .external_lex_state = 13},
  [1271] = {.lex_state = 33, .external_lex_state = 12},
  [1272] = {.lex_state = 33, .external_lex_state = 12},
  [1273] = {.lex_state = 23, .external_lex_state = 12},
  [1274] = {.lex_state = 33, .external_lex_state = 12},
  [1275] = {.lex_state = 24, .external_lex_state = 13},
  [1276] = {.lex_state = 24, .external_lex_state = 13},
  [1277] = {.lex_state = 24, .external_lex_state = 2},
  [1278] = {.lex_state = 24, .external_lex_state = 13},
  [1279] = {.lex_state = 33, .external_lex_state = 13},
  [1280] = {.lex_state = 33, .external_lex_state = 13},
  [1281] = {.lex_state = 33, .external_lex_state = 13},
  [1282] = {.lex_state = 33, .external_lex_state = 13},
  [1283] = {.lex_state = 33, .external_lex_state = 12},
  [1284] = {.lex_state = 24, .external_lex_state = 13},
  [1285] = {.lex_state = 33, .external_lex_state = 12},
  [1286] = {.lex_state = 33, .external_lex_state = 13},
  [1287] = {.lex_state = 33, .external_lex_state = 12},
  [1288] = {.lex_state = 24, .external_lex_state = 13},
  [1289] = {.lex_state = 24, .external_lex_state = 13},
  [1290] = {.lex_state = 33, .external_lex_state = 12},
  [1291] = {.lex_state = 24, .external_lex_state = 13},
  [1292] = {.lex_state = 24, .external_lex_state = 13},
  [1293] = {.lex_state = 24, .external_lex_state = 13},
  [1294] = {.lex_state = 33, .external_lex_state = 12},
  [1295] = {.lex_state = 33, .external_lex_state = 12},
  [1296] = {.lex_state = 33, .external_lex_state = 12},
  [1297] = {.lex_state = 33, .external_lex_state = 12},
  [1298] = {.lex_state = 24, .external_lex_state = 13},
  [1299] = {.lex_state = 22, .external_lex_state = 10},
  [1300] = {.lex_state = 33, .external_lex_state = 12},
  [1301] = {.lex_state = 22, .external_lex_state = 10},
  [1302] = {.lex_state = 24, .external_lex_state = 13},
  [1303] = {.lex_state = 33, .external_lex_state = 12},
  [1304] = {.lex_state = 33, .external_lex_state = 12},
  [1305] = {.lex_state = 24, .external_lex_state = 9},
  [1306] = {.lex_state = 24, .external_lex_state = 13},
  [1307] = {.lex_state = 33, .external_lex_state = 12},
  [1308] = {.lex_state = 24, .external_lex_state = 13},
  [1309] = {.lex_state = 24, .external_lex_state = 2},
  [1310] = {.lex_state = 33, .external_lex_state = 12},
  [1311] = {.lex_state = 33, .external_lex_state = 12},
  [1312] = {.lex_state = 23, .external_lex_state = 13},
  [1313] = {.lex_state = 23, .external_lex_state = 13},
  [1314] = {.lex_state = 33, .external_lex_state = 12},
  [1315] = {.lex_state = 194, .external_lex_state = 2},
  [1316] = {.lex_state = 33, .external_lex_state = 12},
  [1317] = {.lex_state = 33, .external_lex_state = 12},
  [1318] = {.lex_state = 33, .external_lex_state = 12},
  [1319] = {.lex_state = 33, .external_lex_state = 13},
  [1320] = {.lex_state = 23, .external_lex_state = 13},
  [1321] = {.lex_state = 24, .external_lex_state = 9},
  [1322] = {.lex_state = 33, .external_lex_state = 12},
  [1323] = {.lex_state = 33, .external_lex_state = 12},
  [1324] = {.lex_state = 24, .external_lex_state = 12},
  [1325] = {.lex_state = 24, .external_lex_state = 2},
  [1326] = {.lex_state = 24, .external_lex_state = 12},
  [1327] = {.lex_state = 24, .external_lex_state = 12},
  [1328] = {.lex_state = 24, .external_lex_state = 2},
  [1329] = {.lex_state = 24, .external_lex_state = 2},
  [1330] = {.lex_state = 24, .external_lex_state = 2},
  [1331] = {.lex_state = 24, .external_lex_state = 12},
  [1332] = {.lex_state = 23, .external_lex_state = 13},
  [1333] = {.lex_state = 24, .external_lex_state = 12},
  [1334] = {.lex_state = 23, .external_lex_state = 11},
  [1335] = {.lex_state = 23, .external_lex_state = 13},
  [1336] = {.lex_state = 24, .external_lex_state = 2},
  [1337] = {.lex_state = 23, .external_lex_state = 11},
  [1338] = {.lex_state = 24, .external_lex_state = 12},
  [1339] = {.lex_state = 24, .external_lex_state = 12},
  [1340] = {.lex_state = 23, .external_lex_state = 11},
  [1341] = {.lex_state = 24, .external_lex_state = 2},
  [1342] = {.lex_state = 24, .external_lex_state = 12},
  [1343] = {.lex_state = 24, .external_lex_state = 12},
  [1344] = {.lex_state = 24, .external_lex_state = 12},
  [1345] = {.lex_state = 23, .external_lex_state = 13},
  [1346] = {.lex_state = 24, .external_lex_state = 2},
  [1347] = {.lex_state = 24, .external_lex_state = 12},
  [1348] = {.lex_state = 24, .external_lex_state = 12},
  [1349] = {.lex_state = 24, .external_lex_state = 12},
  [1350] = {.lex_state = 24, .external_lex_state = 12},
  [1351] = {.lex_state = 24, .external_lex_state = 12},
  [1352] = {.lex_state = 24, .external_lex_state = 12},
  [1353] = {.lex_state = 24, .external_lex_state = 12},
  [1354] = {.lex_state = 24, .external_lex_state = 12},
  [1355] = {.lex_state = 24, .external_lex_state = 12},
  [1356] = {.lex_state = 24, .external_lex_state = 12},
  [1357] = {.lex_state = 24, .external_lex_state = 12},
  [1358] = {.lex_state = 24, .external_lex_state = 2},
  [1359] = {.lex_state = 24, .external_lex_state = 2},
  [1360] = {.lex_state = 23, .external_lex_state = 12},
  [1361] = {.lex_state = 23, .external_lex_state = 12},
  [1362] = {.lex_state = 24, .external_lex_state = 12},
  [1363] = {.lex_state = 23, .external_lex_state = 12},
  [1364] = {.lex_state = 24, .external_lex_state = 2},
  [1365] = {.lex_state = 24, .external_lex_state = 2},
  [1366] = {.lex_state = 24, .external_lex_state = 12},
  [1367] = {.lex_state = 24, .external_lex_state = 2},
  [1368] = {.lex_state = 24, .external_lex_state = 12},
  [1369] = {.lex_state = 24, .external_lex_state = 12},
  [1370] = {.lex_state = 24, .external_lex_state = 12},
  [1371] = {.lex_state = 24, .external_lex_state = 12},
  [1372] = {.lex_state = 24, .external_lex_state = 12},
  [1373] = {.lex_state = 24, .external_lex_state = 12},
  [1374] = {.lex_state = 24, .external_lex_state = 2},
  [1375] = {.lex_state = 24, .external_lex_state = 12},
  [1376] = {.lex_state = 24, .external_lex_state = 12},
  [1377] = {.lex_state = 24, .external_lex_state = 12},
  [1378] = {.lex_state = 24, .external_lex_state = 12},
  [1379] = {.lex_state = 24, .external_lex_state = 12},
  [1380] = {.lex_state = 24, .external_lex_state = 12},
  [1381] = {.lex_state = 24, .external_lex_state = 12},
  [1382] = {.lex_state = 24, .external_lex_state = 12},
  [1383] = {.lex_state = 24, .external_lex_state = 12},
  [1384] = {.lex_state = 22, .external_lex_state = 2},
  [1385] = {.lex_state = 22, .external_lex_state = 2},
  [1386] = {.lex_state = 22, .external_lex_state = 2},
  [1387] = {.lex_state = 22, .external_lex_state = 2},
  [1388] = {.lex_state = 24, .external_lex_state = 13},
  [1389] = {.lex_state = 24, .external_lex_state = 11},
  [1390] = {.lex_state = 22, .external_lex_state = 2},
  [1391] = {.lex_state = 22, .external_lex_state = 2},
  [1392] = {.lex_state = 22, .external_lex_state = 2},
  [1393] = {.lex_state = 22, .external_lex_state = 2},
  [1394] = {.lex_state = 22, .external_lex_state = 2},
  [1395] = {.lex_state = 22, .external_lex_state = 2},
  [1396] = {.lex_state = 22, .external_lex_state = 2},
  [1397] = {.lex_state = 22, .external_lex_state = 2},
  [1398] = {.lex_state = 22, .external_lex_state = 2},
  [1399] = {.lex_state = 22, .external_lex_state = 2},
  [1400] = {.lex_state = 22, .external_lex_state = 2},
  [1401] = {.lex_state = 22, .external_lex_state = 2},
  [1402] = {.lex_state = 22, .external_lex_state = 10},
  [1403] = {.lex_state = 22, .external_lex_state = 10},
  [1404] = {.lex_state = 24, .external_lex_state = 11},
  [1405] = {.lex_state = 22, .external_lex_state = 13},
  [1406] = {.lex_state = 24, .external_lex_state = 11},
  [1407] = {.lex_state = 24, .external_lex_state = 11},
  [1408] = {.lex_state = 24, .external_lex_state = 11},
  [1409] = {.lex_state = 22, .external_lex_state = 13},
  [1410] = {.lex_state = 24, .external_lex_state = 11},
  [1411] = {.lex_state = 24, .external_lex_state = 11},
  [1412] = {.lex_state = 22, .external_lex_state = 12},
  [1413] = {.lex_state = 22, .external_lex_state = 2},
  [1414] = {.lex_state = 22, .external_lex_state = 2},
  [1415] = {.lex_state = 22, .external_lex_state = 11},
  [1416] = {.lex_state = 22, .external_lex_state = 11},
  [1417] = {.lex_state = 22, .external_lex_state = 12},
  [1418] = {.lex_state = 33, .external_lex_state = 11},
  [1419] = {.lex_state = 33, .external_lex_state = 11},
  [1420] = {.lex_state = 24, .external_lex_state = 13},
  [1421] = {.lex_state = 27, .external_lex_state = 10},
  [1422] = {.lex_state = 24, .external_lex_state = 13},
  [1423] = {.lex_state = 33, .external_lex_state = 13},
  [1424] = {.lex_state = 24, .external_lex_state = 13},
  [1425] = {.lex_state = 27, .external_lex_state = 10},
  [1426] = {.lex_state = 24, .external_lex_state = 13},
  [1427] = {.lex_state = 33, .external_lex_state = 12},
  [1428] = {.lex_state = 33, .external_lex_state = 12},
  [1429] = {.lex_state = 30, .external_lex_state = 10},
  [1430] = {.lex_state = 24, .external_lex_state = 13},
  [1431] = {.lex_state = 24, .external_lex_state = 13},
  [1432] = {.lex_state = 30, .external_lex_state = 10},
  [1433] = {.lex_state = 33, .external_lex_state = 13},
  [1434] = {.lex_state = 24, .external_lex_state = 2},
  [1435] = {.lex_state = 24, .external_lex_state = 2},
  [1436] = {.lex_state = 24, .external_lex_state = 2},
  [1437] = {.lex_state = 24, .external_lex_state = 2},
  [1438] = {.lex_state = 24, .external_lex_state = 2},
  [1439] = {.lex_state = 24, .external_lex_state = 2},
  [1440] = {.lex_state = 24, .external_lex_state = 2},
  [1441] = {.lex_state = 24, .external_lex_state = 2},
  [1442] = {.lex_state = 24, .external_lex_state = 2},
  [1443] = {.lex_state = 24, .external_lex_state = 2},
  [1444] = {.lex_state = 24, .external_lex_state = 2},
  [1445] = {.lex_state = 24, .external_lex_state = 12},
  [1446] = {.lex_state = 24, .external_lex_state = 2},
  [1447] = {.lex_state = 24, .external_lex_state = 12},
  [1448] = {.lex_state = 24, .external_lex_state = 12},
  [1449] = {.lex_state = 1, .external_lex_state = 14},
  [1450] = {.lex_state = 24, .external_lex_state = 12},
  [1451] = {.lex_state = 24, .external_lex_state = 2},
  [1452] = {.lex_state = 24, .external_lex_state = 2},
  [1453] = {.lex_state = 30, .external_lex_state = 10},
  [1454] = {.lex_state = 30, .external_lex_state = 10},
  [1455] = {.lex_state = 24, .external_lex_state = 12},
  [1456] = {.lex_state = 24, .external_lex_state = 12},
  [1457] = {.lex_state = 24, .external_lex_state = 2},
  [1458] = {.lex_state = 24, .external_lex_state = 2},
  [1459] = {.lex_state = 24, .external_lex_state = 2},
  [1460] = {.lex_state = 24, .external_lex_state = 13},
  [1461] = {.lex_state = 24, .external_lex_state = 2},
  [1462] = {.lex_state = 24, .external_lex_state = 2},
  [1463] = {.lex_state = 24, .external_lex_state = 2},
  [1464] = {.lex_state = 30, .external_lex_state = 10},
  [1465] = {.lex_state = 30, .external_lex_state = 10},
  [1466] = {.lex_state = 24, .external_lex_state = 2},
  [1467] = {.lex_state = 24, .external_lex_state = 2},
  [1468] = {.lex_state = 24, .external_lex_state = 2},
  [1469] = {.lex_state = 24, .external_lex_state = 2},
  [1470] = {.lex_state = 24, .external_lex_state = 2},
  [1471] = {.lex_state = 24, .external_lex_state = 13},
  [1472] = {.lex_state = 24, .external_lex_state = 13},
  [1473] = {.lex_state = 24, .external_lex_state = 2},
  [1474] = {.lex_state = 24, .external_lex_state = 13},
  [1475] = {.lex_state = 24, .external_lex_state = 2},
  [1476] = {.lex_state = 24, .external_lex_state = 2},
  [1477] = {.lex_state = 24, .external_lex_state = 2},
  [1478] = {.lex_state = 24, .external_lex_state = 2},
  [1479] = {.lex_state = 24, .external_lex_state = 2},
  [1480] = {.lex_state = 24, .external_lex_state = 13},
  [1481] = {.lex_state = 24, .external_lex_state = 13},
  [1482] = {.lex_state = 22, .external_lex_state = 2},
  [1483] = {.lex_state = 194, .external_lex_state = 2},
  [1484] = {.lex_state = 52, .external_lex_state = 2},
  [1485] = {.lex_state = 52, .external_lex_state = 2},
  [1486] = {.lex_state = 41, .external_lex_state = 14},
  [1487] = {.lex_state = 22, .external_lex_state = 2},
  [1488] = {.lex_state = 52, .external_lex_state = 2},
  [1489] = {.lex_state = 30, .external_lex_state = 2},
  [1490] = {.lex_state = 52, .external_lex_state = 2},
  [1491] = {.lex_state = 22, .external_lex_state = 2},
  [1492] = {.lex_state = 52, .external_lex_state = 2},
  [1493] = {.lex_state = 52, .external_lex_state = 2},
  [1494] = {.lex_state = 30, .external_lex_state = 2},
  [1495] = {.lex_state = 30, .external_lex_state = 2},
  [1496] = {.lex_state = 52, .external_lex_state = 2},
  [1497] = {.lex_state = 52, .external_lex_state = 2},
  [1498] = {.lex_state = 30, .external_lex_state = 10},
  [1499] = {.lex_state = 52, .external_lex_state = 2},
  [1500] = {.lex_state = 30, .external_lex_state = 2},
  [1501] = {.lex_state = 52, .external_lex_state = 2},
  [1502] = {.lex_state = 52, .external_lex_state = 2},
  [1503] = {.lex_state = 52, .external_lex_state = 2},
  [1504] = {.lex_state = 22, .external_lex_state = 2},
  [1505] = {.lex_state = 52, .external_lex_state = 2},
  [1506] = {.lex_state = 27, .external_lex_state = 2},
  [1507] = {.lex_state = 52, .external_lex_state = 13},
  [1508] = {.lex_state = 27, .external_lex_state = 2},
  [1509] = {.lex_state = 52, .external_lex_state = 2},
  [1510] = {.lex_state = 52, .external_lex_state = 13},
  [1511] = {.lex_state = 41, .external_lex_state = 14},
  [1512] = {.lex_state = 42, .external_lex_state = 2},
  [1513] = {.lex_state = 52, .external_lex_state = 13},
  [1514] = {.lex_state = 30, .external_lex_state = 2},
  [1515] = {.lex_state = 52, .external_lex_state = 2},
  [1516] = {.lex_state = 52, .external_lex_state = 2},
  [1517] = {.lex_state = 52, .external_lex_state = 2},
  [1518] = {.lex_state = 41, .external_lex_state = 14},
  [1519] = {.lex_state = 41, .external_lex_state = 14},
  [1520] = {.lex_state = 41, .external_lex_state = 14},
  [1521] = {.lex_state = 41, .external_lex_state = 2},
  [1522] = {.lex_state = 41, .external_lex_state = 14},
  [1523] = {.lex_state = 41, .external_lex_state = 14},
  [1524] = {.lex_state = 41, .external_lex_state = 14},
  [1525] = {.lex_state = 41, .external_lex_state = 14},
  [1526] = {.lex_state = 22, .external_lex_state = 10},
  [1527] = {.lex_state = 33, .external_lex_state = 11},
  [1528] = {.lex_state = 33, .external_lex_state = 11},
  [1529] = {.lex_state = 22, .external_lex_state = 10},
  [1530] = {.lex_state = 22, .external_lex_state = 10},
  [1531] = {.lex_state = 33, .external_lex_state = 11},
  [1532] = {.lex_state = 33, .external_lex_state = 11},
  [1533] = {.lex_state = 33, .external_lex_state = 11},
  [1534] = {.lex_state = 33, .external_lex_state = 11},
  [1535] = {.lex_state = 33, .external_lex_state = 11},
  [1536] = {.lex_state = 41, .external_lex_state = 14},
  [1537] = {.lex_state = 33, .external_lex_state = 11},
  [1538] = {.lex_state = 33, .external_lex_state = 13},
  [1539] = {.lex_state = 22, .external_lex_state = 10},
  [1540] = {.lex_state = 41, .external_lex_state = 2},
  [1541] = {.lex_state = 41, .external_lex_state = 2},
  [1542] = {.lex_state = 41, .external_lex_state = 2},
  [1543] = {.lex_state = 22, .external_lex_state = 10},
  [1544] = {.lex_state = 33, .external_lex_state = 13},
  [1545] = {.lex_state = 33, .external_lex_state = 12},
  [1546] = {.lex_state = 22, .external_lex_state = 10},
  [1547] = {.lex_state = 33, .external_lex_state = 13},
  [1548] = {.lex_state = 33, .external_lex_state = 13},
  [1549] = {.lex_state = 16, .external_lex_state = 2},
  [1550] = {.lex_state = 33, .external_lex_state = 13},
  [1551] = {.lex_state = 22, .external_lex_state = 10},
  [1552] = {.lex_state = 33, .external_lex_state = 13},
  [1553] = {.lex_state = 33, .external_lex_state = 12},
  [1554] = {.lex_state = 33, .external_lex_state = 13},
  [1555] = {.lex_state = 16, .external_lex_state = 2},
  [1556] = {.lex_state = 33, .external_lex_state = 13},
  [1557] = {.lex_state = 33, .external_lex_state = 13},
  [1558] = {.lex_state = 22, .external_lex_state = 10},
  [1559] = {.lex_state = 33, .external_lex_state = 13},
  [1560] = {.lex_state = 33, .external_lex_state = 13},
  [1561] = {.lex_state = 22, .external_lex_state = 10},
  [1562] = {.lex_state = 33, .external_lex_state = 13},
  [1563] = {.lex_state = 41, .external_lex_state = 2},
  [1564] = {.lex_state = 33, .external_lex_state = 13},
  [1565] = {.lex_state = 33, .external_lex_state = 13},
  [1566] = {.lex_state = 41, .external_lex_state = 2},
  [1567] = {.lex_state = 33, .external_lex_state = 13},
  [1568] = {.lex_state = 33, .external_lex_state = 12},
  [1569] = {.lex_state = 33, .external_lex_state = 13},
  [1570] = {.lex_state = 16, .external_lex_state = 2},
  [1571] = {.lex_state = 33, .external_lex_state = 12},
  [1572] = {.lex_state = 33, .external_lex_state = 13},
  [1573] = {.lex_state = 33, .external_lex_state = 12},
  [1574] = {.lex_state = 22, .external_lex_state = 10},
  [1575] = {.lex_state = 33, .external_lex_state = 12},
  [1576] = {.lex_state = 33, .external_lex_state = 12},
  [1577] = {.lex_state = 33, .external_lex_state = 12},
  [1578] = {.lex_state = 22, .external_lex_state = 13},
  [1579] = {.lex_state = 17, .external_lex_state = 2},
  [1580] = {.lex_state = 41, .external_lex_state = 2},
  [1581] = {.lex_state = 22, .external_lex_state = 13},
  [1582] = {.lex_state = 68, .external_lex_state = 15},
  [1583] = {.lex_state = 68, .external_lex_state = 15},
  [1584] = {.lex_state = 68, .external_lex_state = 15},
  [1585] = {.lex_state = 68, .external_lex_state = 15},
  [1586] = {.lex_state = 22, .external_lex_state = 10},
  [1587] = {.lex_state = 22, .external_lex_state = 13},
  [1588] = {.lex_state = 68, .external_lex_state = 15},
  [1589] = {.lex_state = 68, .external_lex_state = 15},
  [1590] = {.lex_state = 41, .external_lex_state = 2},
  [1591] = {.lex_state = 68, .external_lex_state = 15},
  [1592] = {.lex_state = 68, .external_lex_state = 15},
  [1593] = {.lex_state = 22, .external_lex_state = 13},
  [1594] = {.lex_state = 68, .external_lex_state = 15},
  [1595] = {.lex_state = 68, .external_lex_state = 15},
  [1596] = {.lex_state = 68, .external_lex_state = 15},
  [1597] = {.lex_state = 68, .external_lex_state = 15},
  [1598] = {.lex_state = 17, .external_lex_state = 2},
  [1599] = {.lex_state = 68, .external_lex_state = 15},
  [1600] = {.lex_state = 68, .external_lex_state = 15},
  [1601] = {.lex_state = 22, .external_lex_state = 2},
  [1602] = {.lex_state = 22, .external_lex_state = 11},
  [1603] = {.lex_state = 22, .external_lex_state = 11},
  [1604] = {.lex_state = 68, .external_lex_state = 15},
  [1605] = {.lex_state = 68, .external_lex_state = 15},
  [1606] = {.lex_state = 22, .external_lex_state = 13},
  [1607] = {.lex_state = 22, .external_lex_state = 13},
  [1608] = {.lex_state = 22, .external_lex_state = 13},
  [1609] = {.lex_state = 68, .external_lex_state = 15},
  [1610] = {.lex_state = 22, .external_lex_state = 13},
  [1611] = {.lex_state = 22, .external_lex_state = 13},
  [1612] = {.lex_state = 68, .external_lex_state = 15},
  [1613] = {.lex_state = 22, .external_lex_state = 2},
  [1614] = {.lex_state = 22, .external_lex_state = 13},
  [1615] = {.lex_state = 22, .external_lex_state = 2},
  [1616] = {.lex_state = 68, .external_lex_state = 15},
  [1617] = {.lex_state = 41, .external_lex_state = 2},
  [1618] = {.lex_state = 17, .external_lex_state = 2},
  [1619] = {.lex_state = 33, .external_lex_state = 11},
  [1620] = {.lex_state = 33, .external_lex_state = 11},
  [1621] = {.lex_state = 22, .external_lex_state = 11},
  [1622] = {.lex_state = 22, .external_lex_state = 12},
  [1623] = {.lex_state = 22, .external_lex_state = 11},
  [1624] = {.lex_state = 22, .external_lex_state = 11},
  [1625] = {.lex_state = 22, .external_lex_state = 12},
  [1626] = {.lex_state = 22, .external_lex_state = 11},
  [1627] = {.lex_state = 22, .external_lex_state = 11},
  [1628] = {.lex_state = 22, .external_lex_state = 12},
  [1629] = {.lex_state = 41, .external_lex_state = 2},
  [1630] = {.lex_state = 22, .external_lex_state = 12},
  [1631] = {.lex_state = 22, .external_lex_state = 12},
  [1632] = {.lex_state = 22, .external_lex_state = 12},
  [1633] = {.lex_state = 22, .external_lex_state = 12},
  [1634] = {.lex_state = 33, .external_lex_state = 11},
  [1635] = {.lex_state = 22, .external_lex_state = 12},
  [1636] = {.lex_state = 22, .external_lex_state = 11},
  [1637] = {.lex_state = 22, .external_lex_state = 12},
  [1638] = {.lex_state = 22, .external_lex_state = 11},
  [1639] = {.lex_state = 22, .external_lex_state = 2},
  [1640] = {.lex_state = 22, .external_lex_state = 2},
  [1641] = {.lex_state = 22, .external_lex_state = 11},
  [1642] = {.lex_state = 22, .external_lex_state = 2},
  [1643] = {.lex_state = 22, .external_lex_state = 2},
  [1644] = {.lex_state = 22, .external_lex_state = 2},
  [1645] = {.lex_state = 27, .external_lex_state = 10},
  [1646] = {.lex_state = 22, .external_lex_state = 2},
  [1647] = {.lex_state = 22, .external_lex_state = 11},
  [1648] = {.lex_state = 22, .external_lex_state = 11},
  [1649] = {.lex_state = 33, .external_lex_state = 11},
  [1650] = {.lex_state = 33, .external_lex_state = 11},
  [1651] = {.lex_state = 33, .external_lex_state = 11},
  [1652] = {.lex_state = 22, .external_lex_state = 11},
  [1653] = {.lex_state = 33, .external_lex_state = 11},
  [1654] = {.lex_state = 22, .external_lex_state = 2},
  [1655] = {.lex_state = 33, .external_lex_state = 11},
  [1656] = {.lex_state = 22, .external_lex_state = 12},
  [1657] = {.lex_state = 33, .external_lex_state = 11},
  [1658] = {.lex_state = 22, .external_lex_state = 12},
  [1659] = {.lex_state = 45, .external_lex_state = 16},
  [1660] = {.lex_state = 27, .external_lex_state = 10},
  [1661] = {.lex_state = 45, .external_lex_state = 16},
  [1662] = {.lex_state = 44, .external_lex_state = 2},
  [1663] = {.lex_state = 27, .external_lex_state = 10},
  [1664] = {.lex_state = 27, .external_lex_state = 10},
  [1665] = {.lex_state = 27, .external_lex_state = 10},
  [1666] = {.lex_state = 22, .external_lex_state = 12},
  [1667] = {.lex_state = 27, .external_lex_state = 10},
  [1668] = {.lex_state = 27, .external_lex_state = 10},
  [1669] = {.lex_state = 27, .external_lex_state = 10},
  [1670] = {.lex_state = 7, .external_lex_state = 2},
  [1671] = {.lex_state = 45, .external_lex_state = 16},
  [1672] = {.lex_state = 44, .external_lex_state = 2},
  [1673] = {.lex_state = 27, .external_lex_state = 10},
  [1674] = {.lex_state = 27, .external_lex_state = 2},
  [1675] = {.lex_state = 22, .external_lex_state = 12},
  [1676] = {.lex_state = 41, .external_lex_state = 2},
  [1677] = {.lex_state = 41, .external_lex_state = 2},
  [1678] = {.lex_state = 22, .external_lex_state = 12},
  [1679] = {.lex_state = 33, .external_lex_state = 11},
  [1680] = {.lex_state = 33, .external_lex_state = 12},
  [1681] = {.lex_state = 22, .external_lex_state = 12},
  [1682] = {.lex_state = 45, .external_lex_state = 16},
  [1683] = {.lex_state = 33, .external_lex_state = 11},
  [1684] = {.lex_state = 33, .external_lex_state = 12},
  [1685] = {.lex_state = 33, .external_lex_state = 12},
  [1686] = {.lex_state = 33, .external_lex_state = 12},
  [1687] = {.lex_state = 33, .external_lex_state = 13},
  [1688] = {.lex_state = 16, .external_lex_state = 2},
  [1689] = {.lex_state = 45, .external_lex_state = 16},
  [1690] = {.lex_state = 22, .external_lex_state = 12},
  [1691] = {.lex_state = 33, .external_lex_state = 12},
  [1692] = {.lex_state = 33, .external_lex_state = 11},
  [1693] = {.lex_state = 33, .external_lex_state = 12},
  [1694] = {.lex_state = 33, .external_lex_state = 12},
  [1695] = {.lex_state = 33, .external_lex_state = 12},
  [1696] = {.lex_state = 33, .external_lex_state = 12},
  [1697] = {.lex_state = 27, .external_lex_state = 10},
  [1698] = {.lex_state = 27, .external_lex_state = 10},
  [1699] = {.lex_state = 33, .external_lex_state = 13},
  [1700] = {.lex_state = 27, .external_lex_state = 10},
  [1701] = {.lex_state = 27, .external_lex_state = 10},
  [1702] = {.lex_state = 44, .external_lex_state = 2},
  [1703] = {.lex_state = 45, .external_lex_state = 16},
  [1704] = {.lex_state = 22, .external_lex_state = 12},
  [1705] = {.lex_state = 27, .external_lex_state = 10},
  [1706] = {.lex_state = 27, .external_lex_state = 10},
  [1707] = {.lex_state = 44, .external_lex_state = 2},
  [1708] = {.lex_state = 45, .external_lex_state = 16},
  [1709] = {.lex_state = 33, .external_lex_state = 13},
  [1710] = {.lex_state = 41, .external_lex_state = 2},
  [1711] = {.lex_state = 45, .external_lex_state = 16},
  [1712] = {.lex_state = 45, .external_lex_state = 16},
  [1713] = {.lex_state = 45, .external_lex_state = 16},
  [1714] = {.lex_state = 27, .external_lex_state = 2},
  [1715] = {.lex_state = 16, .external_lex_state = 2},
  [1716] = {.lex_state = 33, .external_lex_state = 12},
  [1717] = {.lex_state = 22, .external_lex_state = 12},
  [1718] = {.lex_state = 27, .external_lex_state = 10},
  [1719] = {.lex_state = 45, .external_lex_state = 16},
  [1720] = {.lex_state = 33, .external_lex_state = 13},
  [1721] = {.lex_state = 33, .external_lex_state = 13},
  [1722] = {.lex_state = 33, .external_lex_state = 13},
  [1723] = {.lex_state = 33, .external_lex_state = 13},
  [1724] = {.lex_state = 33, .external_lex_state = 13},
  [1725] = {.lex_state = 45, .external_lex_state = 16},
  [1726] = {.lex_state = 22, .external_lex_state = 12},
  [1727] = {.lex_state = 33, .external_lex_state = 12},
  [1728] = {.lex_state = 16, .external_lex_state = 2},
  [1729] = {.lex_state = 33, .external_lex_state = 13},
  [1730] = {.lex_state = 33, .external_lex_state = 12},
  [1731] = {.lex_state = 22, .external_lex_state = 12},
  [1732] = {.lex_state = 33, .external_lex_state = 13},
  [1733] = {.lex_state = 45, .external_lex_state = 16},
  [1734] = {.lex_state = 33, .external_lex_state = 11},
  [1735] = {.lex_state = 7, .external_lex_state = 2},
  [1736] = {.lex_state = 33, .external_lex_state = 13},
  [1737] = {.lex_state = 33, .external_lex_state = 13},
  [1738] = {.lex_state = 33, .external_lex_state = 11},
  [1739] = {.lex_state = 27, .external_lex_state = 10},
  [1740] = {.lex_state = 17, .external_lex_state = 2},
  [1741] = {.lex_state = 194, .external_lex_state = 14},
  [1742] = {.lex_state = 33, .external_lex_state = 12},
  [1743] = {.lex_state = 17, .external_lex_state = 2},
  [1744] = {.lex_state = 33, .external_lex_state = 12},
  [1745] = {.lex_state = 22, .external_lex_state = 2},
  [1746] = {.lex_state = 33, .external_lex_state = 11},
  [1747] = {.lex_state = 27, .external_lex_state = 13},
  [1748] = {.lex_state = 33, .external_lex_state = 13},
  [1749] = {.lex_state = 22, .external_lex_state = 12},
  [1750] = {.lex_state = 22, .external_lex_state = 12},
  [1751] = {.lex_state = 33, .external_lex_state = 12},
  [1752] = {.lex_state = 22, .external_lex_state = 2},
  [1753] = {.lex_state = 33, .external_lex_state = 11},
  [1754] = {.lex_state = 33, .external_lex_state = 11},
  [1755] = {.lex_state = 33, .external_lex_state = 11},
  [1756] = {.lex_state = 68, .external_lex_state = 15},
  [1757] = {.lex_state = 33, .external_lex_state = 11},
  [1758] = {.lex_state = 33, .external_lex_state = 13},
  [1759] = {.lex_state = 64, .external_lex_state = 2},
  [1760] = {.lex_state = 17, .external_lex_state = 2},
  [1761] = {.lex_state = 33, .external_lex_state = 11},
  [1762] = {.lex_state = 33, .external_lex_state = 11},
  [1763] = {.lex_state = 68, .external_lex_state = 15},
  [1764] = {.lex_state = 22, .external_lex_state = 12},
  [1765] = {.lex_state = 33, .external_lex_state = 11},
  [1766] = {.lex_state = 27, .external_lex_state = 10},
  [1767] = {.lex_state = 33, .external_lex_state = 12},
  [1768] = {.lex_state = 33, .external_lex_state = 11},
  [1769] = {.lex_state = 33, .external_lex_state = 13},
  [1770] = {.lex_state = 33, .external_lex_state = 13},
  [1771] = {.lex_state = 61, .external_lex_state = 2},
  [1772] = {.lex_state = 33, .external_lex_state = 11},
  [1773] = {.lex_state = 33, .external_lex_state = 11},
  [1774] = {.lex_state = 27, .external_lex_state = 12},
  [1775] = {.lex_state = 27, .external_lex_state = 10},
  [1776] = {.lex_state = 22, .external_lex_state = 2},
  [1777] = {.lex_state = 27, .external_lex_state = 13},
  [1778] = {.lex_state = 33, .external_lex_state = 13},
  [1779] = {.lex_state = 27, .external_lex_state = 11},
  [1780] = {.lex_state = 22, .external_lex_state = 12},
  [1781] = {.lex_state = 22, .external_lex_state = 13},
  [1782] = {.lex_state = 22, .external_lex_state = 13},
  [1783] = {.lex_state = 22, .external_lex_state = 13},
  [1784] = {.lex_state = 22, .external_lex_state = 10},
  [1785] = {.lex_state = 27, .external_lex_state = 10},
  [1786] = {.lex_state = 27, .external_lex_state = 13},
  [1787] = {.lex_state = 27, .external_lex_state = 11},
  [1788] = {.lex_state = 27, .external_lex_state = 10},
  [1789] = {.lex_state = 27, .external_lex_state = 12},
  [1790] = {.lex_state = 22, .external_lex_state = 12},
  [1791] = {.lex_state = 27, .external_lex_state = 12},
  [1792] = {.lex_state = 27, .external_lex_state = 10},
  [1793] = {.lex_state = 27, .external_lex_state = 10},
  [1794] = {.lex_state = 22, .external_lex_state = 13},
  [1795] = {.lex_state = 22, .external_lex_state = 13},
  [1796] = {.lex_state = 27, .external_lex_state = 10},
  [1797] = {.lex_state = 2, .external_lex_state = 2},
  [1798] = {.lex_state = 2, .external_lex_state = 2},
  [1799] = {.lex_state = 22, .external_lex_state = 10},
  [1800] = {.lex_state = 22, .external_lex_state = 10},
  [1801] = {.lex_state = 68, .external_lex_state = 15},
  [1802] = {.lex_state = 27, .external_lex_state = 12},
  [1803] = {.lex_state = 194, .external_lex_state = 11},
  [1804] = {.lex_state = 194, .external_lex_state = 11},
  [1805] = {.lex_state = 22, .external_lex_state = 13},
  [1806] = {.lex_state = 27, .external_lex_state = 13},
  [1807] = {.lex_state = 33, .external_lex_state = 12},
  [1808] = {.lex_state = 33, .external_lex_state = 12},
  [1809] = {.lex_state = 22, .external_lex_state = 13},
  [1810] = {.lex_state = 27, .external_lex_state = 11},
  [1811] = {.lex_state = 27, .external_lex_state = 13},
  [1812] = {.lex_state = 27, .external_lex_state = 10},
  [1813] = {.lex_state = 27, .external_lex_state = 12},
  [1814] = {.lex_state = 27, .external_lex_state = 11},
  [1815] = {.lex_state = 68, .external_lex_state = 15},
  [1816] = {.lex_state = 33, .external_lex_state = 11},
  [1817] = {.lex_state = 27, .external_lex_state = 13},
  [1818] = {.lex_state = 22, .external_lex_state = 10},
  [1819] = {.lex_state = 27, .external_lex_state = 13},
  [1820] = {.lex_state = 22, .external_lex_state = 10},
  [1821] = {.lex_state = 68, .external_lex_state = 15},
  [1822] = {.lex_state = 68, .external_lex_state = 15},
  [1823] = {.lex_state = 68, .external_lex_state = 15},
  [1824] = {.lex_state = 22, .external_lex_state = 2},
  [1825] = {.lex_state = 33, .external_lex_state = 12},
  [1826] = {.lex_state = 2, .external_lex_state = 2},
  [1827] = {.lex_state = 22, .external_lex_state = 2},
  [1828] = {.lex_state = 22, .external_lex_state = 2},
  [1829] = {.lex_state = 27, .external_lex_state = 13},
  [1830] = {.lex_state = 194, .external_lex_state = 14},
  [1831] = {.lex_state = 27, .external_lex_state = 13},
  [1832] = {.lex_state = 27, .external_lex_state = 13},
  [1833] = {.lex_state = 22, .external_lex_state = 13},
  [1834] = {.lex_state = 22, .external_lex_state = 10},
  [1835] = {.lex_state = 22, .external_lex_state = 10},
  [1836] = {.lex_state = 22, .external_lex_state = 10},
  [1837] = {.lex_state = 33, .external_lex_state = 13},
  [1838] = {.lex_state = 27, .external_lex_state = 12},
  [1839] = {.lex_state = 33, .external_lex_state = 12},
  [1840] = {.lex_state = 33, .external_lex_state = 11},
  [1841] = {.lex_state = 27, .external_lex_state = 13},
  [1842] = {.lex_state = 33, .external_lex_state = 13},
  [1843] = {.lex_state = 33, .external_lex_state = 12},
  [1844] = {.lex_state = 27, .external_lex_state = 12},
  [1845] = {.lex_state = 27, .external_lex_state = 12},
  [1846] = {.lex_state = 27, .external_lex_state = 13},
  [1847] = {.lex_state = 43, .external_lex_state = 2},
  [1848] = {.lex_state = 22, .external_lex_state = 13},
  [1849] = {.lex_state = 22, .external_lex_state = 2},
  [1850] = {.lex_state = 33, .external_lex_state = 13},
  [1851] = {.lex_state = 22, .external_lex_state = 10},
  [1852] = {.lex_state = 194, .external_lex_state = 11},
  [1853] = {.lex_state = 33, .external_lex_state = 11},
  [1854] = {.lex_state = 194, .external_lex_state = 11},
  [1855] = {.lex_state = 68, .external_lex_state = 15},
  [1856] = {.lex_state = 22, .external_lex_state = 12},
  [1857] = {.lex_state = 22, .external_lex_state = 12},
  [1858] = {.lex_state = 33, .external_lex_state = 11},
  [1859] = {.lex_state = 33, .external_lex_state = 11},
  [1860] = {.lex_state = 69, .external_lex_state = 2},
  [1861] = {.lex_state = 43, .external_lex_state = 2},
  [1862] = {.lex_state = 22, .external_lex_state = 2},
  [1863] = {.lex_state = 33, .external_lex_state = 13},
  [1864] = {.lex_state = 68, .external_lex_state = 15},
  [1865] = {.lex_state = 68, .external_lex_state = 15},
  [1866] = {.lex_state = 7, .external_lex_state = 2},
  [1867] = {.lex_state = 52, .external_lex_state = 10},
  [1868] = {.lex_state = 14, .external_lex_state = 11},
  [1869] = {.lex_state = 33, .external_lex_state = 13},
  [1870] = {.lex_state = 1, .external_lex_state = 2},
  [1871] = {.lex_state = 22, .external_lex_state = 2},
  [1872] = {.lex_state = 7, .external_lex_state = 2},
  [1873] = {.lex_state = 22, .external_lex_state = 2},
  [1874] = {.lex_state = 194, .external_lex_state = 14},
  [1875] = {.lex_state = 22, .external_lex_state = 2},
  [1876] = {.lex_state = 33, .external_lex_state = 13},
  [1877] = {.lex_state = 33, .external_lex_state = 12},
  [1878] = {.lex_state = 33, .external_lex_state = 13},
  [1879] = {.lex_state = 22, .external_lex_state = 2},
  [1880] = {.lex_state = 27, .external_lex_state = 11},
  [1881] = {.lex_state = 22, .external_lex_state = 2},
  [1882] = {.lex_state = 194, .external_lex_state = 11},
  [1883] = {.lex_state = 27, .external_lex_state = 13},
  [1884] = {.lex_state = 33, .external_lex_state = 11},
  [1885] = {.lex_state = 22, .external_lex_state = 2},
  [1886] = {.lex_state = 22, .external_lex_state = 12},
  [1887] = {.lex_state = 22, .external_lex_state = 2},
  [1888] = {.lex_state = 33, .external_lex_state = 12},
  [1889] = {.lex_state = 33, .external_lex_state = 11},
  [1890] = {.lex_state = 33, .external_lex_state = 12},
  [1891] = {.lex_state = 14, .external_lex_state = 11},
  [1892] = {.lex_state = 22, .external_lex_state = 12},
  [1893] = {.lex_state = 22, .external_lex_state = 2},
  [1894] = {.lex_state = 22, .external_lex_state = 12},
  [1895] = {.lex_state = 27, .external_lex_state = 2},
  [1896] = {.lex_state = 27, .external_lex_state = 2},
  [1897] = {.lex_state = 27, .external_lex_state = 11},
  [1898] = {.lex_state = 27, .external_lex_state = 13},
  [1899] = {.lex_state = 33, .external_lex_state = 11},
  [1900] = {.lex_state = 27, .external_lex_state = 2},
  [1901] = {.lex_state = 27, .external_lex_state = 2},
  [1902] = {.lex_state = 7, .external_lex_state = 2},
  [1903] = {.lex_state = 27, .external_lex_state = 2},
  [1904] = {.lex_state = 45, .external_lex_state = 16},
  [1905] = {.lex_state = 22, .external_lex_state = 2},
  [1906] = {.lex_state = 22, .external_lex_state = 12},
  [1907] = {.lex_state = 194, .external_lex_state = 11},
  [1908] = {.lex_state = 22, .external_lex_state = 2},
  [1909] = {.lex_state = 3, .external_lex_state = 2},
  [1910] = {.lex_state = 45, .external_lex_state = 16},
  [1911] = {.lex_state = 39, .external_lex_state = 2},
  [1912] = {.lex_state = 45, .external_lex_state = 16},
  [1913] = {.lex_state = 27, .external_lex_state = 2},
  [1914] = {.lex_state = 27, .external_lex_state = 11},
  [1915] = {.lex_state = 1, .external_lex_state = 2},
  [1916] = {.lex_state = 27, .external_lex_state = 13},
  [1917] = {.lex_state = 194, .external_lex_state = 11},
  [1918] = {.lex_state = 22, .external_lex_state = 2},
  [1919] = {.lex_state = 27, .external_lex_state = 2},
  [1920] = {.lex_state = 27, .external_lex_state = 2},
  [1921] = {.lex_state = 22, .external_lex_state = 2},
  [1922] = {.lex_state = 27, .external_lex_state = 11},
  [1923] = {.lex_state = 27, .external_lex_state = 2},
  [1924] = {.lex_state = 22, .external_lex_state = 2},
  [1925] = {.lex_state = 22, .external_lex_state = 12},
  [1926] = {.lex_state = 22, .external_lex_state = 2},
  [1927] = {.lex_state = 22, .external_lex_state = 2},
  [1928] = {.lex_state = 22, .external_lex_state = 13},
  [1929] = {.lex_state = 45, .external_lex_state = 16},
  [1930] = {.lex_state = 27, .external_lex_state = 10},
  [1931] = {.lex_state = 27, .external_lex_state = 10},
  [1932] = {.lex_state = 27, .external_lex_state = 10},
  [1933] = {.lex_state = 14, .external_lex_state = 11},
  [1934] = {.lex_state = 22, .external_lex_state = 2},
  [1935] = {.lex_state = 194, .external_lex_state = 11},
  [1936] = {.lex_state = 27, .external_lex_state = 2},
  [1937] = {.lex_state = 52, .external_lex_state = 10},
  [1938] = {.lex_state = 22, .external_lex_state = 12},
  [1939] = {.lex_state = 22, .external_lex_state = 12},
  [1940] = {.lex_state = 27, .external_lex_state = 10},
  [1941] = {.lex_state = 22, .external_lex_state = 12},
  [1942] = {.lex_state = 194, .external_lex_state = 11},
  [1943] = {.lex_state = 27, .external_lex_state = 2},
  [1944] = {.lex_state = 27, .external_lex_state = 2},
  [1945] = {.lex_state = 27, .external_lex_state = 2},
  [1946] = {.lex_state = 194, .external_lex_state = 11},
  [1947] = {.lex_state = 194, .external_lex_state = 11},
  [1948] = {.lex_state = 52, .external_lex_state = 10},
  [1949] = {.lex_state = 3, .external_lex_state = 2},
  [1950] = {.lex_state = 22, .external_lex_state = 12},
  [1951] = {.lex_state = 52, .external_lex_state = 2},
  [1952] = {.lex_state = 27, .external_lex_state = 2},
  [1953] = {.lex_state = 45, .external_lex_state = 16},
  [1954] = {.lex_state = 27, .external_lex_state = 2},
  [1955] = {.lex_state = 27, .external_lex_state = 2},
  [1956] = {.lex_state = 39, .external_lex_state = 2},
  [1957] = {.lex_state = 65, .external_lex_state = 2},
  [1958] = {.lex_state = 4, .external_lex_state = 2},
  [1959] = {.lex_state = 194, .external_lex_state = 10},
  [1960] = {.lex_state = 43, .external_lex_state = 2},
  [1961] = {.lex_state = 194, .external_lex_state = 10},
  [1962] = {.lex_state = 194, .external_lex_state = 10},
  [1963] = {.lex_state = 65, .external_lex_state = 2},
  [1964] = {.lex_state = 194, .external_lex_state = 10},
  [1965] = {.lex_state = 194, .external_lex_state = 10},
  [1966] = {.lex_state = 194, .external_lex_state = 10},
  [1967] = {.lex_state = 27, .external_lex_state = 13},
  [1968] = {.lex_state = 194, .external_lex_state = 10},
  [1969] = {.lex_state = 194, .external_lex_state = 10},
  [1970] = {.lex_state = 194, .external_lex_state = 11},
  [1971] = {.lex_state = 194, .external_lex_state = 10},
  [1972] = {.lex_state = 194, .external_lex_state = 10},
  [1973] = {.lex_state = 194, .external_lex_state = 10},
  [1974] = {.lex_state = 5, .external_lex_state = 2},
  [1975] = {.lex_state = 194, .external_lex_state = 10},
  [1976] = {.lex_state = 194, .external_lex_state = 11},
  [1977] = {.lex_state = 22, .external_lex_state = 2},
  [1978] = {.lex_state = 52, .external_lex_state = 13},
  [1979] = {.lex_state = 52, .external_lex_state = 2},
  [1980] = {.lex_state = 27, .external_lex_state = 10},
  [1981] = {.lex_state = 52, .external_lex_state = 2},
  [1982] = {.lex_state = 4, .external_lex_state = 2},
  [1983] = {.lex_state = 194, .external_lex_state = 10},
  [1984] = {.lex_state = 194, .external_lex_state = 10},
  [1985] = {.lex_state = 2, .external_lex_state = 2},
  [1986] = {.lex_state = 1, .external_lex_state = 2},
  [1987] = {.lex_state = 43, .external_lex_state = 2},
  [1988] = {.lex_state = 194, .external_lex_state = 14},
  [1989] = {.lex_state = 194, .external_lex_state = 10},
  [1990] = {.lex_state = 194, .external_lex_state = 10},
  [1991] = {.lex_state = 194, .external_lex_state = 10},
  [1992] = {.lex_state = 194, .external_lex_state = 10},
  [1993] = {.lex_state = 27, .external_lex_state = 13},
  [1994] = {.lex_state = 2, .external_lex_state = 2},
  [1995] = {.lex_state = 52, .external_lex_state = 13},
  [1996] = {.lex_state = 52, .external_lex_state = 2},
  [1997] = {.lex_state = 40, .external_lex_state = 2},
  [1998] = {.lex_state = 52, .external_lex_state = 13},
  [1999] = {.lex_state = 40, .external_lex_state = 2},
  [2000] = {.lex_state = 194, .external_lex_state = 13},
  [2001] = {.lex_state = 2, .external_lex_state = 2},
  [2002] = {.lex_state = 194, .external_lex_state = 14},
  [2003] = {.lex_state = 4, .external_lex_state = 2},
  [2004] = {.lex_state = 194, .external_lex_state = 14},
  [2005] = {.lex_state = 194, .external_lex_state = 12},
  [2006] = {.lex_state = 194, .external_lex_state = 13},
  [2007] = {.lex_state = 194, .external_lex_state = 13},
  [2008] = {.lex_state = 194, .external_lex_state = 2},
  [2009] = {.lex_state = 194, .external_lex_state = 2},
  [2010] = {.lex_state = 194, .external_lex_state = 11},
  [2011] = {.lex_state = 27, .external_lex_state = 2},
  [2012] = {.lex_state = 194, .external_lex_state = 13},
  [2013] = {.lex_state = 194, .external_lex_state = 2},
  [2014] = {.lex_state = 194, .external_lex_state = 12},
  [2015] = {.lex_state = 194, .external_lex_state = 11},
  [2016] = {.lex_state = 27, .external_lex_state = 2},
  [2017] = {.lex_state = 194, .external_lex_state = 10},
  [2018] = {.lex_state = 27, .external_lex_state = 2},
  [2019] = {.lex_state = 194, .external_lex_state = 13},
  [2020] = {.lex_state = 194, .external_lex_state = 13},
  [2021] = {.lex_state = 194, .external_lex_state = 2},
  [2022] = {.lex_state = 27, .external_lex_state = 2},
  [2023] = {.lex_state = 194, .external_lex_state = 13},
  [2024] = {.lex_state = 194, .external_lex_state = 12},
  [2025] = {.lex_state = 194, .external_lex_state = 11},
  [2026] = {.lex_state = 27, .external_lex_state = 2},
  [2027] = {.lex_state = 194, .external_lex_state = 10},
  [2028] = {.lex_state = 27, .external_lex_state = 2},
  [2029] = {.lex_state = 194, .external_lex_state = 10},
  [2030] = {.lex_state = 194, .external_lex_state = 11},
  [2031] = {.lex_state = 194, .external_lex_state = 10},
  [2032] = {.lex_state = 194, .external_lex_state = 10},
  [2033] = {.lex_state = 194, .external_lex_state = 12},
  [2034] = {.lex_state = 194, .external_lex_state = 10},
  [2035] = {.lex_state = 194, .external_lex_state = 10},
  [2036] = {.lex_state = 194, .external_lex_state = 13},
  [2037] = {.lex_state = 27, .external_lex_state = 2},
  [2038] = {.lex_state = 194, .external_lex_state = 13},
  [2039] = {.lex_state = 194, .external_lex_state = 13},
  [2040] = {.lex_state = 194, .external_lex_state = 12},
  [2041] = {.lex_state = 194, .external_lex_state = 13},
  [2042] = {.lex_state = 194, .external_lex_state = 13},
  [2043] = {.lex_state = 194, .external_lex_state = 12},
  [2044] = {.lex_state = 194, .external_lex_state = 11},
  [2045] = {.lex_state = 194, .external_lex_state = 2},
  [2046] = {.lex_state = 194, .external_lex_state = 12},
  [2047] = {.lex_state = 194, .external_lex_state = 2},
  [2048] = {.lex_state = 27, .external_lex_state = 2},
  [2049] = {.lex_state = 194, .external_lex_state = 2},
  [2050] = {.lex_state = 27, .external_lex_state = 2},
  [2051] = {.lex_state = 194, .external_lex_state = 13},
  [2052] = {.lex_state = 194, .external_lex_state = 13},
  [2053] = {.lex_state = 194, .external_lex_state = 10},
  [2054] = {.lex_state = 22, .external_lex_state = 2},
  [2055] = {.lex_state = 194, .external_lex_state = 13},
  [2056] = {.lex_state = 27, .external_lex_state = 2},
  [2057] = {.lex_state = 194, .external_lex_state = 11},
  [2058] = {.lex_state = 22, .external_lex_state = 2},
  [2059] = {.lex_state = 194, .external_lex_state = 13},
  [2060] = {.lex_state = 194, .external_lex_state = 12},
  [2061] = {.lex_state = 194, .external_lex_state = 13},
  [2062] = {.lex_state = 194, .external_lex_state = 12},
  [2063] = {.lex_state = 27, .external_lex_state = 2},
  [2064] = {.lex_state = 194, .external_lex_state = 2},
  [2065] = {.lex_state = 194, .external_lex_state = 13},
  [2066] = {.lex_state = 194, .external_lex_state = 12},
  [2067] = {.lex_state = 27, .external_lex_state = 2},
  [2068] = {.lex_state = 194, .external_lex_state = 11},
  [2069] = {.lex_state = 194, .external_lex_state = 13},
  [2070] = {.lex_state = 194, .external_lex_state = 13},
  [2071] = {.lex_state = 194, .external_lex_state = 10},
  [2072] = {.lex_state = 27, .external_lex_state = 2},
  [2073] = {.lex_state = 194, .external_lex_state = 12},
  [2074] = {.lex_state = 194, .external_lex_state = 12},
  [2075] = {.lex_state = 194, .external_lex_state = 13},
  [2076] = {.lex_state = 194, .external_lex_state = 11},
  [2077] = {.lex_state = 194, .external_lex_state = 12},
  [2078] = {.lex_state = 194, .external_lex_state = 13},
  [2079] = {.lex_state = 194, .external_lex_state = 13},
  [2080] = {.lex_state = 194, .external_lex_state = 12},
  [2081] = {.lex_state = 194, .external_lex_state = 11},
  [2082] = {.lex_state = 194, .external_lex_state = 13},
  [2083] = {.lex_state = 194, .external_lex_state = 11},
  [2084] = {.lex_state = 194, .external_lex_state = 2},
  [2085] = {.lex_state = 194, .external_lex_state = 11},
  [2086] = {.lex_state = 194, .external_lex_state = 13},
  [2087] = {.lex_state = 194, .external_lex_state = 12},
  [2088] = {.lex_state = 194, .external_lex_state = 12},
  [2089] = {.lex_state = 194, .external_lex_state = 10},
  [2090] = {.lex_state = 194, .external_lex_state = 13},
  [2091] = {.lex_state = 194, .external_lex_state = 13},
  [2092] = {.lex_state = 194, .external_lex_state = 13},
  [2093] = {.lex_state = 194, .external_lex_state = 13},
  [2094] = {.lex_state = 194, .external_lex_state = 2},
  [2095] = {.lex_state = 194, .external_lex_state = 13},
  [2096] = {.lex_state = 194, .external_lex_state = 11},
  [2097] = {.lex_state = 194, .external_lex_state = 11},
  [2098] = {.lex_state = 194, .external_lex_state = 12},
  [2099] = {.lex_state = 194, .external_lex_state = 14},
  [2100] = {.lex_state = 194, .external_lex_state = 13},
  [2101] = {.lex_state = 194, .external_lex_state = 11},
  [2102] = {.lex_state = 194, .external_lex_state = 12},
  [2103] = {.lex_state = 194, .external_lex_state = 2},
  [2104] = {.lex_state = 194, .external_lex_state = 2},
  [2105] = {.lex_state = 194, .external_lex_state = 13},
  [2106] = {.lex_state = 194, .external_lex_state = 13},
  [2107] = {.lex_state = 52, .external_lex_state = 2},
  [2108] = {.lex_state = 194, .external_lex_state = 10},
  [2109] = {.lex_state = 194, .external_lex_state = 11},
  [2110] = {.lex_state = 194, .external_lex_state = 2},
  [2111] = {.lex_state = 194, .external_lex_state = 10},
  [2112] = {.lex_state = 194, .external_lex_state = 12},
  [2113] = {.lex_state = 52, .external_lex_state = 2},
  [2114] = {.lex_state = 194, .external_lex_state = 12},
  [2115] = {.lex_state = 194, .external_lex_state = 12},
  [2116] = {.lex_state = 194, .external_lex_state = 12},
  [2117] = {.lex_state = 194, .external_lex_state = 12},
  [2118] = {.lex_state = 194, .external_lex_state = 13},
  [2119] = {.lex_state = 194, .external_lex_state = 12},
  [2120] = {.lex_state = 194, .external_lex_state = 13},
  [2121] = {.lex_state = 194, .external_lex_state = 14},
  [2122] = {.lex_state = 194, .external_lex_state = 10},
  [2123] = {.lex_state = 194, .external_lex_state = 10},
  [2124] = {.lex_state = 27, .external_lex_state = 2},
  [2125] = {.lex_state = 27, .external_lex_state = 2},
  [2126] = {.lex_state = 27, .external_lex_state = 10},
  [2127] = {.lex_state = 194, .external_lex_state = 2},
  [2128] = {.lex_state = 194, .external_lex_state = 10},
  [2129] = {.lex_state = 194, .external_lex_state = 14},
  [2130] = {.lex_state = 194, .external_lex_state = 12},
  [2131] = {.lex_state = 194, .external_lex_state = 2},
  [2132] = {.lex_state = 14, .external_lex_state = 11},
  [2133] = {.lex_state = 194, .external_lex_state = 13},
  [2134] = {.lex_state = 194, .external_lex_state = 12},
  [2135] = {.lex_state = 194, .external_lex_state = 11},
  [2136] = {.lex_state = 194, .external_lex_state = 12},
  [2137] = {.lex_state = 194, .external_lex_state = 13},
  [2138] = {.lex_state = 194, .external_lex_state = 13},
  [2139] = {.lex_state = 194, .external_lex_state = 13},
  [2140] = {.lex_state = 194, .external_lex_state = 13},
  [2141] = {.lex_state = 194, .external_lex_state = 13},
  [2142] = {.lex_state = 194, .external_lex_state = 12},
  [2143] = {.lex_state = 194, .external_lex_state = 2},
  [2144] = {.lex_state = 194, .external_lex_state = 10},
  [2145] = {.lex_state = 194, .external_lex_state = 2},
  [2146] = {.lex_state = 194, .external_lex_state = 12},
  [2147] = {.lex_state = 194, .external_lex_state = 2},
  [2148] = {.lex_state = 194, .external_lex_state = 11},
  [2149] = {.lex_state = 194, .external_lex_state = 13},
  [2150] = {.lex_state = 194, .external_lex_state = 2},
  [2151] = {.lex_state = 194, .external_lex_state = 10},
  [2152] = {.lex_state = 194, .external_lex_state = 12},
  [2153] = {.lex_state = 27, .external_lex_state = 10},
  [2154] = {.lex_state = 194, .external_lex_state = 13},
  [2155] = {.lex_state = 194, .external_lex_state = 13},
  [2156] = {.lex_state = 194, .external_lex_state = 12},
  [2157] = {.lex_state = 194, .external_lex_state = 13},
  [2158] = {.lex_state = 194, .external_lex_state = 10},
  [2159] = {.lex_state = 27, .external_lex_state = 10},
  [2160] = {.lex_state = 194, .external_lex_state = 2},
  [2161] = {.lex_state = 194, .external_lex_state = 13},
  [2162] = {.lex_state = 27, .external_lex_state = 13},
  [2163] = {.lex_state = 194, .external_lex_state = 2},
  [2164] = {.lex_state = 194, .external_lex_state = 13},
  [2165] = {.lex_state = 194, .external_lex_state = 13},
  [2166] = {.lex_state = 194, .external_lex_state = 11},
  [2167] = {.lex_state = 194, .external_lex_state = 12},
  [2168] = {.lex_state = 14, .external_lex_state = 11},
  [2169] = {.lex_state = 194, .external_lex_state = 13},
  [2170] = {.lex_state = 194, .external_lex_state = 12},
  [2171] = {.lex_state = 194, .external_lex_state = 10},
  [2172] = {.lex_state = 27, .external_lex_state = 2},
  [2173] = {.lex_state = 194, .external_lex_state = 2},
  [2174] = {.lex_state = 194, .external_lex_state = 11},
  [2175] = {.lex_state = 194, .external_lex_state = 11},
  [2176] = {.lex_state = 14, .external_lex_state = 11},
  [2177] = {.lex_state = 194, .external_lex_state = 11},
  [2178] = {.lex_state = 194, .external_lex_state = 13},
  [2179] = {.lex_state = 194, .external_lex_state = 13},
  [2180] = {.lex_state = 194, .external_lex_state = 13},
  [2181] = {.lex_state = 194, .external_lex_state = 13},
  [2182] = {.lex_state = 194, .external_lex_state = 12},
  [2183] = {.lex_state = 27, .external_lex_state = 10},
  [2184] = {.lex_state = 14, .external_lex_state = 11},
  [2185] = {.lex_state = 194, .external_lex_state = 13},
  [2186] = {.lex_state = 194, .external_lex_state = 13},
  [2187] = {.lex_state = 194, .external_lex_state = 13},
  [2188] = {.lex_state = 194, .external_lex_state = 10},
  [2189] = {.lex_state = 14, .external_lex_state = 11},
  [2190] = {.lex_state = 194, .external_lex_state = 12},
  [2191] = {.lex_state = 194, .external_lex_state = 12},
  [2192] = {.lex_state = 27, .external_lex_state = 2},
  [2193] = {.lex_state = 194, .external_lex_state = 13},
  [2194] = {.lex_state = 194, .external_lex_state = 12},
  [2195] = {.lex_state = 194, .external_lex_state = 12},
  [2196] = {.lex_state = 65, .external_lex_state = 2},
  [2197] = {.lex_state = 194, .external_lex_state = 13},
  [2198] = {.lex_state = 194, .external_lex_state = 13},
  [2199] = {.lex_state = 194, .external_lex_state = 13},
  [2200] = {.lex_state = 194, .external_lex_state = 13},
  [2201] = {.lex_state = 194, .external_lex_state = 13},
  [2202] = {.lex_state = 194, .external_lex_state = 10},
  [2203] = {.lex_state = 194, .external_lex_state = 13},
  [2204] = {.lex_state = 194, .external_lex_state = 11},
  [2205] = {.lex_state = 194, .external_lex_state = 2},
  [2206] = {.lex_state = 194, .external_lex_state = 10},
  [2207] = {.lex_state = 194, .external_lex_state = 13},
  [2208] = {.lex_state = 194, .external_lex_state = 13},
  [2209] = {.lex_state = 194, .external_lex_state = 13},
  [2210] = {.lex_state = 194, .external_lex_state = 11},
  [2211] = {.lex_state = 194, .external_lex_state = 13},
  [2212] = {.lex_state = 194, .external_lex_state = 12},
  [2213] = {.lex_state = 14, .external_lex_state = 11},
  [2214] = {.lex_state = 194, .external_lex_state = 12},
  [2215] = {.lex_state = 194, .external_lex_state = 13},
  [2216] = {.lex_state = 194, .external_lex_state = 12},
  [2217] = {.lex_state = 27, .external_lex_state = 2},
  [2218] = {.lex_state = 194, .external_lex_state = 12},
  [2219] = {.lex_state = 14, .external_lex_state = 11},
  [2220] = {.lex_state = 194, .external_lex_state = 2},
  [2221] = {.lex_state = 194, .external_lex_state = 13},
  [2222] = {.lex_state = 194, .external_lex_state = 11},
  [2223] = {.lex_state = 14, .external_lex_state = 11},
  [2224] = {.lex_state = 194, .external_lex_state = 13},
  [2225] = {.lex_state = 194, .external_lex_state = 12},
  [2226] = {.lex_state = 14, .external_lex_state = 11},
  [2227] = {.lex_state = 194, .external_lex_state = 12},
  [2228] = {.lex_state = 1, .external_lex_state = 2},
  [2229] = {.lex_state = 194, .external_lex_state = 2},
  [2230] = {.lex_state = 1, .external_lex_state = 2},
  [2231] = {.lex_state = 194, .external_lex_state = 12},
  [2232] = {.lex_state = 1, .external_lex_state = 2},
  [2233] = {.lex_state = 39, .external_lex_state = 11},
  [2234] = {.lex_state = 1, .external_lex_state = 2},
  [2235] = {.lex_state = 194, .external_lex_state = 13},
  [2236] = {.lex_state = 1, .external_lex_state = 2},
  [2237] = {.lex_state = 194, .external_lex_state = 13},
  [2238] = {.lex_state = 194, .external_lex_state = 2},
  [2239] = {.lex_state = 194, .external_lex_state = 10},
  [2240] = {.lex_state = 1, .external_lex_state = 2},
  [2241] = {.lex_state = 194, .external_lex_state = 2},
  [2242] = {.lex_state = 1, .external_lex_state = 2},
  [2243] = {.lex_state = 1, .external_lex_state = 2},
  [2244] = {.lex_state = 194, .external_lex_state = 13},
  [2245] = {.lex_state = 194, .external_lex_state = 13},
  [2246] = {.lex_state = 194, .external_lex_state = 2},
  [2247] = {.lex_state = 1, .external_lex_state = 2},
  [2248] = {.lex_state = 27, .external_lex_state = 2},
  [2249] = {.lex_state = 194, .external_lex_state = 10},
  [2250] = {.lex_state = 194, .external_lex_state = 13},
  [2251] = {.lex_state = 194, .external_lex_state = 13},
  [2252] = {.lex_state = 194, .external_lex_state = 13},
  [2253] = {.lex_state = 194, .external_lex_state = 10},
  [2254] = {.lex_state = 1, .external_lex_state = 2},
  [2255] = {.lex_state = 52, .external_lex_state = 2},
  [2256] = {.lex_state = 194, .external_lex_state = 2},
  [2257] = {.lex_state = 194, .external_lex_state = 2},
  [2258] = {.lex_state = 39, .external_lex_state = 11},
  [2259] = {.lex_state = 194, .external_lex_state = 13},
  [2260] = {.lex_state = 1, .external_lex_state = 2},
  [2261] = {.lex_state = 194, .external_lex_state = 13},
  [2262] = {.lex_state = 39, .external_lex_state = 11},
  [2263] = {.lex_state = 1, .external_lex_state = 2},
  [2264] = {.lex_state = 194, .external_lex_state = 13},
  [2265] = {.lex_state = 194, .external_lex_state = 13},
  [2266] = {.lex_state = 194, .external_lex_state = 11},
  [2267] = {.lex_state = 194, .external_lex_state = 13},
  [2268] = {.lex_state = 1, .external_lex_state = 2},
  [2269] = {.lex_state = 194, .external_lex_state = 2},
  [2270] = {.lex_state = 194, .external_lex_state = 10},
  [2271] = {.lex_state = 1, .external_lex_state = 2},
  [2272] = {.lex_state = 194, .external_lex_state = 10},
  [2273] = {.lex_state = 194, .external_lex_state = 13},
  [2274] = {.lex_state = 194, .external_lex_state = 12},
  [2275] = {.lex_state = 194, .external_lex_state = 12},
  [2276] = {.lex_state = 194, .external_lex_state = 12},
  [2277] = {.lex_state = 194, .external_lex_state = 12},
  [2278] = {.lex_state = 39, .external_lex_state = 11},
  [2279] = {.lex_state = 194, .external_lex_state = 2},
  [2280] = {.lex_state = 194, .external_lex_state = 2},
  [2281] = {.lex_state = 39, .external_lex_state = 2},
  [2282] = {.lex_state = 194, .external_lex_state = 2},
  [2283] = {.lex_state = 194, .external_lex_state = 2},
  [2284] = {.lex_state = 194, .external_lex_state = 12},
  [2285] = {.lex_state = 66, .external_lex_state = 2},
  [2286] = {.lex_state = 39, .external_lex_state = 2},
  [2287] = {.lex_state = 194, .external_lex_state = 11},
  [2288] = {.lex_state = 194, .external_lex_state = 11},
  [2289] = {.lex_state = 194, .external_lex_state = 11},
  [2290] = {.lex_state = 194, .external_lex_state = 13},
  [2291] = {.lex_state = 194, .external_lex_state = 13},
  [2292] = {.lex_state = 194, .external_lex_state = 10},
  [2293] = {.lex_state = 39, .external_lex_state = 11},
  [2294] = {.lex_state = 0, .external_lex_state = 14},
  [2295] = {.lex_state = 1, .external_lex_state = 2},
  [2296] = {.lex_state = 0, .external_lex_state = 14},
  [2297] = {.lex_state = 1, .external_lex_state = 2},
  [2298] = {.lex_state = 1, .external_lex_state = 2},
  [2299] = {.lex_state = 1, .external_lex_state = 2},
  [2300] = {.lex_state = 71, .external_lex_state = 2},
  [2301] = {.lex_state = 1, .external_lex_state = 2},
  [2302] = {.lex_state = 52, .external_lex_state = 2},
  [2303] = {.lex_state = 1, .external_lex_state = 2},
  [2304] = {.lex_state = 194, .external_lex_state = 12},
  [2305] = {.lex_state = 1, .external_lex_state = 2},
  [2306] = {.lex_state = 1, .external_lex_state = 2},
  [2307] = {.lex_state = 1, .external_lex_state = 2},
  [2308] = {.lex_state = 1, .external_lex_state = 2},
  [2309] = {.lex_state = 52, .external_lex_state = 2},
  [2310] = {.lex_state = 194, .external_lex_state = 12},
  [2311] = {.lex_state = 39, .external_lex_state = 11},
  [2312] = {.lex_state = 194, .external_lex_state = 10},
  [2313] = {.lex_state = 1, .external_lex_state = 2},
  [2314] = {.lex_state = 1, .external_lex_state = 2},
  [2315] = {.lex_state = 1, .external_lex_state = 2},
  [2316] = {.lex_state = 1, .external_lex_state = 2},
  [2317] = {.lex_state = 39, .external_lex_state = 2},
  [2318] = {.lex_state = 194, .external_lex_state = 10},
  [2319] = {.lex_state = 194, .external_lex_state = 12},
  [2320] = {.lex_state = 194, .external_lex_state = 10},
  [2321] = {.lex_state = 194, .external_lex_state = 2},
  [2322] = {.lex_state = 194, .external_lex_state = 10},
  [2323] = {.lex_state = 194, .external_lex_state = 10},
  [2324] = {.lex_state = 52, .external_lex_state = 2},
  [2325] = {.lex_state = 71, .external_lex_state = 2},
  [2326] = {.lex_state = 194, .external_lex_state = 10},
  [2327] = {.lex_state = 194, .external_lex_state = 10},
  [2328] = {.lex_state = 194, .external_lex_state = 10},
  [2329] = {.lex_state = 194, .external_lex_state = 10},
  [2330] = {.lex_state = 194, .external_lex_state = 10},
  [2331] = {.lex_state = 194, .external_lex_state = 10},
  [2332] = {.lex_state = 39, .external_lex_state = 11},
  [2333] = {.lex_state = 194, .external_lex_state = 10},
  [2334] = {.lex_state = 1, .external_lex_state = 2},
  [2335] = {.lex_state = 39, .external_lex_state = 2},
  [2336] = {.lex_state = 1, .external_lex_state = 2},
  [2337] = {.lex_state = 39, .external_lex_state = 2},
  [2338] = {.lex_state = 39, .external_lex_state = 2},
  [2339] = {.lex_state = 1, .external_lex_state = 2},
  [2340] = {.lex_state = 71, .external_lex_state = 2},
  [2341] = {.lex_state = 1, .external_lex_state = 2},
  [2342] = {.lex_state = 1, .external_lex_state = 2},
  [2343] = {.lex_state = 1, .external_lex_state = 2},
  [2344] = {.lex_state = 0, .external_lex_state = 11},
  [2345] = {.lex_state = 194, .external_lex_state = 12},
  [2346] = {.lex_state = 52, .external_lex_state = 2},
  [2347] = {.lex_state = 194, .external_lex_state = 13},
  [2348] = {.lex_state = 0, .external_lex_state = 11},
  [2349] = {.lex_state = 0, .external_lex_state = 11},
  [2350] = {.lex_state = 0, .external_lex_state = 11},
  [2351] = {.lex_state = 0, .external_lex_state = 11},
  [2352] = {.lex_state = 0, .external_lex_state = 2},
  [2353] = {.lex_state = 194, .external_lex_state = 2},
  [2354] = {.lex_state = 52, .external_lex_state = 2},
  [2355] = {.lex_state = 52, .external_lex_state = 2},
  [2356] = {.lex_state = 27, .external_lex_state = 2},
  [2357] = {.lex_state = 194, .external_lex_state = 13},
  [2358] = {.lex_state = 39, .external_lex_state = 2},
  [2359] = {.lex_state = 194, .external_lex_state = 12},
  [2360] = {.lex_state = 194, .external_lex_state = 13},
  [2361] = {.lex_state = 41, .external_lex_state = 2},
  [2362] = {.lex_state = 0, .external_lex_state = 2},
  [2363] = {.lex_state = 0, .external_lex_state = 11},
  [2364] = {.lex_state = 0, .external_lex_state = 11},
  [2365] = {.lex_state = 194, .external_lex_state = 12},
  [2366] = {.lex_state = 52, .external_lex_state = 2},
  [2367] = {.lex_state = 194, .external_lex_state = 13},
  [2368] = {.lex_state = 194, .external_lex_state = 13},
  [2369] = {.lex_state = 0, .external_lex_state = 11},
  [2370] = {.lex_state = 0, .external_lex_state = 11},
  [2371] = {.lex_state = 194, .external_lex_state = 13},
  [2372] = {.lex_state = 194, .external_lex_state = 12},
  [2373] = {.lex_state = 194, .external_lex_state = 13},
  [2374] = {.lex_state = 39, .external_lex_state = 2},
  [2375] = {.lex_state = 27, .external_lex_state = 2},
  [2376] = {.lex_state = 52, .external_lex_state = 2},
  [2377] = {.lex_state = 194, .external_lex_state = 2},
  [2378] = {.lex_state = 0, .external_lex_state = 11},
  [2379] = {.lex_state = 0, .external_lex_state = 11},
  [2380] = {.lex_state = 194, .external_lex_state = 13},
  [2381] = {.lex_state = 194, .external_lex_state = 12},
  [2382] = {.lex_state = 194, .external_lex_state = 12},
  [2383] = {.lex_state = 41, .external_lex_state = 2},
  [2384] = {.lex_state = 0, .external_lex_state = 11},
  [2385] = {.lex_state = 0, .external_lex_state = 11},
  [2386] = {.lex_state = 27, .external_lex_state = 2},
  [2387] = {.lex_state = 0, .external_lex_state = 11},
  [2388] = {.lex_state = 194, .external_lex_state = 13},
  [2389] = {.lex_state = 194, .external_lex_state = 13},
  [2390] = {.lex_state = 194, .external_lex_state = 13},
  [2391] = {.lex_state = 0, .external_lex_state = 11},
  [2392] = {.lex_state = 0, .external_lex_state = 11},
  [2393] = {.lex_state = 0, .external_lex_state = 11},
  [2394] = {.lex_state = 0, .external_lex_state = 11},
  [2395] = {.lex_state = 194, .external_lex_state = 13},
  [2396] = {.lex_state = 41, .external_lex_state = 2},
  [2397] = {.lex_state = 194, .external_lex_state = 13},
  [2398] = {.lex_state = 194, .external_lex_state = 12},
  [2399] = {.lex_state = 194, .external_lex_state = 12},
  [2400] = {.lex_state = 194, .external_lex_state = 13},
  [2401] = {.lex_state = 194, .external_lex_state = 12},
  [2402] = {.lex_state = 0, .external_lex_state = 11},
  [2403] = {.lex_state = 0, .external_lex_state = 11},
  [2404] = {.lex_state = 27, .external_lex_state = 2},
  [2405] = {.lex_state = 52, .external_lex_state = 2},
  [2406] = {.lex_state = 194, .external_lex_state = 2},
  [2407] = {.lex_state = 27, .external_lex_state = 2},
  [2408] = {.lex_state = 52, .external_lex_state = 2},
  [2409] = {.lex_state = 27, .external_lex_state = 2},
  [2410] = {.lex_state = 194, .external_lex_state = 2},
  [2411] = {.lex_state = 0, .external_lex_state = 11},
  [2412] = {.lex_state = 194, .external_lex_state = 12},
  [2413] = {.lex_state = 194, .external_lex_state = 13},
  [2414] = {.lex_state = 0, .external_lex_state = 11},
  [2415] = {.lex_state = 194, .external_lex_state = 13},
  [2416] = {.lex_state = 0, .external_lex_state = 11},
  [2417] = {.lex_state = 0, .external_lex_state = 11},
  [2418] = {.lex_state = 194, .external_lex_state = 12},
  [2419] = {.lex_state = 41, .external_lex_state = 2},
  [2420] = {.lex_state = 0, .external_lex_state = 11},
  [2421] = {.lex_state = 194, .external_lex_state = 13},
  [2422] = {.lex_state = 0, .external_lex_state = 11},
  [2423] = {.lex_state = 0, .external_lex_state = 2},
  [2424] = {.lex_state = 0, .external_lex_state = 11},
  [2425] = {.lex_state = 194, .external_lex_state = 2},
  [2426] = {.lex_state = 0, .external_lex_state = 11},
  [2427] = {.lex_state = 52, .external_lex_state = 2},
  [2428] = {.lex_state = 27, .external_lex_state = 2},
  [2429] = {.lex_state = 194, .external_lex_state = 12},
  [2430] = {.lex_state = 52, .external_lex_state = 2},
  [2431] = {.lex_state = 194, .external_lex_state = 13},
  [2432] = {.lex_state = 194, .external_lex_state = 13},
  [2433] = {.lex_state = 0, .external_lex_state = 11},
  [2434] = {.lex_state = 0, .external_lex_state = 11},
  [2435] = {.lex_state = 194, .external_lex_state = 13},
  [2436] = {.lex_state = 194, .external_lex_state = 12},
  [2437] = {.lex_state = 27, .external_lex_state = 2},
  [2438] = {.lex_state = 52, .external_lex_state = 2},
  [2439] = {.lex_state = 194, .external_lex_state = 2},
  [2440] = {.lex_state = 194, .external_lex_state = 13},
  [2441] = {.lex_state = 0, .external_lex_state = 11},
  [2442] = {.lex_state = 194, .external_lex_state = 13},
  [2443] = {.lex_state = 0, .external_lex_state = 2},
  [2444] = {.lex_state = 194, .external_lex_state = 2},
  [2445] = {.lex_state = 194, .external_lex_state = 13},
  [2446] = {.lex_state = 41, .external_lex_state = 2},
  [2447] = {.lex_state = 0, .external_lex_state = 2},
  [2448] = {.lex_state = 194, .external_lex_state = 2},
  [2449] = {.lex_state = 52, .external_lex_state = 2},
  [2450] = {.lex_state = 27, .external_lex_state = 2},
  [2451] = {.lex_state = 27, .external_lex_state = 2},
  [2452] = {.lex_state = 194, .external_lex_state = 13},
  [2453] = {.lex_state = 194, .external_lex_state = 12},
  [2454] = {.lex_state = 41, .external_lex_state = 2},
  [2455] = {.lex_state = 0, .external_lex_state = 11},
  [2456] = {.lex_state = 0, .external_lex_state = 11},
  [2457] = {.lex_state = 52, .external_lex_state = 2},
  [2458] = {.lex_state = 194, .external_lex_state = 2},
  [2459] = {.lex_state = 0, .external_lex_state = 11},
  [2460] = {.lex_state = 27, .external_lex_state = 2},
  [2461] = {.lex_state = 52, .external_lex_state = 2},
  [2462] = {.lex_state = 52, .external_lex_state = 2},
  [2463] = {.lex_state = 0, .external_lex_state = 11},
  [2464] = {.lex_state = 27, .external_lex_state = 2},
  [2465] = {.lex_state = 52, .external_lex_state = 2},
  [2466] = {.lex_state = 194, .external_lex_state = 12},
  [2467] = {.lex_state = 52, .external_lex_state = 2},
  [2468] = {.lex_state = 194, .external_lex_state = 2},
  [2469] = {.lex_state = 41, .external_lex_state = 2},
  [2470] = {.lex_state = 194, .external_lex_state = 2},
  [2471] = {.lex_state = 52, .external_lex_state = 2},
  [2472] = {.lex_state = 27, .external_lex_state = 2},
  [2473] = {.lex_state = 194, .external_lex_state = 2},
  [2474] = {.lex_state = 194, .external_lex_state = 13},
  [2475] = {.lex_state = 194, .external_lex_state = 13},
  [2476] = {.lex_state = 0, .external_lex_state = 11},
  [2477] = {.lex_state = 194, .external_lex_state = 13},
  [2478] = {.lex_state = 194, .external_lex_state = 12},
  [2479] = {.lex_state = 27, .external_lex_state = 2},
  [2480] = {.lex_state = 39, .external_lex_state = 2},
  [2481] = {.lex_state = 52, .external_lex_state = 2},
  [2482] = {.lex_state = 194, .external_lex_state = 2},
  [2483] = {.lex_state = 0, .external_lex_state = 11},
  [2484] = {.lex_state = 0, .external_lex_state = 11},
  [2485] = {.lex_state = 0, .external_lex_state = 11},
  [2486] = {.lex_state = 194, .external_lex_state = 13},
  [2487] = {.lex_state = 0, .external_lex_state = 11},
  [2488] = {.lex_state = 194, .external_lex_state = 12},
  [2489] = {.lex_state = 194, .external_lex_state = 13},
  [2490] = {.lex_state = 194, .external_lex_state = 12},
  [2491] = {.lex_state = 0, .external_lex_state = 11},
  [2492] = {.lex_state = 0, .external_lex_state = 2},
  [2493] = {.lex_state = 0, .external_lex_state = 11},
  [2494] = {.lex_state = 194, .external_lex_state = 12},
  [2495] = {.lex_state = 194, .external_lex_state = 12},
  [2496] = {.lex_state = 0, .external_lex_state = 2},
  [2497] = {.lex_state = 41, .external_lex_state = 2},
  [2498] = {.lex_state = 27, .external_lex_state = 2},
  [2499] = {.lex_state = 27, .external_lex_state = 2},
  [2500] = {.lex_state = 194, .external_lex_state = 2},
  [2501] = {.lex_state = 0, .external_lex_state = 2},
  [2502] = {.lex_state = 194, .external_lex_state = 2},
  [2503] = {.lex_state = 0, .external_lex_state = 2},
  [2504] = {.lex_state = 0, .external_lex_state = 2},
  [2505] = {.lex_state = 0, .external_lex_state = 11},
  [2506] = {.lex_state = 27, .external_lex_state = 2},
  [2507] = {.lex_state = 0, .external_lex_state = 11},
  [2508] = {.lex_state = 194, .external_lex_state = 13},
  [2509] = {.lex_state = 27, .external_lex_state = 2},
  [2510] = {.lex_state = 52, .external_lex_state = 2},
  [2511] = {.lex_state = 52, .external_lex_state = 2},
  [2512] = {.lex_state = 194, .external_lex_state = 2},
  [2513] = {.lex_state = 194, .external_lex_state = 2},
  [2514] = {.lex_state = 27, .external_lex_state = 2},
  [2515] = {.lex_state = 52, .external_lex_state = 2},
  [2516] = {.lex_state = 194, .external_lex_state = 13},
  [2517] = {.lex_state = 0, .external_lex_state = 11},
  [2518] = {.lex_state = 0, .external_lex_state = 11},
  [2519] = {.lex_state = 0, .external_lex_state = 11},
  [2520] = {.lex_state = 39, .external_lex_state = 2},
  [2521] = {.lex_state = 52, .external_lex_state = 2},
  [2522] = {.lex_state = 52, .external_lex_state = 2},
  [2523] = {.lex_state = 0, .external_lex_state = 11},
  [2524] = {.lex_state = 0, .external_lex_state = 11},
  [2525] = {.lex_state = 41, .external_lex_state = 2},
  [2526] = {.lex_state = 194, .external_lex_state = 2},
  [2527] = {.lex_state = 0, .external_lex_state = 11},
  [2528] = {.lex_state = 27, .external_lex_state = 2},
  [2529] = {.lex_state = 0, .external_lex_state = 11},
  [2530] = {.lex_state = 52, .external_lex_state = 2},
  [2531] = {.lex_state = 27, .external_lex_state = 2},
  [2532] = {.lex_state = 194, .external_lex_state = 2},
  [2533] = {.lex_state = 0, .external_lex_state = 11},
  [2534] = {.lex_state = 194, .external_lex_state = 2},
  [2535] = {.lex_state = 194, .external_lex_state = 13},
  [2536] = {.lex_state = 194, .external_lex_state = 12},
  [2537] = {.lex_state = 52, .external_lex_state = 2},
  [2538] = {.lex_state = 194, .external_lex_state = 13},
  [2539] = {.lex_state = 194, .external_lex_state = 13},
  [2540] = {.lex_state = 0, .external_lex_state = 11},
  [2541] = {.lex_state = 0, .external_lex_state = 11},
  [2542] = {.lex_state = 0, .external_lex_state = 11},
  [2543] = {.lex_state = 194, .external_lex_state = 13},
  [2544] = {.lex_state = 194, .external_lex_state = 13},
  [2545] = {.lex_state = 194, .external_lex_state = 12},
  [2546] = {.lex_state = 27, .external_lex_state = 2},
  [2547] = {.lex_state = 52, .external_lex_state = 2},
  [2548] = {.lex_state = 194, .external_lex_state = 2},
  [2549] = {.lex_state = 194, .external_lex_state = 2},
  [2550] = {.lex_state = 194, .external_lex_state = 2},
  [2551] = {.lex_state = 0, .external_lex_state = 11},
  [2552] = {.lex_state = 0, .external_lex_state = 11},
  [2553] = {.lex_state = 0, .external_lex_state = 11},
  [2554] = {.lex_state = 194, .external_lex_state = 13},
  [2555] = {.lex_state = 194, .external_lex_state = 12},
  [2556] = {.lex_state = 194, .external_lex_state = 12},
  [2557] = {.lex_state = 41, .external_lex_state = 2},
  [2558] = {.lex_state = 0, .external_lex_state = 2},
  [2559] = {.lex_state = 194, .external_lex_state = 2},
  [2560] = {.lex_state = 52, .external_lex_state = 2},
  [2561] = {.lex_state = 0, .external_lex_state = 11},
  [2562] = {.lex_state = 0, .external_lex_state = 11},
  [2563] = {.lex_state = 194, .external_lex_state = 2},
  [2564] = {.lex_state = 39, .external_lex_state = 2},
  [2565] = {.lex_state = 39, .external_lex_state = 2},
  [2566] = {.lex_state = 39, .external_lex_state = 2},
  [2567] = {.lex_state = 194, .external_lex_state = 2},
  [2568] = {.lex_state = 194, .external_lex_state = 13},
  [2569] = {.lex_state = 194, .external_lex_state = 13},
  [2570] = {.lex_state = 194, .external_lex_state = 13},
  [2571] = {.lex_state = 194, .external_lex_state = 13},
  [2572] = {.lex_state = 194, .external_lex_state = 2},
  [2573] = {.lex_state = 194, .external_lex_state = 13},
  [2574] = {.lex_state = 194, .external_lex_state = 2},
  [2575] = {.lex_state = 194, .external_lex_state = 2},
  [2576] = {.lex_state = 194, .external_lex_state = 2},
  [2577] = {.lex_state = 52, .external_lex_state = 2},
  [2578] = {.lex_state = 194, .external_lex_state = 2},
  [2579] = {.lex_state = 194, .external_lex_state = 2},
  [2580] = {.lex_state = 27, .external_lex_state = 2},
  [2581] = {.lex_state = 27, .external_lex_state = 2},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_QMARK_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_EQ_PLUS] = ACTIONS(1),
    [anon_sym_DOT_EQ] = ACTIONS(1),
    [anon_sym_EQ_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_noexec] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_append] = ACTIONS(1),
    [anon_sym_prepend] = ACTIONS(1),
    [anon_sym_remove] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [anon_sym_INHERIT] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym_include_directive_token1] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_OVERRIDES] = ACTIONS(1),
    [anon_sym_EXPORT_FUNCTIONS] = ACTIONS(1),
    [anon_sym_addtask] = ACTIONS(1),
    [anon_sym_after] = ACTIONS(1),
    [anon_sym_before] = ACTIONS(1),
    [anon_sym_addhandler] = ACTIONS(1),
    [anon_sym_fakeroot] = ACTIONS(1),
    [anon_sym_python] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [aux_sym_string_token2] = ACTIONS(1),
    [anon_sym_DOLLARBB_ENV_PASSTHROUGH] = ACTIONS(1),
    [anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [aux_sym_string_token4] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE_AT] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_except_STAR] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [sym__not_escape_sequence] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_line_continuation] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym_string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym_escape_interpolation] = ACTIONS(1),
    [sym_string_end] = ACTIONS(1),
    [sym_shell_content] = ACTIONS(1),
  },
  [1] = {
    [sym_recipe] = STATE(2558),
    [sym_variable_assignment] = STATE(2305),
    [sym_unset_statement] = STATE(2305),
    [sym_inherit_directive] = STATE(2305),
    [sym_include_directive] = STATE(2305),
    [sym_require_directive] = STATE(2305),
    [sym_export_statement] = STATE(2305),
    [sym_overrides_statement] = STATE(2305),
    [sym_export_functions_statement] = STATE(2305),
    [sym_addtask_statement] = STATE(2305),
    [sym_deltask_statement] = STATE(2305),
    [sym_addhandler_statement] = STATE(2305),
    [sym_anonymous_python_function] = STATE(2305),
    [sym_function_definition] = STATE(2305),
    [sym_variable_expansion] = STATE(2296),
    [sym_python_function_definition] = STATE(2305),
    [sym_concatenation] = STATE(1521),
    [aux_sym_recipe_repeat1] = STATE(1210),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_unset] = ACTIONS(7),
    [anon_sym_inherit] = ACTIONS(9),
    [anon_sym_include] = ACTIONS(11),
    [anon_sym_require] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_OVERRIDES] = ACTIONS(17),
    [anon_sym_EXPORT_FUNCTIONS] = ACTIONS(19),
    [anon_sym_addtask] = ACTIONS(21),
    [anon_sym_deltask] = ACTIONS(23),
    [anon_sym_addhandler] = ACTIONS(25),
    [anon_sym_fakeroot] = ACTIONS(27),
    [anon_sym_python] = ACTIONS(29),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(35),
    [aux_sym__dotted_identifier_token1] = ACTIONS(37),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_python_function_definition] = STATE(26),
    [sym__statement] = STATE(26),
    [sym__simple_statements] = STATE(26),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(599),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(26),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(113),
  },
  [3] = {
    [sym_python_function_definition] = STATE(35),
    [sym__statement] = STATE(35),
    [sym__simple_statements] = STATE(35),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_with_statement] = STATE(35),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(596),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(113),
  },
  [4] = {
    [sym_python_function_definition] = STATE(32),
    [sym__statement] = STATE(32),
    [sym__simple_statements] = STATE(32),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(2491),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(32),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [5] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(657),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(119),
    [sym_string_start] = ACTIONS(113),
  },
  [6] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(662),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(119),
    [sym_string_start] = ACTIONS(113),
  },
  [7] = {
    [sym_python_function_definition] = STATE(32),
    [sym__statement] = STATE(32),
    [sym__simple_statements] = STATE(32),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(2426),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(32),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [8] = {
    [sym_python_function_definition] = STATE(30),
    [sym__statement] = STATE(30),
    [sym__simple_statements] = STATE(30),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(2306),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(30),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(121),
    [sym_string_start] = ACTIONS(113),
  },
  [9] = {
    [sym_python_function_definition] = STATE(27),
    [sym__statement] = STATE(27),
    [sym__simple_statements] = STATE(27),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(632),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(27),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(123),
    [sym_string_start] = ACTIONS(113),
  },
  [10] = {
    [sym_python_function_definition] = STATE(29),
    [sym__statement] = STATE(29),
    [sym__simple_statements] = STATE(29),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(584),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(29),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(125),
    [sym_string_start] = ACTIONS(113),
  },
  [11] = {
    [sym_python_function_definition] = STATE(26),
    [sym__statement] = STATE(26),
    [sym__simple_statements] = STATE(26),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(598),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(26),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(113),
  },
  [12] = {
    [sym_python_function_definition] = STATE(26),
    [sym__statement] = STATE(26),
    [sym__simple_statements] = STATE(26),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(621),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(26),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(113),
  },
  [13] = {
    [sym_python_function_definition] = STATE(32),
    [sym__statement] = STATE(32),
    [sym__simple_statements] = STATE(32),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(2562),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(32),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [14] = {
    [sym_python_function_definition] = STATE(35),
    [sym__statement] = STATE(35),
    [sym__simple_statements] = STATE(35),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_with_statement] = STATE(35),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(588),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(113),
  },
  [15] = {
    [sym_python_function_definition] = STATE(35),
    [sym__statement] = STATE(35),
    [sym__simple_statements] = STATE(35),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_with_statement] = STATE(35),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(575),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(113),
  },
  [16] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(647),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(119),
    [sym_string_start] = ACTIONS(113),
  },
  [17] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(648),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(119),
    [sym_string_start] = ACTIONS(113),
  },
  [18] = {
    [sym_python_function_definition] = STATE(30),
    [sym__statement] = STATE(30),
    [sym__simple_statements] = STATE(30),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(2260),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(30),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(121),
    [sym_string_start] = ACTIONS(113),
  },
  [19] = {
    [sym_python_function_definition] = STATE(31),
    [sym__statement] = STATE(31),
    [sym__simple_statements] = STATE(31),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(31),
    [sym_for_statement] = STATE(31),
    [sym_while_statement] = STATE(31),
    [sym_try_statement] = STATE(31),
    [sym_with_statement] = STATE(31),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(572),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(31),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(127),
    [sym_string_start] = ACTIONS(113),
  },
  [20] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(663),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(119),
    [sym_string_start] = ACTIONS(113),
  },
  [21] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(1674),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(129),
    [sym_string_start] = ACTIONS(113),
  },
  [22] = {
    [sym_python_function_definition] = STATE(29),
    [sym__statement] = STATE(29),
    [sym__simple_statements] = STATE(29),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(595),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(29),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(125),
    [sym_string_start] = ACTIONS(113),
  },
  [23] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(677),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(119),
    [sym_string_start] = ACTIONS(113),
  },
  [24] = {
    [sym_python_function_definition] = STATE(32),
    [sym__statement] = STATE(32),
    [sym__simple_statements] = STATE(32),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(2523),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(32),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [25] = {
    [sym_python_function_definition] = STATE(31),
    [sym__statement] = STATE(31),
    [sym__simple_statements] = STATE(31),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(31),
    [sym_for_statement] = STATE(31),
    [sym_while_statement] = STATE(31),
    [sym_try_statement] = STATE(31),
    [sym_with_statement] = STATE(31),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_block] = STATE(606),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(31),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(127),
    [sym_string_start] = ACTIONS(113),
  },
  [26] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(131),
    [sym_string_start] = ACTIONS(113),
  },
  [27] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(113),
  },
  [28] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(113),
  },
  [29] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(137),
    [sym_string_start] = ACTIONS(113),
  },
  [30] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(139),
    [sym_string_start] = ACTIONS(113),
  },
  [31] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(141),
    [sym_string_start] = ACTIONS(113),
  },
  [32] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(143),
    [sym_string_start] = ACTIONS(113),
  },
  [33] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LPAREN] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_def] = ACTIONS(154),
    [anon_sym_import] = ACTIONS(157),
    [anon_sym_from] = ACTIONS(160),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_print] = ACTIONS(166),
    [anon_sym_assert] = ACTIONS(169),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_del] = ACTIONS(175),
    [anon_sym_raise] = ACTIONS(178),
    [anon_sym_pass] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(184),
    [anon_sym_continue] = ACTIONS(187),
    [anon_sym_global] = ACTIONS(190),
    [anon_sym_nonlocal] = ACTIONS(193),
    [anon_sym_exec] = ACTIONS(196),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_async] = ACTIONS(202),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(208),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_with] = ACTIONS(214),
    [anon_sym_not] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(220),
    [anon_sym_DASH] = ACTIONS(223),
    [anon_sym_TILDE] = ACTIONS(220),
    [anon_sym_lambda] = ACTIONS(226),
    [anon_sym_yield] = ACTIONS(229),
    [sym_ellipsis] = ACTIONS(232),
    [anon_sym_await] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(238),
    [anon_sym_type] = ACTIONS(241),
    [sym_integer] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_true] = ACTIONS(244),
    [sym_false] = ACTIONS(244),
    [sym_none] = ACTIONS(244),
    [sym_python_identifier] = ACTIONS(247),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(253),
    [sym_string_start] = ACTIONS(255),
  },
  [34] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(258),
    [sym_string_start] = ACTIONS(113),
  },
  [35] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(260),
    [sym_string_start] = ACTIONS(113),
  },
  [36] = {
    [sym__simple_statements] = STATE(649),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(562),
    [sym_subscript] = STATE(562),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(564),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1539),
    [sym_primary_expression] = STATE(846),
    [sym_type] = STATE(1934),
    [sym_splat_type] = STATE(1908),
    [sym_generic_type] = STATE(1908),
    [sym_union_type] = STATE(1908),
    [sym_constrained_type] = STATE(1908),
    [sym_member_type] = STATE(1908),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(264),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(266),
    [anon_sym_print] = ACTIONS(268),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(272),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_STAR_STAR] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(272),
    [anon_sym_type] = ACTIONS(278),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(280),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(282),
    [sym__indent] = ACTIONS(284),
    [sym_string_start] = ACTIONS(113),
  },
  [37] = {
    [sym_chevron] = STATE(1984),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_attribute] = STATE(971),
    [sym_subscript] = STATE(971),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_list_splat_pattern] = STATE(989),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1718),
    [sym_primary_expression] = STATE(840),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(292),
    [anon_sym_COLON] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(305),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_print] = ACTIONS(311),
    [anon_sym_GT_GT] = ACTIONS(313),
    [anon_sym_exec] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(311),
    [anon_sym_not] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(321),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_type] = ACTIONS(323),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(325),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(301),
    [sym_string_start] = ACTIONS(113),
  },
  [38] = {
    [sym__simple_statements] = STATE(2334),
    [sym_import_statement] = STATE(2035),
    [sym_future_import_statement] = STATE(2035),
    [sym_import_from_statement] = STATE(2035),
    [sym_print_statement] = STATE(2035),
    [sym_assert_statement] = STATE(2035),
    [sym_expression_statement] = STATE(2035),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2035),
    [sym_delete_statement] = STATE(2035),
    [sym_raise_statement] = STATE(2035),
    [sym_pass_statement] = STATE(2035),
    [sym_break_statement] = STATE(2035),
    [sym_continue_statement] = STATE(2035),
    [sym_global_statement] = STATE(2035),
    [sym_nonlocal_statement] = STATE(2035),
    [sym_exec_statement] = STATE(2035),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(562),
    [sym_subscript] = STATE(562),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(564),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1539),
    [sym_primary_expression] = STATE(846),
    [sym_type] = STATE(1934),
    [sym_splat_type] = STATE(1908),
    [sym_generic_type] = STATE(1908),
    [sym_union_type] = STATE(1908),
    [sym_constrained_type] = STATE(1908),
    [sym_member_type] = STATE(1908),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(264),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(266),
    [anon_sym_print] = ACTIONS(268),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(272),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_STAR_STAR] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(272),
    [anon_sym_type] = ACTIONS(278),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(280),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(327),
    [sym__indent] = ACTIONS(329),
    [sym_string_start] = ACTIONS(113),
  },
  [39] = {
    [sym_chevron] = STATE(1984),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_attribute] = STATE(971),
    [sym_subscript] = STATE(971),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_list_splat_pattern] = STATE(989),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1718),
    [sym_primary_expression] = STATE(840),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(292),
    [anon_sym_COLON] = ACTIONS(286),
    [anon_sym_LPAREN] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(305),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_print] = ACTIONS(311),
    [anon_sym_GT_GT] = ACTIONS(313),
    [anon_sym_exec] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(311),
    [anon_sym_not] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(321),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_type] = ACTIONS(323),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(325),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(301),
    [sym_string_start] = ACTIONS(113),
  },
  [40] = {
    [sym__simple_statements] = STATE(602),
    [sym_import_statement] = STATE(2053),
    [sym_future_import_statement] = STATE(2053),
    [sym_import_from_statement] = STATE(2053),
    [sym_print_statement] = STATE(2053),
    [sym_assert_statement] = STATE(2053),
    [sym_expression_statement] = STATE(2053),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2053),
    [sym_delete_statement] = STATE(2053),
    [sym_raise_statement] = STATE(2053),
    [sym_pass_statement] = STATE(2053),
    [sym_break_statement] = STATE(2053),
    [sym_continue_statement] = STATE(2053),
    [sym_global_statement] = STATE(2053),
    [sym_nonlocal_statement] = STATE(2053),
    [sym_exec_statement] = STATE(2053),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(331),
    [sym__indent] = ACTIONS(333),
    [sym_string_start] = ACTIONS(113),
  },
  [41] = {
    [sym__simple_statements] = STATE(645),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(335),
    [sym__indent] = ACTIONS(337),
    [sym_string_start] = ACTIONS(113),
  },
  [42] = {
    [sym__simple_statements] = STATE(2493),
    [sym_import_statement] = STATE(2029),
    [sym_future_import_statement] = STATE(2029),
    [sym_import_from_statement] = STATE(2029),
    [sym_print_statement] = STATE(2029),
    [sym_assert_statement] = STATE(2029),
    [sym_expression_statement] = STATE(2029),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2029),
    [sym_delete_statement] = STATE(2029),
    [sym_raise_statement] = STATE(2029),
    [sym_pass_statement] = STATE(2029),
    [sym_break_statement] = STATE(2029),
    [sym_continue_statement] = STATE(2029),
    [sym_global_statement] = STATE(2029),
    [sym_nonlocal_statement] = STATE(2029),
    [sym_exec_statement] = STATE(2029),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(339),
    [sym__indent] = ACTIONS(341),
    [sym_string_start] = ACTIONS(113),
  },
  [43] = {
    [sym__simple_statements] = STATE(591),
    [sym_import_statement] = STATE(2071),
    [sym_future_import_statement] = STATE(2071),
    [sym_import_from_statement] = STATE(2071),
    [sym_print_statement] = STATE(2071),
    [sym_assert_statement] = STATE(2071),
    [sym_expression_statement] = STATE(2071),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2071),
    [sym_delete_statement] = STATE(2071),
    [sym_raise_statement] = STATE(2071),
    [sym_pass_statement] = STATE(2071),
    [sym_break_statement] = STATE(2071),
    [sym_continue_statement] = STATE(2071),
    [sym_global_statement] = STATE(2071),
    [sym_nonlocal_statement] = STATE(2071),
    [sym_exec_statement] = STATE(2071),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(343),
    [sym__indent] = ACTIONS(345),
    [sym_string_start] = ACTIONS(113),
  },
  [44] = {
    [sym__simple_statements] = STATE(660),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(347),
    [sym__indent] = ACTIONS(349),
    [sym_string_start] = ACTIONS(113),
  },
  [45] = {
    [sym__simple_statements] = STATE(2524),
    [sym_import_statement] = STATE(2029),
    [sym_future_import_statement] = STATE(2029),
    [sym_import_from_statement] = STATE(2029),
    [sym_print_statement] = STATE(2029),
    [sym_assert_statement] = STATE(2029),
    [sym_expression_statement] = STATE(2029),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2029),
    [sym_delete_statement] = STATE(2029),
    [sym_raise_statement] = STATE(2029),
    [sym_pass_statement] = STATE(2029),
    [sym_break_statement] = STATE(2029),
    [sym_continue_statement] = STATE(2029),
    [sym_global_statement] = STATE(2029),
    [sym_nonlocal_statement] = STATE(2029),
    [sym_exec_statement] = STATE(2029),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(351),
    [sym__indent] = ACTIONS(353),
    [sym_string_start] = ACTIONS(113),
  },
  [46] = {
    [sym__simple_statements] = STATE(672),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(355),
    [sym__indent] = ACTIONS(357),
    [sym_string_start] = ACTIONS(113),
  },
  [47] = {
    [sym__simple_statements] = STATE(613),
    [sym_import_statement] = STATE(2053),
    [sym_future_import_statement] = STATE(2053),
    [sym_import_from_statement] = STATE(2053),
    [sym_print_statement] = STATE(2053),
    [sym_assert_statement] = STATE(2053),
    [sym_expression_statement] = STATE(2053),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2053),
    [sym_delete_statement] = STATE(2053),
    [sym_raise_statement] = STATE(2053),
    [sym_pass_statement] = STATE(2053),
    [sym_break_statement] = STATE(2053),
    [sym_continue_statement] = STATE(2053),
    [sym_global_statement] = STATE(2053),
    [sym_nonlocal_statement] = STATE(2053),
    [sym_exec_statement] = STATE(2053),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(359),
    [sym__indent] = ACTIONS(361),
    [sym_string_start] = ACTIONS(113),
  },
  [48] = {
    [sym__simple_statements] = STATE(655),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(363),
    [sym__indent] = ACTIONS(365),
    [sym_string_start] = ACTIONS(113),
  },
  [49] = {
    [sym__simple_statements] = STATE(2422),
    [sym_import_statement] = STATE(2029),
    [sym_future_import_statement] = STATE(2029),
    [sym_import_from_statement] = STATE(2029),
    [sym_print_statement] = STATE(2029),
    [sym_assert_statement] = STATE(2029),
    [sym_expression_statement] = STATE(2029),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2029),
    [sym_delete_statement] = STATE(2029),
    [sym_raise_statement] = STATE(2029),
    [sym_pass_statement] = STATE(2029),
    [sym_break_statement] = STATE(2029),
    [sym_continue_statement] = STATE(2029),
    [sym_global_statement] = STATE(2029),
    [sym_nonlocal_statement] = STATE(2029),
    [sym_exec_statement] = STATE(2029),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(367),
    [sym__indent] = ACTIONS(369),
    [sym_string_start] = ACTIONS(113),
  },
  [50] = {
    [sym__simple_statements] = STATE(2351),
    [sym_import_statement] = STATE(2029),
    [sym_future_import_statement] = STATE(2029),
    [sym_import_from_statement] = STATE(2029),
    [sym_print_statement] = STATE(2029),
    [sym_assert_statement] = STATE(2029),
    [sym_expression_statement] = STATE(2029),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2029),
    [sym_delete_statement] = STATE(2029),
    [sym_raise_statement] = STATE(2029),
    [sym_pass_statement] = STATE(2029),
    [sym_break_statement] = STATE(2029),
    [sym_continue_statement] = STATE(2029),
    [sym_global_statement] = STATE(2029),
    [sym_nonlocal_statement] = STATE(2029),
    [sym_exec_statement] = STATE(2029),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__indent] = ACTIONS(373),
    [sym_string_start] = ACTIONS(113),
  },
  [51] = {
    [sym__simple_statements] = STATE(605),
    [sym_import_statement] = STATE(2158),
    [sym_future_import_statement] = STATE(2158),
    [sym_import_from_statement] = STATE(2158),
    [sym_print_statement] = STATE(2158),
    [sym_assert_statement] = STATE(2158),
    [sym_expression_statement] = STATE(2158),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2158),
    [sym_delete_statement] = STATE(2158),
    [sym_raise_statement] = STATE(2158),
    [sym_pass_statement] = STATE(2158),
    [sym_break_statement] = STATE(2158),
    [sym_continue_statement] = STATE(2158),
    [sym_global_statement] = STATE(2158),
    [sym_nonlocal_statement] = STATE(2158),
    [sym_exec_statement] = STATE(2158),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(375),
    [sym__indent] = ACTIONS(377),
    [sym_string_start] = ACTIONS(113),
  },
  [52] = {
    [sym__simple_statements] = STATE(2228),
    [sym_import_statement] = STATE(2035),
    [sym_future_import_statement] = STATE(2035),
    [sym_import_from_statement] = STATE(2035),
    [sym_print_statement] = STATE(2035),
    [sym_assert_statement] = STATE(2035),
    [sym_expression_statement] = STATE(2035),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2035),
    [sym_delete_statement] = STATE(2035),
    [sym_raise_statement] = STATE(2035),
    [sym_pass_statement] = STATE(2035),
    [sym_break_statement] = STATE(2035),
    [sym_continue_statement] = STATE(2035),
    [sym_global_statement] = STATE(2035),
    [sym_nonlocal_statement] = STATE(2035),
    [sym_exec_statement] = STATE(2035),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__indent] = ACTIONS(381),
    [sym_string_start] = ACTIONS(113),
  },
  [53] = {
    [sym__simple_statements] = STATE(576),
    [sym_import_statement] = STATE(2206),
    [sym_future_import_statement] = STATE(2206),
    [sym_import_from_statement] = STATE(2206),
    [sym_print_statement] = STATE(2206),
    [sym_assert_statement] = STATE(2206),
    [sym_expression_statement] = STATE(2206),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2206),
    [sym_delete_statement] = STATE(2206),
    [sym_raise_statement] = STATE(2206),
    [sym_pass_statement] = STATE(2206),
    [sym_break_statement] = STATE(2206),
    [sym_continue_statement] = STATE(2206),
    [sym_global_statement] = STATE(2206),
    [sym_nonlocal_statement] = STATE(2206),
    [sym_exec_statement] = STATE(2206),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(383),
    [sym__indent] = ACTIONS(385),
    [sym_string_start] = ACTIONS(113),
  },
  [54] = {
    [sym__simple_statements] = STATE(586),
    [sym_import_statement] = STATE(2071),
    [sym_future_import_statement] = STATE(2071),
    [sym_import_from_statement] = STATE(2071),
    [sym_print_statement] = STATE(2071),
    [sym_assert_statement] = STATE(2071),
    [sym_expression_statement] = STATE(2071),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2071),
    [sym_delete_statement] = STATE(2071),
    [sym_raise_statement] = STATE(2071),
    [sym_pass_statement] = STATE(2071),
    [sym_break_statement] = STATE(2071),
    [sym_continue_statement] = STATE(2071),
    [sym_global_statement] = STATE(2071),
    [sym_nonlocal_statement] = STATE(2071),
    [sym_exec_statement] = STATE(2071),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(387),
    [sym__indent] = ACTIONS(389),
    [sym_string_start] = ACTIONS(113),
  },
  [55] = {
    [sym__simple_statements] = STATE(661),
    [sym_import_statement] = STATE(2108),
    [sym_future_import_statement] = STATE(2108),
    [sym_import_from_statement] = STATE(2108),
    [sym_print_statement] = STATE(2108),
    [sym_assert_statement] = STATE(2108),
    [sym_expression_statement] = STATE(2108),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2108),
    [sym_delete_statement] = STATE(2108),
    [sym_raise_statement] = STATE(2108),
    [sym_pass_statement] = STATE(2108),
    [sym_break_statement] = STATE(2108),
    [sym_continue_statement] = STATE(2108),
    [sym_global_statement] = STATE(2108),
    [sym_nonlocal_statement] = STATE(2108),
    [sym_exec_statement] = STATE(2108),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(391),
    [sym__indent] = ACTIONS(393),
    [sym_string_start] = ACTIONS(113),
  },
  [56] = {
    [sym__simple_statements] = STATE(555),
    [sym_import_statement] = STATE(2158),
    [sym_future_import_statement] = STATE(2158),
    [sym_import_from_statement] = STATE(2158),
    [sym_print_statement] = STATE(2158),
    [sym_assert_statement] = STATE(2158),
    [sym_expression_statement] = STATE(2158),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2158),
    [sym_delete_statement] = STATE(2158),
    [sym_raise_statement] = STATE(2158),
    [sym_pass_statement] = STATE(2158),
    [sym_break_statement] = STATE(2158),
    [sym_continue_statement] = STATE(2158),
    [sym_global_statement] = STATE(2158),
    [sym_nonlocal_statement] = STATE(2158),
    [sym_exec_statement] = STATE(2158),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(395),
    [sym__indent] = ACTIONS(397),
    [sym_string_start] = ACTIONS(113),
  },
  [57] = {
    [sym__simple_statements] = STATE(581),
    [sym_import_statement] = STATE(2071),
    [sym_future_import_statement] = STATE(2071),
    [sym_import_from_statement] = STATE(2071),
    [sym_print_statement] = STATE(2071),
    [sym_assert_statement] = STATE(2071),
    [sym_expression_statement] = STATE(2071),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2071),
    [sym_delete_statement] = STATE(2071),
    [sym_raise_statement] = STATE(2071),
    [sym_pass_statement] = STATE(2071),
    [sym_break_statement] = STATE(2071),
    [sym_continue_statement] = STATE(2071),
    [sym_global_statement] = STATE(2071),
    [sym_nonlocal_statement] = STATE(2071),
    [sym_exec_statement] = STATE(2071),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(399),
    [sym__indent] = ACTIONS(401),
    [sym_string_start] = ACTIONS(113),
  },
  [58] = {
    [sym__simple_statements] = STATE(620),
    [sym_import_statement] = STATE(2053),
    [sym_future_import_statement] = STATE(2053),
    [sym_import_from_statement] = STATE(2053),
    [sym_print_statement] = STATE(2053),
    [sym_assert_statement] = STATE(2053),
    [sym_expression_statement] = STATE(2053),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2053),
    [sym_delete_statement] = STATE(2053),
    [sym_raise_statement] = STATE(2053),
    [sym_pass_statement] = STATE(2053),
    [sym_break_statement] = STATE(2053),
    [sym_continue_statement] = STATE(2053),
    [sym_global_statement] = STATE(2053),
    [sym_nonlocal_statement] = STATE(2053),
    [sym_exec_statement] = STATE(2053),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(403),
    [sym__indent] = ACTIONS(405),
    [sym_string_start] = ACTIONS(113),
  },
  [59] = {
    [sym__simple_statements] = STATE(635),
    [sym_import_statement] = STATE(2144),
    [sym_future_import_statement] = STATE(2144),
    [sym_import_from_statement] = STATE(2144),
    [sym_print_statement] = STATE(2144),
    [sym_assert_statement] = STATE(2144),
    [sym_expression_statement] = STATE(2144),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2144),
    [sym_delete_statement] = STATE(2144),
    [sym_raise_statement] = STATE(2144),
    [sym_pass_statement] = STATE(2144),
    [sym_break_statement] = STATE(2144),
    [sym_continue_statement] = STATE(2144),
    [sym_global_statement] = STATE(2144),
    [sym_nonlocal_statement] = STATE(2144),
    [sym_exec_statement] = STATE(2144),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(407),
    [sym__indent] = ACTIONS(409),
    [sym_string_start] = ACTIONS(113),
  },
  [60] = {
    [sym__simple_statements] = STATE(1714),
    [sym_import_statement] = STATE(2188),
    [sym_future_import_statement] = STATE(2188),
    [sym_import_from_statement] = STATE(2188),
    [sym_print_statement] = STATE(2188),
    [sym_assert_statement] = STATE(2188),
    [sym_expression_statement] = STATE(2188),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2188),
    [sym_delete_statement] = STATE(2188),
    [sym_raise_statement] = STATE(2188),
    [sym_pass_statement] = STATE(2188),
    [sym_break_statement] = STATE(2188),
    [sym_continue_statement] = STATE(2188),
    [sym_global_statement] = STATE(2188),
    [sym_nonlocal_statement] = STATE(2188),
    [sym_exec_statement] = STATE(2188),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(411),
    [sym__indent] = ACTIONS(413),
    [sym_string_start] = ACTIONS(113),
  },
  [61] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(415),
    [sym_string_start] = ACTIONS(113),
  },
  [62] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(417),
    [sym_string_start] = ACTIONS(113),
  },
  [63] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(419),
    [sym_string_start] = ACTIONS(113),
  },
  [64] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(421),
    [sym_string_start] = ACTIONS(113),
  },
  [65] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(423),
    [sym_string_start] = ACTIONS(113),
  },
  [66] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(425),
    [sym_string_start] = ACTIONS(113),
  },
  [67] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(427),
    [sym_string_start] = ACTIONS(113),
  },
  [68] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(429),
    [sym_string_start] = ACTIONS(113),
  },
  [69] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(431),
    [sym_string_start] = ACTIONS(113),
  },
  [70] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym_string_start] = ACTIONS(113),
  },
  [71] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(435),
    [sym_string_start] = ACTIONS(113),
  },
  [72] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(437),
    [sym_string_start] = ACTIONS(113),
  },
  [73] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(439),
    [sym_string_start] = ACTIONS(113),
  },
  [74] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(441),
    [sym_string_start] = ACTIONS(113),
  },
  [75] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(443),
    [sym_string_start] = ACTIONS(113),
  },
  [76] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym_string_start] = ACTIONS(113),
  },
  [77] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(447),
    [sym_string_start] = ACTIONS(113),
  },
  [78] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(449),
    [sym_string_start] = ACTIONS(113),
  },
  [79] = {
    [sym_import_statement] = STATE(2326),
    [sym_future_import_statement] = STATE(2326),
    [sym_import_from_statement] = STATE(2326),
    [sym_print_statement] = STATE(2326),
    [sym_assert_statement] = STATE(2326),
    [sym_expression_statement] = STATE(2326),
    [sym_named_expression] = STATE(1529),
    [sym__named_expression_lhs] = STATE(2396),
    [sym_return_statement] = STATE(2326),
    [sym_delete_statement] = STATE(2326),
    [sym_raise_statement] = STATE(2326),
    [sym_pass_statement] = STATE(2326),
    [sym_break_statement] = STATE(2326),
    [sym_continue_statement] = STATE(2326),
    [sym_global_statement] = STATE(2326),
    [sym_nonlocal_statement] = STATE(2326),
    [sym_exec_statement] = STATE(2326),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_assignment] = STATE(2327),
    [sym_augmented_assignment] = STATE(2327),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2327),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_pattern] = STATE(1495),
    [sym_tuple_pattern] = STATE(1491),
    [sym_list_pattern] = STATE(1491),
    [sym_list_splat_pattern] = STATE(566),
    [sym_as_pattern] = STATE(1529),
    [sym_expression] = STATE(1697),
    [sym_primary_expression] = STATE(846),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(113),
  },
  [80] = {
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_attribute] = STATE(971),
    [sym_subscript] = STATE(971),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_list_splat_pattern] = STATE(989),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(286),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(305),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(459),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(301),
    [sym_string_start] = ACTIONS(113),
  },
  [81] = {
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_attribute] = STATE(971),
    [sym_subscript] = STATE(971),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_list_splat_pattern] = STATE(989),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(305),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(459),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(301),
    [sym_string_start] = ACTIONS(113),
  },
  [82] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_AT_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(463),
    [sym_string_start] = ACTIONS(490),
  },
  [83] = {
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_attribute] = STATE(971),
    [sym_subscript] = STATE(971),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_list_splat_pattern] = STATE(989),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(459),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(301),
    [sym_string_start] = ACTIONS(113),
  },
  [84] = {
    [sym_binary_operator] = STATE(1026),
    [sym_unary_operator] = STATE(1026),
    [sym_attribute] = STATE(1026),
    [sym_subscript] = STATE(1026),
    [sym_call] = STATE(1026),
    [sym_generator_expression] = STATE(1026),
    [sym_parenthesized_expression] = STATE(1026),
    [sym_list_splat_pattern] = STATE(1028),
    [sym_primary_expression] = STATE(873),
    [sym_list] = STATE(1026),
    [sym_set] = STATE(1026),
    [sym_tuple] = STATE(1026),
    [sym_dictionary] = STATE(1026),
    [sym_list_comprehension] = STATE(1026),
    [sym_dictionary_comprehension] = STATE(1026),
    [sym_set_comprehension] = STATE(1026),
    [sym_concatenated_string] = STATE(1026),
    [sym_python_string] = STATE(841),
    [sym_await] = STATE(1026),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(506),
    [sym_type_conversion] = ACTIONS(301),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [85] = {
    [sym_binary_operator] = STATE(1026),
    [sym_unary_operator] = STATE(1026),
    [sym_attribute] = STATE(1026),
    [sym_subscript] = STATE(1026),
    [sym_call] = STATE(1026),
    [sym_generator_expression] = STATE(1026),
    [sym_parenthesized_expression] = STATE(1026),
    [sym_list_splat_pattern] = STATE(1028),
    [sym_primary_expression] = STATE(873),
    [sym_list] = STATE(1026),
    [sym_set] = STATE(1026),
    [sym_tuple] = STATE(1026),
    [sym_dictionary] = STATE(1026),
    [sym_list_comprehension] = STATE(1026),
    [sym_dictionary_comprehension] = STATE(1026),
    [sym_set_comprehension] = STATE(1026),
    [sym_concatenated_string] = STATE(1026),
    [sym_python_string] = STATE(841),
    [sym_await] = STATE(1026),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(305),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(506),
    [sym_type_conversion] = ACTIONS(301),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [86] = {
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_attribute] = STATE(971),
    [sym_subscript] = STATE(971),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_list_splat_pattern] = STATE(989),
    [sym_primary_expression] = STATE(984),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_from] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(516),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(518),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(522),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(301),
    [sym_string_start] = ACTIONS(113),
  },
  [87] = {
    [sym_binary_operator] = STATE(1026),
    [sym_unary_operator] = STATE(1026),
    [sym_attribute] = STATE(1026),
    [sym_subscript] = STATE(1026),
    [sym_call] = STATE(1026),
    [sym_generator_expression] = STATE(1026),
    [sym_parenthesized_expression] = STATE(1026),
    [sym_list_splat_pattern] = STATE(1028),
    [sym_primary_expression] = STATE(873),
    [sym_list] = STATE(1026),
    [sym_set] = STATE(1026),
    [sym_tuple] = STATE(1026),
    [sym_dictionary] = STATE(1026),
    [sym_list_comprehension] = STATE(1026),
    [sym_dictionary_comprehension] = STATE(1026),
    [sym_set_comprehension] = STATE(1026),
    [sym_concatenated_string] = STATE(1026),
    [sym_python_string] = STATE(841),
    [sym_await] = STATE(1026),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(524),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(524),
    [anon_sym_EQ_EQ] = ACTIONS(524),
    [anon_sym_BANG_EQ] = ACTIONS(524),
    [anon_sym_GT_EQ] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(524),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [88] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(463),
    [sym_string_start] = ACTIONS(490),
  },
  [89] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [sym_type_conversion] = ACTIONS(463),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [90] = {
    [sym_binary_operator] = STATE(1140),
    [sym_unary_operator] = STATE(1140),
    [sym_attribute] = STATE(1140),
    [sym_subscript] = STATE(1140),
    [sym_call] = STATE(1140),
    [sym_generator_expression] = STATE(1140),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_list_splat_pattern] = STATE(1136),
    [sym_primary_expression] = STATE(852),
    [sym_list] = STATE(1140),
    [sym_set] = STATE(1140),
    [sym_tuple] = STATE(1140),
    [sym_dictionary] = STATE(1140),
    [sym_list_comprehension] = STATE(1140),
    [sym_dictionary_comprehension] = STATE(1140),
    [sym_set_comprehension] = STATE(1140),
    [sym_concatenated_string] = STATE(1140),
    [sym_python_string] = STATE(838),
    [sym_await] = STATE(1140),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(527),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(531),
    [anon_sym_RBRACE] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_print] = ACTIONS(535),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(535),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(537),
    [anon_sym_DASH] = ACTIONS(539),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(537),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(541),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(547),
    [sym_true] = ACTIONS(547),
    [sym_false] = ACTIONS(547),
    [sym_none] = ACTIONS(547),
    [sym_python_identifier] = ACTIONS(547),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(549),
  },
  [91] = {
    [sym_binary_operator] = STATE(1026),
    [sym_unary_operator] = STATE(1026),
    [sym_attribute] = STATE(1026),
    [sym_subscript] = STATE(1026),
    [sym_call] = STATE(1026),
    [sym_generator_expression] = STATE(1026),
    [sym_parenthesized_expression] = STATE(1026),
    [sym_list_splat_pattern] = STATE(1028),
    [sym_primary_expression] = STATE(873),
    [sym_list] = STATE(1026),
    [sym_set] = STATE(1026),
    [sym_tuple] = STATE(1026),
    [sym_dictionary] = STATE(1026),
    [sym_list_comprehension] = STATE(1026),
    [sym_dictionary_comprehension] = STATE(1026),
    [sym_set_comprehension] = STATE(1026),
    [sym_concatenated_string] = STATE(1026),
    [sym_python_string] = STATE(841),
    [sym_await] = STATE(1026),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(506),
    [sym_type_conversion] = ACTIONS(301),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [92] = {
    [sym_binary_operator] = STATE(1223),
    [sym_unary_operator] = STATE(1223),
    [sym_attribute] = STATE(1223),
    [sym_subscript] = STATE(1223),
    [sym_call] = STATE(1223),
    [sym_generator_expression] = STATE(1223),
    [sym_parenthesized_expression] = STATE(1223),
    [sym_list_splat_pattern] = STATE(1172),
    [sym_primary_expression] = STATE(916),
    [sym_list] = STATE(1223),
    [sym_set] = STATE(1223),
    [sym_tuple] = STATE(1223),
    [sym_dictionary] = STATE(1223),
    [sym_list_comprehension] = STATE(1223),
    [sym_dictionary_comprehension] = STATE(1223),
    [sym_set_comprehension] = STATE(1223),
    [sym_concatenated_string] = STATE(1223),
    [sym_python_string] = STATE(851),
    [sym_await] = STATE(1223),
    [anon_sym_EQ] = ACTIONS(551),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_print] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(567),
    [anon_sym_await] = ACTIONS(569),
    [anon_sym_match] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(571),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_none] = ACTIONS(573),
    [sym_python_identifier] = ACTIONS(573),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(571),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(575),
  },
  [93] = {
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_attribute] = STATE(971),
    [sym_subscript] = STATE(971),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_list_splat_pattern] = STATE(989),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(459),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(301),
    [sym_string_start] = ACTIONS(113),
  },
  [94] = {
    [sym_binary_operator] = STATE(1222),
    [sym_unary_operator] = STATE(1222),
    [sym_attribute] = STATE(1222),
    [sym_subscript] = STATE(1222),
    [sym_call] = STATE(1222),
    [sym_generator_expression] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_list_splat_pattern] = STATE(1193),
    [sym_primary_expression] = STATE(977),
    [sym_list] = STATE(1222),
    [sym_set] = STATE(1222),
    [sym_tuple] = STATE(1222),
    [sym_dictionary] = STATE(1222),
    [sym_list_comprehension] = STATE(1222),
    [sym_dictionary_comprehension] = STATE(1222),
    [sym_set_comprehension] = STATE(1222),
    [sym_concatenated_string] = STATE(1222),
    [sym_python_string] = STATE(850),
    [sym_await] = STATE(1222),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(579),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_print] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(591),
    [anon_sym_await] = ACTIONS(593),
    [anon_sym_match] = ACTIONS(585),
    [anon_sym_type] = ACTIONS(595),
    [sym_integer] = ACTIONS(597),
    [sym_float] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_none] = ACTIONS(597),
    [sym_python_identifier] = ACTIONS(597),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(599),
  },
  [95] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [96] = {
    [sym_binary_operator] = STATE(1283),
    [sym_unary_operator] = STATE(1283),
    [sym_attribute] = STATE(1283),
    [sym_subscript] = STATE(1283),
    [sym_call] = STATE(1283),
    [sym_generator_expression] = STATE(1283),
    [sym_parenthesized_expression] = STATE(1283),
    [sym_list_splat_pattern] = STATE(1163),
    [sym_primary_expression] = STATE(955),
    [sym_list] = STATE(1283),
    [sym_set] = STATE(1283),
    [sym_tuple] = STATE(1283),
    [sym_dictionary] = STATE(1283),
    [sym_list_comprehension] = STATE(1283),
    [sym_dictionary_comprehension] = STATE(1283),
    [sym_set_comprehension] = STATE(1283),
    [sym_concatenated_string] = STATE(1283),
    [sym_python_string] = STATE(857),
    [sym_await] = STATE(1283),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(601),
    [anon_sym_RBRACK] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_print] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(609),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(609),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(615),
    [anon_sym_await] = ACTIONS(617),
    [anon_sym_match] = ACTIONS(609),
    [anon_sym_type] = ACTIONS(619),
    [sym_integer] = ACTIONS(621),
    [sym_float] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_none] = ACTIONS(621),
    [sym_python_identifier] = ACTIONS(621),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(623),
  },
  [97] = {
    [sym_binary_operator] = STATE(1222),
    [sym_unary_operator] = STATE(1222),
    [sym_attribute] = STATE(1222),
    [sym_subscript] = STATE(1222),
    [sym_call] = STATE(1222),
    [sym_generator_expression] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_list_splat_pattern] = STATE(1193),
    [sym_primary_expression] = STATE(977),
    [sym_list] = STATE(1222),
    [sym_set] = STATE(1222),
    [sym_tuple] = STATE(1222),
    [sym_dictionary] = STATE(1222),
    [sym_list_comprehension] = STATE(1222),
    [sym_dictionary_comprehension] = STATE(1222),
    [sym_set_comprehension] = STATE(1222),
    [sym_concatenated_string] = STATE(1222),
    [sym_python_string] = STATE(850),
    [sym_await] = STATE(1222),
    [anon_sym_EQ] = ACTIONS(551),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_LPAREN] = ACTIONS(579),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_print] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(591),
    [anon_sym_await] = ACTIONS(593),
    [anon_sym_match] = ACTIONS(585),
    [anon_sym_type] = ACTIONS(595),
    [sym_integer] = ACTIONS(597),
    [sym_float] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_none] = ACTIONS(597),
    [sym_python_identifier] = ACTIONS(597),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(599),
  },
  [98] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(290),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(290),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(290),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(290),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(290),
    [sym_string_start] = ACTIONS(490),
  },
  [99] = {
    [sym_binary_operator] = STATE(1379),
    [sym_unary_operator] = STATE(1379),
    [sym_attribute] = STATE(1379),
    [sym_subscript] = STATE(1379),
    [sym_call] = STATE(1379),
    [sym_generator_expression] = STATE(1379),
    [sym_parenthesized_expression] = STATE(1379),
    [sym_list_splat_pattern] = STATE(1347),
    [sym_primary_expression] = STATE(1029),
    [sym_list] = STATE(1379),
    [sym_set] = STATE(1379),
    [sym_tuple] = STATE(1379),
    [sym_dictionary] = STATE(1379),
    [sym_list_comprehension] = STATE(1379),
    [sym_dictionary_comprehension] = STATE(1379),
    [sym_set_comprehension] = STATE(1379),
    [sym_concatenated_string] = STATE(1379),
    [sym_python_string] = STATE(1003),
    [sym_await] = STATE(1379),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(524),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_print] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(524),
    [anon_sym_EQ_EQ] = ACTIONS(524),
    [anon_sym_BANG_EQ] = ACTIONS(524),
    [anon_sym_GT_EQ] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(524),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(639),
    [anon_sym_await] = ACTIONS(641),
    [anon_sym_match] = ACTIONS(633),
    [anon_sym_type] = ACTIONS(643),
    [sym_integer] = ACTIONS(645),
    [sym_float] = ACTIONS(645),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_none] = ACTIONS(645),
    [sym_python_identifier] = ACTIONS(645),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(647),
  },
  [100] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1118),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(655),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [101] = {
    [sym_binary_operator] = STATE(1223),
    [sym_unary_operator] = STATE(1223),
    [sym_attribute] = STATE(1223),
    [sym_subscript] = STATE(1223),
    [sym_call] = STATE(1223),
    [sym_generator_expression] = STATE(1223),
    [sym_parenthesized_expression] = STATE(1223),
    [sym_list_splat_pattern] = STATE(1172),
    [sym_primary_expression] = STATE(916),
    [sym_list] = STATE(1223),
    [sym_set] = STATE(1223),
    [sym_tuple] = STATE(1223),
    [sym_dictionary] = STATE(1223),
    [sym_list_comprehension] = STATE(1223),
    [sym_dictionary_comprehension] = STATE(1223),
    [sym_set_comprehension] = STATE(1223),
    [sym_concatenated_string] = STATE(1223),
    [sym_python_string] = STATE(851),
    [sym_await] = STATE(1223),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(305),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(305),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_print] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(567),
    [anon_sym_await] = ACTIONS(569),
    [anon_sym_match] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(571),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_none] = ACTIONS(573),
    [sym_python_identifier] = ACTIONS(573),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(571),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(575),
  },
  [102] = {
    [sym_binary_operator] = STATE(1223),
    [sym_unary_operator] = STATE(1223),
    [sym_attribute] = STATE(1223),
    [sym_subscript] = STATE(1223),
    [sym_call] = STATE(1223),
    [sym_generator_expression] = STATE(1223),
    [sym_parenthesized_expression] = STATE(1223),
    [sym_list_splat_pattern] = STATE(1172),
    [sym_primary_expression] = STATE(916),
    [sym_list] = STATE(1223),
    [sym_set] = STATE(1223),
    [sym_tuple] = STATE(1223),
    [sym_dictionary] = STATE(1223),
    [sym_list_comprehension] = STATE(1223),
    [sym_dictionary_comprehension] = STATE(1223),
    [sym_set_comprehension] = STATE(1223),
    [sym_concatenated_string] = STATE(1223),
    [sym_python_string] = STATE(851),
    [sym_await] = STATE(1223),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_print] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(567),
    [anon_sym_await] = ACTIONS(569),
    [anon_sym_match] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(571),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_none] = ACTIONS(573),
    [sym_python_identifier] = ACTIONS(573),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(571),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(575),
  },
  [103] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [104] = {
    [sym_binary_operator] = STATE(1283),
    [sym_unary_operator] = STATE(1283),
    [sym_attribute] = STATE(1283),
    [sym_subscript] = STATE(1283),
    [sym_call] = STATE(1283),
    [sym_generator_expression] = STATE(1283),
    [sym_parenthesized_expression] = STATE(1283),
    [sym_list_splat_pattern] = STATE(1163),
    [sym_primary_expression] = STATE(955),
    [sym_list] = STATE(1283),
    [sym_set] = STATE(1283),
    [sym_tuple] = STATE(1283),
    [sym_dictionary] = STATE(1283),
    [sym_list_comprehension] = STATE(1283),
    [sym_dictionary_comprehension] = STATE(1283),
    [sym_set_comprehension] = STATE(1283),
    [sym_concatenated_string] = STATE(1283),
    [sym_python_string] = STATE(857),
    [sym_await] = STATE(1283),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(601),
    [anon_sym_RBRACK] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(305),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_print] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(609),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(609),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(615),
    [anon_sym_await] = ACTIONS(617),
    [anon_sym_match] = ACTIONS(609),
    [anon_sym_type] = ACTIONS(619),
    [sym_integer] = ACTIONS(621),
    [sym_float] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_none] = ACTIONS(621),
    [sym_python_identifier] = ACTIONS(621),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(623),
  },
  [105] = {
    [sym_binary_operator] = STATE(1222),
    [sym_unary_operator] = STATE(1222),
    [sym_attribute] = STATE(1222),
    [sym_subscript] = STATE(1222),
    [sym_call] = STATE(1222),
    [sym_generator_expression] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_list_splat_pattern] = STATE(1193),
    [sym_primary_expression] = STATE(977),
    [sym_list] = STATE(1222),
    [sym_set] = STATE(1222),
    [sym_tuple] = STATE(1222),
    [sym_dictionary] = STATE(1222),
    [sym_list_comprehension] = STATE(1222),
    [sym_dictionary_comprehension] = STATE(1222),
    [sym_set_comprehension] = STATE(1222),
    [sym_concatenated_string] = STATE(1222),
    [sym_python_string] = STATE(850),
    [sym_await] = STATE(1222),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_LPAREN] = ACTIONS(579),
    [anon_sym_RPAREN] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(524),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_print] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(585),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(524),
    [anon_sym_EQ_EQ] = ACTIONS(524),
    [anon_sym_BANG_EQ] = ACTIONS(524),
    [anon_sym_GT_EQ] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(524),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(591),
    [anon_sym_await] = ACTIONS(593),
    [anon_sym_match] = ACTIONS(585),
    [anon_sym_type] = ACTIONS(595),
    [sym_integer] = ACTIONS(597),
    [sym_float] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_none] = ACTIONS(597),
    [sym_python_identifier] = ACTIONS(597),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(599),
  },
  [106] = {
    [sym_binary_operator] = STATE(1140),
    [sym_unary_operator] = STATE(1140),
    [sym_attribute] = STATE(1140),
    [sym_subscript] = STATE(1140),
    [sym_call] = STATE(1140),
    [sym_generator_expression] = STATE(1140),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_list_splat_pattern] = STATE(1136),
    [sym_primary_expression] = STATE(852),
    [sym_list] = STATE(1140),
    [sym_set] = STATE(1140),
    [sym_tuple] = STATE(1140),
    [sym_dictionary] = STATE(1140),
    [sym_list_comprehension] = STATE(1140),
    [sym_dictionary_comprehension] = STATE(1140),
    [sym_set_comprehension] = STATE(1140),
    [sym_concatenated_string] = STATE(1140),
    [sym_python_string] = STATE(838),
    [sym_await] = STATE(1140),
    [anon_sym_LBRACK] = ACTIONS(527),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(531),
    [anon_sym_RBRACE] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_print] = ACTIONS(535),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(535),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(537),
    [anon_sym_DASH] = ACTIONS(539),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(537),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(541),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(547),
    [sym_true] = ACTIONS(547),
    [sym_false] = ACTIONS(547),
    [sym_none] = ACTIONS(547),
    [sym_python_identifier] = ACTIONS(547),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(549),
  },
  [107] = {
    [sym_binary_operator] = STATE(1379),
    [sym_unary_operator] = STATE(1379),
    [sym_attribute] = STATE(1379),
    [sym_subscript] = STATE(1379),
    [sym_call] = STATE(1379),
    [sym_generator_expression] = STATE(1379),
    [sym_parenthesized_expression] = STATE(1379),
    [sym_list_splat_pattern] = STATE(1347),
    [sym_primary_expression] = STATE(1029),
    [sym_list] = STATE(1379),
    [sym_set] = STATE(1379),
    [sym_tuple] = STATE(1379),
    [sym_dictionary] = STATE(1379),
    [sym_list_comprehension] = STATE(1379),
    [sym_dictionary_comprehension] = STATE(1379),
    [sym_set_comprehension] = STATE(1379),
    [sym_concatenated_string] = STATE(1379),
    [sym_python_string] = STATE(1003),
    [sym_await] = STATE(1379),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_print] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(633),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(639),
    [anon_sym_await] = ACTIONS(641),
    [anon_sym_match] = ACTIONS(633),
    [anon_sym_type] = ACTIONS(643),
    [sym_integer] = ACTIONS(645),
    [sym_float] = ACTIONS(645),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_none] = ACTIONS(645),
    [sym_python_identifier] = ACTIONS(645),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(647),
  },
  [108] = {
    [sym_binary_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [sym_attribute] = STATE(971),
    [sym_subscript] = STATE(971),
    [sym_call] = STATE(971),
    [sym_generator_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_list_splat_pattern] = STATE(989),
    [sym_primary_expression] = STATE(984),
    [sym_list] = STATE(971),
    [sym_set] = STATE(971),
    [sym_tuple] = STATE(971),
    [sym_dictionary] = STATE(971),
    [sym_list_comprehension] = STATE(971),
    [sym_dictionary_comprehension] = STATE(971),
    [sym_set_comprehension] = STATE(971),
    [sym_concatenated_string] = STATE(971),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(971),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_from] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(516),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(518),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(522),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(301),
    [sym_string_start] = ACTIONS(113),
  },
  [109] = {
    [sym_binary_operator] = STATE(1222),
    [sym_unary_operator] = STATE(1222),
    [sym_attribute] = STATE(1222),
    [sym_subscript] = STATE(1222),
    [sym_call] = STATE(1222),
    [sym_generator_expression] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_list_splat_pattern] = STATE(1193),
    [sym_primary_expression] = STATE(977),
    [sym_list] = STATE(1222),
    [sym_set] = STATE(1222),
    [sym_tuple] = STATE(1222),
    [sym_dictionary] = STATE(1222),
    [sym_list_comprehension] = STATE(1222),
    [sym_dictionary_comprehension] = STATE(1222),
    [sym_set_comprehension] = STATE(1222),
    [sym_concatenated_string] = STATE(1222),
    [sym_python_string] = STATE(850),
    [sym_await] = STATE(1222),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(579),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_print] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(591),
    [anon_sym_await] = ACTIONS(593),
    [anon_sym_match] = ACTIONS(585),
    [anon_sym_type] = ACTIONS(595),
    [sym_integer] = ACTIONS(597),
    [sym_float] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_none] = ACTIONS(597),
    [sym_python_identifier] = ACTIONS(597),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(599),
  },
  [110] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_from] = ACTIONS(461),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(463),
    [sym_string_start] = ACTIONS(490),
  },
  [111] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_AT_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(463),
    [sym_string_start] = ACTIONS(490),
  },
  [112] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [113] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [114] = {
    [sym_binary_operator] = STATE(1222),
    [sym_unary_operator] = STATE(1222),
    [sym_attribute] = STATE(1222),
    [sym_subscript] = STATE(1222),
    [sym_call] = STATE(1222),
    [sym_generator_expression] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_list_splat_pattern] = STATE(1193),
    [sym_primary_expression] = STATE(977),
    [sym_list] = STATE(1222),
    [sym_set] = STATE(1222),
    [sym_tuple] = STATE(1222),
    [sym_dictionary] = STATE(1222),
    [sym_list_comprehension] = STATE(1222),
    [sym_dictionary_comprehension] = STATE(1222),
    [sym_set_comprehension] = STATE(1222),
    [sym_concatenated_string] = STATE(1222),
    [sym_python_string] = STATE(850),
    [sym_await] = STATE(1222),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_LPAREN] = ACTIONS(579),
    [anon_sym_RPAREN] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(524),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_print] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(524),
    [anon_sym_EQ_EQ] = ACTIONS(524),
    [anon_sym_BANG_EQ] = ACTIONS(524),
    [anon_sym_GT_EQ] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(524),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(591),
    [anon_sym_await] = ACTIONS(593),
    [anon_sym_match] = ACTIONS(585),
    [anon_sym_type] = ACTIONS(595),
    [sym_integer] = ACTIONS(597),
    [sym_float] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_none] = ACTIONS(597),
    [sym_python_identifier] = ACTIONS(597),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(599),
  },
  [115] = {
    [sym_binary_operator] = STATE(1379),
    [sym_unary_operator] = STATE(1379),
    [sym_attribute] = STATE(1379),
    [sym_subscript] = STATE(1379),
    [sym_call] = STATE(1379),
    [sym_generator_expression] = STATE(1379),
    [sym_parenthesized_expression] = STATE(1379),
    [sym_list_splat_pattern] = STATE(1347),
    [sym_primary_expression] = STATE(1029),
    [sym_list] = STATE(1379),
    [sym_set] = STATE(1379),
    [sym_tuple] = STATE(1379),
    [sym_dictionary] = STATE(1379),
    [sym_list_comprehension] = STATE(1379),
    [sym_dictionary_comprehension] = STATE(1379),
    [sym_set_comprehension] = STATE(1379),
    [sym_concatenated_string] = STATE(1379),
    [sym_python_string] = STATE(1003),
    [sym_await] = STATE(1379),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_print] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(633),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(639),
    [anon_sym_await] = ACTIONS(641),
    [anon_sym_match] = ACTIONS(633),
    [anon_sym_type] = ACTIONS(643),
    [sym_integer] = ACTIONS(645),
    [sym_float] = ACTIONS(645),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_none] = ACTIONS(645),
    [sym_python_identifier] = ACTIONS(645),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(647),
  },
  [116] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [117] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1118),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(655),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [118] = {
    [sym_binary_operator] = STATE(1379),
    [sym_unary_operator] = STATE(1379),
    [sym_attribute] = STATE(1379),
    [sym_subscript] = STATE(1379),
    [sym_call] = STATE(1379),
    [sym_generator_expression] = STATE(1379),
    [sym_parenthesized_expression] = STATE(1379),
    [sym_list_splat_pattern] = STATE(1347),
    [sym_primary_expression] = STATE(1029),
    [sym_list] = STATE(1379),
    [sym_set] = STATE(1379),
    [sym_tuple] = STATE(1379),
    [sym_dictionary] = STATE(1379),
    [sym_list_comprehension] = STATE(1379),
    [sym_dictionary_comprehension] = STATE(1379),
    [sym_set_comprehension] = STATE(1379),
    [sym_concatenated_string] = STATE(1379),
    [sym_python_string] = STATE(1003),
    [sym_await] = STATE(1379),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(524),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_print] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(633),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(524),
    [anon_sym_EQ_EQ] = ACTIONS(524),
    [anon_sym_BANG_EQ] = ACTIONS(524),
    [anon_sym_GT_EQ] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(524),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(639),
    [anon_sym_await] = ACTIONS(641),
    [anon_sym_match] = ACTIONS(633),
    [anon_sym_type] = ACTIONS(643),
    [sym_integer] = ACTIONS(645),
    [sym_float] = ACTIONS(645),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_none] = ACTIONS(645),
    [sym_python_identifier] = ACTIONS(645),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(647),
  },
  [119] = {
    [sym_binary_operator] = STATE(1223),
    [sym_unary_operator] = STATE(1223),
    [sym_attribute] = STATE(1223),
    [sym_subscript] = STATE(1223),
    [sym_call] = STATE(1223),
    [sym_generator_expression] = STATE(1223),
    [sym_parenthesized_expression] = STATE(1223),
    [sym_list_splat_pattern] = STATE(1172),
    [sym_primary_expression] = STATE(916),
    [sym_list] = STATE(1223),
    [sym_set] = STATE(1223),
    [sym_tuple] = STATE(1223),
    [sym_dictionary] = STATE(1223),
    [sym_list_comprehension] = STATE(1223),
    [sym_dictionary_comprehension] = STATE(1223),
    [sym_set_comprehension] = STATE(1223),
    [sym_concatenated_string] = STATE(1223),
    [sym_python_string] = STATE(851),
    [sym_await] = STATE(1223),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_print] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(567),
    [anon_sym_await] = ACTIONS(569),
    [anon_sym_match] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(571),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_none] = ACTIONS(573),
    [sym_python_identifier] = ACTIONS(573),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(571),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(575),
  },
  [120] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [121] = {
    [sym_binary_operator] = STATE(1283),
    [sym_unary_operator] = STATE(1283),
    [sym_attribute] = STATE(1283),
    [sym_subscript] = STATE(1283),
    [sym_call] = STATE(1283),
    [sym_generator_expression] = STATE(1283),
    [sym_parenthesized_expression] = STATE(1283),
    [sym_list_splat_pattern] = STATE(1163),
    [sym_primary_expression] = STATE(955),
    [sym_list] = STATE(1283),
    [sym_set] = STATE(1283),
    [sym_tuple] = STATE(1283),
    [sym_dictionary] = STATE(1283),
    [sym_list_comprehension] = STATE(1283),
    [sym_dictionary_comprehension] = STATE(1283),
    [sym_set_comprehension] = STATE(1283),
    [sym_concatenated_string] = STATE(1283),
    [sym_python_string] = STATE(857),
    [sym_await] = STATE(1283),
    [anon_sym_LBRACK] = ACTIONS(601),
    [anon_sym_RBRACK] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_print] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(609),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(609),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(615),
    [anon_sym_await] = ACTIONS(617),
    [anon_sym_match] = ACTIONS(609),
    [anon_sym_type] = ACTIONS(619),
    [sym_integer] = ACTIONS(621),
    [sym_float] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_none] = ACTIONS(621),
    [sym_python_identifier] = ACTIONS(621),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(623),
  },
  [122] = {
    [sym_binary_operator] = STATE(1026),
    [sym_unary_operator] = STATE(1026),
    [sym_attribute] = STATE(1026),
    [sym_subscript] = STATE(1026),
    [sym_call] = STATE(1026),
    [sym_generator_expression] = STATE(1026),
    [sym_parenthesized_expression] = STATE(1026),
    [sym_list_splat_pattern] = STATE(1028),
    [sym_primary_expression] = STATE(873),
    [sym_list] = STATE(1026),
    [sym_set] = STATE(1026),
    [sym_tuple] = STATE(1026),
    [sym_dictionary] = STATE(1026),
    [sym_list_comprehension] = STATE(1026),
    [sym_dictionary_comprehension] = STATE(1026),
    [sym_set_comprehension] = STATE(1026),
    [sym_concatenated_string] = STATE(1026),
    [sym_python_string] = STATE(841),
    [sym_await] = STATE(1026),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(524),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(524),
    [anon_sym_EQ_EQ] = ACTIONS(524),
    [anon_sym_BANG_EQ] = ACTIONS(524),
    [anon_sym_GT_EQ] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(524),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [123] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(290),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(290),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(290),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [124] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_AT_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [125] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1341),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_else] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(663),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [126] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1341),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_as] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(303),
    [anon_sym_else] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(301),
    [anon_sym_SLASH_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_CARET] = ACTIONS(301),
    [anon_sym_LT_LT] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_LT_GT] = ACTIONS(301),
    [anon_sym_is] = ACTIONS(303),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(663),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [127] = {
    [sym_binary_operator] = STATE(1266),
    [sym_unary_operator] = STATE(1266),
    [sym_attribute] = STATE(1266),
    [sym_subscript] = STATE(1266),
    [sym_call] = STATE(1266),
    [sym_generator_expression] = STATE(1266),
    [sym_parenthesized_expression] = STATE(1266),
    [sym_list_splat_pattern] = STATE(1260),
    [sym_primary_expression] = STATE(1475),
    [sym_list] = STATE(1266),
    [sym_set] = STATE(1266),
    [sym_tuple] = STATE(1266),
    [sym_dictionary] = STATE(1266),
    [sym_list_comprehension] = STATE(1266),
    [sym_dictionary_comprehension] = STATE(1266),
    [sym_set_comprehension] = STATE(1266),
    [sym_concatenated_string] = STATE(1266),
    [sym_python_string] = STATE(868),
    [sym_await] = STATE(1266),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_else] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_line_continuation] = ACTIONS(3),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 33,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(669), 1,
      anon_sym_RPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1552), 1,
      sym_expression,
    STATE(2169), 1,
      sym_pattern,
    STATE(2201), 1,
      sym_yield,
    STATE(2388), 1,
      sym__patterns,
    STATE(2400), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [131] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_RBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1571), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2418), 1,
      sym__collection_elements,
    STATE(2536), 1,
      sym__patterns,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [260] = 30,
    ACTIONS(39), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LPAREN,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      anon_sym_STAR,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(95), 1,
      anon_sym_yield,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(99), 1,
      anon_sym_await,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(107), 1,
      sym_python_identifier,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    STATE(566), 1,
      sym_list_splat_pattern,
    STATE(834), 1,
      sym_python_string,
    STATE(846), 1,
      sym_primary_expression,
    STATE(1494), 1,
      sym_pattern,
    STATE(1498), 1,
      sym_pattern_list,
    STATE(1701), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(550), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(101), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(2329), 5,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
      sym_expression_list,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [385] = 33,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(709), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1557), 1,
      sym_expression,
    STATE(2169), 1,
      sym_pattern,
    STATE(2221), 1,
      sym_yield,
    STATE(2388), 1,
      sym__patterns,
    STATE(2415), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [516] = 32,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(713), 1,
      anon_sym_RBRACE,
    ACTIONS(715), 1,
      anon_sym_COMMA,
    ACTIONS(717), 1,
      anon_sym_STAR,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1532), 1,
      sym_expression,
    STATE(1746), 1,
      sym_pair,
    STATE(2010), 1,
      sym_dictionary_splat,
    STATE(2350), 1,
      sym__collection_elements,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2101), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [645] = 32,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(717), 1,
      anon_sym_STAR,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(735), 1,
      anon_sym_RBRACE,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1537), 1,
      sym_expression,
    STATE(1765), 1,
      sym_pair,
    STATE(2057), 1,
      sym_dictionary_splat,
    STATE(2454), 1,
      sym__named_expression_lhs,
    STATE(2551), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2101), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [774] = 33,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(739), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1552), 1,
      sym_expression,
    STATE(2169), 1,
      sym_pattern,
    STATE(2201), 1,
      sym_yield,
    STATE(2388), 1,
      sym__patterns,
    STATE(2400), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [905] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(741), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1571), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2382), 1,
      sym__patterns,
    STATE(2418), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1034] = 33,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(743), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1557), 1,
      sym_expression,
    STATE(2169), 1,
      sym_pattern,
    STATE(2221), 1,
      sym_yield,
    STATE(2415), 1,
      sym__collection_elements,
    STATE(2432), 1,
      sym__patterns,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1165] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(745), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1571), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2418), 1,
      sym__collection_elements,
    STATE(2466), 1,
      sym__patterns,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1294] = 30,
    ACTIONS(39), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LPAREN,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      anon_sym_STAR,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(95), 1,
      anon_sym_yield,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(99), 1,
      anon_sym_await,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(107), 1,
      sym_python_identifier,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    STATE(566), 1,
      sym_list_splat_pattern,
    STATE(834), 1,
      sym_python_string,
    STATE(846), 1,
      sym_primary_expression,
    STATE(1494), 1,
      sym_pattern,
    STATE(1498), 1,
      sym_pattern_list,
    STATE(1701), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(550), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(101), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(2272), 5,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
      sym_expression_list,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1419] = 33,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(747), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1557), 1,
      sym_expression,
    STATE(2169), 1,
      sym_pattern,
    STATE(2221), 1,
      sym_yield,
    STATE(2415), 1,
      sym__collection_elements,
    STATE(2475), 1,
      sym__patterns,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1550] = 32,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(717), 1,
      anon_sym_STAR,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(749), 1,
      anon_sym_RBRACE,
    ACTIONS(751), 1,
      anon_sym_COMMA,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1531), 1,
      sym_expression,
    STATE(1761), 1,
      sym_pair,
    STATE(2076), 1,
      sym_dictionary_splat,
    STATE(2378), 1,
      sym__collection_elements,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2101), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1679] = 30,
    ACTIONS(39), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LPAREN,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      anon_sym_STAR,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(95), 1,
      anon_sym_yield,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(99), 1,
      anon_sym_await,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(107), 1,
      sym_python_identifier,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    STATE(566), 1,
      sym_list_splat_pattern,
    STATE(834), 1,
      sym_python_string,
    STATE(846), 1,
      sym_primary_expression,
    STATE(1494), 1,
      sym_pattern,
    STATE(1498), 1,
      sym_pattern_list,
    STATE(1701), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(550), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(101), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(2328), 5,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
      sym_expression_list,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1804] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(753), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1573), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2466), 1,
      sym__patterns,
    STATE(2555), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1933] = 32,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(717), 1,
      anon_sym_STAR,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(755), 1,
      anon_sym_RBRACE,
    ACTIONS(757), 1,
      anon_sym_COMMA,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1534), 1,
      sym_expression,
    STATE(1738), 1,
      sym_pair,
    STATE(2083), 1,
      sym_dictionary_splat,
    STATE(2454), 1,
      sym__named_expression_lhs,
    STATE(2483), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2101), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2062] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(759), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1575), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2490), 1,
      sym__collection_elements,
    STATE(2536), 1,
      sym__patterns,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2191] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(761), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1545), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2382), 1,
      sym__patterns,
    STATE(2398), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2320] = 33,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(763), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1557), 1,
      sym_expression,
    STATE(2169), 1,
      sym_pattern,
    STATE(2221), 1,
      sym_yield,
    STATE(2415), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    STATE(2539), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2451] = 32,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(717), 1,
      anon_sym_STAR,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(765), 1,
      anon_sym_RBRACE,
    ACTIONS(767), 1,
      anon_sym_COMMA,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1535), 1,
      sym_expression,
    STATE(1754), 1,
      sym_pair,
    STATE(2081), 1,
      sym_dictionary_splat,
    STATE(2454), 1,
      sym__named_expression_lhs,
    STATE(2484), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2101), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2580] = 32,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(717), 1,
      anon_sym_STAR,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(769), 1,
      anon_sym_RBRACE,
    ACTIONS(771), 1,
      anon_sym_COMMA,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1528), 1,
      sym_expression,
    STATE(1773), 1,
      sym_pair,
    STATE(2210), 1,
      sym_dictionary_splat,
    STATE(2411), 1,
      sym__collection_elements,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2101), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2709] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(773), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1571), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2418), 1,
      sym__collection_elements,
    STATE(2429), 1,
      sym__patterns,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2838] = 33,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(775), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1559), 1,
      sym_expression,
    STATE(2079), 1,
      sym_yield,
    STATE(2169), 1,
      sym_pattern,
    STATE(2388), 1,
      sym__patterns,
    STATE(2486), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2969] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(777), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1576), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2382), 1,
      sym__patterns,
    STATE(2488), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3098] = 34,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(779), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1567), 1,
      sym_expression,
    STATE(2051), 1,
      sym_list_splat,
    STATE(2052), 1,
      sym_parenthesized_list_splat,
    STATE(2078), 1,
      sym_yield,
    STATE(2169), 1,
      sym_pattern,
    STATE(2489), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    STATE(2539), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3231] = 34,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(781), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1547), 1,
      sym_expression,
    STATE(2061), 1,
      sym_yield,
    STATE(2169), 1,
      sym_pattern,
    STATE(2198), 1,
      sym_parenthesized_list_splat,
    STATE(2203), 1,
      sym_list_splat,
    STATE(2475), 1,
      sym__patterns,
    STATE(2497), 1,
      sym__named_expression_lhs,
    STATE(2554), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3364] = 33,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(783), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1557), 1,
      sym_expression,
    STATE(2169), 1,
      sym_pattern,
    STATE(2221), 1,
      sym_yield,
    STATE(2390), 1,
      sym__patterns,
    STATE(2415), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3495] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(785), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1545), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2382), 1,
      sym__patterns,
    STATE(2398), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3624] = 32,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(717), 1,
      anon_sym_STAR,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(787), 1,
      anon_sym_RBRACE,
    ACTIONS(789), 1,
      anon_sym_COMMA,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1533), 1,
      sym_expression,
    STATE(1772), 1,
      sym_pair,
    STATE(2204), 1,
      sym_dictionary_splat,
    STATE(2403), 1,
      sym__collection_elements,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2101), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3753] = 33,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(791), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1217), 1,
      sym_list_splat_pattern,
    STATE(1557), 1,
      sym_expression,
    STATE(2169), 1,
      sym_pattern,
    STATE(2221), 1,
      sym_yield,
    STATE(2388), 1,
      sym__patterns,
    STATE(2415), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1221), 2,
      sym_attribute,
      sym_subscript,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3884] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(793), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1571), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2365), 1,
      sym__patterns,
    STATE(2418), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4013] = 32,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(717), 1,
      anon_sym_STAR,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(795), 1,
      anon_sym_RBRACE,
    ACTIONS(797), 1,
      anon_sym_COMMA,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1527), 1,
      sym_expression,
    STATE(1757), 1,
      sym_pair,
    STATE(2166), 1,
      sym_dictionary_splat,
    STATE(2441), 1,
      sym__collection_elements,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2101), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4142] = 32,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(799), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1571), 1,
      sym_expression,
    STATE(2156), 1,
      sym_pattern,
    STATE(2382), 1,
      sym__patterns,
    STATE(2418), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1269), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4271] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      anon_sym_TILDE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(803), 1,
      anon_sym_LBRACK,
    ACTIONS(805), 1,
      anon_sym_LPAREN,
    ACTIONS(807), 1,
      anon_sym_STAR,
    ACTIONS(811), 1,
      anon_sym_await,
    ACTIONS(813), 1,
      anon_sym_type,
    ACTIONS(815), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1167), 1,
      sym_list_splat_pattern,
    STATE(1443), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1158), 2,
      sym_attribute,
      sym_subscript,
    STATE(1454), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(809), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
    ACTIONS(801), 17,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4381] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      anon_sym_TILDE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(803), 1,
      anon_sym_LBRACK,
    ACTIONS(805), 1,
      anon_sym_LPAREN,
    ACTIONS(807), 1,
      anon_sym_STAR,
    ACTIONS(811), 1,
      anon_sym_await,
    ACTIONS(813), 1,
      anon_sym_type,
    ACTIONS(815), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1167), 1,
      sym_list_splat_pattern,
    STATE(1443), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1158), 2,
      sym_attribute,
      sym_subscript,
    STATE(1454), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(809), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
    ACTIONS(817), 17,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4491] = 29,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(819), 1,
      anon_sym_LBRACK,
    ACTIONS(821), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(831), 1,
      anon_sym_await,
    ACTIONS(833), 1,
      anon_sym_type,
    ACTIONS(835), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1054), 1,
      sym_list_splat_pattern,
    STATE(1602), 1,
      sym_expression,
    STATE(2246), 1,
      sym_pattern,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1053), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    STATE(1946), 4,
      sym_pattern_list,
      sym_yield,
      sym_expression_list,
      sym__f_expression,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4612] = 29,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(819), 1,
      anon_sym_LBRACK,
    ACTIONS(821), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(831), 1,
      anon_sym_await,
    ACTIONS(833), 1,
      anon_sym_type,
    ACTIONS(835), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1054), 1,
      sym_list_splat_pattern,
    STATE(1602), 1,
      sym_expression,
    STATE(2246), 1,
      sym_pattern,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1053), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    STATE(1917), 4,
      sym_pattern_list,
      sym_yield,
      sym_expression_list,
      sym__f_expression,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4733] = 27,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(839), 1,
      anon_sym_STAR_STAR,
    ACTIONS(841), 1,
      sym_python_identifier,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1586), 1,
      sym_expression,
    STATE(1834), 1,
      sym_type,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1799), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4849] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(845), 1,
      anon_sym_RPAREN,
    ACTIONS(847), 1,
      anon_sym_COMMA,
    ACTIONS(849), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(855), 1,
      anon_sym_await,
    ACTIONS(857), 1,
      anon_sym_type,
    ACTIONS(859), 1,
      sym_python_identifier,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1572), 1,
      sym_expression,
    STATE(2105), 1,
      sym_parenthesized_list_splat,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2106), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(851), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4969] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(861), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(867), 1,
      anon_sym_STAR_STAR,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(875), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_expression,
    STATE(1856), 1,
      sym_type,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1925), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5085] = 27,
    ACTIONS(274), 1,
      anon_sym_STAR_STAR,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(877), 1,
      anon_sym_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(889), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1654), 1,
      sym_expression,
    STATE(2054), 1,
      sym_type,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1908), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5201] = 27,
    ACTIONS(274), 1,
      anon_sym_STAR_STAR,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(877), 1,
      anon_sym_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(889), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1654), 1,
      sym_expression,
    STATE(1934), 1,
      sym_type,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1908), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5317] = 27,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(893), 1,
      anon_sym_from,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1603), 1,
      sym_expression,
    STATE(1947), 1,
      sym_expression_list,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(891), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5433] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(849), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(855), 1,
      anon_sym_await,
    ACTIONS(857), 1,
      anon_sym_type,
    ACTIONS(859), 1,
      sym_python_identifier,
    ACTIONS(903), 1,
      anon_sym_RPAREN,
    ACTIONS(905), 1,
      anon_sym_COMMA,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1554), 1,
      sym_expression,
    STATE(2165), 1,
      sym_parenthesized_list_splat,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2164), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(851), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5553] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      anon_sym_TILDE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(907), 1,
      anon_sym_LBRACK,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(911), 1,
      anon_sym_STAR,
    ACTIONS(915), 1,
      anon_sym_await,
    ACTIONS(917), 1,
      anon_sym_type,
    ACTIONS(919), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1384), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1394), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(913), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
    ACTIONS(801), 15,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5661] = 27,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(921), 1,
      anon_sym_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(935), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1578), 1,
      sym_expression,
    STATE(1928), 1,
      sym_type,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1809), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5777] = 27,
    ACTIONS(274), 1,
      anon_sym_STAR_STAR,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(877), 1,
      anon_sym_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(889), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1654), 1,
      sym_expression,
    STATE(1921), 1,
      sym_type,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1908), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5893] = 27,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(921), 1,
      anon_sym_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(935), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1578), 1,
      sym_expression,
    STATE(1805), 1,
      sym_type,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1809), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6009] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(849), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(855), 1,
      anon_sym_await,
    ACTIONS(857), 1,
      anon_sym_type,
    ACTIONS(859), 1,
      sym_python_identifier,
    ACTIONS(937), 1,
      anon_sym_RPAREN,
    ACTIONS(939), 1,
      anon_sym_COMMA,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1560), 1,
      sym_expression,
    STATE(2042), 1,
      sym_parenthesized_list_splat,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2007), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(851), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6129] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(849), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(855), 1,
      anon_sym_await,
    ACTIONS(857), 1,
      anon_sym_type,
    ACTIONS(859), 1,
      sym_python_identifier,
    ACTIONS(941), 1,
      anon_sym_RPAREN,
    ACTIONS(943), 1,
      anon_sym_COMMA,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1548), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2036), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(851), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6249] = 27,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(921), 1,
      anon_sym_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(935), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1578), 1,
      sym_expression,
    STATE(1781), 1,
      sym_type,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1809), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6365] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(849), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(855), 1,
      anon_sym_await,
    ACTIONS(857), 1,
      anon_sym_type,
    ACTIONS(859), 1,
      sym_python_identifier,
    ACTIONS(945), 1,
      anon_sym_RPAREN,
    ACTIONS(947), 1,
      anon_sym_COMMA,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1564), 1,
      sym_expression,
    STATE(2059), 1,
      sym_parenthesized_list_splat,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2055), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(851), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6485] = 27,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(839), 1,
      anon_sym_STAR_STAR,
    ACTIONS(841), 1,
      sym_python_identifier,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1586), 1,
      sym_expression,
    STATE(1836), 1,
      sym_type,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1799), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6601] = 27,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(839), 1,
      anon_sym_STAR_STAR,
    ACTIONS(841), 1,
      sym_python_identifier,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1586), 1,
      sym_expression,
    STATE(1784), 1,
      sym_type,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1799), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6717] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(861), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(867), 1,
      anon_sym_STAR_STAR,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(875), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_expression,
    STATE(1894), 1,
      sym_type,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1925), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6833] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(861), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(867), 1,
      anon_sym_STAR_STAR,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(875), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_expression,
    STATE(1790), 1,
      sym_type,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1925), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6949] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(849), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(855), 1,
      anon_sym_await,
    ACTIONS(857), 1,
      anon_sym_type,
    ACTIONS(859), 1,
      sym_python_identifier,
    ACTIONS(949), 1,
      anon_sym_RPAREN,
    ACTIONS(951), 1,
      anon_sym_COMMA,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1538), 1,
      sym_expression,
    STATE(2185), 1,
      sym_parenthesized_list_splat,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2186), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(851), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7069] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(849), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(855), 1,
      anon_sym_await,
    ACTIONS(857), 1,
      anon_sym_type,
    ACTIONS(859), 1,
      sym_python_identifier,
    ACTIONS(953), 1,
      anon_sym_RPAREN,
    ACTIONS(955), 1,
      anon_sym_COMMA,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1565), 1,
      sym_expression,
    STATE(2215), 1,
      sym_parenthesized_list_splat,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2208), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(851), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7189] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(861), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(867), 1,
      anon_sym_STAR_STAR,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(875), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_expression,
    STATE(1906), 1,
      sym_type,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1925), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7305] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(861), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(867), 1,
      anon_sym_STAR_STAR,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(875), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_expression,
    STATE(1780), 1,
      sym_type,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1925), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7421] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(861), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(867), 1,
      anon_sym_STAR_STAR,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(875), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_expression,
    STATE(1857), 1,
      sym_type,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1925), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7537] = 27,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(921), 1,
      anon_sym_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(935), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1578), 1,
      sym_expression,
    STATE(1783), 1,
      sym_type,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1809), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7653] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(861), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(867), 1,
      anon_sym_STAR_STAR,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(875), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_expression,
    STATE(1950), 1,
      sym_type,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1925), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7769] = 30,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(957), 1,
      anon_sym_RPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1550), 1,
      sym_expression,
    STATE(2019), 1,
      sym_with_item,
    STATE(2221), 1,
      sym_yield,
    STATE(2415), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7891] = 27,
    ACTIONS(274), 1,
      anon_sym_STAR_STAR,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(877), 1,
      anon_sym_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(889), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1654), 1,
      sym_expression,
    STATE(2058), 1,
      sym_type,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1908), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8007] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(849), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(855), 1,
      anon_sym_await,
    ACTIONS(857), 1,
      anon_sym_type,
    ACTIONS(859), 1,
      sym_python_identifier,
    ACTIONS(967), 1,
      anon_sym_RPAREN,
    ACTIONS(969), 1,
      anon_sym_COMMA,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1556), 1,
      sym_expression,
    STATE(2065), 1,
      sym_parenthesized_list_splat,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2070), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(851), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8127] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      anon_sym_TILDE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(907), 1,
      anon_sym_LBRACK,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(911), 1,
      anon_sym_STAR,
    ACTIONS(915), 1,
      anon_sym_await,
    ACTIONS(917), 1,
      anon_sym_type,
    ACTIONS(919), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1384), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1394), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(913), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
    ACTIONS(817), 15,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8235] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(973), 1,
      anon_sym_RPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8352] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(985), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8469] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(987), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8586] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(989), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8703] = 28,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(991), 1,
      anon_sym_RBRACK,
    ACTIONS(993), 1,
      anon_sym_LPAREN,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1571), 1,
      sym_expression,
    STATE(2418), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8820] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1003), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8937] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1005), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1562), 1,
      sym_expression,
    STATE(2012), 1,
      sym_yield,
    STATE(2347), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9056] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1007), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9173] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1009), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9290] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1011), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9407] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1013), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9524] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1015), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9641] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1017), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9758] = 30,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1005), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1562), 1,
      sym_expression,
    STATE(2012), 1,
      sym_yield,
    STATE(2051), 1,
      sym_list_splat,
    STATE(2052), 1,
      sym_parenthesized_list_splat,
    STATE(2347), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9879] = 30,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1019), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1544), 1,
      sym_expression,
    STATE(2090), 1,
      sym_yield,
    STATE(2198), 1,
      sym_parenthesized_list_splat,
    STATE(2203), 1,
      sym_list_splat,
    STATE(2380), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10000] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1021), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10117] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1023), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1547), 1,
      sym_expression,
    STATE(2061), 1,
      sym_yield,
    STATE(2497), 1,
      sym__named_expression_lhs,
    STATE(2554), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10236] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1025), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10353] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1027), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10470] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1029), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10587] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1031), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10704] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1033), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10821] = 28,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(993), 1,
      anon_sym_LPAREN,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1035), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1576), 1,
      sym_expression,
    STATE(2488), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10938] = 28,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(993), 1,
      anon_sym_LPAREN,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1037), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1553), 1,
      sym_expression,
    STATE(2453), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11055] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1039), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1559), 1,
      sym_expression,
    STATE(2079), 1,
      sym_yield,
    STATE(2486), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11174] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1041), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11291] = 28,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(993), 1,
      anon_sym_LPAREN,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1043), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1577), 1,
      sym_expression,
    STATE(2381), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11408] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1567), 1,
      sym_expression,
    STATE(2078), 1,
      sym_yield,
    STATE(2489), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11527] = 30,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1039), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1559), 1,
      sym_expression,
    STATE(2079), 1,
      sym_yield,
    STATE(2091), 1,
      sym_parenthesized_list_splat,
    STATE(2092), 1,
      sym_list_splat,
    STATE(2486), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11648] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1047), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11765] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1049), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11882] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1051), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11999] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1053), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12116] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1055), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12233] = 30,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1023), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1547), 1,
      sym_expression,
    STATE(2061), 1,
      sym_yield,
    STATE(2198), 1,
      sym_parenthesized_list_splat,
    STATE(2203), 1,
      sym_list_splat,
    STATE(2497), 1,
      sym__named_expression_lhs,
    STATE(2554), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12354] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1057), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1552), 1,
      sym_expression,
    STATE(2201), 1,
      sym_yield,
    STATE(2400), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12473] = 28,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(993), 1,
      anon_sym_LPAREN,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1059), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1545), 1,
      sym_expression,
    STATE(2398), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12590] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1061), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12707] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1063), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12824] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1065), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12941] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1067), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13058] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(957), 1,
      anon_sym_RPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1557), 1,
      sym_expression,
    STATE(2221), 1,
      sym_yield,
    STATE(2415), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13177] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1069), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13294] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1071), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13411] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1073), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2161), 1,
      sym_yield,
    STATE(2452), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13530] = 30,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1073), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2091), 1,
      sym_parenthesized_list_splat,
    STATE(2092), 1,
      sym_list_splat,
    STATE(2161), 1,
      sym_yield,
    STATE(2452), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13651] = 28,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(993), 1,
      anon_sym_LPAREN,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1075), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1575), 1,
      sym_expression,
    STATE(2490), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13768] = 29,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1019), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1544), 1,
      sym_expression,
    STATE(2090), 1,
      sym_yield,
    STATE(2380), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2133), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13887] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1077), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14004] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1079), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14121] = 28,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    ACTIONS(1081), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14238] = 30,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1567), 1,
      sym_expression,
    STATE(2051), 1,
      sym_list_splat,
    STATE(2052), 1,
      sym_parenthesized_list_splat,
    STATE(2078), 1,
      sym_yield,
    STATE(2489), 1,
      sym__collection_elements,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14359] = 28,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(993), 1,
      anon_sym_LPAREN,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1083), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1568), 1,
      sym_expression,
    STATE(2345), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14476] = 28,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(993), 1,
      anon_sym_LPAREN,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1085), 1,
      anon_sym_RBRACK,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1573), 1,
      sym_expression,
    STATE(2555), 1,
      sym__collection_elements,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2077), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14593] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(290), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(301), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14693] = 27,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1087), 1,
      anon_sym_RPAREN,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1876), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1091), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14807] = 27,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_await,
    ACTIONS(981), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2290), 1,
      sym_parenthesized_list_splat,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2291), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(977), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14921] = 27,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1087), 1,
      anon_sym_RBRACE,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_lambda,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1889), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(719), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1091), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15035] = 27,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    ACTIONS(1099), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1876), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1101), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15149] = 27,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    ACTIONS(1103), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1876), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1105), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15263] = 27,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    ACTIONS(1107), 1,
      anon_sym_RPAREN,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1876), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1109), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15377] = 27,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(1111), 1,
      anon_sym_RPAREN,
    ACTIONS(1113), 1,
      anon_sym_STAR,
    ACTIONS(1115), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1817), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2245), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15491] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1117), 1,
      anon_sym_RBRACK,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    ACTIONS(1121), 1,
      anon_sym_STAR,
    ACTIONS(1123), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1844), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2274), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15605] = 27,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(1113), 1,
      anon_sym_STAR,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1817), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2245), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15719] = 27,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    ACTIONS(1117), 1,
      anon_sym_RBRACE,
    ACTIONS(1125), 1,
      anon_sym_LPAREN,
    ACTIONS(1127), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1810), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2289), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15833] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      anon_sym_RBRACK,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    ACTIONS(1121), 1,
      anon_sym_STAR,
    ACTIONS(1123), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1844), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2274), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15947] = 27,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_lambda,
    ACTIONS(1107), 1,
      anon_sym_RBRACE,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1889), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(719), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1109), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16061] = 25,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1647), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1129), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16171] = 27,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    ACTIONS(1111), 1,
      anon_sym_RBRACE,
    ACTIONS(1125), 1,
      anon_sym_LPAREN,
    ACTIONS(1127), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1810), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2289), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16285] = 25,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1647), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1131), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16395] = 27,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1087), 1,
      anon_sym_RBRACK,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1135), 1,
      anon_sym_lambda,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1730), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1888), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(995), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1091), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16509] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(463), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(524), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16609] = 27,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1107), 1,
      anon_sym_RBRACK,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1135), 1,
      anon_sym_lambda,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1730), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1888), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(995), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1109), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16723] = 27,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1103), 1,
      anon_sym_RBRACK,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1135), 1,
      anon_sym_lambda,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1730), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1888), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(995), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1105), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16837] = 27,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_lambda,
    ACTIONS(1103), 1,
      anon_sym_RBRACE,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1889), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(719), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1105), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16951] = 27,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_lambda,
    ACTIONS(1099), 1,
      anon_sym_RBRACE,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1889), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(719), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1101), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17065] = 27,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1099), 1,
      anon_sym_RBRACK,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1135), 1,
      anon_sym_lambda,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1730), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1888), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(995), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1101), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17179] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    ACTIONS(1139), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17292] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1141), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17405] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1143), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17518] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1145), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17631] = 26,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(1113), 1,
      anon_sym_STAR,
    ACTIONS(1115), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1817), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2245), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17742] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1147), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17855] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1149), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17968] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1151), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18081] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1153), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18194] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1155), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18307] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18420] = 26,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(727), 1,
      anon_sym_yield,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    ACTIONS(1125), 1,
      anon_sym_LPAREN,
    ACTIONS(1127), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1810), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2289), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18531] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1159), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18644] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1161), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18757] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1163), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18870] = 27,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_from,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1673), 1,
      sym_expression,
    STATE(2312), 1,
      sym_expression_list,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(891), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18983] = 27,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1169), 1,
      anon_sym_from,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1747), 1,
      sym_expression,
    STATE(2259), 1,
      sym_expression_list,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(891), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19096] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1173), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19209] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1175), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19322] = 27,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1179), 1,
      anon_sym_from,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1645), 1,
      sym_expression,
    STATE(2159), 1,
      sym_expression_list,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1177), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19435] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1189), 1,
      anon_sym_from,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1774), 1,
      sym_expression,
    STATE(2231), 1,
      sym_expression_list,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(891), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19548] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    ACTIONS(1121), 1,
      anon_sym_STAR,
    ACTIONS(1123), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1844), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2274), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19659] = 27,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_RBRACE,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19772] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1195), 1,
      anon_sym_RBRACK,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19884] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1199), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19996] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1201), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20108] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(463), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(301), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20206] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1203), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20318] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1205), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20430] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1207), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20542] = 26,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(723), 1,
      anon_sym_STAR_STAR,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2266), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20652] = 26,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1705), 1,
      sym_expression,
    STATE(2249), 1,
      sym_expression_list,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1209), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20762] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1211), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20874] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1213), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20986] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1215), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21098] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1217), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21210] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1219), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21322] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1221), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21434] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1225), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1750), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1223), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21544] = 26,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    ACTIONS(1227), 1,
      anon_sym_from,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1698), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1131), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21654] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1229), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21766] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1231), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21878] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1233), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21990] = 26,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    ACTIONS(1235), 1,
      anon_sym_from,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1698), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1129), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22100] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1237), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22212] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1239), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22324] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1241), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22436] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1243), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22548] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(1245), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(301), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22646] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1247), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22758] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1249), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22870] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1251), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22982] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1253), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23094] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1255), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23206] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1257), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23318] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1259), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23430] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1261), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23542] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1263), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23654] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1265), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23766] = 27,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1267), 1,
      anon_sym_RBRACK,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23878] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1271), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1764), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1269), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23988] = 25,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1129), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24095] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1666), 1,
      sym_expression,
    STATE(2062), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24204] = 26,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1776), 1,
      sym_expression,
    STATE(2064), 1,
      sym_with_item,
    STATE(2446), 1,
      sym__named_expression_lhs,
    STATE(2532), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24313] = 25,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1277), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24420] = 25,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_lambda,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1679), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1899), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24527] = 25,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1802), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1279), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24634] = 25,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1739), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1281), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24741] = 25,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1876), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24848] = 25,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1283), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24955] = 26,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1776), 1,
      sym_expression,
    STATE(2064), 1,
      sym_with_item,
    STATE(2446), 1,
      sym__named_expression_lhs,
    STATE(2548), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25064] = 25,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1687), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1869), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25171] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1658), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25280] = 25,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_lambda,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1683), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1884), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25387] = 25,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1739), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1285), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25494] = 25,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_lambda,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1853), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25601] = 26,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    ACTIONS(1287), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2273), 1,
      sym_with_item,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25710] = 25,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1135), 1,
      anon_sym_lambda,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1730), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1888), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25817] = 25,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1131), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25924] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1717), 1,
      sym_expression,
    STATE(2182), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26033] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(303), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(301), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26130] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(463), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(524), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26227] = 26,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_COLON,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1776), 1,
      sym_expression,
    STATE(2282), 1,
      sym_with_item,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26336] = 25,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1737), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1878), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26443] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(303), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(301), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26540] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(463), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(524), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26637] = 25,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1778), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26744] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(1245), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(301), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26841] = 21,
    ACTIONS(286), 1,
      anon_sym_in,
    ACTIONS(290), 1,
      anon_sym_COMMA,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(301), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26940] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1704), 1,
      sym_expression,
    STATE(2080), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27049] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1731), 1,
      sym_expression,
    STATE(2170), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27158] = 25,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1777), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1129), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27265] = 25,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_lambda,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1889), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27372] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1678), 1,
      sym_expression,
    STATE(2102), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27481] = 25,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1813), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1291), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27588] = 25,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1789), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1129), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27695] = 25,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_lambda,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1840), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27802] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(463), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(301), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27899] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1681), 1,
      sym_expression,
    STATE(2060), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28008] = 25,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1837), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28115] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1726), 1,
      sym_expression,
    STATE(2218), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28224] = 25,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1838), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1223), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28331] = 25,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1135), 1,
      anon_sym_lambda,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1684), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1877), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28438] = 25,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1135), 1,
      anon_sym_lambda,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1730), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1825), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28545] = 25,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1739), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1293), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28652] = 21,
    ACTIONS(461), 1,
      anon_sym_in,
    ACTIONS(463), 1,
      anon_sym_COMMA,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(524), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28751] = 25,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1739), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1295), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28858] = 25,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1135), 1,
      anon_sym_lambda,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1730), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1807), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28965] = 26,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    ACTIONS(1297), 1,
      anon_sym_COLON,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1776), 1,
      sym_expression,
    STATE(2282), 1,
      sym_with_item,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29074] = 25,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1789), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1131), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29181] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1690), 1,
      sym_expression,
    STATE(2152), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29290] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2275), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29399] = 26,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    ACTIONS(1299), 1,
      anon_sym_RPAREN,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2273), 1,
      sym_with_item,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29508] = 25,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1135), 1,
      anon_sym_lambda,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1680), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1890), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29615] = 25,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1777), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1131), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29722] = 26,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1675), 1,
      sym_expression,
    STATE(2098), 1,
      sym_slice,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29831] = 25,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1700), 1,
      sym_expression,
    STATE(2253), 1,
      sym_expression_list,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29937] = 25,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      anon_sym_COLON,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1827), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30043] = 25,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1752), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    STATE(2526), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30149] = 25,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1776), 1,
      sym_expression,
    STATE(2282), 1,
      sym_with_item,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30255] = 25,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1129), 1,
      anon_sym_COLON,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1827), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30361] = 25,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    ACTIONS(1301), 1,
      anon_sym_COLON,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1849), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30467] = 25,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1745), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    STATE(2575), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30573] = 25,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2273), 1,
      sym_with_item,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30679] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30782] = 24,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1695), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30885] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1608), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30988] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1610), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31091] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1558), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31194] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1698), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31297] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1614), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31400] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1918), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31503] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1945), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31606] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1593), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31709] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1924), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31812] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1922), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31915] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1615), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32018] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1901), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32121] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1875), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32224] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1551), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32327] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1952), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32430] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1831), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32533] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1832), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32636] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1739), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32739] = 25,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_await,
    ACTIONS(1315), 1,
      anon_sym_type,
    ACTIONS(1317), 1,
      sym_python_identifier,
    STATE(1003), 1,
      sym_python_string,
    STATE(1065), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1791), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1243), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32844] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32947] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1779), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33050] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1766), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33153] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1647), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33256] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1955), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33359] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1625), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33462] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1648), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33565] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1607), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33668] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1873), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33771] = 25,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    ACTIONS(1321), 1,
      anon_sym_await,
    ACTIONS(1323), 1,
      anon_sym_type,
    ACTIONS(1325), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1846), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1388), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1319), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33876] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1785), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33979] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1626), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34082] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1862), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34185] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1657), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34288] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1871), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34391] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1606), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34494] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1914), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34597] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1903), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34700] = 25,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    ACTIONS(1329), 1,
      anon_sym_await,
    ACTIONS(1331), 1,
      anon_sym_type,
    ACTIONS(1333), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_python_string,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1846), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1254), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1327), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34805] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1649), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34908] = 24,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1742), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35011] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1895), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35114] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1621), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35217] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1827), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35320] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1620), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35423] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1619), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35526] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1623), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35629] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1919), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35732] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1638), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35835] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1936), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35938] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1641), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36041] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1954), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36144] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1651), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36247] = 24,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1732), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36350] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1613), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36453] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1634), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36556] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36659] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1819), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36762] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1880), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36865] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1806), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36968] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1639), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37071] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1896), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37174] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1640), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37277] = 24,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1770), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37380] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1642), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37483] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1777), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37586] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1615), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37689] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1643), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37792] = 24,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1727), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37895] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37998] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1811), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38101] = 24,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1699), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38204] = 24,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1686), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38307] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1650), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38410] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1644), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38513] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1561), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38616] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1543), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38719] = 10,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(1335), 1,
      sym_python_identifier,
    ACTIONS(1337), 1,
      sym_string_start,
    STATE(2153), 1,
      sym_python_string,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(301), 10,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(303), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [38794] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1546), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38897] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1828), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39000] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1706), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39103] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1652), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39206] = 24,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1724), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39309] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1913), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39412] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1526), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39515] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1789), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39618] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1530), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39721] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1755), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39824] = 25,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(1341), 1,
      anon_sym_await,
    ACTIONS(1343), 1,
      anon_sym_type,
    ACTIONS(1345), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1034), 1,
      sym_primary_expression,
    STATE(1787), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1127), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1339), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39929] = 24,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1723), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40032] = 24,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1722), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40135] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40238] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1841), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40341] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1845), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40444] = 24,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1721), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40547] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1796), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40650] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1630), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40753] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1631), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40856] = 11,
    ACTIONS(286), 1,
      anon_sym_EQ,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(295), 1,
      anon_sym_COLON,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(1335), 1,
      sym_python_identifier,
    ACTIONS(1337), 1,
      sym_string_start,
    STATE(2153), 1,
      sym_python_string,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(301), 10,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(303), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [40933] = 24,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1720), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41036] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1632), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41139] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1633), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41242] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1622), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41345] = 25,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(1349), 1,
      anon_sym_await,
    ACTIONS(1351), 1,
      anon_sym_type,
    ACTIONS(1353), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1389), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1347), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41450] = 25,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1357), 1,
      anon_sym_await,
    ACTIONS(1359), 1,
      anon_sym_type,
    ACTIONS(1361), 1,
      sym_python_identifier,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1791), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1383), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1355), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41555] = 24,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1716), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41658] = 19,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(301), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41751] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1581), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41854] = 19,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(524), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41947] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1944), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42050] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1920), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42153] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1814), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42256] = 24,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1691), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42359] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1574), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42462] = 24,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1693), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42565] = 24,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    STATE(1709), 1,
      sym_expression,
    STATE(2497), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1736), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42668] = 24,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1694), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42771] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1897), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42874] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42977] = 24,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(897), 1,
      anon_sym_await,
    ACTIONS(899), 1,
      anon_sym_type,
    ACTIONS(901), 1,
      sym_python_identifier,
    STATE(841), 1,
      sym_python_string,
    STATE(844), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    STATE(1636), 1,
      sym_expression,
    STATE(2525), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1624), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43080] = 24,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(925), 1,
      anon_sym_not,
    ACTIONS(929), 1,
      anon_sym_lambda,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    STATE(1587), 1,
      sym_expression,
    STATE(2383), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(923), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1611), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43183] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1665), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43286] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1669), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43389] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1613), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43492] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(881), 1,
      anon_sym_not,
    ACTIONS(883), 1,
      anon_sym_lambda,
    ACTIONS(885), 1,
      anon_sym_await,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(922), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1824), 1,
      sym_expression,
    STATE(2446), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43595] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1668), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43698] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1667), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43801] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1530), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43904] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1664), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44007] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1663), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44110] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1900), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44213] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1660), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44316] = 24,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(997), 1,
      anon_sym_await,
    ACTIONS(999), 1,
      anon_sym_type,
    ACTIONS(1001), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(858), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2557), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(995), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1685), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44419] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1788), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44522] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1183), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_lambda,
    ACTIONS(1187), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(877), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1526), 1,
      sym_expression,
    STATE(2469), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44625] = 24,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(545), 1,
      sym_identifier,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(721), 1,
      anon_sym_not,
    ACTIONS(725), 1,
      anon_sym_lambda,
    ACTIONS(729), 1,
      anon_sym_await,
    ACTIONS(731), 1,
      anon_sym_type,
    ACTIONS(733), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(839), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    STATE(1734), 1,
      sym_expression,
    STATE(2454), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(719), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1655), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44728] = 24,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(321), 1,
      anon_sym_await,
    ACTIONS(323), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(840), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2396), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1529), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44831] = 24,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(887), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_not,
    ACTIONS(1307), 1,
      anon_sym_lambda,
    ACTIONS(1309), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1192), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1923), 1,
      sym_expression,
    STATE(2361), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(879), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1601), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44934] = 24,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(865), 1,
      anon_sym_not,
    ACTIONS(869), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_await,
    ACTIONS(873), 1,
      anon_sym_type,
    ACTIONS(1123), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1003), 1,
      sym_python_string,
    STATE(1347), 1,
      sym_list_splat_pattern,
    STATE(1635), 1,
      sym_expression,
    STATE(2419), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(863), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1637), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [45037] = 9,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(1363), 1,
      anon_sym_for,
    ACTIONS(1365), 1,
      anon_sym_with,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(303), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45109] = 9,
    ACTIONS(1371), 1,
      anon_sym_else,
    ACTIONS(1373), 1,
      anon_sym_except_STAR,
    ACTIONS(1375), 1,
      anon_sym_finally,
    STATE(624), 1,
      sym_else_clause,
    STATE(675), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(559), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1367), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1369), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [45180] = 9,
    ACTIONS(1371), 1,
      anon_sym_else,
    ACTIONS(1375), 1,
      anon_sym_finally,
    ACTIONS(1377), 1,
      anon_sym_except,
    STATE(624), 1,
      sym_else_clause,
    STATE(675), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(560), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1367), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1369), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [45251] = 9,
    ACTIONS(1371), 1,
      anon_sym_else,
    ACTIONS(1373), 1,
      anon_sym_except_STAR,
    ACTIONS(1375), 1,
      anon_sym_finally,
    STATE(608), 1,
      sym_else_clause,
    STATE(676), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(559), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1379), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1381), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [45322] = 9,
    ACTIONS(1371), 1,
      anon_sym_else,
    ACTIONS(1375), 1,
      anon_sym_finally,
    ACTIONS(1377), 1,
      anon_sym_except,
    STATE(608), 1,
      sym_else_clause,
    STATE(676), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(560), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1379), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1381), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [45393] = 10,
    ACTIONS(1383), 1,
      anon_sym_EQ,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1389), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_COLON,
    ACTIONS(1396), 1,
      anon_sym_COMMA,
    STATE(1885), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1399), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 16,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45466] = 8,
    ACTIONS(286), 1,
      anon_sym_EQ,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(295), 1,
      anon_sym_COLON,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(303), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45534] = 7,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(303), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45600] = 7,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(303), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45666] = 7,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1396), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1383), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1387), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1399), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45732] = 8,
    ACTIONS(286), 1,
      anon_sym_EQ,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(295), 1,
      anon_sym_COLON,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(303), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45800] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1401), 1,
      anon_sym_LBRACK,
    ACTIONS(1403), 1,
      anon_sym_LPAREN,
    ACTIONS(1405), 1,
      anon_sym_STAR,
    ACTIONS(1409), 1,
      anon_sym_await,
    ACTIONS(1411), 1,
      anon_sym_type,
    ACTIONS(1413), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1406), 1,
      sym_list_splat_pattern,
    STATE(1446), 1,
      sym_primary_expression,
    STATE(1882), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1407), 2,
      sym_attribute,
      sym_subscript,
    STATE(1907), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(801), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1407), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [45897] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1417), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45954] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46011] = 6,
    ACTIONS(1383), 1,
      anon_sym_EQ,
    ACTIONS(1396), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 14,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1399), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46074] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46131] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46188] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 29,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46249] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1401), 1,
      anon_sym_LBRACK,
    ACTIONS(1403), 1,
      anon_sym_LPAREN,
    ACTIONS(1405), 1,
      anon_sym_STAR,
    ACTIONS(1409), 1,
      anon_sym_await,
    ACTIONS(1411), 1,
      anon_sym_type,
    ACTIONS(1413), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1406), 1,
      sym_list_splat_pattern,
    STATE(1446), 1,
      sym_primary_expression,
    STATE(1882), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1407), 2,
      sym_attribute,
      sym_subscript,
    STATE(1907), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(817), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1407), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [46346] = 8,
    ACTIONS(1431), 1,
      anon_sym_elif,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(573), 1,
      aux_sym_if_statement_repeat1,
    STATE(600), 1,
      sym_elif_clause,
    STATE(665), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1427), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1429), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [46413] = 8,
    ACTIONS(1431), 1,
      anon_sym_elif,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(574), 1,
      aux_sym_if_statement_repeat1,
    STATE(600), 1,
      sym_elif_clause,
    STATE(674), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1435), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1437), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [46480] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46537] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 29,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46598] = 5,
    ACTIONS(1443), 1,
      anon_sym_except_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(559), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1439), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1441), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [46659] = 5,
    ACTIONS(1450), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(560), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1446), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1448), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [46720] = 7,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1457), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(1460), 2,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(1453), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1462), 12,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 28,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46785] = 6,
    ACTIONS(1383), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1396), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1387), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1399), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46848] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1453), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1462), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 29,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46909] = 6,
    ACTIONS(1383), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1387), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1472), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46972] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47029] = 6,
    ACTIONS(1383), 1,
      anon_sym_EQ,
    ACTIONS(1469), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 14,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1472), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [47092] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1480), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47149] = 6,
    ACTIONS(1482), 1,
      anon_sym_EQ,
    ACTIONS(1488), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1484), 14,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1491), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [47212] = 6,
    ACTIONS(1493), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1499), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1495), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1502), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [47275] = 6,
    ACTIONS(1482), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1488), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1484), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1491), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [47338] = 6,
    ACTIONS(1493), 1,
      anon_sym_EQ,
    ACTIONS(1499), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1495), 14,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1502), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [47401] = 8,
    ACTIONS(1431), 1,
      anon_sym_elif,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(556), 1,
      aux_sym_if_statement_repeat1,
    STATE(600), 1,
      sym_elif_clause,
    STATE(650), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1504), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1506), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47468] = 8,
    ACTIONS(1431), 1,
      anon_sym_elif,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(574), 1,
      aux_sym_if_statement_repeat1,
    STATE(600), 1,
      sym_elif_clause,
    STATE(653), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1508), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1510), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47535] = 6,
    ACTIONS(1516), 1,
      anon_sym_elif,
    STATE(574), 1,
      aux_sym_if_statement_repeat1,
    STATE(600), 1,
      sym_elif_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1512), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1514), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47597] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1519), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1521), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47652] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1523), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1525), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47707] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47762] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1531), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1533), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47817] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1535), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1537), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47872] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1539), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1541), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47927] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1543), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1545), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47982] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1531), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1533), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48037] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1535), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1537), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48092] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1547), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1549), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48147] = 24,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1551), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_LPAREN,
    ACTIONS(1555), 1,
      anon_sym_RPAREN,
    ACTIONS(1557), 1,
      anon_sym_STAR,
    ACTIONS(1561), 1,
      anon_sym_await,
    ACTIONS(1563), 1,
      anon_sym_type,
    ACTIONS(1565), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1467), 1,
      sym_primary_expression,
    STATE(1471), 1,
      sym_list_splat_pattern,
    STATE(2169), 1,
      sym_pattern,
    STATE(2539), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1460), 2,
      sym_attribute,
      sym_subscript,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1559), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [48244] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1567), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1569), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48299] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1539), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1541), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48354] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1571), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1573), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48409] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1575), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1577), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48464] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1579), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1581), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48519] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1583), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1585), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48574] = 24,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1551), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_LPAREN,
    ACTIONS(1557), 1,
      anon_sym_STAR,
    ACTIONS(1561), 1,
      anon_sym_await,
    ACTIONS(1563), 1,
      anon_sym_type,
    ACTIONS(1565), 1,
      sym_python_identifier,
    ACTIONS(1587), 1,
      anon_sym_RPAREN,
    STATE(868), 1,
      sym_python_string,
    STATE(1467), 1,
      sym_primary_expression,
    STATE(1471), 1,
      sym_list_splat_pattern,
    STATE(2169), 1,
      sym_pattern,
    STATE(2388), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1460), 2,
      sym_attribute,
      sym_subscript,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1559), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [48671] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1575), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1577), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48726] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1527), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48781] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1589), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1591), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48836] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1593), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1595), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48891] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1535), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1537), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48945] = 5,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(654), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1597), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1599), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49003] = 5,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(669), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1601), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1603), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49061] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1605), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1607), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49115] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1575), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1577), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49169] = 5,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(671), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1609), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1611), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49227] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1531), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1533), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49281] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(2011), 1,
      sym_pattern,
    STATE(2464), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49375] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1627), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1629), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49429] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1631), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1633), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49483] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    ACTIONS(1635), 1,
      anon_sym_in,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49577] = 5,
    ACTIONS(1375), 1,
      anon_sym_finally,
    STATE(673), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1637), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1639), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49635] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(2067), 1,
      sym_pattern,
    STATE(2498), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49729] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(2056), 1,
      sym_pattern,
    STATE(2506), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49823] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1641), 1,
      anon_sym_LBRACK,
    ACTIONS(1643), 1,
      anon_sym_RBRACK,
    ACTIONS(1645), 1,
      anon_sym_LPAREN,
    ACTIONS(1647), 1,
      anon_sym_STAR,
    ACTIONS(1651), 1,
      anon_sym_await,
    ACTIONS(1653), 1,
      anon_sym_type,
    ACTIONS(1655), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1452), 1,
      sym_primary_expression,
    STATE(1455), 1,
      sym_list_splat_pattern,
    STATE(2319), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1456), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1649), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49917] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(2125), 1,
      sym_pattern,
    STATE(2451), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50011] = 5,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(666), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1657), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1659), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50069] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(2028), 1,
      sym_pattern,
    STATE(2531), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50163] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(2124), 1,
      sym_pattern,
    STATE(2386), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50257] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1551), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_LPAREN,
    ACTIONS(1557), 1,
      anon_sym_STAR,
    ACTIONS(1561), 1,
      anon_sym_await,
    ACTIONS(1563), 1,
      anon_sym_type,
    ACTIONS(1565), 1,
      sym_python_identifier,
    ACTIONS(1661), 1,
      anon_sym_RPAREN,
    STATE(868), 1,
      sym_python_string,
    STATE(1467), 1,
      sym_primary_expression,
    STATE(1471), 1,
      sym_list_splat_pattern,
    STATE(2235), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1460), 2,
      sym_attribute,
      sym_subscript,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1559), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50351] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(2048), 1,
      sym_pattern,
    STATE(2509), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50445] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50499] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    ACTIONS(1663), 1,
      anon_sym_in,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50593] = 5,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(652), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1665), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1667), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50651] = 5,
    ACTIONS(1433), 1,
      anon_sym_else,
    STATE(670), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1669), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1671), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50709] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(2016), 1,
      sym_pattern,
    STATE(2528), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50803] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1551), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_LPAREN,
    ACTIONS(1557), 1,
      anon_sym_STAR,
    ACTIONS(1561), 1,
      anon_sym_await,
    ACTIONS(1563), 1,
      anon_sym_type,
    ACTIONS(1565), 1,
      sym_python_identifier,
    ACTIONS(1643), 1,
      anon_sym_RPAREN,
    STATE(868), 1,
      sym_python_string,
    STATE(1467), 1,
      sym_primary_expression,
    STATE(1471), 1,
      sym_list_splat_pattern,
    STATE(2235), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1460), 2,
      sym_attribute,
      sym_subscript,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1559), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50897] = 5,
    ACTIONS(1375), 1,
      anon_sym_finally,
    STATE(667), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1673), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1675), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50955] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1539), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1541), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51009] = 23,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1641), 1,
      anon_sym_LBRACK,
    ACTIONS(1645), 1,
      anon_sym_LPAREN,
    ACTIONS(1647), 1,
      anon_sym_STAR,
    ACTIONS(1651), 1,
      anon_sym_await,
    ACTIONS(1653), 1,
      anon_sym_type,
    ACTIONS(1655), 1,
      sym_python_identifier,
    ACTIONS(1661), 1,
      anon_sym_RBRACK,
    STATE(868), 1,
      sym_python_string,
    STATE(1452), 1,
      sym_primary_expression,
    STATE(1455), 1,
      sym_list_splat_pattern,
    STATE(2319), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1456), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1649), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [51103] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1531), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1533), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51156] = 22,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1401), 1,
      anon_sym_LBRACK,
    ACTIONS(1403), 1,
      anon_sym_LPAREN,
    ACTIONS(1405), 1,
      anon_sym_STAR,
    ACTIONS(1409), 1,
      anon_sym_await,
    ACTIONS(1411), 1,
      anon_sym_type,
    ACTIONS(1413), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1406), 1,
      sym_list_splat_pattern,
    STATE(1446), 1,
      sym_primary_expression,
    STATE(1882), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1407), 2,
      sym_attribute,
      sym_subscript,
    STATE(1907), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1407), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [51247] = 22,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1613), 1,
      anon_sym_LBRACK,
    ACTIONS(1615), 1,
      anon_sym_LPAREN,
    ACTIONS(1617), 1,
      anon_sym_STAR,
    ACTIONS(1621), 1,
      anon_sym_await,
    ACTIONS(1623), 1,
      anon_sym_type,
    ACTIONS(1625), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1466), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1619), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [51338] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1539), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1541), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51391] = 22,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(803), 1,
      anon_sym_LBRACK,
    ACTIONS(805), 1,
      anon_sym_LPAREN,
    ACTIONS(811), 1,
      anon_sym_await,
    ACTIONS(813), 1,
      anon_sym_type,
    ACTIONS(815), 1,
      sym_python_identifier,
    ACTIONS(1677), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1167), 1,
      sym_list_splat_pattern,
    STATE(1443), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1158), 2,
      sym_attribute,
      sym_subscript,
    STATE(1454), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(809), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [51482] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1679), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1681), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51535] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1535), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1537), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51588] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1575), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1577), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51641] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1683), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1685), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51694] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1531), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1533), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51747] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51800] = 22,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(907), 1,
      anon_sym_LBRACK,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(915), 1,
      anon_sym_await,
    ACTIONS(917), 1,
      anon_sym_type,
    ACTIONS(919), 1,
      sym_python_identifier,
    ACTIONS(1687), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1384), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1394), 2,
      sym_attribute,
      sym_subscript,
    STATE(1491), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(913), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [51891] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1575), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1577), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51944] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1535), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1537), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51997] = 22,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1551), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_LPAREN,
    ACTIONS(1557), 1,
      anon_sym_STAR,
    ACTIONS(1561), 1,
      anon_sym_await,
    ACTIONS(1563), 1,
      anon_sym_type,
    ACTIONS(1565), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1467), 1,
      sym_primary_expression,
    STATE(1471), 1,
      sym_list_splat_pattern,
    STATE(2235), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1460), 2,
      sym_attribute,
      sym_subscript,
    STATE(2261), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1559), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [52088] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1539), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1541), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52141] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52194] = 22,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1641), 1,
      anon_sym_LBRACK,
    ACTIONS(1645), 1,
      anon_sym_LPAREN,
    ACTIONS(1647), 1,
      anon_sym_STAR,
    ACTIONS(1651), 1,
      anon_sym_await,
    ACTIONS(1653), 1,
      anon_sym_type,
    ACTIONS(1655), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1452), 1,
      sym_primary_expression,
    STATE(1455), 1,
      sym_list_splat_pattern,
    STATE(2319), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1456), 2,
      sym_attribute,
      sym_subscript,
    STATE(2284), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1649), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [52285] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1689), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1691), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52337] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1575), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1577), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52389] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1693), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1695), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52441] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1679), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1681), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52493] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1697), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1699), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52545] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1701), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1703), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52597] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1379), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1381), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52649] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1705), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1707), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52701] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1709), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1711), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52753] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1713), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1715), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52805] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1717), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1719), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52857] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1531), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1533), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52909] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1721), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1723), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52961] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53013] = 21,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1731), 1,
      anon_sym_await,
    ACTIONS(1733), 1,
      anon_sym_type,
    ACTIONS(1735), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1725), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(1469), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1729), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [53101] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1737), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1739), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53153] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1683), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1685), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53205] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1741), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1743), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53257] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1745), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1747), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53309] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1535), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1537), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53361] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1749), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1751), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53413] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1753), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1755), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53465] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1757), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1759), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53517] = 21,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1763), 1,
      anon_sym_await,
    ACTIONS(1765), 1,
      anon_sym_type,
    ACTIONS(1767), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1467), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1725), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1426), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1761), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [53605] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1769), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1771), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53657] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1773), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1775), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53709] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1777), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1779), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53761] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1781), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1783), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53813] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1785), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1787), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53865] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1789), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1791), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53917] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1673), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1675), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53969] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1637), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1639), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [54021] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1793), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1795), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [54073] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1367), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1369), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [54125] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1539), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1541), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [54177] = 18,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    ACTIONS(1797), 1,
      anon_sym_not,
    STATE(1003), 1,
      sym_python_string,
    STATE(1051), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54258] = 18,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    ACTIONS(1799), 1,
      anon_sym_not,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1336), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54339] = 18,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1801), 1,
      anon_sym_not,
    STATE(851), 1,
      sym_python_string,
    STATE(959), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54420] = 18,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    ACTIONS(1803), 1,
      anon_sym_not,
    STATE(834), 1,
      sym_python_string,
    STATE(951), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54501] = 18,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    ACTIONS(1805), 1,
      anon_sym_not,
    STATE(868), 1,
      sym_python_string,
    STATE(1014), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54582] = 18,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    ACTIONS(1807), 1,
      anon_sym_not,
    STATE(850), 1,
      sym_python_string,
    STATE(940), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54663] = 18,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(1809), 1,
      anon_sym_not,
    STATE(841), 1,
      sym_python_string,
    STATE(878), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54744] = 18,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    ACTIONS(1811), 1,
      anon_sym_not,
    STATE(834), 1,
      sym_python_string,
    STATE(890), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54825] = 18,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      anon_sym_not,
    STATE(857), 1,
      sym_python_string,
    STATE(913), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54906] = 18,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    ACTIONS(1815), 1,
      anon_sym_not,
    STATE(838), 1,
      sym_python_string,
    STATE(847), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54987] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1009), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55065] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(880), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55143] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(889), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55221] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1819), 1,
      anon_sym_await,
    ACTIONS(1821), 1,
      anon_sym_type,
    ACTIONS(1823), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1446), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1044), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55305] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(942), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55383] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1827), 1,
      anon_sym_await,
    ACTIONS(1829), 1,
      anon_sym_type,
    ACTIONS(1831), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1255), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55467] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(947), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55545] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1835), 1,
      anon_sym_await,
    ACTIONS(1837), 1,
      anon_sym_type,
    ACTIONS(1839), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1441), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(991), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1833), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55629] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1843), 1,
      anon_sym_await,
    ACTIONS(1845), 1,
      anon_sym_type,
    ACTIONS(1847), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1452), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1327), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1841), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55713] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(897), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55791] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1851), 1,
      anon_sym_await,
    ACTIONS(1853), 1,
      anon_sym_type,
    ACTIONS(1855), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1443), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(563), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1849), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55875] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(949), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55953] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(900), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56031] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(935), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56109] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1859), 1,
      anon_sym_await,
    ACTIONS(1861), 1,
      anon_sym_type,
    ACTIONS(1863), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1451), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1293), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56193] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1867), 1,
      anon_sym_await,
    ACTIONS(1869), 1,
      anon_sym_type,
    ACTIONS(1871), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1390), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1865), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56277] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(948), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56355] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1835), 1,
      anon_sym_await,
    ACTIONS(1837), 1,
      anon_sym_type,
    ACTIONS(1873), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1441), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(991), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1833), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56439] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1837), 1,
      anon_sym_type,
    ACTIONS(1873), 1,
      sym_python_identifier,
    ACTIONS(1875), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1441), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(991), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1833), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56523] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1008), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56601] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1006), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56679] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(937), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56757] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1005), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56835] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1004), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56913] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(898), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56991] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(1002), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57069] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(901), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57147] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57225] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(956), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57303] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(957), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57381] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(959), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57459] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(951), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57537] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(953), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57615] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1829), 1,
      anon_sym_type,
    ACTIONS(1831), 1,
      sym_python_identifier,
    ACTIONS(1877), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1255), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57699] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(930), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57777] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(918), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57855] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(960), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57933] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(854), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58011] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(962), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58089] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1039), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58167] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1023), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58245] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(963), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58323] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(965), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58401] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1829), 1,
      anon_sym_type,
    ACTIONS(1831), 1,
      sym_python_identifier,
    ACTIONS(1879), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1255), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58485] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(958), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58563] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(966), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58641] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1845), 1,
      anon_sym_type,
    ACTIONS(1881), 1,
      anon_sym_await,
    ACTIONS(1883), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1459), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1327), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1841), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58725] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1887), 1,
      anon_sym_await,
    ACTIONS(1889), 1,
      anon_sym_type,
    ACTIONS(1891), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1477), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1885), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58809] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(520), 1,
      anon_sym_DASH,
    ACTIONS(522), 1,
      anon_sym_await,
    ACTIONS(1181), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(989), 1,
      sym_list_splat_pattern,
    STATE(996), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(518), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58887] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1025), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58965] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59043] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1119), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59121] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1853), 1,
      anon_sym_type,
    ACTIONS(1855), 1,
      sym_python_identifier,
    ACTIONS(1893), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1443), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(563), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1849), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59205] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(964), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59283] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1897), 1,
      anon_sym_await,
    ACTIONS(1899), 1,
      anon_sym_type,
    ACTIONS(1901), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1444), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1147), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59367] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1905), 1,
      anon_sym_await,
    ACTIONS(1907), 1,
      anon_sym_type,
    ACTIONS(1909), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1467), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1431), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1903), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59451] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(872), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59529] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(876), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59607] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(878), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59685] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(929), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59763] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1024), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59841] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(847), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59919] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(891), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59997] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1336), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60075] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(869), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60153] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1845), 1,
      anon_sym_type,
    ACTIONS(1847), 1,
      sym_python_identifier,
    ACTIONS(1881), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1459), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1327), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1841), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60237] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(855), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60315] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(893), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60393] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1859), 1,
      anon_sym_await,
    ACTIONS(1861), 1,
      anon_sym_type,
    ACTIONS(1911), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1451), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1293), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60477] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(894), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60555] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(895), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60633] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(896), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60711] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(919), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60789] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(925), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60867] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60945] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1358), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61023] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(936), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61101] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(860), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61179] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1829), 1,
      anon_sym_type,
    ACTIONS(1831), 1,
      sym_python_identifier,
    ACTIONS(1913), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1255), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61263] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1021), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61341] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1827), 1,
      anon_sym_await,
    ACTIONS(1829), 1,
      anon_sym_type,
    ACTIONS(1915), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1255), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61425] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1364), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61503] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(861), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61581] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(849), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61659] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1919), 1,
      anon_sym_await,
    ACTIONS(1921), 1,
      anon_sym_type,
    ACTIONS(1923), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1452), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1160), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1917), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61743] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1853), 1,
      anon_sym_type,
    ACTIONS(1893), 1,
      anon_sym_await,
    ACTIONS(1925), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1443), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(563), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1849), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61827] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(902), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61905] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1440), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61983] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(886), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62061] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1020), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62139] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1019), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62217] = 17,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(841), 1,
      sym_python_string,
    STATE(875), 1,
      sym_primary_expression,
    STATE(1028), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1026), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62295] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62373] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1439), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62451] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(882), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62529] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1120), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62607] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1123), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62685] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1124), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62763] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1438), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62841] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(888), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62919] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(881), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62997] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1437), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63075] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1436), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63153] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1051), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63231] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1929), 1,
      anon_sym_await,
    ACTIONS(1931), 1,
      anon_sym_type,
    ACTIONS(1933), 1,
      sym_python_identifier,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1467), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1164), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1927), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63315] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(867), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63393] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63471] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1463), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63549] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(890), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63627] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1328), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63705] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1329), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63783] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1125), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63861] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1346), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63939] = 17,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1191), 1,
      anon_sym_STAR,
    STATE(1003), 1,
      sym_python_string,
    STATE(1030), 1,
      sym_primary_expression,
    STATE(1347), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1379), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64017] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1442), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64095] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(879), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64173] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(851), 1,
      sym_python_string,
    STATE(988), 1,
      sym_primary_expression,
    STATE(1172), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1223), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64251] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1330), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64329] = 17,
    ACTIONS(527), 1,
      anon_sym_LBRACK,
    ACTIONS(529), 1,
      anon_sym_LPAREN,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_DASH,
    ACTIONS(541), 1,
      sym_ellipsis,
    ACTIONS(543), 1,
      anon_sym_await,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(1095), 1,
      anon_sym_STAR,
    STATE(838), 1,
      sym_python_string,
    STATE(865), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(545), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(535), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(547), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1140), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64407] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      anon_sym_type,
    ACTIONS(1823), 1,
      sym_python_identifier,
    ACTIONS(1935), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1446), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1044), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64491] = 17,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1167), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(871), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(971), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64569] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1013), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64647] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(940), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64725] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1132), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64803] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1137), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64881] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(928), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64959] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1359), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65037] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1325), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65115] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1365), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65193] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1303), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1367), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65271] = 17,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1171), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_python_string,
    STATE(915), 1,
      sym_primary_expression,
    STATE(1193), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1222), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65349] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1014), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65427] = 20,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1727), 1,
      anon_sym_STAR,
    ACTIONS(1861), 1,
      anon_sym_type,
    ACTIONS(1863), 1,
      sym_python_identifier,
    ACTIONS(1937), 1,
      anon_sym_await,
    STATE(868), 1,
      sym_python_string,
    STATE(1260), 1,
      sym_list_splat_pattern,
    STATE(1467), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1293), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1266), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65511] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1142), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65589] = 17,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1275), 1,
      anon_sym_STAR,
    STATE(868), 1,
      sym_python_string,
    STATE(1148), 1,
      sym_primary_expression,
    STATE(1260), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1266), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65667] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(914), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65745] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(912), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65823] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(913), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65901] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(920), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65979] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(921), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [66057] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(905), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [66135] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(909), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [66213] = 17,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1133), 1,
      anon_sym_STAR,
    STATE(857), 1,
      sym_python_string,
    STATE(910), 1,
      sym_primary_expression,
    STATE(1163), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1283), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [66291] = 5,
    ACTIONS(1943), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(833), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66343] = 5,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(835), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1399), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66395] = 5,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(833), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66447] = 5,
    ACTIONS(1950), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(836), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66498] = 5,
    ACTIONS(1953), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(837), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [66549] = 5,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(842), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66600] = 20,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1964), 1,
      anon_sym_as,
    ACTIONS(1972), 1,
      anon_sym_not,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(1982), 1,
      anon_sym_AMP,
    ACTIONS(1984), 1,
      anon_sym_CARET,
    ACTIONS(1988), 1,
      anon_sym_is,
    STATE(1419), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1966), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1968), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1986), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1976), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1970), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1958), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [66681] = 20,
    ACTIONS(1964), 1,
      anon_sym_EQ,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2002), 1,
      anon_sym_not,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2010), 1,
      anon_sym_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP,
    ACTIONS(2014), 1,
      anon_sym_CARET,
    ACTIONS(2018), 1,
      anon_sym_is,
    STATE(1403), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1998), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2004), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2016), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2000), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1958), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [66762] = 5,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(843), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1399), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [66813] = 5,
    ACTIONS(549), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(836), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66864] = 5,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(837), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [66915] = 20,
    ACTIONS(1964), 1,
      anon_sym_EQ,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2032), 1,
      anon_sym_not,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2040), 1,
      anon_sym_PIPE,
    ACTIONS(2042), 1,
      anon_sym_AMP,
    ACTIONS(2044), 1,
      anon_sym_CARET,
    ACTIONS(2048), 1,
      anon_sym_is,
    STATE(1415), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2028), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2034), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2046), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2030), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1958), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [66996] = 13,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2014), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1998), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2004), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 18,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67062] = 19,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(2002), 1,
      anon_sym_not,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2010), 1,
      anon_sym_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP,
    ACTIONS(2014), 1,
      anon_sym_CARET,
    ACTIONS(2018), 1,
      anon_sym_is,
    ACTIONS(2054), 1,
      anon_sym_LBRACK,
    ACTIONS(2056), 1,
      anon_sym_DOT,
    STATE(1403), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1998), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2004), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2016), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2000), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1958), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [67140] = 15,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(1982), 1,
      anon_sym_AMP,
    ACTIONS(1984), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1966), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1968), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1976), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2060), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2058), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67210] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 30,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67258] = 8,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67314] = 5,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(885), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1399), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67364] = 5,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(870), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67414] = 8,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67470] = 5,
    ACTIONS(2070), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(853), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67520] = 13,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1984), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1966), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1968), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1976), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 18,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67586] = 11,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1966), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1976), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 21,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67648] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 30,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67696] = 5,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(899), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67746] = 20,
    ACTIONS(1964), 1,
      anon_sym_as,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2085), 1,
      anon_sym_not,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2093), 1,
      anon_sym_PIPE,
    ACTIONS(2095), 1,
      anon_sym_AMP,
    ACTIONS(2097), 1,
      anon_sym_CARET,
    ACTIONS(2101), 1,
      anon_sym_is,
    STATE(1427), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2079), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2087), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2099), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2089), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2083), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1958), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [67826] = 8,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 26,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67882] = 8,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 26,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67938] = 8,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67994] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2103), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2105), 32,
      sym__newline,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68040] = 5,
    ACTIONS(2107), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(863), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68090] = 5,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(884), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68140] = 15,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(1982), 1,
      anon_sym_AMP,
    ACTIONS(1984), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1966), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1968), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1976), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2112), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2110), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68210] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2114), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2116), 32,
      sym__newline,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68256] = 15,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(1982), 1,
      anon_sym_AMP,
    ACTIONS(1984), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1966), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1968), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1976), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2120), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2118), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68326] = 5,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(864), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1399), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68376] = 12,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1966), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1968), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1976), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 19,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68440] = 5,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(853), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68490] = 8,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 26,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68546] = 8,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68602] = 8,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68658] = 20,
    ACTIONS(1964), 1,
      anon_sym_as,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2134), 1,
      anon_sym_not,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2142), 1,
      anon_sym_PIPE,
    ACTIONS(2144), 1,
      anon_sym_AMP,
    ACTIONS(2146), 1,
      anon_sym_CARET,
    ACTIONS(2150), 1,
      anon_sym_is,
    STATE(1423), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2128), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2130), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2136), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2148), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2138), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2132), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1958), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [68738] = 8,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68794] = 11,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2034), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 21,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68856] = 19,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2158), 1,
      anon_sym_not,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2166), 1,
      anon_sym_PIPE,
    ACTIONS(2168), 1,
      anon_sym_AMP,
    ACTIONS(2170), 1,
      anon_sym_CARET,
    ACTIONS(2174), 1,
      anon_sym_is,
    STATE(1425), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2154), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2172), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2162), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2156), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1958), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [68934] = 15,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2040), 1,
      anon_sym_PIPE,
    ACTIONS(2042), 1,
      anon_sym_AMP,
    ACTIONS(2044), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2028), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2034), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2060), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2058), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69004] = 11,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2004), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 21,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69066] = 10,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 23,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69126] = 8,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 26,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69182] = 14,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2012), 1,
      anon_sym_AMP,
    ACTIONS(2014), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1998), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2004), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69250] = 20,
    ACTIONS(1964), 1,
      anon_sym_EQ,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2188), 1,
      anon_sym_not,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2196), 1,
      anon_sym_PIPE,
    ACTIONS(2198), 1,
      anon_sym_AMP,
    ACTIONS(2200), 1,
      anon_sym_CARET,
    ACTIONS(2204), 1,
      anon_sym_is,
    STATE(1405), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2184), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2190), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2202), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2186), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1958), 7,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [69330] = 5,
    ACTIONS(2206), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(884), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69380] = 5,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(863), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69430] = 15,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2010), 1,
      anon_sym_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP,
    ACTIONS(2014), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1998), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2004), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2120), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2118), 16,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69500] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 30,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69548] = 15,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2010), 1,
      anon_sym_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP,
    ACTIONS(2014), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1998), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2004), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2112), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2110), 16,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69618] = 10,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1966), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1976), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 23,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69678] = 15,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2010), 1,
      anon_sym_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP,
    ACTIONS(2014), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1998), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2004), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2060), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2058), 16,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69748] = 10,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 23,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69808] = 5,
    ACTIONS(2209), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(892), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69858] = 8,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69914] = 14,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2042), 1,
      anon_sym_AMP,
    ACTIONS(2044), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2028), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2034), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 17,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69982] = 13,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2044), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2028), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2034), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 18,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70048] = 12,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2028), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2034), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 19,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70112] = 15,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2040), 1,
      anon_sym_PIPE,
    ACTIONS(2042), 1,
      anon_sym_AMP,
    ACTIONS(2044), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2028), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2034), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2120), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2118), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70182] = 8,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70238] = 5,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(892), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70288] = 15,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2040), 1,
      anon_sym_PIPE,
    ACTIONS(2042), 1,
      anon_sym_AMP,
    ACTIONS(2044), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2028), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2034), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2112), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2110), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70358] = 14,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_LPAREN,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1982), 1,
      anon_sym_AMP,
    ACTIONS(1984), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1966), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1968), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1114), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1976), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 17,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70426] = 12,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2008), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1998), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2004), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2006), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 19,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70490] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70537] = 6,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2212), 1,
      anon_sym_LBRACK,
    STATE(1794), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70588] = 14,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2095), 1,
      anon_sym_AMP,
    ACTIONS(2097), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2079), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2087), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2089), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 16,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70655] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70700] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70745] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1417), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70790] = 13,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2097), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2079), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2087), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2089), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 17,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70855] = 12,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2079), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2087), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2089), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 18,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70918] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1480), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70963] = 11,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2079), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2087), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2089), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 20,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71024] = 15,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2093), 1,
      anon_sym_PIPE,
    ACTIONS(2095), 1,
      anon_sym_AMP,
    ACTIONS(2097), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2079), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2087), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2089), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2058), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71093] = 8,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 25,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71148] = 15,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2196), 1,
      anon_sym_PIPE,
    ACTIONS(2198), 1,
      anon_sym_AMP,
    ACTIONS(2200), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2184), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2190), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2120), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2118), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71217] = 8,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71272] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2103), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2105), 31,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71317] = 8,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 25,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71372] = 14,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2198), 1,
      anon_sym_AMP,
    ACTIONS(2200), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2184), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2190), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 16,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71439] = 10,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2079), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2089), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 22,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71498] = 8,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 25,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71553] = 20,
    ACTIONS(1964), 1,
      anon_sym_EQ,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2226), 1,
      anon_sym_not,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2234), 1,
      anon_sym_PIPE,
    ACTIONS(2236), 1,
      anon_sym_AMP,
    ACTIONS(2238), 1,
      anon_sym_CARET,
    ACTIONS(2242), 1,
      anon_sym_is,
    STATE(1414), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2220), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2222), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2240), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2230), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1958), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2224), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [71632] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71679] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(551), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71728] = 13,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2200), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2184), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2190), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 17,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71793] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71838] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71883] = 15,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2196), 1,
      anon_sym_PIPE,
    ACTIONS(2198), 1,
      anon_sym_AMP,
    ACTIONS(2200), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2184), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2190), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2112), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2110), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71952] = 8,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72007] = 10,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 22,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72066] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72111] = 5,
    ACTIONS(2244), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(932), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72160] = 5,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2247), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72209] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(551), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72258] = 11,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2190), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 20,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72319] = 12,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2184), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2190), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 18,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72382] = 8,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 25,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72437] = 6,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(461), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72488] = 6,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(461), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72539] = 15,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2196), 1,
      anon_sym_PIPE,
    ACTIONS(2198), 1,
      anon_sym_AMP,
    ACTIONS(2200), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2184), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2190), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2058), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72608] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72655] = 15,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2166), 1,
      anon_sym_PIPE,
    ACTIONS(2168), 1,
      anon_sym_AMP,
    ACTIONS(2170), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2120), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2154), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2162), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2118), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72724] = 6,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1453), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1455), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1462), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72775] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2249), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2251), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72820] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2253), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2255), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72865] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2257), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2259), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72910] = 15,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2166), 1,
      anon_sym_PIPE,
    ACTIONS(2168), 1,
      anon_sym_AMP,
    ACTIONS(2170), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2112), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2154), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2162), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2110), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72979] = 15,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2093), 1,
      anon_sym_PIPE,
    ACTIONS(2095), 1,
      anon_sym_AMP,
    ACTIONS(2097), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2079), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2087), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2089), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2112), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2110), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73048] = 15,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2093), 1,
      anon_sym_PIPE,
    ACTIONS(2095), 1,
      anon_sym_AMP,
    ACTIONS(2097), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2079), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2087), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2089), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2120), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2118), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73117] = 5,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(932), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73166] = 15,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2166), 1,
      anon_sym_PIPE,
    ACTIONS(2168), 1,
      anon_sym_AMP,
    ACTIONS(2170), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2060), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2154), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2162), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2058), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73235] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73282] = 8,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 26,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73337] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73382] = 8,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 25,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73437] = 8,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73492] = 11,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2128), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2136), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2138), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73553] = 8,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LPAREN,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1261), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 25,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73608] = 15,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2142), 1,
      anon_sym_PIPE,
    ACTIONS(2144), 1,
      anon_sym_AMP,
    ACTIONS(2146), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2128), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2130), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2136), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2138), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2058), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73677] = 10,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2128), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2138), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73736] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2261), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2263), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73781] = 8,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73836] = 14,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2144), 1,
      anon_sym_AMP,
    ACTIONS(2146), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2128), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2130), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2136), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2138), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73903] = 8,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 25,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73958] = 13,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2146), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2128), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2130), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2136), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2138), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74023] = 12,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2128), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2130), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2136), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2138), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74086] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74133] = 6,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2265), 1,
      anon_sym_LBRACK,
    STATE(1820), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 27,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74184] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2267), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2269), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74229] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2271), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2273), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74274] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74319] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2114), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2116), 31,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74364] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74409] = 5,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1396), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74458] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2275), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2277), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74503] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74552] = 8,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 25,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74607] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74654] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74703] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2279), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2281), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74748] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2283), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2285), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74793] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2114), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2116), 31,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74838] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74887] = 8,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 26,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74942] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2287), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2289), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74987] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75032] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75081] = 15,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2142), 1,
      anon_sym_PIPE,
    ACTIONS(2144), 1,
      anon_sym_AMP,
    ACTIONS(2146), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2128), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2130), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2136), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2112), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2138), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2110), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75150] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75195] = 19,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2303), 1,
      anon_sym_not,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2311), 1,
      anon_sym_PIPE,
    ACTIONS(2313), 1,
      anon_sym_AMP,
    ACTIONS(2315), 1,
      anon_sym_CARET,
    ACTIONS(2319), 1,
      anon_sym_is,
    STATE(1417), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2299), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2305), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2317), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2301), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1958), 7,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [75272] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1453), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75321] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2103), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2105), 31,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [75366] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2321), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2323), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75411] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2325), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2327), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75456] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75501] = 8,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 26,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75556] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2329), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75601] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2333), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2335), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75646] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2337), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75691] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2341), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75736] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2345), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2347), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75781] = 11,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2162), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 21,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75842] = 5,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(950), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1399), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75891] = 10,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2162), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 23,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75950] = 8,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 26,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76005] = 14,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2168), 1,
      anon_sym_AMP,
    ACTIONS(2170), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2154), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2162), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76072] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2349), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2351), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76117] = 13,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2170), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2154), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2162), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76182] = 12,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2154), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(944), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2162), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 19,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76245] = 15,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2140), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2142), 1,
      anon_sym_PIPE,
    ACTIONS(2144), 1,
      anon_sym_AMP,
    ACTIONS(2146), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2128), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2130), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2136), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1319), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2120), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2138), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2118), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76314] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2353), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2355), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76359] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2357), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2359), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76404] = 14,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2236), 1,
      anon_sym_AMP,
    ACTIONS(2238), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2220), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2222), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2230), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76470] = 15,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2234), 1,
      anon_sym_PIPE,
    ACTIONS(2236), 1,
      anon_sym_AMP,
    ACTIONS(2238), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2220), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2222), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2230), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2058), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76538] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2103), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2105), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76582] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76628] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76674] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76720] = 12,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2299), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2305), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 18,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76782] = 13,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2315), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2299), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2305), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 17,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76846] = 14,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2313), 1,
      anon_sym_AMP,
    ACTIONS(2315), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2299), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2305), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 16,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76912] = 8,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 25,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76966] = 10,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 22,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77024] = 11,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 20,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77084] = 8,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 25,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77138] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77182] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77226] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77270] = 8,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 25,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77324] = 8,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 25,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77378] = 19,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(2188), 1,
      anon_sym_not,
    ACTIONS(2194), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2196), 1,
      anon_sym_PIPE,
    ACTIONS(2198), 1,
      anon_sym_AMP,
    ACTIONS(2200), 1,
      anon_sym_CARET,
    ACTIONS(2204), 1,
      anon_sym_is,
    STATE(1405), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2184), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2190), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2202), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1175), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2192), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1958), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2186), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [77454] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77500] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77546] = 19,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_not,
    ACTIONS(2038), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2040), 1,
      anon_sym_PIPE,
    ACTIONS(2042), 1,
      anon_sym_AMP,
    ACTIONS(2044), 1,
      anon_sym_CARET,
    ACTIONS(2048), 1,
      anon_sym_is,
    STATE(1415), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2026), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2028), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2034), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2046), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1050), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2036), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1958), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2030), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [77622] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77668] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77712] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77756] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2353), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2355), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77800] = 15,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2311), 1,
      anon_sym_PIPE,
    ACTIONS(2313), 1,
      anon_sym_AMP,
    ACTIONS(2315), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2120), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2299), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2305), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2118), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77868] = 15,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2311), 1,
      anon_sym_PIPE,
    ACTIONS(2313), 1,
      anon_sym_AMP,
    ACTIONS(2315), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2112), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2299), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2305), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2110), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77936] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77984] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78030] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78078] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1453), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78126] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78174] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78220] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78266] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78310] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78358] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2249), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2251), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78402] = 15,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2311), 1,
      anon_sym_PIPE,
    ACTIONS(2313), 1,
      anon_sym_AMP,
    ACTIONS(2315), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2060), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2299), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2305), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2058), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78470] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2114), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2116), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78514] = 4,
    ACTIONS(1396), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78560] = 4,
    ACTIONS(1469), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78606] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2103), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2105), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78650] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78698] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78746] = 5,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1455), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1462), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78794] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2253), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2255), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78838] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2257), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2259), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78882] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2261), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2263), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78926] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2275), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2277), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78970] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2357), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2359), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79014] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2103), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2105), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79058] = 19,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2293), 1,
      anon_sym_LPAREN,
    ACTIONS(2303), 1,
      anon_sym_not,
    ACTIONS(2309), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2311), 1,
      anon_sym_PIPE,
    ACTIONS(2313), 1,
      anon_sym_AMP,
    ACTIONS(2315), 1,
      anon_sym_CARET,
    ACTIONS(2319), 1,
      anon_sym_is,
    STATE(1417), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2299), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2305), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2317), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1380), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2307), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1958), 6,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2301), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [79134] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2114), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2116), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79178] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2267), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2269), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79222] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2271), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2273), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79266] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79310] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79354] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2281), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79398] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2283), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2285), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79442] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79486] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79530] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1417), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79574] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2287), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2289), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79618] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2349), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2351), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79662] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79706] = 6,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1389), 1,
      anon_sym_LBRACK,
    STATE(1885), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 26,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79756] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2321), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2323), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79800] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2325), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2327), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79844] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1480), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79888] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2329), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79932] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2333), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2335), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79976] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2337), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80020] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2341), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80064] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2345), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2347), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80108] = 6,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    STATE(1939), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 27,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80158] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(305), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80206] = 4,
    ACTIONS(1499), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80252] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(305), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80300] = 5,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1396), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80348] = 4,
    ACTIONS(1488), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80394] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2345), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2347), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80438] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2341), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80482] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2114), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2116), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80526] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80570] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2349), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2351), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80614] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2337), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80658] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2333), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2335), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80702] = 5,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1455), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1462), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80750] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80798] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2329), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80842] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80890] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2114), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2116), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80934] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2357), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2359), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80978] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2275), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2277), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81022] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2261), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2263), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81066] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2257), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2259), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81110] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2253), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2255), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81154] = 5,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1396), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81202] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(305), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81250] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(305), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81298] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2249), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2251), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81342] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1480), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81386] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2325), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2327), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81430] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2321), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2323), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81474] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 24,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81528] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 24,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81582] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 24,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81636] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2287), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2289), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81680] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81724] = 11,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2220), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2230), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81784] = 10,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2220), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2230), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81842] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 24,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81896] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81940] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1455), 3,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1462), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81986] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1417), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82030] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2353), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2355), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82074] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82118] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82162] = 13,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2238), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2220), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2222), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2230), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82226] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82270] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2283), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2285), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82314] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2103), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2105), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82358] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82402] = 12,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2220), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2222), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2230), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82464] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82508] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2279), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2281), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82552] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82596] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82640] = 15,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2234), 1,
      anon_sym_PIPE,
    ACTIONS(2236), 1,
      anon_sym_AMP,
    ACTIONS(2238), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2220), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2222), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2112), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2230), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2110), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82708] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82754] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82800] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1480), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82844] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82890] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1453), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82938] = 15,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2234), 1,
      anon_sym_PIPE,
    ACTIONS(2236), 1,
      anon_sym_AMP,
    ACTIONS(2238), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2220), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2222), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2120), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2230), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2118), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83006] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1417), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83050] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83094] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83138] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2267), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2269), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83182] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2271), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2273), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83226] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83270] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83314] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83358] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83402] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1394), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1399), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1387), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [83447] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2261), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2263), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83490] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1453), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83537] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2325), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2327), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83580] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2321), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2323), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83623] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83666] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1453), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83713] = 7,
    ACTIONS(1465), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1453), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1460), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(1455), 12,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1457), 12,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [83764] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83811] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1467), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1472), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1387), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [83856] = 7,
    ACTIONS(1465), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1453), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1460), 5,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
    ACTIONS(1455), 12,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1457), 12,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [83907] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1497), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1502), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1495), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [83952] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1486), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1491), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1484), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [83997] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2349), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2351), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84040] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84083] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84126] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1499), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1502), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84171] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2249), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2251), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84214] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1488), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1491), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84259] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84302] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84345] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2345), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2347), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84388] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84435] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84482] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2287), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2289), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84525] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2353), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2355), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84568] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84611] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2341), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84654] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2337), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84697] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2345), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2347), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84740] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2283), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2285), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84783] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2281), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84826] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84869] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2357), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2359), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84912] = 19,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2369), 1,
      anon_sym_not,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2377), 1,
      anon_sym_PIPE,
    ACTIONS(2379), 1,
      anon_sym_AMP,
    ACTIONS(2381), 1,
      anon_sym_CARET,
    ACTIONS(2385), 1,
      anon_sym_is,
    STATE(1506), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2365), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2371), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2383), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2373), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1958), 5,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2367), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [84987] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85030] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85073] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2341), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85116] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2337), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85159] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2333), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2335), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85202] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2329), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85245] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2275), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2277), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85288] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2271), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2273), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85331] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2267), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2269), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85374] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2261), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2263), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85417] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2267), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2269), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85460] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2257), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2259), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85503] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2271), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2273), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85546] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85589] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2253), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2255), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85632] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85675] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2333), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2335), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85718] = 22,
    ACTIONS(7), 1,
      anon_sym_unset,
    ACTIONS(9), 1,
      anon_sym_inherit,
    ACTIONS(11), 1,
      anon_sym_include,
    ACTIONS(13), 1,
      anon_sym_require,
    ACTIONS(15), 1,
      anon_sym_export,
    ACTIONS(17), 1,
      anon_sym_OVERRIDES,
    ACTIONS(19), 1,
      anon_sym_EXPORT_FUNCTIONS,
    ACTIONS(21), 1,
      anon_sym_addtask,
    ACTIONS(23), 1,
      anon_sym_deltask,
    ACTIONS(25), 1,
      anon_sym_addhandler,
    ACTIONS(27), 1,
      anon_sym_fakeroot,
    ACTIONS(29), 1,
      anon_sym_python,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(33), 1,
      anon_sym_def,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(2387), 1,
      ts_builtin_sym_end,
    STATE(1315), 1,
      aux_sym_recipe_repeat1,
    STATE(1521), 1,
      sym_concatenation,
    STATE(2296), 1,
      sym_variable_expansion,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2305), 14,
      sym_variable_assignment,
      sym_unset_statement,
      sym_inherit_directive,
      sym_include_directive,
      sym_require_directive,
      sym_export_statement,
      sym_overrides_statement,
      sym_export_functions_statement,
      sym_addtask_statement,
      sym_deltask_statement,
      sym_addhandler_statement,
      sym_anonymous_python_function,
      sym_function_definition,
      sym_python_function_definition,
  [85799] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2321), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2323), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85842] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2279), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2281), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85885] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2283), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2285), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85928] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85971] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86018] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86061] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1472), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86106] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1417), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86149] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2287), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2289), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86192] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2329), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86235] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1396), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86280] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86323] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86366] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2287), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2289), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86409] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2325), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2327), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86452] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2249), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2251), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86495] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86538] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86581] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2325), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2327), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86624] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86667] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86710] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2321), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2323), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86753] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86796] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1480), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86839] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86882] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86925] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2353), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2355), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86968] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2281), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87011] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87058] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87101] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87148] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2353), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2355), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87191] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1455), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1462), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87236] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1417), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87279] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87322] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2349), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2351), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87365] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2287), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2289), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87408] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2329), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87451] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2321), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2323), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87494] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2283), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2285), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87537] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2279), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2281), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87580] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87623] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1480), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87666] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1455), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1462), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87711] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1453), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87758] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2353), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2355), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87801] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87844] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87887] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87930] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87973] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2249), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2251), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88016] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88059] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88104] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88149] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2271), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2273), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88192] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88235] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2267), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2269), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88278] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1417), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88321] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1396), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88366] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2325), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2327), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88409] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1472), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88454] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88497] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 5,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88542] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2333), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2335), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88585] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2253), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2255), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88628] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2257), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2259), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88671] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1480), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88714] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2261), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2263), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88757] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2357), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2359), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88800] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2275), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2277), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88843] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2261), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2263), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88886] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2257), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2259), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88929] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88972] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2329), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89015] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2337), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89058] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2253), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2255), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89101] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2341), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89144] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89187] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2333), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2335), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89230] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2253), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2255), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89273] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2337), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89316] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2341), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89359] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1453), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89406] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2257), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2259), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89449] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2345), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2347), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89492] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2275), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2277), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89535] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2283), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2285), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89578] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2275), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2277), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89621] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(301), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(303), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(290), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89666] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2357), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2359), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89709] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(301), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(303), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(290), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89754] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2357), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2359), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89797] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89840] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89883] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2103), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2105), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89926] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2349), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2351), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89969] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90012] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2345), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2347), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90055] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90098] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1499), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1502), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90143] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1488), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1491), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90188] = 5,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2247), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90235] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(551), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90282] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90329] = 22,
    ACTIONS(2389), 1,
      ts_builtin_sym_end,
    ACTIONS(2391), 1,
      anon_sym_unset,
    ACTIONS(2394), 1,
      anon_sym_inherit,
    ACTIONS(2397), 1,
      anon_sym_include,
    ACTIONS(2400), 1,
      anon_sym_require,
    ACTIONS(2403), 1,
      anon_sym_export,
    ACTIONS(2406), 1,
      anon_sym_OVERRIDES,
    ACTIONS(2409), 1,
      anon_sym_EXPORT_FUNCTIONS,
    ACTIONS(2412), 1,
      anon_sym_addtask,
    ACTIONS(2415), 1,
      anon_sym_deltask,
    ACTIONS(2418), 1,
      anon_sym_addhandler,
    ACTIONS(2421), 1,
      anon_sym_fakeroot,
    ACTIONS(2424), 1,
      anon_sym_python,
    ACTIONS(2427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2430), 1,
      anon_sym_def,
    ACTIONS(2433), 1,
      sym_identifier,
    ACTIONS(2436), 1,
      aux_sym__dotted_identifier_token1,
    STATE(1315), 1,
      aux_sym_recipe_repeat1,
    STATE(1521), 1,
      sym_concatenation,
    STATE(2296), 1,
      sym_variable_expansion,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2305), 14,
      sym_variable_assignment,
      sym_unset_statement,
      sym_inherit_directive,
      sym_include_directive,
      sym_require_directive,
      sym_export_statement,
      sym_overrides_statement,
      sym_export_functions_statement,
      sym_addtask_statement,
      sym_deltask_statement,
      sym_addhandler_statement,
      sym_anonymous_python_function,
      sym_function_definition,
      sym_python_function_definition,
  [90410] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90457] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2267), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2269), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90500] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2271), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2273), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90543] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2249), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2251), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90586] = 5,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(551), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90633] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2114), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2116), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90676] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2349), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2351), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90719] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90762] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90808] = 11,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2373), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 18,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90866] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90908] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1453), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90954] = 12,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2365), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2371), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2373), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 16,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91014] = 13,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2381), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2365), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2371), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2373), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 15,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91076] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2064), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2062), 23,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91128] = 6,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1453), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1460), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(1455), 12,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1457), 12,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [91176] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91220] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91262] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91306] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91350] = 15,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2377), 1,
      anon_sym_PIPE,
    ACTIONS(2379), 1,
      anon_sym_AMP,
    ACTIONS(2381), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2060), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2365), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2371), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2373), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2058), 13,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91416] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91460] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2353), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2355), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91502] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1486), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91544] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91588] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2068), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 23,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91640] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2253), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2255), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91682] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1497), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91724] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2257), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2259), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91766] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91810] = 14,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2379), 1,
      anon_sym_AMP,
    ACTIONS(2381), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2365), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2371), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2373), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 14,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91874] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91916] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(301), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91958] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2267), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2269), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92000] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2261), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2263), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92042] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2275), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2277), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92084] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1480), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92126] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2357), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2359), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92168] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2271), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2273), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92210] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2349), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2351), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92252] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2279), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2281), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92294] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2283), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2285), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92336] = 15,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2377), 1,
      anon_sym_PIPE,
    ACTIONS(2379), 1,
      anon_sym_AMP,
    ACTIONS(2381), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2120), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2365), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2371), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2373), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2118), 13,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92402] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 23,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92454] = 4,
    ACTIONS(1385), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92498] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92542] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92584] = 4,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(524), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92628] = 15,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2377), 1,
      anon_sym_PIPE,
    ACTIONS(2379), 1,
      anon_sym_AMP,
    ACTIONS(2381), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2112), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2365), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2371), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2373), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2110), 13,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92694] = 10,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2373), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 20,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92750] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2287), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2289), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92792] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2050), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2052), 23,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92844] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1417), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92886] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92928] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1425), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92970] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2321), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2323), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93012] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2345), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2347), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93054] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1421), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93096] = 7,
    ACTIONS(1465), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1453), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1462), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1460), 4,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(1455), 12,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1457), 12,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93146] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2325), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2327), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93188] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2341), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93230] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2337), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93272] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2329), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93314] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1394), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93356] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2249), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2251), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93398] = 5,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(524), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93444] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2333), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2335), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93486] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93527] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1467), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1472), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1387), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93570] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1421), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93611] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(524), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93654] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1476), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93695] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93736] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1462), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93777] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1457), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1462), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1455), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93820] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1419), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1421), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93861] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(524), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93904] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1415), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1417), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93945] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1394), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1399), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1387), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93988] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1497), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1502), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1495), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94031] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1486), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1491), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1484), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94074] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(301), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(303), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(290), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94117] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(301), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(303), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(290), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94160] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1425), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94201] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1478), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1480), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94242] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1423), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1425), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94283] = 8,
    ACTIONS(2439), 1,
      anon_sym_EQ,
    ACTIONS(2446), 1,
      anon_sym_not,
    ACTIONS(2452), 1,
      anon_sym_is,
    STATE(1402), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2449), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2443), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 10,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [94324] = 8,
    ACTIONS(2002), 1,
      anon_sym_not,
    ACTIONS(2018), 1,
      anon_sym_is,
    ACTIONS(2455), 1,
      anon_sym_EQ,
    STATE(1402), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2016), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2000), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2457), 10,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [94365] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(290), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94397] = 8,
    ACTIONS(2188), 1,
      anon_sym_not,
    ACTIONS(2204), 1,
      anon_sym_is,
    ACTIONS(2455), 1,
      anon_sym_EQ,
    STATE(1409), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2202), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2186), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2457), 9,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [94437] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1387), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(1467), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94469] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1387), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(1394), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94501] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(290), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94533] = 8,
    ACTIONS(2439), 1,
      anon_sym_EQ,
    ACTIONS(2462), 1,
      anon_sym_not,
    ACTIONS(2468), 1,
      anon_sym_is,
    STATE(1409), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2459), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 9,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [94573] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1491), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1484), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(1486), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94605] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1502), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1495), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(1497), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94637] = 7,
    ACTIONS(2474), 1,
      anon_sym_not,
    ACTIONS(2480), 1,
      anon_sym_is,
    STATE(1412), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2477), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [94674] = 8,
    ACTIONS(2439), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_not,
    ACTIONS(2492), 1,
      anon_sym_is,
    STATE(1413), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2483), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 8,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [94713] = 8,
    ACTIONS(2226), 1,
      anon_sym_not,
    ACTIONS(2242), 1,
      anon_sym_is,
    ACTIONS(2455), 1,
      anon_sym_EQ,
    STATE(1413), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2240), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2457), 8,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [94752] = 8,
    ACTIONS(2032), 1,
      anon_sym_not,
    ACTIONS(2048), 1,
      anon_sym_is,
    ACTIONS(2455), 1,
      anon_sym_EQ,
    STATE(1416), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2046), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2030), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2457), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [94791] = 8,
    ACTIONS(2439), 1,
      anon_sym_EQ,
    ACTIONS(2498), 1,
      anon_sym_not,
    ACTIONS(2504), 1,
      anon_sym_is,
    STATE(1416), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2501), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2495), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [94830] = 7,
    ACTIONS(2303), 1,
      anon_sym_not,
    ACTIONS(2319), 1,
      anon_sym_is,
    STATE(1412), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2317), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2457), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [94867] = 8,
    ACTIONS(2439), 1,
      anon_sym_as,
    ACTIONS(2510), 1,
      anon_sym_not,
    ACTIONS(2516), 1,
      anon_sym_is,
    STATE(1418), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2513), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2507), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [94906] = 8,
    ACTIONS(1972), 1,
      anon_sym_not,
    ACTIONS(1988), 1,
      anon_sym_is,
    ACTIONS(2455), 1,
      anon_sym_as,
    STATE(1418), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1986), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1970), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2457), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [94945] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(463), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94975] = 7,
    ACTIONS(2522), 1,
      anon_sym_not,
    ACTIONS(2528), 1,
      anon_sym_is,
    STATE(1421), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2525), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2519), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [95011] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1245), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95041] = 8,
    ACTIONS(2134), 1,
      anon_sym_not,
    ACTIONS(2150), 1,
      anon_sym_is,
    ACTIONS(2455), 1,
      anon_sym_as,
    STATE(1433), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2148), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2132), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2457), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [95079] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1245), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95109] = 7,
    ACTIONS(2158), 1,
      anon_sym_not,
    ACTIONS(2174), 1,
      anon_sym_is,
    STATE(1421), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2172), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2156), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2457), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [95145] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1455), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1394), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95175] = 8,
    ACTIONS(2085), 1,
      anon_sym_not,
    ACTIONS(2101), 1,
      anon_sym_is,
    ACTIONS(2455), 1,
      anon_sym_as,
    STATE(1428), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2083), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2457), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [95213] = 8,
    ACTIONS(2439), 1,
      anon_sym_as,
    ACTIONS(2534), 1,
      anon_sym_not,
    ACTIONS(2540), 1,
      anon_sym_is,
    STATE(1428), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2537), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [95251] = 4,
    ACTIONS(2543), 1,
      anon_sym_COMMA,
    STATE(1432), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(817), 17,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95281] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(463), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95311] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2545), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1394), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95341] = 4,
    ACTIONS(2549), 1,
      anon_sym_COMMA,
    STATE(1432), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2547), 17,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95371] = 8,
    ACTIONS(2439), 1,
      anon_sym_as,
    ACTIONS(2555), 1,
      anon_sym_not,
    ACTIONS(2561), 1,
      anon_sym_is,
    STATE(1433), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2558), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2552), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [95409] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(463), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95438] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1467), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95467] = 9,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 7,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95506] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2052), 10,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95543] = 13,
    ACTIONS(2052), 1,
      anon_sym_PIPE,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95590] = 12,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2052), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95635] = 11,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2052), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95678] = 13,
    ACTIONS(1990), 1,
      anon_sym_LBRACK,
    ACTIONS(1994), 1,
      anon_sym_DOT,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95725] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2052), 10,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95762] = 13,
    ACTIONS(2054), 1,
      anon_sym_LBRACK,
    ACTIONS(2056), 1,
      anon_sym_DOT,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95809] = 13,
    ACTIONS(1956), 1,
      anon_sym_LBRACK,
    ACTIONS(1962), 1,
      anon_sym_DOT,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95856] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1484), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1491), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1486), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95885] = 13,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(2024), 1,
      anon_sym_DOT,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95932] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1495), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1502), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1497), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95961] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95990] = 10,
    ACTIONS(2580), 1,
      aux_sym_recipe_token1,
    ACTIONS(2582), 1,
      anon_sym_NULL,
    ACTIONS(2586), 1,
      anon_sym_LBRACK,
    ACTIONS(2588), 1,
      anon_sym_COLON,
    ACTIONS(2590), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2594), 1,
      sym__concat,
    STATE(1519), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1710), 3,
      sym_variable_flag,
      sym_override,
      sym_variable_expansion,
    ACTIONS(2584), 8,
      anon_sym_EQ,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [96031] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96060] = 13,
    ACTIONS(2176), 1,
      anon_sym_LBRACK,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [96107] = 13,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [96154] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2596), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96179] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96204] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1467), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96233] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1399), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1394), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96262] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1484), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1491), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1486), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96291] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1495), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1502), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1497), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96320] = 13,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [96367] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1399), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1394), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96396] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96425] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96454] = 10,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2052), 5,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96495] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2598), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96520] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2547), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96545] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1399), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1394), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96574] = 13,
    ACTIONS(2122), 1,
      anon_sym_LBRACK,
    ACTIONS(2126), 1,
      anon_sym_DOT,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [96621] = 13,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [96668] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1455), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1394), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96697] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1245), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96726] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1467), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96755] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1495), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1502), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1497), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96784] = 13,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_AMP,
    ACTIONS(2576), 1,
      anon_sym_CARET,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(2600), 1,
      anon_sym_LBRACK,
    ACTIONS(2602), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2572), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2566), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [96831] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1484), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1491), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1486), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96860] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2068), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2066), 10,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96897] = 8,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2568), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2064), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1226), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2062), 10,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96934] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1399), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2545), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1394), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96963] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1245), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96992] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(463), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [97021] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [97050] = 4,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(303), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(301), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [97079] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2598), 17,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97103] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2389), 2,
      ts_builtin_sym_end,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2604), 15,
      anon_sym_unset,
      anon_sym_inherit,
      anon_sym_include,
      anon_sym_require,
      anon_sym_export,
      anon_sym_OVERRIDES,
      anon_sym_EXPORT_FUNCTIONS,
      anon_sym_addtask,
      anon_sym_deltask,
      anon_sym_addhandler,
      anon_sym_fakeroot,
      anon_sym_python,
      anon_sym_def,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
  [97129] = 13,
    ACTIONS(2606), 1,
      anon_sym_COLON,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2377), 1,
      sym_lambda_parameters,
    STATE(2468), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97175] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2618), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2468), 1,
      sym__parameters,
    STATE(2470), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97221] = 11,
    ACTIONS(2584), 1,
      anon_sym_EQ,
    ACTIONS(2588), 1,
      anon_sym_COLON,
    ACTIONS(2594), 1,
      sym__concat,
    ACTIONS(2622), 1,
      anon_sym_LBRACK,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2626), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1519), 1,
      aux_sym_concatenation_repeat1,
    STATE(1629), 1,
      sym_override,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1710), 2,
      sym_variable_flag,
      sym_variable_expansion,
    ACTIONS(2620), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [97263] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2596), 17,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97287] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2628), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2468), 1,
      sym__parameters,
    STATE(2534), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97333] = 4,
    ACTIONS(2630), 1,
      anon_sym_COMMA,
    STATE(1489), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2547), 15,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97361] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2633), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2468), 1,
      sym__parameters,
    STATE(2549), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97407] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 17,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97431] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2635), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2468), 1,
      sym__parameters,
    STATE(2473), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97477] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2637), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2406), 1,
      sym_lambda_parameters,
    STATE(2468), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97523] = 6,
    ACTIONS(2639), 1,
      anon_sym_EQ,
    ACTIONS(2643), 1,
      anon_sym_COLON,
    ACTIONS(2645), 1,
      anon_sym_COMMA,
    STATE(1429), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2641), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97555] = 6,
    ACTIONS(2639), 1,
      anon_sym_EQ,
    ACTIONS(2643), 1,
      anon_sym_COLON,
    ACTIONS(2647), 1,
      anon_sym_COMMA,
    STATE(1500), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2641), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97587] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2649), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2410), 1,
      sym_lambda_parameters,
    STATE(2468), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97633] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2651), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2468), 1,
      sym__parameters,
    STATE(2559), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97679] = 5,
    ACTIONS(2639), 1,
      anon_sym_EQ,
    ACTIONS(2643), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2653), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(2641), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97709] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2655), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2439), 1,
      sym_lambda_parameters,
    STATE(2468), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97755] = 4,
    ACTIONS(2657), 1,
      anon_sym_COMMA,
    STATE(1489), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(817), 15,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97783] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2659), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2468), 1,
      sym__parameters,
    STATE(2482), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97829] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2661), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2353), 1,
      sym_lambda_parameters,
    STATE(2468), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97875] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2468), 1,
      sym__parameters,
    STATE(2512), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97921] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2547), 17,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97945] = 13,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2665), 1,
      anon_sym_COLON,
    STATE(2104), 1,
      sym_parameter,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2448), 1,
      sym_lambda_parameters,
    STATE(2468), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97991] = 7,
    ACTIONS(2369), 1,
      anon_sym_not,
    ACTIONS(2385), 1,
      anon_sym_is,
    STATE(1508), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2383), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2457), 5,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2367), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [98024] = 12,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2669), 1,
      anon_sym_RPAREN,
    ACTIONS(2671), 1,
      anon_sym_STAR,
    ACTIONS(2673), 1,
      anon_sym_SLASH,
    ACTIONS(2675), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2677), 1,
      sym_python_identifier,
    STATE(2138), 1,
      sym_parameter,
    STATE(2139), 1,
      sym_tuple_pattern,
    STATE(2440), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2141), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2265), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [98067] = 7,
    ACTIONS(2682), 1,
      anon_sym_not,
    ACTIONS(2688), 1,
      anon_sym_is,
    STATE(1508), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2685), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2441), 5,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2679), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [98100] = 11,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2691), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2241), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [98140] = 11,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2671), 1,
      anon_sym_STAR,
    ACTIONS(2673), 1,
      anon_sym_SLASH,
    ACTIONS(2675), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2677), 1,
      sym_python_identifier,
    ACTIONS(2691), 1,
      anon_sym_RPAREN,
    STATE(2139), 1,
      sym_tuple_pattern,
    STATE(2244), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2141), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2265), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [98180] = 9,
    ACTIONS(2594), 1,
      sym__concat,
    ACTIONS(2622), 1,
      anon_sym_LBRACK,
    ACTIONS(2693), 1,
      anon_sym_EQ,
    ACTIONS(2697), 1,
      anon_sym_COLON,
    STATE(1519), 1,
      aux_sym_concatenation_repeat1,
    STATE(1563), 1,
      sym_variable_flag,
    STATE(1566), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2695), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [98216] = 6,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1522), 1,
      sym_variable_expansion,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2699), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2703), 2,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
    ACTIONS(2701), 9,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98246] = 11,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2671), 1,
      anon_sym_STAR,
    ACTIONS(2673), 1,
      anon_sym_SLASH,
    ACTIONS(2675), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2677), 1,
      sym_python_identifier,
    ACTIONS(2705), 1,
      anon_sym_RPAREN,
    STATE(2139), 1,
      sym_tuple_pattern,
    STATE(2244), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2141), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2265), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [98286] = 4,
    ACTIONS(2639), 1,
      anon_sym_EQ,
    ACTIONS(2643), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2641), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [98312] = 11,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2241), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [98352] = 10,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_STAR,
    ACTIONS(2612), 1,
      anon_sym_SLASH,
    ACTIONS(2614), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2616), 1,
      sym_python_identifier,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2241), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2269), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2280), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [98389] = 10,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2671), 1,
      anon_sym_STAR,
    ACTIONS(2673), 1,
      anon_sym_SLASH,
    ACTIONS(2675), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2677), 1,
      sym_python_identifier,
    STATE(2139), 1,
      sym_tuple_pattern,
    STATE(2244), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2141), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2265), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [98426] = 7,
    ACTIONS(2594), 1,
      sym__concat,
    ACTIONS(2622), 1,
      anon_sym_LBRACK,
    STATE(1519), 1,
      aux_sym_concatenation_repeat1,
    STATE(1580), 1,
      sym_variable_flag,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2707), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2709), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [98457] = 5,
    ACTIONS(2715), 1,
      sym__concat,
    STATE(1520), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2711), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2713), 10,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [98484] = 5,
    ACTIONS(2721), 1,
      sym__concat,
    STATE(1520), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2717), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2719), 10,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [98511] = 7,
    ACTIONS(2584), 1,
      anon_sym_EQ,
    ACTIONS(2588), 1,
      anon_sym_COLON,
    ACTIONS(2622), 1,
      anon_sym_LBRACK,
    ACTIONS(2626), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1710), 3,
      sym_variable_flag,
      sym_override,
      sym_variable_expansion,
    ACTIONS(2620), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [98542] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2717), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2719), 11,
      sym__concat,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [98564] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2724), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2726), 11,
      sym__concat,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [98586] = 7,
    ACTIONS(2594), 1,
      sym__concat,
    ACTIONS(2693), 1,
      anon_sym_EQ,
    ACTIONS(2697), 1,
      anon_sym_COLON,
    STATE(1519), 1,
      aux_sym_concatenation_repeat1,
    STATE(1566), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2695), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [98616] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2728), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2730), 11,
      sym__concat,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [98638] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2732), 12,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [98657] = 13,
    ACTIONS(2734), 1,
      anon_sym_COLON,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2096), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2434), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [98698] = 13,
    ACTIONS(2734), 1,
      anon_sym_COLON,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2096), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2394), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [98739] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1958), 12,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [98758] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 12,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [98777] = 13,
    ACTIONS(2734), 1,
      anon_sym_COLON,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2096), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2370), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [98818] = 13,
    ACTIONS(2734), 1,
      anon_sym_COLON,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2096), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2363), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [98859] = 13,
    ACTIONS(2734), 1,
      anon_sym_COLON,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2096), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2416), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [98900] = 13,
    ACTIONS(2734), 1,
      anon_sym_COLON,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2096), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2476), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [98941] = 13,
    ACTIONS(2734), 1,
      anon_sym_COLON,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2096), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2392), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [98982] = 5,
    ACTIONS(2594), 1,
      sym__concat,
    STATE(1519), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2707), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2709), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [99007] = 13,
    ACTIONS(2734), 1,
      anon_sym_COLON,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2096), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2542), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99048] = 12,
    ACTIONS(2754), 1,
      anon_sym_RPAREN,
    ACTIONS(2756), 1,
      anon_sym_COMMA,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2199), 1,
      aux_sym_argument_list_repeat1,
    STATE(2435), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99086] = 9,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    STATE(1992), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2772), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(2770), 3,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_PIPE,
  [99118] = 5,
    ACTIONS(2693), 1,
      anon_sym_EQ,
    ACTIONS(2697), 1,
      anon_sym_COLON,
    STATE(1566), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2695), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [99142] = 5,
    ACTIONS(2707), 1,
      anon_sym_EQ,
    ACTIONS(2784), 1,
      anon_sym_COLON,
    STATE(1541), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2709), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [99166] = 5,
    ACTIONS(2697), 1,
      anon_sym_COLON,
    ACTIONS(2787), 1,
      anon_sym_EQ,
    STATE(1541), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2789), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [99190] = 5,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2793), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 8,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_PIPE,
  [99214] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2796), 1,
      anon_sym_RPAREN,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2371), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99252] = 12,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    ACTIONS(2800), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    STATE(1767), 1,
      sym_for_in_clause,
    STATE(2214), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2412), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99290] = 4,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 9,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_PIPE,
  [99312] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2816), 1,
      anon_sym_RPAREN,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2544), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99350] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2818), 1,
      anon_sym_RPAREN,
    ACTIONS(2820), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2020), 1,
      aux_sym_argument_list_repeat1,
    STATE(2544), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99388] = 7,
    ACTIONS(2822), 1,
      anon_sym_DQUOTE,
    ACTIONS(2824), 1,
      aux_sym_string_token1,
    ACTIONS(2828), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2830), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1570), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat1,
    ACTIONS(2826), 4,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
  [99416] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2832), 1,
      anon_sym_RPAREN,
    ACTIONS(2834), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2397), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99454] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2837), 7,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [99480] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2839), 1,
      anon_sym_RPAREN,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2413), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99518] = 12,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    ACTIONS(2800), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    STATE(1767), 1,
      sym_for_in_clause,
    STATE(2214), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2436), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99556] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2841), 1,
      anon_sym_RPAREN,
    ACTIONS(2843), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2137), 1,
      aux_sym_argument_list_repeat1,
    STATE(2397), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99594] = 7,
    ACTIONS(2845), 1,
      anon_sym_DQUOTE,
    ACTIONS(2847), 1,
      aux_sym_string_token1,
    ACTIONS(2853), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2856), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1555), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat1,
    ACTIONS(2850), 4,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
  [99622] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2859), 1,
      anon_sym_RPAREN,
    ACTIONS(2861), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2093), 1,
      aux_sym_argument_list_repeat1,
    STATE(2360), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99660] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2832), 1,
      anon_sym_RPAREN,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2397), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99698] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2863), 7,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [99724] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2865), 1,
      anon_sym_RPAREN,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2395), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99762] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2867), 1,
      anon_sym_RPAREN,
    ACTIONS(2869), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2193), 1,
      aux_sym_argument_list_repeat1,
    STATE(2395), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99800] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2871), 7,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [99826] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2873), 1,
      anon_sym_RPAREN,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2360), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99864] = 5,
    ACTIONS(2697), 1,
      anon_sym_COLON,
    ACTIONS(2875), 1,
      anon_sym_EQ,
    STATE(1542), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2877), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [99888] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2879), 1,
      anon_sym_RPAREN,
    ACTIONS(2881), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2039), 1,
      aux_sym_argument_list_repeat1,
    STATE(2371), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99926] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2883), 1,
      anon_sym_RPAREN,
    ACTIONS(2885), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2178), 1,
      aux_sym_argument_list_repeat1,
    STATE(2413), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [99964] = 5,
    ACTIONS(2697), 1,
      anon_sym_COLON,
    ACTIONS(2875), 1,
      anon_sym_EQ,
    STATE(1541), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2877), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [99988] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2887), 1,
      anon_sym_RPAREN,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2477), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [100026] = 12,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    ACTIONS(2800), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    STATE(1767), 1,
      sym_for_in_clause,
    STATE(2214), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2359), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [100064] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2889), 1,
      anon_sym_RPAREN,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2435), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [100102] = 7,
    ACTIONS(2828), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2830), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2891), 1,
      anon_sym_DQUOTE,
    ACTIONS(2893), 1,
      aux_sym_string_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1555), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat1,
    ACTIONS(2895), 4,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
  [100130] = 12,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    ACTIONS(2800), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    STATE(1767), 1,
      sym_for_in_clause,
    STATE(2214), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2399), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [100168] = 12,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(2897), 1,
      anon_sym_RPAREN,
    ACTIONS(2899), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      sym_for_in_clause,
    STATE(2120), 1,
      aux_sym_argument_list_repeat1,
    STATE(2477), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [100206] = 12,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    ACTIONS(2800), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    STATE(1767), 1,
      sym_for_in_clause,
    STATE(2214), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2545), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [100244] = 3,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 10,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      anon_sym_PIPE,
  [100264] = 12,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    ACTIONS(2800), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    STATE(1767), 1,
      sym_for_in_clause,
    STATE(2214), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2478), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [100302] = 12,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    ACTIONS(2800), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    STATE(1767), 1,
      sym_for_in_clause,
    STATE(2214), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2401), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [100340] = 12,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    ACTIONS(2800), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    STATE(1767), 1,
      sym_for_in_clause,
    STATE(2214), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2372), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [100378] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2770), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100403] = 7,
    ACTIONS(2912), 1,
      anon_sym_SQUOTE,
    ACTIONS(2914), 1,
      aux_sym_string_token3,
    ACTIONS(2917), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2920), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2909), 3,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      aux_sym_string_token4,
    STATE(1579), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat2,
  [100430] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2923), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2925), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [100449] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2837), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100474] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2933), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1585), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2935), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1600), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100532] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2937), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1605), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100561] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2939), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100590] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2770), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [100615] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2863), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100640] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2941), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1596), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100669] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2943), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1595), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100698] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2945), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2947), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [100717] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2949), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1599), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100746] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2951), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100775] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2732), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [100792] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2953), 1,
      anon_sym_LBRACE,
    ACTIONS(2959), 1,
      sym__not_escape_sequence,
    ACTIONS(2962), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2956), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2964), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100850] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2966), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100879] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2968), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1592), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100908] = 7,
    ACTIONS(2891), 1,
      anon_sym_SQUOTE,
    ACTIONS(2972), 1,
      aux_sym_string_token3,
    ACTIONS(2974), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2976), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2970), 3,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      aux_sym_string_token4,
    STATE(1579), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat2,
  [100935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2978), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100964] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2980), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [100993] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1958), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [101010] = 8,
    ACTIONS(2984), 1,
      anon_sym_COMMA,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    STATE(1803), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2982), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [101039] = 8,
    ACTIONS(2984), 1,
      anon_sym_COMMA,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    STATE(1803), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2994), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [101068] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2996), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1616), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [101097] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(2998), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [101126] = 3,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      anon_sym_PIPE,
  [101145] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [101162] = 4,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_PIPE,
  [101183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(3000), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [101212] = 5,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3002), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_PIPE,
  [101235] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1958), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [101252] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(3005), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1609), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [101281] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2732), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [101298] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2871), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [101323] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [101340] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 1,
      sym__not_escape_sequence,
    ACTIONS(3007), 1,
      sym_string_end,
    STATE(1756), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2929), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1594), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [101369] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2707), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2709), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [101388] = 7,
    ACTIONS(2822), 1,
      anon_sym_SQUOTE,
    ACTIONS(2974), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2976), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3011), 1,
      aux_sym_string_token3,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3009), 3,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      aux_sym_string_token4,
    STATE(1598), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat2,
  [101415] = 5,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3013), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 6,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [101437] = 3,
    ACTIONS(3015), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [101455] = 5,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3017), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      sym_type_conversion,
  [101477] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2871), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [101501] = 4,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      sym_type_conversion,
  [101521] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1958), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [101537] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2837), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [101561] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2871), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [101585] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2863), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [101609] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2863), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [101633] = 4,
    ACTIONS(3028), 1,
      anon_sym_EQ,
    ACTIONS(3032), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3030), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [101653] = 3,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 8,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      anon_sym_PIPE,
  [101671] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [101687] = 4,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 7,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_PIPE,
  [101707] = 5,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3034), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 6,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_PIPE,
  [101729] = 6,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2871), 5,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [101753] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2732), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [101769] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3037), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [101793] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1958), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [101809] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [101825] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2871), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [101849] = 5,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3047), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_PIPE,
  [101871] = 3,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      sym_type_conversion,
  [101889] = 4,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_PIPE,
  [101909] = 3,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      anon_sym_PIPE,
  [101927] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2863), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [101951] = 9,
    ACTIONS(3052), 1,
      anon_sym_from,
    ACTIONS(3054), 1,
      anon_sym_COMMA,
    ACTIONS(3056), 1,
      anon_sym_as,
    ACTIONS(3058), 1,
      anon_sym_if,
    ACTIONS(3060), 1,
      anon_sym_and,
    ACTIONS(3062), 1,
      anon_sym_or,
    STATE(1931), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3050), 2,
      sym__newline,
      anon_sym_SEMI,
  [101981] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2837), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [102005] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3064), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [102029] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2837), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [102053] = 6,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2863), 5,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [102077] = 6,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2837), 5,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [102101] = 5,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3066), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 6,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102123] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2732), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [102139] = 3,
    ACTIONS(3069), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2732), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [102157] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2770), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [102181] = 3,
    ACTIONS(1964), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1958), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [102199] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2770), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [102223] = 4,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(3015), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 7,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_or,
  [102243] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3071), 1,
      anon_sym_RBRACK,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    STATE(2024), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [102272] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3079), 1,
      anon_sym_RBRACE,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3085), 1,
      sym_shell_content,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1711), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [102297] = 6,
    ACTIONS(3056), 1,
      anon_sym_as,
    ACTIONS(3058), 1,
      anon_sym_if,
    ACTIONS(3060), 1,
      anon_sym_and,
    ACTIONS(3062), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2871), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [102320] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3087), 1,
      anon_sym_RBRACE,
    ACTIONS(3089), 1,
      sym_shell_content,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1708), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [102345] = 7,
    ACTIONS(3093), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3095), 1,
      sym_identifier,
    ACTIONS(3097), 1,
      aux_sym__dotted_identifier_token1,
    STATE(1988), 1,
      sym_variable_expansion,
    STATE(2257), 1,
      sym_concatenation,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3091), 3,
      anon_sym_append,
      anon_sym_prepend,
      anon_sym_remove,
  [102370] = 5,
    ACTIONS(3060), 1,
      anon_sym_and,
    ACTIONS(3062), 1,
      anon_sym_or,
    ACTIONS(3099), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
  [102391] = 4,
    ACTIONS(3060), 1,
      anon_sym_and,
    ACTIONS(3062), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
  [102410] = 8,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3104), 1,
      anon_sym_COMMA,
    STATE(1990), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3102), 2,
      sym__newline,
      anon_sym_SEMI,
  [102437] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3106), 1,
      anon_sym_RBRACK,
    ACTIONS(3108), 1,
      anon_sym_COMMA,
    STATE(2043), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [102466] = 3,
    ACTIONS(3060), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 7,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
  [102483] = 6,
    ACTIONS(3056), 1,
      anon_sym_as,
    ACTIONS(3058), 1,
      anon_sym_if,
    ACTIONS(3060), 1,
      anon_sym_and,
    ACTIONS(3062), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2863), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [102506] = 6,
    ACTIONS(3056), 1,
      anon_sym_as,
    ACTIONS(3058), 1,
      anon_sym_if,
    ACTIONS(3060), 1,
      anon_sym_and,
    ACTIONS(3062), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2837), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [102529] = 6,
    ACTIONS(3112), 1,
      sym_inherit_path,
    ACTIONS(3114), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3110), 2,
      aux_sym_recipe_token1,
      anon_sym_NULL,
    STATE(1735), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_inherit_directive_repeat1,
  [102552] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3118), 1,
      anon_sym_RBRACE,
    ACTIONS(3120), 1,
      sym_shell_content,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1689), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [102577] = 7,
    ACTIONS(3093), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3097), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(3124), 1,
      sym_identifier,
    STATE(1874), 1,
      sym_variable_expansion,
    STATE(2131), 1,
      sym_concatenation,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3122), 3,
      anon_sym_append,
      anon_sym_prepend,
      anon_sym_remove,
  [102602] = 8,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3126), 1,
      anon_sym_COMMA,
    STATE(1983), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2994), 2,
      sym__newline,
      anon_sym_SEMI,
  [102629] = 7,
    ACTIONS(1373), 1,
      anon_sym_except_STAR,
    ACTIONS(1377), 1,
      anon_sym_except,
    ACTIONS(3128), 1,
      anon_sym_finally,
    STATE(678), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(537), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    STATE(538), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [102654] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3130), 1,
      anon_sym_RBRACK,
    ACTIONS(3132), 1,
      anon_sym_COMMA,
    STATE(2087), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [102683] = 3,
    ACTIONS(2728), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2730), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [102700] = 3,
    ACTIONS(2724), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2726), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [102717] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3134), 1,
      anon_sym_RBRACK,
    ACTIONS(3136), 1,
      anon_sym_COMMA,
    STATE(2116), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [102746] = 5,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3138), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102767] = 5,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3138), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102788] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3140), 1,
      anon_sym_RBRACK,
    ACTIONS(3142), 1,
      anon_sym_COMMA,
    STATE(2074), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [102817] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3120), 1,
      sym_shell_content,
    ACTIONS(3144), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1689), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [102842] = 5,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3138), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102863] = 5,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3138), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102884] = 3,
    ACTIONS(1964), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1958), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [102901] = 3,
    ACTIONS(3069), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2732), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [102918] = 5,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3138), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102939] = 3,
    ACTIONS(3148), 1,
      aux_sym_string_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3146), 7,
      anon_sym_DQUOTE,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [102956] = 7,
    ACTIONS(3150), 1,
      anon_sym_fakeroot,
    ACTIONS(3153), 1,
      anon_sym_RBRACE,
    ACTIONS(3155), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3158), 1,
      sym_identifier,
    ACTIONS(3161), 1,
      sym_shell_content,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1689), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [102981] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3164), 1,
      anon_sym_RBRACK,
    ACTIONS(3166), 1,
      anon_sym_COMMA,
    STATE(2130), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [103010] = 6,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2871), 4,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [103033] = 5,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3138), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103054] = 5,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    ACTIONS(3168), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103075] = 5,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    ACTIONS(3013), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103096] = 3,
    ACTIONS(3015), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [103113] = 4,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(3015), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 6,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_or,
  [103132] = 8,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    STATE(1992), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2772), 2,
      sym__newline,
      anon_sym_SEMI,
  [103159] = 6,
    ACTIONS(3056), 1,
      anon_sym_as,
    ACTIONS(3058), 1,
      anon_sym_if,
    ACTIONS(3060), 1,
      anon_sym_and,
    ACTIONS(3062), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3064), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [103182] = 6,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2837), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [103205] = 8,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3126), 1,
      anon_sym_COMMA,
    STATE(1983), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3171), 2,
      sym__newline,
      anon_sym_SEMI,
  [103232] = 8,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3126), 1,
      anon_sym_COMMA,
    STATE(1983), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2653), 2,
      sym__newline,
      anon_sym_SEMI,
  [103259] = 7,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(37), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(3175), 1,
      sym_identifier,
    STATE(1536), 1,
      sym_variable_expansion,
    STATE(1617), 1,
      sym_concatenation,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3173), 3,
      anon_sym_append,
      anon_sym_prepend,
      anon_sym_remove,
  [103284] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3177), 1,
      anon_sym_RBRACE,
    ACTIONS(3179), 1,
      sym_shell_content,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1712), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [103309] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3181), 1,
      anon_sym_RBRACK,
    ACTIONS(3183), 1,
      anon_sym_COMMA,
    STATE(2225), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [103338] = 8,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3126), 1,
      anon_sym_COMMA,
    STATE(1983), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3185), 2,
      sym__newline,
      anon_sym_SEMI,
  [103365] = 8,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3104), 1,
      anon_sym_COMMA,
    STATE(1961), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3187), 2,
      sym__newline,
      anon_sym_SEMI,
  [103392] = 7,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(37), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(3191), 1,
      sym_identifier,
    STATE(1524), 1,
      sym_variable_expansion,
    STATE(1540), 1,
      sym_concatenation,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3189), 3,
      anon_sym_append,
      anon_sym_prepend,
      anon_sym_remove,
  [103417] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3079), 1,
      anon_sym_RBRACE,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3120), 1,
      sym_shell_content,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1689), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [103442] = 6,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2863), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [103465] = 3,
    ACTIONS(3028), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3030), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [103482] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3120), 1,
      sym_shell_content,
    ACTIONS(3193), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1689), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [103507] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3120), 1,
      sym_shell_content,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1689), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [103532] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3193), 1,
      anon_sym_RBRACE,
    ACTIONS(3197), 1,
      sym_shell_content,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1682), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [103557] = 7,
    ACTIONS(1373), 1,
      anon_sym_except_STAR,
    ACTIONS(1377), 1,
      anon_sym_except,
    ACTIONS(3128), 1,
      anon_sym_finally,
    STATE(651), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(539), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    STATE(540), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [103582] = 3,
    ACTIONS(2726), 1,
      aux_sym_string_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2724), 7,
      anon_sym_DQUOTE,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [103599] = 6,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2863), 4,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [103622] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3199), 1,
      anon_sym_RBRACK,
    ACTIONS(3201), 1,
      anon_sym_COMMA,
    STATE(2195), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [103651] = 8,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3205), 1,
      anon_sym_COMMA,
    STATE(1959), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3203), 2,
      sym__newline,
      anon_sym_SEMI,
  [103678] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3207), 1,
      anon_sym_RBRACE,
    ACTIONS(3209), 1,
      sym_shell_content,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1671), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [103703] = 4,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(3015), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_or,
  [103722] = 3,
    ACTIONS(3015), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [103739] = 5,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(3013), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103760] = 5,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(3211), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103781] = 6,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2760), 1,
      anon_sym_if,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2871), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [103804] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3120), 1,
      sym_shell_content,
    ACTIONS(3207), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1689), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [103829] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3214), 1,
      anon_sym_RBRACK,
    ACTIONS(3216), 1,
      anon_sym_COMMA,
    STATE(2190), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [103858] = 6,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2804), 1,
      anon_sym_if,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2837), 4,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [103881] = 3,
    ACTIONS(2730), 1,
      aux_sym_string_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2728), 7,
      anon_sym_DQUOTE,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [103898] = 5,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3138), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103919] = 5,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3138), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103940] = 9,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3218), 1,
      anon_sym_RBRACK,
    ACTIONS(3220), 1,
      anon_sym_COMMA,
    STATE(2142), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [103969] = 3,
    ACTIONS(3069), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2732), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [103986] = 7,
    ACTIONS(3077), 1,
      anon_sym_fakeroot,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    ACTIONS(3222), 1,
      sym_shell_content,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1725), 3,
      sym_function_definition,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [104011] = 6,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2742), 1,
      anon_sym_if,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3224), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [104034] = 6,
    ACTIONS(3228), 1,
      sym_inherit_path,
    ACTIONS(3231), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3234), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3226), 2,
      aux_sym_recipe_token1,
      anon_sym_NULL,
    STATE(1735), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_inherit_directive_repeat1,
  [104057] = 3,
    ACTIONS(1964), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1958), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [104074] = 5,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3138), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104095] = 8,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3237), 1,
      anon_sym_RBRACE,
    ACTIONS(3239), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2097), 1,
      aux_sym_dictionary_repeat1,
    STATE(2344), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104121] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3241), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [104143] = 3,
    ACTIONS(2730), 1,
      aux_sym_string_token3,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2728), 6,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_SQUOTE,
      aux_sym_string_token4,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [104159] = 8,
    ACTIONS(2695), 1,
      anon_sym_LPAREN,
    ACTIONS(3243), 1,
      anon_sym_LBRACK,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    ACTIONS(3247), 1,
      sym__concat,
    STATE(2004), 1,
      aux_sym_concatenation_repeat1,
    STATE(2145), 1,
      aux_sym_override_repeat1,
    STATE(2147), 1,
      sym_variable_flag,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104185] = 5,
    ACTIONS(2802), 1,
      anon_sym_as,
    ACTIONS(2810), 1,
      anon_sym_and,
    ACTIONS(2812), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3249), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104205] = 3,
    ACTIONS(2726), 1,
      aux_sym_string_token3,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2724), 6,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_SQUOTE,
      aux_sym_string_token4,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [104221] = 6,
    ACTIONS(3251), 1,
      anon_sym_RBRACK,
    ACTIONS(3253), 1,
      anon_sym_if,
    ACTIONS(3256), 1,
      anon_sym_async,
    ACTIONS(3259), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1744), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [104243] = 8,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3262), 1,
      anon_sym_COLON,
    ACTIONS(3264), 1,
      anon_sym_COMMA,
    STATE(2013), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104269] = 8,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3266), 1,
      anon_sym_RBRACE,
    ACTIONS(3268), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2025), 1,
      aux_sym_dictionary_repeat1,
    STATE(2364), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104295] = 8,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(2994), 1,
      anon_sym_RPAREN,
    ACTIONS(3270), 1,
      anon_sym_COMMA,
    STATE(2095), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104321] = 6,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(3272), 1,
      anon_sym_RPAREN,
    ACTIONS(3274), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1758), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [104343] = 7,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3073), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3276), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [104367] = 7,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3278), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1279), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [104391] = 6,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(3280), 1,
      anon_sym_RBRACK,
    ACTIONS(3282), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1744), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [104413] = 8,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COMMA,
    ACTIONS(3284), 1,
      anon_sym_COLON,
    STATE(2013), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104439] = 6,
    ACTIONS(3251), 1,
      anon_sym_RBRACE,
    ACTIONS(3286), 1,
      anon_sym_if,
    ACTIONS(3289), 1,
      anon_sym_async,
    ACTIONS(3292), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1753), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [104461] = 8,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3295), 1,
      anon_sym_RBRACE,
    ACTIONS(3297), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2174), 1,
      aux_sym_dictionary_repeat1,
    STATE(2391), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104487] = 5,
    ACTIONS(2740), 1,
      anon_sym_as,
    ACTIONS(2748), 1,
      anon_sym_and,
    ACTIONS(2750), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3249), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104507] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3303), 1,
      sym__not_escape_sequence,
    STATE(1763), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3299), 2,
      sym_string_end,
      anon_sym_LBRACE,
    ACTIONS(3301), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [104529] = 8,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3305), 1,
      anon_sym_RBRACE,
    ACTIONS(3307), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2177), 1,
      aux_sym_dictionary_repeat1,
    STATE(2433), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104555] = 6,
    ACTIONS(2762), 1,
      anon_sym_async,
    ACTIONS(2764), 1,
      anon_sym_for,
    ACTIONS(3274), 1,
      anon_sym_if,
    ACTIONS(3280), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1769), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [104577] = 7,
    ACTIONS(3309), 1,
      anon_sym_DOT,
    ACTIONS(3311), 1,
      anon_sym___future__,
    ACTIONS(3313), 1,
      sym_python_identifier,
    STATE(1957), 1,
      aux_sym_import_prefix_repeat1,
    STATE(2196), 1,
      sym_import_prefix,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(2499), 2,
      sym_relative_import,
      sym_dotted_name,
  [104601] = 3,
    ACTIONS(3148), 1,
      aux_sym_string_token3,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3146), 6,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_SQUOTE,
      aux_sym_string_token4,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [104617] = 8,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3315), 1,
      anon_sym_RBRACE,
    ACTIONS(3317), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2068), 1,
      aux_sym_dictionary_repeat1,
    STATE(2369), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104643] = 6,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3280), 1,
      anon_sym_RBRACE,
    ACTIONS(3319), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1753), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [104665] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3326), 1,
      sym__not_escape_sequence,
    STATE(1763), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3321), 2,
      sym_string_end,
      anon_sym_LBRACE,
    ACTIONS(3323), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [104687] = 7,
    ACTIONS(1225), 1,
      anon_sym_COLON,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1223), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [104711] = 8,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3329), 1,
      anon_sym_RBRACE,
    ACTIONS(3331), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2044), 1,
      aux_sym_dictionary_repeat1,
    STATE(2540), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104737] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3333), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [104759] = 6,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2808), 1,
      anon_sym_for,
    ACTIONS(3272), 1,
      anon_sym_RBRACK,
    ACTIONS(3282), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1751), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [104781] = 6,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3272), 1,
      anon_sym_RBRACE,
    ACTIONS(3319), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1762), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [104803] = 6,
    ACTIONS(3251), 1,
      anon_sym_RPAREN,
    ACTIONS(3335), 1,
      anon_sym_if,
    ACTIONS(3338), 1,
      anon_sym_async,
    ACTIONS(3341), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1769), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [104825] = 5,
    ACTIONS(2758), 1,
      anon_sym_as,
    ACTIONS(2766), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3249), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104845] = 8,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      sym_python_identifier,
    STATE(1940), 1,
      sym_dotted_name,
    STATE(1973), 1,
      sym_aliased_import,
    STATE(2318), 1,
      sym_wildcard_import,
    STATE(2320), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104871] = 8,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3350), 1,
      anon_sym_RBRACE,
    ACTIONS(3352), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2222), 1,
      aux_sym_dictionary_repeat1,
    STATE(2417), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104897] = 8,
    ACTIONS(2744), 1,
      anon_sym_async,
    ACTIONS(2746), 1,
      anon_sym_for,
    ACTIONS(3354), 1,
      anon_sym_RBRACE,
    ACTIONS(3356), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      sym_for_in_clause,
    STATE(2175), 1,
      aux_sym_dictionary_repeat1,
    STATE(2393), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104923] = 8,
    ACTIONS(2994), 1,
      anon_sym_RBRACK,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3358), 1,
      anon_sym_COMMA,
    STATE(2167), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [104949] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3064), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [104971] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3360), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [104992] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3064), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [105013] = 4,
    ACTIONS(3364), 1,
      anon_sym_COMMA,
    STATE(1842), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3362), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105030] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3366), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [105051] = 7,
    ACTIONS(3368), 1,
      anon_sym_RBRACK,
    ACTIONS(3370), 1,
      anon_sym_COLON,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    ACTIONS(3376), 1,
      anon_sym_PIPE,
    STATE(2066), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [105074] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3378), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105087] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3380), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105100] = 5,
    ACTIONS(3384), 1,
      anon_sym_COLON,
    ACTIONS(3386), 1,
      anon_sym_DOT,
    ACTIONS(3388), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3382), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [105119] = 6,
    ACTIONS(3390), 1,
      anon_sym_EQ,
    ACTIONS(3392), 1,
      anon_sym_COLON,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3394), 2,
      sym__newline,
      anon_sym_SEMI,
  [105140] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3400), 2,
      sym__newline,
      anon_sym_SEMI,
  [105161] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3360), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [105182] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3402), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [105203] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3404), 2,
      sym__newline,
      anon_sym_SEMI,
  [105224] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3064), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [105245] = 7,
    ACTIONS(3370), 1,
      anon_sym_COLON,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    ACTIONS(3376), 1,
      anon_sym_PIPE,
    ACTIONS(3406), 1,
      anon_sym_RBRACK,
    STATE(2212), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [105268] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3402), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [105289] = 4,
    ACTIONS(3410), 1,
      anon_sym_DOT,
    STATE(1793), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3408), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [105306] = 4,
    ACTIONS(3410), 1,
      anon_sym_DOT,
    STATE(1812), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3412), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [105323] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3414), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105336] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1460), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105349] = 6,
    ACTIONS(2776), 1,
      anon_sym_as,
    ACTIONS(2778), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3037), 2,
      sym__newline,
      anon_sym_SEMI,
  [105370] = 7,
    ACTIONS(3416), 1,
      aux_sym_recipe_token1,
    ACTIONS(3418), 1,
      anon_sym_NULL,
    ACTIONS(3420), 1,
      aux_sym_include_directive_token1,
    ACTIONS(3422), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1826), 1,
      aux_sym_include_directive_repeat1,
    STATE(1985), 1,
      sym_variable_expansion,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [105393] = 7,
    ACTIONS(3420), 1,
      aux_sym_include_directive_token1,
    ACTIONS(3422), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3424), 1,
      aux_sym_recipe_token1,
    ACTIONS(3426), 1,
      anon_sym_NULL,
    STATE(1826), 1,
      aux_sym_include_directive_repeat1,
    STATE(1985), 1,
      sym_variable_expansion,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [105416] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2770), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [105429] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3428), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [105442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3432), 1,
      sym__not_escape_sequence,
    ACTIONS(3430), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [105459] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1291), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [105480] = 4,
    ACTIONS(3434), 1,
      anon_sym_COMMA,
    STATE(1854), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1129), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [105497] = 4,
    ACTIONS(3436), 1,
      anon_sym_COMMA,
    STATE(1852), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(817), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [105514] = 6,
    ACTIONS(3384), 1,
      anon_sym_COLON,
    ACTIONS(3386), 1,
      anon_sym_DOT,
    ACTIONS(3388), 1,
      anon_sym_PIPE,
    ACTIONS(3438), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3440), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [105535] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3442), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [105556] = 4,
    ACTIONS(3446), 1,
      anon_sym_COMMA,
    STATE(1839), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3444), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105573] = 4,
    ACTIONS(3450), 1,
      anon_sym_COMMA,
    STATE(1843), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3448), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105590] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2770), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105603] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3452), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [105624] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3454), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [105645] = 4,
    ACTIONS(3458), 1,
      anon_sym_DOT,
    STATE(1812), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3456), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [105662] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3461), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [105683] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3224), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [105704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3465), 1,
      sym__not_escape_sequence,
    ACTIONS(3463), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [105721] = 4,
    ACTIONS(3469), 1,
      anon_sym_COMMA,
    STATE(1816), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3467), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105738] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3452), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [105759] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1460), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [105772] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3037), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [105793] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3414), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [105806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3474), 1,
      sym__not_escape_sequence,
    ACTIONS(3472), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [105823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3478), 1,
      sym__not_escape_sequence,
    ACTIONS(3476), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [105840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3482), 1,
      sym__not_escape_sequence,
    ACTIONS(3480), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [105857] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3442), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [105878] = 4,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    STATE(1808), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3362), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105895] = 7,
    ACTIONS(3486), 1,
      aux_sym_recipe_token1,
    ACTIONS(3488), 1,
      anon_sym_NULL,
    ACTIONS(3490), 1,
      aux_sym_include_directive_token1,
    ACTIONS(3493), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1826), 1,
      aux_sym_include_directive_repeat1,
    STATE(1985), 1,
      sym_variable_expansion,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [105918] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3064), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [105939] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3454), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [105960] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3496), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [105981] = 6,
    ACTIONS(3243), 1,
      anon_sym_LBRACK,
    ACTIONS(3247), 1,
      sym__concat,
    STATE(2004), 1,
      aux_sym_concatenation_repeat1,
    STATE(2238), 1,
      sym_variable_flag,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2709), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [106002] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3498), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [106023] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3500), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [106044] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3502), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [106057] = 5,
    ACTIONS(3392), 1,
      anon_sym_COLON,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3382), 3,
      sym__newline,
      anon_sym_EQ,
      anon_sym_SEMI,
  [106076] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3380), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [106089] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3378), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [106102] = 4,
    ACTIONS(3504), 1,
      anon_sym_COMMA,
    STATE(1850), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3444), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106119] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1279), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [106140] = 4,
    ACTIONS(3508), 1,
      anon_sym_COMMA,
    STATE(1843), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3506), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106157] = 4,
    ACTIONS(3510), 1,
      anon_sym_COMMA,
    STATE(1858), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3362), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106174] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3366), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [106195] = 4,
    ACTIONS(3512), 1,
      anon_sym_COMMA,
    STATE(1863), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3448), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106212] = 4,
    ACTIONS(3514), 1,
      anon_sym_COMMA,
    STATE(1843), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3467), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106229] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3452), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [106250] = 6,
    ACTIONS(3020), 1,
      anon_sym_as,
    ACTIONS(3022), 1,
      anon_sym_if,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(3026), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3037), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [106271] = 6,
    ACTIONS(2901), 1,
      anon_sym_as,
    ACTIONS(2903), 1,
      anon_sym_if,
    ACTIONS(2905), 1,
      anon_sym_and,
    ACTIONS(2907), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3402), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [106292] = 7,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(37), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(3517), 1,
      sym_identifier,
    STATE(1521), 1,
      sym_concatenation,
    STATE(2296), 1,
      sym_variable_expansion,
    STATE(2313), 1,
      sym_variable_assignment,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106315] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3428), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [106328] = 7,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3519), 1,
      anon_sym_COLON,
    ACTIONS(3521), 1,
      anon_sym_COMMA,
    ACTIONS(3523), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106351] = 4,
    ACTIONS(3525), 1,
      anon_sym_COMMA,
    STATE(1863), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3506), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106368] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3502), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [106381] = 4,
    ACTIONS(3527), 1,
      anon_sym_COMMA,
    STATE(1852), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2547), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [106398] = 4,
    ACTIONS(3530), 1,
      anon_sym_COMMA,
    STATE(1859), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3444), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106415] = 4,
    ACTIONS(3532), 1,
      anon_sym_COMMA,
    STATE(1854), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3064), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [106432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3537), 1,
      sym__not_escape_sequence,
    ACTIONS(3535), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [106449] = 7,
    ACTIONS(3370), 1,
      anon_sym_COLON,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    ACTIONS(3376), 1,
      anon_sym_PIPE,
    ACTIONS(3539), 1,
      anon_sym_RBRACK,
    STATE(2014), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106472] = 7,
    ACTIONS(3370), 1,
      anon_sym_COLON,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    ACTIONS(3376), 1,
      anon_sym_PIPE,
    ACTIONS(3541), 1,
      anon_sym_RBRACK,
    STATE(2136), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106495] = 4,
    ACTIONS(3543), 1,
      anon_sym_COMMA,
    STATE(1816), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3448), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106512] = 4,
    ACTIONS(3545), 1,
      anon_sym_COMMA,
    STATE(1816), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3506), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106529] = 5,
    ACTIONS(3114), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3547), 1,
      sym_inherit_path,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    STATE(1670), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_inherit_directive_repeat1,
  [106548] = 5,
    ACTIONS(3093), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(2129), 1,
      sym_variable_expansion,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2701), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
    ACTIONS(3549), 2,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
  [106567] = 4,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
  [106584] = 4,
    ACTIONS(3551), 1,
      anon_sym_COMMA,
    STATE(1863), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3467), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3556), 1,
      sym__not_escape_sequence,
    ACTIONS(3554), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [106618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_line_continuation,
    ACTIONS(3560), 1,
      sym__not_escape_sequence,
    ACTIONS(3558), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [106635] = 2,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3146), 5,
      aux_sym_recipe_token1,
      anon_sym_NULL,
      sym_inherit_path,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [106647] = 5,
    ACTIONS(3348), 1,
      sym_python_identifier,
    STATE(1980), 1,
      sym_dotted_name,
    STATE(2027), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3562), 2,
      sym__newline,
      anon_sym_SEMI,
  [106665] = 6,
    ACTIONS(3564), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_RBRACE,
    ACTIONS(3568), 1,
      aux_sym_format_specifier_token1,
    STATE(1891), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2132), 1,
      sym_interpolation,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [106685] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3570), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106697] = 5,
    ACTIONS(3572), 1,
      aux_sym_recipe_token1,
    ACTIONS(3576), 1,
      sym_identifier,
    STATE(1870), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3574), 2,
      anon_sym_NULL,
      anon_sym_after,
  [106715] = 4,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_if,
  [106731] = 2,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2728), 5,
      aux_sym_recipe_token1,
      anon_sym_NULL,
      sym_inherit_path,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [106743] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106763] = 6,
    ACTIONS(2695), 1,
      anon_sym_LPAREN,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    ACTIONS(3247), 1,
      sym__concat,
    STATE(2004), 1,
      aux_sym_concatenation_repeat1,
    STATE(2145), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106783] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3581), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106803] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3467), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106815] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3570), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106827] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3583), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106839] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3585), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106859] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3587), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106879] = 6,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3589), 1,
      anon_sym_COLON,
    ACTIONS(3591), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [106899] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2547), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [106911] = 4,
    ACTIONS(3593), 1,
      anon_sym_DOT,
    STATE(1883), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3456), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [106927] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3583), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106939] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3414), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [106951] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3428), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [106963] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1460), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [106975] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3467), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106987] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3467), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106999] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3583), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [107011] = 6,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3599), 1,
      anon_sym_RBRACE,
    ACTIONS(3601), 1,
      aux_sym_format_specifier_token1,
    STATE(1891), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2132), 1,
      sym_interpolation,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [107031] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3502), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107043] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3428), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107055] = 5,
    ACTIONS(3370), 1,
      anon_sym_COLON,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3376), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3604), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [107073] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3610), 1,
      anon_sym_else,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107093] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3616), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107113] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3618), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107133] = 4,
    ACTIONS(3620), 1,
      anon_sym_DOT,
    STATE(1883), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3412), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [107149] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3570), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [107161] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3622), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107181] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3624), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107201] = 2,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2724), 5,
      aux_sym_recipe_token1,
      anon_sym_NULL,
      sym_inherit_path,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [107213] = 6,
    ACTIONS(2837), 1,
      anon_sym_else,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107233] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3146), 2,
      anon_sym_fakeroot,
      sym_identifier,
    ACTIONS(3148), 3,
      sym_shell_content,
      anon_sym_RBRACE,
      anon_sym_DOLLAR_LBRACE_AT,
  [107247] = 6,
    ACTIONS(3440), 1,
      anon_sym_COMMA,
    ACTIONS(3626), 1,
      anon_sym_EQ,
    ACTIONS(3628), 1,
      anon_sym_COLON,
    ACTIONS(3630), 1,
      anon_sym_DOT,
    ACTIONS(3632), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107267] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3378), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107279] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [107291] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2770), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107303] = 6,
    ACTIONS(3634), 1,
      aux_sym_recipe_token1,
    ACTIONS(3636), 1,
      anon_sym_NULL,
    ACTIONS(3638), 1,
      anon_sym_before,
    ACTIONS(3640), 1,
      sym_identifier,
    STATE(1949), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [107323] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3642), 2,
      anon_sym_fakeroot,
      sym_identifier,
    ACTIONS(3644), 3,
      sym_shell_content,
      anon_sym_RBRACE,
      anon_sym_DOLLAR_LBRACE_AT,
  [107337] = 6,
    ACTIONS(3646), 1,
      anon_sym_DQUOTE,
    ACTIONS(3648), 1,
      anon_sym_SQUOTE,
    ACTIONS(3650), 1,
      sym_identifier,
    STATE(2247), 1,
      sym_literal,
    STATE(2308), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107357] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3652), 2,
      anon_sym_fakeroot,
      sym_identifier,
    ACTIONS(3654), 3,
      sym_shell_content,
      anon_sym_RBRACE,
      anon_sym_DOLLAR_LBRACE_AT,
  [107371] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3656), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107391] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3658), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107411] = 6,
    ACTIONS(3634), 1,
      aux_sym_recipe_token1,
    ACTIONS(3636), 1,
      anon_sym_NULL,
    ACTIONS(3638), 1,
      anon_sym_after,
    ACTIONS(3660), 1,
      sym_identifier,
    STATE(1870), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [107431] = 4,
    ACTIONS(3620), 1,
      anon_sym_DOT,
    STATE(1898), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3408), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [107447] = 6,
    ACTIONS(3662), 1,
      anon_sym_EQ,
    ACTIONS(3664), 1,
      anon_sym_COLON,
    ACTIONS(3666), 1,
      anon_sym_RBRACE,
    ACTIONS(3668), 1,
      sym_type_conversion,
    STATE(2384), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107467] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3670), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107487] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3672), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107507] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3674), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107527] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3378), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107539] = 6,
    ACTIONS(2986), 1,
      anon_sym_as,
    ACTIONS(2988), 1,
      anon_sym_if,
    ACTIONS(2990), 1,
      anon_sym_and,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3676), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107559] = 6,
    ACTIONS(2863), 1,
      anon_sym_else,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107579] = 6,
    ACTIONS(3039), 1,
      anon_sym_as,
    ACTIONS(3041), 1,
      anon_sym_if,
    ACTIONS(3043), 1,
      anon_sym_and,
    ACTIONS(3045), 1,
      anon_sym_or,
    ACTIONS(3678), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107599] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2770), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107611] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3502), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107623] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3380), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107635] = 5,
    ACTIONS(3384), 1,
      anon_sym_COLON,
    ACTIONS(3386), 1,
      anon_sym_DOT,
    ACTIONS(3388), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3440), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [107653] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3680), 2,
      anon_sym_fakeroot,
      sym_identifier,
    ACTIONS(3682), 3,
      sym_shell_content,
      anon_sym_RBRACE,
      anon_sym_DOLLAR_LBRACE_AT,
  [107667] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3456), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
  [107679] = 4,
    ACTIONS(3684), 1,
      anon_sym_COMMA,
    STATE(1932), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1129), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [107695] = 4,
    ACTIONS(3686), 1,
      anon_sym_COMMA,
    STATE(1932), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3064), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [107711] = 6,
    ACTIONS(3564), 1,
      anon_sym_LBRACE,
    ACTIONS(3689), 1,
      anon_sym_RBRACE,
    ACTIONS(3691), 1,
      aux_sym_format_specifier_token1,
    STATE(1868), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2132), 1,
      sym_interpolation,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [107731] = 5,
    ACTIONS(3628), 1,
      anon_sym_COLON,
    ACTIONS(3630), 1,
      anon_sym_DOT,
    ACTIONS(3632), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3382), 2,
      anon_sym_EQ,
      anon_sym_COMMA,
  [107749] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2596), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [107761] = 6,
    ACTIONS(2871), 1,
      anon_sym_else,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107781] = 5,
    ACTIONS(3348), 1,
      sym_python_identifier,
    STATE(1980), 1,
      sym_dotted_name,
    STATE(2027), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3562), 2,
      sym__newline,
      anon_sym_SEMI,
  [107799] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1460), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107811] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3414), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107823] = 5,
    ACTIONS(3695), 1,
      anon_sym_COMMA,
    ACTIONS(3697), 1,
      anon_sym_as,
    STATE(1968), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3693), 2,
      sym__newline,
      anon_sym_SEMI,
  [107841] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3380), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [107853] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2598), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [107865] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3699), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107885] = 5,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3701), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2791), 2,
      anon_sym_if,
      anon_sym_else,
  [107903] = 4,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2814), 3,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
  [107919] = 6,
    ACTIONS(3664), 1,
      anon_sym_COLON,
    ACTIONS(3704), 1,
      anon_sym_EQ,
    ACTIONS(3706), 1,
      anon_sym_RBRACE,
    ACTIONS(3708), 1,
      sym_type_conversion,
    STATE(2533), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [107939] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2994), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [107951] = 5,
    ACTIONS(3348), 1,
      sym_python_identifier,
    STATE(1980), 1,
      sym_dotted_name,
    STATE(2027), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3710), 2,
      sym__newline,
      anon_sym_SEMI,
  [107969] = 5,
    ACTIONS(3572), 1,
      aux_sym_recipe_token1,
    ACTIONS(3712), 1,
      sym_identifier,
    STATE(1949), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3574), 2,
      anon_sym_NULL,
      anon_sym_before,
  [107987] = 5,
    ACTIONS(3370), 1,
      anon_sym_COLON,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3376), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3382), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [108005] = 6,
    ACTIONS(3348), 1,
      sym_python_identifier,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    STATE(1940), 1,
      sym_dotted_name,
    STATE(1973), 1,
      sym_aliased_import,
    STATE(2323), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108025] = 3,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2752), 4,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_or,
  [108039] = 3,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3717), 2,
      anon_sym_fakeroot,
      sym_identifier,
    ACTIONS(3719), 3,
      sym_shell_content,
      anon_sym_RBRACE,
      anon_sym_DOLLAR_LBRACE_AT,
  [108053] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3721), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108073] = 6,
    ACTIONS(3606), 1,
      anon_sym_as,
    ACTIONS(3608), 1,
      anon_sym_if,
    ACTIONS(3612), 1,
      anon_sym_and,
    ACTIONS(3614), 1,
      anon_sym_or,
    ACTIONS(3723), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108093] = 6,
    ACTIONS(3646), 1,
      anon_sym_DQUOTE,
    ACTIONS(3648), 1,
      anon_sym_SQUOTE,
    ACTIONS(3650), 1,
      sym_identifier,
    STATE(2307), 1,
      sym_literal,
    STATE(2308), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108113] = 4,
    ACTIONS(3727), 1,
      anon_sym_DOT,
    STATE(1963), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3725), 2,
      anon_sym_import,
      sym_python_identifier,
  [108128] = 5,
    ACTIONS(3729), 1,
      aux_sym_recipe_token1,
    ACTIONS(3731), 1,
      anon_sym_NULL,
    ACTIONS(3733), 1,
      sym_identifier,
    STATE(2003), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [108145] = 4,
    ACTIONS(3737), 1,
      anon_sym_COMMA,
    STATE(1972), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3735), 2,
      sym__newline,
      anon_sym_SEMI,
  [108160] = 4,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1522), 1,
      sym_variable_expansion,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2703), 2,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
  [108175] = 4,
    ACTIONS(3104), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3739), 2,
      sym__newline,
      anon_sym_SEMI,
  [108190] = 4,
    ACTIONS(3741), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3064), 2,
      sym__newline,
      anon_sym_SEMI,
  [108205] = 4,
    ACTIONS(3746), 1,
      anon_sym_DOT,
    STATE(1963), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3744), 2,
      anon_sym_import,
      sym_python_identifier,
  [108220] = 4,
    ACTIONS(3751), 1,
      anon_sym_COMMA,
    STATE(1975), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3749), 2,
      sym__newline,
      anon_sym_SEMI,
  [108235] = 4,
    ACTIONS(3751), 1,
      anon_sym_COMMA,
    STATE(1975), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3753), 2,
      sym__newline,
      anon_sym_SEMI,
  [108250] = 4,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    STATE(1972), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3755), 2,
      sym__newline,
      anon_sym_SEMI,
  [108265] = 5,
    ACTIONS(3693), 1,
      anon_sym_RPAREN,
    ACTIONS(3759), 1,
      anon_sym_COMMA,
    ACTIONS(3761), 1,
      anon_sym_as,
    STATE(2207), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108282] = 4,
    ACTIONS(3765), 1,
      anon_sym_COMMA,
    STATE(1971), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3763), 2,
      sym__newline,
      anon_sym_SEMI,
  [108297] = 4,
    ACTIONS(3767), 1,
      anon_sym_COMMA,
    STATE(1971), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3763), 2,
      sym__newline,
      anon_sym_SEMI,
  [108312] = 5,
    ACTIONS(3664), 1,
      anon_sym_COLON,
    ACTIONS(3769), 1,
      anon_sym_RBRACE,
    ACTIONS(3771), 1,
      sym_type_conversion,
    STATE(2459), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108329] = 4,
    ACTIONS(3775), 1,
      anon_sym_COMMA,
    STATE(1971), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3773), 2,
      sym__newline,
      anon_sym_SEMI,
  [108344] = 4,
    ACTIONS(3780), 1,
      anon_sym_COMMA,
    STATE(1972), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3778), 2,
      sym__newline,
      anon_sym_SEMI,
  [108359] = 4,
    ACTIONS(3695), 1,
      anon_sym_COMMA,
    STATE(1969), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3693), 2,
      sym__newline,
      anon_sym_SEMI,
  [108374] = 5,
    ACTIONS(3783), 1,
      aux_sym_recipe_token1,
    ACTIONS(3785), 1,
      anon_sym_NULL,
    ACTIONS(3787), 1,
      anon_sym_after,
    ACTIONS(3789), 1,
      anon_sym_before,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [108391] = 4,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    STATE(1975), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3791), 2,
      sym__newline,
      anon_sym_SEMI,
  [108406] = 5,
    ACTIONS(3664), 1,
      anon_sym_COLON,
    ACTIONS(3796), 1,
      anon_sym_RBRACE,
    ACTIONS(3798), 1,
      sym_type_conversion,
    STATE(2529), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108423] = 5,
    ACTIONS(3440), 1,
      anon_sym_COMMA,
    ACTIONS(3628), 1,
      anon_sym_COLON,
    ACTIONS(3630), 1,
      anon_sym_DOT,
    ACTIONS(3632), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108440] = 5,
    ACTIONS(3710), 1,
      anon_sym_RPAREN,
    ACTIONS(3800), 1,
      sym_python_identifier,
    STATE(2162), 1,
      sym_dotted_name,
    STATE(2252), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108457] = 5,
    ACTIONS(3800), 1,
      sym_python_identifier,
    STATE(1967), 1,
      sym_dotted_name,
    STATE(2200), 1,
      sym_aliased_import,
    STATE(2573), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108474] = 3,
    ACTIONS(3697), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3802), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [108487] = 5,
    ACTIONS(3800), 1,
      sym_python_identifier,
    STATE(1967), 1,
      sym_dotted_name,
    STATE(2200), 1,
      sym_aliased_import,
    STATE(2568), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108504] = 5,
    ACTIONS(3733), 1,
      sym_identifier,
    ACTIONS(3804), 1,
      aux_sym_recipe_token1,
    ACTIONS(3806), 1,
      anon_sym_NULL,
    STATE(2003), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [108521] = 4,
    ACTIONS(3808), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1129), 2,
      sym__newline,
      anon_sym_SEMI,
  [108536] = 4,
    ACTIONS(3812), 1,
      anon_sym_COMMA,
    STATE(1966), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3810), 2,
      sym__newline,
      anon_sym_SEMI,
  [108551] = 3,
    ACTIONS(3814), 1,
      aux_sym_recipe_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3816), 3,
      anon_sym_NULL,
      aux_sym_include_directive_token1,
      anon_sym_DOLLAR_LBRACE,
  [108564] = 5,
    ACTIONS(3818), 1,
      aux_sym_recipe_token1,
    ACTIONS(3820), 1,
      anon_sym_NULL,
    ACTIONS(3822), 1,
      anon_sym_LBRACK,
    STATE(2336), 1,
      sym_variable_flag,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [108581] = 4,
    ACTIONS(3093), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(2129), 1,
      sym_variable_expansion,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3549), 2,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
  [108596] = 4,
    ACTIONS(3247), 1,
      sym__concat,
    STATE(2004), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2709), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [108611] = 4,
    ACTIONS(3751), 1,
      anon_sym_COMMA,
    STATE(1964), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3824), 2,
      sym__newline,
      anon_sym_SEMI,
  [108626] = 4,
    ACTIONS(3104), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3826), 2,
      sym__newline,
      anon_sym_SEMI,
  [108641] = 4,
    ACTIONS(3751), 1,
      anon_sym_COMMA,
    STATE(1965), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3828), 2,
      sym__newline,
      anon_sym_SEMI,
  [108656] = 4,
    ACTIONS(3830), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1283), 2,
      sym__newline,
      anon_sym_SEMI,
  [108671] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3456), 4,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
  [108682] = 3,
    ACTIONS(2730), 1,
      aux_sym_recipe_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2728), 3,
      anon_sym_NULL,
      aux_sym_include_directive_token1,
      anon_sym_DOLLAR_LBRACE,
  [108695] = 5,
    ACTIONS(3562), 1,
      anon_sym_RPAREN,
    ACTIONS(3800), 1,
      sym_python_identifier,
    STATE(2162), 1,
      sym_dotted_name,
    STATE(2252), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108712] = 5,
    ACTIONS(3348), 1,
      sym_python_identifier,
    STATE(1940), 1,
      sym_dotted_name,
    STATE(1973), 1,
      sym_aliased_import,
    STATE(2239), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108729] = 5,
    ACTIONS(3420), 1,
      aux_sym_include_directive_token1,
    ACTIONS(3832), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1797), 1,
      aux_sym_include_directive_repeat1,
    STATE(1985), 1,
      sym_variable_expansion,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108746] = 5,
    ACTIONS(3562), 1,
      anon_sym_RPAREN,
    ACTIONS(3800), 1,
      sym_python_identifier,
    STATE(2162), 1,
      sym_dotted_name,
    STATE(2252), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108763] = 5,
    ACTIONS(3420), 1,
      aux_sym_include_directive_token1,
    ACTIONS(3832), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1798), 1,
      aux_sym_include_directive_repeat1,
    STATE(1985), 1,
      sym_variable_expansion,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108780] = 4,
    ACTIONS(3834), 1,
      anon_sym_EQ,
    ACTIONS(3836), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108795] = 3,
    ACTIONS(2726), 1,
      aux_sym_recipe_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2724), 3,
      anon_sym_NULL,
      aux_sym_include_directive_token1,
      anon_sym_DOLLAR_LBRACE,
  [108808] = 4,
    ACTIONS(3840), 1,
      sym__concat,
    STATE(2002), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [108823] = 5,
    ACTIONS(3572), 1,
      aux_sym_recipe_token1,
    ACTIONS(3574), 1,
      anon_sym_NULL,
    ACTIONS(3843), 1,
      sym_identifier,
    STATE(2003), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [108840] = 4,
    ACTIONS(3846), 1,
      sym__concat,
    STATE(2002), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2713), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [108855] = 4,
    ACTIONS(3848), 1,
      anon_sym_RBRACK,
    ACTIONS(3850), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108869] = 4,
    ACTIONS(1643), 1,
      anon_sym_RPAREN,
    ACTIONS(3852), 1,
      anon_sym_COMMA,
    STATE(2211), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108883] = 4,
    ACTIONS(2867), 1,
      anon_sym_RPAREN,
    ACTIONS(2869), 1,
      anon_sym_COMMA,
    STATE(2193), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108897] = 4,
    ACTIONS(3854), 1,
      anon_sym_COLON,
    ACTIONS(3856), 1,
      anon_sym_DQUOTE,
    STATE(2220), 1,
      aux_sym_overrides_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108911] = 4,
    ACTIONS(3064), 1,
      anon_sym_COLON,
    ACTIONS(3858), 1,
      anon_sym_COMMA,
    STATE(2009), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108925] = 4,
    ACTIONS(3266), 1,
      anon_sym_RBRACE,
    ACTIONS(3268), 1,
      anon_sym_COMMA,
    STATE(2025), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108939] = 4,
    ACTIONS(3861), 1,
      anon_sym_COMMA,
    ACTIONS(3863), 1,
      anon_sym_in,
    STATE(2022), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108953] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2873), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108967] = 4,
    ACTIONS(1129), 1,
      anon_sym_COLON,
    ACTIONS(3865), 1,
      anon_sym_COMMA,
    STATE(2009), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108981] = 4,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    ACTIONS(3867), 1,
      anon_sym_RBRACK,
    STATE(2119), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [108995] = 4,
    ACTIONS(3664), 1,
      anon_sym_COLON,
    ACTIONS(3869), 1,
      anon_sym_RBRACE,
    STATE(2519), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109009] = 4,
    ACTIONS(3861), 1,
      anon_sym_COMMA,
    ACTIONS(3871), 1,
      anon_sym_in,
    STATE(2022), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109023] = 4,
    ACTIONS(443), 1,
      sym__newline,
    ACTIONS(3873), 1,
      anon_sym_SEMI,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109037] = 3,
    ACTIONS(1541), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1539), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [109049] = 4,
    ACTIONS(3875), 1,
      anon_sym_RPAREN,
    ACTIONS(3877), 1,
      anon_sym_COMMA,
    STATE(2100), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109063] = 4,
    ACTIONS(1041), 1,
      anon_sym_RPAREN,
    ACTIONS(3879), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109077] = 4,
    ACTIONS(1289), 1,
      anon_sym_COLON,
    ACTIONS(3881), 1,
      anon_sym_COMMA,
    STATE(2103), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109091] = 4,
    ACTIONS(817), 1,
      anon_sym_in,
    ACTIONS(3883), 1,
      anon_sym_COMMA,
    STATE(2037), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109105] = 4,
    ACTIONS(1025), 1,
      anon_sym_RPAREN,
    ACTIONS(3885), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109119] = 4,
    ACTIONS(3887), 1,
      anon_sym_RBRACK,
    ACTIONS(3889), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109133] = 4,
    ACTIONS(1145), 1,
      anon_sym_RBRACE,
    ACTIONS(3891), 1,
      anon_sym_COMMA,
    STATE(2148), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109147] = 3,
    ACTIONS(1533), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1531), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [109159] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3802), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [109169] = 4,
    ACTIONS(3861), 1,
      anon_sym_COMMA,
    ACTIONS(3893), 1,
      anon_sym_in,
    STATE(2022), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109183] = 4,
    ACTIONS(3895), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 1,
      sym__newline,
    STATE(2151), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109197] = 4,
    ACTIONS(3664), 1,
      anon_sym_COLON,
    ACTIONS(3899), 1,
      anon_sym_RBRACE,
    STATE(2527), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109211] = 4,
    ACTIONS(425), 1,
      sym__newline,
    ACTIONS(3901), 1,
      anon_sym_SEMI,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109225] = 4,
    ACTIONS(3903), 1,
      anon_sym_SEMI,
    ACTIONS(3906), 1,
      sym__newline,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109239] = 4,
    ACTIONS(2547), 1,
      anon_sym_RBRACK,
    ACTIONS(3908), 1,
      anon_sym_COMMA,
    STATE(2033), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109253] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3911), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [109263] = 4,
    ACTIONS(3913), 1,
      anon_sym_SEMI,
    ACTIONS(3915), 1,
      sym__newline,
    STATE(2017), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109277] = 4,
    ACTIONS(2818), 1,
      anon_sym_RPAREN,
    ACTIONS(2820), 1,
      anon_sym_COMMA,
    STATE(2020), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109291] = 4,
    ACTIONS(2547), 1,
      anon_sym_in,
    ACTIONS(3917), 1,
      anon_sym_COMMA,
    STATE(2037), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109305] = 4,
    ACTIONS(3920), 1,
      anon_sym_RPAREN,
    ACTIONS(3922), 1,
      anon_sym_COMMA,
    STATE(2023), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109319] = 4,
    ACTIONS(1053), 1,
      anon_sym_RPAREN,
    ACTIONS(3924), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109333] = 4,
    ACTIONS(3071), 1,
      anon_sym_RBRACK,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    STATE(2005), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109347] = 4,
    ACTIONS(1051), 1,
      anon_sym_RPAREN,
    ACTIONS(3926), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109361] = 4,
    ACTIONS(3928), 1,
      anon_sym_RPAREN,
    ACTIONS(3930), 1,
      anon_sym_COMMA,
    STATE(2224), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109375] = 4,
    ACTIONS(3932), 1,
      anon_sym_RBRACK,
    ACTIONS(3934), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109389] = 4,
    ACTIONS(1163), 1,
      anon_sym_RBRACE,
    ACTIONS(3936), 1,
      anon_sym_COMMA,
    STATE(2148), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109403] = 4,
    ACTIONS(3938), 1,
      anon_sym_COLON,
    ACTIONS(3940), 1,
      anon_sym_LPAREN,
    STATE(2444), 1,
      sym_override,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109417] = 4,
    ACTIONS(3942), 1,
      anon_sym_RBRACK,
    ACTIONS(3944), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109431] = 4,
    ACTIONS(3938), 1,
      anon_sym_COLON,
    ACTIONS(3946), 1,
      anon_sym_LPAREN,
    STATE(2500), 1,
      sym_override,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109445] = 4,
    ACTIONS(3861), 1,
      anon_sym_COMMA,
    ACTIONS(3948), 1,
      anon_sym_in,
    STATE(2022), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109459] = 4,
    ACTIONS(3032), 1,
      anon_sym_LPAREN,
    ACTIONS(3938), 1,
      anon_sym_COLON,
    STATE(2502), 1,
      sym_override,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109473] = 3,
    ACTIONS(1577), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1575), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [109485] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(3950), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109499] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(3952), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109513] = 4,
    ACTIONS(3954), 1,
      anon_sym_SEMI,
    ACTIONS(3956), 1,
      sym__newline,
    STATE(2031), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109527] = 4,
    ACTIONS(3630), 1,
      anon_sym_DOT,
    ACTIONS(3632), 1,
      anon_sym_PIPE,
    ACTIONS(3958), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109541] = 4,
    ACTIONS(2879), 1,
      anon_sym_RPAREN,
    ACTIONS(2881), 1,
      anon_sym_COMMA,
    STATE(2039), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109555] = 4,
    ACTIONS(3861), 1,
      anon_sym_COMMA,
    ACTIONS(3960), 1,
      anon_sym_in,
    STATE(2022), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109569] = 4,
    ACTIONS(3329), 1,
      anon_sym_RBRACE,
    ACTIONS(3331), 1,
      anon_sym_COMMA,
    STATE(2044), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109583] = 4,
    ACTIONS(3630), 1,
      anon_sym_DOT,
    ACTIONS(3632), 1,
      anon_sym_PIPE,
    ACTIONS(3962), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109597] = 4,
    ACTIONS(3964), 1,
      anon_sym_RPAREN,
    ACTIONS(3966), 1,
      anon_sym_COMMA,
    STATE(2041), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109611] = 4,
    ACTIONS(3140), 1,
      anon_sym_RBRACK,
    ACTIONS(3142), 1,
      anon_sym_COMMA,
    STATE(2073), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109625] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2816), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109639] = 4,
    ACTIONS(3106), 1,
      anon_sym_RBRACK,
    ACTIONS(3108), 1,
      anon_sym_COMMA,
    STATE(2046), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109653] = 3,
    ACTIONS(1537), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1535), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [109665] = 4,
    ACTIONS(3968), 1,
      anon_sym_COLON,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(2021), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109679] = 4,
    ACTIONS(3972), 1,
      anon_sym_RPAREN,
    ACTIONS(3974), 1,
      anon_sym_COMMA,
    STATE(2082), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109693] = 4,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    ACTIONS(3976), 1,
      anon_sym_RBRACK,
    STATE(2119), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109707] = 4,
    ACTIONS(3861), 1,
      anon_sym_COMMA,
    ACTIONS(3978), 1,
      anon_sym_in,
    STATE(2022), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109721] = 4,
    ACTIONS(1193), 1,
      anon_sym_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_COMMA,
    STATE(2148), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109735] = 4,
    ACTIONS(3064), 1,
      anon_sym_RPAREN,
    ACTIONS(3982), 1,
      anon_sym_COMMA,
    STATE(2069), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109749] = 4,
    ACTIONS(2859), 1,
      anon_sym_RPAREN,
    ACTIONS(2861), 1,
      anon_sym_COMMA,
    STATE(2093), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109763] = 4,
    ACTIONS(3985), 1,
      anon_sym_SEMI,
    ACTIONS(3987), 1,
      sym__newline,
    STATE(2111), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109777] = 3,
    ACTIONS(1529), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1527), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [109789] = 4,
    ACTIONS(3989), 1,
      anon_sym_RBRACK,
    ACTIONS(3991), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109803] = 4,
    ACTIONS(3993), 1,
      anon_sym_RBRACK,
    ACTIONS(3995), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109817] = 4,
    ACTIONS(3997), 1,
      anon_sym_RPAREN,
    ACTIONS(3999), 1,
      anon_sym_COMMA,
    STATE(2075), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109831] = 4,
    ACTIONS(3315), 1,
      anon_sym_RBRACE,
    ACTIONS(3317), 1,
      anon_sym_COMMA,
    STATE(2068), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109845] = 4,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    ACTIONS(2800), 1,
      anon_sym_COMMA,
    STATE(2214), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109859] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2887), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109873] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2865), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109887] = 4,
    ACTIONS(3181), 1,
      anon_sym_RBRACK,
    ACTIONS(3183), 1,
      anon_sym_COMMA,
    STATE(2227), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109901] = 4,
    ACTIONS(3295), 1,
      anon_sym_RBRACE,
    ACTIONS(3297), 1,
      anon_sym_COMMA,
    STATE(2174), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109915] = 4,
    ACTIONS(1067), 1,
      anon_sym_RPAREN,
    ACTIONS(4002), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109929] = 4,
    ACTIONS(3237), 1,
      anon_sym_RBRACE,
    ACTIONS(3239), 1,
      anon_sym_COMMA,
    STATE(2097), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109943] = 4,
    ACTIONS(3938), 1,
      anon_sym_COLON,
    ACTIONS(4004), 1,
      anon_sym_LPAREN,
    STATE(2458), 1,
      sym_override,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109957] = 4,
    ACTIONS(3452), 1,
      anon_sym_RBRACE,
    ACTIONS(4006), 1,
      anon_sym_COMMA,
    STATE(2085), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109971] = 4,
    ACTIONS(3496), 1,
      anon_sym_RPAREN,
    ACTIONS(4009), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109985] = 4,
    ACTIONS(4012), 1,
      anon_sym_RBRACK,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [109999] = 4,
    ACTIONS(4016), 1,
      anon_sym_RBRACK,
    ACTIONS(4018), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110013] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3791), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [110023] = 4,
    ACTIONS(2796), 1,
      anon_sym_RPAREN,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110037] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(4020), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110051] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(4022), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110065] = 4,
    ACTIONS(1065), 1,
      anon_sym_RPAREN,
    ACTIONS(4024), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110079] = 3,
    ACTIONS(4026), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [110091] = 4,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
    ACTIONS(4028), 1,
      anon_sym_COMMA,
    STATE(2069), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110105] = 4,
    ACTIONS(1117), 1,
      anon_sym_RBRACE,
    ACTIONS(4030), 1,
      anon_sym_COMMA,
    STATE(2085), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110119] = 4,
    ACTIONS(1153), 1,
      anon_sym_RBRACE,
    ACTIONS(4032), 1,
      anon_sym_COMMA,
    STATE(2148), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110133] = 4,
    ACTIONS(3130), 1,
      anon_sym_RBRACK,
    ACTIONS(3132), 1,
      anon_sym_COMMA,
    STATE(2088), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110147] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2730), 3,
      sym__concat,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [110157] = 4,
    ACTIONS(1299), 1,
      anon_sym_RPAREN,
    ACTIONS(4034), 1,
      anon_sym_COMMA,
    STATE(2075), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110171] = 4,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    STATE(2096), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110185] = 4,
    ACTIONS(3134), 1,
      anon_sym_RBRACK,
    ACTIONS(3136), 1,
      anon_sym_COMMA,
    STATE(2115), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110199] = 4,
    ACTIONS(3997), 1,
      anon_sym_COLON,
    ACTIONS(4036), 1,
      anon_sym_COMMA,
    STATE(2103), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110213] = 4,
    ACTIONS(4039), 1,
      anon_sym_COLON,
    ACTIONS(4041), 1,
      anon_sym_COMMA,
    STATE(2150), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110227] = 4,
    ACTIONS(4043), 1,
      anon_sym_RPAREN,
    ACTIONS(4045), 1,
      anon_sym_COMMA,
    STATE(2118), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110241] = 4,
    ACTIONS(2897), 1,
      anon_sym_RPAREN,
    ACTIONS(2899), 1,
      anon_sym_COMMA,
    STATE(2120), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110255] = 4,
    ACTIONS(3348), 1,
      sym_python_identifier,
    STATE(1980), 1,
      sym_dotted_name,
    STATE(2027), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110269] = 4,
    ACTIONS(4047), 1,
      anon_sym_SEMI,
    ACTIONS(4049), 1,
      sym__newline,
    STATE(2123), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110283] = 4,
    ACTIONS(3664), 1,
      anon_sym_COLON,
    ACTIONS(4051), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110297] = 3,
    ACTIONS(4026), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [110309] = 4,
    ACTIONS(419), 1,
      sym__newline,
    ACTIONS(4053), 1,
      anon_sym_SEMI,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110323] = 4,
    ACTIONS(4055), 1,
      anon_sym_RBRACK,
    ACTIONS(4057), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110337] = 4,
    ACTIONS(3800), 1,
      sym_python_identifier,
    STATE(2162), 1,
      sym_dotted_name,
    STATE(2252), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110351] = 4,
    ACTIONS(1643), 1,
      anon_sym_RBRACK,
    ACTIONS(4060), 1,
      anon_sym_COMMA,
    STATE(2033), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110365] = 4,
    ACTIONS(4062), 1,
      anon_sym_RBRACK,
    ACTIONS(4064), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110379] = 4,
    ACTIONS(4066), 1,
      anon_sym_RBRACK,
    ACTIONS(4068), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110393] = 4,
    ACTIONS(3452), 1,
      anon_sym_RBRACK,
    ACTIONS(4070), 1,
      anon_sym_COMMA,
    STATE(2117), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110407] = 4,
    ACTIONS(985), 1,
      anon_sym_RPAREN,
    ACTIONS(4073), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110421] = 4,
    ACTIONS(3604), 1,
      anon_sym_RBRACK,
    ACTIONS(4075), 1,
      anon_sym_COMMA,
    STATE(2119), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110435] = 4,
    ACTIONS(1055), 1,
      anon_sym_RPAREN,
    ACTIONS(4078), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110449] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2726), 3,
      sym__concat,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [110459] = 4,
    ACTIONS(429), 1,
      sym__newline,
    ACTIONS(4080), 1,
      anon_sym_SEMI,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110473] = 4,
    ACTIONS(435), 1,
      sym__newline,
    ACTIONS(4082), 1,
      anon_sym_SEMI,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110487] = 4,
    ACTIONS(3861), 1,
      anon_sym_COMMA,
    ACTIONS(4084), 1,
      anon_sym_in,
    STATE(2022), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110501] = 4,
    ACTIONS(3861), 1,
      anon_sym_COMMA,
    ACTIONS(4086), 1,
      anon_sym_in,
    STATE(2022), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110515] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2105), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [110525] = 4,
    ACTIONS(3938), 1,
      anon_sym_COLON,
    ACTIONS(4088), 1,
      anon_sym_LPAREN,
    STATE(2579), 1,
      sym_override,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110539] = 4,
    ACTIONS(415), 1,
      sym__newline,
    ACTIONS(4090), 1,
      anon_sym_SEMI,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110553] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2719), 3,
      sym__concat,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [110563] = 4,
    ACTIONS(4092), 1,
      anon_sym_RBRACK,
    ACTIONS(4094), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110577] = 4,
    ACTIONS(2695), 1,
      anon_sym_LPAREN,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    STATE(2145), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110591] = 3,
    ACTIONS(4098), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4096), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [110603] = 4,
    ACTIONS(2736), 1,
      anon_sym_RPAREN,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110617] = 4,
    ACTIONS(4100), 1,
      anon_sym_RBRACK,
    ACTIONS(4102), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110631] = 4,
    ACTIONS(3664), 1,
      anon_sym_COLON,
    ACTIONS(4104), 1,
      anon_sym_RBRACE,
    STATE(2518), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110645] = 4,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    ACTIONS(4106), 1,
      anon_sym_RBRACK,
    STATE(2119), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110659] = 4,
    ACTIONS(1027), 1,
      anon_sym_RPAREN,
    ACTIONS(4108), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110673] = 4,
    ACTIONS(4039), 1,
      anon_sym_RPAREN,
    ACTIONS(4110), 1,
      anon_sym_COMMA,
    STATE(2157), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110687] = 3,
    ACTIONS(3834), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110699] = 4,
    ACTIONS(1021), 1,
      anon_sym_RPAREN,
    ACTIONS(4112), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110713] = 3,
    ACTIONS(4114), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110725] = 4,
    ACTIONS(4116), 1,
      anon_sym_RBRACK,
    ACTIONS(4118), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110739] = 4,
    ACTIONS(3854), 1,
      anon_sym_COLON,
    ACTIONS(4120), 1,
      anon_sym_DQUOTE,
    STATE(2008), 1,
      aux_sym_overrides_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110753] = 4,
    ACTIONS(4122), 1,
      anon_sym_SEMI,
    ACTIONS(4124), 1,
      sym__newline,
    STATE(2128), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110767] = 4,
    ACTIONS(2877), 1,
      anon_sym_LPAREN,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    STATE(2160), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110781] = 4,
    ACTIONS(4126), 1,
      anon_sym_RBRACK,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110795] = 4,
    ACTIONS(2877), 1,
      anon_sym_LPAREN,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    STATE(2163), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110809] = 4,
    ACTIONS(4130), 1,
      anon_sym_RBRACE,
    ACTIONS(4132), 1,
      anon_sym_COMMA,
    STATE(2148), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110823] = 4,
    ACTIONS(3773), 1,
      anon_sym_RPAREN,
    ACTIONS(4135), 1,
      anon_sym_COMMA,
    STATE(2149), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110837] = 4,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    STATE(2205), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110851] = 4,
    ACTIONS(421), 1,
      sym__newline,
    ACTIONS(4140), 1,
      anon_sym_SEMI,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110865] = 4,
    ACTIONS(3164), 1,
      anon_sym_RBRACK,
    ACTIONS(3166), 1,
      anon_sym_COMMA,
    STATE(2134), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110879] = 3,
    ACTIONS(4144), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4142), 2,
      sym__newline,
      anon_sym_SEMI,
  [110891] = 4,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
    ACTIONS(4146), 1,
      anon_sym_COMMA,
    STATE(2179), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110905] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1484), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110915] = 4,
    ACTIONS(4148), 1,
      anon_sym_RBRACK,
    ACTIONS(4150), 1,
      anon_sym_COMMA,
    STATE(2114), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110929] = 4,
    ACTIONS(2705), 1,
      anon_sym_RPAREN,
    ACTIONS(4152), 1,
      anon_sym_COMMA,
    STATE(2187), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110943] = 4,
    ACTIONS(4154), 1,
      anon_sym_SEMI,
    ACTIONS(4156), 1,
      sym__newline,
    STATE(2122), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110957] = 3,
    ACTIONS(3052), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3050), 2,
      sym__newline,
      anon_sym_SEMI,
  [110969] = 4,
    ACTIONS(2709), 1,
      anon_sym_LPAREN,
    ACTIONS(4158), 1,
      anon_sym_COLON,
    STATE(2160), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110983] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2889), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [110997] = 3,
    ACTIONS(3761), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3802), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [111009] = 4,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    STATE(2160), 1,
      aux_sym_override_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111023] = 4,
    ACTIONS(2841), 1,
      anon_sym_RPAREN,
    ACTIONS(2843), 1,
      anon_sym_COMMA,
    STATE(2137), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111037] = 4,
    ACTIONS(4161), 1,
      anon_sym_RPAREN,
    ACTIONS(4163), 1,
      anon_sym_COMMA,
    STATE(2140), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111051] = 4,
    ACTIONS(3305), 1,
      anon_sym_RBRACE,
    ACTIONS(3307), 1,
      anon_sym_COMMA,
    STATE(2177), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111065] = 4,
    ACTIONS(1129), 1,
      anon_sym_RBRACK,
    ACTIONS(4165), 1,
      anon_sym_COMMA,
    STATE(2216), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111079] = 3,
    ACTIONS(3472), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3474), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [111091] = 4,
    ACTIONS(4148), 1,
      anon_sym_RPAREN,
    ACTIONS(4167), 1,
      anon_sym_COMMA,
    STATE(2006), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111105] = 4,
    ACTIONS(3218), 1,
      anon_sym_RBRACK,
    ACTIONS(3220), 1,
      anon_sym_COMMA,
    STATE(2146), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111119] = 4,
    ACTIONS(417), 1,
      sym__newline,
    ACTIONS(4169), 1,
      anon_sym_SEMI,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111133] = 4,
    ACTIONS(3456), 1,
      anon_sym_import,
    ACTIONS(4171), 1,
      anon_sym_DOT,
    STATE(2172), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111147] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1484), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
  [111157] = 4,
    ACTIONS(1175), 1,
      anon_sym_RBRACE,
    ACTIONS(4174), 1,
      anon_sym_COMMA,
    STATE(2148), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111171] = 4,
    ACTIONS(1155), 1,
      anon_sym_RBRACE,
    ACTIONS(4176), 1,
      anon_sym_COMMA,
    STATE(2148), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111185] = 3,
    ACTIONS(3480), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3482), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [111197] = 4,
    ACTIONS(1151), 1,
      anon_sym_RBRACE,
    ACTIONS(4178), 1,
      anon_sym_COMMA,
    STATE(2148), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111211] = 4,
    ACTIONS(1029), 1,
      anon_sym_RPAREN,
    ACTIONS(4180), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111225] = 4,
    ACTIONS(3452), 1,
      anon_sym_RPAREN,
    ACTIONS(4182), 1,
      anon_sym_COMMA,
    STATE(2179), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111239] = 4,
    ACTIONS(1003), 1,
      anon_sym_RPAREN,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111253] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2596), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [111263] = 4,
    ACTIONS(3199), 1,
      anon_sym_RBRACK,
    ACTIONS(3201), 1,
      anon_sym_COMMA,
    STATE(2194), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111277] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2116), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [111287] = 3,
    ACTIONS(3476), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3478), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [111299] = 4,
    ACTIONS(4187), 1,
      anon_sym_RPAREN,
    ACTIONS(4189), 1,
      anon_sym_COMMA,
    STATE(2197), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111313] = 4,
    ACTIONS(2754), 1,
      anon_sym_RPAREN,
    ACTIONS(2756), 1,
      anon_sym_COMMA,
    STATE(2199), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111327] = 4,
    ACTIONS(4191), 1,
      anon_sym_RPAREN,
    ACTIONS(4193), 1,
      anon_sym_COMMA,
    STATE(2187), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111341] = 4,
    ACTIONS(4196), 1,
      anon_sym_SEMI,
    ACTIONS(4198), 1,
      sym__newline,
    STATE(2202), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111355] = 3,
    ACTIONS(3463), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3465), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [111367] = 4,
    ACTIONS(4200), 1,
      anon_sym_RBRACK,
    ACTIONS(4202), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111381] = 4,
    ACTIONS(4204), 1,
      anon_sym_RBRACK,
    ACTIONS(4206), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111395] = 4,
    ACTIONS(3408), 1,
      anon_sym_import,
    ACTIONS(4208), 1,
      anon_sym_DOT,
    STATE(2217), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111409] = 4,
    ACTIONS(1007), 1,
      anon_sym_RPAREN,
    ACTIONS(4210), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111423] = 4,
    ACTIONS(4212), 1,
      anon_sym_RBRACK,
    ACTIONS(4214), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111437] = 4,
    ACTIONS(4216), 1,
      anon_sym_RBRACK,
    ACTIONS(4218), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111451] = 4,
    ACTIONS(3313), 1,
      sym_python_identifier,
    ACTIONS(4220), 1,
      anon_sym_import,
    STATE(2514), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111465] = 4,
    ACTIONS(1013), 1,
      anon_sym_RPAREN,
    ACTIONS(4222), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111479] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(4224), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111493] = 4,
    ACTIONS(1011), 1,
      anon_sym_RPAREN,
    ACTIONS(4226), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111507] = 4,
    ACTIONS(3693), 1,
      anon_sym_RPAREN,
    ACTIONS(3759), 1,
      anon_sym_COMMA,
    STATE(2209), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111521] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2839), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111535] = 4,
    ACTIONS(437), 1,
      sym__newline,
    ACTIONS(4228), 1,
      anon_sym_SEMI,
    STATE(2032), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111549] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(4230), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111563] = 4,
    ACTIONS(3350), 1,
      anon_sym_RBRACE,
    ACTIONS(3352), 1,
      anon_sym_COMMA,
    STATE(2222), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111577] = 4,
    ACTIONS(4191), 1,
      anon_sym_COLON,
    ACTIONS(4232), 1,
      anon_sym_COMMA,
    STATE(2205), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111591] = 4,
    ACTIONS(4235), 1,
      anon_sym_SEMI,
    ACTIONS(4237), 1,
      sym__newline,
    STATE(2171), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111605] = 4,
    ACTIONS(3763), 1,
      anon_sym_RPAREN,
    ACTIONS(4239), 1,
      anon_sym_COMMA,
    STATE(2149), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111619] = 4,
    ACTIONS(2883), 1,
      anon_sym_RPAREN,
    ACTIONS(2885), 1,
      anon_sym_COMMA,
    STATE(2178), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111633] = 4,
    ACTIONS(3763), 1,
      anon_sym_RPAREN,
    ACTIONS(4241), 1,
      anon_sym_COMMA,
    STATE(2149), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111647] = 4,
    ACTIONS(3354), 1,
      anon_sym_RBRACE,
    ACTIONS(3356), 1,
      anon_sym_COMMA,
    STATE(2175), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111661] = 4,
    ACTIONS(2547), 1,
      anon_sym_RPAREN,
    ACTIONS(4243), 1,
      anon_sym_COMMA,
    STATE(2211), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111675] = 4,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    ACTIONS(4246), 1,
      anon_sym_RBRACK,
    STATE(2119), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111689] = 3,
    ACTIONS(3430), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3432), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [111701] = 4,
    ACTIONS(1117), 1,
      anon_sym_RBRACK,
    ACTIONS(4248), 1,
      anon_sym_COMMA,
    STATE(2117), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111715] = 4,
    ACTIONS(4250), 1,
      anon_sym_RPAREN,
    ACTIONS(4252), 1,
      anon_sym_COMMA,
    STATE(2180), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111729] = 4,
    ACTIONS(3064), 1,
      anon_sym_RBRACK,
    ACTIONS(4254), 1,
      anon_sym_COMMA,
    STATE(2216), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111743] = 4,
    ACTIONS(3412), 1,
      anon_sym_import,
    ACTIONS(4208), 1,
      anon_sym_DOT,
    STATE(2172), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111757] = 4,
    ACTIONS(3214), 1,
      anon_sym_RBRACK,
    ACTIONS(3216), 1,
      anon_sym_COMMA,
    STATE(2191), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111771] = 3,
    ACTIONS(3535), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3537), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [111783] = 4,
    ACTIONS(4257), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_DQUOTE,
    STATE(2220), 1,
      aux_sym_overrides_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111797] = 4,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2832), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111811] = 4,
    ACTIONS(1157), 1,
      anon_sym_RBRACE,
    ACTIONS(4262), 1,
      anon_sym_COMMA,
    STATE(2148), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111825] = 3,
    ACTIONS(3558), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3560), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [111837] = 4,
    ACTIONS(1009), 1,
      anon_sym_RPAREN,
    ACTIONS(4264), 1,
      anon_sym_COMMA,
    STATE(2086), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111851] = 4,
    ACTIONS(4266), 1,
      anon_sym_RBRACK,
    ACTIONS(4268), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111865] = 3,
    ACTIONS(3554), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3556), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [111877] = 4,
    ACTIONS(4270), 1,
      anon_sym_RBRACK,
    ACTIONS(4272), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111891] = 3,
    ACTIONS(1781), 1,
      aux_sym_recipe_token1,
    ACTIONS(1783), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [111902] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4260), 2,
      anon_sym_COLON,
      anon_sym_DQUOTE,
  [111911] = 3,
    ACTIONS(4274), 1,
      aux_sym_recipe_token1,
    ACTIONS(4276), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [111922] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2994), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [111931] = 3,
    ACTIONS(1535), 1,
      aux_sym_recipe_token1,
    ACTIONS(1537), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [111942] = 3,
    ACTIONS(4278), 1,
      anon_sym_RBRACE,
    ACTIONS(4280), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [111953] = 3,
    ACTIONS(3680), 1,
      anon_sym_NULL,
    ACTIONS(3682), 1,
      aux_sym_recipe_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [111964] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2547), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [111973] = 3,
    ACTIONS(4282), 1,
      aux_sym_recipe_token1,
    ACTIONS(4284), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [111984] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2598), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [111993] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2925), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [112002] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4286), 2,
      sym__newline,
      anon_sym_SEMI,
  [112011] = 3,
    ACTIONS(1575), 1,
      aux_sym_recipe_token1,
    ACTIONS(1577), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112022] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4191), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [112031] = 3,
    ACTIONS(1531), 1,
      aux_sym_recipe_token1,
    ACTIONS(1533), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112042] = 3,
    ACTIONS(1527), 1,
      aux_sym_recipe_token1,
    ACTIONS(1529), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112053] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4191), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112062] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3452), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112071] = 3,
    ACTIONS(4288), 1,
      anon_sym_COMMA,
    STATE(1804), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112082] = 3,
    ACTIONS(4290), 1,
      aux_sym_recipe_token1,
    ACTIONS(4292), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112093] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3456), 2,
      anon_sym_import,
      anon_sym_DOT,
  [112102] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3185), 2,
      sym__newline,
      anon_sym_SEMI,
  [112111] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4294), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112120] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4296), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112129] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3802), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112138] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3171), 2,
      sym__newline,
      anon_sym_SEMI,
  [112147] = 3,
    ACTIONS(4298), 1,
      aux_sym_recipe_token1,
    ACTIONS(4300), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112158] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4302), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [112167] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4304), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [112176] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2709), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [112185] = 3,
    ACTIONS(4306), 1,
      anon_sym_RBRACE,
    ACTIONS(4308), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112196] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2994), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112205] = 3,
    ACTIONS(1793), 1,
      aux_sym_recipe_token1,
    ACTIONS(1795), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112216] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112225] = 3,
    ACTIONS(4310), 1,
      anon_sym_RBRACE,
    ACTIONS(4312), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112236] = 3,
    ACTIONS(2945), 1,
      anon_sym_NULL,
    ACTIONS(2947), 1,
      aux_sym_recipe_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112247] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3911), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112256] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112265] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4130), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [112274] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4304), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112283] = 3,
    ACTIONS(1539), 1,
      aux_sym_recipe_token1,
    ACTIONS(1541), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112294] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [112303] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4314), 2,
      sym__newline,
      anon_sym_SEMI,
  [112312] = 3,
    ACTIONS(4316), 1,
      aux_sym_recipe_token1,
    ACTIONS(4318), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112323] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4320), 2,
      sym__newline,
      anon_sym_SEMI,
  [112332] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3997), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112341] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3452), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [112350] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3276), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [112359] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4294), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [112368] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4296), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [112377] = 3,
    ACTIONS(4322), 1,
      anon_sym_RBRACE,
    ACTIONS(4324), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112388] = 3,
    ACTIONS(4326), 1,
      anon_sym_LPAREN,
    STATE(2302), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112399] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [112408] = 3,
    ACTIONS(4328), 1,
      sym_identifier,
    STATE(1982), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112419] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3997), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [112428] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2947), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [112437] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(1387), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [112446] = 3,
    ACTIONS(4330), 1,
      anon_sym_python,
    ACTIONS(4332), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112457] = 3,
    ACTIONS(4334), 1,
      anon_sym_LPAREN,
    ACTIONS(4336), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112468] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4296), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [112477] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4294), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [112486] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3452), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [112495] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4338), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112504] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3496), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112513] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4340), 2,
      sym__newline,
      anon_sym_SEMI,
  [112522] = 3,
    ACTIONS(4342), 1,
      anon_sym_RBRACE,
    ACTIONS(4344), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112533] = 3,
    ACTIONS(3247), 1,
      sym__concat,
    STATE(2004), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112544] = 3,
    ACTIONS(4346), 1,
      aux_sym_recipe_token1,
    ACTIONS(4348), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112555] = 3,
    ACTIONS(2594), 1,
      sym__concat,
    STATE(1519), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112566] = 3,
    ACTIONS(4350), 1,
      aux_sym_recipe_token1,
    ACTIONS(4352), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112577] = 3,
    ACTIONS(3717), 1,
      anon_sym_NULL,
    ACTIONS(3719), 1,
      aux_sym_recipe_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112588] = 3,
    ACTIONS(3642), 1,
      anon_sym_NULL,
    ACTIONS(3644), 1,
      aux_sym_recipe_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112599] = 2,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4354), 2,
      anon_sym_noexec,
      aux_sym_variable_flag_token1,
  [112608] = 3,
    ACTIONS(4356), 1,
      aux_sym_recipe_token1,
    ACTIONS(4358), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112619] = 3,
    ACTIONS(4360), 1,
      anon_sym_COLON,
    ACTIONS(4362), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112630] = 3,
    ACTIONS(4364), 1,
      aux_sym_recipe_token1,
    ACTIONS(4366), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112641] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2598), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [112650] = 3,
    ACTIONS(4368), 1,
      aux_sym_recipe_token1,
    ACTIONS(4370), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112661] = 3,
    ACTIONS(1745), 1,
      aux_sym_recipe_token1,
    ACTIONS(1747), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112672] = 3,
    ACTIONS(4372), 1,
      aux_sym_recipe_token1,
    ACTIONS(4374), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112683] = 3,
    ACTIONS(4376), 1,
      aux_sym_recipe_token1,
    ACTIONS(4378), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112694] = 3,
    ACTIONS(4380), 1,
      anon_sym_COLON,
    ACTIONS(4382), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112705] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2596), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [112714] = 3,
    ACTIONS(4384), 1,
      anon_sym_RBRACE,
    ACTIONS(4386), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112725] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2994), 2,
      sym__newline,
      anon_sym_SEMI,
  [112734] = 3,
    ACTIONS(2580), 1,
      aux_sym_recipe_token1,
    ACTIONS(2582), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112745] = 3,
    ACTIONS(4388), 1,
      aux_sym_recipe_token1,
    ACTIONS(4390), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112756] = 3,
    ACTIONS(4392), 1,
      aux_sym_recipe_token1,
    ACTIONS(4394), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112767] = 3,
    ACTIONS(4396), 1,
      aux_sym_recipe_token1,
    ACTIONS(4398), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112778] = 3,
    ACTIONS(3946), 1,
      anon_sym_LPAREN,
    ACTIONS(4400), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112789] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4402), 2,
      sym__newline,
      anon_sym_SEMI,
  [112798] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2547), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [112807] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4404), 2,
      sym__newline,
      anon_sym_SEMI,
  [112816] = 3,
    ACTIONS(4326), 1,
      anon_sym_LPAREN,
    STATE(2309), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112827] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4406), 2,
      sym__newline,
      anon_sym_SEMI,
  [112836] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4408), 2,
      sym__newline,
      anon_sym_SEMI,
  [112845] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4410), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [112854] = 2,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4412), 2,
      anon_sym_noexec,
      aux_sym_variable_flag_token1,
  [112863] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(3906), 2,
      sym__newline,
      anon_sym_SEMI,
  [112872] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(2772), 2,
      sym__newline,
      anon_sym_SEMI,
  [112881] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4414), 2,
      sym__newline,
      anon_sym_SEMI,
  [112890] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4416), 2,
      sym__newline,
      anon_sym_SEMI,
  [112899] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4418), 2,
      sym__newline,
      anon_sym_SEMI,
  [112908] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4420), 2,
      sym__newline,
      anon_sym_SEMI,
  [112917] = 3,
    ACTIONS(4422), 1,
      anon_sym_RBRACE,
    ACTIONS(4424), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112928] = 2,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4426), 2,
      sym__newline,
      anon_sym_SEMI,
  [112937] = 3,
    ACTIONS(1697), 1,
      aux_sym_recipe_token1,
    ACTIONS(1699), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112948] = 3,
    ACTIONS(4428), 1,
      sym_identifier,
    STATE(1915), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112959] = 3,
    ACTIONS(4430), 1,
      aux_sym_recipe_token1,
    ACTIONS(4432), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [112970] = 3,
    ACTIONS(4434), 1,
      sym_identifier,
    STATE(1909), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112981] = 3,
    ACTIONS(4436), 1,
      sym_identifier,
    STATE(1958), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [112992] = 3,
    ACTIONS(3652), 1,
      anon_sym_NULL,
    ACTIONS(3654), 1,
      aux_sym_recipe_token1,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [113003] = 2,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
    ACTIONS(4438), 2,
      anon_sym_noexec,
      aux_sym_variable_flag_token1,
  [113012] = 3,
    ACTIONS(4440), 1,
      aux_sym_recipe_token1,
    ACTIONS(4442), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [113023] = 3,
    ACTIONS(4444), 1,
      aux_sym_recipe_token1,
    ACTIONS(4446), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [113034] = 3,
    ACTIONS(4448), 1,
      aux_sym_recipe_token1,
    ACTIONS(4450), 1,
      anon_sym_NULL,
    ACTIONS(2592), 2,
      sym_line_continuation,
      sym_comment,
  [113045] = 2,
    ACTIONS(4452), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113053] = 2,
    ACTIONS(4454), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113061] = 2,
    ACTIONS(4456), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113069] = 2,
    ACTIONS(4458), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113077] = 2,
    ACTIONS(4460), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113085] = 2,
    ACTIONS(3266), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113093] = 2,
    ACTIONS(4462), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113101] = 2,
    ACTIONS(4464), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113109] = 2,
    ACTIONS(4466), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113117] = 2,
    ACTIONS(4468), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113125] = 2,
    ACTIONS(4470), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113133] = 2,
    ACTIONS(4472), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113141] = 2,
    ACTIONS(4474), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113149] = 2,
    ACTIONS(4476), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113157] = 2,
    ACTIONS(4478), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113165] = 2,
    ACTIONS(4480), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113173] = 2,
    ACTIONS(4482), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113181] = 2,
    ACTIONS(4484), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113189] = 2,
    ACTIONS(4486), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113197] = 2,
    ACTIONS(4488), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113205] = 2,
    ACTIONS(4490), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113213] = 2,
    ACTIONS(4492), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113221] = 2,
    ACTIONS(4494), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113229] = 2,
    ACTIONS(2879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113237] = 2,
    ACTIONS(2859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113245] = 2,
    ACTIONS(4496), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113253] = 2,
    ACTIONS(4498), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113261] = 2,
    ACTIONS(4500), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113269] = 2,
    ACTIONS(4502), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113277] = 2,
    ACTIONS(2867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113285] = 2,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113293] = 2,
    ACTIONS(4506), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113301] = 2,
    ACTIONS(4508), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113309] = 2,
    ACTIONS(4510), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113317] = 2,
    ACTIONS(4512), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113325] = 2,
    ACTIONS(3315), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113333] = 2,
    ACTIONS(4514), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113341] = 2,
    ACTIONS(4516), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113349] = 2,
    ACTIONS(4518), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113357] = 2,
    ACTIONS(4520), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113365] = 2,
    ACTIONS(4522), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113373] = 2,
    ACTIONS(4524), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113381] = 2,
    ACTIONS(4084), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113389] = 2,
    ACTIONS(3305), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113397] = 2,
    ACTIONS(4526), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113405] = 2,
    ACTIONS(2841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113413] = 2,
    ACTIONS(4528), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113421] = 2,
    ACTIONS(4530), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113429] = 2,
    ACTIONS(4532), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113437] = 2,
    ACTIONS(4534), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113445] = 2,
    ACTIONS(4536), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113453] = 2,
    ACTIONS(4538), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113461] = 2,
    ACTIONS(4540), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113469] = 2,
    ACTIONS(4542), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113477] = 2,
    ACTIONS(4544), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113485] = 2,
    ACTIONS(4546), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113493] = 2,
    ACTIONS(4548), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113501] = 2,
    ACTIONS(4550), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113509] = 2,
    ACTIONS(3350), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113517] = 2,
    ACTIONS(4552), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113525] = 2,
    ACTIONS(4554), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113533] = 2,
    ACTIONS(4556), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113541] = 2,
    ACTIONS(4558), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113549] = 2,
    ACTIONS(4560), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113557] = 2,
    ACTIONS(4562), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113565] = 2,
    ACTIONS(4564), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113573] = 2,
    ACTIONS(4566), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113581] = 2,
    ACTIONS(4568), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113589] = 2,
    ACTIONS(4570), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113597] = 2,
    ACTIONS(4572), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113605] = 2,
    ACTIONS(3354), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113613] = 2,
    ACTIONS(4574), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113621] = 2,
    ACTIONS(4576), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113629] = 2,
    ACTIONS(4578), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113637] = 2,
    ACTIONS(4580), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113645] = 2,
    ACTIONS(4582), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113653] = 2,
    ACTIONS(4584), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113661] = 2,
    ACTIONS(2883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113669] = 2,
    ACTIONS(4586), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113677] = 2,
    ACTIONS(4588), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113685] = 2,
    ACTIONS(1527), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113693] = 2,
    ACTIONS(4590), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113701] = 2,
    ACTIONS(4592), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113709] = 2,
    ACTIONS(4594), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113717] = 2,
    ACTIONS(4596), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113725] = 2,
    ACTIONS(4598), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113733] = 2,
    ACTIONS(4600), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113741] = 2,
    ACTIONS(2754), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113749] = 2,
    ACTIONS(4602), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113757] = 2,
    ACTIONS(4604), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113765] = 2,
    ACTIONS(4606), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113773] = 2,
    ACTIONS(4608), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113781] = 2,
    ACTIONS(4610), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113789] = 2,
    ACTIONS(4612), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113797] = 2,
    ACTIONS(4614), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113805] = 2,
    ACTIONS(4616), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113813] = 2,
    ACTIONS(4618), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113821] = 2,
    ACTIONS(4620), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113829] = 2,
    ACTIONS(4622), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113837] = 2,
    ACTIONS(4624), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113845] = 2,
    ACTIONS(4626), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113853] = 2,
    ACTIONS(4628), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113861] = 2,
    ACTIONS(4630), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113869] = 2,
    ACTIONS(4632), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113877] = 2,
    ACTIONS(4634), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113885] = 2,
    ACTIONS(4636), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113893] = 2,
    ACTIONS(4638), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113901] = 2,
    ACTIONS(4086), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113909] = 2,
    ACTIONS(4640), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113917] = 2,
    ACTIONS(4642), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113925] = 2,
    ACTIONS(4644), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113933] = 2,
    ACTIONS(1575), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113941] = 2,
    ACTIONS(4646), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113949] = 2,
    ACTIONS(4648), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113957] = 2,
    ACTIONS(4088), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113965] = 2,
    ACTIONS(4650), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113973] = 2,
    ACTIONS(4652), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113981] = 2,
    ACTIONS(4654), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113989] = 2,
    ACTIONS(4656), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [113997] = 2,
    ACTIONS(4658), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114005] = 2,
    ACTIONS(3863), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114013] = 2,
    ACTIONS(4660), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114021] = 2,
    ACTIONS(4662), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114029] = 2,
    ACTIONS(4664), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114037] = 2,
    ACTIONS(4666), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114045] = 2,
    ACTIONS(4668), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114053] = 2,
    ACTIONS(4670), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114061] = 2,
    ACTIONS(4672), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114069] = 2,
    ACTIONS(4674), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114077] = 2,
    ACTIONS(4676), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114085] = 2,
    ACTIONS(2897), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114093] = 2,
    ACTIONS(4678), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114101] = 2,
    ACTIONS(4680), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114109] = 2,
    ACTIONS(4682), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114117] = 2,
    ACTIONS(4684), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114125] = 2,
    ACTIONS(4686), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114133] = 2,
    ACTIONS(4688), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114141] = 2,
    ACTIONS(4690), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114149] = 2,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114157] = 2,
    ACTIONS(4694), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114165] = 2,
    ACTIONS(4696), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114173] = 2,
    ACTIONS(3295), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114181] = 2,
    ACTIONS(4698), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114189] = 2,
    ACTIONS(3237), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114197] = 2,
    ACTIONS(4700), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114205] = 2,
    ACTIONS(4702), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114213] = 2,
    ACTIONS(4704), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114221] = 2,
    ACTIONS(4706), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114229] = 2,
    ACTIONS(4708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114237] = 2,
    ACTIONS(4710), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114245] = 2,
    ACTIONS(4712), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114253] = 2,
    ACTIONS(4714), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114261] = 2,
    ACTIONS(4716), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114269] = 2,
    ACTIONS(4718), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114277] = 2,
    ACTIONS(3978), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114285] = 2,
    ACTIONS(4720), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114293] = 2,
    ACTIONS(3940), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114301] = 2,
    ACTIONS(4722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114309] = 2,
    ACTIONS(4724), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114317] = 2,
    ACTIONS(4726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114325] = 2,
    ACTIONS(4728), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114333] = 2,
    ACTIONS(4730), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114341] = 2,
    ACTIONS(3960), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114349] = 2,
    ACTIONS(1535), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114357] = 2,
    ACTIONS(4732), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114365] = 2,
    ACTIONS(3948), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114373] = 2,
    ACTIONS(4734), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114381] = 2,
    ACTIONS(4736), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114389] = 2,
    ACTIONS(4738), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114397] = 2,
    ACTIONS(4740), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114405] = 2,
    ACTIONS(4742), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114413] = 2,
    ACTIONS(4744), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114421] = 2,
    ACTIONS(4746), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114429] = 2,
    ACTIONS(1531), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114437] = 2,
    ACTIONS(4748), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114445] = 2,
    ACTIONS(4750), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114453] = 2,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114461] = 2,
    ACTIONS(4754), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114469] = 2,
    ACTIONS(4756), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114477] = 2,
    ACTIONS(4758), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114485] = 2,
    ACTIONS(4760), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114493] = 2,
    ACTIONS(4762), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114501] = 2,
    ACTIONS(3284), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114509] = 2,
    ACTIONS(4764), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114517] = 2,
    ACTIONS(3871), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114525] = 2,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114533] = 2,
    ACTIONS(4768), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114541] = 2,
    ACTIONS(3893), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114549] = 2,
    ACTIONS(4770), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114557] = 2,
    ACTIONS(4772), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114565] = 2,
    ACTIONS(4774), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114573] = 2,
    ACTIONS(4776), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114581] = 2,
    ACTIONS(4778), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114589] = 2,
    ACTIONS(4780), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114597] = 2,
    ACTIONS(2818), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114605] = 2,
    ACTIONS(4782), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114613] = 2,
    ACTIONS(4784), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114621] = 2,
    ACTIONS(4786), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114629] = 2,
    ACTIONS(4788), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114637] = 2,
    ACTIONS(4790), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114645] = 2,
    ACTIONS(4792), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114653] = 2,
    ACTIONS(4794), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114661] = 2,
    ACTIONS(4796), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114669] = 2,
    ACTIONS(4798), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114677] = 2,
    ACTIONS(4800), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114685] = 2,
    ACTIONS(4802), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114693] = 2,
    ACTIONS(4804), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114701] = 2,
    ACTIONS(4806), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114709] = 2,
    ACTIONS(3329), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114717] = 2,
    ACTIONS(1539), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114725] = 2,
    ACTIONS(4808), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114733] = 2,
    ACTIONS(4810), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114741] = 2,
    ACTIONS(4812), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114749] = 2,
    ACTIONS(4814), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114757] = 2,
    ACTIONS(4816), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114765] = 2,
    ACTIONS(4818), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114773] = 2,
    ACTIONS(4820), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114781] = 2,
    ACTIONS(4822), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114789] = 2,
    ACTIONS(4824), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114797] = 2,
    ACTIONS(4826), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114805] = 2,
    ACTIONS(4828), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114813] = 2,
    ACTIONS(4830), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114821] = 2,
    ACTIONS(4832), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114829] = 2,
    ACTIONS(1297), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114837] = 2,
    ACTIONS(4834), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114845] = 2,
    ACTIONS(4836), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114853] = 2,
    ACTIONS(4838), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114861] = 2,
    ACTIONS(4840), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114869] = 2,
    ACTIONS(4842), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114877] = 2,
    ACTIONS(4844), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114885] = 2,
    ACTIONS(4846), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114893] = 2,
    ACTIONS(3262), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114901] = 2,
    ACTIONS(4848), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114909] = 2,
    ACTIONS(4850), 1,
      sym_python_identifier,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114917] = 2,
    ACTIONS(4852), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114925] = 2,
    ACTIONS(4854), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114933] = 2,
    ACTIONS(4856), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
  [114941] = 2,
    ACTIONS(4858), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_line_continuation,
      sym_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(128)] = 0,
  [SMALL_STATE(129)] = 131,
  [SMALL_STATE(130)] = 260,
  [SMALL_STATE(131)] = 385,
  [SMALL_STATE(132)] = 516,
  [SMALL_STATE(133)] = 645,
  [SMALL_STATE(134)] = 774,
  [SMALL_STATE(135)] = 905,
  [SMALL_STATE(136)] = 1034,
  [SMALL_STATE(137)] = 1165,
  [SMALL_STATE(138)] = 1294,
  [SMALL_STATE(139)] = 1419,
  [SMALL_STATE(140)] = 1550,
  [SMALL_STATE(141)] = 1679,
  [SMALL_STATE(142)] = 1804,
  [SMALL_STATE(143)] = 1933,
  [SMALL_STATE(144)] = 2062,
  [SMALL_STATE(145)] = 2191,
  [SMALL_STATE(146)] = 2320,
  [SMALL_STATE(147)] = 2451,
  [SMALL_STATE(148)] = 2580,
  [SMALL_STATE(149)] = 2709,
  [SMALL_STATE(150)] = 2838,
  [SMALL_STATE(151)] = 2969,
  [SMALL_STATE(152)] = 3098,
  [SMALL_STATE(153)] = 3231,
  [SMALL_STATE(154)] = 3364,
  [SMALL_STATE(155)] = 3495,
  [SMALL_STATE(156)] = 3624,
  [SMALL_STATE(157)] = 3753,
  [SMALL_STATE(158)] = 3884,
  [SMALL_STATE(159)] = 4013,
  [SMALL_STATE(160)] = 4142,
  [SMALL_STATE(161)] = 4271,
  [SMALL_STATE(162)] = 4381,
  [SMALL_STATE(163)] = 4491,
  [SMALL_STATE(164)] = 4612,
  [SMALL_STATE(165)] = 4733,
  [SMALL_STATE(166)] = 4849,
  [SMALL_STATE(167)] = 4969,
  [SMALL_STATE(168)] = 5085,
  [SMALL_STATE(169)] = 5201,
  [SMALL_STATE(170)] = 5317,
  [SMALL_STATE(171)] = 5433,
  [SMALL_STATE(172)] = 5553,
  [SMALL_STATE(173)] = 5661,
  [SMALL_STATE(174)] = 5777,
  [SMALL_STATE(175)] = 5893,
  [SMALL_STATE(176)] = 6009,
  [SMALL_STATE(177)] = 6129,
  [SMALL_STATE(178)] = 6249,
  [SMALL_STATE(179)] = 6365,
  [SMALL_STATE(180)] = 6485,
  [SMALL_STATE(181)] = 6601,
  [SMALL_STATE(182)] = 6717,
  [SMALL_STATE(183)] = 6833,
  [SMALL_STATE(184)] = 6949,
  [SMALL_STATE(185)] = 7069,
  [SMALL_STATE(186)] = 7189,
  [SMALL_STATE(187)] = 7305,
  [SMALL_STATE(188)] = 7421,
  [SMALL_STATE(189)] = 7537,
  [SMALL_STATE(190)] = 7653,
  [SMALL_STATE(191)] = 7769,
  [SMALL_STATE(192)] = 7891,
  [SMALL_STATE(193)] = 8007,
  [SMALL_STATE(194)] = 8127,
  [SMALL_STATE(195)] = 8235,
  [SMALL_STATE(196)] = 8352,
  [SMALL_STATE(197)] = 8469,
  [SMALL_STATE(198)] = 8586,
  [SMALL_STATE(199)] = 8703,
  [SMALL_STATE(200)] = 8820,
  [SMALL_STATE(201)] = 8937,
  [SMALL_STATE(202)] = 9056,
  [SMALL_STATE(203)] = 9173,
  [SMALL_STATE(204)] = 9290,
  [SMALL_STATE(205)] = 9407,
  [SMALL_STATE(206)] = 9524,
  [SMALL_STATE(207)] = 9641,
  [SMALL_STATE(208)] = 9758,
  [SMALL_STATE(209)] = 9879,
  [SMALL_STATE(210)] = 10000,
  [SMALL_STATE(211)] = 10117,
  [SMALL_STATE(212)] = 10236,
  [SMALL_STATE(213)] = 10353,
  [SMALL_STATE(214)] = 10470,
  [SMALL_STATE(215)] = 10587,
  [SMALL_STATE(216)] = 10704,
  [SMALL_STATE(217)] = 10821,
  [SMALL_STATE(218)] = 10938,
  [SMALL_STATE(219)] = 11055,
  [SMALL_STATE(220)] = 11174,
  [SMALL_STATE(221)] = 11291,
  [SMALL_STATE(222)] = 11408,
  [SMALL_STATE(223)] = 11527,
  [SMALL_STATE(224)] = 11648,
  [SMALL_STATE(225)] = 11765,
  [SMALL_STATE(226)] = 11882,
  [SMALL_STATE(227)] = 11999,
  [SMALL_STATE(228)] = 12116,
  [SMALL_STATE(229)] = 12233,
  [SMALL_STATE(230)] = 12354,
  [SMALL_STATE(231)] = 12473,
  [SMALL_STATE(232)] = 12590,
  [SMALL_STATE(233)] = 12707,
  [SMALL_STATE(234)] = 12824,
  [SMALL_STATE(235)] = 12941,
  [SMALL_STATE(236)] = 13058,
  [SMALL_STATE(237)] = 13177,
  [SMALL_STATE(238)] = 13294,
  [SMALL_STATE(239)] = 13411,
  [SMALL_STATE(240)] = 13530,
  [SMALL_STATE(241)] = 13651,
  [SMALL_STATE(242)] = 13768,
  [SMALL_STATE(243)] = 13887,
  [SMALL_STATE(244)] = 14004,
  [SMALL_STATE(245)] = 14121,
  [SMALL_STATE(246)] = 14238,
  [SMALL_STATE(247)] = 14359,
  [SMALL_STATE(248)] = 14476,
  [SMALL_STATE(249)] = 14593,
  [SMALL_STATE(250)] = 14693,
  [SMALL_STATE(251)] = 14807,
  [SMALL_STATE(252)] = 14921,
  [SMALL_STATE(253)] = 15035,
  [SMALL_STATE(254)] = 15149,
  [SMALL_STATE(255)] = 15263,
  [SMALL_STATE(256)] = 15377,
  [SMALL_STATE(257)] = 15491,
  [SMALL_STATE(258)] = 15605,
  [SMALL_STATE(259)] = 15719,
  [SMALL_STATE(260)] = 15833,
  [SMALL_STATE(261)] = 15947,
  [SMALL_STATE(262)] = 16061,
  [SMALL_STATE(263)] = 16171,
  [SMALL_STATE(264)] = 16285,
  [SMALL_STATE(265)] = 16395,
  [SMALL_STATE(266)] = 16509,
  [SMALL_STATE(267)] = 16609,
  [SMALL_STATE(268)] = 16723,
  [SMALL_STATE(269)] = 16837,
  [SMALL_STATE(270)] = 16951,
  [SMALL_STATE(271)] = 17065,
  [SMALL_STATE(272)] = 17179,
  [SMALL_STATE(273)] = 17292,
  [SMALL_STATE(274)] = 17405,
  [SMALL_STATE(275)] = 17518,
  [SMALL_STATE(276)] = 17631,
  [SMALL_STATE(277)] = 17742,
  [SMALL_STATE(278)] = 17855,
  [SMALL_STATE(279)] = 17968,
  [SMALL_STATE(280)] = 18081,
  [SMALL_STATE(281)] = 18194,
  [SMALL_STATE(282)] = 18307,
  [SMALL_STATE(283)] = 18420,
  [SMALL_STATE(284)] = 18531,
  [SMALL_STATE(285)] = 18644,
  [SMALL_STATE(286)] = 18757,
  [SMALL_STATE(287)] = 18870,
  [SMALL_STATE(288)] = 18983,
  [SMALL_STATE(289)] = 19096,
  [SMALL_STATE(290)] = 19209,
  [SMALL_STATE(291)] = 19322,
  [SMALL_STATE(292)] = 19435,
  [SMALL_STATE(293)] = 19548,
  [SMALL_STATE(294)] = 19659,
  [SMALL_STATE(295)] = 19772,
  [SMALL_STATE(296)] = 19884,
  [SMALL_STATE(297)] = 19996,
  [SMALL_STATE(298)] = 20108,
  [SMALL_STATE(299)] = 20206,
  [SMALL_STATE(300)] = 20318,
  [SMALL_STATE(301)] = 20430,
  [SMALL_STATE(302)] = 20542,
  [SMALL_STATE(303)] = 20652,
  [SMALL_STATE(304)] = 20762,
  [SMALL_STATE(305)] = 20874,
  [SMALL_STATE(306)] = 20986,
  [SMALL_STATE(307)] = 21098,
  [SMALL_STATE(308)] = 21210,
  [SMALL_STATE(309)] = 21322,
  [SMALL_STATE(310)] = 21434,
  [SMALL_STATE(311)] = 21544,
  [SMALL_STATE(312)] = 21654,
  [SMALL_STATE(313)] = 21766,
  [SMALL_STATE(314)] = 21878,
  [SMALL_STATE(315)] = 21990,
  [SMALL_STATE(316)] = 22100,
  [SMALL_STATE(317)] = 22212,
  [SMALL_STATE(318)] = 22324,
  [SMALL_STATE(319)] = 22436,
  [SMALL_STATE(320)] = 22548,
  [SMALL_STATE(321)] = 22646,
  [SMALL_STATE(322)] = 22758,
  [SMALL_STATE(323)] = 22870,
  [SMALL_STATE(324)] = 22982,
  [SMALL_STATE(325)] = 23094,
  [SMALL_STATE(326)] = 23206,
  [SMALL_STATE(327)] = 23318,
  [SMALL_STATE(328)] = 23430,
  [SMALL_STATE(329)] = 23542,
  [SMALL_STATE(330)] = 23654,
  [SMALL_STATE(331)] = 23766,
  [SMALL_STATE(332)] = 23878,
  [SMALL_STATE(333)] = 23988,
  [SMALL_STATE(334)] = 24095,
  [SMALL_STATE(335)] = 24204,
  [SMALL_STATE(336)] = 24313,
  [SMALL_STATE(337)] = 24420,
  [SMALL_STATE(338)] = 24527,
  [SMALL_STATE(339)] = 24634,
  [SMALL_STATE(340)] = 24741,
  [SMALL_STATE(341)] = 24848,
  [SMALL_STATE(342)] = 24955,
  [SMALL_STATE(343)] = 25064,
  [SMALL_STATE(344)] = 25171,
  [SMALL_STATE(345)] = 25280,
  [SMALL_STATE(346)] = 25387,
  [SMALL_STATE(347)] = 25494,
  [SMALL_STATE(348)] = 25601,
  [SMALL_STATE(349)] = 25710,
  [SMALL_STATE(350)] = 25817,
  [SMALL_STATE(351)] = 25924,
  [SMALL_STATE(352)] = 26033,
  [SMALL_STATE(353)] = 26130,
  [SMALL_STATE(354)] = 26227,
  [SMALL_STATE(355)] = 26336,
  [SMALL_STATE(356)] = 26443,
  [SMALL_STATE(357)] = 26540,
  [SMALL_STATE(358)] = 26637,
  [SMALL_STATE(359)] = 26744,
  [SMALL_STATE(360)] = 26841,
  [SMALL_STATE(361)] = 26940,
  [SMALL_STATE(362)] = 27049,
  [SMALL_STATE(363)] = 27158,
  [SMALL_STATE(364)] = 27265,
  [SMALL_STATE(365)] = 27372,
  [SMALL_STATE(366)] = 27481,
  [SMALL_STATE(367)] = 27588,
  [SMALL_STATE(368)] = 27695,
  [SMALL_STATE(369)] = 27802,
  [SMALL_STATE(370)] = 27899,
  [SMALL_STATE(371)] = 28008,
  [SMALL_STATE(372)] = 28115,
  [SMALL_STATE(373)] = 28224,
  [SMALL_STATE(374)] = 28331,
  [SMALL_STATE(375)] = 28438,
  [SMALL_STATE(376)] = 28545,
  [SMALL_STATE(377)] = 28652,
  [SMALL_STATE(378)] = 28751,
  [SMALL_STATE(379)] = 28858,
  [SMALL_STATE(380)] = 28965,
  [SMALL_STATE(381)] = 29074,
  [SMALL_STATE(382)] = 29181,
  [SMALL_STATE(383)] = 29290,
  [SMALL_STATE(384)] = 29399,
  [SMALL_STATE(385)] = 29508,
  [SMALL_STATE(386)] = 29615,
  [SMALL_STATE(387)] = 29722,
  [SMALL_STATE(388)] = 29831,
  [SMALL_STATE(389)] = 29937,
  [SMALL_STATE(390)] = 30043,
  [SMALL_STATE(391)] = 30149,
  [SMALL_STATE(392)] = 30255,
  [SMALL_STATE(393)] = 30361,
  [SMALL_STATE(394)] = 30467,
  [SMALL_STATE(395)] = 30573,
  [SMALL_STATE(396)] = 30679,
  [SMALL_STATE(397)] = 30782,
  [SMALL_STATE(398)] = 30885,
  [SMALL_STATE(399)] = 30988,
  [SMALL_STATE(400)] = 31091,
  [SMALL_STATE(401)] = 31194,
  [SMALL_STATE(402)] = 31297,
  [SMALL_STATE(403)] = 31400,
  [SMALL_STATE(404)] = 31503,
  [SMALL_STATE(405)] = 31606,
  [SMALL_STATE(406)] = 31709,
  [SMALL_STATE(407)] = 31812,
  [SMALL_STATE(408)] = 31915,
  [SMALL_STATE(409)] = 32018,
  [SMALL_STATE(410)] = 32121,
  [SMALL_STATE(411)] = 32224,
  [SMALL_STATE(412)] = 32327,
  [SMALL_STATE(413)] = 32430,
  [SMALL_STATE(414)] = 32533,
  [SMALL_STATE(415)] = 32636,
  [SMALL_STATE(416)] = 32739,
  [SMALL_STATE(417)] = 32844,
  [SMALL_STATE(418)] = 32947,
  [SMALL_STATE(419)] = 33050,
  [SMALL_STATE(420)] = 33153,
  [SMALL_STATE(421)] = 33256,
  [SMALL_STATE(422)] = 33359,
  [SMALL_STATE(423)] = 33462,
  [SMALL_STATE(424)] = 33565,
  [SMALL_STATE(425)] = 33668,
  [SMALL_STATE(426)] = 33771,
  [SMALL_STATE(427)] = 33876,
  [SMALL_STATE(428)] = 33979,
  [SMALL_STATE(429)] = 34082,
  [SMALL_STATE(430)] = 34185,
  [SMALL_STATE(431)] = 34288,
  [SMALL_STATE(432)] = 34391,
  [SMALL_STATE(433)] = 34494,
  [SMALL_STATE(434)] = 34597,
  [SMALL_STATE(435)] = 34700,
  [SMALL_STATE(436)] = 34805,
  [SMALL_STATE(437)] = 34908,
  [SMALL_STATE(438)] = 35011,
  [SMALL_STATE(439)] = 35114,
  [SMALL_STATE(440)] = 35217,
  [SMALL_STATE(441)] = 35320,
  [SMALL_STATE(442)] = 35423,
  [SMALL_STATE(443)] = 35526,
  [SMALL_STATE(444)] = 35629,
  [SMALL_STATE(445)] = 35732,
  [SMALL_STATE(446)] = 35835,
  [SMALL_STATE(447)] = 35938,
  [SMALL_STATE(448)] = 36041,
  [SMALL_STATE(449)] = 36144,
  [SMALL_STATE(450)] = 36247,
  [SMALL_STATE(451)] = 36350,
  [SMALL_STATE(452)] = 36453,
  [SMALL_STATE(453)] = 36556,
  [SMALL_STATE(454)] = 36659,
  [SMALL_STATE(455)] = 36762,
  [SMALL_STATE(456)] = 36865,
  [SMALL_STATE(457)] = 36968,
  [SMALL_STATE(458)] = 37071,
  [SMALL_STATE(459)] = 37174,
  [SMALL_STATE(460)] = 37277,
  [SMALL_STATE(461)] = 37380,
  [SMALL_STATE(462)] = 37483,
  [SMALL_STATE(463)] = 37586,
  [SMALL_STATE(464)] = 37689,
  [SMALL_STATE(465)] = 37792,
  [SMALL_STATE(466)] = 37895,
  [SMALL_STATE(467)] = 37998,
  [SMALL_STATE(468)] = 38101,
  [SMALL_STATE(469)] = 38204,
  [SMALL_STATE(470)] = 38307,
  [SMALL_STATE(471)] = 38410,
  [SMALL_STATE(472)] = 38513,
  [SMALL_STATE(473)] = 38616,
  [SMALL_STATE(474)] = 38719,
  [SMALL_STATE(475)] = 38794,
  [SMALL_STATE(476)] = 38897,
  [SMALL_STATE(477)] = 39000,
  [SMALL_STATE(478)] = 39103,
  [SMALL_STATE(479)] = 39206,
  [SMALL_STATE(480)] = 39309,
  [SMALL_STATE(481)] = 39412,
  [SMALL_STATE(482)] = 39515,
  [SMALL_STATE(483)] = 39618,
  [SMALL_STATE(484)] = 39721,
  [SMALL_STATE(485)] = 39824,
  [SMALL_STATE(486)] = 39929,
  [SMALL_STATE(487)] = 40032,
  [SMALL_STATE(488)] = 40135,
  [SMALL_STATE(489)] = 40238,
  [SMALL_STATE(490)] = 40341,
  [SMALL_STATE(491)] = 40444,
  [SMALL_STATE(492)] = 40547,
  [SMALL_STATE(493)] = 40650,
  [SMALL_STATE(494)] = 40753,
  [SMALL_STATE(495)] = 40856,
  [SMALL_STATE(496)] = 40933,
  [SMALL_STATE(497)] = 41036,
  [SMALL_STATE(498)] = 41139,
  [SMALL_STATE(499)] = 41242,
  [SMALL_STATE(500)] = 41345,
  [SMALL_STATE(501)] = 41450,
  [SMALL_STATE(502)] = 41555,
  [SMALL_STATE(503)] = 41658,
  [SMALL_STATE(504)] = 41751,
  [SMALL_STATE(505)] = 41854,
  [SMALL_STATE(506)] = 41947,
  [SMALL_STATE(507)] = 42050,
  [SMALL_STATE(508)] = 42153,
  [SMALL_STATE(509)] = 42256,
  [SMALL_STATE(510)] = 42359,
  [SMALL_STATE(511)] = 42462,
  [SMALL_STATE(512)] = 42565,
  [SMALL_STATE(513)] = 42668,
  [SMALL_STATE(514)] = 42771,
  [SMALL_STATE(515)] = 42874,
  [SMALL_STATE(516)] = 42977,
  [SMALL_STATE(517)] = 43080,
  [SMALL_STATE(518)] = 43183,
  [SMALL_STATE(519)] = 43286,
  [SMALL_STATE(520)] = 43389,
  [SMALL_STATE(521)] = 43492,
  [SMALL_STATE(522)] = 43595,
  [SMALL_STATE(523)] = 43698,
  [SMALL_STATE(524)] = 43801,
  [SMALL_STATE(525)] = 43904,
  [SMALL_STATE(526)] = 44007,
  [SMALL_STATE(527)] = 44110,
  [SMALL_STATE(528)] = 44213,
  [SMALL_STATE(529)] = 44316,
  [SMALL_STATE(530)] = 44419,
  [SMALL_STATE(531)] = 44522,
  [SMALL_STATE(532)] = 44625,
  [SMALL_STATE(533)] = 44728,
  [SMALL_STATE(534)] = 44831,
  [SMALL_STATE(535)] = 44934,
  [SMALL_STATE(536)] = 45037,
  [SMALL_STATE(537)] = 45109,
  [SMALL_STATE(538)] = 45180,
  [SMALL_STATE(539)] = 45251,
  [SMALL_STATE(540)] = 45322,
  [SMALL_STATE(541)] = 45393,
  [SMALL_STATE(542)] = 45466,
  [SMALL_STATE(543)] = 45534,
  [SMALL_STATE(544)] = 45600,
  [SMALL_STATE(545)] = 45666,
  [SMALL_STATE(546)] = 45732,
  [SMALL_STATE(547)] = 45800,
  [SMALL_STATE(548)] = 45897,
  [SMALL_STATE(549)] = 45954,
  [SMALL_STATE(550)] = 46011,
  [SMALL_STATE(551)] = 46074,
  [SMALL_STATE(552)] = 46131,
  [SMALL_STATE(553)] = 46188,
  [SMALL_STATE(554)] = 46249,
  [SMALL_STATE(555)] = 46346,
  [SMALL_STATE(556)] = 46413,
  [SMALL_STATE(557)] = 46480,
  [SMALL_STATE(558)] = 46537,
  [SMALL_STATE(559)] = 46598,
  [SMALL_STATE(560)] = 46659,
  [SMALL_STATE(561)] = 46720,
  [SMALL_STATE(562)] = 46785,
  [SMALL_STATE(563)] = 46848,
  [SMALL_STATE(564)] = 46909,
  [SMALL_STATE(565)] = 46972,
  [SMALL_STATE(566)] = 47029,
  [SMALL_STATE(567)] = 47092,
  [SMALL_STATE(568)] = 47149,
  [SMALL_STATE(569)] = 47212,
  [SMALL_STATE(570)] = 47275,
  [SMALL_STATE(571)] = 47338,
  [SMALL_STATE(572)] = 47401,
  [SMALL_STATE(573)] = 47468,
  [SMALL_STATE(574)] = 47535,
  [SMALL_STATE(575)] = 47597,
  [SMALL_STATE(576)] = 47652,
  [SMALL_STATE(577)] = 47707,
  [SMALL_STATE(578)] = 47762,
  [SMALL_STATE(579)] = 47817,
  [SMALL_STATE(580)] = 47872,
  [SMALL_STATE(581)] = 47927,
  [SMALL_STATE(582)] = 47982,
  [SMALL_STATE(583)] = 48037,
  [SMALL_STATE(584)] = 48092,
  [SMALL_STATE(585)] = 48147,
  [SMALL_STATE(586)] = 48244,
  [SMALL_STATE(587)] = 48299,
  [SMALL_STATE(588)] = 48354,
  [SMALL_STATE(589)] = 48409,
  [SMALL_STATE(590)] = 48464,
  [SMALL_STATE(591)] = 48519,
  [SMALL_STATE(592)] = 48574,
  [SMALL_STATE(593)] = 48671,
  [SMALL_STATE(594)] = 48726,
  [SMALL_STATE(595)] = 48781,
  [SMALL_STATE(596)] = 48836,
  [SMALL_STATE(597)] = 48891,
  [SMALL_STATE(598)] = 48945,
  [SMALL_STATE(599)] = 49003,
  [SMALL_STATE(600)] = 49061,
  [SMALL_STATE(601)] = 49115,
  [SMALL_STATE(602)] = 49169,
  [SMALL_STATE(603)] = 49227,
  [SMALL_STATE(604)] = 49281,
  [SMALL_STATE(605)] = 49375,
  [SMALL_STATE(606)] = 49429,
  [SMALL_STATE(607)] = 49483,
  [SMALL_STATE(608)] = 49577,
  [SMALL_STATE(609)] = 49635,
  [SMALL_STATE(610)] = 49729,
  [SMALL_STATE(611)] = 49823,
  [SMALL_STATE(612)] = 49917,
  [SMALL_STATE(613)] = 50011,
  [SMALL_STATE(614)] = 50069,
  [SMALL_STATE(615)] = 50163,
  [SMALL_STATE(616)] = 50257,
  [SMALL_STATE(617)] = 50351,
  [SMALL_STATE(618)] = 50445,
  [SMALL_STATE(619)] = 50499,
  [SMALL_STATE(620)] = 50593,
  [SMALL_STATE(621)] = 50651,
  [SMALL_STATE(622)] = 50709,
  [SMALL_STATE(623)] = 50803,
  [SMALL_STATE(624)] = 50897,
  [SMALL_STATE(625)] = 50955,
  [SMALL_STATE(626)] = 51009,
  [SMALL_STATE(627)] = 51103,
  [SMALL_STATE(628)] = 51156,
  [SMALL_STATE(629)] = 51247,
  [SMALL_STATE(630)] = 51338,
  [SMALL_STATE(631)] = 51391,
  [SMALL_STATE(632)] = 51482,
  [SMALL_STATE(633)] = 51535,
  [SMALL_STATE(634)] = 51588,
  [SMALL_STATE(635)] = 51641,
  [SMALL_STATE(636)] = 51694,
  [SMALL_STATE(637)] = 51747,
  [SMALL_STATE(638)] = 51800,
  [SMALL_STATE(639)] = 51891,
  [SMALL_STATE(640)] = 51944,
  [SMALL_STATE(641)] = 51997,
  [SMALL_STATE(642)] = 52088,
  [SMALL_STATE(643)] = 52141,
  [SMALL_STATE(644)] = 52194,
  [SMALL_STATE(645)] = 52285,
  [SMALL_STATE(646)] = 52337,
  [SMALL_STATE(647)] = 52389,
  [SMALL_STATE(648)] = 52441,
  [SMALL_STATE(649)] = 52493,
  [SMALL_STATE(650)] = 52545,
  [SMALL_STATE(651)] = 52597,
  [SMALL_STATE(652)] = 52649,
  [SMALL_STATE(653)] = 52701,
  [SMALL_STATE(654)] = 52753,
  [SMALL_STATE(655)] = 52805,
  [SMALL_STATE(656)] = 52857,
  [SMALL_STATE(657)] = 52909,
  [SMALL_STATE(658)] = 52961,
  [SMALL_STATE(659)] = 53013,
  [SMALL_STATE(660)] = 53101,
  [SMALL_STATE(661)] = 53153,
  [SMALL_STATE(662)] = 53205,
  [SMALL_STATE(663)] = 53257,
  [SMALL_STATE(664)] = 53309,
  [SMALL_STATE(665)] = 53361,
  [SMALL_STATE(666)] = 53413,
  [SMALL_STATE(667)] = 53465,
  [SMALL_STATE(668)] = 53517,
  [SMALL_STATE(669)] = 53605,
  [SMALL_STATE(670)] = 53657,
  [SMALL_STATE(671)] = 53709,
  [SMALL_STATE(672)] = 53761,
  [SMALL_STATE(673)] = 53813,
  [SMALL_STATE(674)] = 53865,
  [SMALL_STATE(675)] = 53917,
  [SMALL_STATE(676)] = 53969,
  [SMALL_STATE(677)] = 54021,
  [SMALL_STATE(678)] = 54073,
  [SMALL_STATE(679)] = 54125,
  [SMALL_STATE(680)] = 54177,
  [SMALL_STATE(681)] = 54258,
  [SMALL_STATE(682)] = 54339,
  [SMALL_STATE(683)] = 54420,
  [SMALL_STATE(684)] = 54501,
  [SMALL_STATE(685)] = 54582,
  [SMALL_STATE(686)] = 54663,
  [SMALL_STATE(687)] = 54744,
  [SMALL_STATE(688)] = 54825,
  [SMALL_STATE(689)] = 54906,
  [SMALL_STATE(690)] = 54987,
  [SMALL_STATE(691)] = 55065,
  [SMALL_STATE(692)] = 55143,
  [SMALL_STATE(693)] = 55221,
  [SMALL_STATE(694)] = 55305,
  [SMALL_STATE(695)] = 55383,
  [SMALL_STATE(696)] = 55467,
  [SMALL_STATE(697)] = 55545,
  [SMALL_STATE(698)] = 55629,
  [SMALL_STATE(699)] = 55713,
  [SMALL_STATE(700)] = 55791,
  [SMALL_STATE(701)] = 55875,
  [SMALL_STATE(702)] = 55953,
  [SMALL_STATE(703)] = 56031,
  [SMALL_STATE(704)] = 56109,
  [SMALL_STATE(705)] = 56193,
  [SMALL_STATE(706)] = 56277,
  [SMALL_STATE(707)] = 56355,
  [SMALL_STATE(708)] = 56439,
  [SMALL_STATE(709)] = 56523,
  [SMALL_STATE(710)] = 56601,
  [SMALL_STATE(711)] = 56679,
  [SMALL_STATE(712)] = 56757,
  [SMALL_STATE(713)] = 56835,
  [SMALL_STATE(714)] = 56913,
  [SMALL_STATE(715)] = 56991,
  [SMALL_STATE(716)] = 57069,
  [SMALL_STATE(717)] = 57147,
  [SMALL_STATE(718)] = 57225,
  [SMALL_STATE(719)] = 57303,
  [SMALL_STATE(720)] = 57381,
  [SMALL_STATE(721)] = 57459,
  [SMALL_STATE(722)] = 57537,
  [SMALL_STATE(723)] = 57615,
  [SMALL_STATE(724)] = 57699,
  [SMALL_STATE(725)] = 57777,
  [SMALL_STATE(726)] = 57855,
  [SMALL_STATE(727)] = 57933,
  [SMALL_STATE(728)] = 58011,
  [SMALL_STATE(729)] = 58089,
  [SMALL_STATE(730)] = 58167,
  [SMALL_STATE(731)] = 58245,
  [SMALL_STATE(732)] = 58323,
  [SMALL_STATE(733)] = 58401,
  [SMALL_STATE(734)] = 58485,
  [SMALL_STATE(735)] = 58563,
  [SMALL_STATE(736)] = 58641,
  [SMALL_STATE(737)] = 58725,
  [SMALL_STATE(738)] = 58809,
  [SMALL_STATE(739)] = 58887,
  [SMALL_STATE(740)] = 58965,
  [SMALL_STATE(741)] = 59043,
  [SMALL_STATE(742)] = 59121,
  [SMALL_STATE(743)] = 59205,
  [SMALL_STATE(744)] = 59283,
  [SMALL_STATE(745)] = 59367,
  [SMALL_STATE(746)] = 59451,
  [SMALL_STATE(747)] = 59529,
  [SMALL_STATE(748)] = 59607,
  [SMALL_STATE(749)] = 59685,
  [SMALL_STATE(750)] = 59763,
  [SMALL_STATE(751)] = 59841,
  [SMALL_STATE(752)] = 59919,
  [SMALL_STATE(753)] = 59997,
  [SMALL_STATE(754)] = 60075,
  [SMALL_STATE(755)] = 60153,
  [SMALL_STATE(756)] = 60237,
  [SMALL_STATE(757)] = 60315,
  [SMALL_STATE(758)] = 60393,
  [SMALL_STATE(759)] = 60477,
  [SMALL_STATE(760)] = 60555,
  [SMALL_STATE(761)] = 60633,
  [SMALL_STATE(762)] = 60711,
  [SMALL_STATE(763)] = 60789,
  [SMALL_STATE(764)] = 60867,
  [SMALL_STATE(765)] = 60945,
  [SMALL_STATE(766)] = 61023,
  [SMALL_STATE(767)] = 61101,
  [SMALL_STATE(768)] = 61179,
  [SMALL_STATE(769)] = 61263,
  [SMALL_STATE(770)] = 61341,
  [SMALL_STATE(771)] = 61425,
  [SMALL_STATE(772)] = 61503,
  [SMALL_STATE(773)] = 61581,
  [SMALL_STATE(774)] = 61659,
  [SMALL_STATE(775)] = 61743,
  [SMALL_STATE(776)] = 61827,
  [SMALL_STATE(777)] = 61905,
  [SMALL_STATE(778)] = 61983,
  [SMALL_STATE(779)] = 62061,
  [SMALL_STATE(780)] = 62139,
  [SMALL_STATE(781)] = 62217,
  [SMALL_STATE(782)] = 62295,
  [SMALL_STATE(783)] = 62373,
  [SMALL_STATE(784)] = 62451,
  [SMALL_STATE(785)] = 62529,
  [SMALL_STATE(786)] = 62607,
  [SMALL_STATE(787)] = 62685,
  [SMALL_STATE(788)] = 62763,
  [SMALL_STATE(789)] = 62841,
  [SMALL_STATE(790)] = 62919,
  [SMALL_STATE(791)] = 62997,
  [SMALL_STATE(792)] = 63075,
  [SMALL_STATE(793)] = 63153,
  [SMALL_STATE(794)] = 63231,
  [SMALL_STATE(795)] = 63315,
  [SMALL_STATE(796)] = 63393,
  [SMALL_STATE(797)] = 63471,
  [SMALL_STATE(798)] = 63549,
  [SMALL_STATE(799)] = 63627,
  [SMALL_STATE(800)] = 63705,
  [SMALL_STATE(801)] = 63783,
  [SMALL_STATE(802)] = 63861,
  [SMALL_STATE(803)] = 63939,
  [SMALL_STATE(804)] = 64017,
  [SMALL_STATE(805)] = 64095,
  [SMALL_STATE(806)] = 64173,
  [SMALL_STATE(807)] = 64251,
  [SMALL_STATE(808)] = 64329,
  [SMALL_STATE(809)] = 64407,
  [SMALL_STATE(810)] = 64491,
  [SMALL_STATE(811)] = 64569,
  [SMALL_STATE(812)] = 64647,
  [SMALL_STATE(813)] = 64725,
  [SMALL_STATE(814)] = 64803,
  [SMALL_STATE(815)] = 64881,
  [SMALL_STATE(816)] = 64959,
  [SMALL_STATE(817)] = 65037,
  [SMALL_STATE(818)] = 65115,
  [SMALL_STATE(819)] = 65193,
  [SMALL_STATE(820)] = 65271,
  [SMALL_STATE(821)] = 65349,
  [SMALL_STATE(822)] = 65427,
  [SMALL_STATE(823)] = 65511,
  [SMALL_STATE(824)] = 65589,
  [SMALL_STATE(825)] = 65667,
  [SMALL_STATE(826)] = 65745,
  [SMALL_STATE(827)] = 65823,
  [SMALL_STATE(828)] = 65901,
  [SMALL_STATE(829)] = 65979,
  [SMALL_STATE(830)] = 66057,
  [SMALL_STATE(831)] = 66135,
  [SMALL_STATE(832)] = 66213,
  [SMALL_STATE(833)] = 66291,
  [SMALL_STATE(834)] = 66343,
  [SMALL_STATE(835)] = 66395,
  [SMALL_STATE(836)] = 66447,
  [SMALL_STATE(837)] = 66498,
  [SMALL_STATE(838)] = 66549,
  [SMALL_STATE(839)] = 66600,
  [SMALL_STATE(840)] = 66681,
  [SMALL_STATE(841)] = 66762,
  [SMALL_STATE(842)] = 66813,
  [SMALL_STATE(843)] = 66864,
  [SMALL_STATE(844)] = 66915,
  [SMALL_STATE(845)] = 66996,
  [SMALL_STATE(846)] = 67062,
  [SMALL_STATE(847)] = 67140,
  [SMALL_STATE(848)] = 67210,
  [SMALL_STATE(849)] = 67258,
  [SMALL_STATE(850)] = 67314,
  [SMALL_STATE(851)] = 67364,
  [SMALL_STATE(852)] = 67414,
  [SMALL_STATE(853)] = 67470,
  [SMALL_STATE(854)] = 67520,
  [SMALL_STATE(855)] = 67586,
  [SMALL_STATE(856)] = 67648,
  [SMALL_STATE(857)] = 67696,
  [SMALL_STATE(858)] = 67746,
  [SMALL_STATE(859)] = 67826,
  [SMALL_STATE(860)] = 67882,
  [SMALL_STATE(861)] = 67938,
  [SMALL_STATE(862)] = 67994,
  [SMALL_STATE(863)] = 68040,
  [SMALL_STATE(864)] = 68090,
  [SMALL_STATE(865)] = 68140,
  [SMALL_STATE(866)] = 68210,
  [SMALL_STATE(867)] = 68256,
  [SMALL_STATE(868)] = 68326,
  [SMALL_STATE(869)] = 68376,
  [SMALL_STATE(870)] = 68440,
  [SMALL_STATE(871)] = 68490,
  [SMALL_STATE(872)] = 68546,
  [SMALL_STATE(873)] = 68602,
  [SMALL_STATE(874)] = 68658,
  [SMALL_STATE(875)] = 68738,
  [SMALL_STATE(876)] = 68794,
  [SMALL_STATE(877)] = 68856,
  [SMALL_STATE(878)] = 68934,
  [SMALL_STATE(879)] = 69004,
  [SMALL_STATE(880)] = 69066,
  [SMALL_STATE(881)] = 69126,
  [SMALL_STATE(882)] = 69182,
  [SMALL_STATE(883)] = 69250,
  [SMALL_STATE(884)] = 69330,
  [SMALL_STATE(885)] = 69380,
  [SMALL_STATE(886)] = 69430,
  [SMALL_STATE(887)] = 69500,
  [SMALL_STATE(888)] = 69548,
  [SMALL_STATE(889)] = 69618,
  [SMALL_STATE(890)] = 69678,
  [SMALL_STATE(891)] = 69748,
  [SMALL_STATE(892)] = 69808,
  [SMALL_STATE(893)] = 69858,
  [SMALL_STATE(894)] = 69914,
  [SMALL_STATE(895)] = 69982,
  [SMALL_STATE(896)] = 70048,
  [SMALL_STATE(897)] = 70112,
  [SMALL_STATE(898)] = 70182,
  [SMALL_STATE(899)] = 70238,
  [SMALL_STATE(900)] = 70288,
  [SMALL_STATE(901)] = 70358,
  [SMALL_STATE(902)] = 70426,
  [SMALL_STATE(903)] = 70490,
  [SMALL_STATE(904)] = 70537,
  [SMALL_STATE(905)] = 70588,
  [SMALL_STATE(906)] = 70655,
  [SMALL_STATE(907)] = 70700,
  [SMALL_STATE(908)] = 70745,
  [SMALL_STATE(909)] = 70790,
  [SMALL_STATE(910)] = 70855,
  [SMALL_STATE(911)] = 70918,
  [SMALL_STATE(912)] = 70963,
  [SMALL_STATE(913)] = 71024,
  [SMALL_STATE(914)] = 71093,
  [SMALL_STATE(915)] = 71148,
  [SMALL_STATE(916)] = 71217,
  [SMALL_STATE(917)] = 71272,
  [SMALL_STATE(918)] = 71317,
  [SMALL_STATE(919)] = 71372,
  [SMALL_STATE(920)] = 71439,
  [SMALL_STATE(921)] = 71498,
  [SMALL_STATE(922)] = 71553,
  [SMALL_STATE(923)] = 71632,
  [SMALL_STATE(924)] = 71679,
  [SMALL_STATE(925)] = 71728,
  [SMALL_STATE(926)] = 71793,
  [SMALL_STATE(927)] = 71838,
  [SMALL_STATE(928)] = 71883,
  [SMALL_STATE(929)] = 71952,
  [SMALL_STATE(930)] = 72007,
  [SMALL_STATE(931)] = 72066,
  [SMALL_STATE(932)] = 72111,
  [SMALL_STATE(933)] = 72160,
  [SMALL_STATE(934)] = 72209,
  [SMALL_STATE(935)] = 72258,
  [SMALL_STATE(936)] = 72319,
  [SMALL_STATE(937)] = 72382,
  [SMALL_STATE(938)] = 72437,
  [SMALL_STATE(939)] = 72488,
  [SMALL_STATE(940)] = 72539,
  [SMALL_STATE(941)] = 72608,
  [SMALL_STATE(942)] = 72655,
  [SMALL_STATE(943)] = 72724,
  [SMALL_STATE(944)] = 72775,
  [SMALL_STATE(945)] = 72820,
  [SMALL_STATE(946)] = 72865,
  [SMALL_STATE(947)] = 72910,
  [SMALL_STATE(948)] = 72979,
  [SMALL_STATE(949)] = 73048,
  [SMALL_STATE(950)] = 73117,
  [SMALL_STATE(951)] = 73166,
  [SMALL_STATE(952)] = 73235,
  [SMALL_STATE(953)] = 73282,
  [SMALL_STATE(954)] = 73337,
  [SMALL_STATE(955)] = 73382,
  [SMALL_STATE(956)] = 73437,
  [SMALL_STATE(957)] = 73492,
  [SMALL_STATE(958)] = 73553,
  [SMALL_STATE(959)] = 73608,
  [SMALL_STATE(960)] = 73677,
  [SMALL_STATE(961)] = 73736,
  [SMALL_STATE(962)] = 73781,
  [SMALL_STATE(963)] = 73836,
  [SMALL_STATE(964)] = 73903,
  [SMALL_STATE(965)] = 73958,
  [SMALL_STATE(966)] = 74023,
  [SMALL_STATE(967)] = 74086,
  [SMALL_STATE(968)] = 74133,
  [SMALL_STATE(969)] = 74184,
  [SMALL_STATE(970)] = 74229,
  [SMALL_STATE(971)] = 74274,
  [SMALL_STATE(972)] = 74319,
  [SMALL_STATE(973)] = 74364,
  [SMALL_STATE(974)] = 74409,
  [SMALL_STATE(975)] = 74458,
  [SMALL_STATE(976)] = 74503,
  [SMALL_STATE(977)] = 74552,
  [SMALL_STATE(978)] = 74607,
  [SMALL_STATE(979)] = 74654,
  [SMALL_STATE(980)] = 74703,
  [SMALL_STATE(981)] = 74748,
  [SMALL_STATE(982)] = 74793,
  [SMALL_STATE(983)] = 74838,
  [SMALL_STATE(984)] = 74887,
  [SMALL_STATE(985)] = 74942,
  [SMALL_STATE(986)] = 74987,
  [SMALL_STATE(987)] = 75032,
  [SMALL_STATE(988)] = 75081,
  [SMALL_STATE(989)] = 75150,
  [SMALL_STATE(990)] = 75195,
  [SMALL_STATE(991)] = 75272,
  [SMALL_STATE(992)] = 75321,
  [SMALL_STATE(993)] = 75366,
  [SMALL_STATE(994)] = 75411,
  [SMALL_STATE(995)] = 75456,
  [SMALL_STATE(996)] = 75501,
  [SMALL_STATE(997)] = 75556,
  [SMALL_STATE(998)] = 75601,
  [SMALL_STATE(999)] = 75646,
  [SMALL_STATE(1000)] = 75691,
  [SMALL_STATE(1001)] = 75736,
  [SMALL_STATE(1002)] = 75781,
  [SMALL_STATE(1003)] = 75842,
  [SMALL_STATE(1004)] = 75891,
  [SMALL_STATE(1005)] = 75950,
  [SMALL_STATE(1006)] = 76005,
  [SMALL_STATE(1007)] = 76072,
  [SMALL_STATE(1008)] = 76117,
  [SMALL_STATE(1009)] = 76182,
  [SMALL_STATE(1010)] = 76245,
  [SMALL_STATE(1011)] = 76314,
  [SMALL_STATE(1012)] = 76359,
  [SMALL_STATE(1013)] = 76404,
  [SMALL_STATE(1014)] = 76470,
  [SMALL_STATE(1015)] = 76538,
  [SMALL_STATE(1016)] = 76582,
  [SMALL_STATE(1017)] = 76628,
  [SMALL_STATE(1018)] = 76674,
  [SMALL_STATE(1019)] = 76720,
  [SMALL_STATE(1020)] = 76782,
  [SMALL_STATE(1021)] = 76846,
  [SMALL_STATE(1022)] = 76912,
  [SMALL_STATE(1023)] = 76966,
  [SMALL_STATE(1024)] = 77024,
  [SMALL_STATE(1025)] = 77084,
  [SMALL_STATE(1026)] = 77138,
  [SMALL_STATE(1027)] = 77182,
  [SMALL_STATE(1028)] = 77226,
  [SMALL_STATE(1029)] = 77270,
  [SMALL_STATE(1030)] = 77324,
  [SMALL_STATE(1031)] = 77378,
  [SMALL_STATE(1032)] = 77454,
  [SMALL_STATE(1033)] = 77500,
  [SMALL_STATE(1034)] = 77546,
  [SMALL_STATE(1035)] = 77622,
  [SMALL_STATE(1036)] = 77668,
  [SMALL_STATE(1037)] = 77712,
  [SMALL_STATE(1038)] = 77756,
  [SMALL_STATE(1039)] = 77800,
  [SMALL_STATE(1040)] = 77868,
  [SMALL_STATE(1041)] = 77936,
  [SMALL_STATE(1042)] = 77984,
  [SMALL_STATE(1043)] = 78030,
  [SMALL_STATE(1044)] = 78078,
  [SMALL_STATE(1045)] = 78126,
  [SMALL_STATE(1046)] = 78174,
  [SMALL_STATE(1047)] = 78220,
  [SMALL_STATE(1048)] = 78266,
  [SMALL_STATE(1049)] = 78310,
  [SMALL_STATE(1050)] = 78358,
  [SMALL_STATE(1051)] = 78402,
  [SMALL_STATE(1052)] = 78470,
  [SMALL_STATE(1053)] = 78514,
  [SMALL_STATE(1054)] = 78560,
  [SMALL_STATE(1055)] = 78606,
  [SMALL_STATE(1056)] = 78650,
  [SMALL_STATE(1057)] = 78698,
  [SMALL_STATE(1058)] = 78746,
  [SMALL_STATE(1059)] = 78794,
  [SMALL_STATE(1060)] = 78838,
  [SMALL_STATE(1061)] = 78882,
  [SMALL_STATE(1062)] = 78926,
  [SMALL_STATE(1063)] = 78970,
  [SMALL_STATE(1064)] = 79014,
  [SMALL_STATE(1065)] = 79058,
  [SMALL_STATE(1066)] = 79134,
  [SMALL_STATE(1067)] = 79178,
  [SMALL_STATE(1068)] = 79222,
  [SMALL_STATE(1069)] = 79266,
  [SMALL_STATE(1070)] = 79310,
  [SMALL_STATE(1071)] = 79354,
  [SMALL_STATE(1072)] = 79398,
  [SMALL_STATE(1073)] = 79442,
  [SMALL_STATE(1074)] = 79486,
  [SMALL_STATE(1075)] = 79530,
  [SMALL_STATE(1076)] = 79574,
  [SMALL_STATE(1077)] = 79618,
  [SMALL_STATE(1078)] = 79662,
  [SMALL_STATE(1079)] = 79706,
  [SMALL_STATE(1080)] = 79756,
  [SMALL_STATE(1081)] = 79800,
  [SMALL_STATE(1082)] = 79844,
  [SMALL_STATE(1083)] = 79888,
  [SMALL_STATE(1084)] = 79932,
  [SMALL_STATE(1085)] = 79976,
  [SMALL_STATE(1086)] = 80020,
  [SMALL_STATE(1087)] = 80064,
  [SMALL_STATE(1088)] = 80108,
  [SMALL_STATE(1089)] = 80158,
  [SMALL_STATE(1090)] = 80206,
  [SMALL_STATE(1091)] = 80252,
  [SMALL_STATE(1092)] = 80300,
  [SMALL_STATE(1093)] = 80348,
  [SMALL_STATE(1094)] = 80394,
  [SMALL_STATE(1095)] = 80438,
  [SMALL_STATE(1096)] = 80482,
  [SMALL_STATE(1097)] = 80526,
  [SMALL_STATE(1098)] = 80570,
  [SMALL_STATE(1099)] = 80614,
  [SMALL_STATE(1100)] = 80658,
  [SMALL_STATE(1101)] = 80702,
  [SMALL_STATE(1102)] = 80750,
  [SMALL_STATE(1103)] = 80798,
  [SMALL_STATE(1104)] = 80842,
  [SMALL_STATE(1105)] = 80890,
  [SMALL_STATE(1106)] = 80934,
  [SMALL_STATE(1107)] = 80978,
  [SMALL_STATE(1108)] = 81022,
  [SMALL_STATE(1109)] = 81066,
  [SMALL_STATE(1110)] = 81110,
  [SMALL_STATE(1111)] = 81154,
  [SMALL_STATE(1112)] = 81202,
  [SMALL_STATE(1113)] = 81250,
  [SMALL_STATE(1114)] = 81298,
  [SMALL_STATE(1115)] = 81342,
  [SMALL_STATE(1116)] = 81386,
  [SMALL_STATE(1117)] = 81430,
  [SMALL_STATE(1118)] = 81474,
  [SMALL_STATE(1119)] = 81528,
  [SMALL_STATE(1120)] = 81582,
  [SMALL_STATE(1121)] = 81636,
  [SMALL_STATE(1122)] = 81680,
  [SMALL_STATE(1123)] = 81724,
  [SMALL_STATE(1124)] = 81784,
  [SMALL_STATE(1125)] = 81842,
  [SMALL_STATE(1126)] = 81896,
  [SMALL_STATE(1127)] = 81940,
  [SMALL_STATE(1128)] = 81986,
  [SMALL_STATE(1129)] = 82030,
  [SMALL_STATE(1130)] = 82074,
  [SMALL_STATE(1131)] = 82118,
  [SMALL_STATE(1132)] = 82162,
  [SMALL_STATE(1133)] = 82226,
  [SMALL_STATE(1134)] = 82270,
  [SMALL_STATE(1135)] = 82314,
  [SMALL_STATE(1136)] = 82358,
  [SMALL_STATE(1137)] = 82402,
  [SMALL_STATE(1138)] = 82464,
  [SMALL_STATE(1139)] = 82508,
  [SMALL_STATE(1140)] = 82552,
  [SMALL_STATE(1141)] = 82596,
  [SMALL_STATE(1142)] = 82640,
  [SMALL_STATE(1143)] = 82708,
  [SMALL_STATE(1144)] = 82754,
  [SMALL_STATE(1145)] = 82800,
  [SMALL_STATE(1146)] = 82844,
  [SMALL_STATE(1147)] = 82890,
  [SMALL_STATE(1148)] = 82938,
  [SMALL_STATE(1149)] = 83006,
  [SMALL_STATE(1150)] = 83050,
  [SMALL_STATE(1151)] = 83094,
  [SMALL_STATE(1152)] = 83138,
  [SMALL_STATE(1153)] = 83182,
  [SMALL_STATE(1154)] = 83226,
  [SMALL_STATE(1155)] = 83270,
  [SMALL_STATE(1156)] = 83314,
  [SMALL_STATE(1157)] = 83358,
  [SMALL_STATE(1158)] = 83402,
  [SMALL_STATE(1159)] = 83447,
  [SMALL_STATE(1160)] = 83490,
  [SMALL_STATE(1161)] = 83537,
  [SMALL_STATE(1162)] = 83580,
  [SMALL_STATE(1163)] = 83623,
  [SMALL_STATE(1164)] = 83666,
  [SMALL_STATE(1165)] = 83713,
  [SMALL_STATE(1166)] = 83764,
  [SMALL_STATE(1167)] = 83811,
  [SMALL_STATE(1168)] = 83856,
  [SMALL_STATE(1169)] = 83907,
  [SMALL_STATE(1170)] = 83952,
  [SMALL_STATE(1171)] = 83997,
  [SMALL_STATE(1172)] = 84040,
  [SMALL_STATE(1173)] = 84083,
  [SMALL_STATE(1174)] = 84126,
  [SMALL_STATE(1175)] = 84171,
  [SMALL_STATE(1176)] = 84214,
  [SMALL_STATE(1177)] = 84259,
  [SMALL_STATE(1178)] = 84302,
  [SMALL_STATE(1179)] = 84345,
  [SMALL_STATE(1180)] = 84388,
  [SMALL_STATE(1181)] = 84435,
  [SMALL_STATE(1182)] = 84482,
  [SMALL_STATE(1183)] = 84525,
  [SMALL_STATE(1184)] = 84568,
  [SMALL_STATE(1185)] = 84611,
  [SMALL_STATE(1186)] = 84654,
  [SMALL_STATE(1187)] = 84697,
  [SMALL_STATE(1188)] = 84740,
  [SMALL_STATE(1189)] = 84783,
  [SMALL_STATE(1190)] = 84826,
  [SMALL_STATE(1191)] = 84869,
  [SMALL_STATE(1192)] = 84912,
  [SMALL_STATE(1193)] = 84987,
  [SMALL_STATE(1194)] = 85030,
  [SMALL_STATE(1195)] = 85073,
  [SMALL_STATE(1196)] = 85116,
  [SMALL_STATE(1197)] = 85159,
  [SMALL_STATE(1198)] = 85202,
  [SMALL_STATE(1199)] = 85245,
  [SMALL_STATE(1200)] = 85288,
  [SMALL_STATE(1201)] = 85331,
  [SMALL_STATE(1202)] = 85374,
  [SMALL_STATE(1203)] = 85417,
  [SMALL_STATE(1204)] = 85460,
  [SMALL_STATE(1205)] = 85503,
  [SMALL_STATE(1206)] = 85546,
  [SMALL_STATE(1207)] = 85589,
  [SMALL_STATE(1208)] = 85632,
  [SMALL_STATE(1209)] = 85675,
  [SMALL_STATE(1210)] = 85718,
  [SMALL_STATE(1211)] = 85799,
  [SMALL_STATE(1212)] = 85842,
  [SMALL_STATE(1213)] = 85885,
  [SMALL_STATE(1214)] = 85928,
  [SMALL_STATE(1215)] = 85971,
  [SMALL_STATE(1216)] = 86018,
  [SMALL_STATE(1217)] = 86061,
  [SMALL_STATE(1218)] = 86106,
  [SMALL_STATE(1219)] = 86149,
  [SMALL_STATE(1220)] = 86192,
  [SMALL_STATE(1221)] = 86235,
  [SMALL_STATE(1222)] = 86280,
  [SMALL_STATE(1223)] = 86323,
  [SMALL_STATE(1224)] = 86366,
  [SMALL_STATE(1225)] = 86409,
  [SMALL_STATE(1226)] = 86452,
  [SMALL_STATE(1227)] = 86495,
  [SMALL_STATE(1228)] = 86538,
  [SMALL_STATE(1229)] = 86581,
  [SMALL_STATE(1230)] = 86624,
  [SMALL_STATE(1231)] = 86667,
  [SMALL_STATE(1232)] = 86710,
  [SMALL_STATE(1233)] = 86753,
  [SMALL_STATE(1234)] = 86796,
  [SMALL_STATE(1235)] = 86839,
  [SMALL_STATE(1236)] = 86882,
  [SMALL_STATE(1237)] = 86925,
  [SMALL_STATE(1238)] = 86968,
  [SMALL_STATE(1239)] = 87011,
  [SMALL_STATE(1240)] = 87058,
  [SMALL_STATE(1241)] = 87101,
  [SMALL_STATE(1242)] = 87148,
  [SMALL_STATE(1243)] = 87191,
  [SMALL_STATE(1244)] = 87236,
  [SMALL_STATE(1245)] = 87279,
  [SMALL_STATE(1246)] = 87322,
  [SMALL_STATE(1247)] = 87365,
  [SMALL_STATE(1248)] = 87408,
  [SMALL_STATE(1249)] = 87451,
  [SMALL_STATE(1250)] = 87494,
  [SMALL_STATE(1251)] = 87537,
  [SMALL_STATE(1252)] = 87580,
  [SMALL_STATE(1253)] = 87623,
  [SMALL_STATE(1254)] = 87666,
  [SMALL_STATE(1255)] = 87711,
  [SMALL_STATE(1256)] = 87758,
  [SMALL_STATE(1257)] = 87801,
  [SMALL_STATE(1258)] = 87844,
  [SMALL_STATE(1259)] = 87887,
  [SMALL_STATE(1260)] = 87930,
  [SMALL_STATE(1261)] = 87973,
  [SMALL_STATE(1262)] = 88016,
  [SMALL_STATE(1263)] = 88059,
  [SMALL_STATE(1264)] = 88104,
  [SMALL_STATE(1265)] = 88149,
  [SMALL_STATE(1266)] = 88192,
  [SMALL_STATE(1267)] = 88235,
  [SMALL_STATE(1268)] = 88278,
  [SMALL_STATE(1269)] = 88321,
  [SMALL_STATE(1270)] = 88366,
  [SMALL_STATE(1271)] = 88409,
  [SMALL_STATE(1272)] = 88454,
  [SMALL_STATE(1273)] = 88497,
  [SMALL_STATE(1274)] = 88542,
  [SMALL_STATE(1275)] = 88585,
  [SMALL_STATE(1276)] = 88628,
  [SMALL_STATE(1277)] = 88671,
  [SMALL_STATE(1278)] = 88714,
  [SMALL_STATE(1279)] = 88757,
  [SMALL_STATE(1280)] = 88800,
  [SMALL_STATE(1281)] = 88843,
  [SMALL_STATE(1282)] = 88886,
  [SMALL_STATE(1283)] = 88929,
  [SMALL_STATE(1284)] = 88972,
  [SMALL_STATE(1285)] = 89015,
  [SMALL_STATE(1286)] = 89058,
  [SMALL_STATE(1287)] = 89101,
  [SMALL_STATE(1288)] = 89144,
  [SMALL_STATE(1289)] = 89187,
  [SMALL_STATE(1290)] = 89230,
  [SMALL_STATE(1291)] = 89273,
  [SMALL_STATE(1292)] = 89316,
  [SMALL_STATE(1293)] = 89359,
  [SMALL_STATE(1294)] = 89406,
  [SMALL_STATE(1295)] = 89449,
  [SMALL_STATE(1296)] = 89492,
  [SMALL_STATE(1297)] = 89535,
  [SMALL_STATE(1298)] = 89578,
  [SMALL_STATE(1299)] = 89621,
  [SMALL_STATE(1300)] = 89666,
  [SMALL_STATE(1301)] = 89709,
  [SMALL_STATE(1302)] = 89754,
  [SMALL_STATE(1303)] = 89797,
  [SMALL_STATE(1304)] = 89840,
  [SMALL_STATE(1305)] = 89883,
  [SMALL_STATE(1306)] = 89926,
  [SMALL_STATE(1307)] = 89969,
  [SMALL_STATE(1308)] = 90012,
  [SMALL_STATE(1309)] = 90055,
  [SMALL_STATE(1310)] = 90098,
  [SMALL_STATE(1311)] = 90143,
  [SMALL_STATE(1312)] = 90188,
  [SMALL_STATE(1313)] = 90235,
  [SMALL_STATE(1314)] = 90282,
  [SMALL_STATE(1315)] = 90329,
  [SMALL_STATE(1316)] = 90410,
  [SMALL_STATE(1317)] = 90457,
  [SMALL_STATE(1318)] = 90500,
  [SMALL_STATE(1319)] = 90543,
  [SMALL_STATE(1320)] = 90586,
  [SMALL_STATE(1321)] = 90633,
  [SMALL_STATE(1322)] = 90676,
  [SMALL_STATE(1323)] = 90719,
  [SMALL_STATE(1324)] = 90762,
  [SMALL_STATE(1325)] = 90808,
  [SMALL_STATE(1326)] = 90866,
  [SMALL_STATE(1327)] = 90908,
  [SMALL_STATE(1328)] = 90954,
  [SMALL_STATE(1329)] = 91014,
  [SMALL_STATE(1330)] = 91076,
  [SMALL_STATE(1331)] = 91128,
  [SMALL_STATE(1332)] = 91176,
  [SMALL_STATE(1333)] = 91220,
  [SMALL_STATE(1334)] = 91262,
  [SMALL_STATE(1335)] = 91306,
  [SMALL_STATE(1336)] = 91350,
  [SMALL_STATE(1337)] = 91416,
  [SMALL_STATE(1338)] = 91460,
  [SMALL_STATE(1339)] = 91502,
  [SMALL_STATE(1340)] = 91544,
  [SMALL_STATE(1341)] = 91588,
  [SMALL_STATE(1342)] = 91640,
  [SMALL_STATE(1343)] = 91682,
  [SMALL_STATE(1344)] = 91724,
  [SMALL_STATE(1345)] = 91766,
  [SMALL_STATE(1346)] = 91810,
  [SMALL_STATE(1347)] = 91874,
  [SMALL_STATE(1348)] = 91916,
  [SMALL_STATE(1349)] = 91958,
  [SMALL_STATE(1350)] = 92000,
  [SMALL_STATE(1351)] = 92042,
  [SMALL_STATE(1352)] = 92084,
  [SMALL_STATE(1353)] = 92126,
  [SMALL_STATE(1354)] = 92168,
  [SMALL_STATE(1355)] = 92210,
  [SMALL_STATE(1356)] = 92252,
  [SMALL_STATE(1357)] = 92294,
  [SMALL_STATE(1358)] = 92336,
  [SMALL_STATE(1359)] = 92402,
  [SMALL_STATE(1360)] = 92454,
  [SMALL_STATE(1361)] = 92498,
  [SMALL_STATE(1362)] = 92542,
  [SMALL_STATE(1363)] = 92584,
  [SMALL_STATE(1364)] = 92628,
  [SMALL_STATE(1365)] = 92694,
  [SMALL_STATE(1366)] = 92750,
  [SMALL_STATE(1367)] = 92792,
  [SMALL_STATE(1368)] = 92844,
  [SMALL_STATE(1369)] = 92886,
  [SMALL_STATE(1370)] = 92928,
  [SMALL_STATE(1371)] = 92970,
  [SMALL_STATE(1372)] = 93012,
  [SMALL_STATE(1373)] = 93054,
  [SMALL_STATE(1374)] = 93096,
  [SMALL_STATE(1375)] = 93146,
  [SMALL_STATE(1376)] = 93188,
  [SMALL_STATE(1377)] = 93230,
  [SMALL_STATE(1378)] = 93272,
  [SMALL_STATE(1379)] = 93314,
  [SMALL_STATE(1380)] = 93356,
  [SMALL_STATE(1381)] = 93398,
  [SMALL_STATE(1382)] = 93444,
  [SMALL_STATE(1383)] = 93486,
  [SMALL_STATE(1384)] = 93527,
  [SMALL_STATE(1385)] = 93570,
  [SMALL_STATE(1386)] = 93611,
  [SMALL_STATE(1387)] = 93654,
  [SMALL_STATE(1388)] = 93695,
  [SMALL_STATE(1389)] = 93736,
  [SMALL_STATE(1390)] = 93777,
  [SMALL_STATE(1391)] = 93820,
  [SMALL_STATE(1392)] = 93861,
  [SMALL_STATE(1393)] = 93904,
  [SMALL_STATE(1394)] = 93945,
  [SMALL_STATE(1395)] = 93988,
  [SMALL_STATE(1396)] = 94031,
  [SMALL_STATE(1397)] = 94074,
  [SMALL_STATE(1398)] = 94117,
  [SMALL_STATE(1399)] = 94160,
  [SMALL_STATE(1400)] = 94201,
  [SMALL_STATE(1401)] = 94242,
  [SMALL_STATE(1402)] = 94283,
  [SMALL_STATE(1403)] = 94324,
  [SMALL_STATE(1404)] = 94365,
  [SMALL_STATE(1405)] = 94397,
  [SMALL_STATE(1406)] = 94437,
  [SMALL_STATE(1407)] = 94469,
  [SMALL_STATE(1408)] = 94501,
  [SMALL_STATE(1409)] = 94533,
  [SMALL_STATE(1410)] = 94573,
  [SMALL_STATE(1411)] = 94605,
  [SMALL_STATE(1412)] = 94637,
  [SMALL_STATE(1413)] = 94674,
  [SMALL_STATE(1414)] = 94713,
  [SMALL_STATE(1415)] = 94752,
  [SMALL_STATE(1416)] = 94791,
  [SMALL_STATE(1417)] = 94830,
  [SMALL_STATE(1418)] = 94867,
  [SMALL_STATE(1419)] = 94906,
  [SMALL_STATE(1420)] = 94945,
  [SMALL_STATE(1421)] = 94975,
  [SMALL_STATE(1422)] = 95011,
  [SMALL_STATE(1423)] = 95041,
  [SMALL_STATE(1424)] = 95079,
  [SMALL_STATE(1425)] = 95109,
  [SMALL_STATE(1426)] = 95145,
  [SMALL_STATE(1427)] = 95175,
  [SMALL_STATE(1428)] = 95213,
  [SMALL_STATE(1429)] = 95251,
  [SMALL_STATE(1430)] = 95281,
  [SMALL_STATE(1431)] = 95311,
  [SMALL_STATE(1432)] = 95341,
  [SMALL_STATE(1433)] = 95371,
  [SMALL_STATE(1434)] = 95409,
  [SMALL_STATE(1435)] = 95438,
  [SMALL_STATE(1436)] = 95467,
  [SMALL_STATE(1437)] = 95506,
  [SMALL_STATE(1438)] = 95543,
  [SMALL_STATE(1439)] = 95590,
  [SMALL_STATE(1440)] = 95635,
  [SMALL_STATE(1441)] = 95678,
  [SMALL_STATE(1442)] = 95725,
  [SMALL_STATE(1443)] = 95762,
  [SMALL_STATE(1444)] = 95809,
  [SMALL_STATE(1445)] = 95856,
  [SMALL_STATE(1446)] = 95885,
  [SMALL_STATE(1447)] = 95932,
  [SMALL_STATE(1448)] = 95961,
  [SMALL_STATE(1449)] = 95990,
  [SMALL_STATE(1450)] = 96031,
  [SMALL_STATE(1451)] = 96060,
  [SMALL_STATE(1452)] = 96107,
  [SMALL_STATE(1453)] = 96154,
  [SMALL_STATE(1454)] = 96179,
  [SMALL_STATE(1455)] = 96204,
  [SMALL_STATE(1456)] = 96233,
  [SMALL_STATE(1457)] = 96262,
  [SMALL_STATE(1458)] = 96291,
  [SMALL_STATE(1459)] = 96320,
  [SMALL_STATE(1460)] = 96367,
  [SMALL_STATE(1461)] = 96396,
  [SMALL_STATE(1462)] = 96425,
  [SMALL_STATE(1463)] = 96454,
  [SMALL_STATE(1464)] = 96495,
  [SMALL_STATE(1465)] = 96520,
  [SMALL_STATE(1466)] = 96545,
  [SMALL_STATE(1467)] = 96574,
  [SMALL_STATE(1468)] = 96621,
  [SMALL_STATE(1469)] = 96668,
  [SMALL_STATE(1470)] = 96697,
  [SMALL_STATE(1471)] = 96726,
  [SMALL_STATE(1472)] = 96755,
  [SMALL_STATE(1473)] = 96784,
  [SMALL_STATE(1474)] = 96831,
  [SMALL_STATE(1475)] = 96860,
  [SMALL_STATE(1476)] = 96897,
  [SMALL_STATE(1477)] = 96934,
  [SMALL_STATE(1478)] = 96963,
  [SMALL_STATE(1479)] = 96992,
  [SMALL_STATE(1480)] = 97021,
  [SMALL_STATE(1481)] = 97050,
  [SMALL_STATE(1482)] = 97079,
  [SMALL_STATE(1483)] = 97103,
  [SMALL_STATE(1484)] = 97129,
  [SMALL_STATE(1485)] = 97175,
  [SMALL_STATE(1486)] = 97221,
  [SMALL_STATE(1487)] = 97263,
  [SMALL_STATE(1488)] = 97287,
  [SMALL_STATE(1489)] = 97333,
  [SMALL_STATE(1490)] = 97361,
  [SMALL_STATE(1491)] = 97407,
  [SMALL_STATE(1492)] = 97431,
  [SMALL_STATE(1493)] = 97477,
  [SMALL_STATE(1494)] = 97523,
  [SMALL_STATE(1495)] = 97555,
  [SMALL_STATE(1496)] = 97587,
  [SMALL_STATE(1497)] = 97633,
  [SMALL_STATE(1498)] = 97679,
  [SMALL_STATE(1499)] = 97709,
  [SMALL_STATE(1500)] = 97755,
  [SMALL_STATE(1501)] = 97783,
  [SMALL_STATE(1502)] = 97829,
  [SMALL_STATE(1503)] = 97875,
  [SMALL_STATE(1504)] = 97921,
  [SMALL_STATE(1505)] = 97945,
  [SMALL_STATE(1506)] = 97991,
  [SMALL_STATE(1507)] = 98024,
  [SMALL_STATE(1508)] = 98067,
  [SMALL_STATE(1509)] = 98100,
  [SMALL_STATE(1510)] = 98140,
  [SMALL_STATE(1511)] = 98180,
  [SMALL_STATE(1512)] = 98216,
  [SMALL_STATE(1513)] = 98246,
  [SMALL_STATE(1514)] = 98286,
  [SMALL_STATE(1515)] = 98312,
  [SMALL_STATE(1516)] = 98352,
  [SMALL_STATE(1517)] = 98389,
  [SMALL_STATE(1518)] = 98426,
  [SMALL_STATE(1519)] = 98457,
  [SMALL_STATE(1520)] = 98484,
  [SMALL_STATE(1521)] = 98511,
  [SMALL_STATE(1522)] = 98542,
  [SMALL_STATE(1523)] = 98564,
  [SMALL_STATE(1524)] = 98586,
  [SMALL_STATE(1525)] = 98616,
  [SMALL_STATE(1526)] = 98638,
  [SMALL_STATE(1527)] = 98657,
  [SMALL_STATE(1528)] = 98698,
  [SMALL_STATE(1529)] = 98739,
  [SMALL_STATE(1530)] = 98758,
  [SMALL_STATE(1531)] = 98777,
  [SMALL_STATE(1532)] = 98818,
  [SMALL_STATE(1533)] = 98859,
  [SMALL_STATE(1534)] = 98900,
  [SMALL_STATE(1535)] = 98941,
  [SMALL_STATE(1536)] = 98982,
  [SMALL_STATE(1537)] = 99007,
  [SMALL_STATE(1538)] = 99048,
  [SMALL_STATE(1539)] = 99086,
  [SMALL_STATE(1540)] = 99118,
  [SMALL_STATE(1541)] = 99142,
  [SMALL_STATE(1542)] = 99166,
  [SMALL_STATE(1543)] = 99190,
  [SMALL_STATE(1544)] = 99214,
  [SMALL_STATE(1545)] = 99252,
  [SMALL_STATE(1546)] = 99290,
  [SMALL_STATE(1547)] = 99312,
  [SMALL_STATE(1548)] = 99350,
  [SMALL_STATE(1549)] = 99388,
  [SMALL_STATE(1550)] = 99416,
  [SMALL_STATE(1551)] = 99454,
  [SMALL_STATE(1552)] = 99480,
  [SMALL_STATE(1553)] = 99518,
  [SMALL_STATE(1554)] = 99556,
  [SMALL_STATE(1555)] = 99594,
  [SMALL_STATE(1556)] = 99622,
  [SMALL_STATE(1557)] = 99660,
  [SMALL_STATE(1558)] = 99698,
  [SMALL_STATE(1559)] = 99724,
  [SMALL_STATE(1560)] = 99762,
  [SMALL_STATE(1561)] = 99800,
  [SMALL_STATE(1562)] = 99826,
  [SMALL_STATE(1563)] = 99864,
  [SMALL_STATE(1564)] = 99888,
  [SMALL_STATE(1565)] = 99926,
  [SMALL_STATE(1566)] = 99964,
  [SMALL_STATE(1567)] = 99988,
  [SMALL_STATE(1568)] = 100026,
  [SMALL_STATE(1569)] = 100064,
  [SMALL_STATE(1570)] = 100102,
  [SMALL_STATE(1571)] = 100130,
  [SMALL_STATE(1572)] = 100168,
  [SMALL_STATE(1573)] = 100206,
  [SMALL_STATE(1574)] = 100244,
  [SMALL_STATE(1575)] = 100264,
  [SMALL_STATE(1576)] = 100302,
  [SMALL_STATE(1577)] = 100340,
  [SMALL_STATE(1578)] = 100378,
  [SMALL_STATE(1579)] = 100403,
  [SMALL_STATE(1580)] = 100430,
  [SMALL_STATE(1581)] = 100449,
  [SMALL_STATE(1582)] = 100474,
  [SMALL_STATE(1583)] = 100503,
  [SMALL_STATE(1584)] = 100532,
  [SMALL_STATE(1585)] = 100561,
  [SMALL_STATE(1586)] = 100590,
  [SMALL_STATE(1587)] = 100615,
  [SMALL_STATE(1588)] = 100640,
  [SMALL_STATE(1589)] = 100669,
  [SMALL_STATE(1590)] = 100698,
  [SMALL_STATE(1591)] = 100717,
  [SMALL_STATE(1592)] = 100746,
  [SMALL_STATE(1593)] = 100775,
  [SMALL_STATE(1594)] = 100792,
  [SMALL_STATE(1595)] = 100821,
  [SMALL_STATE(1596)] = 100850,
  [SMALL_STATE(1597)] = 100879,
  [SMALL_STATE(1598)] = 100908,
  [SMALL_STATE(1599)] = 100935,
  [SMALL_STATE(1600)] = 100964,
  [SMALL_STATE(1601)] = 100993,
  [SMALL_STATE(1602)] = 101010,
  [SMALL_STATE(1603)] = 101039,
  [SMALL_STATE(1604)] = 101068,
  [SMALL_STATE(1605)] = 101097,
  [SMALL_STATE(1606)] = 101126,
  [SMALL_STATE(1607)] = 101145,
  [SMALL_STATE(1608)] = 101162,
  [SMALL_STATE(1609)] = 101183,
  [SMALL_STATE(1610)] = 101212,
  [SMALL_STATE(1611)] = 101235,
  [SMALL_STATE(1612)] = 101252,
  [SMALL_STATE(1613)] = 101281,
  [SMALL_STATE(1614)] = 101298,
  [SMALL_STATE(1615)] = 101323,
  [SMALL_STATE(1616)] = 101340,
  [SMALL_STATE(1617)] = 101369,
  [SMALL_STATE(1618)] = 101388,
  [SMALL_STATE(1619)] = 101415,
  [SMALL_STATE(1620)] = 101437,
  [SMALL_STATE(1621)] = 101455,
  [SMALL_STATE(1622)] = 101477,
  [SMALL_STATE(1623)] = 101501,
  [SMALL_STATE(1624)] = 101521,
  [SMALL_STATE(1625)] = 101537,
  [SMALL_STATE(1626)] = 101561,
  [SMALL_STATE(1627)] = 101585,
  [SMALL_STATE(1628)] = 101609,
  [SMALL_STATE(1629)] = 101633,
  [SMALL_STATE(1630)] = 101653,
  [SMALL_STATE(1631)] = 101671,
  [SMALL_STATE(1632)] = 101687,
  [SMALL_STATE(1633)] = 101707,
  [SMALL_STATE(1634)] = 101729,
  [SMALL_STATE(1635)] = 101753,
  [SMALL_STATE(1636)] = 101769,
  [SMALL_STATE(1637)] = 101793,
  [SMALL_STATE(1638)] = 101809,
  [SMALL_STATE(1639)] = 101825,
  [SMALL_STATE(1640)] = 101849,
  [SMALL_STATE(1641)] = 101871,
  [SMALL_STATE(1642)] = 101889,
  [SMALL_STATE(1643)] = 101909,
  [SMALL_STATE(1644)] = 101927,
  [SMALL_STATE(1645)] = 101951,
  [SMALL_STATE(1646)] = 101981,
  [SMALL_STATE(1647)] = 102005,
  [SMALL_STATE(1648)] = 102029,
  [SMALL_STATE(1649)] = 102053,
  [SMALL_STATE(1650)] = 102077,
  [SMALL_STATE(1651)] = 102101,
  [SMALL_STATE(1652)] = 102123,
  [SMALL_STATE(1653)] = 102139,
  [SMALL_STATE(1654)] = 102157,
  [SMALL_STATE(1655)] = 102181,
  [SMALL_STATE(1656)] = 102199,
  [SMALL_STATE(1657)] = 102223,
  [SMALL_STATE(1658)] = 102243,
  [SMALL_STATE(1659)] = 102272,
  [SMALL_STATE(1660)] = 102297,
  [SMALL_STATE(1661)] = 102320,
  [SMALL_STATE(1662)] = 102345,
  [SMALL_STATE(1663)] = 102370,
  [SMALL_STATE(1664)] = 102391,
  [SMALL_STATE(1665)] = 102410,
  [SMALL_STATE(1666)] = 102437,
  [SMALL_STATE(1667)] = 102466,
  [SMALL_STATE(1668)] = 102483,
  [SMALL_STATE(1669)] = 102506,
  [SMALL_STATE(1670)] = 102529,
  [SMALL_STATE(1671)] = 102552,
  [SMALL_STATE(1672)] = 102577,
  [SMALL_STATE(1673)] = 102602,
  [SMALL_STATE(1674)] = 102629,
  [SMALL_STATE(1675)] = 102654,
  [SMALL_STATE(1676)] = 102683,
  [SMALL_STATE(1677)] = 102700,
  [SMALL_STATE(1678)] = 102717,
  [SMALL_STATE(1679)] = 102746,
  [SMALL_STATE(1680)] = 102767,
  [SMALL_STATE(1681)] = 102788,
  [SMALL_STATE(1682)] = 102817,
  [SMALL_STATE(1683)] = 102842,
  [SMALL_STATE(1684)] = 102863,
  [SMALL_STATE(1685)] = 102884,
  [SMALL_STATE(1686)] = 102901,
  [SMALL_STATE(1687)] = 102918,
  [SMALL_STATE(1688)] = 102939,
  [SMALL_STATE(1689)] = 102956,
  [SMALL_STATE(1690)] = 102981,
  [SMALL_STATE(1691)] = 103010,
  [SMALL_STATE(1692)] = 103033,
  [SMALL_STATE(1693)] = 103054,
  [SMALL_STATE(1694)] = 103075,
  [SMALL_STATE(1695)] = 103096,
  [SMALL_STATE(1696)] = 103113,
  [SMALL_STATE(1697)] = 103132,
  [SMALL_STATE(1698)] = 103159,
  [SMALL_STATE(1699)] = 103182,
  [SMALL_STATE(1700)] = 103205,
  [SMALL_STATE(1701)] = 103232,
  [SMALL_STATE(1702)] = 103259,
  [SMALL_STATE(1703)] = 103284,
  [SMALL_STATE(1704)] = 103309,
  [SMALL_STATE(1705)] = 103338,
  [SMALL_STATE(1706)] = 103365,
  [SMALL_STATE(1707)] = 103392,
  [SMALL_STATE(1708)] = 103417,
  [SMALL_STATE(1709)] = 103442,
  [SMALL_STATE(1710)] = 103465,
  [SMALL_STATE(1711)] = 103482,
  [SMALL_STATE(1712)] = 103507,
  [SMALL_STATE(1713)] = 103532,
  [SMALL_STATE(1714)] = 103557,
  [SMALL_STATE(1715)] = 103582,
  [SMALL_STATE(1716)] = 103599,
  [SMALL_STATE(1717)] = 103622,
  [SMALL_STATE(1718)] = 103651,
  [SMALL_STATE(1719)] = 103678,
  [SMALL_STATE(1720)] = 103703,
  [SMALL_STATE(1721)] = 103722,
  [SMALL_STATE(1722)] = 103739,
  [SMALL_STATE(1723)] = 103760,
  [SMALL_STATE(1724)] = 103781,
  [SMALL_STATE(1725)] = 103804,
  [SMALL_STATE(1726)] = 103829,
  [SMALL_STATE(1727)] = 103858,
  [SMALL_STATE(1728)] = 103881,
  [SMALL_STATE(1729)] = 103898,
  [SMALL_STATE(1730)] = 103919,
  [SMALL_STATE(1731)] = 103940,
  [SMALL_STATE(1732)] = 103969,
  [SMALL_STATE(1733)] = 103986,
  [SMALL_STATE(1734)] = 104011,
  [SMALL_STATE(1735)] = 104034,
  [SMALL_STATE(1736)] = 104057,
  [SMALL_STATE(1737)] = 104074,
  [SMALL_STATE(1738)] = 104095,
  [SMALL_STATE(1739)] = 104121,
  [SMALL_STATE(1740)] = 104143,
  [SMALL_STATE(1741)] = 104159,
  [SMALL_STATE(1742)] = 104185,
  [SMALL_STATE(1743)] = 104205,
  [SMALL_STATE(1744)] = 104221,
  [SMALL_STATE(1745)] = 104243,
  [SMALL_STATE(1746)] = 104269,
  [SMALL_STATE(1747)] = 104295,
  [SMALL_STATE(1748)] = 104321,
  [SMALL_STATE(1749)] = 104343,
  [SMALL_STATE(1750)] = 104367,
  [SMALL_STATE(1751)] = 104391,
  [SMALL_STATE(1752)] = 104413,
  [SMALL_STATE(1753)] = 104439,
  [SMALL_STATE(1754)] = 104461,
  [SMALL_STATE(1755)] = 104487,
  [SMALL_STATE(1756)] = 104507,
  [SMALL_STATE(1757)] = 104529,
  [SMALL_STATE(1758)] = 104555,
  [SMALL_STATE(1759)] = 104577,
  [SMALL_STATE(1760)] = 104601,
  [SMALL_STATE(1761)] = 104617,
  [SMALL_STATE(1762)] = 104643,
  [SMALL_STATE(1763)] = 104665,
  [SMALL_STATE(1764)] = 104687,
  [SMALL_STATE(1765)] = 104711,
  [SMALL_STATE(1766)] = 104737,
  [SMALL_STATE(1767)] = 104759,
  [SMALL_STATE(1768)] = 104781,
  [SMALL_STATE(1769)] = 104803,
  [SMALL_STATE(1770)] = 104825,
  [SMALL_STATE(1771)] = 104845,
  [SMALL_STATE(1772)] = 104871,
  [SMALL_STATE(1773)] = 104897,
  [SMALL_STATE(1774)] = 104923,
  [SMALL_STATE(1775)] = 104949,
  [SMALL_STATE(1776)] = 104971,
  [SMALL_STATE(1777)] = 104992,
  [SMALL_STATE(1778)] = 105013,
  [SMALL_STATE(1779)] = 105030,
  [SMALL_STATE(1780)] = 105051,
  [SMALL_STATE(1781)] = 105074,
  [SMALL_STATE(1782)] = 105087,
  [SMALL_STATE(1783)] = 105100,
  [SMALL_STATE(1784)] = 105119,
  [SMALL_STATE(1785)] = 105140,
  [SMALL_STATE(1786)] = 105161,
  [SMALL_STATE(1787)] = 105182,
  [SMALL_STATE(1788)] = 105203,
  [SMALL_STATE(1789)] = 105224,
  [SMALL_STATE(1790)] = 105245,
  [SMALL_STATE(1791)] = 105268,
  [SMALL_STATE(1792)] = 105289,
  [SMALL_STATE(1793)] = 105306,
  [SMALL_STATE(1794)] = 105323,
  [SMALL_STATE(1795)] = 105336,
  [SMALL_STATE(1796)] = 105349,
  [SMALL_STATE(1797)] = 105370,
  [SMALL_STATE(1798)] = 105393,
  [SMALL_STATE(1799)] = 105416,
  [SMALL_STATE(1800)] = 105429,
  [SMALL_STATE(1801)] = 105442,
  [SMALL_STATE(1802)] = 105459,
  [SMALL_STATE(1803)] = 105480,
  [SMALL_STATE(1804)] = 105497,
  [SMALL_STATE(1805)] = 105514,
  [SMALL_STATE(1806)] = 105535,
  [SMALL_STATE(1807)] = 105556,
  [SMALL_STATE(1808)] = 105573,
  [SMALL_STATE(1809)] = 105590,
  [SMALL_STATE(1810)] = 105603,
  [SMALL_STATE(1811)] = 105624,
  [SMALL_STATE(1812)] = 105645,
  [SMALL_STATE(1813)] = 105662,
  [SMALL_STATE(1814)] = 105683,
  [SMALL_STATE(1815)] = 105704,
  [SMALL_STATE(1816)] = 105721,
  [SMALL_STATE(1817)] = 105738,
  [SMALL_STATE(1818)] = 105759,
  [SMALL_STATE(1819)] = 105772,
  [SMALL_STATE(1820)] = 105793,
  [SMALL_STATE(1821)] = 105806,
  [SMALL_STATE(1822)] = 105823,
  [SMALL_STATE(1823)] = 105840,
  [SMALL_STATE(1824)] = 105857,
  [SMALL_STATE(1825)] = 105878,
  [SMALL_STATE(1826)] = 105895,
  [SMALL_STATE(1827)] = 105918,
  [SMALL_STATE(1828)] = 105939,
  [SMALL_STATE(1829)] = 105960,
  [SMALL_STATE(1830)] = 105981,
  [SMALL_STATE(1831)] = 106002,
  [SMALL_STATE(1832)] = 106023,
  [SMALL_STATE(1833)] = 106044,
  [SMALL_STATE(1834)] = 106057,
  [SMALL_STATE(1835)] = 106076,
  [SMALL_STATE(1836)] = 106089,
  [SMALL_STATE(1837)] = 106102,
  [SMALL_STATE(1838)] = 106119,
  [SMALL_STATE(1839)] = 106140,
  [SMALL_STATE(1840)] = 106157,
  [SMALL_STATE(1841)] = 106174,
  [SMALL_STATE(1842)] = 106195,
  [SMALL_STATE(1843)] = 106212,
  [SMALL_STATE(1844)] = 106229,
  [SMALL_STATE(1845)] = 106250,
  [SMALL_STATE(1846)] = 106271,
  [SMALL_STATE(1847)] = 106292,
  [SMALL_STATE(1848)] = 106315,
  [SMALL_STATE(1849)] = 106328,
  [SMALL_STATE(1850)] = 106351,
  [SMALL_STATE(1851)] = 106368,
  [SMALL_STATE(1852)] = 106381,
  [SMALL_STATE(1853)] = 106398,
  [SMALL_STATE(1854)] = 106415,
  [SMALL_STATE(1855)] = 106432,
  [SMALL_STATE(1856)] = 106449,
  [SMALL_STATE(1857)] = 106472,
  [SMALL_STATE(1858)] = 106495,
  [SMALL_STATE(1859)] = 106512,
  [SMALL_STATE(1860)] = 106529,
  [SMALL_STATE(1861)] = 106548,
  [SMALL_STATE(1862)] = 106567,
  [SMALL_STATE(1863)] = 106584,
  [SMALL_STATE(1864)] = 106601,
  [SMALL_STATE(1865)] = 106618,
  [SMALL_STATE(1866)] = 106635,
  [SMALL_STATE(1867)] = 106647,
  [SMALL_STATE(1868)] = 106665,
  [SMALL_STATE(1869)] = 106685,
  [SMALL_STATE(1870)] = 106697,
  [SMALL_STATE(1871)] = 106715,
  [SMALL_STATE(1872)] = 106731,
  [SMALL_STATE(1873)] = 106743,
  [SMALL_STATE(1874)] = 106763,
  [SMALL_STATE(1875)] = 106783,
  [SMALL_STATE(1876)] = 106803,
  [SMALL_STATE(1877)] = 106815,
  [SMALL_STATE(1878)] = 106827,
  [SMALL_STATE(1879)] = 106839,
  [SMALL_STATE(1880)] = 106859,
  [SMALL_STATE(1881)] = 106879,
  [SMALL_STATE(1882)] = 106899,
  [SMALL_STATE(1883)] = 106911,
  [SMALL_STATE(1884)] = 106927,
  [SMALL_STATE(1885)] = 106939,
  [SMALL_STATE(1886)] = 106951,
  [SMALL_STATE(1887)] = 106963,
  [SMALL_STATE(1888)] = 106975,
  [SMALL_STATE(1889)] = 106987,
  [SMALL_STATE(1890)] = 106999,
  [SMALL_STATE(1891)] = 107011,
  [SMALL_STATE(1892)] = 107031,
  [SMALL_STATE(1893)] = 107043,
  [SMALL_STATE(1894)] = 107055,
  [SMALL_STATE(1895)] = 107073,
  [SMALL_STATE(1896)] = 107093,
  [SMALL_STATE(1897)] = 107113,
  [SMALL_STATE(1898)] = 107133,
  [SMALL_STATE(1899)] = 107149,
  [SMALL_STATE(1900)] = 107161,
  [SMALL_STATE(1901)] = 107181,
  [SMALL_STATE(1902)] = 107201,
  [SMALL_STATE(1903)] = 107213,
  [SMALL_STATE(1904)] = 107233,
  [SMALL_STATE(1905)] = 107247,
  [SMALL_STATE(1906)] = 107267,
  [SMALL_STATE(1907)] = 107279,
  [SMALL_STATE(1908)] = 107291,
  [SMALL_STATE(1909)] = 107303,
  [SMALL_STATE(1910)] = 107323,
  [SMALL_STATE(1911)] = 107337,
  [SMALL_STATE(1912)] = 107357,
  [SMALL_STATE(1913)] = 107371,
  [SMALL_STATE(1914)] = 107391,
  [SMALL_STATE(1915)] = 107411,
  [SMALL_STATE(1916)] = 107431,
  [SMALL_STATE(1917)] = 107447,
  [SMALL_STATE(1918)] = 107467,
  [SMALL_STATE(1919)] = 107487,
  [SMALL_STATE(1920)] = 107507,
  [SMALL_STATE(1921)] = 107527,
  [SMALL_STATE(1922)] = 107539,
  [SMALL_STATE(1923)] = 107559,
  [SMALL_STATE(1924)] = 107579,
  [SMALL_STATE(1925)] = 107599,
  [SMALL_STATE(1926)] = 107611,
  [SMALL_STATE(1927)] = 107623,
  [SMALL_STATE(1928)] = 107635,
  [SMALL_STATE(1929)] = 107653,
  [SMALL_STATE(1930)] = 107667,
  [SMALL_STATE(1931)] = 107679,
  [SMALL_STATE(1932)] = 107695,
  [SMALL_STATE(1933)] = 107711,
  [SMALL_STATE(1934)] = 107731,
  [SMALL_STATE(1935)] = 107749,
  [SMALL_STATE(1936)] = 107761,
  [SMALL_STATE(1937)] = 107781,
  [SMALL_STATE(1938)] = 107799,
  [SMALL_STATE(1939)] = 107811,
  [SMALL_STATE(1940)] = 107823,
  [SMALL_STATE(1941)] = 107841,
  [SMALL_STATE(1942)] = 107853,
  [SMALL_STATE(1943)] = 107865,
  [SMALL_STATE(1944)] = 107885,
  [SMALL_STATE(1945)] = 107903,
  [SMALL_STATE(1946)] = 107919,
  [SMALL_STATE(1947)] = 107939,
  [SMALL_STATE(1948)] = 107951,
  [SMALL_STATE(1949)] = 107969,
  [SMALL_STATE(1950)] = 107987,
  [SMALL_STATE(1951)] = 108005,
  [SMALL_STATE(1952)] = 108025,
  [SMALL_STATE(1953)] = 108039,
  [SMALL_STATE(1954)] = 108053,
  [SMALL_STATE(1955)] = 108073,
  [SMALL_STATE(1956)] = 108093,
  [SMALL_STATE(1957)] = 108113,
  [SMALL_STATE(1958)] = 108128,
  [SMALL_STATE(1959)] = 108145,
  [SMALL_STATE(1960)] = 108160,
  [SMALL_STATE(1961)] = 108175,
  [SMALL_STATE(1962)] = 108190,
  [SMALL_STATE(1963)] = 108205,
  [SMALL_STATE(1964)] = 108220,
  [SMALL_STATE(1965)] = 108235,
  [SMALL_STATE(1966)] = 108250,
  [SMALL_STATE(1967)] = 108265,
  [SMALL_STATE(1968)] = 108282,
  [SMALL_STATE(1969)] = 108297,
  [SMALL_STATE(1970)] = 108312,
  [SMALL_STATE(1971)] = 108329,
  [SMALL_STATE(1972)] = 108344,
  [SMALL_STATE(1973)] = 108359,
  [SMALL_STATE(1974)] = 108374,
  [SMALL_STATE(1975)] = 108391,
  [SMALL_STATE(1976)] = 108406,
  [SMALL_STATE(1977)] = 108423,
  [SMALL_STATE(1978)] = 108440,
  [SMALL_STATE(1979)] = 108457,
  [SMALL_STATE(1980)] = 108474,
  [SMALL_STATE(1981)] = 108487,
  [SMALL_STATE(1982)] = 108504,
  [SMALL_STATE(1983)] = 108521,
  [SMALL_STATE(1984)] = 108536,
  [SMALL_STATE(1985)] = 108551,
  [SMALL_STATE(1986)] = 108564,
  [SMALL_STATE(1987)] = 108581,
  [SMALL_STATE(1988)] = 108596,
  [SMALL_STATE(1989)] = 108611,
  [SMALL_STATE(1990)] = 108626,
  [SMALL_STATE(1991)] = 108641,
  [SMALL_STATE(1992)] = 108656,
  [SMALL_STATE(1993)] = 108671,
  [SMALL_STATE(1994)] = 108682,
  [SMALL_STATE(1995)] = 108695,
  [SMALL_STATE(1996)] = 108712,
  [SMALL_STATE(1997)] = 108729,
  [SMALL_STATE(1998)] = 108746,
  [SMALL_STATE(1999)] = 108763,
  [SMALL_STATE(2000)] = 108780,
  [SMALL_STATE(2001)] = 108795,
  [SMALL_STATE(2002)] = 108808,
  [SMALL_STATE(2003)] = 108823,
  [SMALL_STATE(2004)] = 108840,
  [SMALL_STATE(2005)] = 108855,
  [SMALL_STATE(2006)] = 108869,
  [SMALL_STATE(2007)] = 108883,
  [SMALL_STATE(2008)] = 108897,
  [SMALL_STATE(2009)] = 108911,
  [SMALL_STATE(2010)] = 108925,
  [SMALL_STATE(2011)] = 108939,
  [SMALL_STATE(2012)] = 108953,
  [SMALL_STATE(2013)] = 108967,
  [SMALL_STATE(2014)] = 108981,
  [SMALL_STATE(2015)] = 108995,
  [SMALL_STATE(2016)] = 109009,
  [SMALL_STATE(2017)] = 109023,
  [SMALL_STATE(2018)] = 109037,
  [SMALL_STATE(2019)] = 109049,
  [SMALL_STATE(2020)] = 109063,
  [SMALL_STATE(2021)] = 109077,
  [SMALL_STATE(2022)] = 109091,
  [SMALL_STATE(2023)] = 109105,
  [SMALL_STATE(2024)] = 109119,
  [SMALL_STATE(2025)] = 109133,
  [SMALL_STATE(2026)] = 109147,
  [SMALL_STATE(2027)] = 109159,
  [SMALL_STATE(2028)] = 109169,
  [SMALL_STATE(2029)] = 109183,
  [SMALL_STATE(2030)] = 109197,
  [SMALL_STATE(2031)] = 109211,
  [SMALL_STATE(2032)] = 109225,
  [SMALL_STATE(2033)] = 109239,
  [SMALL_STATE(2034)] = 109253,
  [SMALL_STATE(2035)] = 109263,
  [SMALL_STATE(2036)] = 109277,
  [SMALL_STATE(2037)] = 109291,
  [SMALL_STATE(2038)] = 109305,
  [SMALL_STATE(2039)] = 109319,
  [SMALL_STATE(2040)] = 109333,
  [SMALL_STATE(2041)] = 109347,
  [SMALL_STATE(2042)] = 109361,
  [SMALL_STATE(2043)] = 109375,
  [SMALL_STATE(2044)] = 109389,
  [SMALL_STATE(2045)] = 109403,
  [SMALL_STATE(2046)] = 109417,
  [SMALL_STATE(2047)] = 109431,
  [SMALL_STATE(2048)] = 109445,
  [SMALL_STATE(2049)] = 109459,
  [SMALL_STATE(2050)] = 109473,
  [SMALL_STATE(2051)] = 109485,
  [SMALL_STATE(2052)] = 109499,
  [SMALL_STATE(2053)] = 109513,
  [SMALL_STATE(2054)] = 109527,
  [SMALL_STATE(2055)] = 109541,
  [SMALL_STATE(2056)] = 109555,
  [SMALL_STATE(2057)] = 109569,
  [SMALL_STATE(2058)] = 109583,
  [SMALL_STATE(2059)] = 109597,
  [SMALL_STATE(2060)] = 109611,
  [SMALL_STATE(2061)] = 109625,
  [SMALL_STATE(2062)] = 109639,
  [SMALL_STATE(2063)] = 109653,
  [SMALL_STATE(2064)] = 109665,
  [SMALL_STATE(2065)] = 109679,
  [SMALL_STATE(2066)] = 109693,
  [SMALL_STATE(2067)] = 109707,
  [SMALL_STATE(2068)] = 109721,
  [SMALL_STATE(2069)] = 109735,
  [SMALL_STATE(2070)] = 109749,
  [SMALL_STATE(2071)] = 109763,
  [SMALL_STATE(2072)] = 109777,
  [SMALL_STATE(2073)] = 109789,
  [SMALL_STATE(2074)] = 109803,
  [SMALL_STATE(2075)] = 109817,
  [SMALL_STATE(2076)] = 109831,
  [SMALL_STATE(2077)] = 109845,
  [SMALL_STATE(2078)] = 109859,
  [SMALL_STATE(2079)] = 109873,
  [SMALL_STATE(2080)] = 109887,
  [SMALL_STATE(2081)] = 109901,
  [SMALL_STATE(2082)] = 109915,
  [SMALL_STATE(2083)] = 109929,
  [SMALL_STATE(2084)] = 109943,
  [SMALL_STATE(2085)] = 109957,
  [SMALL_STATE(2086)] = 109971,
  [SMALL_STATE(2087)] = 109985,
  [SMALL_STATE(2088)] = 109999,
  [SMALL_STATE(2089)] = 110013,
  [SMALL_STATE(2090)] = 110023,
  [SMALL_STATE(2091)] = 110037,
  [SMALL_STATE(2092)] = 110051,
  [SMALL_STATE(2093)] = 110065,
  [SMALL_STATE(2094)] = 110079,
  [SMALL_STATE(2095)] = 110091,
  [SMALL_STATE(2096)] = 110105,
  [SMALL_STATE(2097)] = 110119,
  [SMALL_STATE(2098)] = 110133,
  [SMALL_STATE(2099)] = 110147,
  [SMALL_STATE(2100)] = 110157,
  [SMALL_STATE(2101)] = 110171,
  [SMALL_STATE(2102)] = 110185,
  [SMALL_STATE(2103)] = 110199,
  [SMALL_STATE(2104)] = 110213,
  [SMALL_STATE(2105)] = 110227,
  [SMALL_STATE(2106)] = 110241,
  [SMALL_STATE(2107)] = 110255,
  [SMALL_STATE(2108)] = 110269,
  [SMALL_STATE(2109)] = 110283,
  [SMALL_STATE(2110)] = 110297,
  [SMALL_STATE(2111)] = 110309,
  [SMALL_STATE(2112)] = 110323,
  [SMALL_STATE(2113)] = 110337,
  [SMALL_STATE(2114)] = 110351,
  [SMALL_STATE(2115)] = 110365,
  [SMALL_STATE(2116)] = 110379,
  [SMALL_STATE(2117)] = 110393,
  [SMALL_STATE(2118)] = 110407,
  [SMALL_STATE(2119)] = 110421,
  [SMALL_STATE(2120)] = 110435,
  [SMALL_STATE(2121)] = 110449,
  [SMALL_STATE(2122)] = 110459,
  [SMALL_STATE(2123)] = 110473,
  [SMALL_STATE(2124)] = 110487,
  [SMALL_STATE(2125)] = 110501,
  [SMALL_STATE(2126)] = 110515,
  [SMALL_STATE(2127)] = 110525,
  [SMALL_STATE(2128)] = 110539,
  [SMALL_STATE(2129)] = 110553,
  [SMALL_STATE(2130)] = 110563,
  [SMALL_STATE(2131)] = 110577,
  [SMALL_STATE(2132)] = 110591,
  [SMALL_STATE(2133)] = 110603,
  [SMALL_STATE(2134)] = 110617,
  [SMALL_STATE(2135)] = 110631,
  [SMALL_STATE(2136)] = 110645,
  [SMALL_STATE(2137)] = 110659,
  [SMALL_STATE(2138)] = 110673,
  [SMALL_STATE(2139)] = 110687,
  [SMALL_STATE(2140)] = 110699,
  [SMALL_STATE(2141)] = 110713,
  [SMALL_STATE(2142)] = 110725,
  [SMALL_STATE(2143)] = 110739,
  [SMALL_STATE(2144)] = 110753,
  [SMALL_STATE(2145)] = 110767,
  [SMALL_STATE(2146)] = 110781,
  [SMALL_STATE(2147)] = 110795,
  [SMALL_STATE(2148)] = 110809,
  [SMALL_STATE(2149)] = 110823,
  [SMALL_STATE(2150)] = 110837,
  [SMALL_STATE(2151)] = 110851,
  [SMALL_STATE(2152)] = 110865,
  [SMALL_STATE(2153)] = 110879,
  [SMALL_STATE(2154)] = 110891,
  [SMALL_STATE(2155)] = 110905,
  [SMALL_STATE(2156)] = 110915,
  [SMALL_STATE(2157)] = 110929,
  [SMALL_STATE(2158)] = 110943,
  [SMALL_STATE(2159)] = 110957,
  [SMALL_STATE(2160)] = 110969,
  [SMALL_STATE(2161)] = 110983,
  [SMALL_STATE(2162)] = 110997,
  [SMALL_STATE(2163)] = 111009,
  [SMALL_STATE(2164)] = 111023,
  [SMALL_STATE(2165)] = 111037,
  [SMALL_STATE(2166)] = 111051,
  [SMALL_STATE(2167)] = 111065,
  [SMALL_STATE(2168)] = 111079,
  [SMALL_STATE(2169)] = 111091,
  [SMALL_STATE(2170)] = 111105,
  [SMALL_STATE(2171)] = 111119,
  [SMALL_STATE(2172)] = 111133,
  [SMALL_STATE(2173)] = 111147,
  [SMALL_STATE(2174)] = 111157,
  [SMALL_STATE(2175)] = 111171,
  [SMALL_STATE(2176)] = 111185,
  [SMALL_STATE(2177)] = 111197,
  [SMALL_STATE(2178)] = 111211,
  [SMALL_STATE(2179)] = 111225,
  [SMALL_STATE(2180)] = 111239,
  [SMALL_STATE(2181)] = 111253,
  [SMALL_STATE(2182)] = 111263,
  [SMALL_STATE(2183)] = 111277,
  [SMALL_STATE(2184)] = 111287,
  [SMALL_STATE(2185)] = 111299,
  [SMALL_STATE(2186)] = 111313,
  [SMALL_STATE(2187)] = 111327,
  [SMALL_STATE(2188)] = 111341,
  [SMALL_STATE(2189)] = 111355,
  [SMALL_STATE(2190)] = 111367,
  [SMALL_STATE(2191)] = 111381,
  [SMALL_STATE(2192)] = 111395,
  [SMALL_STATE(2193)] = 111409,
  [SMALL_STATE(2194)] = 111423,
  [SMALL_STATE(2195)] = 111437,
  [SMALL_STATE(2196)] = 111451,
  [SMALL_STATE(2197)] = 111465,
  [SMALL_STATE(2198)] = 111479,
  [SMALL_STATE(2199)] = 111493,
  [SMALL_STATE(2200)] = 111507,
  [SMALL_STATE(2201)] = 111521,
  [SMALL_STATE(2202)] = 111535,
  [SMALL_STATE(2203)] = 111549,
  [SMALL_STATE(2204)] = 111563,
  [SMALL_STATE(2205)] = 111577,
  [SMALL_STATE(2206)] = 111591,
  [SMALL_STATE(2207)] = 111605,
  [SMALL_STATE(2208)] = 111619,
  [SMALL_STATE(2209)] = 111633,
  [SMALL_STATE(2210)] = 111647,
  [SMALL_STATE(2211)] = 111661,
  [SMALL_STATE(2212)] = 111675,
  [SMALL_STATE(2213)] = 111689,
  [SMALL_STATE(2214)] = 111701,
  [SMALL_STATE(2215)] = 111715,
  [SMALL_STATE(2216)] = 111729,
  [SMALL_STATE(2217)] = 111743,
  [SMALL_STATE(2218)] = 111757,
  [SMALL_STATE(2219)] = 111771,
  [SMALL_STATE(2220)] = 111783,
  [SMALL_STATE(2221)] = 111797,
  [SMALL_STATE(2222)] = 111811,
  [SMALL_STATE(2223)] = 111825,
  [SMALL_STATE(2224)] = 111837,
  [SMALL_STATE(2225)] = 111851,
  [SMALL_STATE(2226)] = 111865,
  [SMALL_STATE(2227)] = 111877,
  [SMALL_STATE(2228)] = 111891,
  [SMALL_STATE(2229)] = 111902,
  [SMALL_STATE(2230)] = 111911,
  [SMALL_STATE(2231)] = 111922,
  [SMALL_STATE(2232)] = 111931,
  [SMALL_STATE(2233)] = 111942,
  [SMALL_STATE(2234)] = 111953,
  [SMALL_STATE(2235)] = 111964,
  [SMALL_STATE(2236)] = 111973,
  [SMALL_STATE(2237)] = 111984,
  [SMALL_STATE(2238)] = 111993,
  [SMALL_STATE(2239)] = 112002,
  [SMALL_STATE(2240)] = 112011,
  [SMALL_STATE(2241)] = 112022,
  [SMALL_STATE(2242)] = 112031,
  [SMALL_STATE(2243)] = 112042,
  [SMALL_STATE(2244)] = 112053,
  [SMALL_STATE(2245)] = 112062,
  [SMALL_STATE(2246)] = 112071,
  [SMALL_STATE(2247)] = 112082,
  [SMALL_STATE(2248)] = 112093,
  [SMALL_STATE(2249)] = 112102,
  [SMALL_STATE(2250)] = 112111,
  [SMALL_STATE(2251)] = 112120,
  [SMALL_STATE(2252)] = 112129,
  [SMALL_STATE(2253)] = 112138,
  [SMALL_STATE(2254)] = 112147,
  [SMALL_STATE(2255)] = 112158,
  [SMALL_STATE(2256)] = 112167,
  [SMALL_STATE(2257)] = 112176,
  [SMALL_STATE(2258)] = 112185,
  [SMALL_STATE(2259)] = 112196,
  [SMALL_STATE(2260)] = 112205,
  [SMALL_STATE(2261)] = 112216,
  [SMALL_STATE(2262)] = 112225,
  [SMALL_STATE(2263)] = 112236,
  [SMALL_STATE(2264)] = 112247,
  [SMALL_STATE(2265)] = 112256,
  [SMALL_STATE(2266)] = 112265,
  [SMALL_STATE(2267)] = 112274,
  [SMALL_STATE(2268)] = 112283,
  [SMALL_STATE(2269)] = 112294,
  [SMALL_STATE(2270)] = 112303,
  [SMALL_STATE(2271)] = 112312,
  [SMALL_STATE(2272)] = 112323,
  [SMALL_STATE(2273)] = 112332,
  [SMALL_STATE(2274)] = 112341,
  [SMALL_STATE(2275)] = 112350,
  [SMALL_STATE(2276)] = 112359,
  [SMALL_STATE(2277)] = 112368,
  [SMALL_STATE(2278)] = 112377,
  [SMALL_STATE(2279)] = 112388,
  [SMALL_STATE(2280)] = 112399,
  [SMALL_STATE(2281)] = 112408,
  [SMALL_STATE(2282)] = 112419,
  [SMALL_STATE(2283)] = 112428,
  [SMALL_STATE(2284)] = 112437,
  [SMALL_STATE(2285)] = 112446,
  [SMALL_STATE(2286)] = 112457,
  [SMALL_STATE(2287)] = 112468,
  [SMALL_STATE(2288)] = 112477,
  [SMALL_STATE(2289)] = 112486,
  [SMALL_STATE(2290)] = 112495,
  [SMALL_STATE(2291)] = 112504,
  [SMALL_STATE(2292)] = 112513,
  [SMALL_STATE(2293)] = 112522,
  [SMALL_STATE(2294)] = 112533,
  [SMALL_STATE(2295)] = 112544,
  [SMALL_STATE(2296)] = 112555,
  [SMALL_STATE(2297)] = 112566,
  [SMALL_STATE(2298)] = 112577,
  [SMALL_STATE(2299)] = 112588,
  [SMALL_STATE(2300)] = 112599,
  [SMALL_STATE(2301)] = 112608,
  [SMALL_STATE(2302)] = 112619,
  [SMALL_STATE(2303)] = 112630,
  [SMALL_STATE(2304)] = 112641,
  [SMALL_STATE(2305)] = 112650,
  [SMALL_STATE(2306)] = 112661,
  [SMALL_STATE(2307)] = 112672,
  [SMALL_STATE(2308)] = 112683,
  [SMALL_STATE(2309)] = 112694,
  [SMALL_STATE(2310)] = 112705,
  [SMALL_STATE(2311)] = 112714,
  [SMALL_STATE(2312)] = 112725,
  [SMALL_STATE(2313)] = 112734,
  [SMALL_STATE(2314)] = 112745,
  [SMALL_STATE(2315)] = 112756,
  [SMALL_STATE(2316)] = 112767,
  [SMALL_STATE(2317)] = 112778,
  [SMALL_STATE(2318)] = 112789,
  [SMALL_STATE(2319)] = 112798,
  [SMALL_STATE(2320)] = 112807,
  [SMALL_STATE(2321)] = 112816,
  [SMALL_STATE(2322)] = 112827,
  [SMALL_STATE(2323)] = 112836,
  [SMALL_STATE(2324)] = 112845,
  [SMALL_STATE(2325)] = 112854,
  [SMALL_STATE(2326)] = 112863,
  [SMALL_STATE(2327)] = 112872,
  [SMALL_STATE(2328)] = 112881,
  [SMALL_STATE(2329)] = 112890,
  [SMALL_STATE(2330)] = 112899,
  [SMALL_STATE(2331)] = 112908,
  [SMALL_STATE(2332)] = 112917,
  [SMALL_STATE(2333)] = 112928,
  [SMALL_STATE(2334)] = 112937,
  [SMALL_STATE(2335)] = 112948,
  [SMALL_STATE(2336)] = 112959,
  [SMALL_STATE(2337)] = 112970,
  [SMALL_STATE(2338)] = 112981,
  [SMALL_STATE(2339)] = 112992,
  [SMALL_STATE(2340)] = 113003,
  [SMALL_STATE(2341)] = 113012,
  [SMALL_STATE(2342)] = 113023,
  [SMALL_STATE(2343)] = 113034,
  [SMALL_STATE(2344)] = 113045,
  [SMALL_STATE(2345)] = 113053,
  [SMALL_STATE(2346)] = 113061,
  [SMALL_STATE(2347)] = 113069,
  [SMALL_STATE(2348)] = 113077,
  [SMALL_STATE(2349)] = 113085,
  [SMALL_STATE(2350)] = 113093,
  [SMALL_STATE(2351)] = 113101,
  [SMALL_STATE(2352)] = 113109,
  [SMALL_STATE(2353)] = 113117,
  [SMALL_STATE(2354)] = 113125,
  [SMALL_STATE(2355)] = 113133,
  [SMALL_STATE(2356)] = 113141,
  [SMALL_STATE(2357)] = 113149,
  [SMALL_STATE(2358)] = 113157,
  [SMALL_STATE(2359)] = 113165,
  [SMALL_STATE(2360)] = 113173,
  [SMALL_STATE(2361)] = 113181,
  [SMALL_STATE(2362)] = 113189,
  [SMALL_STATE(2363)] = 113197,
  [SMALL_STATE(2364)] = 113205,
  [SMALL_STATE(2365)] = 113213,
  [SMALL_STATE(2366)] = 113221,
  [SMALL_STATE(2367)] = 113229,
  [SMALL_STATE(2368)] = 113237,
  [SMALL_STATE(2369)] = 113245,
  [SMALL_STATE(2370)] = 113253,
  [SMALL_STATE(2371)] = 113261,
  [SMALL_STATE(2372)] = 113269,
  [SMALL_STATE(2373)] = 113277,
  [SMALL_STATE(2374)] = 113285,
  [SMALL_STATE(2375)] = 113293,
  [SMALL_STATE(2376)] = 113301,
  [SMALL_STATE(2377)] = 113309,
  [SMALL_STATE(2378)] = 113317,
  [SMALL_STATE(2379)] = 113325,
  [SMALL_STATE(2380)] = 113333,
  [SMALL_STATE(2381)] = 113341,
  [SMALL_STATE(2382)] = 113349,
  [SMALL_STATE(2383)] = 113357,
  [SMALL_STATE(2384)] = 113365,
  [SMALL_STATE(2385)] = 113373,
  [SMALL_STATE(2386)] = 113381,
  [SMALL_STATE(2387)] = 113389,
  [SMALL_STATE(2388)] = 113397,
  [SMALL_STATE(2389)] = 113405,
  [SMALL_STATE(2390)] = 113413,
  [SMALL_STATE(2391)] = 113421,
  [SMALL_STATE(2392)] = 113429,
  [SMALL_STATE(2393)] = 113437,
  [SMALL_STATE(2394)] = 113445,
  [SMALL_STATE(2395)] = 113453,
  [SMALL_STATE(2396)] = 113461,
  [SMALL_STATE(2397)] = 113469,
  [SMALL_STATE(2398)] = 113477,
  [SMALL_STATE(2399)] = 113485,
  [SMALL_STATE(2400)] = 113493,
  [SMALL_STATE(2401)] = 113501,
  [SMALL_STATE(2402)] = 113509,
  [SMALL_STATE(2403)] = 113517,
  [SMALL_STATE(2404)] = 113525,
  [SMALL_STATE(2405)] = 113533,
  [SMALL_STATE(2406)] = 113541,
  [SMALL_STATE(2407)] = 113549,
  [SMALL_STATE(2408)] = 113557,
  [SMALL_STATE(2409)] = 113565,
  [SMALL_STATE(2410)] = 113573,
  [SMALL_STATE(2411)] = 113581,
  [SMALL_STATE(2412)] = 113589,
  [SMALL_STATE(2413)] = 113597,
  [SMALL_STATE(2414)] = 113605,
  [SMALL_STATE(2415)] = 113613,
  [SMALL_STATE(2416)] = 113621,
  [SMALL_STATE(2417)] = 113629,
  [SMALL_STATE(2418)] = 113637,
  [SMALL_STATE(2419)] = 113645,
  [SMALL_STATE(2420)] = 113653,
  [SMALL_STATE(2421)] = 113661,
  [SMALL_STATE(2422)] = 113669,
  [SMALL_STATE(2423)] = 113677,
  [SMALL_STATE(2424)] = 113685,
  [SMALL_STATE(2425)] = 113693,
  [SMALL_STATE(2426)] = 113701,
  [SMALL_STATE(2427)] = 113709,
  [SMALL_STATE(2428)] = 113717,
  [SMALL_STATE(2429)] = 113725,
  [SMALL_STATE(2430)] = 113733,
  [SMALL_STATE(2431)] = 113741,
  [SMALL_STATE(2432)] = 113749,
  [SMALL_STATE(2433)] = 113757,
  [SMALL_STATE(2434)] = 113765,
  [SMALL_STATE(2435)] = 113773,
  [SMALL_STATE(2436)] = 113781,
  [SMALL_STATE(2437)] = 113789,
  [SMALL_STATE(2438)] = 113797,
  [SMALL_STATE(2439)] = 113805,
  [SMALL_STATE(2440)] = 113813,
  [SMALL_STATE(2441)] = 113821,
  [SMALL_STATE(2442)] = 113829,
  [SMALL_STATE(2443)] = 113837,
  [SMALL_STATE(2444)] = 113845,
  [SMALL_STATE(2445)] = 113853,
  [SMALL_STATE(2446)] = 113861,
  [SMALL_STATE(2447)] = 113869,
  [SMALL_STATE(2448)] = 113877,
  [SMALL_STATE(2449)] = 113885,
  [SMALL_STATE(2450)] = 113893,
  [SMALL_STATE(2451)] = 113901,
  [SMALL_STATE(2452)] = 113909,
  [SMALL_STATE(2453)] = 113917,
  [SMALL_STATE(2454)] = 113925,
  [SMALL_STATE(2455)] = 113933,
  [SMALL_STATE(2456)] = 113941,
  [SMALL_STATE(2457)] = 113949,
  [SMALL_STATE(2458)] = 113957,
  [SMALL_STATE(2459)] = 113965,
  [SMALL_STATE(2460)] = 113973,
  [SMALL_STATE(2461)] = 113981,
  [SMALL_STATE(2462)] = 113989,
  [SMALL_STATE(2463)] = 113997,
  [SMALL_STATE(2464)] = 114005,
  [SMALL_STATE(2465)] = 114013,
  [SMALL_STATE(2466)] = 114021,
  [SMALL_STATE(2467)] = 114029,
  [SMALL_STATE(2468)] = 114037,
  [SMALL_STATE(2469)] = 114045,
  [SMALL_STATE(2470)] = 114053,
  [SMALL_STATE(2471)] = 114061,
  [SMALL_STATE(2472)] = 114069,
  [SMALL_STATE(2473)] = 114077,
  [SMALL_STATE(2474)] = 114085,
  [SMALL_STATE(2475)] = 114093,
  [SMALL_STATE(2476)] = 114101,
  [SMALL_STATE(2477)] = 114109,
  [SMALL_STATE(2478)] = 114117,
  [SMALL_STATE(2479)] = 114125,
  [SMALL_STATE(2480)] = 114133,
  [SMALL_STATE(2481)] = 114141,
  [SMALL_STATE(2482)] = 114149,
  [SMALL_STATE(2483)] = 114157,
  [SMALL_STATE(2484)] = 114165,
  [SMALL_STATE(2485)] = 114173,
  [SMALL_STATE(2486)] = 114181,
  [SMALL_STATE(2487)] = 114189,
  [SMALL_STATE(2488)] = 114197,
  [SMALL_STATE(2489)] = 114205,
  [SMALL_STATE(2490)] = 114213,
  [SMALL_STATE(2491)] = 114221,
  [SMALL_STATE(2492)] = 114229,
  [SMALL_STATE(2493)] = 114237,
  [SMALL_STATE(2494)] = 114245,
  [SMALL_STATE(2495)] = 114253,
  [SMALL_STATE(2496)] = 114261,
  [SMALL_STATE(2497)] = 114269,
  [SMALL_STATE(2498)] = 114277,
  [SMALL_STATE(2499)] = 114285,
  [SMALL_STATE(2500)] = 114293,
  [SMALL_STATE(2501)] = 114301,
  [SMALL_STATE(2502)] = 114309,
  [SMALL_STATE(2503)] = 114317,
  [SMALL_STATE(2504)] = 114325,
  [SMALL_STATE(2505)] = 114333,
  [SMALL_STATE(2506)] = 114341,
  [SMALL_STATE(2507)] = 114349,
  [SMALL_STATE(2508)] = 114357,
  [SMALL_STATE(2509)] = 114365,
  [SMALL_STATE(2510)] = 114373,
  [SMALL_STATE(2511)] = 114381,
  [SMALL_STATE(2512)] = 114389,
  [SMALL_STATE(2513)] = 114397,
  [SMALL_STATE(2514)] = 114405,
  [SMALL_STATE(2515)] = 114413,
  [SMALL_STATE(2516)] = 114421,
  [SMALL_STATE(2517)] = 114429,
  [SMALL_STATE(2518)] = 114437,
  [SMALL_STATE(2519)] = 114445,
  [SMALL_STATE(2520)] = 114453,
  [SMALL_STATE(2521)] = 114461,
  [SMALL_STATE(2522)] = 114469,
  [SMALL_STATE(2523)] = 114477,
  [SMALL_STATE(2524)] = 114485,
  [SMALL_STATE(2525)] = 114493,
  [SMALL_STATE(2526)] = 114501,
  [SMALL_STATE(2527)] = 114509,
  [SMALL_STATE(2528)] = 114517,
  [SMALL_STATE(2529)] = 114525,
  [SMALL_STATE(2530)] = 114533,
  [SMALL_STATE(2531)] = 114541,
  [SMALL_STATE(2532)] = 114549,
  [SMALL_STATE(2533)] = 114557,
  [SMALL_STATE(2534)] = 114565,
  [SMALL_STATE(2535)] = 114573,
  [SMALL_STATE(2536)] = 114581,
  [SMALL_STATE(2537)] = 114589,
  [SMALL_STATE(2538)] = 114597,
  [SMALL_STATE(2539)] = 114605,
  [SMALL_STATE(2540)] = 114613,
  [SMALL_STATE(2541)] = 114621,
  [SMALL_STATE(2542)] = 114629,
  [SMALL_STATE(2543)] = 114637,
  [SMALL_STATE(2544)] = 114645,
  [SMALL_STATE(2545)] = 114653,
  [SMALL_STATE(2546)] = 114661,
  [SMALL_STATE(2547)] = 114669,
  [SMALL_STATE(2548)] = 114677,
  [SMALL_STATE(2549)] = 114685,
  [SMALL_STATE(2550)] = 114693,
  [SMALL_STATE(2551)] = 114701,
  [SMALL_STATE(2552)] = 114709,
  [SMALL_STATE(2553)] = 114717,
  [SMALL_STATE(2554)] = 114725,
  [SMALL_STATE(2555)] = 114733,
  [SMALL_STATE(2556)] = 114741,
  [SMALL_STATE(2557)] = 114749,
  [SMALL_STATE(2558)] = 114757,
  [SMALL_STATE(2559)] = 114765,
  [SMALL_STATE(2560)] = 114773,
  [SMALL_STATE(2561)] = 114781,
  [SMALL_STATE(2562)] = 114789,
  [SMALL_STATE(2563)] = 114797,
  [SMALL_STATE(2564)] = 114805,
  [SMALL_STATE(2565)] = 114813,
  [SMALL_STATE(2566)] = 114821,
  [SMALL_STATE(2567)] = 114829,
  [SMALL_STATE(2568)] = 114837,
  [SMALL_STATE(2569)] = 114845,
  [SMALL_STATE(2570)] = 114853,
  [SMALL_STATE(2571)] = 114861,
  [SMALL_STATE(2572)] = 114869,
  [SMALL_STATE(2573)] = 114877,
  [SMALL_STATE(2574)] = 114885,
  [SMALL_STATE(2575)] = 114893,
  [SMALL_STATE(2576)] = 114901,
  [SMALL_STATE(2577)] = 114909,
  [SMALL_STATE(2578)] = 114917,
  [SMALL_STATE(2579)] = 114925,
  [SMALL_STATE(2580)] = 114933,
  [SMALL_STATE(2581)] = 114941,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2565),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2564),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2560),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(145),
  [148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(128),
  [151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(156),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2577),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1996),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1759),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(742),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(477),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(303),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(388),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(291),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2333),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2331),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2330),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2354),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2346),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(474),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(403),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(536),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(609),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(406),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2425),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(342),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(481),
  [220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(767),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(767),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1493),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(287),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(971),
  [235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(80),
  [238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(543),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(544),
  [244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(971),
  [247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(545),
  [250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(986),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1584),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 2),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1, 0, 2),
  [290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 2),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 2), SHIFT(231),
  [295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 2), REDUCE(sym_primary_expression, 1, 0, 2),
  [298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 2), SHIFT(230),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 2),
  [303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 2),
  [305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 2), REDUCE(sym_primary_expression, 1, 0, 2),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 2), SHIFT(707),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 2), SHIFT(481),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 2), SHIFT(767),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, 0, 5),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, 0, 5),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 2), REDUCE(sym_list_splat_pattern, 2, 0, 5),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 2), REDUCE(sym_list_splat_pattern, 2, 0, 5),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 3, 0, 0),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 2, 0, 0),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1, 0, 0),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 7, 0, 73),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 7, 0, 73),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [1099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, 0, 66),
  [1101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, 0, 66),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, 0, 65),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, 0, 65),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, 0, 52),
  [1109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 5, 0, 52),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 3, 0, 0),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 2, 0, 0),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2, 0, 0),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 3, 0, 0),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [1177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 1, 0, 0),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2, 0, 0),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 3, 0, 0),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2, 0, 0),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, 0, 5),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [1269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 1, 0, 0),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 3, 0, 0),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3, 0, 0),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, 0, 43),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, 0, 0),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 2, 0, 0),
  [1291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4, 0, 0),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, -1, 44),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, -1, 6),
  [1297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 0),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, 0, 81),
  [1369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, 0, 81),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 70),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 70),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1, 0, 0),
  [1387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0), REDUCE(sym_primary_expression, 1, 0, 0),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [1396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0), REDUCE(sym_primary_expression, 1, 0, 0),
  [1399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [1415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, 0, 25),
  [1417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, 0, 25),
  [1419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 6, 0, 37),
  [1421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 6, 0, 37),
  [1423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, 0, 37),
  [1425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, 0, 37),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 68),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 68),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 88),
  [1437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 88),
  [1439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2, 0, 0),
  [1441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat2, 2, 0, 0),
  [1443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(417),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [1450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(393),
  [1453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_type, 2, 0, 0),
  [1462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_type, 2, 0, 0),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 3),
  [1469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0), REDUCE(sym_primary_expression, 1, 0, 3),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 3),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, 0, 15),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 15),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, 0, 25),
  [1480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, 0, 25),
  [1482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2, 0, 0),
  [1488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0), REDUCE(sym_tuple, 2, 0, 0),
  [1491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2, 0, 0),
  [1493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [1495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [1497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2, 0, 0),
  [1499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0), REDUCE(sym_list, 2, 0, 0),
  [1502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2, 0, 0),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 77),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 77),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 76),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 76),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 86),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 86),
  [1516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 86), SHIFT_REPEAT(410),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, 0, 0),
  [1521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, 0, 0),
  [1523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 4, 0, 97),
  [1525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 4, 0, 97),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1, 0, 0),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1, 0, 0),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 3, 0, 0),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 3, 0, 0),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 4, 0, 0),
  [1541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 4, 0, 0),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 3, 0, 92),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 3, 0, 92),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 7, 0, 0),
  [1549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 7, 0, 0),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, 0, 97),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, 0, 97),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 7, 0, 0),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 7, 0, 0),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 2, 0, 0),
  [1577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 2, 0, 0),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 6, 0, 40),
  [1581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 6, 0, 40),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 6, 0, 40),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 6, 0, 40),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [1589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 5, 0, 0),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 5, 0, 0),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 5, 0, 0),
  [1595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 5, 0, 0),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 96),
  [1599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 96),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 99),
  [1603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 99),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 74),
  [1607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 74),
  [1609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 69),
  [1611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 69),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 4, 0, 68),
  [1629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 4, 0, 68),
  [1631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 5, 0, 77),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 5, 0, 77),
  [1635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 3, 0, 0),
  [1637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, 0, 70),
  [1639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, 0, 70),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 2, 0, 0),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 90),
  [1659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 90),
  [1661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 3, 0, 0),
  [1663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 2, 0, 0),
  [1665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 94),
  [1667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 94),
  [1669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 80),
  [1671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 80),
  [1673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 81),
  [1675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 81),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 4, 0, 81),
  [1681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 4, 0, 81),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, 0, 70),
  [1685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, 0, 70),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3, 0, 92),
  [1691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 3, 0, 92),
  [1693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 4, 0, 0),
  [1695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 4, 0, 0),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_function_definition, 7, 0, 48),
  [1699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_function_definition, 7, 0, 48),
  [1701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 87),
  [1703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 87),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 98),
  [1707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 98),
  [1709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 85),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 85),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 100),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 100),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 4, 0, 71),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 4, 0, 71),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 6, 0, 89),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 6, 0, 89),
  [1725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_separator, 1, 0, 0),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, 0, 78),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, 0, 78),
  [1741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, 0, 82),
  [1743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, 0, 82),
  [1745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_function_definition, 8, 0, 63),
  [1747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_function_definition, 8, 0, 63),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 75),
  [1751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 75),
  [1753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 95),
  [1755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 95),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, 0, 81),
  [1759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, 0, 81),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 101),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 101),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 91),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 91),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 79),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 79),
  [1781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_function_definition, 5, 0, 18),
  [1783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_function_definition, 5, 0, 18),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 70),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 70),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 93),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 93),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_function_definition, 6, 0, 32),
  [1795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_function_definition, 6, 0, 32),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [1943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1584),
  [1946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [1948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [1950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1582),
  [1953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1591),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [1964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, 0, 14),
  [2052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, 0, 14),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [2058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 16),
  [2060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 16),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, 0, 7),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, 0, 7),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await, 2, 0, 0),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await, 2, 0, 0),
  [2070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1597),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_string, 2, 0, 0),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_string, 2, 0, 0),
  [2107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1583),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 26),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 26),
  [2114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_string, 3, 0, 0),
  [2116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_string, 3, 0, 0),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 27),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 27),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [2182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1588),
  [2209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1612),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1604),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [2249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 8),
  [2251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 8),
  [2253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, 0, 0),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, 0, 0),
  [2257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3, 0, 0),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3, 0, 0),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [2271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 20),
  [2273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 20),
  [2275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3, 0, 0),
  [2277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3, 0, 0),
  [2279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [2281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [2283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 20),
  [2285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 20),
  [2287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 5, 0, 0),
  [2289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 5, 0, 0),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 20),
  [2323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 20),
  [2325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_comprehension, 4, 0, 21),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_comprehension, 4, 0, 21),
  [2333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_comprehension, 4, 0, 21),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_comprehension, 4, 0, 21),
  [2337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4, 0, 0),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4, 0, 0),
  [2341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_expression, 4, 0, 21),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_expression, 4, 0, 21),
  [2345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_comprehension, 4, 0, 21),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_comprehension, 4, 0, 21),
  [2349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 2, 0, 0),
  [2355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 2, 0, 0),
  [2357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 3, 0, 0),
  [2359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 3, 0, 0),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 1, 0, 0),
  [2389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0),
  [2391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2480),
  [2394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(1860),
  [2397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(1999),
  [2400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(1997),
  [2403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(1847),
  [2406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2572),
  [2409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2281),
  [2412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2566),
  [2415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2565),
  [2418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2564),
  [2421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2285),
  [2424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2286),
  [2427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [2430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2560),
  [2433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(1486),
  [2436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(2296),
  [2439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17),
  [2443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(798),
  [2446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2409),
  [2449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(798),
  [2452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(687),
  [2455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 2, 0, 9),
  [2457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 2, 0, 9),
  [2459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(812),
  [2462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2375),
  [2465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(812),
  [2468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(685),
  [2471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(793),
  [2474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2404),
  [2477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(793),
  [2480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(680),
  [2483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(821),
  [2486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2450),
  [2489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(821),
  [2492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(684),
  [2495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(748),
  [2498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2460),
  [2501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(748),
  [2504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(686),
  [2507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(751),
  [2510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2437),
  [2513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(751),
  [2516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(689),
  [2519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(721),
  [2522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2472),
  [2525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(721),
  [2528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(683),
  [2531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(827),
  [2534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2546),
  [2537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(827),
  [2540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(688),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, 0, 0),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2, 0, 0),
  [2549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2, 0, 0), SHIFT_REPEAT(631),
  [2552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(720),
  [2555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2479),
  [2558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(720),
  [2561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(682),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [2580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, 0, 0),
  [2582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, 0, 0),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [2604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2, 0, 0), SHIFT_REPEAT(638),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [2653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__right_hand_side, 1, 0, 0),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [2679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(753),
  [2682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(2356),
  [2685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(753),
  [2688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 17), SHIFT_REPEAT(681),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3, 0, 0),
  [2693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override, 2, 0, 0),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override, 2, 0, 0),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [2699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation, 3, 0, 0),
  [2701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation, 3, 0, 0),
  [2703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [2705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2, 0, 0),
  [2707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_override_repeat1, 2, 0, 0),
  [2709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_override_repeat1, 2, 0, 0),
  [2711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation, 2, 0, 0),
  [2713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation, 2, 0, 0),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenation_repeat1, 2, 0, 0),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2, 0, 0),
  [2721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2, 0, 0), SHIFT_REPEAT(1960),
  [2724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_expansion, 2, 0, 0),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_expansion, 2, 0, 0),
  [2728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_expansion, 3, 0, 0),
  [2730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_expansion, 3, 0, 0),
  [2732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_operator, 2, 0, 6),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 1, 0, 0),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_operator, 3, 0, 14),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [2770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_override_repeat1, 2, 0, 0), SHIFT_REPEAT(1702),
  [2787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override, 4, 0, 0),
  [2789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override, 4, 0, 0),
  [2791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 12),
  [2793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(475),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [2814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, 0, 13),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [2834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_item, 1, 1, 41), SHIFT(258),
  [2837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 0),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [2847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1555),
  [2850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1555),
  [2853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(407),
  [2856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2278),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, 0, 24),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, 0, 11),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [2875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override, 3, 0, 0),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override, 3, 0, 0),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [2891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [2909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(1579),
  [2912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [2914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(1579),
  [2917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(433),
  [2920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(2332),
  [2923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_override_repeat1, 3, 0, 0),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_override_repeat1, 3, 0, 0),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [2931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_flag, 3, 0, 0),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_flag, 3, 0, 0),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [2953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_python_string_repeat1, 2, 0, 0), SHIFT_REPEAT(164),
  [2956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_python_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [2959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_python_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [2962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_python_string_repeat1, 2, 0, 0),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [2974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [2976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__f_expression, 1, 0, 0),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2, 0, 0),
  [2996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [3002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(398),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, 0, 13),
  [3015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_operator, 3, 0, 14),
  [3017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(443),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [3028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [3034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(497),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 3, 0, 0),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [3047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(461),
  [3050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 2, 0, 0),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [3064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0),
  [3066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(442),
  [3069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_operator, 2, 0, 6),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [3099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(525),
  [3102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 4, 0, 31),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inherit_directive, 2, 0, 0),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [3114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [3116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_within_for_in_clause, 1, 0, 0),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [3146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_python, 3, 0, 0),
  [3148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_python, 3, 0, 0),
  [3150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2374),
  [3153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [3155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(514),
  [3158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2084),
  [3161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1689),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(513),
  [3171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_statement, 2, 0, 0),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2, 0, 0),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, -1, 6),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [3211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(487),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 22),
  [3226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_inherit_directive_repeat1, 2, 0, 0),
  [3228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inherit_directive_repeat1, 2, 0, 0), SHIFT_REPEAT(1735),
  [3231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inherit_directive_repeat1, 2, 0, 0), SHIFT_REPEAT(455),
  [3234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inherit_directive_repeat1, 2, 0, 0), SHIFT_REPEAT(2293),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [3241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, 0, 6),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [3249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2, 0, 0),
  [3251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0),
  [3253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(437),
  [3256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2407),
  [3259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(615),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [3272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 1, 0, 0),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [3276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, 0, 36),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [3280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 2, 0, 0),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [3286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(484),
  [3289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2581),
  [3292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(622),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [3297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_content, 1, 0, 0),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [3321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2, 0, 0),
  [3323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2, 0, 0), SHIFT_REPEAT(1763),
  [3326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2, 0, 0), SHIFT_REPEAT(1763),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chevron, 2, 0, 0),
  [3335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(460),
  [3338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2580),
  [3341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(610),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [3360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 1, 1, 41),
  [3362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 4, 0, 52),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat, 2, 0, 0),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3, 0, 0),
  [3380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_type, 3, 0, 0),
  [3382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type, 3, 0, 0),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [3394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 47),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 3, 0, 45),
  [3402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat, 2, 0, 0),
  [3404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 4, 0, 62),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 1, 0, 0),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [3412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 2, 0, 0),
  [3414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 0),
  [3416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_directive, 2, 0, 1),
  [3418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_require_directive, 2, 0, 1),
  [3420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [3422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [3424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_directive, 2, 0, 1),
  [3426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_directive, 2, 0, 1),
  [3428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, 0, 0),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 6, 0, 64),
  [3432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 6, 0, 64),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, 0, 23),
  [3442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, 0, 12),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, 0, 65),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, 0, 66),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0),
  [3454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, 0, 53),
  [3456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0),
  [3458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2510),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 5, 0, 0),
  [3463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 49),
  [3465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, 0, 49),
  [3467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0),
  [3469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(364),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 19),
  [3474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 19),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 50),
  [3478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, 0, 50),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 51),
  [3482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, 0, 51),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_include_directive_repeat1, 2, 0, 0),
  [3488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_include_directive_repeat1, 2, 0, 0),
  [3490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_include_directive_repeat1, 2, 0, 0), SHIFT_REPEAT(1985),
  [3493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_include_directive_repeat1, 2, 0, 0), SHIFT_REPEAT(2311),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, 0, 12),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, 0, 39),
  [3502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 0),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, 0, 73),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(349),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2, 0, 0), SHIFT_REPEAT(628),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(420),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 19),
  [3537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, 0, 19),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [3549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [3551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(340),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 34),
  [3556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, 0, 34),
  [3558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 35),
  [3560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, 0, 35),
  [3562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 3, 0, 42),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [3566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 2, 0, 0),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [3570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 4, 0, 24),
  [3572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2, 0, 0),
  [3574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2, 0, 0),
  [3576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1870),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 3, 0, 11),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [3593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2462),
  [3596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(163),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2, 0, 0),
  [3601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1891),
  [3604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2, 0, 0),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [3634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addtask_statement, 4, 0, 0),
  [3636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addtask_statement, 4, 0, 0),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [3642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 0),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 0),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [3652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 0),
  [3654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 0),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [3680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 0),
  [3682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 0),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(401),
  [3689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 1, 0, 0),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [3693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, 0, 30),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [3701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 12), SHIFT(404),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [3710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, 0, 30),
  [3712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1949),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [3717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 0),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 0),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_prefix, 1, 0, 0),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addtask_statement, 6, 0, 0),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addtask_statement, 6, 0, 0),
  [3733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [3735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, -1, 44),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3, 0, 0),
  [3741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(533),
  [3744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_prefix_repeat1, 2, 0, 0),
  [3746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1963),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 3, 0, 0),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [3753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 3, 0, 0),
  [3755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, 0, 43),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [3763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, 0, 42),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 56),
  [3775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 56), SHIFT_REPEAT(2107),
  [3778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, 0, 61),
  [3780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, 0, 61), SHIFT_REPEAT(415),
  [3783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addtask_statement, 2, 0, 0),
  [3785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addtask_statement, 2, 0, 0),
  [3787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [3789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [3791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2, 0, 0),
  [3793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2515),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [3802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 55),
  [3804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_functions_statement, 2, 0, 0),
  [3806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_functions_statement, 2, 0, 0),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, 0, 0),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_include_directive_repeat1, 1, 0, 0),
  [3816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_include_directive_repeat1, 1, 0, 0),
  [3818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 2, 0, 0),
  [3820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 2, 0, 0),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [3824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 2, 0, 0),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 5, 0, 31),
  [3828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 2, 0, 0),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [3838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [3840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2, 0, 0), SHIFT_REPEAT(1987),
  [3843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2003),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [3858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(440),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2, 0, 0), SHIFT_REPEAT(79),
  [3906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2, 0, 0),
  [3908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2, 0, 0), SHIFT_REPEAT(644),
  [3911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aliased_import, 3, 0, 57),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [3917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2, 0, 0), SHIFT_REPEAT(629),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [3968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 1, 0, 0),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(462),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2, 0, 0),
  [3999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(395),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [4006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(283),
  [4009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(251),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(391),
  [4039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1, 0, 0),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [4055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, 0, 38),
  [4057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, 0, 38), SHIFT_REPEAT(383),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2, 0, 0), SHIFT_REPEAT(182),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 1, 0, 33),
  [4098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 1, 0, 33),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2, 0, 0),
  [4132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2, 0, 0), SHIFT_REPEAT(302),
  [4135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 56), SHIFT_REPEAT(2113),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [4142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 2, 0, 31),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 1, 0, 0),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [4158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_override_repeat1, 2, 0, 0), SHIFT_REPEAT(1662),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [4171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2522),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(276),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [4191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, 0, 0),
  [4193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1517),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [4220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relative_import, 1, 0, 0),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [4232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1516),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [4243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2, 0, 0), SHIFT_REPEAT(641),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [4254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(482),
  [4257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_overrides_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2358),
  [4260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_overrides_statement_repeat1, 2, 0, 0),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [4274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overrides_statement, 6, 0, 0),
  [4276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_overrides_statement, 6, 0, 0),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [4282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 6, 0, 28),
  [4284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 6, 0, 28),
  [4286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, 0, 29),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [4290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_assignment, 4, 0, 10),
  [4292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_assignment, 4, 0, 10),
  [4294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, 0, 0),
  [4296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, 0, 20),
  [4298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [4300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [4302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [4304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_separator, 1, 0, 0),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [4314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 6, 0, 83),
  [4316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 10, 0, 0),
  [4318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 10, 0, 0),
  [4320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 5, 0, 72),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [4330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [4338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 20),
  [4340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 6, 0, 84),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [4346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 7, 0, 40),
  [4348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 7, 0, 40),
  [4350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 9, 0, 67),
  [4352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 9, 0, 67),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [4356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 9, 0, 0),
  [4358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 9, 0, 0),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [4364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [4366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [4372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_assignment, 3, 0, 4),
  [4374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_assignment, 3, 0, 4),
  [4376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [4378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [4388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 7, 0, 0),
  [4390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 7, 0, 0),
  [4392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deltask_statement, 2, 0, 0),
  [4394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deltask_statement, 2, 0, 0),
  [4396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addhandler_statement, 2, 0, 0),
  [4398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addhandler_statement, 2, 0, 0),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, 0, 60),
  [4404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, 0, 59),
  [4406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard_import, 1, 0, 0),
  [4408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 4, 0, 58),
  [4410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [4414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 46),
  [4416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment, 3, 0, 14),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [4420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1, 0, 0),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [4426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pass_statement, 1, 0, 0),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 3, 0, 0),
  [4432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 3, 0, 0),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [4440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 8, 0, 54),
  [4442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 8, 0, 54),
  [4444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overrides_statement, 5, 0, 0),
  [4446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_overrides_statement, 5, 0, 0),
  [4448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 8, 0, 0),
  [4450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 8, 0, 0),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [4666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 1, 0, 0),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [4742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_import, 2, 0, 0),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [4816] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [4848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 0),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [4852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 0),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__concat = 0,
  ts_external_token__newline = 1,
  ts_external_token__indent = 2,
  ts_external_token__dedent = 3,
  ts_external_token_string_start = 4,
  ts_external_token__string_content = 5,
  ts_external_token_escape_interpolation = 6,
  ts_external_token_string_end = 7,
  ts_external_token_comment = 8,
  ts_external_token_RBRACK = 9,
  ts_external_token_RPAREN = 10,
  ts_external_token_RBRACE = 11,
  ts_external_token_shell_content = 12,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__concat] = sym__concat,
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token_string_start] = sym_string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token_escape_interpolation] = sym_escape_interpolation,
  [ts_external_token_string_end] = sym_string_end,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_RPAREN] = anon_sym_RPAREN,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_shell_content] = sym_shell_content,
};

static const bool ts_external_scanner_states[17][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__concat] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_RPAREN] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_shell_content] = true,
  },
  [2] = {
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [6] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [7] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [8] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [9] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [10] = {
    [ts_external_token__newline] = true,
    [ts_external_token_comment] = true,
  },
  [11] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [12] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [13] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_comment] = true,
  },
  [15] = {
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
  },
  [16] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_shell_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_bitbake_external_scanner_create(void);
void tree_sitter_bitbake_external_scanner_destroy(void *);
bool tree_sitter_bitbake_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bitbake_external_scanner_serialize(void *, char *);
void tree_sitter_bitbake_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_bitbake(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_bitbake_external_scanner_create,
      tree_sitter_bitbake_external_scanner_destroy,
      tree_sitter_bitbake_external_scanner_scan,
      tree_sitter_bitbake_external_scanner_serialize,
      tree_sitter_bitbake_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
