#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 553
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 157
#define ALIAS_COUNT 17
#define TOKEN_COUNT 71
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 13
#define PRODUCTION_ID_COUNT 35

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_unique_id = 2,
  anon_sym_SEMI = 3,
  anon_sym_using = 4,
  anon_sym_EQ = 5,
  anon_sym_import = 6,
  anon_sym_DOT = 7,
  anon_sym_DOLLARimport = 8,
  anon_sym_LPAREN = 9,
  anon_sym_RPAREN = 10,
  anon_sym_namespace = 11,
  anon_sym_DOLLAR = 12,
  aux_sym_top_level_annotation_body_token1 = 13,
  anon_sym_COMMA = 14,
  anon_sym_annotation = 15,
  anon_sym_COLON = 16,
  anon_sym_STAR = 17,
  anon_sym_const = 18,
  anon_sym_enumerant = 19,
  anon_sym_field = 20,
  anon_sym_file = 21,
  anon_sym_method = 22,
  anon_sym_param = 23,
  anon_sym_enum = 24,
  anon_sym_group = 25,
  anon_sym_interface = 26,
  anon_sym_struct = 27,
  anon_sym_union = 28,
  anon_sym_LBRACK = 29,
  anon_sym_RBRACK = 30,
  anon_sym_LBRACE = 31,
  anon_sym_RBRACE = 32,
  anon_sym_extends = 33,
  anon_sym_DASH_GT = 34,
  anon_sym_AnyPointer = 35,
  anon_sym_Bool = 36,
  anon_sym_Int8 = 37,
  anon_sym_Int16 = 38,
  anon_sym_Int32 = 39,
  anon_sym_Int64 = 40,
  anon_sym_UInt8 = 41,
  anon_sym_UInt16 = 42,
  anon_sym_UInt32 = 43,
  anon_sym_UInt64 = 44,
  anon_sym_Float32 = 45,
  anon_sym_Float64 = 46,
  anon_sym_Text = 47,
  anon_sym_Data = 48,
  anon_sym_Void = 49,
  anon_sym_List = 50,
  sym_number = 51,
  sym__normal_version = 52,
  aux_sym__inline_version_token1 = 53,
  sym_float = 54,
  anon_sym_true = 55,
  anon_sym_false = 56,
  anon_sym_0x = 57,
  aux_sym_data_token1 = 58,
  sym_void = 59,
  anon_sym_embed = 60,
  anon_sym_DQUOTE = 61,
  anon_sym_SQUOTE = 62,
  anon_sym_BQUOTE = 63,
  sym_unescaped_double_string_fragment = 64,
  sym_unescaped_single_string_fragment = 65,
  sym_unescaped_block_string_fragment = 66,
  aux_sym__escape_sequence_token1 = 67,
  sym_escape_sequence = 68,
  sym__identifier_no_period = 69,
  sym_comment = 70,
  sym_message = 71,
  sym_statement = 72,
  sym_unique_id_statement = 73,
  sym_using_directive = 74,
  sym_replace_using = 75,
  sym_import_using = 76,
  sym_import = 77,
  sym_top_level_annotation = 78,
  sym_top_level_annotation_body = 79,
  sym_annotation = 80,
  sym_annotation_targets = 81,
  sym_annotation_target = 82,
  sym_annotation_literal = 83,
  sym_annotation_array = 84,
  sym__annotation_array_def = 85,
  sym_definition = 86,
  sym_struct = 87,
  sym_nested_struct = 88,
  sym_enum = 89,
  sym_nested_enum = 90,
  sym_enum_field = 91,
  sym_group = 92,
  sym_field = 93,
  sym_union = 94,
  sym_nested_union = 95,
  sym__unnamed_union = 96,
  sym__named_union = 97,
  sym_union_field = 98,
  sym_interface = 99,
  sym_method = 100,
  sym_method_parameters = 101,
  sym_parameters = 102,
  sym_parameter = 103,
  sym_return_type = 104,
  sym_named_return_types = 105,
  sym_unnamed_return_type = 106,
  sym_named_return_type = 107,
  sym_field_type = 108,
  sym_primitive_type = 109,
  sym_list_type = 110,
  sym_custom_type = 111,
  sym_const = 112,
  sym_const_value = 113,
  sym__same_scope_const_value = 114,
  sym_field_version = 115,
  sym__inline_version = 116,
  sym_boolean = 117,
  sym_data = 118,
  sym_const_list = 119,
  sym_struct_shorthand = 120,
  sym__internal_const_identifier = 121,
  sym_embedded_file = 122,
  sym_generics = 123,
  sym_implicit_generics = 124,
  sym_generic_parameters = 125,
  sym_string = 126,
  sym_concatenated_string = 127,
  sym_block_text = 128,
  sym__escape_sequence = 129,
  sym__annotation_definition_identifier = 130,
  sym__method_identifier = 131,
  aux_sym_message_repeat1 = 132,
  aux_sym_import_using_repeat1 = 133,
  aux_sym_top_level_annotation_body_repeat1 = 134,
  aux_sym_annotation_repeat1 = 135,
  aux_sym_annotation_targets_repeat1 = 136,
  aux_sym__annotation_call_repeat1 = 137,
  aux_sym_annotation_array_repeat1 = 138,
  aux_sym__annotation_array_def_repeat1 = 139,
  aux_sym__annotation_array_def_repeat2 = 140,
  aux_sym_struct_repeat1 = 141,
  aux_sym_enum_repeat1 = 142,
  aux_sym_group_repeat1 = 143,
  aux_sym__unnamed_union_repeat1 = 144,
  aux_sym_interface_repeat1 = 145,
  aux_sym_parameters_repeat1 = 146,
  aux_sym_named_return_type_repeat1 = 147,
  aux_sym_custom_type_repeat1 = 148,
  aux_sym_struct_shorthand_repeat1 = 149,
  aux_sym__internal_const_identifier_repeat1 = 150,
  aux_sym_generic_parameters_repeat1 = 151,
  aux_sym_string_repeat1 = 152,
  aux_sym_string_repeat2 = 153,
  aux_sym_concatenated_string_repeat1 = 154,
  aux_sym_block_text_repeat1 = 155,
  aux_sym_block_text_repeat2 = 156,
  alias_sym_annotation_identifier = 157,
  alias_sym_attribute = 158,
  alias_sym_enum_identifier = 159,
  alias_sym_enum_member = 160,
  alias_sym_extend_type = 161,
  alias_sym_field_identifier = 162,
  alias_sym_generic_identifier = 163,
  alias_sym_implicit_generic_parameters = 164,
  alias_sym_import_path = 165,
  alias_sym_local_const = 166,
  alias_sym_method_identifier = 167,
  alias_sym_namespace = 168,
  alias_sym_param_identifier = 169,
  alias_sym_property = 170,
  alias_sym_return_identifier = 171,
  alias_sym_type_definition = 172,
  alias_sym_type_identifier = 173,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "annotation_definition_identifier",
  [sym_unique_id] = "unique_id",
  [anon_sym_SEMI] = ";",
  [anon_sym_using] = "using",
  [anon_sym_EQ] = "=",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_DOLLARimport] = "$import",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_namespace] = "namespace",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_top_level_annotation_body_token1] = "_type_identifier",
  [anon_sym_COMMA] = ",",
  [anon_sym_annotation] = "annotation",
  [anon_sym_COLON] = ":",
  [anon_sym_STAR] = "*",
  [anon_sym_const] = "const",
  [anon_sym_enumerant] = "enumerant",
  [anon_sym_field] = "field",
  [anon_sym_file] = "file",
  [anon_sym_method] = "method",
  [anon_sym_param] = "param",
  [anon_sym_enum] = "enum",
  [anon_sym_group] = "group",
  [anon_sym_interface] = "interface",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_extends] = "extends",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_AnyPointer] = "AnyPointer",
  [anon_sym_Bool] = "Bool",
  [anon_sym_Int8] = "Int8",
  [anon_sym_Int16] = "Int16",
  [anon_sym_Int32] = "Int32",
  [anon_sym_Int64] = "Int64",
  [anon_sym_UInt8] = "UInt8",
  [anon_sym_UInt16] = "UInt16",
  [anon_sym_UInt32] = "UInt32",
  [anon_sym_UInt64] = "UInt64",
  [anon_sym_Float32] = "Float32",
  [anon_sym_Float64] = "Float64",
  [anon_sym_Text] = "Text",
  [anon_sym_Data] = "Data",
  [anon_sym_Void] = "Void",
  [anon_sym_List] = "List",
  [sym_number] = "number",
  [sym__normal_version] = "_normal_version",
  [aux_sym__inline_version_token1] = "inline_field",
  [sym_float] = "float",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_0x] = "data_hex",
  [aux_sym_data_token1] = "data_string",
  [sym_void] = "void",
  [anon_sym_embed] = "embed",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_BQUOTE] = "`",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_unescaped_block_string_fragment] = "string_fragment",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym__identifier_no_period] = "const_identifier",
  [sym_comment] = "comment",
  [sym_message] = "message",
  [sym_statement] = "statement",
  [sym_unique_id_statement] = "unique_id_statement",
  [sym_using_directive] = "using_directive",
  [sym_replace_using] = "replace_using",
  [sym_import_using] = "import_using",
  [sym_import] = "import",
  [sym_top_level_annotation] = "top_level_annotation",
  [sym_top_level_annotation_body] = "top_level_annotation_body",
  [sym_annotation] = "annotation",
  [sym_annotation_targets] = "annotation_targets",
  [sym_annotation_target] = "annotation_target",
  [sym_annotation_literal] = "annotation_literal",
  [sym_annotation_array] = "annotation_array",
  [sym__annotation_array_def] = "_annotation_array_def",
  [sym_definition] = "definition",
  [sym_struct] = "struct",
  [sym_nested_struct] = "nested_struct",
  [sym_enum] = "enum",
  [sym_nested_enum] = "nested_enum",
  [sym_enum_field] = "enum_field",
  [sym_group] = "group",
  [sym_field] = "field",
  [sym_union] = "union",
  [sym_nested_union] = "nested_union",
  [sym__unnamed_union] = "_unnamed_union",
  [sym__named_union] = "_named_union",
  [sym_union_field] = "union_field",
  [sym_interface] = "interface",
  [sym_method] = "method",
  [sym_method_parameters] = "method_parameters",
  [sym_parameters] = "parameters",
  [sym_parameter] = "parameter",
  [sym_return_type] = "return_type",
  [sym_named_return_types] = "named_return_types",
  [sym_unnamed_return_type] = "unnamed_return_type",
  [sym_named_return_type] = "named_return_type",
  [sym_field_type] = "field_type",
  [sym_primitive_type] = "primitive_type",
  [sym_list_type] = "list_type",
  [sym_custom_type] = "custom_type",
  [sym_const] = "const",
  [sym_const_value] = "const_value",
  [sym__same_scope_const_value] = "_same_scope_const_value",
  [sym_field_version] = "field_version",
  [sym__inline_version] = "_inline_version",
  [sym_boolean] = "boolean",
  [sym_data] = "data",
  [sym_const_list] = "const_list",
  [sym_struct_shorthand] = "struct_shorthand",
  [sym__internal_const_identifier] = "_internal_const_identifier",
  [sym_embedded_file] = "embedded_file",
  [sym_generics] = "generics",
  [sym_implicit_generics] = "implicit_generics",
  [sym_generic_parameters] = "generic_parameters",
  [sym_string] = "string",
  [sym_concatenated_string] = "concatenated_string",
  [sym_block_text] = "block_text",
  [sym__escape_sequence] = "_escape_sequence",
  [sym__annotation_definition_identifier] = "_annotation_definition_identifier",
  [sym__method_identifier] = "_method_identifier",
  [aux_sym_message_repeat1] = "message_repeat1",
  [aux_sym_import_using_repeat1] = "import_using_repeat1",
  [aux_sym_top_level_annotation_body_repeat1] = "top_level_annotation_body_repeat1",
  [aux_sym_annotation_repeat1] = "annotation_repeat1",
  [aux_sym_annotation_targets_repeat1] = "annotation_targets_repeat1",
  [aux_sym__annotation_call_repeat1] = "_annotation_call_repeat1",
  [aux_sym_annotation_array_repeat1] = "annotation_array_repeat1",
  [aux_sym__annotation_array_def_repeat1] = "_annotation_array_def_repeat1",
  [aux_sym__annotation_array_def_repeat2] = "_annotation_array_def_repeat2",
  [aux_sym_struct_repeat1] = "struct_repeat1",
  [aux_sym_enum_repeat1] = "enum_repeat1",
  [aux_sym_group_repeat1] = "group_repeat1",
  [aux_sym__unnamed_union_repeat1] = "_unnamed_union_repeat1",
  [aux_sym_interface_repeat1] = "interface_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_named_return_type_repeat1] = "named_return_type_repeat1",
  [aux_sym_custom_type_repeat1] = "custom_type_repeat1",
  [aux_sym_struct_shorthand_repeat1] = "struct_shorthand_repeat1",
  [aux_sym__internal_const_identifier_repeat1] = "_internal_const_identifier_repeat1",
  [aux_sym_generic_parameters_repeat1] = "generic_parameters_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_block_text_repeat1] = "block_text_repeat1",
  [aux_sym_block_text_repeat2] = "block_text_repeat2",
  [alias_sym_annotation_identifier] = "annotation_identifier",
  [alias_sym_attribute] = "attribute",
  [alias_sym_enum_identifier] = "enum_identifier",
  [alias_sym_enum_member] = "enum_member",
  [alias_sym_extend_type] = "extend_type",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_generic_identifier] = "generic_identifier",
  [alias_sym_implicit_generic_parameters] = "implicit_generic_parameters",
  [alias_sym_import_path] = "import_path",
  [alias_sym_local_const] = "local_const",
  [alias_sym_method_identifier] = "method_identifier",
  [alias_sym_namespace] = "namespace",
  [alias_sym_param_identifier] = "param_identifier",
  [alias_sym_property] = "property",
  [alias_sym_return_identifier] = "return_identifier",
  [alias_sym_type_definition] = "type_definition",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_unique_id] = sym_unique_id,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOLLARimport] = anon_sym_DOLLARimport,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_top_level_annotation_body_token1] = aux_sym_top_level_annotation_body_token1,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_annotation] = anon_sym_annotation,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_enumerant] = anon_sym_enumerant,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_file] = anon_sym_file,
  [anon_sym_method] = anon_sym_method,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_group] = anon_sym_group,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_AnyPointer] = anon_sym_AnyPointer,
  [anon_sym_Bool] = anon_sym_Bool,
  [anon_sym_Int8] = anon_sym_Int8,
  [anon_sym_Int16] = anon_sym_Int16,
  [anon_sym_Int32] = anon_sym_Int32,
  [anon_sym_Int64] = anon_sym_Int64,
  [anon_sym_UInt8] = anon_sym_UInt8,
  [anon_sym_UInt16] = anon_sym_UInt16,
  [anon_sym_UInt32] = anon_sym_UInt32,
  [anon_sym_UInt64] = anon_sym_UInt64,
  [anon_sym_Float32] = anon_sym_Float32,
  [anon_sym_Float64] = anon_sym_Float64,
  [anon_sym_Text] = anon_sym_Text,
  [anon_sym_Data] = anon_sym_Data,
  [anon_sym_Void] = anon_sym_Void,
  [anon_sym_List] = anon_sym_List,
  [sym_number] = sym_number,
  [sym__normal_version] = sym__normal_version,
  [aux_sym__inline_version_token1] = aux_sym__inline_version_token1,
  [sym_float] = sym_float,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_0x] = anon_sym_0x,
  [aux_sym_data_token1] = aux_sym_data_token1,
  [sym_void] = sym_void,
  [anon_sym_embed] = anon_sym_embed,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [sym_unescaped_double_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_single_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_block_string_fragment] = sym_unescaped_double_string_fragment,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__identifier_no_period] = sym__identifier_no_period,
  [sym_comment] = sym_comment,
  [sym_message] = sym_message,
  [sym_statement] = sym_statement,
  [sym_unique_id_statement] = sym_unique_id_statement,
  [sym_using_directive] = sym_using_directive,
  [sym_replace_using] = sym_replace_using,
  [sym_import_using] = sym_import_using,
  [sym_import] = sym_import,
  [sym_top_level_annotation] = sym_top_level_annotation,
  [sym_top_level_annotation_body] = sym_top_level_annotation_body,
  [sym_annotation] = sym_annotation,
  [sym_annotation_targets] = sym_annotation_targets,
  [sym_annotation_target] = sym_annotation_target,
  [sym_annotation_literal] = sym_annotation_literal,
  [sym_annotation_array] = sym_annotation_array,
  [sym__annotation_array_def] = sym__annotation_array_def,
  [sym_definition] = sym_definition,
  [sym_struct] = sym_struct,
  [sym_nested_struct] = sym_nested_struct,
  [sym_enum] = sym_enum,
  [sym_nested_enum] = sym_nested_enum,
  [sym_enum_field] = sym_enum_field,
  [sym_group] = sym_group,
  [sym_field] = sym_field,
  [sym_union] = sym_union,
  [sym_nested_union] = sym_nested_union,
  [sym__unnamed_union] = sym__unnamed_union,
  [sym__named_union] = sym__named_union,
  [sym_union_field] = sym_union_field,
  [sym_interface] = sym_interface,
  [sym_method] = sym_method,
  [sym_method_parameters] = sym_method_parameters,
  [sym_parameters] = sym_parameters,
  [sym_parameter] = sym_parameter,
  [sym_return_type] = sym_return_type,
  [sym_named_return_types] = sym_named_return_types,
  [sym_unnamed_return_type] = sym_unnamed_return_type,
  [sym_named_return_type] = sym_named_return_type,
  [sym_field_type] = sym_field_type,
  [sym_primitive_type] = sym_primitive_type,
  [sym_list_type] = sym_list_type,
  [sym_custom_type] = sym_custom_type,
  [sym_const] = sym_const,
  [sym_const_value] = sym_const_value,
  [sym__same_scope_const_value] = sym__same_scope_const_value,
  [sym_field_version] = sym_field_version,
  [sym__inline_version] = sym__inline_version,
  [sym_boolean] = sym_boolean,
  [sym_data] = sym_data,
  [sym_const_list] = sym_const_list,
  [sym_struct_shorthand] = sym_struct_shorthand,
  [sym__internal_const_identifier] = sym__internal_const_identifier,
  [sym_embedded_file] = sym_embedded_file,
  [sym_generics] = sym_generics,
  [sym_implicit_generics] = sym_implicit_generics,
  [sym_generic_parameters] = sym_generic_parameters,
  [sym_string] = sym_string,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_block_text] = sym_block_text,
  [sym__escape_sequence] = sym__escape_sequence,
  [sym__annotation_definition_identifier] = sym__annotation_definition_identifier,
  [sym__method_identifier] = sym__method_identifier,
  [aux_sym_message_repeat1] = aux_sym_message_repeat1,
  [aux_sym_import_using_repeat1] = aux_sym_import_using_repeat1,
  [aux_sym_top_level_annotation_body_repeat1] = aux_sym_top_level_annotation_body_repeat1,
  [aux_sym_annotation_repeat1] = aux_sym_annotation_repeat1,
  [aux_sym_annotation_targets_repeat1] = aux_sym_annotation_targets_repeat1,
  [aux_sym__annotation_call_repeat1] = aux_sym__annotation_call_repeat1,
  [aux_sym_annotation_array_repeat1] = aux_sym_annotation_array_repeat1,
  [aux_sym__annotation_array_def_repeat1] = aux_sym__annotation_array_def_repeat1,
  [aux_sym__annotation_array_def_repeat2] = aux_sym__annotation_array_def_repeat2,
  [aux_sym_struct_repeat1] = aux_sym_struct_repeat1,
  [aux_sym_enum_repeat1] = aux_sym_enum_repeat1,
  [aux_sym_group_repeat1] = aux_sym_group_repeat1,
  [aux_sym__unnamed_union_repeat1] = aux_sym__unnamed_union_repeat1,
  [aux_sym_interface_repeat1] = aux_sym_interface_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_named_return_type_repeat1] = aux_sym_named_return_type_repeat1,
  [aux_sym_custom_type_repeat1] = aux_sym_custom_type_repeat1,
  [aux_sym_struct_shorthand_repeat1] = aux_sym_struct_shorthand_repeat1,
  [aux_sym__internal_const_identifier_repeat1] = aux_sym__internal_const_identifier_repeat1,
  [aux_sym_generic_parameters_repeat1] = aux_sym_generic_parameters_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_block_text_repeat1] = aux_sym_block_text_repeat1,
  [aux_sym_block_text_repeat2] = aux_sym_block_text_repeat2,
  [alias_sym_annotation_identifier] = alias_sym_annotation_identifier,
  [alias_sym_attribute] = alias_sym_attribute,
  [alias_sym_enum_identifier] = alias_sym_enum_identifier,
  [alias_sym_enum_member] = alias_sym_enum_member,
  [alias_sym_extend_type] = alias_sym_extend_type,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_generic_identifier] = alias_sym_generic_identifier,
  [alias_sym_implicit_generic_parameters] = alias_sym_implicit_generic_parameters,
  [alias_sym_import_path] = alias_sym_import_path,
  [alias_sym_local_const] = alias_sym_local_const,
  [alias_sym_method_identifier] = alias_sym_method_identifier,
  [alias_sym_namespace] = alias_sym_namespace,
  [alias_sym_param_identifier] = alias_sym_param_identifier,
  [alias_sym_property] = alias_sym_property,
  [alias_sym_return_identifier] = alias_sym_return_identifier,
  [alias_sym_type_definition] = alias_sym_type_definition,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unique_id] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARimport] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_top_level_annotation_body_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_annotation] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enumerant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_file] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_method] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_group] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AnyPointer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Int8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Int16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Int32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Int64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UInt8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UInt16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UInt32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UInt64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Float32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Float64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Text] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Data] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_List] = {
    .visible = true,
    .named = false,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym__normal_version] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_version_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0x] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_data_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_void] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_embed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_block_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_no_period] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_message] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_unique_id_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_using_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_replace_using] = {
    .visible = true,
    .named = true,
  },
  [sym_import_using] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_top_level_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_top_level_annotation_body] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_targets] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_target] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_array] = {
    .visible = true,
    .named = true,
  },
  [sym__annotation_array_def] = {
    .visible = false,
    .named = true,
  },
  [sym_definition] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_enum] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_enum] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_field] = {
    .visible = true,
    .named = true,
  },
  [sym_group] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_union] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_union] = {
    .visible = true,
    .named = true,
  },
  [sym__unnamed_union] = {
    .visible = false,
    .named = true,
  },
  [sym__named_union] = {
    .visible = false,
    .named = true,
  },
  [sym_union_field] = {
    .visible = true,
    .named = true,
  },
  [sym_interface] = {
    .visible = true,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_method_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_named_return_types] = {
    .visible = true,
    .named = true,
  },
  [sym_unnamed_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_named_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_list_type] = {
    .visible = true,
    .named = true,
  },
  [sym_custom_type] = {
    .visible = true,
    .named = true,
  },
  [sym_const] = {
    .visible = true,
    .named = true,
  },
  [sym_const_value] = {
    .visible = true,
    .named = true,
  },
  [sym__same_scope_const_value] = {
    .visible = false,
    .named = true,
  },
  [sym_field_version] = {
    .visible = true,
    .named = true,
  },
  [sym__inline_version] = {
    .visible = false,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_data] = {
    .visible = true,
    .named = true,
  },
  [sym_const_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_shorthand] = {
    .visible = true,
    .named = true,
  },
  [sym__internal_const_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_embedded_file] = {
    .visible = true,
    .named = true,
  },
  [sym_generics] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_generics] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_block_text] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym__annotation_definition_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__method_identifier] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_message_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_using_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_top_level_annotation_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_targets_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__annotation_call_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__annotation_array_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__annotation_array_def_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__unnamed_union_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_return_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_custom_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_shorthand_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__internal_const_identifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_text_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_text_repeat2] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_annotation_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_enum_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_enum_member] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_extend_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_generic_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_implicit_generic_parameters] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_path] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_local_const] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_method_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_param_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_return_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [1] = alias_sym_import_path,
  },
  [2] = {
    [1] = alias_sym_type_identifier,
  },
  [3] = {
    [0] = alias_sym_type_definition,
    [2] = alias_sym_type_identifier,
  },
  [4] = {
    [0] = alias_sym_type_identifier,
  },
  [5] = {
    [1] = alias_sym_annotation_identifier,
  },
  [6] = {
    [1] = alias_sym_enum_identifier,
  },
  [7] = {
    [0] = alias_sym_generic_identifier,
  },
  [8] = {
    [0] = alias_sym_method_identifier,
  },
  [9] = {
    [0] = alias_sym_type_identifier,
    [3] = alias_sym_import_path,
  },
  [10] = {
    [2] = alias_sym_import_path,
  },
  [11] = {
    [2] = alias_sym_namespace,
  },
  [12] = {
    [1] = alias_sym_attribute,
  },
  [13] = {
    [0] = alias_sym_enum_member,
  },
  [14] = {
    [1] = alias_sym_generic_identifier,
  },
  [15] = {
    [0] = alias_sym_property,
  },
  [16] = {
    [2] = alias_sym_annotation_identifier,
  },
  [17] = {
    [1] = sym__identifier_no_period,
  },
  [18] = {
    [2] = alias_sym_type_identifier,
  },
  [19] = {
    [1] = alias_sym_import_path,
    [5] = alias_sym_namespace,
  },
  [20] = {
    [1] = alias_sym_local_const,
  },
  [21] = {
    [1] = alias_sym_implicit_generic_parameters,
  },
  [22] = {
    [3] = alias_sym_type_identifier,
  },
  [23] = {
    [1] = alias_sym_type_identifier,
    [4] = alias_sym_extend_type,
  },
  [24] = {
    [0] = alias_sym_field_identifier,
  },
  [25] = {
    [1] = alias_sym_annotation_identifier,
    [3] = alias_sym_param_identifier,
  },
  [26] = {
    [1] = alias_sym_type_identifier,
    [5] = alias_sym_extend_type,
  },
  [27] = {
    [0] = alias_sym_param_identifier,
  },
  [28] = {
    [0] = alias_sym_field_identifier,
    [4] = alias_sym_import_path,
  },
  [29] = {
    [2] = alias_sym_import_path,
    [7] = alias_sym_namespace,
  },
  [30] = {
    [1] = alias_sym_annotation_identifier,
    [4] = alias_sym_param_identifier,
  },
  [31] = {
    [1] = alias_sym_type_identifier,
    [6] = alias_sym_extend_type,
  },
  [32] = {
    [0] = alias_sym_return_identifier,
    [2] = alias_sym_type_identifier,
  },
  [33] = {
    [1] = alias_sym_property,
  },
  [34] = {
    [1] = alias_sym_return_identifier,
    [3] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_field_type, 2,
    sym_field_type,
    alias_sym_generic_identifier,
  sym_const_value, 2,
    sym_const_value,
    alias_sym_local_const,
  sym_generic_parameters, 2,
    sym_generic_parameters,
    alias_sym_implicit_generic_parameters,
  sym_string, 3,
    sym_string,
    alias_sym_import_path,
    alias_sym_namespace,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 28,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 196,
  [244] = 200,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 304,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 288,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 290,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 444,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 519,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(55);
      ADVANCE_MAP(
        '"', 103,
        '#', 177,
        '$', 65,
        '\'', 104,
        '(', 62,
        ')', 63,
        '*', 69,
        '+', 23,
        ',', 67,
        '-', 24,
        '.', 60,
        '0', 77,
        ':', 68,
        ';', 57,
        '=', 58,
        '@', 40,
        '[', 70,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == ']') ADVANCE(71);
      if (lookahead == '`') ADVANCE(105);
      if (lookahead == 'e') ADVANCE(150);
      if (lookahead == 'f') ADVANCE(139);
      if (lookahead == 'i') ADVANCE(151);
      if (lookahead == 'n') ADVANCE(140);
      if (lookahead == 't') ADVANCE(154);
      if (lookahead == 'v') ADVANCE(153);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '}') ADVANCE(73);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(0);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(80);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(13);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(13);
      if (lookahead == '\r') SKIP(1);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(15);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(15);
      if (lookahead == '\r') SKIP(3);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(116);
      if (lookahead == '\r') ADVANCE(116);
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(117);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(118);
      if (lookahead != 0) ADVANCE(116);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(14);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(14);
      if (lookahead == '\r') SKIP(6);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(18);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(18);
      if (lookahead == '\r') SKIP(8);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(19);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(19);
      if (lookahead == '\r') SKIP(10);
      END_STATE();
    case 12:
      if (lookahead == ' ') ADVANCE(17);
      if (lookahead == '"') ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '"', 103,
        '#', 177,
        '$', 64,
        '\'', 104,
        '(', 62,
        ')', 63,
        '+', 23,
        ',', 67,
        '-', 24,
        '.', 39,
        '0', 77,
        ':', 68,
        ';', 57,
        '=', 58,
        '@', 26,
        '[', 70,
      );
      if (lookahead == '\\') SKIP(2);
      if (lookahead == ']') ADVANCE(71);
      if (lookahead == '`') ADVANCE(105);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(120);
      if (lookahead == 'i') ADVANCE(132);
      if (lookahead == 'n') ADVANCE(121);
      if (lookahead == 't') ADVANCE(135);
      if (lookahead == 'v') ADVANCE(134);
      if (lookahead == '{') ADVANCE(72);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(13);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(80);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '"', 103,
        '#', 177,
        '$', 64,
        '\'', 104,
        '(', 62,
        ')', 63,
        ',', 67,
        '-', 27,
        '.', 59,
        ':', 68,
        ';', 57,
        '=', 58,
        '@', 26,
        '[', 70,
      );
      if (lookahead == '\\') SKIP(7);
      if (lookahead == ']') ADVANCE(71);
      if (lookahead == '`') ADVANCE(105);
      if (lookahead == '{') ADVANCE(72);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(14);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '"', 103,
        '#', 177,
        '\'', 104,
        '(', 62,
        ')', 63,
        '+', 23,
        ',', 67,
        '-', 25,
        '.', 60,
        '0', 77,
        '[', 70,
      );
      if (lookahead == '\\') SKIP(4);
      if (lookahead == ']') ADVANCE(71);
      if (lookahead == '`') ADVANCE(105);
      if (lookahead == 'e') ADVANCE(169);
      if (lookahead == 'f') ADVANCE(158);
      if (lookahead == 'i') ADVANCE(170);
      if (lookahead == 'n') ADVANCE(159);
      if (lookahead == 't') ADVANCE(173);
      if (lookahead == 'v') ADVANCE(172);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(15);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(80);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(103);
      if (lookahead == '#') ADVANCE(106);
      if (lookahead == '\\') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(107);
      if (lookahead != 0) ADVANCE(108);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(177);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == ')') ADVANCE(63);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '\\') SKIP(9);
      if (lookahead == ']') ADVANCE(71);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(18);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 19:
      if (lookahead == '#') ADVANCE(177);
      if (lookahead == '\\') SKIP(11);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(19);
      END_STATE();
    case 20:
      if (lookahead == '#') ADVANCE(177);
      if (lookahead == '\\') SKIP(11);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(19);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(66);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '#', 112,
        '$', 115,
        ')', 115,
        ',', 115,
        ';', 57,
        '\\', 5,
        ']', 115,
        '`', 105,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(113);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(114);
      if (lookahead != 0) ADVANCE(115);
      END_STATE();
    case 22:
      if (lookahead == '#') ADVANCE(109);
      if (lookahead == '\'') ADVANCE(104);
      if (lookahead == '\\') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(110);
      if (lookahead != 0) ADVANCE(111);
      END_STATE();
    case 23:
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '0') ADVANCE(79);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 24:
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '0') ADVANCE(78);
      if (lookahead == '>') ADVANCE(74);
      if (lookahead == 'i') ADVANCE(30);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '0') ADVANCE(78);
      if (lookahead == 'i') ADVANCE(30);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 26:
      if (lookahead == '0') ADVANCE(38);
      END_STATE();
    case 27:
      if (lookahead == '>') ADVANCE(74);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(75);
      END_STATE();
    case 29:
      if (lookahead == 'm') ADVANCE(32);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(28);
      END_STATE();
    case 31:
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 32:
      if (lookahead == 'p') ADVANCE(31);
      END_STATE();
    case 33:
      if (lookahead == 'r') ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 38:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(45);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(87);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(85);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(118);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 50:
      if (eof) ADVANCE(55);
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 51:
      if (eof) ADVANCE(55);
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(50);
      END_STATE();
    case 52:
      if (eof) ADVANCE(55);
      if (lookahead == '\n') SKIP(54);
      END_STATE();
    case 53:
      if (eof) ADVANCE(55);
      if (lookahead == '\n') SKIP(54);
      if (lookahead == '\r') SKIP(52);
      END_STATE();
    case 54:
      if (eof) ADVANCE(55);
      ADVANCE_MAP(
        '"', 17,
        '#', 177,
        '$', 65,
        '(', 62,
        ')', 63,
        '*', 69,
        ',', 67,
        '.', 59,
        ':', 68,
        ';', 57,
        '=', 58,
        '@', 26,
        '[', 70,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == '}') ADVANCE(73);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(54);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_unique_id);
      if (lookahead == '_') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(87);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DOLLARimport);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == 'i') ADVANCE(29);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym_top_level_annotation_body_token1);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '0') ADVANCE(80);
      if (lookahead == 'X') ADVANCE(43);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(95);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '0') ADVANCE(80);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(43);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '0') ADVANCE(80);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym__normal_version);
      if (lookahead == '!') ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym__inline_version_token1);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(87);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_true);
      if (lookahead == '.') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_true);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_false);
      if (lookahead == '.') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_false);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_0x);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_data_token1);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_void);
      if (lookahead == '.') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_void);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_void);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_embed);
      if (lookahead == '.') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_embed);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_embed);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(108);
      if (lookahead == '#') ADVANCE(106);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\') ADVANCE(106);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '#') ADVANCE(106);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\') ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(111);
      if (lookahead == '#') ADVANCE(109);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '#') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(110);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(111);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(111);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_unescaped_block_string_fragment);
      if (lookahead == '\n') ADVANCE(115);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(112);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_unescaped_block_string_fragment);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(115);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == ',') ADVANCE(115);
      if (lookahead == ']') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(113);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(114);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '\\' &&
          lookahead != ']' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(115);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_unescaped_block_string_fragment);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(114);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '\\' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(115);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_unescaped_block_string_fragment);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(115);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(119);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(118);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'a') ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'a') ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'b') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'd') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'd') ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'e') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'e') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'e') ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'f') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'i') ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'l') ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'm') ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'n') ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'n') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'o') ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'r') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 's') ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'u') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(149);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(152);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'b') ADVANCE(146);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(99);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(102);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(91);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(94);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(143);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(142);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(155);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'm') ADVANCE(141);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(147);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(84);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(148);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(156);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(145);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(144);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(157);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'a') ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'a') ADVANCE(171);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'b') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'd') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'd') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'e') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'e') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'e') ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'f') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'i') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'l') ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'm') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'n') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'n') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'o') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'r') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 's') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (lookahead == 'u') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym__identifier_no_period);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '#') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(177);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'A', 1,
        'B', 2,
        'D', 3,
        'F', 4,
        'I', 5,
        'L', 6,
        'T', 7,
        'U', 8,
        'V', 9,
      );
      if (lookahead == '\\') SKIP(10);
      if (lookahead == 'a') ADVANCE(11);
      if (lookahead == 'c') ADVANCE(12);
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'f') ADVANCE(14);
      if (lookahead == 'g') ADVANCE(15);
      if (lookahead == 'i') ADVANCE(16);
      if (lookahead == 'm') ADVANCE(17);
      if (lookahead == 'n') ADVANCE(18);
      if (lookahead == 'p') ADVANCE(19);
      if (lookahead == 's') ADVANCE(20);
      if (lookahead == 'u') ADVANCE(21);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(24);
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'n') ADVANCE(26);
      END_STATE();
    case 6:
      if (lookahead == 'i') ADVANCE(27);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(28);
      END_STATE();
    case 8:
      if (lookahead == 'I') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(31);
      END_STATE();
    case 11:
      if (lookahead == 'n') ADVANCE(32);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 13:
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 14:
      if (lookahead == 'i') ADVANCE(36);
      END_STATE();
    case 15:
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 16:
      if (lookahead == 'm') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(40);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(41);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(42);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 22:
      if (lookahead == 'y') ADVANCE(46);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(47);
      END_STATE();
    case 24:
      if (lookahead == 't') ADVANCE(48);
      END_STATE();
    case 25:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 26:
      if (lookahead == 't') ADVANCE(50);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(51);
      END_STATE();
    case 28:
      if (lookahead == 'x') ADVANCE(52);
      END_STATE();
    case 29:
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 30:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 32:
      if (lookahead == 'n') ADVANCE(55);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(58);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(59);
      if (lookahead == 'l') ADVANCE(60);
      END_STATE();
    case 37:
      if (lookahead == 'o') ADVANCE(61);
      END_STATE();
    case 38:
      if (lookahead == 'p') ADVANCE(62);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(64);
      END_STATE();
    case 41:
      if (lookahead == 'm') ADVANCE(65);
      END_STATE();
    case 42:
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 43:
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 45:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 46:
      if (lookahead == 'P') ADVANCE(70);
      END_STATE();
    case 47:
      if (lookahead == 'l') ADVANCE(71);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(72);
      END_STATE();
    case 49:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 50:
      if (lookahead == '1') ADVANCE(74);
      if (lookahead == '3') ADVANCE(75);
      if (lookahead == '6') ADVANCE(76);
      if (lookahead == '8') ADVANCE(77);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 54:
      if (lookahead == 'd') ADVANCE(81);
      END_STATE();
    case 55:
      if (lookahead == 'o') ADVANCE(82);
      END_STATE();
    case 56:
      if (lookahead == 's') ADVANCE(83);
      END_STATE();
    case 57:
      if (lookahead == 'm') ADVANCE(84);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 59:
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 61:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 62:
      if (lookahead == 'o') ADVANCE(89);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 64:
      if (lookahead == 'h') ADVANCE(91);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 66:
      if (lookahead == 'a') ADVANCE(93);
      END_STATE();
    case 67:
      if (lookahead == 'u') ADVANCE(94);
      END_STATE();
    case 68:
      if (lookahead == 'o') ADVANCE(95);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(96);
      END_STATE();
    case 70:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_Bool);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_Data);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 74:
      if (lookahead == '6') ADVANCE(99);
      END_STATE();
    case 75:
      if (lookahead == '2') ADVANCE(100);
      END_STATE();
    case 76:
      if (lookahead == '4') ADVANCE(101);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_Int8);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_List);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_Text);
      END_STATE();
    case 80:
      if (lookahead == '1') ADVANCE(102);
      if (lookahead == '3') ADVANCE(103);
      if (lookahead == '6') ADVANCE(104);
      if (lookahead == '8') ADVANCE(105);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_Void);
      END_STATE();
    case 82:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_enum);
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 85:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 86:
      if (lookahead == 'd') ADVANCE(110);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_file);
      END_STATE();
    case 88:
      if (lookahead == 'p') ADVANCE(111);
      END_STATE();
    case 89:
      if (lookahead == 'r') ADVANCE(112);
      END_STATE();
    case 90:
      if (lookahead == 'r') ADVANCE(113);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 92:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(116);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(117);
      END_STATE();
    case 95:
      if (lookahead == 'n') ADVANCE(118);
      END_STATE();
    case 96:
      if (lookahead == 'g') ADVANCE(119);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 98:
      if (lookahead == '3') ADVANCE(121);
      if (lookahead == '6') ADVANCE(122);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_Int16);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_Int32);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_Int64);
      END_STATE();
    case 102:
      if (lookahead == '6') ADVANCE(123);
      END_STATE();
    case 103:
      if (lookahead == '2') ADVANCE(124);
      END_STATE();
    case 104:
      if (lookahead == '4') ADVANCE(125);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_UInt8);
      END_STATE();
    case 106:
      if (lookahead == 'a') ADVANCE(126);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 108:
      if (lookahead == 'r') ADVANCE(127);
      END_STATE();
    case 109:
      if (lookahead == 'd') ADVANCE(128);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_group);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 113:
      if (lookahead == 'f') ADVANCE(130);
      END_STATE();
    case 114:
      if (lookahead == 'd') ADVANCE(131);
      END_STATE();
    case 115:
      if (lookahead == 'p') ADVANCE(132);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_param);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 120:
      if (lookahead == 'n') ADVANCE(134);
      END_STATE();
    case 121:
      if (lookahead == '2') ADVANCE(135);
      END_STATE();
    case 122:
      if (lookahead == '4') ADVANCE(136);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_UInt16);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_UInt32);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_UInt64);
      END_STATE();
    case 126:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 128:
      if (lookahead == 's') ADVANCE(139);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(140);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_method);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 134:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_Float32);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_Float64);
      END_STATE();
    case 137:
      if (lookahead == 'i') ADVANCE(143);
      END_STATE();
    case 138:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 140:
      if (lookahead == 'c') ADVANCE(145);
      END_STATE();
    case 141:
      if (lookahead == 'c') ADVANCE(146);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 143:
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(152);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(153);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_enumerant);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_AnyPointer);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_annotation);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 54},
  [2] = {.lex_state = 13},
  [3] = {.lex_state = 13},
  [4] = {.lex_state = 13},
  [5] = {.lex_state = 13},
  [6] = {.lex_state = 13},
  [7] = {.lex_state = 13},
  [8] = {.lex_state = 13},
  [9] = {.lex_state = 13},
  [10] = {.lex_state = 13},
  [11] = {.lex_state = 13},
  [12] = {.lex_state = 15},
  [13] = {.lex_state = 13},
  [14] = {.lex_state = 15},
  [15] = {.lex_state = 15},
  [16] = {.lex_state = 15},
  [17] = {.lex_state = 13},
  [18] = {.lex_state = 15},
  [19] = {.lex_state = 15},
  [20] = {.lex_state = 15},
  [21] = {.lex_state = 15},
  [22] = {.lex_state = 15},
  [23] = {.lex_state = 15},
  [24] = {.lex_state = 15},
  [25] = {.lex_state = 15},
  [26] = {.lex_state = 15},
  [27] = {.lex_state = 15},
  [28] = {.lex_state = 15},
  [29] = {.lex_state = 15},
  [30] = {.lex_state = 15},
  [31] = {.lex_state = 15},
  [32] = {.lex_state = 15},
  [33] = {.lex_state = 15},
  [34] = {.lex_state = 15},
  [35] = {.lex_state = 15},
  [36] = {.lex_state = 15},
  [37] = {.lex_state = 15},
  [38] = {.lex_state = 15},
  [39] = {.lex_state = 15},
  [40] = {.lex_state = 15},
  [41] = {.lex_state = 54},
  [42] = {.lex_state = 54},
  [43] = {.lex_state = 54},
  [44] = {.lex_state = 54},
  [45] = {.lex_state = 54},
  [46] = {.lex_state = 54},
  [47] = {.lex_state = 54},
  [48] = {.lex_state = 54},
  [49] = {.lex_state = 54},
  [50] = {.lex_state = 54},
  [51] = {.lex_state = 54},
  [52] = {.lex_state = 54},
  [53] = {.lex_state = 54},
  [54] = {.lex_state = 54},
  [55] = {.lex_state = 54},
  [56] = {.lex_state = 54},
  [57] = {.lex_state = 54},
  [58] = {.lex_state = 54},
  [59] = {.lex_state = 54},
  [60] = {.lex_state = 54},
  [61] = {.lex_state = 54},
  [62] = {.lex_state = 54},
  [63] = {.lex_state = 54},
  [64] = {.lex_state = 54},
  [65] = {.lex_state = 54},
  [66] = {.lex_state = 54},
  [67] = {.lex_state = 54},
  [68] = {.lex_state = 54},
  [69] = {.lex_state = 54},
  [70] = {.lex_state = 54},
  [71] = {.lex_state = 54},
  [72] = {.lex_state = 54},
  [73] = {.lex_state = 54},
  [74] = {.lex_state = 54},
  [75] = {.lex_state = 54},
  [76] = {.lex_state = 54},
  [77] = {.lex_state = 54},
  [78] = {.lex_state = 54},
  [79] = {.lex_state = 54},
  [80] = {.lex_state = 54},
  [81] = {.lex_state = 54},
  [82] = {.lex_state = 54},
  [83] = {.lex_state = 54},
  [84] = {.lex_state = 54},
  [85] = {.lex_state = 54},
  [86] = {.lex_state = 54},
  [87] = {.lex_state = 54},
  [88] = {.lex_state = 54},
  [89] = {.lex_state = 54},
  [90] = {.lex_state = 54},
  [91] = {.lex_state = 54},
  [92] = {.lex_state = 54},
  [93] = {.lex_state = 54},
  [94] = {.lex_state = 54},
  [95] = {.lex_state = 54},
  [96] = {.lex_state = 54},
  [97] = {.lex_state = 54},
  [98] = {.lex_state = 54},
  [99] = {.lex_state = 54},
  [100] = {.lex_state = 54},
  [101] = {.lex_state = 54},
  [102] = {.lex_state = 54},
  [103] = {.lex_state = 54},
  [104] = {.lex_state = 54},
  [105] = {.lex_state = 54},
  [106] = {.lex_state = 54},
  [107] = {.lex_state = 21},
  [108] = {.lex_state = 21},
  [109] = {.lex_state = 21},
  [110] = {.lex_state = 14},
  [111] = {.lex_state = 54},
  [112] = {.lex_state = 54},
  [113] = {.lex_state = 54},
  [114] = {.lex_state = 54},
  [115] = {.lex_state = 54},
  [116] = {.lex_state = 14},
  [117] = {.lex_state = 54},
  [118] = {.lex_state = 54},
  [119] = {.lex_state = 54},
  [120] = {.lex_state = 54},
  [121] = {.lex_state = 54},
  [122] = {.lex_state = 54},
  [123] = {.lex_state = 54},
  [124] = {.lex_state = 54},
  [125] = {.lex_state = 54},
  [126] = {.lex_state = 54},
  [127] = {.lex_state = 54},
  [128] = {.lex_state = 54},
  [129] = {.lex_state = 54},
  [130] = {.lex_state = 54},
  [131] = {.lex_state = 54},
  [132] = {.lex_state = 54},
  [133] = {.lex_state = 54},
  [134] = {.lex_state = 54},
  [135] = {.lex_state = 54},
  [136] = {.lex_state = 54},
  [137] = {.lex_state = 54},
  [138] = {.lex_state = 54},
  [139] = {.lex_state = 54},
  [140] = {.lex_state = 54},
  [141] = {.lex_state = 54},
  [142] = {.lex_state = 14},
  [143] = {.lex_state = 54},
  [144] = {.lex_state = 54},
  [145] = {.lex_state = 54},
  [146] = {.lex_state = 14},
  [147] = {.lex_state = 14},
  [148] = {.lex_state = 54},
  [149] = {.lex_state = 14},
  [150] = {.lex_state = 54},
  [151] = {.lex_state = 14},
  [152] = {.lex_state = 14},
  [153] = {.lex_state = 54},
  [154] = {.lex_state = 14},
  [155] = {.lex_state = 14},
  [156] = {.lex_state = 54},
  [157] = {.lex_state = 54},
  [158] = {.lex_state = 14},
  [159] = {.lex_state = 54},
  [160] = {.lex_state = 54},
  [161] = {.lex_state = 54},
  [162] = {.lex_state = 54},
  [163] = {.lex_state = 54},
  [164] = {.lex_state = 54},
  [165] = {.lex_state = 54},
  [166] = {.lex_state = 54},
  [167] = {.lex_state = 14},
  [168] = {.lex_state = 14},
  [169] = {.lex_state = 54},
  [170] = {.lex_state = 54},
  [171] = {.lex_state = 54},
  [172] = {.lex_state = 14},
  [173] = {.lex_state = 54},
  [174] = {.lex_state = 54},
  [175] = {.lex_state = 54},
  [176] = {.lex_state = 14},
  [177] = {.lex_state = 54},
  [178] = {.lex_state = 54},
  [179] = {.lex_state = 54},
  [180] = {.lex_state = 54},
  [181] = {.lex_state = 54},
  [182] = {.lex_state = 54},
  [183] = {.lex_state = 54},
  [184] = {.lex_state = 54},
  [185] = {.lex_state = 54},
  [186] = {.lex_state = 54},
  [187] = {.lex_state = 54},
  [188] = {.lex_state = 14},
  [189] = {.lex_state = 14},
  [190] = {.lex_state = 14},
  [191] = {.lex_state = 14},
  [192] = {.lex_state = 14},
  [193] = {.lex_state = 14},
  [194] = {.lex_state = 14},
  [195] = {.lex_state = 13},
  [196] = {.lex_state = 18},
  [197] = {.lex_state = 14},
  [198] = {.lex_state = 14},
  [199] = {.lex_state = 54},
  [200] = {.lex_state = 18},
  [201] = {.lex_state = 13},
  [202] = {.lex_state = 14},
  [203] = {.lex_state = 22},
  [204] = {.lex_state = 14},
  [205] = {.lex_state = 13},
  [206] = {.lex_state = 13},
  [207] = {.lex_state = 16},
  [208] = {.lex_state = 14},
  [209] = {.lex_state = 13},
  [210] = {.lex_state = 14},
  [211] = {.lex_state = 14},
  [212] = {.lex_state = 14},
  [213] = {.lex_state = 13},
  [214] = {.lex_state = 14},
  [215] = {.lex_state = 14},
  [216] = {.lex_state = 14},
  [217] = {.lex_state = 13},
  [218] = {.lex_state = 13},
  [219] = {.lex_state = 13},
  [220] = {.lex_state = 16},
  [221] = {.lex_state = 13},
  [222] = {.lex_state = 16},
  [223] = {.lex_state = 22},
  [224] = {.lex_state = 13},
  [225] = {.lex_state = 14},
  [226] = {.lex_state = 13},
  [227] = {.lex_state = 13},
  [228] = {.lex_state = 13},
  [229] = {.lex_state = 13},
  [230] = {.lex_state = 13},
  [231] = {.lex_state = 14},
  [232] = {.lex_state = 13},
  [233] = {.lex_state = 14},
  [234] = {.lex_state = 13},
  [235] = {.lex_state = 13},
  [236] = {.lex_state = 22},
  [237] = {.lex_state = 0},
  [238] = {.lex_state = 13},
  [239] = {.lex_state = 54},
  [240] = {.lex_state = 0},
  [241] = {.lex_state = 54},
  [242] = {.lex_state = 54},
  [243] = {.lex_state = 54},
  [244] = {.lex_state = 54},
  [245] = {.lex_state = 54},
  [246] = {.lex_state = 54},
  [247] = {.lex_state = 54},
  [248] = {.lex_state = 54},
  [249] = {.lex_state = 54},
  [250] = {.lex_state = 0},
  [251] = {.lex_state = 54},
  [252] = {.lex_state = 0},
  [253] = {.lex_state = 54},
  [254] = {.lex_state = 54},
  [255] = {.lex_state = 54},
  [256] = {.lex_state = 54},
  [257] = {.lex_state = 54},
  [258] = {.lex_state = 54},
  [259] = {.lex_state = 13},
  [260] = {.lex_state = 54},
  [261] = {.lex_state = 54},
  [262] = {.lex_state = 0},
  [263] = {.lex_state = 54},
  [264] = {.lex_state = 54},
  [265] = {.lex_state = 54},
  [266] = {.lex_state = 0},
  [267] = {.lex_state = 54},
  [268] = {.lex_state = 13},
  [269] = {.lex_state = 54},
  [270] = {.lex_state = 13},
  [271] = {.lex_state = 0},
  [272] = {.lex_state = 13},
  [273] = {.lex_state = 0},
  [274] = {.lex_state = 54},
  [275] = {.lex_state = 0},
  [276] = {.lex_state = 13},
  [277] = {.lex_state = 54},
  [278] = {.lex_state = 13},
  [279] = {.lex_state = 54},
  [280] = {.lex_state = 54},
  [281] = {.lex_state = 0},
  [282] = {.lex_state = 0},
  [283] = {.lex_state = 13},
  [284] = {.lex_state = 0},
  [285] = {.lex_state = 54},
  [286] = {.lex_state = 0},
  [287] = {.lex_state = 13},
  [288] = {.lex_state = 0},
  [289] = {.lex_state = 54},
  [290] = {.lex_state = 0},
  [291] = {.lex_state = 14},
  [292] = {.lex_state = 0},
  [293] = {.lex_state = 13},
  [294] = {.lex_state = 0},
  [295] = {.lex_state = 14},
  [296] = {.lex_state = 13},
  [297] = {.lex_state = 54},
  [298] = {.lex_state = 0},
  [299] = {.lex_state = 13},
  [300] = {.lex_state = 13},
  [301] = {.lex_state = 54},
  [302] = {.lex_state = 0},
  [303] = {.lex_state = 13},
  [304] = {.lex_state = 0},
  [305] = {.lex_state = 54},
  [306] = {.lex_state = 13},
  [307] = {.lex_state = 54},
  [308] = {.lex_state = 0},
  [309] = {.lex_state = 13},
  [310] = {.lex_state = 0},
  [311] = {.lex_state = 0},
  [312] = {.lex_state = 13},
  [313] = {.lex_state = 13},
  [314] = {.lex_state = 13},
  [315] = {.lex_state = 0},
  [316] = {.lex_state = 0},
  [317] = {.lex_state = 0},
  [318] = {.lex_state = 0},
  [319] = {.lex_state = 13},
  [320] = {.lex_state = 13},
  [321] = {.lex_state = 0},
  [322] = {.lex_state = 13},
  [323] = {.lex_state = 0},
  [324] = {.lex_state = 13},
  [325] = {.lex_state = 0},
  [326] = {.lex_state = 0},
  [327] = {.lex_state = 54},
  [328] = {.lex_state = 13},
  [329] = {.lex_state = 54},
  [330] = {.lex_state = 0},
  [331] = {.lex_state = 0},
  [332] = {.lex_state = 0},
  [333] = {.lex_state = 0},
  [334] = {.lex_state = 54},
  [335] = {.lex_state = 0},
  [336] = {.lex_state = 0},
  [337] = {.lex_state = 0},
  [338] = {.lex_state = 13},
  [339] = {.lex_state = 0},
  [340] = {.lex_state = 0},
  [341] = {.lex_state = 54},
  [342] = {.lex_state = 0},
  [343] = {.lex_state = 0},
  [344] = {.lex_state = 0},
  [345] = {.lex_state = 0},
  [346] = {.lex_state = 0},
  [347] = {.lex_state = 54},
  [348] = {.lex_state = 13},
  [349] = {.lex_state = 13},
  [350] = {.lex_state = 0},
  [351] = {.lex_state = 13},
  [352] = {.lex_state = 13},
  [353] = {.lex_state = 13},
  [354] = {.lex_state = 13},
  [355] = {.lex_state = 13},
  [356] = {.lex_state = 0},
  [357] = {.lex_state = 13},
  [358] = {.lex_state = 13},
  [359] = {.lex_state = 54},
  [360] = {.lex_state = 0},
  [361] = {.lex_state = 13},
  [362] = {.lex_state = 54},
  [363] = {.lex_state = 13},
  [364] = {.lex_state = 13},
  [365] = {.lex_state = 13},
  [366] = {.lex_state = 13},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 54},
  [369] = {.lex_state = 13},
  [370] = {.lex_state = 13},
  [371] = {.lex_state = 13},
  [372] = {.lex_state = 54},
  [373] = {.lex_state = 13},
  [374] = {.lex_state = 13},
  [375] = {.lex_state = 13},
  [376] = {.lex_state = 54},
  [377] = {.lex_state = 13},
  [378] = {.lex_state = 54},
  [379] = {.lex_state = 0},
  [380] = {.lex_state = 13},
  [381] = {.lex_state = 13},
  [382] = {.lex_state = 54},
  [383] = {.lex_state = 0},
  [384] = {.lex_state = 0},
  [385] = {.lex_state = 0},
  [386] = {.lex_state = 13},
  [387] = {.lex_state = 54},
  [388] = {.lex_state = 0},
  [389] = {.lex_state = 0},
  [390] = {.lex_state = 54},
  [391] = {.lex_state = 13},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 13},
  [394] = {.lex_state = 13},
  [395] = {.lex_state = 13},
  [396] = {.lex_state = 0},
  [397] = {.lex_state = 13},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 13},
  [400] = {.lex_state = 0},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 13},
  [403] = {.lex_state = 13},
  [404] = {.lex_state = 13},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 54},
  [408] = {.lex_state = 0},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 54},
  [411] = {.lex_state = 13},
  [412] = {.lex_state = 13},
  [413] = {.lex_state = 13},
  [414] = {.lex_state = 13},
  [415] = {.lex_state = 13},
  [416] = {.lex_state = 13},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 13},
  [419] = {.lex_state = 13},
  [420] = {.lex_state = 13},
  [421] = {.lex_state = 13},
  [422] = {.lex_state = 13},
  [423] = {.lex_state = 13},
  [424] = {.lex_state = 13},
  [425] = {.lex_state = 13},
  [426] = {.lex_state = 13},
  [427] = {.lex_state = 13},
  [428] = {.lex_state = 54},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 13},
  [431] = {.lex_state = 13},
  [432] = {.lex_state = 13},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 54},
  [435] = {.lex_state = 13},
  [436] = {.lex_state = 13},
  [437] = {.lex_state = 13},
  [438] = {.lex_state = 54},
  [439] = {.lex_state = 13},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 13},
  [442] = {.lex_state = 54},
  [443] = {.lex_state = 20},
  [444] = {.lex_state = 18},
  [445] = {.lex_state = 18},
  [446] = {.lex_state = 54},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 0},
  [451] = {.lex_state = 54},
  [452] = {.lex_state = 54},
  [453] = {.lex_state = 54},
  [454] = {.lex_state = 0},
  [455] = {.lex_state = 54},
  [456] = {.lex_state = 0},
  [457] = {.lex_state = 54},
  [458] = {.lex_state = 54},
  [459] = {.lex_state = 54},
  [460] = {.lex_state = 13},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 54},
  [463] = {.lex_state = 13},
  [464] = {.lex_state = 54},
  [465] = {.lex_state = 13},
  [466] = {.lex_state = 18},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 13},
  [469] = {.lex_state = 0},
  [470] = {.lex_state = 54},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 18},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 54},
  [476] = {.lex_state = 0},
  [477] = {.lex_state = 0},
  [478] = {.lex_state = 0},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 0},
  [481] = {.lex_state = 54},
  [482] = {.lex_state = 0},
  [483] = {.lex_state = 0},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 0},
  [486] = {.lex_state = 0},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 54},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 0},
  [493] = {.lex_state = 54},
  [494] = {.lex_state = 0},
  [495] = {.lex_state = 0},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 54},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 0},
  [504] = {.lex_state = 54},
  [505] = {.lex_state = 54},
  [506] = {.lex_state = 0},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 0},
  [509] = {.lex_state = 0},
  [510] = {.lex_state = 54},
  [511] = {.lex_state = 0},
  [512] = {.lex_state = 54},
  [513] = {.lex_state = 0},
  [514] = {.lex_state = 54},
  [515] = {.lex_state = 0},
  [516] = {.lex_state = 54},
  [517] = {.lex_state = 0},
  [518] = {.lex_state = 54},
  [519] = {.lex_state = 0},
  [520] = {.lex_state = 0},
  [521] = {.lex_state = 0},
  [522] = {.lex_state = 0},
  [523] = {.lex_state = 0},
  [524] = {.lex_state = 0},
  [525] = {.lex_state = 0},
  [526] = {.lex_state = 0},
  [527] = {.lex_state = 0},
  [528] = {.lex_state = 0},
  [529] = {.lex_state = 0},
  [530] = {.lex_state = 0},
  [531] = {.lex_state = 0},
  [532] = {.lex_state = 0},
  [533] = {.lex_state = 0},
  [534] = {.lex_state = 0},
  [535] = {.lex_state = 0},
  [536] = {.lex_state = 54},
  [537] = {.lex_state = 0},
  [538] = {.lex_state = 0},
  [539] = {.lex_state = 0},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 54},
  [543] = {.lex_state = 54},
  [544] = {.lex_state = 0},
  [545] = {.lex_state = 54},
  [546] = {.lex_state = 54},
  [547] = {.lex_state = 54},
  [548] = {.lex_state = 18},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 54},
  [552] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOLLARimport] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_annotation] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_enumerant] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_file] = ACTIONS(1),
    [anon_sym_method] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_group] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_AnyPointer] = ACTIONS(1),
    [anon_sym_Bool] = ACTIONS(1),
    [anon_sym_Int8] = ACTIONS(1),
    [anon_sym_Int16] = ACTIONS(1),
    [anon_sym_Int32] = ACTIONS(1),
    [anon_sym_Int64] = ACTIONS(1),
    [anon_sym_UInt8] = ACTIONS(1),
    [anon_sym_UInt16] = ACTIONS(1),
    [anon_sym_UInt32] = ACTIONS(1),
    [anon_sym_UInt64] = ACTIONS(1),
    [anon_sym_Float32] = ACTIONS(1),
    [anon_sym_Float64] = ACTIONS(1),
    [anon_sym_Text] = ACTIONS(1),
    [anon_sym_Data] = ACTIONS(1),
    [anon_sym_Void] = ACTIONS(1),
    [anon_sym_List] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym__normal_version] = ACTIONS(1),
    [aux_sym__inline_version_token1] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_0x] = ACTIONS(1),
    [sym_void] = ACTIONS(1),
    [anon_sym_embed] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_message] = STATE(540),
    [sym_statement] = STATE(51),
    [sym_unique_id_statement] = STATE(161),
    [sym_using_directive] = STATE(161),
    [sym_import] = STATE(161),
    [sym_top_level_annotation] = STATE(161),
    [sym_annotation] = STATE(161),
    [sym_definition] = STATE(161),
    [sym_struct] = STATE(160),
    [sym_enum] = STATE(160),
    [sym_interface] = STATE(160),
    [sym_const] = STATE(160),
    [aux_sym_message_repeat1] = STATE(51),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_unique_id] = ACTIONS(7),
    [anon_sym_using] = ACTIONS(9),
    [anon_sym_DOLLARimport] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_annotation] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_enum] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_struct] = ACTIONS(23),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_RPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(294), 1,
      sym_field_type,
    STATE(388), 1,
      sym_const_value,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(478), 1,
      sym_generic_parameters,
    STATE(488), 1,
      sym_annotation_array,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [102] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_RPAREN,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(281), 1,
      sym_const_value,
    STATE(343), 1,
      sym_annotation_array,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(434), 1,
      aux_sym_struct_shorthand_repeat1,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [176] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(59), 1,
      anon_sym_RPAREN,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(388), 1,
      sym_const_value,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(528), 1,
      sym_annotation_array,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [247] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_RPAREN,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(388), 1,
      sym_const_value,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(508), 1,
      sym_annotation_array,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [318] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_RPAREN,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(388), 1,
      sym_const_value,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(509), 1,
      sym_annotation_array,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [389] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(65), 1,
      anon_sym_RPAREN,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(388), 1,
      sym_const_value,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(486), 1,
      sym_annotation_array,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [460] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(67), 1,
      anon_sym_RPAREN,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(388), 1,
      sym_const_value,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(511), 1,
      sym_annotation_array,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [531] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(388), 1,
      sym_const_value,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(526), 1,
      sym_annotation_array,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [602] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(71), 1,
      sym_identifier,
    ACTIONS(73), 1,
      anon_sym_RBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(339), 1,
      sym_annotation_array,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(389), 2,
      sym__annotation_array_def,
      sym_const_value,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [671] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(59), 1,
      anon_sym_RPAREN,
    ACTIONS(75), 1,
      sym_identifier,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(388), 1,
      sym_const_value,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(528), 1,
      sym_annotation_array,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [742] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(367), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    ACTIONS(79), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [806] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(71), 1,
      sym_identifier,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(281), 1,
      sym_const_value,
    STATE(389), 1,
      sym__annotation_array_def,
    STATE(400), 1,
      sym_annotation_array,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [874] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(367), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    ACTIONS(83), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [938] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(87), 1,
      sym__identifier_no_period,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(301), 1,
      sym_const_value,
    STATE(368), 1,
      sym__same_scope_const_value,
    STATE(444), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1003] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(87), 1,
      sym__identifier_no_period,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(444), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(368), 2,
      sym_const_value,
      sym__same_scope_const_value,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1066] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(91), 1,
      anon_sym_RPAREN,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(266), 1,
      sym_string,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(93), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(490), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1128] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_RBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(367), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1190] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(73), 1,
      anon_sym_RBRACK,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(308), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1252] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    ACTIONS(97), 1,
      anon_sym_RBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(367), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1314] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(502), 1,
      sym_const_value,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1373] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(350), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1432] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    ACTIONS(87), 1,
      sym__identifier_no_period,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(329), 1,
      sym_const_value,
    STATE(444), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1491] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(456), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1550] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(472), 1,
      sym_const_value,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1609] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    STATE(523), 1,
      sym_const_value,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1668] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(332), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1727] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(310), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1786] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(406), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1845] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(436), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1904] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(318), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [1963] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(349), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [2022] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(447), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [2081] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(367), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [2140] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(304), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [2199] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(346), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [2258] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(408), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [2317] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(448), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [2376] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(449), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [2435] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_0x,
    ACTIONS(43), 1,
      anon_sym_embed,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    ACTIONS(51), 1,
      sym__identifier_no_period,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(147), 1,
      sym_string,
    STATE(190), 1,
      aux_sym_block_text_repeat2,
    STATE(393), 1,
      sym_const_value,
    STATE(466), 1,
      aux_sym__internal_const_identifier_repeat1,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(37), 3,
      sym_number,
      sym_float,
      sym_void,
    STATE(210), 8,
      sym_boolean,
      sym_data,
      sym_const_list,
      sym_struct_shorthand,
      sym__internal_const_identifier,
      sym_embedded_file,
      sym_concatenated_string,
      sym_block_text,
  [2494] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(101), 1,
      anon_sym_using,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(115), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(43), 3,
      sym_using_directive,
      sym_field,
      aux_sym_struct_repeat1,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [2549] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(101), 1,
      anon_sym_using,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(117), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(46), 3,
      sym_using_directive,
      sym_field,
      aux_sym_struct_repeat1,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [2604] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_identifier,
    ACTIONS(122), 1,
      anon_sym_using,
    ACTIONS(125), 1,
      anon_sym_annotation,
    ACTIONS(128), 1,
      anon_sym_const,
    ACTIONS(131), 1,
      anon_sym_enum,
    ACTIONS(134), 1,
      anon_sym_interface,
    ACTIONS(137), 1,
      anon_sym_struct,
    ACTIONS(140), 1,
      anon_sym_union,
    ACTIONS(143), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(43), 3,
      sym_using_directive,
      sym_field,
      aux_sym_struct_repeat1,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [2659] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(101), 1,
      anon_sym_using,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(115), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(47), 3,
      sym_using_directive,
      sym_field,
      aux_sym_struct_repeat1,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [2714] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(101), 1,
      anon_sym_using,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(145), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(49), 3,
      sym_using_directive,
      sym_field,
      aux_sym_struct_repeat1,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [2769] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(101), 1,
      anon_sym_using,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(147), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(43), 3,
      sym_using_directive,
      sym_field,
      aux_sym_struct_repeat1,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [2824] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(101), 1,
      anon_sym_using,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(117), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(43), 3,
      sym_using_directive,
      sym_field,
      aux_sym_struct_repeat1,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [2879] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(101), 1,
      anon_sym_using,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(149), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(41), 3,
      sym_using_directive,
      sym_field,
      aux_sym_struct_repeat1,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [2934] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(101), 1,
      anon_sym_using,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(149), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(43), 3,
      sym_using_directive,
      sym_field,
      aux_sym_struct_repeat1,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [2989] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    ACTIONS(153), 1,
      anon_sym_import,
    ACTIONS(155), 1,
      anon_sym_union,
    STATE(293), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3030] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_unique_id,
    ACTIONS(9), 1,
      anon_sym_using,
    ACTIONS(11), 1,
      anon_sym_DOLLARimport,
    ACTIONS(13), 1,
      anon_sym_DOLLAR,
    ACTIONS(15), 1,
      anon_sym_annotation,
    ACTIONS(17), 1,
      anon_sym_const,
    ACTIONS(19), 1,
      anon_sym_enum,
    ACTIONS(21), 1,
      anon_sym_interface,
    ACTIONS(23), 1,
      anon_sym_struct,
    ACTIONS(157), 1,
      ts_builtin_sym_end,
    STATE(52), 2,
      sym_statement,
      aux_sym_message_repeat1,
    STATE(160), 4,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_const,
    STATE(161), 6,
      sym_unique_id_statement,
      sym_using_directive,
      sym_import,
      sym_top_level_annotation,
      sym_annotation,
      sym_definition,
  [3082] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(159), 1,
      ts_builtin_sym_end,
    ACTIONS(161), 1,
      sym_unique_id,
    ACTIONS(164), 1,
      anon_sym_using,
    ACTIONS(167), 1,
      anon_sym_DOLLARimport,
    ACTIONS(170), 1,
      anon_sym_DOLLAR,
    ACTIONS(173), 1,
      anon_sym_annotation,
    ACTIONS(176), 1,
      anon_sym_const,
    ACTIONS(179), 1,
      anon_sym_enum,
    ACTIONS(182), 1,
      anon_sym_interface,
    ACTIONS(185), 1,
      anon_sym_struct,
    STATE(52), 2,
      sym_statement,
      aux_sym_message_repeat1,
    STATE(160), 4,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_const,
    STATE(161), 6,
      sym_unique_id_statement,
      sym_using_directive,
      sym_import,
      sym_top_level_annotation,
      sym_annotation,
      sym_definition,
  [3134] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    ACTIONS(155), 1,
      anon_sym_union,
    STATE(306), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3172] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(294), 1,
      sym_field_type,
    STATE(537), 1,
      sym_generic_parameters,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3210] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(294), 1,
      sym_field_type,
    STATE(478), 1,
      sym_generic_parameters,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3248] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(188), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(66), 2,
      sym_field,
      aux_sym_group_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [3299] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(482), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3334] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(190), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(59), 2,
      sym_field,
      aux_sym_group_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [3385] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(188), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(62), 2,
      sym_field,
      aux_sym_group_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [3436] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(403), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3471] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(306), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3506] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      sym_identifier,
    ACTIONS(195), 1,
      anon_sym_annotation,
    ACTIONS(198), 1,
      anon_sym_const,
    ACTIONS(201), 1,
      anon_sym_enum,
    ACTIONS(204), 1,
      anon_sym_interface,
    ACTIONS(207), 1,
      anon_sym_struct,
    ACTIONS(210), 1,
      anon_sym_union,
    ACTIONS(213), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(62), 2,
      sym_field,
      aux_sym_group_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [3557] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(268), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(439), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3627] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(383), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3662] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym_identifier,
    ACTIONS(103), 1,
      anon_sym_annotation,
    ACTIONS(105), 1,
      anon_sym_const,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(113), 1,
      anon_sym_union,
    ACTIONS(215), 1,
      anon_sym_RBRACE,
    STATE(177), 1,
      sym_struct,
    STATE(179), 1,
      sym_enum,
    STATE(62), 2,
      sym_field,
      aux_sym_group_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(165), 7,
      sym_annotation,
      sym_nested_struct,
      sym_nested_enum,
      sym_group,
      sym_union,
      sym_interface,
      sym_const,
  [3713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(496), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_List,
    ACTIONS(151), 1,
      sym_identifier,
    STATE(485), 1,
      sym_field_type,
    STATE(238), 3,
      sym_primitive_type,
      sym_list_type,
      sym_custom_type,
    ACTIONS(33), 15,
      anon_sym_AnyPointer,
      anon_sym_Bool,
      anon_sym_Int8,
      anon_sym_Int16,
      anon_sym_Int32,
      anon_sym_Int64,
      anon_sym_UInt8,
      anon_sym_UInt16,
      anon_sym_UInt32,
      anon_sym_UInt64,
      anon_sym_Float32,
      anon_sym_Float64,
      anon_sym_Text,
      anon_sym_Data,
      anon_sym_Void,
  [3783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_enum,
    STATE(471), 1,
      sym_annotation_target,
    ACTIONS(217), 12,
      anon_sym_annotation,
      anon_sym_STAR,
      anon_sym_const,
      anon_sym_enumerant,
      anon_sym_field,
      anon_sym_file,
      anon_sym_method,
      anon_sym_param,
      anon_sym_group,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
  [3807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_enum,
    STATE(396), 1,
      sym_annotation_target,
    ACTIONS(217), 12,
      anon_sym_annotation,
      anon_sym_STAR,
      anon_sym_const,
      anon_sym_enumerant,
      anon_sym_field,
      anon_sym_file,
      anon_sym_method,
      anon_sym_param,
      anon_sym_group,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
  [3831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(223), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [3852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(227), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [3873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(231), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [3894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(235), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [3915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(239), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [3936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(241), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(243), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [3957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(247), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [3978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(249), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(251), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [3999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(255), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(257), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(259), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(261), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(263), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(265), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(267), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(271), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(275), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(277), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(279), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(281), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(283), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(285), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(287), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(291), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(295), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(299), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(301), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(303), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(305), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(307), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(311), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(313), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(315), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(319), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(323), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(325), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(327), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(329), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(331), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(333), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(335), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(337), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(339), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(341), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(343), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(345), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(347), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(349), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(351), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(355), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(357), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(359), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 4,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_DOLLARimport,
      anon_sym_RBRACE,
    ACTIONS(363), 9,
      anon_sym_using,
      anon_sym_DOLLAR,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [4587] = 5,
    ACTIONS(367), 1,
      sym_unescaped_block_string_fragment,
    ACTIONS(371), 1,
      sym_comment,
    ACTIONS(369), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(109), 2,
      sym__escape_sequence,
      aux_sym_block_text_repeat1,
    ACTIONS(365), 7,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_BQUOTE,
      sym_identifier,
  [4611] = 5,
    ACTIONS(371), 1,
      sym_comment,
    ACTIONS(375), 1,
      sym_unescaped_block_string_fragment,
    ACTIONS(378), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(108), 2,
      sym__escape_sequence,
      aux_sym_block_text_repeat1,
    ACTIONS(373), 7,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_BQUOTE,
      sym_identifier,
  [4635] = 5,
    ACTIONS(371), 1,
      sym_comment,
    ACTIONS(383), 1,
      sym_unescaped_block_string_fragment,
    ACTIONS(385), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(108), 2,
      sym__escape_sequence,
      aux_sym_block_text_repeat1,
    ACTIONS(381), 7,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_BQUOTE,
      sym_identifier,
  [4659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(387), 12,
      sym_unique_id,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_extends,
      anon_sym_DASH_GT,
  [4677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(391), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(133), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4706] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(130), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4735] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(395), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4764] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(121), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4793] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(399), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4822] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_DOT,
    ACTIONS(405), 1,
      anon_sym_LPAREN,
    STATE(152), 1,
      sym_generics,
    STATE(155), 1,
      aux_sym__annotation_call_repeat1,
    STATE(224), 1,
      sym_annotation_literal,
    ACTIONS(401), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [4849] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4878] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(119), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4907] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(409), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4936] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(411), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(137), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(411), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [4994] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(399), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(135), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5023] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(391), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5052] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(413), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(128), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5081] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(415), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(129), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5110] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(415), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5139] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(417), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(115), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5168] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(419), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5197] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(421), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5226] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(423), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5255] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(423), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(126), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5284] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(425), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(123), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5313] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(427), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5342] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(427), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(113), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5371] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5400] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(431), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_enum,
    ACTIONS(437), 1,
      anon_sym_interface,
    ACTIONS(440), 1,
      anon_sym_struct,
    ACTIONS(443), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5429] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(413), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(136), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5458] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_enum,
    ACTIONS(109), 1,
      anon_sym_interface,
    ACTIONS(111), 1,
      anon_sym_struct,
    ACTIONS(389), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym__method_identifier,
    STATE(117), 5,
      sym_struct,
      sym_enum,
      sym_interface,
      sym_method,
      aux_sym_interface_repeat1,
  [5487] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_union,
    ACTIONS(449), 1,
      anon_sym_RBRACE,
    STATE(376), 1,
      sym_union,
    STATE(150), 2,
      sym_union_field,
      aux_sym__unnamed_union_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(378), 2,
      sym_group,
      sym_nested_union,
  [5515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(453), 1,
      anon_sym_DOLLAR,
    ACTIONS(451), 9,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_using,
      anon_sym_DOLLARimport,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
  [5533] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_union,
    ACTIONS(449), 1,
      anon_sym_RBRACE,
    STATE(376), 1,
      sym_union,
    STATE(153), 2,
      sym_union_field,
      aux_sym__unnamed_union_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(378), 2,
      sym_group,
      sym_nested_union,
  [5561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(457), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      anon_sym_SQUOTE,
    STATE(142), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(455), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [5583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_DOLLAR,
    ACTIONS(463), 9,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_using,
      anon_sym_DOLLARimport,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
  [5601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_DOLLAR,
    ACTIONS(467), 9,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_using,
      anon_sym_DOLLARimport,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
  [5619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_union,
    ACTIONS(471), 1,
      anon_sym_RBRACE,
    STATE(376), 1,
      sym_union,
    STATE(157), 2,
      sym_union_field,
      aux_sym__unnamed_union_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(378), 2,
      sym_group,
      sym_nested_union,
  [5647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    STATE(142), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(473), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [5669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    STATE(146), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(475), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [5691] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_union,
    ACTIONS(477), 1,
      anon_sym_RBRACE,
    STATE(376), 1,
      sym_union,
    STATE(156), 2,
      sym_union_field,
      aux_sym__unnamed_union_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(378), 2,
      sym_group,
      sym_nested_union,
  [5719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_DOT,
    ACTIONS(481), 1,
      anon_sym_LPAREN,
    STATE(168), 1,
      aux_sym__annotation_call_repeat1,
    STATE(201), 1,
      sym_annotation_literal,
    ACTIONS(479), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [5743] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(483), 1,
      sym_identifier,
    ACTIONS(486), 1,
      anon_sym_union,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    STATE(376), 1,
      sym_union,
    STATE(150), 2,
      sym_union_field,
      aux_sym__unnamed_union_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(378), 2,
      sym_group,
      sym_nested_union,
  [5771] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_DOT,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    STATE(168), 1,
      aux_sym__annotation_call_repeat1,
    STATE(235), 1,
      sym_annotation_literal,
    ACTIONS(491), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [5795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_DOT,
    ACTIONS(497), 1,
      anon_sym_LPAREN,
    STATE(151), 1,
      aux_sym__annotation_call_repeat1,
    STATE(228), 1,
      sym_annotation_literal,
    ACTIONS(495), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [5819] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_union,
    ACTIONS(477), 1,
      anon_sym_RBRACE,
    STATE(376), 1,
      sym_union,
    STATE(150), 2,
      sym_union_field,
      aux_sym__unnamed_union_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(378), 2,
      sym_group,
      sym_nested_union,
  [5847] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DOT,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    STATE(192), 1,
      aux_sym_custom_type_repeat1,
    STATE(193), 1,
      sym_generics,
    ACTIONS(499), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [5871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_DOT,
    ACTIONS(505), 1,
      anon_sym_LPAREN,
    STATE(168), 1,
      aux_sym__annotation_call_repeat1,
    STATE(228), 1,
      sym_annotation_literal,
    ACTIONS(495), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [5895] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_union,
    ACTIONS(507), 1,
      anon_sym_RBRACE,
    STATE(376), 1,
      sym_union,
    STATE(150), 2,
      sym_union_field,
      aux_sym__unnamed_union_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(378), 2,
      sym_group,
      sym_nested_union,
  [5923] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_union,
    ACTIONS(509), 1,
      anon_sym_RBRACE,
    STATE(376), 1,
      sym_union,
    STATE(150), 2,
      sym_union_field,
      aux_sym__unnamed_union_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(378), 2,
      sym_group,
      sym_nested_union,
  [5951] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_DOT,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    STATE(168), 1,
      aux_sym__annotation_call_repeat1,
    STATE(209), 1,
      sym_annotation_literal,
    ACTIONS(511), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [5975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 1,
      anon_sym_DOLLAR,
    ACTIONS(515), 9,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_using,
      anon_sym_DOLLARimport,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
  [5993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_DOLLAR,
    ACTIONS(519), 9,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_using,
      anon_sym_DOLLARimport,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
  [6011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_DOLLAR,
    ACTIONS(523), 9,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_using,
      anon_sym_DOLLARimport,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
  [6029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DOLLAR,
    ACTIONS(527), 9,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_using,
      anon_sym_DOLLARimport,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
  [6047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_DOLLAR,
    ACTIONS(531), 9,
      ts_builtin_sym_end,
      sym_unique_id,
      anon_sym_using,
      anon_sym_DOLLARimport,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
  [6065] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_union,
    ACTIONS(535), 1,
      anon_sym_RBRACE,
    STATE(376), 1,
      sym_union,
    STATE(139), 2,
      sym_union_field,
      aux_sym__unnamed_union_repeat1,
    STATE(182), 2,
      sym__unnamed_union,
      sym__named_union,
    STATE(378), 2,
      sym_group,
      sym_nested_union,
  [6093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(537), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_RBRACE,
    ACTIONS(541), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    STATE(197), 1,
      sym_generics,
    ACTIONS(545), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [6146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 1,
      anon_sym_DOT,
    STATE(168), 1,
      aux_sym__annotation_call_repeat1,
    ACTIONS(547), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [6165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(554), 1,
      anon_sym_RBRACE,
    ACTIONS(552), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 1,
      anon_sym_RBRACE,
    ACTIONS(556), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(562), 1,
      anon_sym_RBRACE,
    ACTIONS(560), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(564), 9,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_identifier,
  [6231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_RBRACE,
    ACTIONS(566), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_RBRACE,
    ACTIONS(570), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_RBRACE,
    ACTIONS(574), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(578), 9,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_identifier,
  [6297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(582), 1,
      anon_sym_RBRACE,
    ACTIONS(580), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(586), 1,
      anon_sym_RBRACE,
    ACTIONS(584), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 1,
      anon_sym_RBRACE,
    ACTIONS(588), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_RBRACE,
    ACTIONS(592), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_RBRACE,
    ACTIONS(596), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(602), 1,
      anon_sym_RBRACE,
    ACTIONS(600), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_RBRACE,
    ACTIONS(604), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(610), 1,
      anon_sym_RBRACE,
    ACTIONS(608), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(614), 1,
      anon_sym_RBRACE,
    ACTIONS(612), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(618), 1,
      anon_sym_RBRACE,
    ACTIONS(616), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      anon_sym_RBRACE,
    ACTIONS(620), 8,
      anon_sym_using,
      anon_sym_annotation,
      anon_sym_const,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [6484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      anon_sym_DOT,
    STATE(188), 1,
      aux_sym_custom_type_repeat1,
    ACTIONS(624), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [6502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DOT,
    STATE(188), 1,
      aux_sym_custom_type_repeat1,
    ACTIONS(629), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [6520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_BQUOTE,
    STATE(194), 1,
      aux_sym_block_text_repeat2,
    ACTIONS(631), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [6538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(633), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [6552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DOT,
    STATE(188), 1,
      aux_sym_custom_type_repeat1,
    ACTIONS(635), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [6570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DOT,
    STATE(189), 1,
      aux_sym_custom_type_repeat1,
    ACTIONS(635), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [6588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 1,
      anon_sym_BQUOTE,
    STATE(194), 1,
      aux_sym_block_text_repeat2,
    ACTIONS(637), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [6606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_DOLLAR,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(642), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [6623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 1,
      anon_sym_DOT,
    ACTIONS(651), 1,
      sym__identifier_no_period,
    ACTIONS(647), 5,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [6640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [6653] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(655), 1,
      sym_unique_id,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(661), 1,
      anon_sym_extends,
    STATE(295), 1,
      sym_generics,
    STATE(361), 1,
      aux_sym_annotation_repeat1,
  [6678] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DOT,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(663), 1,
      anon_sym_EQ,
    STATE(192), 1,
      aux_sym_custom_type_repeat1,
    STATE(193), 1,
      sym_generics,
    ACTIONS(499), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [6701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 1,
      anon_sym_DOT,
    ACTIONS(651), 1,
      sym__identifier_no_period,
    ACTIONS(665), 5,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [6718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [6730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [6742] = 5,
    ACTIONS(371), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_SQUOTE,
    ACTIONS(673), 1,
      sym_unescaped_single_string_fragment,
    ACTIONS(675), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(236), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [6760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [6772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [6784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(681), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [6796] = 5,
    ACTIONS(371), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_DQUOTE,
    ACTIONS(683), 1,
      sym_unescaped_double_string_fragment,
    ACTIONS(685), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(220), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [6814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 6,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_COLON,
      anon_sym_LBRACK,
      sym_identifier,
  [6826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [6838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [6850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [6862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [6874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [6886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [6898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [6910] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(699), 1,
      anon_sym_LBRACE,
    ACTIONS(701), 1,
      anon_sym_extends,
    STATE(291), 1,
      sym_generics,
    STATE(412), 1,
      aux_sym_annotation_repeat1,
  [6932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [6944] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(705), 1,
      anon_sym_SEMI,
    ACTIONS(707), 1,
      anon_sym_DASH_GT,
    STATE(270), 1,
      sym_generics,
    STATE(375), 1,
      aux_sym_annotation_repeat1,
  [6966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [6978] = 5,
    ACTIONS(371), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_DQUOTE,
    ACTIONS(713), 1,
      sym_unescaped_double_string_fragment,
    ACTIONS(716), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(220), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [6996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(719), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [7008] = 5,
    ACTIONS(371), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_DQUOTE,
    ACTIONS(723), 1,
      sym_unescaped_double_string_fragment,
    ACTIONS(725), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(207), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [7026] = 5,
    ACTIONS(371), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_SQUOTE,
    ACTIONS(727), 1,
      sym_unescaped_single_string_fragment,
    ACTIONS(729), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(203), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [7044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [7056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(731), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [7068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(733), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [7080] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(735), 1,
      sym_unique_id,
    ACTIONS(737), 1,
      anon_sym_LBRACE,
    STATE(287), 1,
      sym_generics,
    STATE(371), 1,
      aux_sym_annotation_repeat1,
  [7102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(491), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [7114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [7126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(741), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [7138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [7150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(511), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [7162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [7174] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(747), 1,
      anon_sym_SEMI,
    ACTIONS(749), 1,
      anon_sym_DASH_GT,
    STATE(299), 1,
      sym_generics,
    STATE(314), 1,
      aux_sym_annotation_repeat1,
  [7196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [7208] = 5,
    ACTIONS(371), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_SQUOTE,
    ACTIONS(755), 1,
      sym_unescaped_single_string_fragment,
    ACTIONS(758), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(236), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [7226] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(761), 1,
      anon_sym_EQ,
    ACTIONS(763), 1,
      anon_sym_RPAREN,
    ACTIONS(765), 1,
      anon_sym_COMMA,
    STATE(284), 1,
      sym_generics,
    STATE(336), 1,
      aux_sym_named_return_type_repeat1,
  [7248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(767), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [7260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_LPAREN,
    STATE(272), 1,
      sym_unnamed_return_type,
    STATE(370), 1,
      sym_return_type,
    STATE(465), 1,
      sym_named_return_types,
  [7279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(773), 1,
      anon_sym_EQ,
    STATE(311), 1,
      sym_generics,
    ACTIONS(775), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [7296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_RBRACE,
    ACTIONS(777), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_RBRACE,
    ACTIONS(781), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 1,
      anon_sym_DOT,
    ACTIONS(785), 1,
      sym__identifier_no_period,
    ACTIONS(647), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym_identifier,
  [7337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 1,
      anon_sym_DOT,
    ACTIONS(785), 1,
      sym__identifier_no_period,
    ACTIONS(665), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym_identifier,
  [7352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(789), 1,
      anon_sym_RBRACE,
    ACTIONS(787), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(793), 1,
      anon_sym_RBRACE,
    ACTIONS(791), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_RBRACE,
    ACTIONS(795), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_RBRACE,
    ACTIONS(799), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(805), 1,
      anon_sym_RBRACE,
    ACTIONS(803), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7417] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      sym__normal_version,
    ACTIONS(811), 1,
      aux_sym__inline_version_token1,
    STATE(208), 1,
      sym__inline_version,
    STATE(539), 1,
      sym_field_version,
  [7436] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(813), 1,
      sym_identifier,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_LBRACK,
    STATE(278), 1,
      sym_method_parameters,
    STATE(382), 1,
      sym_implicit_generics,
  [7455] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      sym__normal_version,
    ACTIONS(811), 1,
      aux_sym__inline_version_token1,
    ACTIONS(819), 1,
      anon_sym_COLON,
    STATE(208), 1,
      sym__inline_version,
    STATE(538), 1,
      sym_field_version,
  [7474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_LPAREN,
    STATE(272), 1,
      sym_unnamed_return_type,
    STATE(309), 1,
      sym_return_type,
    STATE(465), 1,
      sym_named_return_types,
  [7493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(823), 1,
      anon_sym_RBRACE,
    ACTIONS(821), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(827), 1,
      anon_sym_RBRACE,
    ACTIONS(825), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7519] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_LPAREN,
    STATE(272), 1,
      sym_unnamed_return_type,
    STATE(427), 1,
      sym_return_type,
    STATE(465), 1,
      sym_named_return_types,
  [7538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(831), 1,
      anon_sym_RBRACE,
    ACTIONS(829), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(835), 1,
      anon_sym_RBRACE,
    ACTIONS(833), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(837), 1,
      anon_sym_EQ,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(839), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [7581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(843), 1,
      anon_sym_RBRACE,
    ACTIONS(841), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_LPAREN,
    STATE(272), 1,
      sym_unnamed_return_type,
    STATE(424), 1,
      sym_return_type,
    STATE(465), 1,
      sym_named_return_types,
  [7613] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      sym__normal_version,
    ACTIONS(811), 1,
      aux_sym__inline_version_token1,
    ACTIONS(819), 1,
      anon_sym_COLON,
    STATE(208), 1,
      sym__inline_version,
    STATE(495), 1,
      sym_field_version,
  [7632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_RBRACE,
    ACTIONS(845), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7645] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_LPAREN,
    STATE(272), 1,
      sym_unnamed_return_type,
    STATE(364), 1,
      sym_return_type,
    STATE(465), 1,
      sym_named_return_types,
  [7664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_LPAREN,
    STATE(272), 1,
      sym_unnamed_return_type,
    STATE(416), 1,
      sym_return_type,
    STATE(465), 1,
      sym_named_return_types,
  [7683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(849), 1,
      anon_sym_RPAREN,
    STATE(146), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
  [7700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(853), 1,
      anon_sym_RBRACE,
    ACTIONS(851), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(855), 1,
      anon_sym_EQ,
    STATE(259), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(857), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [7730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 1,
      anon_sym_RBRACE,
    ACTIONS(859), 4,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_struct,
      sym_identifier,
  [7743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(863), 1,
      anon_sym_SEMI,
    ACTIONS(865), 1,
      anon_sym_DASH_GT,
    STATE(430), 1,
      aux_sym_annotation_repeat1,
  [7759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_COMMA,
    STATE(271), 1,
      aux_sym__annotation_array_def_repeat2,
    ACTIONS(867), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [7773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    STATE(460), 1,
      sym_generics,
    ACTIONS(872), 2,
      anon_sym_SEMI,
      anon_sym_DOLLAR,
  [7787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(876), 1,
      anon_sym_COMMA,
    STATE(282), 1,
      aux_sym_generic_parameters_repeat1,
    ACTIONS(874), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [7801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(878), 1,
      sym_identifier,
    ACTIONS(881), 1,
      anon_sym_RBRACE,
    STATE(274), 2,
      sym_enum_field,
      aux_sym_enum_repeat1,
  [7815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(885), 1,
      anon_sym_COMMA,
    STATE(275), 1,
      aux_sym__annotation_array_def_repeat1,
    ACTIONS(883), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [7829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(888), 1,
      anon_sym_SEMI,
    ACTIONS(890), 1,
      anon_sym_COLON,
    STATE(437), 1,
      aux_sym_annotation_repeat1,
  [7845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_RBRACE,
    STATE(274), 2,
      sym_enum_field,
      aux_sym_enum_repeat1,
  [7859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(896), 1,
      anon_sym_SEMI,
    ACTIONS(898), 1,
      anon_sym_DASH_GT,
    STATE(319), 1,
      aux_sym_annotation_repeat1,
  [7875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 1,
      sym_identifier,
    ACTIONS(902), 1,
      anon_sym_RPAREN,
    STATE(317), 1,
      sym_parameter,
    STATE(541), 1,
      sym_parameters,
  [7891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(904), 1,
      sym_identifier,
    ACTIONS(906), 1,
      anon_sym_import,
    STATE(530), 2,
      sym_replace_using,
      sym_import_using,
  [7905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(910), 1,
      anon_sym_COMMA,
    STATE(288), 1,
      aux_sym__annotation_array_def_repeat2,
    ACTIONS(908), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [7919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(914), 1,
      anon_sym_COMMA,
    STATE(282), 1,
      aux_sym_generic_parameters_repeat1,
    ACTIONS(912), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [7933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(917), 1,
      anon_sym_SEMI,
    ACTIONS(919), 1,
      anon_sym_EQ,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [7949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_COMMA,
    ACTIONS(921), 1,
      anon_sym_EQ,
    ACTIONS(923), 1,
      anon_sym_RPAREN,
    STATE(331), 1,
      aux_sym_named_return_type_repeat1,
  [7965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(925), 1,
      anon_sym_RBRACE,
    STATE(277), 2,
      sym_enum_field,
      aux_sym_enum_repeat1,
  [7979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      sym__normal_version,
    ACTIONS(811), 1,
      aux_sym__inline_version_token1,
    STATE(208), 1,
      sym__inline_version,
    STATE(435), 1,
      sym_field_version,
  [7995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(927), 1,
      sym_unique_id,
    ACTIONS(929), 1,
      anon_sym_LBRACE,
    STATE(420), 1,
      aux_sym_annotation_repeat1,
  [8011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(271), 1,
      aux_sym__annotation_array_def_repeat2,
    ACTIONS(79), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [8023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(925), 1,
      anon_sym_RBRACE,
    STATE(274), 2,
      sym_enum_field,
      aux_sym_enum_repeat1,
  [8037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(275), 1,
      aux_sym__annotation_array_def_repeat1,
    ACTIONS(931), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [8049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(933), 1,
      anon_sym_LBRACE,
    ACTIONS(935), 1,
      anon_sym_extends,
    STATE(432), 1,
      aux_sym_annotation_repeat1,
  [8065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(937), 1,
      anon_sym_LPAREN,
    STATE(453), 1,
      sym_string,
  [8081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(939), 1,
      anon_sym_SEMI,
    ACTIONS(941), 1,
      anon_sym_EQ,
    STATE(394), 1,
      aux_sym_annotation_repeat1,
  [8097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(876), 1,
      anon_sym_COMMA,
    STATE(273), 1,
      aux_sym_generic_parameters_repeat1,
    ACTIONS(943), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [8111] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(699), 1,
      anon_sym_LBRACE,
    ACTIONS(701), 1,
      anon_sym_extends,
    STATE(412), 1,
      aux_sym_annotation_repeat1,
  [8127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(945), 1,
      sym_unique_id,
    ACTIONS(947), 1,
      anon_sym_LBRACE,
    STATE(357), 1,
      aux_sym_annotation_repeat1,
  [8143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(949), 1,
      anon_sym_RBRACE,
    STATE(274), 2,
      sym_enum_field,
      aux_sym_enum_repeat1,
  [8157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      sym__normal_version,
    ACTIONS(811), 1,
      aux_sym__inline_version_token1,
    STATE(208), 1,
      sym__inline_version,
    STATE(251), 1,
      sym_field_version,
  [8173] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(951), 1,
      anon_sym_SEMI,
    ACTIONS(953), 1,
      anon_sym_DASH_GT,
    STATE(369), 1,
      aux_sym_annotation_repeat1,
  [8189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(955), 1,
      anon_sym_SEMI,
    ACTIONS(957), 1,
      anon_sym_COLON,
    STATE(402), 1,
      aux_sym_annotation_repeat1,
  [8205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(959), 1,
      sym_identifier,
    STATE(290), 1,
      aux_sym__annotation_array_def_repeat1,
    ACTIONS(961), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [8219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(965), 1,
      anon_sym_COMMA,
    STATE(302), 1,
      aux_sym_annotation_array_repeat1,
    ACTIONS(963), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [8233] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(968), 1,
      anon_sym_SEMI,
    ACTIONS(970), 1,
      anon_sym_DASH_GT,
    STATE(377), 1,
      aux_sym_annotation_repeat1,
  [8249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_COMMA,
    STATE(290), 1,
      aux_sym__annotation_array_def_repeat1,
    ACTIONS(961), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [8263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_RBRACE,
    STATE(289), 2,
      sym_enum_field,
      aux_sym_enum_repeat1,
  [8277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(976), 1,
      anon_sym_SEMI,
    ACTIONS(978), 1,
      anon_sym_EQ,
    STATE(283), 1,
      aux_sym_annotation_repeat1,
  [8293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_RBRACE,
    STATE(297), 2,
      sym_enum_field,
      aux_sym_enum_repeat1,
  [8307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 1,
      anon_sym_COMMA,
    ACTIONS(982), 1,
      anon_sym_RBRACK,
    STATE(409), 1,
      aux_sym__annotation_array_def_repeat2,
  [8320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(984), 1,
      anon_sym_SEMI,
    STATE(415), 1,
      aux_sym_annotation_repeat1,
  [8333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_RPAREN,
    ACTIONS(972), 1,
      anon_sym_COMMA,
    STATE(405), 1,
      aux_sym__annotation_array_def_repeat1,
  [8346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(986), 1,
      anon_sym_EQ,
    ACTIONS(988), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [8357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(990), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(990), 1,
      anon_sym_LBRACE,
    STATE(381), 1,
      aux_sym_annotation_repeat1,
  [8383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(951), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_COMMA,
    ACTIONS(992), 1,
      anon_sym_RPAREN,
    STATE(330), 1,
      aux_sym_named_return_type_repeat1,
  [8409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    STATE(347), 1,
      sym_string,
  [8422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(994), 1,
      anon_sym_RPAREN,
    ACTIONS(996), 1,
      anon_sym_COMMA,
    STATE(360), 1,
      aux_sym_parameters_repeat1,
  [8435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_COMMA,
    ACTIONS(998), 1,
      anon_sym_RPAREN,
    STATE(315), 1,
      aux_sym_named_return_type_repeat1,
  [8448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(968), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1000), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    STATE(533), 1,
      sym_string,
  [8487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1002), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    STATE(390), 1,
      sym_string,
  [8513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1002), 1,
      anon_sym_LBRACE,
    STATE(391), 1,
      aux_sym_annotation_repeat1,
  [8526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(1004), 1,
      anon_sym_RPAREN,
    STATE(506), 1,
      sym_generics,
  [8539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_COMMA,
    ACTIONS(998), 1,
      anon_sym_RPAREN,
    STATE(330), 1,
      aux_sym_named_return_type_repeat1,
  [8552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1008), 1,
      anon_sym_RBRACE,
    ACTIONS(1006), 2,
      anon_sym_union,
      sym_identifier,
  [8563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    STATE(352), 1,
      aux_sym_annotation_repeat1,
  [8576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1012), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym_identifier,
  [8585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_RPAREN,
    ACTIONS(1016), 1,
      anon_sym_COMMA,
    STATE(330), 1,
      aux_sym_named_return_type_repeat1,
  [8598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_COMMA,
    ACTIONS(1019), 1,
      anon_sym_RPAREN,
    STATE(330), 1,
      aux_sym_named_return_type_repeat1,
  [8611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_COMMA,
    ACTIONS(1019), 1,
      anon_sym_RPAREN,
    STATE(326), 1,
      aux_sym_named_return_type_repeat1,
  [8624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    STATE(513), 1,
      sym_string,
  [8637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 1,
      anon_sym_RBRACE,
    ACTIONS(1021), 2,
      anon_sym_union,
      sym_identifier,
  [8648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      anon_sym_RPAREN,
    ACTIONS(1027), 1,
      anon_sym_COMMA,
    STATE(335), 1,
      aux_sym_top_level_annotation_body_repeat1,
  [8661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_COMMA,
    ACTIONS(923), 1,
      anon_sym_RPAREN,
    STATE(330), 1,
      aux_sym_named_return_type_repeat1,
  [8674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    ACTIONS(1030), 1,
      anon_sym_COMMA,
    STATE(271), 1,
      aux_sym__annotation_array_def_repeat2,
  [8687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1032), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 1,
      anon_sym_COMMA,
    ACTIONS(1036), 1,
      anon_sym_RBRACK,
    STATE(344), 1,
      aux_sym_annotation_array_repeat1,
  [8713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [8722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 1,
      sym_unique_id,
    ACTIONS(1042), 1,
      anon_sym_LPAREN,
    STATE(300), 1,
      sym_annotation_targets,
  [8735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 1,
      anon_sym_COMMA,
    ACTIONS(1044), 1,
      anon_sym_RPAREN,
    STATE(302), 1,
      aux_sym_annotation_array_repeat1,
  [8748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 1,
      anon_sym_COMMA,
    ACTIONS(1036), 1,
      anon_sym_RPAREN,
    STATE(342), 1,
      aux_sym_annotation_array_repeat1,
  [8761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 1,
      anon_sym_COMMA,
    ACTIONS(1044), 1,
      anon_sym_RBRACK,
    STATE(302), 1,
      aux_sym_annotation_array_repeat1,
  [8774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(271), 1,
      aux_sym__annotation_array_def_repeat2,
    ACTIONS(79), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [8785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_RPAREN,
    ACTIONS(972), 1,
      anon_sym_COMMA,
    STATE(405), 1,
      aux_sym__annotation_array_def_repeat1,
  [8798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1046), 1,
      anon_sym_SEMI,
    ACTIONS(1048), 1,
      anon_sym_DOT,
    STATE(372), 1,
      aux_sym_import_using_repeat1,
  [8811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1050), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1050), 1,
      anon_sym_SEMI,
    STATE(338), 1,
      aux_sym_annotation_repeat1,
  [8837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [8846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1054), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1056), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1056), 1,
      anon_sym_LBRACE,
    STATE(411), 1,
      aux_sym_annotation_repeat1,
  [8885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1058), 1,
      anon_sym_LBRACE,
    STATE(413), 1,
      aux_sym_annotation_repeat1,
  [8898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1060), 1,
      anon_sym_LBRACE,
    STATE(404), 1,
      aux_sym_annotation_repeat1,
  [8911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1062), 1,
      anon_sym_RPAREN,
    ACTIONS(1064), 1,
      anon_sym_COMMA,
    STATE(335), 1,
      aux_sym_top_level_annotation_body_repeat1,
  [8924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1060), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 3,
      anon_sym_SEMI,
      anon_sym_DOLLAR,
      anon_sym_DASH_GT,
  [8946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1070), 1,
      anon_sym_RBRACE,
    ACTIONS(1068), 2,
      anon_sym_union,
      sym_identifier,
  [8957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 1,
      anon_sym_COMMA,
    ACTIONS(1072), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      aux_sym_parameters_repeat1,
  [8970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(699), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [8983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      sym_identifier,
    ACTIONS(1076), 1,
      anon_sym_RPAREN,
    STATE(503), 1,
      sym_named_return_type,
  [8996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1078), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
  [9005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1080), 1,
      anon_sym_SEMI,
    STATE(422), 1,
      aux_sym_annotation_repeat1,
  [9018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1082), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(929), 1,
      anon_sym_LBRACE,
    STATE(420), 1,
      aux_sym_annotation_repeat1,
  [9044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(867), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1084), 1,
      anon_sym_COMMA,
    ACTIONS(959), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [9064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1080), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1086), 1,
      anon_sym_SEMI,
    STATE(426), 1,
      aux_sym_annotation_repeat1,
  [9090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(929), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 1,
      anon_sym_DOT,
    ACTIONS(1088), 1,
      anon_sym_SEMI,
    STATE(428), 1,
      aux_sym_import_using_repeat1,
  [9116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1090), 1,
      anon_sym_LBRACE,
    STATE(322), 1,
      aux_sym_annotation_repeat1,
  [9129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1092), 1,
      anon_sym_LBRACE,
    STATE(320), 1,
      aux_sym_annotation_repeat1,
  [9142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(863), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_RBRACE,
    ACTIONS(1094), 2,
      anon_sym_union,
      sym_identifier,
  [9166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1086), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1100), 1,
      anon_sym_RBRACE,
    ACTIONS(1098), 2,
      anon_sym_union,
      sym_identifier,
  [9190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    STATE(517), 1,
      sym_string,
  [9203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1102), 1,
      anon_sym_LBRACE,
    STATE(312), 1,
      aux_sym_annotation_repeat1,
  [9216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1104), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    STATE(303), 1,
      sym_method_parameters,
  [9242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1108), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(1110), 1,
      anon_sym_SEMI,
    STATE(524), 1,
      sym_generics,
  [9264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(1112), 1,
      anon_sym_RPAREN,
    STATE(535), 1,
      sym_generics,
  [9277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1114), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_RPAREN,
    ACTIONS(1116), 1,
      sym_identifier,
    STATE(434), 1,
      aux_sym_struct_shorthand_repeat1,
  [9303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(908), 1,
      anon_sym_RPAREN,
    ACTIONS(910), 1,
      anon_sym_COMMA,
    STATE(337), 1,
      aux_sym__annotation_array_def_repeat2,
  [9316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 1,
      anon_sym_DOT,
    ACTIONS(1120), 1,
      anon_sym_SEMI,
    STATE(438), 1,
      aux_sym_import_using_repeat1,
  [9338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1122), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    STATE(225), 1,
      sym_string,
  [9364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1124), 1,
      anon_sym_SEMI,
    STATE(348), 1,
      aux_sym_annotation_repeat1,
  [9377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1126), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1128), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1130), 1,
      anon_sym_RPAREN,
    ACTIONS(1132), 1,
      anon_sym_COMMA,
    STATE(440), 1,
      aux_sym_annotation_targets_repeat1,
  [9416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1134), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1136), 1,
      anon_sym_RPAREN,
    ACTIONS(1138), 1,
      anon_sym_COMMA,
    STATE(398), 1,
      aux_sym_annotation_targets_repeat1,
  [9442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 3,
      anon_sym_SEMI,
      anon_sym_DOLLAR,
      anon_sym_COLON,
  [9451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(888), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1134), 1,
      anon_sym_SEMI,
    STATE(351), 1,
      aux_sym_annotation_repeat1,
  [9495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(931), 1,
      anon_sym_RPAREN,
    ACTIONS(972), 1,
      anon_sym_COMMA,
    STATE(275), 1,
      aux_sym__annotation_array_def_repeat1,
  [9521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_RPAREN,
    ACTIONS(972), 1,
      anon_sym_COMMA,
    STATE(405), 1,
      aux_sym__annotation_array_def_repeat1,
  [9534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 1,
      anon_sym_RBRACE,
    ACTIONS(1147), 2,
      anon_sym_union,
      sym_identifier,
  [9545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 1,
      anon_sym_COMMA,
    ACTIONS(1151), 1,
      anon_sym_RPAREN,
    STATE(356), 1,
      aux_sym_top_level_annotation_body_repeat1,
  [9558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_RBRACK,
    ACTIONS(1153), 1,
      anon_sym_COMMA,
    STATE(271), 1,
      aux_sym__annotation_array_def_repeat2,
  [9571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
    STATE(410), 1,
      aux_sym_struct_shorthand_repeat1,
  [9584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1160), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(933), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1162), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1162), 1,
      anon_sym_LBRACE,
    STATE(425), 1,
      aux_sym_annotation_repeat1,
  [9636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1164), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1166), 1,
      anon_sym_SEMI,
    STATE(365), 1,
      aux_sym_annotation_repeat1,
  [9662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    ACTIONS(1170), 1,
      anon_sym_COMMA,
    STATE(417), 1,
      aux_sym_parameters_repeat1,
  [9675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1166), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1173), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1175), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1177), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9727] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1179), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1175), 1,
      anon_sym_LBRACE,
    STATE(421), 1,
      aux_sym_annotation_repeat1,
  [9753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1179), 1,
      anon_sym_SEMI,
    STATE(419), 1,
      aux_sym_annotation_repeat1,
  [9766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1181), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(984), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1183), 1,
      anon_sym_SEMI,
    STATE(418), 1,
      aux_sym_annotation_repeat1,
  [9805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_SEMI,
    ACTIONS(1187), 1,
      anon_sym_DOT,
    STATE(428), 1,
      aux_sym_import_using_repeat1,
  [9818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(1190), 1,
      anon_sym_RPAREN,
    STATE(494), 1,
      sym_generics,
  [9831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1183), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1192), 3,
      anon_sym_SEMI,
      anon_sym_DOLLAR,
      anon_sym_DASH_GT,
  [9853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1194), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    STATE(479), 1,
      sym_string,
  [9879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1116), 1,
      sym_identifier,
    ACTIONS(1196), 1,
      anon_sym_RPAREN,
    STATE(410), 1,
      aux_sym_struct_shorthand_repeat1,
  [9892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1198), 1,
      anon_sym_SEMI,
    STATE(386), 1,
      aux_sym_annotation_repeat1,
  [9905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1200), 1,
      anon_sym_SEMI,
    STATE(395), 1,
      aux_sym_annotation_repeat1,
  [9918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1202), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      aux_sym_annotation_repeat1,
  [9931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 1,
      anon_sym_DOT,
    ACTIONS(1204), 1,
      anon_sym_SEMI,
    STATE(428), 1,
      aux_sym_import_using_repeat1,
  [9944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_DOLLAR,
    ACTIONS(1202), 1,
      anon_sym_SEMI,
    STATE(397), 1,
      aux_sym_annotation_repeat1,
  [9957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1132), 1,
      anon_sym_COMMA,
    ACTIONS(1206), 1,
      anon_sym_RPAREN,
    STATE(398), 1,
      aux_sym_annotation_targets_repeat1,
  [9970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 3,
      anon_sym_SEMI,
      anon_sym_DOLLAR,
      anon_sym_COLON,
  [9979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1210), 1,
      anon_sym_SEMI,
    ACTIONS(1212), 1,
      anon_sym_DOT,
  [9989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1214), 1,
      aux_sym_top_level_annotation_body_token1,
    STATE(521), 1,
      sym_top_level_annotation_body,
  [9999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 1,
      sym__identifier_no_period,
    STATE(445), 1,
      aux_sym__internal_const_identifier_repeat1,
  [10009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 1,
      sym__identifier_no_period,
    STATE(445), 1,
      aux_sym__internal_const_identifier_repeat1,
  [10019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      sym_identifier,
    STATE(341), 1,
      sym__annotation_definition_identifier,
  [10029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [10037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1225), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [10045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [10053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_SEMI,
    ACTIONS(1231), 1,
      anon_sym_EQ,
  [10063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1233), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [10071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [10079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 1,
      anon_sym_SEMI,
    ACTIONS(1239), 1,
      anon_sym_DOT,
  [10089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      anon_sym_SEMI,
    ACTIONS(1243), 1,
      anon_sym_LPAREN,
  [10099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 1,
      sym_unique_id,
    ACTIONS(1247), 1,
      anon_sym_COLON,
  [10109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [10117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 1,
      anon_sym_group,
    ACTIONS(1253), 1,
      anon_sym_union,
  [10127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
  [10135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      sym_identifier,
    ACTIONS(1259), 1,
      anon_sym_import,
  [10145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1261), 2,
      anon_sym_SEMI,
      anon_sym_DOLLAR,
  [10153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1042), 1,
      anon_sym_LPAREN,
    STATE(276), 1,
      sym_annotation_targets,
  [10163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 1,
      sym_identifier,
    STATE(469), 1,
      sym_parameter,
  [10173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1263), 2,
      anon_sym_SEMI,
      anon_sym_DOLLAR,
  [10181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1265), 2,
      anon_sym_LPAREN,
      sym_identifier,
  [10189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 2,
      anon_sym_SEMI,
      anon_sym_DOLLAR,
  [10197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 1,
      sym__identifier_no_period,
    STATE(445), 1,
      aux_sym__internal_const_identifier_repeat1,
  [10207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1269), 1,
      sym__normal_version,
    ACTIONS(1271), 1,
      aux_sym__inline_version_token1,
  [10217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1273), 2,
      anon_sym_SEMI,
      anon_sym_DOLLAR,
  [10225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [10233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [10241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1136), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [10249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1277), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [10257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 1,
      anon_sym_DOT,
    ACTIONS(651), 1,
      sym__identifier_no_period,
  [10267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [10275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1281), 1,
      sym_identifier,
  [10282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
  [10289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1283), 1,
      anon_sym_LPAREN,
  [10296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1285), 1,
      anon_sym_RPAREN,
  [10303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_RPAREN,
  [10310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      anon_sym_LPAREN,
  [10317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      sym_identifier,
  [10324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 1,
      anon_sym_EQ,
  [10331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
  [10338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1297), 1,
      anon_sym_SEMI,
  [10345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1299), 1,
      anon_sym_RPAREN,
  [10352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_RPAREN,
  [10359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1301), 1,
      anon_sym_EQ,
  [10366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(59), 1,
      anon_sym_RPAREN,
  [10373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      aux_sym_data_token1,
  [10380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1305), 1,
      anon_sym_RPAREN,
  [10387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 1,
      anon_sym_SEMI,
  [10394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
  [10401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 1,
      sym_identifier,
  [10408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1313), 1,
      anon_sym_RPAREN,
  [10415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1315), 1,
      anon_sym_COLON,
  [10422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 1,
      anon_sym_EQ,
  [10429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1319), 1,
      anon_sym_SEMI,
  [10436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1321), 1,
      anon_sym_SEMI,
  [10443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 1,
      sym_identifier,
  [10450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1325), 1,
      anon_sym_COLON,
  [10457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1327), 1,
      anon_sym_LPAREN,
  [10464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1329), 1,
      anon_sym_SEMI,
  [10471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 1,
      anon_sym_RPAREN,
  [10478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1333), 1,
      sym_identifier,
  [10485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 1,
      sym_identifier,
  [10492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      anon_sym_RPAREN,
  [10499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1339), 1,
      anon_sym_COLON,
  [10506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 1,
      anon_sym_RPAREN,
  [10513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_RPAREN,
  [10520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1345), 1,
      sym_identifier,
  [10527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
  [10534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 1,
      anon_sym_namespace,
  [10541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_RPAREN,
  [10548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      sym_identifier,
  [10555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1353), 1,
      anon_sym_EQ,
  [10562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1355), 1,
      anon_sym_namespace,
  [10569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1357), 1,
      anon_sym_SEMI,
  [10576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1359), 1,
      sym_identifier,
  [10583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_EQ,
  [10590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1363), 1,
      anon_sym_EQ,
  [10597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 1,
      anon_sym_SEMI,
  [10604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_SEMI,
  [10611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_SEMI,
  [10618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 1,
      anon_sym_SEMI,
  [10625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1373), 1,
      anon_sym_SEMI,
  [10632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 1,
      anon_sym_RPAREN,
  [10639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1377), 1,
      anon_sym_EQ,
  [10646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_RPAREN,
  [10653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 1,
      anon_sym_COLON,
  [10660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1381), 1,
      anon_sym_SEMI,
  [10667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
  [10674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      anon_sym_EQ,
  [10681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1387), 1,
      anon_sym_RPAREN,
  [10688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 1,
      anon_sym_EQ,
  [10695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 1,
      anon_sym_RPAREN,
  [10702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1393), 1,
      sym_identifier,
  [10709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1395), 1,
      anon_sym_RBRACK,
  [10716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 1,
      anon_sym_COLON,
  [10723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_COLON,
  [10730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 1,
      ts_builtin_sym_end,
  [10737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1403), 1,
      anon_sym_RPAREN,
  [10744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1405), 1,
      sym_identifier,
  [10751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 1,
      sym_identifier,
  [10758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_SEMI,
  [10765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1411), 1,
      sym_identifier,
  [10772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1413), 1,
      sym_identifier,
  [10779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      sym_identifier,
  [10786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1417), 1,
      sym__identifier_no_period,
  [10793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_SEMI,
  [10800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 1,
      anon_sym_COLON,
  [10807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 1,
      sym_identifier,
  [10814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 102,
  [SMALL_STATE(4)] = 176,
  [SMALL_STATE(5)] = 247,
  [SMALL_STATE(6)] = 318,
  [SMALL_STATE(7)] = 389,
  [SMALL_STATE(8)] = 460,
  [SMALL_STATE(9)] = 531,
  [SMALL_STATE(10)] = 602,
  [SMALL_STATE(11)] = 671,
  [SMALL_STATE(12)] = 742,
  [SMALL_STATE(13)] = 806,
  [SMALL_STATE(14)] = 874,
  [SMALL_STATE(15)] = 938,
  [SMALL_STATE(16)] = 1003,
  [SMALL_STATE(17)] = 1066,
  [SMALL_STATE(18)] = 1128,
  [SMALL_STATE(19)] = 1190,
  [SMALL_STATE(20)] = 1252,
  [SMALL_STATE(21)] = 1314,
  [SMALL_STATE(22)] = 1373,
  [SMALL_STATE(23)] = 1432,
  [SMALL_STATE(24)] = 1491,
  [SMALL_STATE(25)] = 1550,
  [SMALL_STATE(26)] = 1609,
  [SMALL_STATE(27)] = 1668,
  [SMALL_STATE(28)] = 1727,
  [SMALL_STATE(29)] = 1786,
  [SMALL_STATE(30)] = 1845,
  [SMALL_STATE(31)] = 1904,
  [SMALL_STATE(32)] = 1963,
  [SMALL_STATE(33)] = 2022,
  [SMALL_STATE(34)] = 2081,
  [SMALL_STATE(35)] = 2140,
  [SMALL_STATE(36)] = 2199,
  [SMALL_STATE(37)] = 2258,
  [SMALL_STATE(38)] = 2317,
  [SMALL_STATE(39)] = 2376,
  [SMALL_STATE(40)] = 2435,
  [SMALL_STATE(41)] = 2494,
  [SMALL_STATE(42)] = 2549,
  [SMALL_STATE(43)] = 2604,
  [SMALL_STATE(44)] = 2659,
  [SMALL_STATE(45)] = 2714,
  [SMALL_STATE(46)] = 2769,
  [SMALL_STATE(47)] = 2824,
  [SMALL_STATE(48)] = 2879,
  [SMALL_STATE(49)] = 2934,
  [SMALL_STATE(50)] = 2989,
  [SMALL_STATE(51)] = 3030,
  [SMALL_STATE(52)] = 3082,
  [SMALL_STATE(53)] = 3134,
  [SMALL_STATE(54)] = 3172,
  [SMALL_STATE(55)] = 3210,
  [SMALL_STATE(56)] = 3248,
  [SMALL_STATE(57)] = 3299,
  [SMALL_STATE(58)] = 3334,
  [SMALL_STATE(59)] = 3385,
  [SMALL_STATE(60)] = 3436,
  [SMALL_STATE(61)] = 3471,
  [SMALL_STATE(62)] = 3506,
  [SMALL_STATE(63)] = 3557,
  [SMALL_STATE(64)] = 3592,
  [SMALL_STATE(65)] = 3627,
  [SMALL_STATE(66)] = 3662,
  [SMALL_STATE(67)] = 3713,
  [SMALL_STATE(68)] = 3748,
  [SMALL_STATE(69)] = 3783,
  [SMALL_STATE(70)] = 3807,
  [SMALL_STATE(71)] = 3831,
  [SMALL_STATE(72)] = 3852,
  [SMALL_STATE(73)] = 3873,
  [SMALL_STATE(74)] = 3894,
  [SMALL_STATE(75)] = 3915,
  [SMALL_STATE(76)] = 3936,
  [SMALL_STATE(77)] = 3957,
  [SMALL_STATE(78)] = 3978,
  [SMALL_STATE(79)] = 3999,
  [SMALL_STATE(80)] = 4020,
  [SMALL_STATE(81)] = 4041,
  [SMALL_STATE(82)] = 4062,
  [SMALL_STATE(83)] = 4083,
  [SMALL_STATE(84)] = 4104,
  [SMALL_STATE(85)] = 4125,
  [SMALL_STATE(86)] = 4146,
  [SMALL_STATE(87)] = 4167,
  [SMALL_STATE(88)] = 4188,
  [SMALL_STATE(89)] = 4209,
  [SMALL_STATE(90)] = 4230,
  [SMALL_STATE(91)] = 4251,
  [SMALL_STATE(92)] = 4272,
  [SMALL_STATE(93)] = 4293,
  [SMALL_STATE(94)] = 4314,
  [SMALL_STATE(95)] = 4335,
  [SMALL_STATE(96)] = 4356,
  [SMALL_STATE(97)] = 4377,
  [SMALL_STATE(98)] = 4398,
  [SMALL_STATE(99)] = 4419,
  [SMALL_STATE(100)] = 4440,
  [SMALL_STATE(101)] = 4461,
  [SMALL_STATE(102)] = 4482,
  [SMALL_STATE(103)] = 4503,
  [SMALL_STATE(104)] = 4524,
  [SMALL_STATE(105)] = 4545,
  [SMALL_STATE(106)] = 4566,
  [SMALL_STATE(107)] = 4587,
  [SMALL_STATE(108)] = 4611,
  [SMALL_STATE(109)] = 4635,
  [SMALL_STATE(110)] = 4659,
  [SMALL_STATE(111)] = 4677,
  [SMALL_STATE(112)] = 4706,
  [SMALL_STATE(113)] = 4735,
  [SMALL_STATE(114)] = 4764,
  [SMALL_STATE(115)] = 4793,
  [SMALL_STATE(116)] = 4822,
  [SMALL_STATE(117)] = 4849,
  [SMALL_STATE(118)] = 4878,
  [SMALL_STATE(119)] = 4907,
  [SMALL_STATE(120)] = 4936,
  [SMALL_STATE(121)] = 4965,
  [SMALL_STATE(122)] = 4994,
  [SMALL_STATE(123)] = 5023,
  [SMALL_STATE(124)] = 5052,
  [SMALL_STATE(125)] = 5081,
  [SMALL_STATE(126)] = 5110,
  [SMALL_STATE(127)] = 5139,
  [SMALL_STATE(128)] = 5168,
  [SMALL_STATE(129)] = 5197,
  [SMALL_STATE(130)] = 5226,
  [SMALL_STATE(131)] = 5255,
  [SMALL_STATE(132)] = 5284,
  [SMALL_STATE(133)] = 5313,
  [SMALL_STATE(134)] = 5342,
  [SMALL_STATE(135)] = 5371,
  [SMALL_STATE(136)] = 5400,
  [SMALL_STATE(137)] = 5429,
  [SMALL_STATE(138)] = 5458,
  [SMALL_STATE(139)] = 5487,
  [SMALL_STATE(140)] = 5515,
  [SMALL_STATE(141)] = 5533,
  [SMALL_STATE(142)] = 5561,
  [SMALL_STATE(143)] = 5583,
  [SMALL_STATE(144)] = 5601,
  [SMALL_STATE(145)] = 5619,
  [SMALL_STATE(146)] = 5647,
  [SMALL_STATE(147)] = 5669,
  [SMALL_STATE(148)] = 5691,
  [SMALL_STATE(149)] = 5719,
  [SMALL_STATE(150)] = 5743,
  [SMALL_STATE(151)] = 5771,
  [SMALL_STATE(152)] = 5795,
  [SMALL_STATE(153)] = 5819,
  [SMALL_STATE(154)] = 5847,
  [SMALL_STATE(155)] = 5871,
  [SMALL_STATE(156)] = 5895,
  [SMALL_STATE(157)] = 5923,
  [SMALL_STATE(158)] = 5951,
  [SMALL_STATE(159)] = 5975,
  [SMALL_STATE(160)] = 5993,
  [SMALL_STATE(161)] = 6011,
  [SMALL_STATE(162)] = 6029,
  [SMALL_STATE(163)] = 6047,
  [SMALL_STATE(164)] = 6065,
  [SMALL_STATE(165)] = 6093,
  [SMALL_STATE(166)] = 6110,
  [SMALL_STATE(167)] = 6127,
  [SMALL_STATE(168)] = 6146,
  [SMALL_STATE(169)] = 6165,
  [SMALL_STATE(170)] = 6182,
  [SMALL_STATE(171)] = 6199,
  [SMALL_STATE(172)] = 6216,
  [SMALL_STATE(173)] = 6231,
  [SMALL_STATE(174)] = 6248,
  [SMALL_STATE(175)] = 6265,
  [SMALL_STATE(176)] = 6282,
  [SMALL_STATE(177)] = 6297,
  [SMALL_STATE(178)] = 6314,
  [SMALL_STATE(179)] = 6331,
  [SMALL_STATE(180)] = 6348,
  [SMALL_STATE(181)] = 6365,
  [SMALL_STATE(182)] = 6382,
  [SMALL_STATE(183)] = 6399,
  [SMALL_STATE(184)] = 6416,
  [SMALL_STATE(185)] = 6433,
  [SMALL_STATE(186)] = 6450,
  [SMALL_STATE(187)] = 6467,
  [SMALL_STATE(188)] = 6484,
  [SMALL_STATE(189)] = 6502,
  [SMALL_STATE(190)] = 6520,
  [SMALL_STATE(191)] = 6538,
  [SMALL_STATE(192)] = 6552,
  [SMALL_STATE(193)] = 6570,
  [SMALL_STATE(194)] = 6588,
  [SMALL_STATE(195)] = 6606,
  [SMALL_STATE(196)] = 6623,
  [SMALL_STATE(197)] = 6640,
  [SMALL_STATE(198)] = 6653,
  [SMALL_STATE(199)] = 6678,
  [SMALL_STATE(200)] = 6701,
  [SMALL_STATE(201)] = 6718,
  [SMALL_STATE(202)] = 6730,
  [SMALL_STATE(203)] = 6742,
  [SMALL_STATE(204)] = 6760,
  [SMALL_STATE(205)] = 6772,
  [SMALL_STATE(206)] = 6784,
  [SMALL_STATE(207)] = 6796,
  [SMALL_STATE(208)] = 6814,
  [SMALL_STATE(209)] = 6826,
  [SMALL_STATE(210)] = 6838,
  [SMALL_STATE(211)] = 6850,
  [SMALL_STATE(212)] = 6862,
  [SMALL_STATE(213)] = 6874,
  [SMALL_STATE(214)] = 6886,
  [SMALL_STATE(215)] = 6898,
  [SMALL_STATE(216)] = 6910,
  [SMALL_STATE(217)] = 6932,
  [SMALL_STATE(218)] = 6944,
  [SMALL_STATE(219)] = 6966,
  [SMALL_STATE(220)] = 6978,
  [SMALL_STATE(221)] = 6996,
  [SMALL_STATE(222)] = 7008,
  [SMALL_STATE(223)] = 7026,
  [SMALL_STATE(224)] = 7044,
  [SMALL_STATE(225)] = 7056,
  [SMALL_STATE(226)] = 7068,
  [SMALL_STATE(227)] = 7080,
  [SMALL_STATE(228)] = 7102,
  [SMALL_STATE(229)] = 7114,
  [SMALL_STATE(230)] = 7126,
  [SMALL_STATE(231)] = 7138,
  [SMALL_STATE(232)] = 7150,
  [SMALL_STATE(233)] = 7162,
  [SMALL_STATE(234)] = 7174,
  [SMALL_STATE(235)] = 7196,
  [SMALL_STATE(236)] = 7208,
  [SMALL_STATE(237)] = 7226,
  [SMALL_STATE(238)] = 7248,
  [SMALL_STATE(239)] = 7260,
  [SMALL_STATE(240)] = 7279,
  [SMALL_STATE(241)] = 7296,
  [SMALL_STATE(242)] = 7309,
  [SMALL_STATE(243)] = 7322,
  [SMALL_STATE(244)] = 7337,
  [SMALL_STATE(245)] = 7352,
  [SMALL_STATE(246)] = 7365,
  [SMALL_STATE(247)] = 7378,
  [SMALL_STATE(248)] = 7391,
  [SMALL_STATE(249)] = 7404,
  [SMALL_STATE(250)] = 7417,
  [SMALL_STATE(251)] = 7436,
  [SMALL_STATE(252)] = 7455,
  [SMALL_STATE(253)] = 7474,
  [SMALL_STATE(254)] = 7493,
  [SMALL_STATE(255)] = 7506,
  [SMALL_STATE(256)] = 7519,
  [SMALL_STATE(257)] = 7538,
  [SMALL_STATE(258)] = 7551,
  [SMALL_STATE(259)] = 7564,
  [SMALL_STATE(260)] = 7581,
  [SMALL_STATE(261)] = 7594,
  [SMALL_STATE(262)] = 7613,
  [SMALL_STATE(263)] = 7632,
  [SMALL_STATE(264)] = 7645,
  [SMALL_STATE(265)] = 7664,
  [SMALL_STATE(266)] = 7683,
  [SMALL_STATE(267)] = 7700,
  [SMALL_STATE(268)] = 7713,
  [SMALL_STATE(269)] = 7730,
  [SMALL_STATE(270)] = 7743,
  [SMALL_STATE(271)] = 7759,
  [SMALL_STATE(272)] = 7773,
  [SMALL_STATE(273)] = 7787,
  [SMALL_STATE(274)] = 7801,
  [SMALL_STATE(275)] = 7815,
  [SMALL_STATE(276)] = 7829,
  [SMALL_STATE(277)] = 7845,
  [SMALL_STATE(278)] = 7859,
  [SMALL_STATE(279)] = 7875,
  [SMALL_STATE(280)] = 7891,
  [SMALL_STATE(281)] = 7905,
  [SMALL_STATE(282)] = 7919,
  [SMALL_STATE(283)] = 7933,
  [SMALL_STATE(284)] = 7949,
  [SMALL_STATE(285)] = 7965,
  [SMALL_STATE(286)] = 7979,
  [SMALL_STATE(287)] = 7995,
  [SMALL_STATE(288)] = 8011,
  [SMALL_STATE(289)] = 8023,
  [SMALL_STATE(290)] = 8037,
  [SMALL_STATE(291)] = 8049,
  [SMALL_STATE(292)] = 8065,
  [SMALL_STATE(293)] = 8081,
  [SMALL_STATE(294)] = 8097,
  [SMALL_STATE(295)] = 8111,
  [SMALL_STATE(296)] = 8127,
  [SMALL_STATE(297)] = 8143,
  [SMALL_STATE(298)] = 8157,
  [SMALL_STATE(299)] = 8173,
  [SMALL_STATE(300)] = 8189,
  [SMALL_STATE(301)] = 8205,
  [SMALL_STATE(302)] = 8219,
  [SMALL_STATE(303)] = 8233,
  [SMALL_STATE(304)] = 8249,
  [SMALL_STATE(305)] = 8263,
  [SMALL_STATE(306)] = 8277,
  [SMALL_STATE(307)] = 8293,
  [SMALL_STATE(308)] = 8307,
  [SMALL_STATE(309)] = 8320,
  [SMALL_STATE(310)] = 8333,
  [SMALL_STATE(311)] = 8346,
  [SMALL_STATE(312)] = 8357,
  [SMALL_STATE(313)] = 8370,
  [SMALL_STATE(314)] = 8383,
  [SMALL_STATE(315)] = 8396,
  [SMALL_STATE(316)] = 8409,
  [SMALL_STATE(317)] = 8422,
  [SMALL_STATE(318)] = 8435,
  [SMALL_STATE(319)] = 8448,
  [SMALL_STATE(320)] = 8461,
  [SMALL_STATE(321)] = 8474,
  [SMALL_STATE(322)] = 8487,
  [SMALL_STATE(323)] = 8500,
  [SMALL_STATE(324)] = 8513,
  [SMALL_STATE(325)] = 8526,
  [SMALL_STATE(326)] = 8539,
  [SMALL_STATE(327)] = 8552,
  [SMALL_STATE(328)] = 8563,
  [SMALL_STATE(329)] = 8576,
  [SMALL_STATE(330)] = 8585,
  [SMALL_STATE(331)] = 8598,
  [SMALL_STATE(332)] = 8611,
  [SMALL_STATE(333)] = 8624,
  [SMALL_STATE(334)] = 8637,
  [SMALL_STATE(335)] = 8648,
  [SMALL_STATE(336)] = 8661,
  [SMALL_STATE(337)] = 8674,
  [SMALL_STATE(338)] = 8687,
  [SMALL_STATE(339)] = 8700,
  [SMALL_STATE(340)] = 8713,
  [SMALL_STATE(341)] = 8722,
  [SMALL_STATE(342)] = 8735,
  [SMALL_STATE(343)] = 8748,
  [SMALL_STATE(344)] = 8761,
  [SMALL_STATE(345)] = 8774,
  [SMALL_STATE(346)] = 8785,
  [SMALL_STATE(347)] = 8798,
  [SMALL_STATE(348)] = 8811,
  [SMALL_STATE(349)] = 8824,
  [SMALL_STATE(350)] = 8837,
  [SMALL_STATE(351)] = 8846,
  [SMALL_STATE(352)] = 8859,
  [SMALL_STATE(353)] = 8872,
  [SMALL_STATE(354)] = 8885,
  [SMALL_STATE(355)] = 8898,
  [SMALL_STATE(356)] = 8911,
  [SMALL_STATE(357)] = 8924,
  [SMALL_STATE(358)] = 8937,
  [SMALL_STATE(359)] = 8946,
  [SMALL_STATE(360)] = 8957,
  [SMALL_STATE(361)] = 8970,
  [SMALL_STATE(362)] = 8983,
  [SMALL_STATE(363)] = 8996,
  [SMALL_STATE(364)] = 9005,
  [SMALL_STATE(365)] = 9018,
  [SMALL_STATE(366)] = 9031,
  [SMALL_STATE(367)] = 9044,
  [SMALL_STATE(368)] = 9053,
  [SMALL_STATE(369)] = 9064,
  [SMALL_STATE(370)] = 9077,
  [SMALL_STATE(371)] = 9090,
  [SMALL_STATE(372)] = 9103,
  [SMALL_STATE(373)] = 9116,
  [SMALL_STATE(374)] = 9129,
  [SMALL_STATE(375)] = 9142,
  [SMALL_STATE(376)] = 9155,
  [SMALL_STATE(377)] = 9166,
  [SMALL_STATE(378)] = 9179,
  [SMALL_STATE(379)] = 9190,
  [SMALL_STATE(380)] = 9203,
  [SMALL_STATE(381)] = 9216,
  [SMALL_STATE(382)] = 9229,
  [SMALL_STATE(383)] = 9242,
  [SMALL_STATE(384)] = 9251,
  [SMALL_STATE(385)] = 9264,
  [SMALL_STATE(386)] = 9277,
  [SMALL_STATE(387)] = 9290,
  [SMALL_STATE(388)] = 9303,
  [SMALL_STATE(389)] = 9316,
  [SMALL_STATE(390)] = 9325,
  [SMALL_STATE(391)] = 9338,
  [SMALL_STATE(392)] = 9351,
  [SMALL_STATE(393)] = 9364,
  [SMALL_STATE(394)] = 9377,
  [SMALL_STATE(395)] = 9390,
  [SMALL_STATE(396)] = 9403,
  [SMALL_STATE(397)] = 9416,
  [SMALL_STATE(398)] = 9429,
  [SMALL_STATE(399)] = 9442,
  [SMALL_STATE(400)] = 9451,
  [SMALL_STATE(401)] = 9460,
  [SMALL_STATE(402)] = 9469,
  [SMALL_STATE(403)] = 9482,
  [SMALL_STATE(404)] = 9495,
  [SMALL_STATE(405)] = 9508,
  [SMALL_STATE(406)] = 9521,
  [SMALL_STATE(407)] = 9534,
  [SMALL_STATE(408)] = 9545,
  [SMALL_STATE(409)] = 9558,
  [SMALL_STATE(410)] = 9571,
  [SMALL_STATE(411)] = 9584,
  [SMALL_STATE(412)] = 9597,
  [SMALL_STATE(413)] = 9610,
  [SMALL_STATE(414)] = 9623,
  [SMALL_STATE(415)] = 9636,
  [SMALL_STATE(416)] = 9649,
  [SMALL_STATE(417)] = 9662,
  [SMALL_STATE(418)] = 9675,
  [SMALL_STATE(419)] = 9688,
  [SMALL_STATE(420)] = 9701,
  [SMALL_STATE(421)] = 9714,
  [SMALL_STATE(422)] = 9727,
  [SMALL_STATE(423)] = 9740,
  [SMALL_STATE(424)] = 9753,
  [SMALL_STATE(425)] = 9766,
  [SMALL_STATE(426)] = 9779,
  [SMALL_STATE(427)] = 9792,
  [SMALL_STATE(428)] = 9805,
  [SMALL_STATE(429)] = 9818,
  [SMALL_STATE(430)] = 9831,
  [SMALL_STATE(431)] = 9844,
  [SMALL_STATE(432)] = 9853,
  [SMALL_STATE(433)] = 9866,
  [SMALL_STATE(434)] = 9879,
  [SMALL_STATE(435)] = 9892,
  [SMALL_STATE(436)] = 9905,
  [SMALL_STATE(437)] = 9918,
  [SMALL_STATE(438)] = 9931,
  [SMALL_STATE(439)] = 9944,
  [SMALL_STATE(440)] = 9957,
  [SMALL_STATE(441)] = 9970,
  [SMALL_STATE(442)] = 9979,
  [SMALL_STATE(443)] = 9989,
  [SMALL_STATE(444)] = 9999,
  [SMALL_STATE(445)] = 10009,
  [SMALL_STATE(446)] = 10019,
  [SMALL_STATE(447)] = 10029,
  [SMALL_STATE(448)] = 10037,
  [SMALL_STATE(449)] = 10045,
  [SMALL_STATE(450)] = 10053,
  [SMALL_STATE(451)] = 10063,
  [SMALL_STATE(452)] = 10071,
  [SMALL_STATE(453)] = 10079,
  [SMALL_STATE(454)] = 10089,
  [SMALL_STATE(455)] = 10099,
  [SMALL_STATE(456)] = 10109,
  [SMALL_STATE(457)] = 10117,
  [SMALL_STATE(458)] = 10127,
  [SMALL_STATE(459)] = 10135,
  [SMALL_STATE(460)] = 10145,
  [SMALL_STATE(461)] = 10153,
  [SMALL_STATE(462)] = 10163,
  [SMALL_STATE(463)] = 10173,
  [SMALL_STATE(464)] = 10181,
  [SMALL_STATE(465)] = 10189,
  [SMALL_STATE(466)] = 10197,
  [SMALL_STATE(467)] = 10207,
  [SMALL_STATE(468)] = 10217,
  [SMALL_STATE(469)] = 10225,
  [SMALL_STATE(470)] = 10233,
  [SMALL_STATE(471)] = 10241,
  [SMALL_STATE(472)] = 10249,
  [SMALL_STATE(473)] = 10257,
  [SMALL_STATE(474)] = 10267,
  [SMALL_STATE(475)] = 10275,
  [SMALL_STATE(476)] = 10282,
  [SMALL_STATE(477)] = 10289,
  [SMALL_STATE(478)] = 10296,
  [SMALL_STATE(479)] = 10303,
  [SMALL_STATE(480)] = 10310,
  [SMALL_STATE(481)] = 10317,
  [SMALL_STATE(482)] = 10324,
  [SMALL_STATE(483)] = 10331,
  [SMALL_STATE(484)] = 10338,
  [SMALL_STATE(485)] = 10345,
  [SMALL_STATE(486)] = 10352,
  [SMALL_STATE(487)] = 10359,
  [SMALL_STATE(488)] = 10366,
  [SMALL_STATE(489)] = 10373,
  [SMALL_STATE(490)] = 10380,
  [SMALL_STATE(491)] = 10387,
  [SMALL_STATE(492)] = 10394,
  [SMALL_STATE(493)] = 10401,
  [SMALL_STATE(494)] = 10408,
  [SMALL_STATE(495)] = 10415,
  [SMALL_STATE(496)] = 10422,
  [SMALL_STATE(497)] = 10429,
  [SMALL_STATE(498)] = 10436,
  [SMALL_STATE(499)] = 10443,
  [SMALL_STATE(500)] = 10450,
  [SMALL_STATE(501)] = 10457,
  [SMALL_STATE(502)] = 10464,
  [SMALL_STATE(503)] = 10471,
  [SMALL_STATE(504)] = 10478,
  [SMALL_STATE(505)] = 10485,
  [SMALL_STATE(506)] = 10492,
  [SMALL_STATE(507)] = 10499,
  [SMALL_STATE(508)] = 10506,
  [SMALL_STATE(509)] = 10513,
  [SMALL_STATE(510)] = 10520,
  [SMALL_STATE(511)] = 10527,
  [SMALL_STATE(512)] = 10534,
  [SMALL_STATE(513)] = 10541,
  [SMALL_STATE(514)] = 10548,
  [SMALL_STATE(515)] = 10555,
  [SMALL_STATE(516)] = 10562,
  [SMALL_STATE(517)] = 10569,
  [SMALL_STATE(518)] = 10576,
  [SMALL_STATE(519)] = 10583,
  [SMALL_STATE(520)] = 10590,
  [SMALL_STATE(521)] = 10597,
  [SMALL_STATE(522)] = 10604,
  [SMALL_STATE(523)] = 10611,
  [SMALL_STATE(524)] = 10618,
  [SMALL_STATE(525)] = 10625,
  [SMALL_STATE(526)] = 10632,
  [SMALL_STATE(527)] = 10639,
  [SMALL_STATE(528)] = 10646,
  [SMALL_STATE(529)] = 10653,
  [SMALL_STATE(530)] = 10660,
  [SMALL_STATE(531)] = 10667,
  [SMALL_STATE(532)] = 10674,
  [SMALL_STATE(533)] = 10681,
  [SMALL_STATE(534)] = 10688,
  [SMALL_STATE(535)] = 10695,
  [SMALL_STATE(536)] = 10702,
  [SMALL_STATE(537)] = 10709,
  [SMALL_STATE(538)] = 10716,
  [SMALL_STATE(539)] = 10723,
  [SMALL_STATE(540)] = 10730,
  [SMALL_STATE(541)] = 10737,
  [SMALL_STATE(542)] = 10744,
  [SMALL_STATE(543)] = 10751,
  [SMALL_STATE(544)] = 10758,
  [SMALL_STATE(545)] = 10765,
  [SMALL_STATE(546)] = 10772,
  [SMALL_STATE(547)] = 10779,
  [SMALL_STATE(548)] = 10786,
  [SMALL_STATE(549)] = 10793,
  [SMALL_STATE(550)] = 10800,
  [SMALL_STATE(551)] = 10807,
  [SMALL_STATE(552)] = 10814,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_message, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__annotation_array_def, 2, 0, 0),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__annotation_array_def, 3, 0, 0),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0), SHIFT_REPEAT(262),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0), SHIFT_REPEAT(280),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0), SHIFT_REPEAT(547),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0), SHIFT_REPEAT(546),
  [134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0), SHIFT_REPEAT(545),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0), SHIFT_REPEAT(543),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0), SHIFT_REPEAT(476),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_message, 1, 0, 0),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0),
  [161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0), SHIFT_REPEAT(525),
  [164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0), SHIFT_REPEAT(280),
  [167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0), SHIFT_REPEAT(292),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0), SHIFT_REPEAT(443),
  [173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0), SHIFT_REPEAT(547),
  [179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0), SHIFT_REPEAT(546),
  [182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0), SHIFT_REPEAT(545),
  [185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_message_repeat1, 2, 0, 0), SHIFT_REPEAT(543),
  [188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_group_repeat1, 2, 0, 0), SHIFT_REPEAT(262),
  [195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_group_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_group_repeat1, 2, 0, 0), SHIFT_REPEAT(547),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_group_repeat1, 2, 0, 0), SHIFT_REPEAT(546),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_group_repeat1, 2, 0, 0), SHIFT_REPEAT(545),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_group_repeat1, 2, 0, 0), SHIFT_REPEAT(543),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_group_repeat1, 2, 0, 0), SHIFT_REPEAT(476),
  [213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_group_repeat1, 2, 0, 0),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum, 7, 0, 6),
  [223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum, 7, 0, 6),
  [225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 6, 0, 0),
  [227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 6, 0, 0),
  [229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum, 5, 0, 6),
  [231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum, 5, 0, 6),
  [233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 7, 0, 2),
  [235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 7, 0, 2),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 8, 0, 0),
  [239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 8, 0, 0),
  [241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const, 8, 0, 17),
  [243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const, 8, 0, 17),
  [245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 5, 0, 2),
  [247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 5, 0, 2),
  [249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 7, 0, 2),
  [251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 7, 0, 2),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 3, 0, 0),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 3, 0, 0),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 11, 0, 31),
  [259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 11, 0, 31),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 9, 0, 26),
  [263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 9, 0, 26),
  [265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 10, 0, 26),
  [267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 10, 0, 26),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 9, 0, 23),
  [271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 9, 0, 23),
  [273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 11, 0, 26),
  [275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 11, 0, 26),
  [277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const, 7, 0, 17),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const, 7, 0, 17),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 7, 0, 0),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 7, 0, 0),
  [285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 10, 0, 31),
  [287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 10, 0, 31),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 10, 0, 23),
  [291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 10, 0, 23),
  [293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 8, 0, 2),
  [295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 8, 0, 2),
  [297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 13, 0, 31),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 13, 0, 31),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 6, 0, 2),
  [303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 6, 0, 2),
  [305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 8, 0, 23),
  [307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 8, 0, 23),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 4, 0, 0),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 4, 0, 0),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const, 9, 0, 17),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const, 9, 0, 17),
  [317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 12, 0, 26),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 12, 0, 26),
  [321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 5, 0, 2),
  [323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 5, 0, 2),
  [325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 4, 0, 2),
  [327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 4, 0, 2),
  [329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 8, 0, 2),
  [331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 8, 0, 2),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 3, 0, 2),
  [335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 3, 0, 2),
  [337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 6, 0, 2),
  [339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 6, 0, 2),
  [341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 12, 0, 31),
  [343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 12, 0, 31),
  [345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum, 4, 0, 6),
  [347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum, 4, 0, 6),
  [349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 11, 0, 23),
  [351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 11, 0, 23),
  [353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum, 6, 0, 6),
  [355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum, 6, 0, 6),
  [357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 4, 0, 2),
  [359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 4, 0, 2),
  [361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 5, 0, 0),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 5, 0, 0),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_text_repeat2, 1, 0, 0),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_text_repeat1, 2, 0, 0),
  [375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_text_repeat1, 2, 0, 0), SHIFT_REPEAT(108),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_text_repeat1, 2, 0, 0), SHIFT_REPEAT(108),
  [381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_text_repeat2, 2, 0, 0),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generics, 3, 0, 0),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2, 0, 5),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(546),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(545),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(543),
  [443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 3, 0, 1),
  [453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 3, 0, 1),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(222),
  [460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(223),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 10),
  [465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 5, 0, 10),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 10, 0, 29),
  [469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 10, 0, 29),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_value, 1, 0, 0),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 8, 0, 25),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__unnamed_union_repeat1, 2, 0, 0), SHIFT_REPEAT(252),
  [486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__unnamed_union_repeat1, 2, 0, 0), SHIFT_REPEAT(250),
  [489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__unnamed_union_repeat1, 2, 0, 0),
  [491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 4, 0, 5),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 3, 0, 5),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_custom_type, 1, 0, 4),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 9, 0, 30),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unique_id_statement, 2, 0, 0),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unique_id_statement, 2, 0, 0),
  [519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 1, 0, 0),
  [521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_definition, 1, 0, 0),
  [523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_level_annotation, 3, 0, 0),
  [529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_top_level_annotation, 3, 0, 0),
  [531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 8, 0, 19),
  [533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 8, 0, 19),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 1, 0, 0),
  [539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 1, 0, 0),
  [541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unnamed_union, 3, 0, 0),
  [543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unnamed_union, 3, 0, 0),
  [545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_custom_type_repeat1, 2, 0, 2),
  [547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__annotation_call_repeat1, 2, 0, 0),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__annotation_call_repeat1, 2, 0, 0), SHIFT_REPEAT(551),
  [552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 6, 0, 28),
  [554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 6, 0, 28),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_union, 6, 0, 4),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_union, 6, 0, 4),
  [560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_group, 6, 0, 4),
  [562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group, 6, 0, 4),
  [564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_union, 5, 0, 4),
  [568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_union, 5, 0, 4),
  [570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_union, 8, 0, 4),
  [572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_union, 8, 0, 4),
  [574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unnamed_union, 4, 0, 0),
  [576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unnamed_union, 4, 0, 0),
  [578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_struct, 1, 0, 0),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_struct, 1, 0, 0),
  [584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 6, 0, 24),
  [586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 6, 0, 24),
  [588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_enum, 1, 0, 0),
  [590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_enum, 1, 0, 0),
  [592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 7, 0, 24),
  [594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 7, 0, 24),
  [596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_group, 5, 0, 4),
  [598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group, 5, 0, 4),
  [600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union, 1, 0, 0),
  [602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union, 1, 0, 0),
  [604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 7, 0, 28),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 7, 0, 28),
  [608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 8, 0, 24),
  [610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 8, 0, 24),
  [612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_union, 7, 0, 4),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_union, 7, 0, 4),
  [616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_group, 7, 0, 4),
  [618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group, 7, 0, 4),
  [620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 5, 0, 24),
  [622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, 0, 24),
  [624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_custom_type_repeat1, 2, 0, 0),
  [626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_custom_type_repeat1, 2, 0, 0), SHIFT_REPEAT(499),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_custom_type, 3, 0, 4),
  [631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_text, 1, 0, 0),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__annotation_call_repeat1, 2, 0, 12),
  [635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_custom_type, 2, 0, 4),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_text_repeat2, 2, 0, 0),
  [639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_text_repeat2, 2, 0, 0), SHIFT_REPEAT(107),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2, 0, 0),
  [644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2, 0, 0), SHIFT_REPEAT(505),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__internal_const_identifier, 1, 0, 0),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__internal_const_identifier_repeat1, 1, 0, 4),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_custom_type_repeat1, 3, 0, 2),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__internal_const_identifier, 2, 0, 0),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 9, 0, 25),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_list, 4, 0, 0),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data, 2, 0, 0),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 12, 0, 30),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 6, 0, 5),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_version, 1, 0, 0),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 10, 0, 30),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_shorthand, 3, 0, 0),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_list, 2, 0, 0),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_list, 3, 0, 0),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_shorthand, 2, 0, 0),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 7, 0, 5),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_type, 4, 0, 0),
  [711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(220),
  [716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(220),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 11, 0, 30),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_embedded_file, 2, 0, 0),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 11, 0, 25),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 10, 0, 25),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1, 0, 0),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_list, 5, 0, 0),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 5, 0, 5),
  [753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(236),
  [758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(236),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_return_type, 3, 0, 32),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_type, 1, 0, 0),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_return_type_repeat1, 4, 0, 34),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 6, 0, 0),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 6, 0, 0),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 9, 0, 22),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 9, 0, 22),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__internal_const_identifier_repeat1, 1, 0, 4),
  [787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 8, 0, 18),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 8, 0, 18),
  [791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 8, 0, 22),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 8, 0, 22),
  [795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 7, 0, 22),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 7, 0, 22),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 6, 0, 22),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 6, 0, 22),
  [803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 7, 0, 0),
  [805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 7, 0, 0),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 8, 0, 0),
  [823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 8, 0, 0),
  [825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 4, 0, 18),
  [827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 4, 0, 18),
  [829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 5, 0, 22),
  [831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 5, 0, 22),
  [833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 7, 0, 18),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 7, 0, 18),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 27),
  [841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 5, 0, 0),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 5, 0, 0),
  [845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 5, 0, 18),
  [847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 5, 0, 18),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 4, 0, 0),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 4, 0, 0),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 27),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 6, 0, 18),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 6, 0, 18),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__annotation_array_def_repeat2, 2, 0, 0),
  [869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__annotation_array_def_repeat2, 2, 0, 0), SHIFT_REPEAT(34),
  [872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_type, 1, 0, 0),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 2, 0, 7),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_repeat1, 2, 0, 0), SHIFT_REPEAT(286),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_repeat1, 2, 0, 0),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__annotation_array_def_repeat1, 2, 0, 0),
  [885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__annotation_array_def_repeat1, 2, 0, 0), SHIFT_REPEAT(481),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__annotation_array_def, 1, 0, 0),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_parameters_repeat1, 2, 0, 0),
  [914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(65),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_return_type, 4, 0, 32),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__annotation_array_def, 4, 0, 15),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 1, 0, 7),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_shorthand_repeat1, 3, 0, 15),
  [961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__annotation_array_def, 3, 0, 15),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_array_repeat1, 2, 0, 0),
  [965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_array_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_return_type_repeat1, 5, 0, 34),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_return_type, 7, 0, 32),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 1, 0, 0),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_return_type, 6, 0, 32),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_field, 8, 0, 24),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_field, 8, 0, 24),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__same_scope_const_value, 2, 0, 20),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_return_type_repeat1, 2, 0, 0),
  [1016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_return_type_repeat1, 2, 0, 0), SHIFT_REPEAT(518),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_return_type, 5, 0, 32),
  [1021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_field, 7, 0, 24),
  [1023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_field, 7, 0, 24),
  [1025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_top_level_annotation_body_repeat1, 2, 0, 0),
  [1027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_top_level_annotation_body_repeat1, 2, 0, 0), SHIFT_REPEAT(504),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_array, 3, 0, 0),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_using, 2, 0, 1),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__annotation_array_def_repeat1, 4, 0, 33),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_parameters, 3, 0, 0),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_field, 6, 0, 24),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_field, 6, 0, 24),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unnamed_return_type, 1, 0, 4),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_using, 3, 0, 1),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_union, 1, 0, 0),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_union, 1, 0, 0),
  [1098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_field, 1, 0, 0),
  [1100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_field, 1, 0, 0),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_parameters_repeat1, 2, 0, 14),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_replace_using, 3, 0, 3),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_array, 1, 0, 0),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_targets_repeat1, 2, 0, 0),
  [1138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_targets_repeat1, 2, 0, 0), SHIFT_REPEAT(69),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_targets, 4, 0, 0),
  [1143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_array, 4, 0, 0),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_field, 5, 0, 24),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_field, 5, 0, 24),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_shorthand_repeat1, 2, 0, 0), SHIFT_REPEAT(532),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_shorthand_repeat1, 2, 0, 0),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [1170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(462),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_using_repeat1, 2, 0, 0),
  [1187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_using_repeat1, 2, 0, 0), SHIFT_REPEAT(475),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_parameters, 2, 0, 0),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_targets, 3, 0, 0),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__internal_const_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_top_level_annotation_body_repeat1, 4, 0, 5),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_return_type_repeat1, 7, 0, 34),
  [1227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_return_type_repeat1, 6, 0, 34),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_shorthand_repeat1, 4, 0, 15),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_field, 4, 0, 13),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_level_annotation_body, 1, 0, 0),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 6, 0, 27),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_using_repeat1, 2, 0, 2),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [1261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_type, 2, 0, 0),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_return_types, 3, 0, 0),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_generics, 3, 0, 21),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_identifier, 1, 0, 8),
  [1271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_identifier, 1, 0, 8),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_return_types, 2, 0, 0),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_field, 3, 0, 13),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 5, 0, 27),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_target, 1, 0, 0),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_level_annotation_body, 3, 0, 0),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_level_annotation_body, 6, 0, 16),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_using, 4, 0, 9),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_level_annotation_body, 7, 0, 16),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_replace_using, 4, 0, 3),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1401] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_level_annotation_body, 4, 0, 0),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__internal_const_identifier_repeat1, 2, 0, 4),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_level_annotation_body, 4, 0, 11),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_capnp(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
