#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 784
#define LARGE_STATE_COUNT 3
#define SYMBOL_COUNT 122
#define ALIAS_COUNT 0
#define TOKEN_COUNT 49
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 7
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 13

enum {
  sym_symbol = 1,
  anon_sym_LPAREN = 2,
  anon_sym_each = 3,
  anon_sym_LBRACK = 4,
  anon_sym_RBRACK = 5,
  anon_sym_RPAREN = 6,
  anon_sym_COLONuntil = 7,
  anon_sym_for = 8,
  anon_sym_let = 9,
  anon_sym_global = 10,
  anon_sym_local = 11,
  anon_sym_var = 12,
  anon_sym_set = 13,
  anon_sym_AMP = 14,
  anon_sym_LBRACE = 15,
  anon_sym_COLON = 16,
  anon_sym_AMPas = 17,
  anon_sym_RBRACE = 18,
  anon_sym_hashfn = 19,
  anon_sym_POUND = 20,
  anon_sym_fn = 21,
  anon_sym_lambda = 22,
  anon_sym_ = 23,
  anon_sym_match = 24,
  anon_sym_QMARK = 25,
  anon_sym_where = 26,
  anon_sym_or = 27,
  anon_sym_collect = 28,
  anon_sym_icollect = 29,
  anon_sym_accumulate = 30,
  anon_sym_quote = 31,
  anon_sym_SQUOTE = 32,
  anon_sym_BQUOTE = 33,
  anon_sym_COMMA = 34,
  sym_nil = 35,
  sym_nil_safe = 36,
  sym_vararg = 37,
  anon_sym_true = 38,
  anon_sym_false = 39,
  aux_sym_string_token1 = 40,
  anon_sym_DQUOTE = 41,
  aux_sym_string_token2 = 42,
  sym_escape_sequence = 43,
  sym_number = 44,
  anon_sym_DOT = 45,
  anon_sym_COLON2 = 46,
  sym_symbol_immediate = 47,
  sym_comment = 48,
  sym_program = 49,
  sym__sexp = 50,
  sym__special_form = 51,
  sym_each = 52,
  sym_iter_bindings = 53,
  sym_for = 54,
  sym_for_clause = 55,
  sym_let = 56,
  sym_let_clause = 57,
  sym_global = 58,
  sym_local = 59,
  sym_var = 60,
  sym_set = 61,
  sym__binding = 62,
  sym_multi_value_binding = 63,
  sym__non_multi_value_binding = 64,
  sym_binding = 65,
  sym_sequential_table_binding = 66,
  sym_table_binding = 67,
  sym__assignment = 68,
  sym_multi_value_assignment = 69,
  sym__non_multi_value_assignment = 70,
  sym_assignment = 71,
  sym_sequential_table_assignment = 72,
  sym_table_assignment = 73,
  sym_hashfn = 74,
  sym_fn = 75,
  sym_lambda = 76,
  sym__function_body = 77,
  sym_parameters = 78,
  sym_match = 79,
  sym__pattern = 80,
  sym__simple_pattern = 81,
  sym_guard_pattern = 82,
  sym_where_pattern = 83,
  sym_multi_value_pattern = 84,
  sym__non_multi_value_pattern = 85,
  sym_sequential_table_pattern = 86,
  sym_table_pattern = 87,
  sym_collect = 88,
  sym_icollect = 89,
  sym_accumulate = 90,
  sym_quote = 91,
  sym_unquote = 92,
  sym__quoted_sexp = 93,
  sym_quoted_list = 94,
  sym_quoted_sequential_table = 95,
  sym_quoted_table = 96,
  sym_list = 97,
  sym_sequential_table = 98,
  sym_table_pair = 99,
  sym_table = 100,
  sym__literal = 101,
  sym_boolean = 102,
  sym_string = 103,
  sym_multi_symbol = 104,
  sym_multi_symbol_method = 105,
  aux_sym_program_repeat1 = 106,
  aux_sym_iter_bindings_repeat1 = 107,
  aux_sym_let_clause_repeat1 = 108,
  aux_sym_multi_value_binding_repeat1 = 109,
  aux_sym_table_binding_repeat1 = 110,
  aux_sym_multi_value_assignment_repeat1 = 111,
  aux_sym_table_assignment_repeat1 = 112,
  aux_sym_parameters_repeat1 = 113,
  aux_sym_match_repeat1 = 114,
  aux_sym_where_pattern_repeat1 = 115,
  aux_sym_multi_value_pattern_repeat1 = 116,
  aux_sym_table_pattern_repeat1 = 117,
  aux_sym_quoted_list_repeat1 = 118,
  aux_sym_table_repeat1 = 119,
  aux_sym_string_repeat1 = 120,
  aux_sym_multi_symbol_repeat1 = 121,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_symbol] = "symbol",
  [anon_sym_LPAREN] = "(",
  [anon_sym_each] = "each",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COLONuntil] = ":until",
  [anon_sym_for] = "for",
  [anon_sym_let] = "let",
  [anon_sym_global] = "global",
  [anon_sym_local] = "local",
  [anon_sym_var] = "var",
  [anon_sym_set] = "set",
  [anon_sym_AMP] = "&",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COLON] = ":",
  [anon_sym_AMPas] = "&as",
  [anon_sym_RBRACE] = "}",
  [anon_sym_hashfn] = "hashfn",
  [anon_sym_POUND] = "#",
  [anon_sym_fn] = "fn",
  [anon_sym_lambda] = "lambda",
  [anon_sym_] = "λ",
  [anon_sym_match] = "match",
  [anon_sym_QMARK] = "\?",
  [anon_sym_where] = "where",
  [anon_sym_or] = "or",
  [anon_sym_collect] = "collect",
  [anon_sym_icollect] = "icollect",
  [anon_sym_accumulate] = "accumulate",
  [anon_sym_quote] = "quote",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_COMMA] = ",",
  [sym_nil] = "nil",
  [sym_nil_safe] = "nil_safe",
  [sym_vararg] = "vararg",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_number] = "number",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON2] = ":",
  [sym_symbol_immediate] = "symbol",
  [sym_comment] = "comment",
  [sym_program] = "program",
  [sym__sexp] = "_sexp",
  [sym__special_form] = "_special_form",
  [sym_each] = "each",
  [sym_iter_bindings] = "iter_bindings",
  [sym_for] = "for",
  [sym_for_clause] = "for_clause",
  [sym_let] = "let",
  [sym_let_clause] = "let_clause",
  [sym_global] = "global",
  [sym_local] = "local",
  [sym_var] = "var",
  [sym_set] = "set",
  [sym__binding] = "_binding",
  [sym_multi_value_binding] = "multi_value_binding",
  [sym__non_multi_value_binding] = "_non_multi_value_binding",
  [sym_binding] = "binding",
  [sym_sequential_table_binding] = "sequential_table_binding",
  [sym_table_binding] = "table_binding",
  [sym__assignment] = "_assignment",
  [sym_multi_value_assignment] = "multi_value_assignment",
  [sym__non_multi_value_assignment] = "_non_multi_value_assignment",
  [sym_assignment] = "assignment",
  [sym_sequential_table_assignment] = "sequential_table_assignment",
  [sym_table_assignment] = "table_assignment",
  [sym_hashfn] = "hashfn",
  [sym_fn] = "fn",
  [sym_lambda] = "lambda",
  [sym__function_body] = "_function_body",
  [sym_parameters] = "parameters",
  [sym_match] = "match",
  [sym__pattern] = "_pattern",
  [sym__simple_pattern] = "_simple_pattern",
  [sym_guard_pattern] = "guard_pattern",
  [sym_where_pattern] = "where_pattern",
  [sym_multi_value_pattern] = "multi_value_pattern",
  [sym__non_multi_value_pattern] = "_non_multi_value_pattern",
  [sym_sequential_table_pattern] = "sequential_table_pattern",
  [sym_table_pattern] = "table_pattern",
  [sym_collect] = "collect",
  [sym_icollect] = "icollect",
  [sym_accumulate] = "accumulate",
  [sym_quote] = "quote",
  [sym_unquote] = "unquote",
  [sym__quoted_sexp] = "_quoted_sexp",
  [sym_quoted_list] = "quoted_list",
  [sym_quoted_sequential_table] = "quoted_sequential_table",
  [sym_quoted_table] = "quoted_table",
  [sym_list] = "list",
  [sym_sequential_table] = "sequential_table",
  [sym_table_pair] = "table_pair",
  [sym_table] = "table",
  [sym__literal] = "_literal",
  [sym_boolean] = "boolean",
  [sym_string] = "string",
  [sym_multi_symbol] = "multi_symbol",
  [sym_multi_symbol_method] = "multi_symbol_method",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_iter_bindings_repeat1] = "iter_bindings_repeat1",
  [aux_sym_let_clause_repeat1] = "let_clause_repeat1",
  [aux_sym_multi_value_binding_repeat1] = "multi_value_binding_repeat1",
  [aux_sym_table_binding_repeat1] = "table_binding_repeat1",
  [aux_sym_multi_value_assignment_repeat1] = "multi_value_assignment_repeat1",
  [aux_sym_table_assignment_repeat1] = "table_assignment_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_match_repeat1] = "match_repeat1",
  [aux_sym_where_pattern_repeat1] = "where_pattern_repeat1",
  [aux_sym_multi_value_pattern_repeat1] = "multi_value_pattern_repeat1",
  [aux_sym_table_pattern_repeat1] = "table_pattern_repeat1",
  [aux_sym_quoted_list_repeat1] = "quoted_list_repeat1",
  [aux_sym_table_repeat1] = "table_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_multi_symbol_repeat1] = "multi_symbol_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_symbol] = sym_symbol,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_each] = anon_sym_each,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COLONuntil] = anon_sym_COLONuntil,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AMPas] = anon_sym_AMPas,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_hashfn] = anon_sym_hashfn,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_lambda] = anon_sym_lambda,
  [anon_sym_] = anon_sym_,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_collect] = anon_sym_collect,
  [anon_sym_icollect] = anon_sym_icollect,
  [anon_sym_accumulate] = anon_sym_accumulate,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_nil] = sym_nil,
  [sym_nil_safe] = sym_nil_safe,
  [sym_vararg] = sym_vararg,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_number] = sym_number,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON2] = anon_sym_COLON,
  [sym_symbol_immediate] = sym_symbol,
  [sym_comment] = sym_comment,
  [sym_program] = sym_program,
  [sym__sexp] = sym__sexp,
  [sym__special_form] = sym__special_form,
  [sym_each] = sym_each,
  [sym_iter_bindings] = sym_iter_bindings,
  [sym_for] = sym_for,
  [sym_for_clause] = sym_for_clause,
  [sym_let] = sym_let,
  [sym_let_clause] = sym_let_clause,
  [sym_global] = sym_global,
  [sym_local] = sym_local,
  [sym_var] = sym_var,
  [sym_set] = sym_set,
  [sym__binding] = sym__binding,
  [sym_multi_value_binding] = sym_multi_value_binding,
  [sym__non_multi_value_binding] = sym__non_multi_value_binding,
  [sym_binding] = sym_binding,
  [sym_sequential_table_binding] = sym_sequential_table_binding,
  [sym_table_binding] = sym_table_binding,
  [sym__assignment] = sym__assignment,
  [sym_multi_value_assignment] = sym_multi_value_assignment,
  [sym__non_multi_value_assignment] = sym__non_multi_value_assignment,
  [sym_assignment] = sym_assignment,
  [sym_sequential_table_assignment] = sym_sequential_table_assignment,
  [sym_table_assignment] = sym_table_assignment,
  [sym_hashfn] = sym_hashfn,
  [sym_fn] = sym_fn,
  [sym_lambda] = sym_lambda,
  [sym__function_body] = sym__function_body,
  [sym_parameters] = sym_parameters,
  [sym_match] = sym_match,
  [sym__pattern] = sym__pattern,
  [sym__simple_pattern] = sym__simple_pattern,
  [sym_guard_pattern] = sym_guard_pattern,
  [sym_where_pattern] = sym_where_pattern,
  [sym_multi_value_pattern] = sym_multi_value_pattern,
  [sym__non_multi_value_pattern] = sym__non_multi_value_pattern,
  [sym_sequential_table_pattern] = sym_sequential_table_pattern,
  [sym_table_pattern] = sym_table_pattern,
  [sym_collect] = sym_collect,
  [sym_icollect] = sym_icollect,
  [sym_accumulate] = sym_accumulate,
  [sym_quote] = sym_quote,
  [sym_unquote] = sym_unquote,
  [sym__quoted_sexp] = sym__quoted_sexp,
  [sym_quoted_list] = sym_quoted_list,
  [sym_quoted_sequential_table] = sym_quoted_sequential_table,
  [sym_quoted_table] = sym_quoted_table,
  [sym_list] = sym_list,
  [sym_sequential_table] = sym_sequential_table,
  [sym_table_pair] = sym_table_pair,
  [sym_table] = sym_table,
  [sym__literal] = sym__literal,
  [sym_boolean] = sym_boolean,
  [sym_string] = sym_string,
  [sym_multi_symbol] = sym_multi_symbol,
  [sym_multi_symbol_method] = sym_multi_symbol_method,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_iter_bindings_repeat1] = aux_sym_iter_bindings_repeat1,
  [aux_sym_let_clause_repeat1] = aux_sym_let_clause_repeat1,
  [aux_sym_multi_value_binding_repeat1] = aux_sym_multi_value_binding_repeat1,
  [aux_sym_table_binding_repeat1] = aux_sym_table_binding_repeat1,
  [aux_sym_multi_value_assignment_repeat1] = aux_sym_multi_value_assignment_repeat1,
  [aux_sym_table_assignment_repeat1] = aux_sym_table_assignment_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_match_repeat1] = aux_sym_match_repeat1,
  [aux_sym_where_pattern_repeat1] = aux_sym_where_pattern_repeat1,
  [aux_sym_multi_value_pattern_repeat1] = aux_sym_multi_value_pattern_repeat1,
  [aux_sym_table_pattern_repeat1] = aux_sym_table_pattern_repeat1,
  [aux_sym_quoted_list_repeat1] = aux_sym_quoted_list_repeat1,
  [aux_sym_table_repeat1] = aux_sym_table_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_multi_symbol_repeat1] = aux_sym_multi_symbol_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_each] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLONuntil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMPas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hashfn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_collect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_icollect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_accumulate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_nil_safe] = {
    .visible = true,
    .named = true,
  },
  [sym_vararg] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [sym_symbol_immediate] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__sexp] = {
    .visible = false,
    .named = true,
  },
  [sym__special_form] = {
    .visible = false,
    .named = true,
  },
  [sym_each] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_bindings] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_let_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_global] = {
    .visible = true,
    .named = true,
  },
  [sym_local] = {
    .visible = true,
    .named = true,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym__binding] = {
    .visible = false,
    .named = true,
  },
  [sym_multi_value_binding] = {
    .visible = true,
    .named = true,
  },
  [sym__non_multi_value_binding] = {
    .visible = false,
    .named = true,
  },
  [sym_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_sequential_table_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_table_binding] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_multi_value_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__non_multi_value_assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_sequential_table_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_table_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_hashfn] = {
    .visible = true,
    .named = true,
  },
  [sym_fn] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_match] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_guard_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_where_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_multi_value_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__non_multi_value_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_sequential_table_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_table_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_collect] = {
    .visible = true,
    .named = true,
  },
  [sym_icollect] = {
    .visible = true,
    .named = true,
  },
  [sym_accumulate] = {
    .visible = true,
    .named = true,
  },
  [sym_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym__quoted_sexp] = {
    .visible = false,
    .named = true,
  },
  [sym_quoted_list] = {
    .visible = true,
    .named = true,
  },
  [sym_quoted_sequential_table] = {
    .visible = true,
    .named = true,
  },
  [sym_quoted_table] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_sequential_table] = {
    .visible = true,
    .named = true,
  },
  [sym_table_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_table] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_multi_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_multi_symbol_method] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_iter_bindings_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_let_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multi_value_binding_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_binding_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multi_value_assignment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_assignment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multi_value_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_quoted_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multi_symbol_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_docstring = 1,
  field_guard = 2,
  field_iterator = 3,
  field_key = 4,
  field_name = 5,
  field_until = 6,
  field_value = 7,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_docstring] = "docstring",
  [field_guard] = "guard",
  [field_iterator] = "iterator",
  [field_key] = "key",
  [field_name] = "name",
  [field_until] = "until",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 2},
  [5] = {.index = 6, .length = 1},
  [6] = {.index = 7, .length = 1},
  [7] = {.index = 8, .length = 2},
  [8] = {.index = 10, .length = 2},
  [9] = {.index = 12, .length = 2},
  [10] = {.index = 14, .length = 1},
  [11] = {.index = 15, .length = 1},
  [12] = {.index = 16, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_key, 0},
    {field_value, 1},
  [2] =
    {field_iterator, 0},
  [3] =
    {field_name, 0},
  [4] =
    {field_docstring, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [6] =
    {field_iterator, 1},
  [7] =
    {field_docstring, 1},
  [8] =
    {field_iterator, 0},
    {field_until, 2},
  [10] =
    {field_docstring, 2},
    {field_name, 0},
  [12] =
    {field_iterator, 1},
    {field_until, 3},
  [14] =
    {field_guard, 3},
  [15] =
    {field_guard, 5},
  [16] =
    {field_guard, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 3,
  [5] = 3,
  [6] = 3,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 9,
  [11] = 7,
  [12] = 8,
  [13] = 13,
  [14] = 14,
  [15] = 9,
  [16] = 7,
  [17] = 13,
  [18] = 14,
  [19] = 9,
  [20] = 14,
  [21] = 7,
  [22] = 13,
  [23] = 14,
  [24] = 8,
  [25] = 13,
  [26] = 26,
  [27] = 27,
  [28] = 27,
  [29] = 27,
  [30] = 30,
  [31] = 30,
  [32] = 32,
  [33] = 32,
  [34] = 34,
  [35] = 35,
  [36] = 32,
  [37] = 32,
  [38] = 30,
  [39] = 30,
  [40] = 32,
  [41] = 30,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 42,
  [47] = 44,
  [48] = 42,
  [49] = 43,
  [50] = 45,
  [51] = 51,
  [52] = 45,
  [53] = 43,
  [54] = 54,
  [55] = 44,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 56,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 61,
  [78] = 78,
  [79] = 63,
  [80] = 80,
  [81] = 65,
  [82] = 56,
  [83] = 83,
  [84] = 73,
  [85] = 74,
  [86] = 86,
  [87] = 57,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 66,
  [92] = 68,
  [93] = 93,
  [94] = 94,
  [95] = 88,
  [96] = 96,
  [97] = 76,
  [98] = 98,
  [99] = 76,
  [100] = 68,
  [101] = 88,
  [102] = 75,
  [103] = 66,
  [104] = 90,
  [105] = 89,
  [106] = 86,
  [107] = 83,
  [108] = 90,
  [109] = 57,
  [110] = 74,
  [111] = 83,
  [112] = 75,
  [113] = 89,
  [114] = 73,
  [115] = 56,
  [116] = 72,
  [117] = 61,
  [118] = 78,
  [119] = 63,
  [120] = 65,
  [121] = 78,
  [122] = 72,
  [123] = 73,
  [124] = 74,
  [125] = 65,
  [126] = 86,
  [127] = 63,
  [128] = 78,
  [129] = 61,
  [130] = 86,
  [131] = 89,
  [132] = 90,
  [133] = 133,
  [134] = 134,
  [135] = 72,
  [136] = 75,
  [137] = 83,
  [138] = 138,
  [139] = 57,
  [140] = 140,
  [141] = 141,
  [142] = 88,
  [143] = 66,
  [144] = 68,
  [145] = 76,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 148,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 154,
  [158] = 158,
  [159] = 153,
  [160] = 151,
  [161] = 148,
  [162] = 148,
  [163] = 153,
  [164] = 164,
  [165] = 151,
  [166] = 155,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 156,
  [172] = 158,
  [173] = 173,
  [174] = 158,
  [175] = 153,
  [176] = 164,
  [177] = 164,
  [178] = 164,
  [179] = 155,
  [180] = 180,
  [181] = 156,
  [182] = 154,
  [183] = 151,
  [184] = 154,
  [185] = 158,
  [186] = 156,
  [187] = 187,
  [188] = 155,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 190,
  [193] = 191,
  [194] = 194,
  [195] = 190,
  [196] = 191,
  [197] = 190,
  [198] = 191,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 201,
  [204] = 204,
  [205] = 205,
  [206] = 204,
  [207] = 202,
  [208] = 205,
  [209] = 204,
  [210] = 202,
  [211] = 199,
  [212] = 200,
  [213] = 199,
  [214] = 201,
  [215] = 205,
  [216] = 205,
  [217] = 200,
  [218] = 204,
  [219] = 199,
  [220] = 202,
  [221] = 201,
  [222] = 200,
  [223] = 223,
  [224] = 224,
  [225] = 224,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 226,
  [231] = 224,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 226,
  [236] = 226,
  [237] = 224,
  [238] = 234,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 227,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 241,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 250,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 250,
  [283] = 281,
  [284] = 278,
  [285] = 278,
  [286] = 268,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 268,
  [292] = 281,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 234,
  [305] = 305,
  [306] = 306,
  [307] = 306,
  [308] = 227,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 311,
  [313] = 241,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 279,
  [325] = 325,
  [326] = 309,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 331,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 325,
  [341] = 341,
  [342] = 342,
  [343] = 302,
  [344] = 335,
  [345] = 337,
  [346] = 342,
  [347] = 332,
  [348] = 348,
  [349] = 294,
  [350] = 258,
  [351] = 351,
  [352] = 352,
  [353] = 333,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 338,
  [358] = 325,
  [359] = 342,
  [360] = 360,
  [361] = 316,
  [362] = 323,
  [363] = 363,
  [364] = 364,
  [365] = 348,
  [366] = 327,
  [367] = 339,
  [368] = 368,
  [369] = 314,
  [370] = 370,
  [371] = 227,
  [372] = 311,
  [373] = 322,
  [374] = 330,
  [375] = 234,
  [376] = 328,
  [377] = 377,
  [378] = 319,
  [379] = 320,
  [380] = 380,
  [381] = 381,
  [382] = 318,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 241,
  [388] = 388,
  [389] = 302,
  [390] = 331,
  [391] = 332,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 335,
  [396] = 337,
  [397] = 279,
  [398] = 258,
  [399] = 399,
  [400] = 294,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 404,
  [406] = 404,
  [407] = 407,
  [408] = 404,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 409,
  [417] = 412,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 420,
  [422] = 420,
  [423] = 414,
  [424] = 414,
  [425] = 412,
  [426] = 411,
  [427] = 418,
  [428] = 428,
  [429] = 410,
  [430] = 410,
  [431] = 411,
  [432] = 409,
  [433] = 418,
  [434] = 415,
  [435] = 415,
  [436] = 414,
  [437] = 411,
  [438] = 414,
  [439] = 411,
  [440] = 418,
  [441] = 412,
  [442] = 409,
  [443] = 410,
  [444] = 444,
  [445] = 428,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 447,
  [450] = 450,
  [451] = 447,
  [452] = 450,
  [453] = 446,
  [454] = 450,
  [455] = 448,
  [456] = 450,
  [457] = 447,
  [458] = 229,
  [459] = 459,
  [460] = 227,
  [461] = 234,
  [462] = 229,
  [463] = 227,
  [464] = 234,
  [465] = 234,
  [466] = 227,
  [467] = 309,
  [468] = 240,
  [469] = 241,
  [470] = 240,
  [471] = 471,
  [472] = 227,
  [473] = 241,
  [474] = 234,
  [475] = 241,
  [476] = 377,
  [477] = 320,
  [478] = 246,
  [479] = 323,
  [480] = 316,
  [481] = 319,
  [482] = 383,
  [483] = 314,
  [484] = 246,
  [485] = 318,
  [486] = 322,
  [487] = 241,
  [488] = 293,
  [489] = 489,
  [490] = 252,
  [491] = 261,
  [492] = 265,
  [493] = 263,
  [494] = 255,
  [495] = 256,
  [496] = 260,
  [497] = 266,
  [498] = 498,
  [499] = 249,
  [500] = 251,
  [501] = 253,
  [502] = 254,
  [503] = 288,
  [504] = 295,
  [505] = 300,
  [506] = 299,
  [507] = 276,
  [508] = 274,
  [509] = 294,
  [510] = 269,
  [511] = 271,
  [512] = 272,
  [513] = 280,
  [514] = 290,
  [515] = 297,
  [516] = 303,
  [517] = 275,
  [518] = 301,
  [519] = 270,
  [520] = 227,
  [521] = 267,
  [522] = 262,
  [523] = 279,
  [524] = 273,
  [525] = 264,
  [526] = 298,
  [527] = 289,
  [528] = 259,
  [529] = 257,
  [530] = 287,
  [531] = 316,
  [532] = 258,
  [533] = 316,
  [534] = 234,
  [535] = 258,
  [536] = 262,
  [537] = 267,
  [538] = 327,
  [539] = 287,
  [540] = 294,
  [541] = 302,
  [542] = 498,
  [543] = 489,
  [544] = 314,
  [545] = 257,
  [546] = 318,
  [547] = 302,
  [548] = 489,
  [549] = 259,
  [550] = 323,
  [551] = 322,
  [552] = 498,
  [553] = 553,
  [554] = 489,
  [555] = 320,
  [556] = 319,
  [557] = 296,
  [558] = 498,
  [559] = 559,
  [560] = 289,
  [561] = 298,
  [562] = 229,
  [563] = 270,
  [564] = 271,
  [565] = 264,
  [566] = 566,
  [567] = 266,
  [568] = 260,
  [569] = 256,
  [570] = 255,
  [571] = 293,
  [572] = 273,
  [573] = 263,
  [574] = 265,
  [575] = 261,
  [576] = 279,
  [577] = 252,
  [578] = 296,
  [579] = 249,
  [580] = 301,
  [581] = 339,
  [582] = 348,
  [583] = 251,
  [584] = 253,
  [585] = 254,
  [586] = 275,
  [587] = 328,
  [588] = 288,
  [589] = 295,
  [590] = 330,
  [591] = 300,
  [592] = 299,
  [593] = 276,
  [594] = 274,
  [595] = 269,
  [596] = 272,
  [597] = 280,
  [598] = 290,
  [599] = 297,
  [600] = 303,
  [601] = 316,
  [602] = 602,
  [603] = 322,
  [604] = 320,
  [605] = 605,
  [606] = 323,
  [607] = 605,
  [608] = 318,
  [609] = 609,
  [610] = 610,
  [611] = 609,
  [612] = 609,
  [613] = 319,
  [614] = 605,
  [615] = 314,
  [616] = 240,
  [617] = 605,
  [618] = 609,
  [619] = 605,
  [620] = 609,
  [621] = 609,
  [622] = 241,
  [623] = 605,
  [624] = 624,
  [625] = 246,
  [626] = 280,
  [627] = 303,
  [628] = 302,
  [629] = 294,
  [630] = 267,
  [631] = 631,
  [632] = 632,
  [633] = 262,
  [634] = 634,
  [635] = 635,
  [636] = 258,
  [637] = 287,
  [638] = 257,
  [639] = 259,
  [640] = 289,
  [641] = 641,
  [642] = 298,
  [643] = 264,
  [644] = 293,
  [645] = 273,
  [646] = 279,
  [647] = 301,
  [648] = 275,
  [649] = 290,
  [650] = 650,
  [651] = 635,
  [652] = 650,
  [653] = 635,
  [654] = 654,
  [655] = 655,
  [656] = 272,
  [657] = 269,
  [658] = 274,
  [659] = 659,
  [660] = 276,
  [661] = 299,
  [662] = 300,
  [663] = 650,
  [664] = 632,
  [665] = 631,
  [666] = 295,
  [667] = 650,
  [668] = 635,
  [669] = 288,
  [670] = 254,
  [671] = 671,
  [672] = 253,
  [673] = 251,
  [674] = 249,
  [675] = 296,
  [676] = 632,
  [677] = 631,
  [678] = 252,
  [679] = 650,
  [680] = 635,
  [681] = 261,
  [682] = 265,
  [683] = 263,
  [684] = 297,
  [685] = 255,
  [686] = 256,
  [687] = 260,
  [688] = 266,
  [689] = 270,
  [690] = 631,
  [691] = 632,
  [692] = 271,
  [693] = 693,
  [694] = 693,
  [695] = 693,
  [696] = 693,
  [697] = 693,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 693,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 693,
  [713] = 713,
  [714] = 704,
  [715] = 706,
  [716] = 698,
  [717] = 700,
  [718] = 718,
  [719] = 702,
  [720] = 703,
  [721] = 707,
  [722] = 705,
  [723] = 709,
  [724] = 699,
  [725] = 725,
  [726] = 725,
  [727] = 718,
  [728] = 713,
  [729] = 710,
  [730] = 699,
  [731] = 699,
  [732] = 698,
  [733] = 733,
  [734] = 700,
  [735] = 735,
  [736] = 702,
  [737] = 703,
  [738] = 703,
  [739] = 705,
  [740] = 702,
  [741] = 709,
  [742] = 742,
  [743] = 707,
  [744] = 744,
  [745] = 718,
  [746] = 746,
  [747] = 747,
  [748] = 704,
  [749] = 706,
  [750] = 704,
  [751] = 706,
  [752] = 707,
  [753] = 709,
  [754] = 725,
  [755] = 693,
  [756] = 710,
  [757] = 700,
  [758] = 713,
  [759] = 693,
  [760] = 698,
  [761] = 698,
  [762] = 710,
  [763] = 713,
  [764] = 764,
  [765] = 765,
  [766] = 764,
  [767] = 747,
  [768] = 746,
  [769] = 718,
  [770] = 764,
  [771] = 747,
  [772] = 746,
  [773] = 699,
  [774] = 764,
  [775] = 747,
  [776] = 746,
  [777] = 725,
  [778] = 333,
  [779] = 338,
  [780] = 705,
  [781] = 733,
  [782] = 733,
  [783] = 733,
};

static inline bool aux_sym_string_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '['
        ? c == '@'
        : (c <= '[' || c == ']'))
      : (c <= '`' || (c < '}'
        ? c == '{'
        : c <= '~')))));
}

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < ':'
    ? (c < '"'
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : (c <= '\r' || c == ' '))
      : (c <= '"' || (c < ','
        ? (c >= '\'' && c <= ')')
        : (c <= ',' || c == '.'))))
    : (c <= ';' || (c < '`'
      ? (c < '['
        ? c == '@'
        : (c <= '[' || c == ']'))
      : (c <= '`' || (c < '}'
        ? c == '{'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_1(int32_t c) {
  return (c < '['
    ? (c < '\''
      ? (c < '#'
        ? c == 0
        : c <= '#')
      : (c <= ')' || (c < '@'
        ? c == ','
        : c <= '@')))
    : (c <= '[' || (c < '{'
      ? (c < '`'
        ? c == ']'
        : c <= '`')
      : (c <= '{' || c == '~'))));
}

static inline bool sym_symbol_character_set_2(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : (c <= ')' || c == ','))))
    : (c <= '.' || (c < ']'
      ? (c < '@'
        ? (c >= ':' && c <= ';')
        : (c <= '@' || c == '['))
      : (c <= ']' || (c < '{'
        ? c == '`'
        : (c <= '{' || (c >= '}' && c <= '~')))))));
}

static inline bool sym_symbol_character_set_3(int32_t c) {
  return (c < ':'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '['
        ? c == '@'
        : (c <= '[' || c == ']'))
      : (c <= '`' || (c < '}'
        ? c == '{'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_4(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : (c <= ')' || c == ','))))
    : (c <= '.' || (c < ']'
      ? (c < '@'
        ? (c >= ':' && c <= ';')
        : (c <= '@' || c == '['))
      : (c <= ']' || (c < '}'
        ? c == '`'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_5(int32_t c) {
  return (c < ':'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : (c <= ')' || (c >= ',' && c <= '.')))))
    : (c <= ';' || (c < '`'
      ? (c < '['
        ? c == '@'
        : (c <= '[' || c == ']'))
      : (c <= '`' || (c < '}'
        ? c == '{'
        : c <= '~')))));
}

static inline bool sym_symbol_immediate_character_set_1(int32_t c) {
  return (c < '['
    ? (c < '\''
      ? (c < '"'
        ? c == 0
        : c <= '#')
      : (c <= ')' || (c < '@'
        ? c == ','
        : c <= '@')))
    : (c <= '[' || (c < '{'
      ? (c < '`'
        ? c == ']'
        : c <= '`')
      : (c <= '{' || (c >= '}' && c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(50);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '&') ADVANCE(57);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(64);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == '\\') ADVANCE(109);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(45)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '&') ADVANCE(57);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(122);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '&') ADVANCE(57);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(122);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '&') ADVANCE(107);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(110);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(110);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(122);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(64);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\'' &&
          lookahead != '(' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != ']' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(122);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(64);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\'' &&
          lookahead != '(' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != ']' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(120);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(120);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '.') ADVANCE(121);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(120);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '.') ADVANCE(121);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(120);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == ';') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(77);
      if (lookahead != 0) ADVANCE(78);
      END_STATE();
    case 15:
      if (lookahead == '&') ADVANCE(57);
      if (lookahead == '.') ADVANCE(121);
      if (lookahead == ':') ADVANCE(100);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 16:
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == ':') ADVANCE(100);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\'' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 17:
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '.') ADVANCE(121);
      if (lookahead == ':') ADVANCE(100);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\'' &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 18:
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 19:
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '.') ADVANCE(121);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 20:
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '.') ADVANCE(121);
      if (lookahead == ':') ADVANCE(100);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 21:
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == '.') ADVANCE(105);
      if (lookahead == ':') ADVANCE(100);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != '@' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 22:
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(63);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(25)
      END_STATE();
    case 23:
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == ':') ADVANCE(32);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      END_STATE();
    case 24:
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ':') ADVANCE(123);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(27)
      if (!sym_symbol_immediate_character_set_1(lookahead)) ADVANCE(124);
      END_STATE();
    case 25:
      if (lookahead == ':') ADVANCE(32);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(63);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(25)
      END_STATE();
    case 26:
      if (lookahead == ':') ADVANCE(32);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      END_STATE();
    case 27:
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(27)
      END_STATE();
    case 28:
      if (lookahead == 'i') ADVANCE(29);
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(55);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 't') ADVANCE(28);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(30);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (lookahead != 0) ADVANCE(79);
      END_STATE();
    case 34:
      if (lookahead == '{') ADVANCE(42);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 37:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(97);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(89);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(92);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(97);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 45:
      if (eof) ADVANCE(50);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '&') ADVANCE(57);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(64);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(45)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 46:
      if (eof) ADVANCE(50);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(49)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 47:
      if (eof) ADVANCE(50);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(122);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(49)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 48:
      if (eof) ADVANCE(50);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(49)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 49:
      if (eof) ADVANCE(50);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '(') ADVANCE(51);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(101);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(122);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '[') ADVANCE(52);
      if (lookahead == ']') ADVANCE(53);
      if (lookahead == '`') ADVANCE(66);
      if (lookahead == '{') ADVANCE(58);
      if (lookahead == '}') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(49)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(120);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COLONuntil);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_COLONuntil);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(74);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(74);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_AMPas);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(68);
      if (!sym_symbol_character_set_3(lookahead)) ADVANCE(120);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_nil_safe);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_vararg);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == 'i') ADVANCE(71);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(74);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == 'l') ADVANCE(56);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(74);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == 'n') ADVANCE(73);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(74);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == 't') ADVANCE(70);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '\n') ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == ';') ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(77);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(84);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(81);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(88);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(112);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(86);
      if (!sym_symbol_character_set_3(lookahead)) ADVANCE(120);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(88);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(86);
      if (!sym_symbol_character_set_3(lookahead)) ADVANCE(120);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      if (!sym_symbol_character_set_3(lookahead)) ADVANCE(120);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(90);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(93);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(94);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(95);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(97);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_symbol);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '0') ADVANCE(85);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (!sym_symbol_character_set_3(lookahead)) ADVANCE(120);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(68);
      if (!sym_symbol_character_set_3(lookahead)) ADVANCE(120);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      if (!sym_symbol_character_set_3(lookahead)) ADVANCE(120);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(90);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(106);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(69);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'a') ADVANCE(108);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 's') ADVANCE(60);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'u') ADVANCE(111);
      if (lookahead == 'x') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(79);
      if (lookahead != 0) ADVANCE(84);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'u') ADVANCE(72);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(74);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '{') ADVANCE(42);
      if (!sym_symbol_character_set_4(lookahead)) ADVANCE(120);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(93);
      if (!sym_symbol_character_set_5(lookahead)) ADVANCE(120);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      if (!sym_symbol_character_set_5(lookahead)) ADVANCE(120);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(93);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(117);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_symbol);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_symbol);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_symbol);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(74);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_symbol_immediate);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_symbol_immediate);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(124);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_symbol_immediate);
      if (!aux_sym_string_token1_character_set_1(lookahead)) ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(126);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'c') ADVANCE(2);
      if (lookahead == 'e') ADVANCE(3);
      if (lookahead == 'f') ADVANCE(4);
      if (lookahead == 'g') ADVANCE(5);
      if (lookahead == 'h') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'q') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'v') ADVANCE(15);
      if (lookahead == 'w') ADVANCE(16);
      if (lookahead == 955) ADVANCE(17);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'c') ADVANCE(18);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(20);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(21);
      if (lookahead == 'n') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(24);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(25);
      END_STATE();
    case 7:
      if (lookahead == 'c') ADVANCE(26);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(27);
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(30);
      END_STATE();
    case 10:
      if (lookahead == 'i') ADVANCE(31);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(32);
      END_STATE();
    case 12:
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(35);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(36);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(37);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_);
      END_STATE();
    case 18:
      if (lookahead == 'c') ADVANCE(38);
      END_STATE();
    case 19:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 20:
      if (lookahead == 'c') ADVANCE(40);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(42);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(43);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 27:
      if (lookahead == 'm') ADVANCE(46);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(47);
      END_STATE();
    case 29:
      if (lookahead == 'c') ADVANCE(48);
      END_STATE();
    case 30:
      if (lookahead == 't') ADVANCE(49);
      END_STATE();
    case 31:
      if (lookahead == 'l') ADVANCE(50);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 33:
      if (lookahead == 'o') ADVANCE(51);
      END_STATE();
    case 34:
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 35:
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(54);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(57);
      END_STATE();
    case 40:
      if (lookahead == 'h') ADVANCE(58);
      END_STATE();
    case 41:
      if (lookahead == 's') ADVANCE(59);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 43:
      if (lookahead == 'b') ADVANCE(60);
      END_STATE();
    case 44:
      if (lookahead == 'h') ADVANCE(61);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 46:
      if (lookahead == 'b') ADVANCE(63);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 49:
      if (lookahead == 'c') ADVANCE(65);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_nil);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 56:
      if (lookahead == 'm') ADVANCE(69);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_each);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(72);
      END_STATE();
    case 61:
      if (lookahead == 'f') ADVANCE(73);
      END_STATE();
    case 62:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 63:
      if (lookahead == 'd') ADVANCE(75);
      END_STATE();
    case 64:
      if (lookahead == 'l') ADVANCE(76);
      END_STATE();
    case 65:
      if (lookahead == 'h') ADVANCE(77);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(79);
      END_STATE();
    case 69:
      if (lookahead == 'u') ADVANCE(80);
      END_STATE();
    case 70:
      if (lookahead == 'c') ADVANCE(81);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 72:
      if (lookahead == 'l') ADVANCE(82);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(83);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 75:
      if (lookahead == 'a') ADVANCE(85);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_hashfn);
      END_STATE();
    case 84:
      if (lookahead == 'c') ADVANCE(88);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 86:
      if (lookahead == 'a') ADVANCE(89);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_collect);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 89:
      if (lookahead == 't') ADVANCE(91);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_icollect);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_accumulate);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 49},
  [2] = {.lex_state = 49},
  [3] = {.lex_state = 49},
  [4] = {.lex_state = 49},
  [5] = {.lex_state = 49},
  [6] = {.lex_state = 49},
  [7] = {.lex_state = 49},
  [8] = {.lex_state = 2},
  [9] = {.lex_state = 49},
  [10] = {.lex_state = 49},
  [11] = {.lex_state = 49},
  [12] = {.lex_state = 2},
  [13] = {.lex_state = 49},
  [14] = {.lex_state = 49},
  [15] = {.lex_state = 49},
  [16] = {.lex_state = 49},
  [17] = {.lex_state = 49},
  [18] = {.lex_state = 49},
  [19] = {.lex_state = 49},
  [20] = {.lex_state = 49},
  [21] = {.lex_state = 49},
  [22] = {.lex_state = 49},
  [23] = {.lex_state = 49},
  [24] = {.lex_state = 2},
  [25] = {.lex_state = 49},
  [26] = {.lex_state = 49},
  [27] = {.lex_state = 3},
  [28] = {.lex_state = 3},
  [29] = {.lex_state = 3},
  [30] = {.lex_state = 3},
  [31] = {.lex_state = 3},
  [32] = {.lex_state = 3},
  [33] = {.lex_state = 3},
  [34] = {.lex_state = 3},
  [35] = {.lex_state = 49},
  [36] = {.lex_state = 3},
  [37] = {.lex_state = 3},
  [38] = {.lex_state = 3},
  [39] = {.lex_state = 3},
  [40] = {.lex_state = 3},
  [41] = {.lex_state = 3},
  [42] = {.lex_state = 6},
  [43] = {.lex_state = 6},
  [44] = {.lex_state = 6},
  [45] = {.lex_state = 6},
  [46] = {.lex_state = 6},
  [47] = {.lex_state = 6},
  [48] = {.lex_state = 6},
  [49] = {.lex_state = 6},
  [50] = {.lex_state = 6},
  [51] = {.lex_state = 6},
  [52] = {.lex_state = 6},
  [53] = {.lex_state = 6},
  [54] = {.lex_state = 6},
  [55] = {.lex_state = 6},
  [56] = {.lex_state = 49},
  [57] = {.lex_state = 49},
  [58] = {.lex_state = 49},
  [59] = {.lex_state = 49},
  [60] = {.lex_state = 49},
  [61] = {.lex_state = 49},
  [62] = {.lex_state = 49},
  [63] = {.lex_state = 49},
  [64] = {.lex_state = 49},
  [65] = {.lex_state = 49},
  [66] = {.lex_state = 49},
  [67] = {.lex_state = 49},
  [68] = {.lex_state = 49},
  [69] = {.lex_state = 49},
  [70] = {.lex_state = 49},
  [71] = {.lex_state = 49},
  [72] = {.lex_state = 49},
  [73] = {.lex_state = 49},
  [74] = {.lex_state = 49},
  [75] = {.lex_state = 49},
  [76] = {.lex_state = 49},
  [77] = {.lex_state = 49},
  [78] = {.lex_state = 49},
  [79] = {.lex_state = 49},
  [80] = {.lex_state = 49},
  [81] = {.lex_state = 49},
  [82] = {.lex_state = 49},
  [83] = {.lex_state = 49},
  [84] = {.lex_state = 49},
  [85] = {.lex_state = 49},
  [86] = {.lex_state = 49},
  [87] = {.lex_state = 49},
  [88] = {.lex_state = 49},
  [89] = {.lex_state = 49},
  [90] = {.lex_state = 49},
  [91] = {.lex_state = 49},
  [92] = {.lex_state = 49},
  [93] = {.lex_state = 49},
  [94] = {.lex_state = 49},
  [95] = {.lex_state = 49},
  [96] = {.lex_state = 49},
  [97] = {.lex_state = 49},
  [98] = {.lex_state = 49},
  [99] = {.lex_state = 49},
  [100] = {.lex_state = 49},
  [101] = {.lex_state = 49},
  [102] = {.lex_state = 49},
  [103] = {.lex_state = 49},
  [104] = {.lex_state = 49},
  [105] = {.lex_state = 49},
  [106] = {.lex_state = 49},
  [107] = {.lex_state = 49},
  [108] = {.lex_state = 49},
  [109] = {.lex_state = 49},
  [110] = {.lex_state = 49},
  [111] = {.lex_state = 49},
  [112] = {.lex_state = 49},
  [113] = {.lex_state = 49},
  [114] = {.lex_state = 49},
  [115] = {.lex_state = 49},
  [116] = {.lex_state = 49},
  [117] = {.lex_state = 49},
  [118] = {.lex_state = 49},
  [119] = {.lex_state = 49},
  [120] = {.lex_state = 49},
  [121] = {.lex_state = 49},
  [122] = {.lex_state = 49},
  [123] = {.lex_state = 49},
  [124] = {.lex_state = 49},
  [125] = {.lex_state = 49},
  [126] = {.lex_state = 49},
  [127] = {.lex_state = 49},
  [128] = {.lex_state = 49},
  [129] = {.lex_state = 49},
  [130] = {.lex_state = 49},
  [131] = {.lex_state = 49},
  [132] = {.lex_state = 49},
  [133] = {.lex_state = 47},
  [134] = {.lex_state = 47},
  [135] = {.lex_state = 49},
  [136] = {.lex_state = 49},
  [137] = {.lex_state = 49},
  [138] = {.lex_state = 49},
  [139] = {.lex_state = 49},
  [140] = {.lex_state = 49},
  [141] = {.lex_state = 49},
  [142] = {.lex_state = 49},
  [143] = {.lex_state = 49},
  [144] = {.lex_state = 49},
  [145] = {.lex_state = 49},
  [146] = {.lex_state = 49},
  [147] = {.lex_state = 49},
  [148] = {.lex_state = 49},
  [149] = {.lex_state = 49},
  [150] = {.lex_state = 49},
  [151] = {.lex_state = 49},
  [152] = {.lex_state = 49},
  [153] = {.lex_state = 49},
  [154] = {.lex_state = 49},
  [155] = {.lex_state = 49},
  [156] = {.lex_state = 49},
  [157] = {.lex_state = 49},
  [158] = {.lex_state = 49},
  [159] = {.lex_state = 49},
  [160] = {.lex_state = 49},
  [161] = {.lex_state = 49},
  [162] = {.lex_state = 49},
  [163] = {.lex_state = 49},
  [164] = {.lex_state = 49},
  [165] = {.lex_state = 49},
  [166] = {.lex_state = 49},
  [167] = {.lex_state = 49},
  [168] = {.lex_state = 49},
  [169] = {.lex_state = 49},
  [170] = {.lex_state = 49},
  [171] = {.lex_state = 49},
  [172] = {.lex_state = 49},
  [173] = {.lex_state = 49},
  [174] = {.lex_state = 49},
  [175] = {.lex_state = 49},
  [176] = {.lex_state = 49},
  [177] = {.lex_state = 49},
  [178] = {.lex_state = 49},
  [179] = {.lex_state = 49},
  [180] = {.lex_state = 49},
  [181] = {.lex_state = 49},
  [182] = {.lex_state = 49},
  [183] = {.lex_state = 49},
  [184] = {.lex_state = 49},
  [185] = {.lex_state = 49},
  [186] = {.lex_state = 49},
  [187] = {.lex_state = 49},
  [188] = {.lex_state = 49},
  [189] = {.lex_state = 49},
  [190] = {.lex_state = 49},
  [191] = {.lex_state = 49},
  [192] = {.lex_state = 49},
  [193] = {.lex_state = 49},
  [194] = {.lex_state = 49},
  [195] = {.lex_state = 49},
  [196] = {.lex_state = 49},
  [197] = {.lex_state = 49},
  [198] = {.lex_state = 49},
  [199] = {.lex_state = 49},
  [200] = {.lex_state = 49},
  [201] = {.lex_state = 49},
  [202] = {.lex_state = 49},
  [203] = {.lex_state = 49},
  [204] = {.lex_state = 49},
  [205] = {.lex_state = 49},
  [206] = {.lex_state = 49},
  [207] = {.lex_state = 49},
  [208] = {.lex_state = 49},
  [209] = {.lex_state = 49},
  [210] = {.lex_state = 49},
  [211] = {.lex_state = 49},
  [212] = {.lex_state = 49},
  [213] = {.lex_state = 49},
  [214] = {.lex_state = 49},
  [215] = {.lex_state = 49},
  [216] = {.lex_state = 49},
  [217] = {.lex_state = 49},
  [218] = {.lex_state = 49},
  [219] = {.lex_state = 49},
  [220] = {.lex_state = 49},
  [221] = {.lex_state = 49},
  [222] = {.lex_state = 49},
  [223] = {.lex_state = 49},
  [224] = {.lex_state = 49},
  [225] = {.lex_state = 49},
  [226] = {.lex_state = 49},
  [227] = {.lex_state = 46},
  [228] = {.lex_state = 49},
  [229] = {.lex_state = 46},
  [230] = {.lex_state = 49},
  [231] = {.lex_state = 49},
  [232] = {.lex_state = 49},
  [233] = {.lex_state = 49},
  [234] = {.lex_state = 46},
  [235] = {.lex_state = 49},
  [236] = {.lex_state = 49},
  [237] = {.lex_state = 49},
  [238] = {.lex_state = 47},
  [239] = {.lex_state = 49},
  [240] = {.lex_state = 47},
  [241] = {.lex_state = 46},
  [242] = {.lex_state = 47},
  [243] = {.lex_state = 49},
  [244] = {.lex_state = 49},
  [245] = {.lex_state = 49},
  [246] = {.lex_state = 48},
  [247] = {.lex_state = 47},
  [248] = {.lex_state = 49},
  [249] = {.lex_state = 49},
  [250] = {.lex_state = 49},
  [251] = {.lex_state = 49},
  [252] = {.lex_state = 49},
  [253] = {.lex_state = 49},
  [254] = {.lex_state = 49},
  [255] = {.lex_state = 49},
  [256] = {.lex_state = 49},
  [257] = {.lex_state = 49},
  [258] = {.lex_state = 49},
  [259] = {.lex_state = 49},
  [260] = {.lex_state = 49},
  [261] = {.lex_state = 49},
  [262] = {.lex_state = 49},
  [263] = {.lex_state = 49},
  [264] = {.lex_state = 49},
  [265] = {.lex_state = 49},
  [266] = {.lex_state = 49},
  [267] = {.lex_state = 49},
  [268] = {.lex_state = 49},
  [269] = {.lex_state = 49},
  [270] = {.lex_state = 49},
  [271] = {.lex_state = 49},
  [272] = {.lex_state = 49},
  [273] = {.lex_state = 49},
  [274] = {.lex_state = 49},
  [275] = {.lex_state = 49},
  [276] = {.lex_state = 49},
  [277] = {.lex_state = 49},
  [278] = {.lex_state = 49},
  [279] = {.lex_state = 49},
  [280] = {.lex_state = 49},
  [281] = {.lex_state = 49},
  [282] = {.lex_state = 49},
  [283] = {.lex_state = 49},
  [284] = {.lex_state = 49},
  [285] = {.lex_state = 49},
  [286] = {.lex_state = 49},
  [287] = {.lex_state = 49},
  [288] = {.lex_state = 49},
  [289] = {.lex_state = 49},
  [290] = {.lex_state = 49},
  [291] = {.lex_state = 49},
  [292] = {.lex_state = 49},
  [293] = {.lex_state = 49},
  [294] = {.lex_state = 49},
  [295] = {.lex_state = 49},
  [296] = {.lex_state = 49},
  [297] = {.lex_state = 49},
  [298] = {.lex_state = 49},
  [299] = {.lex_state = 49},
  [300] = {.lex_state = 49},
  [301] = {.lex_state = 49},
  [302] = {.lex_state = 49},
  [303] = {.lex_state = 49},
  [304] = {.lex_state = 4},
  [305] = {.lex_state = 46},
  [306] = {.lex_state = 1},
  [307] = {.lex_state = 5},
  [308] = {.lex_state = 4},
  [309] = {.lex_state = 4},
  [310] = {.lex_state = 46},
  [311] = {.lex_state = 47},
  [312] = {.lex_state = 4},
  [313] = {.lex_state = 4},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 49},
  [316] = {.lex_state = 3},
  [317] = {.lex_state = 3},
  [318] = {.lex_state = 3},
  [319] = {.lex_state = 3},
  [320] = {.lex_state = 3},
  [321] = {.lex_state = 3},
  [322] = {.lex_state = 3},
  [323] = {.lex_state = 3},
  [324] = {.lex_state = 6},
  [325] = {.lex_state = 2},
  [326] = {.lex_state = 47},
  [327] = {.lex_state = 6},
  [328] = {.lex_state = 6},
  [329] = {.lex_state = 6},
  [330] = {.lex_state = 6},
  [331] = {.lex_state = 6},
  [332] = {.lex_state = 6},
  [333] = {.lex_state = 6},
  [334] = {.lex_state = 49},
  [335] = {.lex_state = 6},
  [336] = {.lex_state = 6},
  [337] = {.lex_state = 6},
  [338] = {.lex_state = 6},
  [339] = {.lex_state = 6},
  [340] = {.lex_state = 7},
  [341] = {.lex_state = 48},
  [342] = {.lex_state = 7},
  [343] = {.lex_state = 6},
  [344] = {.lex_state = 49},
  [345] = {.lex_state = 49},
  [346] = {.lex_state = 2},
  [347] = {.lex_state = 49},
  [348] = {.lex_state = 6},
  [349] = {.lex_state = 6},
  [350] = {.lex_state = 6},
  [351] = {.lex_state = 49},
  [352] = {.lex_state = 49},
  [353] = {.lex_state = 49},
  [354] = {.lex_state = 49},
  [355] = {.lex_state = 49},
  [356] = {.lex_state = 49},
  [357] = {.lex_state = 49},
  [358] = {.lex_state = 49},
  [359] = {.lex_state = 49},
  [360] = {.lex_state = 49},
  [361] = {.lex_state = 49},
  [362] = {.lex_state = 49},
  [363] = {.lex_state = 49},
  [364] = {.lex_state = 49},
  [365] = {.lex_state = 49},
  [366] = {.lex_state = 49},
  [367] = {.lex_state = 49},
  [368] = {.lex_state = 49},
  [369] = {.lex_state = 49},
  [370] = {.lex_state = 49},
  [371] = {.lex_state = 8},
  [372] = {.lex_state = 8},
  [373] = {.lex_state = 49},
  [374] = {.lex_state = 49},
  [375] = {.lex_state = 8},
  [376] = {.lex_state = 49},
  [377] = {.lex_state = 49},
  [378] = {.lex_state = 49},
  [379] = {.lex_state = 49},
  [380] = {.lex_state = 49},
  [381] = {.lex_state = 49},
  [382] = {.lex_state = 49},
  [383] = {.lex_state = 49},
  [384] = {.lex_state = 49},
  [385] = {.lex_state = 49},
  [386] = {.lex_state = 49},
  [387] = {.lex_state = 8},
  [388] = {.lex_state = 21},
  [389] = {.lex_state = 9},
  [390] = {.lex_state = 9},
  [391] = {.lex_state = 9},
  [392] = {.lex_state = 21},
  [393] = {.lex_state = 49},
  [394] = {.lex_state = 21},
  [395] = {.lex_state = 9},
  [396] = {.lex_state = 9},
  [397] = {.lex_state = 9},
  [398] = {.lex_state = 9},
  [399] = {.lex_state = 9},
  [400] = {.lex_state = 9},
  [401] = {.lex_state = 17},
  [402] = {.lex_state = 17},
  [403] = {.lex_state = 17},
  [404] = {.lex_state = 17},
  [405] = {.lex_state = 17},
  [406] = {.lex_state = 17},
  [407] = {.lex_state = 17},
  [408] = {.lex_state = 17},
  [409] = {.lex_state = 17},
  [410] = {.lex_state = 17},
  [411] = {.lex_state = 15},
  [412] = {.lex_state = 17},
  [413] = {.lex_state = 17},
  [414] = {.lex_state = 15},
  [415] = {.lex_state = 17},
  [416] = {.lex_state = 17},
  [417] = {.lex_state = 17},
  [418] = {.lex_state = 17},
  [419] = {.lex_state = 17},
  [420] = {.lex_state = 17},
  [421] = {.lex_state = 17},
  [422] = {.lex_state = 17},
  [423] = {.lex_state = 15},
  [424] = {.lex_state = 15},
  [425] = {.lex_state = 17},
  [426] = {.lex_state = 15},
  [427] = {.lex_state = 17},
  [428] = {.lex_state = 15},
  [429] = {.lex_state = 17},
  [430] = {.lex_state = 17},
  [431] = {.lex_state = 15},
  [432] = {.lex_state = 17},
  [433] = {.lex_state = 17},
  [434] = {.lex_state = 17},
  [435] = {.lex_state = 17},
  [436] = {.lex_state = 15},
  [437] = {.lex_state = 15},
  [438] = {.lex_state = 15},
  [439] = {.lex_state = 15},
  [440] = {.lex_state = 17},
  [441] = {.lex_state = 17},
  [442] = {.lex_state = 17},
  [443] = {.lex_state = 17},
  [444] = {.lex_state = 13},
  [445] = {.lex_state = 17},
  [446] = {.lex_state = 17},
  [447] = {.lex_state = 13},
  [448] = {.lex_state = 17},
  [449] = {.lex_state = 13},
  [450] = {.lex_state = 13},
  [451] = {.lex_state = 13},
  [452] = {.lex_state = 13},
  [453] = {.lex_state = 17},
  [454] = {.lex_state = 13},
  [455] = {.lex_state = 17},
  [456] = {.lex_state = 13},
  [457] = {.lex_state = 13},
  [458] = {.lex_state = 18},
  [459] = {.lex_state = 17},
  [460] = {.lex_state = 18},
  [461] = {.lex_state = 18},
  [462] = {.lex_state = 10},
  [463] = {.lex_state = 16},
  [464] = {.lex_state = 10},
  [465] = {.lex_state = 16},
  [466] = {.lex_state = 10},
  [467] = {.lex_state = 16},
  [468] = {.lex_state = 11},
  [469] = {.lex_state = 18},
  [470] = {.lex_state = 16},
  [471] = {.lex_state = 17},
  [472] = {.lex_state = 11},
  [473] = {.lex_state = 16},
  [474] = {.lex_state = 11},
  [475] = {.lex_state = 10},
  [476] = {.lex_state = 21},
  [477] = {.lex_state = 21},
  [478] = {.lex_state = 12},
  [479] = {.lex_state = 21},
  [480] = {.lex_state = 21},
  [481] = {.lex_state = 21},
  [482] = {.lex_state = 21},
  [483] = {.lex_state = 21},
  [484] = {.lex_state = 19},
  [485] = {.lex_state = 21},
  [486] = {.lex_state = 21},
  [487] = {.lex_state = 11},
  [488] = {.lex_state = 17},
  [489] = {.lex_state = 17},
  [490] = {.lex_state = 17},
  [491] = {.lex_state = 17},
  [492] = {.lex_state = 17},
  [493] = {.lex_state = 17},
  [494] = {.lex_state = 17},
  [495] = {.lex_state = 17},
  [496] = {.lex_state = 17},
  [497] = {.lex_state = 17},
  [498] = {.lex_state = 17},
  [499] = {.lex_state = 17},
  [500] = {.lex_state = 17},
  [501] = {.lex_state = 17},
  [502] = {.lex_state = 17},
  [503] = {.lex_state = 17},
  [504] = {.lex_state = 17},
  [505] = {.lex_state = 17},
  [506] = {.lex_state = 17},
  [507] = {.lex_state = 17},
  [508] = {.lex_state = 17},
  [509] = {.lex_state = 13},
  [510] = {.lex_state = 17},
  [511] = {.lex_state = 13},
  [512] = {.lex_state = 17},
  [513] = {.lex_state = 17},
  [514] = {.lex_state = 17},
  [515] = {.lex_state = 17},
  [516] = {.lex_state = 17},
  [517] = {.lex_state = 17},
  [518] = {.lex_state = 17},
  [519] = {.lex_state = 13},
  [520] = {.lex_state = 22},
  [521] = {.lex_state = 13},
  [522] = {.lex_state = 13},
  [523] = {.lex_state = 17},
  [524] = {.lex_state = 17},
  [525] = {.lex_state = 17},
  [526] = {.lex_state = 17},
  [527] = {.lex_state = 17},
  [528] = {.lex_state = 17},
  [529] = {.lex_state = 17},
  [530] = {.lex_state = 17},
  [531] = {.lex_state = 15},
  [532] = {.lex_state = 13},
  [533] = {.lex_state = 13},
  [534] = {.lex_state = 22},
  [535] = {.lex_state = 17},
  [536] = {.lex_state = 17},
  [537] = {.lex_state = 17},
  [538] = {.lex_state = 17},
  [539] = {.lex_state = 13},
  [540] = {.lex_state = 17},
  [541] = {.lex_state = 17},
  [542] = {.lex_state = 17},
  [543] = {.lex_state = 17},
  [544] = {.lex_state = 15},
  [545] = {.lex_state = 13},
  [546] = {.lex_state = 15},
  [547] = {.lex_state = 13},
  [548] = {.lex_state = 17},
  [549] = {.lex_state = 13},
  [550] = {.lex_state = 15},
  [551] = {.lex_state = 15},
  [552] = {.lex_state = 17},
  [553] = {.lex_state = 13},
  [554] = {.lex_state = 17},
  [555] = {.lex_state = 15},
  [556] = {.lex_state = 15},
  [557] = {.lex_state = 17},
  [558] = {.lex_state = 17},
  [559] = {.lex_state = 13},
  [560] = {.lex_state = 13},
  [561] = {.lex_state = 13},
  [562] = {.lex_state = 22},
  [563] = {.lex_state = 17},
  [564] = {.lex_state = 17},
  [565] = {.lex_state = 13},
  [566] = {.lex_state = 17},
  [567] = {.lex_state = 13},
  [568] = {.lex_state = 13},
  [569] = {.lex_state = 13},
  [570] = {.lex_state = 13},
  [571] = {.lex_state = 13},
  [572] = {.lex_state = 13},
  [573] = {.lex_state = 13},
  [574] = {.lex_state = 13},
  [575] = {.lex_state = 13},
  [576] = {.lex_state = 13},
  [577] = {.lex_state = 13},
  [578] = {.lex_state = 13},
  [579] = {.lex_state = 13},
  [580] = {.lex_state = 13},
  [581] = {.lex_state = 17},
  [582] = {.lex_state = 17},
  [583] = {.lex_state = 13},
  [584] = {.lex_state = 13},
  [585] = {.lex_state = 13},
  [586] = {.lex_state = 13},
  [587] = {.lex_state = 17},
  [588] = {.lex_state = 13},
  [589] = {.lex_state = 13},
  [590] = {.lex_state = 17},
  [591] = {.lex_state = 13},
  [592] = {.lex_state = 13},
  [593] = {.lex_state = 13},
  [594] = {.lex_state = 13},
  [595] = {.lex_state = 13},
  [596] = {.lex_state = 13},
  [597] = {.lex_state = 13},
  [598] = {.lex_state = 13},
  [599] = {.lex_state = 13},
  [600] = {.lex_state = 13},
  [601] = {.lex_state = 17},
  [602] = {.lex_state = 14},
  [603] = {.lex_state = 17},
  [604] = {.lex_state = 17},
  [605] = {.lex_state = 14},
  [606] = {.lex_state = 17},
  [607] = {.lex_state = 14},
  [608] = {.lex_state = 17},
  [609] = {.lex_state = 14},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 14},
  [612] = {.lex_state = 14},
  [613] = {.lex_state = 17},
  [614] = {.lex_state = 14},
  [615] = {.lex_state = 17},
  [616] = {.lex_state = 23},
  [617] = {.lex_state = 14},
  [618] = {.lex_state = 14},
  [619] = {.lex_state = 14},
  [620] = {.lex_state = 14},
  [621] = {.lex_state = 14},
  [622] = {.lex_state = 22},
  [623] = {.lex_state = 14},
  [624] = {.lex_state = 17},
  [625] = {.lex_state = 22},
  [626] = {.lex_state = 23},
  [627] = {.lex_state = 23},
  [628] = {.lex_state = 23},
  [629] = {.lex_state = 23},
  [630] = {.lex_state = 23},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 23},
  [634] = {.lex_state = 17},
  [635] = {.lex_state = 17},
  [636] = {.lex_state = 23},
  [637] = {.lex_state = 23},
  [638] = {.lex_state = 23},
  [639] = {.lex_state = 23},
  [640] = {.lex_state = 23},
  [641] = {.lex_state = 23},
  [642] = {.lex_state = 23},
  [643] = {.lex_state = 23},
  [644] = {.lex_state = 23},
  [645] = {.lex_state = 23},
  [646] = {.lex_state = 23},
  [647] = {.lex_state = 23},
  [648] = {.lex_state = 23},
  [649] = {.lex_state = 23},
  [650] = {.lex_state = 17},
  [651] = {.lex_state = 17},
  [652] = {.lex_state = 17},
  [653] = {.lex_state = 17},
  [654] = {.lex_state = 17},
  [655] = {.lex_state = 23},
  [656] = {.lex_state = 23},
  [657] = {.lex_state = 23},
  [658] = {.lex_state = 23},
  [659] = {.lex_state = 17},
  [660] = {.lex_state = 23},
  [661] = {.lex_state = 23},
  [662] = {.lex_state = 23},
  [663] = {.lex_state = 17},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 23},
  [667] = {.lex_state = 17},
  [668] = {.lex_state = 17},
  [669] = {.lex_state = 23},
  [670] = {.lex_state = 23},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 23},
  [673] = {.lex_state = 23},
  [674] = {.lex_state = 23},
  [675] = {.lex_state = 23},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 23},
  [679] = {.lex_state = 17},
  [680] = {.lex_state = 17},
  [681] = {.lex_state = 23},
  [682] = {.lex_state = 23},
  [683] = {.lex_state = 23},
  [684] = {.lex_state = 23},
  [685] = {.lex_state = 23},
  [686] = {.lex_state = 23},
  [687] = {.lex_state = 23},
  [688] = {.lex_state = 23},
  [689] = {.lex_state = 23},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 23},
  [693] = {.lex_state = 24},
  [694] = {.lex_state = 24},
  [695] = {.lex_state = 24},
  [696] = {.lex_state = 24},
  [697] = {.lex_state = 24},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 22},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 24},
  [709] = {.lex_state = 24},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 17},
  [712] = {.lex_state = 24},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 0},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 24},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 0},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 24},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 24},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 24},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 24},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 0},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 22},
  [779] = {.lex_state = 22},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_symbol] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_each] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_hashfn] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_collect] = ACTIONS(1),
    [anon_sym_icollect] = ACTIONS(1),
    [anon_sym_accumulate] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [sym_nil] = ACTIONS(1),
    [sym_nil_safe] = ACTIONS(1),
    [sym_vararg] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [aux_sym_string_token1] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(765),
    [sym__sexp] = STATE(98),
    [sym__special_form] = STATE(98),
    [sym_each] = STATE(98),
    [sym_for] = STATE(98),
    [sym_let] = STATE(98),
    [sym_global] = STATE(98),
    [sym_local] = STATE(98),
    [sym_var] = STATE(98),
    [sym_set] = STATE(98),
    [sym_hashfn] = STATE(98),
    [sym_fn] = STATE(98),
    [sym_lambda] = STATE(98),
    [sym_match] = STATE(98),
    [sym_collect] = STATE(98),
    [sym_icollect] = STATE(98),
    [sym_accumulate] = STATE(98),
    [sym_quote] = STATE(98),
    [sym_list] = STATE(98),
    [sym_sequential_table] = STATE(98),
    [sym_table] = STATE(98),
    [sym__literal] = STATE(98),
    [sym_boolean] = STATE(98),
    [sym_string] = STATE(98),
    [sym_multi_symbol] = STATE(98),
    [aux_sym_program_repeat1] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_symbol] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(17),
    [anon_sym_BQUOTE] = ACTIONS(17),
    [sym_nil] = ACTIONS(19),
    [sym_nil_safe] = ACTIONS(21),
    [sym_vararg] = ACTIONS(19),
    [anon_sym_true] = ACTIONS(23),
    [anon_sym_false] = ACTIONS(23),
    [aux_sym_string_token1] = ACTIONS(25),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [sym_number] = ACTIONS(19),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__sexp] = STATE(137),
    [sym__special_form] = STATE(137),
    [sym_each] = STATE(137),
    [sym_for] = STATE(137),
    [sym_let] = STATE(137),
    [sym_global] = STATE(137),
    [sym_local] = STATE(137),
    [sym_var] = STATE(137),
    [sym_set] = STATE(137),
    [sym__non_multi_value_binding] = STATE(446),
    [sym_binding] = STATE(446),
    [sym_sequential_table_binding] = STATE(446),
    [sym_table_binding] = STATE(446),
    [sym_hashfn] = STATE(137),
    [sym_fn] = STATE(137),
    [sym_lambda] = STATE(137),
    [sym_match] = STATE(137),
    [sym_collect] = STATE(137),
    [sym_icollect] = STATE(137),
    [sym_accumulate] = STATE(137),
    [sym_quote] = STATE(137),
    [sym_list] = STATE(137),
    [sym_sequential_table] = STATE(137),
    [sym_table] = STATE(137),
    [sym__literal] = STATE(137),
    [sym_boolean] = STATE(137),
    [sym_string] = STATE(137),
    [sym_multi_symbol] = STATE(341),
    [sym_multi_symbol_method] = STATE(137),
    [aux_sym_multi_value_binding_repeat1] = STATE(446),
    [sym_symbol] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_each] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RPAREN] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_global] = ACTIONS(41),
    [anon_sym_local] = ACTIONS(43),
    [anon_sym_var] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_hashfn] = ACTIONS(51),
    [anon_sym_POUND] = ACTIONS(15),
    [anon_sym_fn] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(55),
    [anon_sym_] = ACTIONS(55),
    [anon_sym_match] = ACTIONS(57),
    [anon_sym_collect] = ACTIONS(59),
    [anon_sym_icollect] = ACTIONS(61),
    [anon_sym_accumulate] = ACTIONS(63),
    [anon_sym_quote] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(17),
    [anon_sym_BQUOTE] = ACTIONS(17),
    [sym_nil] = ACTIONS(67),
    [sym_nil_safe] = ACTIONS(69),
    [sym_vararg] = ACTIONS(67),
    [anon_sym_true] = ACTIONS(23),
    [anon_sym_false] = ACTIONS(23),
    [aux_sym_string_token1] = ACTIONS(25),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [sym_number] = ACTIONS(67),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      sym_symbol,
    ACTIONS(73), 1,
      anon_sym_each,
    ACTIONS(75), 1,
      anon_sym_for,
    ACTIONS(77), 1,
      anon_sym_let,
    ACTIONS(79), 1,
      anon_sym_global,
    ACTIONS(81), 1,
      anon_sym_local,
    ACTIONS(83), 1,
      anon_sym_var,
    ACTIONS(85), 1,
      anon_sym_set,
    ACTIONS(87), 1,
      anon_sym_hashfn,
    ACTIONS(89), 1,
      anon_sym_fn,
    ACTIONS(93), 1,
      anon_sym_match,
    ACTIONS(95), 1,
      anon_sym_collect,
    ACTIONS(97), 1,
      anon_sym_icollect,
    ACTIONS(99), 1,
      anon_sym_accumulate,
    ACTIONS(101), 1,
      anon_sym_quote,
    ACTIONS(105), 1,
      sym_nil_safe,
    STATE(341), 1,
      sym_multi_symbol,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(91), 2,
      anon_sym_lambda,
      anon_sym_,
    ACTIONS(103), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(107), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [116] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      sym_symbol,
    ACTIONS(107), 1,
      anon_sym_each,
    ACTIONS(109), 1,
      anon_sym_for,
    ACTIONS(111), 1,
      anon_sym_let,
    ACTIONS(113), 1,
      anon_sym_global,
    ACTIONS(115), 1,
      anon_sym_local,
    ACTIONS(117), 1,
      anon_sym_var,
    ACTIONS(119), 1,
      anon_sym_set,
    ACTIONS(121), 1,
      anon_sym_hashfn,
    ACTIONS(123), 1,
      anon_sym_fn,
    ACTIONS(127), 1,
      anon_sym_match,
    ACTIONS(129), 1,
      anon_sym_collect,
    ACTIONS(131), 1,
      anon_sym_icollect,
    ACTIONS(133), 1,
      anon_sym_accumulate,
    ACTIONS(135), 1,
      anon_sym_quote,
    ACTIONS(139), 1,
      sym_nil_safe,
    STATE(341), 1,
      sym_multi_symbol,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(125), 2,
      anon_sym_lambda,
      anon_sym_,
    ACTIONS(137), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(83), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [232] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      sym_symbol,
    ACTIONS(141), 1,
      anon_sym_each,
    ACTIONS(143), 1,
      anon_sym_for,
    ACTIONS(145), 1,
      anon_sym_let,
    ACTIONS(147), 1,
      anon_sym_global,
    ACTIONS(149), 1,
      anon_sym_local,
    ACTIONS(151), 1,
      anon_sym_var,
    ACTIONS(153), 1,
      anon_sym_set,
    ACTIONS(155), 1,
      anon_sym_hashfn,
    ACTIONS(157), 1,
      anon_sym_fn,
    ACTIONS(161), 1,
      anon_sym_match,
    ACTIONS(163), 1,
      anon_sym_collect,
    ACTIONS(165), 1,
      anon_sym_icollect,
    ACTIONS(167), 1,
      anon_sym_accumulate,
    ACTIONS(169), 1,
      anon_sym_quote,
    ACTIONS(173), 1,
      sym_nil_safe,
    STATE(341), 1,
      sym_multi_symbol,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(159), 2,
      anon_sym_lambda,
      anon_sym_,
    ACTIONS(171), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(111), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [348] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(31), 1,
      anon_sym_each,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_let,
    ACTIONS(41), 1,
      anon_sym_global,
    ACTIONS(43), 1,
      anon_sym_local,
    ACTIONS(45), 1,
      anon_sym_var,
    ACTIONS(47), 1,
      anon_sym_set,
    ACTIONS(51), 1,
      anon_sym_hashfn,
    ACTIONS(53), 1,
      anon_sym_fn,
    ACTIONS(57), 1,
      anon_sym_match,
    ACTIONS(59), 1,
      anon_sym_collect,
    ACTIONS(61), 1,
      anon_sym_icollect,
    ACTIONS(63), 1,
      anon_sym_accumulate,
    ACTIONS(65), 1,
      anon_sym_quote,
    ACTIONS(69), 1,
      sym_nil_safe,
    ACTIONS(71), 1,
      sym_symbol,
    STATE(341), 1,
      sym_multi_symbol,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(55), 2,
      anon_sym_lambda,
      anon_sym_,
    ACTIONS(67), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(137), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [464] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(738), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [543] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(197), 1,
      sym_symbol,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(201), 1,
      anon_sym_RBRACK,
    ACTIONS(203), 1,
      anon_sym_AMP,
    ACTIONS(205), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(207), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(423), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
    STATE(57), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [624] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(739), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [703] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(780), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [782] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(737), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [861] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(197), 1,
      sym_symbol,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(205), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      sym_nil_safe,
    ACTIONS(211), 1,
      anon_sym_RBRACK,
    ACTIONS(213), 1,
      anon_sym_AMP,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(207), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(414), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
    STATE(57), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [942] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(736), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1021] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(734), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1100] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(722), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1179] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(720), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1258] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(719), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1337] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(717), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1416] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(705), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1495] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(757), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1574] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(703), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1653] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(702), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1732] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(700), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1811] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(197), 1,
      sym_symbol,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(205), 1,
      anon_sym_LBRACE,
    ACTIONS(215), 1,
      anon_sym_RBRACK,
    ACTIONS(217), 1,
      anon_sym_AMP,
    ACTIONS(221), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(219), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(438), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
    STATE(139), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [1892] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(189), 1,
      sym_nil_safe,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    STATE(740), 1,
      sym_iter_bindings,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(187), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(26), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(641), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [1971] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym_symbol,
    ACTIONS(177), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    ACTIONS(225), 1,
      sym_nil_safe,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(223), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(239), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
    STATE(655), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [2047] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(227), 1,
      sym_symbol,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(235), 1,
      anon_sym_COLON,
    ACTIONS(237), 1,
      anon_sym_AMPas,
    ACTIONS(239), 1,
      anon_sym_RBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    STATE(36), 1,
      aux_sym_table_binding_repeat1,
    STATE(167), 1,
      sym_string,
    STATE(168), 1,
      sym_multi_symbol,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(447), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 22,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
  [2134] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(227), 1,
      sym_symbol,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(235), 1,
      anon_sym_COLON,
    ACTIONS(237), 1,
      anon_sym_AMPas,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(251), 1,
      anon_sym_RBRACE,
    STATE(37), 1,
      aux_sym_table_binding_repeat1,
    STATE(167), 1,
      sym_string,
    STATE(168), 1,
      sym_multi_symbol,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(447), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 22,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
  [2221] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(227), 1,
      sym_symbol,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(235), 1,
      anon_sym_COLON,
    ACTIONS(237), 1,
      anon_sym_AMPas,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(253), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      aux_sym_table_binding_repeat1,
    STATE(167), 1,
      sym_string,
    STATE(168), 1,
      sym_multi_symbol,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(451), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 22,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
  [2308] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(257), 1,
      anon_sym_RBRACE,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    STATE(40), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [2385] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(263), 1,
      anon_sym_RBRACE,
    STATE(37), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [2462] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(265), 1,
      anon_sym_RBRACE,
    STATE(34), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [2539] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(267), 1,
      anon_sym_RBRACE,
    STATE(34), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [2616] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 1,
      sym_symbol,
    ACTIONS(272), 1,
      anon_sym_LPAREN,
    ACTIONS(275), 1,
      anon_sym_LBRACK,
    ACTIONS(278), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_RBRACE,
    ACTIONS(286), 1,
      anon_sym_POUND,
    ACTIONS(295), 1,
      sym_nil_safe,
    ACTIONS(301), 1,
      aux_sym_string_token1,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(34), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(281), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(289), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(292), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [2693] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym_symbol,
    ACTIONS(312), 1,
      anon_sym_LPAREN,
    ACTIONS(315), 1,
      anon_sym_LBRACK,
    ACTIONS(318), 1,
      anon_sym_LBRACE,
    ACTIONS(321), 1,
      anon_sym_POUND,
    ACTIONS(330), 1,
      sym_nil_safe,
    ACTIONS(336), 1,
      aux_sym_string_token1,
    ACTIONS(339), 1,
      anon_sym_DQUOTE,
    ACTIONS(324), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(333), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(307), 3,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(327), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [2766] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(342), 1,
      anon_sym_RBRACE,
    STATE(34), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [2843] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(344), 1,
      anon_sym_RBRACE,
    STATE(34), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [2920] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      anon_sym_RBRACE,
    STATE(33), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [2997] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(348), 1,
      anon_sym_RBRACE,
    STATE(36), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3074] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(350), 1,
      anon_sym_RBRACE,
    STATE(34), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3151] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      sym_nil_safe,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_RBRACE,
    STATE(32), 1,
      aux_sym_table_binding_repeat1,
    ACTIONS(237), 2,
      anon_sym_COLON,
      anon_sym_AMPas,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(245), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(471), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3228] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(354), 1,
      anon_sym_COLON,
    ACTIONS(356), 1,
      anon_sym_RBRACE,
    ACTIONS(360), 1,
      sym_nil_safe,
    STATE(54), 1,
      aux_sym_table_assignment_repeat1,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(358), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(459), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3304] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(354), 1,
      anon_sym_COLON,
    ACTIONS(360), 1,
      sym_nil_safe,
    ACTIONS(362), 1,
      anon_sym_RBRACE,
    STATE(48), 1,
      aux_sym_table_assignment_repeat1,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(358), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(459), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3380] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_COLON,
    ACTIONS(366), 1,
      anon_sym_RBRACE,
    ACTIONS(370), 1,
      sym_nil_safe,
    STATE(50), 1,
      aux_sym_table_pattern_repeat1,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(368), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(315), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3456] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_COLON,
    ACTIONS(370), 1,
      sym_nil_safe,
    ACTIONS(372), 1,
      anon_sym_RBRACE,
    STATE(51), 1,
      aux_sym_table_pattern_repeat1,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(368), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(315), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3532] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(354), 1,
      anon_sym_COLON,
    ACTIONS(360), 1,
      sym_nil_safe,
    ACTIONS(374), 1,
      anon_sym_RBRACE,
    STATE(54), 1,
      aux_sym_table_assignment_repeat1,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(358), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(459), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3608] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_COLON,
    ACTIONS(370), 1,
      sym_nil_safe,
    ACTIONS(376), 1,
      anon_sym_RBRACE,
    STATE(45), 1,
      aux_sym_table_pattern_repeat1,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(368), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(315), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3684] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(354), 1,
      anon_sym_COLON,
    ACTIONS(360), 1,
      sym_nil_safe,
    ACTIONS(378), 1,
      anon_sym_RBRACE,
    STATE(54), 1,
      aux_sym_table_assignment_repeat1,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(358), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(459), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3760] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(354), 1,
      anon_sym_COLON,
    ACTIONS(360), 1,
      sym_nil_safe,
    ACTIONS(380), 1,
      anon_sym_RBRACE,
    STATE(42), 1,
      aux_sym_table_assignment_repeat1,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(358), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(459), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3836] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_COLON,
    ACTIONS(370), 1,
      sym_nil_safe,
    ACTIONS(382), 1,
      anon_sym_RBRACE,
    STATE(51), 1,
      aux_sym_table_pattern_repeat1,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(368), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(315), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3912] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(384), 1,
      sym_symbol,
    ACTIONS(387), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_LBRACK,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_COLON,
    ACTIONS(399), 1,
      anon_sym_RBRACE,
    ACTIONS(401), 1,
      anon_sym_POUND,
    ACTIONS(410), 1,
      sym_nil_safe,
    ACTIONS(416), 1,
      aux_sym_string_token1,
    ACTIONS(419), 1,
      anon_sym_DQUOTE,
    STATE(51), 1,
      aux_sym_table_pattern_repeat1,
    ACTIONS(404), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(413), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(407), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(315), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [3988] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_COLON,
    ACTIONS(370), 1,
      sym_nil_safe,
    ACTIONS(422), 1,
      anon_sym_RBRACE,
    STATE(51), 1,
      aux_sym_table_pattern_repeat1,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(368), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(315), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [4064] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(354), 1,
      anon_sym_COLON,
    ACTIONS(360), 1,
      sym_nil_safe,
    ACTIONS(424), 1,
      anon_sym_RBRACE,
    STATE(46), 1,
      aux_sym_table_assignment_repeat1,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(358), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(459), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [4140] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 1,
      sym_symbol,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(432), 1,
      anon_sym_LBRACK,
    ACTIONS(435), 1,
      anon_sym_LBRACE,
    ACTIONS(438), 1,
      anon_sym_COLON,
    ACTIONS(441), 1,
      anon_sym_RBRACE,
    ACTIONS(443), 1,
      anon_sym_POUND,
    ACTIONS(452), 1,
      sym_nil_safe,
    ACTIONS(458), 1,
      aux_sym_string_token1,
    ACTIONS(461), 1,
      anon_sym_DQUOTE,
    STATE(54), 1,
      aux_sym_table_assignment_repeat1,
    ACTIONS(446), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(455), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(449), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(459), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [4216] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_COLON,
    ACTIONS(370), 1,
      sym_nil_safe,
    ACTIONS(464), 1,
      anon_sym_RBRACE,
    STATE(52), 1,
      aux_sym_table_pattern_repeat1,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(368), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(315), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [4292] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(466), 1,
      anon_sym_RPAREN,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [4363] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(472), 1,
      anon_sym_RBRACK,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [4434] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(474), 1,
      anon_sym_RPAREN,
    ACTIONS(478), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(476), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(62), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [4505] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(480), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [4576] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(482), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [4647] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(484), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [4718] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(486), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [4789] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(488), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [4860] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(490), 1,
      anon_sym_RPAREN,
    ACTIONS(494), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(492), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(67), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [4931] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(496), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5002] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(498), 1,
      anon_sym_RPAREN,
    ACTIONS(502), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(500), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(108), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5073] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(504), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5144] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(506), 1,
      anon_sym_RPAREN,
    ACTIONS(510), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(508), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(113), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5215] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(512), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(514), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(60), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5286] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5357] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(520), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5428] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(522), 1,
      anon_sym_RBRACK,
    ACTIONS(526), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(524), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(87), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5499] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(528), 1,
      anon_sym_RPAREN,
    ACTIONS(532), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(530), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(63), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5570] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(534), 1,
      anon_sym_RPAREN,
    ACTIONS(538), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(536), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(65), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5641] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(540), 1,
      anon_sym_RPAREN,
    ACTIONS(544), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(542), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(97), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5712] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5783] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(548), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5854] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(550), 1,
      anon_sym_RPAREN,
    ACTIONS(554), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(552), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(77), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5925] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(556), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [5996] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_RPAREN,
    ACTIONS(562), 1,
      sym_nil_safe,
    STATE(140), 1,
      sym_string,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(560), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(141), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6069] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(564), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6140] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(566), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6211] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(568), 1,
      anon_sym_RPAREN,
    ACTIONS(572), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(570), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(101), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6282] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(574), 1,
      anon_sym_RPAREN,
    ACTIONS(578), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(576), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(79), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6353] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(580), 1,
      anon_sym_RPAREN,
    ACTIONS(584), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(582), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(81), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6424] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(586), 1,
      anon_sym_RPAREN,
    ACTIONS(590), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(588), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(82), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6495] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(592), 1,
      anon_sym_RBRACK,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6566] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(594), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6637] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(596), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6708] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(598), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6779] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(600), 1,
      anon_sym_RPAREN,
    ACTIONS(604), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(602), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(104), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6850] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_RPAREN,
    ACTIONS(610), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(608), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(105), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6921] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(612), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [6992] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(614), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7063] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(616), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7134] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(618), 1,
      anon_sym_RPAREN,
    ACTIONS(622), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(620), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(70), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7205] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(624), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7276] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(626), 1,
      ts_builtin_sym_end,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7347] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(628), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7418] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(630), 1,
      anon_sym_RPAREN,
    ACTIONS(634), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(632), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(89), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7489] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(636), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7560] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      anon_sym_RPAREN,
    ACTIONS(642), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(640), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(76), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7631] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(644), 1,
      anon_sym_RPAREN,
    ACTIONS(648), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(646), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(90), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7702] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(650), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7773] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(652), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7844] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(654), 1,
      anon_sym_RPAREN,
    ACTIONS(658), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(656), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(115), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7915] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      anon_sym_RPAREN,
    ACTIONS(664), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(662), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(88), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [7986] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(666), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8057] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(668), 1,
      anon_sym_RBRACK,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8128] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(670), 1,
      anon_sym_RPAREN,
    ACTIONS(674), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(672), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(125), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8199] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(676), 1,
      anon_sym_RPAREN,
    ACTIONS(680), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(678), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(95), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8270] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(682), 1,
      anon_sym_RPAREN,
    ACTIONS(686), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(684), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(99), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8341] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(688), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8412] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(690), 1,
      anon_sym_RPAREN,
    ACTIONS(694), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(692), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(127), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8483] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(696), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8554] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(221), 1,
      sym_nil_safe,
    ACTIONS(698), 1,
      anon_sym_RBRACK,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(219), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(139), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8625] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(700), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8696] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(702), 1,
      anon_sym_RPAREN,
    ACTIONS(706), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(704), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(117), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8767] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(708), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8838] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(710), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8909] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(712), 1,
      anon_sym_RPAREN,
    ACTIONS(716), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(714), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(61), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [8980] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(209), 1,
      sym_nil_safe,
    ACTIONS(718), 1,
      anon_sym_RBRACK,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(207), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(57), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9051] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(720), 1,
      anon_sym_RPAREN,
    ACTIONS(724), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(722), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(119), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9122] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(726), 1,
      anon_sym_RPAREN,
    ACTIONS(730), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(728), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(120), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9193] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9264] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(734), 1,
      anon_sym_RPAREN,
    ACTIONS(738), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(736), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(56), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9335] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(740), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9406] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(742), 1,
      anon_sym_RPAREN,
    ACTIONS(746), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(744), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(129), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9477] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(748), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9548] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(750), 1,
      anon_sym_RPAREN,
    ACTIONS(754), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(752), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(71), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9619] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(756), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9690] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9761] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      sym_symbol,
    ACTIONS(762), 1,
      anon_sym_LPAREN,
    ACTIONS(764), 1,
      anon_sym_LBRACK,
    ACTIONS(766), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_POUND,
    ACTIONS(774), 1,
      sym_nil_safe,
    ACTIONS(778), 1,
      aux_sym_string_token1,
    ACTIONS(780), 1,
      anon_sym_DQUOTE,
    ACTIONS(782), 1,
      anon_sym_DOT,
    STATE(238), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(770), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(776), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(772), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(559), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [9834] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      sym_symbol,
    ACTIONS(762), 1,
      anon_sym_LPAREN,
    ACTIONS(764), 1,
      anon_sym_LBRACK,
    ACTIONS(766), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_POUND,
    ACTIONS(774), 1,
      sym_nil_safe,
    ACTIONS(778), 1,
      aux_sym_string_token1,
    ACTIONS(780), 1,
      anon_sym_DQUOTE,
    ACTIONS(782), 1,
      anon_sym_DOT,
    STATE(238), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(770), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(776), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(772), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(559), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [9907] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(784), 1,
      anon_sym_RBRACK,
    ACTIONS(788), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(786), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(109), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [9978] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(790), 1,
      anon_sym_RPAREN,
    ACTIONS(794), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(792), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(145), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10049] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(796), 1,
      anon_sym_RPAREN,
    ACTIONS(800), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(798), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(142), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10120] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(802), 1,
      anon_sym_RPAREN,
    ACTIONS(806), 1,
      sym_nil_safe,
    STATE(96), 1,
      sym_string,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(804), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(94), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10193] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(808), 1,
      anon_sym_RBRACK,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10264] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(618), 1,
      anon_sym_RPAREN,
    ACTIONS(812), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(810), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(93), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10335] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(814), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10406] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(816), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10477] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(818), 1,
      anon_sym_RPAREN,
    ACTIONS(822), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(820), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(132), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10548] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(824), 1,
      anon_sym_RPAREN,
    ACTIONS(828), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(826), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(131), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10619] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      sym_nil_safe,
    ACTIONS(830), 1,
      anon_sym_RPAREN,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(468), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(35), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10690] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(834), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(832), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(59), 25,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_program_repeat1,
  [10758] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(836), 1,
      anon_sym_RBRACK,
    ACTIONS(840), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(838), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(744), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [10828] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(844), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(842), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(729), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [10895] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(848), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(846), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(742), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [10962] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(852), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(850), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(393), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11029] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(856), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(854), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(758), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11096] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(860), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(858), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(756), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11163] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(864), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(862), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(273), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11230] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(868), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(866), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(10), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11297] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(872), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(870), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(192), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11364] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(876), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(874), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(725), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11431] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(880), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(878), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(9), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11498] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(884), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(882), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(718), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11565] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      sym_symbol,
    ACTIONS(762), 1,
      anon_sym_LPAREN,
    ACTIONS(764), 1,
      anon_sym_LBRACK,
    ACTIONS(766), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_POUND,
    ACTIONS(778), 1,
      aux_sym_string_token1,
    ACTIONS(780), 1,
      anon_sym_DQUOTE,
    ACTIONS(888), 1,
      sym_nil_safe,
    ACTIONS(770), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(776), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(886), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(572), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11632] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(892), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(890), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(713), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11699] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(896), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(894), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(710), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11766] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(900), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(898), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(762), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11833] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    ACTIONS(902), 1,
      sym_symbol,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(908), 1,
      anon_sym_LBRACE,
    ACTIONS(912), 1,
      sym_nil_safe,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(910), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(645), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11900] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(183), 1,
      anon_sym_POUND,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    ACTIONS(902), 1,
      sym_symbol,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(908), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_nil_safe,
    ACTIONS(185), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(914), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(630), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [11967] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(920), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(918), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(763), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12034] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(922), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(190), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12101] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      sym_symbol,
    ACTIONS(762), 1,
      anon_sym_LPAREN,
    ACTIONS(764), 1,
      anon_sym_LBRACK,
    ACTIONS(766), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_POUND,
    ACTIONS(774), 1,
      sym_nil_safe,
    ACTIONS(778), 1,
      aux_sym_string_token1,
    ACTIONS(780), 1,
      anon_sym_DQUOTE,
    ACTIONS(770), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(776), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(772), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(559), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12168] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      sym_symbol,
    ACTIONS(762), 1,
      anon_sym_LPAREN,
    ACTIONS(764), 1,
      anon_sym_LBRACK,
    ACTIONS(766), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_POUND,
    ACTIONS(774), 1,
      sym_nil_safe,
    ACTIONS(778), 1,
      aux_sym_string_token1,
    ACTIONS(780), 1,
      anon_sym_DQUOTE,
    ACTIONS(770), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(776), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(772), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(559), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12235] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(926), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(735), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12302] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      sym_symbol,
    ACTIONS(762), 1,
      anon_sym_LPAREN,
    ACTIONS(764), 1,
      anon_sym_LBRACK,
    ACTIONS(766), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_POUND,
    ACTIONS(774), 1,
      sym_nil_safe,
    ACTIONS(778), 1,
      aux_sym_string_token1,
    ACTIONS(780), 1,
      anon_sym_DQUOTE,
    ACTIONS(770), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(776), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(772), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(559), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12369] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(932), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(930), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(777), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12436] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(936), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(934), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(769), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12503] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(940), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(938), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(147), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12570] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(944), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(942), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(745), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12637] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(948), 1,
      sym_nil_safe,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(946), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(524), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12704] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      sym_symbol,
    ACTIONS(762), 1,
      anon_sym_LPAREN,
    ACTIONS(764), 1,
      anon_sym_LBRACK,
    ACTIONS(766), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_POUND,
    ACTIONS(778), 1,
      aux_sym_string_token1,
    ACTIONS(780), 1,
      anon_sym_DQUOTE,
    ACTIONS(952), 1,
      sym_nil_safe,
    ACTIONS(770), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(776), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(950), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(521), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12771] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(956), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(954), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(267), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12838] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(960), 1,
      sym_nil_safe,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(958), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(537), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12905] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(964), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(962), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(197), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [12972] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym_symbol,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(968), 1,
      sym_nil_safe,
    ACTIONS(243), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(966), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(566), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13039] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(972), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(970), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(754), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13106] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(976), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(974), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(15), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13173] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(980), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(978), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(728), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13240] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(984), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(982), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(19), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13307] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(988), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(986), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(727), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13374] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(992), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(990), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(726), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13441] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(996), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(994), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(173), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13508] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_symbol,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_LBRACK,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_POUND,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1000), 1,
      sym_nil_safe,
    ACTIONS(17), 2,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(998), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(195), 24,
      sym__sexp,
      sym__special_form,
      sym_each,
      sym_for,
      sym_let,
      sym_global,
      sym_local,
      sym_var,
      sym_set,
      sym_hashfn,
      sym_fn,
      sym_lambda,
      sym_match,
      sym_collect,
      sym_icollect,
      sym_accumulate,
      sym_quote,
      sym_list,
      sym_sequential_table,
      sym_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13575] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1002), 1,
      sym_symbol,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1008), 1,
      anon_sym_LBRACK,
    ACTIONS(1013), 1,
      anon_sym_LBRACE,
    ACTIONS(1016), 1,
      anon_sym_COMMA,
    ACTIONS(1022), 1,
      sym_nil_safe,
    ACTIONS(1028), 1,
      aux_sym_string_token1,
    ACTIONS(1031), 1,
      anon_sym_DQUOTE,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(1025), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1011), 3,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(1019), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [13632] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1036), 1,
      anon_sym_LPAREN,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1040), 1,
      anon_sym_RPAREN,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1046), 1,
      sym_nil_safe,
    STATE(196), 1,
      aux_sym_match_repeat1,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1044), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(150), 12,
      sym__pattern,
      sym__simple_pattern,
      sym_guard_pattern,
      sym_where_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13686] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1036), 1,
      anon_sym_LPAREN,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1046), 1,
      sym_nil_safe,
    ACTIONS(1048), 1,
      anon_sym_RPAREN,
    STATE(194), 1,
      aux_sym_match_repeat1,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1044), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(150), 12,
      sym__pattern,
      sym__simple_pattern,
      sym_guard_pattern,
      sym_where_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13740] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1036), 1,
      anon_sym_LPAREN,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1046), 1,
      sym_nil_safe,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
    STATE(193), 1,
      aux_sym_match_repeat1,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1044), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(150), 12,
      sym__pattern,
      sym__simple_pattern,
      sym_guard_pattern,
      sym_where_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13794] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1036), 1,
      anon_sym_LPAREN,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1046), 1,
      sym_nil_safe,
    ACTIONS(1052), 1,
      anon_sym_RPAREN,
    STATE(194), 1,
      aux_sym_match_repeat1,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1044), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(150), 12,
      sym__pattern,
      sym__simple_pattern,
      sym_guard_pattern,
      sym_where_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13848] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1054), 1,
      sym_symbol,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1060), 1,
      anon_sym_LBRACK,
    ACTIONS(1063), 1,
      anon_sym_RPAREN,
    ACTIONS(1065), 1,
      anon_sym_LBRACE,
    ACTIONS(1071), 1,
      sym_nil_safe,
    ACTIONS(1077), 1,
      aux_sym_string_token1,
    ACTIONS(1080), 1,
      anon_sym_DQUOTE,
    STATE(194), 1,
      aux_sym_match_repeat1,
    ACTIONS(1074), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1068), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(150), 12,
      sym__pattern,
      sym__simple_pattern,
      sym_guard_pattern,
      sym_where_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13902] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1036), 1,
      anon_sym_LPAREN,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1046), 1,
      sym_nil_safe,
    ACTIONS(1083), 1,
      anon_sym_RPAREN,
    STATE(191), 1,
      aux_sym_match_repeat1,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1044), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(150), 12,
      sym__pattern,
      sym__simple_pattern,
      sym_guard_pattern,
      sym_where_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [13956] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1036), 1,
      anon_sym_LPAREN,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1046), 1,
      sym_nil_safe,
    ACTIONS(1085), 1,
      anon_sym_RPAREN,
    STATE(194), 1,
      aux_sym_match_repeat1,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1044), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(150), 12,
      sym__pattern,
      sym__simple_pattern,
      sym_guard_pattern,
      sym_where_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [14010] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1036), 1,
      anon_sym_LPAREN,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1046), 1,
      sym_nil_safe,
    ACTIONS(1087), 1,
      anon_sym_RPAREN,
    STATE(198), 1,
      aux_sym_match_repeat1,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1044), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(150), 12,
      sym__pattern,
      sym__simple_pattern,
      sym_guard_pattern,
      sym_where_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [14064] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1036), 1,
      anon_sym_LPAREN,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1046), 1,
      sym_nil_safe,
    ACTIONS(1089), 1,
      anon_sym_RPAREN,
    STATE(194), 1,
      aux_sym_match_repeat1,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1044), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(150), 12,
      sym__pattern,
      sym__simple_pattern,
      sym_guard_pattern,
      sym_where_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [14118] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1097), 1,
      anon_sym_RBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1105), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1103), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(204), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14173] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1107), 1,
      anon_sym_RPAREN,
    ACTIONS(1111), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1109), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(216), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14228] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1113), 1,
      anon_sym_RBRACE,
    ACTIONS(1117), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14283] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1119), 1,
      anon_sym_RBRACE,
    ACTIONS(1123), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1121), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(203), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14338] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1125), 1,
      anon_sym_RBRACE,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14393] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1127), 1,
      anon_sym_RBRACK,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14448] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14503] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1131), 1,
      anon_sym_RBRACK,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14558] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1133), 1,
      anon_sym_RBRACE,
    ACTIONS(1137), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1135), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(221), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14613] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1139), 1,
      anon_sym_RPAREN,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14668] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1141), 1,
      anon_sym_RBRACK,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14723] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1143), 1,
      anon_sym_RBRACE,
    ACTIONS(1147), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1145), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(201), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14778] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1149), 1,
      anon_sym_RBRACK,
    ACTIONS(1153), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1151), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(206), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14833] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1155), 1,
      anon_sym_RPAREN,
    ACTIONS(1159), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1157), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(215), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14888] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1161), 1,
      anon_sym_RBRACK,
    ACTIONS(1165), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1163), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(218), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14943] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1167), 1,
      anon_sym_RBRACE,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [14998] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1169), 1,
      anon_sym_RPAREN,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [15053] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1171), 1,
      anon_sym_RPAREN,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [15108] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_RPAREN,
    ACTIONS(1177), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1175), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(208), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [15163] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1179), 1,
      anon_sym_RBRACK,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [15218] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1181), 1,
      anon_sym_RBRACK,
    ACTIONS(1185), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1183), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(209), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [15273] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1187), 1,
      anon_sym_RBRACE,
    ACTIONS(1191), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1189), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(214), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [15328] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      sym_nil_safe,
    ACTIONS(1193), 1,
      anon_sym_RBRACE,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1115), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(189), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [15383] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1195), 1,
      anon_sym_RPAREN,
    ACTIONS(1199), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1197), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(205), 10,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
      aux_sym_quoted_list_repeat1,
  [15438] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 1,
      sym_symbol,
    ACTIONS(1203), 1,
      anon_sym_LPAREN,
    ACTIONS(1205), 1,
      anon_sym_LBRACK,
    ACTIONS(1207), 1,
      anon_sym_RPAREN,
    ACTIONS(1209), 1,
      anon_sym_LBRACE,
    ACTIONS(1211), 1,
      anon_sym_where,
    ACTIONS(1215), 1,
      sym_nil_safe,
    ACTIONS(1219), 1,
      aux_sym_string_token1,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    STATE(284), 1,
      aux_sym_multi_value_pattern_repeat1,
    ACTIONS(1217), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(701), 2,
      sym__simple_pattern,
      sym_multi_value_pattern,
    ACTIONS(1213), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(399), 7,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [15494] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1225), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1223), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(721), 9,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [15545] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1229), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1227), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(707), 9,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [15596] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(193), 1,
      aux_sym_string_token1,
    ACTIONS(195), 1,
      anon_sym_DQUOTE,
    ACTIONS(1231), 1,
      sym_symbol,
    ACTIONS(1233), 1,
      anon_sym_LPAREN,
    ACTIONS(1235), 1,
      anon_sym_LBRACK,
    ACTIONS(1237), 1,
      anon_sym_LBRACE,
    ACTIONS(1239), 1,
      anon_sym_COMMA,
    ACTIONS(1243), 1,
      sym_nil_safe,
    STATE(625), 1,
      sym_multi_symbol,
    ACTIONS(191), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1241), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(633), 9,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [15647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      anon_sym_DOT,
    STATE(227), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1247), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1245), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      anon_sym_DQUOTE,
      anon_sym_COLON2,
  [15682] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1252), 1,
      anon_sym_LPAREN,
    ACTIONS(1254), 1,
      anon_sym_RPAREN,
    ACTIONS(1258), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1256), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(232), 10,
      sym__simple_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_where_pattern_repeat1,
  [15731] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_DOT,
    ACTIONS(1266), 1,
      anon_sym_COLON2,
    STATE(234), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1262), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1260), 13,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      anon_sym_DQUOTE,
  [15768] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(778), 1,
      aux_sym_string_token1,
    ACTIONS(780), 1,
      anon_sym_DQUOTE,
    ACTIONS(1268), 1,
      sym_symbol,
    ACTIONS(1270), 1,
      anon_sym_LPAREN,
    ACTIONS(1272), 1,
      anon_sym_LBRACK,
    ACTIONS(1274), 1,
      anon_sym_LBRACE,
    ACTIONS(1276), 1,
      anon_sym_COMMA,
    ACTIONS(1280), 1,
      sym_nil_safe,
    STATE(478), 1,
      sym_multi_symbol,
    ACTIONS(776), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1278), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(522), 9,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [15819] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1284), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1282), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(743), 9,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [15870] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1252), 1,
      anon_sym_LPAREN,
    ACTIONS(1286), 1,
      anon_sym_RPAREN,
    ACTIONS(1290), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1288), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(233), 10,
      sym__simple_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_where_pattern_repeat1,
  [15919] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1292), 1,
      sym_symbol,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1298), 1,
      anon_sym_LBRACK,
    ACTIONS(1301), 1,
      anon_sym_RPAREN,
    ACTIONS(1303), 1,
      anon_sym_LBRACE,
    ACTIONS(1309), 1,
      sym_nil_safe,
    ACTIONS(1315), 1,
      aux_sym_string_token1,
    ACTIONS(1318), 1,
      anon_sym_DQUOTE,
    ACTIONS(1312), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1306), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(233), 10,
      sym__simple_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_where_pattern_repeat1,
  [15968] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_DOT,
    STATE(227), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1323), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1321), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      anon_sym_DQUOTE,
      anon_sym_COLON2,
  [16003] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1327), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1325), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(262), 9,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [16054] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(259), 1,
      aux_sym_string_token1,
    ACTIONS(261), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym_symbol,
    ACTIONS(1331), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_LBRACK,
    ACTIONS(1335), 1,
      anon_sym_LBRACE,
    ACTIONS(1337), 1,
      anon_sym_COMMA,
    ACTIONS(1341), 1,
      sym_nil_safe,
    STATE(484), 1,
      sym_multi_symbol,
    ACTIONS(249), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1339), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(536), 9,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [16105] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1345), 1,
      sym_nil_safe,
    STATE(246), 1,
      sym_multi_symbol,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1343), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(752), 9,
      sym_unquote,
      sym__quoted_sexp,
      sym_quoted_list,
      sym_quoted_sequential_table,
      sym_quoted_table,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol_method,
  [16156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 1,
      anon_sym_DOT,
    STATE(242), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1323), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1321), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16190] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 1,
      sym_symbol,
    ACTIONS(1350), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_LBRACK,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    ACTIONS(1361), 5,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
    ACTIONS(1359), 6,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    STATE(239), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_iter_bindings_repeat1,
  [16230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 1,
      anon_sym_DOT,
    STATE(238), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1365), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1363), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1245), 15,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      anon_sym_DQUOTE,
      anon_sym_DOT,
      anon_sym_COLON2,
  [16294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_DOT,
    STATE(242), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1247), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1245), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16328] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 1,
      sym_symbol,
    ACTIONS(1373), 1,
      anon_sym_LBRACK,
    ACTIONS(1378), 1,
      anon_sym_LBRACE,
    ACTIONS(1384), 1,
      sym_nil_safe,
    ACTIONS(1390), 1,
      aux_sym_string_token1,
    ACTIONS(1393), 1,
      anon_sym_DQUOTE,
    ACTIONS(1376), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(1387), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1381), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(243), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [16373] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1396), 1,
      anon_sym_LPAREN,
    ACTIONS(1400), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1398), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(69), 9,
      sym__simple_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [16418] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1402), 1,
      sym_symbol,
    ACTIONS(1404), 1,
      anon_sym_LPAREN,
    ACTIONS(1406), 1,
      anon_sym_LBRACK,
    ACTIONS(1408), 1,
      anon_sym_LBRACE,
    ACTIONS(1412), 1,
      sym_nil_safe,
    ACTIONS(1416), 1,
      aux_sym_string_token1,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1414), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1410), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(329), 9,
      sym__simple_pattern,
      sym_multi_value_pattern,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [16463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      anon_sym_COLON2,
    ACTIONS(1262), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1260), 13,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      anon_sym_DQUOTE,
  [16494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1245), 15,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
      anon_sym_DOT,
  [16523] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1207), 1,
      anon_sym_RPAREN,
    ACTIONS(1420), 1,
      anon_sym_or,
    ACTIONS(1424), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1422), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(284), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [16570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1428), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1426), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16598] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1207), 1,
      anon_sym_RPAREN,
    ACTIONS(1424), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1422), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(284), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [16642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1430), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1434), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1438), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1442), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1446), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1450), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1454), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1458), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1462), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1466), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1472), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1470), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1474), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [16978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1478), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1482), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1486), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1490), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1494), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17118] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1498), 1,
      anon_sym_RBRACK,
    ACTIONS(1502), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1500), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(281), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1504), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1508), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1512), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1516), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1520), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1524), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1528), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1532), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17386] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1536), 1,
      anon_sym_RPAREN,
    ACTIONS(1540), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1538), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(285), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17430] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1542), 1,
      anon_sym_RPAREN,
    ACTIONS(1546), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1544), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(243), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1548), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1552), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17530] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1546), 1,
      sym_nil_safe,
    ACTIONS(1556), 1,
      anon_sym_RBRACK,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1544), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(243), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17574] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      anon_sym_RPAREN,
    ACTIONS(1562), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1560), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(278), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17618] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1546), 1,
      sym_nil_safe,
    ACTIONS(1564), 1,
      anon_sym_RBRACK,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1544), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(243), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17662] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1546), 1,
      sym_nil_safe,
    ACTIONS(1566), 1,
      anon_sym_RPAREN,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1544), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(243), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17706] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1546), 1,
      sym_nil_safe,
    ACTIONS(1568), 1,
      anon_sym_RPAREN,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1544), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(243), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17750] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      anon_sym_RBRACK,
    ACTIONS(1574), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1572), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(292), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1576), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1580), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1584), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1590), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1588), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [17906] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1592), 1,
      anon_sym_RBRACK,
    ACTIONS(1596), 1,
      sym_nil_safe,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1594), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(283), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17950] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_symbol,
    ACTIONS(1038), 1,
      anon_sym_LBRACK,
    ACTIONS(1042), 1,
      anon_sym_LBRACE,
    ACTIONS(1546), 1,
      sym_nil_safe,
    ACTIONS(1598), 1,
      anon_sym_RBRACK,
    ACTIONS(23), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1544), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(243), 8,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
      aux_sym_multi_value_pattern_repeat1,
  [17994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1600), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1604), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1608), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1612), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1616), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1620), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1624), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1628), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1632), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1636), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1640), 14,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1644), 1,
      anon_sym_DOT,
    STATE(308), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1323), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1321), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18333] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_DOT,
    ACTIONS(1266), 1,
      anon_sym_COLON2,
    ACTIONS(1646), 1,
      sym_symbol,
    STATE(234), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1649), 3,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(1363), 6,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      anon_sym_DQUOTE,
    ACTIONS(1365), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
  [18370] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 1,
      anon_sym_DOT,
    ACTIONS(1646), 1,
      sym_symbol,
    ACTIONS(1652), 1,
      anon_sym_AMP,
    STATE(238), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1649), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
    ACTIONS(1365), 5,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
    ACTIONS(1363), 7,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1363), 1,
      anon_sym_RBRACK,
    ACTIONS(1365), 1,
      anon_sym_COLONuntil,
    ACTIONS(1656), 1,
      anon_sym_DOT,
    STATE(534), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1652), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1654), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      anon_sym_DQUOTE,
  [18442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1658), 1,
      anon_sym_DOT,
    STATE(308), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1247), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1245), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1644), 1,
      anon_sym_DOT,
    STATE(304), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1661), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1663), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18504] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_DOT,
    ACTIONS(1266), 1,
      anon_sym_COLON2,
    STATE(234), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1365), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1363), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      anon_sym_DQUOTE,
  [18537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 1,
      anon_sym_DOT,
    STATE(238), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1665), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1667), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18568] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1644), 1,
      anon_sym_DOT,
    STATE(304), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1665), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1667), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1245), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
      anon_sym_DOT,
  [18625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1669), 8,
      anon_sym_COLON,
      anon_sym_AMPas,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1671), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18651] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1402), 1,
      sym_symbol,
    ACTIONS(1406), 1,
      anon_sym_LBRACK,
    ACTIONS(1408), 1,
      anon_sym_LBRACE,
    ACTIONS(1412), 1,
      sym_nil_safe,
    ACTIONS(1416), 1,
      aux_sym_string_token1,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1414), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1410), 3,
      sym_nil,
      sym_vararg,
      sym_number,
    STATE(329), 7,
      sym__non_multi_value_pattern,
      sym_sequential_table_pattern,
      sym_table_pattern,
      sym__literal,
      sym_boolean,
      sym_string,
      sym_multi_symbol,
  [18691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 8,
      anon_sym_COLON,
      anon_sym_AMPas,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1654), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1677), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 6,
      anon_sym_AMPas,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
    ACTIONS(284), 7,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
  [18747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 8,
      anon_sym_COLON,
      anon_sym_AMPas,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1681), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1683), 8,
      anon_sym_COLON,
      anon_sym_AMPas,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1685), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1687), 8,
      anon_sym_COLON,
      anon_sym_AMPas,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1689), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1675), 8,
      anon_sym_COLON,
      anon_sym_AMPas,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(284), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1691), 8,
      anon_sym_COLON,
      anon_sym_AMPas,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1693), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 8,
      anon_sym_COLON,
      anon_sym_AMPas,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1697), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1548), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1683), 1,
      anon_sym_AMP,
    ACTIONS(1699), 1,
      sym_symbol,
    ACTIONS(1702), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
    ACTIONS(1514), 5,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
    ACTIONS(1512), 7,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 1,
      anon_sym_DOT,
    STATE(238), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1661), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1663), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [18988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1661), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1663), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1705), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1707), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1709), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(399), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1713), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1715), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1717), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1721), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1723), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1725), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1715), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1717), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1729), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1731), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(441), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1735), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1739), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1743), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1512), 1,
      anon_sym_RBRACK,
    ACTIONS(1514), 1,
      anon_sym_COLONuntil,
    ACTIONS(1683), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1685), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      anon_sym_DQUOTE,
  [19342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      anon_sym_COLON2,
    ACTIONS(1365), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1363), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      anon_sym_DQUOTE,
  [19369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 1,
      anon_sym_RBRACK,
    ACTIONS(1510), 1,
      anon_sym_COLONuntil,
    ACTIONS(1687), 7,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      sym_number,
      sym_symbol,
    ACTIONS(1689), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      anon_sym_DQUOTE,
  [19398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1636), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1729), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1735), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19473] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1687), 1,
      anon_sym_AMP,
    ACTIONS(1745), 1,
      sym_symbol,
    ACTIONS(1748), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
    ACTIONS(1510), 5,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
    ACTIONS(1508), 7,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1721), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1751), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1753), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1604), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 7,
      anon_sym_COLON,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1458), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1755), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1757), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1759), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1761), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1723), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1725), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1763), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1765), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1767), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1769), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1771), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1773), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1739), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_symbol,
    ACTIONS(1702), 3,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(1514), 5,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
    ACTIONS(1512), 7,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1745), 1,
      sym_symbol,
    ACTIONS(1748), 3,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(1510), 5,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
    ACTIONS(1508), 7,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1775), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1777), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1654), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1697), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1779), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1781), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1783), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1785), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1751), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1753), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1661), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1663), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [19991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1743), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1789), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1669), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1671), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1791), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1793), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1795), 1,
      anon_sym_DOT,
    STATE(371), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1245), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1247), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20110] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 1,
      anon_sym_DOT,
    STATE(375), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1667), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1665), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1691), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1693), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1713), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20183] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 1,
      anon_sym_DOT,
    STATE(371), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1321), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1323), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1705), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1707), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1802), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1683), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1685), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1687), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1689), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1806), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1808), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1810), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1681), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1812), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1814), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1818), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1822), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1824), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1826), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 7,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
      anon_sym_DOT,
    ACTIONS(1247), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20485] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1828), 1,
      sym_symbol,
    ACTIONS(1830), 1,
      anon_sym_LPAREN,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1834), 1,
      anon_sym_RBRACK,
    ACTIONS(1836), 1,
      anon_sym_LBRACE,
    ACTIONS(1838), 1,
      sym_vararg,
    STATE(392), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_parameters_repeat1,
  [20516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1636), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1638), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1717), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1715), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1719), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20579] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1828), 1,
      sym_symbol,
    ACTIONS(1830), 1,
      anon_sym_LPAREN,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1836), 1,
      anon_sym_LBRACE,
    ACTIONS(1840), 1,
      anon_sym_RBRACK,
    ACTIONS(1842), 1,
      sym_vararg,
    STATE(394), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_parameters_repeat1,
  [20610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1844), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1063), 7,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20631] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1846), 1,
      sym_symbol,
    ACTIONS(1849), 1,
      anon_sym_LPAREN,
    ACTIONS(1852), 1,
      anon_sym_LBRACK,
    ACTIONS(1855), 1,
      anon_sym_RBRACK,
    ACTIONS(1857), 1,
      anon_sym_LBRACE,
    ACTIONS(1860), 1,
      sym_vararg,
    STATE(394), 7,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_parameters_repeat1,
  [20662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1727), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1733), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1550), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1460), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      anon_sym_QMARK,
    ACTIONS(1863), 6,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
    ACTIONS(1865), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [20769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 6,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_nil_safe,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1606), 7,
      anon_sym_QMARK,
      sym_nil,
      sym_vararg,
      anon_sym_true,
      anon_sym_false,
      sym_number,
      sym_symbol,
  [20790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1875), 1,
      anon_sym_RBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(402), 1,
      aux_sym_let_clause_repeat1,
    STATE(180), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [20820] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      sym_symbol,
    ACTIONS(1882), 1,
      anon_sym_LPAREN,
    ACTIONS(1885), 1,
      anon_sym_LBRACK,
    ACTIONS(1888), 1,
      anon_sym_RBRACK,
    ACTIONS(1890), 1,
      anon_sym_LBRACE,
    STATE(402), 1,
      aux_sym_let_clause_repeat1,
    STATE(180), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [20850] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      anon_sym_RBRACK,
    STATE(401), 1,
      aux_sym_let_clause_repeat1,
    STATE(180), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [20880] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 1,
      sym_symbol,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_LBRACK,
    ACTIONS(1901), 1,
      anon_sym_LBRACE,
    STATE(366), 1,
      sym_multi_symbol,
    STATE(181), 6,
      sym__assignment,
      sym_multi_value_assignment,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
  [20907] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 1,
      sym_symbol,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_LBRACK,
    ACTIONS(1901), 1,
      anon_sym_LBRACE,
    STATE(366), 1,
      sym_multi_symbol,
    STATE(186), 6,
      sym__assignment,
      sym_multi_value_assignment,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
  [20934] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 1,
      sym_symbol,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_LBRACK,
    ACTIONS(1901), 1,
      anon_sym_LBRACE,
    STATE(366), 1,
      sym_multi_symbol,
    STATE(156), 6,
      sym__assignment,
      sym_multi_value_assignment,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
  [20961] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 1,
      sym_symbol,
    ACTIONS(1906), 1,
      anon_sym_LBRACK,
    ACTIONS(1911), 1,
      anon_sym_LBRACE,
    STATE(538), 1,
      sym_multi_symbol,
    ACTIONS(1909), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(407), 5,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
      aux_sym_multi_value_assignment_repeat1,
  [20988] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 1,
      sym_symbol,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_LBRACK,
    ACTIONS(1901), 1,
      anon_sym_LBRACE,
    STATE(366), 1,
      sym_multi_symbol,
    STATE(171), 6,
      sym__assignment,
      sym_multi_value_assignment,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
  [21015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(151), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(158), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21063] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(217), 1,
      anon_sym_AMP,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1918), 1,
      anon_sym_RBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    STATE(438), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(154), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21113] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      sym_symbol,
    ACTIONS(1924), 1,
      anon_sym_LBRACK,
    ACTIONS(1926), 1,
      anon_sym_RPAREN,
    ACTIONS(1928), 1,
      anon_sym_LBRACE,
    STATE(538), 1,
      sym_multi_symbol,
    STATE(419), 5,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
      aux_sym_multi_value_assignment_repeat1,
  [21139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    ACTIONS(1930), 1,
      anon_sym_RBRACK,
    ACTIONS(1932), 1,
      anon_sym_AMP,
    STATE(428), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21165] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      sym_symbol,
    ACTIONS(1924), 1,
      anon_sym_LBRACK,
    ACTIONS(1928), 1,
      anon_sym_LBRACE,
    ACTIONS(1934), 1,
      anon_sym_RBRACK,
    STATE(538), 1,
      sym_multi_symbol,
    STATE(420), 5,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
      aux_sym_multi_value_assignment_repeat1,
  [21191] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(160), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21215] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(182), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(161), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      sym_symbol,
    ACTIONS(1924), 1,
      anon_sym_LBRACK,
    ACTIONS(1928), 1,
      anon_sym_LBRACE,
    ACTIONS(1936), 1,
      anon_sym_RPAREN,
    STATE(538), 1,
      sym_multi_symbol,
    STATE(407), 5,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
      aux_sym_multi_value_assignment_repeat1,
  [21289] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      sym_symbol,
    ACTIONS(1924), 1,
      anon_sym_LBRACK,
    ACTIONS(1928), 1,
      anon_sym_LBRACE,
    ACTIONS(1938), 1,
      anon_sym_RBRACK,
    STATE(538), 1,
      sym_multi_symbol,
    STATE(407), 5,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
      aux_sym_multi_value_assignment_repeat1,
  [21315] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      sym_symbol,
    ACTIONS(1924), 1,
      anon_sym_LBRACK,
    ACTIONS(1928), 1,
      anon_sym_LBRACE,
    ACTIONS(1940), 1,
      anon_sym_RBRACK,
    STATE(538), 1,
      sym_multi_symbol,
    STATE(407), 5,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
      aux_sym_multi_value_assignment_repeat1,
  [21341] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      sym_symbol,
    ACTIONS(1924), 1,
      anon_sym_LBRACK,
    ACTIONS(1928), 1,
      anon_sym_LBRACE,
    ACTIONS(1942), 1,
      anon_sym_RBRACK,
    STATE(538), 1,
      sym_multi_symbol,
    STATE(407), 5,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
      aux_sym_multi_value_assignment_repeat1,
  [21367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    ACTIONS(1944), 1,
      anon_sym_RBRACK,
    ACTIONS(1946), 1,
      anon_sym_AMP,
    STATE(428), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    ACTIONS(1948), 1,
      anon_sym_RBRACK,
    ACTIONS(1950), 1,
      anon_sym_AMP,
    STATE(428), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21419] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(157), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    ACTIONS(1952), 1,
      anon_sym_RBRACK,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    STATE(424), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(152), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21493] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1956), 1,
      sym_symbol,
    ACTIONS(1959), 1,
      anon_sym_LBRACK,
    ACTIONS(1962), 1,
      anon_sym_RBRACK,
    ACTIONS(1964), 1,
      anon_sym_AMP,
    ACTIONS(1966), 1,
      anon_sym_LBRACE,
    STATE(428), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21519] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(174), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21543] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(172), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21567] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    ACTIONS(1969), 1,
      anon_sym_RBRACK,
    ACTIONS(1971), 1,
      anon_sym_AMP,
    STATE(436), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21593] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(165), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(162), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21641] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      sym_symbol,
    ACTIONS(1924), 1,
      anon_sym_LBRACK,
    ACTIONS(1928), 1,
      anon_sym_LBRACE,
    ACTIONS(1973), 1,
      anon_sym_RBRACK,
    STATE(538), 1,
      sym_multi_symbol,
    STATE(421), 5,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
      aux_sym_multi_value_assignment_repeat1,
  [21667] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      sym_symbol,
    ACTIONS(1924), 1,
      anon_sym_LBRACK,
    ACTIONS(1928), 1,
      anon_sym_LBRACE,
    ACTIONS(1975), 1,
      anon_sym_RBRACK,
    STATE(538), 1,
      sym_multi_symbol,
    STATE(422), 5,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
      aux_sym_multi_value_assignment_repeat1,
  [21693] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    ACTIONS(1977), 1,
      anon_sym_RBRACK,
    ACTIONS(1979), 1,
      anon_sym_AMP,
    STATE(428), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_AMP,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    ACTIONS(1981), 1,
      anon_sym_RBRACK,
    STATE(414), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21745] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    ACTIONS(1983), 1,
      anon_sym_RBRACK,
    ACTIONS(1985), 1,
      anon_sym_AMP,
    STATE(428), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21771] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_AMP,
    ACTIONS(1914), 1,
      sym_symbol,
    ACTIONS(1916), 1,
      anon_sym_LBRACK,
    ACTIONS(1920), 1,
      anon_sym_LBRACE,
    ACTIONS(1987), 1,
      anon_sym_RBRACK,
    STATE(423), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21797] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(148), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(184), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21845] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(183), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21869] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 1,
      anon_sym_LBRACK,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(185), 6,
      sym__binding,
      sym_multi_value_binding,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [21893] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 1,
      sym_symbol,
    ACTIONS(1992), 1,
      anon_sym_COLON,
    ACTIONS(1995), 1,
      anon_sym_RBRACE,
    ACTIONS(1997), 1,
      aux_sym_string_token1,
    ACTIONS(2000), 1,
      anon_sym_DQUOTE,
    STATE(170), 2,
      sym_string,
      sym_multi_symbol,
    STATE(444), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
  [21920] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1962), 1,
      anon_sym_RPAREN,
    ACTIONS(2003), 1,
      sym_symbol,
    ACTIONS(2006), 1,
      anon_sym_LBRACK,
    ACTIONS(2009), 1,
      anon_sym_LBRACE,
    STATE(445), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21943] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2012), 1,
      sym_symbol,
    ACTIONS(2014), 1,
      anon_sym_LBRACK,
    ACTIONS(2016), 1,
      anon_sym_RPAREN,
    ACTIONS(2018), 1,
      anon_sym_LBRACE,
    STATE(445), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [21966] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(2020), 1,
      sym_symbol,
    ACTIONS(2022), 1,
      anon_sym_COLON,
    ACTIONS(2024), 1,
      anon_sym_RBRACE,
    STATE(170), 2,
      sym_string,
      sym_multi_symbol,
    STATE(444), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
  [21993] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_RPAREN,
    ACTIONS(2012), 1,
      sym_symbol,
    ACTIONS(2014), 1,
      anon_sym_LBRACK,
    ACTIONS(2018), 1,
      anon_sym_LBRACE,
    STATE(446), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [22016] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(2020), 1,
      sym_symbol,
    ACTIONS(2022), 1,
      anon_sym_COLON,
    ACTIONS(2026), 1,
      anon_sym_RBRACE,
    STATE(170), 2,
      sym_string,
      sym_multi_symbol,
    STATE(444), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
  [22043] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(2020), 1,
      sym_symbol,
    ACTIONS(2022), 1,
      anon_sym_COLON,
    ACTIONS(2028), 1,
      anon_sym_RBRACE,
    STATE(170), 2,
      sym_string,
      sym_multi_symbol,
    STATE(457), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
  [22070] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(2020), 1,
      sym_symbol,
    ACTIONS(2022), 1,
      anon_sym_COLON,
    ACTIONS(2030), 1,
      anon_sym_RBRACE,
    STATE(170), 2,
      sym_string,
      sym_multi_symbol,
    STATE(444), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
  [22097] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(2020), 1,
      sym_symbol,
    ACTIONS(2022), 1,
      anon_sym_COLON,
    ACTIONS(2032), 1,
      anon_sym_RBRACE,
    STATE(170), 2,
      sym_string,
      sym_multi_symbol,
    STATE(449), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
  [22124] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2012), 1,
      sym_symbol,
    ACTIONS(2014), 1,
      anon_sym_LBRACK,
    ACTIONS(2018), 1,
      anon_sym_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_RPAREN,
    STATE(445), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [22147] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(2020), 1,
      sym_symbol,
    ACTIONS(2022), 1,
      anon_sym_COLON,
    ACTIONS(2036), 1,
      anon_sym_RBRACE,
    STATE(170), 2,
      sym_string,
      sym_multi_symbol,
    STATE(447), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
  [22174] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2012), 1,
      sym_symbol,
    ACTIONS(2014), 1,
      anon_sym_LBRACK,
    ACTIONS(2018), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      anon_sym_RPAREN,
    STATE(453), 5,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
      aux_sym_multi_value_binding_repeat1,
  [22197] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(2020), 1,
      sym_symbol,
    ACTIONS(2022), 1,
      anon_sym_COLON,
    ACTIONS(2040), 1,
      anon_sym_RBRACE,
    STATE(170), 2,
      sym_string,
      sym_multi_symbol,
    STATE(451), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
  [22224] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(25), 1,
      aux_sym_string_token1,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(2020), 1,
      sym_symbol,
    ACTIONS(2022), 1,
      anon_sym_COLON,
    ACTIONS(2042), 1,
      anon_sym_RBRACE,
    STATE(170), 2,
      sym_string,
      sym_multi_symbol,
    STATE(444), 2,
      sym_table_pair,
      aux_sym_table_repeat1,
  [22251] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      sym_symbol,
    ACTIONS(2044), 1,
      anon_sym_DOT,
    ACTIONS(2046), 1,
      anon_sym_COLON2,
    STATE(461), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1260), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 1,
      sym_symbol,
    ACTIONS(2050), 1,
      anon_sym_LBRACK,
    ACTIONS(2052), 1,
      anon_sym_LBRACE,
    STATE(327), 1,
      sym_multi_symbol,
    STATE(336), 4,
      sym__non_multi_value_assignment,
      sym_assignment,
      sym_sequential_table_assignment,
      sym_table_assignment,
  [22295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      sym_symbol,
    ACTIONS(2054), 1,
      anon_sym_DOT,
    STATE(460), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1245), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON2,
  [22315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 1,
      sym_symbol,
    ACTIONS(2044), 1,
      anon_sym_DOT,
    STATE(460), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1321), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON2,
  [22335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2057), 1,
      anon_sym_DOT,
    ACTIONS(2059), 1,
      anon_sym_COLON2,
    STATE(464), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1260), 2,
      anon_sym_RBRACE,
      anon_sym_DQUOTE,
    ACTIONS(1262), 3,
      anon_sym_COLON,
      aux_sym_string_token1,
      sym_symbol,
  [22357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      sym_symbol,
    ACTIONS(2061), 1,
      anon_sym_DOT,
    STATE(463), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1245), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [22377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2057), 1,
      anon_sym_DOT,
    STATE(466), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1321), 3,
      anon_sym_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_COLON2,
    ACTIONS(1323), 3,
      anon_sym_COLON,
      aux_sym_string_token1,
      sym_symbol,
  [22397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 1,
      sym_symbol,
    ACTIONS(2064), 1,
      anon_sym_DOT,
    STATE(463), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1321), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [22417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 1,
      anon_sym_DOT,
    STATE(466), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1245), 3,
      anon_sym_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_COLON2,
    ACTIONS(1247), 3,
      anon_sym_COLON,
      aux_sym_string_token1,
      sym_symbol,
  [22437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1661), 1,
      sym_symbol,
    ACTIONS(2064), 1,
      anon_sym_DOT,
    STATE(465), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1663), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [22456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_DOT,
    STATE(474), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1365), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1363), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [22475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      sym_symbol,
    ACTIONS(1245), 6,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_COLON2,
  [22490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 1,
      sym_symbol,
    ACTIONS(2064), 1,
      anon_sym_DOT,
    STATE(465), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1363), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 1,
      sym_symbol,
    ACTIONS(2073), 1,
      anon_sym_LBRACK,
    ACTIONS(2075), 1,
      anon_sym_LBRACE,
    STATE(321), 4,
      sym__non_multi_value_binding,
      sym_binding,
      sym_sequential_table_binding,
      sym_table_binding,
  [22528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2077), 1,
      anon_sym_DOT,
    STATE(472), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1247), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1245), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [22547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      sym_symbol,
    ACTIONS(1245), 6,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT,
  [22562] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_DOT,
    STATE(472), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1323), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1321), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [22581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 3,
      anon_sym_COLON,
      aux_sym_string_token1,
      sym_symbol,
    ACTIONS(1245), 4,
      anon_sym_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_DOT,
      anon_sym_COLON2,
  [22596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 2,
      sym_vararg,
      sym_symbol,
    ACTIONS(1802), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1687), 2,
      sym_vararg,
      sym_symbol,
    ACTIONS(1689), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2059), 1,
      anon_sym_COLON2,
    ACTIONS(1260), 2,
      anon_sym_RBRACE,
      anon_sym_DQUOTE,
    ACTIONS(1262), 3,
      anon_sym_COLON,
      aux_sym_string_token1,
      sym_symbol,
  [22640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 2,
      sym_vararg,
      sym_symbol,
    ACTIONS(1697), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 2,
      sym_vararg,
      sym_symbol,
    ACTIONS(1654), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1683), 2,
      sym_vararg,
      sym_symbol,
    ACTIONS(1685), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1812), 2,
      sym_vararg,
      sym_symbol,
    ACTIONS(1814), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1669), 2,
      sym_vararg,
      sym_symbol,
    ACTIONS(1671), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      sym_symbol,
    ACTIONS(2046), 1,
      anon_sym_COLON2,
    ACTIONS(1260), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 2,
      sym_vararg,
      sym_symbol,
    ACTIONS(1681), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1691), 2,
      sym_vararg,
      sym_symbol,
    ACTIONS(1693), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [22754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1245), 4,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
      anon_sym_DOT,
  [22768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22779] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      sym_symbol,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(80), 1,
      sym_parameters,
    STATE(671), 1,
      sym_multi_symbol,
    STATE(715), 1,
      sym__function_body,
  [22798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1434), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1450), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22886] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      sym_symbol,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(80), 1,
      sym_parameters,
    STATE(671), 1,
      sym_multi_symbol,
    STATE(748), 1,
      sym__function_body,
  [22905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1442), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [22993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1532), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1604), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1504), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1512), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1616), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1528), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1632), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1508), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23142] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      anon_sym_COLONuntil,
    ACTIONS(2084), 1,
      anon_sym_DOT,
    STATE(520), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1245), 2,
      anon_sym_RBRACK,
      anon_sym_COLON2,
  [23159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1494), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1474), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1620), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1462), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 2,
      anon_sym_AMP,
      sym_symbol,
    ACTIONS(1654), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [23286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1458), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1654), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23312] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 1,
      anon_sym_COLONuntil,
    ACTIONS(1656), 1,
      anon_sym_DOT,
    STATE(520), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1321), 2,
      anon_sym_RBRACK,
      anon_sym_COLON2,
  [23329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1494), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1663), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [23373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1576), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1636), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23408] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      sym_symbol,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(80), 1,
      sym_parameters,
    STATE(671), 1,
      sym_multi_symbol,
    STATE(704), 1,
      sym__function_body,
  [23427] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      sym_symbol,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(80), 1,
      sym_parameters,
    STATE(671), 1,
      sym_multi_symbol,
    STATE(706), 1,
      sym__function_body,
  [23446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1669), 2,
      anon_sym_AMP,
      sym_symbol,
    ACTIONS(1671), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [23459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1454), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 2,
      anon_sym_AMP,
      sym_symbol,
    ACTIONS(1681), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [23485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1636), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23498] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      sym_symbol,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(80), 1,
      sym_parameters,
    STATE(671), 1,
      sym_multi_symbol,
    STATE(751), 1,
      sym__function_body,
  [23517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1462), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 2,
      anon_sym_AMP,
      sym_symbol,
    ACTIONS(1697), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [23543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1691), 2,
      anon_sym_AMP,
      sym_symbol,
    ACTIONS(1693), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [23556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      sym_symbol,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(80), 1,
      sym_parameters,
    STATE(671), 1,
      sym_multi_symbol,
    STATE(750), 1,
      sym__function_body,
  [23575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1677), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      sym_symbol,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(80), 1,
      sym_parameters,
    STATE(671), 1,
      sym_multi_symbol,
    STATE(749), 1,
      sym__function_body,
  [23607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1687), 2,
      anon_sym_AMP,
      sym_symbol,
    ACTIONS(1689), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [23620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1683), 2,
      anon_sym_AMP,
      sym_symbol,
    ACTIONS(1685), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [23633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      sym_symbol,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(80), 1,
      sym_parameters,
    STATE(671), 1,
      sym_multi_symbol,
    STATE(714), 1,
      sym__function_body,
  [23663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(2089), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1584), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1620), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_RBRACK,
    ACTIONS(1262), 1,
      anon_sym_COLONuntil,
    ACTIONS(1656), 1,
      anon_sym_DOT,
    ACTIONS(2091), 1,
      anon_sym_COLON2,
    STATE(534), 1,
      aux_sym_multi_symbol_repeat1,
  [23721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1512), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1482), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1888), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_symbol,
  [23767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1490), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1466), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1450), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1446), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1600), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1520), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1478), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1486), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1472), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1470), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1548), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1434), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1612), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1428), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1426), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1632), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [23960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1753), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [23971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1430), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1438), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [23997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1442), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1528), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1707), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [24034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1580), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1608), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1713), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [24071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1628), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1624), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1532), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1524), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1504), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1516), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1552), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1590), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1588), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1616), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 2,
      anon_sym_COLON,
      sym_symbol,
    ACTIONS(1640), 3,
      anon_sym_RBRACE,
      aux_sym_string_token1,
      anon_sym_DQUOTE,
  [24201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 4,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [24211] = 4,
    ACTIONS(2093), 1,
      anon_sym_DQUOTE,
    ACTIONS(2098), 1,
      sym_comment,
    STATE(602), 1,
      aux_sym_string_repeat1,
    ACTIONS(2095), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1693), 4,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [24235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 4,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [24245] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_DQUOTE,
    STATE(602), 1,
      aux_sym_string_repeat1,
    ACTIONS(2102), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 4,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [24269] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_DQUOTE,
    STATE(602), 1,
      aux_sym_string_repeat1,
    ACTIONS(2102), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 4,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [24293] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    STATE(607), 1,
      aux_sym_string_repeat1,
    ACTIONS(2108), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 1,
      anon_sym_DOT,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(138), 1,
      sym_parameters,
    STATE(238), 1,
      aux_sym_multi_symbol_repeat1,
  [24323] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2110), 1,
      anon_sym_DQUOTE,
    STATE(614), 1,
      aux_sym_string_repeat1,
    ACTIONS(2112), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24337] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2114), 1,
      anon_sym_DQUOTE,
    STATE(617), 1,
      aux_sym_string_repeat1,
    ACTIONS(2116), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1685), 4,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [24361] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2118), 1,
      anon_sym_DQUOTE,
    STATE(602), 1,
      aux_sym_string_repeat1,
    ACTIONS(2102), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1671), 4,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      sym_symbol,
  [24385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1656), 1,
      anon_sym_DOT,
    STATE(534), 1,
      aux_sym_multi_symbol_repeat1,
    ACTIONS(1363), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24399] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_DQUOTE,
    STATE(602), 1,
      aux_sym_string_repeat1,
    ACTIONS(2102), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24413] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2122), 1,
      anon_sym_DQUOTE,
    STATE(619), 1,
      aux_sym_string_repeat1,
    ACTIONS(2124), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24427] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2126), 1,
      anon_sym_DQUOTE,
    STATE(602), 1,
      aux_sym_string_repeat1,
    ACTIONS(2102), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24441] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2128), 1,
      anon_sym_DQUOTE,
    STATE(605), 1,
      aux_sym_string_repeat1,
    ACTIONS(2130), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24455] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2132), 1,
      anon_sym_DQUOTE,
    STATE(623), 1,
      aux_sym_string_repeat1,
    ACTIONS(2134), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      anon_sym_COLONuntil,
    ACTIONS(1245), 3,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON2,
  [24481] = 4,
    ACTIONS(2098), 1,
      sym_comment,
    ACTIONS(2136), 1,
      anon_sym_DQUOTE,
    STATE(602), 1,
      aux_sym_string_repeat1,
    ACTIONS(2102), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [24495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 1,
      sym_symbol,
    STATE(327), 1,
      sym_multi_symbol,
    STATE(336), 1,
      sym_assignment,
  [24508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_RBRACK,
    ACTIONS(1262), 1,
      anon_sym_COLONuntil,
    ACTIONS(2091), 1,
      anon_sym_COLON2,
  [24521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1636), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1494), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    STATE(66), 1,
      sym_for_clause,
  [24571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2140), 1,
      anon_sym_LBRACK,
    STATE(68), 1,
      sym_let_clause,
  [24581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 1,
      sym_symbol,
    STATE(321), 1,
      sym_binding,
  [24599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(731), 1,
      sym_binding,
  [24609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1462), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 1,
      anon_sym_RBRACK,
    ACTIONS(2144), 1,
      anon_sym_COLONuntil,
  [24659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1620), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1632), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1528), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(698), 1,
      sym_binding,
  [24733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(699), 1,
      sym_binding,
  [24743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(716), 1,
      sym_binding,
  [24753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(724), 1,
      sym_binding,
  [24763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 1,
      sym_symbol,
    STATE(317), 1,
      sym_binding,
  [24773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_RBRACK,
    ACTIONS(2148), 1,
      anon_sym_COLONuntil,
  [24783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1504), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 1,
      sym_symbol,
    STATE(553), 1,
      sym_binding,
  [24817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1532), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(761), 1,
      sym_binding,
  [24851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2140), 1,
      anon_sym_LBRACK,
    STATE(100), 1,
      sym_let_clause,
  [24861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    STATE(103), 1,
      sym_for_clause,
  [24871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(760), 1,
      sym_binding,
  [24889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(773), 1,
      sym_binding,
  [24899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1442), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(138), 1,
      sym_parameters,
  [24925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2140), 1,
      anon_sym_LBRACK,
    STATE(144), 1,
      sym_let_clause,
  [24967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    STATE(143), 1,
      sym_for_clause,
  [24977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1434), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [24985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(732), 1,
      sym_binding,
  [24995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_symbol,
    STATE(730), 1,
      sym_binding,
  [25005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1616), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1450), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    STATE(91), 1,
      sym_for_clause,
  [25087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2140), 1,
      anon_sym_LBRACK,
    STATE(92), 1,
      sym_let_clause,
  [25097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1512), 2,
      anon_sym_RBRACK,
      anon_sym_COLONuntil,
  [25105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      sym_symbol_immediate,
  [25112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      sym_symbol_immediate,
  [25119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2156), 1,
      sym_symbol_immediate,
  [25126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      sym_symbol_immediate,
  [25133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2160), 1,
      sym_symbol_immediate,
  [25140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2162), 1,
      anon_sym_RBRACK,
  [25147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_RBRACK,
  [25154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2166), 1,
      anon_sym_RBRACK,
  [25161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2168), 1,
      anon_sym_QMARK,
  [25168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2170), 1,
      anon_sym_RBRACK,
  [25175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2172), 1,
      anon_sym_RBRACK,
  [25182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2174), 1,
      anon_sym_RPAREN,
  [25189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_RBRACK,
  [25196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2178), 1,
      anon_sym_RPAREN,
  [25203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_RPAREN,
  [25210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 1,
      sym_symbol_immediate,
  [25217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 1,
      sym_symbol_immediate,
  [25224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 1,
      anon_sym_RPAREN,
  [25231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2188), 1,
      sym_symbol,
  [25238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      sym_symbol_immediate,
  [25245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2192), 1,
      anon_sym_RPAREN,
  [25252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_RPAREN,
  [25259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_RPAREN,
  [25266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 1,
      anon_sym_RBRACK,
  [25273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2200), 1,
      anon_sym_RBRACK,
  [25280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 1,
      anon_sym_RPAREN,
  [25287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2204), 1,
      anon_sym_RBRACK,
  [25294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 1,
      anon_sym_RBRACK,
  [25301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_RPAREN,
  [25308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 1,
      anon_sym_RBRACK,
  [25315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 1,
      sym_symbol_immediate,
  [25322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 1,
      anon_sym_RBRACK,
  [25329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2216), 1,
      anon_sym_RPAREN,
  [25336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_RPAREN,
  [25343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_RPAREN,
  [25350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_RPAREN,
  [25357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 1,
      anon_sym_RPAREN,
  [25364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_RBRACK,
  [25371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      anon_sym_RBRACK,
  [25378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_RBRACK,
  [25385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
  [25392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 1,
      anon_sym_RBRACK,
  [25399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_RBRACK,
  [25406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_RBRACK,
  [25413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 1,
      anon_sym_RBRACK,
  [25420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 1,
      anon_sym_RBRACK,
  [25427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      anon_sym_RBRACK,
  [25434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2246), 1,
      anon_sym_RBRACK,
  [25441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2248), 1,
      sym_symbol_immediate,
  [25448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      anon_sym_RBRACK,
  [25455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 1,
      anon_sym_RPAREN,
  [25462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 1,
      anon_sym_RBRACK,
  [25469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_RPAREN,
  [25476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
  [25483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 1,
      anon_sym_LBRACK,
  [25490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_RPAREN,
  [25497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_RPAREN,
  [25504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 1,
      anon_sym_RPAREN,
  [25511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2268), 1,
      anon_sym_RPAREN,
  [25518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 1,
      anon_sym_RPAREN,
  [25525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 1,
      sym_symbol_immediate,
  [25532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 1,
      anon_sym_RPAREN,
  [25539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      sym_symbol_immediate,
  [25546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 1,
      anon_sym_RPAREN,
  [25553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2280), 1,
      anon_sym_RBRACK,
  [25560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 1,
      anon_sym_RPAREN,
  [25567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 1,
      sym_symbol_immediate,
  [25574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_RBRACK,
  [25581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 1,
      anon_sym_RBRACK,
  [25588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym_RPAREN,
  [25595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 1,
      anon_sym_RPAREN,
  [25602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 1,
      anon_sym_LBRACK,
  [25609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 1,
      ts_builtin_sym_end,
  [25616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_LBRACK,
  [25623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2300), 1,
      anon_sym_LBRACK,
  [25630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 1,
      anon_sym_LBRACK,
  [25637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
  [25644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_LBRACK,
  [25651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 1,
      anon_sym_LBRACK,
  [25658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 1,
      anon_sym_LBRACK,
  [25665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2312), 1,
      anon_sym_RBRACK,
  [25672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_LBRACK,
  [25679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2316), 1,
      anon_sym_LBRACK,
  [25686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_LBRACK,
  [25693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      anon_sym_RPAREN,
  [25700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1725), 1,
      anon_sym_QMARK,
  [25707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 1,
      anon_sym_QMARK,
  [25714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 1,
      anon_sym_RBRACK,
  [25721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2324), 1,
      anon_sym_LBRACK,
  [25728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 1,
      anon_sym_LBRACK,
  [25735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2328), 1,
      anon_sym_LBRACK,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(3)] = 0,
  [SMALL_STATE(4)] = 116,
  [SMALL_STATE(5)] = 232,
  [SMALL_STATE(6)] = 348,
  [SMALL_STATE(7)] = 464,
  [SMALL_STATE(8)] = 543,
  [SMALL_STATE(9)] = 624,
  [SMALL_STATE(10)] = 703,
  [SMALL_STATE(11)] = 782,
  [SMALL_STATE(12)] = 861,
  [SMALL_STATE(13)] = 942,
  [SMALL_STATE(14)] = 1021,
  [SMALL_STATE(15)] = 1100,
  [SMALL_STATE(16)] = 1179,
  [SMALL_STATE(17)] = 1258,
  [SMALL_STATE(18)] = 1337,
  [SMALL_STATE(19)] = 1416,
  [SMALL_STATE(20)] = 1495,
  [SMALL_STATE(21)] = 1574,
  [SMALL_STATE(22)] = 1653,
  [SMALL_STATE(23)] = 1732,
  [SMALL_STATE(24)] = 1811,
  [SMALL_STATE(25)] = 1892,
  [SMALL_STATE(26)] = 1971,
  [SMALL_STATE(27)] = 2047,
  [SMALL_STATE(28)] = 2134,
  [SMALL_STATE(29)] = 2221,
  [SMALL_STATE(30)] = 2308,
  [SMALL_STATE(31)] = 2385,
  [SMALL_STATE(32)] = 2462,
  [SMALL_STATE(33)] = 2539,
  [SMALL_STATE(34)] = 2616,
  [SMALL_STATE(35)] = 2693,
  [SMALL_STATE(36)] = 2766,
  [SMALL_STATE(37)] = 2843,
  [SMALL_STATE(38)] = 2920,
  [SMALL_STATE(39)] = 2997,
  [SMALL_STATE(40)] = 3074,
  [SMALL_STATE(41)] = 3151,
  [SMALL_STATE(42)] = 3228,
  [SMALL_STATE(43)] = 3304,
  [SMALL_STATE(44)] = 3380,
  [SMALL_STATE(45)] = 3456,
  [SMALL_STATE(46)] = 3532,
  [SMALL_STATE(47)] = 3608,
  [SMALL_STATE(48)] = 3684,
  [SMALL_STATE(49)] = 3760,
  [SMALL_STATE(50)] = 3836,
  [SMALL_STATE(51)] = 3912,
  [SMALL_STATE(52)] = 3988,
  [SMALL_STATE(53)] = 4064,
  [SMALL_STATE(54)] = 4140,
  [SMALL_STATE(55)] = 4216,
  [SMALL_STATE(56)] = 4292,
  [SMALL_STATE(57)] = 4363,
  [SMALL_STATE(58)] = 4434,
  [SMALL_STATE(59)] = 4505,
  [SMALL_STATE(60)] = 4576,
  [SMALL_STATE(61)] = 4647,
  [SMALL_STATE(62)] = 4718,
  [SMALL_STATE(63)] = 4789,
  [SMALL_STATE(64)] = 4860,
  [SMALL_STATE(65)] = 4931,
  [SMALL_STATE(66)] = 5002,
  [SMALL_STATE(67)] = 5073,
  [SMALL_STATE(68)] = 5144,
  [SMALL_STATE(69)] = 5215,
  [SMALL_STATE(70)] = 5286,
  [SMALL_STATE(71)] = 5357,
  [SMALL_STATE(72)] = 5428,
  [SMALL_STATE(73)] = 5499,
  [SMALL_STATE(74)] = 5570,
  [SMALL_STATE(75)] = 5641,
  [SMALL_STATE(76)] = 5712,
  [SMALL_STATE(77)] = 5783,
  [SMALL_STATE(78)] = 5854,
  [SMALL_STATE(79)] = 5925,
  [SMALL_STATE(80)] = 5996,
  [SMALL_STATE(81)] = 6069,
  [SMALL_STATE(82)] = 6140,
  [SMALL_STATE(83)] = 6211,
  [SMALL_STATE(84)] = 6282,
  [SMALL_STATE(85)] = 6353,
  [SMALL_STATE(86)] = 6424,
  [SMALL_STATE(87)] = 6495,
  [SMALL_STATE(88)] = 6566,
  [SMALL_STATE(89)] = 6637,
  [SMALL_STATE(90)] = 6708,
  [SMALL_STATE(91)] = 6779,
  [SMALL_STATE(92)] = 6850,
  [SMALL_STATE(93)] = 6921,
  [SMALL_STATE(94)] = 6992,
  [SMALL_STATE(95)] = 7063,
  [SMALL_STATE(96)] = 7134,
  [SMALL_STATE(97)] = 7205,
  [SMALL_STATE(98)] = 7276,
  [SMALL_STATE(99)] = 7347,
  [SMALL_STATE(100)] = 7418,
  [SMALL_STATE(101)] = 7489,
  [SMALL_STATE(102)] = 7560,
  [SMALL_STATE(103)] = 7631,
  [SMALL_STATE(104)] = 7702,
  [SMALL_STATE(105)] = 7773,
  [SMALL_STATE(106)] = 7844,
  [SMALL_STATE(107)] = 7915,
  [SMALL_STATE(108)] = 7986,
  [SMALL_STATE(109)] = 8057,
  [SMALL_STATE(110)] = 8128,
  [SMALL_STATE(111)] = 8199,
  [SMALL_STATE(112)] = 8270,
  [SMALL_STATE(113)] = 8341,
  [SMALL_STATE(114)] = 8412,
  [SMALL_STATE(115)] = 8483,
  [SMALL_STATE(116)] = 8554,
  [SMALL_STATE(117)] = 8625,
  [SMALL_STATE(118)] = 8696,
  [SMALL_STATE(119)] = 8767,
  [SMALL_STATE(120)] = 8838,
  [SMALL_STATE(121)] = 8909,
  [SMALL_STATE(122)] = 8980,
  [SMALL_STATE(123)] = 9051,
  [SMALL_STATE(124)] = 9122,
  [SMALL_STATE(125)] = 9193,
  [SMALL_STATE(126)] = 9264,
  [SMALL_STATE(127)] = 9335,
  [SMALL_STATE(128)] = 9406,
  [SMALL_STATE(129)] = 9477,
  [SMALL_STATE(130)] = 9548,
  [SMALL_STATE(131)] = 9619,
  [SMALL_STATE(132)] = 9690,
  [SMALL_STATE(133)] = 9761,
  [SMALL_STATE(134)] = 9834,
  [SMALL_STATE(135)] = 9907,
  [SMALL_STATE(136)] = 9978,
  [SMALL_STATE(137)] = 10049,
  [SMALL_STATE(138)] = 10120,
  [SMALL_STATE(139)] = 10193,
  [SMALL_STATE(140)] = 10264,
  [SMALL_STATE(141)] = 10335,
  [SMALL_STATE(142)] = 10406,
  [SMALL_STATE(143)] = 10477,
  [SMALL_STATE(144)] = 10548,
  [SMALL_STATE(145)] = 10619,
  [SMALL_STATE(146)] = 10690,
  [SMALL_STATE(147)] = 10758,
  [SMALL_STATE(148)] = 10828,
  [SMALL_STATE(149)] = 10895,
  [SMALL_STATE(150)] = 10962,
  [SMALL_STATE(151)] = 11029,
  [SMALL_STATE(152)] = 11096,
  [SMALL_STATE(153)] = 11163,
  [SMALL_STATE(154)] = 11230,
  [SMALL_STATE(155)] = 11297,
  [SMALL_STATE(156)] = 11364,
  [SMALL_STATE(157)] = 11431,
  [SMALL_STATE(158)] = 11498,
  [SMALL_STATE(159)] = 11565,
  [SMALL_STATE(160)] = 11632,
  [SMALL_STATE(161)] = 11699,
  [SMALL_STATE(162)] = 11766,
  [SMALL_STATE(163)] = 11833,
  [SMALL_STATE(164)] = 11900,
  [SMALL_STATE(165)] = 11967,
  [SMALL_STATE(166)] = 12034,
  [SMALL_STATE(167)] = 12101,
  [SMALL_STATE(168)] = 12168,
  [SMALL_STATE(169)] = 12235,
  [SMALL_STATE(170)] = 12302,
  [SMALL_STATE(171)] = 12369,
  [SMALL_STATE(172)] = 12436,
  [SMALL_STATE(173)] = 12503,
  [SMALL_STATE(174)] = 12570,
  [SMALL_STATE(175)] = 12637,
  [SMALL_STATE(176)] = 12704,
  [SMALL_STATE(177)] = 12771,
  [SMALL_STATE(178)] = 12838,
  [SMALL_STATE(179)] = 12905,
  [SMALL_STATE(180)] = 12972,
  [SMALL_STATE(181)] = 13039,
  [SMALL_STATE(182)] = 13106,
  [SMALL_STATE(183)] = 13173,
  [SMALL_STATE(184)] = 13240,
  [SMALL_STATE(185)] = 13307,
  [SMALL_STATE(186)] = 13374,
  [SMALL_STATE(187)] = 13441,
  [SMALL_STATE(188)] = 13508,
  [SMALL_STATE(189)] = 13575,
  [SMALL_STATE(190)] = 13632,
  [SMALL_STATE(191)] = 13686,
  [SMALL_STATE(192)] = 13740,
  [SMALL_STATE(193)] = 13794,
  [SMALL_STATE(194)] = 13848,
  [SMALL_STATE(195)] = 13902,
  [SMALL_STATE(196)] = 13956,
  [SMALL_STATE(197)] = 14010,
  [SMALL_STATE(198)] = 14064,
  [SMALL_STATE(199)] = 14118,
  [SMALL_STATE(200)] = 14173,
  [SMALL_STATE(201)] = 14228,
  [SMALL_STATE(202)] = 14283,
  [SMALL_STATE(203)] = 14338,
  [SMALL_STATE(204)] = 14393,
  [SMALL_STATE(205)] = 14448,
  [SMALL_STATE(206)] = 14503,
  [SMALL_STATE(207)] = 14558,
  [SMALL_STATE(208)] = 14613,
  [SMALL_STATE(209)] = 14668,
  [SMALL_STATE(210)] = 14723,
  [SMALL_STATE(211)] = 14778,
  [SMALL_STATE(212)] = 14833,
  [SMALL_STATE(213)] = 14888,
  [SMALL_STATE(214)] = 14943,
  [SMALL_STATE(215)] = 14998,
  [SMALL_STATE(216)] = 15053,
  [SMALL_STATE(217)] = 15108,
  [SMALL_STATE(218)] = 15163,
  [SMALL_STATE(219)] = 15218,
  [SMALL_STATE(220)] = 15273,
  [SMALL_STATE(221)] = 15328,
  [SMALL_STATE(222)] = 15383,
  [SMALL_STATE(223)] = 15438,
  [SMALL_STATE(224)] = 15494,
  [SMALL_STATE(225)] = 15545,
  [SMALL_STATE(226)] = 15596,
  [SMALL_STATE(227)] = 15647,
  [SMALL_STATE(228)] = 15682,
  [SMALL_STATE(229)] = 15731,
  [SMALL_STATE(230)] = 15768,
  [SMALL_STATE(231)] = 15819,
  [SMALL_STATE(232)] = 15870,
  [SMALL_STATE(233)] = 15919,
  [SMALL_STATE(234)] = 15968,
  [SMALL_STATE(235)] = 16003,
  [SMALL_STATE(236)] = 16054,
  [SMALL_STATE(237)] = 16105,
  [SMALL_STATE(238)] = 16156,
  [SMALL_STATE(239)] = 16190,
  [SMALL_STATE(240)] = 16230,
  [SMALL_STATE(241)] = 16264,
  [SMALL_STATE(242)] = 16294,
  [SMALL_STATE(243)] = 16328,
  [SMALL_STATE(244)] = 16373,
  [SMALL_STATE(245)] = 16418,
  [SMALL_STATE(246)] = 16463,
  [SMALL_STATE(247)] = 16494,
  [SMALL_STATE(248)] = 16523,
  [SMALL_STATE(249)] = 16570,
  [SMALL_STATE(250)] = 16598,
  [SMALL_STATE(251)] = 16642,
  [SMALL_STATE(252)] = 16670,
  [SMALL_STATE(253)] = 16698,
  [SMALL_STATE(254)] = 16726,
  [SMALL_STATE(255)] = 16754,
  [SMALL_STATE(256)] = 16782,
  [SMALL_STATE(257)] = 16810,
  [SMALL_STATE(258)] = 16838,
  [SMALL_STATE(259)] = 16866,
  [SMALL_STATE(260)] = 16894,
  [SMALL_STATE(261)] = 16922,
  [SMALL_STATE(262)] = 16950,
  [SMALL_STATE(263)] = 16978,
  [SMALL_STATE(264)] = 17006,
  [SMALL_STATE(265)] = 17034,
  [SMALL_STATE(266)] = 17062,
  [SMALL_STATE(267)] = 17090,
  [SMALL_STATE(268)] = 17118,
  [SMALL_STATE(269)] = 17162,
  [SMALL_STATE(270)] = 17190,
  [SMALL_STATE(271)] = 17218,
  [SMALL_STATE(272)] = 17246,
  [SMALL_STATE(273)] = 17274,
  [SMALL_STATE(274)] = 17302,
  [SMALL_STATE(275)] = 17330,
  [SMALL_STATE(276)] = 17358,
  [SMALL_STATE(277)] = 17386,
  [SMALL_STATE(278)] = 17430,
  [SMALL_STATE(279)] = 17474,
  [SMALL_STATE(280)] = 17502,
  [SMALL_STATE(281)] = 17530,
  [SMALL_STATE(282)] = 17574,
  [SMALL_STATE(283)] = 17618,
  [SMALL_STATE(284)] = 17662,
  [SMALL_STATE(285)] = 17706,
  [SMALL_STATE(286)] = 17750,
  [SMALL_STATE(287)] = 17794,
  [SMALL_STATE(288)] = 17822,
  [SMALL_STATE(289)] = 17850,
  [SMALL_STATE(290)] = 17878,
  [SMALL_STATE(291)] = 17906,
  [SMALL_STATE(292)] = 17950,
  [SMALL_STATE(293)] = 17994,
  [SMALL_STATE(294)] = 18022,
  [SMALL_STATE(295)] = 18050,
  [SMALL_STATE(296)] = 18078,
  [SMALL_STATE(297)] = 18106,
  [SMALL_STATE(298)] = 18134,
  [SMALL_STATE(299)] = 18162,
  [SMALL_STATE(300)] = 18190,
  [SMALL_STATE(301)] = 18218,
  [SMALL_STATE(302)] = 18246,
  [SMALL_STATE(303)] = 18274,
  [SMALL_STATE(304)] = 18302,
  [SMALL_STATE(305)] = 18333,
  [SMALL_STATE(306)] = 18370,
  [SMALL_STATE(307)] = 18407,
  [SMALL_STATE(308)] = 18442,
  [SMALL_STATE(309)] = 18473,
  [SMALL_STATE(310)] = 18504,
  [SMALL_STATE(311)] = 18537,
  [SMALL_STATE(312)] = 18568,
  [SMALL_STATE(313)] = 18599,
  [SMALL_STATE(314)] = 18625,
  [SMALL_STATE(315)] = 18651,
  [SMALL_STATE(316)] = 18691,
  [SMALL_STATE(317)] = 18717,
  [SMALL_STATE(318)] = 18747,
  [SMALL_STATE(319)] = 18773,
  [SMALL_STATE(320)] = 18799,
  [SMALL_STATE(321)] = 18825,
  [SMALL_STATE(322)] = 18851,
  [SMALL_STATE(323)] = 18877,
  [SMALL_STATE(324)] = 18903,
  [SMALL_STATE(325)] = 18928,
  [SMALL_STATE(326)] = 18959,
  [SMALL_STATE(327)] = 18988,
  [SMALL_STATE(328)] = 19013,
  [SMALL_STATE(329)] = 19038,
  [SMALL_STATE(330)] = 19063,
  [SMALL_STATE(331)] = 19088,
  [SMALL_STATE(332)] = 19113,
  [SMALL_STATE(333)] = 19138,
  [SMALL_STATE(334)] = 19163,
  [SMALL_STATE(335)] = 19188,
  [SMALL_STATE(336)] = 19213,
  [SMALL_STATE(337)] = 19238,
  [SMALL_STATE(338)] = 19263,
  [SMALL_STATE(339)] = 19288,
  [SMALL_STATE(340)] = 19313,
  [SMALL_STATE(341)] = 19342,
  [SMALL_STATE(342)] = 19369,
  [SMALL_STATE(343)] = 19398,
  [SMALL_STATE(344)] = 19423,
  [SMALL_STATE(345)] = 19448,
  [SMALL_STATE(346)] = 19473,
  [SMALL_STATE(347)] = 19504,
  [SMALL_STATE(348)] = 19529,
  [SMALL_STATE(349)] = 19554,
  [SMALL_STATE(350)] = 19579,
  [SMALL_STATE(351)] = 19604,
  [SMALL_STATE(352)] = 19628,
  [SMALL_STATE(353)] = 19652,
  [SMALL_STATE(354)] = 19676,
  [SMALL_STATE(355)] = 19700,
  [SMALL_STATE(356)] = 19724,
  [SMALL_STATE(357)] = 19748,
  [SMALL_STATE(358)] = 19772,
  [SMALL_STATE(359)] = 19800,
  [SMALL_STATE(360)] = 19828,
  [SMALL_STATE(361)] = 19852,
  [SMALL_STATE(362)] = 19876,
  [SMALL_STATE(363)] = 19899,
  [SMALL_STATE(364)] = 19922,
  [SMALL_STATE(365)] = 19945,
  [SMALL_STATE(366)] = 19968,
  [SMALL_STATE(367)] = 19991,
  [SMALL_STATE(368)] = 20014,
  [SMALL_STATE(369)] = 20037,
  [SMALL_STATE(370)] = 20060,
  [SMALL_STATE(371)] = 20083,
  [SMALL_STATE(372)] = 20110,
  [SMALL_STATE(373)] = 20137,
  [SMALL_STATE(374)] = 20160,
  [SMALL_STATE(375)] = 20183,
  [SMALL_STATE(376)] = 20210,
  [SMALL_STATE(377)] = 20233,
  [SMALL_STATE(378)] = 20256,
  [SMALL_STATE(379)] = 20279,
  [SMALL_STATE(380)] = 20302,
  [SMALL_STATE(381)] = 20325,
  [SMALL_STATE(382)] = 20348,
  [SMALL_STATE(383)] = 20371,
  [SMALL_STATE(384)] = 20394,
  [SMALL_STATE(385)] = 20417,
  [SMALL_STATE(386)] = 20440,
  [SMALL_STATE(387)] = 20463,
  [SMALL_STATE(388)] = 20485,
  [SMALL_STATE(389)] = 20516,
  [SMALL_STATE(390)] = 20537,
  [SMALL_STATE(391)] = 20558,
  [SMALL_STATE(392)] = 20579,
  [SMALL_STATE(393)] = 20610,
  [SMALL_STATE(394)] = 20631,
  [SMALL_STATE(395)] = 20662,
  [SMALL_STATE(396)] = 20683,
  [SMALL_STATE(397)] = 20704,
  [SMALL_STATE(398)] = 20725,
  [SMALL_STATE(399)] = 20746,
  [SMALL_STATE(400)] = 20769,
  [SMALL_STATE(401)] = 20790,
  [SMALL_STATE(402)] = 20820,
  [SMALL_STATE(403)] = 20850,
  [SMALL_STATE(404)] = 20880,
  [SMALL_STATE(405)] = 20907,
  [SMALL_STATE(406)] = 20934,
  [SMALL_STATE(407)] = 20961,
  [SMALL_STATE(408)] = 20988,
  [SMALL_STATE(409)] = 21015,
  [SMALL_STATE(410)] = 21039,
  [SMALL_STATE(411)] = 21063,
  [SMALL_STATE(412)] = 21089,
  [SMALL_STATE(413)] = 21113,
  [SMALL_STATE(414)] = 21139,
  [SMALL_STATE(415)] = 21165,
  [SMALL_STATE(416)] = 21191,
  [SMALL_STATE(417)] = 21215,
  [SMALL_STATE(418)] = 21239,
  [SMALL_STATE(419)] = 21263,
  [SMALL_STATE(420)] = 21289,
  [SMALL_STATE(421)] = 21315,
  [SMALL_STATE(422)] = 21341,
  [SMALL_STATE(423)] = 21367,
  [SMALL_STATE(424)] = 21393,
  [SMALL_STATE(425)] = 21419,
  [SMALL_STATE(426)] = 21443,
  [SMALL_STATE(427)] = 21469,
  [SMALL_STATE(428)] = 21493,
  [SMALL_STATE(429)] = 21519,
  [SMALL_STATE(430)] = 21543,
  [SMALL_STATE(431)] = 21567,
  [SMALL_STATE(432)] = 21593,
  [SMALL_STATE(433)] = 21617,
  [SMALL_STATE(434)] = 21641,
  [SMALL_STATE(435)] = 21667,
  [SMALL_STATE(436)] = 21693,
  [SMALL_STATE(437)] = 21719,
  [SMALL_STATE(438)] = 21745,
  [SMALL_STATE(439)] = 21771,
  [SMALL_STATE(440)] = 21797,
  [SMALL_STATE(441)] = 21821,
  [SMALL_STATE(442)] = 21845,
  [SMALL_STATE(443)] = 21869,
  [SMALL_STATE(444)] = 21893,
  [SMALL_STATE(445)] = 21920,
  [SMALL_STATE(446)] = 21943,
  [SMALL_STATE(447)] = 21966,
  [SMALL_STATE(448)] = 21993,
  [SMALL_STATE(449)] = 22016,
  [SMALL_STATE(450)] = 22043,
  [SMALL_STATE(451)] = 22070,
  [SMALL_STATE(452)] = 22097,
  [SMALL_STATE(453)] = 22124,
  [SMALL_STATE(454)] = 22147,
  [SMALL_STATE(455)] = 22174,
  [SMALL_STATE(456)] = 22197,
  [SMALL_STATE(457)] = 22224,
  [SMALL_STATE(458)] = 22251,
  [SMALL_STATE(459)] = 22273,
  [SMALL_STATE(460)] = 22295,
  [SMALL_STATE(461)] = 22315,
  [SMALL_STATE(462)] = 22335,
  [SMALL_STATE(463)] = 22357,
  [SMALL_STATE(464)] = 22377,
  [SMALL_STATE(465)] = 22397,
  [SMALL_STATE(466)] = 22417,
  [SMALL_STATE(467)] = 22437,
  [SMALL_STATE(468)] = 22456,
  [SMALL_STATE(469)] = 22475,
  [SMALL_STATE(470)] = 22490,
  [SMALL_STATE(471)] = 22509,
  [SMALL_STATE(472)] = 22528,
  [SMALL_STATE(473)] = 22547,
  [SMALL_STATE(474)] = 22562,
  [SMALL_STATE(475)] = 22581,
  [SMALL_STATE(476)] = 22596,
  [SMALL_STATE(477)] = 22610,
  [SMALL_STATE(478)] = 22624,
  [SMALL_STATE(479)] = 22640,
  [SMALL_STATE(480)] = 22654,
  [SMALL_STATE(481)] = 22668,
  [SMALL_STATE(482)] = 22682,
  [SMALL_STATE(483)] = 22696,
  [SMALL_STATE(484)] = 22710,
  [SMALL_STATE(485)] = 22726,
  [SMALL_STATE(486)] = 22740,
  [SMALL_STATE(487)] = 22754,
  [SMALL_STATE(488)] = 22768,
  [SMALL_STATE(489)] = 22779,
  [SMALL_STATE(490)] = 22798,
  [SMALL_STATE(491)] = 22809,
  [SMALL_STATE(492)] = 22820,
  [SMALL_STATE(493)] = 22831,
  [SMALL_STATE(494)] = 22842,
  [SMALL_STATE(495)] = 22853,
  [SMALL_STATE(496)] = 22864,
  [SMALL_STATE(497)] = 22875,
  [SMALL_STATE(498)] = 22886,
  [SMALL_STATE(499)] = 22905,
  [SMALL_STATE(500)] = 22916,
  [SMALL_STATE(501)] = 22927,
  [SMALL_STATE(502)] = 22938,
  [SMALL_STATE(503)] = 22949,
  [SMALL_STATE(504)] = 22960,
  [SMALL_STATE(505)] = 22971,
  [SMALL_STATE(506)] = 22982,
  [SMALL_STATE(507)] = 22993,
  [SMALL_STATE(508)] = 23004,
  [SMALL_STATE(509)] = 23015,
  [SMALL_STATE(510)] = 23028,
  [SMALL_STATE(511)] = 23039,
  [SMALL_STATE(512)] = 23052,
  [SMALL_STATE(513)] = 23063,
  [SMALL_STATE(514)] = 23074,
  [SMALL_STATE(515)] = 23085,
  [SMALL_STATE(516)] = 23096,
  [SMALL_STATE(517)] = 23107,
  [SMALL_STATE(518)] = 23118,
  [SMALL_STATE(519)] = 23129,
  [SMALL_STATE(520)] = 23142,
  [SMALL_STATE(521)] = 23159,
  [SMALL_STATE(522)] = 23172,
  [SMALL_STATE(523)] = 23185,
  [SMALL_STATE(524)] = 23196,
  [SMALL_STATE(525)] = 23207,
  [SMALL_STATE(526)] = 23218,
  [SMALL_STATE(527)] = 23229,
  [SMALL_STATE(528)] = 23240,
  [SMALL_STATE(529)] = 23251,
  [SMALL_STATE(530)] = 23262,
  [SMALL_STATE(531)] = 23273,
  [SMALL_STATE(532)] = 23286,
  [SMALL_STATE(533)] = 23299,
  [SMALL_STATE(534)] = 23312,
  [SMALL_STATE(535)] = 23329,
  [SMALL_STATE(536)] = 23340,
  [SMALL_STATE(537)] = 23351,
  [SMALL_STATE(538)] = 23362,
  [SMALL_STATE(539)] = 23373,
  [SMALL_STATE(540)] = 23386,
  [SMALL_STATE(541)] = 23397,
  [SMALL_STATE(542)] = 23408,
  [SMALL_STATE(543)] = 23427,
  [SMALL_STATE(544)] = 23446,
  [SMALL_STATE(545)] = 23459,
  [SMALL_STATE(546)] = 23472,
  [SMALL_STATE(547)] = 23485,
  [SMALL_STATE(548)] = 23498,
  [SMALL_STATE(549)] = 23517,
  [SMALL_STATE(550)] = 23530,
  [SMALL_STATE(551)] = 23543,
  [SMALL_STATE(552)] = 23556,
  [SMALL_STATE(553)] = 23575,
  [SMALL_STATE(554)] = 23588,
  [SMALL_STATE(555)] = 23607,
  [SMALL_STATE(556)] = 23620,
  [SMALL_STATE(557)] = 23633,
  [SMALL_STATE(558)] = 23644,
  [SMALL_STATE(559)] = 23663,
  [SMALL_STATE(560)] = 23676,
  [SMALL_STATE(561)] = 23689,
  [SMALL_STATE(562)] = 23702,
  [SMALL_STATE(563)] = 23721,
  [SMALL_STATE(564)] = 23732,
  [SMALL_STATE(565)] = 23743,
  [SMALL_STATE(566)] = 23756,
  [SMALL_STATE(567)] = 23767,
  [SMALL_STATE(568)] = 23780,
  [SMALL_STATE(569)] = 23793,
  [SMALL_STATE(570)] = 23806,
  [SMALL_STATE(571)] = 23819,
  [SMALL_STATE(572)] = 23832,
  [SMALL_STATE(573)] = 23845,
  [SMALL_STATE(574)] = 23858,
  [SMALL_STATE(575)] = 23871,
  [SMALL_STATE(576)] = 23884,
  [SMALL_STATE(577)] = 23897,
  [SMALL_STATE(578)] = 23910,
  [SMALL_STATE(579)] = 23923,
  [SMALL_STATE(580)] = 23936,
  [SMALL_STATE(581)] = 23949,
  [SMALL_STATE(582)] = 23960,
  [SMALL_STATE(583)] = 23971,
  [SMALL_STATE(584)] = 23984,
  [SMALL_STATE(585)] = 23997,
  [SMALL_STATE(586)] = 24010,
  [SMALL_STATE(587)] = 24023,
  [SMALL_STATE(588)] = 24034,
  [SMALL_STATE(589)] = 24047,
  [SMALL_STATE(590)] = 24060,
  [SMALL_STATE(591)] = 24071,
  [SMALL_STATE(592)] = 24084,
  [SMALL_STATE(593)] = 24097,
  [SMALL_STATE(594)] = 24110,
  [SMALL_STATE(595)] = 24123,
  [SMALL_STATE(596)] = 24136,
  [SMALL_STATE(597)] = 24149,
  [SMALL_STATE(598)] = 24162,
  [SMALL_STATE(599)] = 24175,
  [SMALL_STATE(600)] = 24188,
  [SMALL_STATE(601)] = 24201,
  [SMALL_STATE(602)] = 24211,
  [SMALL_STATE(603)] = 24225,
  [SMALL_STATE(604)] = 24235,
  [SMALL_STATE(605)] = 24245,
  [SMALL_STATE(606)] = 24259,
  [SMALL_STATE(607)] = 24269,
  [SMALL_STATE(608)] = 24283,
  [SMALL_STATE(609)] = 24293,
  [SMALL_STATE(610)] = 24307,
  [SMALL_STATE(611)] = 24323,
  [SMALL_STATE(612)] = 24337,
  [SMALL_STATE(613)] = 24351,
  [SMALL_STATE(614)] = 24361,
  [SMALL_STATE(615)] = 24375,
  [SMALL_STATE(616)] = 24385,
  [SMALL_STATE(617)] = 24399,
  [SMALL_STATE(618)] = 24413,
  [SMALL_STATE(619)] = 24427,
  [SMALL_STATE(620)] = 24441,
  [SMALL_STATE(621)] = 24455,
  [SMALL_STATE(622)] = 24469,
  [SMALL_STATE(623)] = 24481,
  [SMALL_STATE(624)] = 24495,
  [SMALL_STATE(625)] = 24508,
  [SMALL_STATE(626)] = 24521,
  [SMALL_STATE(627)] = 24529,
  [SMALL_STATE(628)] = 24537,
  [SMALL_STATE(629)] = 24545,
  [SMALL_STATE(630)] = 24553,
  [SMALL_STATE(631)] = 24561,
  [SMALL_STATE(632)] = 24571,
  [SMALL_STATE(633)] = 24581,
  [SMALL_STATE(634)] = 24589,
  [SMALL_STATE(635)] = 24599,
  [SMALL_STATE(636)] = 24609,
  [SMALL_STATE(637)] = 24617,
  [SMALL_STATE(638)] = 24625,
  [SMALL_STATE(639)] = 24633,
  [SMALL_STATE(640)] = 24641,
  [SMALL_STATE(641)] = 24649,
  [SMALL_STATE(642)] = 24659,
  [SMALL_STATE(643)] = 24667,
  [SMALL_STATE(644)] = 24675,
  [SMALL_STATE(645)] = 24683,
  [SMALL_STATE(646)] = 24691,
  [SMALL_STATE(647)] = 24699,
  [SMALL_STATE(648)] = 24707,
  [SMALL_STATE(649)] = 24715,
  [SMALL_STATE(650)] = 24723,
  [SMALL_STATE(651)] = 24733,
  [SMALL_STATE(652)] = 24743,
  [SMALL_STATE(653)] = 24753,
  [SMALL_STATE(654)] = 24763,
  [SMALL_STATE(655)] = 24773,
  [SMALL_STATE(656)] = 24783,
  [SMALL_STATE(657)] = 24791,
  [SMALL_STATE(658)] = 24799,
  [SMALL_STATE(659)] = 24807,
  [SMALL_STATE(660)] = 24817,
  [SMALL_STATE(661)] = 24825,
  [SMALL_STATE(662)] = 24833,
  [SMALL_STATE(663)] = 24841,
  [SMALL_STATE(664)] = 24851,
  [SMALL_STATE(665)] = 24861,
  [SMALL_STATE(666)] = 24871,
  [SMALL_STATE(667)] = 24879,
  [SMALL_STATE(668)] = 24889,
  [SMALL_STATE(669)] = 24899,
  [SMALL_STATE(670)] = 24907,
  [SMALL_STATE(671)] = 24915,
  [SMALL_STATE(672)] = 24925,
  [SMALL_STATE(673)] = 24933,
  [SMALL_STATE(674)] = 24941,
  [SMALL_STATE(675)] = 24949,
  [SMALL_STATE(676)] = 24957,
  [SMALL_STATE(677)] = 24967,
  [SMALL_STATE(678)] = 24977,
  [SMALL_STATE(679)] = 24985,
  [SMALL_STATE(680)] = 24995,
  [SMALL_STATE(681)] = 25005,
  [SMALL_STATE(682)] = 25013,
  [SMALL_STATE(683)] = 25021,
  [SMALL_STATE(684)] = 25029,
  [SMALL_STATE(685)] = 25037,
  [SMALL_STATE(686)] = 25045,
  [SMALL_STATE(687)] = 25053,
  [SMALL_STATE(688)] = 25061,
  [SMALL_STATE(689)] = 25069,
  [SMALL_STATE(690)] = 25077,
  [SMALL_STATE(691)] = 25087,
  [SMALL_STATE(692)] = 25097,
  [SMALL_STATE(693)] = 25105,
  [SMALL_STATE(694)] = 25112,
  [SMALL_STATE(695)] = 25119,
  [SMALL_STATE(696)] = 25126,
  [SMALL_STATE(697)] = 25133,
  [SMALL_STATE(698)] = 25140,
  [SMALL_STATE(699)] = 25147,
  [SMALL_STATE(700)] = 25154,
  [SMALL_STATE(701)] = 25161,
  [SMALL_STATE(702)] = 25168,
  [SMALL_STATE(703)] = 25175,
  [SMALL_STATE(704)] = 25182,
  [SMALL_STATE(705)] = 25189,
  [SMALL_STATE(706)] = 25196,
  [SMALL_STATE(707)] = 25203,
  [SMALL_STATE(708)] = 25210,
  [SMALL_STATE(709)] = 25217,
  [SMALL_STATE(710)] = 25224,
  [SMALL_STATE(711)] = 25231,
  [SMALL_STATE(712)] = 25238,
  [SMALL_STATE(713)] = 25245,
  [SMALL_STATE(714)] = 25252,
  [SMALL_STATE(715)] = 25259,
  [SMALL_STATE(716)] = 25266,
  [SMALL_STATE(717)] = 25273,
  [SMALL_STATE(718)] = 25280,
  [SMALL_STATE(719)] = 25287,
  [SMALL_STATE(720)] = 25294,
  [SMALL_STATE(721)] = 25301,
  [SMALL_STATE(722)] = 25308,
  [SMALL_STATE(723)] = 25315,
  [SMALL_STATE(724)] = 25322,
  [SMALL_STATE(725)] = 25329,
  [SMALL_STATE(726)] = 25336,
  [SMALL_STATE(727)] = 25343,
  [SMALL_STATE(728)] = 25350,
  [SMALL_STATE(729)] = 25357,
  [SMALL_STATE(730)] = 25364,
  [SMALL_STATE(731)] = 25371,
  [SMALL_STATE(732)] = 25378,
  [SMALL_STATE(733)] = 25385,
  [SMALL_STATE(734)] = 25392,
  [SMALL_STATE(735)] = 25399,
  [SMALL_STATE(736)] = 25406,
  [SMALL_STATE(737)] = 25413,
  [SMALL_STATE(738)] = 25420,
  [SMALL_STATE(739)] = 25427,
  [SMALL_STATE(740)] = 25434,
  [SMALL_STATE(741)] = 25441,
  [SMALL_STATE(742)] = 25448,
  [SMALL_STATE(743)] = 25455,
  [SMALL_STATE(744)] = 25462,
  [SMALL_STATE(745)] = 25469,
  [SMALL_STATE(746)] = 25476,
  [SMALL_STATE(747)] = 25483,
  [SMALL_STATE(748)] = 25490,
  [SMALL_STATE(749)] = 25497,
  [SMALL_STATE(750)] = 25504,
  [SMALL_STATE(751)] = 25511,
  [SMALL_STATE(752)] = 25518,
  [SMALL_STATE(753)] = 25525,
  [SMALL_STATE(754)] = 25532,
  [SMALL_STATE(755)] = 25539,
  [SMALL_STATE(756)] = 25546,
  [SMALL_STATE(757)] = 25553,
  [SMALL_STATE(758)] = 25560,
  [SMALL_STATE(759)] = 25567,
  [SMALL_STATE(760)] = 25574,
  [SMALL_STATE(761)] = 25581,
  [SMALL_STATE(762)] = 25588,
  [SMALL_STATE(763)] = 25595,
  [SMALL_STATE(764)] = 25602,
  [SMALL_STATE(765)] = 25609,
  [SMALL_STATE(766)] = 25616,
  [SMALL_STATE(767)] = 25623,
  [SMALL_STATE(768)] = 25630,
  [SMALL_STATE(769)] = 25637,
  [SMALL_STATE(770)] = 25644,
  [SMALL_STATE(771)] = 25651,
  [SMALL_STATE(772)] = 25658,
  [SMALL_STATE(773)] = 25665,
  [SMALL_STATE(774)] = 25672,
  [SMALL_STATE(775)] = 25679,
  [SMALL_STATE(776)] = 25686,
  [SMALL_STATE(777)] = 25693,
  [SMALL_STATE(778)] = 25700,
  [SMALL_STATE(779)] = 25707,
  [SMALL_STATE(780)] = 25714,
  [SMALL_STATE(781)] = 25721,
  [SMALL_STATE(782)] = 25728,
  [SMALL_STATE(783)] = 25735,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(470),
  [272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(5),
  [275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(135),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(450),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(634),
  [284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_binding_repeat1, 2),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(178),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(236),
  [292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(471),
  [295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(471),
  [298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(541),
  [301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(540),
  [304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_binding_repeat1, 2), SHIFT_REPEAT(620),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(240),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(122),
  [318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(454),
  [321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(177),
  [324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(235),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(35),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(35),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(302),
  [336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(294),
  [339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(611),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(240),
  [387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(3),
  [390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(122),
  [393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(454),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(245),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_pattern_repeat1, 2),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(177),
  [404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(235),
  [407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(315),
  [410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(315),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(302),
  [416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(294),
  [419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_pattern_repeat1, 2), SHIFT_REPEAT(611),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(470),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(5),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(135),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(450),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(624),
  [441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_assignment_repeat1, 2),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(178),
  [446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(236),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(459),
  [452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(459),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(541),
  [458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(540),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_assignment_repeat1, 2), SHIFT_REPEAT(620),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 4, .production_id = 8),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 1),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, .production_id = 6),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, .production_id = 3),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, .production_id = 3),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(229),
  [1005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(222),
  [1008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(199),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_quoted_list_repeat1, 2),
  [1013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(202),
  [1016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(153),
  [1019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(189),
  [1022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(189),
  [1025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(302),
  [1028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(294),
  [1031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_list_repeat1, 2), SHIFT_REPEAT(611),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(311),
  [1057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(223),
  [1060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(286),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2),
  [1065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(55),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(150),
  [1071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(150),
  [1074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(302),
  [1077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(294),
  [1080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(611),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2),
  [1247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_multi_symbol_repeat1, 2),
  [1249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2), SHIFT_REPEAT(697),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quoted_sexp, 1),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__quoted_sexp, 1),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_where_pattern_repeat1, 2), SHIFT_REPEAT(311),
  [1295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_pattern_repeat1, 2), SHIFT_REPEAT(250),
  [1298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_pattern_repeat1, 2), SHIFT_REPEAT(286),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_pattern_repeat1, 2),
  [1303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_pattern_repeat1, 2), SHIFT_REPEAT(55),
  [1306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_where_pattern_repeat1, 2), SHIFT_REPEAT(233),
  [1309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_pattern_repeat1, 2), SHIFT_REPEAT(233),
  [1312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_where_pattern_repeat1, 2), SHIFT_REPEAT(302),
  [1315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_pattern_repeat1, 2), SHIFT_REPEAT(294),
  [1318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_pattern_repeat1, 2), SHIFT_REPEAT(611),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_symbol, 2),
  [1323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_symbol, 2),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_iter_bindings_repeat1, 2), SHIFT_REPEAT(361),
  [1350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iter_bindings_repeat1, 2), SHIFT_REPEAT(448),
  [1353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iter_bindings_repeat1, 2), SHIFT_REPEAT(411),
  [1356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iter_bindings_repeat1, 2), SHIFT_REPEAT(30),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_iter_bindings_repeat1, 2),
  [1361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_iter_bindings_repeat1, 2),
  [1363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sexp, 1),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__sexp, 1),
  [1367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2), SHIFT_REPEAT(712),
  [1370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 2), SHIFT_REPEAT(311),
  [1373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 2), SHIFT_REPEAT(286),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 2),
  [1378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 2), SHIFT_REPEAT(55),
  [1381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 2), SHIFT_REPEAT(243),
  [1384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 2), SHIFT_REPEAT(243),
  [1387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 2), SHIFT_REPEAT(302),
  [1390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 2), SHIFT_REPEAT(294),
  [1393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 2), SHIFT_REPEAT(611),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [1422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 5),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 5),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 5),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 5),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each, 6),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each, 6),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local, 5),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 5),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global, 5),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global, 5),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_collect, 7),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_collect, 7),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_icollect, 7),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_icollect, 7),
  [1454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table, 3),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table, 3),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulate, 8),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accumulate, 8),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_collect, 6),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_collect, 6),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 2),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 2),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each, 7),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each, 7),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_sequential_table, 2),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_sequential_table, 2),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_icollect, 6),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_icollect, 6),
  [1490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulate, 9),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accumulate, 9),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hashfn, 2),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hashfn, 2),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_symbol_method, 3),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_symbol_method, 3),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 2),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 2),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table, 2),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table, 2),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 4),
  [1518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 4),
  [1520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote, 2),
  [1522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote, 2),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 4),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 4),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_list, 3),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_list, 3),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match, 4),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match, 4),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hashfn, 3),
  [1578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hashfn, 3),
  [1580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 5),
  [1582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 5),
  [1584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 3),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 3),
  [1588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 4),
  [1590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 4, .production_id = 4),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_table, 2),
  [1602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_table, 2),
  [1604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for, 5),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for, 5),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match, 5),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match, 5),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 4, .production_id = 4),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 4, .production_id = 4),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_list, 2),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_list, 2),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_sequential_table, 3),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_sequential_table, 3),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_table, 3),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_table, 3),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for, 4),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for, 4),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hashfn, 4),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hashfn, 4),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__sexp, 1), REDUCE(sym_binding, 1),
  [1649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__sexp, 1), REDUCE(sym_binding, 1),
  [1652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binding, 1),
  [1654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binding, 1),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2), SHIFT_REPEAT(694),
  [1661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 1),
  [1663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 1),
  [1665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__non_multi_value_pattern, 1),
  [1667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__non_multi_value_pattern, 1),
  [1669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table_binding, 5),
  [1671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table_binding, 5),
  [1673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_pair, 2),
  [1675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_table_binding_repeat1, 2),
  [1677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_pair, 2),
  [1679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table_binding, 4),
  [1681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table_binding, 4),
  [1683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table_binding, 2),
  [1685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table_binding, 2),
  [1687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_binding, 2),
  [1689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_binding, 2),
  [1691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table_binding, 3),
  [1693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table_binding, 3),
  [1695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_binding, 3),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_binding, 3),
  [1699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sequential_table_binding, 2), REDUCE(sym_sequential_table, 2),
  [1702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sequential_table_binding, 2), REDUCE(sym_sequential_table, 2),
  [1705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table_assignment, 2),
  [1707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table_assignment, 2),
  [1709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_table_pattern_repeat1, 2),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_assignment, 2),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_assignment, 2),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_pattern, 3),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_pattern, 3),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table_pattern, 3),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table_pattern, 3),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_value_pattern, 3),
  [1725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_value_pattern, 3),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_pattern, 2),
  [1729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_pattern, 2),
  [1731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_table_assignment_repeat1, 2),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table_pattern, 2),
  [1735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table_pattern, 2),
  [1737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_value_pattern, 2),
  [1739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_value_pattern, 2),
  [1741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_assignment, 3),
  [1743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_assignment, 3),
  [1745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_table_binding, 2), REDUCE(sym_table, 2),
  [1748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_table_binding, 2), REDUCE(sym_table, 2),
  [1751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_table_assignment, 3),
  [1753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_table_assignment, 3),
  [1755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_clause, 3),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_clause, 3),
  [1759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3),
  [1761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [1763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_clause, 2),
  [1765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_clause, 2),
  [1767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 6),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 6),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 5),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_value_assignment, 2),
  [1781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_value_assignment, 2),
  [1783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_pattern, 6),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_pattern, 6),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_value_assignment, 3),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_value_assignment, 3),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_pattern, 4),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_pattern, 4),
  [1795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2), SHIFT_REPEAT(693),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_value_binding, 2),
  [1802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_value_binding, 2),
  [1804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_pattern, 5, .production_id = 10),
  [1806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_pattern, 5, .production_id = 10),
  [1808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_pattern, 8, .production_id = 12),
  [1810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_pattern, 8, .production_id = 12),
  [1812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_value_binding, 3),
  [1814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_value_binding, 3),
  [1816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_guard_pattern, 5, .production_id = 10),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard_pattern, 5, .production_id = 10),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_pattern, 7),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_pattern, 7),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_pattern, 7, .production_id = 11),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_pattern, 7, .production_id = 11),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [1844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 2),
  [1846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(480),
  [1849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(455),
  [1852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(426),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2),
  [1857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(38),
  [1860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(394),
  [1863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 1),
  [1865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multi_value_pattern_repeat1, 1),
  [1867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_pattern, 1),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_clause_repeat1, 2), SHIFT_REPEAT(361),
  [1882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_clause_repeat1, 2), SHIFT_REPEAT(448),
  [1885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_clause_repeat1, 2), SHIFT_REPEAT(411),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_let_clause_repeat1, 2),
  [1890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_clause_repeat1, 2), SHIFT_REPEAT(30),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_assignment_repeat1, 2), SHIFT_REPEAT(467),
  [1906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_assignment_repeat1, 2), SHIFT_REPEAT(435),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multi_value_assignment_repeat1, 2),
  [1911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_assignment_repeat1, 2), SHIFT_REPEAT(53),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [1956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_multi_value_binding_repeat1, 2), SHIFT_REPEAT(531),
  [1959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_binding_repeat1, 2), SHIFT_REPEAT(439),
  [1962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multi_value_binding_repeat1, 2),
  [1964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_multi_value_binding_repeat1, 2),
  [1966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_binding_repeat1, 2), SHIFT_REPEAT(31),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_repeat1, 2), SHIFT_REPEAT(134),
  [1992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_repeat1, 2), SHIFT_REPEAT(659),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2),
  [1997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2), SHIFT_REPEAT(294),
  [2000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2), SHIFT_REPEAT(611),
  [2003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_binding_repeat1, 2), SHIFT_REPEAT(601),
  [2006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_binding_repeat1, 2), SHIFT_REPEAT(437),
  [2009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_value_binding_repeat1, 2), SHIFT_REPEAT(39),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2), SHIFT_REPEAT(695),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2), SHIFT_REPEAT(708),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2), SHIFT_REPEAT(696),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2), SHIFT_REPEAT(759),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multi_symbol_repeat1, 2), SHIFT_REPEAT(755),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_pair, 2, .production_id = 1),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_pair, 2, .production_id = 1),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [2095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(602),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [2120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_bindings, 1, .production_id = 2),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_bindings, 2, .production_id = 5),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_bindings, 3, .production_id = 7),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_bindings, 4, .production_id = 9),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2296] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_fennel(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_symbol,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
