#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 443
#define LARGE_STATE_COUNT 95
#define SYMBOL_COUNT 194
#define ALIAS_COUNT 0
#define TOKEN_COUNT 129
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 3

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_circuit = 2,
  anon_sym_COLON = 3,
  anon_sym_module = 4,
  anon_sym_extmodule = 5,
  anon_sym_input = 6,
  anon_sym_output = 7,
  anon_sym_const = 8,
  anon_sym_UInt = 9,
  anon_sym_SInt = 10,
  anon_sym_Analog = 11,
  anon_sym_LT = 12,
  anon_sym_GT = 13,
  anon_sym_Fixed = 14,
  anon_sym_Clock = 15,
  anon_sym_AsyncReset = 16,
  anon_sym_Reset = 17,
  anon_sym_LBRACE = 18,
  anon_sym_COMMA = 19,
  anon_sym_RBRACE = 20,
  anon_sym_LBRACK = 21,
  anon_sym_RBRACK = 22,
  anon_sym_flip = 23,
  anon_sym_defname = 24,
  anon_sym_EQ = 25,
  anon_sym_parameter = 26,
  anon_sym_reset = 27,
  anon_sym_EQ_GT = 28,
  anon_sym_LPAREN = 29,
  anon_sym_RPAREN = 30,
  anon_sym_wire = 31,
  anon_sym_cmem = 32,
  anon_sym_smem = 33,
  anon_sym_reg = 34,
  anon_sym_with = 35,
  anon_sym_mem = 36,
  anon_sym_mport = 37,
  anon_sym_inst = 38,
  anon_sym_of = 39,
  anon_sym_node = 40,
  anon_sym_LT_EQ = 41,
  anon_sym_LT_DASH = 42,
  anon_sym_is = 43,
  anon_sym_invalid = 44,
  anon_sym_data_DASHtype = 45,
  anon_sym_depth = 46,
  anon_sym_read_DASHlatency = 47,
  anon_sym_write_DASHlatency = 48,
  anon_sym_read_DASHunder_DASHwrite = 49,
  anon_sym_reader = 50,
  anon_sym_writer = 51,
  anon_sym_readwriter = 52,
  anon_sym_when = 53,
  anon_sym_else = 54,
  anon_sym_stop = 55,
  anon_sym_printf = 56,
  anon_sym_assert = 57,
  anon_sym_assume = 58,
  anon_sym_cover = 59,
  anon_sym_skip = 60,
  anon_sym_attach = 61,
  sym_info = 62,
  anon_sym_infer = 63,
  anon_sym_read = 64,
  anon_sym_write = 65,
  anon_sym_rdwr = 66,
  anon_sym_old = 67,
  anon_sym_new = 68,
  anon_sym_undefined = 69,
  anon_sym_DOT = 70,
  anon_sym_mux = 71,
  anon_sym_validif = 72,
  anon_sym_add = 73,
  anon_sym_sub = 74,
  anon_sym_mul = 75,
  anon_sym_div = 76,
  anon_sym_rem = 77,
  anon_sym_lt = 78,
  anon_sym_leq = 79,
  anon_sym_gt = 80,
  anon_sym_geq = 81,
  anon_sym_eq = 82,
  anon_sym_neq = 83,
  anon_sym_pad = 84,
  anon_sym_asUInt = 85,
  anon_sym_asAsyncReset = 86,
  anon_sym_asSInt = 87,
  anon_sym_asClock = 88,
  anon_sym_shl = 89,
  anon_sym_shr = 90,
  anon_sym_dshl = 91,
  anon_sym_dshlw = 92,
  anon_sym_dshr = 93,
  anon_sym_dshrw = 94,
  anon_sym_cvt = 95,
  anon_sym_neg = 96,
  anon_sym_not = 97,
  anon_sym_and = 98,
  anon_sym_or = 99,
  anon_sym_xor = 100,
  anon_sym_andr = 101,
  anon_sym_orr = 102,
  anon_sym_xorr = 103,
  anon_sym_cat = 104,
  anon_sym_bits = 105,
  anon_sym_head = 106,
  anon_sym_tail = 107,
  anon_sym_asFixedPoint = 108,
  anon_sym_bpshl = 109,
  anon_sym_bpshr = 110,
  anon_sym_bpset = 111,
  anon_sym_0 = 112,
  aux_sym_uint_token1 = 113,
  anon_sym_PLUS = 114,
  anon_sym_DASH = 115,
  sym_number_str = 116,
  sym_double = 117,
  anon_sym_DQUOTE = 118,
  anon_sym_SQUOTE = 119,
  sym_string_content = 120,
  sym_raw_string_content = 121,
  aux_sym__escape_sequence_token1 = 122,
  sym_escape_sequence = 123,
  sym_relaxed_identifier = 124,
  sym_comment = 125,
  sym__newline = 126,
  sym__indent = 127,
  sym__dedent = 128,
  sym_source_file = 129,
  sym_circuit = 130,
  sym_module = 131,
  sym_port = 132,
  sym_dir = 133,
  sym_qualifier = 134,
  sym_type = 135,
  sym_field = 136,
  sym_defname = 137,
  sym_parameter = 138,
  sym__reset = 139,
  sym_reset = 140,
  sym_reset_block = 141,
  sym_statement = 142,
  sym_wire = 143,
  sym_cmem = 144,
  sym_smem = 145,
  sym_register = 146,
  sym_memory = 147,
  sym_rdwr = 148,
  sym_inst = 149,
  sym_node = 150,
  sym_connection = 151,
  sym_partial_connection = 152,
  sym_is_invalid = 153,
  sym_memory_field = 154,
  sym_suite = 155,
  sym_when = 156,
  sym_else = 157,
  sym_stop = 158,
  sym_printf = 159,
  sym_verif = 160,
  sym_skip = 161,
  sym_attach = 162,
  sym_mdir = 163,
  sym_ruw = 164,
  sym_litType = 165,
  sym_expression = 166,
  sym_literal = 167,
  sym_sub_field = 168,
  sym_sub_index = 169,
  sym_sub_access = 170,
  sym_mux = 171,
  sym_conditionally_valid = 172,
  sym_primitive_operation = 173,
  sym_field_id = 174,
  sym_primop = 175,
  sym_uint = 176,
  sym_sint = 177,
  sym_number = 178,
  sym_string = 179,
  sym_raw_string = 180,
  sym__escape_sequence = 181,
  aux_sym_source_file_repeat1 = 182,
  aux_sym_circuit_repeat1 = 183,
  aux_sym_module_repeat1 = 184,
  aux_sym_module_repeat2 = 185,
  aux_sym_module_repeat3 = 186,
  aux_sym_type_repeat1 = 187,
  aux_sym_memory_repeat1 = 188,
  aux_sym_memory_field_repeat1 = 189,
  aux_sym_printf_repeat1 = 190,
  aux_sym_primitive_operation_repeat1 = 191,
  aux_sym_string_repeat1 = 192,
  aux_sym_raw_string_repeat1 = 193,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_circuit] = "circuit",
  [anon_sym_COLON] = ":",
  [anon_sym_module] = "module",
  [anon_sym_extmodule] = "extmodule",
  [anon_sym_input] = "input",
  [anon_sym_output] = "output",
  [anon_sym_const] = "const",
  [anon_sym_UInt] = "UInt",
  [anon_sym_SInt] = "SInt",
  [anon_sym_Analog] = "Analog",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_Fixed] = "Fixed",
  [anon_sym_Clock] = "Clock",
  [anon_sym_AsyncReset] = "AsyncReset",
  [anon_sym_Reset] = "Reset",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_flip] = "flip",
  [anon_sym_defname] = "defname",
  [anon_sym_EQ] = "=",
  [anon_sym_parameter] = "parameter",
  [anon_sym_reset] = "reset",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_wire] = "wire",
  [anon_sym_cmem] = "cmem",
  [anon_sym_smem] = "smem",
  [anon_sym_reg] = "reg",
  [anon_sym_with] = "with",
  [anon_sym_mem] = "mem",
  [anon_sym_mport] = "mport",
  [anon_sym_inst] = "inst",
  [anon_sym_of] = "of",
  [anon_sym_node] = "node",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_is] = "is",
  [anon_sym_invalid] = "invalid",
  [anon_sym_data_DASHtype] = "data-type",
  [anon_sym_depth] = "depth",
  [anon_sym_read_DASHlatency] = "read-latency",
  [anon_sym_write_DASHlatency] = "write-latency",
  [anon_sym_read_DASHunder_DASHwrite] = "read-under-write",
  [anon_sym_reader] = "reader",
  [anon_sym_writer] = "writer",
  [anon_sym_readwriter] = "readwriter",
  [anon_sym_when] = "when",
  [anon_sym_else] = "else",
  [anon_sym_stop] = "stop",
  [anon_sym_printf] = "printf",
  [anon_sym_assert] = "assert",
  [anon_sym_assume] = "assume",
  [anon_sym_cover] = "cover",
  [anon_sym_skip] = "skip",
  [anon_sym_attach] = "attach",
  [sym_info] = "info",
  [anon_sym_infer] = "infer",
  [anon_sym_read] = "read",
  [anon_sym_write] = "write",
  [anon_sym_rdwr] = "rdwr",
  [anon_sym_old] = "old",
  [anon_sym_new] = "new",
  [anon_sym_undefined] = "undefined",
  [anon_sym_DOT] = ".",
  [anon_sym_mux] = "mux",
  [anon_sym_validif] = "validif",
  [anon_sym_add] = "add",
  [anon_sym_sub] = "sub",
  [anon_sym_mul] = "mul",
  [anon_sym_div] = "div",
  [anon_sym_rem] = "rem",
  [anon_sym_lt] = "lt",
  [anon_sym_leq] = "leq",
  [anon_sym_gt] = "gt",
  [anon_sym_geq] = "geq",
  [anon_sym_eq] = "eq",
  [anon_sym_neq] = "neq",
  [anon_sym_pad] = "pad",
  [anon_sym_asUInt] = "asUInt",
  [anon_sym_asAsyncReset] = "asAsyncReset",
  [anon_sym_asSInt] = "asSInt",
  [anon_sym_asClock] = "asClock",
  [anon_sym_shl] = "shl",
  [anon_sym_shr] = "shr",
  [anon_sym_dshl] = "dshl",
  [anon_sym_dshlw] = "dshlw",
  [anon_sym_dshr] = "dshr",
  [anon_sym_dshrw] = "dshrw",
  [anon_sym_cvt] = "cvt",
  [anon_sym_neg] = "neg",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_xor] = "xor",
  [anon_sym_andr] = "andr",
  [anon_sym_orr] = "orr",
  [anon_sym_xorr] = "xorr",
  [anon_sym_cat] = "cat",
  [anon_sym_bits] = "bits",
  [anon_sym_head] = "head",
  [anon_sym_tail] = "tail",
  [anon_sym_asFixedPoint] = "asFixedPoint",
  [anon_sym_bpshl] = "bpshl",
  [anon_sym_bpshr] = "bpshr",
  [anon_sym_bpset] = "bpset",
  [anon_sym_0] = "0",
  [aux_sym_uint_token1] = "uint_token1",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [sym_number_str] = "number_str",
  [sym_double] = "double",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_string_content] = "string_content",
  [sym_raw_string_content] = "string_content",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_relaxed_identifier] = "relaxed_identifier",
  [sym_comment] = "comment",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym_source_file] = "source_file",
  [sym_circuit] = "circuit",
  [sym_module] = "module",
  [sym_port] = "port",
  [sym_dir] = "dir",
  [sym_qualifier] = "qualifier",
  [sym_type] = "type",
  [sym_field] = "field",
  [sym_defname] = "defname",
  [sym_parameter] = "parameter",
  [sym__reset] = "_reset",
  [sym_reset] = "reset",
  [sym_reset_block] = "reset_block",
  [sym_statement] = "statement",
  [sym_wire] = "wire",
  [sym_cmem] = "cmem",
  [sym_smem] = "smem",
  [sym_register] = "register",
  [sym_memory] = "memory",
  [sym_rdwr] = "rdwr",
  [sym_inst] = "inst",
  [sym_node] = "node",
  [sym_connection] = "connection",
  [sym_partial_connection] = "partial_connection",
  [sym_is_invalid] = "is_invalid",
  [sym_memory_field] = "memory_field",
  [sym_suite] = "suite",
  [sym_when] = "when",
  [sym_else] = "else",
  [sym_stop] = "stop",
  [sym_printf] = "printf",
  [sym_verif] = "verif",
  [sym_skip] = "skip",
  [sym_attach] = "attach",
  [sym_mdir] = "mdir",
  [sym_ruw] = "ruw",
  [sym_litType] = "litType",
  [sym_expression] = "expression",
  [sym_literal] = "literal",
  [sym_sub_field] = "sub_field",
  [sym_sub_index] = "sub_index",
  [sym_sub_access] = "sub_access",
  [sym_mux] = "mux",
  [sym_conditionally_valid] = "conditionally_valid",
  [sym_primitive_operation] = "primitive_operation",
  [sym_field_id] = "field_id",
  [sym_primop] = "primop",
  [sym_uint] = "uint",
  [sym_sint] = "number",
  [sym_number] = "number",
  [sym_string] = "string",
  [sym_raw_string] = "raw_string",
  [sym__escape_sequence] = "_escape_sequence",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_circuit_repeat1] = "circuit_repeat1",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym_module_repeat2] = "module_repeat2",
  [aux_sym_module_repeat3] = "module_repeat3",
  [aux_sym_type_repeat1] = "type_repeat1",
  [aux_sym_memory_repeat1] = "memory_repeat1",
  [aux_sym_memory_field_repeat1] = "memory_field_repeat1",
  [aux_sym_printf_repeat1] = "printf_repeat1",
  [aux_sym_primitive_operation_repeat1] = "primitive_operation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_raw_string_repeat1] = "raw_string_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_circuit] = anon_sym_circuit,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_extmodule] = anon_sym_extmodule,
  [anon_sym_input] = anon_sym_input,
  [anon_sym_output] = anon_sym_output,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_UInt] = anon_sym_UInt,
  [anon_sym_SInt] = anon_sym_SInt,
  [anon_sym_Analog] = anon_sym_Analog,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_Fixed] = anon_sym_Fixed,
  [anon_sym_Clock] = anon_sym_Clock,
  [anon_sym_AsyncReset] = anon_sym_AsyncReset,
  [anon_sym_Reset] = anon_sym_Reset,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_flip] = anon_sym_flip,
  [anon_sym_defname] = anon_sym_defname,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_parameter] = anon_sym_parameter,
  [anon_sym_reset] = anon_sym_reset,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_wire] = anon_sym_wire,
  [anon_sym_cmem] = anon_sym_cmem,
  [anon_sym_smem] = anon_sym_smem,
  [anon_sym_reg] = anon_sym_reg,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_mem] = anon_sym_mem,
  [anon_sym_mport] = anon_sym_mport,
  [anon_sym_inst] = anon_sym_inst,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_node] = anon_sym_node,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_invalid] = anon_sym_invalid,
  [anon_sym_data_DASHtype] = anon_sym_data_DASHtype,
  [anon_sym_depth] = anon_sym_depth,
  [anon_sym_read_DASHlatency] = anon_sym_read_DASHlatency,
  [anon_sym_write_DASHlatency] = anon_sym_write_DASHlatency,
  [anon_sym_read_DASHunder_DASHwrite] = anon_sym_read_DASHunder_DASHwrite,
  [anon_sym_reader] = anon_sym_reader,
  [anon_sym_writer] = anon_sym_writer,
  [anon_sym_readwriter] = anon_sym_readwriter,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_stop] = anon_sym_stop,
  [anon_sym_printf] = anon_sym_printf,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_assume] = anon_sym_assume,
  [anon_sym_cover] = anon_sym_cover,
  [anon_sym_skip] = anon_sym_skip,
  [anon_sym_attach] = anon_sym_attach,
  [sym_info] = sym_info,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_read] = anon_sym_read,
  [anon_sym_write] = anon_sym_write,
  [anon_sym_rdwr] = anon_sym_rdwr,
  [anon_sym_old] = anon_sym_old,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_undefined] = anon_sym_undefined,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_mux] = anon_sym_mux,
  [anon_sym_validif] = anon_sym_validif,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_sub] = anon_sym_sub,
  [anon_sym_mul] = anon_sym_mul,
  [anon_sym_div] = anon_sym_div,
  [anon_sym_rem] = anon_sym_rem,
  [anon_sym_lt] = anon_sym_lt,
  [anon_sym_leq] = anon_sym_leq,
  [anon_sym_gt] = anon_sym_gt,
  [anon_sym_geq] = anon_sym_geq,
  [anon_sym_eq] = anon_sym_eq,
  [anon_sym_neq] = anon_sym_neq,
  [anon_sym_pad] = anon_sym_pad,
  [anon_sym_asUInt] = anon_sym_asUInt,
  [anon_sym_asAsyncReset] = anon_sym_asAsyncReset,
  [anon_sym_asSInt] = anon_sym_asSInt,
  [anon_sym_asClock] = anon_sym_asClock,
  [anon_sym_shl] = anon_sym_shl,
  [anon_sym_shr] = anon_sym_shr,
  [anon_sym_dshl] = anon_sym_dshl,
  [anon_sym_dshlw] = anon_sym_dshlw,
  [anon_sym_dshr] = anon_sym_dshr,
  [anon_sym_dshrw] = anon_sym_dshrw,
  [anon_sym_cvt] = anon_sym_cvt,
  [anon_sym_neg] = anon_sym_neg,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_andr] = anon_sym_andr,
  [anon_sym_orr] = anon_sym_orr,
  [anon_sym_xorr] = anon_sym_xorr,
  [anon_sym_cat] = anon_sym_cat,
  [anon_sym_bits] = anon_sym_bits,
  [anon_sym_head] = anon_sym_head,
  [anon_sym_tail] = anon_sym_tail,
  [anon_sym_asFixedPoint] = anon_sym_asFixedPoint,
  [anon_sym_bpshl] = anon_sym_bpshl,
  [anon_sym_bpshr] = anon_sym_bpshr,
  [anon_sym_bpset] = anon_sym_bpset,
  [anon_sym_0] = anon_sym_0,
  [aux_sym_uint_token1] = aux_sym_uint_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [sym_number_str] = sym_number_str,
  [sym_double] = sym_double,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_string_content] = sym_string_content,
  [sym_raw_string_content] = sym_string_content,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_relaxed_identifier] = sym_relaxed_identifier,
  [sym_comment] = sym_comment,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym_source_file] = sym_source_file,
  [sym_circuit] = sym_circuit,
  [sym_module] = sym_module,
  [sym_port] = sym_port,
  [sym_dir] = sym_dir,
  [sym_qualifier] = sym_qualifier,
  [sym_type] = sym_type,
  [sym_field] = sym_field,
  [sym_defname] = sym_defname,
  [sym_parameter] = sym_parameter,
  [sym__reset] = sym__reset,
  [sym_reset] = sym_reset,
  [sym_reset_block] = sym_reset_block,
  [sym_statement] = sym_statement,
  [sym_wire] = sym_wire,
  [sym_cmem] = sym_cmem,
  [sym_smem] = sym_smem,
  [sym_register] = sym_register,
  [sym_memory] = sym_memory,
  [sym_rdwr] = sym_rdwr,
  [sym_inst] = sym_inst,
  [sym_node] = sym_node,
  [sym_connection] = sym_connection,
  [sym_partial_connection] = sym_partial_connection,
  [sym_is_invalid] = sym_is_invalid,
  [sym_memory_field] = sym_memory_field,
  [sym_suite] = sym_suite,
  [sym_when] = sym_when,
  [sym_else] = sym_else,
  [sym_stop] = sym_stop,
  [sym_printf] = sym_printf,
  [sym_verif] = sym_verif,
  [sym_skip] = sym_skip,
  [sym_attach] = sym_attach,
  [sym_mdir] = sym_mdir,
  [sym_ruw] = sym_ruw,
  [sym_litType] = sym_litType,
  [sym_expression] = sym_expression,
  [sym_literal] = sym_literal,
  [sym_sub_field] = sym_sub_field,
  [sym_sub_index] = sym_sub_index,
  [sym_sub_access] = sym_sub_access,
  [sym_mux] = sym_mux,
  [sym_conditionally_valid] = sym_conditionally_valid,
  [sym_primitive_operation] = sym_primitive_operation,
  [sym_field_id] = sym_field_id,
  [sym_primop] = sym_primop,
  [sym_uint] = sym_uint,
  [sym_sint] = sym_number,
  [sym_number] = sym_number,
  [sym_string] = sym_string,
  [sym_raw_string] = sym_raw_string,
  [sym__escape_sequence] = sym__escape_sequence,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_circuit_repeat1] = aux_sym_circuit_repeat1,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym_module_repeat2] = aux_sym_module_repeat2,
  [aux_sym_module_repeat3] = aux_sym_module_repeat3,
  [aux_sym_type_repeat1] = aux_sym_type_repeat1,
  [aux_sym_memory_repeat1] = aux_sym_memory_repeat1,
  [aux_sym_memory_field_repeat1] = aux_sym_memory_field_repeat1,
  [aux_sym_printf_repeat1] = aux_sym_printf_repeat1,
  [aux_sym_primitive_operation_repeat1] = aux_sym_primitive_operation_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_raw_string_repeat1] = aux_sym_raw_string_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_circuit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extmodule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_input] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_output] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UInt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SInt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Analog] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Fixed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Clock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AsyncReset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Reset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_flip] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defname] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parameter] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_reset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_wire] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cmem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_smem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_reg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mport] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_node] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_invalid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_data_DASHtype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_depth] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_read_DASHlatency] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_write_DASHlatency] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_read_DASHunder_DASHwrite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_reader] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_writer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readwriter] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_printf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assume] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cover] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_skip] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_attach] = {
    .visible = true,
    .named = false,
  },
  [sym_info] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_read] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_write] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rdwr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_old] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undefined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mux] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_validif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mul] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_div] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_leq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_geq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_neq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pad] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asUInt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asAsyncReset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asSInt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asClock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dshl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dshlw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dshr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dshrw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cvt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_neg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_andr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_orr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xorr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_head] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tail] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asFixedPoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bpshl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bpshr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bpset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_uint_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_number_str] = {
    .visible = true,
    .named = true,
  },
  [sym_double] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_relaxed_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_circuit] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_port] = {
    .visible = true,
    .named = true,
  },
  [sym_dir] = {
    .visible = true,
    .named = true,
  },
  [sym_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_defname] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__reset] = {
    .visible = false,
    .named = true,
  },
  [sym_reset] = {
    .visible = true,
    .named = true,
  },
  [sym_reset_block] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_wire] = {
    .visible = true,
    .named = true,
  },
  [sym_cmem] = {
    .visible = true,
    .named = true,
  },
  [sym_smem] = {
    .visible = true,
    .named = true,
  },
  [sym_register] = {
    .visible = true,
    .named = true,
  },
  [sym_memory] = {
    .visible = true,
    .named = true,
  },
  [sym_rdwr] = {
    .visible = true,
    .named = true,
  },
  [sym_inst] = {
    .visible = true,
    .named = true,
  },
  [sym_node] = {
    .visible = true,
    .named = true,
  },
  [sym_connection] = {
    .visible = true,
    .named = true,
  },
  [sym_partial_connection] = {
    .visible = true,
    .named = true,
  },
  [sym_is_invalid] = {
    .visible = true,
    .named = true,
  },
  [sym_memory_field] = {
    .visible = true,
    .named = true,
  },
  [sym_suite] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_stop] = {
    .visible = true,
    .named = true,
  },
  [sym_printf] = {
    .visible = true,
    .named = true,
  },
  [sym_verif] = {
    .visible = true,
    .named = true,
  },
  [sym_skip] = {
    .visible = true,
    .named = true,
  },
  [sym_attach] = {
    .visible = true,
    .named = true,
  },
  [sym_mdir] = {
    .visible = true,
    .named = true,
  },
  [sym_ruw] = {
    .visible = true,
    .named = true,
  },
  [sym_litType] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_sub_field] = {
    .visible = true,
    .named = true,
  },
  [sym_sub_index] = {
    .visible = true,
    .named = true,
  },
  [sym_sub_access] = {
    .visible = true,
    .named = true,
  },
  [sym_mux] = {
    .visible = true,
    .named = true,
  },
  [sym_conditionally_valid] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_operation] = {
    .visible = true,
    .named = true,
  },
  [sym_field_id] = {
    .visible = true,
    .named = true,
  },
  [sym_primop] = {
    .visible = true,
    .named = true,
  },
  [sym_uint] = {
    .visible = true,
    .named = true,
  },
  [sym_sint] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_circuit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_memory_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_memory_field_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_printf_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_primitive_operation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_raw_string_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = sym_number,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_primop, 2,
    sym_primop,
    sym_identifier,
  sym_uint, 2,
    sym_uint,
    sym_number,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 95,
  [97] = 97,
  [98] = 98,
  [99] = 97,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 100,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 105,
  [112] = 103,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 107,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 114,
  [125] = 104,
  [126] = 126,
  [127] = 101,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 18,
  [142] = 17,
  [143] = 19,
  [144] = 23,
  [145] = 145,
  [146] = 20,
  [147] = 26,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 24,
  [153] = 151,
  [154] = 22,
  [155] = 155,
  [156] = 156,
  [157] = 151,
  [158] = 158,
  [159] = 159,
  [160] = 31,
  [161] = 161,
  [162] = 29,
  [163] = 25,
  [164] = 164,
  [165] = 21,
  [166] = 27,
  [167] = 30,
  [168] = 168,
  [169] = 169,
  [170] = 169,
  [171] = 171,
  [172] = 172,
  [173] = 172,
  [174] = 172,
  [175] = 175,
  [176] = 175,
  [177] = 177,
  [178] = 175,
  [179] = 179,
  [180] = 177,
  [181] = 179,
  [182] = 182,
  [183] = 177,
  [184] = 184,
  [185] = 185,
  [186] = 182,
  [187] = 182,
  [188] = 179,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 196,
  [198] = 198,
  [199] = 195,
  [200] = 194,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 204,
  [211] = 211,
  [212] = 212,
  [213] = 34,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 40,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 39,
  [225] = 225,
  [226] = 226,
  [227] = 40,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 34,
  [232] = 39,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 43,
  [239] = 49,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 244,
  [247] = 240,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 248,
  [252] = 252,
  [253] = 50,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 252,
  [263] = 263,
  [264] = 48,
  [265] = 245,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 261,
  [272] = 267,
  [273] = 47,
  [274] = 252,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 258,
  [279] = 254,
  [280] = 280,
  [281] = 281,
  [282] = 266,
  [283] = 261,
  [284] = 284,
  [285] = 42,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 250,
  [290] = 47,
  [291] = 291,
  [292] = 43,
  [293] = 48,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 50,
  [298] = 298,
  [299] = 49,
  [300] = 300,
  [301] = 301,
  [302] = 42,
  [303] = 275,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 313,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 23,
  [343] = 222,
  [344] = 344,
  [345] = 345,
  [346] = 235,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 314,
  [365] = 365,
  [366] = 324,
  [367] = 323,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 353,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 348,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 377,
  [397] = 352,
  [398] = 385,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 391,
  [403] = 348,
  [404] = 404,
  [405] = 394,
  [406] = 377,
  [407] = 352,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 309,
  [415] = 415,
  [416] = 400,
  [417] = 358,
  [418] = 418,
  [419] = 382,
  [420] = 420,
  [421] = 380,
  [422] = 422,
  [423] = 400,
  [424] = 358,
  [425] = 425,
  [426] = 426,
  [427] = 311,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 391,
  [432] = 432,
  [433] = 425,
  [434] = 434,
  [435] = 376,
  [436] = 436,
  [437] = 376,
  [438] = 426,
  [439] = 394,
  [440] = 349,
  [441] = 441,
  [442] = 356,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        '"', 96,
        '\'', 97,
        '(', 73,
        ')', 74,
        '+', 90,
        ',', 66,
        '-', 92,
        '.', 82,
        '0', 84,
        ':', 61,
        ';', 123,
        '<', 63,
        '=', 71,
        '>', 64,
        '@', 11,
        '[', 68,
        '\\', 37,
        ']', 69,
        'd', 109,
        'r', 113,
        'w', 116,
        '{', 65,
        '}', 67,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(96);
      if (lookahead == ';') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(37);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (lookahead != 0) ADVANCE(99);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(93);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(4);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '$', 120,
        '(', 73,
        ')', 74,
        ',', 66,
        '.', 82,
        '0', 85,
        ':', 61,
        ';', 123,
        '<', 8,
        '=', 70,
        '>', 64,
        '[', 68,
        ']', 69,
        '}', 67,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(88);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 6:
      if (lookahead == '\'') ADVANCE(97);
      if (lookahead == ';') ADVANCE(122);
      if (lookahead == '\\') ADVANCE(37);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(100);
      if (lookahead != 0) ADVANCE(101);
      END_STATE();
    case 7:
      if (lookahead == '-') ADVANCE(38);
      END_STATE();
    case 8:
      if (lookahead == '-') ADVANCE(76);
      if (lookahead == '=') ADVANCE(75);
      END_STATE();
    case 9:
      if (lookahead == '.') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '>') ADVANCE(72);
      END_STATE();
    case 11:
      if (lookahead == '[') ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == ']') ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(12);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(34);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(36);
      END_STATE();
    case 15:
      if (lookahead == 'b') ADVANCE(45);
      if (lookahead == 'h') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 16:
      if (lookahead == 'c') ADVANCE(40);
      END_STATE();
    case 17:
      if (lookahead == 'c') ADVANCE(41);
      END_STATE();
    case 18:
      if (lookahead == 'd') ADVANCE(20);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(31);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(28);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(29);
      END_STATE();
    case 24:
      if (lookahead == 'i') ADVANCE(35);
      END_STATE();
    case 25:
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 'u') ADVANCE(27);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(14);
      END_STATE();
    case 27:
      if (lookahead == 'n') ADVANCE(18);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 29:
      if (lookahead == 'n') ADVANCE(17);
      END_STATE();
    case 30:
      if (lookahead == 'p') ADVANCE(19);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(7);
      END_STATE();
    case 32:
      if (lookahead == 'r') ADVANCE(24);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(39);
      END_STATE();
    case 34:
      if (lookahead == 't') ADVANCE(22);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(21);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(23);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(42);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(103);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(104);
      if (lookahead != 0) ADVANCE(102);
      END_STATE();
    case 38:
      if (lookahead == 'w') ADVANCE(32);
      END_STATE();
    case 39:
      if (lookahead == 'y') ADVANCE(30);
      END_STATE();
    case 40:
      if (lookahead == 'y') ADVANCE(78);
      END_STATE();
    case 41:
      if (lookahead == 'y') ADVANCE(79);
      END_STATE();
    case 42:
      if (lookahead == '{') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(9);
      END_STATE();
    case 45:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(49);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(2);
      END_STATE();
    case 46:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(3);
      END_STATE();
    case 47:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 48:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(4);
      END_STATE();
    case 49:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(2);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(3);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(4);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 58:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        '"', 96,
        '\'', 97,
        '(', 73,
        ')', 74,
        '+', 90,
        ',', 66,
        '-', 92,
        '.', 82,
        '0', 84,
        ':', 61,
        ';', 123,
        '<', 63,
        '=', 71,
        '>', 64,
        '@', 11,
        '[', 68,
        ']', 69,
        'd', 109,
        'r', 113,
        'w', 116,
        '{', 65,
        '}', 67,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 59:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        '"', 15,
        '(', 73,
        '+', 89,
        ',', 66,
        '-', 91,
        '.', 82,
        '0', 83,
        ':', 61,
        ';', 123,
        '<', 62,
        '=', 10,
        '@', 11,
        '[', 68,
        '{', 65,
        '}', 67,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(87);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(75);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_data_DASHtype);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_read_DASHlatency);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_write_DASHlatency);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_read_DASHunder_DASHwrite);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_info);
      if (lookahead == ']') ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(12);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_0);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '.') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(9);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_uint_token1);
      if (lookahead == '.') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_uint_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(87);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_uint_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(9);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(9);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_number_str);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_double);
      if (lookahead == 'E') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_double);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '"') ADVANCE(96);
      if (lookahead == ';') ADVANCE(121);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(99);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(99);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_raw_string_content);
      if (lookahead == '\'') ADVANCE(97);
      if (lookahead == ';') ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(101);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_raw_string_content);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(101);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(105);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(104);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(25);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(118);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(107);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(110);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(108);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(117);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(115);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(114);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(111);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_relaxed_identifier);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '"' ||
          lookahead == '\\') ADVANCE(123);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(123);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(122);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(123);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'A', 1,
        'C', 2,
        'F', 3,
        'R', 4,
        'S', 5,
        'U', 6,
        'a', 7,
        'b', 8,
        'c', 9,
        'd', 10,
        'e', 11,
        'f', 12,
        'g', 13,
        'h', 14,
        'i', 15,
        'l', 16,
        'm', 17,
        'n', 18,
        'o', 19,
        'p', 20,
        'r', 21,
        's', 22,
        't', 23,
        'u', 24,
        'v', 25,
        'w', 26,
        'x', 27,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 's') ADVANCE(29);
      END_STATE();
    case 2:
      if (lookahead == 'l') ADVANCE(30);
      END_STATE();
    case 3:
      if (lookahead == 'i') ADVANCE(31);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'I') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'I') ADVANCE(34);
      END_STATE();
    case 7:
      if (lookahead == 'd') ADVANCE(35);
      if (lookahead == 'n') ADVANCE(36);
      if (lookahead == 's') ADVANCE(37);
      if (lookahead == 't') ADVANCE(38);
      END_STATE();
    case 8:
      if (lookahead == 'i') ADVANCE(39);
      if (lookahead == 'p') ADVANCE(40);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(41);
      if (lookahead == 'i') ADVANCE(42);
      if (lookahead == 'm') ADVANCE(43);
      if (lookahead == 'o') ADVANCE(44);
      if (lookahead == 'v') ADVANCE(45);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(46);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 's') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(49);
      if (lookahead == 'q') ADVANCE(50);
      if (lookahead == 'x') ADVANCE(51);
      END_STATE();
    case 12:
      if (lookahead == 'l') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(53);
      if (lookahead == 't') ADVANCE(54);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(56);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(58);
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(60);
      if (lookahead == 'o') ADVANCE(61);
      if (lookahead == 'p') ADVANCE(62);
      if (lookahead == 'u') ADVANCE(63);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 19:
      if (lookahead == 'f') ADVANCE(66);
      if (lookahead == 'l') ADVANCE(67);
      if (lookahead == 'r') ADVANCE(68);
      if (lookahead == 'u') ADVANCE(69);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      END_STATE();
    case 21:
      if (lookahead == 'd') ADVANCE(72);
      if (lookahead == 'e') ADVANCE(73);
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(74);
      if (lookahead == 'k') ADVANCE(75);
      if (lookahead == 'm') ADVANCE(76);
      if (lookahead == 't') ADVANCE(77);
      if (lookahead == 'u') ADVANCE(78);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(80);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 26:
      if (lookahead == 'h') ADVANCE(82);
      if (lookahead == 'i') ADVANCE(83);
      if (lookahead == 'r') ADVANCE(84);
      END_STATE();
    case 27:
      if (lookahead == 'o') ADVANCE(85);
      END_STATE();
    case 28:
      if (lookahead == 'a') ADVANCE(86);
      END_STATE();
    case 29:
      if (lookahead == 'y') ADVANCE(87);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(88);
      END_STATE();
    case 31:
      if (lookahead == 'x') ADVANCE(89);
      END_STATE();
    case 32:
      if (lookahead == 's') ADVANCE(90);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(92);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(93);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(94);
      END_STATE();
    case 37:
      if (lookahead == 'A') ADVANCE(95);
      if (lookahead == 'C') ADVANCE(96);
      if (lookahead == 'F') ADVANCE(97);
      if (lookahead == 'S') ADVANCE(98);
      if (lookahead == 'U') ADVANCE(99);
      if (lookahead == 's') ADVANCE(100);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(103);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 42:
      if (lookahead == 'r') ADVANCE(105);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 44:
      if (lookahead == 'n') ADVANCE(107);
      if (lookahead == 'v') ADVANCE(108);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(109);
      END_STATE();
    case 46:
      if (lookahead == 'f') ADVANCE(110);
      if (lookahead == 'p') ADVANCE(111);
      END_STATE();
    case 47:
      if (lookahead == 'v') ADVANCE(112);
      END_STATE();
    case 48:
      if (lookahead == 'h') ADVANCE(113);
      END_STATE();
    case 49:
      if (lookahead == 's') ADVANCE(114);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_eq);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(116);
      END_STATE();
    case 53:
      if (lookahead == 'q') ADVANCE(117);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_gt);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(118);
      END_STATE();
    case 56:
      if (lookahead == 'f') ADVANCE(119);
      if (lookahead == 'p') ADVANCE(120);
      if (lookahead == 's') ADVANCE(121);
      if (lookahead == 'v') ADVANCE(122);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 58:
      if (lookahead == 'q') ADVANCE(123);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_lt);
      END_STATE();
    case 60:
      if (lookahead == 'm') ADVANCE(124);
      END_STATE();
    case 61:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 62:
      if (lookahead == 'o') ADVANCE(126);
      END_STATE();
    case 63:
      if (lookahead == 'l') ADVANCE(127);
      if (lookahead == 'x') ADVANCE(128);
      END_STATE();
    case 64:
      if (lookahead == 'g') ADVANCE(129);
      if (lookahead == 'q') ADVANCE(130);
      if (lookahead == 'w') ADVANCE(131);
      END_STATE();
    case 65:
      if (lookahead == 'd') ADVANCE(132);
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 67:
      if (lookahead == 'd') ADVANCE(134);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'r') ADVANCE(135);
      END_STATE();
    case 69:
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 70:
      if (lookahead == 'd') ADVANCE(137);
      if (lookahead == 'r') ADVANCE(138);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 72:
      if (lookahead == 'w') ADVANCE(140);
      END_STATE();
    case 73:
      if (lookahead == 'a') ADVANCE(141);
      if (lookahead == 'g') ADVANCE(142);
      if (lookahead == 'm') ADVANCE(143);
      if (lookahead == 's') ADVANCE(144);
      END_STATE();
    case 74:
      if (lookahead == 'l') ADVANCE(145);
      if (lookahead == 'r') ADVANCE(146);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(147);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 77:
      if (lookahead == 'o') ADVANCE(149);
      END_STATE();
    case 78:
      if (lookahead == 'b') ADVANCE(150);
      END_STATE();
    case 79:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 80:
      if (lookahead == 'd') ADVANCE(152);
      END_STATE();
    case 81:
      if (lookahead == 'l') ADVANCE(153);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 83:
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 84:
      if (lookahead == 'i') ADVANCE(157);
      END_STATE();
    case 85:
      if (lookahead == 'r') ADVANCE(158);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(159);
      END_STATE();
    case 87:
      if (lookahead == 'n') ADVANCE(160);
      END_STATE();
    case 88:
      if (lookahead == 'c') ADVANCE(161);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 91:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 92:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_add);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == 'r') ADVANCE(166);
      END_STATE();
    case 95:
      if (lookahead == 's') ADVANCE(167);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(168);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 98:
      if (lookahead == 'I') ADVANCE(170);
      END_STATE();
    case 99:
      if (lookahead == 'I') ADVANCE(171);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(172);
      if (lookahead == 'u') ADVANCE(173);
      END_STATE();
    case 101:
      if (lookahead == 'a') ADVANCE(174);
      END_STATE();
    case 102:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(176);
      if (lookahead == 'h') ADVANCE(177);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_cat);
      END_STATE();
    case 105:
      if (lookahead == 'c') ADVANCE(178);
      END_STATE();
    case 106:
      if (lookahead == 'm') ADVANCE(179);
      END_STATE();
    case 107:
      if (lookahead == 's') ADVANCE(180);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_cvt);
      END_STATE();
    case 110:
      if (lookahead == 'n') ADVANCE(182);
      END_STATE();
    case 111:
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_div);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(184);
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 115:
      if (lookahead == 'm') ADVANCE(187);
      END_STATE();
    case 116:
      if (lookahead == 'p') ADVANCE(188);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_geq);
      END_STATE();
    case 118:
      if (lookahead == 'd') ADVANCE(189);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(190);
      END_STATE();
    case 120:
      if (lookahead == 'u') ADVANCE(191);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(192);
      END_STATE();
    case 122:
      if (lookahead == 'a') ADVANCE(193);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_leq);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_mem);
      END_STATE();
    case 125:
      if (lookahead == 'u') ADVANCE(194);
      END_STATE();
    case 126:
      if (lookahead == 'r') ADVANCE(195);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_mul);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_mux);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_neg);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_neq);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_old);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_orr);
      END_STATE();
    case 136:
      if (lookahead == 'p') ADVANCE(197);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_pad);
      END_STATE();
    case 138:
      if (lookahead == 'a') ADVANCE(198);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(199);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(200);
      END_STATE();
    case 141:
      if (lookahead == 'd') ADVANCE(201);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_reg);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_rem);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_shl);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_shr);
      END_STATE();
    case 147:
      if (lookahead == 'p') ADVANCE(203);
      END_STATE();
    case 148:
      if (lookahead == 'm') ADVANCE(204);
      END_STATE();
    case 149:
      if (lookahead == 'p') ADVANCE(205);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_sub);
      END_STATE();
    case 151:
      if (lookahead == 'l') ADVANCE(206);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(207);
      END_STATE();
    case 153:
      if (lookahead == 'i') ADVANCE(208);
      END_STATE();
    case 154:
      if (lookahead == 'n') ADVANCE(209);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 156:
      if (lookahead == 'h') ADVANCE(211);
      END_STATE();
    case 157:
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == 'r') ADVANCE(213);
      END_STATE();
    case 159:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 160:
      if (lookahead == 'c') ADVANCE(215);
      END_STATE();
    case 161:
      if (lookahead == 'k') ADVANCE(216);
      END_STATE();
    case 162:
      if (lookahead == 'd') ADVANCE(217);
      END_STATE();
    case 163:
      if (lookahead == 't') ADVANCE(218);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_SInt);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_UInt);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_andr);
      END_STATE();
    case 167:
      if (lookahead == 'y') ADVANCE(219);
      END_STATE();
    case 168:
      if (lookahead == 'o') ADVANCE(220);
      END_STATE();
    case 169:
      if (lookahead == 'x') ADVANCE(221);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(222);
      END_STATE();
    case 171:
      if (lookahead == 'n') ADVANCE(223);
      END_STATE();
    case 172:
      if (lookahead == 'r') ADVANCE(224);
      END_STATE();
    case 173:
      if (lookahead == 'm') ADVANCE(225);
      END_STATE();
    case 174:
      if (lookahead == 'c') ADVANCE(226);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_bits);
      END_STATE();
    case 176:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 177:
      if (lookahead == 'l') ADVANCE(228);
      if (lookahead == 'r') ADVANCE(229);
      END_STATE();
    case 178:
      if (lookahead == 'u') ADVANCE(230);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_cmem);
      END_STATE();
    case 180:
      if (lookahead == 't') ADVANCE(231);
      END_STATE();
    case 181:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 182:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 183:
      if (lookahead == 'h') ADVANCE(234);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_dshl);
      if (lookahead == 'w') ADVANCE(235);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_dshr);
      if (lookahead == 'w') ADVANCE(236);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 187:
      if (lookahead == 'o') ADVANCE(237);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_flip);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_head);
      END_STATE();
    case 190:
      if (lookahead == 'r') ADVANCE(238);
      END_STATE();
    case 191:
      if (lookahead == 't') ADVANCE(239);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_inst);
      END_STATE();
    case 193:
      if (lookahead == 'l') ADVANCE(240);
      END_STATE();
    case 194:
      if (lookahead == 'l') ADVANCE(241);
      END_STATE();
    case 195:
      if (lookahead == 't') ADVANCE(242);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_node);
      END_STATE();
    case 197:
      if (lookahead == 'u') ADVANCE(243);
      END_STATE();
    case 198:
      if (lookahead == 'm') ADVANCE(244);
      END_STATE();
    case 199:
      if (lookahead == 't') ADVANCE(245);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_rdwr);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_read);
      if (lookahead == 'e') ADVANCE(246);
      if (lookahead == 'w') ADVANCE(247);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_skip);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_smem);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_stop);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_tail);
      END_STATE();
    case 207:
      if (lookahead == 'f') ADVANCE(249);
      END_STATE();
    case 208:
      if (lookahead == 'd') ADVANCE(250);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_wire);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_xorr);
      END_STATE();
    case 214:
      if (lookahead == 'g') ADVANCE(252);
      END_STATE();
    case 215:
      if (lookahead == 'R') ADVANCE(253);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_Clock);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_Fixed);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_Reset);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(254);
      END_STATE();
    case 220:
      if (lookahead == 'c') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      if (lookahead == 't') ADVANCE(258);
      END_STATE();
    case 224:
      if (lookahead == 't') ADVANCE(259);
      END_STATE();
    case 225:
      if (lookahead == 'e') ADVANCE(260);
      END_STATE();
    case 226:
      if (lookahead == 'h') ADVANCE(261);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_bpset);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_bpshl);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_bpshr);
      END_STATE();
    case 230:
      if (lookahead == 'i') ADVANCE(262);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_cover);
      END_STATE();
    case 233:
      if (lookahead == 'm') ADVANCE(263);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_depth);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_dshlw);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_dshrw);
      END_STATE();
    case 237:
      if (lookahead == 'd') ADVANCE(264);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_input);
      END_STATE();
    case 240:
      if (lookahead == 'i') ADVANCE(265);
      END_STATE();
    case 241:
      if (lookahead == 'e') ADVANCE(266);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_mport);
      END_STATE();
    case 243:
      if (lookahead == 't') ADVANCE(267);
      END_STATE();
    case 244:
      if (lookahead == 'e') ADVANCE(268);
      END_STATE();
    case 245:
      if (lookahead == 'f') ADVANCE(269);
      END_STATE();
    case 246:
      if (lookahead == 'r') ADVANCE(270);
      END_STATE();
    case 247:
      if (lookahead == 'r') ADVANCE(271);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_reset);
      END_STATE();
    case 249:
      if (lookahead == 'i') ADVANCE(272);
      END_STATE();
    case 250:
      if (lookahead == 'i') ADVANCE(273);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_write);
      if (lookahead == 'r') ADVANCE(274);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_Analog);
      END_STATE();
    case 253:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 254:
      if (lookahead == 'c') ADVANCE(276);
      END_STATE();
    case 255:
      if (lookahead == 'k') ADVANCE(277);
      END_STATE();
    case 256:
      if (lookahead == 'd') ADVANCE(278);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_asSInt);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_asUInt);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_assume);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_attach);
      END_STATE();
    case 262:
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'e') ADVANCE(280);
      END_STATE();
    case 264:
      if (lookahead == 'u') ADVANCE(281);
      END_STATE();
    case 265:
      if (lookahead == 'd') ADVANCE(282);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_output);
      END_STATE();
    case 268:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_printf);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_reader);
      END_STATE();
    case 271:
      if (lookahead == 'i') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'n') ADVANCE(285);
      END_STATE();
    case 273:
      if (lookahead == 'f') ADVANCE(286);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_writer);
      END_STATE();
    case 275:
      if (lookahead == 's') ADVANCE(287);
      END_STATE();
    case 276:
      if (lookahead == 'R') ADVANCE(288);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_asClock);
      END_STATE();
    case 278:
      if (lookahead == 'P') ADVANCE(289);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_circuit);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_defname);
      END_STATE();
    case 281:
      if (lookahead == 'l') ADVANCE(290);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_invalid);
      END_STATE();
    case 283:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 284:
      if (lookahead == 't') ADVANCE(292);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_validif);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 288:
      if (lookahead == 'e') ADVANCE(295);
      END_STATE();
    case 289:
      if (lookahead == 'o') ADVANCE(296);
      END_STATE();
    case 290:
      if (lookahead == 'e') ADVANCE(297);
      END_STATE();
    case 291:
      if (lookahead == 'r') ADVANCE(298);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 293:
      if (lookahead == 'd') ADVANCE(300);
      END_STATE();
    case 294:
      if (lookahead == 't') ADVANCE(301);
      END_STATE();
    case 295:
      if (lookahead == 's') ADVANCE(302);
      END_STATE();
    case 296:
      if (lookahead == 'i') ADVANCE(303);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_extmodule);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_parameter);
      END_STATE();
    case 299:
      if (lookahead == 'r') ADVANCE(304);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_undefined);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_AsyncReset);
      END_STATE();
    case 302:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 303:
      if (lookahead == 'n') ADVANCE(306);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_readwriter);
      END_STATE();
    case 305:
      if (lookahead == 't') ADVANCE(307);
      END_STATE();
    case 306:
      if (lookahead == 't') ADVANCE(308);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_asAsyncReset);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_asFixedPoint);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 59},
  [2] = {.lex_state = 59, .external_lex_state = 2},
  [3] = {.lex_state = 59, .external_lex_state = 2},
  [4] = {.lex_state = 59, .external_lex_state = 2},
  [5] = {.lex_state = 59, .external_lex_state = 2},
  [6] = {.lex_state = 59, .external_lex_state = 3},
  [7] = {.lex_state = 59, .external_lex_state = 3},
  [8] = {.lex_state = 59, .external_lex_state = 4},
  [9] = {.lex_state = 59, .external_lex_state = 2},
  [10] = {.lex_state = 59, .external_lex_state = 2},
  [11] = {.lex_state = 59, .external_lex_state = 4},
  [12] = {.lex_state = 59, .external_lex_state = 2},
  [13] = {.lex_state = 59, .external_lex_state = 2},
  [14] = {.lex_state = 59, .external_lex_state = 2},
  [15] = {.lex_state = 59},
  [16] = {.lex_state = 59, .external_lex_state = 2},
  [17] = {.lex_state = 59, .external_lex_state = 2},
  [18] = {.lex_state = 59, .external_lex_state = 2},
  [19] = {.lex_state = 59, .external_lex_state = 2},
  [20] = {.lex_state = 59, .external_lex_state = 2},
  [21] = {.lex_state = 59, .external_lex_state = 2},
  [22] = {.lex_state = 59, .external_lex_state = 2},
  [23] = {.lex_state = 59, .external_lex_state = 2},
  [24] = {.lex_state = 59, .external_lex_state = 2},
  [25] = {.lex_state = 59, .external_lex_state = 2},
  [26] = {.lex_state = 59, .external_lex_state = 2},
  [27] = {.lex_state = 59, .external_lex_state = 2},
  [28] = {.lex_state = 59, .external_lex_state = 2},
  [29] = {.lex_state = 59, .external_lex_state = 2},
  [30] = {.lex_state = 59, .external_lex_state = 2},
  [31] = {.lex_state = 59, .external_lex_state = 2},
  [32] = {.lex_state = 59, .external_lex_state = 2},
  [33] = {.lex_state = 59, .external_lex_state = 2},
  [34] = {.lex_state = 59, .external_lex_state = 2},
  [35] = {.lex_state = 59, .external_lex_state = 2},
  [36] = {.lex_state = 59, .external_lex_state = 2},
  [37] = {.lex_state = 59, .external_lex_state = 2},
  [38] = {.lex_state = 59, .external_lex_state = 2},
  [39] = {.lex_state = 59, .external_lex_state = 2},
  [40] = {.lex_state = 59, .external_lex_state = 2},
  [41] = {.lex_state = 59, .external_lex_state = 2},
  [42] = {.lex_state = 59, .external_lex_state = 2},
  [43] = {.lex_state = 59, .external_lex_state = 2},
  [44] = {.lex_state = 59, .external_lex_state = 2},
  [45] = {.lex_state = 59, .external_lex_state = 2},
  [46] = {.lex_state = 59, .external_lex_state = 2},
  [47] = {.lex_state = 59, .external_lex_state = 2},
  [48] = {.lex_state = 59, .external_lex_state = 2},
  [49] = {.lex_state = 59, .external_lex_state = 2},
  [50] = {.lex_state = 59, .external_lex_state = 2},
  [51] = {.lex_state = 59, .external_lex_state = 2},
  [52] = {.lex_state = 59, .external_lex_state = 2},
  [53] = {.lex_state = 59, .external_lex_state = 2},
  [54] = {.lex_state = 59, .external_lex_state = 2},
  [55] = {.lex_state = 59, .external_lex_state = 2},
  [56] = {.lex_state = 59, .external_lex_state = 2},
  [57] = {.lex_state = 59, .external_lex_state = 2},
  [58] = {.lex_state = 59, .external_lex_state = 2},
  [59] = {.lex_state = 59, .external_lex_state = 2},
  [60] = {.lex_state = 59, .external_lex_state = 2},
  [61] = {.lex_state = 59, .external_lex_state = 2},
  [62] = {.lex_state = 59, .external_lex_state = 2},
  [63] = {.lex_state = 59, .external_lex_state = 2},
  [64] = {.lex_state = 59, .external_lex_state = 2},
  [65] = {.lex_state = 59, .external_lex_state = 2},
  [66] = {.lex_state = 59, .external_lex_state = 2},
  [67] = {.lex_state = 59, .external_lex_state = 2},
  [68] = {.lex_state = 59, .external_lex_state = 2},
  [69] = {.lex_state = 59, .external_lex_state = 2},
  [70] = {.lex_state = 59, .external_lex_state = 2},
  [71] = {.lex_state = 59, .external_lex_state = 2},
  [72] = {.lex_state = 59, .external_lex_state = 2},
  [73] = {.lex_state = 59, .external_lex_state = 2},
  [74] = {.lex_state = 59, .external_lex_state = 2},
  [75] = {.lex_state = 59, .external_lex_state = 2},
  [76] = {.lex_state = 59, .external_lex_state = 2},
  [77] = {.lex_state = 59, .external_lex_state = 2},
  [78] = {.lex_state = 59, .external_lex_state = 2},
  [79] = {.lex_state = 59, .external_lex_state = 2},
  [80] = {.lex_state = 59, .external_lex_state = 2},
  [81] = {.lex_state = 59, .external_lex_state = 2},
  [82] = {.lex_state = 59, .external_lex_state = 2},
  [83] = {.lex_state = 59, .external_lex_state = 2},
  [84] = {.lex_state = 59, .external_lex_state = 2},
  [85] = {.lex_state = 59, .external_lex_state = 2},
  [86] = {.lex_state = 59, .external_lex_state = 2},
  [87] = {.lex_state = 59, .external_lex_state = 2},
  [88] = {.lex_state = 59, .external_lex_state = 2},
  [89] = {.lex_state = 59, .external_lex_state = 2},
  [90] = {.lex_state = 59, .external_lex_state = 2},
  [91] = {.lex_state = 59, .external_lex_state = 2},
  [92] = {.lex_state = 59, .external_lex_state = 2},
  [93] = {.lex_state = 59, .external_lex_state = 2},
  [94] = {.lex_state = 59, .external_lex_state = 2},
  [95] = {.lex_state = 59},
  [96] = {.lex_state = 59},
  [97] = {.lex_state = 59},
  [98] = {.lex_state = 59},
  [99] = {.lex_state = 59},
  [100] = {.lex_state = 59},
  [101] = {.lex_state = 59},
  [102] = {.lex_state = 59},
  [103] = {.lex_state = 59},
  [104] = {.lex_state = 59},
  [105] = {.lex_state = 59},
  [106] = {.lex_state = 59},
  [107] = {.lex_state = 59},
  [108] = {.lex_state = 59},
  [109] = {.lex_state = 59},
  [110] = {.lex_state = 59},
  [111] = {.lex_state = 59},
  [112] = {.lex_state = 59},
  [113] = {.lex_state = 59},
  [114] = {.lex_state = 59},
  [115] = {.lex_state = 59},
  [116] = {.lex_state = 59},
  [117] = {.lex_state = 59},
  [118] = {.lex_state = 59},
  [119] = {.lex_state = 59},
  [120] = {.lex_state = 59},
  [121] = {.lex_state = 59},
  [122] = {.lex_state = 59},
  [123] = {.lex_state = 59},
  [124] = {.lex_state = 59},
  [125] = {.lex_state = 59},
  [126] = {.lex_state = 59},
  [127] = {.lex_state = 59},
  [128] = {.lex_state = 59},
  [129] = {.lex_state = 59},
  [130] = {.lex_state = 0},
  [131] = {.lex_state = 59, .external_lex_state = 2},
  [132] = {.lex_state = 0, .external_lex_state = 2},
  [133] = {.lex_state = 0, .external_lex_state = 2},
  [134] = {.lex_state = 0, .external_lex_state = 2},
  [135] = {.lex_state = 59},
  [136] = {.lex_state = 59, .external_lex_state = 2},
  [137] = {.lex_state = 59, .external_lex_state = 2},
  [138] = {.lex_state = 0, .external_lex_state = 2},
  [139] = {.lex_state = 0, .external_lex_state = 2},
  [140] = {.lex_state = 59, .external_lex_state = 2},
  [141] = {.lex_state = 5},
  [142] = {.lex_state = 5},
  [143] = {.lex_state = 5},
  [144] = {.lex_state = 5},
  [145] = {.lex_state = 0, .external_lex_state = 2},
  [146] = {.lex_state = 5},
  [147] = {.lex_state = 5},
  [148] = {.lex_state = 59},
  [149] = {.lex_state = 59},
  [150] = {.lex_state = 59},
  [151] = {.lex_state = 5},
  [152] = {.lex_state = 5},
  [153] = {.lex_state = 5},
  [154] = {.lex_state = 5},
  [155] = {.lex_state = 0, .external_lex_state = 2},
  [156] = {.lex_state = 59},
  [157] = {.lex_state = 5},
  [158] = {.lex_state = 59},
  [159] = {.lex_state = 59},
  [160] = {.lex_state = 5},
  [161] = {.lex_state = 59},
  [162] = {.lex_state = 5},
  [163] = {.lex_state = 5},
  [164] = {.lex_state = 59},
  [165] = {.lex_state = 5},
  [166] = {.lex_state = 5},
  [167] = {.lex_state = 5},
  [168] = {.lex_state = 5},
  [169] = {.lex_state = 59},
  [170] = {.lex_state = 59},
  [171] = {.lex_state = 59},
  [172] = {.lex_state = 59},
  [173] = {.lex_state = 59},
  [174] = {.lex_state = 59},
  [175] = {.lex_state = 59},
  [176] = {.lex_state = 59},
  [177] = {.lex_state = 59},
  [178] = {.lex_state = 59},
  [179] = {.lex_state = 59},
  [180] = {.lex_state = 59},
  [181] = {.lex_state = 59},
  [182] = {.lex_state = 59},
  [183] = {.lex_state = 59},
  [184] = {.lex_state = 59},
  [185] = {.lex_state = 59},
  [186] = {.lex_state = 59},
  [187] = {.lex_state = 59},
  [188] = {.lex_state = 59},
  [189] = {.lex_state = 59},
  [190] = {.lex_state = 6},
  [191] = {.lex_state = 6},
  [192] = {.lex_state = 1},
  [193] = {.lex_state = 6},
  [194] = {.lex_state = 1},
  [195] = {.lex_state = 1},
  [196] = {.lex_state = 5},
  [197] = {.lex_state = 5},
  [198] = {.lex_state = 5},
  [199] = {.lex_state = 1},
  [200] = {.lex_state = 1},
  [201] = {.lex_state = 59, .external_lex_state = 2},
  [202] = {.lex_state = 59, .external_lex_state = 2},
  [203] = {.lex_state = 59, .external_lex_state = 2},
  [204] = {.lex_state = 0},
  [205] = {.lex_state = 5},
  [206] = {.lex_state = 59, .external_lex_state = 3},
  [207] = {.lex_state = 59, .external_lex_state = 3},
  [208] = {.lex_state = 0},
  [209] = {.lex_state = 59, .external_lex_state = 2},
  [210] = {.lex_state = 0},
  [211] = {.lex_state = 59, .external_lex_state = 2},
  [212] = {.lex_state = 59},
  [213] = {.lex_state = 59, .external_lex_state = 5},
  [214] = {.lex_state = 59, .external_lex_state = 2},
  [215] = {.lex_state = 59, .external_lex_state = 2},
  [216] = {.lex_state = 59, .external_lex_state = 3},
  [217] = {.lex_state = 0},
  [218] = {.lex_state = 59, .external_lex_state = 4},
  [219] = {.lex_state = 59},
  [220] = {.lex_state = 0},
  [221] = {.lex_state = 59, .external_lex_state = 2},
  [222] = {.lex_state = 0},
  [223] = {.lex_state = 59},
  [224] = {.lex_state = 59, .external_lex_state = 5},
  [225] = {.lex_state = 59, .external_lex_state = 2},
  [226] = {.lex_state = 59},
  [227] = {.lex_state = 59, .external_lex_state = 5},
  [228] = {.lex_state = 59},
  [229] = {.lex_state = 59, .external_lex_state = 2},
  [230] = {.lex_state = 59, .external_lex_state = 2},
  [231] = {.lex_state = 59},
  [232] = {.lex_state = 59},
  [233] = {.lex_state = 59, .external_lex_state = 3},
  [234] = {.lex_state = 59},
  [235] = {.lex_state = 0},
  [236] = {.lex_state = 59, .external_lex_state = 2},
  [237] = {.lex_state = 59, .external_lex_state = 2},
  [238] = {.lex_state = 0},
  [239] = {.lex_state = 0, .external_lex_state = 5},
  [240] = {.lex_state = 0},
  [241] = {.lex_state = 0},
  [242] = {.lex_state = 0},
  [243] = {.lex_state = 0},
  [244] = {.lex_state = 0},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 0},
  [247] = {.lex_state = 0},
  [248] = {.lex_state = 0},
  [249] = {.lex_state = 59, .external_lex_state = 2},
  [250] = {.lex_state = 0},
  [251] = {.lex_state = 0},
  [252] = {.lex_state = 0},
  [253] = {.lex_state = 0},
  [254] = {.lex_state = 0},
  [255] = {.lex_state = 0},
  [256] = {.lex_state = 59, .external_lex_state = 2},
  [257] = {.lex_state = 59, .external_lex_state = 4},
  [258] = {.lex_state = 0},
  [259] = {.lex_state = 59, .external_lex_state = 2},
  [260] = {.lex_state = 59, .external_lex_state = 2},
  [261] = {.lex_state = 0},
  [262] = {.lex_state = 0},
  [263] = {.lex_state = 0, .external_lex_state = 5},
  [264] = {.lex_state = 0},
  [265] = {.lex_state = 0},
  [266] = {.lex_state = 0},
  [267] = {.lex_state = 0},
  [268] = {.lex_state = 0},
  [269] = {.lex_state = 0},
  [270] = {.lex_state = 0},
  [271] = {.lex_state = 0},
  [272] = {.lex_state = 0},
  [273] = {.lex_state = 0},
  [274] = {.lex_state = 0},
  [275] = {.lex_state = 0},
  [276] = {.lex_state = 0, .external_lex_state = 5},
  [277] = {.lex_state = 59},
  [278] = {.lex_state = 0},
  [279] = {.lex_state = 0},
  [280] = {.lex_state = 0},
  [281] = {.lex_state = 0},
  [282] = {.lex_state = 0},
  [283] = {.lex_state = 0},
  [284] = {.lex_state = 0},
  [285] = {.lex_state = 0, .external_lex_state = 5},
  [286] = {.lex_state = 0},
  [287] = {.lex_state = 0},
  [288] = {.lex_state = 0, .external_lex_state = 4},
  [289] = {.lex_state = 0},
  [290] = {.lex_state = 0, .external_lex_state = 5},
  [291] = {.lex_state = 0, .external_lex_state = 5},
  [292] = {.lex_state = 0, .external_lex_state = 5},
  [293] = {.lex_state = 0, .external_lex_state = 5},
  [294] = {.lex_state = 0},
  [295] = {.lex_state = 59, .external_lex_state = 2},
  [296] = {.lex_state = 0},
  [297] = {.lex_state = 0, .external_lex_state = 5},
  [298] = {.lex_state = 0, .external_lex_state = 5},
  [299] = {.lex_state = 0},
  [300] = {.lex_state = 0},
  [301] = {.lex_state = 0},
  [302] = {.lex_state = 0},
  [303] = {.lex_state = 0},
  [304] = {.lex_state = 0},
  [305] = {.lex_state = 0, .external_lex_state = 5},
  [306] = {.lex_state = 0, .external_lex_state = 5},
  [307] = {.lex_state = 0},
  [308] = {.lex_state = 0, .external_lex_state = 5},
  [309] = {.lex_state = 0},
  [310] = {.lex_state = 59, .external_lex_state = 2},
  [311] = {.lex_state = 0},
  [312] = {.lex_state = 0},
  [313] = {.lex_state = 59},
  [314] = {.lex_state = 0, .external_lex_state = 5},
  [315] = {.lex_state = 0, .external_lex_state = 5},
  [316] = {.lex_state = 0},
  [317] = {.lex_state = 59},
  [318] = {.lex_state = 59},
  [319] = {.lex_state = 0},
  [320] = {.lex_state = 59},
  [321] = {.lex_state = 59, .external_lex_state = 2},
  [322] = {.lex_state = 0},
  [323] = {.lex_state = 0, .external_lex_state = 5},
  [324] = {.lex_state = 0, .external_lex_state = 5},
  [325] = {.lex_state = 59},
  [326] = {.lex_state = 0, .external_lex_state = 4},
  [327] = {.lex_state = 59},
  [328] = {.lex_state = 0},
  [329] = {.lex_state = 0},
  [330] = {.lex_state = 0, .external_lex_state = 2},
  [331] = {.lex_state = 0, .external_lex_state = 5},
  [332] = {.lex_state = 0},
  [333] = {.lex_state = 59},
  [334] = {.lex_state = 59},
  [335] = {.lex_state = 59},
  [336] = {.lex_state = 0, .external_lex_state = 2},
  [337] = {.lex_state = 59},
  [338] = {.lex_state = 0},
  [339] = {.lex_state = 0},
  [340] = {.lex_state = 0},
  [341] = {.lex_state = 0},
  [342] = {.lex_state = 0, .external_lex_state = 5},
  [343] = {.lex_state = 0, .external_lex_state = 5},
  [344] = {.lex_state = 59},
  [345] = {.lex_state = 5},
  [346] = {.lex_state = 0, .external_lex_state = 5},
  [347] = {.lex_state = 0},
  [348] = {.lex_state = 0},
  [349] = {.lex_state = 0},
  [350] = {.lex_state = 59},
  [351] = {.lex_state = 59},
  [352] = {.lex_state = 0},
  [353] = {.lex_state = 59},
  [354] = {.lex_state = 59},
  [355] = {.lex_state = 0},
  [356] = {.lex_state = 59},
  [357] = {.lex_state = 0, .external_lex_state = 5},
  [358] = {.lex_state = 0},
  [359] = {.lex_state = 0},
  [360] = {.lex_state = 0},
  [361] = {.lex_state = 59},
  [362] = {.lex_state = 59},
  [363] = {.lex_state = 59},
  [364] = {.lex_state = 0},
  [365] = {.lex_state = 59},
  [366] = {.lex_state = 0},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 59},
  [370] = {.lex_state = 59},
  [371] = {.lex_state = 59},
  [372] = {.lex_state = 0},
  [373] = {.lex_state = 59},
  [374] = {.lex_state = 59},
  [375] = {.lex_state = 59},
  [376] = {.lex_state = 59},
  [377] = {.lex_state = 0},
  [378] = {.lex_state = 0},
  [379] = {.lex_state = 59},
  [380] = {.lex_state = 0},
  [381] = {.lex_state = 59},
  [382] = {.lex_state = 0},
  [383] = {.lex_state = 59},
  [384] = {.lex_state = 0},
  [385] = {.lex_state = 0},
  [386] = {.lex_state = 0},
  [387] = {.lex_state = 59},
  [388] = {.lex_state = 0, .external_lex_state = 5},
  [389] = {.lex_state = 0, .external_lex_state = 5},
  [390] = {.lex_state = 0, .external_lex_state = 4},
  [391] = {.lex_state = 0},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 0},
  [394] = {.lex_state = 0},
  [395] = {.lex_state = 0},
  [396] = {.lex_state = 0},
  [397] = {.lex_state = 0},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 0},
  [400] = {.lex_state = 0},
  [401] = {.lex_state = 59},
  [402] = {.lex_state = 0},
  [403] = {.lex_state = 0},
  [404] = {.lex_state = 0, .external_lex_state = 5},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 0},
  [408] = {.lex_state = 5},
  [409] = {.lex_state = 59},
  [410] = {.lex_state = 0},
  [411] = {.lex_state = 5},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 0, .external_lex_state = 5},
  [414] = {.lex_state = 0, .external_lex_state = 5},
  [415] = {.lex_state = 0, .external_lex_state = 5},
  [416] = {.lex_state = 0},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 0, .external_lex_state = 5},
  [419] = {.lex_state = 0},
  [420] = {.lex_state = 0},
  [421] = {.lex_state = 0},
  [422] = {.lex_state = 5},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 0},
  [425] = {.lex_state = 0},
  [426] = {.lex_state = 0},
  [427] = {.lex_state = 0, .external_lex_state = 5},
  [428] = {.lex_state = 0, .external_lex_state = 5},
  [429] = {.lex_state = 59},
  [430] = {.lex_state = 59},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 59},
  [435] = {.lex_state = 59},
  [436] = {.lex_state = 59},
  [437] = {.lex_state = 59},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 0},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 0},
  [442] = {.lex_state = 59},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_circuit] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_extmodule] = ACTIONS(1),
    [anon_sym_input] = ACTIONS(1),
    [anon_sym_output] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_UInt] = ACTIONS(1),
    [anon_sym_SInt] = ACTIONS(1),
    [anon_sym_Analog] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_Fixed] = ACTIONS(1),
    [anon_sym_Clock] = ACTIONS(1),
    [anon_sym_AsyncReset] = ACTIONS(1),
    [anon_sym_Reset] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_flip] = ACTIONS(1),
    [anon_sym_defname] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_parameter] = ACTIONS(1),
    [anon_sym_reset] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_wire] = ACTIONS(1),
    [anon_sym_cmem] = ACTIONS(1),
    [anon_sym_smem] = ACTIONS(1),
    [anon_sym_reg] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_mem] = ACTIONS(1),
    [anon_sym_mport] = ACTIONS(1),
    [anon_sym_inst] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_node] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_invalid] = ACTIONS(1),
    [anon_sym_data_DASHtype] = ACTIONS(1),
    [anon_sym_depth] = ACTIONS(1),
    [anon_sym_read_DASHlatency] = ACTIONS(1),
    [anon_sym_write_DASHlatency] = ACTIONS(1),
    [anon_sym_read_DASHunder_DASHwrite] = ACTIONS(1),
    [anon_sym_reader] = ACTIONS(1),
    [anon_sym_writer] = ACTIONS(1),
    [anon_sym_readwriter] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_stop] = ACTIONS(1),
    [anon_sym_printf] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_assume] = ACTIONS(1),
    [anon_sym_cover] = ACTIONS(1),
    [anon_sym_skip] = ACTIONS(1),
    [anon_sym_attach] = ACTIONS(1),
    [sym_info] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_read] = ACTIONS(1),
    [anon_sym_write] = ACTIONS(1),
    [anon_sym_rdwr] = ACTIONS(1),
    [anon_sym_old] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_undefined] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_mux] = ACTIONS(1),
    [anon_sym_validif] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_sub] = ACTIONS(1),
    [anon_sym_mul] = ACTIONS(1),
    [anon_sym_div] = ACTIONS(1),
    [anon_sym_rem] = ACTIONS(1),
    [anon_sym_lt] = ACTIONS(1),
    [anon_sym_leq] = ACTIONS(1),
    [anon_sym_gt] = ACTIONS(1),
    [anon_sym_geq] = ACTIONS(1),
    [anon_sym_eq] = ACTIONS(1),
    [anon_sym_neq] = ACTIONS(1),
    [anon_sym_pad] = ACTIONS(1),
    [anon_sym_asUInt] = ACTIONS(1),
    [anon_sym_asAsyncReset] = ACTIONS(1),
    [anon_sym_asSInt] = ACTIONS(1),
    [anon_sym_asClock] = ACTIONS(1),
    [anon_sym_shl] = ACTIONS(1),
    [anon_sym_shr] = ACTIONS(1),
    [anon_sym_dshl] = ACTIONS(1),
    [anon_sym_dshlw] = ACTIONS(1),
    [anon_sym_dshr] = ACTIONS(1),
    [anon_sym_dshrw] = ACTIONS(1),
    [anon_sym_cvt] = ACTIONS(1),
    [anon_sym_neg] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_andr] = ACTIONS(1),
    [anon_sym_orr] = ACTIONS(1),
    [anon_sym_xorr] = ACTIONS(1),
    [anon_sym_cat] = ACTIONS(1),
    [anon_sym_bits] = ACTIONS(1),
    [anon_sym_head] = ACTIONS(1),
    [anon_sym_tail] = ACTIONS(1),
    [anon_sym_asFixedPoint] = ACTIONS(1),
    [anon_sym_bpshl] = ACTIONS(1),
    [anon_sym_bpshr] = ACTIONS(1),
    [anon_sym_bpset] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [aux_sym_uint_token1] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [sym_double] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [aux_sym__escape_sequence_token1] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(410),
    [sym_circuit] = STATE(234),
    [aux_sym_source_file_repeat1] = STATE(234),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_circuit] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_port] = STATE(16),
    [sym_dir] = STATE(429),
    [sym_statement] = STATE(9),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat1] = STATE(16),
    [aux_sym_module_repeat2] = STATE(9),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_input] = ACTIONS(11),
    [anon_sym_output] = ACTIONS(11),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(49),
  },
  [3] = {
    [sym_port] = STATE(16),
    [sym_dir] = STATE(429),
    [sym_statement] = STATE(13),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat1] = STATE(16),
    [aux_sym_module_repeat2] = STATE(13),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_input] = ACTIONS(11),
    [anon_sym_output] = ACTIONS(11),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(51),
  },
  [4] = {
    [sym_port] = STATE(3),
    [sym_dir] = STATE(429),
    [sym_statement] = STATE(9),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat1] = STATE(3),
    [aux_sym_module_repeat2] = STATE(9),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_input] = ACTIONS(11),
    [anon_sym_output] = ACTIONS(11),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(49),
  },
  [5] = {
    [sym_port] = STATE(2),
    [sym_dir] = STATE(429),
    [sym_statement] = STATE(12),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat1] = STATE(2),
    [aux_sym_module_repeat2] = STATE(12),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_input] = ACTIONS(11),
    [anon_sym_output] = ACTIONS(11),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(53),
  },
  [6] = {
    [sym_statement] = STATE(79),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_suite] = STATE(63),
    [sym_when] = STATE(65),
    [sym_else] = STATE(77),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_else] = ACTIONS(55),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [sym_info] = ACTIONS(57),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(59),
    [sym__dedent] = ACTIONS(61),
  },
  [7] = {
    [sym_statement] = STATE(79),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_suite] = STATE(58),
    [sym_when] = STATE(65),
    [sym_else] = STATE(76),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_else] = ACTIONS(55),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(59),
    [sym__dedent] = ACTIONS(63),
  },
  [8] = {
    [sym_statement] = STATE(79),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_suite] = STATE(86),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [sym_info] = ACTIONS(65),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(59),
  },
  [9] = {
    [sym_statement] = STATE(10),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat2] = STATE(10),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(51),
  },
  [10] = {
    [sym_statement] = STATE(10),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat2] = STATE(10),
    [sym_identifier] = ACTIONS(67),
    [anon_sym_UInt] = ACTIONS(70),
    [anon_sym_SInt] = ACTIONS(70),
    [anon_sym_wire] = ACTIONS(73),
    [anon_sym_cmem] = ACTIONS(76),
    [anon_sym_smem] = ACTIONS(79),
    [anon_sym_reg] = ACTIONS(82),
    [anon_sym_mem] = ACTIONS(85),
    [anon_sym_inst] = ACTIONS(88),
    [anon_sym_node] = ACTIONS(91),
    [anon_sym_when] = ACTIONS(94),
    [anon_sym_stop] = ACTIONS(97),
    [anon_sym_printf] = ACTIONS(100),
    [anon_sym_assert] = ACTIONS(103),
    [anon_sym_assume] = ACTIONS(103),
    [anon_sym_cover] = ACTIONS(103),
    [anon_sym_skip] = ACTIONS(106),
    [anon_sym_attach] = ACTIONS(109),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_read] = ACTIONS(112),
    [anon_sym_write] = ACTIONS(112),
    [anon_sym_rdwr] = ACTIONS(112),
    [anon_sym_mux] = ACTIONS(115),
    [anon_sym_validif] = ACTIONS(118),
    [anon_sym_add] = ACTIONS(121),
    [anon_sym_sub] = ACTIONS(121),
    [anon_sym_mul] = ACTIONS(121),
    [anon_sym_div] = ACTIONS(121),
    [anon_sym_rem] = ACTIONS(121),
    [anon_sym_lt] = ACTIONS(121),
    [anon_sym_leq] = ACTIONS(121),
    [anon_sym_gt] = ACTIONS(121),
    [anon_sym_geq] = ACTIONS(121),
    [anon_sym_eq] = ACTIONS(121),
    [anon_sym_neq] = ACTIONS(121),
    [anon_sym_pad] = ACTIONS(121),
    [anon_sym_asUInt] = ACTIONS(121),
    [anon_sym_asAsyncReset] = ACTIONS(121),
    [anon_sym_asSInt] = ACTIONS(121),
    [anon_sym_asClock] = ACTIONS(121),
    [anon_sym_shl] = ACTIONS(121),
    [anon_sym_shr] = ACTIONS(121),
    [anon_sym_dshl] = ACTIONS(121),
    [anon_sym_dshlw] = ACTIONS(121),
    [anon_sym_dshr] = ACTIONS(121),
    [anon_sym_dshrw] = ACTIONS(121),
    [anon_sym_cvt] = ACTIONS(121),
    [anon_sym_neg] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(121),
    [anon_sym_and] = ACTIONS(121),
    [anon_sym_or] = ACTIONS(121),
    [anon_sym_xor] = ACTIONS(121),
    [anon_sym_andr] = ACTIONS(121),
    [anon_sym_orr] = ACTIONS(121),
    [anon_sym_xorr] = ACTIONS(121),
    [anon_sym_cat] = ACTIONS(121),
    [anon_sym_bits] = ACTIONS(121),
    [anon_sym_head] = ACTIONS(121),
    [anon_sym_tail] = ACTIONS(121),
    [anon_sym_asFixedPoint] = ACTIONS(121),
    [anon_sym_bpshl] = ACTIONS(121),
    [anon_sym_bpshr] = ACTIONS(121),
    [anon_sym_bpset] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(124),
  },
  [11] = {
    [sym_statement] = STATE(79),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_suite] = STATE(92),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(59),
  },
  [12] = {
    [sym_statement] = STATE(10),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat2] = STATE(10),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(49),
  },
  [13] = {
    [sym_statement] = STATE(10),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat2] = STATE(10),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(126),
  },
  [14] = {
    [sym_statement] = STATE(10),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat2] = STATE(10),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(128),
  },
  [15] = {
    [sym_statement] = STATE(14),
    [sym_wire] = STATE(65),
    [sym_cmem] = STATE(65),
    [sym_smem] = STATE(65),
    [sym_register] = STATE(65),
    [sym_memory] = STATE(65),
    [sym_rdwr] = STATE(65),
    [sym_inst] = STATE(65),
    [sym_node] = STATE(65),
    [sym_connection] = STATE(65),
    [sym_partial_connection] = STATE(65),
    [sym_is_invalid] = STATE(65),
    [sym_when] = STATE(65),
    [sym_stop] = STATE(65),
    [sym_printf] = STATE(65),
    [sym_verif] = STATE(65),
    [sym_skip] = STATE(65),
    [sym_attach] = STATE(65),
    [sym_mdir] = STATE(430),
    [sym_litType] = STATE(433),
    [sym_expression] = STATE(205),
    [sym_literal] = STATE(160),
    [sym_sub_field] = STATE(160),
    [sym_sub_index] = STATE(160),
    [sym_sub_access] = STATE(160),
    [sym_mux] = STATE(160),
    [sym_conditionally_valid] = STATE(160),
    [sym_primitive_operation] = STATE(160),
    [sym_primop] = STATE(143),
    [aux_sym_module_repeat2] = STATE(14),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_UInt] = ACTIONS(13),
    [anon_sym_SInt] = ACTIONS(13),
    [anon_sym_wire] = ACTIONS(15),
    [anon_sym_cmem] = ACTIONS(17),
    [anon_sym_smem] = ACTIONS(19),
    [anon_sym_reg] = ACTIONS(21),
    [anon_sym_mem] = ACTIONS(23),
    [anon_sym_inst] = ACTIONS(25),
    [anon_sym_node] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_stop] = ACTIONS(31),
    [anon_sym_printf] = ACTIONS(33),
    [anon_sym_assert] = ACTIONS(35),
    [anon_sym_assume] = ACTIONS(35),
    [anon_sym_cover] = ACTIONS(35),
    [anon_sym_skip] = ACTIONS(37),
    [anon_sym_attach] = ACTIONS(39),
    [anon_sym_infer] = ACTIONS(41),
    [anon_sym_read] = ACTIONS(41),
    [anon_sym_write] = ACTIONS(41),
    [anon_sym_rdwr] = ACTIONS(41),
    [anon_sym_mux] = ACTIONS(43),
    [anon_sym_validif] = ACTIONS(45),
    [anon_sym_add] = ACTIONS(47),
    [anon_sym_sub] = ACTIONS(47),
    [anon_sym_mul] = ACTIONS(47),
    [anon_sym_div] = ACTIONS(47),
    [anon_sym_rem] = ACTIONS(47),
    [anon_sym_lt] = ACTIONS(47),
    [anon_sym_leq] = ACTIONS(47),
    [anon_sym_gt] = ACTIONS(47),
    [anon_sym_geq] = ACTIONS(47),
    [anon_sym_eq] = ACTIONS(47),
    [anon_sym_neq] = ACTIONS(47),
    [anon_sym_pad] = ACTIONS(47),
    [anon_sym_asUInt] = ACTIONS(47),
    [anon_sym_asAsyncReset] = ACTIONS(47),
    [anon_sym_asSInt] = ACTIONS(47),
    [anon_sym_asClock] = ACTIONS(47),
    [anon_sym_shl] = ACTIONS(47),
    [anon_sym_shr] = ACTIONS(47),
    [anon_sym_dshl] = ACTIONS(47),
    [anon_sym_dshlw] = ACTIONS(47),
    [anon_sym_dshr] = ACTIONS(47),
    [anon_sym_dshrw] = ACTIONS(47),
    [anon_sym_cvt] = ACTIONS(47),
    [anon_sym_neg] = ACTIONS(47),
    [anon_sym_not] = ACTIONS(47),
    [anon_sym_and] = ACTIONS(47),
    [anon_sym_or] = ACTIONS(47),
    [anon_sym_xor] = ACTIONS(47),
    [anon_sym_andr] = ACTIONS(47),
    [anon_sym_orr] = ACTIONS(47),
    [anon_sym_xorr] = ACTIONS(47),
    [anon_sym_cat] = ACTIONS(47),
    [anon_sym_bits] = ACTIONS(47),
    [anon_sym_head] = ACTIONS(47),
    [anon_sym_tail] = ACTIONS(47),
    [anon_sym_asFixedPoint] = ACTIONS(47),
    [anon_sym_bpshl] = ACTIONS(47),
    [anon_sym_bpshr] = ACTIONS(47),
    [anon_sym_bpset] = ACTIONS(47),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_port] = STATE(16),
    [sym_dir] = STATE(429),
    [aux_sym_module_repeat1] = STATE(16),
    [sym_identifier] = ACTIONS(130),
    [anon_sym_input] = ACTIONS(132),
    [anon_sym_output] = ACTIONS(132),
    [anon_sym_UInt] = ACTIONS(130),
    [anon_sym_SInt] = ACTIONS(130),
    [anon_sym_defname] = ACTIONS(130),
    [anon_sym_parameter] = ACTIONS(130),
    [anon_sym_wire] = ACTIONS(130),
    [anon_sym_cmem] = ACTIONS(130),
    [anon_sym_smem] = ACTIONS(130),
    [anon_sym_reg] = ACTIONS(130),
    [anon_sym_mem] = ACTIONS(130),
    [anon_sym_inst] = ACTIONS(130),
    [anon_sym_node] = ACTIONS(130),
    [anon_sym_when] = ACTIONS(130),
    [anon_sym_stop] = ACTIONS(130),
    [anon_sym_printf] = ACTIONS(130),
    [anon_sym_assert] = ACTIONS(130),
    [anon_sym_assume] = ACTIONS(130),
    [anon_sym_cover] = ACTIONS(130),
    [anon_sym_skip] = ACTIONS(130),
    [anon_sym_attach] = ACTIONS(130),
    [anon_sym_infer] = ACTIONS(130),
    [anon_sym_read] = ACTIONS(130),
    [anon_sym_write] = ACTIONS(130),
    [anon_sym_rdwr] = ACTIONS(130),
    [anon_sym_mux] = ACTIONS(130),
    [anon_sym_validif] = ACTIONS(130),
    [anon_sym_add] = ACTIONS(130),
    [anon_sym_sub] = ACTIONS(130),
    [anon_sym_mul] = ACTIONS(130),
    [anon_sym_div] = ACTIONS(130),
    [anon_sym_rem] = ACTIONS(130),
    [anon_sym_lt] = ACTIONS(130),
    [anon_sym_leq] = ACTIONS(130),
    [anon_sym_gt] = ACTIONS(130),
    [anon_sym_geq] = ACTIONS(130),
    [anon_sym_eq] = ACTIONS(130),
    [anon_sym_neq] = ACTIONS(130),
    [anon_sym_pad] = ACTIONS(130),
    [anon_sym_asUInt] = ACTIONS(130),
    [anon_sym_asAsyncReset] = ACTIONS(130),
    [anon_sym_asSInt] = ACTIONS(130),
    [anon_sym_asClock] = ACTIONS(130),
    [anon_sym_shl] = ACTIONS(130),
    [anon_sym_shr] = ACTIONS(130),
    [anon_sym_dshl] = ACTIONS(130),
    [anon_sym_dshlw] = ACTIONS(130),
    [anon_sym_dshr] = ACTIONS(130),
    [anon_sym_dshrw] = ACTIONS(130),
    [anon_sym_cvt] = ACTIONS(130),
    [anon_sym_neg] = ACTIONS(130),
    [anon_sym_not] = ACTIONS(130),
    [anon_sym_and] = ACTIONS(130),
    [anon_sym_or] = ACTIONS(130),
    [anon_sym_xor] = ACTIONS(130),
    [anon_sym_andr] = ACTIONS(130),
    [anon_sym_orr] = ACTIONS(130),
    [anon_sym_xorr] = ACTIONS(130),
    [anon_sym_cat] = ACTIONS(130),
    [anon_sym_bits] = ACTIONS(130),
    [anon_sym_head] = ACTIONS(130),
    [anon_sym_tail] = ACTIONS(130),
    [anon_sym_asFixedPoint] = ACTIONS(130),
    [anon_sym_bpshl] = ACTIONS(130),
    [anon_sym_bpshr] = ACTIONS(130),
    [anon_sym_bpset] = ACTIONS(130),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(135),
  },
  [17] = {
    [sym_identifier] = ACTIONS(137),
    [anon_sym_UInt] = ACTIONS(137),
    [anon_sym_SInt] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_wire] = ACTIONS(137),
    [anon_sym_cmem] = ACTIONS(137),
    [anon_sym_smem] = ACTIONS(137),
    [anon_sym_reg] = ACTIONS(137),
    [anon_sym_with] = ACTIONS(137),
    [anon_sym_mem] = ACTIONS(137),
    [anon_sym_inst] = ACTIONS(137),
    [anon_sym_node] = ACTIONS(137),
    [anon_sym_when] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(137),
    [anon_sym_stop] = ACTIONS(137),
    [anon_sym_printf] = ACTIONS(137),
    [anon_sym_assert] = ACTIONS(137),
    [anon_sym_assume] = ACTIONS(137),
    [anon_sym_cover] = ACTIONS(137),
    [anon_sym_skip] = ACTIONS(137),
    [anon_sym_attach] = ACTIONS(137),
    [sym_info] = ACTIONS(139),
    [anon_sym_infer] = ACTIONS(137),
    [anon_sym_read] = ACTIONS(137),
    [anon_sym_write] = ACTIONS(137),
    [anon_sym_rdwr] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_mux] = ACTIONS(137),
    [anon_sym_validif] = ACTIONS(137),
    [anon_sym_add] = ACTIONS(137),
    [anon_sym_sub] = ACTIONS(137),
    [anon_sym_mul] = ACTIONS(137),
    [anon_sym_div] = ACTIONS(137),
    [anon_sym_rem] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_leq] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_geq] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_neq] = ACTIONS(137),
    [anon_sym_pad] = ACTIONS(137),
    [anon_sym_asUInt] = ACTIONS(137),
    [anon_sym_asAsyncReset] = ACTIONS(137),
    [anon_sym_asSInt] = ACTIONS(137),
    [anon_sym_asClock] = ACTIONS(137),
    [anon_sym_shl] = ACTIONS(137),
    [anon_sym_shr] = ACTIONS(137),
    [anon_sym_dshl] = ACTIONS(137),
    [anon_sym_dshlw] = ACTIONS(137),
    [anon_sym_dshr] = ACTIONS(137),
    [anon_sym_dshrw] = ACTIONS(137),
    [anon_sym_cvt] = ACTIONS(137),
    [anon_sym_neg] = ACTIONS(137),
    [anon_sym_not] = ACTIONS(137),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_xor] = ACTIONS(137),
    [anon_sym_andr] = ACTIONS(137),
    [anon_sym_orr] = ACTIONS(137),
    [anon_sym_xorr] = ACTIONS(137),
    [anon_sym_cat] = ACTIONS(137),
    [anon_sym_bits] = ACTIONS(137),
    [anon_sym_head] = ACTIONS(137),
    [anon_sym_tail] = ACTIONS(137),
    [anon_sym_asFixedPoint] = ACTIONS(137),
    [anon_sym_bpshl] = ACTIONS(137),
    [anon_sym_bpshr] = ACTIONS(137),
    [anon_sym_bpset] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(139),
  },
  [18] = {
    [sym_identifier] = ACTIONS(141),
    [anon_sym_UInt] = ACTIONS(141),
    [anon_sym_SInt] = ACTIONS(141),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_wire] = ACTIONS(141),
    [anon_sym_cmem] = ACTIONS(141),
    [anon_sym_smem] = ACTIONS(141),
    [anon_sym_reg] = ACTIONS(141),
    [anon_sym_with] = ACTIONS(141),
    [anon_sym_mem] = ACTIONS(141),
    [anon_sym_inst] = ACTIONS(141),
    [anon_sym_node] = ACTIONS(141),
    [anon_sym_when] = ACTIONS(141),
    [anon_sym_else] = ACTIONS(141),
    [anon_sym_stop] = ACTIONS(141),
    [anon_sym_printf] = ACTIONS(141),
    [anon_sym_assert] = ACTIONS(141),
    [anon_sym_assume] = ACTIONS(141),
    [anon_sym_cover] = ACTIONS(141),
    [anon_sym_skip] = ACTIONS(141),
    [anon_sym_attach] = ACTIONS(141),
    [sym_info] = ACTIONS(143),
    [anon_sym_infer] = ACTIONS(141),
    [anon_sym_read] = ACTIONS(141),
    [anon_sym_write] = ACTIONS(141),
    [anon_sym_rdwr] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_mux] = ACTIONS(141),
    [anon_sym_validif] = ACTIONS(141),
    [anon_sym_add] = ACTIONS(141),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_mul] = ACTIONS(141),
    [anon_sym_div] = ACTIONS(141),
    [anon_sym_rem] = ACTIONS(141),
    [anon_sym_lt] = ACTIONS(141),
    [anon_sym_leq] = ACTIONS(141),
    [anon_sym_gt] = ACTIONS(141),
    [anon_sym_geq] = ACTIONS(141),
    [anon_sym_eq] = ACTIONS(141),
    [anon_sym_neq] = ACTIONS(141),
    [anon_sym_pad] = ACTIONS(141),
    [anon_sym_asUInt] = ACTIONS(141),
    [anon_sym_asAsyncReset] = ACTIONS(141),
    [anon_sym_asSInt] = ACTIONS(141),
    [anon_sym_asClock] = ACTIONS(141),
    [anon_sym_shl] = ACTIONS(141),
    [anon_sym_shr] = ACTIONS(141),
    [anon_sym_dshl] = ACTIONS(141),
    [anon_sym_dshlw] = ACTIONS(141),
    [anon_sym_dshr] = ACTIONS(141),
    [anon_sym_dshrw] = ACTIONS(141),
    [anon_sym_cvt] = ACTIONS(141),
    [anon_sym_neg] = ACTIONS(141),
    [anon_sym_not] = ACTIONS(141),
    [anon_sym_and] = ACTIONS(141),
    [anon_sym_or] = ACTIONS(141),
    [anon_sym_xor] = ACTIONS(141),
    [anon_sym_andr] = ACTIONS(141),
    [anon_sym_orr] = ACTIONS(141),
    [anon_sym_xorr] = ACTIONS(141),
    [anon_sym_cat] = ACTIONS(141),
    [anon_sym_bits] = ACTIONS(141),
    [anon_sym_head] = ACTIONS(141),
    [anon_sym_tail] = ACTIONS(141),
    [anon_sym_asFixedPoint] = ACTIONS(141),
    [anon_sym_bpshl] = ACTIONS(141),
    [anon_sym_bpshr] = ACTIONS(141),
    [anon_sym_bpset] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(143),
  },
  [19] = {
    [sym_identifier] = ACTIONS(141),
    [anon_sym_UInt] = ACTIONS(141),
    [anon_sym_SInt] = ACTIONS(141),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(147),
    [anon_sym_wire] = ACTIONS(141),
    [anon_sym_cmem] = ACTIONS(141),
    [anon_sym_smem] = ACTIONS(141),
    [anon_sym_reg] = ACTIONS(141),
    [anon_sym_with] = ACTIONS(141),
    [anon_sym_mem] = ACTIONS(141),
    [anon_sym_inst] = ACTIONS(141),
    [anon_sym_node] = ACTIONS(141),
    [anon_sym_when] = ACTIONS(141),
    [anon_sym_else] = ACTIONS(141),
    [anon_sym_stop] = ACTIONS(141),
    [anon_sym_printf] = ACTIONS(141),
    [anon_sym_assert] = ACTIONS(141),
    [anon_sym_assume] = ACTIONS(141),
    [anon_sym_cover] = ACTIONS(141),
    [anon_sym_skip] = ACTIONS(141),
    [anon_sym_attach] = ACTIONS(141),
    [sym_info] = ACTIONS(143),
    [anon_sym_infer] = ACTIONS(141),
    [anon_sym_read] = ACTIONS(141),
    [anon_sym_write] = ACTIONS(141),
    [anon_sym_rdwr] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_mux] = ACTIONS(141),
    [anon_sym_validif] = ACTIONS(141),
    [anon_sym_add] = ACTIONS(141),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_mul] = ACTIONS(141),
    [anon_sym_div] = ACTIONS(141),
    [anon_sym_rem] = ACTIONS(141),
    [anon_sym_lt] = ACTIONS(141),
    [anon_sym_leq] = ACTIONS(141),
    [anon_sym_gt] = ACTIONS(141),
    [anon_sym_geq] = ACTIONS(141),
    [anon_sym_eq] = ACTIONS(141),
    [anon_sym_neq] = ACTIONS(141),
    [anon_sym_pad] = ACTIONS(141),
    [anon_sym_asUInt] = ACTIONS(141),
    [anon_sym_asAsyncReset] = ACTIONS(141),
    [anon_sym_asSInt] = ACTIONS(141),
    [anon_sym_asClock] = ACTIONS(141),
    [anon_sym_shl] = ACTIONS(141),
    [anon_sym_shr] = ACTIONS(141),
    [anon_sym_dshl] = ACTIONS(141),
    [anon_sym_dshlw] = ACTIONS(141),
    [anon_sym_dshr] = ACTIONS(141),
    [anon_sym_dshrw] = ACTIONS(141),
    [anon_sym_cvt] = ACTIONS(141),
    [anon_sym_neg] = ACTIONS(141),
    [anon_sym_not] = ACTIONS(141),
    [anon_sym_and] = ACTIONS(141),
    [anon_sym_or] = ACTIONS(141),
    [anon_sym_xor] = ACTIONS(141),
    [anon_sym_andr] = ACTIONS(141),
    [anon_sym_orr] = ACTIONS(141),
    [anon_sym_xorr] = ACTIONS(141),
    [anon_sym_cat] = ACTIONS(141),
    [anon_sym_bits] = ACTIONS(141),
    [anon_sym_head] = ACTIONS(141),
    [anon_sym_tail] = ACTIONS(141),
    [anon_sym_asFixedPoint] = ACTIONS(141),
    [anon_sym_bpshl] = ACTIONS(141),
    [anon_sym_bpshr] = ACTIONS(141),
    [anon_sym_bpset] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(143),
  },
  [20] = {
    [sym_identifier] = ACTIONS(149),
    [anon_sym_UInt] = ACTIONS(149),
    [anon_sym_SInt] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_wire] = ACTIONS(149),
    [anon_sym_cmem] = ACTIONS(149),
    [anon_sym_smem] = ACTIONS(149),
    [anon_sym_reg] = ACTIONS(149),
    [anon_sym_with] = ACTIONS(149),
    [anon_sym_mem] = ACTIONS(149),
    [anon_sym_inst] = ACTIONS(149),
    [anon_sym_node] = ACTIONS(149),
    [anon_sym_when] = ACTIONS(149),
    [anon_sym_else] = ACTIONS(149),
    [anon_sym_stop] = ACTIONS(149),
    [anon_sym_printf] = ACTIONS(149),
    [anon_sym_assert] = ACTIONS(149),
    [anon_sym_assume] = ACTIONS(149),
    [anon_sym_cover] = ACTIONS(149),
    [anon_sym_skip] = ACTIONS(149),
    [anon_sym_attach] = ACTIONS(149),
    [sym_info] = ACTIONS(151),
    [anon_sym_infer] = ACTIONS(149),
    [anon_sym_read] = ACTIONS(149),
    [anon_sym_write] = ACTIONS(149),
    [anon_sym_rdwr] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_mux] = ACTIONS(149),
    [anon_sym_validif] = ACTIONS(149),
    [anon_sym_add] = ACTIONS(149),
    [anon_sym_sub] = ACTIONS(149),
    [anon_sym_mul] = ACTIONS(149),
    [anon_sym_div] = ACTIONS(149),
    [anon_sym_rem] = ACTIONS(149),
    [anon_sym_lt] = ACTIONS(149),
    [anon_sym_leq] = ACTIONS(149),
    [anon_sym_gt] = ACTIONS(149),
    [anon_sym_geq] = ACTIONS(149),
    [anon_sym_eq] = ACTIONS(149),
    [anon_sym_neq] = ACTIONS(149),
    [anon_sym_pad] = ACTIONS(149),
    [anon_sym_asUInt] = ACTIONS(149),
    [anon_sym_asAsyncReset] = ACTIONS(149),
    [anon_sym_asSInt] = ACTIONS(149),
    [anon_sym_asClock] = ACTIONS(149),
    [anon_sym_shl] = ACTIONS(149),
    [anon_sym_shr] = ACTIONS(149),
    [anon_sym_dshl] = ACTIONS(149),
    [anon_sym_dshlw] = ACTIONS(149),
    [anon_sym_dshr] = ACTIONS(149),
    [anon_sym_dshrw] = ACTIONS(149),
    [anon_sym_cvt] = ACTIONS(149),
    [anon_sym_neg] = ACTIONS(149),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_and] = ACTIONS(149),
    [anon_sym_or] = ACTIONS(149),
    [anon_sym_xor] = ACTIONS(149),
    [anon_sym_andr] = ACTIONS(149),
    [anon_sym_orr] = ACTIONS(149),
    [anon_sym_xorr] = ACTIONS(149),
    [anon_sym_cat] = ACTIONS(149),
    [anon_sym_bits] = ACTIONS(149),
    [anon_sym_head] = ACTIONS(149),
    [anon_sym_tail] = ACTIONS(149),
    [anon_sym_asFixedPoint] = ACTIONS(149),
    [anon_sym_bpshl] = ACTIONS(149),
    [anon_sym_bpshr] = ACTIONS(149),
    [anon_sym_bpset] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(151),
  },
  [21] = {
    [sym_identifier] = ACTIONS(153),
    [anon_sym_UInt] = ACTIONS(153),
    [anon_sym_SInt] = ACTIONS(153),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_wire] = ACTIONS(153),
    [anon_sym_cmem] = ACTIONS(153),
    [anon_sym_smem] = ACTIONS(153),
    [anon_sym_reg] = ACTIONS(153),
    [anon_sym_with] = ACTIONS(153),
    [anon_sym_mem] = ACTIONS(153),
    [anon_sym_inst] = ACTIONS(153),
    [anon_sym_node] = ACTIONS(153),
    [anon_sym_when] = ACTIONS(153),
    [anon_sym_else] = ACTIONS(153),
    [anon_sym_stop] = ACTIONS(153),
    [anon_sym_printf] = ACTIONS(153),
    [anon_sym_assert] = ACTIONS(153),
    [anon_sym_assume] = ACTIONS(153),
    [anon_sym_cover] = ACTIONS(153),
    [anon_sym_skip] = ACTIONS(153),
    [anon_sym_attach] = ACTIONS(153),
    [sym_info] = ACTIONS(155),
    [anon_sym_infer] = ACTIONS(153),
    [anon_sym_read] = ACTIONS(153),
    [anon_sym_write] = ACTIONS(153),
    [anon_sym_rdwr] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_mux] = ACTIONS(153),
    [anon_sym_validif] = ACTIONS(153),
    [anon_sym_add] = ACTIONS(153),
    [anon_sym_sub] = ACTIONS(153),
    [anon_sym_mul] = ACTIONS(153),
    [anon_sym_div] = ACTIONS(153),
    [anon_sym_rem] = ACTIONS(153),
    [anon_sym_lt] = ACTIONS(153),
    [anon_sym_leq] = ACTIONS(153),
    [anon_sym_gt] = ACTIONS(153),
    [anon_sym_geq] = ACTIONS(153),
    [anon_sym_eq] = ACTIONS(153),
    [anon_sym_neq] = ACTIONS(153),
    [anon_sym_pad] = ACTIONS(153),
    [anon_sym_asUInt] = ACTIONS(153),
    [anon_sym_asAsyncReset] = ACTIONS(153),
    [anon_sym_asSInt] = ACTIONS(153),
    [anon_sym_asClock] = ACTIONS(153),
    [anon_sym_shl] = ACTIONS(153),
    [anon_sym_shr] = ACTIONS(153),
    [anon_sym_dshl] = ACTIONS(153),
    [anon_sym_dshlw] = ACTIONS(153),
    [anon_sym_dshr] = ACTIONS(153),
    [anon_sym_dshrw] = ACTIONS(153),
    [anon_sym_cvt] = ACTIONS(153),
    [anon_sym_neg] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_and] = ACTIONS(153),
    [anon_sym_or] = ACTIONS(153),
    [anon_sym_xor] = ACTIONS(153),
    [anon_sym_andr] = ACTIONS(153),
    [anon_sym_orr] = ACTIONS(153),
    [anon_sym_xorr] = ACTIONS(153),
    [anon_sym_cat] = ACTIONS(153),
    [anon_sym_bits] = ACTIONS(153),
    [anon_sym_head] = ACTIONS(153),
    [anon_sym_tail] = ACTIONS(153),
    [anon_sym_asFixedPoint] = ACTIONS(153),
    [anon_sym_bpshl] = ACTIONS(153),
    [anon_sym_bpshr] = ACTIONS(153),
    [anon_sym_bpset] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(155),
  },
  [22] = {
    [sym_identifier] = ACTIONS(157),
    [anon_sym_UInt] = ACTIONS(157),
    [anon_sym_SInt] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_wire] = ACTIONS(157),
    [anon_sym_cmem] = ACTIONS(157),
    [anon_sym_smem] = ACTIONS(157),
    [anon_sym_reg] = ACTIONS(157),
    [anon_sym_with] = ACTIONS(157),
    [anon_sym_mem] = ACTIONS(157),
    [anon_sym_inst] = ACTIONS(157),
    [anon_sym_node] = ACTIONS(157),
    [anon_sym_when] = ACTIONS(157),
    [anon_sym_else] = ACTIONS(157),
    [anon_sym_stop] = ACTIONS(157),
    [anon_sym_printf] = ACTIONS(157),
    [anon_sym_assert] = ACTIONS(157),
    [anon_sym_assume] = ACTIONS(157),
    [anon_sym_cover] = ACTIONS(157),
    [anon_sym_skip] = ACTIONS(157),
    [anon_sym_attach] = ACTIONS(157),
    [sym_info] = ACTIONS(159),
    [anon_sym_infer] = ACTIONS(157),
    [anon_sym_read] = ACTIONS(157),
    [anon_sym_write] = ACTIONS(157),
    [anon_sym_rdwr] = ACTIONS(157),
    [anon_sym_DOT] = ACTIONS(159),
    [anon_sym_mux] = ACTIONS(157),
    [anon_sym_validif] = ACTIONS(157),
    [anon_sym_add] = ACTIONS(157),
    [anon_sym_sub] = ACTIONS(157),
    [anon_sym_mul] = ACTIONS(157),
    [anon_sym_div] = ACTIONS(157),
    [anon_sym_rem] = ACTIONS(157),
    [anon_sym_lt] = ACTIONS(157),
    [anon_sym_leq] = ACTIONS(157),
    [anon_sym_gt] = ACTIONS(157),
    [anon_sym_geq] = ACTIONS(157),
    [anon_sym_eq] = ACTIONS(157),
    [anon_sym_neq] = ACTIONS(157),
    [anon_sym_pad] = ACTIONS(157),
    [anon_sym_asUInt] = ACTIONS(157),
    [anon_sym_asAsyncReset] = ACTIONS(157),
    [anon_sym_asSInt] = ACTIONS(157),
    [anon_sym_asClock] = ACTIONS(157),
    [anon_sym_shl] = ACTIONS(157),
    [anon_sym_shr] = ACTIONS(157),
    [anon_sym_dshl] = ACTIONS(157),
    [anon_sym_dshlw] = ACTIONS(157),
    [anon_sym_dshr] = ACTIONS(157),
    [anon_sym_dshrw] = ACTIONS(157),
    [anon_sym_cvt] = ACTIONS(157),
    [anon_sym_neg] = ACTIONS(157),
    [anon_sym_not] = ACTIONS(157),
    [anon_sym_and] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(157),
    [anon_sym_xor] = ACTIONS(157),
    [anon_sym_andr] = ACTIONS(157),
    [anon_sym_orr] = ACTIONS(157),
    [anon_sym_xorr] = ACTIONS(157),
    [anon_sym_cat] = ACTIONS(157),
    [anon_sym_bits] = ACTIONS(157),
    [anon_sym_head] = ACTIONS(157),
    [anon_sym_tail] = ACTIONS(157),
    [anon_sym_asFixedPoint] = ACTIONS(157),
    [anon_sym_bpshl] = ACTIONS(157),
    [anon_sym_bpshr] = ACTIONS(157),
    [anon_sym_bpset] = ACTIONS(157),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(159),
  },
  [23] = {
    [sym_identifier] = ACTIONS(161),
    [anon_sym_UInt] = ACTIONS(161),
    [anon_sym_SInt] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_wire] = ACTIONS(161),
    [anon_sym_cmem] = ACTIONS(161),
    [anon_sym_smem] = ACTIONS(161),
    [anon_sym_reg] = ACTIONS(161),
    [anon_sym_with] = ACTIONS(161),
    [anon_sym_mem] = ACTIONS(161),
    [anon_sym_inst] = ACTIONS(161),
    [anon_sym_node] = ACTIONS(161),
    [anon_sym_when] = ACTIONS(161),
    [anon_sym_else] = ACTIONS(161),
    [anon_sym_stop] = ACTIONS(161),
    [anon_sym_printf] = ACTIONS(161),
    [anon_sym_assert] = ACTIONS(161),
    [anon_sym_assume] = ACTIONS(161),
    [anon_sym_cover] = ACTIONS(161),
    [anon_sym_skip] = ACTIONS(161),
    [anon_sym_attach] = ACTIONS(161),
    [sym_info] = ACTIONS(163),
    [anon_sym_infer] = ACTIONS(161),
    [anon_sym_read] = ACTIONS(161),
    [anon_sym_write] = ACTIONS(161),
    [anon_sym_rdwr] = ACTIONS(161),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_mux] = ACTIONS(161),
    [anon_sym_validif] = ACTIONS(161),
    [anon_sym_add] = ACTIONS(161),
    [anon_sym_sub] = ACTIONS(161),
    [anon_sym_mul] = ACTIONS(161),
    [anon_sym_div] = ACTIONS(161),
    [anon_sym_rem] = ACTIONS(161),
    [anon_sym_lt] = ACTIONS(161),
    [anon_sym_leq] = ACTIONS(161),
    [anon_sym_gt] = ACTIONS(161),
    [anon_sym_geq] = ACTIONS(161),
    [anon_sym_eq] = ACTIONS(161),
    [anon_sym_neq] = ACTIONS(161),
    [anon_sym_pad] = ACTIONS(161),
    [anon_sym_asUInt] = ACTIONS(161),
    [anon_sym_asAsyncReset] = ACTIONS(161),
    [anon_sym_asSInt] = ACTIONS(161),
    [anon_sym_asClock] = ACTIONS(161),
    [anon_sym_shl] = ACTIONS(161),
    [anon_sym_shr] = ACTIONS(161),
    [anon_sym_dshl] = ACTIONS(161),
    [anon_sym_dshlw] = ACTIONS(161),
    [anon_sym_dshr] = ACTIONS(161),
    [anon_sym_dshrw] = ACTIONS(161),
    [anon_sym_cvt] = ACTIONS(161),
    [anon_sym_neg] = ACTIONS(161),
    [anon_sym_not] = ACTIONS(161),
    [anon_sym_and] = ACTIONS(161),
    [anon_sym_or] = ACTIONS(161),
    [anon_sym_xor] = ACTIONS(161),
    [anon_sym_andr] = ACTIONS(161),
    [anon_sym_orr] = ACTIONS(161),
    [anon_sym_xorr] = ACTIONS(161),
    [anon_sym_cat] = ACTIONS(161),
    [anon_sym_bits] = ACTIONS(161),
    [anon_sym_head] = ACTIONS(161),
    [anon_sym_tail] = ACTIONS(161),
    [anon_sym_asFixedPoint] = ACTIONS(161),
    [anon_sym_bpshl] = ACTIONS(161),
    [anon_sym_bpshr] = ACTIONS(161),
    [anon_sym_bpset] = ACTIONS(161),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(163),
  },
  [24] = {
    [sym_identifier] = ACTIONS(165),
    [anon_sym_UInt] = ACTIONS(165),
    [anon_sym_SInt] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_wire] = ACTIONS(165),
    [anon_sym_cmem] = ACTIONS(165),
    [anon_sym_smem] = ACTIONS(165),
    [anon_sym_reg] = ACTIONS(165),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_mem] = ACTIONS(165),
    [anon_sym_inst] = ACTIONS(165),
    [anon_sym_node] = ACTIONS(165),
    [anon_sym_when] = ACTIONS(165),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_stop] = ACTIONS(165),
    [anon_sym_printf] = ACTIONS(165),
    [anon_sym_assert] = ACTIONS(165),
    [anon_sym_assume] = ACTIONS(165),
    [anon_sym_cover] = ACTIONS(165),
    [anon_sym_skip] = ACTIONS(165),
    [anon_sym_attach] = ACTIONS(165),
    [sym_info] = ACTIONS(167),
    [anon_sym_infer] = ACTIONS(165),
    [anon_sym_read] = ACTIONS(165),
    [anon_sym_write] = ACTIONS(165),
    [anon_sym_rdwr] = ACTIONS(165),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_mux] = ACTIONS(165),
    [anon_sym_validif] = ACTIONS(165),
    [anon_sym_add] = ACTIONS(165),
    [anon_sym_sub] = ACTIONS(165),
    [anon_sym_mul] = ACTIONS(165),
    [anon_sym_div] = ACTIONS(165),
    [anon_sym_rem] = ACTIONS(165),
    [anon_sym_lt] = ACTIONS(165),
    [anon_sym_leq] = ACTIONS(165),
    [anon_sym_gt] = ACTIONS(165),
    [anon_sym_geq] = ACTIONS(165),
    [anon_sym_eq] = ACTIONS(165),
    [anon_sym_neq] = ACTIONS(165),
    [anon_sym_pad] = ACTIONS(165),
    [anon_sym_asUInt] = ACTIONS(165),
    [anon_sym_asAsyncReset] = ACTIONS(165),
    [anon_sym_asSInt] = ACTIONS(165),
    [anon_sym_asClock] = ACTIONS(165),
    [anon_sym_shl] = ACTIONS(165),
    [anon_sym_shr] = ACTIONS(165),
    [anon_sym_dshl] = ACTIONS(165),
    [anon_sym_dshlw] = ACTIONS(165),
    [anon_sym_dshr] = ACTIONS(165),
    [anon_sym_dshrw] = ACTIONS(165),
    [anon_sym_cvt] = ACTIONS(165),
    [anon_sym_neg] = ACTIONS(165),
    [anon_sym_not] = ACTIONS(165),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_andr] = ACTIONS(165),
    [anon_sym_orr] = ACTIONS(165),
    [anon_sym_xorr] = ACTIONS(165),
    [anon_sym_cat] = ACTIONS(165),
    [anon_sym_bits] = ACTIONS(165),
    [anon_sym_head] = ACTIONS(165),
    [anon_sym_tail] = ACTIONS(165),
    [anon_sym_asFixedPoint] = ACTIONS(165),
    [anon_sym_bpshl] = ACTIONS(165),
    [anon_sym_bpshr] = ACTIONS(165),
    [anon_sym_bpset] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(167),
  },
  [25] = {
    [sym_identifier] = ACTIONS(169),
    [anon_sym_UInt] = ACTIONS(169),
    [anon_sym_SInt] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(171),
    [anon_sym_wire] = ACTIONS(169),
    [anon_sym_cmem] = ACTIONS(169),
    [anon_sym_smem] = ACTIONS(169),
    [anon_sym_reg] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(169),
    [anon_sym_mem] = ACTIONS(169),
    [anon_sym_inst] = ACTIONS(169),
    [anon_sym_node] = ACTIONS(169),
    [anon_sym_when] = ACTIONS(169),
    [anon_sym_else] = ACTIONS(169),
    [anon_sym_stop] = ACTIONS(169),
    [anon_sym_printf] = ACTIONS(169),
    [anon_sym_assert] = ACTIONS(169),
    [anon_sym_assume] = ACTIONS(169),
    [anon_sym_cover] = ACTIONS(169),
    [anon_sym_skip] = ACTIONS(169),
    [anon_sym_attach] = ACTIONS(169),
    [sym_info] = ACTIONS(171),
    [anon_sym_infer] = ACTIONS(169),
    [anon_sym_read] = ACTIONS(169),
    [anon_sym_write] = ACTIONS(169),
    [anon_sym_rdwr] = ACTIONS(169),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_mux] = ACTIONS(169),
    [anon_sym_validif] = ACTIONS(169),
    [anon_sym_add] = ACTIONS(169),
    [anon_sym_sub] = ACTIONS(169),
    [anon_sym_mul] = ACTIONS(169),
    [anon_sym_div] = ACTIONS(169),
    [anon_sym_rem] = ACTIONS(169),
    [anon_sym_lt] = ACTIONS(169),
    [anon_sym_leq] = ACTIONS(169),
    [anon_sym_gt] = ACTIONS(169),
    [anon_sym_geq] = ACTIONS(169),
    [anon_sym_eq] = ACTIONS(169),
    [anon_sym_neq] = ACTIONS(169),
    [anon_sym_pad] = ACTIONS(169),
    [anon_sym_asUInt] = ACTIONS(169),
    [anon_sym_asAsyncReset] = ACTIONS(169),
    [anon_sym_asSInt] = ACTIONS(169),
    [anon_sym_asClock] = ACTIONS(169),
    [anon_sym_shl] = ACTIONS(169),
    [anon_sym_shr] = ACTIONS(169),
    [anon_sym_dshl] = ACTIONS(169),
    [anon_sym_dshlw] = ACTIONS(169),
    [anon_sym_dshr] = ACTIONS(169),
    [anon_sym_dshrw] = ACTIONS(169),
    [anon_sym_cvt] = ACTIONS(169),
    [anon_sym_neg] = ACTIONS(169),
    [anon_sym_not] = ACTIONS(169),
    [anon_sym_and] = ACTIONS(169),
    [anon_sym_or] = ACTIONS(169),
    [anon_sym_xor] = ACTIONS(169),
    [anon_sym_andr] = ACTIONS(169),
    [anon_sym_orr] = ACTIONS(169),
    [anon_sym_xorr] = ACTIONS(169),
    [anon_sym_cat] = ACTIONS(169),
    [anon_sym_bits] = ACTIONS(169),
    [anon_sym_head] = ACTIONS(169),
    [anon_sym_tail] = ACTIONS(169),
    [anon_sym_asFixedPoint] = ACTIONS(169),
    [anon_sym_bpshl] = ACTIONS(169),
    [anon_sym_bpshr] = ACTIONS(169),
    [anon_sym_bpset] = ACTIONS(169),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(171),
  },
  [26] = {
    [sym_identifier] = ACTIONS(173),
    [anon_sym_UInt] = ACTIONS(173),
    [anon_sym_SInt] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_wire] = ACTIONS(173),
    [anon_sym_cmem] = ACTIONS(173),
    [anon_sym_smem] = ACTIONS(173),
    [anon_sym_reg] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(173),
    [anon_sym_mem] = ACTIONS(173),
    [anon_sym_inst] = ACTIONS(173),
    [anon_sym_node] = ACTIONS(173),
    [anon_sym_when] = ACTIONS(173),
    [anon_sym_else] = ACTIONS(173),
    [anon_sym_stop] = ACTIONS(173),
    [anon_sym_printf] = ACTIONS(173),
    [anon_sym_assert] = ACTIONS(173),
    [anon_sym_assume] = ACTIONS(173),
    [anon_sym_cover] = ACTIONS(173),
    [anon_sym_skip] = ACTIONS(173),
    [anon_sym_attach] = ACTIONS(173),
    [sym_info] = ACTIONS(175),
    [anon_sym_infer] = ACTIONS(173),
    [anon_sym_read] = ACTIONS(173),
    [anon_sym_write] = ACTIONS(173),
    [anon_sym_rdwr] = ACTIONS(173),
    [anon_sym_DOT] = ACTIONS(175),
    [anon_sym_mux] = ACTIONS(173),
    [anon_sym_validif] = ACTIONS(173),
    [anon_sym_add] = ACTIONS(173),
    [anon_sym_sub] = ACTIONS(173),
    [anon_sym_mul] = ACTIONS(173),
    [anon_sym_div] = ACTIONS(173),
    [anon_sym_rem] = ACTIONS(173),
    [anon_sym_lt] = ACTIONS(173),
    [anon_sym_leq] = ACTIONS(173),
    [anon_sym_gt] = ACTIONS(173),
    [anon_sym_geq] = ACTIONS(173),
    [anon_sym_eq] = ACTIONS(173),
    [anon_sym_neq] = ACTIONS(173),
    [anon_sym_pad] = ACTIONS(173),
    [anon_sym_asUInt] = ACTIONS(173),
    [anon_sym_asAsyncReset] = ACTIONS(173),
    [anon_sym_asSInt] = ACTIONS(173),
    [anon_sym_asClock] = ACTIONS(173),
    [anon_sym_shl] = ACTIONS(173),
    [anon_sym_shr] = ACTIONS(173),
    [anon_sym_dshl] = ACTIONS(173),
    [anon_sym_dshlw] = ACTIONS(173),
    [anon_sym_dshr] = ACTIONS(173),
    [anon_sym_dshrw] = ACTIONS(173),
    [anon_sym_cvt] = ACTIONS(173),
    [anon_sym_neg] = ACTIONS(173),
    [anon_sym_not] = ACTIONS(173),
    [anon_sym_and] = ACTIONS(173),
    [anon_sym_or] = ACTIONS(173),
    [anon_sym_xor] = ACTIONS(173),
    [anon_sym_andr] = ACTIONS(173),
    [anon_sym_orr] = ACTIONS(173),
    [anon_sym_xorr] = ACTIONS(173),
    [anon_sym_cat] = ACTIONS(173),
    [anon_sym_bits] = ACTIONS(173),
    [anon_sym_head] = ACTIONS(173),
    [anon_sym_tail] = ACTIONS(173),
    [anon_sym_asFixedPoint] = ACTIONS(173),
    [anon_sym_bpshl] = ACTIONS(173),
    [anon_sym_bpshr] = ACTIONS(173),
    [anon_sym_bpset] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(175),
  },
  [27] = {
    [sym_identifier] = ACTIONS(177),
    [anon_sym_UInt] = ACTIONS(177),
    [anon_sym_SInt] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(179),
    [anon_sym_wire] = ACTIONS(177),
    [anon_sym_cmem] = ACTIONS(177),
    [anon_sym_smem] = ACTIONS(177),
    [anon_sym_reg] = ACTIONS(177),
    [anon_sym_with] = ACTIONS(177),
    [anon_sym_mem] = ACTIONS(177),
    [anon_sym_inst] = ACTIONS(177),
    [anon_sym_node] = ACTIONS(177),
    [anon_sym_when] = ACTIONS(177),
    [anon_sym_else] = ACTIONS(177),
    [anon_sym_stop] = ACTIONS(177),
    [anon_sym_printf] = ACTIONS(177),
    [anon_sym_assert] = ACTIONS(177),
    [anon_sym_assume] = ACTIONS(177),
    [anon_sym_cover] = ACTIONS(177),
    [anon_sym_skip] = ACTIONS(177),
    [anon_sym_attach] = ACTIONS(177),
    [sym_info] = ACTIONS(179),
    [anon_sym_infer] = ACTIONS(177),
    [anon_sym_read] = ACTIONS(177),
    [anon_sym_write] = ACTIONS(177),
    [anon_sym_rdwr] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_mux] = ACTIONS(177),
    [anon_sym_validif] = ACTIONS(177),
    [anon_sym_add] = ACTIONS(177),
    [anon_sym_sub] = ACTIONS(177),
    [anon_sym_mul] = ACTIONS(177),
    [anon_sym_div] = ACTIONS(177),
    [anon_sym_rem] = ACTIONS(177),
    [anon_sym_lt] = ACTIONS(177),
    [anon_sym_leq] = ACTIONS(177),
    [anon_sym_gt] = ACTIONS(177),
    [anon_sym_geq] = ACTIONS(177),
    [anon_sym_eq] = ACTIONS(177),
    [anon_sym_neq] = ACTIONS(177),
    [anon_sym_pad] = ACTIONS(177),
    [anon_sym_asUInt] = ACTIONS(177),
    [anon_sym_asAsyncReset] = ACTIONS(177),
    [anon_sym_asSInt] = ACTIONS(177),
    [anon_sym_asClock] = ACTIONS(177),
    [anon_sym_shl] = ACTIONS(177),
    [anon_sym_shr] = ACTIONS(177),
    [anon_sym_dshl] = ACTIONS(177),
    [anon_sym_dshlw] = ACTIONS(177),
    [anon_sym_dshr] = ACTIONS(177),
    [anon_sym_dshrw] = ACTIONS(177),
    [anon_sym_cvt] = ACTIONS(177),
    [anon_sym_neg] = ACTIONS(177),
    [anon_sym_not] = ACTIONS(177),
    [anon_sym_and] = ACTIONS(177),
    [anon_sym_or] = ACTIONS(177),
    [anon_sym_xor] = ACTIONS(177),
    [anon_sym_andr] = ACTIONS(177),
    [anon_sym_orr] = ACTIONS(177),
    [anon_sym_xorr] = ACTIONS(177),
    [anon_sym_cat] = ACTIONS(177),
    [anon_sym_bits] = ACTIONS(177),
    [anon_sym_head] = ACTIONS(177),
    [anon_sym_tail] = ACTIONS(177),
    [anon_sym_asFixedPoint] = ACTIONS(177),
    [anon_sym_bpshl] = ACTIONS(177),
    [anon_sym_bpshr] = ACTIONS(177),
    [anon_sym_bpset] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(179),
  },
  [28] = {
    [sym_identifier] = ACTIONS(181),
    [anon_sym_UInt] = ACTIONS(181),
    [anon_sym_SInt] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_wire] = ACTIONS(181),
    [anon_sym_cmem] = ACTIONS(181),
    [anon_sym_smem] = ACTIONS(181),
    [anon_sym_reg] = ACTIONS(181),
    [anon_sym_with] = ACTIONS(185),
    [anon_sym_mem] = ACTIONS(181),
    [anon_sym_inst] = ACTIONS(181),
    [anon_sym_node] = ACTIONS(181),
    [anon_sym_when] = ACTIONS(181),
    [anon_sym_else] = ACTIONS(181),
    [anon_sym_stop] = ACTIONS(181),
    [anon_sym_printf] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_assume] = ACTIONS(181),
    [anon_sym_cover] = ACTIONS(181),
    [anon_sym_skip] = ACTIONS(181),
    [anon_sym_attach] = ACTIONS(181),
    [sym_info] = ACTIONS(187),
    [anon_sym_infer] = ACTIONS(181),
    [anon_sym_read] = ACTIONS(181),
    [anon_sym_write] = ACTIONS(181),
    [anon_sym_rdwr] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(189),
    [anon_sym_mux] = ACTIONS(181),
    [anon_sym_validif] = ACTIONS(181),
    [anon_sym_add] = ACTIONS(181),
    [anon_sym_sub] = ACTIONS(181),
    [anon_sym_mul] = ACTIONS(181),
    [anon_sym_div] = ACTIONS(181),
    [anon_sym_rem] = ACTIONS(181),
    [anon_sym_lt] = ACTIONS(181),
    [anon_sym_leq] = ACTIONS(181),
    [anon_sym_gt] = ACTIONS(181),
    [anon_sym_geq] = ACTIONS(181),
    [anon_sym_eq] = ACTIONS(181),
    [anon_sym_neq] = ACTIONS(181),
    [anon_sym_pad] = ACTIONS(181),
    [anon_sym_asUInt] = ACTIONS(181),
    [anon_sym_asAsyncReset] = ACTIONS(181),
    [anon_sym_asSInt] = ACTIONS(181),
    [anon_sym_asClock] = ACTIONS(181),
    [anon_sym_shl] = ACTIONS(181),
    [anon_sym_shr] = ACTIONS(181),
    [anon_sym_dshl] = ACTIONS(181),
    [anon_sym_dshlw] = ACTIONS(181),
    [anon_sym_dshr] = ACTIONS(181),
    [anon_sym_dshrw] = ACTIONS(181),
    [anon_sym_cvt] = ACTIONS(181),
    [anon_sym_neg] = ACTIONS(181),
    [anon_sym_not] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_xor] = ACTIONS(181),
    [anon_sym_andr] = ACTIONS(181),
    [anon_sym_orr] = ACTIONS(181),
    [anon_sym_xorr] = ACTIONS(181),
    [anon_sym_cat] = ACTIONS(181),
    [anon_sym_bits] = ACTIONS(181),
    [anon_sym_head] = ACTIONS(181),
    [anon_sym_tail] = ACTIONS(181),
    [anon_sym_asFixedPoint] = ACTIONS(181),
    [anon_sym_bpshl] = ACTIONS(181),
    [anon_sym_bpshr] = ACTIONS(181),
    [anon_sym_bpset] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(191),
  },
  [29] = {
    [sym_identifier] = ACTIONS(193),
    [anon_sym_UInt] = ACTIONS(193),
    [anon_sym_SInt] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_wire] = ACTIONS(193),
    [anon_sym_cmem] = ACTIONS(193),
    [anon_sym_smem] = ACTIONS(193),
    [anon_sym_reg] = ACTIONS(193),
    [anon_sym_with] = ACTIONS(193),
    [anon_sym_mem] = ACTIONS(193),
    [anon_sym_inst] = ACTIONS(193),
    [anon_sym_node] = ACTIONS(193),
    [anon_sym_when] = ACTIONS(193),
    [anon_sym_else] = ACTIONS(193),
    [anon_sym_stop] = ACTIONS(193),
    [anon_sym_printf] = ACTIONS(193),
    [anon_sym_assert] = ACTIONS(193),
    [anon_sym_assume] = ACTIONS(193),
    [anon_sym_cover] = ACTIONS(193),
    [anon_sym_skip] = ACTIONS(193),
    [anon_sym_attach] = ACTIONS(193),
    [sym_info] = ACTIONS(195),
    [anon_sym_infer] = ACTIONS(193),
    [anon_sym_read] = ACTIONS(193),
    [anon_sym_write] = ACTIONS(193),
    [anon_sym_rdwr] = ACTIONS(193),
    [anon_sym_DOT] = ACTIONS(195),
    [anon_sym_mux] = ACTIONS(193),
    [anon_sym_validif] = ACTIONS(193),
    [anon_sym_add] = ACTIONS(193),
    [anon_sym_sub] = ACTIONS(193),
    [anon_sym_mul] = ACTIONS(193),
    [anon_sym_div] = ACTIONS(193),
    [anon_sym_rem] = ACTIONS(193),
    [anon_sym_lt] = ACTIONS(193),
    [anon_sym_leq] = ACTIONS(193),
    [anon_sym_gt] = ACTIONS(193),
    [anon_sym_geq] = ACTIONS(193),
    [anon_sym_eq] = ACTIONS(193),
    [anon_sym_neq] = ACTIONS(193),
    [anon_sym_pad] = ACTIONS(193),
    [anon_sym_asUInt] = ACTIONS(193),
    [anon_sym_asAsyncReset] = ACTIONS(193),
    [anon_sym_asSInt] = ACTIONS(193),
    [anon_sym_asClock] = ACTIONS(193),
    [anon_sym_shl] = ACTIONS(193),
    [anon_sym_shr] = ACTIONS(193),
    [anon_sym_dshl] = ACTIONS(193),
    [anon_sym_dshlw] = ACTIONS(193),
    [anon_sym_dshr] = ACTIONS(193),
    [anon_sym_dshrw] = ACTIONS(193),
    [anon_sym_cvt] = ACTIONS(193),
    [anon_sym_neg] = ACTIONS(193),
    [anon_sym_not] = ACTIONS(193),
    [anon_sym_and] = ACTIONS(193),
    [anon_sym_or] = ACTIONS(193),
    [anon_sym_xor] = ACTIONS(193),
    [anon_sym_andr] = ACTIONS(193),
    [anon_sym_orr] = ACTIONS(193),
    [anon_sym_xorr] = ACTIONS(193),
    [anon_sym_cat] = ACTIONS(193),
    [anon_sym_bits] = ACTIONS(193),
    [anon_sym_head] = ACTIONS(193),
    [anon_sym_tail] = ACTIONS(193),
    [anon_sym_asFixedPoint] = ACTIONS(193),
    [anon_sym_bpshl] = ACTIONS(193),
    [anon_sym_bpshr] = ACTIONS(193),
    [anon_sym_bpset] = ACTIONS(193),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(195),
  },
  [30] = {
    [sym_identifier] = ACTIONS(197),
    [anon_sym_UInt] = ACTIONS(197),
    [anon_sym_SInt] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(199),
    [anon_sym_wire] = ACTIONS(197),
    [anon_sym_cmem] = ACTIONS(197),
    [anon_sym_smem] = ACTIONS(197),
    [anon_sym_reg] = ACTIONS(197),
    [anon_sym_with] = ACTIONS(197),
    [anon_sym_mem] = ACTIONS(197),
    [anon_sym_inst] = ACTIONS(197),
    [anon_sym_node] = ACTIONS(197),
    [anon_sym_when] = ACTIONS(197),
    [anon_sym_else] = ACTIONS(197),
    [anon_sym_stop] = ACTIONS(197),
    [anon_sym_printf] = ACTIONS(197),
    [anon_sym_assert] = ACTIONS(197),
    [anon_sym_assume] = ACTIONS(197),
    [anon_sym_cover] = ACTIONS(197),
    [anon_sym_skip] = ACTIONS(197),
    [anon_sym_attach] = ACTIONS(197),
    [sym_info] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(197),
    [anon_sym_read] = ACTIONS(197),
    [anon_sym_write] = ACTIONS(197),
    [anon_sym_rdwr] = ACTIONS(197),
    [anon_sym_DOT] = ACTIONS(199),
    [anon_sym_mux] = ACTIONS(197),
    [anon_sym_validif] = ACTIONS(197),
    [anon_sym_add] = ACTIONS(197),
    [anon_sym_sub] = ACTIONS(197),
    [anon_sym_mul] = ACTIONS(197),
    [anon_sym_div] = ACTIONS(197),
    [anon_sym_rem] = ACTIONS(197),
    [anon_sym_lt] = ACTIONS(197),
    [anon_sym_leq] = ACTIONS(197),
    [anon_sym_gt] = ACTIONS(197),
    [anon_sym_geq] = ACTIONS(197),
    [anon_sym_eq] = ACTIONS(197),
    [anon_sym_neq] = ACTIONS(197),
    [anon_sym_pad] = ACTIONS(197),
    [anon_sym_asUInt] = ACTIONS(197),
    [anon_sym_asAsyncReset] = ACTIONS(197),
    [anon_sym_asSInt] = ACTIONS(197),
    [anon_sym_asClock] = ACTIONS(197),
    [anon_sym_shl] = ACTIONS(197),
    [anon_sym_shr] = ACTIONS(197),
    [anon_sym_dshl] = ACTIONS(197),
    [anon_sym_dshlw] = ACTIONS(197),
    [anon_sym_dshr] = ACTIONS(197),
    [anon_sym_dshrw] = ACTIONS(197),
    [anon_sym_cvt] = ACTIONS(197),
    [anon_sym_neg] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_and] = ACTIONS(197),
    [anon_sym_or] = ACTIONS(197),
    [anon_sym_xor] = ACTIONS(197),
    [anon_sym_andr] = ACTIONS(197),
    [anon_sym_orr] = ACTIONS(197),
    [anon_sym_xorr] = ACTIONS(197),
    [anon_sym_cat] = ACTIONS(197),
    [anon_sym_bits] = ACTIONS(197),
    [anon_sym_head] = ACTIONS(197),
    [anon_sym_tail] = ACTIONS(197),
    [anon_sym_asFixedPoint] = ACTIONS(197),
    [anon_sym_bpshl] = ACTIONS(197),
    [anon_sym_bpshr] = ACTIONS(197),
    [anon_sym_bpset] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(199),
  },
  [31] = {
    [sym_identifier] = ACTIONS(201),
    [anon_sym_UInt] = ACTIONS(201),
    [anon_sym_SInt] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(203),
    [anon_sym_wire] = ACTIONS(201),
    [anon_sym_cmem] = ACTIONS(201),
    [anon_sym_smem] = ACTIONS(201),
    [anon_sym_reg] = ACTIONS(201),
    [anon_sym_with] = ACTIONS(201),
    [anon_sym_mem] = ACTIONS(201),
    [anon_sym_inst] = ACTIONS(201),
    [anon_sym_node] = ACTIONS(201),
    [anon_sym_when] = ACTIONS(201),
    [anon_sym_else] = ACTIONS(201),
    [anon_sym_stop] = ACTIONS(201),
    [anon_sym_printf] = ACTIONS(201),
    [anon_sym_assert] = ACTIONS(201),
    [anon_sym_assume] = ACTIONS(201),
    [anon_sym_cover] = ACTIONS(201),
    [anon_sym_skip] = ACTIONS(201),
    [anon_sym_attach] = ACTIONS(201),
    [sym_info] = ACTIONS(203),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_read] = ACTIONS(201),
    [anon_sym_write] = ACTIONS(201),
    [anon_sym_rdwr] = ACTIONS(201),
    [anon_sym_DOT] = ACTIONS(203),
    [anon_sym_mux] = ACTIONS(201),
    [anon_sym_validif] = ACTIONS(201),
    [anon_sym_add] = ACTIONS(201),
    [anon_sym_sub] = ACTIONS(201),
    [anon_sym_mul] = ACTIONS(201),
    [anon_sym_div] = ACTIONS(201),
    [anon_sym_rem] = ACTIONS(201),
    [anon_sym_lt] = ACTIONS(201),
    [anon_sym_leq] = ACTIONS(201),
    [anon_sym_gt] = ACTIONS(201),
    [anon_sym_geq] = ACTIONS(201),
    [anon_sym_eq] = ACTIONS(201),
    [anon_sym_neq] = ACTIONS(201),
    [anon_sym_pad] = ACTIONS(201),
    [anon_sym_asUInt] = ACTIONS(201),
    [anon_sym_asAsyncReset] = ACTIONS(201),
    [anon_sym_asSInt] = ACTIONS(201),
    [anon_sym_asClock] = ACTIONS(201),
    [anon_sym_shl] = ACTIONS(201),
    [anon_sym_shr] = ACTIONS(201),
    [anon_sym_dshl] = ACTIONS(201),
    [anon_sym_dshlw] = ACTIONS(201),
    [anon_sym_dshr] = ACTIONS(201),
    [anon_sym_dshrw] = ACTIONS(201),
    [anon_sym_cvt] = ACTIONS(201),
    [anon_sym_neg] = ACTIONS(201),
    [anon_sym_not] = ACTIONS(201),
    [anon_sym_and] = ACTIONS(201),
    [anon_sym_or] = ACTIONS(201),
    [anon_sym_xor] = ACTIONS(201),
    [anon_sym_andr] = ACTIONS(201),
    [anon_sym_orr] = ACTIONS(201),
    [anon_sym_xorr] = ACTIONS(201),
    [anon_sym_cat] = ACTIONS(201),
    [anon_sym_bits] = ACTIONS(201),
    [anon_sym_head] = ACTIONS(201),
    [anon_sym_tail] = ACTIONS(201),
    [anon_sym_asFixedPoint] = ACTIONS(201),
    [anon_sym_bpshl] = ACTIONS(201),
    [anon_sym_bpshr] = ACTIONS(201),
    [anon_sym_bpset] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(203),
  },
  [32] = {
    [sym_identifier] = ACTIONS(205),
    [anon_sym_UInt] = ACTIONS(205),
    [anon_sym_SInt] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_wire] = ACTIONS(205),
    [anon_sym_cmem] = ACTIONS(205),
    [anon_sym_smem] = ACTIONS(205),
    [anon_sym_reg] = ACTIONS(205),
    [anon_sym_mem] = ACTIONS(205),
    [anon_sym_inst] = ACTIONS(205),
    [anon_sym_node] = ACTIONS(205),
    [anon_sym_when] = ACTIONS(205),
    [anon_sym_else] = ACTIONS(205),
    [anon_sym_stop] = ACTIONS(205),
    [anon_sym_printf] = ACTIONS(205),
    [anon_sym_assert] = ACTIONS(205),
    [anon_sym_assume] = ACTIONS(205),
    [anon_sym_cover] = ACTIONS(205),
    [anon_sym_skip] = ACTIONS(205),
    [anon_sym_attach] = ACTIONS(205),
    [sym_info] = ACTIONS(207),
    [anon_sym_infer] = ACTIONS(205),
    [anon_sym_read] = ACTIONS(205),
    [anon_sym_write] = ACTIONS(205),
    [anon_sym_rdwr] = ACTIONS(205),
    [anon_sym_DOT] = ACTIONS(189),
    [anon_sym_mux] = ACTIONS(205),
    [anon_sym_validif] = ACTIONS(205),
    [anon_sym_add] = ACTIONS(205),
    [anon_sym_sub] = ACTIONS(205),
    [anon_sym_mul] = ACTIONS(205),
    [anon_sym_div] = ACTIONS(205),
    [anon_sym_rem] = ACTIONS(205),
    [anon_sym_lt] = ACTIONS(205),
    [anon_sym_leq] = ACTIONS(205),
    [anon_sym_gt] = ACTIONS(205),
    [anon_sym_geq] = ACTIONS(205),
    [anon_sym_eq] = ACTIONS(205),
    [anon_sym_neq] = ACTIONS(205),
    [anon_sym_pad] = ACTIONS(205),
    [anon_sym_asUInt] = ACTIONS(205),
    [anon_sym_asAsyncReset] = ACTIONS(205),
    [anon_sym_asSInt] = ACTIONS(205),
    [anon_sym_asClock] = ACTIONS(205),
    [anon_sym_shl] = ACTIONS(205),
    [anon_sym_shr] = ACTIONS(205),
    [anon_sym_dshl] = ACTIONS(205),
    [anon_sym_dshlw] = ACTIONS(205),
    [anon_sym_dshr] = ACTIONS(205),
    [anon_sym_dshrw] = ACTIONS(205),
    [anon_sym_cvt] = ACTIONS(205),
    [anon_sym_neg] = ACTIONS(205),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_and] = ACTIONS(205),
    [anon_sym_or] = ACTIONS(205),
    [anon_sym_xor] = ACTIONS(205),
    [anon_sym_andr] = ACTIONS(205),
    [anon_sym_orr] = ACTIONS(205),
    [anon_sym_xorr] = ACTIONS(205),
    [anon_sym_cat] = ACTIONS(205),
    [anon_sym_bits] = ACTIONS(205),
    [anon_sym_head] = ACTIONS(205),
    [anon_sym_tail] = ACTIONS(205),
    [anon_sym_asFixedPoint] = ACTIONS(205),
    [anon_sym_bpshl] = ACTIONS(205),
    [anon_sym_bpshr] = ACTIONS(205),
    [anon_sym_bpset] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(209),
  },
  [33] = {
    [sym_identifier] = ACTIONS(211),
    [anon_sym_input] = ACTIONS(211),
    [anon_sym_output] = ACTIONS(211),
    [anon_sym_UInt] = ACTIONS(211),
    [anon_sym_SInt] = ACTIONS(211),
    [anon_sym_defname] = ACTIONS(211),
    [anon_sym_parameter] = ACTIONS(211),
    [anon_sym_wire] = ACTIONS(211),
    [anon_sym_cmem] = ACTIONS(211),
    [anon_sym_smem] = ACTIONS(211),
    [anon_sym_reg] = ACTIONS(211),
    [anon_sym_mem] = ACTIONS(211),
    [anon_sym_inst] = ACTIONS(211),
    [anon_sym_node] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(211),
    [anon_sym_stop] = ACTIONS(211),
    [anon_sym_printf] = ACTIONS(211),
    [anon_sym_assert] = ACTIONS(211),
    [anon_sym_assume] = ACTIONS(211),
    [anon_sym_cover] = ACTIONS(211),
    [anon_sym_skip] = ACTIONS(211),
    [anon_sym_attach] = ACTIONS(211),
    [anon_sym_infer] = ACTIONS(211),
    [anon_sym_read] = ACTIONS(211),
    [anon_sym_write] = ACTIONS(211),
    [anon_sym_rdwr] = ACTIONS(211),
    [anon_sym_mux] = ACTIONS(211),
    [anon_sym_validif] = ACTIONS(211),
    [anon_sym_add] = ACTIONS(211),
    [anon_sym_sub] = ACTIONS(211),
    [anon_sym_mul] = ACTIONS(211),
    [anon_sym_div] = ACTIONS(211),
    [anon_sym_rem] = ACTIONS(211),
    [anon_sym_lt] = ACTIONS(211),
    [anon_sym_leq] = ACTIONS(211),
    [anon_sym_gt] = ACTIONS(211),
    [anon_sym_geq] = ACTIONS(211),
    [anon_sym_eq] = ACTIONS(211),
    [anon_sym_neq] = ACTIONS(211),
    [anon_sym_pad] = ACTIONS(211),
    [anon_sym_asUInt] = ACTIONS(211),
    [anon_sym_asAsyncReset] = ACTIONS(211),
    [anon_sym_asSInt] = ACTIONS(211),
    [anon_sym_asClock] = ACTIONS(211),
    [anon_sym_shl] = ACTIONS(211),
    [anon_sym_shr] = ACTIONS(211),
    [anon_sym_dshl] = ACTIONS(211),
    [anon_sym_dshlw] = ACTIONS(211),
    [anon_sym_dshr] = ACTIONS(211),
    [anon_sym_dshrw] = ACTIONS(211),
    [anon_sym_cvt] = ACTIONS(211),
    [anon_sym_neg] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(211),
    [anon_sym_and] = ACTIONS(211),
    [anon_sym_or] = ACTIONS(211),
    [anon_sym_xor] = ACTIONS(211),
    [anon_sym_andr] = ACTIONS(211),
    [anon_sym_orr] = ACTIONS(211),
    [anon_sym_xorr] = ACTIONS(211),
    [anon_sym_cat] = ACTIONS(211),
    [anon_sym_bits] = ACTIONS(211),
    [anon_sym_head] = ACTIONS(211),
    [anon_sym_tail] = ACTIONS(211),
    [anon_sym_asFixedPoint] = ACTIONS(211),
    [anon_sym_bpshl] = ACTIONS(211),
    [anon_sym_bpshr] = ACTIONS(211),
    [anon_sym_bpset] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(213),
  },
  [34] = {
    [sym_identifier] = ACTIONS(215),
    [anon_sym_UInt] = ACTIONS(215),
    [anon_sym_SInt] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(217),
    [anon_sym_LBRACK] = ACTIONS(219),
    [anon_sym_wire] = ACTIONS(215),
    [anon_sym_cmem] = ACTIONS(215),
    [anon_sym_smem] = ACTIONS(215),
    [anon_sym_reg] = ACTIONS(215),
    [anon_sym_mem] = ACTIONS(215),
    [anon_sym_inst] = ACTIONS(215),
    [anon_sym_node] = ACTIONS(215),
    [anon_sym_when] = ACTIONS(215),
    [anon_sym_else] = ACTIONS(215),
    [anon_sym_stop] = ACTIONS(215),
    [anon_sym_printf] = ACTIONS(215),
    [anon_sym_assert] = ACTIONS(215),
    [anon_sym_assume] = ACTIONS(215),
    [anon_sym_cover] = ACTIONS(215),
    [anon_sym_skip] = ACTIONS(215),
    [anon_sym_attach] = ACTIONS(215),
    [sym_info] = ACTIONS(219),
    [anon_sym_infer] = ACTIONS(215),
    [anon_sym_read] = ACTIONS(215),
    [anon_sym_write] = ACTIONS(215),
    [anon_sym_rdwr] = ACTIONS(215),
    [anon_sym_mux] = ACTIONS(215),
    [anon_sym_validif] = ACTIONS(215),
    [anon_sym_add] = ACTIONS(215),
    [anon_sym_sub] = ACTIONS(215),
    [anon_sym_mul] = ACTIONS(215),
    [anon_sym_div] = ACTIONS(215),
    [anon_sym_rem] = ACTIONS(215),
    [anon_sym_lt] = ACTIONS(215),
    [anon_sym_leq] = ACTIONS(215),
    [anon_sym_gt] = ACTIONS(215),
    [anon_sym_geq] = ACTIONS(215),
    [anon_sym_eq] = ACTIONS(215),
    [anon_sym_neq] = ACTIONS(215),
    [anon_sym_pad] = ACTIONS(215),
    [anon_sym_asUInt] = ACTIONS(215),
    [anon_sym_asAsyncReset] = ACTIONS(215),
    [anon_sym_asSInt] = ACTIONS(215),
    [anon_sym_asClock] = ACTIONS(215),
    [anon_sym_shl] = ACTIONS(215),
    [anon_sym_shr] = ACTIONS(215),
    [anon_sym_dshl] = ACTIONS(215),
    [anon_sym_dshlw] = ACTIONS(215),
    [anon_sym_dshr] = ACTIONS(215),
    [anon_sym_dshrw] = ACTIONS(215),
    [anon_sym_cvt] = ACTIONS(215),
    [anon_sym_neg] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_and] = ACTIONS(215),
    [anon_sym_or] = ACTIONS(215),
    [anon_sym_xor] = ACTIONS(215),
    [anon_sym_andr] = ACTIONS(215),
    [anon_sym_orr] = ACTIONS(215),
    [anon_sym_xorr] = ACTIONS(215),
    [anon_sym_cat] = ACTIONS(215),
    [anon_sym_bits] = ACTIONS(215),
    [anon_sym_head] = ACTIONS(215),
    [anon_sym_tail] = ACTIONS(215),
    [anon_sym_asFixedPoint] = ACTIONS(215),
    [anon_sym_bpshl] = ACTIONS(215),
    [anon_sym_bpshr] = ACTIONS(215),
    [anon_sym_bpset] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(219),
  },
  [35] = {
    [sym_identifier] = ACTIONS(221),
    [anon_sym_UInt] = ACTIONS(221),
    [anon_sym_SInt] = ACTIONS(221),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_wire] = ACTIONS(221),
    [anon_sym_cmem] = ACTIONS(221),
    [anon_sym_smem] = ACTIONS(221),
    [anon_sym_reg] = ACTIONS(221),
    [anon_sym_mem] = ACTIONS(221),
    [anon_sym_inst] = ACTIONS(221),
    [anon_sym_node] = ACTIONS(221),
    [anon_sym_when] = ACTIONS(221),
    [anon_sym_else] = ACTIONS(221),
    [anon_sym_stop] = ACTIONS(221),
    [anon_sym_printf] = ACTIONS(221),
    [anon_sym_assert] = ACTIONS(221),
    [anon_sym_assume] = ACTIONS(221),
    [anon_sym_cover] = ACTIONS(221),
    [anon_sym_skip] = ACTIONS(221),
    [anon_sym_attach] = ACTIONS(221),
    [sym_info] = ACTIONS(223),
    [anon_sym_infer] = ACTIONS(221),
    [anon_sym_read] = ACTIONS(221),
    [anon_sym_write] = ACTIONS(221),
    [anon_sym_rdwr] = ACTIONS(221),
    [anon_sym_DOT] = ACTIONS(189),
    [anon_sym_mux] = ACTIONS(221),
    [anon_sym_validif] = ACTIONS(221),
    [anon_sym_add] = ACTIONS(221),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_mul] = ACTIONS(221),
    [anon_sym_div] = ACTIONS(221),
    [anon_sym_rem] = ACTIONS(221),
    [anon_sym_lt] = ACTIONS(221),
    [anon_sym_leq] = ACTIONS(221),
    [anon_sym_gt] = ACTIONS(221),
    [anon_sym_geq] = ACTIONS(221),
    [anon_sym_eq] = ACTIONS(221),
    [anon_sym_neq] = ACTIONS(221),
    [anon_sym_pad] = ACTIONS(221),
    [anon_sym_asUInt] = ACTIONS(221),
    [anon_sym_asAsyncReset] = ACTIONS(221),
    [anon_sym_asSInt] = ACTIONS(221),
    [anon_sym_asClock] = ACTIONS(221),
    [anon_sym_shl] = ACTIONS(221),
    [anon_sym_shr] = ACTIONS(221),
    [anon_sym_dshl] = ACTIONS(221),
    [anon_sym_dshlw] = ACTIONS(221),
    [anon_sym_dshr] = ACTIONS(221),
    [anon_sym_dshrw] = ACTIONS(221),
    [anon_sym_cvt] = ACTIONS(221),
    [anon_sym_neg] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(221),
    [anon_sym_and] = ACTIONS(221),
    [anon_sym_or] = ACTIONS(221),
    [anon_sym_xor] = ACTIONS(221),
    [anon_sym_andr] = ACTIONS(221),
    [anon_sym_orr] = ACTIONS(221),
    [anon_sym_xorr] = ACTIONS(221),
    [anon_sym_cat] = ACTIONS(221),
    [anon_sym_bits] = ACTIONS(221),
    [anon_sym_head] = ACTIONS(221),
    [anon_sym_tail] = ACTIONS(221),
    [anon_sym_asFixedPoint] = ACTIONS(221),
    [anon_sym_bpshl] = ACTIONS(221),
    [anon_sym_bpshr] = ACTIONS(221),
    [anon_sym_bpset] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(225),
  },
  [36] = {
    [sym_identifier] = ACTIONS(227),
    [anon_sym_input] = ACTIONS(227),
    [anon_sym_output] = ACTIONS(227),
    [anon_sym_UInt] = ACTIONS(227),
    [anon_sym_SInt] = ACTIONS(227),
    [anon_sym_defname] = ACTIONS(227),
    [anon_sym_parameter] = ACTIONS(227),
    [anon_sym_wire] = ACTIONS(227),
    [anon_sym_cmem] = ACTIONS(227),
    [anon_sym_smem] = ACTIONS(227),
    [anon_sym_reg] = ACTIONS(227),
    [anon_sym_mem] = ACTIONS(227),
    [anon_sym_inst] = ACTIONS(227),
    [anon_sym_node] = ACTIONS(227),
    [anon_sym_when] = ACTIONS(227),
    [anon_sym_stop] = ACTIONS(227),
    [anon_sym_printf] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_assume] = ACTIONS(227),
    [anon_sym_cover] = ACTIONS(227),
    [anon_sym_skip] = ACTIONS(227),
    [anon_sym_attach] = ACTIONS(227),
    [anon_sym_infer] = ACTIONS(227),
    [anon_sym_read] = ACTIONS(227),
    [anon_sym_write] = ACTIONS(227),
    [anon_sym_rdwr] = ACTIONS(227),
    [anon_sym_mux] = ACTIONS(227),
    [anon_sym_validif] = ACTIONS(227),
    [anon_sym_add] = ACTIONS(227),
    [anon_sym_sub] = ACTIONS(227),
    [anon_sym_mul] = ACTIONS(227),
    [anon_sym_div] = ACTIONS(227),
    [anon_sym_rem] = ACTIONS(227),
    [anon_sym_lt] = ACTIONS(227),
    [anon_sym_leq] = ACTIONS(227),
    [anon_sym_gt] = ACTIONS(227),
    [anon_sym_geq] = ACTIONS(227),
    [anon_sym_eq] = ACTIONS(227),
    [anon_sym_neq] = ACTIONS(227),
    [anon_sym_pad] = ACTIONS(227),
    [anon_sym_asUInt] = ACTIONS(227),
    [anon_sym_asAsyncReset] = ACTIONS(227),
    [anon_sym_asSInt] = ACTIONS(227),
    [anon_sym_asClock] = ACTIONS(227),
    [anon_sym_shl] = ACTIONS(227),
    [anon_sym_shr] = ACTIONS(227),
    [anon_sym_dshl] = ACTIONS(227),
    [anon_sym_dshlw] = ACTIONS(227),
    [anon_sym_dshr] = ACTIONS(227),
    [anon_sym_dshrw] = ACTIONS(227),
    [anon_sym_cvt] = ACTIONS(227),
    [anon_sym_neg] = ACTIONS(227),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_and] = ACTIONS(227),
    [anon_sym_or] = ACTIONS(227),
    [anon_sym_xor] = ACTIONS(227),
    [anon_sym_andr] = ACTIONS(227),
    [anon_sym_orr] = ACTIONS(227),
    [anon_sym_xorr] = ACTIONS(227),
    [anon_sym_cat] = ACTIONS(227),
    [anon_sym_bits] = ACTIONS(227),
    [anon_sym_head] = ACTIONS(227),
    [anon_sym_tail] = ACTIONS(227),
    [anon_sym_asFixedPoint] = ACTIONS(227),
    [anon_sym_bpshl] = ACTIONS(227),
    [anon_sym_bpshr] = ACTIONS(227),
    [anon_sym_bpset] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(229),
  },
  [37] = {
    [sym_identifier] = ACTIONS(231),
    [anon_sym_UInt] = ACTIONS(231),
    [anon_sym_SInt] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_wire] = ACTIONS(231),
    [anon_sym_cmem] = ACTIONS(231),
    [anon_sym_smem] = ACTIONS(231),
    [anon_sym_reg] = ACTIONS(231),
    [anon_sym_mem] = ACTIONS(231),
    [anon_sym_inst] = ACTIONS(231),
    [anon_sym_node] = ACTIONS(231),
    [anon_sym_when] = ACTIONS(231),
    [anon_sym_else] = ACTIONS(231),
    [anon_sym_stop] = ACTIONS(231),
    [anon_sym_printf] = ACTIONS(231),
    [anon_sym_assert] = ACTIONS(231),
    [anon_sym_assume] = ACTIONS(231),
    [anon_sym_cover] = ACTIONS(231),
    [anon_sym_skip] = ACTIONS(231),
    [anon_sym_attach] = ACTIONS(231),
    [sym_info] = ACTIONS(233),
    [anon_sym_infer] = ACTIONS(231),
    [anon_sym_read] = ACTIONS(231),
    [anon_sym_write] = ACTIONS(231),
    [anon_sym_rdwr] = ACTIONS(231),
    [anon_sym_DOT] = ACTIONS(189),
    [anon_sym_mux] = ACTIONS(231),
    [anon_sym_validif] = ACTIONS(231),
    [anon_sym_add] = ACTIONS(231),
    [anon_sym_sub] = ACTIONS(231),
    [anon_sym_mul] = ACTIONS(231),
    [anon_sym_div] = ACTIONS(231),
    [anon_sym_rem] = ACTIONS(231),
    [anon_sym_lt] = ACTIONS(231),
    [anon_sym_leq] = ACTIONS(231),
    [anon_sym_gt] = ACTIONS(231),
    [anon_sym_geq] = ACTIONS(231),
    [anon_sym_eq] = ACTIONS(231),
    [anon_sym_neq] = ACTIONS(231),
    [anon_sym_pad] = ACTIONS(231),
    [anon_sym_asUInt] = ACTIONS(231),
    [anon_sym_asAsyncReset] = ACTIONS(231),
    [anon_sym_asSInt] = ACTIONS(231),
    [anon_sym_asClock] = ACTIONS(231),
    [anon_sym_shl] = ACTIONS(231),
    [anon_sym_shr] = ACTIONS(231),
    [anon_sym_dshl] = ACTIONS(231),
    [anon_sym_dshlw] = ACTIONS(231),
    [anon_sym_dshr] = ACTIONS(231),
    [anon_sym_dshrw] = ACTIONS(231),
    [anon_sym_cvt] = ACTIONS(231),
    [anon_sym_neg] = ACTIONS(231),
    [anon_sym_not] = ACTIONS(231),
    [anon_sym_and] = ACTIONS(231),
    [anon_sym_or] = ACTIONS(231),
    [anon_sym_xor] = ACTIONS(231),
    [anon_sym_andr] = ACTIONS(231),
    [anon_sym_orr] = ACTIONS(231),
    [anon_sym_xorr] = ACTIONS(231),
    [anon_sym_cat] = ACTIONS(231),
    [anon_sym_bits] = ACTIONS(231),
    [anon_sym_head] = ACTIONS(231),
    [anon_sym_tail] = ACTIONS(231),
    [anon_sym_asFixedPoint] = ACTIONS(231),
    [anon_sym_bpshl] = ACTIONS(231),
    [anon_sym_bpshr] = ACTIONS(231),
    [anon_sym_bpset] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(235),
  },
  [38] = {
    [sym_identifier] = ACTIONS(237),
    [anon_sym_UInt] = ACTIONS(237),
    [anon_sym_SInt] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_wire] = ACTIONS(237),
    [anon_sym_cmem] = ACTIONS(237),
    [anon_sym_smem] = ACTIONS(237),
    [anon_sym_reg] = ACTIONS(237),
    [anon_sym_mem] = ACTIONS(237),
    [anon_sym_inst] = ACTIONS(237),
    [anon_sym_node] = ACTIONS(237),
    [anon_sym_when] = ACTIONS(237),
    [anon_sym_else] = ACTIONS(237),
    [anon_sym_stop] = ACTIONS(237),
    [anon_sym_printf] = ACTIONS(237),
    [anon_sym_assert] = ACTIONS(237),
    [anon_sym_assume] = ACTIONS(237),
    [anon_sym_cover] = ACTIONS(237),
    [anon_sym_skip] = ACTIONS(237),
    [anon_sym_attach] = ACTIONS(237),
    [sym_info] = ACTIONS(239),
    [anon_sym_infer] = ACTIONS(237),
    [anon_sym_read] = ACTIONS(237),
    [anon_sym_write] = ACTIONS(237),
    [anon_sym_rdwr] = ACTIONS(237),
    [anon_sym_DOT] = ACTIONS(189),
    [anon_sym_mux] = ACTIONS(237),
    [anon_sym_validif] = ACTIONS(237),
    [anon_sym_add] = ACTIONS(237),
    [anon_sym_sub] = ACTIONS(237),
    [anon_sym_mul] = ACTIONS(237),
    [anon_sym_div] = ACTIONS(237),
    [anon_sym_rem] = ACTIONS(237),
    [anon_sym_lt] = ACTIONS(237),
    [anon_sym_leq] = ACTIONS(237),
    [anon_sym_gt] = ACTIONS(237),
    [anon_sym_geq] = ACTIONS(237),
    [anon_sym_eq] = ACTIONS(237),
    [anon_sym_neq] = ACTIONS(237),
    [anon_sym_pad] = ACTIONS(237),
    [anon_sym_asUInt] = ACTIONS(237),
    [anon_sym_asAsyncReset] = ACTIONS(237),
    [anon_sym_asSInt] = ACTIONS(237),
    [anon_sym_asClock] = ACTIONS(237),
    [anon_sym_shl] = ACTIONS(237),
    [anon_sym_shr] = ACTIONS(237),
    [anon_sym_dshl] = ACTIONS(237),
    [anon_sym_dshlw] = ACTIONS(237),
    [anon_sym_dshr] = ACTIONS(237),
    [anon_sym_dshrw] = ACTIONS(237),
    [anon_sym_cvt] = ACTIONS(237),
    [anon_sym_neg] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(237),
    [anon_sym_and] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(237),
    [anon_sym_xor] = ACTIONS(237),
    [anon_sym_andr] = ACTIONS(237),
    [anon_sym_orr] = ACTIONS(237),
    [anon_sym_xorr] = ACTIONS(237),
    [anon_sym_cat] = ACTIONS(237),
    [anon_sym_bits] = ACTIONS(237),
    [anon_sym_head] = ACTIONS(237),
    [anon_sym_tail] = ACTIONS(237),
    [anon_sym_asFixedPoint] = ACTIONS(237),
    [anon_sym_bpshl] = ACTIONS(237),
    [anon_sym_bpshr] = ACTIONS(237),
    [anon_sym_bpset] = ACTIONS(237),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(241),
  },
  [39] = {
    [sym_identifier] = ACTIONS(215),
    [anon_sym_UInt] = ACTIONS(215),
    [anon_sym_SInt] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(219),
    [anon_sym_wire] = ACTIONS(215),
    [anon_sym_cmem] = ACTIONS(215),
    [anon_sym_smem] = ACTIONS(215),
    [anon_sym_reg] = ACTIONS(215),
    [anon_sym_mem] = ACTIONS(215),
    [anon_sym_inst] = ACTIONS(215),
    [anon_sym_node] = ACTIONS(215),
    [anon_sym_when] = ACTIONS(215),
    [anon_sym_else] = ACTIONS(215),
    [anon_sym_stop] = ACTIONS(215),
    [anon_sym_printf] = ACTIONS(215),
    [anon_sym_assert] = ACTIONS(215),
    [anon_sym_assume] = ACTIONS(215),
    [anon_sym_cover] = ACTIONS(215),
    [anon_sym_skip] = ACTIONS(215),
    [anon_sym_attach] = ACTIONS(215),
    [sym_info] = ACTIONS(219),
    [anon_sym_infer] = ACTIONS(215),
    [anon_sym_read] = ACTIONS(215),
    [anon_sym_write] = ACTIONS(215),
    [anon_sym_rdwr] = ACTIONS(215),
    [anon_sym_mux] = ACTIONS(215),
    [anon_sym_validif] = ACTIONS(215),
    [anon_sym_add] = ACTIONS(215),
    [anon_sym_sub] = ACTIONS(215),
    [anon_sym_mul] = ACTIONS(215),
    [anon_sym_div] = ACTIONS(215),
    [anon_sym_rem] = ACTIONS(215),
    [anon_sym_lt] = ACTIONS(215),
    [anon_sym_leq] = ACTIONS(215),
    [anon_sym_gt] = ACTIONS(215),
    [anon_sym_geq] = ACTIONS(215),
    [anon_sym_eq] = ACTIONS(215),
    [anon_sym_neq] = ACTIONS(215),
    [anon_sym_pad] = ACTIONS(215),
    [anon_sym_asUInt] = ACTIONS(215),
    [anon_sym_asAsyncReset] = ACTIONS(215),
    [anon_sym_asSInt] = ACTIONS(215),
    [anon_sym_asClock] = ACTIONS(215),
    [anon_sym_shl] = ACTIONS(215),
    [anon_sym_shr] = ACTIONS(215),
    [anon_sym_dshl] = ACTIONS(215),
    [anon_sym_dshlw] = ACTIONS(215),
    [anon_sym_dshr] = ACTIONS(215),
    [anon_sym_dshrw] = ACTIONS(215),
    [anon_sym_cvt] = ACTIONS(215),
    [anon_sym_neg] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_and] = ACTIONS(215),
    [anon_sym_or] = ACTIONS(215),
    [anon_sym_xor] = ACTIONS(215),
    [anon_sym_andr] = ACTIONS(215),
    [anon_sym_orr] = ACTIONS(215),
    [anon_sym_xorr] = ACTIONS(215),
    [anon_sym_cat] = ACTIONS(215),
    [anon_sym_bits] = ACTIONS(215),
    [anon_sym_head] = ACTIONS(215),
    [anon_sym_tail] = ACTIONS(215),
    [anon_sym_asFixedPoint] = ACTIONS(215),
    [anon_sym_bpshl] = ACTIONS(215),
    [anon_sym_bpshr] = ACTIONS(215),
    [anon_sym_bpset] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(219),
  },
  [40] = {
    [sym_identifier] = ACTIONS(245),
    [anon_sym_UInt] = ACTIONS(245),
    [anon_sym_SInt] = ACTIONS(245),
    [anon_sym_LT] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_wire] = ACTIONS(245),
    [anon_sym_cmem] = ACTIONS(245),
    [anon_sym_smem] = ACTIONS(245),
    [anon_sym_reg] = ACTIONS(245),
    [anon_sym_mem] = ACTIONS(245),
    [anon_sym_inst] = ACTIONS(245),
    [anon_sym_node] = ACTIONS(245),
    [anon_sym_when] = ACTIONS(245),
    [anon_sym_else] = ACTIONS(245),
    [anon_sym_stop] = ACTIONS(245),
    [anon_sym_printf] = ACTIONS(245),
    [anon_sym_assert] = ACTIONS(245),
    [anon_sym_assume] = ACTIONS(245),
    [anon_sym_cover] = ACTIONS(245),
    [anon_sym_skip] = ACTIONS(245),
    [anon_sym_attach] = ACTIONS(245),
    [sym_info] = ACTIONS(249),
    [anon_sym_infer] = ACTIONS(245),
    [anon_sym_read] = ACTIONS(245),
    [anon_sym_write] = ACTIONS(245),
    [anon_sym_rdwr] = ACTIONS(245),
    [anon_sym_mux] = ACTIONS(245),
    [anon_sym_validif] = ACTIONS(245),
    [anon_sym_add] = ACTIONS(245),
    [anon_sym_sub] = ACTIONS(245),
    [anon_sym_mul] = ACTIONS(245),
    [anon_sym_div] = ACTIONS(245),
    [anon_sym_rem] = ACTIONS(245),
    [anon_sym_lt] = ACTIONS(245),
    [anon_sym_leq] = ACTIONS(245),
    [anon_sym_gt] = ACTIONS(245),
    [anon_sym_geq] = ACTIONS(245),
    [anon_sym_eq] = ACTIONS(245),
    [anon_sym_neq] = ACTIONS(245),
    [anon_sym_pad] = ACTIONS(245),
    [anon_sym_asUInt] = ACTIONS(245),
    [anon_sym_asAsyncReset] = ACTIONS(245),
    [anon_sym_asSInt] = ACTIONS(245),
    [anon_sym_asClock] = ACTIONS(245),
    [anon_sym_shl] = ACTIONS(245),
    [anon_sym_shr] = ACTIONS(245),
    [anon_sym_dshl] = ACTIONS(245),
    [anon_sym_dshlw] = ACTIONS(245),
    [anon_sym_dshr] = ACTIONS(245),
    [anon_sym_dshrw] = ACTIONS(245),
    [anon_sym_cvt] = ACTIONS(245),
    [anon_sym_neg] = ACTIONS(245),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_and] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(245),
    [anon_sym_xor] = ACTIONS(245),
    [anon_sym_andr] = ACTIONS(245),
    [anon_sym_orr] = ACTIONS(245),
    [anon_sym_xorr] = ACTIONS(245),
    [anon_sym_cat] = ACTIONS(245),
    [anon_sym_bits] = ACTIONS(245),
    [anon_sym_head] = ACTIONS(245),
    [anon_sym_tail] = ACTIONS(245),
    [anon_sym_asFixedPoint] = ACTIONS(245),
    [anon_sym_bpshl] = ACTIONS(245),
    [anon_sym_bpshr] = ACTIONS(245),
    [anon_sym_bpset] = ACTIONS(245),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(249),
  },
  [41] = {
    [sym_identifier] = ACTIONS(251),
    [anon_sym_input] = ACTIONS(251),
    [anon_sym_output] = ACTIONS(251),
    [anon_sym_UInt] = ACTIONS(251),
    [anon_sym_SInt] = ACTIONS(251),
    [anon_sym_defname] = ACTIONS(251),
    [anon_sym_parameter] = ACTIONS(251),
    [anon_sym_wire] = ACTIONS(251),
    [anon_sym_cmem] = ACTIONS(251),
    [anon_sym_smem] = ACTIONS(251),
    [anon_sym_reg] = ACTIONS(251),
    [anon_sym_mem] = ACTIONS(251),
    [anon_sym_inst] = ACTIONS(251),
    [anon_sym_node] = ACTIONS(251),
    [anon_sym_when] = ACTIONS(251),
    [anon_sym_stop] = ACTIONS(251),
    [anon_sym_printf] = ACTIONS(251),
    [anon_sym_assert] = ACTIONS(251),
    [anon_sym_assume] = ACTIONS(251),
    [anon_sym_cover] = ACTIONS(251),
    [anon_sym_skip] = ACTIONS(251),
    [anon_sym_attach] = ACTIONS(251),
    [anon_sym_infer] = ACTIONS(251),
    [anon_sym_read] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [anon_sym_rdwr] = ACTIONS(251),
    [anon_sym_mux] = ACTIONS(251),
    [anon_sym_validif] = ACTIONS(251),
    [anon_sym_add] = ACTIONS(251),
    [anon_sym_sub] = ACTIONS(251),
    [anon_sym_mul] = ACTIONS(251),
    [anon_sym_div] = ACTIONS(251),
    [anon_sym_rem] = ACTIONS(251),
    [anon_sym_lt] = ACTIONS(251),
    [anon_sym_leq] = ACTIONS(251),
    [anon_sym_gt] = ACTIONS(251),
    [anon_sym_geq] = ACTIONS(251),
    [anon_sym_eq] = ACTIONS(251),
    [anon_sym_neq] = ACTIONS(251),
    [anon_sym_pad] = ACTIONS(251),
    [anon_sym_asUInt] = ACTIONS(251),
    [anon_sym_asAsyncReset] = ACTIONS(251),
    [anon_sym_asSInt] = ACTIONS(251),
    [anon_sym_asClock] = ACTIONS(251),
    [anon_sym_shl] = ACTIONS(251),
    [anon_sym_shr] = ACTIONS(251),
    [anon_sym_dshl] = ACTIONS(251),
    [anon_sym_dshlw] = ACTIONS(251),
    [anon_sym_dshr] = ACTIONS(251),
    [anon_sym_dshrw] = ACTIONS(251),
    [anon_sym_cvt] = ACTIONS(251),
    [anon_sym_neg] = ACTIONS(251),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_and] = ACTIONS(251),
    [anon_sym_or] = ACTIONS(251),
    [anon_sym_xor] = ACTIONS(251),
    [anon_sym_andr] = ACTIONS(251),
    [anon_sym_orr] = ACTIONS(251),
    [anon_sym_xorr] = ACTIONS(251),
    [anon_sym_cat] = ACTIONS(251),
    [anon_sym_bits] = ACTIONS(251),
    [anon_sym_head] = ACTIONS(251),
    [anon_sym_tail] = ACTIONS(251),
    [anon_sym_asFixedPoint] = ACTIONS(251),
    [anon_sym_bpshl] = ACTIONS(251),
    [anon_sym_bpshr] = ACTIONS(251),
    [anon_sym_bpset] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(253),
  },
  [42] = {
    [sym_identifier] = ACTIONS(255),
    [anon_sym_UInt] = ACTIONS(255),
    [anon_sym_SInt] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(257),
    [anon_sym_wire] = ACTIONS(255),
    [anon_sym_cmem] = ACTIONS(255),
    [anon_sym_smem] = ACTIONS(255),
    [anon_sym_reg] = ACTIONS(255),
    [anon_sym_mem] = ACTIONS(255),
    [anon_sym_inst] = ACTIONS(255),
    [anon_sym_node] = ACTIONS(255),
    [anon_sym_when] = ACTIONS(255),
    [anon_sym_else] = ACTIONS(255),
    [anon_sym_stop] = ACTIONS(255),
    [anon_sym_printf] = ACTIONS(255),
    [anon_sym_assert] = ACTIONS(255),
    [anon_sym_assume] = ACTIONS(255),
    [anon_sym_cover] = ACTIONS(255),
    [anon_sym_skip] = ACTIONS(255),
    [anon_sym_attach] = ACTIONS(255),
    [sym_info] = ACTIONS(257),
    [anon_sym_infer] = ACTIONS(255),
    [anon_sym_read] = ACTIONS(255),
    [anon_sym_write] = ACTIONS(255),
    [anon_sym_rdwr] = ACTIONS(255),
    [anon_sym_mux] = ACTIONS(255),
    [anon_sym_validif] = ACTIONS(255),
    [anon_sym_add] = ACTIONS(255),
    [anon_sym_sub] = ACTIONS(255),
    [anon_sym_mul] = ACTIONS(255),
    [anon_sym_div] = ACTIONS(255),
    [anon_sym_rem] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_leq] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_geq] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_neq] = ACTIONS(255),
    [anon_sym_pad] = ACTIONS(255),
    [anon_sym_asUInt] = ACTIONS(255),
    [anon_sym_asAsyncReset] = ACTIONS(255),
    [anon_sym_asSInt] = ACTIONS(255),
    [anon_sym_asClock] = ACTIONS(255),
    [anon_sym_shl] = ACTIONS(255),
    [anon_sym_shr] = ACTIONS(255),
    [anon_sym_dshl] = ACTIONS(255),
    [anon_sym_dshlw] = ACTIONS(255),
    [anon_sym_dshr] = ACTIONS(255),
    [anon_sym_dshrw] = ACTIONS(255),
    [anon_sym_cvt] = ACTIONS(255),
    [anon_sym_neg] = ACTIONS(255),
    [anon_sym_not] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_xor] = ACTIONS(255),
    [anon_sym_andr] = ACTIONS(255),
    [anon_sym_orr] = ACTIONS(255),
    [anon_sym_xorr] = ACTIONS(255),
    [anon_sym_cat] = ACTIONS(255),
    [anon_sym_bits] = ACTIONS(255),
    [anon_sym_head] = ACTIONS(255),
    [anon_sym_tail] = ACTIONS(255),
    [anon_sym_asFixedPoint] = ACTIONS(255),
    [anon_sym_bpshl] = ACTIONS(255),
    [anon_sym_bpshr] = ACTIONS(255),
    [anon_sym_bpset] = ACTIONS(255),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(257),
  },
  [43] = {
    [sym_identifier] = ACTIONS(259),
    [anon_sym_UInt] = ACTIONS(259),
    [anon_sym_SInt] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_wire] = ACTIONS(259),
    [anon_sym_cmem] = ACTIONS(259),
    [anon_sym_smem] = ACTIONS(259),
    [anon_sym_reg] = ACTIONS(259),
    [anon_sym_mem] = ACTIONS(259),
    [anon_sym_inst] = ACTIONS(259),
    [anon_sym_node] = ACTIONS(259),
    [anon_sym_when] = ACTIONS(259),
    [anon_sym_else] = ACTIONS(259),
    [anon_sym_stop] = ACTIONS(259),
    [anon_sym_printf] = ACTIONS(259),
    [anon_sym_assert] = ACTIONS(259),
    [anon_sym_assume] = ACTIONS(259),
    [anon_sym_cover] = ACTIONS(259),
    [anon_sym_skip] = ACTIONS(259),
    [anon_sym_attach] = ACTIONS(259),
    [sym_info] = ACTIONS(261),
    [anon_sym_infer] = ACTIONS(259),
    [anon_sym_read] = ACTIONS(259),
    [anon_sym_write] = ACTIONS(259),
    [anon_sym_rdwr] = ACTIONS(259),
    [anon_sym_mux] = ACTIONS(259),
    [anon_sym_validif] = ACTIONS(259),
    [anon_sym_add] = ACTIONS(259),
    [anon_sym_sub] = ACTIONS(259),
    [anon_sym_mul] = ACTIONS(259),
    [anon_sym_div] = ACTIONS(259),
    [anon_sym_rem] = ACTIONS(259),
    [anon_sym_lt] = ACTIONS(259),
    [anon_sym_leq] = ACTIONS(259),
    [anon_sym_gt] = ACTIONS(259),
    [anon_sym_geq] = ACTIONS(259),
    [anon_sym_eq] = ACTIONS(259),
    [anon_sym_neq] = ACTIONS(259),
    [anon_sym_pad] = ACTIONS(259),
    [anon_sym_asUInt] = ACTIONS(259),
    [anon_sym_asAsyncReset] = ACTIONS(259),
    [anon_sym_asSInt] = ACTIONS(259),
    [anon_sym_asClock] = ACTIONS(259),
    [anon_sym_shl] = ACTIONS(259),
    [anon_sym_shr] = ACTIONS(259),
    [anon_sym_dshl] = ACTIONS(259),
    [anon_sym_dshlw] = ACTIONS(259),
    [anon_sym_dshr] = ACTIONS(259),
    [anon_sym_dshrw] = ACTIONS(259),
    [anon_sym_cvt] = ACTIONS(259),
    [anon_sym_neg] = ACTIONS(259),
    [anon_sym_not] = ACTIONS(259),
    [anon_sym_and] = ACTIONS(259),
    [anon_sym_or] = ACTIONS(259),
    [anon_sym_xor] = ACTIONS(259),
    [anon_sym_andr] = ACTIONS(259),
    [anon_sym_orr] = ACTIONS(259),
    [anon_sym_xorr] = ACTIONS(259),
    [anon_sym_cat] = ACTIONS(259),
    [anon_sym_bits] = ACTIONS(259),
    [anon_sym_head] = ACTIONS(259),
    [anon_sym_tail] = ACTIONS(259),
    [anon_sym_asFixedPoint] = ACTIONS(259),
    [anon_sym_bpshl] = ACTIONS(259),
    [anon_sym_bpshr] = ACTIONS(259),
    [anon_sym_bpset] = ACTIONS(259),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(261),
  },
  [44] = {
    [sym_identifier] = ACTIONS(263),
    [anon_sym_UInt] = ACTIONS(263),
    [anon_sym_SInt] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(265),
    [anon_sym_wire] = ACTIONS(263),
    [anon_sym_cmem] = ACTIONS(263),
    [anon_sym_smem] = ACTIONS(263),
    [anon_sym_reg] = ACTIONS(263),
    [anon_sym_mem] = ACTIONS(263),
    [anon_sym_inst] = ACTIONS(263),
    [anon_sym_node] = ACTIONS(263),
    [anon_sym_when] = ACTIONS(263),
    [anon_sym_else] = ACTIONS(263),
    [anon_sym_stop] = ACTIONS(263),
    [anon_sym_printf] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_assume] = ACTIONS(263),
    [anon_sym_cover] = ACTIONS(263),
    [anon_sym_skip] = ACTIONS(263),
    [anon_sym_attach] = ACTIONS(263),
    [sym_info] = ACTIONS(267),
    [anon_sym_infer] = ACTIONS(263),
    [anon_sym_read] = ACTIONS(263),
    [anon_sym_write] = ACTIONS(263),
    [anon_sym_rdwr] = ACTIONS(263),
    [anon_sym_mux] = ACTIONS(263),
    [anon_sym_validif] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(263),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_div] = ACTIONS(263),
    [anon_sym_rem] = ACTIONS(263),
    [anon_sym_lt] = ACTIONS(263),
    [anon_sym_leq] = ACTIONS(263),
    [anon_sym_gt] = ACTIONS(263),
    [anon_sym_geq] = ACTIONS(263),
    [anon_sym_eq] = ACTIONS(263),
    [anon_sym_neq] = ACTIONS(263),
    [anon_sym_pad] = ACTIONS(263),
    [anon_sym_asUInt] = ACTIONS(263),
    [anon_sym_asAsyncReset] = ACTIONS(263),
    [anon_sym_asSInt] = ACTIONS(263),
    [anon_sym_asClock] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_shr] = ACTIONS(263),
    [anon_sym_dshl] = ACTIONS(263),
    [anon_sym_dshlw] = ACTIONS(263),
    [anon_sym_dshr] = ACTIONS(263),
    [anon_sym_dshrw] = ACTIONS(263),
    [anon_sym_cvt] = ACTIONS(263),
    [anon_sym_neg] = ACTIONS(263),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_andr] = ACTIONS(263),
    [anon_sym_orr] = ACTIONS(263),
    [anon_sym_xorr] = ACTIONS(263),
    [anon_sym_cat] = ACTIONS(263),
    [anon_sym_bits] = ACTIONS(263),
    [anon_sym_head] = ACTIONS(263),
    [anon_sym_tail] = ACTIONS(263),
    [anon_sym_asFixedPoint] = ACTIONS(263),
    [anon_sym_bpshl] = ACTIONS(263),
    [anon_sym_bpshr] = ACTIONS(263),
    [anon_sym_bpset] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(269),
  },
  [45] = {
    [sym_identifier] = ACTIONS(271),
    [anon_sym_UInt] = ACTIONS(271),
    [anon_sym_SInt] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(265),
    [anon_sym_wire] = ACTIONS(271),
    [anon_sym_cmem] = ACTIONS(271),
    [anon_sym_smem] = ACTIONS(271),
    [anon_sym_reg] = ACTIONS(271),
    [anon_sym_mem] = ACTIONS(271),
    [anon_sym_inst] = ACTIONS(271),
    [anon_sym_node] = ACTIONS(271),
    [anon_sym_when] = ACTIONS(271),
    [anon_sym_else] = ACTIONS(271),
    [anon_sym_stop] = ACTIONS(271),
    [anon_sym_printf] = ACTIONS(271),
    [anon_sym_assert] = ACTIONS(271),
    [anon_sym_assume] = ACTIONS(271),
    [anon_sym_cover] = ACTIONS(271),
    [anon_sym_skip] = ACTIONS(271),
    [anon_sym_attach] = ACTIONS(271),
    [sym_info] = ACTIONS(273),
    [anon_sym_infer] = ACTIONS(271),
    [anon_sym_read] = ACTIONS(271),
    [anon_sym_write] = ACTIONS(271),
    [anon_sym_rdwr] = ACTIONS(271),
    [anon_sym_mux] = ACTIONS(271),
    [anon_sym_validif] = ACTIONS(271),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(271),
    [anon_sym_mul] = ACTIONS(271),
    [anon_sym_div] = ACTIONS(271),
    [anon_sym_rem] = ACTIONS(271),
    [anon_sym_lt] = ACTIONS(271),
    [anon_sym_leq] = ACTIONS(271),
    [anon_sym_gt] = ACTIONS(271),
    [anon_sym_geq] = ACTIONS(271),
    [anon_sym_eq] = ACTIONS(271),
    [anon_sym_neq] = ACTIONS(271),
    [anon_sym_pad] = ACTIONS(271),
    [anon_sym_asUInt] = ACTIONS(271),
    [anon_sym_asAsyncReset] = ACTIONS(271),
    [anon_sym_asSInt] = ACTIONS(271),
    [anon_sym_asClock] = ACTIONS(271),
    [anon_sym_shl] = ACTIONS(271),
    [anon_sym_shr] = ACTIONS(271),
    [anon_sym_dshl] = ACTIONS(271),
    [anon_sym_dshlw] = ACTIONS(271),
    [anon_sym_dshr] = ACTIONS(271),
    [anon_sym_dshrw] = ACTIONS(271),
    [anon_sym_cvt] = ACTIONS(271),
    [anon_sym_neg] = ACTIONS(271),
    [anon_sym_not] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(271),
    [anon_sym_or] = ACTIONS(271),
    [anon_sym_xor] = ACTIONS(271),
    [anon_sym_andr] = ACTIONS(271),
    [anon_sym_orr] = ACTIONS(271),
    [anon_sym_xorr] = ACTIONS(271),
    [anon_sym_cat] = ACTIONS(271),
    [anon_sym_bits] = ACTIONS(271),
    [anon_sym_head] = ACTIONS(271),
    [anon_sym_tail] = ACTIONS(271),
    [anon_sym_asFixedPoint] = ACTIONS(271),
    [anon_sym_bpshl] = ACTIONS(271),
    [anon_sym_bpshr] = ACTIONS(271),
    [anon_sym_bpset] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(275),
  },
  [46] = {
    [sym_identifier] = ACTIONS(277),
    [anon_sym_UInt] = ACTIONS(277),
    [anon_sym_SInt] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(265),
    [anon_sym_wire] = ACTIONS(277),
    [anon_sym_cmem] = ACTIONS(277),
    [anon_sym_smem] = ACTIONS(277),
    [anon_sym_reg] = ACTIONS(277),
    [anon_sym_mem] = ACTIONS(277),
    [anon_sym_inst] = ACTIONS(277),
    [anon_sym_node] = ACTIONS(277),
    [anon_sym_when] = ACTIONS(277),
    [anon_sym_else] = ACTIONS(277),
    [anon_sym_stop] = ACTIONS(277),
    [anon_sym_printf] = ACTIONS(277),
    [anon_sym_assert] = ACTIONS(277),
    [anon_sym_assume] = ACTIONS(277),
    [anon_sym_cover] = ACTIONS(277),
    [anon_sym_skip] = ACTIONS(277),
    [anon_sym_attach] = ACTIONS(277),
    [sym_info] = ACTIONS(279),
    [anon_sym_infer] = ACTIONS(277),
    [anon_sym_read] = ACTIONS(277),
    [anon_sym_write] = ACTIONS(277),
    [anon_sym_rdwr] = ACTIONS(277),
    [anon_sym_mux] = ACTIONS(277),
    [anon_sym_validif] = ACTIONS(277),
    [anon_sym_add] = ACTIONS(277),
    [anon_sym_sub] = ACTIONS(277),
    [anon_sym_mul] = ACTIONS(277),
    [anon_sym_div] = ACTIONS(277),
    [anon_sym_rem] = ACTIONS(277),
    [anon_sym_lt] = ACTIONS(277),
    [anon_sym_leq] = ACTIONS(277),
    [anon_sym_gt] = ACTIONS(277),
    [anon_sym_geq] = ACTIONS(277),
    [anon_sym_eq] = ACTIONS(277),
    [anon_sym_neq] = ACTIONS(277),
    [anon_sym_pad] = ACTIONS(277),
    [anon_sym_asUInt] = ACTIONS(277),
    [anon_sym_asAsyncReset] = ACTIONS(277),
    [anon_sym_asSInt] = ACTIONS(277),
    [anon_sym_asClock] = ACTIONS(277),
    [anon_sym_shl] = ACTIONS(277),
    [anon_sym_shr] = ACTIONS(277),
    [anon_sym_dshl] = ACTIONS(277),
    [anon_sym_dshlw] = ACTIONS(277),
    [anon_sym_dshr] = ACTIONS(277),
    [anon_sym_dshrw] = ACTIONS(277),
    [anon_sym_cvt] = ACTIONS(277),
    [anon_sym_neg] = ACTIONS(277),
    [anon_sym_not] = ACTIONS(277),
    [anon_sym_and] = ACTIONS(277),
    [anon_sym_or] = ACTIONS(277),
    [anon_sym_xor] = ACTIONS(277),
    [anon_sym_andr] = ACTIONS(277),
    [anon_sym_orr] = ACTIONS(277),
    [anon_sym_xorr] = ACTIONS(277),
    [anon_sym_cat] = ACTIONS(277),
    [anon_sym_bits] = ACTIONS(277),
    [anon_sym_head] = ACTIONS(277),
    [anon_sym_tail] = ACTIONS(277),
    [anon_sym_asFixedPoint] = ACTIONS(277),
    [anon_sym_bpshl] = ACTIONS(277),
    [anon_sym_bpshr] = ACTIONS(277),
    [anon_sym_bpset] = ACTIONS(277),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(281),
  },
  [47] = {
    [sym_identifier] = ACTIONS(245),
    [anon_sym_UInt] = ACTIONS(245),
    [anon_sym_SInt] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_wire] = ACTIONS(245),
    [anon_sym_cmem] = ACTIONS(245),
    [anon_sym_smem] = ACTIONS(245),
    [anon_sym_reg] = ACTIONS(245),
    [anon_sym_mem] = ACTIONS(245),
    [anon_sym_inst] = ACTIONS(245),
    [anon_sym_node] = ACTIONS(245),
    [anon_sym_when] = ACTIONS(245),
    [anon_sym_else] = ACTIONS(245),
    [anon_sym_stop] = ACTIONS(245),
    [anon_sym_printf] = ACTIONS(245),
    [anon_sym_assert] = ACTIONS(245),
    [anon_sym_assume] = ACTIONS(245),
    [anon_sym_cover] = ACTIONS(245),
    [anon_sym_skip] = ACTIONS(245),
    [anon_sym_attach] = ACTIONS(245),
    [sym_info] = ACTIONS(249),
    [anon_sym_infer] = ACTIONS(245),
    [anon_sym_read] = ACTIONS(245),
    [anon_sym_write] = ACTIONS(245),
    [anon_sym_rdwr] = ACTIONS(245),
    [anon_sym_mux] = ACTIONS(245),
    [anon_sym_validif] = ACTIONS(245),
    [anon_sym_add] = ACTIONS(245),
    [anon_sym_sub] = ACTIONS(245),
    [anon_sym_mul] = ACTIONS(245),
    [anon_sym_div] = ACTIONS(245),
    [anon_sym_rem] = ACTIONS(245),
    [anon_sym_lt] = ACTIONS(245),
    [anon_sym_leq] = ACTIONS(245),
    [anon_sym_gt] = ACTIONS(245),
    [anon_sym_geq] = ACTIONS(245),
    [anon_sym_eq] = ACTIONS(245),
    [anon_sym_neq] = ACTIONS(245),
    [anon_sym_pad] = ACTIONS(245),
    [anon_sym_asUInt] = ACTIONS(245),
    [anon_sym_asAsyncReset] = ACTIONS(245),
    [anon_sym_asSInt] = ACTIONS(245),
    [anon_sym_asClock] = ACTIONS(245),
    [anon_sym_shl] = ACTIONS(245),
    [anon_sym_shr] = ACTIONS(245),
    [anon_sym_dshl] = ACTIONS(245),
    [anon_sym_dshlw] = ACTIONS(245),
    [anon_sym_dshr] = ACTIONS(245),
    [anon_sym_dshrw] = ACTIONS(245),
    [anon_sym_cvt] = ACTIONS(245),
    [anon_sym_neg] = ACTIONS(245),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_and] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(245),
    [anon_sym_xor] = ACTIONS(245),
    [anon_sym_andr] = ACTIONS(245),
    [anon_sym_orr] = ACTIONS(245),
    [anon_sym_xorr] = ACTIONS(245),
    [anon_sym_cat] = ACTIONS(245),
    [anon_sym_bits] = ACTIONS(245),
    [anon_sym_head] = ACTIONS(245),
    [anon_sym_tail] = ACTIONS(245),
    [anon_sym_asFixedPoint] = ACTIONS(245),
    [anon_sym_bpshl] = ACTIONS(245),
    [anon_sym_bpshr] = ACTIONS(245),
    [anon_sym_bpset] = ACTIONS(245),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(249),
  },
  [48] = {
    [sym_identifier] = ACTIONS(283),
    [anon_sym_UInt] = ACTIONS(283),
    [anon_sym_SInt] = ACTIONS(283),
    [anon_sym_LBRACK] = ACTIONS(285),
    [anon_sym_wire] = ACTIONS(283),
    [anon_sym_cmem] = ACTIONS(283),
    [anon_sym_smem] = ACTIONS(283),
    [anon_sym_reg] = ACTIONS(283),
    [anon_sym_mem] = ACTIONS(283),
    [anon_sym_inst] = ACTIONS(283),
    [anon_sym_node] = ACTIONS(283),
    [anon_sym_when] = ACTIONS(283),
    [anon_sym_else] = ACTIONS(283),
    [anon_sym_stop] = ACTIONS(283),
    [anon_sym_printf] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(283),
    [anon_sym_assume] = ACTIONS(283),
    [anon_sym_cover] = ACTIONS(283),
    [anon_sym_skip] = ACTIONS(283),
    [anon_sym_attach] = ACTIONS(283),
    [sym_info] = ACTIONS(285),
    [anon_sym_infer] = ACTIONS(283),
    [anon_sym_read] = ACTIONS(283),
    [anon_sym_write] = ACTIONS(283),
    [anon_sym_rdwr] = ACTIONS(283),
    [anon_sym_mux] = ACTIONS(283),
    [anon_sym_validif] = ACTIONS(283),
    [anon_sym_add] = ACTIONS(283),
    [anon_sym_sub] = ACTIONS(283),
    [anon_sym_mul] = ACTIONS(283),
    [anon_sym_div] = ACTIONS(283),
    [anon_sym_rem] = ACTIONS(283),
    [anon_sym_lt] = ACTIONS(283),
    [anon_sym_leq] = ACTIONS(283),
    [anon_sym_gt] = ACTIONS(283),
    [anon_sym_geq] = ACTIONS(283),
    [anon_sym_eq] = ACTIONS(283),
    [anon_sym_neq] = ACTIONS(283),
    [anon_sym_pad] = ACTIONS(283),
    [anon_sym_asUInt] = ACTIONS(283),
    [anon_sym_asAsyncReset] = ACTIONS(283),
    [anon_sym_asSInt] = ACTIONS(283),
    [anon_sym_asClock] = ACTIONS(283),
    [anon_sym_shl] = ACTIONS(283),
    [anon_sym_shr] = ACTIONS(283),
    [anon_sym_dshl] = ACTIONS(283),
    [anon_sym_dshlw] = ACTIONS(283),
    [anon_sym_dshr] = ACTIONS(283),
    [anon_sym_dshrw] = ACTIONS(283),
    [anon_sym_cvt] = ACTIONS(283),
    [anon_sym_neg] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(283),
    [anon_sym_xor] = ACTIONS(283),
    [anon_sym_andr] = ACTIONS(283),
    [anon_sym_orr] = ACTIONS(283),
    [anon_sym_xorr] = ACTIONS(283),
    [anon_sym_cat] = ACTIONS(283),
    [anon_sym_bits] = ACTIONS(283),
    [anon_sym_head] = ACTIONS(283),
    [anon_sym_tail] = ACTIONS(283),
    [anon_sym_asFixedPoint] = ACTIONS(283),
    [anon_sym_bpshl] = ACTIONS(283),
    [anon_sym_bpshr] = ACTIONS(283),
    [anon_sym_bpset] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(285),
  },
  [49] = {
    [sym_identifier] = ACTIONS(287),
    [anon_sym_UInt] = ACTIONS(287),
    [anon_sym_SInt] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_wire] = ACTIONS(287),
    [anon_sym_cmem] = ACTIONS(287),
    [anon_sym_smem] = ACTIONS(287),
    [anon_sym_reg] = ACTIONS(287),
    [anon_sym_mem] = ACTIONS(287),
    [anon_sym_inst] = ACTIONS(287),
    [anon_sym_node] = ACTIONS(287),
    [anon_sym_when] = ACTIONS(287),
    [anon_sym_else] = ACTIONS(287),
    [anon_sym_stop] = ACTIONS(287),
    [anon_sym_printf] = ACTIONS(287),
    [anon_sym_assert] = ACTIONS(287),
    [anon_sym_assume] = ACTIONS(287),
    [anon_sym_cover] = ACTIONS(287),
    [anon_sym_skip] = ACTIONS(287),
    [anon_sym_attach] = ACTIONS(287),
    [sym_info] = ACTIONS(289),
    [anon_sym_infer] = ACTIONS(287),
    [anon_sym_read] = ACTIONS(287),
    [anon_sym_write] = ACTIONS(287),
    [anon_sym_rdwr] = ACTIONS(287),
    [anon_sym_mux] = ACTIONS(287),
    [anon_sym_validif] = ACTIONS(287),
    [anon_sym_add] = ACTIONS(287),
    [anon_sym_sub] = ACTIONS(287),
    [anon_sym_mul] = ACTIONS(287),
    [anon_sym_div] = ACTIONS(287),
    [anon_sym_rem] = ACTIONS(287),
    [anon_sym_lt] = ACTIONS(287),
    [anon_sym_leq] = ACTIONS(287),
    [anon_sym_gt] = ACTIONS(287),
    [anon_sym_geq] = ACTIONS(287),
    [anon_sym_eq] = ACTIONS(287),
    [anon_sym_neq] = ACTIONS(287),
    [anon_sym_pad] = ACTIONS(287),
    [anon_sym_asUInt] = ACTIONS(287),
    [anon_sym_asAsyncReset] = ACTIONS(287),
    [anon_sym_asSInt] = ACTIONS(287),
    [anon_sym_asClock] = ACTIONS(287),
    [anon_sym_shl] = ACTIONS(287),
    [anon_sym_shr] = ACTIONS(287),
    [anon_sym_dshl] = ACTIONS(287),
    [anon_sym_dshlw] = ACTIONS(287),
    [anon_sym_dshr] = ACTIONS(287),
    [anon_sym_dshrw] = ACTIONS(287),
    [anon_sym_cvt] = ACTIONS(287),
    [anon_sym_neg] = ACTIONS(287),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_and] = ACTIONS(287),
    [anon_sym_or] = ACTIONS(287),
    [anon_sym_xor] = ACTIONS(287),
    [anon_sym_andr] = ACTIONS(287),
    [anon_sym_orr] = ACTIONS(287),
    [anon_sym_xorr] = ACTIONS(287),
    [anon_sym_cat] = ACTIONS(287),
    [anon_sym_bits] = ACTIONS(287),
    [anon_sym_head] = ACTIONS(287),
    [anon_sym_tail] = ACTIONS(287),
    [anon_sym_asFixedPoint] = ACTIONS(287),
    [anon_sym_bpshl] = ACTIONS(287),
    [anon_sym_bpshr] = ACTIONS(287),
    [anon_sym_bpset] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(289),
  },
  [50] = {
    [sym_identifier] = ACTIONS(215),
    [anon_sym_UInt] = ACTIONS(215),
    [anon_sym_SInt] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(219),
    [anon_sym_wire] = ACTIONS(215),
    [anon_sym_cmem] = ACTIONS(215),
    [anon_sym_smem] = ACTIONS(215),
    [anon_sym_reg] = ACTIONS(215),
    [anon_sym_mem] = ACTIONS(215),
    [anon_sym_inst] = ACTIONS(215),
    [anon_sym_node] = ACTIONS(215),
    [anon_sym_when] = ACTIONS(215),
    [anon_sym_else] = ACTIONS(215),
    [anon_sym_stop] = ACTIONS(215),
    [anon_sym_printf] = ACTIONS(215),
    [anon_sym_assert] = ACTIONS(215),
    [anon_sym_assume] = ACTIONS(215),
    [anon_sym_cover] = ACTIONS(215),
    [anon_sym_skip] = ACTIONS(215),
    [anon_sym_attach] = ACTIONS(215),
    [sym_info] = ACTIONS(219),
    [anon_sym_infer] = ACTIONS(215),
    [anon_sym_read] = ACTIONS(215),
    [anon_sym_write] = ACTIONS(215),
    [anon_sym_rdwr] = ACTIONS(215),
    [anon_sym_mux] = ACTIONS(215),
    [anon_sym_validif] = ACTIONS(215),
    [anon_sym_add] = ACTIONS(215),
    [anon_sym_sub] = ACTIONS(215),
    [anon_sym_mul] = ACTIONS(215),
    [anon_sym_div] = ACTIONS(215),
    [anon_sym_rem] = ACTIONS(215),
    [anon_sym_lt] = ACTIONS(215),
    [anon_sym_leq] = ACTIONS(215),
    [anon_sym_gt] = ACTIONS(215),
    [anon_sym_geq] = ACTIONS(215),
    [anon_sym_eq] = ACTIONS(215),
    [anon_sym_neq] = ACTIONS(215),
    [anon_sym_pad] = ACTIONS(215),
    [anon_sym_asUInt] = ACTIONS(215),
    [anon_sym_asAsyncReset] = ACTIONS(215),
    [anon_sym_asSInt] = ACTIONS(215),
    [anon_sym_asClock] = ACTIONS(215),
    [anon_sym_shl] = ACTIONS(215),
    [anon_sym_shr] = ACTIONS(215),
    [anon_sym_dshl] = ACTIONS(215),
    [anon_sym_dshlw] = ACTIONS(215),
    [anon_sym_dshr] = ACTIONS(215),
    [anon_sym_dshrw] = ACTIONS(215),
    [anon_sym_cvt] = ACTIONS(215),
    [anon_sym_neg] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_and] = ACTIONS(215),
    [anon_sym_or] = ACTIONS(215),
    [anon_sym_xor] = ACTIONS(215),
    [anon_sym_andr] = ACTIONS(215),
    [anon_sym_orr] = ACTIONS(215),
    [anon_sym_xorr] = ACTIONS(215),
    [anon_sym_cat] = ACTIONS(215),
    [anon_sym_bits] = ACTIONS(215),
    [anon_sym_head] = ACTIONS(215),
    [anon_sym_tail] = ACTIONS(215),
    [anon_sym_asFixedPoint] = ACTIONS(215),
    [anon_sym_bpshl] = ACTIONS(215),
    [anon_sym_bpshr] = ACTIONS(215),
    [anon_sym_bpset] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(219),
  },
  [51] = {
    [sym_identifier] = ACTIONS(291),
    [anon_sym_UInt] = ACTIONS(291),
    [anon_sym_SInt] = ACTIONS(291),
    [anon_sym_wire] = ACTIONS(291),
    [anon_sym_cmem] = ACTIONS(291),
    [anon_sym_smem] = ACTIONS(291),
    [anon_sym_reg] = ACTIONS(291),
    [anon_sym_mem] = ACTIONS(291),
    [anon_sym_inst] = ACTIONS(291),
    [anon_sym_node] = ACTIONS(291),
    [anon_sym_when] = ACTIONS(291),
    [anon_sym_else] = ACTIONS(291),
    [anon_sym_stop] = ACTIONS(291),
    [anon_sym_printf] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_assume] = ACTIONS(291),
    [anon_sym_cover] = ACTIONS(291),
    [anon_sym_skip] = ACTIONS(291),
    [anon_sym_attach] = ACTIONS(291),
    [sym_info] = ACTIONS(293),
    [anon_sym_infer] = ACTIONS(291),
    [anon_sym_read] = ACTIONS(291),
    [anon_sym_write] = ACTIONS(291),
    [anon_sym_rdwr] = ACTIONS(291),
    [anon_sym_mux] = ACTIONS(291),
    [anon_sym_validif] = ACTIONS(291),
    [anon_sym_add] = ACTIONS(291),
    [anon_sym_sub] = ACTIONS(291),
    [anon_sym_mul] = ACTIONS(291),
    [anon_sym_div] = ACTIONS(291),
    [anon_sym_rem] = ACTIONS(291),
    [anon_sym_lt] = ACTIONS(291),
    [anon_sym_leq] = ACTIONS(291),
    [anon_sym_gt] = ACTIONS(291),
    [anon_sym_geq] = ACTIONS(291),
    [anon_sym_eq] = ACTIONS(291),
    [anon_sym_neq] = ACTIONS(291),
    [anon_sym_pad] = ACTIONS(291),
    [anon_sym_asUInt] = ACTIONS(291),
    [anon_sym_asAsyncReset] = ACTIONS(291),
    [anon_sym_asSInt] = ACTIONS(291),
    [anon_sym_asClock] = ACTIONS(291),
    [anon_sym_shl] = ACTIONS(291),
    [anon_sym_shr] = ACTIONS(291),
    [anon_sym_dshl] = ACTIONS(291),
    [anon_sym_dshlw] = ACTIONS(291),
    [anon_sym_dshr] = ACTIONS(291),
    [anon_sym_dshrw] = ACTIONS(291),
    [anon_sym_cvt] = ACTIONS(291),
    [anon_sym_neg] = ACTIONS(291),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_xor] = ACTIONS(291),
    [anon_sym_andr] = ACTIONS(291),
    [anon_sym_orr] = ACTIONS(291),
    [anon_sym_xorr] = ACTIONS(291),
    [anon_sym_cat] = ACTIONS(291),
    [anon_sym_bits] = ACTIONS(291),
    [anon_sym_head] = ACTIONS(291),
    [anon_sym_tail] = ACTIONS(291),
    [anon_sym_asFixedPoint] = ACTIONS(291),
    [anon_sym_bpshl] = ACTIONS(291),
    [anon_sym_bpshr] = ACTIONS(291),
    [anon_sym_bpset] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(295),
  },
  [52] = {
    [sym_identifier] = ACTIONS(297),
    [anon_sym_UInt] = ACTIONS(297),
    [anon_sym_SInt] = ACTIONS(297),
    [anon_sym_wire] = ACTIONS(297),
    [anon_sym_cmem] = ACTIONS(297),
    [anon_sym_smem] = ACTIONS(297),
    [anon_sym_reg] = ACTIONS(297),
    [anon_sym_mem] = ACTIONS(297),
    [anon_sym_inst] = ACTIONS(297),
    [anon_sym_node] = ACTIONS(297),
    [anon_sym_when] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(297),
    [anon_sym_stop] = ACTIONS(297),
    [anon_sym_printf] = ACTIONS(297),
    [anon_sym_assert] = ACTIONS(297),
    [anon_sym_assume] = ACTIONS(297),
    [anon_sym_cover] = ACTIONS(297),
    [anon_sym_skip] = ACTIONS(297),
    [anon_sym_attach] = ACTIONS(297),
    [sym_info] = ACTIONS(299),
    [anon_sym_infer] = ACTIONS(297),
    [anon_sym_read] = ACTIONS(297),
    [anon_sym_write] = ACTIONS(297),
    [anon_sym_rdwr] = ACTIONS(297),
    [anon_sym_mux] = ACTIONS(297),
    [anon_sym_validif] = ACTIONS(297),
    [anon_sym_add] = ACTIONS(297),
    [anon_sym_sub] = ACTIONS(297),
    [anon_sym_mul] = ACTIONS(297),
    [anon_sym_div] = ACTIONS(297),
    [anon_sym_rem] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_leq] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_geq] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_neq] = ACTIONS(297),
    [anon_sym_pad] = ACTIONS(297),
    [anon_sym_asUInt] = ACTIONS(297),
    [anon_sym_asAsyncReset] = ACTIONS(297),
    [anon_sym_asSInt] = ACTIONS(297),
    [anon_sym_asClock] = ACTIONS(297),
    [anon_sym_shl] = ACTIONS(297),
    [anon_sym_shr] = ACTIONS(297),
    [anon_sym_dshl] = ACTIONS(297),
    [anon_sym_dshlw] = ACTIONS(297),
    [anon_sym_dshr] = ACTIONS(297),
    [anon_sym_dshrw] = ACTIONS(297),
    [anon_sym_cvt] = ACTIONS(297),
    [anon_sym_neg] = ACTIONS(297),
    [anon_sym_not] = ACTIONS(297),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_xor] = ACTIONS(297),
    [anon_sym_andr] = ACTIONS(297),
    [anon_sym_orr] = ACTIONS(297),
    [anon_sym_xorr] = ACTIONS(297),
    [anon_sym_cat] = ACTIONS(297),
    [anon_sym_bits] = ACTIONS(297),
    [anon_sym_head] = ACTIONS(297),
    [anon_sym_tail] = ACTIONS(297),
    [anon_sym_asFixedPoint] = ACTIONS(297),
    [anon_sym_bpshl] = ACTIONS(297),
    [anon_sym_bpshr] = ACTIONS(297),
    [anon_sym_bpset] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(301),
  },
  [53] = {
    [sym_identifier] = ACTIONS(303),
    [anon_sym_UInt] = ACTIONS(303),
    [anon_sym_SInt] = ACTIONS(303),
    [anon_sym_wire] = ACTIONS(303),
    [anon_sym_cmem] = ACTIONS(303),
    [anon_sym_smem] = ACTIONS(303),
    [anon_sym_reg] = ACTIONS(303),
    [anon_sym_mem] = ACTIONS(303),
    [anon_sym_inst] = ACTIONS(303),
    [anon_sym_node] = ACTIONS(303),
    [anon_sym_when] = ACTIONS(303),
    [anon_sym_else] = ACTIONS(303),
    [anon_sym_stop] = ACTIONS(303),
    [anon_sym_printf] = ACTIONS(303),
    [anon_sym_assert] = ACTIONS(303),
    [anon_sym_assume] = ACTIONS(303),
    [anon_sym_cover] = ACTIONS(303),
    [anon_sym_skip] = ACTIONS(303),
    [anon_sym_attach] = ACTIONS(303),
    [sym_info] = ACTIONS(305),
    [anon_sym_infer] = ACTIONS(303),
    [anon_sym_read] = ACTIONS(303),
    [anon_sym_write] = ACTIONS(303),
    [anon_sym_rdwr] = ACTIONS(303),
    [anon_sym_mux] = ACTIONS(303),
    [anon_sym_validif] = ACTIONS(303),
    [anon_sym_add] = ACTIONS(303),
    [anon_sym_sub] = ACTIONS(303),
    [anon_sym_mul] = ACTIONS(303),
    [anon_sym_div] = ACTIONS(303),
    [anon_sym_rem] = ACTIONS(303),
    [anon_sym_lt] = ACTIONS(303),
    [anon_sym_leq] = ACTIONS(303),
    [anon_sym_gt] = ACTIONS(303),
    [anon_sym_geq] = ACTIONS(303),
    [anon_sym_eq] = ACTIONS(303),
    [anon_sym_neq] = ACTIONS(303),
    [anon_sym_pad] = ACTIONS(303),
    [anon_sym_asUInt] = ACTIONS(303),
    [anon_sym_asAsyncReset] = ACTIONS(303),
    [anon_sym_asSInt] = ACTIONS(303),
    [anon_sym_asClock] = ACTIONS(303),
    [anon_sym_shl] = ACTIONS(303),
    [anon_sym_shr] = ACTIONS(303),
    [anon_sym_dshl] = ACTIONS(303),
    [anon_sym_dshlw] = ACTIONS(303),
    [anon_sym_dshr] = ACTIONS(303),
    [anon_sym_dshrw] = ACTIONS(303),
    [anon_sym_cvt] = ACTIONS(303),
    [anon_sym_neg] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_xor] = ACTIONS(303),
    [anon_sym_andr] = ACTIONS(303),
    [anon_sym_orr] = ACTIONS(303),
    [anon_sym_xorr] = ACTIONS(303),
    [anon_sym_cat] = ACTIONS(303),
    [anon_sym_bits] = ACTIONS(303),
    [anon_sym_head] = ACTIONS(303),
    [anon_sym_tail] = ACTIONS(303),
    [anon_sym_asFixedPoint] = ACTIONS(303),
    [anon_sym_bpshl] = ACTIONS(303),
    [anon_sym_bpshr] = ACTIONS(303),
    [anon_sym_bpset] = ACTIONS(303),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(307),
  },
  [54] = {
    [sym_identifier] = ACTIONS(309),
    [anon_sym_UInt] = ACTIONS(309),
    [anon_sym_SInt] = ACTIONS(309),
    [anon_sym_wire] = ACTIONS(309),
    [anon_sym_cmem] = ACTIONS(309),
    [anon_sym_smem] = ACTIONS(309),
    [anon_sym_reg] = ACTIONS(309),
    [anon_sym_mem] = ACTIONS(309),
    [anon_sym_inst] = ACTIONS(309),
    [anon_sym_node] = ACTIONS(309),
    [anon_sym_when] = ACTIONS(309),
    [anon_sym_else] = ACTIONS(309),
    [anon_sym_stop] = ACTIONS(309),
    [anon_sym_printf] = ACTIONS(309),
    [anon_sym_assert] = ACTIONS(309),
    [anon_sym_assume] = ACTIONS(309),
    [anon_sym_cover] = ACTIONS(309),
    [anon_sym_skip] = ACTIONS(309),
    [anon_sym_attach] = ACTIONS(309),
    [sym_info] = ACTIONS(311),
    [anon_sym_infer] = ACTIONS(309),
    [anon_sym_read] = ACTIONS(309),
    [anon_sym_write] = ACTIONS(309),
    [anon_sym_rdwr] = ACTIONS(309),
    [anon_sym_mux] = ACTIONS(309),
    [anon_sym_validif] = ACTIONS(309),
    [anon_sym_add] = ACTIONS(309),
    [anon_sym_sub] = ACTIONS(309),
    [anon_sym_mul] = ACTIONS(309),
    [anon_sym_div] = ACTIONS(309),
    [anon_sym_rem] = ACTIONS(309),
    [anon_sym_lt] = ACTIONS(309),
    [anon_sym_leq] = ACTIONS(309),
    [anon_sym_gt] = ACTIONS(309),
    [anon_sym_geq] = ACTIONS(309),
    [anon_sym_eq] = ACTIONS(309),
    [anon_sym_neq] = ACTIONS(309),
    [anon_sym_pad] = ACTIONS(309),
    [anon_sym_asUInt] = ACTIONS(309),
    [anon_sym_asAsyncReset] = ACTIONS(309),
    [anon_sym_asSInt] = ACTIONS(309),
    [anon_sym_asClock] = ACTIONS(309),
    [anon_sym_shl] = ACTIONS(309),
    [anon_sym_shr] = ACTIONS(309),
    [anon_sym_dshl] = ACTIONS(309),
    [anon_sym_dshlw] = ACTIONS(309),
    [anon_sym_dshr] = ACTIONS(309),
    [anon_sym_dshrw] = ACTIONS(309),
    [anon_sym_cvt] = ACTIONS(309),
    [anon_sym_neg] = ACTIONS(309),
    [anon_sym_not] = ACTIONS(309),
    [anon_sym_and] = ACTIONS(309),
    [anon_sym_or] = ACTIONS(309),
    [anon_sym_xor] = ACTIONS(309),
    [anon_sym_andr] = ACTIONS(309),
    [anon_sym_orr] = ACTIONS(309),
    [anon_sym_xorr] = ACTIONS(309),
    [anon_sym_cat] = ACTIONS(309),
    [anon_sym_bits] = ACTIONS(309),
    [anon_sym_head] = ACTIONS(309),
    [anon_sym_tail] = ACTIONS(309),
    [anon_sym_asFixedPoint] = ACTIONS(309),
    [anon_sym_bpshl] = ACTIONS(309),
    [anon_sym_bpshr] = ACTIONS(309),
    [anon_sym_bpset] = ACTIONS(309),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(313),
  },
  [55] = {
    [sym_identifier] = ACTIONS(315),
    [anon_sym_UInt] = ACTIONS(315),
    [anon_sym_SInt] = ACTIONS(315),
    [anon_sym_wire] = ACTIONS(315),
    [anon_sym_cmem] = ACTIONS(315),
    [anon_sym_smem] = ACTIONS(315),
    [anon_sym_reg] = ACTIONS(315),
    [anon_sym_mem] = ACTIONS(315),
    [anon_sym_inst] = ACTIONS(315),
    [anon_sym_node] = ACTIONS(315),
    [anon_sym_when] = ACTIONS(315),
    [anon_sym_else] = ACTIONS(315),
    [anon_sym_stop] = ACTIONS(315),
    [anon_sym_printf] = ACTIONS(315),
    [anon_sym_assert] = ACTIONS(315),
    [anon_sym_assume] = ACTIONS(315),
    [anon_sym_cover] = ACTIONS(315),
    [anon_sym_skip] = ACTIONS(315),
    [anon_sym_attach] = ACTIONS(315),
    [sym_info] = ACTIONS(317),
    [anon_sym_infer] = ACTIONS(315),
    [anon_sym_read] = ACTIONS(315),
    [anon_sym_write] = ACTIONS(315),
    [anon_sym_rdwr] = ACTIONS(315),
    [anon_sym_mux] = ACTIONS(315),
    [anon_sym_validif] = ACTIONS(315),
    [anon_sym_add] = ACTIONS(315),
    [anon_sym_sub] = ACTIONS(315),
    [anon_sym_mul] = ACTIONS(315),
    [anon_sym_div] = ACTIONS(315),
    [anon_sym_rem] = ACTIONS(315),
    [anon_sym_lt] = ACTIONS(315),
    [anon_sym_leq] = ACTIONS(315),
    [anon_sym_gt] = ACTIONS(315),
    [anon_sym_geq] = ACTIONS(315),
    [anon_sym_eq] = ACTIONS(315),
    [anon_sym_neq] = ACTIONS(315),
    [anon_sym_pad] = ACTIONS(315),
    [anon_sym_asUInt] = ACTIONS(315),
    [anon_sym_asAsyncReset] = ACTIONS(315),
    [anon_sym_asSInt] = ACTIONS(315),
    [anon_sym_asClock] = ACTIONS(315),
    [anon_sym_shl] = ACTIONS(315),
    [anon_sym_shr] = ACTIONS(315),
    [anon_sym_dshl] = ACTIONS(315),
    [anon_sym_dshlw] = ACTIONS(315),
    [anon_sym_dshr] = ACTIONS(315),
    [anon_sym_dshrw] = ACTIONS(315),
    [anon_sym_cvt] = ACTIONS(315),
    [anon_sym_neg] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(315),
    [anon_sym_or] = ACTIONS(315),
    [anon_sym_xor] = ACTIONS(315),
    [anon_sym_andr] = ACTIONS(315),
    [anon_sym_orr] = ACTIONS(315),
    [anon_sym_xorr] = ACTIONS(315),
    [anon_sym_cat] = ACTIONS(315),
    [anon_sym_bits] = ACTIONS(315),
    [anon_sym_head] = ACTIONS(315),
    [anon_sym_tail] = ACTIONS(315),
    [anon_sym_asFixedPoint] = ACTIONS(315),
    [anon_sym_bpshl] = ACTIONS(315),
    [anon_sym_bpshr] = ACTIONS(315),
    [anon_sym_bpset] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(319),
  },
  [56] = {
    [sym_identifier] = ACTIONS(321),
    [anon_sym_UInt] = ACTIONS(321),
    [anon_sym_SInt] = ACTIONS(321),
    [anon_sym_wire] = ACTIONS(321),
    [anon_sym_cmem] = ACTIONS(321),
    [anon_sym_smem] = ACTIONS(321),
    [anon_sym_reg] = ACTIONS(321),
    [anon_sym_mem] = ACTIONS(321),
    [anon_sym_inst] = ACTIONS(321),
    [anon_sym_node] = ACTIONS(321),
    [anon_sym_when] = ACTIONS(321),
    [anon_sym_else] = ACTIONS(321),
    [anon_sym_stop] = ACTIONS(321),
    [anon_sym_printf] = ACTIONS(321),
    [anon_sym_assert] = ACTIONS(321),
    [anon_sym_assume] = ACTIONS(321),
    [anon_sym_cover] = ACTIONS(321),
    [anon_sym_skip] = ACTIONS(321),
    [anon_sym_attach] = ACTIONS(321),
    [sym_info] = ACTIONS(323),
    [anon_sym_infer] = ACTIONS(321),
    [anon_sym_read] = ACTIONS(321),
    [anon_sym_write] = ACTIONS(321),
    [anon_sym_rdwr] = ACTIONS(321),
    [anon_sym_mux] = ACTIONS(321),
    [anon_sym_validif] = ACTIONS(321),
    [anon_sym_add] = ACTIONS(321),
    [anon_sym_sub] = ACTIONS(321),
    [anon_sym_mul] = ACTIONS(321),
    [anon_sym_div] = ACTIONS(321),
    [anon_sym_rem] = ACTIONS(321),
    [anon_sym_lt] = ACTIONS(321),
    [anon_sym_leq] = ACTIONS(321),
    [anon_sym_gt] = ACTIONS(321),
    [anon_sym_geq] = ACTIONS(321),
    [anon_sym_eq] = ACTIONS(321),
    [anon_sym_neq] = ACTIONS(321),
    [anon_sym_pad] = ACTIONS(321),
    [anon_sym_asUInt] = ACTIONS(321),
    [anon_sym_asAsyncReset] = ACTIONS(321),
    [anon_sym_asSInt] = ACTIONS(321),
    [anon_sym_asClock] = ACTIONS(321),
    [anon_sym_shl] = ACTIONS(321),
    [anon_sym_shr] = ACTIONS(321),
    [anon_sym_dshl] = ACTIONS(321),
    [anon_sym_dshlw] = ACTIONS(321),
    [anon_sym_dshr] = ACTIONS(321),
    [anon_sym_dshrw] = ACTIONS(321),
    [anon_sym_cvt] = ACTIONS(321),
    [anon_sym_neg] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(321),
    [anon_sym_and] = ACTIONS(321),
    [anon_sym_or] = ACTIONS(321),
    [anon_sym_xor] = ACTIONS(321),
    [anon_sym_andr] = ACTIONS(321),
    [anon_sym_orr] = ACTIONS(321),
    [anon_sym_xorr] = ACTIONS(321),
    [anon_sym_cat] = ACTIONS(321),
    [anon_sym_bits] = ACTIONS(321),
    [anon_sym_head] = ACTIONS(321),
    [anon_sym_tail] = ACTIONS(321),
    [anon_sym_asFixedPoint] = ACTIONS(321),
    [anon_sym_bpshl] = ACTIONS(321),
    [anon_sym_bpshr] = ACTIONS(321),
    [anon_sym_bpset] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(325),
  },
  [57] = {
    [sym_identifier] = ACTIONS(327),
    [anon_sym_UInt] = ACTIONS(327),
    [anon_sym_SInt] = ACTIONS(327),
    [anon_sym_wire] = ACTIONS(327),
    [anon_sym_cmem] = ACTIONS(327),
    [anon_sym_smem] = ACTIONS(327),
    [anon_sym_reg] = ACTIONS(327),
    [anon_sym_mem] = ACTIONS(327),
    [anon_sym_inst] = ACTIONS(327),
    [anon_sym_node] = ACTIONS(327),
    [anon_sym_when] = ACTIONS(327),
    [anon_sym_else] = ACTIONS(327),
    [anon_sym_stop] = ACTIONS(327),
    [anon_sym_printf] = ACTIONS(327),
    [anon_sym_assert] = ACTIONS(327),
    [anon_sym_assume] = ACTIONS(327),
    [anon_sym_cover] = ACTIONS(327),
    [anon_sym_skip] = ACTIONS(327),
    [anon_sym_attach] = ACTIONS(327),
    [sym_info] = ACTIONS(329),
    [anon_sym_infer] = ACTIONS(327),
    [anon_sym_read] = ACTIONS(327),
    [anon_sym_write] = ACTIONS(327),
    [anon_sym_rdwr] = ACTIONS(327),
    [anon_sym_mux] = ACTIONS(327),
    [anon_sym_validif] = ACTIONS(327),
    [anon_sym_add] = ACTIONS(327),
    [anon_sym_sub] = ACTIONS(327),
    [anon_sym_mul] = ACTIONS(327),
    [anon_sym_div] = ACTIONS(327),
    [anon_sym_rem] = ACTIONS(327),
    [anon_sym_lt] = ACTIONS(327),
    [anon_sym_leq] = ACTIONS(327),
    [anon_sym_gt] = ACTIONS(327),
    [anon_sym_geq] = ACTIONS(327),
    [anon_sym_eq] = ACTIONS(327),
    [anon_sym_neq] = ACTIONS(327),
    [anon_sym_pad] = ACTIONS(327),
    [anon_sym_asUInt] = ACTIONS(327),
    [anon_sym_asAsyncReset] = ACTIONS(327),
    [anon_sym_asSInt] = ACTIONS(327),
    [anon_sym_asClock] = ACTIONS(327),
    [anon_sym_shl] = ACTIONS(327),
    [anon_sym_shr] = ACTIONS(327),
    [anon_sym_dshl] = ACTIONS(327),
    [anon_sym_dshlw] = ACTIONS(327),
    [anon_sym_dshr] = ACTIONS(327),
    [anon_sym_dshrw] = ACTIONS(327),
    [anon_sym_cvt] = ACTIONS(327),
    [anon_sym_neg] = ACTIONS(327),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_and] = ACTIONS(327),
    [anon_sym_or] = ACTIONS(327),
    [anon_sym_xor] = ACTIONS(327),
    [anon_sym_andr] = ACTIONS(327),
    [anon_sym_orr] = ACTIONS(327),
    [anon_sym_xorr] = ACTIONS(327),
    [anon_sym_cat] = ACTIONS(327),
    [anon_sym_bits] = ACTIONS(327),
    [anon_sym_head] = ACTIONS(327),
    [anon_sym_tail] = ACTIONS(327),
    [anon_sym_asFixedPoint] = ACTIONS(327),
    [anon_sym_bpshl] = ACTIONS(327),
    [anon_sym_bpshr] = ACTIONS(327),
    [anon_sym_bpset] = ACTIONS(327),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(331),
  },
  [58] = {
    [sym_else] = STATE(88),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_UInt] = ACTIONS(333),
    [anon_sym_SInt] = ACTIONS(333),
    [anon_sym_wire] = ACTIONS(333),
    [anon_sym_cmem] = ACTIONS(333),
    [anon_sym_smem] = ACTIONS(333),
    [anon_sym_reg] = ACTIONS(333),
    [anon_sym_mem] = ACTIONS(333),
    [anon_sym_inst] = ACTIONS(333),
    [anon_sym_node] = ACTIONS(333),
    [anon_sym_when] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(55),
    [anon_sym_stop] = ACTIONS(333),
    [anon_sym_printf] = ACTIONS(333),
    [anon_sym_assert] = ACTIONS(333),
    [anon_sym_assume] = ACTIONS(333),
    [anon_sym_cover] = ACTIONS(333),
    [anon_sym_skip] = ACTIONS(333),
    [anon_sym_attach] = ACTIONS(333),
    [anon_sym_infer] = ACTIONS(333),
    [anon_sym_read] = ACTIONS(333),
    [anon_sym_write] = ACTIONS(333),
    [anon_sym_rdwr] = ACTIONS(333),
    [anon_sym_mux] = ACTIONS(333),
    [anon_sym_validif] = ACTIONS(333),
    [anon_sym_add] = ACTIONS(333),
    [anon_sym_sub] = ACTIONS(333),
    [anon_sym_mul] = ACTIONS(333),
    [anon_sym_div] = ACTIONS(333),
    [anon_sym_rem] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(333),
    [anon_sym_leq] = ACTIONS(333),
    [anon_sym_gt] = ACTIONS(333),
    [anon_sym_geq] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(333),
    [anon_sym_neq] = ACTIONS(333),
    [anon_sym_pad] = ACTIONS(333),
    [anon_sym_asUInt] = ACTIONS(333),
    [anon_sym_asAsyncReset] = ACTIONS(333),
    [anon_sym_asSInt] = ACTIONS(333),
    [anon_sym_asClock] = ACTIONS(333),
    [anon_sym_shl] = ACTIONS(333),
    [anon_sym_shr] = ACTIONS(333),
    [anon_sym_dshl] = ACTIONS(333),
    [anon_sym_dshlw] = ACTIONS(333),
    [anon_sym_dshr] = ACTIONS(333),
    [anon_sym_dshrw] = ACTIONS(333),
    [anon_sym_cvt] = ACTIONS(333),
    [anon_sym_neg] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_xor] = ACTIONS(333),
    [anon_sym_andr] = ACTIONS(333),
    [anon_sym_orr] = ACTIONS(333),
    [anon_sym_xorr] = ACTIONS(333),
    [anon_sym_cat] = ACTIONS(333),
    [anon_sym_bits] = ACTIONS(333),
    [anon_sym_head] = ACTIONS(333),
    [anon_sym_tail] = ACTIONS(333),
    [anon_sym_asFixedPoint] = ACTIONS(333),
    [anon_sym_bpshl] = ACTIONS(333),
    [anon_sym_bpshr] = ACTIONS(333),
    [anon_sym_bpset] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(335),
  },
  [59] = {
    [sym_identifier] = ACTIONS(337),
    [anon_sym_UInt] = ACTIONS(337),
    [anon_sym_SInt] = ACTIONS(337),
    [anon_sym_wire] = ACTIONS(337),
    [anon_sym_cmem] = ACTIONS(337),
    [anon_sym_smem] = ACTIONS(337),
    [anon_sym_reg] = ACTIONS(337),
    [anon_sym_mem] = ACTIONS(337),
    [anon_sym_inst] = ACTIONS(337),
    [anon_sym_node] = ACTIONS(337),
    [anon_sym_when] = ACTIONS(337),
    [anon_sym_else] = ACTIONS(337),
    [anon_sym_stop] = ACTIONS(337),
    [anon_sym_printf] = ACTIONS(337),
    [anon_sym_assert] = ACTIONS(337),
    [anon_sym_assume] = ACTIONS(337),
    [anon_sym_cover] = ACTIONS(337),
    [anon_sym_skip] = ACTIONS(337),
    [anon_sym_attach] = ACTIONS(337),
    [sym_info] = ACTIONS(339),
    [anon_sym_infer] = ACTIONS(337),
    [anon_sym_read] = ACTIONS(337),
    [anon_sym_write] = ACTIONS(337),
    [anon_sym_rdwr] = ACTIONS(337),
    [anon_sym_mux] = ACTIONS(337),
    [anon_sym_validif] = ACTIONS(337),
    [anon_sym_add] = ACTIONS(337),
    [anon_sym_sub] = ACTIONS(337),
    [anon_sym_mul] = ACTIONS(337),
    [anon_sym_div] = ACTIONS(337),
    [anon_sym_rem] = ACTIONS(337),
    [anon_sym_lt] = ACTIONS(337),
    [anon_sym_leq] = ACTIONS(337),
    [anon_sym_gt] = ACTIONS(337),
    [anon_sym_geq] = ACTIONS(337),
    [anon_sym_eq] = ACTIONS(337),
    [anon_sym_neq] = ACTIONS(337),
    [anon_sym_pad] = ACTIONS(337),
    [anon_sym_asUInt] = ACTIONS(337),
    [anon_sym_asAsyncReset] = ACTIONS(337),
    [anon_sym_asSInt] = ACTIONS(337),
    [anon_sym_asClock] = ACTIONS(337),
    [anon_sym_shl] = ACTIONS(337),
    [anon_sym_shr] = ACTIONS(337),
    [anon_sym_dshl] = ACTIONS(337),
    [anon_sym_dshlw] = ACTIONS(337),
    [anon_sym_dshr] = ACTIONS(337),
    [anon_sym_dshrw] = ACTIONS(337),
    [anon_sym_cvt] = ACTIONS(337),
    [anon_sym_neg] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(337),
    [anon_sym_and] = ACTIONS(337),
    [anon_sym_or] = ACTIONS(337),
    [anon_sym_xor] = ACTIONS(337),
    [anon_sym_andr] = ACTIONS(337),
    [anon_sym_orr] = ACTIONS(337),
    [anon_sym_xorr] = ACTIONS(337),
    [anon_sym_cat] = ACTIONS(337),
    [anon_sym_bits] = ACTIONS(337),
    [anon_sym_head] = ACTIONS(337),
    [anon_sym_tail] = ACTIONS(337),
    [anon_sym_asFixedPoint] = ACTIONS(337),
    [anon_sym_bpshl] = ACTIONS(337),
    [anon_sym_bpshr] = ACTIONS(337),
    [anon_sym_bpset] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(339),
  },
  [60] = {
    [sym_identifier] = ACTIONS(341),
    [anon_sym_UInt] = ACTIONS(341),
    [anon_sym_SInt] = ACTIONS(341),
    [anon_sym_wire] = ACTIONS(341),
    [anon_sym_cmem] = ACTIONS(341),
    [anon_sym_smem] = ACTIONS(341),
    [anon_sym_reg] = ACTIONS(341),
    [anon_sym_mem] = ACTIONS(341),
    [anon_sym_inst] = ACTIONS(341),
    [anon_sym_node] = ACTIONS(341),
    [anon_sym_when] = ACTIONS(341),
    [anon_sym_else] = ACTIONS(341),
    [anon_sym_stop] = ACTIONS(341),
    [anon_sym_printf] = ACTIONS(341),
    [anon_sym_assert] = ACTIONS(341),
    [anon_sym_assume] = ACTIONS(341),
    [anon_sym_cover] = ACTIONS(341),
    [anon_sym_skip] = ACTIONS(341),
    [anon_sym_attach] = ACTIONS(341),
    [sym_info] = ACTIONS(343),
    [anon_sym_infer] = ACTIONS(341),
    [anon_sym_read] = ACTIONS(341),
    [anon_sym_write] = ACTIONS(341),
    [anon_sym_rdwr] = ACTIONS(341),
    [anon_sym_mux] = ACTIONS(341),
    [anon_sym_validif] = ACTIONS(341),
    [anon_sym_add] = ACTIONS(341),
    [anon_sym_sub] = ACTIONS(341),
    [anon_sym_mul] = ACTIONS(341),
    [anon_sym_div] = ACTIONS(341),
    [anon_sym_rem] = ACTIONS(341),
    [anon_sym_lt] = ACTIONS(341),
    [anon_sym_leq] = ACTIONS(341),
    [anon_sym_gt] = ACTIONS(341),
    [anon_sym_geq] = ACTIONS(341),
    [anon_sym_eq] = ACTIONS(341),
    [anon_sym_neq] = ACTIONS(341),
    [anon_sym_pad] = ACTIONS(341),
    [anon_sym_asUInt] = ACTIONS(341),
    [anon_sym_asAsyncReset] = ACTIONS(341),
    [anon_sym_asSInt] = ACTIONS(341),
    [anon_sym_asClock] = ACTIONS(341),
    [anon_sym_shl] = ACTIONS(341),
    [anon_sym_shr] = ACTIONS(341),
    [anon_sym_dshl] = ACTIONS(341),
    [anon_sym_dshlw] = ACTIONS(341),
    [anon_sym_dshr] = ACTIONS(341),
    [anon_sym_dshrw] = ACTIONS(341),
    [anon_sym_cvt] = ACTIONS(341),
    [anon_sym_neg] = ACTIONS(341),
    [anon_sym_not] = ACTIONS(341),
    [anon_sym_and] = ACTIONS(341),
    [anon_sym_or] = ACTIONS(341),
    [anon_sym_xor] = ACTIONS(341),
    [anon_sym_andr] = ACTIONS(341),
    [anon_sym_orr] = ACTIONS(341),
    [anon_sym_xorr] = ACTIONS(341),
    [anon_sym_cat] = ACTIONS(341),
    [anon_sym_bits] = ACTIONS(341),
    [anon_sym_head] = ACTIONS(341),
    [anon_sym_tail] = ACTIONS(341),
    [anon_sym_asFixedPoint] = ACTIONS(341),
    [anon_sym_bpshl] = ACTIONS(341),
    [anon_sym_bpshr] = ACTIONS(341),
    [anon_sym_bpset] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(343),
  },
  [61] = {
    [sym_identifier] = ACTIONS(345),
    [anon_sym_UInt] = ACTIONS(345),
    [anon_sym_SInt] = ACTIONS(345),
    [anon_sym_wire] = ACTIONS(345),
    [anon_sym_cmem] = ACTIONS(345),
    [anon_sym_smem] = ACTIONS(345),
    [anon_sym_reg] = ACTIONS(345),
    [anon_sym_mem] = ACTIONS(345),
    [anon_sym_inst] = ACTIONS(345),
    [anon_sym_node] = ACTIONS(345),
    [anon_sym_when] = ACTIONS(345),
    [anon_sym_else] = ACTIONS(345),
    [anon_sym_stop] = ACTIONS(345),
    [anon_sym_printf] = ACTIONS(345),
    [anon_sym_assert] = ACTIONS(345),
    [anon_sym_assume] = ACTIONS(345),
    [anon_sym_cover] = ACTIONS(345),
    [anon_sym_skip] = ACTIONS(345),
    [anon_sym_attach] = ACTIONS(345),
    [sym_info] = ACTIONS(347),
    [anon_sym_infer] = ACTIONS(345),
    [anon_sym_read] = ACTIONS(345),
    [anon_sym_write] = ACTIONS(345),
    [anon_sym_rdwr] = ACTIONS(345),
    [anon_sym_mux] = ACTIONS(345),
    [anon_sym_validif] = ACTIONS(345),
    [anon_sym_add] = ACTIONS(345),
    [anon_sym_sub] = ACTIONS(345),
    [anon_sym_mul] = ACTIONS(345),
    [anon_sym_div] = ACTIONS(345),
    [anon_sym_rem] = ACTIONS(345),
    [anon_sym_lt] = ACTIONS(345),
    [anon_sym_leq] = ACTIONS(345),
    [anon_sym_gt] = ACTIONS(345),
    [anon_sym_geq] = ACTIONS(345),
    [anon_sym_eq] = ACTIONS(345),
    [anon_sym_neq] = ACTIONS(345),
    [anon_sym_pad] = ACTIONS(345),
    [anon_sym_asUInt] = ACTIONS(345),
    [anon_sym_asAsyncReset] = ACTIONS(345),
    [anon_sym_asSInt] = ACTIONS(345),
    [anon_sym_asClock] = ACTIONS(345),
    [anon_sym_shl] = ACTIONS(345),
    [anon_sym_shr] = ACTIONS(345),
    [anon_sym_dshl] = ACTIONS(345),
    [anon_sym_dshlw] = ACTIONS(345),
    [anon_sym_dshr] = ACTIONS(345),
    [anon_sym_dshrw] = ACTIONS(345),
    [anon_sym_cvt] = ACTIONS(345),
    [anon_sym_neg] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(345),
    [anon_sym_and] = ACTIONS(345),
    [anon_sym_or] = ACTIONS(345),
    [anon_sym_xor] = ACTIONS(345),
    [anon_sym_andr] = ACTIONS(345),
    [anon_sym_orr] = ACTIONS(345),
    [anon_sym_xorr] = ACTIONS(345),
    [anon_sym_cat] = ACTIONS(345),
    [anon_sym_bits] = ACTIONS(345),
    [anon_sym_head] = ACTIONS(345),
    [anon_sym_tail] = ACTIONS(345),
    [anon_sym_asFixedPoint] = ACTIONS(345),
    [anon_sym_bpshl] = ACTIONS(345),
    [anon_sym_bpshr] = ACTIONS(345),
    [anon_sym_bpset] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(349),
  },
  [62] = {
    [sym_identifier] = ACTIONS(351),
    [anon_sym_UInt] = ACTIONS(351),
    [anon_sym_SInt] = ACTIONS(351),
    [anon_sym_wire] = ACTIONS(351),
    [anon_sym_cmem] = ACTIONS(351),
    [anon_sym_smem] = ACTIONS(351),
    [anon_sym_reg] = ACTIONS(351),
    [anon_sym_mem] = ACTIONS(351),
    [anon_sym_inst] = ACTIONS(351),
    [anon_sym_node] = ACTIONS(351),
    [anon_sym_when] = ACTIONS(351),
    [anon_sym_else] = ACTIONS(351),
    [anon_sym_stop] = ACTIONS(351),
    [anon_sym_printf] = ACTIONS(351),
    [anon_sym_assert] = ACTIONS(351),
    [anon_sym_assume] = ACTIONS(351),
    [anon_sym_cover] = ACTIONS(351),
    [anon_sym_skip] = ACTIONS(351),
    [anon_sym_attach] = ACTIONS(351),
    [sym_info] = ACTIONS(353),
    [anon_sym_infer] = ACTIONS(351),
    [anon_sym_read] = ACTIONS(351),
    [anon_sym_write] = ACTIONS(351),
    [anon_sym_rdwr] = ACTIONS(351),
    [anon_sym_mux] = ACTIONS(351),
    [anon_sym_validif] = ACTIONS(351),
    [anon_sym_add] = ACTIONS(351),
    [anon_sym_sub] = ACTIONS(351),
    [anon_sym_mul] = ACTIONS(351),
    [anon_sym_div] = ACTIONS(351),
    [anon_sym_rem] = ACTIONS(351),
    [anon_sym_lt] = ACTIONS(351),
    [anon_sym_leq] = ACTIONS(351),
    [anon_sym_gt] = ACTIONS(351),
    [anon_sym_geq] = ACTIONS(351),
    [anon_sym_eq] = ACTIONS(351),
    [anon_sym_neq] = ACTIONS(351),
    [anon_sym_pad] = ACTIONS(351),
    [anon_sym_asUInt] = ACTIONS(351),
    [anon_sym_asAsyncReset] = ACTIONS(351),
    [anon_sym_asSInt] = ACTIONS(351),
    [anon_sym_asClock] = ACTIONS(351),
    [anon_sym_shl] = ACTIONS(351),
    [anon_sym_shr] = ACTIONS(351),
    [anon_sym_dshl] = ACTIONS(351),
    [anon_sym_dshlw] = ACTIONS(351),
    [anon_sym_dshr] = ACTIONS(351),
    [anon_sym_dshrw] = ACTIONS(351),
    [anon_sym_cvt] = ACTIONS(351),
    [anon_sym_neg] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_and] = ACTIONS(351),
    [anon_sym_or] = ACTIONS(351),
    [anon_sym_xor] = ACTIONS(351),
    [anon_sym_andr] = ACTIONS(351),
    [anon_sym_orr] = ACTIONS(351),
    [anon_sym_xorr] = ACTIONS(351),
    [anon_sym_cat] = ACTIONS(351),
    [anon_sym_bits] = ACTIONS(351),
    [anon_sym_head] = ACTIONS(351),
    [anon_sym_tail] = ACTIONS(351),
    [anon_sym_asFixedPoint] = ACTIONS(351),
    [anon_sym_bpshl] = ACTIONS(351),
    [anon_sym_bpshr] = ACTIONS(351),
    [anon_sym_bpset] = ACTIONS(351),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(355),
  },
  [63] = {
    [sym_else] = STATE(76),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_UInt] = ACTIONS(357),
    [anon_sym_SInt] = ACTIONS(357),
    [anon_sym_wire] = ACTIONS(357),
    [anon_sym_cmem] = ACTIONS(357),
    [anon_sym_smem] = ACTIONS(357),
    [anon_sym_reg] = ACTIONS(357),
    [anon_sym_mem] = ACTIONS(357),
    [anon_sym_inst] = ACTIONS(357),
    [anon_sym_node] = ACTIONS(357),
    [anon_sym_when] = ACTIONS(357),
    [anon_sym_else] = ACTIONS(55),
    [anon_sym_stop] = ACTIONS(357),
    [anon_sym_printf] = ACTIONS(357),
    [anon_sym_assert] = ACTIONS(357),
    [anon_sym_assume] = ACTIONS(357),
    [anon_sym_cover] = ACTIONS(357),
    [anon_sym_skip] = ACTIONS(357),
    [anon_sym_attach] = ACTIONS(357),
    [anon_sym_infer] = ACTIONS(357),
    [anon_sym_read] = ACTIONS(357),
    [anon_sym_write] = ACTIONS(357),
    [anon_sym_rdwr] = ACTIONS(357),
    [anon_sym_mux] = ACTIONS(357),
    [anon_sym_validif] = ACTIONS(357),
    [anon_sym_add] = ACTIONS(357),
    [anon_sym_sub] = ACTIONS(357),
    [anon_sym_mul] = ACTIONS(357),
    [anon_sym_div] = ACTIONS(357),
    [anon_sym_rem] = ACTIONS(357),
    [anon_sym_lt] = ACTIONS(357),
    [anon_sym_leq] = ACTIONS(357),
    [anon_sym_gt] = ACTIONS(357),
    [anon_sym_geq] = ACTIONS(357),
    [anon_sym_eq] = ACTIONS(357),
    [anon_sym_neq] = ACTIONS(357),
    [anon_sym_pad] = ACTIONS(357),
    [anon_sym_asUInt] = ACTIONS(357),
    [anon_sym_asAsyncReset] = ACTIONS(357),
    [anon_sym_asSInt] = ACTIONS(357),
    [anon_sym_asClock] = ACTIONS(357),
    [anon_sym_shl] = ACTIONS(357),
    [anon_sym_shr] = ACTIONS(357),
    [anon_sym_dshl] = ACTIONS(357),
    [anon_sym_dshlw] = ACTIONS(357),
    [anon_sym_dshr] = ACTIONS(357),
    [anon_sym_dshrw] = ACTIONS(357),
    [anon_sym_cvt] = ACTIONS(357),
    [anon_sym_neg] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(357),
    [anon_sym_and] = ACTIONS(357),
    [anon_sym_or] = ACTIONS(357),
    [anon_sym_xor] = ACTIONS(357),
    [anon_sym_andr] = ACTIONS(357),
    [anon_sym_orr] = ACTIONS(357),
    [anon_sym_xorr] = ACTIONS(357),
    [anon_sym_cat] = ACTIONS(357),
    [anon_sym_bits] = ACTIONS(357),
    [anon_sym_head] = ACTIONS(357),
    [anon_sym_tail] = ACTIONS(357),
    [anon_sym_asFixedPoint] = ACTIONS(357),
    [anon_sym_bpshl] = ACTIONS(357),
    [anon_sym_bpshr] = ACTIONS(357),
    [anon_sym_bpset] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(63),
  },
  [64] = {
    [sym_identifier] = ACTIONS(359),
    [anon_sym_UInt] = ACTIONS(359),
    [anon_sym_SInt] = ACTIONS(359),
    [anon_sym_wire] = ACTIONS(359),
    [anon_sym_cmem] = ACTIONS(359),
    [anon_sym_smem] = ACTIONS(359),
    [anon_sym_reg] = ACTIONS(359),
    [anon_sym_mem] = ACTIONS(359),
    [anon_sym_inst] = ACTIONS(359),
    [anon_sym_node] = ACTIONS(359),
    [anon_sym_when] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(359),
    [anon_sym_stop] = ACTIONS(359),
    [anon_sym_printf] = ACTIONS(359),
    [anon_sym_assert] = ACTIONS(359),
    [anon_sym_assume] = ACTIONS(359),
    [anon_sym_cover] = ACTIONS(359),
    [anon_sym_skip] = ACTIONS(359),
    [anon_sym_attach] = ACTIONS(359),
    [sym_info] = ACTIONS(361),
    [anon_sym_infer] = ACTIONS(359),
    [anon_sym_read] = ACTIONS(359),
    [anon_sym_write] = ACTIONS(359),
    [anon_sym_rdwr] = ACTIONS(359),
    [anon_sym_mux] = ACTIONS(359),
    [anon_sym_validif] = ACTIONS(359),
    [anon_sym_add] = ACTIONS(359),
    [anon_sym_sub] = ACTIONS(359),
    [anon_sym_mul] = ACTIONS(359),
    [anon_sym_div] = ACTIONS(359),
    [anon_sym_rem] = ACTIONS(359),
    [anon_sym_lt] = ACTIONS(359),
    [anon_sym_leq] = ACTIONS(359),
    [anon_sym_gt] = ACTIONS(359),
    [anon_sym_geq] = ACTIONS(359),
    [anon_sym_eq] = ACTIONS(359),
    [anon_sym_neq] = ACTIONS(359),
    [anon_sym_pad] = ACTIONS(359),
    [anon_sym_asUInt] = ACTIONS(359),
    [anon_sym_asAsyncReset] = ACTIONS(359),
    [anon_sym_asSInt] = ACTIONS(359),
    [anon_sym_asClock] = ACTIONS(359),
    [anon_sym_shl] = ACTIONS(359),
    [anon_sym_shr] = ACTIONS(359),
    [anon_sym_dshl] = ACTIONS(359),
    [anon_sym_dshlw] = ACTIONS(359),
    [anon_sym_dshr] = ACTIONS(359),
    [anon_sym_dshrw] = ACTIONS(359),
    [anon_sym_cvt] = ACTIONS(359),
    [anon_sym_neg] = ACTIONS(359),
    [anon_sym_not] = ACTIONS(359),
    [anon_sym_and] = ACTIONS(359),
    [anon_sym_or] = ACTIONS(359),
    [anon_sym_xor] = ACTIONS(359),
    [anon_sym_andr] = ACTIONS(359),
    [anon_sym_orr] = ACTIONS(359),
    [anon_sym_xorr] = ACTIONS(359),
    [anon_sym_cat] = ACTIONS(359),
    [anon_sym_bits] = ACTIONS(359),
    [anon_sym_head] = ACTIONS(359),
    [anon_sym_tail] = ACTIONS(359),
    [anon_sym_asFixedPoint] = ACTIONS(359),
    [anon_sym_bpshl] = ACTIONS(359),
    [anon_sym_bpshr] = ACTIONS(359),
    [anon_sym_bpset] = ACTIONS(359),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(361),
  },
  [65] = {
    [sym_identifier] = ACTIONS(363),
    [anon_sym_UInt] = ACTIONS(363),
    [anon_sym_SInt] = ACTIONS(363),
    [anon_sym_wire] = ACTIONS(363),
    [anon_sym_cmem] = ACTIONS(363),
    [anon_sym_smem] = ACTIONS(363),
    [anon_sym_reg] = ACTIONS(363),
    [anon_sym_mem] = ACTIONS(363),
    [anon_sym_inst] = ACTIONS(363),
    [anon_sym_node] = ACTIONS(363),
    [anon_sym_when] = ACTIONS(363),
    [anon_sym_else] = ACTIONS(363),
    [anon_sym_stop] = ACTIONS(363),
    [anon_sym_printf] = ACTIONS(363),
    [anon_sym_assert] = ACTIONS(363),
    [anon_sym_assume] = ACTIONS(363),
    [anon_sym_cover] = ACTIONS(363),
    [anon_sym_skip] = ACTIONS(363),
    [anon_sym_attach] = ACTIONS(363),
    [anon_sym_infer] = ACTIONS(363),
    [anon_sym_read] = ACTIONS(363),
    [anon_sym_write] = ACTIONS(363),
    [anon_sym_rdwr] = ACTIONS(363),
    [anon_sym_mux] = ACTIONS(363),
    [anon_sym_validif] = ACTIONS(363),
    [anon_sym_add] = ACTIONS(363),
    [anon_sym_sub] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(363),
    [anon_sym_div] = ACTIONS(363),
    [anon_sym_rem] = ACTIONS(363),
    [anon_sym_lt] = ACTIONS(363),
    [anon_sym_leq] = ACTIONS(363),
    [anon_sym_gt] = ACTIONS(363),
    [anon_sym_geq] = ACTIONS(363),
    [anon_sym_eq] = ACTIONS(363),
    [anon_sym_neq] = ACTIONS(363),
    [anon_sym_pad] = ACTIONS(363),
    [anon_sym_asUInt] = ACTIONS(363),
    [anon_sym_asAsyncReset] = ACTIONS(363),
    [anon_sym_asSInt] = ACTIONS(363),
    [anon_sym_asClock] = ACTIONS(363),
    [anon_sym_shl] = ACTIONS(363),
    [anon_sym_shr] = ACTIONS(363),
    [anon_sym_dshl] = ACTIONS(363),
    [anon_sym_dshlw] = ACTIONS(363),
    [anon_sym_dshr] = ACTIONS(363),
    [anon_sym_dshrw] = ACTIONS(363),
    [anon_sym_cvt] = ACTIONS(363),
    [anon_sym_neg] = ACTIONS(363),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_xor] = ACTIONS(363),
    [anon_sym_andr] = ACTIONS(363),
    [anon_sym_orr] = ACTIONS(363),
    [anon_sym_xorr] = ACTIONS(363),
    [anon_sym_cat] = ACTIONS(363),
    [anon_sym_bits] = ACTIONS(363),
    [anon_sym_head] = ACTIONS(363),
    [anon_sym_tail] = ACTIONS(363),
    [anon_sym_asFixedPoint] = ACTIONS(363),
    [anon_sym_bpshl] = ACTIONS(363),
    [anon_sym_bpshr] = ACTIONS(363),
    [anon_sym_bpset] = ACTIONS(363),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(365),
  },
  [66] = {
    [sym_identifier] = ACTIONS(367),
    [anon_sym_UInt] = ACTIONS(367),
    [anon_sym_SInt] = ACTIONS(367),
    [anon_sym_wire] = ACTIONS(367),
    [anon_sym_cmem] = ACTIONS(367),
    [anon_sym_smem] = ACTIONS(367),
    [anon_sym_reg] = ACTIONS(367),
    [anon_sym_mem] = ACTIONS(367),
    [anon_sym_inst] = ACTIONS(367),
    [anon_sym_node] = ACTIONS(367),
    [anon_sym_when] = ACTIONS(367),
    [anon_sym_else] = ACTIONS(367),
    [anon_sym_stop] = ACTIONS(367),
    [anon_sym_printf] = ACTIONS(367),
    [anon_sym_assert] = ACTIONS(367),
    [anon_sym_assume] = ACTIONS(367),
    [anon_sym_cover] = ACTIONS(367),
    [anon_sym_skip] = ACTIONS(367),
    [anon_sym_attach] = ACTIONS(367),
    [anon_sym_infer] = ACTIONS(367),
    [anon_sym_read] = ACTIONS(367),
    [anon_sym_write] = ACTIONS(367),
    [anon_sym_rdwr] = ACTIONS(367),
    [anon_sym_mux] = ACTIONS(367),
    [anon_sym_validif] = ACTIONS(367),
    [anon_sym_add] = ACTIONS(367),
    [anon_sym_sub] = ACTIONS(367),
    [anon_sym_mul] = ACTIONS(367),
    [anon_sym_div] = ACTIONS(367),
    [anon_sym_rem] = ACTIONS(367),
    [anon_sym_lt] = ACTIONS(367),
    [anon_sym_leq] = ACTIONS(367),
    [anon_sym_gt] = ACTIONS(367),
    [anon_sym_geq] = ACTIONS(367),
    [anon_sym_eq] = ACTIONS(367),
    [anon_sym_neq] = ACTIONS(367),
    [anon_sym_pad] = ACTIONS(367),
    [anon_sym_asUInt] = ACTIONS(367),
    [anon_sym_asAsyncReset] = ACTIONS(367),
    [anon_sym_asSInt] = ACTIONS(367),
    [anon_sym_asClock] = ACTIONS(367),
    [anon_sym_shl] = ACTIONS(367),
    [anon_sym_shr] = ACTIONS(367),
    [anon_sym_dshl] = ACTIONS(367),
    [anon_sym_dshlw] = ACTIONS(367),
    [anon_sym_dshr] = ACTIONS(367),
    [anon_sym_dshrw] = ACTIONS(367),
    [anon_sym_cvt] = ACTIONS(367),
    [anon_sym_neg] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(367),
    [anon_sym_and] = ACTIONS(367),
    [anon_sym_or] = ACTIONS(367),
    [anon_sym_xor] = ACTIONS(367),
    [anon_sym_andr] = ACTIONS(367),
    [anon_sym_orr] = ACTIONS(367),
    [anon_sym_xorr] = ACTIONS(367),
    [anon_sym_cat] = ACTIONS(367),
    [anon_sym_bits] = ACTIONS(367),
    [anon_sym_head] = ACTIONS(367),
    [anon_sym_tail] = ACTIONS(367),
    [anon_sym_asFixedPoint] = ACTIONS(367),
    [anon_sym_bpshl] = ACTIONS(367),
    [anon_sym_bpshr] = ACTIONS(367),
    [anon_sym_bpset] = ACTIONS(367),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(369),
  },
  [67] = {
    [sym_identifier] = ACTIONS(371),
    [anon_sym_UInt] = ACTIONS(371),
    [anon_sym_SInt] = ACTIONS(371),
    [anon_sym_wire] = ACTIONS(371),
    [anon_sym_cmem] = ACTIONS(371),
    [anon_sym_smem] = ACTIONS(371),
    [anon_sym_reg] = ACTIONS(371),
    [anon_sym_mem] = ACTIONS(371),
    [anon_sym_inst] = ACTIONS(371),
    [anon_sym_node] = ACTIONS(371),
    [anon_sym_when] = ACTIONS(371),
    [anon_sym_else] = ACTIONS(371),
    [anon_sym_stop] = ACTIONS(371),
    [anon_sym_printf] = ACTIONS(371),
    [anon_sym_assert] = ACTIONS(371),
    [anon_sym_assume] = ACTIONS(371),
    [anon_sym_cover] = ACTIONS(371),
    [anon_sym_skip] = ACTIONS(371),
    [anon_sym_attach] = ACTIONS(371),
    [anon_sym_infer] = ACTIONS(371),
    [anon_sym_read] = ACTIONS(371),
    [anon_sym_write] = ACTIONS(371),
    [anon_sym_rdwr] = ACTIONS(371),
    [anon_sym_mux] = ACTIONS(371),
    [anon_sym_validif] = ACTIONS(371),
    [anon_sym_add] = ACTIONS(371),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_mul] = ACTIONS(371),
    [anon_sym_div] = ACTIONS(371),
    [anon_sym_rem] = ACTIONS(371),
    [anon_sym_lt] = ACTIONS(371),
    [anon_sym_leq] = ACTIONS(371),
    [anon_sym_gt] = ACTIONS(371),
    [anon_sym_geq] = ACTIONS(371),
    [anon_sym_eq] = ACTIONS(371),
    [anon_sym_neq] = ACTIONS(371),
    [anon_sym_pad] = ACTIONS(371),
    [anon_sym_asUInt] = ACTIONS(371),
    [anon_sym_asAsyncReset] = ACTIONS(371),
    [anon_sym_asSInt] = ACTIONS(371),
    [anon_sym_asClock] = ACTIONS(371),
    [anon_sym_shl] = ACTIONS(371),
    [anon_sym_shr] = ACTIONS(371),
    [anon_sym_dshl] = ACTIONS(371),
    [anon_sym_dshlw] = ACTIONS(371),
    [anon_sym_dshr] = ACTIONS(371),
    [anon_sym_dshrw] = ACTIONS(371),
    [anon_sym_cvt] = ACTIONS(371),
    [anon_sym_neg] = ACTIONS(371),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_and] = ACTIONS(371),
    [anon_sym_or] = ACTIONS(371),
    [anon_sym_xor] = ACTIONS(371),
    [anon_sym_andr] = ACTIONS(371),
    [anon_sym_orr] = ACTIONS(371),
    [anon_sym_xorr] = ACTIONS(371),
    [anon_sym_cat] = ACTIONS(371),
    [anon_sym_bits] = ACTIONS(371),
    [anon_sym_head] = ACTIONS(371),
    [anon_sym_tail] = ACTIONS(371),
    [anon_sym_asFixedPoint] = ACTIONS(371),
    [anon_sym_bpshl] = ACTIONS(371),
    [anon_sym_bpshr] = ACTIONS(371),
    [anon_sym_bpset] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(373),
  },
  [68] = {
    [sym_identifier] = ACTIONS(375),
    [anon_sym_UInt] = ACTIONS(375),
    [anon_sym_SInt] = ACTIONS(375),
    [anon_sym_wire] = ACTIONS(375),
    [anon_sym_cmem] = ACTIONS(375),
    [anon_sym_smem] = ACTIONS(375),
    [anon_sym_reg] = ACTIONS(375),
    [anon_sym_mem] = ACTIONS(375),
    [anon_sym_inst] = ACTIONS(375),
    [anon_sym_node] = ACTIONS(375),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_stop] = ACTIONS(375),
    [anon_sym_printf] = ACTIONS(375),
    [anon_sym_assert] = ACTIONS(375),
    [anon_sym_assume] = ACTIONS(375),
    [anon_sym_cover] = ACTIONS(375),
    [anon_sym_skip] = ACTIONS(375),
    [anon_sym_attach] = ACTIONS(375),
    [anon_sym_infer] = ACTIONS(375),
    [anon_sym_read] = ACTIONS(375),
    [anon_sym_write] = ACTIONS(375),
    [anon_sym_rdwr] = ACTIONS(375),
    [anon_sym_mux] = ACTIONS(375),
    [anon_sym_validif] = ACTIONS(375),
    [anon_sym_add] = ACTIONS(375),
    [anon_sym_sub] = ACTIONS(375),
    [anon_sym_mul] = ACTIONS(375),
    [anon_sym_div] = ACTIONS(375),
    [anon_sym_rem] = ACTIONS(375),
    [anon_sym_lt] = ACTIONS(375),
    [anon_sym_leq] = ACTIONS(375),
    [anon_sym_gt] = ACTIONS(375),
    [anon_sym_geq] = ACTIONS(375),
    [anon_sym_eq] = ACTIONS(375),
    [anon_sym_neq] = ACTIONS(375),
    [anon_sym_pad] = ACTIONS(375),
    [anon_sym_asUInt] = ACTIONS(375),
    [anon_sym_asAsyncReset] = ACTIONS(375),
    [anon_sym_asSInt] = ACTIONS(375),
    [anon_sym_asClock] = ACTIONS(375),
    [anon_sym_shl] = ACTIONS(375),
    [anon_sym_shr] = ACTIONS(375),
    [anon_sym_dshl] = ACTIONS(375),
    [anon_sym_dshlw] = ACTIONS(375),
    [anon_sym_dshr] = ACTIONS(375),
    [anon_sym_dshrw] = ACTIONS(375),
    [anon_sym_cvt] = ACTIONS(375),
    [anon_sym_neg] = ACTIONS(375),
    [anon_sym_not] = ACTIONS(375),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_xor] = ACTIONS(375),
    [anon_sym_andr] = ACTIONS(375),
    [anon_sym_orr] = ACTIONS(375),
    [anon_sym_xorr] = ACTIONS(375),
    [anon_sym_cat] = ACTIONS(375),
    [anon_sym_bits] = ACTIONS(375),
    [anon_sym_head] = ACTIONS(375),
    [anon_sym_tail] = ACTIONS(375),
    [anon_sym_asFixedPoint] = ACTIONS(375),
    [anon_sym_bpshl] = ACTIONS(375),
    [anon_sym_bpshr] = ACTIONS(375),
    [anon_sym_bpset] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(377),
  },
  [69] = {
    [sym_identifier] = ACTIONS(379),
    [anon_sym_UInt] = ACTIONS(379),
    [anon_sym_SInt] = ACTIONS(379),
    [anon_sym_wire] = ACTIONS(379),
    [anon_sym_cmem] = ACTIONS(379),
    [anon_sym_smem] = ACTIONS(379),
    [anon_sym_reg] = ACTIONS(379),
    [anon_sym_mem] = ACTIONS(379),
    [anon_sym_inst] = ACTIONS(379),
    [anon_sym_node] = ACTIONS(379),
    [anon_sym_when] = ACTIONS(379),
    [anon_sym_else] = ACTIONS(379),
    [anon_sym_stop] = ACTIONS(379),
    [anon_sym_printf] = ACTIONS(379),
    [anon_sym_assert] = ACTIONS(379),
    [anon_sym_assume] = ACTIONS(379),
    [anon_sym_cover] = ACTIONS(379),
    [anon_sym_skip] = ACTIONS(379),
    [anon_sym_attach] = ACTIONS(379),
    [anon_sym_infer] = ACTIONS(379),
    [anon_sym_read] = ACTIONS(379),
    [anon_sym_write] = ACTIONS(379),
    [anon_sym_rdwr] = ACTIONS(379),
    [anon_sym_mux] = ACTIONS(379),
    [anon_sym_validif] = ACTIONS(379),
    [anon_sym_add] = ACTIONS(379),
    [anon_sym_sub] = ACTIONS(379),
    [anon_sym_mul] = ACTIONS(379),
    [anon_sym_div] = ACTIONS(379),
    [anon_sym_rem] = ACTIONS(379),
    [anon_sym_lt] = ACTIONS(379),
    [anon_sym_leq] = ACTIONS(379),
    [anon_sym_gt] = ACTIONS(379),
    [anon_sym_geq] = ACTIONS(379),
    [anon_sym_eq] = ACTIONS(379),
    [anon_sym_neq] = ACTIONS(379),
    [anon_sym_pad] = ACTIONS(379),
    [anon_sym_asUInt] = ACTIONS(379),
    [anon_sym_asAsyncReset] = ACTIONS(379),
    [anon_sym_asSInt] = ACTIONS(379),
    [anon_sym_asClock] = ACTIONS(379),
    [anon_sym_shl] = ACTIONS(379),
    [anon_sym_shr] = ACTIONS(379),
    [anon_sym_dshl] = ACTIONS(379),
    [anon_sym_dshlw] = ACTIONS(379),
    [anon_sym_dshr] = ACTIONS(379),
    [anon_sym_dshrw] = ACTIONS(379),
    [anon_sym_cvt] = ACTIONS(379),
    [anon_sym_neg] = ACTIONS(379),
    [anon_sym_not] = ACTIONS(379),
    [anon_sym_and] = ACTIONS(379),
    [anon_sym_or] = ACTIONS(379),
    [anon_sym_xor] = ACTIONS(379),
    [anon_sym_andr] = ACTIONS(379),
    [anon_sym_orr] = ACTIONS(379),
    [anon_sym_xorr] = ACTIONS(379),
    [anon_sym_cat] = ACTIONS(379),
    [anon_sym_bits] = ACTIONS(379),
    [anon_sym_head] = ACTIONS(379),
    [anon_sym_tail] = ACTIONS(379),
    [anon_sym_asFixedPoint] = ACTIONS(379),
    [anon_sym_bpshl] = ACTIONS(379),
    [anon_sym_bpshr] = ACTIONS(379),
    [anon_sym_bpset] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(381),
  },
  [70] = {
    [sym_identifier] = ACTIONS(383),
    [anon_sym_UInt] = ACTIONS(383),
    [anon_sym_SInt] = ACTIONS(383),
    [anon_sym_wire] = ACTIONS(383),
    [anon_sym_cmem] = ACTIONS(383),
    [anon_sym_smem] = ACTIONS(383),
    [anon_sym_reg] = ACTIONS(383),
    [anon_sym_mem] = ACTIONS(383),
    [anon_sym_inst] = ACTIONS(383),
    [anon_sym_node] = ACTIONS(383),
    [anon_sym_when] = ACTIONS(383),
    [anon_sym_else] = ACTIONS(383),
    [anon_sym_stop] = ACTIONS(383),
    [anon_sym_printf] = ACTIONS(383),
    [anon_sym_assert] = ACTIONS(383),
    [anon_sym_assume] = ACTIONS(383),
    [anon_sym_cover] = ACTIONS(383),
    [anon_sym_skip] = ACTIONS(383),
    [anon_sym_attach] = ACTIONS(383),
    [anon_sym_infer] = ACTIONS(383),
    [anon_sym_read] = ACTIONS(383),
    [anon_sym_write] = ACTIONS(383),
    [anon_sym_rdwr] = ACTIONS(383),
    [anon_sym_mux] = ACTIONS(383),
    [anon_sym_validif] = ACTIONS(383),
    [anon_sym_add] = ACTIONS(383),
    [anon_sym_sub] = ACTIONS(383),
    [anon_sym_mul] = ACTIONS(383),
    [anon_sym_div] = ACTIONS(383),
    [anon_sym_rem] = ACTIONS(383),
    [anon_sym_lt] = ACTIONS(383),
    [anon_sym_leq] = ACTIONS(383),
    [anon_sym_gt] = ACTIONS(383),
    [anon_sym_geq] = ACTIONS(383),
    [anon_sym_eq] = ACTIONS(383),
    [anon_sym_neq] = ACTIONS(383),
    [anon_sym_pad] = ACTIONS(383),
    [anon_sym_asUInt] = ACTIONS(383),
    [anon_sym_asAsyncReset] = ACTIONS(383),
    [anon_sym_asSInt] = ACTIONS(383),
    [anon_sym_asClock] = ACTIONS(383),
    [anon_sym_shl] = ACTIONS(383),
    [anon_sym_shr] = ACTIONS(383),
    [anon_sym_dshl] = ACTIONS(383),
    [anon_sym_dshlw] = ACTIONS(383),
    [anon_sym_dshr] = ACTIONS(383),
    [anon_sym_dshrw] = ACTIONS(383),
    [anon_sym_cvt] = ACTIONS(383),
    [anon_sym_neg] = ACTIONS(383),
    [anon_sym_not] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(383),
    [anon_sym_or] = ACTIONS(383),
    [anon_sym_xor] = ACTIONS(383),
    [anon_sym_andr] = ACTIONS(383),
    [anon_sym_orr] = ACTIONS(383),
    [anon_sym_xorr] = ACTIONS(383),
    [anon_sym_cat] = ACTIONS(383),
    [anon_sym_bits] = ACTIONS(383),
    [anon_sym_head] = ACTIONS(383),
    [anon_sym_tail] = ACTIONS(383),
    [anon_sym_asFixedPoint] = ACTIONS(383),
    [anon_sym_bpshl] = ACTIONS(383),
    [anon_sym_bpshr] = ACTIONS(383),
    [anon_sym_bpset] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(385),
  },
  [71] = {
    [sym_identifier] = ACTIONS(387),
    [anon_sym_UInt] = ACTIONS(387),
    [anon_sym_SInt] = ACTIONS(387),
    [anon_sym_wire] = ACTIONS(387),
    [anon_sym_cmem] = ACTIONS(387),
    [anon_sym_smem] = ACTIONS(387),
    [anon_sym_reg] = ACTIONS(387),
    [anon_sym_mem] = ACTIONS(387),
    [anon_sym_inst] = ACTIONS(387),
    [anon_sym_node] = ACTIONS(387),
    [anon_sym_when] = ACTIONS(387),
    [anon_sym_else] = ACTIONS(387),
    [anon_sym_stop] = ACTIONS(387),
    [anon_sym_printf] = ACTIONS(387),
    [anon_sym_assert] = ACTIONS(387),
    [anon_sym_assume] = ACTIONS(387),
    [anon_sym_cover] = ACTIONS(387),
    [anon_sym_skip] = ACTIONS(387),
    [anon_sym_attach] = ACTIONS(387),
    [anon_sym_infer] = ACTIONS(387),
    [anon_sym_read] = ACTIONS(387),
    [anon_sym_write] = ACTIONS(387),
    [anon_sym_rdwr] = ACTIONS(387),
    [anon_sym_mux] = ACTIONS(387),
    [anon_sym_validif] = ACTIONS(387),
    [anon_sym_add] = ACTIONS(387),
    [anon_sym_sub] = ACTIONS(387),
    [anon_sym_mul] = ACTIONS(387),
    [anon_sym_div] = ACTIONS(387),
    [anon_sym_rem] = ACTIONS(387),
    [anon_sym_lt] = ACTIONS(387),
    [anon_sym_leq] = ACTIONS(387),
    [anon_sym_gt] = ACTIONS(387),
    [anon_sym_geq] = ACTIONS(387),
    [anon_sym_eq] = ACTIONS(387),
    [anon_sym_neq] = ACTIONS(387),
    [anon_sym_pad] = ACTIONS(387),
    [anon_sym_asUInt] = ACTIONS(387),
    [anon_sym_asAsyncReset] = ACTIONS(387),
    [anon_sym_asSInt] = ACTIONS(387),
    [anon_sym_asClock] = ACTIONS(387),
    [anon_sym_shl] = ACTIONS(387),
    [anon_sym_shr] = ACTIONS(387),
    [anon_sym_dshl] = ACTIONS(387),
    [anon_sym_dshlw] = ACTIONS(387),
    [anon_sym_dshr] = ACTIONS(387),
    [anon_sym_dshrw] = ACTIONS(387),
    [anon_sym_cvt] = ACTIONS(387),
    [anon_sym_neg] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(387),
    [anon_sym_and] = ACTIONS(387),
    [anon_sym_or] = ACTIONS(387),
    [anon_sym_xor] = ACTIONS(387),
    [anon_sym_andr] = ACTIONS(387),
    [anon_sym_orr] = ACTIONS(387),
    [anon_sym_xorr] = ACTIONS(387),
    [anon_sym_cat] = ACTIONS(387),
    [anon_sym_bits] = ACTIONS(387),
    [anon_sym_head] = ACTIONS(387),
    [anon_sym_tail] = ACTIONS(387),
    [anon_sym_asFixedPoint] = ACTIONS(387),
    [anon_sym_bpshl] = ACTIONS(387),
    [anon_sym_bpshr] = ACTIONS(387),
    [anon_sym_bpset] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(389),
  },
  [72] = {
    [sym_identifier] = ACTIONS(391),
    [anon_sym_UInt] = ACTIONS(391),
    [anon_sym_SInt] = ACTIONS(391),
    [anon_sym_wire] = ACTIONS(391),
    [anon_sym_cmem] = ACTIONS(391),
    [anon_sym_smem] = ACTIONS(391),
    [anon_sym_reg] = ACTIONS(391),
    [anon_sym_mem] = ACTIONS(391),
    [anon_sym_inst] = ACTIONS(391),
    [anon_sym_node] = ACTIONS(391),
    [anon_sym_when] = ACTIONS(391),
    [anon_sym_else] = ACTIONS(391),
    [anon_sym_stop] = ACTIONS(391),
    [anon_sym_printf] = ACTIONS(391),
    [anon_sym_assert] = ACTIONS(391),
    [anon_sym_assume] = ACTIONS(391),
    [anon_sym_cover] = ACTIONS(391),
    [anon_sym_skip] = ACTIONS(391),
    [anon_sym_attach] = ACTIONS(391),
    [anon_sym_infer] = ACTIONS(391),
    [anon_sym_read] = ACTIONS(391),
    [anon_sym_write] = ACTIONS(391),
    [anon_sym_rdwr] = ACTIONS(391),
    [anon_sym_mux] = ACTIONS(391),
    [anon_sym_validif] = ACTIONS(391),
    [anon_sym_add] = ACTIONS(391),
    [anon_sym_sub] = ACTIONS(391),
    [anon_sym_mul] = ACTIONS(391),
    [anon_sym_div] = ACTIONS(391),
    [anon_sym_rem] = ACTIONS(391),
    [anon_sym_lt] = ACTIONS(391),
    [anon_sym_leq] = ACTIONS(391),
    [anon_sym_gt] = ACTIONS(391),
    [anon_sym_geq] = ACTIONS(391),
    [anon_sym_eq] = ACTIONS(391),
    [anon_sym_neq] = ACTIONS(391),
    [anon_sym_pad] = ACTIONS(391),
    [anon_sym_asUInt] = ACTIONS(391),
    [anon_sym_asAsyncReset] = ACTIONS(391),
    [anon_sym_asSInt] = ACTIONS(391),
    [anon_sym_asClock] = ACTIONS(391),
    [anon_sym_shl] = ACTIONS(391),
    [anon_sym_shr] = ACTIONS(391),
    [anon_sym_dshl] = ACTIONS(391),
    [anon_sym_dshlw] = ACTIONS(391),
    [anon_sym_dshr] = ACTIONS(391),
    [anon_sym_dshrw] = ACTIONS(391),
    [anon_sym_cvt] = ACTIONS(391),
    [anon_sym_neg] = ACTIONS(391),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_xor] = ACTIONS(391),
    [anon_sym_andr] = ACTIONS(391),
    [anon_sym_orr] = ACTIONS(391),
    [anon_sym_xorr] = ACTIONS(391),
    [anon_sym_cat] = ACTIONS(391),
    [anon_sym_bits] = ACTIONS(391),
    [anon_sym_head] = ACTIONS(391),
    [anon_sym_tail] = ACTIONS(391),
    [anon_sym_asFixedPoint] = ACTIONS(391),
    [anon_sym_bpshl] = ACTIONS(391),
    [anon_sym_bpshr] = ACTIONS(391),
    [anon_sym_bpset] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(393),
  },
  [73] = {
    [sym_identifier] = ACTIONS(395),
    [anon_sym_UInt] = ACTIONS(395),
    [anon_sym_SInt] = ACTIONS(395),
    [anon_sym_wire] = ACTIONS(395),
    [anon_sym_cmem] = ACTIONS(395),
    [anon_sym_smem] = ACTIONS(395),
    [anon_sym_reg] = ACTIONS(395),
    [anon_sym_mem] = ACTIONS(395),
    [anon_sym_inst] = ACTIONS(395),
    [anon_sym_node] = ACTIONS(395),
    [anon_sym_when] = ACTIONS(395),
    [anon_sym_else] = ACTIONS(395),
    [anon_sym_stop] = ACTIONS(395),
    [anon_sym_printf] = ACTIONS(395),
    [anon_sym_assert] = ACTIONS(395),
    [anon_sym_assume] = ACTIONS(395),
    [anon_sym_cover] = ACTIONS(395),
    [anon_sym_skip] = ACTIONS(395),
    [anon_sym_attach] = ACTIONS(395),
    [anon_sym_infer] = ACTIONS(395),
    [anon_sym_read] = ACTIONS(395),
    [anon_sym_write] = ACTIONS(395),
    [anon_sym_rdwr] = ACTIONS(395),
    [anon_sym_mux] = ACTIONS(395),
    [anon_sym_validif] = ACTIONS(395),
    [anon_sym_add] = ACTIONS(395),
    [anon_sym_sub] = ACTIONS(395),
    [anon_sym_mul] = ACTIONS(395),
    [anon_sym_div] = ACTIONS(395),
    [anon_sym_rem] = ACTIONS(395),
    [anon_sym_lt] = ACTIONS(395),
    [anon_sym_leq] = ACTIONS(395),
    [anon_sym_gt] = ACTIONS(395),
    [anon_sym_geq] = ACTIONS(395),
    [anon_sym_eq] = ACTIONS(395),
    [anon_sym_neq] = ACTIONS(395),
    [anon_sym_pad] = ACTIONS(395),
    [anon_sym_asUInt] = ACTIONS(395),
    [anon_sym_asAsyncReset] = ACTIONS(395),
    [anon_sym_asSInt] = ACTIONS(395),
    [anon_sym_asClock] = ACTIONS(395),
    [anon_sym_shl] = ACTIONS(395),
    [anon_sym_shr] = ACTIONS(395),
    [anon_sym_dshl] = ACTIONS(395),
    [anon_sym_dshlw] = ACTIONS(395),
    [anon_sym_dshr] = ACTIONS(395),
    [anon_sym_dshrw] = ACTIONS(395),
    [anon_sym_cvt] = ACTIONS(395),
    [anon_sym_neg] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_and] = ACTIONS(395),
    [anon_sym_or] = ACTIONS(395),
    [anon_sym_xor] = ACTIONS(395),
    [anon_sym_andr] = ACTIONS(395),
    [anon_sym_orr] = ACTIONS(395),
    [anon_sym_xorr] = ACTIONS(395),
    [anon_sym_cat] = ACTIONS(395),
    [anon_sym_bits] = ACTIONS(395),
    [anon_sym_head] = ACTIONS(395),
    [anon_sym_tail] = ACTIONS(395),
    [anon_sym_asFixedPoint] = ACTIONS(395),
    [anon_sym_bpshl] = ACTIONS(395),
    [anon_sym_bpshr] = ACTIONS(395),
    [anon_sym_bpset] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(397),
  },
  [74] = {
    [sym_identifier] = ACTIONS(399),
    [anon_sym_UInt] = ACTIONS(399),
    [anon_sym_SInt] = ACTIONS(399),
    [anon_sym_wire] = ACTIONS(399),
    [anon_sym_cmem] = ACTIONS(399),
    [anon_sym_smem] = ACTIONS(399),
    [anon_sym_reg] = ACTIONS(399),
    [anon_sym_mem] = ACTIONS(399),
    [anon_sym_inst] = ACTIONS(399),
    [anon_sym_node] = ACTIONS(399),
    [anon_sym_when] = ACTIONS(399),
    [anon_sym_else] = ACTIONS(399),
    [anon_sym_stop] = ACTIONS(399),
    [anon_sym_printf] = ACTIONS(399),
    [anon_sym_assert] = ACTIONS(399),
    [anon_sym_assume] = ACTIONS(399),
    [anon_sym_cover] = ACTIONS(399),
    [anon_sym_skip] = ACTIONS(399),
    [anon_sym_attach] = ACTIONS(399),
    [anon_sym_infer] = ACTIONS(399),
    [anon_sym_read] = ACTIONS(399),
    [anon_sym_write] = ACTIONS(399),
    [anon_sym_rdwr] = ACTIONS(399),
    [anon_sym_mux] = ACTIONS(399),
    [anon_sym_validif] = ACTIONS(399),
    [anon_sym_add] = ACTIONS(399),
    [anon_sym_sub] = ACTIONS(399),
    [anon_sym_mul] = ACTIONS(399),
    [anon_sym_div] = ACTIONS(399),
    [anon_sym_rem] = ACTIONS(399),
    [anon_sym_lt] = ACTIONS(399),
    [anon_sym_leq] = ACTIONS(399),
    [anon_sym_gt] = ACTIONS(399),
    [anon_sym_geq] = ACTIONS(399),
    [anon_sym_eq] = ACTIONS(399),
    [anon_sym_neq] = ACTIONS(399),
    [anon_sym_pad] = ACTIONS(399),
    [anon_sym_asUInt] = ACTIONS(399),
    [anon_sym_asAsyncReset] = ACTIONS(399),
    [anon_sym_asSInt] = ACTIONS(399),
    [anon_sym_asClock] = ACTIONS(399),
    [anon_sym_shl] = ACTIONS(399),
    [anon_sym_shr] = ACTIONS(399),
    [anon_sym_dshl] = ACTIONS(399),
    [anon_sym_dshlw] = ACTIONS(399),
    [anon_sym_dshr] = ACTIONS(399),
    [anon_sym_dshrw] = ACTIONS(399),
    [anon_sym_cvt] = ACTIONS(399),
    [anon_sym_neg] = ACTIONS(399),
    [anon_sym_not] = ACTIONS(399),
    [anon_sym_and] = ACTIONS(399),
    [anon_sym_or] = ACTIONS(399),
    [anon_sym_xor] = ACTIONS(399),
    [anon_sym_andr] = ACTIONS(399),
    [anon_sym_orr] = ACTIONS(399),
    [anon_sym_xorr] = ACTIONS(399),
    [anon_sym_cat] = ACTIONS(399),
    [anon_sym_bits] = ACTIONS(399),
    [anon_sym_head] = ACTIONS(399),
    [anon_sym_tail] = ACTIONS(399),
    [anon_sym_asFixedPoint] = ACTIONS(399),
    [anon_sym_bpshl] = ACTIONS(399),
    [anon_sym_bpshr] = ACTIONS(399),
    [anon_sym_bpset] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(401),
  },
  [75] = {
    [sym_identifier] = ACTIONS(403),
    [anon_sym_UInt] = ACTIONS(403),
    [anon_sym_SInt] = ACTIONS(403),
    [anon_sym_wire] = ACTIONS(403),
    [anon_sym_cmem] = ACTIONS(403),
    [anon_sym_smem] = ACTIONS(403),
    [anon_sym_reg] = ACTIONS(403),
    [anon_sym_mem] = ACTIONS(403),
    [anon_sym_inst] = ACTIONS(403),
    [anon_sym_node] = ACTIONS(403),
    [anon_sym_when] = ACTIONS(403),
    [anon_sym_else] = ACTIONS(403),
    [anon_sym_stop] = ACTIONS(403),
    [anon_sym_printf] = ACTIONS(403),
    [anon_sym_assert] = ACTIONS(403),
    [anon_sym_assume] = ACTIONS(403),
    [anon_sym_cover] = ACTIONS(403),
    [anon_sym_skip] = ACTIONS(403),
    [anon_sym_attach] = ACTIONS(403),
    [anon_sym_infer] = ACTIONS(403),
    [anon_sym_read] = ACTIONS(403),
    [anon_sym_write] = ACTIONS(403),
    [anon_sym_rdwr] = ACTIONS(403),
    [anon_sym_mux] = ACTIONS(403),
    [anon_sym_validif] = ACTIONS(403),
    [anon_sym_add] = ACTIONS(403),
    [anon_sym_sub] = ACTIONS(403),
    [anon_sym_mul] = ACTIONS(403),
    [anon_sym_div] = ACTIONS(403),
    [anon_sym_rem] = ACTIONS(403),
    [anon_sym_lt] = ACTIONS(403),
    [anon_sym_leq] = ACTIONS(403),
    [anon_sym_gt] = ACTIONS(403),
    [anon_sym_geq] = ACTIONS(403),
    [anon_sym_eq] = ACTIONS(403),
    [anon_sym_neq] = ACTIONS(403),
    [anon_sym_pad] = ACTIONS(403),
    [anon_sym_asUInt] = ACTIONS(403),
    [anon_sym_asAsyncReset] = ACTIONS(403),
    [anon_sym_asSInt] = ACTIONS(403),
    [anon_sym_asClock] = ACTIONS(403),
    [anon_sym_shl] = ACTIONS(403),
    [anon_sym_shr] = ACTIONS(403),
    [anon_sym_dshl] = ACTIONS(403),
    [anon_sym_dshlw] = ACTIONS(403),
    [anon_sym_dshr] = ACTIONS(403),
    [anon_sym_dshrw] = ACTIONS(403),
    [anon_sym_cvt] = ACTIONS(403),
    [anon_sym_neg] = ACTIONS(403),
    [anon_sym_not] = ACTIONS(403),
    [anon_sym_and] = ACTIONS(403),
    [anon_sym_or] = ACTIONS(403),
    [anon_sym_xor] = ACTIONS(403),
    [anon_sym_andr] = ACTIONS(403),
    [anon_sym_orr] = ACTIONS(403),
    [anon_sym_xorr] = ACTIONS(403),
    [anon_sym_cat] = ACTIONS(403),
    [anon_sym_bits] = ACTIONS(403),
    [anon_sym_head] = ACTIONS(403),
    [anon_sym_tail] = ACTIONS(403),
    [anon_sym_asFixedPoint] = ACTIONS(403),
    [anon_sym_bpshl] = ACTIONS(403),
    [anon_sym_bpshr] = ACTIONS(403),
    [anon_sym_bpset] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(405),
  },
  [76] = {
    [sym_identifier] = ACTIONS(333),
    [anon_sym_UInt] = ACTIONS(333),
    [anon_sym_SInt] = ACTIONS(333),
    [anon_sym_wire] = ACTIONS(333),
    [anon_sym_cmem] = ACTIONS(333),
    [anon_sym_smem] = ACTIONS(333),
    [anon_sym_reg] = ACTIONS(333),
    [anon_sym_mem] = ACTIONS(333),
    [anon_sym_inst] = ACTIONS(333),
    [anon_sym_node] = ACTIONS(333),
    [anon_sym_when] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(333),
    [anon_sym_stop] = ACTIONS(333),
    [anon_sym_printf] = ACTIONS(333),
    [anon_sym_assert] = ACTIONS(333),
    [anon_sym_assume] = ACTIONS(333),
    [anon_sym_cover] = ACTIONS(333),
    [anon_sym_skip] = ACTIONS(333),
    [anon_sym_attach] = ACTIONS(333),
    [anon_sym_infer] = ACTIONS(333),
    [anon_sym_read] = ACTIONS(333),
    [anon_sym_write] = ACTIONS(333),
    [anon_sym_rdwr] = ACTIONS(333),
    [anon_sym_mux] = ACTIONS(333),
    [anon_sym_validif] = ACTIONS(333),
    [anon_sym_add] = ACTIONS(333),
    [anon_sym_sub] = ACTIONS(333),
    [anon_sym_mul] = ACTIONS(333),
    [anon_sym_div] = ACTIONS(333),
    [anon_sym_rem] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(333),
    [anon_sym_leq] = ACTIONS(333),
    [anon_sym_gt] = ACTIONS(333),
    [anon_sym_geq] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(333),
    [anon_sym_neq] = ACTIONS(333),
    [anon_sym_pad] = ACTIONS(333),
    [anon_sym_asUInt] = ACTIONS(333),
    [anon_sym_asAsyncReset] = ACTIONS(333),
    [anon_sym_asSInt] = ACTIONS(333),
    [anon_sym_asClock] = ACTIONS(333),
    [anon_sym_shl] = ACTIONS(333),
    [anon_sym_shr] = ACTIONS(333),
    [anon_sym_dshl] = ACTIONS(333),
    [anon_sym_dshlw] = ACTIONS(333),
    [anon_sym_dshr] = ACTIONS(333),
    [anon_sym_dshrw] = ACTIONS(333),
    [anon_sym_cvt] = ACTIONS(333),
    [anon_sym_neg] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_xor] = ACTIONS(333),
    [anon_sym_andr] = ACTIONS(333),
    [anon_sym_orr] = ACTIONS(333),
    [anon_sym_xorr] = ACTIONS(333),
    [anon_sym_cat] = ACTIONS(333),
    [anon_sym_bits] = ACTIONS(333),
    [anon_sym_head] = ACTIONS(333),
    [anon_sym_tail] = ACTIONS(333),
    [anon_sym_asFixedPoint] = ACTIONS(333),
    [anon_sym_bpshl] = ACTIONS(333),
    [anon_sym_bpshr] = ACTIONS(333),
    [anon_sym_bpset] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(335),
  },
  [77] = {
    [sym_identifier] = ACTIONS(357),
    [anon_sym_UInt] = ACTIONS(357),
    [anon_sym_SInt] = ACTIONS(357),
    [anon_sym_wire] = ACTIONS(357),
    [anon_sym_cmem] = ACTIONS(357),
    [anon_sym_smem] = ACTIONS(357),
    [anon_sym_reg] = ACTIONS(357),
    [anon_sym_mem] = ACTIONS(357),
    [anon_sym_inst] = ACTIONS(357),
    [anon_sym_node] = ACTIONS(357),
    [anon_sym_when] = ACTIONS(357),
    [anon_sym_else] = ACTIONS(357),
    [anon_sym_stop] = ACTIONS(357),
    [anon_sym_printf] = ACTIONS(357),
    [anon_sym_assert] = ACTIONS(357),
    [anon_sym_assume] = ACTIONS(357),
    [anon_sym_cover] = ACTIONS(357),
    [anon_sym_skip] = ACTIONS(357),
    [anon_sym_attach] = ACTIONS(357),
    [anon_sym_infer] = ACTIONS(357),
    [anon_sym_read] = ACTIONS(357),
    [anon_sym_write] = ACTIONS(357),
    [anon_sym_rdwr] = ACTIONS(357),
    [anon_sym_mux] = ACTIONS(357),
    [anon_sym_validif] = ACTIONS(357),
    [anon_sym_add] = ACTIONS(357),
    [anon_sym_sub] = ACTIONS(357),
    [anon_sym_mul] = ACTIONS(357),
    [anon_sym_div] = ACTIONS(357),
    [anon_sym_rem] = ACTIONS(357),
    [anon_sym_lt] = ACTIONS(357),
    [anon_sym_leq] = ACTIONS(357),
    [anon_sym_gt] = ACTIONS(357),
    [anon_sym_geq] = ACTIONS(357),
    [anon_sym_eq] = ACTIONS(357),
    [anon_sym_neq] = ACTIONS(357),
    [anon_sym_pad] = ACTIONS(357),
    [anon_sym_asUInt] = ACTIONS(357),
    [anon_sym_asAsyncReset] = ACTIONS(357),
    [anon_sym_asSInt] = ACTIONS(357),
    [anon_sym_asClock] = ACTIONS(357),
    [anon_sym_shl] = ACTIONS(357),
    [anon_sym_shr] = ACTIONS(357),
    [anon_sym_dshl] = ACTIONS(357),
    [anon_sym_dshlw] = ACTIONS(357),
    [anon_sym_dshr] = ACTIONS(357),
    [anon_sym_dshrw] = ACTIONS(357),
    [anon_sym_cvt] = ACTIONS(357),
    [anon_sym_neg] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(357),
    [anon_sym_and] = ACTIONS(357),
    [anon_sym_or] = ACTIONS(357),
    [anon_sym_xor] = ACTIONS(357),
    [anon_sym_andr] = ACTIONS(357),
    [anon_sym_orr] = ACTIONS(357),
    [anon_sym_xorr] = ACTIONS(357),
    [anon_sym_cat] = ACTIONS(357),
    [anon_sym_bits] = ACTIONS(357),
    [anon_sym_head] = ACTIONS(357),
    [anon_sym_tail] = ACTIONS(357),
    [anon_sym_asFixedPoint] = ACTIONS(357),
    [anon_sym_bpshl] = ACTIONS(357),
    [anon_sym_bpshr] = ACTIONS(357),
    [anon_sym_bpset] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(63),
  },
  [78] = {
    [sym_identifier] = ACTIONS(327),
    [anon_sym_UInt] = ACTIONS(327),
    [anon_sym_SInt] = ACTIONS(327),
    [anon_sym_wire] = ACTIONS(327),
    [anon_sym_cmem] = ACTIONS(327),
    [anon_sym_smem] = ACTIONS(327),
    [anon_sym_reg] = ACTIONS(327),
    [anon_sym_mem] = ACTIONS(327),
    [anon_sym_inst] = ACTIONS(327),
    [anon_sym_node] = ACTIONS(327),
    [anon_sym_when] = ACTIONS(327),
    [anon_sym_else] = ACTIONS(327),
    [anon_sym_stop] = ACTIONS(327),
    [anon_sym_printf] = ACTIONS(327),
    [anon_sym_assert] = ACTIONS(327),
    [anon_sym_assume] = ACTIONS(327),
    [anon_sym_cover] = ACTIONS(327),
    [anon_sym_skip] = ACTIONS(327),
    [anon_sym_attach] = ACTIONS(327),
    [anon_sym_infer] = ACTIONS(327),
    [anon_sym_read] = ACTIONS(327),
    [anon_sym_write] = ACTIONS(327),
    [anon_sym_rdwr] = ACTIONS(327),
    [anon_sym_mux] = ACTIONS(327),
    [anon_sym_validif] = ACTIONS(327),
    [anon_sym_add] = ACTIONS(327),
    [anon_sym_sub] = ACTIONS(327),
    [anon_sym_mul] = ACTIONS(327),
    [anon_sym_div] = ACTIONS(327),
    [anon_sym_rem] = ACTIONS(327),
    [anon_sym_lt] = ACTIONS(327),
    [anon_sym_leq] = ACTIONS(327),
    [anon_sym_gt] = ACTIONS(327),
    [anon_sym_geq] = ACTIONS(327),
    [anon_sym_eq] = ACTIONS(327),
    [anon_sym_neq] = ACTIONS(327),
    [anon_sym_pad] = ACTIONS(327),
    [anon_sym_asUInt] = ACTIONS(327),
    [anon_sym_asAsyncReset] = ACTIONS(327),
    [anon_sym_asSInt] = ACTIONS(327),
    [anon_sym_asClock] = ACTIONS(327),
    [anon_sym_shl] = ACTIONS(327),
    [anon_sym_shr] = ACTIONS(327),
    [anon_sym_dshl] = ACTIONS(327),
    [anon_sym_dshlw] = ACTIONS(327),
    [anon_sym_dshr] = ACTIONS(327),
    [anon_sym_dshrw] = ACTIONS(327),
    [anon_sym_cvt] = ACTIONS(327),
    [anon_sym_neg] = ACTIONS(327),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_and] = ACTIONS(327),
    [anon_sym_or] = ACTIONS(327),
    [anon_sym_xor] = ACTIONS(327),
    [anon_sym_andr] = ACTIONS(327),
    [anon_sym_orr] = ACTIONS(327),
    [anon_sym_xorr] = ACTIONS(327),
    [anon_sym_cat] = ACTIONS(327),
    [anon_sym_bits] = ACTIONS(327),
    [anon_sym_head] = ACTIONS(327),
    [anon_sym_tail] = ACTIONS(327),
    [anon_sym_asFixedPoint] = ACTIONS(327),
    [anon_sym_bpshl] = ACTIONS(327),
    [anon_sym_bpshr] = ACTIONS(327),
    [anon_sym_bpset] = ACTIONS(327),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(331),
  },
  [79] = {
    [sym_identifier] = ACTIONS(407),
    [anon_sym_UInt] = ACTIONS(407),
    [anon_sym_SInt] = ACTIONS(407),
    [anon_sym_wire] = ACTIONS(407),
    [anon_sym_cmem] = ACTIONS(407),
    [anon_sym_smem] = ACTIONS(407),
    [anon_sym_reg] = ACTIONS(407),
    [anon_sym_mem] = ACTIONS(407),
    [anon_sym_inst] = ACTIONS(407),
    [anon_sym_node] = ACTIONS(407),
    [anon_sym_when] = ACTIONS(407),
    [anon_sym_else] = ACTIONS(407),
    [anon_sym_stop] = ACTIONS(407),
    [anon_sym_printf] = ACTIONS(407),
    [anon_sym_assert] = ACTIONS(407),
    [anon_sym_assume] = ACTIONS(407),
    [anon_sym_cover] = ACTIONS(407),
    [anon_sym_skip] = ACTIONS(407),
    [anon_sym_attach] = ACTIONS(407),
    [anon_sym_infer] = ACTIONS(407),
    [anon_sym_read] = ACTIONS(407),
    [anon_sym_write] = ACTIONS(407),
    [anon_sym_rdwr] = ACTIONS(407),
    [anon_sym_mux] = ACTIONS(407),
    [anon_sym_validif] = ACTIONS(407),
    [anon_sym_add] = ACTIONS(407),
    [anon_sym_sub] = ACTIONS(407),
    [anon_sym_mul] = ACTIONS(407),
    [anon_sym_div] = ACTIONS(407),
    [anon_sym_rem] = ACTIONS(407),
    [anon_sym_lt] = ACTIONS(407),
    [anon_sym_leq] = ACTIONS(407),
    [anon_sym_gt] = ACTIONS(407),
    [anon_sym_geq] = ACTIONS(407),
    [anon_sym_eq] = ACTIONS(407),
    [anon_sym_neq] = ACTIONS(407),
    [anon_sym_pad] = ACTIONS(407),
    [anon_sym_asUInt] = ACTIONS(407),
    [anon_sym_asAsyncReset] = ACTIONS(407),
    [anon_sym_asSInt] = ACTIONS(407),
    [anon_sym_asClock] = ACTIONS(407),
    [anon_sym_shl] = ACTIONS(407),
    [anon_sym_shr] = ACTIONS(407),
    [anon_sym_dshl] = ACTIONS(407),
    [anon_sym_dshlw] = ACTIONS(407),
    [anon_sym_dshr] = ACTIONS(407),
    [anon_sym_dshrw] = ACTIONS(407),
    [anon_sym_cvt] = ACTIONS(407),
    [anon_sym_neg] = ACTIONS(407),
    [anon_sym_not] = ACTIONS(407),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_or] = ACTIONS(407),
    [anon_sym_xor] = ACTIONS(407),
    [anon_sym_andr] = ACTIONS(407),
    [anon_sym_orr] = ACTIONS(407),
    [anon_sym_xorr] = ACTIONS(407),
    [anon_sym_cat] = ACTIONS(407),
    [anon_sym_bits] = ACTIONS(407),
    [anon_sym_head] = ACTIONS(407),
    [anon_sym_tail] = ACTIONS(407),
    [anon_sym_asFixedPoint] = ACTIONS(407),
    [anon_sym_bpshl] = ACTIONS(407),
    [anon_sym_bpshr] = ACTIONS(407),
    [anon_sym_bpset] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(409),
  },
  [80] = {
    [sym_identifier] = ACTIONS(411),
    [anon_sym_UInt] = ACTIONS(411),
    [anon_sym_SInt] = ACTIONS(411),
    [anon_sym_wire] = ACTIONS(411),
    [anon_sym_cmem] = ACTIONS(411),
    [anon_sym_smem] = ACTIONS(411),
    [anon_sym_reg] = ACTIONS(411),
    [anon_sym_mem] = ACTIONS(411),
    [anon_sym_inst] = ACTIONS(411),
    [anon_sym_node] = ACTIONS(411),
    [anon_sym_when] = ACTIONS(411),
    [anon_sym_else] = ACTIONS(411),
    [anon_sym_stop] = ACTIONS(411),
    [anon_sym_printf] = ACTIONS(411),
    [anon_sym_assert] = ACTIONS(411),
    [anon_sym_assume] = ACTIONS(411),
    [anon_sym_cover] = ACTIONS(411),
    [anon_sym_skip] = ACTIONS(411),
    [anon_sym_attach] = ACTIONS(411),
    [anon_sym_infer] = ACTIONS(411),
    [anon_sym_read] = ACTIONS(411),
    [anon_sym_write] = ACTIONS(411),
    [anon_sym_rdwr] = ACTIONS(411),
    [anon_sym_mux] = ACTIONS(411),
    [anon_sym_validif] = ACTIONS(411),
    [anon_sym_add] = ACTIONS(411),
    [anon_sym_sub] = ACTIONS(411),
    [anon_sym_mul] = ACTIONS(411),
    [anon_sym_div] = ACTIONS(411),
    [anon_sym_rem] = ACTIONS(411),
    [anon_sym_lt] = ACTIONS(411),
    [anon_sym_leq] = ACTIONS(411),
    [anon_sym_gt] = ACTIONS(411),
    [anon_sym_geq] = ACTIONS(411),
    [anon_sym_eq] = ACTIONS(411),
    [anon_sym_neq] = ACTIONS(411),
    [anon_sym_pad] = ACTIONS(411),
    [anon_sym_asUInt] = ACTIONS(411),
    [anon_sym_asAsyncReset] = ACTIONS(411),
    [anon_sym_asSInt] = ACTIONS(411),
    [anon_sym_asClock] = ACTIONS(411),
    [anon_sym_shl] = ACTIONS(411),
    [anon_sym_shr] = ACTIONS(411),
    [anon_sym_dshl] = ACTIONS(411),
    [anon_sym_dshlw] = ACTIONS(411),
    [anon_sym_dshr] = ACTIONS(411),
    [anon_sym_dshrw] = ACTIONS(411),
    [anon_sym_cvt] = ACTIONS(411),
    [anon_sym_neg] = ACTIONS(411),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_and] = ACTIONS(411),
    [anon_sym_or] = ACTIONS(411),
    [anon_sym_xor] = ACTIONS(411),
    [anon_sym_andr] = ACTIONS(411),
    [anon_sym_orr] = ACTIONS(411),
    [anon_sym_xorr] = ACTIONS(411),
    [anon_sym_cat] = ACTIONS(411),
    [anon_sym_bits] = ACTIONS(411),
    [anon_sym_head] = ACTIONS(411),
    [anon_sym_tail] = ACTIONS(411),
    [anon_sym_asFixedPoint] = ACTIONS(411),
    [anon_sym_bpshl] = ACTIONS(411),
    [anon_sym_bpshr] = ACTIONS(411),
    [anon_sym_bpset] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(413),
  },
  [81] = {
    [sym_identifier] = ACTIONS(415),
    [anon_sym_UInt] = ACTIONS(415),
    [anon_sym_SInt] = ACTIONS(415),
    [anon_sym_wire] = ACTIONS(415),
    [anon_sym_cmem] = ACTIONS(415),
    [anon_sym_smem] = ACTIONS(415),
    [anon_sym_reg] = ACTIONS(415),
    [anon_sym_mem] = ACTIONS(415),
    [anon_sym_inst] = ACTIONS(415),
    [anon_sym_node] = ACTIONS(415),
    [anon_sym_when] = ACTIONS(415),
    [anon_sym_else] = ACTIONS(415),
    [anon_sym_stop] = ACTIONS(415),
    [anon_sym_printf] = ACTIONS(415),
    [anon_sym_assert] = ACTIONS(415),
    [anon_sym_assume] = ACTIONS(415),
    [anon_sym_cover] = ACTIONS(415),
    [anon_sym_skip] = ACTIONS(415),
    [anon_sym_attach] = ACTIONS(415),
    [anon_sym_infer] = ACTIONS(415),
    [anon_sym_read] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [anon_sym_rdwr] = ACTIONS(415),
    [anon_sym_mux] = ACTIONS(415),
    [anon_sym_validif] = ACTIONS(415),
    [anon_sym_add] = ACTIONS(415),
    [anon_sym_sub] = ACTIONS(415),
    [anon_sym_mul] = ACTIONS(415),
    [anon_sym_div] = ACTIONS(415),
    [anon_sym_rem] = ACTIONS(415),
    [anon_sym_lt] = ACTIONS(415),
    [anon_sym_leq] = ACTIONS(415),
    [anon_sym_gt] = ACTIONS(415),
    [anon_sym_geq] = ACTIONS(415),
    [anon_sym_eq] = ACTIONS(415),
    [anon_sym_neq] = ACTIONS(415),
    [anon_sym_pad] = ACTIONS(415),
    [anon_sym_asUInt] = ACTIONS(415),
    [anon_sym_asAsyncReset] = ACTIONS(415),
    [anon_sym_asSInt] = ACTIONS(415),
    [anon_sym_asClock] = ACTIONS(415),
    [anon_sym_shl] = ACTIONS(415),
    [anon_sym_shr] = ACTIONS(415),
    [anon_sym_dshl] = ACTIONS(415),
    [anon_sym_dshlw] = ACTIONS(415),
    [anon_sym_dshr] = ACTIONS(415),
    [anon_sym_dshrw] = ACTIONS(415),
    [anon_sym_cvt] = ACTIONS(415),
    [anon_sym_neg] = ACTIONS(415),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(415),
    [anon_sym_or] = ACTIONS(415),
    [anon_sym_xor] = ACTIONS(415),
    [anon_sym_andr] = ACTIONS(415),
    [anon_sym_orr] = ACTIONS(415),
    [anon_sym_xorr] = ACTIONS(415),
    [anon_sym_cat] = ACTIONS(415),
    [anon_sym_bits] = ACTIONS(415),
    [anon_sym_head] = ACTIONS(415),
    [anon_sym_tail] = ACTIONS(415),
    [anon_sym_asFixedPoint] = ACTIONS(415),
    [anon_sym_bpshl] = ACTIONS(415),
    [anon_sym_bpshr] = ACTIONS(415),
    [anon_sym_bpset] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(417),
  },
  [82] = {
    [sym_identifier] = ACTIONS(419),
    [anon_sym_UInt] = ACTIONS(419),
    [anon_sym_SInt] = ACTIONS(419),
    [anon_sym_wire] = ACTIONS(419),
    [anon_sym_cmem] = ACTIONS(419),
    [anon_sym_smem] = ACTIONS(419),
    [anon_sym_reg] = ACTIONS(419),
    [anon_sym_mem] = ACTIONS(419),
    [anon_sym_inst] = ACTIONS(419),
    [anon_sym_node] = ACTIONS(419),
    [anon_sym_when] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_stop] = ACTIONS(419),
    [anon_sym_printf] = ACTIONS(419),
    [anon_sym_assert] = ACTIONS(419),
    [anon_sym_assume] = ACTIONS(419),
    [anon_sym_cover] = ACTIONS(419),
    [anon_sym_skip] = ACTIONS(419),
    [anon_sym_attach] = ACTIONS(419),
    [anon_sym_infer] = ACTIONS(419),
    [anon_sym_read] = ACTIONS(419),
    [anon_sym_write] = ACTIONS(419),
    [anon_sym_rdwr] = ACTIONS(419),
    [anon_sym_mux] = ACTIONS(419),
    [anon_sym_validif] = ACTIONS(419),
    [anon_sym_add] = ACTIONS(419),
    [anon_sym_sub] = ACTIONS(419),
    [anon_sym_mul] = ACTIONS(419),
    [anon_sym_div] = ACTIONS(419),
    [anon_sym_rem] = ACTIONS(419),
    [anon_sym_lt] = ACTIONS(419),
    [anon_sym_leq] = ACTIONS(419),
    [anon_sym_gt] = ACTIONS(419),
    [anon_sym_geq] = ACTIONS(419),
    [anon_sym_eq] = ACTIONS(419),
    [anon_sym_neq] = ACTIONS(419),
    [anon_sym_pad] = ACTIONS(419),
    [anon_sym_asUInt] = ACTIONS(419),
    [anon_sym_asAsyncReset] = ACTIONS(419),
    [anon_sym_asSInt] = ACTIONS(419),
    [anon_sym_asClock] = ACTIONS(419),
    [anon_sym_shl] = ACTIONS(419),
    [anon_sym_shr] = ACTIONS(419),
    [anon_sym_dshl] = ACTIONS(419),
    [anon_sym_dshlw] = ACTIONS(419),
    [anon_sym_dshr] = ACTIONS(419),
    [anon_sym_dshrw] = ACTIONS(419),
    [anon_sym_cvt] = ACTIONS(419),
    [anon_sym_neg] = ACTIONS(419),
    [anon_sym_not] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_xor] = ACTIONS(419),
    [anon_sym_andr] = ACTIONS(419),
    [anon_sym_orr] = ACTIONS(419),
    [anon_sym_xorr] = ACTIONS(419),
    [anon_sym_cat] = ACTIONS(419),
    [anon_sym_bits] = ACTIONS(419),
    [anon_sym_head] = ACTIONS(419),
    [anon_sym_tail] = ACTIONS(419),
    [anon_sym_asFixedPoint] = ACTIONS(419),
    [anon_sym_bpshl] = ACTIONS(419),
    [anon_sym_bpshr] = ACTIONS(419),
    [anon_sym_bpset] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(421),
  },
  [83] = {
    [sym_identifier] = ACTIONS(423),
    [anon_sym_UInt] = ACTIONS(423),
    [anon_sym_SInt] = ACTIONS(423),
    [anon_sym_wire] = ACTIONS(423),
    [anon_sym_cmem] = ACTIONS(423),
    [anon_sym_smem] = ACTIONS(423),
    [anon_sym_reg] = ACTIONS(423),
    [anon_sym_mem] = ACTIONS(423),
    [anon_sym_inst] = ACTIONS(423),
    [anon_sym_node] = ACTIONS(423),
    [anon_sym_when] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_stop] = ACTIONS(423),
    [anon_sym_printf] = ACTIONS(423),
    [anon_sym_assert] = ACTIONS(423),
    [anon_sym_assume] = ACTIONS(423),
    [anon_sym_cover] = ACTIONS(423),
    [anon_sym_skip] = ACTIONS(423),
    [anon_sym_attach] = ACTIONS(423),
    [anon_sym_infer] = ACTIONS(423),
    [anon_sym_read] = ACTIONS(423),
    [anon_sym_write] = ACTIONS(423),
    [anon_sym_rdwr] = ACTIONS(423),
    [anon_sym_mux] = ACTIONS(423),
    [anon_sym_validif] = ACTIONS(423),
    [anon_sym_add] = ACTIONS(423),
    [anon_sym_sub] = ACTIONS(423),
    [anon_sym_mul] = ACTIONS(423),
    [anon_sym_div] = ACTIONS(423),
    [anon_sym_rem] = ACTIONS(423),
    [anon_sym_lt] = ACTIONS(423),
    [anon_sym_leq] = ACTIONS(423),
    [anon_sym_gt] = ACTIONS(423),
    [anon_sym_geq] = ACTIONS(423),
    [anon_sym_eq] = ACTIONS(423),
    [anon_sym_neq] = ACTIONS(423),
    [anon_sym_pad] = ACTIONS(423),
    [anon_sym_asUInt] = ACTIONS(423),
    [anon_sym_asAsyncReset] = ACTIONS(423),
    [anon_sym_asSInt] = ACTIONS(423),
    [anon_sym_asClock] = ACTIONS(423),
    [anon_sym_shl] = ACTIONS(423),
    [anon_sym_shr] = ACTIONS(423),
    [anon_sym_dshl] = ACTIONS(423),
    [anon_sym_dshlw] = ACTIONS(423),
    [anon_sym_dshr] = ACTIONS(423),
    [anon_sym_dshrw] = ACTIONS(423),
    [anon_sym_cvt] = ACTIONS(423),
    [anon_sym_neg] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_xor] = ACTIONS(423),
    [anon_sym_andr] = ACTIONS(423),
    [anon_sym_orr] = ACTIONS(423),
    [anon_sym_xorr] = ACTIONS(423),
    [anon_sym_cat] = ACTIONS(423),
    [anon_sym_bits] = ACTIONS(423),
    [anon_sym_head] = ACTIONS(423),
    [anon_sym_tail] = ACTIONS(423),
    [anon_sym_asFixedPoint] = ACTIONS(423),
    [anon_sym_bpshl] = ACTIONS(423),
    [anon_sym_bpshr] = ACTIONS(423),
    [anon_sym_bpset] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(425),
  },
  [84] = {
    [sym_identifier] = ACTIONS(427),
    [anon_sym_UInt] = ACTIONS(427),
    [anon_sym_SInt] = ACTIONS(427),
    [anon_sym_wire] = ACTIONS(427),
    [anon_sym_cmem] = ACTIONS(427),
    [anon_sym_smem] = ACTIONS(427),
    [anon_sym_reg] = ACTIONS(427),
    [anon_sym_mem] = ACTIONS(427),
    [anon_sym_inst] = ACTIONS(427),
    [anon_sym_node] = ACTIONS(427),
    [anon_sym_when] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_stop] = ACTIONS(427),
    [anon_sym_printf] = ACTIONS(427),
    [anon_sym_assert] = ACTIONS(427),
    [anon_sym_assume] = ACTIONS(427),
    [anon_sym_cover] = ACTIONS(427),
    [anon_sym_skip] = ACTIONS(427),
    [anon_sym_attach] = ACTIONS(427),
    [anon_sym_infer] = ACTIONS(427),
    [anon_sym_read] = ACTIONS(427),
    [anon_sym_write] = ACTIONS(427),
    [anon_sym_rdwr] = ACTIONS(427),
    [anon_sym_mux] = ACTIONS(427),
    [anon_sym_validif] = ACTIONS(427),
    [anon_sym_add] = ACTIONS(427),
    [anon_sym_sub] = ACTIONS(427),
    [anon_sym_mul] = ACTIONS(427),
    [anon_sym_div] = ACTIONS(427),
    [anon_sym_rem] = ACTIONS(427),
    [anon_sym_lt] = ACTIONS(427),
    [anon_sym_leq] = ACTIONS(427),
    [anon_sym_gt] = ACTIONS(427),
    [anon_sym_geq] = ACTIONS(427),
    [anon_sym_eq] = ACTIONS(427),
    [anon_sym_neq] = ACTIONS(427),
    [anon_sym_pad] = ACTIONS(427),
    [anon_sym_asUInt] = ACTIONS(427),
    [anon_sym_asAsyncReset] = ACTIONS(427),
    [anon_sym_asSInt] = ACTIONS(427),
    [anon_sym_asClock] = ACTIONS(427),
    [anon_sym_shl] = ACTIONS(427),
    [anon_sym_shr] = ACTIONS(427),
    [anon_sym_dshl] = ACTIONS(427),
    [anon_sym_dshlw] = ACTIONS(427),
    [anon_sym_dshr] = ACTIONS(427),
    [anon_sym_dshrw] = ACTIONS(427),
    [anon_sym_cvt] = ACTIONS(427),
    [anon_sym_neg] = ACTIONS(427),
    [anon_sym_not] = ACTIONS(427),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_xor] = ACTIONS(427),
    [anon_sym_andr] = ACTIONS(427),
    [anon_sym_orr] = ACTIONS(427),
    [anon_sym_xorr] = ACTIONS(427),
    [anon_sym_cat] = ACTIONS(427),
    [anon_sym_bits] = ACTIONS(427),
    [anon_sym_head] = ACTIONS(427),
    [anon_sym_tail] = ACTIONS(427),
    [anon_sym_asFixedPoint] = ACTIONS(427),
    [anon_sym_bpshl] = ACTIONS(427),
    [anon_sym_bpshr] = ACTIONS(427),
    [anon_sym_bpset] = ACTIONS(427),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(429),
  },
  [85] = {
    [sym_identifier] = ACTIONS(431),
    [anon_sym_UInt] = ACTIONS(431),
    [anon_sym_SInt] = ACTIONS(431),
    [anon_sym_wire] = ACTIONS(431),
    [anon_sym_cmem] = ACTIONS(431),
    [anon_sym_smem] = ACTIONS(431),
    [anon_sym_reg] = ACTIONS(431),
    [anon_sym_mem] = ACTIONS(431),
    [anon_sym_inst] = ACTIONS(431),
    [anon_sym_node] = ACTIONS(431),
    [anon_sym_when] = ACTIONS(431),
    [anon_sym_else] = ACTIONS(431),
    [anon_sym_stop] = ACTIONS(431),
    [anon_sym_printf] = ACTIONS(431),
    [anon_sym_assert] = ACTIONS(431),
    [anon_sym_assume] = ACTIONS(431),
    [anon_sym_cover] = ACTIONS(431),
    [anon_sym_skip] = ACTIONS(431),
    [anon_sym_attach] = ACTIONS(431),
    [anon_sym_infer] = ACTIONS(431),
    [anon_sym_read] = ACTIONS(431),
    [anon_sym_write] = ACTIONS(431),
    [anon_sym_rdwr] = ACTIONS(431),
    [anon_sym_mux] = ACTIONS(431),
    [anon_sym_validif] = ACTIONS(431),
    [anon_sym_add] = ACTIONS(431),
    [anon_sym_sub] = ACTIONS(431),
    [anon_sym_mul] = ACTIONS(431),
    [anon_sym_div] = ACTIONS(431),
    [anon_sym_rem] = ACTIONS(431),
    [anon_sym_lt] = ACTIONS(431),
    [anon_sym_leq] = ACTIONS(431),
    [anon_sym_gt] = ACTIONS(431),
    [anon_sym_geq] = ACTIONS(431),
    [anon_sym_eq] = ACTIONS(431),
    [anon_sym_neq] = ACTIONS(431),
    [anon_sym_pad] = ACTIONS(431),
    [anon_sym_asUInt] = ACTIONS(431),
    [anon_sym_asAsyncReset] = ACTIONS(431),
    [anon_sym_asSInt] = ACTIONS(431),
    [anon_sym_asClock] = ACTIONS(431),
    [anon_sym_shl] = ACTIONS(431),
    [anon_sym_shr] = ACTIONS(431),
    [anon_sym_dshl] = ACTIONS(431),
    [anon_sym_dshlw] = ACTIONS(431),
    [anon_sym_dshr] = ACTIONS(431),
    [anon_sym_dshrw] = ACTIONS(431),
    [anon_sym_cvt] = ACTIONS(431),
    [anon_sym_neg] = ACTIONS(431),
    [anon_sym_not] = ACTIONS(431),
    [anon_sym_and] = ACTIONS(431),
    [anon_sym_or] = ACTIONS(431),
    [anon_sym_xor] = ACTIONS(431),
    [anon_sym_andr] = ACTIONS(431),
    [anon_sym_orr] = ACTIONS(431),
    [anon_sym_xorr] = ACTIONS(431),
    [anon_sym_cat] = ACTIONS(431),
    [anon_sym_bits] = ACTIONS(431),
    [anon_sym_head] = ACTIONS(431),
    [anon_sym_tail] = ACTIONS(431),
    [anon_sym_asFixedPoint] = ACTIONS(431),
    [anon_sym_bpshl] = ACTIONS(431),
    [anon_sym_bpshr] = ACTIONS(431),
    [anon_sym_bpset] = ACTIONS(431),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(433),
  },
  [86] = {
    [sym_identifier] = ACTIONS(435),
    [anon_sym_UInt] = ACTIONS(435),
    [anon_sym_SInt] = ACTIONS(435),
    [anon_sym_wire] = ACTIONS(435),
    [anon_sym_cmem] = ACTIONS(435),
    [anon_sym_smem] = ACTIONS(435),
    [anon_sym_reg] = ACTIONS(435),
    [anon_sym_mem] = ACTIONS(435),
    [anon_sym_inst] = ACTIONS(435),
    [anon_sym_node] = ACTIONS(435),
    [anon_sym_when] = ACTIONS(435),
    [anon_sym_else] = ACTIONS(435),
    [anon_sym_stop] = ACTIONS(435),
    [anon_sym_printf] = ACTIONS(435),
    [anon_sym_assert] = ACTIONS(435),
    [anon_sym_assume] = ACTIONS(435),
    [anon_sym_cover] = ACTIONS(435),
    [anon_sym_skip] = ACTIONS(435),
    [anon_sym_attach] = ACTIONS(435),
    [anon_sym_infer] = ACTIONS(435),
    [anon_sym_read] = ACTIONS(435),
    [anon_sym_write] = ACTIONS(435),
    [anon_sym_rdwr] = ACTIONS(435),
    [anon_sym_mux] = ACTIONS(435),
    [anon_sym_validif] = ACTIONS(435),
    [anon_sym_add] = ACTIONS(435),
    [anon_sym_sub] = ACTIONS(435),
    [anon_sym_mul] = ACTIONS(435),
    [anon_sym_div] = ACTIONS(435),
    [anon_sym_rem] = ACTIONS(435),
    [anon_sym_lt] = ACTIONS(435),
    [anon_sym_leq] = ACTIONS(435),
    [anon_sym_gt] = ACTIONS(435),
    [anon_sym_geq] = ACTIONS(435),
    [anon_sym_eq] = ACTIONS(435),
    [anon_sym_neq] = ACTIONS(435),
    [anon_sym_pad] = ACTIONS(435),
    [anon_sym_asUInt] = ACTIONS(435),
    [anon_sym_asAsyncReset] = ACTIONS(435),
    [anon_sym_asSInt] = ACTIONS(435),
    [anon_sym_asClock] = ACTIONS(435),
    [anon_sym_shl] = ACTIONS(435),
    [anon_sym_shr] = ACTIONS(435),
    [anon_sym_dshl] = ACTIONS(435),
    [anon_sym_dshlw] = ACTIONS(435),
    [anon_sym_dshr] = ACTIONS(435),
    [anon_sym_dshrw] = ACTIONS(435),
    [anon_sym_cvt] = ACTIONS(435),
    [anon_sym_neg] = ACTIONS(435),
    [anon_sym_not] = ACTIONS(435),
    [anon_sym_and] = ACTIONS(435),
    [anon_sym_or] = ACTIONS(435),
    [anon_sym_xor] = ACTIONS(435),
    [anon_sym_andr] = ACTIONS(435),
    [anon_sym_orr] = ACTIONS(435),
    [anon_sym_xorr] = ACTIONS(435),
    [anon_sym_cat] = ACTIONS(435),
    [anon_sym_bits] = ACTIONS(435),
    [anon_sym_head] = ACTIONS(435),
    [anon_sym_tail] = ACTIONS(435),
    [anon_sym_asFixedPoint] = ACTIONS(435),
    [anon_sym_bpshl] = ACTIONS(435),
    [anon_sym_bpshr] = ACTIONS(435),
    [anon_sym_bpset] = ACTIONS(435),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(437),
  },
  [87] = {
    [sym_identifier] = ACTIONS(439),
    [anon_sym_UInt] = ACTIONS(439),
    [anon_sym_SInt] = ACTIONS(439),
    [anon_sym_wire] = ACTIONS(439),
    [anon_sym_cmem] = ACTIONS(439),
    [anon_sym_smem] = ACTIONS(439),
    [anon_sym_reg] = ACTIONS(439),
    [anon_sym_mem] = ACTIONS(439),
    [anon_sym_inst] = ACTIONS(439),
    [anon_sym_node] = ACTIONS(439),
    [anon_sym_when] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_stop] = ACTIONS(439),
    [anon_sym_printf] = ACTIONS(439),
    [anon_sym_assert] = ACTIONS(439),
    [anon_sym_assume] = ACTIONS(439),
    [anon_sym_cover] = ACTIONS(439),
    [anon_sym_skip] = ACTIONS(439),
    [anon_sym_attach] = ACTIONS(439),
    [anon_sym_infer] = ACTIONS(439),
    [anon_sym_read] = ACTIONS(439),
    [anon_sym_write] = ACTIONS(439),
    [anon_sym_rdwr] = ACTIONS(439),
    [anon_sym_mux] = ACTIONS(439),
    [anon_sym_validif] = ACTIONS(439),
    [anon_sym_add] = ACTIONS(439),
    [anon_sym_sub] = ACTIONS(439),
    [anon_sym_mul] = ACTIONS(439),
    [anon_sym_div] = ACTIONS(439),
    [anon_sym_rem] = ACTIONS(439),
    [anon_sym_lt] = ACTIONS(439),
    [anon_sym_leq] = ACTIONS(439),
    [anon_sym_gt] = ACTIONS(439),
    [anon_sym_geq] = ACTIONS(439),
    [anon_sym_eq] = ACTIONS(439),
    [anon_sym_neq] = ACTIONS(439),
    [anon_sym_pad] = ACTIONS(439),
    [anon_sym_asUInt] = ACTIONS(439),
    [anon_sym_asAsyncReset] = ACTIONS(439),
    [anon_sym_asSInt] = ACTIONS(439),
    [anon_sym_asClock] = ACTIONS(439),
    [anon_sym_shl] = ACTIONS(439),
    [anon_sym_shr] = ACTIONS(439),
    [anon_sym_dshl] = ACTIONS(439),
    [anon_sym_dshlw] = ACTIONS(439),
    [anon_sym_dshr] = ACTIONS(439),
    [anon_sym_dshrw] = ACTIONS(439),
    [anon_sym_cvt] = ACTIONS(439),
    [anon_sym_neg] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(439),
    [anon_sym_or] = ACTIONS(439),
    [anon_sym_xor] = ACTIONS(439),
    [anon_sym_andr] = ACTIONS(439),
    [anon_sym_orr] = ACTIONS(439),
    [anon_sym_xorr] = ACTIONS(439),
    [anon_sym_cat] = ACTIONS(439),
    [anon_sym_bits] = ACTIONS(439),
    [anon_sym_head] = ACTIONS(439),
    [anon_sym_tail] = ACTIONS(439),
    [anon_sym_asFixedPoint] = ACTIONS(439),
    [anon_sym_bpshl] = ACTIONS(439),
    [anon_sym_bpshr] = ACTIONS(439),
    [anon_sym_bpset] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(441),
  },
  [88] = {
    [sym_identifier] = ACTIONS(443),
    [anon_sym_UInt] = ACTIONS(443),
    [anon_sym_SInt] = ACTIONS(443),
    [anon_sym_wire] = ACTIONS(443),
    [anon_sym_cmem] = ACTIONS(443),
    [anon_sym_smem] = ACTIONS(443),
    [anon_sym_reg] = ACTIONS(443),
    [anon_sym_mem] = ACTIONS(443),
    [anon_sym_inst] = ACTIONS(443),
    [anon_sym_node] = ACTIONS(443),
    [anon_sym_when] = ACTIONS(443),
    [anon_sym_else] = ACTIONS(443),
    [anon_sym_stop] = ACTIONS(443),
    [anon_sym_printf] = ACTIONS(443),
    [anon_sym_assert] = ACTIONS(443),
    [anon_sym_assume] = ACTIONS(443),
    [anon_sym_cover] = ACTIONS(443),
    [anon_sym_skip] = ACTIONS(443),
    [anon_sym_attach] = ACTIONS(443),
    [anon_sym_infer] = ACTIONS(443),
    [anon_sym_read] = ACTIONS(443),
    [anon_sym_write] = ACTIONS(443),
    [anon_sym_rdwr] = ACTIONS(443),
    [anon_sym_mux] = ACTIONS(443),
    [anon_sym_validif] = ACTIONS(443),
    [anon_sym_add] = ACTIONS(443),
    [anon_sym_sub] = ACTIONS(443),
    [anon_sym_mul] = ACTIONS(443),
    [anon_sym_div] = ACTIONS(443),
    [anon_sym_rem] = ACTIONS(443),
    [anon_sym_lt] = ACTIONS(443),
    [anon_sym_leq] = ACTIONS(443),
    [anon_sym_gt] = ACTIONS(443),
    [anon_sym_geq] = ACTIONS(443),
    [anon_sym_eq] = ACTIONS(443),
    [anon_sym_neq] = ACTIONS(443),
    [anon_sym_pad] = ACTIONS(443),
    [anon_sym_asUInt] = ACTIONS(443),
    [anon_sym_asAsyncReset] = ACTIONS(443),
    [anon_sym_asSInt] = ACTIONS(443),
    [anon_sym_asClock] = ACTIONS(443),
    [anon_sym_shl] = ACTIONS(443),
    [anon_sym_shr] = ACTIONS(443),
    [anon_sym_dshl] = ACTIONS(443),
    [anon_sym_dshlw] = ACTIONS(443),
    [anon_sym_dshr] = ACTIONS(443),
    [anon_sym_dshrw] = ACTIONS(443),
    [anon_sym_cvt] = ACTIONS(443),
    [anon_sym_neg] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_and] = ACTIONS(443),
    [anon_sym_or] = ACTIONS(443),
    [anon_sym_xor] = ACTIONS(443),
    [anon_sym_andr] = ACTIONS(443),
    [anon_sym_orr] = ACTIONS(443),
    [anon_sym_xorr] = ACTIONS(443),
    [anon_sym_cat] = ACTIONS(443),
    [anon_sym_bits] = ACTIONS(443),
    [anon_sym_head] = ACTIONS(443),
    [anon_sym_tail] = ACTIONS(443),
    [anon_sym_asFixedPoint] = ACTIONS(443),
    [anon_sym_bpshl] = ACTIONS(443),
    [anon_sym_bpshr] = ACTIONS(443),
    [anon_sym_bpset] = ACTIONS(443),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(445),
  },
  [89] = {
    [sym_identifier] = ACTIONS(447),
    [anon_sym_UInt] = ACTIONS(447),
    [anon_sym_SInt] = ACTIONS(447),
    [anon_sym_wire] = ACTIONS(447),
    [anon_sym_cmem] = ACTIONS(447),
    [anon_sym_smem] = ACTIONS(447),
    [anon_sym_reg] = ACTIONS(447),
    [anon_sym_mem] = ACTIONS(447),
    [anon_sym_inst] = ACTIONS(447),
    [anon_sym_node] = ACTIONS(447),
    [anon_sym_when] = ACTIONS(447),
    [anon_sym_else] = ACTIONS(447),
    [anon_sym_stop] = ACTIONS(447),
    [anon_sym_printf] = ACTIONS(447),
    [anon_sym_assert] = ACTIONS(447),
    [anon_sym_assume] = ACTIONS(447),
    [anon_sym_cover] = ACTIONS(447),
    [anon_sym_skip] = ACTIONS(447),
    [anon_sym_attach] = ACTIONS(447),
    [anon_sym_infer] = ACTIONS(447),
    [anon_sym_read] = ACTIONS(447),
    [anon_sym_write] = ACTIONS(447),
    [anon_sym_rdwr] = ACTIONS(447),
    [anon_sym_mux] = ACTIONS(447),
    [anon_sym_validif] = ACTIONS(447),
    [anon_sym_add] = ACTIONS(447),
    [anon_sym_sub] = ACTIONS(447),
    [anon_sym_mul] = ACTIONS(447),
    [anon_sym_div] = ACTIONS(447),
    [anon_sym_rem] = ACTIONS(447),
    [anon_sym_lt] = ACTIONS(447),
    [anon_sym_leq] = ACTIONS(447),
    [anon_sym_gt] = ACTIONS(447),
    [anon_sym_geq] = ACTIONS(447),
    [anon_sym_eq] = ACTIONS(447),
    [anon_sym_neq] = ACTIONS(447),
    [anon_sym_pad] = ACTIONS(447),
    [anon_sym_asUInt] = ACTIONS(447),
    [anon_sym_asAsyncReset] = ACTIONS(447),
    [anon_sym_asSInt] = ACTIONS(447),
    [anon_sym_asClock] = ACTIONS(447),
    [anon_sym_shl] = ACTIONS(447),
    [anon_sym_shr] = ACTIONS(447),
    [anon_sym_dshl] = ACTIONS(447),
    [anon_sym_dshlw] = ACTIONS(447),
    [anon_sym_dshr] = ACTIONS(447),
    [anon_sym_dshrw] = ACTIONS(447),
    [anon_sym_cvt] = ACTIONS(447),
    [anon_sym_neg] = ACTIONS(447),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_and] = ACTIONS(447),
    [anon_sym_or] = ACTIONS(447),
    [anon_sym_xor] = ACTIONS(447),
    [anon_sym_andr] = ACTIONS(447),
    [anon_sym_orr] = ACTIONS(447),
    [anon_sym_xorr] = ACTIONS(447),
    [anon_sym_cat] = ACTIONS(447),
    [anon_sym_bits] = ACTIONS(447),
    [anon_sym_head] = ACTIONS(447),
    [anon_sym_tail] = ACTIONS(447),
    [anon_sym_asFixedPoint] = ACTIONS(447),
    [anon_sym_bpshl] = ACTIONS(447),
    [anon_sym_bpshr] = ACTIONS(447),
    [anon_sym_bpset] = ACTIONS(447),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(449),
  },
  [90] = {
    [sym_identifier] = ACTIONS(451),
    [anon_sym_UInt] = ACTIONS(451),
    [anon_sym_SInt] = ACTIONS(451),
    [anon_sym_wire] = ACTIONS(451),
    [anon_sym_cmem] = ACTIONS(451),
    [anon_sym_smem] = ACTIONS(451),
    [anon_sym_reg] = ACTIONS(451),
    [anon_sym_mem] = ACTIONS(451),
    [anon_sym_inst] = ACTIONS(451),
    [anon_sym_node] = ACTIONS(451),
    [anon_sym_when] = ACTIONS(451),
    [anon_sym_else] = ACTIONS(451),
    [anon_sym_stop] = ACTIONS(451),
    [anon_sym_printf] = ACTIONS(451),
    [anon_sym_assert] = ACTIONS(451),
    [anon_sym_assume] = ACTIONS(451),
    [anon_sym_cover] = ACTIONS(451),
    [anon_sym_skip] = ACTIONS(451),
    [anon_sym_attach] = ACTIONS(451),
    [anon_sym_infer] = ACTIONS(451),
    [anon_sym_read] = ACTIONS(451),
    [anon_sym_write] = ACTIONS(451),
    [anon_sym_rdwr] = ACTIONS(451),
    [anon_sym_mux] = ACTIONS(451),
    [anon_sym_validif] = ACTIONS(451),
    [anon_sym_add] = ACTIONS(451),
    [anon_sym_sub] = ACTIONS(451),
    [anon_sym_mul] = ACTIONS(451),
    [anon_sym_div] = ACTIONS(451),
    [anon_sym_rem] = ACTIONS(451),
    [anon_sym_lt] = ACTIONS(451),
    [anon_sym_leq] = ACTIONS(451),
    [anon_sym_gt] = ACTIONS(451),
    [anon_sym_geq] = ACTIONS(451),
    [anon_sym_eq] = ACTIONS(451),
    [anon_sym_neq] = ACTIONS(451),
    [anon_sym_pad] = ACTIONS(451),
    [anon_sym_asUInt] = ACTIONS(451),
    [anon_sym_asAsyncReset] = ACTIONS(451),
    [anon_sym_asSInt] = ACTIONS(451),
    [anon_sym_asClock] = ACTIONS(451),
    [anon_sym_shl] = ACTIONS(451),
    [anon_sym_shr] = ACTIONS(451),
    [anon_sym_dshl] = ACTIONS(451),
    [anon_sym_dshlw] = ACTIONS(451),
    [anon_sym_dshr] = ACTIONS(451),
    [anon_sym_dshrw] = ACTIONS(451),
    [anon_sym_cvt] = ACTIONS(451),
    [anon_sym_neg] = ACTIONS(451),
    [anon_sym_not] = ACTIONS(451),
    [anon_sym_and] = ACTIONS(451),
    [anon_sym_or] = ACTIONS(451),
    [anon_sym_xor] = ACTIONS(451),
    [anon_sym_andr] = ACTIONS(451),
    [anon_sym_orr] = ACTIONS(451),
    [anon_sym_xorr] = ACTIONS(451),
    [anon_sym_cat] = ACTIONS(451),
    [anon_sym_bits] = ACTIONS(451),
    [anon_sym_head] = ACTIONS(451),
    [anon_sym_tail] = ACTIONS(451),
    [anon_sym_asFixedPoint] = ACTIONS(451),
    [anon_sym_bpshl] = ACTIONS(451),
    [anon_sym_bpshr] = ACTIONS(451),
    [anon_sym_bpset] = ACTIONS(451),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(453),
  },
  [91] = {
    [sym_identifier] = ACTIONS(455),
    [anon_sym_UInt] = ACTIONS(455),
    [anon_sym_SInt] = ACTIONS(455),
    [anon_sym_wire] = ACTIONS(455),
    [anon_sym_cmem] = ACTIONS(455),
    [anon_sym_smem] = ACTIONS(455),
    [anon_sym_reg] = ACTIONS(455),
    [anon_sym_mem] = ACTIONS(455),
    [anon_sym_inst] = ACTIONS(455),
    [anon_sym_node] = ACTIONS(455),
    [anon_sym_when] = ACTIONS(455),
    [anon_sym_else] = ACTIONS(455),
    [anon_sym_stop] = ACTIONS(455),
    [anon_sym_printf] = ACTIONS(455),
    [anon_sym_assert] = ACTIONS(455),
    [anon_sym_assume] = ACTIONS(455),
    [anon_sym_cover] = ACTIONS(455),
    [anon_sym_skip] = ACTIONS(455),
    [anon_sym_attach] = ACTIONS(455),
    [anon_sym_infer] = ACTIONS(455),
    [anon_sym_read] = ACTIONS(455),
    [anon_sym_write] = ACTIONS(455),
    [anon_sym_rdwr] = ACTIONS(455),
    [anon_sym_mux] = ACTIONS(455),
    [anon_sym_validif] = ACTIONS(455),
    [anon_sym_add] = ACTIONS(455),
    [anon_sym_sub] = ACTIONS(455),
    [anon_sym_mul] = ACTIONS(455),
    [anon_sym_div] = ACTIONS(455),
    [anon_sym_rem] = ACTIONS(455),
    [anon_sym_lt] = ACTIONS(455),
    [anon_sym_leq] = ACTIONS(455),
    [anon_sym_gt] = ACTIONS(455),
    [anon_sym_geq] = ACTIONS(455),
    [anon_sym_eq] = ACTIONS(455),
    [anon_sym_neq] = ACTIONS(455),
    [anon_sym_pad] = ACTIONS(455),
    [anon_sym_asUInt] = ACTIONS(455),
    [anon_sym_asAsyncReset] = ACTIONS(455),
    [anon_sym_asSInt] = ACTIONS(455),
    [anon_sym_asClock] = ACTIONS(455),
    [anon_sym_shl] = ACTIONS(455),
    [anon_sym_shr] = ACTIONS(455),
    [anon_sym_dshl] = ACTIONS(455),
    [anon_sym_dshlw] = ACTIONS(455),
    [anon_sym_dshr] = ACTIONS(455),
    [anon_sym_dshrw] = ACTIONS(455),
    [anon_sym_cvt] = ACTIONS(455),
    [anon_sym_neg] = ACTIONS(455),
    [anon_sym_not] = ACTIONS(455),
    [anon_sym_and] = ACTIONS(455),
    [anon_sym_or] = ACTIONS(455),
    [anon_sym_xor] = ACTIONS(455),
    [anon_sym_andr] = ACTIONS(455),
    [anon_sym_orr] = ACTIONS(455),
    [anon_sym_xorr] = ACTIONS(455),
    [anon_sym_cat] = ACTIONS(455),
    [anon_sym_bits] = ACTIONS(455),
    [anon_sym_head] = ACTIONS(455),
    [anon_sym_tail] = ACTIONS(455),
    [anon_sym_asFixedPoint] = ACTIONS(455),
    [anon_sym_bpshl] = ACTIONS(455),
    [anon_sym_bpshr] = ACTIONS(455),
    [anon_sym_bpset] = ACTIONS(455),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(457),
  },
  [92] = {
    [sym_identifier] = ACTIONS(459),
    [anon_sym_UInt] = ACTIONS(459),
    [anon_sym_SInt] = ACTIONS(459),
    [anon_sym_wire] = ACTIONS(459),
    [anon_sym_cmem] = ACTIONS(459),
    [anon_sym_smem] = ACTIONS(459),
    [anon_sym_reg] = ACTIONS(459),
    [anon_sym_mem] = ACTIONS(459),
    [anon_sym_inst] = ACTIONS(459),
    [anon_sym_node] = ACTIONS(459),
    [anon_sym_when] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(459),
    [anon_sym_stop] = ACTIONS(459),
    [anon_sym_printf] = ACTIONS(459),
    [anon_sym_assert] = ACTIONS(459),
    [anon_sym_assume] = ACTIONS(459),
    [anon_sym_cover] = ACTIONS(459),
    [anon_sym_skip] = ACTIONS(459),
    [anon_sym_attach] = ACTIONS(459),
    [anon_sym_infer] = ACTIONS(459),
    [anon_sym_read] = ACTIONS(459),
    [anon_sym_write] = ACTIONS(459),
    [anon_sym_rdwr] = ACTIONS(459),
    [anon_sym_mux] = ACTIONS(459),
    [anon_sym_validif] = ACTIONS(459),
    [anon_sym_add] = ACTIONS(459),
    [anon_sym_sub] = ACTIONS(459),
    [anon_sym_mul] = ACTIONS(459),
    [anon_sym_div] = ACTIONS(459),
    [anon_sym_rem] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_leq] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_geq] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_neq] = ACTIONS(459),
    [anon_sym_pad] = ACTIONS(459),
    [anon_sym_asUInt] = ACTIONS(459),
    [anon_sym_asAsyncReset] = ACTIONS(459),
    [anon_sym_asSInt] = ACTIONS(459),
    [anon_sym_asClock] = ACTIONS(459),
    [anon_sym_shl] = ACTIONS(459),
    [anon_sym_shr] = ACTIONS(459),
    [anon_sym_dshl] = ACTIONS(459),
    [anon_sym_dshlw] = ACTIONS(459),
    [anon_sym_dshr] = ACTIONS(459),
    [anon_sym_dshrw] = ACTIONS(459),
    [anon_sym_cvt] = ACTIONS(459),
    [anon_sym_neg] = ACTIONS(459),
    [anon_sym_not] = ACTIONS(459),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_xor] = ACTIONS(459),
    [anon_sym_andr] = ACTIONS(459),
    [anon_sym_orr] = ACTIONS(459),
    [anon_sym_xorr] = ACTIONS(459),
    [anon_sym_cat] = ACTIONS(459),
    [anon_sym_bits] = ACTIONS(459),
    [anon_sym_head] = ACTIONS(459),
    [anon_sym_tail] = ACTIONS(459),
    [anon_sym_asFixedPoint] = ACTIONS(459),
    [anon_sym_bpshl] = ACTIONS(459),
    [anon_sym_bpshr] = ACTIONS(459),
    [anon_sym_bpset] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(461),
  },
  [93] = {
    [sym_identifier] = ACTIONS(463),
    [anon_sym_UInt] = ACTIONS(463),
    [anon_sym_SInt] = ACTIONS(463),
    [anon_sym_wire] = ACTIONS(463),
    [anon_sym_cmem] = ACTIONS(463),
    [anon_sym_smem] = ACTIONS(463),
    [anon_sym_reg] = ACTIONS(463),
    [anon_sym_mem] = ACTIONS(463),
    [anon_sym_inst] = ACTIONS(463),
    [anon_sym_node] = ACTIONS(463),
    [anon_sym_when] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(463),
    [anon_sym_stop] = ACTIONS(463),
    [anon_sym_printf] = ACTIONS(463),
    [anon_sym_assert] = ACTIONS(463),
    [anon_sym_assume] = ACTIONS(463),
    [anon_sym_cover] = ACTIONS(463),
    [anon_sym_skip] = ACTIONS(463),
    [anon_sym_attach] = ACTIONS(463),
    [anon_sym_infer] = ACTIONS(463),
    [anon_sym_read] = ACTIONS(463),
    [anon_sym_write] = ACTIONS(463),
    [anon_sym_rdwr] = ACTIONS(463),
    [anon_sym_mux] = ACTIONS(463),
    [anon_sym_validif] = ACTIONS(463),
    [anon_sym_add] = ACTIONS(463),
    [anon_sym_sub] = ACTIONS(463),
    [anon_sym_mul] = ACTIONS(463),
    [anon_sym_div] = ACTIONS(463),
    [anon_sym_rem] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_leq] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_geq] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_neq] = ACTIONS(463),
    [anon_sym_pad] = ACTIONS(463),
    [anon_sym_asUInt] = ACTIONS(463),
    [anon_sym_asAsyncReset] = ACTIONS(463),
    [anon_sym_asSInt] = ACTIONS(463),
    [anon_sym_asClock] = ACTIONS(463),
    [anon_sym_shl] = ACTIONS(463),
    [anon_sym_shr] = ACTIONS(463),
    [anon_sym_dshl] = ACTIONS(463),
    [anon_sym_dshlw] = ACTIONS(463),
    [anon_sym_dshr] = ACTIONS(463),
    [anon_sym_dshrw] = ACTIONS(463),
    [anon_sym_cvt] = ACTIONS(463),
    [anon_sym_neg] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(463),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_xor] = ACTIONS(463),
    [anon_sym_andr] = ACTIONS(463),
    [anon_sym_orr] = ACTIONS(463),
    [anon_sym_xorr] = ACTIONS(463),
    [anon_sym_cat] = ACTIONS(463),
    [anon_sym_bits] = ACTIONS(463),
    [anon_sym_head] = ACTIONS(463),
    [anon_sym_tail] = ACTIONS(463),
    [anon_sym_asFixedPoint] = ACTIONS(463),
    [anon_sym_bpshl] = ACTIONS(463),
    [anon_sym_bpshr] = ACTIONS(463),
    [anon_sym_bpset] = ACTIONS(463),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(465),
  },
  [94] = {
    [sym_identifier] = ACTIONS(321),
    [anon_sym_UInt] = ACTIONS(321),
    [anon_sym_SInt] = ACTIONS(321),
    [anon_sym_wire] = ACTIONS(321),
    [anon_sym_cmem] = ACTIONS(321),
    [anon_sym_smem] = ACTIONS(321),
    [anon_sym_reg] = ACTIONS(321),
    [anon_sym_mem] = ACTIONS(321),
    [anon_sym_inst] = ACTIONS(321),
    [anon_sym_node] = ACTIONS(321),
    [anon_sym_when] = ACTIONS(321),
    [anon_sym_else] = ACTIONS(321),
    [anon_sym_stop] = ACTIONS(321),
    [anon_sym_printf] = ACTIONS(321),
    [anon_sym_assert] = ACTIONS(321),
    [anon_sym_assume] = ACTIONS(321),
    [anon_sym_cover] = ACTIONS(321),
    [anon_sym_skip] = ACTIONS(321),
    [anon_sym_attach] = ACTIONS(321),
    [anon_sym_infer] = ACTIONS(321),
    [anon_sym_read] = ACTIONS(321),
    [anon_sym_write] = ACTIONS(321),
    [anon_sym_rdwr] = ACTIONS(321),
    [anon_sym_mux] = ACTIONS(321),
    [anon_sym_validif] = ACTIONS(321),
    [anon_sym_add] = ACTIONS(321),
    [anon_sym_sub] = ACTIONS(321),
    [anon_sym_mul] = ACTIONS(321),
    [anon_sym_div] = ACTIONS(321),
    [anon_sym_rem] = ACTIONS(321),
    [anon_sym_lt] = ACTIONS(321),
    [anon_sym_leq] = ACTIONS(321),
    [anon_sym_gt] = ACTIONS(321),
    [anon_sym_geq] = ACTIONS(321),
    [anon_sym_eq] = ACTIONS(321),
    [anon_sym_neq] = ACTIONS(321),
    [anon_sym_pad] = ACTIONS(321),
    [anon_sym_asUInt] = ACTIONS(321),
    [anon_sym_asAsyncReset] = ACTIONS(321),
    [anon_sym_asSInt] = ACTIONS(321),
    [anon_sym_asClock] = ACTIONS(321),
    [anon_sym_shl] = ACTIONS(321),
    [anon_sym_shr] = ACTIONS(321),
    [anon_sym_dshl] = ACTIONS(321),
    [anon_sym_dshlw] = ACTIONS(321),
    [anon_sym_dshr] = ACTIONS(321),
    [anon_sym_dshrw] = ACTIONS(321),
    [anon_sym_cvt] = ACTIONS(321),
    [anon_sym_neg] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(321),
    [anon_sym_and] = ACTIONS(321),
    [anon_sym_or] = ACTIONS(321),
    [anon_sym_xor] = ACTIONS(321),
    [anon_sym_andr] = ACTIONS(321),
    [anon_sym_orr] = ACTIONS(321),
    [anon_sym_xorr] = ACTIONS(321),
    [anon_sym_cat] = ACTIONS(321),
    [anon_sym_bits] = ACTIONS(321),
    [anon_sym_head] = ACTIONS(321),
    [anon_sym_tail] = ACTIONS(321),
    [anon_sym_asFixedPoint] = ACTIONS(321),
    [anon_sym_bpshl] = ACTIONS(321),
    [anon_sym_bpshr] = ACTIONS(321),
    [anon_sym_bpset] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(325),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(210), 1,
      sym_expression,
    STATE(258), 1,
      sym_number,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [91] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(204), 1,
      sym_expression,
    STATE(278), 1,
      sym_number,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [182] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(254), 1,
      sym_expression,
    STATE(419), 1,
      sym_number,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [273] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(220), 1,
      sym_expression,
    STATE(319), 1,
      sym_number,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [364] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(279), 1,
      sym_expression,
    STATE(382), 1,
      sym_number,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [455] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(244), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [531] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(265), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [607] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(304), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [683] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(248), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [759] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(240), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [835] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(289), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [911] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(246), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [987] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(267), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1063] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(268), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1139] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(217), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1215] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(281), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1291] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(250), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1367] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(251), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1443] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      sym_identifier,
    ACTIONS(473), 1,
      anon_sym_mux,
    ACTIONS(475), 1,
      anon_sym_validif,
    STATE(19), 1,
      sym_primop,
    STATE(35), 1,
      sym_expression,
    STATE(425), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(31), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(477), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1519] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(282), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1595] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      sym_identifier,
    ACTIONS(473), 1,
      anon_sym_mux,
    ACTIONS(475), 1,
      anon_sym_validif,
    STATE(19), 1,
      sym_primop,
    STATE(37), 1,
      sym_expression,
    STATE(425), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(31), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(477), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1671] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(284), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1747] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      sym_identifier,
    ACTIONS(473), 1,
      anon_sym_mux,
    ACTIONS(475), 1,
      anon_sym_validif,
    STATE(19), 1,
      sym_primop,
    STATE(32), 1,
      sym_expression,
    STATE(425), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(31), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(477), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1823] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(272), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1899] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      sym_identifier,
    ACTIONS(473), 1,
      anon_sym_mux,
    ACTIONS(475), 1,
      anon_sym_validif,
    STATE(19), 1,
      sym_primop,
    STATE(38), 1,
      sym_expression,
    STATE(425), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(31), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(477), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [1975] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(300), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2051] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(301), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2127] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(208), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2203] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(243), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2279] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(266), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2355] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(247), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2431] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      sym_identifier,
    ACTIONS(473), 1,
      anon_sym_mux,
    ACTIONS(475), 1,
      anon_sym_validif,
    STATE(19), 1,
      sym_primop,
    STATE(28), 1,
      sym_expression,
    STATE(425), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(31), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(477), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2507] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(245), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2583] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(241), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2659] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(43), 1,
      anon_sym_mux,
    ACTIONS(45), 1,
      anon_sym_validif,
    STATE(143), 1,
      sym_primop,
    STATE(242), 1,
      sym_expression,
    STATE(433), 1,
      sym_litType,
    ACTIONS(13), 2,
      anon_sym_UInt,
      anon_sym_SInt,
    STATE(160), 7,
      sym_literal,
      sym_sub_field,
      sym_sub_index,
      sym_sub_access,
      sym_mux,
      sym_conditionally_valid,
      sym_primitive_operation,
    ACTIONS(47), 39,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_mul,
      anon_sym_div,
      anon_sym_rem,
      anon_sym_lt,
      anon_sym_leq,
      anon_sym_gt,
      anon_sym_geq,
      anon_sym_eq,
      anon_sym_neq,
      anon_sym_pad,
      anon_sym_asUInt,
      anon_sym_asAsyncReset,
      anon_sym_asSInt,
      anon_sym_asClock,
      anon_sym_shl,
      anon_sym_shr,
      anon_sym_dshl,
      anon_sym_dshlw,
      anon_sym_dshr,
      anon_sym_dshrw,
      anon_sym_cvt,
      anon_sym_neg,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_andr,
      anon_sym_orr,
      anon_sym_xorr,
      anon_sym_cat,
      anon_sym_bits,
      anon_sym_head,
      anon_sym_tail,
      anon_sym_asFixedPoint,
      anon_sym_bpshl,
      anon_sym_bpshr,
      anon_sym_bpset,
  [2735] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(483), 1,
      sym_double,
    ACTIONS(485), 1,
      anon_sym_DQUOTE,
    ACTIONS(487), 1,
      anon_sym_SQUOTE,
    ACTIONS(479), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(481), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(343), 2,
      sym_uint,
      sym_sint,
    STATE(357), 3,
      sym_number,
      sym_string,
      sym_raw_string,
  [2765] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym__dedent,
    ACTIONS(491), 1,
      anon_sym_defname,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(225), 1,
      sym_defname,
    STATE(429), 1,
      sym_dir,
    ACTIONS(489), 2,
      anon_sym_input,
      anon_sym_output,
    STATE(137), 2,
      sym_port,
      aux_sym_module_repeat1,
    STATE(230), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [2796] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_data_DASHtype,
    ACTIONS(499), 1,
      anon_sym_read_DASHunder_DASHwrite,
    ACTIONS(503), 1,
      sym__dedent,
    STATE(133), 2,
      sym_memory_field,
      aux_sym_memory_repeat1,
    ACTIONS(497), 3,
      anon_sym_depth,
      anon_sym_read_DASHlatency,
      anon_sym_write_DASHlatency,
    ACTIONS(501), 3,
      anon_sym_reader,
      anon_sym_writer,
      anon_sym_readwriter,
  [2823] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_data_DASHtype,
    ACTIONS(499), 1,
      anon_sym_read_DASHunder_DASHwrite,
    ACTIONS(505), 1,
      sym__dedent,
    STATE(139), 2,
      sym_memory_field,
      aux_sym_memory_repeat1,
    ACTIONS(497), 3,
      anon_sym_depth,
      anon_sym_read_DASHlatency,
      anon_sym_write_DASHlatency,
    ACTIONS(501), 3,
      anon_sym_reader,
      anon_sym_writer,
      anon_sym_readwriter,
  [2850] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_data_DASHtype,
    ACTIONS(499), 1,
      anon_sym_read_DASHunder_DASHwrite,
    ACTIONS(505), 1,
      sym__dedent,
    STATE(138), 2,
      sym_memory_field,
      aux_sym_memory_repeat1,
    ACTIONS(497), 3,
      anon_sym_depth,
      anon_sym_read_DASHlatency,
      anon_sym_write_DASHlatency,
    ACTIONS(501), 3,
      anon_sym_reader,
      anon_sym_writer,
      anon_sym_readwriter,
  [2877] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(507), 1,
      anon_sym_const,
    ACTIONS(511), 1,
      anon_sym_Fixed,
    ACTIONS(515), 1,
      anon_sym_LBRACE,
    STATE(164), 1,
      sym_qualifier,
    STATE(298), 1,
      sym_type,
    ACTIONS(509), 3,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
    ACTIONS(513), 3,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
  [2906] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym__dedent,
    ACTIONS(491), 1,
      anon_sym_defname,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(237), 1,
      sym_defname,
    STATE(429), 1,
      sym_dir,
    ACTIONS(489), 2,
      anon_sym_input,
      anon_sym_output,
    STATE(140), 2,
      sym_port,
      aux_sym_module_repeat1,
    STATE(236), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [2937] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym__dedent,
    ACTIONS(491), 1,
      anon_sym_defname,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(237), 1,
      sym_defname,
    STATE(429), 1,
      sym_dir,
    ACTIONS(489), 2,
      anon_sym_input,
      anon_sym_output,
    STATE(16), 2,
      sym_port,
      aux_sym_module_repeat1,
    STATE(236), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [2968] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_data_DASHtype,
    ACTIONS(499), 1,
      anon_sym_read_DASHunder_DASHwrite,
    ACTIONS(517), 1,
      sym__dedent,
    STATE(139), 2,
      sym_memory_field,
      aux_sym_memory_repeat1,
    ACTIONS(497), 3,
      anon_sym_depth,
      anon_sym_read_DASHlatency,
      anon_sym_write_DASHlatency,
    ACTIONS(501), 3,
      anon_sym_reader,
      anon_sym_writer,
      anon_sym_readwriter,
  [2995] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_data_DASHtype,
    ACTIONS(525), 1,
      anon_sym_read_DASHunder_DASHwrite,
    ACTIONS(531), 1,
      sym__dedent,
    STATE(139), 2,
      sym_memory_field,
      aux_sym_memory_repeat1,
    ACTIONS(522), 3,
      anon_sym_depth,
      anon_sym_read_DASHlatency,
      anon_sym_write_DASHlatency,
    ACTIONS(528), 3,
      anon_sym_reader,
      anon_sym_writer,
      anon_sym_readwriter,
  [3022] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym__dedent,
    ACTIONS(491), 1,
      anon_sym_defname,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(215), 1,
      sym_defname,
    STATE(429), 1,
      sym_dir,
    ACTIONS(489), 2,
      anon_sym_input,
      anon_sym_output,
    STATE(16), 2,
      sym_port,
      aux_sym_module_repeat1,
    STATE(221), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [3053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(139), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(535), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(163), 10,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(537), 9,
      sym__dedent,
      anon_sym_data_DASHtype,
      anon_sym_depth,
      anon_sym_read_DASHlatency,
      anon_sym_write_DASHlatency,
      anon_sym_read_DASHunder_DASHwrite,
      anon_sym_reader,
      anon_sym_writer,
      anon_sym_readwriter,
  [3136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(151), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3166] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(511), 1,
      anon_sym_Fixed,
    ACTIONS(515), 1,
      anon_sym_LBRACE,
    STATE(308), 1,
      sym_type,
    ACTIONS(509), 3,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
    ACTIONS(513), 3,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
  [3189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 1,
      anon_sym_Fixed,
    ACTIONS(545), 1,
      anon_sym_LBRACE,
    STATE(270), 1,
      sym_type,
    ACTIONS(539), 3,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
    ACTIONS(543), 3,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
  [3212] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 1,
      anon_sym_Fixed,
    ACTIONS(553), 1,
      anon_sym_LBRACE,
    STATE(44), 1,
      sym_type,
    ACTIONS(547), 3,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
    ACTIONS(551), 3,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
  [3235] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_RBRACE,
    ACTIONS(559), 1,
      anon_sym_flip,
    STATE(152), 1,
      sym_uint,
    STATE(252), 1,
      sym_field,
    STATE(347), 1,
      sym_field_id,
    ACTIONS(555), 2,
      sym_identifier,
      sym_relaxed_identifier,
    ACTIONS(561), 2,
      anon_sym_0,
      aux_sym_uint_token1,
  [3262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3277] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(559), 1,
      anon_sym_flip,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    STATE(152), 1,
      sym_uint,
    STATE(262), 1,
      sym_field,
    STATE(347), 1,
      sym_field_id,
    ACTIONS(555), 2,
      sym_identifier,
      sym_relaxed_identifier,
    ACTIONS(561), 2,
      anon_sym_0,
      aux_sym_uint_token1,
  [3304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(159), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(565), 9,
      sym__dedent,
      anon_sym_data_DASHtype,
      anon_sym_depth,
      anon_sym_read_DASHlatency,
      anon_sym_write_DASHlatency,
      anon_sym_read_DASHunder_DASHwrite,
      anon_sym_reader,
      anon_sym_writer,
      anon_sym_readwriter,
  [3334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 1,
      anon_sym_Fixed,
    ACTIONS(553), 1,
      anon_sym_LBRACE,
    STATE(45), 1,
      sym_type,
    ACTIONS(547), 3,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
    ACTIONS(551), 3,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
  [3357] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(559), 1,
      anon_sym_flip,
    ACTIONS(567), 1,
      anon_sym_RBRACE,
    STATE(152), 1,
      sym_uint,
    STATE(274), 1,
      sym_field,
    STATE(347), 1,
      sym_field_id,
    ACTIONS(555), 2,
      sym_identifier,
      sym_relaxed_identifier,
    ACTIONS(561), 2,
      anon_sym_0,
      aux_sym_uint_token1,
  [3384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 1,
      anon_sym_Fixed,
    ACTIONS(553), 1,
      anon_sym_LBRACE,
    STATE(46), 1,
      sym_type,
    ACTIONS(547), 3,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
    ACTIONS(551), 3,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
  [3407] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 1,
      anon_sym_Fixed,
    ACTIONS(545), 1,
      anon_sym_LBRACE,
    STATE(287), 1,
      sym_type,
    ACTIONS(539), 3,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
    ACTIONS(543), 3,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
  [3430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3445] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 1,
      anon_sym_Fixed,
    ACTIONS(545), 1,
      anon_sym_LBRACE,
    STATE(316), 1,
      sym_type,
    ACTIONS(539), 3,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
    ACTIONS(543), 3,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
  [3468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(171), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3498] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(511), 1,
      anon_sym_Fixed,
    ACTIONS(515), 1,
      anon_sym_LBRACE,
    STATE(263), 1,
      sym_type,
    ACTIONS(509), 3,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
    ACTIONS(513), 3,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
  [3521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(155), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT_EQ,
      anon_sym_LT_DASH,
      anon_sym_is,
      anon_sym_DOT,
  [3566] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(559), 1,
      anon_sym_flip,
    STATE(152), 1,
      sym_uint,
    STATE(312), 1,
      sym_field,
    STATE(347), 1,
      sym_field_id,
    ACTIONS(555), 2,
      sym_identifier,
      sym_relaxed_identifier,
    ACTIONS(561), 2,
      anon_sym_0,
      aux_sym_uint_token1,
  [3590] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(569), 1,
      sym_number_str,
    STATE(421), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(571), 1,
      sym_number_str,
    STATE(380), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(573), 8,
      anon_sym_UInt,
      anon_sym_SInt,
      anon_sym_Analog,
      anon_sym_Fixed,
      anon_sym_Clock,
      anon_sym_AsyncReset,
      anon_sym_Reset,
      anon_sym_LBRACE,
  [3648] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_LT,
    STATE(403), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3670] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LT,
    STATE(392), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3692] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_LT,
    STATE(348), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(358), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(417), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(416), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(424), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(394), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(400), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(405), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(431), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3866] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(423), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(441), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(384), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(402), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(391), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(439), 1,
      sym_number,
    ACTIONS(467), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(222), 2,
      sym_uint,
      sym_sint,
  [3980] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(389), 1,
      sym_number,
    ACTIONS(581), 2,
      anon_sym_0,
      aux_sym_uint_token1,
    ACTIONS(583), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(343), 2,
      sym_uint,
      sym_sint,
  [3999] = 4,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(590), 1,
      sym_comment,
    STATE(190), 2,
      sym__escape_sequence,
      aux_sym_raw_string_repeat1,
    ACTIONS(587), 3,
      sym_raw_string_content,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [4015] = 4,
    ACTIONS(590), 1,
      sym_comment,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    STATE(190), 2,
      sym__escape_sequence,
      aux_sym_raw_string_repeat1,
    ACTIONS(594), 3,
      sym_raw_string_content,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [4031] = 4,
    ACTIONS(590), 1,
      sym_comment,
    ACTIONS(596), 1,
      anon_sym_DQUOTE,
    STATE(192), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
    ACTIONS(598), 3,
      sym_string_content,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [4047] = 4,
    ACTIONS(590), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_SQUOTE,
    STATE(191), 2,
      sym__escape_sequence,
      aux_sym_raw_string_repeat1,
    ACTIONS(603), 3,
      sym_raw_string_content,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [4063] = 4,
    ACTIONS(590), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_DQUOTE,
    STATE(192), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
    ACTIONS(607), 3,
      sym_string_content,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [4079] = 4,
    ACTIONS(590), 1,
      sym_comment,
    ACTIONS(609), 1,
      anon_sym_DQUOTE,
    STATE(194), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
    ACTIONS(611), 3,
      sym_string_content,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [4095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 1,
      sym_identifier,
    ACTIONS(617), 1,
      sym_relaxed_identifier,
    STATE(24), 1,
      sym_uint,
    STATE(26), 1,
      sym_field_id,
    ACTIONS(615), 2,
      anon_sym_0,
      aux_sym_uint_token1,
  [4115] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(555), 1,
      sym_relaxed_identifier,
    ACTIONS(619), 1,
      sym_identifier,
    STATE(147), 1,
      sym_field_id,
    STATE(152), 1,
      sym_uint,
    ACTIONS(561), 2,
      anon_sym_0,
      aux_sym_uint_token1,
  [4135] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(555), 1,
      sym_relaxed_identifier,
    ACTIONS(619), 1,
      sym_identifier,
    STATE(152), 1,
      sym_uint,
    STATE(341), 1,
      sym_field_id,
    ACTIONS(561), 2,
      anon_sym_0,
      aux_sym_uint_token1,
  [4155] = 4,
    ACTIONS(590), 1,
      sym_comment,
    ACTIONS(621), 1,
      anon_sym_DQUOTE,
    STATE(200), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
    ACTIONS(623), 3,
      sym_string_content,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [4171] = 4,
    ACTIONS(590), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_DQUOTE,
    STATE(192), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
    ACTIONS(607), 3,
      sym_string_content,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [4187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_module,
    ACTIONS(629), 1,
      anon_sym_extmodule,
    ACTIONS(631), 1,
      sym__dedent,
    STATE(202), 2,
      sym_module,
      aux_sym_circuit_repeat1,
  [4204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(633), 1,
      anon_sym_module,
    ACTIONS(636), 1,
      anon_sym_extmodule,
    ACTIONS(639), 1,
      sym__dedent,
    STATE(202), 2,
      sym_module,
      aux_sym_circuit_repeat1,
  [4221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_module,
    ACTIONS(629), 1,
      anon_sym_extmodule,
    ACTIONS(631), 1,
      sym__dedent,
    STATE(209), 2,
      sym_module,
      aux_sym_circuit_repeat1,
  [4238] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_COMMA,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_RPAREN,
    ACTIONS(647), 1,
      anon_sym_DOT,
    STATE(275), 1,
      aux_sym_primitive_operation_repeat1,
  [4257] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(649), 1,
      anon_sym_LT_EQ,
    ACTIONS(651), 1,
      anon_sym_LT_DASH,
    ACTIONS(653), 1,
      anon_sym_is,
  [4276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      sym_info,
    ACTIONS(659), 1,
      sym__indent,
    ACTIONS(655), 3,
      sym__dedent,
      anon_sym_module,
      anon_sym_extmodule,
  [4291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(661), 1,
      sym_info,
    ACTIONS(663), 1,
      sym__indent,
    ACTIONS(655), 3,
      sym__dedent,
      anon_sym_module,
      anon_sym_extmodule,
  [4306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(665), 1,
      anon_sym_COMMA,
    ACTIONS(667), 1,
      anon_sym_RPAREN,
    STATE(286), 1,
      aux_sym_printf_repeat1,
  [4325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_module,
    ACTIONS(629), 1,
      anon_sym_extmodule,
    ACTIONS(669), 1,
      sym__dedent,
    STATE(202), 2,
      sym_module,
      aux_sym_circuit_repeat1,
  [4342] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_COMMA,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(671), 1,
      anon_sym_RPAREN,
    STATE(303), 1,
      aux_sym_primitive_operation_repeat1,
  [4361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_module,
    ACTIONS(629), 1,
      anon_sym_extmodule,
    ACTIONS(673), 1,
      sym__dedent,
    STATE(201), 2,
      sym_module,
      aux_sym_circuit_repeat1,
  [4378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(389), 1,
      sym_ruw,
    ACTIONS(675), 3,
      anon_sym_old,
      anon_sym_new,
      anon_sym_undefined,
  [4390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      anon_sym_LT,
    ACTIONS(219), 3,
      sym__newline,
      anon_sym_LBRACK,
      sym_info,
  [4402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 1,
      anon_sym_parameter,
    ACTIONS(682), 1,
      sym__dedent,
    STATE(214), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [4416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      sym__dedent,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(229), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [4430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(686), 1,
      sym__indent,
    ACTIONS(684), 3,
      sym__dedent,
      anon_sym_module,
      anon_sym_extmodule,
  [4442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(688), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(692), 1,
      sym_info,
    ACTIONS(694), 1,
      sym__indent,
    ACTIONS(690), 2,
      ts_builtin_sym_end,
      anon_sym_circuit,
  [4470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 1,
      anon_sym_LT,
    ACTIONS(249), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [4482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(698), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      sym__dedent,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(214), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [4510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 4,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [4520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(702), 1,
      ts_builtin_sym_end,
    ACTIONS(704), 1,
      anon_sym_circuit,
    STATE(223), 2,
      sym_circuit,
      aux_sym_source_file_repeat1,
  [4534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(707), 1,
      anon_sym_LT,
    ACTIONS(219), 3,
      sym__newline,
      anon_sym_LBRACK,
      sym_info,
  [4546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym__dedent,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(236), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [4560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 1,
      anon_sym_reset,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    STATE(314), 1,
      sym__reset,
    STATE(315), 1,
      sym_reset,
  [4576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_LT,
    ACTIONS(249), 3,
      sym__newline,
      anon_sym_LBRACK,
      sym_info,
  [4588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(715), 1,
      anon_sym_reset,
    ACTIONS(717), 1,
      anon_sym_LPAREN,
    STATE(355), 1,
      sym_reset,
    STATE(364), 1,
      sym__reset,
  [4604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(493), 1,
      anon_sym_parameter,
    ACTIONS(719), 1,
      sym__dedent,
    STATE(214), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [4618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym__dedent,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(214), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [4632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_LT,
    ACTIONS(219), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [4644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(723), 1,
      anon_sym_LT,
    ACTIONS(219), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [4656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 1,
      sym__indent,
    ACTIONS(684), 3,
      sym__dedent,
      anon_sym_module,
      anon_sym_extmodule,
  [4668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_circuit,
    ACTIONS(727), 1,
      ts_builtin_sym_end,
    STATE(223), 2,
      sym_circuit,
      aux_sym_source_file_repeat1,
  [4682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 4,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [4692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym__dedent,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(214), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [4706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym__dedent,
    ACTIONS(493), 1,
      anon_sym_parameter,
    STATE(221), 2,
      sym_parameter,
      aux_sym_module_repeat3,
  [4720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(261), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [4729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 3,
      sym__newline,
      anon_sym_LBRACK,
      sym_info,
  [4738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(731), 1,
      anon_sym_COMMA,
  [4751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(733), 1,
      anon_sym_COMMA,
  [4764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(735), 1,
      anon_sym_COMMA,
  [4777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(737), 1,
      anon_sym_COMMA,
  [4790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(739), 1,
      anon_sym_COMMA,
  [4803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(741), 1,
      anon_sym_RPAREN,
  [4816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(743), 1,
      anon_sym_COMMA,
  [4829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(745), 1,
      anon_sym_COMMA,
  [4842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(747), 1,
      anon_sym_COMMA,
  [4855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 3,
      sym__dedent,
      anon_sym_module,
      anon_sym_extmodule,
  [4864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(751), 1,
      anon_sym_COMMA,
  [4877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(753), 1,
      anon_sym_COMMA,
  [4890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_COMMA,
    ACTIONS(757), 1,
      anon_sym_RBRACE,
    STATE(283), 1,
      aux_sym_type_repeat1,
  [4903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [4912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(759), 1,
      anon_sym_RBRACK,
  [4925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 1,
      anon_sym_RPAREN,
    ACTIONS(761), 1,
      anon_sym_COMMA,
    STATE(255), 1,
      aux_sym_primitive_operation_repeat1,
  [4938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 3,
      sym__dedent,
      anon_sym_module,
      anon_sym_extmodule,
  [4947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(768), 1,
      sym__indent,
    ACTIONS(766), 2,
      ts_builtin_sym_end,
      anon_sym_circuit,
  [4958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_COMMA,
    ACTIONS(671), 1,
      anon_sym_RPAREN,
    STATE(303), 1,
      aux_sym_primitive_operation_repeat1,
  [4971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 3,
      sym__dedent,
      anon_sym_module,
      anon_sym_extmodule,
  [4980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(772), 3,
      sym__dedent,
      anon_sym_module,
      anon_sym_extmodule,
  [4989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_COMMA,
    ACTIONS(774), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      aux_sym_type_repeat1,
  [5002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_COMMA,
    ACTIONS(776), 1,
      anon_sym_RBRACE,
    STATE(261), 1,
      aux_sym_type_repeat1,
  [5015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(778), 1,
      anon_sym_LBRACK,
    ACTIONS(780), 1,
      sym_info,
    ACTIONS(782), 1,
      sym__newline,
  [5028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(285), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [5037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(784), 1,
      anon_sym_RPAREN,
  [5050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(786), 1,
      anon_sym_RPAREN,
  [5063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(788), 1,
      anon_sym_RPAREN,
  [5076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(790), 1,
      anon_sym_COLON,
  [5089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(792), 1,
      anon_sym_COMMA,
    ACTIONS(795), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      aux_sym_type_repeat1,
  [5102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_LBRACK,
    ACTIONS(797), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [5113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_COMMA,
    ACTIONS(801), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      aux_sym_type_repeat1,
  [5126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(803), 1,
      anon_sym_RPAREN,
  [5139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(249), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [5148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_COMMA,
    ACTIONS(805), 1,
      anon_sym_RBRACE,
    STATE(271), 1,
      aux_sym_type_repeat1,
  [5161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_COMMA,
    ACTIONS(807), 1,
      anon_sym_RPAREN,
    STATE(255), 1,
      aux_sym_primitive_operation_repeat1,
  [5174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_COMMA,
    ACTIONS(811), 1,
      sym__newline,
    STATE(291), 1,
      aux_sym_memory_field_repeat1,
  [5187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(813), 1,
      anon_sym_COLON,
    ACTIONS(815), 1,
      anon_sym_when,
    STATE(70), 1,
      sym_when,
  [5200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_COMMA,
    ACTIONS(645), 1,
      anon_sym_RPAREN,
    STATE(275), 1,
      aux_sym_primitive_operation_repeat1,
  [5213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(817), 1,
      anon_sym_RBRACK,
  [5226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(665), 1,
      anon_sym_COMMA,
    ACTIONS(819), 1,
      anon_sym_RPAREN,
    STATE(294), 1,
      aux_sym_printf_repeat1,
  [5239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(821), 1,
      anon_sym_COMMA,
  [5252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(823), 1,
      anon_sym_RPAREN,
  [5265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_COMMA,
    ACTIONS(825), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      aux_sym_type_repeat1,
  [5278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(827), 1,
      anon_sym_RBRACK,
  [5291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(257), 3,
      sym__newline,
      anon_sym_LBRACK,
      sym_info,
  [5300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(665), 1,
      anon_sym_COMMA,
    ACTIONS(829), 1,
      anon_sym_RPAREN,
    STATE(296), 1,
      aux_sym_printf_repeat1,
  [5313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_LBRACK,
    ACTIONS(831), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [5324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      sym__indent,
    STATE(54), 1,
      sym_reset_block,
  [5337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(837), 1,
      anon_sym_COMMA,
  [5350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(249), 3,
      sym__newline,
      anon_sym_LBRACK,
      sym_info,
  [5359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_COMMA,
    ACTIONS(839), 1,
      sym__newline,
    STATE(305), 1,
      aux_sym_memory_field_repeat1,
  [5372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(261), 3,
      sym__newline,
      anon_sym_LBRACK,
      sym_info,
  [5381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(285), 3,
      sym__newline,
      anon_sym_LBRACK,
      sym_info,
  [5390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(665), 1,
      anon_sym_COMMA,
    ACTIONS(841), 1,
      anon_sym_RPAREN,
    STATE(296), 1,
      aux_sym_printf_repeat1,
  [5403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(843), 3,
      sym__dedent,
      anon_sym_module,
      anon_sym_extmodule,
  [5412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(688), 1,
      anon_sym_RPAREN,
    ACTIONS(845), 1,
      anon_sym_COMMA,
    STATE(296), 1,
      aux_sym_printf_repeat1,
  [5425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 3,
      sym__newline,
      anon_sym_LBRACK,
      sym_info,
  [5434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(778), 1,
      anon_sym_LBRACK,
    ACTIONS(848), 1,
      sym_info,
    ACTIONS(850), 1,
      sym__newline,
  [5447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [5456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(852), 1,
      anon_sym_COMMA,
  [5469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(854), 1,
      anon_sym_COMMA,
  [5482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(257), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [5491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_COMMA,
    ACTIONS(856), 1,
      anon_sym_RPAREN,
    STATE(255), 1,
      aux_sym_primitive_operation_repeat1,
  [5504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LBRACK,
    ACTIONS(647), 1,
      anon_sym_DOT,
    ACTIONS(858), 1,
      anon_sym_COMMA,
  [5517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(863), 1,
      sym__newline,
    STATE(305), 1,
      aux_sym_memory_field_repeat1,
  [5530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(863), 2,
      sym__newline,
      anon_sym_COMMA,
  [5538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 1,
      anon_sym_DQUOTE,
    STATE(360), 1,
      sym_string,
  [5548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(778), 1,
      anon_sym_LBRACK,
    ACTIONS(811), 1,
      sym__newline,
  [5558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(867), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [5566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 2,
      sym__dedent,
      anon_sym_parameter,
  [5574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(871), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [5582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(795), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [5590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(715), 1,
      anon_sym_reset,
    STATE(385), 1,
      sym__reset,
  [5600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(873), 2,
      sym__newline,
      sym_info,
  [5608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      sym_info,
    ACTIONS(877), 1,
      sym__newline,
  [5618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_LBRACK,
    ACTIONS(879), 1,
      anon_sym_COMMA,
  [5628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(881), 1,
      anon_sym_LT,
    ACTIONS(883), 1,
      anon_sym_LPAREN,
  [5638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(715), 1,
      anon_sym_reset,
    STATE(398), 1,
      sym__reset,
  [5648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [5656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(885), 2,
      ts_builtin_sym_end,
      anon_sym_circuit,
  [5664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(887), 2,
      sym__dedent,
      anon_sym_parameter,
  [5672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 1,
      anon_sym_DQUOTE,
    STATE(280), 1,
      sym_string,
  [5682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(889), 2,
      sym__newline,
      sym_info,
  [5690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 2,
      sym__newline,
      sym_info,
  [5698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(893), 2,
      ts_builtin_sym_end,
      anon_sym_circuit,
  [5706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      sym_info,
    ACTIONS(897), 1,
      sym__indent,
  [5716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 2,
      ts_builtin_sym_end,
      anon_sym_circuit,
  [5724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COLON,
  [5731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(903), 1,
      anon_sym_LPAREN,
  [5738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(905), 1,
      sym__dedent,
  [5745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(907), 1,
      sym__newline,
  [5752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(909), 1,
      anon_sym_COLON,
  [5759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(911), 1,
      anon_sym_EQ_GT,
  [5766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      anon_sym_EQ_GT,
  [5773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(915), 1,
      anon_sym_EQ_GT,
  [5780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      sym__dedent,
  [5787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(919), 1,
      anon_sym_EQ_GT,
  [5794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(921), 1,
      anon_sym_COLON,
  [5801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_COLON,
  [5808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(925), 1,
      anon_sym_COLON,
  [5815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(927), 1,
      anon_sym_COLON,
  [5822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(163), 1,
      sym__newline,
  [5829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      sym__newline,
  [5836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(929), 1,
      anon_sym_of,
  [5843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(931), 1,
      anon_sym_EQ,
  [5850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 1,
      sym__newline,
  [5857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(933), 1,
      anon_sym_COLON,
  [5864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(935), 1,
      anon_sym_GT,
  [5871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 1,
      anon_sym_LPAREN,
  [5878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
  [5885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_identifier,
  [5892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      anon_sym_GT,
  [5899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      aux_sym_uint_token1,
  [5906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(947), 1,
      sym_identifier,
  [5913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(949), 1,
      anon_sym_RPAREN,
  [5920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(951), 1,
      anon_sym_EQ_GT,
  [5927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      sym__newline,
  [5934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(955), 1,
      anon_sym_GT,
  [5941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_COLON,
  [5948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(959), 1,
      anon_sym_RPAREN,
  [5955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      sym_identifier,
  [5962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      sym_identifier,
  [5969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(965), 1,
      sym_identifier,
  [5976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(873), 1,
      anon_sym_RPAREN,
  [5983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(967), 1,
      sym_identifier,
  [5990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_RPAREN,
  [5997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(889), 1,
      anon_sym_RPAREN,
  [6004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_COLON,
  [6011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_identifier,
  [6018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(973), 1,
      sym_identifier,
  [6025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym_identifier,
  [6032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 1,
      anon_sym_COMMA,
  [6039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 1,
      sym_identifier,
  [6046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 1,
      sym_identifier,
  [6053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym_identifier,
  [6060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 1,
      anon_sym_LT,
  [6067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 1,
      anon_sym_GT,
  [6074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 1,
      anon_sym_COLON,
  [6081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 1,
      aux_sym_uint_token1,
  [6088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(993), 1,
      anon_sym_RPAREN,
  [6095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 1,
      sym_identifier,
  [6102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 1,
      anon_sym_RBRACK,
  [6109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 1,
      sym_identifier,
  [6116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_RPAREN,
  [6123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_RPAREN,
  [6130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
  [6137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_invalid,
  [6144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1009), 1,
      sym__newline,
  [6151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(811), 1,
      sym__newline,
  [6158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1011), 1,
      sym__indent,
  [6165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_GT,
  [6172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 1,
      anon_sym_GT,
  [6179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_LPAREN,
  [6186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_RBRACK,
  [6193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_COLON,
  [6200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 1,
      anon_sym_GT,
  [6207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_GT,
  [6214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 1,
      anon_sym_RPAREN,
  [6221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      anon_sym_LPAREN,
  [6228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_GT,
  [6235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_mport,
  [6242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(774), 1,
      anon_sym_GT,
  [6249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_GT,
  [6256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 1,
      sym__newline,
  [6263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(774), 1,
      anon_sym_RBRACK,
  [6270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      anon_sym_GT,
  [6277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1037), 1,
      anon_sym_GT,
  [6284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 1,
      anon_sym_EQ,
  [6291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 1,
      sym_identifier,
  [6298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      ts_builtin_sym_end,
  [6305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1045), 1,
      anon_sym_EQ,
  [6312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 1,
      anon_sym_LPAREN,
  [6319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 1,
      sym__newline,
  [6326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(867), 1,
      sym__newline,
  [6333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 1,
      sym__newline,
  [6340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 1,
      anon_sym_GT,
  [6347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 1,
      anon_sym_GT,
  [6354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 1,
      sym__newline,
  [6361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 1,
      anon_sym_RBRACK,
  [6368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_LBRACK,
  [6375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_RPAREN,
  [6382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 1,
      anon_sym_EQ,
  [6389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_GT,
  [6396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_GT,
  [6403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
  [6410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
  [6417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(871), 1,
      sym__newline,
  [6424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1073), 1,
      sym__newline,
  [6431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1075), 1,
      sym_identifier,
  [6438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1077), 1,
      anon_sym_mport,
  [6445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_GT,
  [6452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 1,
      anon_sym_COLON,
  [6459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1081), 1,
      anon_sym_LPAREN,
  [6466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_identifier,
  [6473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_LT,
  [6480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      sym_identifier,
  [6487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LT,
  [6494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym_LPAREN,
  [6501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_RBRACK,
  [6508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
  [6515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1095), 1,
      anon_sym_GT,
  [6522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1097), 1,
      anon_sym_EQ_GT,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(95)] = 0,
  [SMALL_STATE(96)] = 91,
  [SMALL_STATE(97)] = 182,
  [SMALL_STATE(98)] = 273,
  [SMALL_STATE(99)] = 364,
  [SMALL_STATE(100)] = 455,
  [SMALL_STATE(101)] = 531,
  [SMALL_STATE(102)] = 607,
  [SMALL_STATE(103)] = 683,
  [SMALL_STATE(104)] = 759,
  [SMALL_STATE(105)] = 835,
  [SMALL_STATE(106)] = 911,
  [SMALL_STATE(107)] = 987,
  [SMALL_STATE(108)] = 1063,
  [SMALL_STATE(109)] = 1139,
  [SMALL_STATE(110)] = 1215,
  [SMALL_STATE(111)] = 1291,
  [SMALL_STATE(112)] = 1367,
  [SMALL_STATE(113)] = 1443,
  [SMALL_STATE(114)] = 1519,
  [SMALL_STATE(115)] = 1595,
  [SMALL_STATE(116)] = 1671,
  [SMALL_STATE(117)] = 1747,
  [SMALL_STATE(118)] = 1823,
  [SMALL_STATE(119)] = 1899,
  [SMALL_STATE(120)] = 1975,
  [SMALL_STATE(121)] = 2051,
  [SMALL_STATE(122)] = 2127,
  [SMALL_STATE(123)] = 2203,
  [SMALL_STATE(124)] = 2279,
  [SMALL_STATE(125)] = 2355,
  [SMALL_STATE(126)] = 2431,
  [SMALL_STATE(127)] = 2507,
  [SMALL_STATE(128)] = 2583,
  [SMALL_STATE(129)] = 2659,
  [SMALL_STATE(130)] = 2735,
  [SMALL_STATE(131)] = 2765,
  [SMALL_STATE(132)] = 2796,
  [SMALL_STATE(133)] = 2823,
  [SMALL_STATE(134)] = 2850,
  [SMALL_STATE(135)] = 2877,
  [SMALL_STATE(136)] = 2906,
  [SMALL_STATE(137)] = 2937,
  [SMALL_STATE(138)] = 2968,
  [SMALL_STATE(139)] = 2995,
  [SMALL_STATE(140)] = 3022,
  [SMALL_STATE(141)] = 3053,
  [SMALL_STATE(142)] = 3071,
  [SMALL_STATE(143)] = 3087,
  [SMALL_STATE(144)] = 3105,
  [SMALL_STATE(145)] = 3121,
  [SMALL_STATE(146)] = 3136,
  [SMALL_STATE(147)] = 3151,
  [SMALL_STATE(148)] = 3166,
  [SMALL_STATE(149)] = 3189,
  [SMALL_STATE(150)] = 3212,
  [SMALL_STATE(151)] = 3235,
  [SMALL_STATE(152)] = 3262,
  [SMALL_STATE(153)] = 3277,
  [SMALL_STATE(154)] = 3304,
  [SMALL_STATE(155)] = 3319,
  [SMALL_STATE(156)] = 3334,
  [SMALL_STATE(157)] = 3357,
  [SMALL_STATE(158)] = 3384,
  [SMALL_STATE(159)] = 3407,
  [SMALL_STATE(160)] = 3430,
  [SMALL_STATE(161)] = 3445,
  [SMALL_STATE(162)] = 3468,
  [SMALL_STATE(163)] = 3483,
  [SMALL_STATE(164)] = 3498,
  [SMALL_STATE(165)] = 3521,
  [SMALL_STATE(166)] = 3536,
  [SMALL_STATE(167)] = 3551,
  [SMALL_STATE(168)] = 3566,
  [SMALL_STATE(169)] = 3590,
  [SMALL_STATE(170)] = 3612,
  [SMALL_STATE(171)] = 3634,
  [SMALL_STATE(172)] = 3648,
  [SMALL_STATE(173)] = 3670,
  [SMALL_STATE(174)] = 3692,
  [SMALL_STATE(175)] = 3714,
  [SMALL_STATE(176)] = 3733,
  [SMALL_STATE(177)] = 3752,
  [SMALL_STATE(178)] = 3771,
  [SMALL_STATE(179)] = 3790,
  [SMALL_STATE(180)] = 3809,
  [SMALL_STATE(181)] = 3828,
  [SMALL_STATE(182)] = 3847,
  [SMALL_STATE(183)] = 3866,
  [SMALL_STATE(184)] = 3885,
  [SMALL_STATE(185)] = 3904,
  [SMALL_STATE(186)] = 3923,
  [SMALL_STATE(187)] = 3942,
  [SMALL_STATE(188)] = 3961,
  [SMALL_STATE(189)] = 3980,
  [SMALL_STATE(190)] = 3999,
  [SMALL_STATE(191)] = 4015,
  [SMALL_STATE(192)] = 4031,
  [SMALL_STATE(193)] = 4047,
  [SMALL_STATE(194)] = 4063,
  [SMALL_STATE(195)] = 4079,
  [SMALL_STATE(196)] = 4095,
  [SMALL_STATE(197)] = 4115,
  [SMALL_STATE(198)] = 4135,
  [SMALL_STATE(199)] = 4155,
  [SMALL_STATE(200)] = 4171,
  [SMALL_STATE(201)] = 4187,
  [SMALL_STATE(202)] = 4204,
  [SMALL_STATE(203)] = 4221,
  [SMALL_STATE(204)] = 4238,
  [SMALL_STATE(205)] = 4257,
  [SMALL_STATE(206)] = 4276,
  [SMALL_STATE(207)] = 4291,
  [SMALL_STATE(208)] = 4306,
  [SMALL_STATE(209)] = 4325,
  [SMALL_STATE(210)] = 4342,
  [SMALL_STATE(211)] = 4361,
  [SMALL_STATE(212)] = 4378,
  [SMALL_STATE(213)] = 4390,
  [SMALL_STATE(214)] = 4402,
  [SMALL_STATE(215)] = 4416,
  [SMALL_STATE(216)] = 4430,
  [SMALL_STATE(217)] = 4442,
  [SMALL_STATE(218)] = 4456,
  [SMALL_STATE(219)] = 4470,
  [SMALL_STATE(220)] = 4482,
  [SMALL_STATE(221)] = 4496,
  [SMALL_STATE(222)] = 4510,
  [SMALL_STATE(223)] = 4520,
  [SMALL_STATE(224)] = 4534,
  [SMALL_STATE(225)] = 4546,
  [SMALL_STATE(226)] = 4560,
  [SMALL_STATE(227)] = 4576,
  [SMALL_STATE(228)] = 4588,
  [SMALL_STATE(229)] = 4604,
  [SMALL_STATE(230)] = 4618,
  [SMALL_STATE(231)] = 4632,
  [SMALL_STATE(232)] = 4644,
  [SMALL_STATE(233)] = 4656,
  [SMALL_STATE(234)] = 4668,
  [SMALL_STATE(235)] = 4682,
  [SMALL_STATE(236)] = 4692,
  [SMALL_STATE(237)] = 4706,
  [SMALL_STATE(238)] = 4720,
  [SMALL_STATE(239)] = 4729,
  [SMALL_STATE(240)] = 4738,
  [SMALL_STATE(241)] = 4751,
  [SMALL_STATE(242)] = 4764,
  [SMALL_STATE(243)] = 4777,
  [SMALL_STATE(244)] = 4790,
  [SMALL_STATE(245)] = 4803,
  [SMALL_STATE(246)] = 4816,
  [SMALL_STATE(247)] = 4829,
  [SMALL_STATE(248)] = 4842,
  [SMALL_STATE(249)] = 4855,
  [SMALL_STATE(250)] = 4864,
  [SMALL_STATE(251)] = 4877,
  [SMALL_STATE(252)] = 4890,
  [SMALL_STATE(253)] = 4903,
  [SMALL_STATE(254)] = 4912,
  [SMALL_STATE(255)] = 4925,
  [SMALL_STATE(256)] = 4938,
  [SMALL_STATE(257)] = 4947,
  [SMALL_STATE(258)] = 4958,
  [SMALL_STATE(259)] = 4971,
  [SMALL_STATE(260)] = 4980,
  [SMALL_STATE(261)] = 4989,
  [SMALL_STATE(262)] = 5002,
  [SMALL_STATE(263)] = 5015,
  [SMALL_STATE(264)] = 5028,
  [SMALL_STATE(265)] = 5037,
  [SMALL_STATE(266)] = 5050,
  [SMALL_STATE(267)] = 5063,
  [SMALL_STATE(268)] = 5076,
  [SMALL_STATE(269)] = 5089,
  [SMALL_STATE(270)] = 5102,
  [SMALL_STATE(271)] = 5113,
  [SMALL_STATE(272)] = 5126,
  [SMALL_STATE(273)] = 5139,
  [SMALL_STATE(274)] = 5148,
  [SMALL_STATE(275)] = 5161,
  [SMALL_STATE(276)] = 5174,
  [SMALL_STATE(277)] = 5187,
  [SMALL_STATE(278)] = 5200,
  [SMALL_STATE(279)] = 5213,
  [SMALL_STATE(280)] = 5226,
  [SMALL_STATE(281)] = 5239,
  [SMALL_STATE(282)] = 5252,
  [SMALL_STATE(283)] = 5265,
  [SMALL_STATE(284)] = 5278,
  [SMALL_STATE(285)] = 5291,
  [SMALL_STATE(286)] = 5300,
  [SMALL_STATE(287)] = 5313,
  [SMALL_STATE(288)] = 5324,
  [SMALL_STATE(289)] = 5337,
  [SMALL_STATE(290)] = 5350,
  [SMALL_STATE(291)] = 5359,
  [SMALL_STATE(292)] = 5372,
  [SMALL_STATE(293)] = 5381,
  [SMALL_STATE(294)] = 5390,
  [SMALL_STATE(295)] = 5403,
  [SMALL_STATE(296)] = 5412,
  [SMALL_STATE(297)] = 5425,
  [SMALL_STATE(298)] = 5434,
  [SMALL_STATE(299)] = 5447,
  [SMALL_STATE(300)] = 5456,
  [SMALL_STATE(301)] = 5469,
  [SMALL_STATE(302)] = 5482,
  [SMALL_STATE(303)] = 5491,
  [SMALL_STATE(304)] = 5504,
  [SMALL_STATE(305)] = 5517,
  [SMALL_STATE(306)] = 5530,
  [SMALL_STATE(307)] = 5538,
  [SMALL_STATE(308)] = 5548,
  [SMALL_STATE(309)] = 5558,
  [SMALL_STATE(310)] = 5566,
  [SMALL_STATE(311)] = 5574,
  [SMALL_STATE(312)] = 5582,
  [SMALL_STATE(313)] = 5590,
  [SMALL_STATE(314)] = 5600,
  [SMALL_STATE(315)] = 5608,
  [SMALL_STATE(316)] = 5618,
  [SMALL_STATE(317)] = 5628,
  [SMALL_STATE(318)] = 5638,
  [SMALL_STATE(319)] = 5648,
  [SMALL_STATE(320)] = 5656,
  [SMALL_STATE(321)] = 5664,
  [SMALL_STATE(322)] = 5672,
  [SMALL_STATE(323)] = 5682,
  [SMALL_STATE(324)] = 5690,
  [SMALL_STATE(325)] = 5698,
  [SMALL_STATE(326)] = 5706,
  [SMALL_STATE(327)] = 5716,
  [SMALL_STATE(328)] = 5724,
  [SMALL_STATE(329)] = 5731,
  [SMALL_STATE(330)] = 5738,
  [SMALL_STATE(331)] = 5745,
  [SMALL_STATE(332)] = 5752,
  [SMALL_STATE(333)] = 5759,
  [SMALL_STATE(334)] = 5766,
  [SMALL_STATE(335)] = 5773,
  [SMALL_STATE(336)] = 5780,
  [SMALL_STATE(337)] = 5787,
  [SMALL_STATE(338)] = 5794,
  [SMALL_STATE(339)] = 5801,
  [SMALL_STATE(340)] = 5808,
  [SMALL_STATE(341)] = 5815,
  [SMALL_STATE(342)] = 5822,
  [SMALL_STATE(343)] = 5829,
  [SMALL_STATE(344)] = 5836,
  [SMALL_STATE(345)] = 5843,
  [SMALL_STATE(346)] = 5850,
  [SMALL_STATE(347)] = 5857,
  [SMALL_STATE(348)] = 5864,
  [SMALL_STATE(349)] = 5871,
  [SMALL_STATE(350)] = 5878,
  [SMALL_STATE(351)] = 5885,
  [SMALL_STATE(352)] = 5892,
  [SMALL_STATE(353)] = 5899,
  [SMALL_STATE(354)] = 5906,
  [SMALL_STATE(355)] = 5913,
  [SMALL_STATE(356)] = 5920,
  [SMALL_STATE(357)] = 5927,
  [SMALL_STATE(358)] = 5934,
  [SMALL_STATE(359)] = 5941,
  [SMALL_STATE(360)] = 5948,
  [SMALL_STATE(361)] = 5955,
  [SMALL_STATE(362)] = 5962,
  [SMALL_STATE(363)] = 5969,
  [SMALL_STATE(364)] = 5976,
  [SMALL_STATE(365)] = 5983,
  [SMALL_STATE(366)] = 5990,
  [SMALL_STATE(367)] = 5997,
  [SMALL_STATE(368)] = 6004,
  [SMALL_STATE(369)] = 6011,
  [SMALL_STATE(370)] = 6018,
  [SMALL_STATE(371)] = 6025,
  [SMALL_STATE(372)] = 6032,
  [SMALL_STATE(373)] = 6039,
  [SMALL_STATE(374)] = 6046,
  [SMALL_STATE(375)] = 6053,
  [SMALL_STATE(376)] = 6060,
  [SMALL_STATE(377)] = 6067,
  [SMALL_STATE(378)] = 6074,
  [SMALL_STATE(379)] = 6081,
  [SMALL_STATE(380)] = 6088,
  [SMALL_STATE(381)] = 6095,
  [SMALL_STATE(382)] = 6102,
  [SMALL_STATE(383)] = 6109,
  [SMALL_STATE(384)] = 6116,
  [SMALL_STATE(385)] = 6123,
  [SMALL_STATE(386)] = 6130,
  [SMALL_STATE(387)] = 6137,
  [SMALL_STATE(388)] = 6144,
  [SMALL_STATE(389)] = 6151,
  [SMALL_STATE(390)] = 6158,
  [SMALL_STATE(391)] = 6165,
  [SMALL_STATE(392)] = 6172,
  [SMALL_STATE(393)] = 6179,
  [SMALL_STATE(394)] = 6186,
  [SMALL_STATE(395)] = 6193,
  [SMALL_STATE(396)] = 6200,
  [SMALL_STATE(397)] = 6207,
  [SMALL_STATE(398)] = 6214,
  [SMALL_STATE(399)] = 6221,
  [SMALL_STATE(400)] = 6228,
  [SMALL_STATE(401)] = 6235,
  [SMALL_STATE(402)] = 6242,
  [SMALL_STATE(403)] = 6249,
  [SMALL_STATE(404)] = 6256,
  [SMALL_STATE(405)] = 6263,
  [SMALL_STATE(406)] = 6270,
  [SMALL_STATE(407)] = 6277,
  [SMALL_STATE(408)] = 6284,
  [SMALL_STATE(409)] = 6291,
  [SMALL_STATE(410)] = 6298,
  [SMALL_STATE(411)] = 6305,
  [SMALL_STATE(412)] = 6312,
  [SMALL_STATE(413)] = 6319,
  [SMALL_STATE(414)] = 6326,
  [SMALL_STATE(415)] = 6333,
  [SMALL_STATE(416)] = 6340,
  [SMALL_STATE(417)] = 6347,
  [SMALL_STATE(418)] = 6354,
  [SMALL_STATE(419)] = 6361,
  [SMALL_STATE(420)] = 6368,
  [SMALL_STATE(421)] = 6375,
  [SMALL_STATE(422)] = 6382,
  [SMALL_STATE(423)] = 6389,
  [SMALL_STATE(424)] = 6396,
  [SMALL_STATE(425)] = 6403,
  [SMALL_STATE(426)] = 6410,
  [SMALL_STATE(427)] = 6417,
  [SMALL_STATE(428)] = 6424,
  [SMALL_STATE(429)] = 6431,
  [SMALL_STATE(430)] = 6438,
  [SMALL_STATE(431)] = 6445,
  [SMALL_STATE(432)] = 6452,
  [SMALL_STATE(433)] = 6459,
  [SMALL_STATE(434)] = 6466,
  [SMALL_STATE(435)] = 6473,
  [SMALL_STATE(436)] = 6480,
  [SMALL_STATE(437)] = 6487,
  [SMALL_STATE(438)] = 6494,
  [SMALL_STATE(439)] = 6501,
  [SMALL_STATE(440)] = 6508,
  [SMALL_STATE(441)] = 6515,
  [SMALL_STATE(442)] = 6522,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [61] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 3, 0, 0),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 4, 0, 0),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [67] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(160),
  [70] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(317),
  [73] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(361),
  [76] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(362),
  [79] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(363),
  [82] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(365),
  [85] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(371),
  [88] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(373),
  [91] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(374),
  [94] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(108),
  [97] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(329),
  [100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(386),
  [103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(393),
  [106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(53),
  [109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(399),
  [112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(401),
  [115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(141),
  [118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(426),
  [121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0), SHIFT_REPEAT(142),
  [124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat2, 2, 0, 0),
  [126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(354),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primop, 1, 0, 0),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primop, 1, 0, 0),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 1),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 1),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sub_access, 4, 0, 0),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sub_access, 4, 0, 0),
  [153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sub_index, 4, 0, 0),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sub_index, 4, 0, 0),
  [157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mux, 8, 0, 0),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mux, 8, 0, 0),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint, 1, 0, 0),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint, 1, 0, 0),
  [165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_id, 1, 0, 0),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_id, 1, 0, 0),
  [169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditionally_valid, 6, 0, 0),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditionally_valid, 6, 0, 0),
  [173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sub_field, 3, 0, 0),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sub_field, 3, 0, 0),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_operation, 5, 0, 0),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_operation, 5, 0, 0),
  [181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_register, 6, 0, 0),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_register, 6, 0, 0),
  [193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_operation, 4, 0, 0),
  [195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_operation, 4, 0, 0),
  [197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 4, 0, 0),
  [199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 4, 0, 0),
  [201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_partial_connection, 3, 0, 0),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_partial_connection, 3, 0, 0),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_port, 5, 0, 0),
  [213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_port, 5, 0, 0),
  [215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_node, 4, 0, 0),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_node, 4, 0, 0),
  [227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_port, 7, 0, 0),
  [229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_port, 7, 0, 0),
  [231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_connection, 3, 0, 0),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_connection, 3, 0, 0),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rdwr, 10, 0, 0),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdwr, 10, 0, 0),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 4, 0, 0),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 4, 0, 0),
  [251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_port, 6, 0, 0),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_port, 6, 0, 0),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 6, 0, 0),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 6, 0, 0),
  [259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 3, 0, 0),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 3, 0, 0),
  [263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_wire, 4, 0, 0),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wire, 4, 0, 0),
  [271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmem, 4, 0, 0),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmem, 4, 0, 0),
  [277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_smem, 4, 0, 0),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_smem, 4, 0, 0),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 2, 0, 0),
  [285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2, 0, 0),
  [287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 9, 0, 0),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 9, 0, 0),
  [291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_printf, 8, 0, 0),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_printf, 8, 0, 0),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stop, 8, 0, 0),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stop, 8, 0, 0),
  [303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_skip, 1, 0, 0),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_skip, 1, 0, 0),
  [309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_register, 9, 0, 0),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_register, 9, 0, 0),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst, 4, 0, 0),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst, 4, 0, 0),
  [321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_printf, 9, 0, 0),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_printf, 9, 0, 0),
  [327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attach, 5, 0, 0),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attach, 5, 0, 0),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 5, 0, 0),
  [335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 5, 0, 0),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reset_block, 3, 0, 0),
  [339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reset_block, 3, 0, 0),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reset_block, 5, 0, 0),
  [343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reset_block, 5, 0, 0),
  [345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_invalid, 3, 0, 0),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_invalid, 3, 0, 0),
  [351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attach, 4, 0, 0),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attach, 4, 0, 0),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 4, 0, 0),
  [359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reset_block, 4, 0, 0),
  [361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reset_block, 4, 0, 0),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_register, 7, 0, 0),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_register, 7, 0, 0),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_smem, 5, 0, 0),
  [373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_smem, 5, 0, 0),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmem, 5, 0, 0),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmem, 5, 0, 0),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_wire, 5, 0, 0),
  [381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wire, 5, 0, 0),
  [383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 2, 0, 0),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 2, 0, 0),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rdwr, 11, 0, 0),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdwr, 11, 0, 0),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_invalid, 4, 0, 0),
  [393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_invalid, 4, 0, 0),
  [395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_partial_connection, 4, 0, 0),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_partial_connection, 4, 0, 0),
  [399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_connection, 4, 0, 0),
  [401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_connection, 4, 0, 0),
  [403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_skip, 2, 0, 0),
  [405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_skip, 2, 0, 0),
  [407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_suite, 1, 0, 0),
  [409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_suite, 1, 0, 0),
  [411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_node, 5, 0, 0),
  [413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_node, 5, 0, 0),
  [415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst, 5, 0, 0),
  [417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst, 5, 0, 0),
  [419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verif, 10, 0, 0),
  [421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verif, 10, 0, 0),
  [423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_printf, 10, 0, 0),
  [425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_printf, 10, 0, 0),
  [427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memory, 6, 0, 0),
  [429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory, 6, 0, 0),
  [431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_suite, 3, 0, 0),
  [433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_suite, 3, 0, 0),
  [435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 3, 0, 0),
  [437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 3, 0, 0),
  [439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_register, 10, 0, 0),
  [441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_register, 10, 0, 0),
  [443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 6, 0, 0),
  [445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 6, 0, 0),
  [447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attach, 6, 0, 0),
  [449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attach, 6, 0, 0),
  [451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memory, 5, 0, 0),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory, 5, 0, 0),
  [455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memory, 7, 0, 0),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory, 7, 0, 0),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 4, 0, 0),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 4, 0, 0),
  [463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stop, 9, 0, 0),
  [465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stop, 9, 0, 0),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_memory_repeat1, 2, 0, 0), SHIFT_REPEAT(337),
  [522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_memory_repeat1, 2, 0, 0), SHIFT_REPEAT(335),
  [525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_memory_repeat1, 2, 0, 0), SHIFT_REPEAT(334),
  [528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_memory_repeat1, 2, 0, 0), SHIFT_REPEAT(333),
  [531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_memory_repeat1, 2, 0, 0),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_field, 5, 0, 0),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_field, 4, 0, 0),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifier, 1, 0, 0),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_raw_string_repeat1, 2, 0, 0),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_raw_string_repeat1, 2, 0, 0), SHIFT_REPEAT(190),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(192),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_circuit_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_circuit_repeat1, 2, 0, 0), SHIFT_REPEAT(350),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_circuit_repeat1, 2, 0, 0),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, 0, 0),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat3, 2, 0, 0), SHIFT_REPEAT(370),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat3, 2, 0, 0),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 0),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_printf_repeat1, 2, 0, 0),
  [690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_circuit, 3, 0, 0),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_primitive_operation_repeat1, 2, 0, 0),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number, 1, 0, 2),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(381),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sint, 2, 0, 0),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 9, 0, 0),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_primitive_operation_repeat1, 2, 0, 0), SHIFT_REPEAT(98),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, 0, 0),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_circuit, 4, 0, 0),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 7, 0, 0),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 6, 0, 0),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0), SHIFT_REPEAT(168),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, 0, 0),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 4, 0, 0),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 8, 0, 0),
  [845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_printf_repeat1, 2, 0, 0), SHIFT_REPEAT(109),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_memory_field_repeat1, 2, 0, 0), SHIFT_REPEAT(375),
  [863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_memory_field_repeat1, 2, 0, 0),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defname, 4, 0, 0),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reset, 1, 0, 0),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_litType, 1, 0, 0),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_circuit, 5, 0, 0),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 5, 0, 0),
  [889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__reset, 7, 0, 0),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reset, 3, 0, 0),
  [893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_circuit, 6, 0, 0),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_circuit, 7, 0, 0),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dir, 1, 0, 0),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ruw, 1, 0, 0),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mdir, 1, 0, 0),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string, 3, 0, 0),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1043] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_litType, 4, 0, 0),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string, 2, 0, 0),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
};

static const bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
  },
  [2] = {
    [ts_external_token__dedent] = true,
  },
  [3] = {
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
  },
  [4] = {
    [ts_external_token__indent] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_firrtl_external_scanner_create(void);
void tree_sitter_firrtl_external_scanner_destroy(void *);
bool tree_sitter_firrtl_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_firrtl_external_scanner_serialize(void *, char *);
void tree_sitter_firrtl_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_firrtl(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_firrtl_external_scanner_create,
      tree_sitter_firrtl_external_scanner_destroy,
      tree_sitter_firrtl_external_scanner_scan,
      tree_sitter_firrtl_external_scanner_serialize,
      tree_sitter_firrtl_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
